<?php
/**
 * accueil.php
 *
 * Page d'accueil de l'application
 * 
 * Ce fichier fait partie du projet IntraEduWeb (IEW)
 * 
 * @package		IEW
 * @author			Sylvain GODM <sylvain.godme@gmail.com>
 * @version		$LastChangedRevision$, $LastChangedDate$
 * @copyright		2004-2012 Sylvain GODM
 * @link			http://iew.free.fr
 * @license		GPL License version 3 (http://www.gnu.org/licenses/gpl.html)
 * @filesource
 * 
 */

if (!defined('IEW_DIR')) {
 	/**
 	 * Constante contenant le chemin complet du rpertoire d'installation IEW
 	 */	
	define('IEW_DIR',realpath(dirname(__FILE__)).'/');
}

/**
 * On inclut la librairie complte des fonctions
 */
require_once(IEW_DIR."librairie_fonctions.php");

// fonctions locales
function message_accueil_utilisateur_authentifie()
{
	if ($_SESSION['valid_login'] == "admin-iew" || $_SESSION['valid_group'] == "1")
        {
          if (isset($_SESSION['anscol']) && isset($_SESSION['anscol']) !="") // Si on est dans les archives
            echo "<center><div class='encadrer_justifie'>Vous tes un <strong>administrateur</strong> de ce site. Comme vous venez d'accder aux archives de l'anne <strong>".$_SESSION['anscol']."</strong>, vous n'avez plus votre sommaire classique qui vous permet habituellement d'effectuer certaines oprations de maintenance et de paramtrage du site. Ces oprations ne sont ralisables que pour <a href='prive/admin/prive/exit_archives.php'>l'anne scolaire en cours</a>.</div></center>";
          else
            echo "<center><div class='encadrer_justifie'>Vous tes un <strong>administrateur</strong> de ce site. Vous pouvez utiliser votre sommaire spcifique sur la partie gauche de la page pour changer les paramtres du site ou faire les tches d'administration courantes.</div></center>";
        }
        else
        {
          // On cherche si l'utilisateur a sign la charte intraeduweb
          $sql = "SELECT id_pers from accept_charte WHERE id_pers='".quote_smart($_SESSION['valid_id_user'])."'";
          $resultat = mysql_query($sql);
          if (mysql_num_rows($resultat)==0) // pas de signature enregistre
          {
            $error_message = array("C'est votre premire connexion  IntraEduWeb !<br /><br /><div align='justify'>Pour accder  toutes les informations internes (en fonction de vos droits),<strong><font color='black'> vous devez au pralable accepter de respecter la charte des droits et devoirs de l'utilisateur</font></strong> prsente ci-dessous.</div>","charte");
            affiche_erreurs($error_message);
            return false;
          }
          if ($_SESSION['valid_group'] == "11")
          {
            echo "<center><div class='encadrer_justifie'><p>Vous tes un <strong>IPR</strong> autoris  accder  notre application IEW de faon temporaire. Les informations concernant la date d'expiration de votre compte vous ont t transmises par mail.</p><p>Pour accder aux cahiers textes, cliquez sur les liens <a href='prive/edt.php?categorie=professeurs'>dans les emplois du temps des professeurs que vous allez inspecter</a>.</p><p>Vous pouvez accder aussi  d'autres parties du site en utilisant le sommaire sur la partie gauche de la page.</p></div></center>";
            return true;
          }
          if ($_SESSION['valid_group'] == "4")
          {
            echo "<center><div class='encadrer_justifie'><p>Vous tes un <strong>Parent d'lve</strong> autoris  accder  <u>certaines informations</u> de notre application <abbr title='IntraEduWeb'>IEW</abbr>.</p>
            <p>Vous pouvez en particulier consulter <a href='prive/cahiers_textes.php'>son cahier de textes</a> et <a href='".$GLOBALS['url_notation']."'>ses notes</a></p>
            <p> Les autres informations auxquelles vous avez accs vous sont prsentes dans le menu de gauche : vous pouvez y accder en cliquant sur les liens correspondants.</p>
            </div></center>";
            return true;
          }
          ?>
          <center>
          <div class="encadrer" style="text-align: justify;">
            <table width="100%">
              <tr>
                <td width="15%" align="center">
                  <span class="rouge" style="text-decoration: underline;"><strong>Rappel:</strong></span>
                </td>
                <td rowspan="2">
                  <p>Pensez  vrifier le contenu de votre bote aux lettres <strong>au moins</strong> une fois par jour !</p>
                </td>
              </tr>
              <tr>
                <td width="15%" align="center" valign="center">
                  <img src="images/warning.gif" alt="Attention" />
                </td>
              </tr>
            </table>
	        </div>
            </center>
	  <?php
        }
        return true;
}

function message_accueil_standard()
{
  ?>
  <br /><h2 class="hidden">Prsentation du portail</h2>
  <p>
	Cette brique ENT (<a href="http://fr.wikipedia.org/wiki/Espace_num%C3%A9rique_de_travail">Espace Numrique de Travail</a>) est destine  favoriser la communication au sein de l'tablissement entre les
	diffrents acteurs de la vie scolaire.</p><br />
  <p>IntraEduWeb propose toutes sortes d'informations (administratives,
  pdagogiques, Vie scolaire).</p><br />
	<p>Les visiteurs qui ne font pas partie de la communaut ducative de l'tablissement peuvent consulter les pages publiques (dans ce cas, ne pas remplir le formulaire d'identification), mais ne seront pas autoriss  consulter certaines informations contenant des donnes personnelles concernant les lves, les parents, les enseignants ou les autres membres du personnel.</p><br /><p>Le traitement de ce type de donnes dans le cadre d'un ENT est l'objet d'une rglementation dfinie par un <a href="http://www.legifrance.gouv.fr/WAspad/UnTexteDeJorf?numjo=MENT0602397A" title="arrt du Ministre de l'ducation Nationale rglementant les Espaces Numriques de Travail">arrt du Ministre de l'ducation Nationale</a>. Un engagement de conformit  cet arrt a t envoy  la <a href="http://www.cnil.fr" title="Commission Nationale de l'Informatique et des Liberts"><abbr title="Commission Nationale de l'Informatique et des Liberts">CNIL</abbr></a> par le Chef d'tablissement avant la mise en oeuvre effective de l'ENT.</p>
	<?php
}

function affiche_notes_service($destinataire)
{
	connexion_mysql();
	select_database();
	$sql = "SELECT UNIX_TIMESTAMP(date), auteur, objet, destinataire, note FROM notes WHERE destinataire='".quote_smart($destinataire)."' OR destinataire=\"lves et $destinataire\" ORDER BY date DESC LIMIT 3";
	// DEBUGG print $sql."<br />";
	$resultat = mysql_query($sql);
	$nbligne = mysql_num_rows($resultat);
	if ($nbligne>0)
	{
		$i=0;
		echo "<h1>Consultez les dernires notes d'information&nbsp:</h1>";
		echo "<table class='ctextes' width='100%'>";
		while($ligne = mysql_fetch_array($resultat))
		{
 			$i++;
 			if ($i == 1)
 			{
 				$class_titre_note = "class='top'";
 				if ($nbligne == 1)
 					$class_note = "class='bottom'";
 				else 
 					$class_note = "";	
 			}
 			elseif ($i == $nbligne)
 			{
	 			$class_titre_note = "";
 				$class_note = "class='bottom'";
	 		}
 			else
 			{
	 			$class_titre_note = "";
 				$class_note = "";	
 			}
 			echo "
 			<tr>
 				<td bgcolor=\"#FFCC99\" $class_titre_note>
 					<h2 class='hidden'>".stripslashes($ligne["objet"])."</h2>	
 					<strong>
 					<font color=\"brown\">
	 					$i. ".stripslashes($ligne["objet"])."
 					</font></strong>
 				</td>
 			</tr>
 			<tr>
	 			<td $class_note>
 					Auteur : ".stripslashes($ligne["auteur"])."
 					<br />Publi le : ".date("d\/m\/Y  H\hi", $ligne["UNIX_TIMESTAMP(date)"])."<hr />".
 					stripslashes($ligne["note"])."<br />
 				</td>
 			</tr>";
		}
		echo "
    </table>";
	}
}

// Script principal

// DEBUGG echo "POST :"; print_r($_POST); echo "<br /><br />";

echo "<h1 class='hidden'>Bienvenue</h1>";

if (isset($_SESSION['valid_id_user'])) // Si l'utilisateur est authentifi, message d'accueil personnalis
{
	// Si on revient sur cette page, on vrifie le timeout et l'ip
	$array_valid_user=array("tous"); // Toutes les catgories d'utilisateurs authentifis ont accs  cette page
	$error_message = check_valid_user($array_valid_user);
	if (isset($error_message) && $error_message[1]!="charte") // si l'accs n'est plus autoris  cause d'un timeout ou d'une autre ip que la session actuelle
	{
    	echo "<p></p>";
    	affiche_erreurs($error_message); // dont le formulaire de login
    	message_accueil_standard();
  	}
  	else // la session est encore valable
	{
		// On vrifie juste, si c'est la premire connexion de l'utilisateur authentifi, que celui-ci vient bien d'accepter la charte IntraEduWeb
    	if (isset($_POST['accept_charte'])) // il a effectivement cliqu sur le bouton Accepter
    	{
	    	// on met  jour dans la base de donne
    		$sql = "INSERT INTO accept_charte VALUES('".quote_smart($_SESSION['valid_id_user'])."')";
      		mysql_query($sql);
      		if (mysql_affected_rows()!=0)
      		{
        		$ok_message = "Votre acceptation de la <a href='".$GLOBALS['texte_charte']."'>Charte d'utilisation IntraEduWeb</a> a t enregistre. Vous pouvez maintenant accder pleinement (en fonction de vos droits) au contenu du portail IEW.";
        		echo "<br />";
        		affiche_ok($ok_message);
        		unset($_SESSION['accept_charte']); // la variable de session tait positionne  "non" dans fonctions_erreurs.php, ce qui permettait d'intgrer les styles propres au formulaire d'acceptation de la charte dans la fonction debut_code_html() dans fonctions_affichage.php pour qu'ils soient au sein de la balise <head>
		        // On supprime les donnes du post (car rcupres  partir de la session) pour viter que le message prcdent ne s'affiche une seconde fois
    		    unset($_POST);
        		unset($_SESSION['post_imprimable']);
      		}
    	}
    
		if ($_SESSION['valid_nom']=="") // en principe, pour l'admin
    	{
       		$username = $_SESSION['valid_login'];
    	}
    	else
    	{
        	$username = $_SESSION['valid_prenom']." ".$_SESSION['valid_nom'];
    	}
    	echo "
    	<br />
    	<div id='welcome_message'>
    	Votre authentification a russi, <span class='bleu'>".$username."</span>. Bienvenue !<br />";
	    // La date de dernire visite est affiche le cas chant
    	$sql = "SELECT debut FROM journal_connexions WHERE id_pers='".$_SESSION['valid_id_user']."' ORDER BY debut DESC";
    	$result2 = mysql_query($sql);
    	if ($result2 && mysql_num_rows($result2))
    	{
      		$nb_connexions = mysql_num_rows($result2); // Nombre total de connexions
      		$ligne2 = mysql_fetch_array($result2); // Voil la connexion actuelle
      		$ligne2 = mysql_fetch_array($result2); // On rcupre seulement la dernire connexion
      		$date_last_connect = $ligne2['debut'];
      		if ($date_last_connect!="")
        		echo "<div id='last_connection'>Votre dernire connexion : le <span class='date_last_connect'>".date("d/m/Y  H:i",$date_last_connect)."</span> , connexion actuelle : n<span class='date_last_connect'>$nb_connexions</span></div>";
    	}
    	echo "</div>";
	   // On vrifie la date de validit du mot de passe et on informe l'utilisateur un certain nombre de jours avant
    	// tout ceci est paramtr danc config.php
    	if ($_SESSION['auth_method_user'] == "native") // seulement en authentification native pour l'utilisateur
    	{
    		if (isset($_SESSION['date_limite_passwd']) && strtotime(date("Y-m-d"))<=strtotime($_SESSION['date_limite_passwd'])) // la date du jour n'a pas dpass la date limite de validit du mot de passe
    		{
	        	// On dtermine le nombre de jours pendant lesquels le compte est encore actif
      			$nbJour = intval((strtotime($_SESSION['date_limite_passwd']) - strtotime(date("Y-m-d"))) / (60*60*24));
      			if ($nbJour <= $GLOBALS['timeout_desactivation_mdp'] && $_SESSION['valid_group'] != "11") // Si on est dans la priode de timeout avant la dsactivation, on informe l'utilisateur
      			{
        			$error_message = array("<div align='justify'>Votre mot de passe va bientt expirer ! Il vous faut le changer : vous disposez encore de <font color='black'><strong>$nbJour</strong></font> jour(s) avant que votre compte d'accs ne soit bloqu.</div>","");
        			affiche_erreurs($error_message);
      			}
    		}
    		elseif ($_SESSION['valid_login'] != "admin-iew") // la date limite de validit du mot de passe est dpasse
    		{
		        // En principe, on ne devrait pas arriver ici car une vrification est effectue par la fonction auth_success($infos_utilisateurs), ce qui permet d'empcher l'accs  un utilisateur qui tenterait de ne pas passer par la page d'accueil, mais au cas o....
    	  		$error_message = array("<div align='justify'>Votre mot de passe a expir ! Vous avez dpass la date ultime autorise pour changer votre mot de passe. Vous tes dconnect du systme. Pour pouvoir vous connecter  nouveau, faites une <a href='mdp_perdu.php'>demande de mot de passe</a></div>","");
	      		// Le mot de passe est chang
      			$password=random_password(8); // On gnre un mot de passe de 8 caractres
      			$md5_password = md5($password); // on le hashe (ne sera pas en clair dans la table)
      			// Sa dure de validit est paramtrable dans config.php (en nombre de mois)
      			$today = strtotime(date("Y-m-d"));
      			$upto = $today+60*60*24*30*$GLOBALS['validite_mdp'];
      			$limit_date_passwd = date("Y-m-d",$upto);
      			$sql = "UPDATE login set mot_pass='".quote_smart($md5_password)."',limit_date_passwd='$limit_date_passwd' WHERE nomlogin='".quote_smart($_SESSION['valid_login'])."' AND auth_source='native'"; // AND auth_source = native permet de distinguer le bon utilisateur (le couple nomlogin/auth_source est unique, mais pas le nomlogin seul !)
      			mysql_query($sql);  // Le compte est modifi
				// On inscrit le changement dans le fichier de stockage
		        // En fait ici, le changement de mot de passe ayant t fait automatiquement  cause d'un 
		        // ancien mot de passe devenu invalide
	    	    // Celui-ci ne sera pas inscrit dans le fichier de stockage (remplac par une zone vide)
	        	// Ceci permettra  l'admnistrateur de n'avoir  diffuser en dbut d'anne scolaire
		        // que les comptes disposant d'un mot de passe (crypt), c'est--dire pour les utilisateurs
		        // crs aprs un import automatique (s'ils ne modifient pas eux-mme leur mot de passe
	    	    // par la suite)
	        	$sql = "SELECT id_gpe_utilisateurs FROM login WHERE nom_login='".quote_smart($_SESSION['valid_login'])."' AND auth_source='native'"; // il faut d'abord savoir  quel type d'utilisateur lve, membre du personnel, parent, on a  faire
        		$result1 = mysql_query($sql);
    	    	$ligne1 = mysql_fetch_array($result1);
	        	if ($ligne1['id_gpe_utilisateurs'] == "2") // L'utilisateur est un lve
    	    	{
          			$nom_fichier = $GLOBALS['stock_baselev']."comptes_eleves.txt";
        		}
        		elseif ($ligne1['id_gpe_utilisateurs'] == "4") // L'utilisateur est un parent
        		{
          			$nom_fichier = $GLOBALS['stock_baselev']."comptes_parents.txt";
        		}
        		elseif ($ligne1['id_gpe_utilisateurs'] == "11") // L'utilisateur est un IPR
        		{
        			$nom_fichier = $GLOBALS['stock_baselev']."comptes_ipr.txt";
        		}
        		elseif ($ligne1['id_gpe_utilisateurs'] != "11") // L'utilisateur est un membre du personnel
        		{
          			$nom_fichier = $GLOBALS['stock_baselev']."comptes_personnel.txt";
        		}
        		modif_codes_acces_fichier_texte($nom_fichier,$_SESSION['valid_id_user'],$_SESSION['valid_prenom'],$_SESSION['valid_nom'],$_SESSION['valid_login'],"","");
				// On dconnecte l'utilisateur, et personne ne peut connatre le nouveau mot de passe
				// Il ne pourra plus y avoir de connexion de cet utilisateur (il faudra qu'il redemande un mot de passe  l'administrateur)
      			$_SESSION = array();
      			session_destroy();
      			affiche_erreurs($error_message);
      			return;
    		}
  		}
		if (isset($_SESSION['anscol']) && isset($_SESSION['anscol']) !="") // Si on est dans les archives
		{
      		echo "<center><b>Vous tes connect <font color='red'>aux archives de l'anne ".$_SESSION['anscol']."</font>.</b></center><br />
      		<b>Pour sortir des archives, cliquez sur le logo \"Archives\" en haut  droite des pages</b>";
		}
    	if (message_accueil_utilisateur_authentifie()) // Si l'utilisateur s'est authentifi et a dj accept la charte IntraEduWeb
    	{
      		switch ($_SESSION['valid_group'])
      		{
        		case '3': // les profs
          			affiche_notes_service("profs");
          			break;
        		case '2': // les lves
          			affiche_notes_service("eleves");
          			break;
        		case '4': // les parents
          			affiche_notes_service("parents");
          			break;
        		default:
      		}
      		affiche_mention_cnil();
    	}
  	}
}
else // Utilisateur non authentifi : On propose du SSO, ou bien  
{
  echo "<div id='copyright_start_page'>".$GLOBALS['copyright']."</div><br />";
  affiche_formulaire_login();
  message_accueil_standard();
}
?>