<?php 
/**
 * Browser.php
 *
 *  Alternative  Browscap.php, beaucoup moins fiable, mais utilisable pour les navigateurs principaux
 * 
 * Ce fichier fait partie du projet IntraEduWeb (IEW)
 * 
 * @package	IEW
 * @author	Sylvain GODM <sylvain.godme@gmail.com>
 * @version	$LastChangedRevision$, $LastChangedDate$
 * @copyright	2004-2014 Sylvain GODM
 * @link	http://iew.free.fr
 * @license	GPL License version 3 (http://www.gnu.org/licenses/gpl.html)
 * @filesource
 * 
 */

class Browser { 
    /** 
    Figure out what browser is used, its version and the platform it is 
    running on. 

    The following code was ported in part from JQuery v1.3.1 
    */ 
    public static function detect() { 
        $userAgent = strtolower($_SERVER['HTTP_USER_AGENT']); 

        // Identify the browser. Check Opera and Safari first in case of spoof. Let Google Chrome be identified as Safari. 
        if (preg_match('/opera/', $userAgent)) { 
            $name = 'Opera'; 
        } 
        elseif (preg_match('/webkit/', $userAgent)) { 
            if (preg_match('/chrome/', $userAgent)) // Si je ne fait pas a, chrome apparat comme "Safari"
            	$name = 'Chrome';
            else
        	 $name = 'Safari'; 
        } 
        elseif (preg_match('/msie/', $userAgent)) { 
            $name = 'Internet Explorer'; 
        } 
        elseif (preg_match('/mozilla/', $userAgent) && !preg_match('/compatible/', $userAgent)) { 
            if (preg_match('/firefox/', $userAgent)) // // Si je ne fait pas a, firefox apparat comme "Mozilla"
            	$name = 'Firefox';
            else
        	$name = 'Mozilla'; 
        } 
        else { 
            $name = 'Non reconnu'; 
        } 

        // What version? 
        if ($name == 'Chrome') // Pour Chrome, comme apparat comme Safari, ce serait la version de Safari : on vite cela en induqant pas la version
        {
        	$version = '';
        }
        elseif (preg_match('/.+(?:rv|it|ra|ie)[\/: ]([\d.]+)/', $userAgent, $matches)) { 
            $version = $matches[1]; 
        } 
        else { 
            $version = 'unknown'; 
        } 

        // Running on what platform? 
        if (preg_match('/linux/', $userAgent)) { 
            $platform = 'linux'; 
        } 
        elseif (preg_match('/macintosh|mac os x/', $userAgent)) { 
            $platform = 'mac'; 
        } 
        elseif (preg_match('/windows|win32/', $userAgent)) { 
            $platform = 'windows'; 
        } 
        else { 
            $platform = 'unrecognized'; 
        } 

        return array( 
            'name'      => $name, 
            'version'   => $version, 
            'platform'  => $platform, 
            'userAgent' => $userAgent 
        ); 
    } 
} 
 
?>