<?php
/**
 * c_consult_not.php
 *
 * permet la consultation des notes d'information
 * 
 * Ce fichier fait partie du projet IntraEduWeb (IEW)
 * 
 * @package		IEW
 * @author			Sylvain GODM <sylvain.godme@gmail.com>
 * @version		$LastChangedRevision$, $LastChangedDate$
 * @copyright		2004-2012 Sylvain GODM
 * @link			http://iew.free.fr
 * @license		GPL License version 3 (http://www.gnu.org/licenses/gpl.html)
 * @filesource
 * 
 * @param			$critere (contient les destinataires des notes d'information : lves, profs ou les 2)
 * @param			$target (si la valeur est  'all' alors toutes les notes d'information depuis le dbut de l'anne scolaire sont affiches, dans le cas contraire, seules les notes des 7 derniers jours sont affiches)
 * 
 */
 
connexion_mysql();
select_database();
$target = "";
if (isset($_GET['critere']))
  $critere = trim(htmlspecialchars(quote_smart($_GET['critere'])));
elseif ($_SESSION['valid_group']=='3')
  $critere = "profs";
elseif ($_SESSION['valid_group']=='4')
  $critere = "parents";
else // entre par dfaut pour tous les autres utilisateurs
  $critere = "lves";
if (isset($_GET['target']))
$target = $_GET['target'];
$racine = $GLOBALS['racine'];

// Attention cette page est accessible  tous par dfaut, mais si on chercher les notes d'information  destination des profs,il faut s'assurer que seuls les profs authentifis (ou la direction, les surveillants, gestadmin et admin)
if ($critere == "profs")
{
  // Le script en cours doit tre le script d'appel prvu
  if (!end_with_string($_SERVER['PHP_SELF'],"consult_not.php") && !end_with_string($_SERVER['PHP_SELF'],"prive/profs/notserv.php"))
  {
    // L'utilisateur essaie d'invoquer ce script directement dans l'URL (interdit)  
    $error_message = array("Vous tentez d'accder  un script qui n'est pas accessible directement  partir de l'URL... Utilisez les liens de navigation !","");
  affiche_erreurs($error_message);
    return;
  }
}
echo "<br /><h1>Consultation des notes d'information<br/>aux $critere</h1>";
if ($target=="all")
{
  echo "<p>Voici affiches toutes les notes  destination des ".$critere." publies <font color='red'>depuis le dbut de l'anne scolaire</font>. Si vous souhaitez consulter seulement les notes depuis 7 jours, cliquer <a href='$racine"."consult_not.php?critere=$critere'".">ici</a>.</p>";
  $sql = "SELECT UNIX_TIMESTAMP(date), auteur, objet, destinataire, note FROM notes WHERE destinataire like '%$critere%'";
}
else
{
  echo "<p>Par dfaut, sont affiches les notes  destination des <strong><u>$critere</u></strong> publies <font color='red'><b>depuis 7 jours</b></font>. Si vous souhaitez consulter toutes les notes de l'anne scolaire en cours, cliquer <a href='$racine"."consult_not.php?target=all&amp;critere=$critere'>ici</a>.</p>";
  $sql = "SELECT UNIX_TIMESTAMP(date), auteur, objet, destinataire, note FROM notes WHERE destinataire like '%$critere%' AND UNIX_TIMESTAMP(NOW())-UNIX_TIMESTAMP(date)<=604800";
}
if ($critere=="lves")
{
  echo "<p>Les notes destines aux parents sont accessibles aux seuls parents : <a href='$racine"."consult_not.php?critere=parents'> Accs Parent</a><br />";
  echo "Les notes destines aux professeurs sont accessibles aux seuls membres du personnel : <a href='$racine"."consult_not.php?critere=profs'> Accs Professeur</a></p>";
}
elseif ($critere=="parents")
{
  echo "<p>Les notes destines aux lves sont accessibles  tous : <a href='$racine"."consult_not.php?critere=lves'> Accs Elve</a><br />";
  echo "Les notes destines aux professeurs sont accessibles aux seuls membres du personnel : <a href='$racine"."consult_not.php?critere=profs'> Accs Professeur</a></p>";
}
else // Accs prof ou autre membre du personnel
{
  echo "<p>Les notes destines aux lves sont accessibles  tous : <a href='$racine"."consult_not.php?critere=lves'> Accs Elve</a>";
  echo "<br />Les notes destines aux parents sont accessibles aux seuls parents : <a href='$racine"."consult_not.php?critere=parents'> Accs Parent</a></p>";
}
$resultat = mysql_query($sql);
if ($resultat)
{
  $i=0;
  $nbligne = mysql_num_rows($resultat);
  echo "<table border='0' width='100%'>
  <tr>
  	<td>
  		<i><br />Il y a <b><font color='red'>$nbligne</font></b> note(s) d'information <b><i><u>pour les $critere</u></i></b>.</i>
  	</td>";
  if ($nbligne>=3)
  {
    echo "
    <td align='right' valign='bottom'>
    	<a href='#bas'>Bas de la page</a>
    </td>";
  }
  else
  {
  	echo "
    <td align='right' valign='bottom'>
    </td>";
  }
  echo "</tr></table>
  <br />";
  if ($nbligne >= 1)
  {
  	echo "
  	<table class='ctextes' width='100%'>";
	while($ligne = mysql_fetch_array($resultat))
	{
 		$i++;
 		if ($i == 1)
 		{
 			$class_titre_note = "class='top'";
 			if ($nbligne == 1)
 				$class_note = "class='bottom'";
 			else 
 				$class_note = "";	
 		}
 		elseif ($i == $nbligne)
 		{
 			$class_titre_note = "";
 			$class_note = "class='bottom'";
 		}
 		else
 		{
 			$class_titre_note = "";
 			$class_note = "";	
 		}
 		echo "
 		<tr>
 			<td bgcolor=\"#FFCC99\" $class_titre_note>
 				<h2 class='hidden'>".stripslashes($ligne["objet"])."</h2>	
 				<strong>
 				<font color=\"brown\">
 					$i. ".stripslashes($ligne["objet"])."
 				</font></strong>
 			</td>
 		</tr>
 		<tr>
 			<td $class_note>
 				Auteur : ".stripslashes($ligne["auteur"])."
 				<br />Publi le : ".date("d\/m\/Y  H\hi", $ligne["UNIX_TIMESTAMP(date)"])."<hr />".
 				stripslashes($ligne["note"])."<br />
 			</td>
 		</tr>";
	}
	echo "
    </table>";
  }
  // on affiche le formulaire de gestion administrative de ces pages
  if ($_SESSION['valid_group'] == "1" || $_SESSION['valid_group'] == "5" || $_SESSION['valid_group'] == "6")
  {
    echo "<br /><br /><center>";
    $code_formulaire = "<br />Cet accs est strictement rserv aux personnes charges de la gestion administrative de l'intranet, comme le secrtariat de l'tablissement par exemple.<br /><br /><a href='$racine"."prive/admin_notes.php'>Ajout-modification-suppression des notes d'information</a><br /><br />";
    squelette_formulaire_standard("75%","","","Rserv  l'administration",$code_formulaire,"","","","","","","");
    echo "</center>";
  }
}
?>