<?php
/**
 * c_mdp_perdu.php
 *
 * page de gestion des pertes de mot de passe (uniquement pour les utilisateurs authentifis localement)
 * 
 * On part du principe parano : il n'est pas possible d'identifier  100% une personne ayant perdu
 * son mot de passe. Donc, on demande des renseignements et on vrifie les dclarations faites par le
 * demmandeur dans la bdd, mais on fournira directement  la personne concerne son nouveau mot de passe :
 * une vrification manuelle sera ainsi faite pour s'assurer 100% de bonne identification
 * 
 * Ce fichier fait partie du projet IntraEduWeb (IEW)
 * 
 * @package		IEW
 * @author			Sylvain GODM <sylvain.godme@gmail.com>
 * @version		$LastChangedRevision$, $LastChangedDate$
 * @copyright		2004-2012 Sylvain GODM
 * @link			http://iew.free.fr
 * @license		GPL License version 3 (http://www.gnu.org/licenses/gpl.html)
 * @filesource
 * 
 */
 

function affiche_formulaire()
{
  if (isset($_POST['nomlogin'])) // s'il y a eu un post
    $tab = $_POST;
  else // sinon on initialise les varaibles (vite erreur E_NOTICE)
    $tab = array("nomlogin"=>"","nom"=>"","prenom"=>"","sexe"=>"","usercat"=>"","classe"=>"","datenais"=>"","nom1"=>"","prenom1"=>"","nom2"=>"","prenom2"=>"","nom3"=>"","prenom3"=>"","nom4"=>"","prenom4"=>"","nom5"=>"","prenom5"=>"");
  // les catgories d'utilisateur
  $cat_users = array("2"=>"lve","3"=>"Professeur","4"=>"Parent d'lve","6"=>"Membre du personnel","11"=>"IPR");
  if(isset($_SESSION['valid_group'])) // vite erreur E_NOTICE
    $valid_group = $_SESSION['valid_group'];
  else
    $valid_group = "";
  $code_formulaire = "<br />
  Ce formulaire de collecte de donnes respecte <a href='javascript://' onclick=\"window.open('".$GLOBALS['chemin_relatif']."cnil_art32.php?usercat=".$valid_group."','CNIL_article32','toolbar=no,location=no,directories=no,menuBar=no,scrollbars=yes,resizable=no,status=no,width=500,height=500');return false;\">les recommandations de la CNIL</a><br />
  <table width='100%' cellspacing='5' cellpadding='5'>
  <tr>
    <td align='right'>
      <label for='FormReqNomlogin'>Entrez votre identifiant</label>&nbsp;:
    </td>
    <td>
      <input type='text' size='20' name='nomlogin' id='FormReqNomlogin' value=\"".stripslashes($tab['nomlogin'])."\" /><br />
    </td>
    <td valign='middle' rowspan='4'>
    <label for='FormReqUsercat'>Vous tes un</label>&nbsp;:
      <br /><select size='5' name='usercat' id='FormReqUsercat' onchange='complement_form(event)'>";
      foreach ($cat_users as $key => $value)
      {
        if ($tab['usercat'] == $key)  
          $code_formulaire .= "<option value='$key' selected='selected'>$value</option>";
        else
          $code_formulaire .= "<option value='$key'>$value</option>";
      }
  $code_formulaire .="
      </select>
    </td>
  </tr>
  <tr>
    <td align='right'>
     <label for='FormReqNom'>Nom</label>&nbsp;:  
    </td>
    <td>
      <input type='text' size='20' name='nom' id='FormReqNom' value=\"".stripslashes($tab['nom'])."\" /><br />
    </td>
  </tr>
  <tr>
    <td align='right'>
      <label for='FormReqPrenom'>Prnom</label>&nbsp;:  
    </td>
      <td>
      <input type='text' size='20' name='prenom' id='FormReqPrenom' value=\"".stripslashes($tab['prenom'])."\" /><br />
    </td>
  </tr>
  <tr>
    <td align='right'>
       <label for='FormReqSexe'>Sexe</label>&nbsp;:
    </td>
    <td>
      <select size='1' name='sexe' id='FormReqSexe'>";
      if ($tab['sexe'] == "1")
      {
        $code_formulaire .= "<option value='1' selected='selected'>Fminin</option><option value='2'>Masculin</option></select>";
      }
      elseif ($tab['sexe'] == "2")
      {
        $code_formulaire .= "<option value='2' selected='selected'>Masculin</option><option value='1'>Fminin</option></select>";
      }
      else
        $code_formulaire .= "<option></option><option value='1'>Fminin</option><option value='2'>Masculin</option></select>";
    $code_formulaire .= "
    </td>
  </tr>
  </table>";
  $code_formulaire .="
  <div id='sous_form' style='text-align: justify; margin-top: 10px;";
  if (isset($_POST['usercat'])) // Le formulaire a dj t soumis (mais mal rempli => on le raffiche)
  {
    $code_formulaire .= "'>
    ";
    if ($_POST['usercat'] == 2) // Cas d'un lve
    {
      $code_formulaire .= "<label for='FormClasse'>Prcisez votre classe</label>&nbsp;:<select size='1' name='classe' id='FormClasse'><option selected='selected'>".$_POST['classe']."</option><option></option>".liste_classes();
      $code_formulaire .= "</select><img src='images/pixel.gif' width='15' alt='' />Votre Date de Naissance : (jj/mm/aaaa) <input type='text' size='20' name='datenais' value='".$_POST['datenais']."' /><br /><br />";
    }
    elseif ($_POST['usercat'] == 3) // Cas d'un prof
    {
      $code_formulaire .= "<center><table><tr><td valign='middle'><label for='FormReqclasses'>Slectionnez vos classes</label>&nbsp;: (maintenir la touche CTRL enfonce)</td><td><select size='5' multiple='multiple' id='FormReqclasses' name='classes[]'>". liste_classes();$code_formulaire .= "</select></td></tr></table></center><br />";
    }
    elseif ($_POST['usercat'] == 4) // Cas d'un parent d'lve
    {
      $code_formulaire .= "Remplissez le tableau ci-dessous, pour chacun de vos enfants scolariss dans notre tablissement<font color='red'>*</font> :<br /><table><tr><th>Nom</th><th>Prnom</th><th>Date de naissance<br />(format jj/mm/aaaa)</th></tr>";
      $i=1;
      for ($i=1;$i<=5;$i++)
      {
        $code_formulaire .= "<tr><td><input type='text' size='20' id='nom$i' name='nom$i' value='".$_POST["nom$i"]."' /></td><td><input type='text' size='20' id='prenom$i' name='prenom$i' value='".$_POST["prenom$i"]."' /></td><td><input type='text' size='16' id='datenais$i' name='datenais$i' value='".$_POST["datenais$i"]."' /></td></tr>";
      }
      $code_formulaire .= "</table><br />";
    }
    elseif ($_POST['usercat'] == 11) // Cas d'un IPR
    {
      $code_formulaire .= "<label for='FormReqDatevisite'>Prcisez la date de votre visite dans l'tablissement (format jj/mm/aaaa)</label>&nbsp;: <input type='text' name='datevisite' id='FormReqDatevisite' size='12' value='".$_POST['datevisite']."' /><br /><br />";
    }
    $code_formulaire .= "</div>";
  }
  else // au dpart le div est invisible
  {
    $code_formulaire .=" visibility: hidden; display: none;'>
    </div>";
  }
  $code_formulaire .= info_champs_obligatoires()."<br />";
  
  echo "<center>";
  squelette_formulaire_standard("100%","post",$_SERVER['PHP_SELF']."' name='ident_form' onsubmit='return valider_form();'","<h2 class='hidden'>Formulaire d'identification du demandeur</h2>Formulaire d'identification du demandeur",$code_formulaire,"Valider","soumettre","","","","","");
  echo "</center>";
}

function liste_classes()
{
  $liste_classes = "<option></option>";
  $sql = "SELECT division FROM divisions ORDER BY division";
  $resultat = mysql_query($sql);
  if ($resultat && mysql_num_rows($resultat) >0)
  {
    while ($ligne = mysql_fetch_array($resultat))
    {
      if (isset($_POST['usercat']) && $_POST['usercat']=="3") // le formulaire a dj t post
      {
        if (is_array($_POST['classes']) && in_array($ligne['division'],$_POST['classes']))
          $liste_classes .= "<option selected='selected'>".$ligne['division']."</option>";
        else
          $liste_classes .= "<option>".$ligne['division']."</option>";
      }
      else
        $liste_classes .= "<option>".$ligne['division']."</option>";
    }
  }
  return $liste_classes;
}

function rejette_demande()
{
  // Renvoie un message d'erreur, sans indiquer la raison prcise de l'chec de l'identification
  // (pour ne pas donner d'indication  un ventuel usurpateur d'identit)
  $error_message = array("<div align='justify'>Les informations fournies ne permettent pas de vous identifier : vous ne pouvez pas demander un mot de passe !<br />Si vous estimez que ceci est une erreur, refaites une tentative (en modifiant ventuellement certains champs du formulaire), et en cas de nouvel chec, <a href='mailto:".email_encode($GLOBALS['admin_email'])."'>prenez contact avec votre administrateur IntraEduWeb</a></div>","");
  affiche_erreurs($error_message);
  return;
}

function enregistre_demande($id_pers,$usercat,$nom,$prenom)
{
  // Avant d'enregistrer la demande, on vrifie qu'il n'exsite pas dj une demande non satisfaite
  // En effet, compte tenu de l'index unique ($id_pers, date) sur la table demande_mdp, il ne peut y avoir 2 demandes de la mm personne le mme jour
  // mais cet index n'empche pas  lui seul l'utilisateur de faire une 2me demande ou plus les jours suivants
  // pour viter de multiplier les demandes non satisfaites d'un mme utilisateur on fait la vrif suivante :
  $sql = "SELECT * FROM demande_mdp WHERE id_pers='$id_pers' AND date_satisfaction IS NULL";
  $resultat = mysql_query($sql);
  if ($resultat && mysql_affected_rows() > 0) // il y a dj une demande non satisfaite
  {
  	$ligne = mysql_fetch_array($resultat);
  	$date_demande = $ligne['date'];
  	$aujourdhui = date('Y-m-d');
  	$nb_jours = date_difference($date_demande, $aujourdhui); // on cherche le nb de jours couls depuis la demande
  	if ($nb_jours["d"] < 7)
  	{
  		$msg = "Elle date de moins de 7 jours. Attendez quelques jours avant de ";
  	}
  	else
  	{
  		$msg = "Elle date de plus de 7 jours ! Vtre nouveau mot de passe aurait d vous tre communiqu. Veuillez ";
  	}
  	$error_message = array("Vous avez dj effectu une demande de mot de passe le ".MySQLDateToExplicitDate($ligne['date']).", mais celle-ci n'a pas encore t satisfaite. $msg contacter <a href='mailto:".email_encode($GLOBALS['admin_email'])."'>l'administrateur IntraEduWeb</a>.","");
  	affiche_erreurs($error_message);
  	return; // pas d'enregistrement de la demande
  }
  // On peut cependant avoir un utilisateur tourdi qui fait plusieurs demandes dans l'anne, du moment que le couple (id_pers, date) n'existe pas dans la table dmeande_mdp, c'est ok
  // Cela permet de maintenir l'historique des demandes
  $cat_users = array("2"=>"lve","3"=>"Professeur","4"=>"Parent d'lve","6"=>"Membre du personnel","11"=>"IPR");
  $sql = "INSERT INTO demande_mdp VALUES('".quote_smart($id_pers)."',NOW(),'".quote_smart($usercat)."','".quote_smart($nom)."','".quote_smart($prenom)."',NULL)";
  $resultat = mysql_query($sql);
  if ($resultat && mysql_affected_rows() == 1)
  {
    $ok_message = "<div align='justify'>Votre demande a t enregistre : vous serez contact pour une ultime vrification et une confirmation de la perte de votre mot de passe. Si vous n'avez pas de nouvelles d'ici quelques jours, <a href='mailto:".email_encode($GLOBALS['admin_email'])."'>prenez contact avec votre administrateur IntraEduWeb</a></div>";
    affiche_ok($ok_message);
    // On envoie un mail  l'tablissement
    $message = "Bonjour,\n\nCeci est un message automatique envoy par l'application IEW du ".$GLOBALS['nom_etablissement']." :\n\nPour cause de perte du mot de passe, une demande de nouveau mot de passe semble avoir t effectue par un ".$cat_users[$usercat]." nomm :\n\n$nom $prenom (identifiant : $id_pers dans la base de donnes IEW)\n\nMerci de bien vouloir contacter cette personne pour s'assurer de son identit et de la confirmation de la demande.\n\nLorsque cette vrification sera faite, prvenez votre administrateur IEW.";
    // Ce message doit tre morcel en lignes de 70 cc max pour la fonction mail()
    $message = wordwrap($message, 70);
    $entetes_additionnels = "From: ".$GLOBALS['nom_etablissement']."<".$GLOBALS['email_etablissement'].">\n";
    // Si chec du mail automatique, lui communiquer autrement (mail manuel, ou de vive voix...)
    if (!mail($GLOBALS['email_etablissement'],"Demande de nouveau mot de passe pour l'application IEW du ".$GLOBALS['nom_etablissement'],$message,$entetes_additionnels))
    {
      $error_message = array("
      <div align='justify'>
      Suite  un problme technique, le service administratif de l'tablissement n'a pas pu tre inform <strong>par mail</strong> de votre demande. Veuillez contacter directement l'tablissement.
      </div>","");
      affiche_erreurs($error_message);
    }
  }
  else
  {
    //DEBUGG echo "$sql<br />";
    $error_message = array("<div align='justify'>Votre demande n'a pas pu tre enregistre. Si vous avez eu auparavant un message vous indiquant l'enregistrement de votre demande et que ayez recharg la page, ce message est tout  fait normal. Si vous n'avez pas eu de confirmation de l'enregistrement de votre demande, <a href='mailto:".email_encode($GLOBALS['admin_email'])."'>prenez contact avec votre administrateur IntraEduWeb</a></div>","");
    affiche_erreurs($error_message);
  }
  unset($_POST);
  unset($_SESSION['post_imprimable']);
  return;
}

/* Programme principal */

// Le script en cours doit tre le script d'appel prvu
if ($_SERVER['PHP_SELF'] == $GLOBALS['racine']."mdp_perdu.php")
{
  connexion_mysql();
  select_database();

  echo "<script type='text/javascript'>
    function complement_form(evt)
    {
      // equalize W3C/IE event models to get event object
      evt = (evt) ? evt : ((window.event) ? window.event : null);
      if (evt)
      {
        // equalize W3C/IE models to get event target reference
        var elem = (evt.target) ? evt.target : ((evt.srcElement) ? evt.srcElement : null);
        if (elem)
        {
          // On commence par afficher le bloc div contenant le critre  slectionner
          div = document.getElementById(\"sous_form\");
          div.innerHTML = \"\";
          if (elem.selectedIndex == 0) // Cas d'un lve
          {
            div.innerHTML = \"<label for='FormClasse'>Prcisez votre classe</label>&nbsp;: <select size='1' name='classe' id='FormClasse'>"; echo liste_classes();echo "</select><img src='images/pixel.gif' width='15' alt='' />Votre Date de Naissance : (jj/mm/aaaa) <input type='text' size='12' name='datenais' /><br /><br />\";
          }
          if (elem.selectedIndex == 1) // Cas d'un prof
          {
            div.innerHTML = \"<center><table><tr><td valign='middle'><label for='FormReqclasses'>Slectionnez vos classes</label>&nbsp;: (maintenir la touche CTRL enfonce)</td><td><select size='5' multiple='multiple' id='FormReqclasses' name='classes[]'>"; echo liste_classes();echo "</select></td></tr></table></center><br />\";
          }
          if (elem.selectedIndex == 2) // Cas d'un parent d'lve
          {
            div.innerHTML = \"Remplissez le tableau ci-dessous, pour chacun de vos enfants scolariss dans notre tablissement<font color='red'>*</font> :<br /><center><table><tr><th>Nom</th><th>Prnom</th><th>Date de naissance<br />(format jj/mm/aaaa)</th></tr>";
            $i=1;
            for ($i=1;$i<=5;$i++)
            {
              echo "<tr><td><input type='text' size='20' id='nom$i' name='nom$i' /></td><td><input type='text' size='20' id='prenom$i' name='prenom$i' /></td><td><input type='text' size='16' id='datenais$i' name='datenais$i' /></td></tr>";
            }
            echo "</table></center><br />\";
          }
          if (elem.selectedIndex == 3) // Cas d'un membre du personnel
          {
            return; // il n'y a pas de renseignement complmentaire  demander
          }
          if (elem.selectedIndex == 4) // Cas d'un IPR
          {
            div.innerHTML = \"<label for='FormReqDatevisite'>Prcisez la date de votre visite dans l'tablissement (format jj/mm/aaaa)</label>&nbsp;: <input type='text' name='datevisite' id='FormReqDatevisite' size='12' /><br /><br />\";
          }
          div.style.visibility = \"visible\";
          div.style.display = \"block\";
        }
      }
    }
    function valider_form() // Contrle de validation de formulaire avant envoi
    {
      if (document.ident_form.nomlogin.value != \"\" && document.ident_form.nom.value != \"\" && document.ident_form.prenom.value != \"\" && document.ident_form.sexe.value != \"\" && document.ident_form.usercat.value != \"\")
      {
        // On poursuit les vrifications
        if (document.ident_form.usercat.value == 2) // Cas d'un lve
        {
          // La classe ne doit pas tre vide
          if (document.ident_form.classe.value == \"\")
          {
            alert(\"Vous n\'avez pas renseign votre classe !\");
            return false;
          }
          // La date doit tre correctement formate (jj/mm/aaaa)
          if (document.ident_form.datenais.value == \"\")
          {
            alert(\"Le champ date de naissance est vide !\");
            return false;
          }
          if (CheckDate(document.ident_form.datenais.value) == false)
          {
            return false;
          }
        }
        if (document.ident_form.usercat.value == 3) // Cas d'un PROF
        {
          // Les classes qu'il a en charge doivent tre renseignes
          // On rcupre dans une variable de type tableau les options du champ select multiple
          var selectedList = new Array();
          var selectBox = document.ident_form.FormReqclasses; 
          for (var i=0; i<selectBox.options.length; i++)
          { 
            if (selectBox.options[i].selected)
            { 
              selectedList.push(selectBox.options[i]); 
            } 
          }
          if (selectedList.length == 0) // Si rien n'a t slectionn dans le formulaire
          {
            alert(\"Vous n\'avez pas slectionn vos classes !\");
            return false;
          }
        }
        if (document.ident_form.usercat.value == 4) // Cas d'un parent d'lve
        {
          var flag = \"\"; // servira  savoir si au moins une ligne du tableau concernant les enfants scolariss est remplie
          for (var i=1; i<=5;i++)
          {
            var nom = \"nom\"+i;
            var prenom = \"prenom\"+i;
            var datenais = \"datenais\"+i;
            if (document.getElementById(nom).value != \"\" && document.getElementById(prenom).value != \"\" && document.getElementById(datenais).value != \"\")
            {
              flag = true; // Oui, au moins une ligne complte
            }
          }
          if (!flag) // Si aucune ligne complte
          {
            alert(\"Vous n\'avez pas rempli correctement le tableau concernant vos enfants scolariss dans notre tablissement !\");
            return false;
          }
          // On contrle le format des dates
          var message = \"\";
          for (var i=1; i<=5;i++)
          {
            var datenais = \"datenais\"+i;
            if (document.getElementById(datenais).value != \"\" && CheckDate(document.getElementById(datenais).value) == false)
            {
              message += \"La date sur la ligne \" + i + \" du tableau est incorrecte \";
            }
            if (message != \"\")
            {
              alert(message);
              return false;
            }
          }
        }
        if (document.ident_form.usercat.value == 11) // Cas d'un IPR
        {
          // La date doit tre correctement formate (jj/mm/aaaa)
          if (document.ident_form.datevisite.value == \"\")
          {
            alert(\"Le champ date de visite est vide !\");
            return false;
          }
          if (CheckDate(document.ident_form.datevisite.value) == false)
          {
            return false;
          }
        }
      }
      else
      {
        alert(\"Vous n\'avez pas rempli tous les champs !\");
        return false;
      }
    }

    function CheckDate(d) {
      // Cette fonction vrifie le format JJ/MM/AAAA saisi et la validit de la date.
      // Le sparateur est dfini dans la variable separateur
      var amin=1900; // anne mini
      var amax=2100; // anne maxi
      var separateur=\"/\"; // separateur entre jour/mois/annee
      var j=(d.substring(0,2));
      var m=(d.substring(3,5));
      var a=(d.substring(6));
      var ok=1;
      if ( ((isNaN(j))||(j<1)||(j>31)) && (ok==1) ) {
         alert(\"Le jour n\'est pas correct.\"); ok=0;
      }
      if ( ((isNaN(m))||(m<1)||(m>12)) && (ok==1) ) {
         alert(\"Le mois n\'est pas correct.\"); ok=0;
      }
      if ( ((isNaN(a))||(a<amin)||(a>amax)) && (ok==1) ) {
         alert(\"L\'anne n\'est pas correcte.\"); ok=0;
      }
      if ( ((d.substring(2,3)!=separateur)||(d.substring(5,6)!=separateur)) && (ok==1) ) {
         alert(\"Les sparateurs doivent tre des \"+separateur); ok=0;
      }
      if (ok==1) {
         var d2=new Date(a,m-1,j);
         j2=d2.getDate();
         m2=d2.getMonth()+1;
         a2=d2.getFullYear();
         if (a2<=100) {a2=1900+a2}
         if ( (j!=j2)||(m!=m2)||(a!=a2) ) {
            alert(\"La date \"+d+\" n\'existe pas !\");
            ok=0;
         }
      }
      return ok;
   }
    </script>";

  echo "<h1>J'ai perdu mon mot de passe !</h1>";
  
  if (isset($_POST['soumettre']))
  {
    // On formate les noms et prnom avec la bonne casse
    $_POST['nom'] = trim(htmlspecialchars(strtoupper($_POST['nom'])));
    $_POST['prenom'] = trim(htmlspecialchars(strtoupper(substr($_POST['prenom'],0,1)).substr($_POST['prenom'],1,strlen($_POST['prenom'])-1)));
    if (isset($_POST['datenais']))
      $_POST['datenais'] = trim(htmlspecialchars($_POST['datenais']));
    
    //DEBUGG print_r($_POST); echo "<br />";
    
    // On vrifie les entres de formulaire ct serveur ainsi que l'identit du demandeur
    $sql = "SELECT * FROM login WHERE nomlogin='".quote_smart(trim(htmlspecialchars($_POST['nomlogin'])))."'";
    $resultat = mysql_query($sql);
    if ($resultat && mysql_num_rows($resultat) >0) // Il y a un compte correspondant  ce nom de login
    {
      $ligne = mysql_fetch_array($resultat); // On rcupre l'enregistrement correspondant
      if ($ligne['date_validite'] != "")
      {
        $date_validite = strtotime($ligne['date_validite']); // date de validit du compte en timestamp
        if ($date_validite<strtotime(date("Y-m-d"))) // la date de validit est dpasse
        {
          $error_message = array("<div align='justify'>Votre compte existe, mais sa date de validit est dpasse : vous ne pouvez pas demander un mot de passe !<br />Si vous estimez que ceci est une erreur, <a href='mailto:".email_encode($GLOBALS['admin_email'])."'>prenez contact avec votre administrateur IntraEduWeb</a></div>","");
          affiche_erreurs($error_message);
          affiche_formulaire();
          return;
        }
      }
      $etat = $ligne['etat'];
      if ($etat == 0) // Le compte n'est pas activ 
      {
        $error_message = array("<div align='justify'>Votre compte existe, mais n'est pas activ : vous ne pouvez pas demander un mot de passe !<br />Si vous estimez que ceci est une erreur, <a href='mailto:".email_encode($GLOBALS['admin_email'])."'>prenez contact avec votre administrateur IntraEduWeb</a></div>","");
        affiche_erreurs($error_message);
        affiche_formulaire();
        return;
      }
      // Si on arrive l, c'est que le compte est actif : on rcupre d'autres informations d'identification
      $id_pers = $ligne['id_pers'];
      $nom = $ligne['nom'];
      $prenom = $ligne['prenom'];
      // Mais l'identit est loin d'tre prouve (nom de login facile  deviner)
      switch($_POST['usercat'])
      {
        case "2": // demandeur = lve
          $tab_sexe = array("1"=>"F","2"=>"M");
          $sql1 = "SELECT * FROM eleves WHERE id_eleve='".quote_smart($id_pers)."'";
          $resultat1 = mysql_query($sql1);
          if ($resultat1 && mysql_num_rows($resultat1) >0) // Il y a un lve correspondant
          {
            // On continue les vrifications
            $ligne1 = mysql_fetch_array($resultat1);
            // d'abord le nom et le prnom
            if ($nom != $_POST['nom'] || $prenom != $_POST['prenom'])
            {
              //DEBUGG echo "Pb de nom<br />";
              rejette_demande();
              affiche_formulaire();
              return;
            }
            // Le sexe
            if ($ligne1['sexe'] != $tab_sexe[$_POST['sexe']])
            {
              //DEBUGG echo "Pb de sexe<br />";
              rejette_demande();
              affiche_formulaire();
              return;
            }
            // La classe
            if ($ligne1['classe'] != $_POST['classe'])
            {
              //DEBUGG echo "Pb de classe<br />";
              rejette_demande();
              affiche_formulaire();
              return;
            }
            // Puis la date de naissance
            if (date_mysql_to_jjmmaaaa($ligne1['datnaiss']) != $_POST['datenais'])
            {
              //DEBUGG echo "Pb de date de naissance<br />";
              rejette_demande();
              affiche_formulaire();
              return;
            }
            // Tout  l'air OK, on enregistre la demande
            enregistre_demande($id_pers,$_POST['usercat'],$nom,$prenom);
            return;
          }
          else
          {
            $error_message = array("<div align='justify'>L'identifiant fournit ne correspond  aucun lve : vous ne pouvez pas demander un mot de passe !<br />Si vous estimez que ceci est une erreur, <a href='mailto:".email_encode($GLOBALS['admin_email'])."'>prenez contact avec votre administrateur IntraEduWeb</a></div>","");
            affiche_erreurs($error_message);
            affiche_formulaire();
            return;
          }
          break;
        case "3": // demandeur = prof
          $sql1 = "SELECT * FROM personnel WHERE id_pers='".quote_smart($id_pers)."'";
          $resultat1 = mysql_query($sql1);
          if ($resultat1 && mysql_num_rows($resultat1) >0) // Il y a un prof correspondant
          {
            // On continue les vrifications
            $ligne1 = mysql_fetch_array($resultat1);
            // d'abord le nom et le prnom
            if ($nom != $_POST['nom'] || $prenom != $_POST['prenom'])
            {
              //DEBUGG echo "Pb de nom<br />";
              rejette_demande();
              affiche_formulaire();
              return;
            }
            // Le sexe
            //DEBUGG echo "Civilit dans bdd : ".$ligne1['civilite']."  Sexe suppos (1=fminin; 2=masculin) : ".$_POST['sexe']."<br />";
            if (($ligne1['civilite'] == "M." && $_POST['sexe'] != 2) || ($ligne1['sexe'] == "Mme" && $_POST['sexe'] != 1) || ($ligne1['sexe'] == "Mlle" && $_POST['sexe'] != 1))
            {
              //DEBUGG echo "Pb de sexe<br />";
              rejette_demande();
              affiche_formulaire();
              return;
            }
            // Les classes
            $sql2 = "SELECT DISTINCTROW classe from eqpedag WHERE id_prof='".quote_smart($id_pers)."' ORDER BY classe";
            //DEBUGG echo $sql2;"<br />";
            $resultat2 = mysql_query($sql2);
            if ($resultat2 && mysql_num_rows($resultat2) >0)
            {
              $liste_classes_effective = array();
              // Les classes sont trouves dans la bdd, on compare avec les dclarations de formulaire
              while ($ligne2 = mysql_fetch_array($resultat2))
              {
                $liste_classes_effective[] = $ligne2['classe'];
              }
              if ($liste_classes_effective != $_POST['classes'])
              {
                //DEBUGG echo "Pb de classes<br />";
                rejette_demande();
                affiche_formulaire();
                return;
              }
            }
            else
            {
              $error_message = array("<div align='justify'>Vos classes ne sont pas dans la base de donnes. Il n'est donc pas possible de vrifier vos dclarations. En consquence, votre demande de mot de passe est annule.<br />Si vous estimez que ceci est une erreur, , refaites une tentative (en modifiant ventuellment certains champs du formulaire), et en cas de nouvel chec, <a href='mailto:".email_encode($GLOBALS['admin_email'])."'>prenez contact avec votre administrateur IntraEduWeb</a></div>","");
              affiche_erreurs($error_message);
              affiche_formulaire();
              return;
            }
            
            // Tout  l'air OK, on enregistre la demande
            enregistre_demande($id_pers,$_POST['usercat'],$nom,$prenom);
            return;
          }
          else
          {
            $error_message = array("<div align='justify'>L'identifiant fournit ne correspond  aucun professeur : vous ne pouvez pas demander un mot de passe !<br />Si vous estimez que ceci est une erreur, <a href='mailto:".email_encode($GLOBALS['admin_email'])."'>prenez contact avec votre administrateur IntraEduWeb</a></div>","");
            affiche_erreurs($error_message);
            return;
          }
          break;
        case "4": // demandeur = parent d'lve
          // On formate correctement la casse des noms+prnom des enfants dclars
          for ($i=1;$i<=5;$i++)
          {
            if ($_POST["nom$i"] != "")
            {
              $_POST["nom$i"] = strtoupper($_POST["nom$i"]);
              $_POST["prenom$i"] = strtoupper(substr($_POST["prenom$i"],0,1)).substr($_POST["prenom$i"],1,strlen($_POST["prenom$i"])-1);
            }
          }
          // On rcupre les infos sur le parent dans la bdd
          $sql1 = "SELECT * FROM parents WHERE id_pers='".quote_smart($id_pers)."'";
          $resultat1 = mysql_query($sql1);
          if ($resultat1 && mysql_num_rows($resultat1) >0) // Il y a un parent d'lve correspondant
          {
            // On continue les vrifications
            $ligne1 = mysql_fetch_array($resultat1);
            // d'abord le nom et le prnom
            if ($nom != $_POST['nom'] || $prenom != $_POST['prenom'])
            {
              //DEBUGG echo "<u>Pb de nom</u><br />Nom dans bdd : $nom  Nom dclar : ".$_POST['nom']."<br />Prnom dans bdd : $prenom  Prnom dclar : ".$_POST['prenom']."<br />";
              rejette_demande();
              affiche_formulaire();
              return;
            }
            // Puis, on vrifie le (ou les) enfants dclars comme scolariss dans l'tablissement
            // On trie le tableau post dans l'ordre alphabtique nom+prnom
            $enfants_declares = array();
            for($i=1;$i<=5;$i++) // on passe en revue les 5 lignes du tableau du formulaire "parent"
            {
              if ($_POST["nom$i"] != "") // Si la ligne $i contient un nom
              {
                $enfants_declares[] = $_POST["nom$i"].",".$_POST["prenom$i"].",".$_POST["datenais$i"]; // On l'inclut dans un enregistrement
              }
            }
            sort($enfants_declares); // voil le tri
            // On rcupre les enfants dans la base de donnes
            $sql2 = "SELECT t1.nom,t1.prenom,t1.datnaiss FROM eleves as t1, parents as t2 WHERE t1.ereno=t2.ereno AND t2.id_pers='".quote_smart($id_pers)."' ORDER BY t1.nom,t1.prenom,t1.datnaiss";
            $resultat2 = mysql_query($sql2);
            if ($resultat2 && mysql_num_rows($resultat2) >0)
            {
              // Il y a des rsultats, encore faut-il vrifier la correspondance avec les dclarations faites
              $bdd_enfants = array();
              while ($ligne2 = mysql_fetch_array($resultat2))
              {
                $bdd_enfants[] = $ligne2['nom'].",".$ligne2['prenom'].",".date_mysql_to_jjmmaaaa($ligne2['datnaiss']); // On l'inclut dans un enregistrement
              }
              if ($enfants_declares != $bdd_enfants)
              {
                //DEBUGG echo "Pb sur les enfants dclars (ne correspond pas  ce qui est dcrit dans la base de donnes)<br />";
                //DEBUGG echo "Enfants dans la bdd : "; print_r($bdd_enfants); echo "<br />";
                //DEBUGG echo "Enfants dclars : "; print_r($enfants_declares); echo "<br />";
                rejette_demande();
                affiche_formulaire();
                return;
              }
            }
            else
            {
              $error_message = array("<div align='justify'>Votre(vos) enfant(s) n'est(ne sont) pas dans la base de donnes. Il n'est donc pas possible de vrifier vos dclarations. En consquence, votre demande de mot de passe est annule.<br />Si vous estimez que ceci est une erreur, , refaites une tentative (en modifiant ventuellment certains champs du formulaire), et en cas de nouvel chec, <a href='mailto:".email_encode($GLOBALS['admin_email'])."'>prenez contact avec votre administrateur IntraEduWeb</a></div>","");
              affiche_erreurs($error_message);
              affiche_formulaire();
              return;
            }
            // Tout  l'air OK, on enregistre la demande
            enregistre_demande($id_pers,$_POST['usercat'],$nom,$prenom);
            return;
          }
          else
          {
            $error_message = array("<div align='justify'>L'identifiant fournit ne correspond  aucun parent d'lve : vous ne pouvez pas demander un mot de passe !<br />Si vous estimez que ceci est une erreur, <a href='mailto:".email_encode($GLOBALS['admin_email'])."'>prenez contact avec votre administrateur IntraEduWeb</a></div>","");
            affiche_erreurs($error_message);
            affiche_formulaire();
            return;
          }
          break;
        case "6": // demandeur = membre du personnel (non enseignant)
          $sql1 = "SELECT * FROM personnel WHERE id_pers='".quote_smart($id_pers)."'";
          $resultat1 = mysql_query($sql1);
          if ($resultat1 && mysql_num_rows($resultat1) >0) // Il y a un membre du personnel correspondant
          {
            // On continue les vrifications
            $ligne1 = mysql_fetch_array($resultat1);
            // d'abord le nom et le prnom
            if ($nom != $_POST['nom'] || $prenom != $_POST['prenom'])
            {
              //DEBUGG echo "<u>Pb de nom</u><br />Nom dans bdd : $nom  Nom dclar : ".$_POST['nom']."<br />Prnom dans bdd : $prenom  Prnom dclar : ".$_POST['prenom']."<br />";
              rejette_demande();
              affiche_formulaire();
              return;
            }
            // Le sexe
            //DEBUGG echo "Civilit dans bdd : ".$ligne1['civilite']."  Sexe suppos (1=fminin; 2=masculin) : ".$_POST['sexe']."<br />";
            if (($ligne1['civilite'] == "M." && $_POST['sexe'] != 2) || ($ligne1['sexe'] == "Mme" && $_POST['sexe'] != 1) || ($ligne1['sexe'] == "Mlle" && $_POST['sexe'] != 1))
            {
              //DEBUGG echo "Pb de sexe<br />";
              rejette_demande();
              affiche_formulaire();
              return;
            }
            // Tout  l'air OK, on enregistre la demande
            enregistre_demande($id_pers,$_POST['usercat'],$nom,$prenom);
            return;
          }
          else
          {
            $error_message = array("<div align='justify'>L'identifiant fournit ne correspond  aucun Membre du personnel de l'tablissement : vous ne pouvez pas demander un mot de passe !<br />Si vous estimez que ceci est une erreur, <a href='mailto:".email_encode($GLOBALS['admin_email'])."'>prenez contact avec votre administrateur IntraEduWeb</a></div>","");
            affiche_erreurs($error_message);
            return;
          }
          break;
        case "11": // demandeur = IPR
          $sql1 = "SELECT * FROM ipr WHERE id_pers='".quote_smart($id_pers)."'";
          $resultat1 = mysql_query($sql1);
          if ($resultat1 && mysql_num_rows($resultat1) >0) // Il y a un IPR correspondant
          {
            // On continue les vrifications
            $ligne1 = mysql_fetch_array($resultat1);
            // d'abord le nom et le prnom
            if ($nom != $_POST['nom'] || $prenom != $_POST['prenom'])
            {
              //DEBUGG echo "<u>Pb de nom</u><br />Nom dans bdd : $nom  Nom dclar : ".$_POST['nom']."<br />Prnom dans bdd : $prenom  Prnom dclar : ".$_POST['prenom']."<br />";
              rejette_demande();
              affiche_formulaire();
              return;
            }
            // puis la date visite
            if (date_mysql_to_jjmmaaaa($ligne1['date_visite']) != $_POST['datevisite'])
            {
              //DEBUGG echo "Pb de date de visite<br />";
              rejette_demande();
              affiche_formulaire();
              return;
            }
            // Tout  l'air OK, on enregistre la demande
            enregistre_demande($id_pers,$_POST['usercat'],$nom,$prenom);
            return;
          }
          else
          {
            $error_message = array("<div align='justify'>L'identifiant fournit ne correspond  aucun IPR : vous ne pouvez pas demander un mot de passe !<br />Si vous estimez que ceci est une erreur, <a href='mailto:".email_encode($GLOBALS['admin_email'])."'>prenez contact avec votre administrateur IntraEduWeb</a></div>","");
            affiche_erreurs($error_message);
            return;
          }
          break;
      }
    }
    else
    {
      $error_message = array("<div align='justify'>Vous n'avez pas de compte enregistr dans la base de donnes : vous ne pouvez pas demander un mot de passe !<br />Si vous estimez que ceci est une erreur, <a href='mailto:".email_encode($GLOBALS['admin_email'])."'>prenez contact avec votre administrateur IntraEduWeb</a></div>","");
      affiche_erreurs($error_message);
      affiche_formulaire();
      return;
    }
    // On affiche un message indiquant la prise en compte de la demande
    affiche_formulaire();
  }
  else
  {
    echo "
    <p>
    Il est possible d'obtenir un nouveau mot de passe. Pour cela, nous devons nous assurer de votre identit&nbsp;: merci de bien remplir le formulaire ci-dessous.</p>
    <p>
    Ce formulaire sera trait par notre service de gestion des comptes utilisateurs. Celui-ci, aprs <u>vrification</u>, vous fera remettre en main propre votre nouveau mot de passe.
    </p>";
    affiche_formulaire();
  }
}
else // L'utilisateur essaie d'invoquer ce script directement dans l'URL (interdit)
{
  $error_message = array("Vous tentez d'accder  un script qui n'est pas accessible directement  partir de l'URL... Utilisez les liens de navigation !","");
  affiche_erreurs($error_message);
}
?>