<?php
/**
 * c_modif_config.php
 *
 * script de modification du fichier de configuration config.php
 * On suppose que ce fichier existe dj (cr lors de l'installation par le script install.php)
 * 
 * Ce fichier fait partie du projet IntraEduWeb (IEW)
 * 
 * @package		IEW
 * @author			Sylvain GODM <sylvain.godme@gmail.com>
 * @version		$LastChangedRevision$, $LastChangedDate$
 * @copyright		2004-2012 Sylvain GODM
 * @link			http://iew.free.fr
 * @license		GPL License version 3 (http://www.gnu.org/licenses/gpl.html)
 * @filesource
 * 
 */

if (!defined('IEW_DIR')) {
 	/**
 	 * Constante contenant le chemin complet du rpertoire d'installation IEW
 	 */	
	define('IEW_DIR',realpath(dirname(__FILE__).'/../').'/');
}

$GLOBALS['dir_theme'] = IEW_DIR."themes/"; // rpertoire contenant les thmes des interfaces graphiques

function affiche_formulaire_config()
{
  // La plupart des variables suivantes sont initialises dans le fichier config.php
  global $chemin_relatif,$jeu_couleurs,$squelette,$repertoire_navigation;
  global $mysql_server,$mysql_admin,$mysql_admin_passwd,$mysql_database,$mail_server,$url_mail_server,$mail_protocol;
  global $stock_baselev,$apache_username,$apache_groupname;
  global $url_grr,$code_periode_edt,$url_notation,$url_gestdoc,$url_gestb2i,$nom_etablissement,$adresse_etablissement,$cp_etablissement,$ville_etablissement,$tel_etablissement,$fax_etablissement,$email_etablissement,$nom_directeur_publication,$email_directeur_publication,$url_site_etablissement,$admin_name,$admin_passwd,$message_pied_page,$session_timeout;
  
  global $dir_theme;
  
  if (isset($_POST)) // Si le formulaire a dj t envoy et est  nouveau affich, on affiche les valeurs du POST
  {
    foreach ($_POST as $value)
    {
      
      $cle = key($_POST); // Renvoie la cl courante
      if (substr($cle,0,4)=="new_") // si prefixe 'new_' on le retire
      {
        $cle = substr($cle,4,strlen($cle)-4);
      }
      //echo $cle." = ";
      $$cle = stripslashes($value); // Forme une variable ayant pour nom la cl courante et lui donne la valeur de l'lment courant
      //echo $$cle."<br />";
      next($_POST); // pointe sur la cl suivante
    }
  }
  // Interface graphique
  $code_formulaire = "<br />
  <div class=titre_cadre_formulaire align=center><b>Interface Graphique</b></div>
  <div class=cadre_formulaire align=center>
    <table border=0>
      <tr>
        <td valign=top>
          <img src='".$chemin_relatif."images/puce.png' border=0> <u>Cochez le thme choisi :</u>
          <img src='".$chemin_relatif."images/pixel.gif' border=0 width=10>
          <br /><br />
          <center>";
          if (is_dir($dir_theme)) // Si le rpertoire existe bien
          {
            if ($dh = opendir($dir_theme)) // et si on peut le lire
            {
              while (($file = readdir($dh)) !== false)
              {
                if ($file != "." && $file != ".." && substr($file,0,1) != ".")
                {
                  $code_formulaire .= "<INPUT type='radio'";
                  if ($file == "defaut")
                  {
                    $code_formulaire .= " checked ";
                  }
                  $code_formulaire .= "name='theme' value='$file'>$file<br />";
                }
              }
              closedir($dh);
            }
            else
            {
              $error_message = array("Le Dossier contenant les thmes d'interface graphique ne peut pas tre lu !","");
              affiche_erreurs($error_message);
            }
          }
          else
          {
            $error_message = array("Le Dossier \"$repertoire_theme\" contenant les thmes d'interface graphique n'existe pas !","");
            affiche_erreurs($error_message);
          }
        // Choix de la couleur
        $code_formulaire .= "  
        </td>
        <td valign=top>
          <img src='".$chemin_relatif."images/puce.png' border=0> <u>Choisissez la couleur dominante pour le thme :</u><br />";
          $code_formulaire .= "<center><table border=0>";
          include ($dir_theme."defaut/couleurs.php"); // on inclut les dfinitions de couleurs
          foreach(array_keys($couleur_dominante) as $value)
          {
            if ($jeu_couleurs == $couleur_dominante["$value"]) // On coche le bouton radio qui correspond  la couleur actuelle
            {
              $code_formulaire .= "<tr><td><INPUT type='radio' checked name='couleur' value='$value'>$value (couleur actuelle)</td></tr>";
            }
            else
            {
              $code_formulaire .= "<tr><td><INPUT type='radio' name='couleur' value='$value'>$value</td></tr>";
            }         
          }
          $code_formulaire .= "</table></center>";
          $code_formulaire .="
        </td>
      </tr>
    </table>";
    $code_formulaire .= "</center></div><br />";
        
    // Service de messagerie interne
    if ($GLOBALS['mail_server'] =="") // Si service encore non dfini
    {
      $mail_port = "";
      $protocol = "";
    }
    else // si le service a dj t dfini (prsent dans config.php))
    {
      $fragment = explode("/",substr($mail_protocol,1,strlen($mail_protocol)-1));
      $mail_port = $fragment[0];
      $protocol = $fragment[1];
    }
    $code_formulaire .= "<a name='gestion_mail'></a>
    <br />
  <div class=titre_cadre_formulaire align=center><b>Paramtrer le serveur de messagerie</b></div>
  <div class=cadre_formulaire align=center>
    <img src='".$chemin_relatif."images/puce.png' border=0> <u>Configuration du serveur mail :</u><br /><br />
   <table border=0>
     <tr>
       <td align=right>
         Nom de la machine hte :
       </td>
       <td>
         <INPUT type='text' name='new_mail_server' value='$mail_server'>
       </td>
     </tr>
     <tr>
       <td align=right>
         URL du service Webmail :
       </td>
       <td>
         <INPUT type='text' name='new_url_mail_server' value='$url_mail_server'>
       </td>
     </tr>
     <tr>
       <td align=right>
         Port :
       </td>
       <td>
         <SELECT name='mail_port' size=1>
           <option>$mail_port</option>
           <option></option>
           <option>110</option>
           <option>143</option>
         </SELECT>
       </td>
     </tr>
     <tr>
       <td align=right>
         Protocole :
       </td>
       <td>
         <SELECT name='protocol' size=1>
           <option>$protocol</option>
           <option></option>
           <option>pop3</option>
           <option>imap</option>
         </SELECT>
       </td>
     </tr>
   </table>
    <br /></div><br />";
    
    // Informations Etablissement
    // On cherche le type d'tablissement
    $checked_clg = "";
    $checked_lyc = "";
    if ($GLOBALS['type_etablissement'] == "Collge")
      $checked_clg = "checked='checked'";
    elseif ($GLOBALS['type_etablissement'] == "Lyce")
      $checked_lyc = "checked='checked'";
    $code_formulaire .= "<a name='infos_etab'></a>
    <br />
  <div class=titre_cadre_formulaire align=center><b>Informations sur l'tablissement</b></div>
  <div class=cadre_formulaire>
    <table border='0'>
    <tr>
      <td rowspan='2'>
        Type d'Etablissement<font color=red>* :
      </td>
      <td>
        <input type='radio' name='new_type_etablissement' value='Collge' $checked_clg />Collge
      </td>
    </tr>
    <tr>
      <td>
        <input type='radio' name='new_type_etablissement' value='Lyce' $checked_lyc />Lyce
      </td>
    </tr>
    </table><br />
    <img src='".$chemin_relatif."images/puce.png' border=0> <u>Coordonnes de l'tablissement :</u><br /><br />
   <div align=justify>Ces informations apparaissent sur chaque page du site dans l'encadr suivant le sommaire et sur chaque pied de page.<br /><br /></div>
   <table border=0>
     <tr>
       <td align=right>
         Nom de l'tablissement<font color=red>*</font> :
       </td>
       <td>
         <INPUT type='text' name='new_nom_etablissement' value=\"$nom_etablissement\">
       </td>
     </tr>
     <tr>
       <td align=right>
         Adresse<font color=red>*</font> :
       </td>
       <td>
         <INPUT type='text' name='new_adresse_etablissement' value=\"$adresse_etablissement\">
       </td>
     </tr>
     <tr>
       <td align=right>
         Code postal<font color=red>*</font> :
       </td>
       <td>
         <INPUT type='text' name='new_cp_etablissement' value='$cp_etablissement'>
       </td>
     </tr>
     <tr>
       <td align=right>
         Ville<font color=red>*</font> :
       </td>
       <td>
         <INPUT type='text' name='new_ville_etablissement' value=\"$ville_etablissement\">
       </td>
     </tr>
     <tr>
       <td align=right>
         Tlphone<font color=red>*</font> :
       </td>
       <td>
         <INPUT type='text' name='new_tel_etablissement' value='$tel_etablissement'>
       </td>
     </tr>
     <tr>
       <td align=right>
         Fax<font color=red>*</font> :
       </td>
       <td>
         <INPUT type='text' name='new_fax_etablissement' value='$fax_etablissement'>
       </td>
     </tr>
     <tr>
       <td align=right>
         Email<font color=red>*</font> :
       </td>
       <td>
         <INPUT type='text' name='new_email_etablissement' value='$email_etablissement'>
       </td>
     </tr>
     <tr>
       <td align=right>
         Prnom NOM du Chef d'tablissement<font color=red>*</font> :
       </td>
       <td>
         <INPUT type='text' name='new_nom_directeur_publication' value=\"$nom_directeur_publication\">
       </td>
     </tr>
     <tr>
       <td align=right>
         Email du Chef d'tablissement :
       </td>
       <td>
         <INPUT type='text' name='new_email_directeur_publication' value='$email_directeur_publication'>
       </td>
     </tr>
     <tr>
       <td align=right>
         URL du site internet de l'tablissement :
       </td>
       <td>
         <INPUT type='text' name='new_url_site_etablissement' value='$url_site_etablissement'>
       </td>
     </tr>
     <tr>
       <td align=right>
         Prnom NOM de l'Administrateur<br />du site IntraEduWeb<font color=red>*</font> :
       </td>
       <td>
         <INPUT type='text' name='new_admin_name' value=\"$admin_name\">
       </td>
     </tr>
     <tr>
       <td align=right>
         Texte de pied de page :
       </td>
       <td>
         <textarea rows='4' name='new_message_pied_page'>".stripslashes($message_pied_page)."</textarea>
       </td>
     </tr>
   </table>
    <br />".info_champs_obligatoires()."</div><br />";

   // Paramtrage des applications externes
    $code_formulaire .= "<a name='applis_ext'></a>
    <br />
  <div class=titre_cadre_formulaire align=center><b>Paramtres des applications externes</b></div>
  <div class=cadre_formulaire align=center>
    <br />
    <div align=justify>Si <u>un systme de Gestion de Rservation de ressources</u> comme GRR est install (rservations de salle ou de matriel), prcisez son URL (absolue ou relative) ci dessous.</div><br />
    <input type='text' name=new_url_grr value='$url_grr'><br /><br />
    <div align=justify>Si vous exportez <u>les emplois du temps</u> (gnrs en page HTML et images GIF) depuis l'application EDT, Veuillez remplir le champ suivant en y indiquant le code de la priode comme dcrit dans la documentation (voir les noms des fichiers d'export pour trouver ce code de priode):</div><br />
    <input type='text' name=new_code_periode_edt value='$code_periode_edt'><br />
  <br />
    <div align=justify>Si vous utilisez <u>un systme de gestion des notes</u> par interface web (gepi, pronote...), Veuillez remplir le champ suivant en y indiquant l'URL (absolue ou relative) qui permet d'y accder</div><br />
    <input type='text' name=new_url_notation value='$url_notation'>
  <br />
  <br />
    <div align=justify>Si vous utilisez <u>un systme de gestion documentaire</u> par interface web (PMB, BCDI...), Veuillez remplir le champ suivant en y indiquant l'URL (absolue ou relative) qui permet d'y accder</div><br />
    <input type='text' name=new_url_gestdoc value='$url_gestdoc'>
  <br />
  <br />
    <div align=justify>Si vous utilisez <u>un systme de gestion du B2i</u> par interface web (gibii...), Veuillez remplir le champ suivant en y indiquant l'URL (absolue ou relative) qui permet d'y accder</div><br />
    <input type='text' name=new_url_gestb2i value='$url_gestb2i'></div><br />";
  
  // Paramtres scurit
  $code_formulaire .= "<a name='param_secure'></a>
    <br />
  <div class=titre_cadre_formulaire align=center><b>Paramtres de Scurit</b></div>
  <div class=cadre_formulaire align=center>
    <br />
    <div align=justify>
    	IntraEduWeb utilise un systme de session utilisateur pour stocker certaines variables. Pour des raisons de scurit, la dure de la session est limite par un timeout (temps d'inactivit maximal). Ceci (entres autres) permet de prvenir les attaques ventuelles du site par une personne mal intentionne.<br /><br />Modifiez <b>ventuellement</b> dans le champ suivant la valeur de timeout actuelle (exprime en seconde) :<br />
    </div>
    <br />
    <input type='text' size=4 name=session_timeout value='$session_timeout'><br /><br />
    </div><br />";
  squelette_formulaire_standard("100%","POST",$_SERVER['PHP_SELF'],"Configuration de IntraEduWeb",$code_formulaire,"Modifier la configuration","soumettre","Retour aux valeurs initiales","annuler","","","");
}

/* Programme principal */

if (!isset($_POST['soumettre'])) // Si le formulaire n'a pas encore t envoy, il faut l'afficher
{
echo "<br />";
affiche_formulaire_config();
}
else // le formulaire a t envoy, on traite les donnes
{
  //DEBUGG print_r($_POST);
  // D'abord, on reconstitue certaines variables
  // 1. Le thme choisi
  $repertoire_theme = "themes/".$_POST['theme']."/";
  // 2. le protocole pour la messagerie
  $new_mail_protocol = ":".$_POST['mail_port']."/".$_POST['protocol'];
  // 3. On Vrifie certaines saisies
  $champs_obligatoires = array("$_POST[new_type_etablissement]","$_POST[new_nom_etablissement]","$_POST[new_adresse_etablissement]","$_POST[new_cp_etablissement]","$_POST[new_ville_etablissement]","$_POST[new_tel_etablissement]","$_POST[new_fax_etablissement]","$_POST[new_email_etablissement]","$_POST[new_nom_directeur_publication]","$_POST[new_admin_name]", "$_POST[session_timeout]");
  if (filled_out($champs_obligatoires)) // Si le formulaire prcdent est bien rempli
    {
      // On vrifie la validit du format de certaines informations envoyes par l'utilisateur
      // On vrifie que le code postal est bien du numrique, idem pour le tl et le fax, vrifier la validit des adresses emails etc..... 
      if (!is_numeric($_POST['new_cp_etablissement']) )
      {
        $error_message = array("Le code postal est incorrect (ce champ est doit tre rempli exclusivement de chiffres (sans espace) !<br />Veuillez <a href='#infos_etab'>corriger</a> cette valeur SVP !","");
        affiche_erreurs($error_message);
        affiche_formulaire_config();
        return;
      }
      if (!email_check($_POST['new_email_etablissement'], $error_message))
      {
        $message_intro = "Vous n'avez pas entr une adresse email correcte pour l'tablissement ou bien votre connexion internet n'est pas active<br />Veuillez <a href='#infos_etab'>corriger l'adresse </a>ou vrifier votre connexion internet SVP !<br />";
        $err_message = array($message_intro.$GLOBALS['error_message'],"");
        affiche_erreurs($err_message);
        //affiche_formulaire_config();
        //return;
      }
      if ($_POST['new_email_directeur_publication']!="" && !email_check($_POST['new_email_directeur_publication'], $error_message))
      {
        $message_intro = "Vous n'avez pas entr une adresse email correcte pour <a href='#infos_etab'>le Chef d'tablissement</a> ou bien votre connexion internet n'est pas active.<br />Veuillez corriger SVP ou vrifier votre connexion internet !<br />";
        $err_message = array($message_intro.$GLOBALS['error_message'],"");
        affiche_erreurs($err_message);
        //affiche_formulaire_config();
        //return;
      }
      if ($_POST['new_url_site_etablissement']!="")
        $err = verif_url_syntax_exist($_POST['new_url_site_etablissement']);
      if ( $_POST['new_url_site_etablissement']!="" && $err!="")
      {
        $message_intro = "Vous n'avez pas entr une adresse URL correcte pour <a href='#infos_etab'>le site d'tablissement</a> ou bien $err Veuillez corriger SVP !<br />";
        $err_message = array($message_intro.$GLOBALS['error_message'],"");
        affiche_erreurs($err_message);
        affiche_formulaire_config();
        return;
      }
     /* if ($_POST['new_url_grr']!="")
        $err = verif_url_syntax_exist($_POST['new_url_grr']);
      if ( $_POST['new_url_grr']!="" && $err!="")
      {
        $message_intro = "Vous n'avez pas entr une adresse URL correcte pour <a href='#applis_ext'>le Systme de Rservation de Ressources</a>.<br />Veuillez corriger SVP !<br />";
        $err_message = array($message_intro.$GLOBALS['error_message'],"");
        affiche_erreurs($err_message);
        affiche_formulaire_config();
        return;
      }
      if ($_POST['new_url_notation']!="")
        $err = verif_url_syntax_exist($_POST['new_url_notation']);
      if ( $_POST['new_url_notation']!="" && $err!="")
      {
        $message_intro = "Vous n'avez pas entr une adresse URL correcte pour <a href='#applis_ext'>le Systme de Gestion des Notes</a>.<br />Veuillez corriger SVP !<br />";
        $err_message = array($message_intro.$GLOBALS['error_message'],"");
        affiche_erreurs($err_message);
        affiche_formulaire_config();
        return;
      }*/
      if (!is_numeric($_POST['session_timeout']) || $_POST['session_timeout']<300 || $_POST['session_timeout']>14400) // les timeout de session infrieurs  5 minutes ne sont pas accepts
      {
        $error_message = array("La valeur de timeout de session doit tre un nombre compris entre 300 et 14400 secondes !<br />Veuillez <a href='#param_secure'>corriger</a> cette valeur SVP !","");
        affiche_erreurs($error_message);
        affiche_formulaire_config();
        return;
      }
      // Formatage du numro de tlphone + fax (00 00 00 00 00)
      $_POST['new_tel_etablissement'] = numtel($_POST['new_tel_etablissement']);
      $_POST['new_fax_etablissement'] = numtel($_POST['new_fax_etablissement']);
      // Formatage du nom + prnom de l'administrateur IntraEduWeb
      $fragment_nom = explode(" ",$_POST["new_admin_name"]);
      $admin_nom = strtoupper($fragment_nom[1]); // formate le nom en majuscules
      $admin_prenom = strtoupper(substr($fragment_nom[0],0,1)).strtolower(substr($fragment_nom[0],1,strlen($fragment_nom[0]))); // formate la 1re lettre du prnom en majuscule
      $new_admin_name = $admin_prenom." ".$admin_nom;
      // Formatage du nom + prnom du directeur de publication
      $fragment_nom = explode(" ",$_POST["new_nom_directeur_publication"]);
      $directeur_nom = strtoupper($fragment_nom[1]); // formate le nom en majuscules
      $directeur_prenom = strtoupper(substr($fragment_nom[0],0,1)).strtolower(substr($fragment_nom[0],1,strlen($fragment_nom[0]))); // formate la 1re lettre du prnom en majuscule
      $new_nom_directeur_publication = $directeur_prenom." ".$directeur_nom;
  
      //************************* Etape finale : criture du fichier de configuration **********************/
      
        // il faut d'abord redfinir les jours ouvrables en fonction de la valeur actuelle dans config.php
        if (in_array("Samedi",$GLOBALS['jours_ouvrables']))
          $GLOBALS['def_jours_ouvrables'] = "array('Lundi','Mardi','Mercredi','Jeudi','Vendredi','Samedi')";
        else
          $GLOBALS['def_jours_ouvrables'] = "array('Lundi','Mardi','Mercredi','Jeudi','Vendredi')";
        include("./templates/modele_config.php");
        $ok_message = "Vous avez effectu une modification de la configuration de IntraEduWeb. Cliquez <a href='modif_config.php'>ICI</a> pour que vos modifications soient prises en compte.";
        affiche_ok($ok_message);
        //  faire aprs chaque validation dfinitive de formulaire pour viter des problmes avec le changement de format d'affichage
        unset($_SESSION['post_imprimable']);
    } // if (filled_out($champs_obligatoires))
    else
    {
      $error_message = array("Certains champs obligatoires (ceux marqus d'un astrisque) ne sont pas remplis !","");
      affiche_erreurs($error_message);
      affiche_formulaire_config();
    }
  }
?>