<?php
/**
 * modif-cas_eoleclient.php
 *
 * Contient une fonction  recopier sur le serveur scribe
 * dans /usr/share/php/CAS/eoleclient.php
 * afin de permettre la prise en compte d'une requte de dconnexion centralise SSO
 * pour effacer la session IEW (car IEW change son id de session au cours du temps) 
 * 
 * Ce fichier fait partie du projet IntraEduWeb (IEW)
 * 
 * @package		IEW
 * @author			Sylvain GODM <sylvain.godme@gmail.com>
 * @version		$LastChangedRevision$, $LastChangedDate$
 * @copyright		2004-2012 Sylvain GODM
 * @link			http://iew.free.fr
 * @license		GPL License version 3 (http://www.gnu.org/licenses/gpl.html)
 * @filesource
 * 
 */

/**************************************************************************************************
 * La portion ci-dessous est  copier, puis  coller dans /usr/share/php/CAS/eoleclient.php
 *************************************************************************************************/

/*
 * Fonction pour tenir compte des applis qui grent elles-mme les id de session
 * notamment si l'id de session change au cours du temps (utilisation de session_regenerate_id)
 * dans l'application */
function change_session_id($ticket, $new_session_id){
	/*
	 * Met  jour l'id de session associ au ticket 
     */
	phpCAS::traceBegin();
	phpCAS::LOG("## Modification de l'identifiant session associe au ticket : '" . $ticket ."'.");
    if (!is_dir(TICKET_BDD_PATH)){
    	phpCAS::LOG("!!!! Le rpertoire pour la bdd de gestion des tickets n'existe pas !!!!");
    	phpCAS::traceEnd();
        return;
    }
    if (!$db = sqlite_open(TICKET_BDD)){
        phpCAS::LOG("!!!! Impossible d'ouvrir la base de donnes pour le changement de l'id de session !!!!");
        phpCAS::traceEnd();
	    return;
    }
	phpCAS::LOG("Le ticket : " . $ticket . " doit tre dornavant associ est associe  la session : " . $new_session_id);
    $sql = "UPDATE " . TICKET_TABLE . " SET session_id='" . sqlite_escape_string($new_session_id). "' WHERE ticket='" . sqlite_escape_string($ticket) . "'";
	phpCAS::LOG($sql);
    if (sqlite_query($db, $sql) && sqlite_changes($db) > 0){
        phpCAS::LOG(" + L'id de session a t modifi dans la base de donnes.");
	    phpCAS::traceEnd();
    }
	else {
	    phpCAS::LOG(" - L'id de session n'a pas pu tre modifi dans la base de donnes !! La session de l'application ne pourra pas tre supprime lors d'un appel de dconnexion centralise !!");
	    phpCAS::traceEnd();
	}
	phpCAS::traceExit();
    exit();
}
?>