<?php
/**
 * config-origine.php
 *
 * copie du fichier original config.php fourni par dfaut avec IntraEduWeb
 * Utilit : sauvegarde, car le fichier d'origine config-origine.php est modifi ds l'installation
 * et renomm config.php (tout en tant dplac vers le rpertoire data du dossier de stockage prcis  l'installation)
 * 
 * Ce fichier fait partie du projet IntraEduWeb (IEW)
 * 
 * @package		IEW
 * @author			Sylvain GODM <sylvain.godme@gmail.com>
 * @version		$LastChangedRevision$, $LastChangedDate$
 * @copyright		2004-2012 Sylvain GODM
 * @link			http://iew.free.fr
 * @license		GPL License version 3 (http://www.gnu.org/licenses/gpl.html)
 * @filesource
 * 
 */

/* Constantes */
define('SESSION_NAME', "IEW");

/********************** Racine du site ********************************/

// Emplacement de la racine IEW dans l'arborescence gnrale
if(!defined('IEW_DIR')) define('IEW_DIR',realpath(dirname(__FILE__)."/../").'/');

// Variable contenant l'Alias d'apache qui permet d'accder  la racine de l'application IEW
//  adapter en cas de modification de l'Alias dfini dans IEW_DIR/install/conf-scribe/apache-iew.conf
// Elle est utilise par de nombreux liens absolus
$racine = "/iew/";  // doit imprativement se terminer par un slash !!

// On a besoin de ceci pour la fonction verif_authdir_data invoque plus loin dans ce script
require_once(IEW_DIR."lib/fonctions_diverses.php");
// et aussi pour la fonction affiche_erreurs :
require_once(IEW_DIR."lib/fonctions_erreurs.php");

/**************************** Informations de version *********************************************************/
// Laisser ce copyright SVP
$copyright = "Copyright &copy; 2004-".date("Y")." - Sylvain GODM - Tous droits rservs -<br />IntraEduWeb version ". trim(file_get_contents(IEW_DIR."VERSION"));
//URL Site officiel IntraEduWeb
$url_site_intraEduWeb = "http://iew.free.fr";

/*************************** Paramtrage des sessions **************************************/
// temps d'inactivit en secondes au bout duquel les utilisateurs authentifis devront se reconnecter
$session_timeout = "14400";

/********************** Paramtres d'authentification ******************************************************/
$auth_method = "";
$ldap_server = "";
$validite_mdp = 9; // c'est le nombre de mois pendant lesquels le mot de passe d'un utilisateur reste valide
$timeout_desactivation_mdp = 60; // c'est le nombre de jours prcdent la date limite de validit du mot de passe pendant lesquels l'utilisateur est averti qu'il doit modifier son mot de passe avant que l'accs au systme ne soit bloqu

/********************** Paramtres Serveur MySQL ******************************************************/
// Ces informations seront prcises dans le fichier inc_connect.php


/********************** Interface graphique : les thmes et les couleurs ****************************/
// c'est le rpertoire contenant les squelettes et les feuilles de style par dfaut
$repertoire_theme = "themes/defaut/";
// Squelette par dfaut utilis pour afficher les pages
$squelette = "principal.php";
// rpertoire contenant les lments de navigation
$repertoire_navigation = "navigation/defaut/";
require_once(IEW_DIR.$repertoire_theme."couleurs.php");
// Dominante de couleur utilise pour l'interface graphique
$jeu_couleurs = $couleur_dominante["jaune"];

/********************* Paramtres linguistiques ********************************************/
// Langue par dfaut (utilise pour l'instant seulement pour le format d'affichage de la date)
$default_language = "fr";


/********************** Messagerie interne **************************************/
//(vers l'interface de messagerie web seulement)
$url_mail_server = "";
// Contient le nom d'hte du serveur de messagerie (aprs le @ dans les adresses email)
$mail_server = "";
// le protocole utilis
$mail_protocol = ":/";

/***************** Emplacement de donnes stockes sous forme de fichiers *******************************/
// Dossier de stockage des donnes sous forme fichier
// il comprend :
// - En mode d'authentification native seulement : les fichiers textes contenant les identifiants et mots de passe des utilisateurs - ces derniers sont crypts -
// - les fichiers joints aux cahiers de textes
// - les trombinoscopes (fichiers jpg ou png)
// - les fichiers de config ncessaires  IEW
// Seul l'utilisateur apache a le droit d'y crire
// Ce dossier doit tre cr par root sur la machine hbergeante avec un chown -R utilisateur_apache et un chmod -R 0755 sur ce rpertoire
// ceci est un chemin absolu sur la machine hbergeante (doit se terminer par un slash !!)

$stock_baselev = IEW_DIR."data/"; 

// On vrifie l'existence et les droits d'accs au dossier de stockage des fichiers spciaux s'il est dfini
if ($stock_baselev !="") 
{
  $err = verif_authdir_data($stock_baselev);
  if ($err!="")
  {
    $error_message = array($err,"");  
    affiche_erreurs($error_message);
    exit;
  }
}

/**************************** Ressources externes *******************************/
// Si disponible, URL de l'application GRR installe
// si http:// prcis, c'est relatif  $DOCUMENT_ROOT (doit se terminer par un slash !!)
$url_grr = "";

// Si disponible, URL de l'application web de gestion des notes (gepi, pronote -logiciel propritaire = beurk-,...)
$url_notation = "";

// Si disponible, URL de l'application web de gestion documentaire (PMB, BCDI,...)
$url_gestdoc = "";

// Si disponible, URL de l'application web de gestion du b2i (gibii,...)
$url_gestb2i = "";

/************************** Informations sur l'tablissement ********************************/
// nom Etablissement

$nom_etablissement = "";
$adresse_etablissement = "";
$cp_etablissement = "";
$ville_etablissement = "";
$tel_etablissement = "";
$fax_etablissement = "";
$email_etablissement = "";

// Responsables de publication
// C'est le directeur de l'tablissement

$nom_directeur_publication = "";
$email_directeur_publication = "";

// URL du site internet de l'tablissement
$url_site_etablissement = "";

// Administrateur IntraEduWeb
$admin_name = "";
$admin_email = "admin-intraeduweb"."@".$mail_server;
// en fait ici on va passer par un formulaire de saisie avec un champ password puis le script de config crira directement et sous forme crypte ce mot de passe dans la base de donnes mysql (table login)
$admin_passwd = "";

// Le message personnalis de pied de page
$message_pied_page = "";

// Les jours de la ouvrables de la semaine (necessite que le language par defaut soit fr)
$jours_ouvrables = array('Lundi','Mardi','Mercredi','Jeudi','Vendredi','Samedi');

/************** A DEPLACER VERS LES REPERTOIRES DES THEMES POUR L'INTERFACE GRAPHIQUE *****************/
// Concepteur graphique des pages
include(IEW_DIR."themes/defaut/designer.php");


// Pas de balise de fin de code php car sinon envoi un message d'erreur : header already sent sur la prochaine intruction session_start()
