<?php
/**
 * modele_config.php
 *
 * c'est le modle de fichier de configuration utilis par les scripts install.php et c_modif_config.php
 * pour produire le nouveau fichier de configuration config.php
 * 
 * Ce fichier fait partie du projet IntraEduWeb (IEW)
 * 
 * @package		IEW
 * @author			Sylvain GODM <sylvain.godme@gmail.com>
 * @version		$LastChangedRevision$, $LastChangedDate$
 * @copyright		2004-2012 Sylvain GODM
 * @link			http://iew.free.fr
 * @license		GPL License version 3 (http://www.gnu.org/licenses/gpl.html)
 * @filesource
 * 
 */

// la variable $fichier_config (voir + bas) va contenir les lignes du nouveau fichier de config qui sera crit

// Quelques paramtrages suivant la provenance de la demande d'include :
// Si l'include vient de install.php (c'est--dire  l'installation IEW)
if (isset($include_install))
{
  // Alors les variables prfixes par $_POST['nom_variable'] doivent avoir pour contenu celui de $_SESSION['nom_variable']
  // car dans install.php le transfert des donnes de formulaire du tableau superglobal $_POST a dj eu lieu vers les variables de mme nom (sous forme de variables de session), il faut donc raffecter les variables $_POST  partir des variables de session (ceci permet d'conomiser l'criture d'un autre script o l'on remplacerait tous les $_POST par $_SESSION, et en plus cela permet d'avoir en un seul lieu la structure et la dfinition du ficher de config ce qui ne devrait pas rendre trop diffcile les modifications ultrieures de ce fichier)
  $_POST['couleur'] = "jaune"; // c'est la couleur par dfaut  l'installation
  $_POST['new_url_mail_server'] = $_SESSION['liste_variables']['new_url_mail_server'];
  $_POST['new_mail_server'] = $_SESSION['liste_variables']['new_mail_server'];
  if (isset($_SESSION['liste_variables']['new_mail_protocol']))
  {
    $new_mail_protocol = $_SESSION['liste_variables']['new_mail_protocol'];
  }
  else
  {
    $new_mail_protocol = "";
  }
  $_POST['new_url_grr'] = "";
  $_POST['new_code_periode_edt'] = "";
  $_POST['new_url_notation'] = "";
  $_POST['new_url_gestdoc'] = "";
  $_POST['new_url_gestb2i'] = "";
  $_POST['auth_method'] = $_SESSION['liste_variables']['auth_method'];
  if (isset($_SESSION['liste_variables']['ldap_server_name']))
   $_POST['ldap_server_name'] = $_SESSION['liste_variables']['ldap_server_name'];
  else
    $_POST['ldap_server_name'] = "";
   if (isset($_SESSION['liste_variables']['ldap_server_port']))
   $_POST['ldap_server_port'] = $_SESSION['liste_variables']['ldap_server_port'];
  else
    $_POST['ldap_server_port'] = "";
        
   if (isset($_SESSION['liste_variables']['ldap_base_dn']))
    $_POST['ldap_base_dn'] = $_SESSION['liste_variables']['ldap_base_dn'];
   else
    $_POST['ldap_base_dn'] = "";
   if (isset($_SESSION['liste_variables']['ldap_user_login_attribute']))
    $_POST['ldap_user_login_attribute'] = $_SESSION['liste_variables']['ldap_user_login_attribute'];
   else
    $_POST['ldap_user_login_attribute'] = "";
   if (isset($_SESSION['liste_variables']['ldap_user_prof_attribute']))
    $_POST['ldap_user_prof_attribute'] = $_SESSION['liste_variables']['ldap_user_prof_attribute'];
   else
    $_POST['ldap_user_prof_attribute'] = "";
   if (isset($_SESSION['liste_variables']['ldap_user_prof_attribute_value']))
    $_POST['ldap_user_prof_attribute_value'] = $_SESSION['liste_variables']['ldap_user_prof_attribute_value'];
   else
    $_POST['ldap_user_prof_attribute_value'] = ""; 
    if (isset($_SESSION['liste_variables']['ldap_user_eleve_attribute']))
     $_POST['ldap_user_eleve_attribute'] = $_SESSION['liste_variables']['ldap_user_eleve_attribute'];
    else
    $_POST['ldap_user_eleve_attribute'] = "";
    if (isset($_SESSION['liste_variables']['ldap_user_eleve_attribute_value']))
     $_POST['ldap_user_eleve_attribute_value'] = $_SESSION['liste_variables']['ldap_user_eleve_attribute_value'];
   else
    $_POST['ldap_cle_jointure'] = "";
    if (isset($_SESSION['liste_variables']['ldap_cle_jointure']))
     $_POST['ldap_cle_jointure'] = $_SESSION['liste_variables']['ldap_cle_jointure'];
   else
    $_POST['ldap_cle_jointure'] = "";
    
  if (isset($_SESSION['liste_variables']['cas_server_name']))
   $_POST['cas_server_name'] = $_SESSION['liste_variables']['cas_server_name'];
  else
    $_POST['cas_server_name'] = "";
  if (isset($_SESSION['liste_variables']['cas_server_port']))
   $_POST['cas_server_port'] = $_SESSION['liste_variables']['cas_server_port'];
  else
    $_POST['cas_server_port'] = "";
  $_POST['new_adresse_etablissement'] = $_SESSION['liste_variables']['new_adresse_etablissement'];
  $_POST['new_cp_etablissement'] = $_SESSION['liste_variables']['new_cp_etablissement'];
  $_POST['new_ville_etablissement'] = $_SESSION['liste_variables']['new_ville_etablissement'];
  $_POST['new_tel_etablissement'] = $_SESSION['liste_variables']['new_tel_etablissement'];
  $_POST['new_fax_etablissement'] = $_SESSION['liste_variables']['new_fax_etablissement'];
  $_POST['new_email_etablissement'] = $_SESSION['liste_variables']['new_email_etablissement'];
  $_POST['new_nom_directeur_publication'] = $_SESSION['liste_variables']['new_nom_directeur_publication'];
  $_POST['new_email_directeur_publication'] = $_SESSION['liste_variables']['new_email_directeur_publication'];
  $_POST['new_url_site_etablissement'] = $_SESSION['liste_variables']['new_url_site_etablissement'];
  $_POST['new_admin_name'] = $_SESSION['liste_variables']['new_admin_name'];
  $_POST['new_admin_email'] = $_SESSION['liste_variables']['new_admin_email'];
  $stock_baselev = $_SESSION['liste_variables']['new_stock_baselev'];
  $_POST['session_timeout'] = "3000"; // valeur par dfaut  l'install (timeout de session en secondes)
  $GLOBALS['def_jours_ouvrables'] = "array('Lundi','Mardi','Mercredi','Jeudi','Vendredi','Samedi')";
}



// Si l'include ne vient pas de install.php, c'est une modification de configuration post-installation.
// les valeurs du tableau $_POST sont utilises telles qu'elles sont fournies par le script d'appel
// Dans ce cas, les variables manquantes viennent du fichier config.php actuel
// Il faut les rcuprer :
// le tableau suivant contient les cls du tableau des variables $_POST (variables utilises pour l'criture du fichier de config et postes par formulaire)
$variables_post_a_verifier = array("session_timeout","couleur","auth_method","ldap_server","new_url_mail_server","new_mail_server","new_url_grr","new_code_periode_edt","new_url_notation","new_url_gestdoc","new_url_gestb2i","new_nom_etablissement","new_adresse_etablissement","new_cp_etablissement","new_ville_etablissement","new_tel_etablissement","new_fax_etablissement","new_email_etablissement","new_nom_directeur_publication","new_email_directeur_publication","new_url_site_etablissement","new_admin_name","new_message_pied_page");
// on va vrifier si pour chaque lment du tableau,la variable existe bien dans le tableau $_POST
// si c'est le cas, on laisse comme a, et sinon, il faut affecter la valeur actuelle de la variable dans le fichier config
foreach($variables_post_a_verifier as $value)
{
  if (!isset($_POST[$value]) || $_POST[$value]=="") // si la variable n'est pas dfini ou est vide
  {
    if ($value=="couleur") // si c'est la couleur du site
    {
      foreach(array_keys($GLOBALS['couleur_dominante']) as $couleur) // on recherche la couleur actuelle
      {
            if ($jeu_couleurs == $couleur_dominante["$couleur"]) // c'est la couleur actuelle
            {
              $_POST[$value] = $couleur;
            }      
      } 
    }
    elseif (substr($value,0,4)=="new_") // si la variable commence par new_ la variable correspondante dans le fichier de config ne contient pas le prfixe new_ : il faut donc le retirer pour accder  la valeur actuelle de cette variable dans le fichier de config
    {
      $parametre = substr($value,4,strlen($value)-4); // nom de la variable sans le prefix new_
      $_POST[$value] = $GLOBALS[$parametre]; // on affecte la valeur actuelle du fichier de config
    }
    else
    {
      $_POST[$value] = $GLOBALS[$value];
    }
  }
}

// le tableau suivant contient les variables non disponibles dans le tableau $_POST, mais qui doivent tre rcrites (ce sont les variables dont le nom commence par new_ )
$variables_normales_a_verifier = array("new_mail_protocol");
// on va vrifier si pour chaque lment du tableau,la variable existe bien
// si c'est le cas, on laisse comme a, et sinon, il faut affecter la valeur actuelle de la variable dans le fichier config
foreach($variables_normales_a_verifier as $value)
{
  if (!isset($$value) || $$value=="")
  {
    if (substr($value,0,4)=="new_") // si la variable commence par new_ la variable correspondante dans le fichier de config ne contient pas le prfixe new_ : il faut donc le retirer pour accder  la valeur actuelle de cette variable dans le fichier de config
    {
      $parametre = substr($value,4,strlen($value)-4); // nom de la variable sans le prefix new_
      $$value = $GLOBALS[$parametre]; // on affecte la valeur actuelle du fichier de config
    }
    else
    {
      $$value = $GLOBALS[$value];
    }
  }
}

// On peut maintenant dfinir le contenu du fichier de config

$fichier_config = "<?php
/**
 * config.php
 *
 * contient toutes les options de configuration, il est inclus dans presque tous les scripts
 * car les valeurs des variables qu'ils contient doivent tre disponibles pour la plupart des scripts
 * Il est gnr automatiquement lors de l'installation
 * 
 * Ce fichier fait partie du projet IntraEduWeb (IEW)
 * 
 * @package	IEW
 * @author	Sylvain GODM <sylvain.godme@gmail.com>
 * @version	gnr  l'installation, le ";
$fichier_config .= format_date_long("fr","")."  ".date("H:i:s");
$fichier_config .= "
 * @copyright	2004-".date("Y")." Sylvain GODM
 * @link	http://iew.free.fr
 * @license	GPL License version 3 (http://www.gnu.org/licenses/gpl.html)
 * @filesource
 * 
 */

if (!defined('SESSION_NAME')) {
 	/**
 	 * Constante contenant le nom de la session PHP (nom du cookie stock sur le navigateur du client)
 	 */	
	define('SESSION_NAME','IEW');
}

/********************** Racine du site ********************************/

if (!defined('IEW_DIR')) {
 	/**
 	 * Constante contenant le chemin complet du rpertoire d'installation IEW
 	 */	
	define('IEW_DIR',realpath(dirname(__FILE__).'/../').'/');
}

// Variable contenant l'Alias d'apache qui permet d'accder  la racine de l'application IEW
//  adapter en cas de modification de l'Alias dfini dans IEW_DIR/install/conf-scribe/apache-iew.conf
// Elle est utilise par de nombreux liens absolus
$"."racine = \"".$GLOBALS['racine']."\"; // doit imprativement se terminer par un slash !!

// On a besoin de ceci pour la fonction verif_authdir_data invoque plus loin dans ce script
require_once(IEW_DIR.'lib/fonctions_diverses.php');

// et aussi pour la fonction affiche_erreurs :
require_once(IEW_DIR.'lib/fonctions_erreurs.php');


/**************************** Informations de version *********************************************************/
// Laisser ce copyright SVP
";
$fichier_config .= 
"$"."copyright = \"Copyright &copy; 2004-\".date(\"Y\").\" - Sylvain GODM - Tous droits rservs -<br />IntraEduWeb version \"";
$fichier_config .= ".trim(file_get_contents(IEW_DIR.'VERSION'));

//URL Site officiel IntraEduWeb
$"."url_site_intraEduWeb = \"http://iew.free.fr\";

/*************************** Paramtrage des sessions **************************************/
// temps d'inactivit en secondes au bout duquel les utilisateurs authentifis devront se reconnecter
$"."session_timeout = \"".$_POST['session_timeout']."\";

/********************** Paramtres d'authentification ******************************************************/
/**

La procdure d'authentification se droule comme suit :
1 => on tente une authentification SSO (si configur et si l'utilisateur clique sur le lien correspondant dans le formulaire de connexion : variable $"."auth_method = \""."cas"."\" ou \""."lemonldap"."\" 
2 => on tente une authentification sur un serveur LDAP (si configur : variable $"."auth_method = \""."ldap"."\")
3 => on tente une authentification locale (native) dans la base utilisateurs IEW (table login)

Si variable $"."auth_method = \""."native"."\", seule la tentative n3 sera excute

En authentification SSO ou LDAP, un annuaire LDAP est consult : il est important de connatre sa structure
pour rcuprer les bons attributs, et notamment de connatre le gidNumber d'un individu, pour savoir s'il appartient au groupe des professeurs
ou au groupe des lves par exemple...

**/
$"."auth_method = \"".$_POST['auth_method']."\";
$"."sso = \"eolesso\"; //  dcommenter si l'authentification se fait par CAS eole
$"."ldap_server_name = \"".$_POST['ldap_server_name']."\";
$"."ldap_server_port = \"".$_POST['ldap_server_port']."\";
$"."ldap_base_dn = \"".$_POST['ldap_base_dn']."\";
$"."ldap_user_login_attribute = \"".$_POST['ldap_user_login_attribute']."\"; // nom de l'Attribut LDAP contenant l'identifiant de connexion
$"."ldap_user_eleve_attribute = \"".$_POST['ldap_user_eleve_attribute']."\"; // nom de l'Attribut LDAP qui si prsent dans le dn, permet d'identifier un utilisateur comme tant un lve (on prend pour cela un attribut obligatoire du schma LDAP de l'annuaire ENT)
$"."ldap_user_eleve_attribute_value = \"".$_POST['ldap_user_eleve_attribute_value']."\"; // nom de l'Attribut LDAP qui si prsent dans le dn, permet d'identifier un utilisateur comme tant un lve (on prend pour cela un attribut obligatoire du schma LDAP de l'annuaire ENT)
$"."ldap_user_prof_attribute = \"".$_POST['ldap_user_prof_attribute']."\"; // nom de l'Attribut LDAP qui si prsent dans le dn, permet d'identifier un utilisateur comme tant un professeur (on prend pour cela un attribut obligatoire du schma LDAP de l'annuaire ENT)
$"."ldap_user_prof_attribute_value = \"".$_POST['ldap_user_prof_attribute_value']."\"; // valeur de l'Attribut LDAP qui si prsent dans le dn, permet d'identifier un utilisateur comme tant un professeur (on prend pour cela un attribut obligatoire du schma LDAP de l'annuaire ENT)
$"."ldap_cle_jointure = \"".$_POST['ldap_cle_jointure']."\"; // nom de l'Attribut LDAP contenant la cl de jointure entre les donnes du SI MENESR et les donnes d'annuaire ENT ou LDAP
$"."cas_server_name = \"".$_POST['cas_server_name']."\";
$"."cas_server_port = \"".$_POST['cas_server_port']."\";
$"."validite_mdp = 9; // c'est le nombre de mois pendant lesquels le mot de passe d'un utilisateur reste valide
$"."timeout_desactivation_mdp = 60; // c'est le nombre de jours prcdent la date limite de validit du mot de passe pendant lesquels l'utilisateur est averti qu'il doit modifier son mot de passe avant que l'accs au systme ne soit bloqu

/********************** Paramtres Serveur MySQL ******************************************************/
// Ces informations seront prcises dans le fichier inc_connect.php


/********************** Interface graphique : les thmes et les couleurs ****************************/
// c'est le rpertoire contenant les squelettes et les feuilles de style par dfaut
$"."repertoire_theme = \"".$GLOBALS['repertoire_theme']."\";
// Squelette par dfaut utilis pour afficher les pages
$"."squelette = \"".$GLOBALS['squelette']."\";
// rpertoire contenant les lments de navigation
$"."repertoire_navigation = \"".$GLOBALS['repertoire_navigation']."\";
require_once(IEW_DIR.$"."repertoire_theme.\"couleurs.php\");
// Dominante de couleur utilise pour l'interface graphique
if (isset($"."_SESSION['anscol']) && $"."_SESSION['anscol'] !=\"\") // Si on est dans les archives
  $"."jeu_couleurs = $"."couleur_dominante[\"archives\"];
else
  $"."jeu_couleurs = $"."couleur_dominante[\"".$_POST['couleur']."\"];

/********************* Paramtres linguistiques ********************************************/
// Langue par dfaut (utilise pour l'instant seulement pour le format d'affichage de la date)
$"."default_language = \"fr\";


/********************** Messagerie interne **************************************/
//(vers l'interface de messagerie web seulement)
$"."url_mail_server = \"".$_POST['new_url_mail_server']."\";
// Contient le nom d'hte du serveur de messagerie (aprs le @ dans les adresses email)
$"."mail_server = \"".$_POST['new_mail_server']."\";
// le protocole utilis
$"."mail_protocol = \"".$GLOBALS['new_mail_protocol']."\";

/***************** Emplacement de donnes stockes sous forme de fichiers *******************************/
// Dossier de stockage des donnes sous forme fichier
// il comprend :
// - En mode d'authentification native seulement : les fichiers textes contenant les identifiants et mots de passe des utilisateurs - ces derniers sont crypts -
// - les fichiers joints aux cahiers de textes
// - les trombinoscopes (fichiers jpg ou png)
// - les fichiers de config ncessaires  IEW
// Seul l'utilisateur apache a le droit d'y crire
// Ce dossier doit tre cr par root sur la machine hbergeante avec un chown -R utilisateur_apache et un chmod -R 0755 sur ce rpertoire
// ceci est un chemin absolu sur la machine hbergeante (doit se terminer par un slash !!)

if (isset($"."_SESSION['anscol']) && $"."_SESSION['anscol'] !=\"\") // Si on est dans les archives, ce dossier est dfini en fonction de l'anne scolaire consulte
  $"."anscol = \"data_\".$"."_SESSION['anscol'];
else // sinon, c'est le dossier de stockage classique
  $"."anscol = \"\";
if ($"."anscol == \"\")
{
  if (substr(\"".$GLOBALS['stock_baselev']."\",-5,5)!=\"data/\")
   $"."stock_baselev = \"".$GLOBALS['stock_baselev']."\".\"data/\";
  else
   $"."stock_baselev = \"".$GLOBALS['stock_baselev']."\";
}
else
{
  if (substr(\"".$GLOBALS['stock_baselev']."\",-5,5)!=\"data/\")
   $"."stock_baselev = \"".$GLOBALS['stock_baselev']."\".\"data/\".$"."anscol.\"/\";
  else
   $"."stock_baselev = \"".$GLOBALS['stock_baselev']."\".$"."anscol.\"/\";
}

// On vrifie l'existence et les droits d'accs au dossier de stockage des fichiers spciaux s'il est dfini
if ($"."stock_baselev !=\"\") 
{
  $"."err = verif_authdir_data($"."stock_baselev);
  if ($"."err!=\"\")
  {
    $"."error_message = array($"."err,\"\");  
    affiche_erreurs($"."error_message);
    exit;
  }
}

/**************************** Ressources externes *******************************/
// Si disponible, URL de l'application GRR installe
// si http:// non prcis, c'est relatif  $"."DOCUMENT_ROOT (doit se terminer par un slash !!) ou bien mettre un Alias apache
$"."url_grr = \"".$_POST['new_url_grr']."\";

// Si disponible, URL de l'application web de gestion des notes (gepi, pronote -logiciel propritaire = beurk-,...)
$"."url_notation = \"".$_POST['new_url_notation']."\";

// Si disponible, URL de l'application web de gestion documentaire (PMB, BCDI,...)
$"."url_gestdoc = \"".$_POST['new_url_gestdoc']."\";

// Si disponible, URL de l'application web de gestion du b2i (gibii,...)
$"."url_gestb2i = \"".$_POST['new_url_gestb2i']."\";

/************************** Informations sur l'tablissement ********************************/
// nom Etablissement

$"."type_etablissement = \"".stripslashes($_POST['new_type_etablissement'])."\";
$"."nom_etablissement = \"".stripslashes($_POST['new_nom_etablissement'])."\";
$"."adresse_etablissement = \"".stripslashes($_POST['new_adresse_etablissement'])."\";
$"."cp_etablissement = \"".$_POST['new_cp_etablissement']."\";
$"."ville_etablissement = \"".stripslashes($_POST['new_ville_etablissement'])."\";
$"."tel_etablissement = \"".$_POST['new_tel_etablissement']."\";
$"."fax_etablissement = \"".$_POST['new_fax_etablissement']."\";
$"."email_etablissement = \"".$_POST['new_email_etablissement']."\";

// Responsables de publication
// C'est le directeur de l'tablissement

$"."nom_directeur_publication = \"".stripslashes($_POST['new_nom_directeur_publication'])."\";
$"."email_directeur_publication = \"".$_POST['new_email_directeur_publication']."\";

// URL du site internet de l'tablissement
$"."url_site_etablissement = \"".$_POST['new_url_site_etablissement']."\";

// Administrateur IntraEduWeb
$"."admin_name = \"".stripslashes($_POST['new_admin_name'])."\";
$"."admin_email = \"".stripslashes($_POST['new_admin_email'])."\";
// en fait ici on va passer par un formulaire de saisie avec un champ password puis le script de config crira directement et sous forme crypte ce mot de passe dans la base de donnes mysql (table login)
$"."admin_passwd = \"\";

// Le message personnalis de pied de page
$"."message_pied_page = \"".addslashes($_POST['new_message_pied_page'])."\";

// Les jours de la ouvrables de la semaine (necessite que le language par defaut soit fr)
$"."jours_ouvrables = ".$GLOBALS['def_jours_ouvrables'].";

/************** A DEPLACER VERS LES REPERTOIRES DES THEMES POUR L'INTERFACE GRAPHIQUE *****************/
// Concepteur graphique des pages
include(IEW_DIR.\"".$GLOBALS['repertoire_theme']."\".\"designer.php\");

// Pas de balise de fin de code php car sinon envoi un message d'erreur : header already sent sur la prochaine intruction session_start()
";

// On enregistre les changements dans le fichier de configuration
if (isset($include_install)) // Ce script est appel par le script d'installation
  $chemin_config = $_SESSION['liste_variables']['new_stock_baselev']; // Le dossier de stockage est dans une variable de session
else // Ce script est appel par le script de modification de configuration post-installation
  $chemin_config = CONF_DIR; // Le dossier de stockage est dans la constante CONF_DIR (dfinie dans conf_dir.php)

//DEBUGG echo str_replace("\n","<br />",$fichier_config)."<br />"; exit;

$fichier = fopen($chemin_config."config.php","w"); // ouverture en criture en crasant le contenu existant
// on ecrit la ligne d'en-tte contenant les champs de donnes
fwrite($fichier,$fichier_config);
fclose($fichier);
?>