<?php
/**
 * modele_htaccess404.php
 *
 * c'est le modle de fichier .htaccess utilis par le script install.php
 * pour permettre au serveur web sur lequel est install IntraEduWeb, de rediriger la page 404
 * vers une page propre  IntraEduweb (page-404.php)
 * 
 * Ce fichier fait partie du projet IntraEduWeb (IEW)
 * 
 * @package		IEW
 * @author			Sylvain GODM <sylvain.godme@gmail.com>
 * @version		$LastChangedRevision$, $LastChangedDate$
 * @copyright		2004-2012 Sylvain GODM
 * @link			http://iew.free.fr
 * @license		GPL License version 3 (http://www.gnu.org/licenses/gpl.html)
 * @filesource
 * 
 */

if (!defined('IEW_DIR')) {
 	/**
 	 * Constante contenant le chemin complet du rpertoire d'installation IEW
 	 */	
	define('IEW_DIR',realpath(dirname(__FILE__).'/../../').'/');
}

$fichier_htaccess404 = "
#
# .htaccess
#
# Fonction : Permet de rediriger la page d'erreur 404 standard d'apache
# Il est gnr automatiquement lors de l'installation
# 
# Ce fichier fait partie du projet IntraEduWeb (IEW)
# 
# @package	IEW
# @author	Sylvain GODM <sylvain.godme@gmail.com>
# @version	gnr  l'installation, le ";
$fichier_htaccess404 .= format_date_long("fr","")."  ".date("H:i:s");
$fichier_htaccess404 .= "
# @copyright	2004-".date("Y")." Sylvain GODM
# @link	http://iew.free.fr
# @license	GPL License version 3 (http://www.gnu.org/licenses/gpl.html)
# @filesource

# l'URL du site est change par le script d'installation IntraEduWeb
ErrorDocument 404 ".$GLOBALS['racine']."page-404.php";

// Tentative d'criture du fichier .htaccess  la racine IntraEduWeb
$fichier = @fopen(IEW_DIR.".htaccess","w"); // ouverture en criture en crasant le contenu existant
if ($fichier)
{
  // on ecrit la ligne d'en-tte contenant les champs de donnes
  if (!@fwrite($fichier,$fichier_htaccess404)) // le fichier destination n'a pu tre crit
  {
    // c'est parce que les droits ne sont pas ceux de l'utilisateur "apache", donc on crit dans /data
    // mais comme il existe dj dans ce rpertoire un .htaccess important, celui qui est cr est .htaccess404
    $fichier = @fopen(IEW_DIR."data/.htaccess404","w"); // ouverture en criture en crasant le contenu existant
    // on ecrit la ligne d'en-tte contenant les champs de donnes
    @fwrite($fichier,$fichier_htaccess404);
    @fclose($fichier);
    $error_message = array("<div align='justify'>Le fichier .htaccess permettant de rediriger la page d'erreur 404 du serveur web (page introuvable) vers la page d'erreur 404 propre  IntraEduWeb n'a pas pu tre crit  la racine de votre site (".IEW_DIR.")
    <br />Il a t enregistr sous le nom .htaccess404 dans le rpertoire <strong>data</strong>.
    <br />Veuillez le copier manuellement par ftp depuis ce rpertoire <strong>data</strong> vers <u>la racine de votre site IntraEduWeb</u>, et <u>renommez-le</u> en <strong>.htaccess</strong> (crasez ventuellement le .htaccess existant).</div>
    ","");
    affiche_erreurs($error_message);
    echo "<br />";
  }
  @fclose($fichier);
}
else // le fichier destination n'a pu tre ouvert ou cr
{
  // c'est parce que les droits ne sont pas ceux de l'utilisateur "apache", donc on crit dans /data
  // mais comme il existe dj dans ce rpertoire un .htaccess important, celui qui est cr est .htaccess404
  $fichier = @fopen(IEW_DIR."data/.htaccess404","w"); // ouverture en criture en crasant le contenu existant
  // on ecrit la ligne d'en-tte contenant les champs de donnes
  @fwrite($fichier,$fichier_htaccess404);
  @fclose($fichier);
  $error_message = array("<div align='justify'>Le fichier .htaccess permettant de rediriger la page d'erreur 404 du serveur web (page introuvable) vers la page d'erreur 404 propre  IntraEduWeb n'a pas pu tre crit  la racine de votre site (".IEW_DIR.")
  <br />Il a t enregistr sous le nom .htaccess404 dans le rpertoire <strong>data</strong>.
  <br /> /Veuillez le copier manuellement par ftp depuis ce rpertoire <strong>data</strong> vers <u>la racine de votre site IntraEduWeb</u>, et <u>renommez-le</u> en <strong>.htaccess</strong> (crasez ventuellement le .htaccess existant).</div>
  ","");
  affiche_erreurs($error_message);
  echo "<br />";
}
?>