/**
 * ajax_autorisations_parentales.js
 *
 * Ce code l'affichage des options et de leur commentaire dans le select
 * du formulaire de consultation des autorisations parentales
 * en fonction de la slection courante de l'utilisateur
 * 
 * On pourra s'inspirer de ce code pour fournir un fichier plus gnrique
 * permettant un comportement similaire sur tout formulaire o l'on en aurait besoin...
 * 
 * Ce fichier fait partie du projet IntraEduWeb (IEW)
 * 
 * @package		IEW
 * @author			Sylvain GODM <sylvain.godme@gmail.com>
 * @version		$$LastChangedRevision$$, $$LastChangedDate$$
 * @copyright		2004-2012 Sylvain GODM
 * @link			http://iew.free.fr
 * @license		GPL License version 3 (http://www.gnu.org/licenses/gpl.html)
 * @filesource
 * 
 */

//global flag
var isIE = false;

// global request and XML document objects
var req;

document.observe('dom:loaded', init);

if (window.ActiveXObject) // flag dtection IE
{
  isIE = true;
}

function init()
{
	if ($('Form_Req_Domaine'))
	{
		$('Form_Req_Domaine').observe('change', loadDoc);
	}
	if ($('Form_Req_Criteres'))
	{
		$('Form_Req_Criteres').observe('change', showDetail);
	}
	if ($('recherche_form'))
	{
		$('recherche_form').observe('submit', valider_form);
	}
}

function loadXMLDoc(url)
{
	/**
     * Charge un document XML (la rponse  la requte Ajax) dans un objet xhr
     * Le XML source doit venir du mme nom de domaine que le fichier HTML d'appel
     */
	
	// Mise  jour de la liste d'options du select pour le choix du titulaire dans le formulaire
	new Ajax.Request
	(
			url,
			{
				method: 'get',
				onComplete: function gestionReponse(xhr) {
				if (xhr.status == 200)
				{
					// On efface la liste des options actuelle
			        clearTopicList();
			        // et on la reconstruit
			        buildTopicList(xhr);
			    }
			    else {
			    	alert("Il y a eu un problme pour rcuprer les donnes XML : " + xhr.statusText);
			    }
				init();
			}
		}
	);
}

// la fonction suivante est appele  chaque changement de slection dans l'lment select (Form_Req_Domaine)
// Ceci provoque le chargement du document XML contenant les donnes, l'effacement des options de l'lment select (critere) actuelle
// et le chargement des nouvelles options de l'lment select (critere)

function loadDoc(evt)
{
    // equalize W3C/IE event models to get event object
    evt = (evt) ? evt : ((window.event) ? window.event : null);
    if (evt)
    {
      // On commence par afficher le bloc div contenant le critre  slectionner
      document.getElementById("select_critere").style.visibility="visible";
      document.getElementById("select_critere").style.display="block";
      // equalize W3C/IE models to get event target reference
      var elem = (evt.target) ? evt.target : ((evt.srcElement) ? evt.srcElement : null);
      if (elem)
      {
        // On affecte le champ cach id_domaine avec le domaine choisi
        document.getElementById("id_domaine").value=elem.selectedIndex;
        try
        {
          if (elem.selectedIndex > 0)
          {
            // Si un lment est slectionn dans le champ de formulaire id=id_domaine, alors on charge le doucment XML contenant les donns correspondantes
        	  loadXMLDoc(elem.options[elem.selectedIndex].value);
          } 
        }
        catch(e)
        {
          var msg = (typeof e == "string") ? e : ((e.message) ? e.message : "Erreur inconnue");
          alert("Impossible d obtenir les donnes XML:" + msg);
          return;
        }
      }
    }
}

// On rcupre le texte des lments du document XML

function getElementTextNS(prefix, local, parentElem, index)
{
    /**
     * 
     */
	var result = "";
    if (prefix && isIE)
    {
      // IE/Windows way of handling namespaces
      result = parentElem.getElementsByTagName(prefix + ":" + local)[index];
    }
    else
    {
      // the namespace versions of this method 
      // (getElementsByTagNameNS()) operate
      // differently in Safari and Mozilla, but both
      // return value with just local name, provided 
      // there aren't conflicts with non-namespace element
      // names
      result = parentElem.getElementsByTagName(local)[index];
    }
    if (result)
    {
      // get text, accounting for possible
      // whitespace (carriage return) text nodes 
      if (result.childNodes.length > 1)
      {
        return result.childNodes[1].nodeValue;
      }
      else
      {
        return result.firstChild.nodeValue;       
      }
    }
    else
    {
      return "n/a";
    }
}

  // Efface la liste des options courantes de l'lment select
  function clearTopicList()
  {
    var select = document.getElementById("Form_Req_Criteres");
    while (select.length > 0)
    {
      select.remove(0);
    }
  }

  // ajoute une option  l'lment select en argument
  function appendToSelect(select, value, content)
  {
    var opt;
    opt = document.createElement("option");
    opt.value = value;
    opt.appendChild(content);
    select.appendChild(opt);
  }

  // Remplit la liste de slection Form_Req_Criteres  partir des donnes XML charges
  function buildTopicList(xhr)
  {
    var select = document.getElementById("Form_Req_Criteres");
    var items = xhr.responseXML.getElementsByTagName("autorisation");
    req = xhr; // on copie l'objet local xhr dans la variable globale window.req afin qu'lle soit utilisable par la fonction showDetail()
    // puis on boucle  travers les lments <autorisation> du document XML et l'on ajoute
    // chaque lment <libelle> comme option de l'lment select (Form_Req_Criteres)
    for (var i = 0; i < items.length; i++)
    {
      appendToSelect(select, i,document.createTextNode(getElementTextNS("", "libelle", items[i], 0)));
    }
    // Efface l'affichage du dtail
    document.getElementById("detail").innerHTML = "";
  }

  // affiche le dtail (content:encoded) rcupr depuis le document XML
  function showDetail(evt)
  {
    evt = (evt) ? evt : ((window.event) ? window.event : null);
    var item, content, div;
    if (evt)
    {
      var select = (evt.target) ? evt.target : ((evt.srcElement) ? evt.srcElement : null);
      if (select && select.options.length > 1)
      {
        // copie l'lment (<contenu>) de llment parent (autorisation) slectionn
        // initialement c'tait <content:encoded> (mme chose dans autorisations_domaine.php
        // avec un content = getElementTextNS("content", "encoded", item, 0);
        // mais cela ne marchait pas avec Firefox Pb (erreur JS : prfixe non limit  un espace de noms)
        item = window.req.responseXML.getElementsByTagName("autorisation")[select.value];
        content = getElementTextNS("", "contenu", item, 0);
        div = document.getElementById("detail");
        div.innerHTML = "";
        // Place le nouveau contenu HTML dans le conteneur (detail)
        div.style.visibility = "visible";
        div.style.display = "block";
        div.innerHTML = content;
      }
    }
  }
  
  // Fonction servant  vrifier qu'aucun champ de formulaire n'est vide
  function valider_form(event) // Contrle de validation de formulaire avant envoi
  {
    if (document.recherche_form.classe.value == "" || document.recherche_form.domaine.value == "" || document.recherche_form.criteres.value == "")
    {
      alert("Vous n\'avez pas rempli tous les champs obligatoires !");
      // On stoppe l'venement submit de faon  ce que le script dclar en action du formulaire ne soit pas appel : on reste sur la page courante
      Event.stop(event);
    }
  }