/**
 * remplacants.js
 *
 * Code grant la mise  jour de la page de gestion des professeurs remplaants
 * Il permet de rafrachir les donnes affiches aprs soumission du formulaire
 * d'ajout d'un nouveau professeur remplaant ou aprs la suppression d'un remplacement
 * 
 * Ce fichier fait partie du projet IntraEduWeb (IEW)
 * 
 * @package		IEW
 * @author			Sylvain GODM <sylvain.godme@gmail.com>
 * @version		$LastChangedRevision$, $LastChangedDate$
 * @copyright		2004-2012 Sylvain GODM
 * @link			http://iew.free.fr
 * @license		GPL License version 3 (http://www.gnu.org/licenses/gpl.html)
 * @filesource
 * 
 */

// on s'assure que le dom est charg
document.observe('dom:loaded', init);
 
// au chargement de la page on prcharge l'image de l'ajaxloader
Event.observe(window, 'load', updateInit);

function init() // On surveille certains vnements
{
	if ($('AddSubstituteForm'))
	{
		$('AddSubstituteForm').observe('submit', update_add);
	}
	/*
	 * Les attributs id des liens  surveiller doivent tre uniques
	 * donc ces attributs ont une valeur 'linkSuppr' + n du lien
	 * Comme je ne sais pas comment faire pour associer le mme vnement pour le groupe complet de TOUS les liens 'linkSuppr'
	 * Je cre un gestionnaire si l'lment existe pour un maximun de 10 liens, je pense que c'est suffisant
	 * Mais il y a peut-tre un moyen + lgant de le faire... */
	for (i = 1; i < 11; i++)
	{
		var idElement = 'linkSuppr' + i;
		if ($(idElement))
		{
			$(idElement).observe('click', update_suppr);
		}
	}
}

function updateInit()
{
  	// Je pr-charge l'image du loader
    var oLoading = new Image();
    oLoading.src = "../../../images/ajax-loader.gif";
}

function update_add(event)
{
	/**
	 * Permet l'ajout d'un remplacement et met  jour le div 'add_msg'
	 * pour indiquer le rsultat (succs ou chec) de l'opration
	 * 
	 * Excute lors de la soumission du formulaire d'ajout d'un remplacement de professeur
	 */
	Event.stop(event); // On supprime l'action par dfaut de l'vnement (ici l'xcution du script dfini par l'attribut action du formulaire)
	// Information de l'utilisateur sur les oprations en cours
    $('wait_message').innerHTML = "<img src=\"../../../images/ajax-loader.gif\" alt=\"Enregistrement en cours...\" width=\"50\" height=\"50\" />Veuillez patienter pendant l'enregistrement du nouveau remplacement...";
    $('wait_message').style.display = "block";
    new Ajax.Updater
	(
		'add_msg',
		'c_do_remplacants.php',
		{
			method: 'post',
			parameters: {id_remplacant: $F('Form_Req_remplacant'), id_titulaire: $F('Form_Req_titulaire')},
			onComplete: update_substitutes_list // Il faut attendre que la requte soit termine avant de mettre  jour la liste des remplacements en cours
		}
	);
    $('wait_message').style.display = "none";
    $('AddSubstituteForm').reset(); // Evite qu'une nouvelle soumission renvoie les mmes donnes car la page n'est pas recharge, le formulaire restait donc dans l'tat o on l'a laiss  sa soumission
}

function update_suppr(event)
{
	/**
	 * Permet la suppression d'un remplacement et met  jour le div 'add_msg'
	 * pour indiquer le rsultat (succs ou chec) de l'opration
	 * 
	 * Excute lors du click sur un lien [supprimer] dans la liste des remplacements en cours
	 */
	var r=confirm('tes-vous sr de vouloir supprimer ce remplacement ?');
	if (r==true)
	{
		Event.stop(event); // On supprime l'action par dfaut de l'vnement (ici l'xcution du script dfini dans l'attribut href du lien)
		// Information de l'utilisateur sur les oprations en cours
		$('wait_message').innerHTML = "<img src=\"../../../images/ajax-loader.gif\" alt=\"Suppression en cours...\" width=\"50\" height=\"50\" />Veuillez patienter pendant la suppression du remplacement...";
		$('wait_message').style.display = "block";
		var element = Event.element(event); // c'est l'lment sur lequel l'vnement a eu lieu (ici l'icne en forme de croix delete.png, c'est une balise img qui ne contient pas d'attribut href)
		// pour avoir l'attribut href, il va falloir prendre comme element le parent direct de cette balise <img>  savoir la balise <a> qui la contient
		var element = element.parentNode; // voil le bon lment sur lequel on va rcuprer l'attribut href
		var href = element.readAttribute('href'); // on rcupre la valeur du href du lien sur lequel l'vnement click a eu lieu
		var fragmentsArray = href.split("?"); // on isole les paramtre URL (query_string)
		var paramUrl = fragmentsArray[1]; // ce qui nous intresse se trouve aprs le ?
		var paramSuppr = recup_paramHref(paramUrl,'suppr'); // on rcupre la valeur du paramtre 'suppr'
		element.writeAttribute('href', 'remplacants.php'); // on remet la cible du lien vers la page appelante (sinon la page est remplace par celle cible par le lien d'origine)
		//var newHref = element.readAttribute('href');
		//alert(newHref);
		// Ce qui est gnant en Ajax car le contenu initial de la page est effac et remplac par la nouvelle page, ce qui empche le 2me Ajax.Updater de mettre  jour le div prvu
		new Ajax.Updater
		(
				'add_msg',
				'c_do_remplacants.php',
				{
					method: 'get',
					parameters: {suppr: paramSuppr},
					onComplete: update_substitutes_list // Il faut attendre que la requte soit termine avant de mettre  jour la liste des remplacements en cours
				}
		);
		$('wait_message').style.display = "none";
	}
	else
	{
		Event.stop(event); // On supprime l'action par dfaut de l'vnement (ici l'xcution du script dfini dans l'attribut href du lien)
	}
}

function recup_paramHref(href,urlParam)
{ 
	// Rcupration de tous les paramtres url du href fourni en argument
		// On isole les couples nom_paramtre=valeur
	var pairsArray = href.split("&");

	for (i = 0; i < pairsArray.length; i++)
	{
		var pair = pairsArray[i].split("=");
	    if (pair[0] == urlParam)
	    {
	    	//alert(pair[1] + ' est la valeur du paramtre ' + urlParam);
	    	return pair[1];
	    }
	} 
}

function update_substitutes_list()
{
	/**
	 * Met  jour la liste des remplacements en cours
	 * et remet les gestionnaires d'vnements actifs s'ils ont t stopps avant les appels AJAX
	 */
	
	if ($('AddSubstituteForm'))
	{
		$('AddSubstituteForm').style.display = 'block'; // On s'assure que le formulaire est affich (car peut tre non affich + bas)
	}
	
	// Mise  jour de la liste affiche des remplacements en cours
	new Ajax.Updater
	(
		'substitutes',
		'liste_remplatits.php',
		{
			method: 'get',
			onComplete: init() // permet de prendre en compte le gestionnaire d'vnement associ au lien [supprimer] qui a t ajout ou retir du DOM
		}
	);
	
	// Mise  jour de la liste d'options du select pour le choix du remplaant dans le formulaire
	new Ajax.Request
	(
		'liste_remplatits.php?type=remplacants',
		{
			method: 'get',
			onComplete: function gestionReponse(xhr) {
				if (xhr.status == 200)
				{
			        if (xhr.responseText.indexOf('texterror') != -1) // si message d'erreur
			        {
			        	//alert(xhr.responseText);
			        	$('add_msg').innerHTML = xhr.responseText; // on affiche l'erreur
			        	if (xhr.responseText.indexOf('plus de professeur') != -1)// Si le message d'erreur indique qu'il n'y a plus de remplaant disponible
			        		$('AddSubstituteForm').style.display = 'none'; // le formulaire n'est pas affich (pas la peine d'afficher un formulaire dans lequel on en peut pas choisir de remplaant puisque la liste est vide !)
			        }
			        else // pas d'erreur : il y a des remplaants disponibles
			        {
			        	//alert(xhr.responseText);
			        	if ($('Form_Req_remplacant')) // Si le formulaire d'ajout d'un remplacement est prsent dans le DOM, on met  jour le select pour les remplaants disponibles
			        	{
			        		$('Form_Req_remplacant').innerHTML = xhr.responseText;
			        	}
			        	else // pas de formulaire dans le DOM : cela signifie qu'au chargement de la page (c_remplacants.php), il n'y avait pas de remplaant disponible
			        	{
			        		//alert('La liste des remplaants disponibles ne pas tre affiche car il n\'y a pas de formulaire dans le DOM !');
			        		
			        		// Il faut afficher un formulaire, car on est juste aprs une phase de suppression d'un remplacement
			        		// donc il y a obligatoirement au moins un remplaant disponible
			        		// il faut donc modifier le DOM de la page par un appel AJAX pour afficher le formulaire
			        		affiche_form();
			        	}
			        }
			    }
			    else {
			        $('add_msg').innerHTML = "La requte AJAX sur liste_remplatits.php?type=remplacants n'a pas abouti. Le code d'erreur est : " + xhr.status;
			    }
				init();
			}
		}
	);
	
	// Mise  jour de la liste d'options du select pour le choix du titulaire dans le formulaire
	new Ajax.Request
	(
		'liste_remplatits.php?type=titulaires',
		{
			method: 'get',
			onComplete: function gestionReponse(xhr) {
				if (xhr.status == 200)
				{
			        if (xhr.responseText.indexOf('texterror') != -1)
			        {
			        	//alert(xhr.responseText);
			        	$('add_msg').innerHTML = xhr.responseText;
			        	$('AddSubstituteForm').style.display = 'none';
			        }
			        else
			        {
			        	//alert(xhr.responseText);
			        	$('Form_Req_titulaire').innerHTML = xhr.responseText;
			        }
			    }
			    else {
			        $('add_msg').innerHTML = "La requte AJAX sur liste_remplatits.php?type=titulaires n'a pas abouti. Le code d'erreur est : " + xhr.status;
			    }
				init();
			}
		}
	);
}

function affiche_form()
{
	/**
	 * Affiche le formulaire de saisie d'un nouveau remplacement
	 * 
	 * n'est appel que si le formulaire n'est pas dans le DOM
	 * et si l'appel  la fonction update_substitutes_list() a renvoy un message indiquant qu'il n'y plus de remplaant disponible
	 * */
	new Ajax.Request
	(
		'form_remplacants.php?request=ajax',
		{
			method: 'get',
			onComplete: function gestionReponse(xhr) {
				if (xhr.status == 200)
				{
			        $('form_container').innerHTML = xhr.responseText;
			    }
			    else {
			        $('add_msg').innerHTML = "La requte AJAX  sur form_remplacants.php?request=ajax n'a pas abouti. Le code d'erreur est : " + xhr.status;
			    }
				init();
			}
		}
	);
}