/**
 * update_ct.js
 *
 * Code grant la modification de l'affichage du carnet de bord sans rechargement de la page
 * 
 * Ce fichier fait partie du projet IntraEduWeb (IEW)
 * 
 * @package		IEW
 * @author			Sylvain GODM <sylvain.godme@gmail.com>
 * @version		$LastChangedRevision$, $LastChangedDate$
 * @copyright		2004-2012 Sylvain GODM
 * @link			http://iew.free.fr
 * @license		GPL License version 3 (http://www.gnu.org/licenses/gpl.html)
 * @filesource
 * 
 */

//on s'assure que le dom est charg pour surveiller les vnements sur certains lments
document.observe('dom:loaded', init);

//Comme le dom peut changer lors de la mise  jour d'lments sur la page (et donc les gestionnaires de surveillance peuvent tre supprims par un Element.update)
//Il faut relancer la surveillance
document.observe('dom:changed', init);

function init() 
{
	if ($('loadAjax')) // l'lement peut ne pas tre prsent : dans le cas d'un jour sans cours, si on ne met pas ce test, le js plante car l'elt n'est pas trouv
		$('loadAjax').style.display = 'none'; // le spinner Ajax n'est pas affich au chargement de page
	// Suveillance des contrles de navigation jour prcdent et jour suivant
	$('DayNavLeft').observe('click', displayOtherDay);
	$('DayNavRight').observe('click', displayOtherDay);
}

function displayOtherDay(event)
{
	/**
	 * Va afficher le carnet de bord pour du jour prcdent ou suivant
	 */
	Event.stop(event); // On supprime l'action par dfaut de l'vnement (ici le rechargement de page avec un nouveau paramtre URL j
	// On va afficher le spinner AJAX  la place de l'icne de modif
	var element = Event.element(event); // c'est l'lment sur lequel l'vnement a eu lieu (ici l'icne en forme de flche vers la gauche, c'est une balise img qui ne contient pas d'attribut href)
	// pour avoir l'attribut href, il va falloir prendre comme element le parent direct de cette balise <img>  savoir la balise <a> qui la contient
	var element = element.parentNode; // voil le bon lment sur lequel on va rcuprer l'attribut href
	var url = 'ct_day.php' + element.readAttribute('href'); // on rcupre la valeur du href du lien sur lequel l'vnement click a eu lieu
	display_ct_day_update(url);
}

function display_ct_day_update(url)
{
	/**
	 * Met  jour le carnet de bord selon le jour
	 */
	
	// On affiche le spinner AJAX pendant la requte
	if ($('textNavBar')) // l'lement peut ne pas tre prsent : dans le cas d'un jour sans cours, si on ne met pas ce test, le js plante car l'elt n'est pas trouv
		$('textNavBar').style.display = 'none';
	if ($('loadAjax'))
		$('loadAjax').style.display = 'inline';
	new Ajax.Updater
	(
		'content_ct_day',
		url,
		{
			method: 'get',
			onComplete: function gestionReponse(xhr)
			{
				if (xhr.status == 200)
				{
					// On cre un element dans le DOM pour recevoir la rponse (texte contenant du HTML) que l'on souhaitera parser
					// En effet, ce qui est renvoy est le document source HTML complet de la requte
					// on ne veut pas tout le code de la page mais seulement le contenu du div id='content_ct_day'
					var wrapper = new Element('div'); // ce sera la seule faon de pouvoir parser la rponse a priori
				    wrapper.update(xhr.responseText);
					// on ne veut pas tout le code de la page mais seulement le contenu de 'content_ct_day' : il faut l'extraire de la rponse
				    var nestedElement = wrapper.select('[id="content_ct_day"]');
				    $('content_ct_day').update(nestedElement[0].outerHTML); // On affiche la rponse du script (formulaire d'ajout/modification/suppression d'un cours)
				    if ($('loadAjax')) // l'lement peut ne pas tre prsent : dans le cas d'un jour sans cours, si on ne met pas ce test, le js plante car l'elt n'est pas trouv
				    	$('loadAjax').style.display = 'none'; // On n'affiche plus le spinner AJAX
					if ($('loadAjax'))
						$('textNavBar').style.display = 'inline'; // mais on affiche la barre de navigation textuelle
					// Le DOM tant modifi, on recharge les gestionnaires d'vnements (voir en haut du script)
					document.fire('dom:changed'); // cela va faire appel  la fonction init
				}
				else
				{
					if ($('add_msg')) // l'lement peut ne pas tre prsent : dans le cas d'un jour sans cours, si on ne met pas ce test, le js plante car l'elt n'est pas trouv
					{
						$('add_msg').style.display = 'block';
						$('add_msg').setStyle({marginBottom: '1.5em'}); // sinon a touche le datepicker de la semaine
						$('add_msg').append("<br />L'affichage du carnet de bord n'a pas pu tre mis  jour. Le code d'erreur est : " + xhr.status);
					}
				}
			}
		}
	);
}
