/**
 * upload_files_imports.js
 *
 * Code grant l'upload de fichiers
 * 
 * Ce fichier fait partie du projet IntraEduWeb (IEW)
 * 
 * @package		IEW
 * @author			Sylvain GODM <sylvain.godme@gmail.com>
 * @version		$LastChangedRevision$, $LastChangedDate$
 * @copyright		2004-2012 Sylvain GODM
 * @link			http://iew.free.fr
 * @license		GPL License version 3 (http://www.gnu.org/licenses/gpl.html)
 * @filesource
 * 
 */

// on s'assure que le dom est charg
document.observe('dom:loaded', init);
 
// au chargement de la page on prcharge l'image de l'ajaxloader
Event.observe(window, 'load', uploadInit);

// Variable globale, va conditionner l'url appele par la requte AJAX dans la fonction lancer_importation()
typeImport = recup_paramurl('type');

function init()
{
	if ($('uploadForm'))
	{
		$('uploadForm').observe('submit', uploadRun);
	}
}

function uploadInit()
{
  	// Je pr-charge l'image du loader
    var oLoading = new Image();
    oLoading.src = "../../../images/ajax-loader.gif";
}
 
function uploadRun()
{
	// On change la valeur de l'attribut action du formulaire afin d'orienter le traitement par AJAX
	var actionValue = $('uploadForm').readAttribute('action');
	actionValue = actionValue.replace('=php', '=ajax');
	$('uploadForm').writeAttribute("action", actionValue);
	// on ajoute un attribut target vers une iframe ncessaire pour l'upload de fichier en ajax
	$('uploadForm').writeAttribute("target", "uploadFrame");
	// dclenche  la soumission du formulaire d'upload
	// Suppression de l'affichage du formulaire (et ventuellement d'un message d'erreur sur une 1re soumission infructueuse)
    $('form_container').style.display = "none";
    $('upload_error_msg').style.display = "none";
    // Information de l'utilisateur sur les oprations en cours
    $('wait_message').innerHTML = "<img src=\"../../../images/ajax-loader.gif\" alt=\"Tlchargement en cours...\" width=\"50\" height=\"50\" />Veuillez patienter pendant le tlchargement des fichiers...";
    $('wait_message').style.display = "block";
    $('page').scrollTo();
}
        
function uploadEnd(sError)
{
	// Le traitement tant termin, le bloc d'information sur les oprations en cours peut-tre cach
  	$('wait_message').style.display = "none";
  	
  	 // Ractivation du bouton "importer" du formulaire pour permettre une nouvelle tentative d'upload
    $('uploadSubmit').disabled = false;
  	
	if(sError == 'OK') // pas d'erreur
    {
   		// Eventuellement suppression d'un message d'erreur prcdent
		$('upload_error_msg').style.display = "none";
		// suppression de l'affichage du formulaire
		 $('form_container').style.display = "none";
		// Affichage du message de succs
        $('upload_ok_msg').style.display = "block";
        $('uploadStatus_ok').innerHTML = "Les fichiers ont bien t tlchargs ! <a href='#' id='lanceur_import'>Lancer l\'importation des donnes</a>";
        $('page').scrollTo();
        // On surveille le lien de lancement de l'importation
        $('lanceur_import').observe('click', lancer_importation); 
    }
    else // il y a erreur
    {
		// Affichage du message d'erreur
        $('uploadStatus_error').innerHTML = sError;
        $('upload_error_msg').style.display = "block";
        $('page').scrollTo();
        // Raffichage du formulaire
        $('form_container').style.display = "block"; 
    }
}

function lancer_importation(event)
{
	// Information de l'utilisateur sur les oprations en cours
	$('upload_ok_msg').style.display = "none";
	$('wait_message').innerHTML = "<img src=\"../../../images/ajax-loader.gif\" alt=\"Traitement en cours...\" width=\"50\" height=\"50\" />Veuillez patienter pendant l'importation des donnes...";
	$('wait_message').style.display = "block";
	var url = "c_do_imports_" + typeImport + ".php"; // on adapte l'url en fonction du type d'import (adm pour import administratif et elev pour importer les lves et les responsables
	// Requte AJAX en backend : importation effective des donnes
	new Ajax.Request
	(
		url,
		{
			method: 'get',
			onComplete: function gestionReponse(xhr) {
				$('wait_message').style.display = "none";
				if (xhr.status == 200) {
			        $('resume_rapport').innerHTML = xhr.responseText;
			    }
			    else {
			        $('resume_rapport').innerHTML = "La requte AJAX vers l'url '" + url + "' n'a pas abouti. Le code d'erreur est : " + xhr.status;
			    }
			}
		}
	);
}

function recup_paramurl(urlParam)
{ 
	// Rcupration de tous les paramtres de l'url de la page en cours
	var varsFromUrl = document.location.search;

	// on supprime '?'                                                  
	varsFromUrl = varsFromUrl.substring(1);

	// On isole les couples nom_paramtre=valeur
	var pairsArray = varsFromUrl.split("&");

	for (i = 0; i < pairsArray.length; i++)
	{
		var pair = pairsArray[i].split("=");
	    if (pair[0] == urlParam)
	    {
	    	//alert(pair[1] + ' est la valeur du paramtre ' + urlParam);
	    	return pair[1];
	    }
	} 
}
