<?php
/**
 * je_suis_la.php
 *
 * Met  jour le timestamp "last_request" de la table journal_connexions
 * Est appel  intervalle rguliers par une page ouverte sur le navigateur de l'utilisateur (= heartbeat)
 * ceci afin de confirmer la prsence de l'utilisateur (navigateur ouvert sur l'application) ou dtecter une fermeture du navigateur
 * Cela permet de maintenir une session active tant que la fentre navigateur est "ouverte" sur la page et vite  un professeur de devoir
 * se reconnecter au cours d'une mme matine/aprs-midi de cours...
 * 
 * Ce fichier fait partie du projet IntraEduWeb (IEW)
 * 
 * @package		IEW
 * @author			Sylvain GODM <sylvain.godme@gmail.com>
 * @version		$LastChangedRevision$, $LastChangedDate$
 * @copyright		2004-2012 Sylvain GODM
 * @link			http://iew.free.fr
 * @license		GPL License version 3 (http://www.gnu.org/licenses/gpl.html)
 * @filesource
 * 
 */

if(!defined('IEW_DIR')) define('IEW_DIR',realpath(dirname(__FILE__)).'/');
// Inclusions
require_once(IEW_DIR."librairie_fonctions.php");

// Scurit des sessions : on profite de l'appel rgulier  ce script pour modifier l'id de session
if ($GLOBALS['auth_method'] != "cas" || $GLOBALS['sso'] != "eolesso") // Mais pas sur eole pour ne pas compromettre la prise en compte de la dconnexion centralise
	session_regenerate_id(true); // le paramtre optionnel $delete_old_session est mis  true pour dtruire l'ancienne session sinon les fichiers de sessions s'accumulent 

/* Voir le memo dev (+ anomalie n78) pour comprendre pourquoi les 2 instructions suivantes sont dsactives
if ($GLOBALS['auth_method'] == "cas" && $GLOBALS['sso'] == "eolesso") // uniquement sur un serveur scribe eole afin de permettre la continuit de la gestion de la dconnexion centralise
	modify_session_id_with_eolecas_ticket("init_casclient");
*/

// Existe-t-il une session authentifie pour l'utilisateur qui appelle le script ?
// si oui, on met  jour le journal des connexions  chaque appel de ce script
if (isset($_SESSION['id_connexion']))
{
  // On informe le navigateur qu'il va recevoir un fichier texte
  header('Content-Type: text/plain'); 
  echo "JE SUIS LA !"; // On envoie un texte quelconque, histoire d'envoyer qq chose
  // Mais ce ne sera ni affich, ni trait
  
  // On ouvre une connexion  la bdd
  connexion_mysql();
  select_database();
  
  $last_request = time();
  // On met  jour la date du dernier accs  une page protge
  // le timestamp "last_request" est mis  jour avec l'heure actuelle
  // et le timestamp "fin" est laiss ou remis*  zro (=> utilisateur connect puisque vient de charger une page)
  // * il est remis  zro dans le cas ou l'utilisateur vient de se "rveiller" (il n'avait pas ferm son
  // navigateur, mais tait rest inactif + de 5 minutes, donc son timestamp "fin" peut tre diffrent de zro
  // (utilisateur considr comme dconnect, mais peut-tre simplement inactif)
  $sql = "UPDATE journal_connexions SET last_request='$last_request',fin='0' WHERE id_connexion='".$_SESSION['id_connexion']."'";
  mysql_query($sql);
}
// sinon, on sort du script
?>