<?php
/**
 * fonctions_affichage.php
 *
 * fournit des lments affichs dans le squelette principal des pages (en-tte, pied de page, date du jour
 * logos de ressources utilise pour la cration d'IntraEduWeb, les responsables lgaux du site, les barres
 * de navigation adaptes au contexte, le nombre de messages non lus dans la BAL de l'utilisateur connect,
 * les dernires notes de service...)
 * mais aussi des fonctions de formatage HTML comme les squelettes de formulaires, de liens...
 * 
 * Ce fichier fait partie du projet IntraEduWeb (IEW)
 * 
 * @package		IEW
 * @author			Sylvain GODM <sylvain.godme@gmail.com>
 * @version		$LastChangedRevision$, $LastChangedDate$
 * @copyright		2004-2012 Sylvain GODM
 * @link			http://iew.free.fr
 * @license		GPL License version 3 (http://www.gnu.org/licenses/gpl.html)
 * @filesource
 * 
 */

/////////// Voici d'abord les fonctions utilises pour l'affichage des lments des squelettes de page /////////////////


function affiche_entete(){

global $jeu_couleurs;

?>
<img src="<?php echo $GLOBALS['chemin_relatif']."images/".$jeu_couleurs["logo_en_tete"]?>" id="logo_gauche" alt="" />
<?php
// On affiche un logo (ou une photo) en haut  droite
      if ($GLOBALS['contexte'] == "cahiers_textes")
        echo "<img src='".$GLOBALS['chemin_relatif']."images/logo_cahiers_textes.gif' id='logo_droit' alt='logo cahiers de textes' />";
      elseif (isset($_SESSION['anscol']) && isset($_SESSION['anscol']) !="") // Si on est dans les archives
      {
        echo "<a href='".$GLOBALS['chemin_relatif']."prive/admin/prive/exit_archives.php' title='Sortir des archives'><img src='".$GLOBALS['chemin_relatif']."images/tampon_archives_rouge.png' id='logo_droit' alt='Archives' /></a>";
        $titre_annee_scol = $_SESSION['anscol'];
        echo "<div id='anscol'>$titre_annee_scol</div>";
      }
?>
  
<!-- Affichage du nom de l'tablissement en position absolue -->
<?php
// comme c'est prvu de l'afficher dans un bloc de taille fixe
// il faut s'assurer que le nom de l'tablissement tient en entier dans ce bloc
// avec une rsolution la plus faible de 800 par 600, on peut faire tenir
// 27 caractres avec une taille de 2em
// au del de 27 ccil faut rduire la taille de 0.1 par caractre supplmentaire
// et l, a tient dans le cadre !

$titre_etab = $GLOBALS['nom_etablissement'];

if (strlen($titre_etab)>27)
{
  $nb_cc_supplem = strlen($titre_etab) - 27;
  $nb_em = 2 - 0.025*$nb_cc_supplem;
  echo "<div id='encadrer_en_tete' style='font-size: $nb_em"."em;'>";
}
else
 echo "<div id='encadrer_en_tete'>";
 echo $titre_etab;
 echo "</div>";
}

function affiche_entete_imprimable()
{
	/*
	 * Affiche l'en-tte dans les squelettes au format imprimable
	 */
	// taille correcte de l'en-tte en mode archives
	if (isset($_SESSION['anscol']) && isset($_SESSION['anscol']) !="") // Si on est dans les archives
	{
		$logo_entete = "logo_en_tete";
		$id_entete = "entete";
	}
	else
	{
		$logo_entete = "logo_en_tete_small";
		$id_entete = "entete_small";
	}
	echo "<div id='$id_entete' role='banner'>
		<img src='".$GLOBALS['chemin_relatif']."images/".$GLOBALS['jeu_couleurs'][$logo_entete]."' id='logo_small_gauche' alt='' />
	<!-- Affichage des liens d'vitement -->";
	aff_menu_evitement(); 
	if (strlen($GLOBALS['nom_etablissement'])>27)
	{
  		$nb_cc_supplem = strlen($GLOBALS['nom_etablissement']) - 27;
  		$nb_em = 2 - 0.1*$nb_cc_supplem;
  		echo "<div id='encadrer_en_tete' style='font-size: $nb_em"."em'>";
	}
	else
 		echo "<div id='encadrer_en_tete_small'>";
 	echo $GLOBALS['nom_etablissement'];
 	echo "</div>";
 	if (isset($_SESSION['anscol']) && isset($_SESSION['anscol']) !="") // Si on est dans les archives
 	{
        echo "<a href='".$GLOBALS['chemin_relatif']."prive/admin/prive/exit_archives.php' title='Sortir des archives'><img src='".$GLOBALS['chemin_relatif']."images/tampon_archives_rouge.png' id='logo_droit' alt='Archives' /></a>";
        $titre_annee_scol = $_SESSION['anscol'];
        echo "<div id='anscol'>$titre_annee_scol</div>";
 	}
	echo "</div>"; 
}

function aff_menu_evitement()
{
	/*
	 * Affiche le menu d'vitement pour l'accessibilit
	 */
	echo "<div id='menu_evitement' role='navigation'> 
      <ul>
        <li><a href='".$GLOBALS['racine']."?imprimable=non'>Accueil</a></li>";
	if ($_SESSION['imprimable'] != 'oui') // on affiche le lien d'vitement aller au menu uniquement si le format d'affichage n'est pas imprimable ou pour les pages ayant un menu propre
	{
		if ($_SERVER['PHP_SELF'] == $GLOBALS['racine']."prive/cahiers_textes.php")
			$href="#menu_gauche_ct";
		else
			$href="#nav_horiz_sup";
		echo "<li><a href='$href' title='Aller directement au menu de la page'>Aller au menu</a></li>";
	}
	elseif ($_SERVER['PHP_SELF'] == $GLOBALS['racine']."prive/cahiers_textes.php")
	{
		$href="#menu_gauche_ct";
		echo "<li><a href='$href' title='Aller directement au menu de la page'>Aller au menu</a></li>";
	}
    echo "<li><a href='#contenu_central' title='Aller directement au contenu de la page'>Aller au contenu</a></li>
        <li class='last'><a href='".$GLOBALS['racine']."aide/accessibilite.php' title='Accessibilite du site'>Aide et accessibilit&eacute;</a></li>
      </ul>
	</div>";
}

function aff_piedpage() {
?>
<br /><br />
<hr />
<br />
<div id="message_pp">
  <?php echo stripslashes(preg_replace("#\n#","<br />",$GLOBALS['message_pied_page'])) ?>
  <br /><br/>
	Pour tout renseignement, contacter l'<a href="mailto:<?php echo $GLOBALS['admin_email'] ?>" title="Contacter l'administrateur IntraEduWeb">administrateur du site.</a>
	<br /><br />
</div>
<div class="centrage">
 <div class="encadrer centrage">
    <?php
    echo "<b>".$GLOBALS['nom_etablissement']."</b><br />".$GLOBALS['adresse_etablissement']."<br />".$GLOBALS['cp_etablissement']." ".$GLOBALS['ville_etablissement']."<br />Tl: ".$GLOBALS['tel_etablissement']."<br />
    fax: ".$GLOBALS['fax_etablissement'];
    ?>
  </div>
</div>
<br />
<div id="copyright">
  <?php aff_copyright();?>
  <br /><br />
  Pour un meilleur confort visuel, veuillez utiliser une rsolution d'cran minimale de 1024 x 768 et un navigateur respectant les standards du web, comme <a href="http://www.mozilla.org/fr/firefox/fx/">Firefox</a> par exemple
  <br/>
  <a href="<?php echo $GLOBALS['url_site_intraEduWeb'] ?>" title="Visiter le site officiel IntraEduWeb"><img id='logo_iew_pp' src="<?php echo $GLOBALS['chemin_relatif'] ?>images/petit_logo_intraEduWeb.png" alt="Visiter le site officiel IntraEduWeb" /></a>
  <br />
  <a href="http://validator.w3.org/check?uri=referer" title="Vrifier la validit XHTML 1.0"><img class='logo_validator' src="<?php echo $GLOBALS['chemin_relatif'] ?>images/valid-xhtml10.png" alt="Vrifier la validit XHTML 1.0" height="31" width="88" /></a>
  <a href="http://jigsaw.w3.org/css-validator/" title="Vrifier la validit CSS"><img class='logo_validator' src="<?php echo $GLOBALS['chemin_relatif'] ?>images/valid-css2.png" alt="Vrifier la validit CSS" height="31" width="88" /></a>
  <br /><br />
</div>
<?php
}

function aff_copyright()
{
	/*
	 * Affiche les informations de copyright en pied de page + lien vers la licence et la charte utilisateur
	 */
	echo $GLOBALS['copyright']."
  	<br /><br/>
  	<p>IntraEduWeb est livr absolument SANS AUCUNE GARANTIE; Il s'agit d'un logiciel libre, et vous avez le droit de le redistribuer sous certaines conditions;<br />Pour plus de dtails, consulter <a href='/iew/copyright-fr.php'>la licence et les conditions d'utilisation</a><br />Consulter aussi 
  	<a href='/iew/";
	if (isset($_SESSION['valid_group']) && $_SESSION['valid_group'] == "2")
  		$texte_charte = "charte_eleves.html";
	else
  		$texte_charte = "charte_droits.html";
	echo $texte_charte."'>la Charte utilisateur IntraEduWeb</a>
	</p>";
}

function affiche_barre_navigation_horizontale_sup(){
?>
<ul class="menu">
      <li><a href="<?php echo $GLOBALS['racine'] ?>prive/absences.php" title="Signaler ou consulter les absences">Absences</a></li>
      <li><a href="<?php echo $GLOBALS['racine'] ?>prive/cahiers_textes.php" title="Remplir ou consulter le cahier de textes">Cahier de textes</a></li>
      <li><a href="<?php echo $GLOBALS['racine'] ?>docs/index.php" title="Accder  la documentation de l'application IntraEduWeb">Documentation</a></li>
      <li><a href="<?php echo $GLOBALS['url_site_etablissement'] ?>" title="Visiter le site internet de l'tablissement">Site internet</a></li>
      <?php 
      if (isset($_SESSION['valid_id_user']))
      {
      	echo "<li class='connected'><a href='".$GLOBALS['racine']."deconnexion.php' title='Se dconnecter'>Connect</a></li>";
      }
      else
      {
      	echo "<li class='not_connected'><a href=''></a>Dconnect</li>";
      }
      ?>
</ul>
<?php
}

function affiche_barre_navigation_horizontale_inf(){
  ?>
    <div id="nav_horiz_inf" class="centrage" role="navigation">
      <a href="<?php echo $GLOBALS['racine'] ?>index.php">Accueil</a>&nbsp;|
      <a href="<?php echo $GLOBALS['racine'] ?>prive/absences.php">Gestion des Absences</a>&nbsp;|
      <a href="<?php echo $GLOBALS['racine'] ?>prive/cahiers_textes.php">Cahiers de textes</a>&nbsp;|
      <a href="<?php echo $GLOBALS['racine'] ?>docs/index.php">Documentation</a>&nbsp;|
      <a href="<?php echo $GLOBALS['url_site_etablissement'] ?>" title="Visiter le site internet de l'tablissement">Site internet</a>
	  </div>
	<?php
}

function affiche_contenu()
{

	global $error_message;
	echo "
      <div id='connect'>
      ";
      if (isset($_SESSION['valid_login']))
      {
        echo "<a href='".$GLOBALS['racine']."deconnexion.php'>Se dconnecter (utilisateur : ".$_SESSION['valid_login'].")</a>";
        // Si une connexion est en cours, on enregistre les variables du tableau $_POST s'il est dfini, dans une variable de session. C'est le seul moyen que j'ai trouv pour l'instant pour transmettre des variables POST vers le format imprimable des pages. A charge pour le script de tester suivant l'existence de $_GET[imprimable'] ce qu'il doit faire c'est--dire prendre directement les valeurs de $_POST ou celles de $_SESSION['post_imprimable']
        if (count($_POST)!=0)
          $_SESSION['post_imprimable'] = $_POST;
        elseif (isset($_SESSION['post_imprimable']))
          $_POST = $_SESSION['post_imprimable'];
      }
      elseif ($_SERVER['PHP_SELF']!=$GLOBALS['racine']."index.php")
        echo "<a href='".$GLOBALS['racine']."index.php'>Se connecter</a>";
      echo "
      </div>
      ";
      // Affichage du lien "Format imprimable" ou "retour au format normal"
      // sauf sur la page d'index ou alors si la page d'index est dj au format imprimable
      if ($_SERVER['PHP_SELF']!=$GLOBALS['racine']."index.php" || ($_SERVER['PHP_SELF'] == $GLOBALS['racine']."index.php" && (isset($_SESSION['imprimable']) && $_SESSION['imprimable'] == "oui")))
      {	
      	if ((isset($_GET['imprimable']) && $_GET['imprimable'] == "oui") || (isset($_SESSION['imprimable']) && $_SESSION['imprimable'] == "oui"))
      	{
      		// Cas particulier des edt qui ne doivent pas s'afficher au format normal car les plannings dbordent du conteneur, idem pour la liste des utilisateurs connect et les cahiers de textes
      		if ($_SERVER['PHP_SELF'] == $GLOBALS['racine']."prive/edt.php" || $_SERVER['PHP_SELF'] == $GLOBALS['racine']."prive/admintraeduweb/users_inline.php" || $_SERVER['PHP_SELF'] == $GLOBALS['racine']."prive/cahiers_textes.php" || $_SERVER['PHP_SELF'] == $GLOBALS['racine']."prive/synthese_ctextes.php")
      		{
      			echo "<div id='main-nav-right'>";
      			if ($_SESSION['valid_group'] == "3")
      				echo "<a href='".$GLOBALS['racine']."prive/absences.php?imprimable=non'><img src='".$GLOBALS['chemin_relatif']."images/missing.png' alt=\"Retour aux absences\" title=\"Retour au signalement des absences\" /></a>";
      			echo "<a href='".$GLOBALS['racine']."index.php?imprimable=non'><img src='".$GLOBALS['chemin_relatif']."images/home.png' id='home_icon' alt=\"Retour  l'accueil\" title=\"Retour  l'accueil\" /></a></div>";
      		}
      		elseif (!isset($_GET['noreturn'])) // Pas de lien [Retour au format imprimable si le paramtre noreturn est dans l'url
  				echo "<div id='main-nav-right'><a href='?imprimable=non".recup_get_url($_GET)."'><img src='".$GLOBALS['chemin_relatif']."images/noprint.png' alt='[Sortie du format imprimable]' title='Sortir du format imprimable' /></a></div>";	
      	}
      	else
      	{
      		echo "<div id='print'>
      		<a href='?imprimable=oui".recup_get_url($_GET)."' title='Format Imprimable, contenu principal de la page seulement'><img src='".$GLOBALS['chemin_relatif']."images/print.png' alt='Format Imprimable, contenu principal de la page seulement' title='Format Imprimable, contenu principal de la page seulement' /></a>
      		</div>
      		";
      	}
      }
      echo "<div class='spacer'>&nbsp;</div>
      ";
      // Javascript doit tre activ ! Ceci fait partie du code source de la page mais ne sera affich que si le javascript est dsactiv dans le navigateur
      echo "<noscript>
      ";
      $code_formulaire = "
      <p>
      <br />
      Votre navigateur a dsactiv l'xcution de code JavaScript.
      <b>Vous ne pouvez pas</b> utiliser IntraEduWeb sans problme tant que vous ne paramtrerez pas votre navigateur pour que le JavaScript soit activ. 
      Veuillez autoriser cette excution et puis <a href=''>rechargez</a> cette page.
      <br /><br />
      </p>
      ";
      squelette_formulaire_standard("75%","","","Activez Javascript !",$code_formulaire,"","","","","","","");
      echo "</noscript>";
      // Le navigateur doit accepter les cookies !
      echo "<script type='text/javascript'>
        <!-- 
        if ( window.navigator.cookieEnabled==false )
        {
          document.write( \"<br /><div class='encadrer'><font color='red'><b>Votre navigateur n'accepte pas les cookies ! Vous ne pourrez pas utiliser correctement IntraEduWeb si vous n'autorisez pas les cookies. Faites-le et rechargez cette page...</b></font></div>\" );
        }
        //-->
      </script>
      ";
      if (isset($GLOBALS['error_message']) && $GLOBALS['error_message'][0]!="") // S'il y a un message d'erreur, on l'affiche
      {
        // pour viter l'affichage d'un message d'erreur sur une tentative de connexion sur LDAP
        // et l'affichage du formulaire de login alors que l'utilisateur a finalement t authentifi localement
      	if ($GLOBALS['error_message'][1] == "login" && isset($_SESSION['valid_id_user']) && $_SESSION['valid_id_user'] != "")
        {
        	if (file_exists($GLOBALS['nomfichier'])) include($GLOBALS['nomfichier']); // SECURITE : attention  la faille include()
        }
        else // dans le cas contraire (authentification rate sur LDAP + localement) ou bien tout autre message d'erreur en dehors de l'authentification, on affiche le message
        {
        	echo "<p></p>";
        	affiche_erreurs($GLOBALS['error_message']);	
        }
      }
      else // Si pas de message d'erreur, on affiche le contenu de la page
      {
      	if (file_exists($GLOBALS['nomfichier'])) 
      	{
      		if (!isset($_SESSION['valid_id_user']) && isset($_GET['log']) && $_GET['log'] == "locale") // C'est une connexion d'un utilisateur local
      		{
      			affiche_formulaire_login(); // formulaire d'identification locale
      			return; // on affiche pas la suite
      		}
      		include($GLOBALS['nomfichier']); // SECURITE : attention  la faille include()
      	}
      }
}

function affiche_menu_droite()
{
  ?>
  <div id="titre_menu_droit" class="titre_menu_droit">Infos et liens</div>
      <div id="lien_messagerie_menu_droit" class="sous_titre_menu_droit">
      	<?php
              if (isset($_SESSION['valid_login']))
                echo "<a href='".lien_messagerie()."'>Votre messagerie</a>&nbsp;
              <img src='".$GLOBALS['chemin_relatif']."images/mini_enveloppe.png' alt='' />";
              else
                echo "Votre messagerie&nbsp;<img src='".$GLOBALS['chemin_relatif']."images/mini_enveloppe.png' alt='' />";
              ?>
      </div>
      	<?php
                if (isset($_SESSION['valid_login']))
                {
                  // Code  mettre pour indiquer le nb de messages dans la mailbox
                }
                else
                {
                  echo "<ul>
      						<li>
      							<i>Non disponible hors connexion</i>
      						</li>
      					</ul>";
                }
              ?>
      <div id="lien_notes_de_services_menu_droit" class="sous_titre_menu_droit">
      	<?php 
      			if (isset($_SESSION['valid_login']))
                {
                	echo "<img src='".$GLOBALS['chemin_relatif']."images/pixel.gif' width='20' alt= ''/><a href='".$GLOBALS['chemin_relatif']."consult_not.php' title='Consulter les notes de Service'>Notes de service</a>";
                    //affiche_intro_notes_service(5,$GLOBALS['categorie_utilisateur']);
                }
                else 
                echo "Notes de service";
         ?>
        <img src="<?php echo $GLOBALS['chemin_relatif'] ?>images/kwrite.png" width="32" height="32" style="margin-left:7px;" alt="" />
      </div>
      
      <div id="logos_marge_droite" class="logos_marge_droite">
      <?php
      	affiche_logos_marge_droite();
      ?>
      </div><?php
}

function affiche_logos_marge_gauche(){
?>
  <br />
  Ce site est ralis grce aux ressources libres :
  <br /><br />
  <a href="http://www.php.net" title="Visiter le site officiel PHP"><img src="<?php echo $GLOBALS['chemin_relatif'] ?>images/php_logo.gif" alt="Visiter le site officiel PHP" /></a>
  <br /><br />
  <a href="http://www.mysql.fr" title="Visiter le site officiel MySQL"><img src="<?php echo $GLOBALS['chemin_relatif'] ?>images/mysql.png" alt="Visiter le site officiel MySQL" /></a>
  <br /><br />
<?php
};



function affiche_logos_marge_droite(){
?>
  <br />
  <a href="http://www.educasource.education.fr/" title="Accs aux ressources pdagogiques ducasource"><img src="<?php echo $GLOBALS['chemin_relatif'] ?>images/logo_educasources.png" alt="Accder aux Ressources pdagogiques ducasource" /><br /></a><br /><br />
  <a href="http://eduscol.education.fr/" title="Site des professionnels de l'ducation"><img src="<?php echo $GLOBALS['chemin_relatif'] ?>images/logo_eduscol.png" alt="Visiter le site duSCOL" /><br /></a><br /><br />
  <a href="http://www.framasoft.net" title="Annuaire de Logiciels libres et gratuits"><img src="<?php echo $GLOBALS['chemin_relatif'] ?>images/framasoft.jpg" alt="Visiter le site Framasoft" /><br /></a><br /><br />
  <a href="http://www.cndp.fr/sialle/" title="Service d'Information et d'Analyse des Logiciels Libres ducatifs"><img src="<?php echo $GLOBALS['chemin_relatif'] ?>images/logo_sialle.png" alt="Visiter le site d'Analyse des Logiciels Libres ducatifs" /></a><br /><br />
  <a href="http://www.internetsanscrainte.fr/" title="Programme National de sensibilisation des jeunes aux bons usages de l'internet"><img src="<?php echo $GLOBALS['chemin_relatif'] ?>images/internetsanscrainte.jpg" alt="Visiter le site Internet sans crainte" /><br /></a><br /><br />
  <a href="http://www.delegation.internet.gouv.fr/index.htm" title="Dlgation aux usages de l'internet"><img src="<?php echo $GLOBALS['chemin_relatif'] ?>images/logoDele_internet.gif" alt="Visiter le site de la Dlgation aux usages de l'internet" /><br /></a><br /><br />
<?php
};



function affiche_responsables(){
// Cette fonction assure l'affichage des responsables du site. 
?>
<div class="encadrer">
<?php
  echo "
  <div class='encadrer_titre'>Directeur de publication</div>
  <a href=\"mailto:".$GLOBALS['email_directeur_publication']."\" title='crire au Directeur de publication ".$GLOBALS['nom_directeur_publication']."'>".$GLOBALS['nom_directeur_publication']."</a>
  <br /><br />
  ";
  echo "<div class='encadrer_titre'>Responsable(s) de rdaction</div>";
  echo "
  <a href='mailto:".$GLOBALS['admin_email']."' title='crire au Responsable de publication et administrateur IntraEduweb ".$GLOBALS['admin_name']."'>".$GLOBALS['admin_name']."</a>
  <br /><br />";
  echo "
  <div class='encadrer_titre'>Dveloppeur IntraEduWeb</div>
  <a href='mailto:".$GLOBALS['email_developpeur_iew']."' title='crire au Dveloppeur IntraEduweb ".$GLOBALS['nom_developpeur_iew']."'>".$GLOBALS['nom_developpeur_iew']."</a>
  <br /><br />";
  echo "
  <div class='encadrer_titre'>".$GLOBALS['nom_etablissement']."</div>
  ".$GLOBALS['adresse_etablissement']."
  <br />".$GLOBALS['cp_etablissement']." ".$GLOBALS['ville_etablissement']."
  <br />Tl: ".$GLOBALS['tel_etablissement']."
  <br />fax: ".$GLOBALS['fax_etablissement']."
  <br />Email: <a href='mailto:".$GLOBALS['email_etablissement']."' title='crire au ".$GLOBALS['nom_etablissement']."'>".$GLOBALS['email_etablissement']."</a>";
?>

</div>
<br />
<?php
};

function affiche_menu_principal()
{
 	// d'abord la partie du menu dpendant du contexte 
        switch ($GLOBALS['contexte'])
        {
          case "absences": // on affiche si ncessaire le sommaire li au contexte absences
            if (file_exists($GLOBALS['chemin_relatif'].$GLOBALS['repertoire_navigation']."somabsences.php"))
            {
              include($GLOBALS['chemin_relatif'].$GLOBALS['repertoire_navigation']."somabsences.php");
              affiche_sommaire($rubriques_somabsences);
            }
            break;
          // autre cas:
          case "cahiers_textes": // on affiche si ncessaire le sommaire li au contexte cahier de textes
            include($GLOBALS['chemin_relatif'].$GLOBALS['repertoire_navigation']."somcahiers_textes.php");
            affiche_sommaire_cahiers_textes();
            break;
          default:   
        }
        // puis la partie dpendant des droits de l'utilisateur connect 
        if (isset($_SESSION['valid_group'])) // Si l'utilisateur est logu on switche sur la valeur de son groupe
        {
        	if ($_SESSION['valid_group'] != 1)
        	{
        		//  inclure au dbut, le sommaire donnant le lien vers les donnes perso, dans tous les cas (sauf pour admin-iew)
        		$inclure_sommaire = $GLOBALS['chemin_relatif'].$GLOBALS['repertoire_navigation']."somuser.php";
            	if (file_exists($inclure_sommaire))
            	{
              		include($inclure_sommaire); // Sommaire affich dans tous les cas
              		affiche_sommaire($rubriques_somuser);
            	}
        	}
        	switch ($_SESSION['valid_group'])
        	{ // voir le fichier intraeduweb.sql et la table groupes_utilisateurs pour la liste des groupes installs par dfaut
          		
        		case 1: // c'est le groupe administrateur du site IntraEduWeb, voir la table groupes_utilisateurs pour retrouver tous les identifiants des groupes par dfaut
            		echo "<div class='titre_menu_gauche'>Sommaire Admin</div>"; 
        			$a_inclure = $GLOBALS['chemin_relatif'].$GLOBALS['repertoire_navigation']."somadmintraeduweb.php";
            		if (file_exists($a_inclure))
            		{
              			include($a_inclure);
              			affiche_sommaire($rubriques_somadmintraeduweb);
              			echo "<div class='titre_menu_gauche'>Sommaire Gestadmin</div>";
            		}
            		$a_inclure = $GLOBALS['chemin_relatif'].$GLOBALS['repertoire_navigation']."somgestadmin.php";
            		if (file_exists($a_inclure))
            		{
	              		include($a_inclure);
              			affiche_sommaire($rubriques_somgestadmin);
            		}
	            	break;
	            	
          		case 4:
        			$a_inclure = $GLOBALS['chemin_relatif'].$GLOBALS['repertoire_navigation']."somparent.php";
            		if (file_exists($a_inclure))
            		{
              			include($a_inclure);
              			affiche_sommaire($rubriques_somparent);
            		}
        			echo "<div class='titre_menu_gauche'>Sommaire Gnral</div>"; 
        			$inclure_sommaire = $GLOBALS['chemin_relatif'].$GLOBALS['repertoire_navigation']."sommaire.php";
            		if (file_exists($inclure_sommaire))
            		{
              			include($inclure_sommaire); // Sommaire affich dans tous les cas
              			affiche_sommaire($rubriques_sommaire);
            		}
          			break;
          			
          		case 5: // c'est le groupe pour la gestion administrative du contenu de l'intranet
            		echo "<div class='titre_menu_gauche'>Sommaire Gestadmin</div>";
          			$a_inclure = $GLOBALS['chemin_relatif'].$GLOBALS['repertoire_navigation']."somgestadmin.php";
            		if (file_exists($a_inclure))
            		{
              			include($a_inclure);
              			affiche_sommaire($rubriques_somgestadmin);
            		}
            		break;
            		
          		default: // rien par dfaut car le sommaire par dfaut est affich dans tous les cas voir ci-dessous
        			echo "<div class='titre_menu_gauche'>Sommaire Gnral</div>"; 
        			$inclure_sommaire = $GLOBALS['chemin_relatif'].$GLOBALS['repertoire_navigation']."sommaire.php";
            		if (file_exists($inclure_sommaire))
            		{
              			include($inclure_sommaire); // Sommaire affich dans tous les cas
              			affiche_sommaire($rubriques_sommaire);
            		}
        	} // fin du switch
        	
        }
        else // Utilisateur non logu, sommaire par dfaut
        {
        	echo "<div class='titre_menu_gauche'>Sommaire Gnral</div>"; 
        	$inclure_sommaire = $GLOBALS['chemin_relatif'].$GLOBALS['repertoire_navigation']."sommaire.php";
            if (file_exists($inclure_sommaire))
            {
              include($inclure_sommaire); // Sommaire affich dans tous les cas
              affiche_sommaire($rubriques_sommaire);
            }
        }
}

function affiche_mention_cnil()
{
  
  if ($_SESSION['valid_group'] == "4")
    $script_donnees_perso = "prive/donnees_parent.php";
  else
    $script_donnees_perso = "prive/donnees_perso.php";
  echo "
  <hr /><div id='mentions_cnil'>
  Ce site respecte les recommandations de la <a href='http://www.cnil.fr' title=\"Commission Nationale de l'Informatique et des Liberts\"><abbr title=\"Commission Nationale de l'Informatique et des Liberts\">CNIL</abbr></a> : Vous disposez, conformment  l'article 34 de la loi \"Informatique et Liberts\" du 6 janvier 1978, d'un droit d'accs et de rectification <a href='".$GLOBALS['racine']."$script_donnees_perso' title='Accdez  vos donnes personnelles'>des donnes qui vous concernent</a>. Pour exercer ce droit, veuillez contacter votre <a href='mailto:".email_encode($GLOBALS['admin_email'])."'>administrateur IntraEduWeb</a>.
  <br /><br /><p>Le traitement des donnes personnelles dans le cadre d'un <abbr title='Espace Numrique de Travail'>ENT</abbr> est l'objet d'une rglementation dfinie par un <a href='http://www.legifrance.gouv.fr/WAspad/UnTexteDeJorf?numjo=MENT0602397A' title=\"arrt du Ministre de l'ducation Nationale rglementant les Espaces Numriques de Travail\">arrt du Ministre de l'ducation Nationale</a>. Un engagement de conformit  cet arrt a t envoy  la CNIL par le Chef d'tablissement avant la mise en oeuvre effective de l'ENT.</p>
  </div>";
}

function affiche_version_environnement()
{
  global $security_warning;
  $code_formulaire = "
    <h3>Vrification de versions</h3>
    <p>Serveur web et Plate-forme: <strong>".apache_get_version()."</strong></p>
    <p>Protocole : ";
    if (empty($_SERVER['HTTPS']))
    {
      $code_formulaire .="<strong>HTTP</strong><span class='wrong'> non scuris !</span></p>";
      $security_warning = true;
    }
    else
      $code_formulaire .="<strong>HTTP</strong><span class='ok'> scuris (OK)</span></p>";
    $code_formulaire .="
    <p>PHP : Version <strong>".phpversion()."</strong> ";
    if (version_compare(phpversion(), "5.1.0", ">="))
    {
      // La version php installe est correcte (>=5.1.0)
      $code_formulaire .= "<span class='ok'>OK</span> (&gt;=5.1.0)</p>";
    }
    else
    {
      $code_formulaire .= "<span class='wrong'>Infrieure  celle requise !</span> (&gt;=5.1.0)</p>";
    } 
    // Serveur MySQL : version 4.1.0 mini (apparition des fonctions AES_ENCRYPT() et AES_DECRYPT() en version 4.0.2, 
    // et  partir de la 4.1, la prcision de format TIMESTAMP ne ncessite plus un nombre entre () prcisant le format voulu pour le timestamp.)
    $version_mysql = @mysql_get_server_info();
    $code_formulaire .="
    <p>Serveur MySQL : Version <strong>".$version_mysql."</strong> ";
    $fragment_mysql_version = explode(".",$version_mysql);
    if (count($fragment_mysql_version) > 1)
    {
      $major_mysql_version = intval($fragment_mysql_version[0]);
      $minor_mysql_version = intval($fragment_mysql_version[1]);
      $micro_mysql_version = intval($fragment_mysql_version[2]);
      if ($major_mysql_version >= 4) // Version majeure OK
      {
        if ($minor_mysql_version == 1) // Version mineure 0 possible mais version micro doit tre 2
        {  
          if ($micro_mysql_version >= 0)
            // La version du serveur MySQL est correcte (>=4.1.0)
            $code_formulaire .= "<span class='ok'>OK</span> (&gt;=4.1.0)</p>";
          else // c'est pas bon
            $code_formulaire .= "<span class='wrong'>Infrieure  celle requise !</span> (&gt;=4.1.0)</p>";
        }
        else // Version mineure suprieure  0 => c'est toujours bon
          $code_formulaire .= "<span class='ok'>OK</span> (&gt;=4.1.0)</p>";
      }
      else // La version majeure est trop ancienne
      {
        $code_formulaire .= "<span class='wrong'><strong>Infrieure  celle requise !</span> (&gt;=4.1.0)</p>";
      }
    }
    else
    {
      $code_formulaire .= "<span class='wrong'>Information non disponible !</span><br />(Pas de connexion possible en anonyme avec le serveur)</p>";
    }
  return $code_formulaire;
}

function protection_image()
{
  // Cette fonction est excute sur chaque page o est visible une photo d'identit
  // Le clic droit est bloqu, mais ce n'est pas vraiment une protection => L'utilisateur est prvenu des
  // consquences d'un ventuel dtournement des images
  echo "
  <script type='text/javascript'>
    function nodroit()
    {
      alert('Le clic droit sur les pages contenant des photos d\'identit est dsactiv !\\nIl est rappel que si leur publication dans IEW a t autorise, ceci ne permet pas pour autant  l\'utilisateur qui les consulte d\'en faire usage en dehors du cadre de la simple consultation du trombinoscope dans l\'application.\\n".strtoupper("Tout autre utilisation est strictement interdite et peut donner lieu  des poursuites judiciaires !")."');
      return(false);
    }
    document.oncontextmenu= nodroit;
  </script>";
}

function affiche_intro_notes_service($nombre,$categorie_utilisateur)
{
// Cette fontion permet l'affichage de l"introduction des $nombre dernires notes de service en fonction du public concern

}

//////////// Voici les fonctions de formatage d'images, des messages d'erreurs, de liens, de formulaires..... //////////////

// Fonctions d'affichage et de traitement des images 

function affiche_fotoprof($prenom,$nom,$id_pers)
{
 // On recherche la civilit de la personne pour affichage dans l'attribut alt
 $sql = "SELECT civilite FROM personnel WHERE id_pers='".quote_smart($id_pers)."'";
 // DEBUGG print $sql."<br />";
 $resultat = mysql_query($sql);
 if ($resultat && mysql_num_rows($resultat)>0)
 {
    $ligne = mysql_fetch_array($resultat);
    $civilite = $ligne['civilite'];
 }
 $code_html = "";
 $prenom = ucfirst(strtolower($prenom)); // On formate le prnom car il est parfois tout en majuscule dans la base de donnes
 $image = $GLOBALS['stock_baselev']."fotoprof/".$id_pers.".jpg"; // a priori la photo de la personne
 // Si la photo prcdente n'existe pas, elle sera remplace par une photo par dfaut
 if (isset($_GET['imprimable']) && $_GET['imprimable']=="oui")
  $defaut = $GLOBALS['stock_baselev']."fotoprof/blanc.jpg"; // dans le format imprimable la photo par dfaut sera un blanc (pour conomiser l'encre)
 else // dans le format normal
  $defaut = $GLOBALS['stock_baselev']."fotoprof/defaut.jpg"; // On affiche la photo par dfaut
 // Le prnom ne doit pas tre visible des lves et des parents dans l'attribut title utilis + bas
  if ($_SESSION['valid_group'] == "2" || $_SESSION['valid_group'] == "4")
  	$title = $civilite." ".$nom;
  else 
  	$title = $civilite." ".$prenom." ".$nom;
 if (file_exists($image)) // La photo est disponible (elle existe)
 {
  // Mais elle n'est pas forcment affichable pour l'utilisateur en cours
  if ($_SESSION['valid_id_user'] != $id_pers) // Si l'utilisateur en cours n'est pas la personne reprsente sur la photo
  {
    $image = $GLOBALS['stock_baselev']."fotoprof/".verif_autorisation_publication_foto("prof",$id_pers);
  }
  if (isset($_SESSION['valid_id_user']) && ($_SESSION['valid_id_user'] == $id_pers || $_SESSION['valid_group'] == "1" || $_SESSION['valid_group'] == "5")) // si l'id de la personne connecte correspond  la photo affiche (ou fait partie du groupe admin ou gestadmin), cette photo est cliquable pour permettre  l'utilisateur de mettre  jour sa propre photographie
    $code_html = "<a href='javascript://'><img id='$id_pers' title=\"$title\" class='trombi' src='".$GLOBALS['chemin_relatif']."resize_image.php?image=$image' onclick=\" window.open('".$GLOBALS['chemin_relatif']."prive/admin/prive/maj_trombin_personnel.php?id_pers=$id_pers','Mise_a_jour_photo','toolbar=no,location=no,directories=no,menuBar=no,scrollbars=no,resizable=no,status=no,width=500,height=400')\" title=\"Mettre  jour la photo de $prenom $nom\" alt=\"photo de $prenom $nom\" /></a><br />";
  else
    $code_html = "<img id='$id_pers' title=\"$title\" class='trombi' src='".$GLOBALS['chemin_relatif']."resize_image.php?image=$image' alt=\"photo de $civilite $nom\" /><br />";
 }
 else
 {
  if (isset($_SESSION['valid_id_user']) && ($_SESSION['valid_id_user'] == $id_pers || $_SESSION['valid_group'] == "1" || $_SESSION['valid_group'] == "5")) // si l'id de la personne connecte correspond  la photo affiche (ou fait partie du groupe admin ou gestadmin), cette photo est cliquable pour permettre  l'utilisateur de mettre  jour sa propre photographie
    $code_html = "<a href='javascript://'><img id='$id_pers' title=\"$title\" class='trombi' src='".$GLOBALS['chemin_relatif']."resize_image.php?image=$defaut' onclick=\" window.open('".$GLOBALS['chemin_relatif']."prive/admin/prive/maj_trombin_personnel.php?id_pers=$id_pers','Mise_a_jour_photo','toolbar=no,location=no,directories=no,menuBar=no,scrollbars=no,resizable=no,status=no,width=500,height=400')\" title=\"Mettre  jour la photo de $prenom $nom\" alt=\"photo de $prenom $nom\" /></a><br />";
  else
    $code_html = "<img id='$id_pers' title=\"$title\" class='trombi' src='".$GLOBALS['chemin_relatif']."resize_image.php?image=$defaut' alt=\"photo de $civilite $nom\" /><br />";    
 }
 return $code_html;
}

function affiche_fotoelev($id_eleve,$max_width="95",$max_height="135")
{
 // On recherche l'eleve_id  partir de l'id_eleve car c'est cet identifiant qui est utilis dans la table autorisations_1
 $sql = "SELECT eleve_id,nom,prenom,classe FROM eleves WHERE id_eleve='".quote_smart($id_eleve)."'";
 // DEBUGG print $sql."<br />";
 $resultat = mysql_query($sql);
 if ($resultat && mysql_num_rows($resultat)>0)
 {
    $ligne = mysql_fetch_array($resultat);
    $eleve_id = $ligne['eleve_id'];
    $nom = $ligne['nom'];
    $prenom = $ligne['prenom'];
    $classe = $ligne['classe'];
 }
 $code_html = "";
 global $racine;
 $image = $GLOBALS['stock_baselev']."fotoelev/".$id_eleve.".jpg"; // a priori la photo de l'lve
 $unauthorized = $GLOBALS['stock_baselev']."fotoelev/opposition_parentale.jpg"; // photo de remplacement si le reprsentant lgal a refus la publication
 // Si la photo prcdente n'existe pas, elle sera remplace par une photo par dfaut
 if (isset($_GET['imprimable']) && $_GET['imprimable']=="oui")
  $defaut = $GLOBALS['stock_baselev']."fotoelev/blanc.jpg"; // dans le format imprimable la photo par dfaut sera un blanc (pour conomiser l'encre)
 else // dans le format normal
  $defaut = $GLOBALS['stock_baselev']."fotoelev/defaut.jpg"; // On affiche la photo par dfaut
 if (file_exists($image)) // La photo est disponible (elle existe)
 {    
    // On vrifie s'il y a autorisation parentale
    $autorisation = "";
    $sql = "SELECT pub_intranet FROM autorisations_1 WHERE eleve_id='$eleve_id'";
    $resultat = mysql_query($sql);
    if ($resultat && mysql_num_rows($resultat)>0)
    {  
      $ligne = mysql_fetch_array($resultat);
      $autorisation = $ligne['pub_intranet'];
    }
    if ($autorisation == "1") // autorisation accorde
    //if ($autorisation != "1") // SEULEMENT A LA PRE-RENTREE POUR PERMETTRE L'IMPRESSION ET LA SAISIE DU TROMBINOSCOPE, ensuite commenter la ligne !!
    {
      if (isset ($_SESSION['valid_group']) && ($_SESSION['valid_group'] == "1" || $_SESSION['valid_group'] == "8") || $_SESSION['valid_group'] == "5" || $_SESSION['valid_group'] == "4")  // photo cliquable (cas pour le groupe surveillance -vie scolaire- charg de la maj du trombinoscope lves, ou du groupe admin ou gestadmin)
        $code_html = "<a href='javascript://'><img id='$id_eleve' title=\"$prenom $nom ($classe)\" class='trombi' src='".$GLOBALS['chemin_relatif']."resize_image.php?image=$image&amp;max_width=$max_width&amp;max_height=$max_height' onclick=\" window.open('".$GLOBALS['chemin_relatif']."prive/admin/prive/maj_trombinelev.php?id_eleve=$id_eleve','Mise_a_jour_photo','toolbar=no,location=no,directories=no,menuBar=no,scrollbars=no,resizable=no,status=no,width=500,height=380')\" title=\"Mettre  jour la photo de $prenom $nom\" alt=\"photo de l'lve $prenom $nom\" /></a><br />";
      else // photo non cliquable
        $code_html = "<img id='$id_eleve' title=\"$prenom $nom ($classe)\" class='trombi' src='".$GLOBALS['chemin_relatif']."resize_image.php?image=$image&amp;max_width=$max_width&amp;max_height=$max_height' alt=\"photo de l'lve $prenom $nom\" /><br />";
    }
    else // cas de refus parental, on met une photo par dfaut non cliquable
    {
      $code_html = "<img id='$id_eleve' title=\"$prenom $nom ($classe)\" class='trombi' src='".$GLOBALS['chemin_relatif']."resize_image.php?image=$unauthorized&amp;max_width=$max_width&amp;max_height=$max_height' alt=\"photo de l'lve $prenom $nom\" /><br />";
    }
 }
 else // Si la photo n'existe pas on met la photo par dfaut
 {
  if (isset ($_SESSION['valid_group']) && ($_SESSION['valid_group'] == "1" || $_SESSION['valid_group'] == "8") || $_SESSION['valid_group'] == "5" || $_SESSION['valid_group'] == "4")  // photo cliquable (cas pour le groupe surveillance -vie scolaire- charg de la maj du trombinoscope lves, ou du groupe admin ou gestadmin)
    $code_html = "<a href='javascript://'><img id='$id_eleve' title=\"$prenom $nom ($classe)\" class='trombi' src='".$GLOBALS['chemin_relatif']."resize_image.php?image=$defaut&amp;max_width=$max_width&amp;max_height=$max_height' onclick=\" window.open('".$GLOBALS['chemin_relatif']."prive/admin/prive/maj_trombinelev.php?id_eleve=$id_eleve','Mise_a_jour_photo','toolbar=no,location=no,directories=no,menuBar=no,scrollbars=no,resizable=no,status=no,width=500,height=380')\" title=\"Mettre  jour la photo de $prenom $nom\" alt=\"photo de l'lve $prenom $nom\" /></a><br />";
  else // photo non cliquable
    $code_html = "<img id='$id_eleve' title=\"$prenom $nom ($classe)\" class='trombi' src='".$GLOBALS['chemin_relatif']."resize_image.php?image=$defaut&amp;max_width=$max_width&amp;max_height=$max_height'  alt=\"photo de l'lve $prenom $nom\" /><br />";
 }
 return $code_html;
}

function affiche_bouton_precedent_ou_premier($tableau,$indice,$cible_lien,$alt)
// Permet d'afficher les boutons graphiques de retour rapide et les liens associs
// Ceci facilite la navigation pour afficher des pages successives
{
  $cles = array_keys($tableau); // Les cls de $tableau ne sont pas des entiers conscutifs : on les rcupre dans un aute tableau ($cles)
  $la_cle_indice = array_search($indice,$cles); // On cherche dans ce tableau la cl correspondant (dans $cles)  l'indice fourni en paramtre
  //print_r($cles);echo "la cle indice : $la_cle_indice<br />";
  $prev = $la_cle_indice-1; // Cette cl (de $cles) permettra de trouver l'indice prcdent dans $tableau
  // On teste si la cls $prev existe bien dans $cles
  if (!array_key_exists($prev,$cles)) // elle n'existe pas
    $prev = $la_cle_indice+1; // on incrmente la cl car elle n'existe pas ($la_cle_indice tait donc la premire cl)
  else // elle existe, on affiche le bouton permettant de l'atteindre
    $lien_nav_prec = "<a href='".$cible_lien.$cles[0]."'><img src='".$GLOBALS['chemin_relatif']."images/prec_rapid.gif' alt='Premier(e) $alt' title='Premier(e) $alt' width='33' height='23' /></a>
          <a href='".$cible_lien.$cles[$prev]."'><img src='".$GLOBALS['chemin_relatif']."images/prec.gif' alt='$alt prcdent(e)' title='$alt prcdent(e)' width='23' height='23' /></a>";
  if (isset($lien_nav_prec))
    return $lien_nav_prec;          
}

function affiche_bouton_suivant_ou_dernier($tableau,$indice,$cible_lien,$alt)
// Permet d'afficher les boutons graphiques de retour rapide et les liens associs
// Ceci facilite la navigation pour afficher des pages successives
{
  $cles = array_keys($tableau); // Les cls de $tableau ne sont pas des entiers conscutifs : on les rcupre dans un aute tableau ($cles)
  $la_cle_indice = array_search($indice,$cles); // On cherche dans ce tableau la cl correspondant (dans $cles)  l'indice fourni en paramtre
  //print_r($cles);echo "la cle indice : $la_cle_indice<br />";
  $next = $la_cle_indice+1; // Cette cl (de $cles) permettra de trouver l'indice suivant dans $tableau
  // On teste si les cls $prev et $next existent bien dans $cles
  if (!array_key_exists($next,$cles))
    $next = $la_cle_indice; // on dcrmente la cl car elle n'existe pas ($la_cle_indice tait donc la dernire cl)
  else  
    $lien_nav_suiv = "<a href='".$cible_lien.$cles[$next]."'><img src='".$GLOBALS['chemin_relatif']."images/suiv.gif' alt='$alt suivant(e)' title='$alt suivant(e)' width='23' height='23' /></a>
          <a href='".$cible_lien.$cles[count($cles)-1]."'><img src='".$GLOBALS['chemin_relatif']."images/suiv_rapid.gif' alt='Dernier(e) $alt' title='Dernier(e) $alt' width='33' height='23' /></a>";
  if (isset($lien_nav_suiv))
    return $lien_nav_suiv;    
}


// Autres Fonctions 

function affiche_eleve_absent($eleve,$eleve_id,$script,$id_transaction,$champ,$classe)
 //***************************** description *****************************************************************//
 // cette fonction assure l'affichage du nom d'un lve absent dans le cahier d'appel (voir c_cahier_appel.php
 // et c_bddabsences.php)
 // Date de cration : 15/12/2004
 // Date de dernire mise  jour : 
 //***************************** Fin description ***********************************************************//
 {
   $ancre_classe = str_replace(" ","",$classe);
   echo "<td style='border:none;'>";
 	if ($champ !="")
 		$query_string = "retirer=ok&amp;id_transaction=".$id_transaction."&amp;eleve_id=".$eleve_id."&amp;".$champ."#$ancre_classe";
 	else 
 		$query_string = "retirer=ok&amp;id_transaction=".$id_transaction."&amp;eleve_id=".$eleve_id."#$ancre_classe";
    echo "<font class='color_absent'>$eleve</font>
    </td>
    <td style='border:none;'>
    	<a href='".$script."?".$query_string."' onclick=\"return(window.confirm('Voulez-vous vraiment retirer l\'lve ".$eleve." de la liste des absents ?'));\"><img src='".$GLOBALS['chemin_relatif']."images/delete.png"."' alt='[Retirer]' title=\"Supprimer $eleve de cette liste d'absents\" width='18px' height='18px' /></a>
    </td>";
 }

function affiche_charte()
{
  //***************************** description *****************************************************************//
 // cette fonction permet d'afficher la charte d'utilisation IntraEduWeb, prlable  toute consultation des pages protges par une authentification
 // Date de cration : 02/04/2005
 // Date de dernire mise  jour : 
 //***************************** Fin description ***********************************************************//
 
  if (isset($_SESSION['valid_group']) && $_SESSION['valid_group'] == "2")
  	$fichier_charte = "charte_eleves.html";
  else
	$fichier_charte = "charte_droits.html"; 
 // On rcupre le texte de la charte  partir du fichier charte_droits.html ou charte_eleves.html, le texte se trouvent entre les balises de commentaires <!-- Debut texte charte --> et <!-- Fin texte charte -->
  $contenu_fichier = file_get_contents(IEW_DIR.$fichier_charte);
  $coupure1 = explode("<!-- Debut texte charte -->",$contenu_fichier);
  $coupure2 = explode("<!-- Fin texte charte -->",$coupure1[1]);
  $texte_charte = $coupure2[0];
  $code_formulaire = "<br /><div class='frame_form'>$texte_charte<br /></div><br />";
  squelette_formulaire_standard("100%","post",$GLOBALS['racine']."index.php","Vous devez <u>lire</u> et accepter la charte IntraEduWeb",$code_formulaire,"Accepter","accept_charte","","","","",""); 
}

function debut_code_html()
{
	global $error_message,$contexte,$titre_page;
	echo "<?xml version='1.0' encoding='iso-8859-1'?>
	<!DOCTYPE html PUBLIC '-//W3C//DTD XHTML 1.0 Transitional//EN' 'http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd'>
	<html xmlns='http://www.w3.org/1999/xhtml' lang='fr-FR' xml:lang='fr-FR'>
  	<head>
    <title>IntraEduWeb, Espace Numrique de Travail du ".$GLOBALS['nom_etablissement'];
	if (isset($_SESSION['anscol']) && $_SESSION['anscol'] != "")
		echo " (Archives ".$_SESSION['anscol'].")";
	echo ", $titre_page</title>
    <meta http-equiv='Content-Type' content='text/html; charset=iso-8859-1' />
    <meta name='author'    content='Sylvain GODM' />
    <meta name='copyright' content='2004-".date("Y").", Sylvain GODM. All Rights Reserved.' />
    <meta name='viewport' content='width=device-width' />
    <link rel='stylesheet' type='text/css' href='".$GLOBALS['racine'].$GLOBALS['repertoire_theme'].$GLOBALS['jeu_couleurs']['stylesheet']."' media='screen' />";
    if (isset($GLOBALS['css']) && $GLOBALS['css'] != "") // si dfini, une feuille de style particulire au script est incluse
	{
		echo "<link rel='stylesheet' type='text/css' href='".$GLOBALS['racine'].$GLOBALS['repertoire_theme'].$GLOBALS['css']."' media='screen' />
		";
	}
	echo "<link rel='stylesheet' type='text/css' href='".$GLOBALS['racine'].$GLOBALS['repertoire_theme']."print.css' media='print' />";
    echo "<script type=\"text/javascript\" src='".$GLOBALS['racine']."javascript/prototype.js'></script>
    <script type=\"text/javascript\" src='".$GLOBALS['racine']."javascript/decorate_labels.js'></script>
    ";
	if (isset($GLOBALS['js']) && $GLOBALS['js'] != "") // si dfini, un fichier js particulier au script est inclus
	{
		if (is_array($GLOBALS['js'])) // Mais on peut inclure ventuellement plusieurs js
		{
			foreach($GLOBALS['js'] as $value)
			{
				echo "<script type=\"text/javascript\" src='".$GLOBALS['racine']."javascript/".$value."'></script>\n";
			}
		}
		else 
			echo "<script type=\"text/javascript\" src='".$GLOBALS['racine']."javascript/".$GLOBALS['js']."'></script>";
	}
	if (isset($GLOBALS['contexte']) && ($GLOBALS['contexte'] == "cahiers_textes" || $GLOBALS['contexte'] == "notes_infos" 
	|| $GLOBALS['contexte'] == "saisie_semab" || $GLOBALS['contexte'] == "bdd_pers") || $GLOBALS['contexte'] == 'edt' || $GLOBALS['contexte'] == 'compte_ipr') // Si c'est une page  contexte particulier ncessitant TinyMCE et/ou un Datepicker
	{
		// On intgre l'diteur WYSIWYG pour le cahier de textes et les notes d'infos uniquement
		if ($GLOBALS['contexte'] == "cahiers_textes" || $GLOBALS['contexte'] == "notes_infos")
		{
			echo "
			<script type=\"text/javascript\" src=\"".$GLOBALS["racine"]."javascript/tinymce/tiny_mce.js\"></script>
			<script type=\"text/javascript\">
			// <![CDATA[
			tinyMCE.init({
				mode : \"textareas\",
    			language : \"fr\",
    			theme : \"advanced\",
    			gecko_spellcheck : \"true\",
    			plugins : \"fullscreen,autoresize,tiny_mce_wiris\",
    			theme_advanced_disable : \"image,anchor,cleanup,styleselect\",
    			theme_advanced_buttons1_add : \"forecolor,backcolor,fullscreen\",
    			theme_advanced_buttons3_add : \"tiny_mce_wiris_formulaEditor,tiny_mce_wiris_CAS\"
			});
			// ]]></script>";
		}
		
		// le Datepicker pour les champs Date :
		$icon_calendar = $GLOBALS["chemin_relatif"]."images/calendar-icon.jpg";
		echo "<script type=\"text/javascript\" src=\"".$GLOBALS["racine"]."javascript/prototype-base-extensions.js\"></script>
		<script type=\"text/javascript\" src=\"".$GLOBALS["racine"]."javascript/prototype-date-extensions.js\"></script>
		<script type=\"text/javascript\" src=\"".$GLOBALS["racine"]."javascript/datepicker.js\"></script>
		<script type=\"text/javascript\" src=\"".$GLOBALS["racine"]."javascript/datepicker-locale-fr_FR.js\"></script>
		<link rel='stylesheet' type='text/css' href='".$GLOBALS['racine'].$GLOBALS['repertoire_theme']."datepicker.css' />
		<script type=\"text/javascript\">
		function createPickers() 
		{ 
			$(document.body).select('input.datepicker').each( function(e) 
			{ 
				new Control.DatePicker(e, { 'icon': '$icon_calendar', 'locale':'fr_FR' });
			}
			);
		 } 
		 Event.observe(window, 'load', createPickers); 
		 </script>
		";
	}
  if (isset($GLOBALS['code_css'])) // si du code de feuille de style (provenant du script d'appel) doit s'insrer ici
  {
    echo $GLOBALS['code_css'];
  }
  if (isset($GLOBALS['css_file']) && $GLOBALS['css_file'] != "") // on peut insrer carrment une (ou plusieurs) feuille(s) de style externe(s) (la variable css_file doit contenir le chemin d'accs complet au fichier relatif au dossier racine IEW)
  {
  	if (is_array($GLOBALS['css_file'])) // Mais on peut inclure ventuellement plusieurs js
	{
		foreach($GLOBALS['css_file'] as $value)
		{
			echo "<link rel=\"stylesheet\" type=\"text/css\" href='".$GLOBALS['racine'].$value."' />\n";
		}
	}
	else 
		echo "<link rel=\"stylesheet\" type=\"text/css\" href='".$GLOBALS['racine'].$GLOBALS['css_file']."' />\n";
  }

  // On dclenche le heartbeat destin  envoyer une requte "bidon" au serveur  intervalles rguliers afin de maintenir
  // la session active (jusqu'au timeout de session gr par IEW), ainsi on vite que le session.gc_maxlifetime arrive  son terme
  // et ne supprime la session en cas d'inactivit de l'utilisateur sur la page. Ceci est oprationnel videmment tant que la page est affiche
  je_suis_la();
  
  // Code ventuel  rajouter dans la partie head (par exemple du code javascript)
  if (isset($GLOBALS['head']))
  {
    echo $GLOBALS['head'];
  }
  echo " </head>
  
  <!-- Corps de la page -->";
  // Suivant le 1er paramtre pass  la fonction, on ajuste le style CSS de l'lment body
  if (@func_get_arg(0) == "popup") // utilis  l'appel dans toutes les fentre pop-up
  	echo "
  		<body class='popup'>
  	";
  else	// cas normal (affichage en fentre classique)
  	echo "
  		<body>
  	";
}

function affiche_personnel_enseignant($with_grade)
{
  
   /**
   * Affiche sous forme de tableau, la liste du personnel enseignant, class par discipline poste
   * Le parammtre $with_grade s'il vaut 'true' permet d'afficher le grade 
   */
	
  // On rcupre d'abord la liste des discipline poste reprsente dans l'tablissement
  $sql = "SELECT DISTINCT libelle_long from personnel as t1, disciplines_bcn as t2 WHERE categorie='7' AND t1.code_discipline=t2.code_discipline ORDER BY libelle_long";
  // DEBUGG print $sql."<hr />";
  $resultat = @mysql_query($sql);
  if (@mysql_num_rows($resultat))
  {
    // si c'est bon, on affiche la liste du personnel par discipline enseigne
    while ($ligne_discipline = mysql_fetch_array($resultat))
    {
      echo "<table width=\"100%\">";
      echo "<tr><td width='34%'><i><u>".strtoupper($ligne_discipline['libelle_long'])."</u></i></td>";
      echo "<td>"; // colonne contenant le tableau des prof de la discipline
      echo "<table width='100%'>";
      $sql = "select civilite,nom,prenom,sous_categorie from personnel as t1, disciplines_bcn as t2 where categorie='7' AND t2.libelle_long='".$ligne_discipline['libelle_long']."' AND t1.code_discipline=t2.code_discipline ORDER BY nom,prenom";
      $result = @mysql_query($sql);
      if (mysql_num_rows($result)):
        while ($ligne = mysql_fetch_array($result))
        {
          echo "<tr><td width='33%'>".$ligne['civilite']." ".$ligne['nom'];
          if ($with_grade) // On affiche le prnom complet et le grade
          {
          	echo " ".ucfirst(strtolower($ligne['prenom']))."</td>";
          	echo "<td width='33%' >".stripslashes($ligne['sous_categorie'])."</td>";
          }
          else // On n'affiche que la 1re lettre du prnom et pas le grade
          {
          	echo " ".substr($ligne['prenom'],0,1).".</td>";
          }
          echo "</tr>";
        }
      endif;
      echo "</table>";
      echo "</td>";
      echo "</tr>"; // fin de ligne discipline
      echo "</table><br /><hr />";
    }
  }
  else
  {
    $error_message = "La table <i>disciplines_bcn</i> n'existe pas ou ne contient aucune donne.<br />Le script est interrompu.";
    affiche_erreurs($error_message);
    return;
  }
}

function affiche_autres_personnels($with_grade,$categorie)
{
	$sql1 = "SELECT categorie FROM categories_pers WHERE id_cat='".quote_smart($categorie)."'";
	// DEBUGG print $sql1."<hr />"; 
	$resultat1 = @mysql_query($sql1);
	if ($resultat1 && mysql_num_rows($resultat1)>0)
	{
  		$ligne = mysql_fetch_array($resultat1);
  		echo "<table width='100%'>";
  		echo "<tr><td width=\"34%\"><i><u>".$ligne['categorie']."</u></i></td>";
  		echo "<td>"; // colonne contenant le tableau des personnels de la catgorie
  		echo "<table border='0' width='100%'>";
  		if ($categorie == "4") // Si c'est le COP
  		{
    		$sql = "SELECT t1.civilite,t1.nom,t1.prenom,t2.categorie FROM personnel as t1,categories_pers as t2 WHERE t1.categorie='".quote_smart($categorie)."' AND t2.id_cat=t1.categorie ORDER BY nom";
		}
  		elseif ($categorie == "12") // Contrat Aid
  		{
    		$sql = "SELECT t1.civilite,t1.nom,t1.prenom,t1.activite,t2.categorie FROM personnel as t1,categories_pers as t2 WHERE t1.categorie='".quote_smart($categorie)."' AND t2.id_cat=t1.categorie ORDER BY nom";
  		}
  		else // cas par dfaut
  		{
    		$sql = "SELECT t1.civilite,t1.nom,t1.prenom,t2.categorie,t3.sous_categorie,t1.activite FROM personnel as t1, categories_pers as t2, sous_categories_pers as t3 WHERE t1.categorie='".quote_smart($categorie)."' AND t2.id_cat=t1.categorie AND t3.id_sous_cat=t1.sous_categorie ORDER BY nom";
    		// DEBUGG print $sql."<br />";
  		}
  		$resultat = @mysql_query($sql);
  		if (mysql_num_rows($resultat)>0)
  		{
    		while ($ligne = mysql_fetch_array($resultat))
    		{
      			echo "<tr><td width=\"33%\">".$ligne['civilite']." ".$ligne['nom'];
    			if ($with_grade == "activit")
      			{
      				echo " ".substr($ligne['prenom'],0,1).".</td><td width=\"33%\">";
      				if (isset($ligne['sous_categorie']))
      				{
        				echo stripslashes($ligne['sous_categorie'])." ";
      				}
      				if (isset($ligne['activite']) && $ligne['activite'] != "")
      				{
        				echo "(".$ligne['activite'].")";
      				}
      			}
      			elseif ($with_grade == "tout")
      			{
      				echo " ".ucfirst(strtolower($ligne['prenom']))."</td><td width=\"33%\">";
      				if (isset($ligne['sous_categorie']))
      				{
        				echo stripslashes($ligne['sous_categorie'])." ";
      				}
      				if (isset($ligne['activite']) && $ligne['activite'] != "")
      				{
        				echo "(".$ligne['activite'].")";
      				}
      			}    			
      			else
      			{
      				echo " ".substr($ligne['prenom'],0,1).".</td><td width=\"33%\">";
      			}
      			echo "</td></tr>";
    		}
  		}
  		else // Pour une conformit du code au doctype
  		{
  			echo "<tr><td width=\"33%\"></td><td width=\"33%\"></td></tr>";
  		}
  		echo "</table>";
  		echo "</td>";
  		echo "</tr>"; // fin de ligne categorie
  		echo "</table><br /><hr />";
	}
}

function fin_code_html()
{
  echo "<p id='hautdepage'>
  <a href='#haut' title='Haut de page'>
  <img src='".$GLOBALS["chemin_relatif"]."images/hp.png' alt='Haut de page' />
  </a>
  </p>
  </body>
  </html>";
}

function affiche_astuce($tip_message)
/**
 * cette fonction permet d'afficher les messages de trucs/astuces
 * @param $tip_message contient le message  afficher
*/
{
	global $racine;
   	echo "<center><div class='encadrer ok_message'><center><table width='50%'><tr><td align='center'><img src=\"$racine"."images/tip.png\" alt='' /></td><td align='center'><div class='texterror-warning'>Truc/Astuce</div></td><td align='center'><img src=\"$racine"."images/tip.png\" alt='' /></td></tr></table></center><br />";
	$fragments = preg_split("#<br />#",$tip_message);
   	foreach($fragments as $value)
   	{
   		$chaine_brute = trim(strip_tags($value)); 
   		if (strlen($chaine_brute)<105)
   		{	
   			// On peut centrer
   			echo $value."<br />";
   		}
   		else
   		{
   			// On justifie
   			echo "<div align='justify'>".$value."</div>";
   		}
   	}
   	echo "</div></center><br />";
}
?>