<?php
/**
 * fonctions_authentification.php
 *
 * regroupe les fonctions d'authentification 
 * 
 * Ce fichier fait partie du projet IntraEduWeb (IEW)
 * 
 * @package		IEW
 * @author			Sylvain GODM <sylvain.godme@gmail.com>
 * @version		$LastChangedRevision$, $LastChangedDate$
 * @copyright		2004-2012 Sylvain GODM
 * @link			http://iew.free.fr
 * @license		GPL License version 3 (http://www.gnu.org/licenses/gpl.html)
 * @filesource
 * 
 */

// On cherche le rpertoire d'installation IEW
if(!defined('IEW_DIR')) define('IEW_DIR',realpath(dirname(__FILE__)."/../").'/');

$flag_auth_ldap = false; // initialisation pour une authentification SSO ou LDAP

////////////////////////// Fonctions d'authentification //////////////////////////////////////////////////////////////////

/*
 * Ces fonctions servent  configurer l'authentification SSO Eole
 * On utilise ici la librairie phpCAS fournie par eole (eolephpCAS)
 */
function cas_auth()
{
   if (is_dir('/usr/share/php/CAS-1.3.1'))
   		require_once('CAS-1.3.1/eoleCAS.php');
   else 
   		require_once('CAS/eoleCAS.php');
   require_once('configCAS/cas.inc.php');
   define('__CAS_URL', '');
   //eolephpCAS::setDebug(); // ligne  dcommenter pour dbugger les changes entre CAS et IEW (le log se fait par dfaut dans /tmp/phpCAS.log)
   eolephpCAS::client(__CAS_VERSION, __CAS_SERVER, __CAS_PORT, __CAS_URL, false);
   
	if (defined('__CAS_VALIDER_CA'))
	{
    	eolephpCAS::setCasServerCACert(__CAS_CA_LOCATION);
   	}
   	else
   	{
   		if (method_exists(eolephpCAS, 'setNoCasServerValidation'))
   		{
       		eolephpCAS::setNoCasServerValidation();
    	}
   	}
   	if (defined('__CAS_LOGOUT'))
   	{
       if (method_exists(eolephpCAS, 'EolelogoutRequests'))
       {
          eolephpCAS::EolelogoutRequests(false); // permet de prendre en compte l'appel du serveur SSO lors d'une dconnexion centralise
       }
   	}
   	eolephpCAS::forceAuthentication();
}

function cas_logout()
{
   if (is_dir('/usr/share/php/CAS-1.3.1'))
   		require_once('CAS-1.3.1/eoleCAS.php');
   else 
   		require_once('CAS/eoleCAS.php');
   require_once('configCAS/cas.inc.php');
   define('__CAS_URL', '');
   //eolephpCAS::setDebug(); // ligne  dcommenter pour dbugger les changes entre CAS et IEW (le log se fait par dfaut dans /tmp/phpCAS.log)
   eolephpCAS::client(__CAS_VERSION, __CAS_SERVER, __CAS_PORT, __CAS_URL, false);
   
   if (defined('__CAS_VALIDER_CA'))
   {
   		eolephpCAS::setCasServerCACert(__CAS_CA_LOCATION);
   }
   else
   {
       if (method_exists(eolephpCAS, 'setNoCasServerValidation'))
       {
           eolephpCAS::setNoCasServerValidation();
       }
   }
   // On dtruit aussi la session IEW avant la redirection vers le serveur CAS
   destroy_session_IEW();
   eolephpCAS::logout(array("url"=>$_SERVER["SCRIPT_URI"]));
}

function after_sso_maj_table_login_personnel($sql,$info_ldap,$id_gpe_utilisateur)
{
	/**
	 * Aprs la connexion de l'utilisateur et la rcupration des attributs LDAP par le SSO
	 * On met  jour la table login lors de la premire connexion et ventuellement la table personnel
	 */
	// DEBUGG print "L'application est en maintenance (mais elle reste utilisable : <b>rechargez la page (touche F5)</b>), des messages de dbogage s'affichent sur votre cran. MErci de ne pas en tenir compte. L'affichage habituel sera rtabli ds que possible<br />Sylvain Godm<br /><br />Informations rcupres du serveur SSO : <br />"; 
	// DEBUGG print "<pre>";
	// DEBUGG print_r($info_ldap);
	// DEBUGG print "</pre>";
	// DEBUGG print "<br />Requte d'update ou select : ".$sql."<br /><br />";
	$resultat = mysql_query($sql);
	// pour viter un warning chiant en dev
	if (substr($sql,0,6) == "SELECT")
		$nb_resultats = mysql_num_rows($resultat);
	// DEBUGG print "Infos sur le Rsultat de la requte d'update (n'existe que si update pas select !) : ".mysql_info()."<br /><br />";
	/* mysql_info() renvoie des infos sur la requte update : nb de lignes correspondantes (Row matched), nb de lignes changes (Changed), avertissements (Warnings)*/
	// DEBUGG print "Nombre de Rsultats de la requte select (n'existe que si select pas update !) : ".$nb_resultats."<br /><br />"; // Dans le cas d'une requte SELECT, mysq_info() renvoie false (aucune info) : c'est pourcela qu'on ne l'utilise pas ici
	preg_match("#Rows matched: ([0-9]*)#", mysql_info(), $rows_matched); // $rows_matched[1] donnera le nombre de lignes existantes qui correspondent  la requte UPDATE (mme si aucun update n'est effectivement fait)
	// Rappel : vide si la requte est un SELECT
	// DEBUGG print "tableau row_matched :"; var_dump($rows_matched);echo "<br /><br />";
	$not_allowed = array("National_1","National_2","National_4");
	/* Les lves, les responsables, le personnel de direction n'ont pas le droit de se connecter  IEW s'ils n'ont pas t
	 * imports dans IEW par les fichiers de gestion administratives (sconet et sts) : en consquence, mme si ceux-ci sont reconnus par le SSO (car leur compte existe sur ce serveur)
	 * la cration automatique d'un compte dans IEW (comme il sera procd plus loin pour les administratifs, les personnels de vie scolaire ou les autres personnels)
	 * n'aura pas lieu. En effet, sinon il serait possible pour des utilisateurs qui ne sont plus dans l'tablissement (mais qui n'ont pas encore t retir du serveur SSO,
	 * ce qui peut tre le cas en dbut d'anne scolaire si la maj des comptes des lves et responsables n'est pas faite, alors que celle des profs oui)
	 * */
	// Ce qui suit suppose que la requte est un UPDATE
	if (($rows_matched[1] === "0" || $nb_resultats === 0) && !in_array($info_ldap['utilisateur']['profil'][0],$not_allowed)) // Si l'utilisateur n'est pas dans la base IEW (table login)
	{
		/* Les utilisateurs pour lesquels on excute cette partie du script sont tous les utilisateurs qui ne sont pas dans les tables IEW :
		 * AUTRES QUE les lves, les responsables, le personnel de direction, CPE et chefs de travaux
		 * AUTREMENT DIT, il s'agit des professeurs non imports dans IEW par les fichiers de gestion administratives (sconet et sts)
		 * Soit les personnes cres manuellement dans l'EAD :
		 * - le(s) documentaliste(s)
		 * - les professeurs remplaants
		 * - les administratifs (hors direction, cpe, chef de travaux) : vie scolaire,...
		 * - les comptes invits de scribe */
		// DEBUGG print "Cet utilisateur n'est pas dans la base IEW, mais son compte va etre cr<br /><br/>";
		/* Il faut donc crer le compte IEW
		* Si aucun d'enregistrement dans la table login correspond  l'utilisateur, il faut crer le compte
		* Comme cet utilisateur a t cr dans l'EAD sans import, il n'a pas d'attribut 'intid' permettant la mise en relation avec les donnes sconet
		* Ce qui n'est pas un problme, puisque aucune donne de sconet ne le concerne. Cependant; il doit tre identifiable de faon unique dans IEW, aussi, on va prendre l'attribut uidNumber
		* qui lui existe (sauf pour les comptes invits de scribe), en lieu et place du 'intid' (pour le champ 'id_individu')
		* Le seul problme thorique est que l'uidNumber de cet utilisateur soit gal au intid d'un autre !!
		* 
		* La fonction utf8_decode() est utilise pour convertir les donnes aplhabtiques nom + prenom encodes en utf8 sur scribe
		* au format iso-8859-1 pour IEW
		*/
		if ($id_gpe_utilisateur == "") // Si le groupe de l'utilisateur (au sens des droits IEW) n'est pas connu : la valeur $id_gpe_utilisateur est fournie par l'attribut profil renvoy par le serveur SSO lors de l'authentification (voir fonction recup_infos_ldap_et_IEW())
		{ 
			/* Donc il s'agit d'un administratif (autre que le personnel de direction, CPE et chefs de travaux)
			 * ou d'un compte invit
			 * on l'affecte par dfaut au groupe "exterieurs" (12) au sens des droits IEW = droits minima dans l'application
			* (h oui, on ne sait pas  qui on a  faire !)
			* Il faudra alors qu'il demande  l'admin de lui donner des droits suffisants (devra tre affect  un autre groupe IEW)*/	
			$id_gpe_utilisateur = "12";
			if (isset($info_ldap['utilisateur']['intid'])) // Si l'utilisateur a t import de SCONET sur le serveur SSO par import XML
			{
				$valeur_id_individu = $info_ldap['utilisateur']['intid'][0];
			}
			else // Si l'utilisateur n'a pas t import de SCONET, mais cr dans l'EAD
			{
				$valeur_id_individu = $info_ldap['utilisateur']['uidNumber'][0];
			}
		}
		elseif (isset($info_ldap['utilisateur']['intid'])) // groupe de l'utilisateur connu et l'utilisateur a t import par XML dans l'EAD, c'est sa premire connexion  IEW
		{
			$valeur_id_individu = $info_ldap['utilisateur']['intid'][0];
		}
    elseif (!isset($info_ldap['utilisateur']['intid'])) // groupe de l'utilisateur connu mais l'utilisateur n'a pas t import par XML dans l'EAD, mais cr MANUELLEMENT dans l'EAD
		{
			// C'est le cas par exemple d'un documentaliste ou d'un professeur remplaant
			$valeur_id_individu = $info_ldap['utilisateur']['uidNumber'][0];
		}
		// DEBUGG print "La valeur de l'id_individu est : $valeur_id_individu (doit correspondre  l'attribut LDAP intid si cet utilisateur est import de SCONET/STS et  uidNumber s'il a t cr manuellement dans l'EAD)<br />";
		// Pour un compte invit de scribe, uidNumber n'existant pas, la valeur de id_individu dans la table login sera 0 (ne sera pas unique si plusieurs comptes invits se sont connects  IEW, mais pas grave puisque seul l'id_pers est unique dans cette table) 
		$id=cree_compte_iew("id_individu",$valeur_id_individu,$info_ldap['utilisateur']['user'][0],utf8_decode($info_ldap['utilisateur']['nom'][0]),utf8_decode($info_ldap['utilisateur']['prenom'][0]),$id_gpe_utilisateur,"","");
		// DEBUGG print "Identifiant numrique de l'utilisateur dans IEW (id_pers) = ".$id."<br />";
		if ($id && $info_ldap['utilisateur']['user'][0] != "admin" &&  isset($info_ldap['utilisateur']['uidNumber'][0])) // Si la cration du compte a russi, on intgre l'utilisateur dans la table 'personnel' de IEW (sauf pour l'admin scribe et les comptes invits de scribe -qui n'ont pas d'uidNumber-)
        {
        	// DEBUGG print "<strong>Cration</strong> du compte IntraEduWeb <strong>russie</strong> !<br /><br />";
           	// Un identifiant utilisateur unique vient d'tre cr, on le rcupre
    		// On le met comme identifiant de la personne dans la base du personnel
    		// Cet enregistrement devra tre complt + tard par l'admin (en ditant la fiche de ce membre du personnel)
    		if ($id_gpe_utilisateur == "3") // documentaliste ou prof remplaant, la categorie IEW vaut 7, mais le reste (sous_categorie = GRADE), code_discipline, ne sont pas connus car utilisateur cr dans l'EAD
    		{
				$sql1 = "INSERT INTO personnel VALUES('$id','".quote_smart($valeur_id_individu)."','','".quote_smart(utf8_decode($info_ldap['utilisateur']['nom'][0]))."','".quote_smart(utf8_decode($info_ldap['utilisateur']['prenom'][0]))."','NULL','NULL','7','NULL','".quote_smart($info_ldap['utilisateur']['civilite'][0])."','')";    			
    		}
    		else // autre cas : categorie non connue, donc mise  NULL
    		{
			    $sql1 = "INSERT INTO personnel VALUES('$id','".quote_smart($valeur_id_individu)."','','".quote_smart(utf8_decode($info_ldap['utilisateur']['nom'][0]))."','".quote_smart(utf8_decode($info_ldap['utilisateur']['prenom'][0]))."','NULL','NULL','NULL','NULL','".quote_smart($info_ldap['utilisateur']['civilite'][0])."','')";
    		}        	
            // DEBUGG print $sql1."<br /><br />";
    		mysql_query($sql1);
            if (mysql_affected_rows()==-1) // Si l'criture n'a pas russi
            {
		    	// DEBUGG print "L'identifiant numrique de <strong>".stripslashes(utf8_decode($info_ldap['utilisateur']['prenom'][0]))." ".stripslashes(utf8_decode($info_ldap['utilisateur']['nom'][0]))."</strong> n'a pas pu tre mis  jour dans la base de donnes. La correspondance entre les donnes du compte utilisateur et la table personnel risque de ne plus tre correcte.<br />";
    	    }
    	    else 
    	    {
    	    	// DEBUGG print "L'utilisateur a t intgr(e) dans la table du personnel.<br/><br/>";
    	    }
        }
        elseif (!$id) // l'criture dans la table login n'a pas eu lieu
        {
		   	// DEBUGG print "Le <u>login</u> et le <u>mot de passe</u> de <strong>".stripslashes(utf8_decode($info_ldap['utilisateur']['prenom'][0]))." ".stripslashes(utf8_decode($info_ldap['utilisateur']['nom'][0]))."</strong> n'ont pas pu tre inscrits dans la base de donnes.<br />";
    	}
    	else // le cas restant est que le compte est bien cr, mais concerne admin ou un compte invit (donc ils ne seront pas intgrs dans la table "personnel")
    	{
    		// DEBUGG print "<strong>Cration</strong> du compte IntraEduWeb <strong>russie</strong> (pour admin ou un invit) !<br /><br />";
    	}
	} // la requte est tjs un UPDATE n'ayant aucun rsultat
	elseif (($rows_matched[1] === "0" || $nb_resultats === 0) && in_array($info_ldap['utilisateur']['profil'][0],$not_allowed))
	{
	    $error_message = array("Vous n'tes pas autoris  vous connecter  l'application : <br />
	    <ul>
	    <li>soit parce que vous n'tes plus dans l'tablissement (et que votre compte n'a pas encore t supprim du serveur d'authentification SSO),</li>
	    <li>soit parce que l'administrateur de l'application IEW n'a pas encore import les donnes de gestion vous concernant.</li>
	    <p>Veuillez renouveler votre tentative dans quelques jours, et en cas de problme persistant, contacter l'administrateur.</p>","");
	    affiche_erreurs($error_message);
		// DEBUGG print "<br />Cet utilisateur n'est pas dans la base IEW, et compte tenu de son profil ENT, n'a pas le droit de se connecter à IEW : il devrait avoir un compte IEW import dans IEW par les fichiers de gestion en provenance de sconet ou sts-web<br />";
	}
	
	/* si la requte est un SELECT ou bien si la requte UPDATE aboutit, on poursuit aussi le script */
	
	// On rcupre les infos ncessaires  IEW, mais dans le cas o l'utilisateur n'a pas le droit de se connecter, on ne rcupre rien
	// et on obtient une erreur phpCAS qui arrte le script (mais on s'en fout...)
	$infos_utilisateurs2 = user_record_in_login_table(quote_smart($info_ldap['utilisateur']['user'][0])); // la rcup s'effectue  partir du nomlogin
	// DEBUGG print "Rcup dans la table login aprs after_sso_maj_table_login_personnel:<br />";
	// DEBUGG print "<pre>";
	// DEBUGG print_r($infos_utilisateurs2);
	// DEBUGG print "</pre>";
	$_SESSION['infos_utilisateurs'] = $infos_utilisateurs2;
	// DEBUGG print "Variable de session 'infos_utilisateurs' : <br />";
	// DEBUGG print "<pre>";// DEBUGG print_r($_SESSION['infos_utilisateurs']);
	// DEBUGG print "</pre>";
}

function recup_infos_ldap_et_IEW()
{
	/**
	 * Rcupre les informations utilisateurs en provenance de l'annuaire LDAP
	 * et se sert de ces infos pour rcuprer les donnes utilisateurs concernant le compte IEW
	 * (Table login) et on met  jour les champs nomlogin et auth_source de la table login
	 *  la premire connexion utilisateur
	 * Met  jour la variable $message s'il y a une erreur
	 * Renvoie le tableau $infos_utilisateurs (donnes de la table login) ventuellement vide
	 */
	
	global $message;
	
	/* En d'identification par le serveur CAS eole, la rcupration est rapide
	 * Pour que ces lignes s'excutent, il faut que $sso = "eolesso" dans config.php
	 * */
	if ($_SESSION['CAS'] && $GLOBALS['sso'] == "eolesso")
	{
		// Attention, pour rcuprer les bonnes infos, il faut configurer correctement le filtre SSO pour IEW
		
		/* Sur scribe, dans /usr/share/sso/app_filters/ :
		 *
		 * - Crer un fichier iew_apps.ini contenant :
		 * 
		 * [iew]
		 * baseurl=/iew/
		 * scheme=both
		 * addr=0/0
		 * typeaddr=ip
		 * filter=iew
		 * 
		 * Puis un fichier iew.ini contenant le filtre proprement dit :
		 * 
		 * [utilisateur]
		 * user=uid
		 * intid=intid
		 * uidNumber=uidNumber
		 * prenom=givenName
		 * nom=sn
		 * profil=ENTPersonProfils
		 * typeadmin=typeadmin
		 * civilite=personalTitle
		 * 
		 * Et ne pas oublier de relancer le serveur SSO : /etc/init.d/eole-sso restart
		 * 
		 * Remarques :
		 * 
		 * uidNumber est un attribut ldap prsent uniquement pour les lves et les membres du personnel (profs ou administratifs)
		 * mais absent pour les invits et les responsables
		 * 
		 * ENTPersonProfils est un attribut ldap absent pour les invits
		 * 
		 * typeadmin est un attribut ldap prsent uniquement pour les membres du personnel (professeur ou administratif)
		 * avec les valeurs suivantes : 0 pour les profs normaux, 1 pour les administrateurs, 2 pour les profs principaux, 3 pour les administratifs
		 * Mais absent pour les lves, les responsables et les invits.
		 * Cet attribut, bien que rcupr du SSO lorsqu'il existe, n'est pas utilis pour l'instant par IEW (au 05/03/2011)  
		 * 
		 * */
		$info_ldap = eolephpCAS::getDetails();
		// DEBUGG var_dump($info_ldap);
		// Suivant le profil de l'utilisateur (lve, prof, responsable...) on dtermine la requte SQL  faire
		switch ($info_ldap['utilisateur']['profil'][0])
		{
			/* Nomenclature nationale des profils utilisateurs
    		# National_1 : lve
    		# National_2 : Responsable d'un lve (parent, tuteur lgal)
    		# National_3 : Enseignant
    		# National_4 : Personnel de direction de l'tablissement
    		# National_5 : Personnel de vie scolaire travaillant dans l'tablissement
    		# National_6 : Personnel administratif, technique ou d'encadrement travaillant dans l'tablissement
    		# National_7 : Personnel de rectorat, de DRAF, de collectivit locale, d'inspection acadmique
    		*/
			
			/*
			 * Dans ce qui suit, les cas National_4, National_5, National_7 ne sont pas encore implments car
			 * en ce qui concerne les 2 premiers en tous cas, certains de leur membre sont dj import par les fichiers
			 * de gestion STS WEB. On risquerai alors d'avoir des comptes "en double".
			 * */
			
			case "National_3": // Cas d'un professeur, dj import dans IEW (imports SCONET)
				// S'il ne s'est pas encore connect  IEW, on met  jour la table login
				$id_gpe_utilisateur = "3"; // C'est l'identifiant du groupe prof pour IEW
				if ($info_ldap['utilisateur']['user'][0] == "admin")
					$id_gpe_utilisateur = "1"; // C'est l'identifiant du groupe admin pour IEW (on y met l'admin de scribe dedans)
				if (!isset($info_ldap['utilisateur']['intid'])) // Si l'utilisateur n'a pas t import de SCONET, mais cr dans l'EAD, ex : le DOCUMENTALISTE
					$sql = "UPDATE login set nomlogin='".$info_ldap['utilisateur']['user'][0]."', auth_source='cas' WHERE id_gpe_utilisateurs='$id_gpe_utilisateur' AND id_individu='".$info_ldap['utilisateur']['uidNumber'][0]."'";
				else
					$sql = "UPDATE login set nomlogin='".$info_ldap['utilisateur']['user'][0]."', auth_source='cas' WHERE id_gpe_utilisateurs='$id_gpe_utilisateur' AND id_individu='".$info_ldap['utilisateur']['intid'][0]."'";
				break;
			case "National_1": // Cas d'un lve, dj import dans IEW (imports SCONET)
				// S'il ne s'est pas encore connect  IEW, on met  jour la table login
				$id_gpe_utilisateur = "2"; // C'est l'identifiant du groupe eleves pour IEW
				$sql = "UPDATE login set nomlogin='".$info_ldap['utilisateur']['user'][0]."', auth_source='cas' WHERE id_gpe_utilisateurs='$id_gpe_utilisateur' AND eleve_id='".$info_ldap['utilisateur']['intid'][0]."'";
				break;
			case "National_2"; // Cas d'un responsable, dj import dans IEW (imports SCONET)
				// S'il ne s'est pas encore connect  IEW, on met  jour la table login
				$id_gpe_utilisateur = "4"; // C'est l'identifiant du groupe parent pour IEW
				$sql = "UPDATE login set nomlogin='".$info_ldap['utilisateur']['user'][0]."', auth_source='cas' WHERE id_gpe_utilisateurs='$id_gpe_utilisateur' AND id_personne='".$info_ldap['utilisateur']['intid'][0]."'";
				break;
			case "National_6": // Cas d'un administratif
				// Ici, ce type d'utilisateur ne correspond pas  un groupe reconnu par IEW
				$id_gpe_utilisateur = "";
				// Le personnel de direction et les CPE ont dj t imports et disposent d'un enregistrement dans la table login (car donnes importes de sconet)
				// Les autres membres du personnel administratifs ne peuvent pas tre imports depuis sconet
				// Il faut donc crer manuellement ces comptes sur scribe (sinon pas de connexion SSO possible). Pour ceux-l, la requte d'update va chouer
				// car ils n'ont pas d'attribut 'intid', on ajoutera alors un enregistrement  la table login
				if (!isset($info_ldap['utilisateur']['intid'])) // Si l'utilisateur n'a pas t import de SCONET, mais cr dans l'EAD
					$sql = "UPDATE login set nomlogin='".$info_ldap['utilisateur']['user'][0]."', auth_source='cas' WHERE id_individu='".$info_ldap['utilisateur']['uidNumber'][0]."'";
				else
					$sql = "UPDATE login set nomlogin='".$info_ldap['utilisateur']['user'][0]."', auth_source='cas' WHERE id_individu='".$info_ldap['utilisateur']['intid'][0]."'";
				break;
			default: // Cas d'un compte invit de scribe par exemple
				$id_gpe_utilisateur = "";
				$sql = "SELECT * FROM login WHERE nomlogin='".$info_ldap['utilisateur']['user'][0]."'";
		}
		after_sso_maj_table_login_personnel($sql,$info_ldap,$id_gpe_utilisateur);
		// DEBUGG echo "Informations utilisateurs rcupres pour la fin de connexion : <br />";
		// DEBUGG var_dump($_SESSION['infos_utilisateurs']);
		return; // on sort de la fonction car on a les infos voulues (le code des lignes suivantes ne sera pas excut)
	}
	
	// La portion de script qui suit doit tre revue car non modifie depuis le developpment de IEW sur scribe
	// dans la mesure o sur scribe elle n'est jamais excute !
	
	$ds = ldap_connect($GLOBALS['ldap_server_name'], $GLOBALS['ldap_server_port']);
  			if ($ds)
		  	{
		  		ldap_set_option ($ds, LDAP_OPT_PROTOCOL_VERSION, 3);
		  		// D'abord attachement anonyme pour rcuprer le DN ncessaire  la connexion utilisateur
		  		if (@ldap_bind ($ds))
    			{
    				$dn = $GLOBALS['ldap_base_dn']; // DN de Base du serveur LDAP
    				$filtre="uid=".$_POST['username'];

    				// DEBUGG echo "Filtre de recherche LDAP : ".$filtre."<br />";
    				
    				$sr=ldap_search($ds, $dn, $filtre);
    				$info = ldap_get_entries ($ds, $sr);
    				$dn_user = $info[0]['dn'];
    				
    				// DEBUGG echo "dn de l'utilisateur : ".$dn_user."<br />";
    				
    				    				
    				if($info['count'] > 0) // L'utilisateur se trouve dans l'annuaire LDAP
    				{
    					
	    				// Si une session CAS est ouverte, il faut rcuprer la cl de jointure permettant de lier les donnes IEW
    					// avec l'utilisateur authentifi
    					if ($_SESSION['CAS'])
    					{
    						// On reste en attachement anonyme car on ne connat pas le mot de passe de l'utilisateur
    						// (connu du serveur SSO seulement)
    						// CECI IMPOSE QUE CETTE CLE DE JOINTURE SOIT ACCESSIBLE EN BIND ANONYME SUR LE SERVEUR LDAP
    						$attributs = array_unique(array($GLOBALS['ldap_cle_jointure'], $GLOBALS['ldap_user_eleve_attribute'], $GLOBALS['ldap_user_prof_attribute']));
    						$sr=ldap_search($ds, $dn, $filtre, $attributs);
							$info = ldap_get_entries ($ds, $sr);
							
							/*** Portion de code identique  celle un peu plus bas aprs l'attachement utilisateur au serveur LDAP (connnexion non anonyme) ***/
							// TOUTE MODIFICATION DANS CETTE PORTION DE CODE DOIT ETRE RECOPIEE DANS L'AUTRE
							
							// DEBUGG echo "<pre>".var_dump($info)."</pre><br />";
							
							if (isset($info[0][$GLOBALS['ldap_user_eleve_attribute']][0]))
							{
								$gidNumber = $info[0][$GLOBALS['ldap_user_eleve_attribute']][0]; // Contient la valeur de l'attribut identifiant l'utilisateur comme lve
							}
							elseif (isset($info[0][$GLOBALS['ldap_user_prof_attribute']][0]))
							{
								$gidNumber = $info[0][$GLOBALS['ldap_user_prof_attribute']][0]; // Contient la valeur de l'attribut identifiant l'utilisateur comme professeur
							}							
  							$employeeNumber = $info[0][$GLOBALS['ldap_cle_jointure']][0]; // Contient la cl de jointure entre les donnes de l'annuaire ENT ou LDAP et lkes donnes provenant du SI MENESR
							// DEBUGG echo "gidNumber : $gidNumber<br />employeeNumber : $employeeNumber<br />";
  							$GLOBALS['flag_auth_ldap'] = true;
  							// On cherche l'utilisateur dans la table login, pour complter des infos
  							// notamment y inscrire l'uid si l'utilisateur LDAP ne s'est pas encore connect  IEW, ou bien si l'uid a chang
		  					if ($gidNumber == $GLOBALS['ldap_user_prof_attribute_value']) // cas d'un prof
			  				{
			  					$sql = "UPDATE login set nomlogin='".quote_smart($_POST['username'])."', auth_source='".$GLOBALS['auth_method']."' WHERE id_gpe_utilisateurs='3' AND id_individu='$employeeNumber'";
	  						}
  							elseif ($gidNumber == $GLOBALS['ldap_user_eleve_attribute_value']) // cas d'un eleve
  							{
  								$sql = "UPDATE login set nomlogin='".quote_smart($_POST['username'])."', auth_source='".$GLOBALS['auth_method']."' WHERE id_gpe_utilisateurs='2' AND eleve_id='$employeeNumber'";
	  						}
    						else // on suppose que c'est un responsable
	  						{
	  							$sql = "UPDATE login set nomlogin='".quote_smart($_POST['username'])."', auth_source='".$GLOBALS['auth_method']."' WHERE id_gpe_utilisateurs='4' AND id_personne='$employeeNumber'";
	  						}
  							// DEBUGG echo "SQL : ".$sql."<br />";exit;
							if ($employeeNumber != "")
							{
								mysql_query($sql);
								// On rcupre maintenant les informations de la table login utiles pour la connexion
								$_SESSION['infos_utilisateurs'] = user_record_in_login_table(quote_smart($_POST['username']));
								// DEBUGG var_dump($infos_utilisateurs);exit;
							}
							else
							{
								$message .= "Vous vous tes connect(e) avec un compte utilisateur de l'annuaire LDAP n'ayant pas de cl de jointure avec les donnes en provenance du SI MENESR. Il est fort probable que ce ne soit pas un membre de la communaut ducative de l'tablissement. Il faut vous connecter avec un autre compte.<br />";
							}
							// DEBUGG echo "message erreur : ".$message."<br />";exit;
							
							/*** Fin de portion ***/
	    				}
    					else // Ce n'est pas une session CAS
    					{
	    					// Attachement utilisateur 
							if (@ldap_bind ($ds,$dn_user,$_POST['ldap_passwd']))
							{
								$filtre = $GLOBALS['ldap_user_login_attribute']."=".$_POST['username'];
								// DEBUGG echo "Filtre de recherche LDAP : ".$filtre."<br />";
								// On utilise ci-dessous array_unique pour s'assurer qu'il n'y a pas de doublons dans les attributs
								// car dans le cas de scribe la valeur de ldap_user_eleve_attribute = celle de ldap_user_prof = gidnumber
								$attributs = array_unique(array($GLOBALS['ldap_cle_jointure'], $GLOBALS['ldap_user_eleve_attribute'], $GLOBALS['ldap_user_prof_attribute']));
								// DEBUGG echo "Attributs slectionns : <br />"; print_r($attributs);echo "<br/>";
								// DEBUGG echo "ds,dn,filtre : $ds , $dn , $filtre <br />";
								$sr=ldap_search($ds, $dn, $filtre, $attributs);
								$info = ldap_get_entries ($ds, $sr);
							
								/*** Portion de code identique  celle un peu plus haut si session CAS ouverte ( et connnexion anonyme sur le serveur LDAP) ***/
								// TOUTE MODIFICATION DANS CTTE PORTION DE CODE DOIT ETRE RECOPIEE DANS L'AUTRE
								
								// DEBUGG echo "<pre>".var_dump($info)."</pre><br />";
							
								// Il n'y a qu'un rsultat possible : on rcupre les infos utilisateur (notamment l'attribut permettant d'identifier l'utilisateur comme prof ou lve et la cl de jointure entre les donnes utilisateurs de l'annuaire et les donnes en provenance du SI MENESR)
								// 
								if (isset($info[0][$GLOBALS['ldap_user_eleve_attribute']][0]))
								{
									$gidNumber = $info[0][$GLOBALS['ldap_user_eleve_attribute']][0]; // Contient la valeur de l'attribut identifiant l'utilisateur comme lve
								}
								elseif (isset($info[0][$GLOBALS['ldap_user_prof_attribute']][0]))
								{
									$gidNumber = $info[0][$GLOBALS['ldap_user_prof_attribute']][0]; // Contient la valeur de l'attribut identifiant l'utilisateur comme professeur
								}
  								$employeeNumber = $info[0][$GLOBALS['ldap_cle_jointure']][0]; // Contient la cl de jointure entre les donnes de l'annuaire ENT ou LDAP et lkes donnes provenant du SI MENESR
								// Pour l'annuaire scribe, c'est la valeur de l'attribut intid
								
  								// DEBUGG echo "gidNumber : $gidNumber<br />employeeNumber : $employeeNumber<br />";
  								$GLOBALS['flag_auth_ldap'] = true;
  								// On cherche l'utilisateur dans la table login, pour complter des infos
  								// notamment y inscrire l'uid si l'utilisateur LDAP ne s'est pas encore connect  IEW, ou bien si l'uid a chang
		  						if ($gidNumber == $GLOBALS['ldap_user_prof_attribute_value']) // cas d'un prof
			  					{
			  						$sql = "UPDATE login set nomlogin='".quote_smart($_POST['username'])."', auth_source='".$GLOBALS['auth_method']."' WHERE id_gpe_utilisateurs='3' AND id_individu='$employeeNumber'";
	  							}
  								elseif ($gidNumber == $GLOBALS['ldap_user_eleve_attribute_value']) // cas d'un eleve
  								{
  									$sql = "UPDATE login set nomlogin='".quote_smart($_POST['username'])."', auth_source='".$GLOBALS['auth_method']."' WHERE id_gpe_utilisateurs='2' AND eleve_id='$employeeNumber'";
	  							}
	  							else // on suppose que c'est un responsable
	  							{
	  								$sql = "UPDATE login set nomlogin='".quote_smart($_POST['username'])."', auth_source='".$GLOBALS['auth_method']."' WHERE id_gpe_utilisateurs='4' AND id_personne='$employeeNumber'";
	  							}
  								// DEBUGG echo "SQL : ".$sql."<br />";exit;
								if ($employeeNumber != "")
								{
									mysql_query($sql);
									// On rcupre maintenant les informations de la table login utiles pour la connexion
									$_SESSION['infos_utilisateurs'] = user_record_in_login_table(quote_smart($_POST['username']));
									// DEBUGG var_dump($infos_utilisateurs);exit;
								}
								else
								{
									$message .= "Vous vous tes connect(e) avec un compte utilisateur de l'annuaire LDAP n'ayant pas de cl de jointure avec les donnes en provenance du SI MENESR. Il est fort probable que ce ne soit pas un membre de la communaut ducative de l'tablissement. Il faut vous connecter avec un autre compte.<br />";
								}
								// DEBUGG echo "message erreur : ".$message."<br />";exit;	

								/*** Fin de portion ***/
							}
							else
							{
								$message .= "Impossible de se connecter au serveur LDAP avec le couple identifiant-mot de passe fourni !<br />";
								$_SESSION['infos_utilisateurs'] = native_auth(); // On tente une authentification locale
  							}
    					}
    				}
					else // L'utilisateur ne se trouve pas dans l'annuaire LDAP => il faut tenter une authentification locale
					{
						$_SESSION['infos_utilisateurs'] = native_auth();
					}
    			}
    			else
    			{
    				$message .= "Impossible de se connecter au serveur LDAP pour vous authentifier !<br />";
    				//DEBUGG echo $message;exit;
    				$_SESSION['infos_utilisateurs'] = native_auth(); // On tente une authentification locale
    				// DEBUGG print_r($infos_utilisateurs);exit;
    			}
				
	  		}
	  		else // L encore la connexion au serveur LDAP n'a pas pu s'tablir
	  		{
	  			
    			$message .= "Impossible de se connecter au serveur LDAP pour vous authentifier !<br />";
    			//DEBUGG echo $message;	print_r($_POST); exit;
	  			// Alors on tente une authentification locale
	  			$_SESSION['infos_utilisateurs'] = native_auth();
	  		}
	  		@ldap_close ($ds);
// DEBUGG echo "Informations utilisateurs rcupres pour la fin de connexion : <br />";
// DEBUGG var_dump($_SESSION['infos_utilisateurs']);
}

function try_login()
{

	/**
	 * Cette fonction tente le login utilisateur dans l'application IEW
	 * Quelle que soit sa mthode d'authentification
	 * Renvoie $message vide si tout c'est bien pass, sinon $message contient l'erreur
	 */
	
		$message = "";	
		$infos_utilisateurs = array(); // Tableau qui contiendra les donnes locales utilisateur (provenant du compte IEW : Table login)
		/** Si configur, tentative d'authentification LDAP
		* Ce type d'authentification sera tent si la mthode d'authentification n'est pas native
		*  moins que le paramtre log=locale (forcer une authentification locale dans le cas d'une
		* authentification par SSO dans le config.php
		*/
		if($GLOBALS['auth_method'] != "native" && ((!isset($_GET['log']) || (isset($_GET['log']) && $_GET['log'] != 'locale'))))
  		{
  			recup_infos_ldap_et_IEW(); // les infos sont rcupres en combinant les donnes LDAP d'authentification et les donnes IEW de la table login
  			$infos_utilisateurs = $_SESSION['infos_utilisateurs'];
  			// DEBUGG var_dump($infos_utilisateurs);
  		} 
  		/** Enfin, on tente une authentification native **/
  		else
  		{	
  			$infos_utilisateurs = native_auth(); // l, les infos sont rcupres  partir de IEW seul : (table login)
  		}
	  // la variable $infos_utilisateurs contient l'identifiant personnel (numro), le nom de login, l'identifiant du groupe auquel il appartient, le nom et le prnom usuel, la date de fin de validit du compte, l'tat (activ ou non)
  
	  if (isset($infos_utilisateurs[0])) // l'identifiant personnel n'a pas pu tre dfini
  	  {
	    $message .= auth_success($infos_utilisateurs); // renvoie un message vide en cas de connexion effective, ou la raison du refus de connexion le cas chant
  	  } 
  	  elseif ($GLOBALS['flag_auth_ldap']) // les infos de la table login n'ont pas pu tre rcupres mais l'utilisateur est authentifi LDAP
  	  {
  	  	// Cela signifie que l'utilisateur qui se connecte n'est pas dans la base IEW (n'a pas t import lors des imports SCONET/ STS WEB)
  	  	// Il faut prvenir l'utilisateur car ceci ne devrait pas se produire si l'admin fait son boulot d'importation ou de mise  jour de la base lve correctement
  	  	// Ce message ne parvient pas  l'utilisateur en cas d'authentification SSO
  	  	// car la fonction destroy_session_cas() redirige vers index.php (donc la valeur de $message est perdue)
  	  	// Mais cela ne pose pas de problme
  	  	// Il faut simplement savoir qu'un utilisateur, mme authentifi par SSO, ne sera pas autoris  se connecter (sauf cas particulier : voir fonction after_sso_maj_table_login_personnel) s'il ne dispose pas de compte IEW
  	  	// cr par l'import XML des applications de gestion SCONET + STS WEB
  	  	// Et par scurit, la session SSO est dtruite
  	  	// Ceci est transparent pour l'utilisateur car le formulaire de login natif est  nouveau affich
  	  	$message .= "Vous avez t authentifi, mais vous ne pouvez pas vous connecter  IEW car aucun enregistrement ne vous correspond dans la base locale. Demandez  <a href='mailto:".email_encode($GLOBALS['admin_email'])."'>l'administrateur IEW</a> de mettre  jour les donnes en provenance des applications de gestion.";
  	  	//DEBUGG echo $message;exit;
  	  	
  	  	if (isset($_SESSION['CAS'])) // Par prcaution, on dtruit la session CAS pour le service IEW
  	  	{	
  	  		// Malheureusement, dans ce cas, il est impossible d'informer l'utilisateur
  	  		// car les variables de session seront dtruites (aucun moyen de transmettre le message d'erreur $message
  	  		if ($GLOBALS['sso'] == "eolesso")
  	  			cas_logout();
  	  		else
  	  			destroy_session_cas();
  	  	}
  	  }
	  else // l'authentification a chou
	  {
	    $message .= auth_failed(); // renvoie un message d'chec de connexion et permet de faire jusqu' 5 tentatives
	    // DEBUGG echo $message;exit;
  	  }
  	  return $message;
}

function native_auth()
{
	/**
	 * Cette fonction tente d'authentifier l'utilisateur sur la base locale propre  IEW
	 * Elle renvoie en cas de succs un tableau contenant des donnes utilisateurs
	 * En cas d'chec, le tabelau renvoy est vide
	 */
	
	$infos_utilisateurs = login($_POST['username'], $_POST['md5']); // est vide si chec de l'identification
	return $infos_utilisateurs;
}

function auth_success($infos_utilisateurs)
{
	/**
	 * Si l'authentification (quelle que soit la mthode) russie, 
	 * et si l'utilisateur authentifi a le droit (date de validit de compte, tat du compte activ)
	 * on dmarre une session utilisateur
	 * 
	 * Renvoie la variable $message vide en cas de succs, sinon contient la raison du refus de connexion
	 */
	
	 global $message;
	
	// On efface ventuellement les tentatives infructueuses de connexion de cet utilisateur
	    $sql = "DELETE FROM echec_acces WHERE nomlogin='".quote_smart($infos_utilisateurs[4])."'";
	    // DEBUGG echo $sql."<br />";
	    mysql_query($sql);
	    // authentification russie (le compte existe bien), on va vrifier l'autorisation de connexion
	    // DEBUGG var_dump($infos_utilisateurs);exit;
	    $valid_id_user = $infos_utilisateurs[0]; // Contient l'identifiant numrique
	    $valid_login = $infos_utilisateurs[4];
	    $auth_method_user = $infos_utilisateurs[5];
	    $valid_group = $infos_utilisateurs[6];
	    $valid_nom = $infos_utilisateurs[7];
	    $valid_prenom = $infos_utilisateurs[8];
	    $date_expiration_compte = $infos_utilisateurs[9];
	    $etat_compte = $infos_utilisateurs[10];
	    $date_limite_passwd = $infos_utilisateurs[11];
	    switch ($valid_group)
	    {
	    	case "2": // Cas d'un lve
	    		$identifiant_individu = $infos_utilisateurs[2]; // = eleve_id
	    		break;
	    	case "4": // Cas d'un parent
	    		$identifiant_individu = $infos_utilisateurs[3]; // = id_personne
	    		break;
	    	case "3": // Cas d'un prof
	    		$identifiant_individu = $infos_utilisateurs[1]; // = id_individu
	    		break;
	    	default: // dans tous les autres cas on prend l'id_pers de la table login comme identifiant individu
	    	 $identifiant_individu = $valid_id_user;
	    	
	    }
	    $aujourdhui_mysql = convert_date_to_mysql(date("d/m/Y"));
	    	    
	    if ($date_expiration_compte != "") // si la date d'expiration du compte existe
	    {
	      // on remplace les dates par des timestamp pour pouvoir les comparer plus bas
      		$date_expiration_compte = strtotime($date_expiration_compte); // le timestamp n'est calculable que si la date d'expiration existe (c'est--dire non vide) => Sinon cela gnre un warning
      		$aujourdhui_mysql = strtotime($aujourdhui_mysql);
    	}

	    // Le premier test ($aujourdhui_mysql <= $date_expiration_compte) si dessous choue si la date d'expiration du compte n'existe pas,
	    // mais le deuxime ($date_expiration_compte == "") est alors russi, ce qui nous permet d'entrer dans le bloc d'instruction ( condition que le compte soit activ)
	    // Il faut aussi que le mot de passe n'ait pas dpass sa date limite de validit si celle-ci existe
	    // On entre aussi dans ce bloc d'instruction si la mthode d'authentification de l'utilisateur n'est pas native (cas ou ldap)
	    // Car dans ce cas, le mot de passe, donc la date d'expiration du compte et de validit du mot de passe ne sont pas grs par IEW
	    // (valeur NULL dans la table login), par contre il faut tout de mme que le compte soit activ
	    if ((($aujourdhui_mysql <= $date_expiration_compte) || $date_expiration_compte == "") && ($etat_compte == 1) && ($date_limite_passwd != "" && strtotime(date("Y-m-d"))<=strtotime($date_limite_passwd)) || ($valid_login == "admin-iew") || ($auth_method_user != "native" && $etat_compte == 1)) // alors on teste pour savoir si on ne l'a pas dpass
	    {
	      // Ce qui suit permet d'viter une attaque de fixation de session
	      if ($GLOBALS['sso'] != "eolesso") //  ne pas faire sur un serveur scribe car sinon IEW ne prendra pas en compte l'appel de dconnexion centralise du serveur SSO (voir http://dev-eole.ac-dijon.fr/projects/eole-php5-cas/wiki/Wiki) : en effet, si l'ID de session change ici, le serveur SSO n'en serait pas inform
	      {
			// Copie des variables de la session en cours
	      	$tmpSession = $_SESSION;
	        // destruction des anciennes variables
      	    $_SESSION = array();
	        // destruction de l'ancienne session
	        session_destroy();
	        // Utilisation d'un nouvel ID de session
	        session_id(md5(microtime()));
	        // Ouverture de la nouvelle session (avec le nouvel ID)*/
	        if(!defined('SESSION_NAME')) define('SESSION_NAME','IEW');
			session_name(SESSION_NAME);
			session_start();
	        // Rcupration des variables de session sauvegardes
	        $_SESSION = $tmpSession;
	        // On dtruit la variable temporaire devenue inutile
	        unset($tmpSession);
	        // c'est prt !
	      }
	      
	      // Mais les variables sont encore les anciennes (recopies)
	      // Si l'utilisateur vient d'arriver sur une page protge et qu'il vient d'entrer un nouveau couple identifiant/mot de passe, il faut mette fin  l'ancienne connexion dans le journal des connexions
	      // Ceci peut se produire si l'admin fait des test de connexion avec plusieurs comptes
	      // et cela permet d'enregistrer l'heure de fin de connexion avec le compte prcdent
	      if (isset($_SESSION['valid_login']) && $_SESSION['valid_login']!=$valid_login)
	      {
	        $fin_connexion = time();
	        // On met  jour le journal des connexions
	        $sql = "UPDATE journal_connexions SET fin='$fin_connexion' WHERE id_connexion='".$_SESSION['id_connexion']."'";
	        mysql_query($sql);
	      }

	      // on enregistre ces variables pour les rendre disponibles pour toute la session
	      $_SESSION['valid_id_user'] = $valid_id_user;
	      $_SESSION['valid_login'] = $valid_login;
	      $_SESSION['auth_method_user'] = $auth_method_user;
	      $_SESSION['valid_group'] = $valid_group;
	      $_SESSION['valid_nom'] = $valid_nom;
	      $_SESSION['valid_prenom'] = $valid_prenom;
	      $_SESSION['date_limite_passwd'] = $date_limite_passwd;
	      $_SESSION['identifiant_individu'] = $identifiant_individu;
	      //$_SESSION['nb_messages'] = $nb_messages;
	      $_SESSION['dernier_acces'] = time(); // la session sera sur un timeout
	      $_SESSION['ipaddr'] = realip(); // pour plus de scurit, on garde l'IP du client
	      $_SESSION['id_navigateur'] = $_SERVER['HTTP_USER_AGENT'];
	      $navigateur = get_navigator(); // voici le nom (libell court) rel du navigateur
	      $debut_connexion = time();
	      $last_request = $debut_connexion; // c'est la premire requte
	
	      // On enregistre la connexion dans le journal des connexions
	      $sql = "INSERT INTO journal_connexions VALUES(NULL,'$valid_id_user','$debut_connexion','','$last_request','".$_SESSION['ipaddr']."','$navigateur')";
	      // DEBUGG print "<br />".$sql."<br />";
	      mysql_query($sql);
	      $_SESSION['id_connexion']=mysql_insert_id(); // On rcupre l'identifiant de connexion cr
	
	      if ($_SESSION['valid_group'] == "4") // dans le cas d'un parent, il y a d'autres infos  rcuprer
	      {
	        // On recherche les identifiants de ses enfants et on les stocke dans une variable de session
	        $sql1 = "SELECT t1.eleve_id,t1.nom,t1.prenom,t1.classe FROM eleves as t1, responsables as t2, responsables_eleves as t3 WHERE t1.eleve_id=t3.eleve_id AND t2.personne_id=t3.personne_id AND t2.personne_id='$identifiant_individu' ORDER BY t1.nom,t1.prenom";
	        $resultat1 = mysql_query($sql1);
	        while ($ligne=mysql_fetch_array($resultat1))
	        {
	          $_SESSION['enfants_scol'][] = $ligne['eleve_id'].",".$ligne['nom'].",".$ligne['prenom'].",".$ligne['classe'];
	        }
	        //print_r($_SESSION['enfants_scol']);
	      }
	      elseif($_SESSION['valid_group'] == "11") // Pour les IPR, on rcupre les donnes qui seront ncessaires lors de leur session utilisateur
	      {
	      	cherche_infos_ipr();
	      }
	    }
	    else
	    {
	      // Le compte utilisateur a expir ou est dsactiv
	      // Echec de l'authentification, on recharge la page
	      $message .= "Votre compte est dsactiv ou a expir ! Vous ne pouvez pas vous connecter  l'application. Veuillez contacter <a href='mailto:".email_encode($GLOBALS['admin_email'])."'>l'administrateur IntraEduWeb</a>.<br />";
    	}
	return $message;
}

function auth_failed()
{
	/**
	 * Si l'authentification choue (toute mthode sauf SSO), on laisse la possibilit d'effectuer 4 tentatives supplmentaires
	 */
	
	global $message;
	
	// Si le nom d'utilisateur est reconnu, il reste 4 tentatives encore possibles
    	$sql = "SELECT nomlogin FROM login WHERE nomlogin='".quote_smart($_POST['username'])."'";
	    $result = mysql_query($sql);
    	if ($result && mysql_num_rows($result) >0)
	    {
	      // Scurit : il faut limiter le nombre de tentatives d'accs infructueuses par heure  5
	      // On recherche d'abord le nombre de tentatives ayant chou avec ce nom d'utilisateur
	      $sql = "SELECT id,connect_failed_nb,heure FROM echec_acces WHERE nomlogin='".quote_smart($_POST['username'])."'";
	      $resultat = mysql_query($sql);
	      if ($resultat && mysql_num_rows($resultat) > 0) // Il y a dj eu au moins une tentative infructueuse avec ce nom d'utilisateur
	      {
	        $ligne = mysql_fetch_array($resultat);
	        $heure = $ligne['heure']; // On rcupre le timestamp de cette tentative
	        if (time()-$heure < 3600)
	        {
	          // On incrmente le nombre de tentatives de connexion choues au cours de la dernire heure
	          $connect_failed_nb = $ligne['connect_failed_nb']; // dans une variable de session pour tre disponible au rechargement de la page
	          $connect_failed_nb++;
	          $connexion_try_to_go = 5 - $connect_failed_nb;
	          $id = $ligne['id'];
	          $sql = "UPDATE echec_acces SET connect_failed_nb='$connect_failed_nb' WHERE id='$id'";
	          mysql_query($sql);
	        }
	        else // Les dernires tentatives ayant chou remontent  plus d'une heure : on les efface
	        {
	          $sql = "DELETE FROM echec_acces WHERE nomlogin='".quote_smart($_POST['username'])."'";
	          mysql_query($sql);
	          // et on rinscrit la nouvelle (qui devient donc la premire tentative choue)
          	  $sql = "INSERT INTO echec_acces VALUES(NULL,'".quote_smart($_POST['username'])."','1','".time()."')";
	          mysql_query($sql);
        	}
	        if ($connect_failed_nb >=5)
	        {
	          // Il faut bloquer toute nouvelle tentative pendant une heure :
	          // la prochaine tentative de login (fonction login) va provoquer une lecture de la table echec_acces
	          // et si le dcalage des timestamp est infrieur  une heure avec un nombre de tentatives choues
	          // suprieur ou gal  5, l'accs sera bloqu pendant le temps restant ( concurrence d'une heure)
	          $message .= "Echec de la dernire tentative d'authentification. L'accs est bloqu ! Il faudra ressayer ultrieurement...<br />";
        	}
     	  }
      	  else // pas de tentative prcdente infructueuse dtecte
      	  {
	        // On inscrit la premire tentative de connexion infructueuse
    	    $sql = "INSERT INTO echec_acces VALUES(NULL,'".quote_smart($_POST['username'])."','1','".time()."')";
        	mysql_query($sql);
      	  }
	      // Echec de l'authentification, on recharge la page
      	  if (!isset($connexion_try_to_go))
        	$connexion_try_to_go = 4;
      	  $message .= "Echec de l'authentification. Vous avez encore $connexion_try_to_go tentative(s) autorise(s) !<br />";
    	}
    	else // Le nom d'utilisateur n'est pas reconnu, on jette ! (et on recharge la page)
    	{
      		$message .= "Echec de l'authentification. Renouvelez votre tentative !<br />";
    	}
    return $message;
}

function affiche_formulaire_login()
{
 echo "<h2 class='hidden'>Formulaire de connexion</h2>";
 $ldap_flag = false; // a priori pas d'identification sur ldap
 // On inclut ici du code javascript qui sert  l'authentification avec un hashage MD5 ct client du mot de passe fourni dans le formulaire de login :ainsi le mot de passe n'est pas transmis au serveur (on limine le risque d'interception de celui-ci) mais seulement sa signature MD5.
 echo "<script type=\"text/javascript\" src=\"".$GLOBALS["racine"]."javascript/login.js\"></script>
 <script type=\"text/javascript\" src=\"".$GLOBALS["racine"]."javascript/decorate_labels.js\"></script>";
 
 $chemin_relatif = $GLOBALS['chemin_relatif'];
 $code_formulaire = "";
 $titre_fieldset = "Authentification";
 if ($GLOBALS['auth_method'] != "native") // si la mthode d'authentification ne se fait pas localement
 {
   switch($GLOBALS['auth_method'])
   {
   		case "cas":
   			$code_formulaire = "<p id='link_auth_server'><a href='".$GLOBALS["racine"]."index.php'>S'authentifier sur le serveur <abbr lang='en' title='Single Sign On'>SSO</abbr></a></p>";
   			$ldap_flag = true; // authentification sur ldap
   			$titre_fieldset .= " locale"; // L'alternative d'authentification ne peut tre que locale
   			break;
   		case "lemonldap":
   			$titre_fieldset .= " locale ou sur annuaire LDAP";
   			break;
   		case "ldap":
   			$ldap_flag = true;
   			$titre_fieldset .= " locale ou sur annuaire LDAP";
   			break;
   		default:
   			$titre_fieldset .= " locale";
   }
 }
 $code_formulaire .= "
 <fieldset id='login_fields'>
 	<legend>$titre_fieldset</legend>
 	<input type='hidden' id='loginForm_md5_hide' name='md5' />";
    if ($ldap_flag)
    {
    	$code_formulaire .= "<input type='hidden' id='loginForm_ldap_passwd' name='ldap_passwd' />";
    }
 	$code_formulaire .= "
 	<div id='login_form'>
 	<p>
 		<label for='loginForm_Req_username' accesskey='D'>Identifiant</label>
 		<input type='text' id='loginForm_Req_username' name='username' size='20' />
 	</p>
 	<p>
 		<label for='loginForm_Req_password' accesskey='M'>Mot de passe</label>
 		<input type='password' id='loginForm_Req_password' name='passwd' size='20' />
 	</p>
 	</div>
 	<p id='lost_passwd'><a href='".$chemin_relatif."mdp_perdu.php'>J'ai oubli mon mot de passe</a></p>
 </fieldset>";
 squelette_formulaire_standard("75%","post","' id='log' onsubmit='javascript:submit_pass();","Se connecter<img src='".$chemin_relatif."images/pixel.gif' width='30' height='2' alt='' /><img src='".$chemin_relatif."images/connected.png' alt='icone_connected' />",$code_formulaire,"Valider","","Annuler","","","","");
 echo "<script type='text/javascript'><!--
 document.forms['log'].loginForm_Req_username.focus();
 //--></script>";
}

function login($username, $md5_password)
// Vrifie si l'utilisateur est enregistr (donc autoris)
// Si oui, retourne l'enregistrement utilisateur
// Sinon ne retourne rien
{
  // connexion  la base de donnes
  $username = trim(htmlspecialchars(quote_smart($username)));
  $md5_password = trim(htmlspecialchars(quote_smart($md5_password)));
  if (check_nbmax_failed_connect($username))
  {
  	return;
  }
  // On arrive ici dans 2 cas :
  // - C'est la 1re tentative de connexion
  // - Les tentatives prcdentes ne dpassent pas la maximum autoris (5)
  $sql = "SELECT id_pers,id_individu,eleve_id,id_personne,nomlogin,auth_source,id_gpe_utilisateurs,nom,prenom,date_validite,etat,limit_date_passwd FROM login WHERE nomlogin ='$username' AND mot_pass = '$md5_password'";
  $result = mysql_query($sql);
  if (!$result || mysql_num_rows($result)==0)
    return;

  $ligne = mysql_fetch_row($result); // Un enregistrement unique sous forme de tableau associatif
  return $ligne;
}

function user_record_in_login_table($username)
{
	/**
	 * Retourne l'enregistrement de la table login correspondant  l'utilisateur authentifi
	 * par un mcanisme SSO ou LDAP (non natif)
	 */
	
	// Pas besoin de mot de passe dans la requte car l'utilisateur est dj authentifi (SSO ou LDAP)
	$sql = "SELECT id_pers,id_individu,eleve_id,id_personne,nomlogin,auth_source,id_gpe_utilisateurs,nom,prenom,date_validite,etat,limit_date_passwd FROM login WHERE nomlogin ='$username' ORDER BY id_gpe_utilisateurs";
	// La requte peut potentiellement donner plus d'un rsultat : il s'agit dans ce cas d'un bug ou d'un cas qui doit tre examin par l'administrateur
	// DEBUGG print $sql."<br />";
	$result = mysql_query($sql);
  	if (!$result || mysql_num_rows($result)==0)
    	return;
	if (mysql_num_rows($result) > 1) // cas probable de bug
	{
		$error_message = array("Votre identifiant correspond  2 comptes IEW. Il ne vous est pas possible pour l'instant de vous connecter. Signalez le problme  votre <a href='mailto:".email_encode($admin_email)."'>administrateur IEW</a>, en prcisant bien ce message d'erreur.","");
		affiche_erreurs($error_message);
		die();
	}
  	$ligne = mysql_fetch_row($result); // Un enregistrement unique sous forme de tableau associatif
  	// DEBUGG print "Rcup par user_record_in_login_table : ";var_dump($ligne);
  	return $ligne;
}

function check_authentication()
{
	/**
	 * Vrifie si l'utilisateur est authentifi (dans ce cas, ne fait rien)
	 * Dans le cas contraire, renvoie vers le formulaire d'authentification
	 * 
	 */
	
	$message = "";
	
	if (!isset($_SESSION['valid_id_user'])) // pas de session utilisateur ouverte
	{
		if ($GLOBALS['auth_method'] == "cas" && ((isset($_GET['log']) && $_GET['log'] != 'locale' ) || (!isset($_GET['log'])))) // la mthode d'authentification dfinie par dfaut  l'install est CAS (SSO)
		{ 
			/* On va rediriger vers le formulaire du serveur SSO
			A CONDITION TOUTEFOIS QUE :
			- on n'ait pas de paramtre log=locale dans l'URL (permet une authentification locale pour l'admin IEW)
			*/
						
			if ($GLOBALS['sso'] == "eolesso")
			{
				// Si on utilise une authentification EoleSSO
				cas_auth();
				// La suite du code s'xcute uniquement si l'utilisateur est authentifi
				// Scurit des sessions : on modifie l'id de session
				/* Voir le memo dev (+ anomalie n78) pour comprendre pourquoi les 2 instructions suivantes sont dsactives
				session_regenerate_id(true); // le paramtre optionnel $delete_old_session est mis  true pour dtruire l'ancienne session sinon les fichiers de sessions s'accumulent 
				modify_session_id_with_eolecas_ticket();
				*/
				$_SESSION['CAS'] = "true"; // Important pour la dconnexion, voir deconnexion.php
				$_POST['username'] = eolephpCAS::getUser(); // la fonction getDetails() sera utilise + tard
				// On simule un POST avec cette valeur
				// On va pouvoir rcuprer les informations manquantes sur le serveur SSO : attributs
				// et d'abord voir si un compte iew existe dj
				$GLOBALS['flag_auth_ldap'] = true; // indique que l'utilisateur a t authentifi
				$message .= try_login(); // Vide si pas d'erreur
				if ($message == "") // si pas d'erreur on vrifie si la charte IEW est accepte
					verif_accept_charte();
				return $message; // s'il y a erreur, cette erreur apparatra dans le message			
			}
			else // Authentification CAS classique (avec le client CAS par dfaut fourni avec IEW)
			{
				include_once(IEW_DIR.'/lib/CAS.php'); // Accs  la librairie phpCAS
				phpCAS::setDebug(); // mode dbugg
				phpCAS::client(CAS_VERSION_2_0,$GLOBALS['cas_server_name'],intval($GLOBALS['cas_server_port']),''); // initialise phpCAS en tant que client
				phpCAS::setLang(PHPCAS_LANG_FRENCH); 	// set the language to french
				phpCAS::setNoCasServerValidation();
				phpCAS::forceAuthentication();
				$auth = phpCAS::checkAuthentication();
				if ($auth) // Authentification russie
				{
					// Scurit des sessions : on modifie l'id de session
					session_regenerate_id(true); // le paramtre optionnel $delete_old_session est mis  true pour dtruire l'ancienne session sinon les fichiers de sessions s'accumulent 
					$_SESSION['CAS'] = "true"; // Important pour la dconnexion, voir deconnexion.php
					$_POST['username'] = phpCAS::getUser(); //phpCAS ne peut rcuprer que l'identifiant utilisateur, pas les rles et attributs
					// On simule un POST avec cette valeur
					// On va pouvoir rcuprer les informations manquantes sur le serveur LDAP : attributs
					// et voir si un compte iew existe dj
					$GLOBALS['flag_auth_ldap'] = true; // indique que l'utilisateur a t authentifi
					$message .= try_login(); // Vide si pas d'erreur			
				}
				else
				{
					$message .= "Pour une raison inconnue, le serveur SSO n'a pas pu vous identifier.<br />";
				}
				if ($message == "") // si pas d'erreur on vrifie si la charte IEW est accepte
					verif_accept_charte();
				return $message; // s'il y a erreur, cette erreur apparatra dans le message	
			}
		}
		elseif ((isset($_POST['username']) && $_POST['username'] != "") && (isset($_POST['md5']) && $_POST['md5'] != "")) // Le formulaire de connexion propre  IEW a t rempli
		{
	  		$message .= try_login(); // Vide si pas d'erreur
	  		if ($message == "") // ok, utilisateur authentifi
	  		{
	  			// Scurit des sessions : on modifie l'id de session
				session_regenerate_id(true); // le paramtre optionnel $delete_old_session est mis  true pour dtruire l'ancienne session sinon les fichiers de sessions s'accumulent
				verif_accept_charte(); 
	  		}
	  		return $message; // s'il y a erreur, cette erreur apparatra dans le message	
		} 
		elseif ((isset($_POST['username']) && $_POST['username'] == "") XOR (isset($_POST['md5']) && $_POST['md5'] == "")) // Si le formulaire d'identification a t valid sans tre rempli compltement
		{
		  // Echec de l'authentification, on recharge la page
  			$message .= "Formulaire incomplet : Echec de l'authentification. Renouvelez votre tentative !<br />";
  			return $message;
		}
		elseif (isset($_POST['username'])) // S'il y a eu un post du formulaire
		{
			 // Echec de l'authentification, on recharge la page
  			$message .= "Le Formulaire est vide !<br />Echec de l'authentification. Renouvelez votre tentative !<br />";
  			return $message;
		}
		// S'il n'y  pas eu de post de formulaire, on raffiche la page d'accueil avec le formulaire de login et le message de coypright
	}
	elseif (time() - $_SESSION['dernier_acces']>$GLOBALS['session_timeout']) // Utilisateur connect, mais on vrifie si le timeout n'est pas dpass, sinon on jette
    {  
      /* On ne peut pas afficher de message ici indiquant ce qui s'est pass car comme on va dconnecter
       * et appeler la fonction header(), il ne faut qu'aucun affichage n'ait eu lieu
       * donc on dconnecte directement
       */
    	deconnexion();
    }
	else // Utilisateur connect et le timeout n'est pas dpass
	{
		return $message; // Renvoie une variable vide si authentification dj faite
	}
}

function destroy_session_cas()
{
	/**
	 * Ferme une session CAS en cours et la session IEW du mme coup
	 */
	include_once(IEW_DIR.'/lib/CAS.php'); // Accs  la librairie phpCAS
	phpCAS::setDebug(); // mode dbugg
	phpCAS::client(CAS_VERSION_2_0,$GLOBALS['cas_server_name'],intval($GLOBALS['cas_server_port']),''); // initialise phpCAS en tant que client
	//phpCAS::proxy(CAS_VERSION_2_0,$GLOBALS['cas_server_name'],intval($GLOBALS['cas_server_port']),''); // initialise phpCAS en tant que client proxy (car IEW est un portail web)
	phpCAS::setLang(PHPCAS_LANG_FRENCH); 	// set the language to french
	$protocole = get_protocol_http($_SERVER['SCRIPT_URI']);
	$urlretour = $protocole.$_SERVER['HTTP_HOST'].$GLOBALS['racine']."index.php";
	// On peut dtruire la session (dconnexion effective)
	destroy_session_IEW();
	phpCAS::logoutWithUrl($urlretour);
}

function destroy_session_IEW()
{
	/**
	 * Ferme une session IEW
	 */
	if (isset($_SESSION['valid_id_user']) && $_SESSION['valid_id_user'] !="") // On s'assure qu'il y avait bien une session IEW
	{
		$_SESSION = array();
		session_destroy();
	}
}

function check_valid_user($array_valid_user)

//***************************** description *****************************************************************//
 // cette fonction est utilise sur chaque page  accs protg du site, elle
 // vrifie si l'utilisateur est authentifi et actif (un timeout est programm), sinon elle affiche
 // le formulaire de login
 // paramtres entrs : $array_valid_user, tableau contenant les catgories d'utilisateurs autorises 
 // accder  la page appelante
 // sortie : retour au script d'appel en cas de succes et en cas d'echec, affichage du formulaire de login
 // Retourne un tableau $error_message  2 lments : le premier contient le message d'erreur (vide si succs)
 // le deuxime est un paramtre qui permet d'indiquer  la fonction affiche_erreurs ce qu'elle doit afficher aprs le message d'erreur :
 // - login ou log-cas => Raffichage du formulaire d'identifaction
 // - charte => Affichage du formulaire d'acceptation de la charte IEW
 // auteur : S.GODM (sylvain.godme@gmail.com)
 // Date de dernire mise  jour : 
 //***************************** Fin description ***********************************************************//

//
{
  // $log_type est le 2me lment du tableau $error_message, sa valeur "login" ou "logout" permet d'indiquer  la fonction affiche_erreurs ce qu'elle doit afficher aprs le message d'erreur
  if ($GLOBALS['auth_method'] == "cas")
  	$log_type = "log-cas"; // Aprs le message d'erreur, on affichera le formulaire CAS (Redirection CAS)
  else // cas d'authentification native ou ldap
  	$log_type = "login"; // Aprs le message d'erreur, on affichera le formulaire d'authentification IEW 
  $succes="faux"; // On suppose au dpart que l'accs n'est pas autoris
  if (isset($_SESSION['valid_login'])) // Si l'utilisateur est dej authentifi
  {	
  	// On teste d'abord si le compte n'a pas t dsactiv par un administrateur depuis le dpart de la connexion (par exemple et entre autres, en cas de clture de l'anne scolaire)
  	$sql = "SELECT etat FROM login WHERE id_pers='".$_SESSION['valid_id_user']."'";
    $resultat = mysql_query($sql);
  	if ($resultat && mysql_num_rows($resultat)>0)
  	{
  		$ligne = mysql_fetch_array($resultat);
  		if ($ligne['etat'] == 0) // le compte vient d'tre dsactiv : on force la dconnexion
  			deconnexion();
  	}
  	
  	// Sinon vrifie s'il a le droit d'accs  la page demande	
	// On commence par vrifier si l'utilisateur authentifi a accept la charte d'utilisation IntraEduWeb (au cas o)
    $sql = "SELECT id_pers from accept_charte WHERE id_pers='".$_SESSION['valid_id_user']."'";
    $resultat = mysql_query($sql);
    if (mysql_num_rows($resultat)==0) // pas de signature enregistre
    {
      $error_message = array("C'est votre premire connexion  IntraEduWeb !<br />Ou bien vous n'avez pas encore accept la charte IntraEduweb<br /><br /><div align='justify'>Pour accder  toutes les informations internes,</font> <b><font color='black'>vous devez au pralable accepter de respecter la charte des droits et devoirs de l'utilisateur</b></font> prsente ci-dessous.<br />Aprs avoir cliqu sur le bouton <font color='black'><b>Accepter</b></font>, il vous faudra  nouveau vous identifier pour accder pleinement au site</div>","charte");
      // DEBUGG echo "t'as pas  sign la charte !<br />";
      return $error_message;
    }
    // On vrifie d'abord si le timeout n'est pas dpass, sinon on jette
    if (time() - $_SESSION['dernier_acces']>$GLOBALS['session_timeout'])
    {  
      /* On ne peut pas afficher de message ici indiquant ce qui s'est pass car comme on va dconnecter
       * et appeler la fonction header(), il ne faut qu'aucun affichage n'ait eu lieu
       * donc on dconnecte directement
       */
    	deconnexion();
    }
    // On vrifie ensuite que l'adresse IP est la mme, et le navigateur aussi, sinon on jette 
    if ($_SESSION['ipaddr'] != realip() || $_SESSION['id_navigateur'] != $_SERVER['HTTP_USER_AGENT'])
    {
      deconnexion();
    }
    if ($_SESSION['valid_login']=="admin-iew") // Accs autoris pour l'administrateur IntraEduweb
	{
      
	}
	else // Si ce n'est pas l'administrateur IntraEduweb
	{
		foreach($array_valid_user as $value) // On parcourt chaque lment du tableau d'authentification
		{
			if ($value==$_SESSION['valid_group'] || $value=="tous") // Si la cl de l'lment de tableau gale la categorie de l'utilisateur ou si accs pour tous les utilisateurs dj authentifis
			{
				$succes = "vrai";
    	        break;
			}
        	else
        	{
          		$succes = "faux";
        	}
		}
		if ($succes=="faux") // Si l'accs  la page est refus, un message s'affiche, mais l'utilisateur n'est pas dconnect
		{
        	$error_message = array("<strong>Vous tentez d'accder  une page protge pour laquelle vous n'avez pas les droits d'accs.</strong>","");
        	return $error_message;
		}
		else		// Si l'accs est autoris, retour au script d'appel
		{
        	return;
		}
	}
  }
  else	// Si l'utilisateur n'a pas encore t authentifi
  {
  	return check_authentication(); // on va authentifier l'utilisateur
  }
}

function random_password($length)

//***************************** description *****************************************************************//
 // cette fonction renvoie un mot de passe alatoire
 // paramtres entrs : $length, la longueur souhaite du mot de passe
 // sortie : Renvoie le mot de passe gnr (en clair)
 // auteur : S.GODM (sylvain.godme@gmail.com)
 // Date de cration :	23/07/2003
 // Date de dernire mise  jour : 25/11/2006
 //***************************** Fin description ***********************************************************//

{
    $possible_charactors = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890";
    $string = "";
    while(strlen($string)<$length)
    {
        $string .= substr($possible_charactors,rand()%(strlen($possible_charactors)),1);
    }
    return($string);
}


function prepare_login($prenom,$nom)

//***************************** description *****************************************************************//
 // cette fonction renvoie une chane dbarrasse de ses caractres accentus et de ses espaces (elle est utilise
 // notamment pour fabriquer des noms de login
 // paramtres entrs : $chaine, la chaine  nettoyer
 // sortie : Renvoie la chaine nettoye
 // auteur : S.GODM (sylvain.godme@gmail.com)
 // Date de cration :	26/07/2003
 // Date de dernire mise  jour : 10/10/2005
 //***************************** Fin description ***********************************************************//

{
	$flag_tiret="";
        // si le nom est compos avec un tiret, on pose un flag
	if (stristr($nom,"-"))
	{
		$flag_tiret="TRUE";
	}
	$login_brut=strtolower(substr($prenom,0,1).$nom); //login brut = 1re lettre du prnom suivi du nom (le tout en minuscules)
	$login_sans_accents=strtr($login_brut,"'-","eeeeaiicuuoo  ");
	// on retire les espaces s'il y en a
	$fragment=explode(" ",$login_sans_accents);
	$login_propre="";
	foreach ($fragment as $value)
	{
		$login_propre.=$value;  //  la fin, on aura une chaine propre, sans espace, ni cc accentu
	}
	if ($flag_tiret=="TRUE")
	{
		$login_propre=substr($login_propre,0,11); // on tronque le login  11 caractres (compatibilit iac)
	}
	return $login_propre;
}

function test_exist_login($login)

//***************************** description *****************************************************************//
 // cette fonction permet de tester si le login qui vient d'tre cr, n'existe pas dj
 // en authentification native. Les login provenant d'authentification non native (LDAP)
 // ne peuvent pas donner de doublons (en principe)
 // paramtres entrs : $login , le login propos
 // sortie : Renvoie un login unique (authentification native uniquement)
 // auteur : S.GODM (sylvain.godme@gmail.com)
 // Date de cration :	30/07/2003
 // Date de dernire mise  jour : 28/08/2007
 //***************************** Fin description ***********************************************************//
{
	$valnum = 0;
        // on s'assure que le login n'existe pas dj
	$sql="SELECT nomlogin FROM login WHERE nomlogin like '".quote_smart($login)."%' AND auth_source='native'"; // on recherche les nomlogin commenant pareil
	$resultat=mysql_query($sql);
	if ($resultat && mysql_num_rows($resultat)!=0) // s'il existe dj un ou des login commenant par $cleanlogin
	{
		while($ligne=mysql_fetch_array($resultat)) // on tudie tous les cas trouvs
		{
			$fin_login=substr($ligne['nomlogin'],strlen($login),strlen($ligne['nomlogin'])-strlen($login)); // on extrait la portion % du like (cf $sql)
			// la prtion obtenue peut-tre vide (mme nomlogin) ou "1" ou "2" ou tt nombre ou "autre chane"
			if (!$fin_login || intval($fin_login)!=0) // Si portion vide ou contient un nombre
			{
				$valnum=intval($fin_login); // on regarde sa valeur numrique de la portion
				$valnum++; // on l'incrmente
			}
		}
		if ($valnum!=0) // si le login a t incrment
		{
			$login=$login.strval($valnum); // voil le nouveau login incrment d'un chiffre
		}
	}
	return $login;
}

function check_del_access_absences($id_transaction)
 //***************************** description *****************************************************************//
 // cette fonction permet de s'assurer que l'utilisateur qui tente d'effacer une entre dans la table des absences enregistres a le droit de la faire :
 // - si c'est lui-mme qui avait effectu l'enregistrement initial
 // - si c'est un membre du groupe direction ou surveillant (vie scolaire)
 // Date de cration : 15/12/2004
 // Date de dernire mise  jour : 
 //***************************** Fin description ***********************************************************//
 {
   $valid_group = $_SESSION['valid_group'];
   global $classe_del; // est utilis pour transmettre (si effacement autoris) le nom de la classe concern :
   // c'est utile pour afficher un message d'erreur ventuel uniquement  l'endroit concernant cette classe sur le cahier d'appel
   
   // On recherche "le propritaire" de la transaction qui avait t faite
   $sql = "SELECT id_pers,classe FROM liste_absents_transactions where id_transaction='".quote_smart($id_transaction)."'";
   // DEBUGG echo $sql."<br />";
   $resultat = mysql_query($sql);
   $ligne = mysql_fetch_array($resultat);
   $classe_del = $ligne['classe']; // On enregistre la classe concerne
   // DEBUGG echo $classe_del."<br/>";
   if ($ligne['id_pers'] == $_SESSION['valid_id_user']) // Le proprio est bien celui qui essaye d'effacer, on le laisse faire
   {
     return true;
   }
   else // ce n'est pas le proprio
   {
     if ($valid_group=="6" || $valid_group=="8" || $valid_group=="1") // Si c'est un membre du groupe direction ou surveillant ou un admin intraeduweb
     {
       // On le laisse faire
       return true;
     }
     else // Ce n'est pas une personne autorise
     {
       return false;
     }
   }
 }
 
function verif_password($password)
//***************************** description *****************************************************************//
 // cette fonction permet de vrifier la validit d'un mot de passe dans un champ de formulaire
 // Date de cration : 12/01/2005
 // Date de dernire mise  jour : 
 //***************************** Fin description ***********************************************************//
{
  $error_message = "";
  if(!preg_match('#^[[:alnum:]_-]{8,20}$#', $password))
  {
    $error_message = "Le mot de passe doit contenir au moins 8 caractres (maximum 20) et comporter des caractres alphanumriques, tiret ou caractre de soulignement";
  }
  return $error_message;
}

function cree_compte_iew($nom_cle_jointure,$valeur_cle_jointure,$identifiant,$nom_utilisateur,$prenom_utilisateur,$id_gpe_utilisateurs,$fichier_enregistrement_codes1,$fichier_enregistrement_codes2)
{
  //***************************** description *****************************************************************//
 // cette fonction permet de crer un compte utilisateur IEW
 // En mode d'authentification native, $dentifiant est vide
 // et on enregistre les codes d'accs dans un fichier texte
 // $fichier_enregistrement_codes doit tre un pointeur vers un fichier DEJA OUVERT !!!!
 // Si $fichier_enregistrement_codes est vide, l'enregistrement des codes d'accs dans le fichier texte
 // n'aura pas lieu (authentification non native)
 // Date de cration : 24/02/2006
 // Date de dernire mise  jour : 
 //***************************** Fin description ***********************************************************//
  
	
	// Le $flag_no_user_ldap_import sert  indiquer que la cration du compte IEW doit avoir lieu
	// avec cration d'un mot de passe (et inscription dans un fichier de diffusion),
	// mme si la mthode d'authentification par dfaut n'est pas native
	// En effet, certains utilisateurs de IEW (notamment les parents, ipr, certais membres du personnel de l'tablissement)
	// ne sont pas authentifis sur l'annuaire LDAP (en attendant l'arrive des annuaires ENT ou fdrateurs)
	// Il faut positionner ce flag  true avant l'appel  cette fonction
	// et le repositionner  false aprs l'appel	

  // Il faut retirer les anti-slashs ventuels sur le nom et le prnom
  // Ce peut-tre le cas si les donnes proviennent d'une table MySQL
  $prenom_utilisateur = stripslashes($prenom_utilisateur);
  $nom_utilisateur = stripslashes($nom_utilisateur);
  // Prparation de l'identifiant pour une authentification native ou utilisateur hors annuaire LDAP
  if ($GLOBALS['auth_method'] == "native" || (isset($GLOBALS['flag_no_user_ldap_import']) && $GLOBALS['flag_no_user_ldap_import']))
  {
  	$login=prepare_login($prenom_utilisateur,$nom_utilisateur); // On formate le login
	$login=test_exist_login($login); // On s'assure qu'il est unique (modifi si ncessaire)
  	$password=random_password(8); // On gnre un mot de passe de 8 caractres
    $md5_password = md5($password); // on le hashe (ne sera pas en clair dans la table)
    // Sa dure de validit est paramtrable dans config.php (en nombre de mois)  moins que la table semab soit renseigne
    $sql = "SELECT dbt_ete FROM semab";
    $resultat = mysql_query($sql);
    if ($resultat && mysql_num_rows($resultat) > 0) // la table semab est renseigne : a date limite de validit du mot de passe est la date de fin d'anne scolaire
    {
    	$ligne = mysql_fetch_array($resultat);
    	$limit_date_passwd = $ligne['dbt_ete']; // cette date limite pourra tre remodifie automatiquement lors de la saisie des dates du calendrier scolaire (voir c_saisie_semab.php)
    }
    if (!isset($limit_date_passwd))
    {
    	$today = strtotime(date("Y-m-d"));
    	$upto = $today+60*60*24*30*$GLOBALS['validite_mdp'];
    	$limit_date_passwd = date("Y-m-d",$upto);	
    }
    // On crit ces infos dans la base de donnes (table login)
  	switch ($nom_cle_jointure )
  	{
  		case "id_individu": // Cas d'un professeur ou d'un membre du personnel
  			$sql = "INSERT INTO login VALUES(NULL,'".quote_smart($valeur_cle_jointure)."',NULL,NULL,'".quote_smart($login)."','native','".quote_smart($id_gpe_utilisateurs)."','".quote_smart($md5_password)."','".quote_smart($nom_utilisateur)."','".quote_smart($prenom_utilisateur)."',NULL,'1','".quote_smart($limit_date_passwd)."')";
  		    break;
  		case "eleve_id": // Cas d'un lve
			$sql = "INSERT INTO login VALUES(NULL,NULL,'".quote_smart($valeur_cle_jointure)."',NULL,'".quote_smart($login)."','native','".quote_smart($id_gpe_utilisateurs)."','".quote_smart($md5_password)."','".quote_smart($nom_utilisateur)."','".quote_smart($prenom_utilisateur)."',NULL,'1','".quote_smart($limit_date_passwd)."')";
  			break;
  		case "id_personne": // Cas d'un responsable
			$sql = "INSERT INTO login VALUES(NULL,NULL,NULL,'".quote_smart($valeur_cle_jointure)."','".quote_smart($login)."','native','".quote_smart($id_gpe_utilisateurs)."','".quote_smart($md5_password)."','".quote_smart($nom_utilisateur)."','".quote_smart($prenom_utilisateur)."',NULL,'1','".quote_smart($limit_date_passwd)."')";
  			break;
  		default:
  			$sql = "INSERT INTO login VALUES(NULL,NULL,NULL,NULL,'".quote_smart($login)."','native','".quote_smart($id_gpe_utilisateurs)."','".quote_smart($md5_password)."','".quote_smart($nom_utilisateur)."','".quote_smart($prenom_utilisateur)."',NULL,'1','".quote_smart($limit_date_passwd)."')";
  	}
  }
  else // Mthode d'authentification par SSO ou LDAP
  {
    $login = $identifiant; // Pour une authentification non native, l'identifiant est vide  la cration du compte
  	// Le mot de passe n'est pas gr par IEW (mis  NULL dans $sql comme limit_date_passwd)
  	// On crit ces infos dans la base de donnes (table login)
  	switch ($nom_cle_jointure )
  	{
  		case "id_individu": // Cas d'un professeur ou d'un membre du personnel
  			$sql = "INSERT INTO login VALUES(NULL,'".quote_smart($valeur_cle_jointure)."',NULL,NULL,'".quote_smart($login)."','".quote_smart($GLOBALS['auth_method'])."','".quote_smart($id_gpe_utilisateurs)."',NULL,'".quote_smart($nom_utilisateur)."','".quote_smart($prenom_utilisateur)."',NULL,'1',NULL)";
  		    break;
  		case "eleve_id": // Cas d'un lve
			$sql = "INSERT INTO login VALUES(NULL,NULL,'".quote_smart($valeur_cle_jointure)."',NULL,'".quote_smart($login)."','".quote_smart($GLOBALS['auth_method'])."','".quote_smart($id_gpe_utilisateurs)."',NULL,'".quote_smart($nom_utilisateur)."','".quote_smart($prenom_utilisateur)."',NULL,'1',NULL)";
  			break;
  		case "id_personne": // Cas d'un responsable
			$sql = "INSERT INTO login VALUES(NULL,NULL,NULL,'".quote_smart($valeur_cle_jointure)."','".quote_smart($login)."','".quote_smart($GLOBALS['auth_method'])."','".quote_smart($id_gpe_utilisateurs)."',NULL,'".quote_smart($nom_utilisateur)."','".quote_smart($prenom_utilisateur)."',NULL,'1',NULL)";
  			break;
  		default:
  	}
  }
 // DEBUGG echo "SQL : cration de compte IEW : $sql <br />";
  if (isset($GLOBALS['flag_no_user_ldap_import']) && $GLOBALS['flag_no_user_ldap_import'])
  {	
  	 // DEBUGG echo "flag_no_user_ldap_import : cet utilisateur s'authentifie nativement<br />";
  }
  else
  {
  	// DEBUGG echo "flag_no_user_ldap_import : non dfini = cet utilisateur s'authenfie sur annuaire LDAP (ventuellement par SSO)<br />";
  }
  if (mysql_query($sql) && strlen(mysql_error()) == 0) // Si l'criture a russi
  {
    $id=mysql_insert_id(); // on rcupre l'id parent qui vient d'tre cr dans la table login et qui servira d'identifiant unique utilisateur
    // DEBUGG echo "ID_PERS dans table login : $id<br />";
    if (isset($password) && $password != "") // Si le mot de passe a t cre pr IEW
    {
    	include(CONF_DIR."k.php"); // pour accder  la cl de cryptage
	    // Il faut maintenant crire les codes d'accs dans un fichier texte (les mots de passe vont tre crypts)
    	$crypt_password = base64_encode(mcrypt_encrypt($algo, $crypt_key, $password, $mode, $iv));
    	$enregistrement = $id.",".$login.",".$prenom_utilisateur.",".$nom_utilisateur.",".$crypt_password.",".$limit_date_passwd."\n";
    	if ($fichier_enregistrement_codes1!="")
      		fwrite($fichier_enregistrement_codes1,$enregistrement);
    	if ($fichier_enregistrement_codes2!="")
      	fwrite($fichier_enregistrement_codes2,$enregistrement);
    }
    return $id; // l'identifiant cre est utilis dans d'autres tables pour une correspondance unique avec la table login
  }
  else
  {
  	// DEBUGG echo "ID_PERS dans table login : $id<br />";
  	// DEBUGG echo "MYSQL_ERROR : ".mysql_error(); echo "<br /";
  }
}

function modif_codes_acces_fichier_texte($nom_fichier,$id_pers,$prenom,$nom,$nouveau_login,$nouveau_mdp,$limit_date_passwd)

//***************************** description *****************************************************************//
 // cette fonction permet de modifier le fichier texte contenant les comptes utilisateurs
 // A la cration d'un utilisateur, son identifiant et son mot de passe sont stocks dans un fichier texte
 // Le mot de passe est crypt avant stockage.
 // Le fichier texte en question permet, en dbut d'anne scolaire, de diffuser ces informations auprs
 // des utilisateurs pour qu'ils puissent se connecter au portail IEW
 // Ceux-ci ont la possibilit,  tout moment, de changer leur mot de passe (appel depuis c_mdp.php)

 // Mais le nouveau mot de passe n'est plus stock dans le fichier ($nouveau_mdp et $limit_date_passwd sont vides au moment de l'appel si celui-ci vient du scrit c_mdp.php ou accueil.php), ce qui permet une meilleure
 // scurit d'une part, mais aussi, lors de la prochaine diffusion des codes d'accs, de limiter celle-ci,
 // aux seuls nouveaux utilisateurs du systme ainsi qu' ceux qui n'auraient pas chang le mot de passe qui
 // leur a t affect  l'origine

 // Le revers de la mdaille est qu'il n'est plus possible dans ce cas, de connatre le mot de passe
 // et donc de le diffuser ou rediffuser  son proritaire : si celui-ci l'a perdu, il doit faire une
 // demande de nouveau mot de passe (c_mdp_perdu.php)

 // Pour modifier ce comportement par dfaut, il suffirait dans les scripts d'appel, de renseigner les
 // variables $nouveau_mdp et $limit_date_passwd, ce qui inscrirait ces valeurs dans le fichier texte
 // La diffusion sera alors possible.
 
 // auteur : S.GODM (sylvain.godme@gmail.com)
 // Date de cration :  02/01/2007
 // Date de dernire mise  jour : 04/01/2007
 //***************************** Fin description ***********************************************************//

{
  // Il faut un include(CONF_DIR."k.php"); dans le script d'appel, pour pouvoir encrypter le mot de passe
  global $algo, $crypt_key, $mode, $iv;
  $flag_trouve="";
        $fichier = fopen($nom_fichier,"r");  //ouverture en lecture seule
  if ($fichier) // Si ce fichier existe et peut tre ouvert
  {
    $utilisateurs=array(); // cration d'un tableau vide destin  recevoir les utilisateurs  conserver
    while (!feof($fichier)) // on commence la recherche jusqu' la fin du fichier
    {
      $champs=fgetcsv($fichier,100,","); // Lit une ligne et envoie dans un tableau les champs spars par ","
        if ($champs[0]==$id_pers && $champs[2]==$prenom && $champs[3]==$nom) // Si l'utilisateur  modifier est sur cette ligne du fichier (reconnaissance pas seulement par nom et prnom  cause d'homonymie possible, donc l'id_pers intervient)
        {
          $flag_trouve="oui"; // Un drapeau est positionn
          // Il faut maintenant crire les codes d'accs dans un fichier texte (le mdp est crypt)
          // Si le mdp est vide dans les paramtres d'appel, le cryptage donnera une valeur vide galement
          $crypt_nouveau_mdp = base64_encode(mcrypt_encrypt($algo, $crypt_key, $nouveau_mdp, $mode, $iv));
          $newligne=$champs[0].",".$nouveau_login.",".$prenom.",".$nom.",".$crypt_nouveau_mdp.",".$limit_date_passwd; // on modifie les champs
          array_push($utilisateurs,$newligne); // On l'empile dans le tableau des utilisateurs  conserver
        }
        else // si ce n'est pas le membre du personnel  modifier
        {
          // on reconstitue la ligne lue prcdemment
          $ligne="";
          if (count($champs)!=1) // Si la ligne contient plus d'un lment
          {
            foreach ($champs as $value)
            {
              $ligne.=$value.",";
            }
            $ligne=substr($ligne,0,-1); // on retire la virgule en fin de ligne
            array_push($utilisateurs,$ligne); // On l'empile dans le tableau des utilisateurs  conserver
          }
        }
    }
    fclose($fichier);
    if ($flag_trouve=="oui") // Si l'utilisateur tait dans ce fichier
    {
      // on effectue une sauvegarde de la version prcdente du fichier
      $fragment=explode(".",$nom_fichier);
      @copy($nom_fichier,$fragment[0].".bak");
      // on rcrit ce fichier avec le membre du personnel modifi
      $fichier = fopen($nom_fichier,"w"); // ouverture en criture en crasant le contenu existant
      foreach ($utilisateurs as $value)
      {
        $enregistrement=$value."\n";
        fwrite($fichier,$enregistrement);
      }
      fclose($fichier);
    }
    // Si l'utilisateur n'est pas dans ce fichier, aucune modification de celui-ci n'est faite
    }
}

function modif_fichier_texte_codes_acces($nom_fichier,$supprimer,$id_pers,$ancien_prenom,$ancien_nom,$prenom,$nom,$nouveau_login)

//***************************** description *****************************************************************//
 // cette fonction permet de modifier le fichier texte contenant les codes d'accs utilisateurs
 // A la cration d'un utilisateur, son identifiant et son mot de passe sont stocks dans un fichier texte
 // Le mot de passe est crypt avant stockage.
 // Le fichier texte en question permet, en dbut d'anne scolaire, de diffuser ces informations auprs
 // des utilisateurs pour qu'ils puissent se connecter au portail IEW

 // Elle ressemble beaucoup  la fonction modif_codes_acces_fichier_texte MAIS
 // ICI, cette fonction est utilise pour mettre  jour ce fichier texte, dans le cas de la suppression
 // d'un utilisateur, ou d'une mise  jour concernant son nom, prnom (qui peuvent avoir t mal orthographis
 //  la saisie initiale) et login

 // Elle est typiquement appele par les script d'import des utilisateurs (maj_bddelev_sconet.php et
 //  c_bdd_pers.php

 // paramtres entrs : $nom_fichier : le nom du fichier texte  examiner
 //     $supprimer : si c'est une suppression de la fiche utilisateur
 //     $id_pers : Permet l'identification en cas d'homonymie
 //     $ancien_prenom,$ancien_nom : les noms et prnom d'origine de l'utilisateur
 //     $prenom,$nom : les nouveaux noms et prnoms de cet utilisateur
 //     $nouveau_login : son nouveau login (puisque dpend du nom et du prnom)
 // auteur : S.GODM (sylvain.godme@gmail.com)
 // Date de cration :  04/01/2007
 // Date de dernire mise  jour : 04/01/2007
 //***************************** Fin description ***********************************************************//

{
  $flag_trouve="";
        $fichier = @fopen($nom_fichier,"r");  //ouverture en lecture seule
  if ($fichier) // Si ce fichier existe et peut tre ouvert
  {
    $utilisateurs=array(); // cration d'un tableau vide destin  recevoir les utilisateurs  conserver
    while (!feof($fichier)) // on commence la recherche jusqu' la fin du fichier
    {
      $champs=fgetcsv($fichier,100,","); // Lit une ligne et envoie dans un tableau les champs spars par ","
      if ($supprimer!="ok") // c'est une mise  jour
      {
        if ($champs[0]==$id_pers && $champs[2]==$ancien_prenom && $champs[3]==$ancien_nom) // Si le membre du personnel  modifier est sur cette ligne du fichier
        {
          $flag_trouve="oui"; // Un drapeau est positionn
          $newligne=$champs[0].",".$nouveau_login.",".$prenom.",".$nom.",".$champs[4].",".$champs[5]; // on modifie les champs sauf l'identifiant numrique, le mot de passe, et sa date de validit
          array_push($utilisateurs,$newligne); // On l'empile dans le tableau des utilisateurs  conserver
        }
        else // si ce n'est pas le membre du personnel  modifier
        {
          // on reconstitue la ligne lue prcdemment
          $ligne="";
          if (count($champs)!=1) // Si la ligne contient plus d'un lment
          {
            foreach ($champs as $value)
            {
              $ligne.=$value.",";
            }
            $ligne=substr($ligne,0,-1); // on retire la virgule en fin de ligne
            array_push($utilisateurs,$ligne); // On l'empile dans le tableau des utilisateurs  conserver
          }
        }
      }
      else // c'est une suppression de l'utilisateur
      {
        if ($champs[0]==$id_pers && $champs[2]==$prenom && $champs[3]==$nom) // Si le membre du personnel  supprimer est sur cette ligne du fichier
        {
          $flag_trouve="oui"; // Un drapeau est positionn
          // on n'empile rien du tout => utilisateur supprim
        }
        else // si ce n'est pas le membre du personnel  supprimer
        {
          // on reconstitue la ligne lue prcdemment
          $ligne="";
          if (count($champs)!=1) // Si la ligne contient plus d'un lment
          {
            foreach ($champs as $value)
            {
              $ligne.=$value.",";
            }
            $ligne=substr($ligne,0,-1); // on retire la virgule en fin de ligne
            array_push($utilisateurs,$ligne); // On l'empile dans le tableau des utilisateurs  conserver
          }
        }
      }
    }
    fclose($fichier);
    if ($flag_trouve=="oui") // Si le membre du personnel tait dans ce fichier
    {
      // on effectue une sauvegarde de la version prcdente du fichier
      $fragment=explode(".",$nom_fichier);
      @copy($nom_fichier,$fragment[0].".bak");
      // on rcrit ce fichier avec le membre du personnel modifi
      $fichier = fopen($nom_fichier,"w"); // ouverture en criture en crasant le contenu existant
      foreach ($utilisateurs as $value)
      {
        $enregistrement=$value."\n";
        fwrite($fichier,$enregistrement);
      }
      fclose($fichier);
    }
    // Si le membre du personnel n'est pas dans ce fichier, aucune modification de celui-ci n'est faite
    }
}

function lire_entete_lemonldap()
{
     // code rcupr sur http://lemonldap.sourceforge.net/appl.html
	 // rcupration de l'en-tte http renvoy par le portail applicatif
     // dcoupage de la chane xml =>     $sParamtre[0] -> schma ldap de base
     //                                   $sParamtre[1] -> identit de l'utilisateur
     //                                   $sParamtre[2] -> habilitations

     $sHeaders = getallheaders();
     while (list($sEntete, $sValeur) = each($sHeaders))
       {
        if ($sEntete=="Authorization")
          {
           $l=strlen($sValeur);
           $sModif=substr($sValeur,6,$l);
           $sDecode=base64_decode($sModif);
           $sParametre=explode($sDecode,":");
          }
       }
     return ($sParametre);
}

function check_nbmax_failed_connect($username)
{
	// Il ne faut pas laisser passer une 6me (ou plus) tentative de connexion
  	$sql = "SELECT connect_failed_nb FROM echec_acces WHERE nomlogin='$username'";
  	$resultat = mysql_query($sql);
  	if ($resultat && mysql_num_rows($resultat) > 0) // Il y a dj des tentatives de connexion infructueuses pour $username
  	{
    	$ligne = mysql_fetch_array($resultat);
    	if ($ligne['connect_failed_nb'] >=6) // s'il y en a plus de 5
    	{
    		return true; // On jette systmatiquement sans mme essayer d'authentifier
    	}
      	else
      	{
      		return false;	
      	}
    }
}

function deconnexion()
{
	/*
	 * Dconnecte l'utilisateur et renvoi sur la page d'accueil (formulaire d'identification)
	 */
		
	// On met  jour le journal des connexions
    $sql = "UPDATE journal_connexions SET fin='".time()."' WHERE id_connexion='".$_SESSION['id_connexion']."'";
    mysql_query($sql);
	// avant de dtruire la session, on rcupre la mthode d'authentification (cas, native,...) pour l'inclure dans la redirection header() + bas
	if ($_SESSION['auth_method_user'] == "native")
		$param_url = "?log=locale";
	else 
		$param_url = "";
    if (isset($_SESSION['CAS'])) // Une session CAS a t ouverte
	{
		if ($GLOBALS['sso'] == "eolesso") 
			cas_logout(); // dconnexion SSO
		else
			destroy_session_cas(); // dconnexion serveur CAS + suppression session IEW
	}
	else // pas de session CAS
	{
		// 	On peut dtruire la session (dconnexion effective)
		$_SESSION = array();
		session_destroy();
	}
	header("Location: ".$GLOBALS['racine']."index.php".$param_url); // on renvoie sur la page d'accueil
}

function modify_session_id_with_eolecas_ticket($init_cas=null)
{
	/*
	 * Permet d'envoyer au client CAS eole l'id de session de la session active IEW
	 * frachement modifi par session_regenerate_id() afin de permettre la suppression de la session IEW 
	 * en cas de requte de dconnexion centralise
	 * 
	 * Est lie  une modification de eoleclient.php (ajout d'une fonction publique change_session_id())
	 * 
	 * Elle est appele immdiatement aprs un session_regenerate_id()
	 * 
	 * @param : $init_cas est un paramtre facultatif
	 * Ce paramtre sera fourni seulement s'il est ncessaire de dmarrer le client CAS
	 * Ce sera le cas dans le script (heartbeat) je_suis_la.php  intervalles rguliers (sans action utilisateur) o l'id de session IEW est rgnre
	 * Ce n'est pas le cas lorsque l'appel a lieu juste aprs un session_regenerate_id suivant l'appel  cas_auth() (car le client CAS est dj dmarr)
	 * 
	 */
	if (is_dir('/usr/share/php/CAS-1.3.1'))
   		require_once('CAS-1.3.1/eoleCAS.php');
   else 
   		require_once('CAS/eoleCAS.php');
	require_once('configCAS/cas.inc.php');
	if ($init_cas == "init_casclient") // on dmarre le client CAS seulement s'il n'est pas dmarr (sinon erreur = phpCAS error:phpCAS::error(): EolephpCAS::client() has already been called)
	{
		//eolephpCAS::setDebug(); // ligne  dcommenter pour dbugger les changes entre CAS et IEW (le log se fait par dfaut dans /tmp/phpCAS.log)
		define('__CAS_URL', '');
		eolephpCAS::client(__CAS_VERSION, __CAS_SERVER, __CAS_PORT, __CAS_URL, false);
		if (defined('__CAS_VALIDER_CA'))
		{
       		eolephpCAS::setCasServerCACert(__CAS_CA_LOCATION);
   		}
   		else
   		{
   			if (method_exists(eolephpCAS, 'setNoCasServerValidation'))
   			{
           		eolephpCAS::setNoCasServerValidation();
       		}
   		}
	}
	if (isset($_SESSION['ticket_cas']) && $_SESSION['ticket_cas'] !="") // le ticket CAS est dans la session (si l'utilisateur est dj authentifi)
		$ticket = $_SESSION['ticket_cas']; // il est rcupr depuis la session
	elseif (isset($_REQUEST['ticket'])) // lors du premier appel  la fonction, le ticket est dans l'url de retour entre le serveur CAS et l'appli IEW, mais est accessible dans $_REQUEST, pas dans $_GET (je ne sais pourquoi...)
	{
		// l'utilisateur vient d'tre authentifi, mais IEW ne connat pas encore son identifiant et ses attributs : le ticket sera utilis par IEW
		// pour rcuprer ces informations auprs du serveur CAS (qui validera le ticket, mais qui ne sera plus rejouable) 
		$ticket = $_REQUEST['ticket']; // On rcupre le ticket CAS car ne sera plus disponible par la suite
		$_SESSION['ticket_cas'] = $ticket; // on le sauvegarde dans la session : on en aura besoin lors des prochains appels  la fonction
	}
	// Si aucun des tests prcdents n'est russi, $ticket sera vide et la maj de l'id de session chouera (la suppression de la session IEW en cas de requte de dconnexion centralise ne fonctionnera pas !)
	// On laisse faire cependant (mais si le log du client CAS est activ il y aura une trace de ce problme)
	
	// On appelle la mthode permettant de mettre  jour l'id de session sur le serveur CAS	
	if (method_exists(EoleCASClient, 'change_session_id')){
        EoleCASClient::change_session_id($ticket,session_id()); // le client CAS va propager la modif de l'id de session auprs du serveur CAS
   }
}

function verif_accept_charte()
{
	if ($_SESSION['nouveau_script'] != "/iew/index.php") // mais il n'entre pas par la page d'accueil
	{
		// Alors on vrifie que l'utilisateur a accept la charte
		$sql = "SELECT id_pers from accept_charte WHERE id_pers='".quote_smart($_SESSION['valid_id_user'])."'";
       	$resultat = mysql_query($sql);
       	if (mysql_num_rows($resultat)==0) // pas de signature enregistre
       	{
       		header("Location: ".$GLOBALS['racine']."index.php"); // on renvoie sur la page d'accueil pour forcer l'acceptation de la charte
       		exit;
       	}
	}
}
?>