<?php
/**
 * fonctions_bdd.php
 *
 * regroupe les fonctions d'accs  la base de donnes
 * 
 * Ce fichier fait partie du projet IntraEduWeb (IEW)
 * 
 * @package		IEW
 * @author			Sylvain GODM <sylvain.godme@gmail.com>
 * @version		$LastChangedRevision$, $LastChangedDate$
 * @copyright		2004-2012 Sylvain GODM
 * @link			http://iew.free.fr
 * @license		GPL License version 3 (http://www.gnu.org/licenses/gpl.html)
 * @filesource
 * 
 */
 
// On cherche le rpertoire d'installation IEW
if(!defined('IEW_DIR')) {
	/**
 	 * Constante contenant le chemin complet du rpertoire d'installation IEW
 	 */	
	define('IEW_DIR',realpath(dirname(__FILE__)."/../").'/');
}

/**
 * cette fonction initialise la connexion avec le serveur mysql
 *
 * @return true|false
 */
function connexion_mysql()
{ 
 if (!file_exists(CONF_DIR."inc_connect.php") || !file_exists(CONF_DIR."k.php"))
 {
  return false; // La connexion choue si on a pas les infos dessus (identifiant+mot de passe)
 }
 else // Les fichiers contenant les infos de connexion sont bien l
 {
  /**
   * Contient les codes d'accs (crypts)  la base de donnes MySQL
   */
  include(CONF_DIR."inc_connect.php");
  /**
   * Contient la cl de cryptage dfinie  l'installation
   */
  include(CONF_DIR."k.php");
  global $admin_email;
  $user = mcrypt_decrypt($algo, $crypt_key, base64_decode($mysql_admin), $mode, $iv);
  $passwd = mcrypt_decrypt($algo, $crypt_key, base64_decode($mysql_admin_passwd), $mode, $iv);
  $bd =@mysql_connect($mysql_server,$user, $passwd);
  if (!$bd)
  {
   $error_message = array("Connexion au serveur de base de donnes <b>\"$mysql_server\"</b> impossible. Ressayez ultrieurement
   ou prvenez <a href='mailto:".email_encode($admin_email)."'>l'administrateur du site</a>.","");
   affiche_erreurs($error_message);
   return false;
  }
 }
 
 return true;
}

/**
 * Initialise la connexion  la base de donnes IEW
 *
 * @return true|false
 */
function select_database()
{
 if (!file_exists(CONF_DIR."inc_connect.php") || !file_exists(CONF_DIR."k.php"))
 {
  return false;
 }
 else
 {
  include(CONF_DIR."inc_connect.php");
  include(CONF_DIR."k.php");
 }
 global $admin_email;
 $err = "";
 $seldb=mysql_select_db($mysql_database); // ne marche pas avec $GLOBALS['mysql_database']
 if (!$seldb)
 {
  $err = mysql_error();
  $error_message = array("Slection de la base de donnes IntraEduWeb impossible. La base de donnes <b>\"$mysql_database\"</b>
  n'existe pas ou est inaccessible pour le moment. Veuillez ressayer ultrieurement.
  En cas de nouvel echec, prvenez <a href='mailto:".email_encode($admin_email)."'>l'administrateur du site</a>.<br />$err","");
  affiche_erreurs($error_message);
  return false;
 }
 return true;
}

/**
 * Cette fonction permet de protger une variable avant son introduction dans une requte SQL
 * pour empcher les injections SQL; de plus ceci vite la gestion des addslashes et des stripslashes
 * qui sont alors utiles uniquement pour l'affichage dans les formulaires ou bien pour les alert() de javascript
 *
 * Stripslashes (si les magic_quotes sont activs, les donnes issues des requtes HTTP (GET, POST, et COOKIE)
 * sont dj addslashes, donc il faut les stripslasher car sinon elles seront addslashes  nouveau par cette
 * fonction, ce qui peut multiplier les \\\)
 * 
 * @param string $value
 * @return $value
 */


function quote_smart($value)
{
   /*  */

   // 
   if (get_magic_quotes_gpc()) {
     $value = stripslashes($value);
   }
   // Protection si ce n'est pas un entier (si c'est un entier, il ne peut pas y avoir de caractre comme ')
   // Si c'est un entier commenant par zro, ce sera considr comme un chane, et donc protg.
   if (!is_numeric($value) || $value[0] == '0') {
     $value = mysql_real_escape_string($value);
   }
   return $value; 
   // il ne faudra pas oublier de mettre cette valeur retourne entre des guillements simples dans le code
   // ex : $sql = "SELECT FROM eleves WHERE nom='".quote_smart($_POST['nom']).'";
   // Ainsi mme si la valeur est numrique, le Manuel MySQL conseille d'ajouter toujours des guillemets autour des constantes numriques pour viter certaines attaques de deni de service
}

/**
 * Vrifie si l'installation a dj t faite
 *
 * @return true|false
 */
function verif_install()
{
  if (connexion_mysql() && select_database()) {
    $sql = "SELECT date_install FROM installation;";
    $resultat = mysql_query($sql);
    if ($resultat && mysql_num_rows($resultat)>0) {
      return true; // L'installation est dj faite !
    } else {
      return false; // Alors l'installation n'est pas faite ou pas complte
    }
  } else { // si la connexion choue, on considre que l'install n'est pas encore faite si le fichier inc_connect n'existe pas encore
    if (!file_exists(CONF_DIR."inc_connect.php")) {
    return false;
    }
  }
}

function verif_xmlfile($filename,$root_tag_name,$href="#")
{
	/**
	 * Vrification du fichier d'import xml fourni
	 */
	$test_uaj = false; // Servira pour savoir si l'UAJ vient juste d'tre inscrite dans la base de donnes
	
	global $parser,$rapport,$test_uaj;
	
	// Initialisation du parser
	$fichier = $GLOBALS['stock_baselev']."importation/$filename";
	if (!file_exists($fichier))
	{
		$error_message = array("Le fichier <b>$filename</b> n'est pas prsent sur le serveur. Veuillez <a href='".$href."'>recommencer la mise  jour avec un fichier correct</a>","");
		return $error_message;
	}
	//Get the XML document loaded into a variable
	$xml = file_get_contents($fichier);
	//Set up the parser object
	$parser = new XMLParser($xml);
	//Work the magic...
	$parser->Parse();
	
	// On vrifie que le fichier xml est bien celui attendu
	// Le nom des TAG bien qu'en majuscule dans le fichier xml lu, sont convertis en minuscule par XMLParser, donc on utilise des minuscules pour accder  chaque noeud souhait
	if ($parser->document->tagName != $root_tag_name) // Pour XmlParser, Le noeud "document" est la TAG racine du document XML, c'est un objet
	{
		$error_message = array("Le fichier <b>$filename</b> n'est pas format correctement. Veuillez <a href='".$href."'>recommencer la mise  jour avec un fichier correct</a>","");
		return $error_message;
	}
	
	// Le fichier xml est le bon, on accde aux paramtres UAJ, ANNEE_SCOLAIRE
	$sql = "SELECT code_rne FROM uaj"; // Voici l'UAJ dans la base de donnes IEW
  	$resultat = mysql_query($sql);
  	if ($resultat && mysql_num_rows($resultat)==1)
  	{
  		$ligne = mysql_fetch_array($resultat);
		//echo "CODE RNE (UAJ) : ".$ligne['code_rne']."<br />";	
  		// On compare avec l'UAJ dans le fichier xml d'import
		if (substr($filename,0,7) == "sts_emp") // cas particulier du fichier sts_emp_rne_annee.xml : l'UAJ est spcifi dans un attribut de balise UAJ pas dans une valeur
		{
			if ($ligne['code_rne']!=$parser->document->parametres[0]->uaj[0]->tagAttrs['code']) // Pour XmlParser, Les noeuds enfants du noeud racine sont des tableaux : on accde au premier lment (mme si c'est l'unique par l'index 0)
			{
				$error_message = array("Le fichier <b>$filename</b> tlcharg ne provient pas de votre tablissement. Veuillez <a href='".$href."'>recommencer la mise  jour avec un fichier correct</a>","");
				return $error_message;
			}
		}
		else // Alors que dans les autres fichiers xml (provenant de sconet), l'uaj est spcifie par une valeur
		{
			if ($ligne['code_rne']!=$parser->document->parametres[0]->uaj[0]->tagData) // Pour XmlParser, Les noeuds enfants du noeud racine sont des tableaux : on accde au premier lment (mme si c'est l'unique par l'index 0)
			{
				$error_message = array("Le fichier <b>$filename</b> tlcharg ne provient pas de votre tablissement. Veuillez <a href='".$href."'>recommencer la mise  jour avec un fichier correct</a>","");
				return $error_message;
			}
		}
  	}
  	elseif ($filename == "Communs.xml") // l'UAJ n'est pas renseigne dans la base IEW => On importe les valeurs du fichier xml fourni
  	{
  		// On prpare les donnes  crire
		// Certaines balises XML ne sont pas obligatoires => Remplies par une valeur NULL dans la table uaj
		$etab_uaj_id = "'".quote_smart($parser->document->donnees[0]->uaj[0]->etab_uaj_id[0]->tagData)."'"; // Obligatoire (Export "Commun", Bloc UAJ)
		$code_rne = "'".quote_smart($parser->document->parametres[0]->uaj[0]->tagData)."'"; // Obligatoire (Fait partie des PARAMETRES de tout export XML  partir de SCONET
		if (!isset($parser->document->donnees[0]->uaj[0]->num_siren[0])) // Facultative  (Export "Commun", Bloc UAJ)
			$num_siren = "NULL";
		else
			$num_siren = "'".quote_smart($parser->document->donnees[0]->uaj[0]->num_siren[0]->tagData)."'";
		if (!isset($parser->document->donnees[0]->uaj[0]->denom_princ[0])) // Facultative  (Export "Commun", Bloc UAJ)
			$denom_princ = "NULL";
		else
			$denom_princ = "'".quote_smart($parser->document->donnees[0]->uaj[0]->denom_princ[0]->tagData)."'";
		if (!isset($parser->document->donnees[0]->uaj[0]->denom_compl[0])) // Facultative  (Export "Commun", Bloc UAJ)
			$denom_compl = "NULL";
		else
			$denom_compl = "'".quote_smart($parser->document->donnees[0]->uaj[0]->denom_compl[0]->tagData)."'";
		if (!isset($parser->document->donnees[0]->uaj[0]->nom_resp[0])) // Facultative  (Export "Commun", Bloc UAJ)
			$nom_resp = "NULL";
		else
			$nom_resp = "'".quote_smart($parser->document->donnees[0]->uaj[0]->nom_resp[0]->tagData)."'";
		if (!isset($parser->document->donnees[0]->uaj[0]->qual_resp[0])) // Facultative  (Export "Commun", Bloc UAJ)
			$qual_resp = "NULL";
		else
			$qual_resp = "'".quote_smart($parser->document->donnees[0]->uaj[0]->qual_resp[0]->tagData)."'";
		if (!isset($parser->document->donnees[0]->uaj[0]->ligne1_adresse[0])) // Facultative  (Export "Commun", Bloc UAJ)
			$ligne1_adresse = "NULL";
		else
			$ligne1_adresse = "'".quote_smart($parser->document->donnees[0]->uaj[0]->ligne1_adresse[0]->tagData)."'";
		if (!isset($parser->document->donnees[0]->uaj[0]->ligne2_adresse[0])) // Facultative  (Export "Commun", Bloc UAJ)
			$ligne2_adresse = "NULL";
		else
			$ligne2_adresse = "'".quote_smart($parser->document->donnees[0]->uaj[0]->ligne2_adresse[0]->tagData)."'";
		if (!isset($parser->document->donnees[0]->uaj[0]->ligne3_adresse[0])) // Facultative  (Export "Commun", Bloc UAJ)
			$ligne3_adresse = "NULL";
		else
			$ligne3_adresse = "'".quote_smart($parser->document->donnees[0]->uaj[0]->ligne3_adresse[0]->tagData)."'";
		if (!isset($parser->document->donnees[0]->uaj[0]->ligne4_adresse[0])) // Facultative  (Export "Commun", Bloc UAJ)
			$ligne4_adresse = "NULL";
		else
			$ligne4_adresse = "'".quote_smart($parser->document->donnees[0]->uaj[0]->ligne4_adresse[0]->tagData)."'";
		if (!isset($parser->document->donnees[0]->uaj[0]->telephone[0])) // Facultative  (Export "Commun", Bloc UAJ)
			$telephone = "NULL";
		else
			$telephone = "'".quote_smart($parser->document->donnees[0]->uaj[0]->telephone[0]->tagData)."'";
		if (!isset($parser->document->donnees[0]->uaj[0]->telecopie[0])) // Facultative  (Export "Commun", Bloc UAJ)
			$telecopie = "NULL";
		else
			$telecopie = "'".quote_smart($parser->document->donnees[0]->uaj[0]->telecopie[0]->tagData)."'";
		if (!isset($parser->document->donnees[0]->uaj[0]->mel_1[0])) // Facultative  (Export "Commun", Bloc UAJ)
			$mel_1 = "NULL";
		else
			$mel_1 = "'".quote_smart($parser->document->donnees[0]->uaj[0]->mel_1[0]->tagData)."'";
		if (!isset($parser->document->donnees[0]->uaj[0]->mel_2[0])) // Facultative  (Export "Commun", Bloc UAJ)
			$mel_2 = "NULL";
		else
			$mel_2 = "'".quote_smart($parser->document->donnees[0]->uaj[0]->mel_2[0]->tagData)."'";
		if (!isset($parser->document->donnees[0]->uaj[0]->code_type_etab[0])) // Facultative  (Export "Commun", Bloc UAJ)
			$code_type_etab = "NULL";
		else
			$code_type_etab = "'".quote_smart($parser->document->donnees[0]->uaj[0]->code_type_etab[0]->tagData)."'";
		if (!isset($parser->document->donnees[0]->uaj[0]->code_postal[0])) // Facultative  (Export "Commun", Bloc UAJ)
			$code_postal = "NULL";
		else
			$code_postal = "'".quote_smart($parser->document->donnees[0]->uaj[0]->code_postal[0]->tagData)."'";
			
		$sql = "INSERT INTO uaj VALUES($etab_uaj_id, $code_rne, $num_siren, $denom_princ, $denom_compl, $nom_resp, $qual_resp, $ligne1_adresse, $ligne2_adresse, $ligne3_adresse, $ligne4_adresse, $telephone, $telecopie, $mel_1, $mel_2, $code_type_etab, $code_postal, '".quote_smart($GLOBALS['ville_etablissement'])."')";
		// La valeur pour le champ libelle_postal (qui n'est pas prsent dans Communs.xml)
		// est complt avec la  valeur $GLOBALS['ville_etablissement'] de config.php
  		mysql_query($sql);
  		if (mysql_affected_rows() == 1)
		{
			$rapport .= "L'UAJ <strong><i>".$parser->document->donnees[0]->uaj[0]->tagData."</i></strong> a t <u>ajoute</u> dans la base de donnes.<br />";
			$test_uaj = true;
		}
  		else
  		{
  			$error_message = array("Les Donnes UAJ (Unit Administrative et Juridique) de l'tablissement n'ont pas pu tre inscrites dans la base de donnes.","");
  			affiche_erreurs($error_message);
  		}
  	}
  	// On vrifie que l'anne scolaire est la bonne
	
	/*$anscol = annee_scolaire_en_cours(); // on rcupre l'anne scolaire en cours au format aaaa - aaaa
	$anscol = substr($anscol,0,4); // Les 4 premiers cc (anne de rentre)
	if (substr($filename,0,7) == "sts_emp") // cas particulier du fichier sts_emp_rne_annee.xml : l'anne est spcifie dans un attribut de balise ANNEE_SCOLAIRE pas dans une valeur
	{
		if ($anscol!=$parser->document->parametres[0]->annee_scolaire[0]->tagAttrs['annee'])
		{
			$error_message = array("Le fichier $filename tlcharg ne correspond pas  l'anne scolaire en cours. Veuillez <a href='".$href."'>recommencer</a> la mise  jour avec un fichier correct","");
			return $error_message;
		}
	}
	else  // Alors que dans les autres fichiers xml (provenant de sconet), l'anne est spcifie par une valeur
	{
		if ($anscol!=$parser->document->parametres[0]->annee_scolaire[0]->tagData)
		{
			$error_message = array("Le fichier $filename tlcharg ne correspond pas  l'anne scolaire en cours. Veuillez <a href='".$href."'>recommencer</a> la mise  jour avec un fichier correct","");
			return $error_message;
		}
	}*/
  	
	// Enfin on vrifie si l'horodatage est postrieur (ou gal en cas de rechargement pour des essais)
	//  celui enregistr lors de l'import prcdent
	if (substr($filename,0,7) != "sts_emp" && substr($filename,0,12) != "EDT_vers_STS") // les fichiers sts_emp_rne_annee.xml et EDT_vers_STS_RNE_annee.xml ne contiennent pas d'horodatage
	{
		$horodatage_fichier = $parser->document->parametres[0]->horodatage[0]->tagData; // format jj/mm/aaaa hh:mm:ss
		$fragment = explode(" ",$horodatage_fichier);
		$date_fichier = $fragment[0];
		$heure_fichier = $fragment[1];
		$date_fichier = convert_date_to_mysql($date_fichier);
		$horodatage_fichier = $date_fichier." ".$heure_fichier; // Horodatage au format US aaaa-mm-jj hh:mm:ss
		// On convertit en timestamp pour faciliter la comparaison qui va suivre
		$horodatage_fichier = strtotime($horodatage_fichier);
		if ($filename == "ElevesAvecAdresses.xml" || $filename == "ResponsablesAvecAdresses.xml") // si on fait une maj de la base lve
		{
			$champ = strtolower(substr($filename,0,strlen($filename)-16)); // Si 'ElevesAvecAdresses.xml', on rcupre 'communs'
			$sql = "SELECT $champ FROM horodatages_imports_eleves";
		}
		else // Pour une aute mise  jour
		{
			$champ = strtolower(substr($filename,0,strlen($filename)-4)); // Si 'Communs.xml', on rcupre 'communs'
			$sql = "SELECT $champ FROM horodatages_imports_base";
		}
		$resultat = mysql_query($sql);
		if ($resultat && mysql_num_rows($resultat)>0) // Le champ peut tre vide, dans ce cas aucun contrle d'horodatage n'est effectu (premire mise  jour)
		{
			$ligne = mysql_fetch_array($resultat);
			$horodatage_table = $ligne[$champ];
			$fragment = explode(" ",$horodatage_table);
			$date_table = $fragment[0];
			$heure_table = $fragment[1];
			$date_table = convert_date_to_mysql($date_table);
			$horodatage_table = $date_table." ".$heure_table; // Horodatage au format US aaaa-mm-jj hh:mm:ss
			// On convertit en timestamp pour faciliter la comparaison qui va suivre
			$horodatage_table = strtotime($horodatage_table);
			if ($horodatage_fichier<$horodatage_table)
			{
				$error_message = array("Le fichier <b>$filename</b> tlcharg est plus ancien que le fichier provenant de la dernire mise  jour. Veuillez <a href='".$href."'>recommencer la mise  jour avec un fichier correct</a> (vrifiez l'horodatage).","");
				return $error_message;
			}
		}
	}
}

function suppr_compte_tables_nettoyage($id_pers)
{
	/**
	 * Assure la suppression des donnes obsoltes suite  la suppression d'un compte utilisateur
	 * 
	 * @param $id_pers : identifiant numrique du compte supprim servant de lien avec les tables dont les donnes sont  supprimer
	 */
	
	$table = array("accept_charte","auth_foto","demande_mdp");
	foreach($table as $value)
	{
		$sql = "DELETE FROM $value WHERE id_pers='".quote_smart($id_pers);"'";
		mysql_query($sql);
	}
}

function trouve_annees_archives()
{
	/**
	 * Renvoie les annes scolaires archives (suite aux cltures des annes scolaires successives
	 * 
	 * @return $annees_scol : tableau contenant les annes scolaires au format AAAA-AAAA(+1)
	 */
	// On recherche dans les archives les annes scolaires disponibles
    $d = opendir($GLOBALS['stock_baselev']);
    $annees_scol = array();
    while (false !== ($f = readdir($d)))
    {
      	if (is_dir($GLOBALS['stock_baselev'].$f) && substr($f,0,5) == "data_")
        $annees_scol[] = substr($f,5,strlen($f)-5);
    }
    closedir($d);
    natsort($annees_scol); 
    return $annees_scol;
}
?>