<?php
/**
 * fonctions_dates.php
 *
 * regroupe les fonctions de traitement de dates 
 * 
 * Ce fichier fait partie du projet IntraEduWeb (IEW)
 * 
 * @package		IEW
 * @author			Sylvain GODM <sylvain.godme@gmail.com>
 * @version		$LastChangedRevision$, $LastChangedDate$
 * @copyright		2004-2012 Sylvain GODM
 * @link			http://iew.free.fr
 * @license		GPL License version 3 (http://www.gnu.org/licenses/gpl.html)
 * @filesource
 * 
 */

// On cherche le rpertoire d'installation IEW
if(!defined('IEW_DIR')) define('IEW_DIR',realpath(dirname(__FILE__)."/../").'/');

function date_mysql_to_jjmmaaaa($date)
{
//***************************** description ********************************//
 // cette fonction assure la conversion du format de date mysql aaaa-mm-jj au format jj/mm/aaaa
 // paramtre entr ($date) : date  reformater
 // sortie : $newdate (nouveau format)
 // auteur : S.GODM (sylvain.godme@gmail.com)
 // Date de dernire mise  jour : 13/04/02
 //***************************** Fin description *****************************//

  list($annee,$mois,$jour)=explode("-",$date);
  $newdate=date("d/m/Y", mktime(0,0,0,$mois,$jour,$annee));
  return $newdate;
  }

function date_mysql_to_jjmmaaaa_tiret($date)
{
//***************************** description ********************************//
 // cette fonction assure la conversion du format de date mysql aaaa-mm-jj au format jj-mm-aaaa
 // paramtre entr ($date) : date  reformater
 // sortie : $newdate (nouveau format)
 // auteur : S.GODM (sylvain.godme@gmail.com)
 // Date de dernire mise  jour : 13/04/02
 //***************************** Fin description *****************************//

  list($annee,$mois,$jour)=explode("-",$date);
  $newdate=date("d-m-Y", mktime(0,0,0,$mois,$jour,$annee));
  return $newdate;
  }


function date_mysql_to_jjmmaa($date)
{
//***************************** description ********************************//
 // cette fonction assure la conversion du format de date mysql aaaa-mm-jj au format jj/mm/aa
 // paramtre entr ($date) : date  reformater
 // sortie : $newdate (nouveau format)
 // auteur : S.GODM (sylvain.godme@gmail.com)
 // Date de dernire mise  jour : 16/02/2005
 //***************************** Fin description *****************************//

  list($annee,$mois,$jour)=explode("-",$date);
  $newdate=date("d/m/y", mktime(0,0,0,$mois,$jour,$annee));
  return $newdate;
}

function format_date_long($langue,$date)
{
//***************************** description ********************************//
 // cette fonction assure la conversion du format de date jj/mm/aaaa au format long
 // paramtres entrs : $langue (choix de la langue pour la date)
 //                     $date (date  formater)
 // sortie : variable $newdate (date au format long dans la langue choisie)
 // auteur : S.GODM (sylvain.godme@gmail.com)
 // Date de dernire mise  jour : 21/09/02
 // Commentaire : il s'agit de la mme fonction que affiche_date() (voir le script fonctions_affichage.php)
 //               mais celle-ci n'affiche pas la date, elle renvoie seulement la variable $newdate
 //***************************** Fin description *****************************//


if($langue!="fr"){
 switch ($langue){
  case de:
   $jour = array("Sonntag", "Montag", "Dienstag","Mittwoch", "Donnerstag", "Freitag", "Samstag");
   $mois = array("Januar", "Februar", "Mrz", "April", "Mai", "Juni", "July", "August", "September", "Oktober", "November",
   "Dezember");
   break;
  case us:
   $jour = array("Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday");
   $mois = array("January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December");
   break;
 }
}
else
{
$jour = array("Dimanche", "Lundi", "Mardi","Mercredi", "Jeudi", "Vendredi", "Samedi");
$mois = array("Janvier", "Fvrier", "Mars", "Avril", "Mai", "Juin", "Juillet", "Aot", "Septembre", "Octobre", "Novembre",
"Dcembre");
}

if($langue=="us"):
    if ($date!=""): // si la date en argument n est pas vide, faire le formatage avec cette date
     list($day,$month,$annee)=explode("/",$date);
     $timestamp=mktime(0,0,0,$month,$day,$annee);
     $newdate=$jour[strftime("%w", $timestamp)].", ".date("jS", $timestamp)." ".$mois[(strftime("%m", $timestamp)-1)]." ".date("Y", $timestamp);
    else: // si la date fournie en argument est vide, faire le formatage avec la date en cours
     $newdate=$jour[strftime("%w")].", ".date("jS")." ".$mois[(strftime("%m")-1)]." ".date("Y");
    endif;
else: // mme chose mais pour une date autre que US
    if ($date!=""):
     list($day,$month,$annee)=explode("/",$date);
     $timestamp=mktime(0,0,0,$month,$day,$annee);
     $newdate=$jour[strftime("%w", $timestamp)]." ".date("j", $timestamp)." ".$mois[(strftime("%m", $timestamp)-1)]." ".date("Y", $timestamp);
    else:
     $newdate=$jour[strftime("%w")]." ".date("j")." ".$mois[(strftime("%m")-1)]." ".date("Y");
    endif;

endif;
return $newdate;
}

function date_long_fr_to_mysql($date)
{
	/*
	 * Convertit une date comme "lundi 12 janvier 2012" en "2012-01-12" 
	 */
	$mois = array("Janvier", "Fvrier", "Mars", "Avril", "Mai", "Juin", "Juillet", "Aot", "Septembre", "Octobre", "Novembre",
"Dcembre");
	list($datejour,$numjour_dans_mois,$datemois,$dateannee)=explode(" ",$date); // le libell du jour ne nous intresse pas ($datejour)
	// le mois doit tre au format numrique  2 chiffres
	$nummois = array_search($datemois,$mois)+1;
	if ($nummois < 10)
		$nummois = "0".$nummois;
	$newdate = $dateannee."-".$nummois."-".$numjour_dans_mois;
	return $newdate;
}

function MySQLDateToExplicitDate($MyDate, $WeekDayOn=1, $YearOn=1)
{ // cette fonction permet de convertir une date au format mysql 2002-06-11 en : Mardi 11 Juin 2002.
	// En option vous pouvez choisir de ne pas afficher le jour de la semaine et/ou l'anne.
  $MyMonths = array("Janvier", "Fvrier", "Mars", "Avril", "Mai", "Juin",
        "Juillet", "Aot", "Septembre", "Octobre", "Novembre", "Dcembre");
  $MyDays = array("Dimanche", "Lundi", "Mardi", "Mercredi", "Jeudi",
                  "Vendredi", "Samedi");
  $DF=explode('-',$MyDate);
  $TheDay=getdate(mktime(0,0,0,$DF[1],$DF[2],$DF[0]));
  $MyDate=$DF[2]." ".$MyMonths[$DF[1]-1];
  if($WeekDayOn){$MyDate=$MyDays[$TheDay["wday"]]." ".$MyDate;}
  if($YearOn){$MyDate.=" ".$DF[0];}
  return $MyDate;
}

function ExplicitDateToMySQLDate($MyDateLong)
{
	/** Fonction inverse de la prcdente */
	$MyMonths = array("Janvier", "Fvrier", "Mars", "Avril", "Mai", "Juin",
        "Juillet", "Aot", "Septembre", "Octobre", "Novembre", "Dcembre");
  	$DF = explode(" ",$MyDateLong);
  	$TheDay = $DF[1];
  	$TheMonth = array_search(utf8_decode($DF[2]),$MyMonths) + 1; // car le mois peut comporter des accents encods en utf8 alors que dans le tableau $MyMonths, c encod comme le script en ISO-8859-1
  	if ($TheMonth < 10)
  		$TheMonth = "0".$TheMonth;
  	$TheYear = $DF[3];
  	$MyDateMySQL = $TheYear."-".$TheMonth."-".$TheDay;
  	return $MyDateMySQL;
}

function convert_date_to_mysql($date, $delimiter = '/')
{ // cette fonction permet de convertir une date provenant de php au format mysql.
  if (preg_match("#([0-9]{1,2})$delimiter([0-9]{1,2})$delimiter([0-9]{2,4})#",
      $date, $regs))
  {
    if(strlen($regs[1]) <2) $regs[1] = "0$regs[1]";
    if(strlen($regs[2]) <2) $regs[2] = "0$regs[2]";
    if(strlen($regs[3]) <4) $regs[3] = "20$regs[3]";

    return $regs[3]."-".$regs[2]."-".$regs[1];
  }
  else
  {
    return false;
  }
}

function affiche_date($date)
{
  // Cette fonction est utilise pour afficher la date dans l'en-tte de page
  if (isset($_SESSION['anscol']) && isset($_SESSION['anscol']) !="") // Si on est dans les archives
    echo "<strong><i>ARCHIVES ".$_SESSION['anscol']."</i></strong>";
  else
  {
    $jour = array("Dimanche", "Lundi", "Mardi","Mercredi", "Jeudi", "Vendredi", "Samedi");
    $mois = array("Janvier", "Fvrier", "Mars", "Avril", "Mai", "Juin", "Juillet", "Aot", "Septembre", "Octobre", "Novembre",
    "Dcembre");
    if ($date!="")
    {
      list($day,$month,$annee)=explode("/",$date);
      $timestamp=mktime(0,0,0,$month,$day,$annee);
      print $jour[strftime("%w", $timestamp)]." ".date("j", $timestamp)." ".$mois[(strftime("%m", $timestamp)-1)]." ".date("Y", $timestamp);
    }
    else
    {
      print $jour[strftime("%w")]." ".date("j")." ".$mois[(strftime("%m")-1)]." ".date("Y");
    }
  }
}

function verif_format_saisie_date_jjmmaaaa($date,$separateur)
{
//***************************** description *****************************************************************//
 // cette fonction permet de vrifier le format (jj-mm-aaaa) des dates saisies dans le formulaire
 // paramtres entrs : $date qui peut-tre une date isole ou un tableau contenant une liste de dates conscutives
 // auteur : S.GODM (sylvain.godme@gmail.com)
 // Date de cration :	23/02/205
 // Date de dernire mise  jour : 23/02/2005
 //***************************** Fin description ***********************************************************//

  if (!preg_match ("#([0-9]{2})".$separateur."([0-9]{2})".$separateur."([0-9]{4})#", $date))
    return false;
  else
  {  
    $fragment = explode($separateur,$date);
    // Pendant qu'on y est, on vrifie si la date correspond bien  un jour ouvrable de la semaine dans l'tablissement
    $jour = preg_split("# #", format_date_long($GLOBALS['default_language'],preg_replace("#".$separateur."#","/",$date)));
    if (!checkdate($fragment[1],$fragment[0],$fragment[2]) || !in_array($jour[0],$GLOBALS['jours_ouvrables']))
      return false;
    else
      return true;
  }
}

function is_format_date_jjmmaaaa($date,$separateur)
{
	/*
	 * Mme chose que verif_format_saisie_date_jjmmaaaa($date,$separateur)
	 * mais ici on ne vrifie pas si la date correspond bien  un jour ouvrable de la semaine dans l'tablissement
	 * */
	
	if (!preg_match ("#([0-9]{2})".$separateur."([0-9]{2})".$separateur."([0-9]{4})#", $date))
    	return false;
    else
    	return true;
}

function verif_format_saisie_heure_hhmm($heure,$separateur)
{
//***************************** description *****************************************************************//
 // cette fonction permet de vrifier le format heures saisies dans le formulaire
 // paramtres entrs : $date qui peut-tre une date isole ou un tableau contenant une liste de dates conscutives
 // auteur : S.GODM (sylvain.godme@gmail.com)
 // Date de cration :	23/02/205
 // Date de dernire mise  jour : 23/02/2005
 //***************************** Fin description ***********************************************************//
 
  if (!ereg ("([0-9]{2})".$separateur."([0-9]{2})", $heure))
    return false;
  else
  {
    $fragment = explode($separateur,$heure);
    if ($fragment[0]>23 || $fragment[1]>59)
      return false;
    return true;
  }
  return true;
}

function test_jour_ouvrable($date)
{
  // Vrifie si le jour est ouvrable (teste le jour de la semaine)
  // la date doit tre au format jj/mm/aaaa !!
  $jour = preg_split("# #", format_date_long($GLOBALS['default_language'],$date));
  if (!in_array($jour[0],$GLOBALS['jours_ouvrables']))
  {
    return false;
   }
  // TODO : Vrifie si le jour est ouvrable (pendant le temps scolaire hors vacances et hors jours fris)
  return true;
}

function annee_scolaire_en_cours()
{
  // Renvoie l'anne scolaire au format aaaa - aaaa
  $sql = "select * from semab";
  $resultat =@mysql_query($sql);
  if (!$resultat)
  {
   $error_message=array( "<div align='justify'>La table contenant les informations pour le calendrier des semaines existe bien mais ne contient aucune donne. Ceci s'explique si l'installation de IEW est frache ou bien si vous venez de clturer l'anne scolaire. Dans tous les cas, il faut mettre  jour ce calendrier pour permettre l'accs  de nombreuses fonctionnalits de l'application.
   	<p><a href='".$GLOBALS['racine']."prive/admin/prive/saisie_semab.php'>Prparer le calendrier scolaire</a></p></div>","");
   affiche_erreurs($error_message);
   return;
  }
  if (mysql_num_rows($resultat)==0)
  {
  	
  		$error_message=array( "<div align='justify'>La table contenant les informations pour le calendrier des semaines existe bien mais ne contient aucune donne. Ceci s'explique si l'installation de IEW est frache ou bien si vous venez de clturer l'anne scolaire. Dans tous les cas, il faut mettre  jour ce calendrier pour permettre l'accs  de nombreuses fonctionnalits de l'application.
   		<p><a href='".$GLOBALS['racine']."prive/admin/prive/saisie_semab.php'>Prparer le calendrier scolaire</a></p></div>","");
   		affiche_erreurs($error_message);
    	return;
    
  }
  $variable = mysql_fetch_array($resultat);
  $date_rentree = $variable['date_rentree'];
  $annee = substr($date_rentree,0,4); // dtermine anne de rfrence  la date de rentre
  $fin_annee = $annee + 1;
  $annee_scolaire = $annee." - ".$fin_annee;
  return $annee_scolaire;
}

function mysql_jour_suiv_prec_ouvrable($date,$increment)
{
//***************************** description *****************************************************************//
 // cette fonction permet de dterminer le jour ouvrable (dans la priode d'une anne scolaire, hors vacances)
 // correspondant  l'incrment par rapport  la date fournie en paramtre (le tout au format MySQL)
 // si $increment = 1, la fonction renvoie le jour ouvrable suivant (ou le cherche rcursivement)
 // si $increment = -1, la fonction renvoie le jour ouvrable prcdent (ou le cherche rcursivement)
 // paramtres entrs : $date au format MySQL
 // auteur : S.GODM (sylvain.godme@gmail.com)
 // Date de cration :	15/06/2005
 // Date de dernire mise  jour : 20/06/2005
 //***************************** Fin description ***********************************************************//

$elts = explode("-", $date);
//print_r($elts);
//echo "<br />";
$an = $elts[0];
$mois = $elts[1];
$jour   = $elts[2];

$newdate = mktime(0, 0, 0, $mois, $jour+$increment, $an); // voici la nouvelle date
$newdate = date("Y-m-d", $newdate); // au format MySQL
if (test_jour_dans_periode_scolaire($newdate)) // Si c'est dans une priode de travail
  if (test_jour_ouvrable(date_mysql_to_jjmmaaaa($newdate))) // on vrifie aussi si c'est un jour ouvrable de la semaine
    // un return ne fonctionne pas pour une fonction rcursive tant donn que ce renvoi est donn  la fonction elle-mme et pa au script appelant !
    $GLOBALS['newdate_ouvrable']= $newdate; // on renvoie cette date (qui est donc valide)
  else // sinon on fait un appel recursif  cette fonction pour quelle renvoie la premire date ouvrable
  {
    if ($increment<0) // Si on cherche une date prcdente
      $increment--; // on dcrmente le jour
    else // Si on cherche une date suivante
      $increment++; // on incremente le jour
    if (abs($increment)<31) // au maximum, la rcursivit s'appliquera 30 fois (au cours d'une anne scolaire, l'cart entre deux dates ouvrables ne dpasse pas une quinzaine de jours -temps max de vacances en pleine anne scolaire-, donc avec 30 appels rcursifs max on est large)
      mysql_jour_suiv_prec_ouvrable($date,$increment); //donc appel rcursif
    else // on a dpass l'tendue maximum de la recherche
      $GLOBALS['newdate_ouvrable']= $date; // on fixe la date  la valeur du dernier appel de la fonction (c'est soit la date de rentre, soit la date des grandes vacances)
  }
else // on est dans une priode de vacances
  {
    if ($increment<0) // Si on cherche une date prcdente
      $increment--; // on dcrmente le jour
    else // Si on cherche une date suivante
      $increment++; // on incremente le jour
    if (abs($increment)<31) // au maximum, la rcursivit s'appliquera 30 fois (au cours d'une anne scolaire, l'cart entre deux dates ouvrables ne dpasse pas une quinzaine de jours -temps max de vacances en pleine anne scolaire-, donc avec 30 appels rcursifs max on est large)
      mysql_jour_suiv_prec_ouvrable($date,$increment); // donc appel rcursif
    else // on a dpass l'tendue maximum de la recherche
      $GLOBALS['newdate_ouvrable']= $date; // on fixe la date  la valeur du dernier appel de la fonction (c'est soit la date de rentre, soit la date des grandes vacances)
  }
}

function test_jour_dans_periode_scolaire($date)
{
// Teste si la date (MySQL) fournie en paramtre est un jour ouvrable compris dans les priodes de classe

// On rcupre donc dans la base les dates de rentre et de vacances scolaires
$sql = "select * from semab";
 $resultat =@mysql_query($sql);
 if (!$resultat)
 {
  $error_message = array("La table contenant les informations pour le calendrier des semaines n'existe
  pas. Prvenez <a href='mailto".email_encode($GLOBALS['admin_email'])."'>l'administrateur IntraEduWeb.</a>.",""); 
  affiche_erreurs($error_message);
  return;
 }
 if (mysql_num_rows($resultat)==0)
 {
  
   	$error_message=array( "<div align='justify'>La table contenant les informations pour le calendrier des semaines existe bien mais ne contient aucune donne. Ceci s'explique si l'installation de IEW est frache ou bien si vous venez de clturer l'anne scolaire. Dans tous les cas, il faut mettre  jour ce calendrier pour permettre l'accs  de nombreuses fonctionnalits de l'application.
   	<p><a href='".$GLOBALS['racine']."prive/admin/prive/saisie_semab.php'>Prparer le calendrier scolaire</a></p></div>","");
   	affiche_erreurs($error_message);
   	return;
   
 }
 $variable = mysql_fetch_array($resultat);
 // On transforme les dates rcupres en timestamp pour comparaison ultrieure
 $date_rentree = strtotime($variable['date_rentree']);
 $dbt_toussaint = strtotime($variable['dbt_toussaint']);
 $fin_toussaint = strtotime($variable['fin_toussaint']);
 $dbt_noel = strtotime($variable['dbt_noel']);
 $fin_noel = strtotime($variable['fin_noel']);
 $dbt_fev = strtotime($variable['dbt_fev']);
 $fin_fev = strtotime($variable['fin_fev']);
 $dbt_paq = strtotime($variable['dbt_paq']);
 $fin_paq = strtotime($variable['fin_paq']);
 $dbt_1t = strtotime($variable['dbt_1t']);
 $fin_1t = strtotime($variable['fin_1t']);
 $p_1t = strtotime($variable['p_1t']);
 $dbt_2t = strtotime($variable['dbt_2t']);
 $fin_2t = strtotime($variable['fin_2t']);
 $p_2t = strtotime($variable['p_2t']);
 $dbt_3t = strtotime($variable['dbt_3t']);
 $fin_3t = strtotime($variable['fin_3t']);
 $p_3t = strtotime($variable['p_3t']);
 $dbt_ete = strtotime($variable['dbt_ete']);
 
// La date fournie en paramtre  la fonction correspond-elle  un jour de travail ?
$date = strtotime($date); // on la transforme aussi en timestamp

if (($date<$date_rentree) || (($date>$dbt_toussaint) && ($date<$fin_toussaint)) || (($date>$dbt_noel) && ($date<$fin_noel)) || (($date>$dbt_fev) && ($date<$fin_fev)) || (($date>$dbt_paq) && ($date<$fin_paq)) || ($date>$dbt_ete))
{  
  //echo "NO<br />";
  return false; // la date est hors priode scolaire : c'est pendant les vacances !
}
else
{
  //echo "YES<br />";
  return true; // ok, la date est dans la priode scolaire
}
}

function debut_semaine($date)
{
	/*
	 * Renvoie, en fonction du jour $date en paramtre, la date de dbut de la semaine
	 * correspondante
	 * */
	if ($date == "") // date non fournie => Date en cours
	{
		if (date('D') == "Mon") // si on est lundi
		{
			return date('Y-m-d'); // alors c'est le dbut de la semaine
		} 
		else // cas d'un autre jour => on renvoie le lundi qui prcde comme dbut de semaine
		{
			return date('Y-m-d',strtotime('Last Monday'));
		}	
	}
	else // la date est fournie
	{
		// on calcule le timestamp de la date (ncessaire pour la fct strtotime())
		$elts = explode("-", $date);
		$an = $elts[0];
		$mois = $elts[1];
		$jour   = $elts[2];
		$timestamp = mktime(0, 0, 0, $mois, $jour, $an);
		// Si la date fournie est un lundi, la date du dbut de semaine doit tre CE lundi
		// Comme strtotime('Last Monday',$timestamp) va renvoyer le lundi prcdent, il faut ruser :
		if (date('D',$timestamp) == "Mon")
		{
			$date = date("Y-m-d", mktime(0,0,0,$mois, $jour, $an)+24*3600); // on met 24 h de + => Mardi
			$elts = explode("-", $date);
			$an = $elts[0];
			$mois = $elts[1];
			$jour   = $elts[2];
			$timestamp = mktime(0, 0, 0, $mois, $jour, $an);
		}
		$newdate = date('Y-m-d',strtotime('Last Monday',$timestamp)); // ainsi la date du dbut de semaine renvoye est bien le lundi souhait
		return $newdate;
	}
}

function debut_semaine_alternance($alternance)
{
	/** Renvoie un tableau contenant les dates de dbut de semaines pour la quinzaine considre
	 * 
	 * @param $alternance : code_alternance = H, Q1, Q2, ...
	 * @return $tab_result : array
	 */
	
	$sql = "SELECT date_debut_semaine FROM semaines_alternances WHERE code_alternance='$alternance' ORDER BY date_debut_semaine";
	$resultat = mysql_query($sql);
	$tab_result = array();
	while ($ligne = mysql_fetch_array($resultat)) {
		array_push($tab_result,$ligne['date_debut_semaine']);
	} 
	return $tab_result;
}

function quelle_semaine_alternance($debut_semaine)
{
	$sql = "SELECT code_alternance FROM semaines_alternances WHERE date_debut_semaine='".quote_smart($debut_semaine)."' AND code_alternance NOT LIKE 'H'";
	// DEBUGG print $sql."<br />";
	$resultat = mysql_query($sql);
	if (mysql_num_rows($resultat)>0)
	{
		$ligne = mysql_fetch_array($resultat);
		$semaine_alternance = $ligne['code_alternance'];
	}
	return $semaine_alternance;
}

function date_difference($date1, $date2)
{ 
  /**
   * 
   * Calcule la diffrence entre 2 dates : en jours + heures + minutes + secondes
   * @param $date1 : 1re date  comparer au format MySQL
   * @param $date2 : 2me date  comparer au format MySQL
   * @return array : tableau contenant les diffrences */
	
  $s = strtotime($date2)-strtotime($date1); 
  $d = intval($s/86400);  
  $s -= $d*86400; 
  $h = intval($s/3600); 
  $s -= $h*3600; 
  $m = intval($s/60);  
  $s -= $m*60; 
  return array("d"=>$d,"h"=>$h,"m"=>$m,"s"=>$s); 
}

function horaires_values($horaire_base,$horaire_max,$pas)
{
	/**
	 * Renvoie un tableau avec des horaires croissants avec un pas de croissance en minutes
	 * @param  $horaire_base : horaire de dpart (format hhmm)
	 * @param  $horaire_max : horaire final (format hhmm)
	 * @param $pas : pas de croissance d'un horaire  l'autre
	 * @return $tab_horaires : tableau concernant les horaires ainsi constitus 
	 * */
	$max_iteration = ($horaire_max - $horaire_base - $pas) / 100 * (60 / $pas); // On ne dpassera pas l'horaire max
	$horaire_value = $horaire_base;
	$tab_horaires[0] = $horaire_value;
	for($i=0;$i<=$max_iteration;$i++)
	{
		$horaire_value += $pas; // on incrmente de $pas minutes  partir de la 2me itration (lors de la 1re $horaire_value ne change pas par rapport  $horaire_base)
		// Mais un horaire dont les 2 derniers chiffres dpassent 60 n'est pas admis
		$h_test_int = 60 - intval(substr($horaire_value,-2,2));
		if ($h_test_int <= 0) // On a atteint ou dpass 60
		{
			if (strlen($horaire_value) == 4) // format 0000 : l'heure est reprsente par les 2 premiers chiffres
				$nb_heures = intval(substr($horaire_value,0,2)) + 1; // il faut incrmenter l'heure
			elseif (strlen($horaire_value) == 3) // format 000 : : l'heure est reprsente par le premier chiffre
				$nb_heures = intval(substr($horaire_value,0,1)) + 1; // il faut incrmenter l'heure
			elseif (strlen($horaire_value) == 2) // format 00 : ce ne sont que les minutes
				$nb_heures = 1; // donc il y a 1 heure
			$minutes = -$h_test_int; // et rcuprer les minutes qui rsultent du dpassement
		}
		else
		{
			if (strlen($horaire_value) == 4) // format 0000 : l'heure est reprsente par les 2 premiers chiffres
				$nb_heures = intval(substr($horaire_value,0,2));
			elseif (strlen($horaire_value) == 3) // format 000 : : l'heure est reprsente par le premier chiffre
				$nb_heures = intval(substr($horaire_value,0,1));
			elseif (strlen($horaire_value) == 2) // format 00 : ce ne sont que les minutes
				$nb_heures = 0; // donc il y a 0 heure
			$minutes = intval(substr($horaire_value,-2,2));
		}
		$horaire_value = $nb_heures * 100; // on rcrit la valeur numrique de la bonne heure
		if ($minutes < 10)
			$minutes = "0".strval($minutes);
		if ($nb_heures < 10)
			$horaire_value = "0".$nb_heures.$minutes;
		else 
			$horaire_value = $nb_heures.$minutes;
		$tab_horaires[] = $horaire_value;
	}
	return $tab_horaires;
}

function Check_DateTime($date_time)
{
 	/**
	 * Vrifie si une date est au format DATETIME "YYYY-MM-DD HH:MM:SS"
	 * et correspond  une date correcte
	 * Lance une exception en cas d'erreur 
	 * 
	 */
	if (preg_match("#^([1-9][0-9]{3})-(0[1-9]|1[012])-(0[1-9]|[12][0-9]|3[01])\s(0[0-9]|1[0-9]|2[0-3]):([0-5][0-9]):([0-5][0-9])$#",
     $date_time))
   	{
     	return true;
   	}
    else
    {
     	echo "ERREUR !!";
    	return false;
     }
}         

function JoursFeries($date)
{
	/**
	 * Dtermine si le timestamp fourni en paramtre correspond  un jour fri
	 * 
	 * @param $date : timestamp
	 * @return boolean
	 */
	
	if ($date === null)
    {
    	$date = time();
    }
 
    $date = strtotime(date('m/d/Y',$date));
 
    $year = date('Y',$date);
 
    $easterDate  = easter_date($year);
    $easterDay   = date('j', $easterDate);
    $easterMonth = date('n', $easterDate);
    $easterYear   = date('Y', $easterDate);

    $holidays = array(
    // Dates fixes
    mktime(0, 0, 0, 1,  1,  $year),  // 1er janvier
    mktime(0, 0, 0, 5,  1,  $year),  // Fte du travail
    mktime(0, 0, 0, 5,  8,  $year),  // Victoire des allis
    mktime(0, 0, 0, 7,  14, $year),  // Fte nationale
    mktime(0, 0, 0, 8,  15, $year),  // Assomption
    mktime(0, 0, 0, 11, 1,  $year),  // Toussaint
    mktime(0, 0, 0, 11, 11, $year),  // Armistice
    mktime(0, 0, 0, 12, 25, $year),  // Noel
 
    // Dates variables
    mktime(0, 0, 0, $easterMonth, $easterDay + 1,  $easterYear),
    mktime(0, 0, 0, $easterMonth, $easterDay + 39, $easterYear),
    mktime(0, 0, 0, $easterMonth, $easterDay + 50, $easterYear),
    );
 
    return in_array($date, $holidays);
}

function getNbJoursSemaineEcoules()
{
	/**
	 * Renvoie le nombre de lundis ou mardi ou .... ouvrables (pendant les priodes de cours) couls depuis la rentre scolaire jusqu' aujourd'hui
	 * 
	 * @return $nb_jours_ouvrables_ecoules : array("1" => array("Q1"=>int,"Q2"=>int),...) 	 1 = lundi, 2 = mardi etc
	 */
	
	$alternances_quinzaine = array("Q1","Q2");
	$nb_jours_ouvrables_ecoules = array();

	foreach ($alternances_quinzaine as $value) {
		$nom_tab = "dates_debut_semaine" . $value;
		$$nom_tab = debut_semaine_alternance($value);
		$next_value = current($alternances_quinzaine);
		if ($next_value === false) 
			$next_value = reset($alternances_quinzaine);
		$nom_tab_next = "dates_debut_semaine" . $next_value;
		$$nom_tab_next = debut_semaine_alternance($next_value);
		$nb_jours_ouvrables_ecoules = getNbJoursSemaineEcoulesQuinzaine($nb_jours_ouvrables_ecoules, $value, $$nom_tab, $$nom_tab_next);
		next($alternances_quinzaine);
	}
	
	return $nb_jours_ouvrables_ecoules;
}

function getNbJoursSemaineEcoulesQuinzaine($nb_jours_ouvrables_ecoules,$alternance_quinzaine, $debut_semaine_alternance_quinzaine, $next_debut_semaine_alternance_quinzaine)
{
	$aujourdhui = date('Y-m-d');
	foreach ($debut_semaine_alternance_quinzaine as $value) {
		if ($value < $aujourdhui) {
			// quel jour ?
			// on calcule le timestamp de la date (ncessaire pour la fct strtotime())
			$elts = explode("-", $value);
			$an = $elts[0];
			$mois = $elts[1];
			$jour   = $elts[2];
			$timestamp = mktime(0, 0, 0, $mois, $jour, $an);
			if (!JoursFeries($timestamp)) // si le dbut de semaine tombe un jour fri, il ne sera pas comptabilis
				$nb_jours_ouvrables_ecoules[date('w',$timestamp)][$alternance_quinzaine]++;
				//$date = date("Y-m-d", mktime(0,0,0,$mois, $jour, $an)+24*3600); // on met 24 h de + : cette mthode ne fonctionne pas le jour du passage  l'heure d'hiver ou d't (la date reste bloque  la mme valeur = bug de mktime)
			$date = date("Y-m-d", mktime(0,0,0,$mois, $jour+1, $an)); // on met 24 h de + : cette mthode marche !// on cherche si ces 24 h de + nous font tomber dans une autre quinzaine
			$next_value = next($debut_semaine_alternance_quinzaine);
			while ($date < $next_value)	 {
				if (array_search($date,$next_debut_semaine_alternance_quinzaine) === false) {
					$elts = explode("-", $date);
					$an = $elts[0];
					$mois = $elts[1];
					$jour   = $elts[2];
					$timestamp = mktime(0, 0, 0, $mois, $jour, $an);
					if (date('w',$timestamp) != 0 && test_jour_dans_periode_scolaire($date) && !JoursFeries($timestamp)) // le dimanche ne compte pas, les jours de vacances scolaires non plus (comment fait-on avec les jours fris ?)
						$nb_jours_ouvrables_ecoules[date('w',$timestamp)][$alternance_quinzaine]++;
					//$date = date("Y-m-d", mktime(0,0,0,$mois, $jour, $an)+24*3600); // on met 24 h de + : cette mthode ne fonctionne pas le jour du passage  l'heure d'hiver ou d't (la date reste bloque  la mme valeur = bug de mktime)
					$date = date("Y-m-d", mktime(0,0,0,$mois, $jour+1, $an)); // on met 24 h de + : cette mthode marche !
				} else	break;
			}
		} else	break;
	}
	return $nb_jours_ouvrables_ecoules;
}
?>