<?php
/**
 * fonctions_diverses.php
 *
 * regroupe les fonctions n'tant pas classes ailleurs (fourre-tout)
 * 
 * Ce fichier fait partie du projet IntraEduWeb (IEW)
 * 
 * @package		IEW
 * @author			Sylvain GODM <sylvain.godme@gmail.com>
 * @version		$LastChangedRevision$, $LastChangedDate$
 * @copyright		2004-2012 Sylvain GODM
 * @link			http://iew.free.fr
 * @license		GPL License version 3 (http://www.gnu.org/licenses/gpl.html)
 * @filesource
 * 
 */

// On cherche le rpertoire d'installation IEW
if(!defined('IEW_DIR')) define('IEW_DIR',realpath(dirname(__FILE__)."/../").'/');

function horaires()
 //***************************** description *****************************************************************//
 // cette fonction renvoie un tableau contenant la liste des horaires de dbut de cours pour la journe
 // Date de cration : 24/11/2004
 // Date de dernire mise  jour : 05/02/2005
 //***************************** Fin description ***********************************************************//
 {
   global $admin_email;
   $sql = "SELECT * FROM horaires";
   $resultat = mysql_query($sql);
   if (!$resultat)
   {
    affiche_erreurs("La table contenant les informations pour les horaires de dbut des cours n'existe
    pas. Prvenez votre <a href='mailto:".email_encode($admin_email)."'>administrateur IntraEduWeb</a>.");
   }
   else
   {
     if (mysql_num_rows($resultat)==0)
     {
      affiche_erreurs("La table contenant les informations pour les horaires de dbut des cours existe bien
      mais ne contient aucune donne. Prvenez votre <a href='mailto:".email_encode($admin_email)."'>administrateur IntraEduWeb</a>.");
     }
     else
     {
       $enregistrement = mysql_fetch_array($resultat);
       $debut_matin = $enregistrement["debut_matin"];
       $nb_matin = $enregistrement["nb_matin"];
       $debut_aprem = $enregistrement["debut_aprem"];
       $nb_aprem = $enregistrement["nb_aprem"];
       $duree_cours = $enregistrement["duree_cours"];
       $tableau_horaires=array();
       array_push($tableau_horaires,$debut_matin); // le 1er horaire de cours de la journe (chane affiche)
       $valeur = intval(substr($debut_matin,0,2).substr($debut_matin,-2,2)); // ex : 08h00 devient le nombre 800
       //$valeur = intval(substr($debut_matin,0,2));
       for ($i=1;$i<$nb_matin;$i++)
       {
         $valeur += 100;
         if ($valeur<1000)
         {
           $chaine_valeur = "0".substr(strval($valeur),0,1)."h".substr($debut_matin,-2,2);
         }
         else
         {
           $chaine_valeur = substr(strval($valeur),0,2)."h".substr($debut_matin,-2,2);
         }
         array_push($tableau_horaires,$chaine_valeur);
       }
       array_push($tableau_horaires,$debut_aprem); // le 1er horaire de cours de l'aprs-midi (chane affiche)
       $valeur = intval(substr($debut_aprem,0,2).substr($debut_aprem,-2,2)); // ex : 13h30 devient le nombre 1330
       for ($i=1;$i<$nb_aprem;$i++)
       {
         $valeur += 100;
         $chaine_valeur = substr(strval($valeur),0,2)."h".substr($debut_aprem,-2,2);
         array_push($tableau_horaires,$chaine_valeur);
       }
       return $tableau_horaires;
     }
   }
 }

function verif_authdir_data($stock_baselev)

  //***************************** description *****************************************************************//
 // cette fonction permet de vrifier l'existence et les droits d'accs
 // au rpertoire de stockage des fichiers spciaux (la base lves provenant de GEP, identifiants utilisateurs)
 // Date de cration : 12/07/2004
 // Date de dernire mise  jour : 09/07/2006
 //***************************** Fin description ***********************************************************//
{  
  $error_message = "";
  if (is_dir($stock_baselev)) // Si le dossier existe
  {
    // On tente dj de modifier les droits puis d'y crire
    chmod($stock_baselev, 0700); // tous droits pour le propritaire seulement (utilisateur apache)
    if (!test_ecrire($stock_baselev)) // Si a ne marche pas
    $error_message = "<div align='justify'>Les droits d'accs sur le dossier <b>$stock_baselev</b> ne permettent pas  IntraEduWeb d'y crire.<br /><br />Vous pouvez soit changer le propritaire du dossier (nouveau propritaire : utilisateur sous le nom duquel tourne le service web), soit modifier les droits d'accs en lecture/criture pour tout le monde.<br /><br />Veuillez remdier  ce problme puis Cliquez sur le bouton 'Actualiser' du navigateur pour recharger cette page.<br /><br />Le script a t interrompu.</div>";
  }
  else
  {
    $error_message = "<div align='justify'>Le dossier <b>$stock_baselev</b> qui doit servir au stockage d'une partie des donnes de l'application n'existe pas ou a t supprim !<br />Il est galement possible que la directive open_basedir du fichier de configuration PHP (php.ini) ne permette pas l'accs  ce dossier : consultez la documentation d'installation pour davantage de dtails.<br />Le script a t interrompu. <br />Veuillez utiliser le bouton 'page prcdente' de votre navigateur pour pouvoir revenir au formulaire prcdent</div>";
  }
  return $error_message;
}

function test_ecrire($my_dir) {
//***************************** description *****************************************************************//
 // cette fonction permet de vrifier les droits d'critures dans un dossier
 // Date de cration : tir de SPIP (spip_tests_dirs.php3)
 // Date de dernire mise  jour : 
 //***************************** Fin description ***********************************************************//
	$ok = true;
	$nom_fich = $my_dir."test.txt";
	/*
	 * Suite  des messages d'erreur affichs sur les pages de gestion des remplacements de professeurs
	 * voici une correction destine  viter les problmes lis aux chevauchements de requtes AJAX asynchrones
	 * faisant appel  des scripts incluant les fonctions de la librairie (qui incluent le script config.php,
	 * ce qui semble provoquer son excution donc celle de la fonction verif_authdir_data() )*/
	$i = 1;
	while (file_exists($nom_fich))
	{
		$i++;
		$nom_fich = $nom_fich.$i;
	}
	$f = fopen($nom_fich, "w");
	if (!$f) $ok = false;
	else if (!fclose($f)) $ok = false;
	else if (!unlink($nom_fich)) $ok = false;
	return $ok;
}

function verif_url_syntax_exist($url)
//***************************** description *****************************************************************//
 // cette fonction permet de vrifier la syntaxe et l'existence d'une URL
 // Date de cration : 12/01/2005
 // Date de dernire mise  jour : 
 //***************************** Fin description ***********************************************************//
{
  $error_message = "";
  // On vrifie d'abord la syntaxe, ici les dlimiteurs sont # donc le #  l'intrieur du masque est chapp
  if (!preg_match("#^http(s)?://[_A-Z0-9-]+\.?[_A-Z0-9-]+[.A-Z0-9-]*(:[0-9]+)?(/~|/?)[/_.A-Z0-9\#?&=+-]*$#i",$url))
  {
    $error_message = "L'URL '$url' n'est pas valide !";
  }
  
  // On vrifie ensuite si l'URL existe bien (attention au timeout)
  $details = parse_url($url);
  // vrification du port 80 li au protocole HTTP
    if (!isset($details['port'])) {
        $details['port'] = "80";
    }
    // vrification du chemin
    if (!isset($details['path'])) {
        $details['path'] = "/";
    }
    // vrification de l'adresse du serveur, il faut faire attention au timeout
    if (!preg_match("#[0-9]+\.[0-9]+\.[0-9]+\.[0-9]+#", $details['host']))
    {
        $details['host'] = gethostbyname($details['host']);
    }
    // ouverture d'une connexion vers le serveur
    $timeout = 10;
	if (false !== ($fp = @fsockopen($details['host'], $details['port'], $errno, $errstr, $timeout)))
	{
    	fclose($fp);
	}
	else
	{
    	$error_message = "L'URL '$url' n'existe pas ou le serveur ne rpond pas (Erreur #" . $errno . " : " . $errstr . "). Veuillez vrifier cette URL. Il est aussi possible que votre connexion internet ne soit pas active; dans ce cas, laissez le champ correspondant du formulaire vide et cliquez sur le bouton de validation. Vous pourrez y revenir plus tard.";
	}
  return $error_message; // vide si pas d'erreur
}

function numtel($tel)
//***************************** description *****************************************************************//
 // cette fonction permet de formater un numro de tlphone
 // Date de cration : 
 // Date de dernire mise  jour : 14/01/2005
 //***************************** Fin description ***********************************************************//
{
    $ch = 10;                               // Numro  10 chiffres
    $tel = preg_replace('#[^0-9]#i',"",$tel); // supression sauf chiffres
    $tel = trim($tel);                      // suppression espaces avant et aprs
    if (strlen($tel) > $ch)
    {
        $d = strlen($tel) - $ch; // retrouve la position pour ne garder
                                 // que les $ch derniers
    }
    else
    {
        $d = 0;
    }
    $tel = substr($tel,$d,$ch); // rcupration des $ch derniers chiffres
    $regex = '#([0-9]{1,2})([0-9]{1,2})([0-9]{1,2})([0-9]{1,2})([0-9]{1,2})$#i';
    $newtel = preg_replace($regex,
        '\\1 \\2 \\3 \\4 \\5',$tel); // mise en forme
    return $newtel; /* Exemple : 03 81 51 45 78  */
}

function enlever_valeurs_vides($tableau)
{
  $r = array(); // le tableau de retour
  if (is_array($tableau))
  {
    reset($tableau);
    while (list($key, $val)=each($tableau))
    {
      if ($val) $r[$key]=$val;
    }
    return $r;
  } 
  else
   return false;
}

function recup_get_url($tableau)
//***************************** description *****************************************************************//
 // cette fonction permet de rcuprer les variables du tableau $_GET pour les rinjecter dans une url
 // Utilise notamment pour les versions imprimables des pages (permet de renvoyer les arguments GET s'il y
 // en avait dans l'url de la page au format normal)
 
 // La variable 'imprimable' du tableau $_GET n'est pas prise en compte car si l'appel provient d'un lien
 // de format imprimable, cette variable existe dj et a une valeur crite dans le lien positionne sur oui
 // Au retour au format normal, cette variable est positionne sur non dans le lien, ce qui fait que l'on peut
 // se retrouver avec deux variables 'imprimable' dans l'url finale (la dernire valeur crasant la 1re)
 // c'est--dire par exemple ?imprimable=oui&imprimable=non; on vite ceci dans le code qui suit
 
 // Date de cration : 28/01/2005
 // Date de dernire mise  jour : 
 //***************************** Fin description ***********************************************************//
{
  $liste_arguments = "";
  if (isset($tableau))
  {
    reset($tableau);
    while (list($key, $val)=each($tableau))
    {
      if ($key != "imprimable")
        $liste_arguments .= "&amp;".$key."=".$val;
    }
    return $liste_arguments;
  }
  else
  {
    return;
  }
}

function recup_post_url($tableau)
//***************************** description *****************************************************************//
 // cette fonction permet de rcuprer les variables du tableau $_POST pour les transmettre dans une url
 // Utilise notamment pour les versions imprimables des pages (permet de renvoyer les valeurs POST s'il y
 // en avait dans la page au format normal)
 // Date de cration : 13/02/2005
 // Date de dernire mise  jour : 13/02/2005
 //***************************** Fin description ***********************************************************//
{
  $liste_arguments = "";
  if (isset($tableau))
  {
    $liste_arguments .= "&post=".$val;
   
    return $liste_arguments;
  }
  else
  {
    return;
  }
}

function recup_url_param_from_query_string($query_string)
{
	/**
	 * Permet de rcuprer les paramtres url contenus dans une query_string sous forme de tableau cl; valeur
	 * 
	 * @param $query_string : QUERY_STRING
	 * @return $url_params : Tableau dont les clssont les noms des variables de la QUERY_STRING, et dont les valeurs sont les valeurs de ces variables
	 */
	$url_params = array();
	$tableau = explode("&",$query_string);
    foreach($tableau as $value)
    {
    	$fragment = explode("=",$value);
    	$key = $fragment[0];
    	$key_value = $fragment[1];
    	$url_params[$key] = $key_value;
    }
    return $url_params;
}

function ajouterParametreGET($url, $paramNom, $paramValeur)
{
	/**
	 * Ajoute ou modifie un paramtre URL avec la valeur fournie
	 * 
	 * @param $url : url de la page
	 * @param $paramNom : nom du paramtre URL  ajouter/modifier
	 * @param $paramValeur : valeur du paramtre  inscrire
	 * 
	 * @return $urlFinal : url modifie
	 */
	$urlFinal = "";
	if($paramNom=="")
	{
		$urlFinal = $url;
	}
	else
	{
		$t_url = explode("?",$url);
		if(count($t_url)==1)
		{
			// pas de queryString
			$urlFinal .= $url;
			if(substr($url,strlen($url)-1,strlen($url))!="/")
			{
				$t_url2 = explode("/",$url);
				if(preg_match("/./",$t_url2[count($t_url2)-1])==false)
				{
					$urlFinal .= "/";
				}
			}
			$urlFinal .= "?".$paramNom."=".$paramValeur;
		}
		else if(count($t_url)==2)
		{
			// il y a une queryString
			$paramAAjouterPresentDansQueryString = "non";
			$t_queryString = explode("&",$t_url[1]);
			foreach($t_queryString as $cle => $coupleNomValeur)
			{
				$t_param = explode("=",$coupleNomValeur);
				if($t_param[0]==$paramNom)
				{
					$paramAAjouterPresentDansQueryString = "oui";
				}
			}
			if($paramAAjouterPresentDansQueryString=="non")
			{
				// le parametre  ajouter n'existe pas encore dans la queryString
				$urlFinal = $url."&amp;".$paramNom."=".$paramValeur;
			}
			else if($paramAAjouterPresentDansQueryString=="oui")
			{
				// le parametre  ajouter existe dj dans la queryString
				// donc on va reconstruire l'URL
				$urlFinal = $t_url[0]."?";
				foreach($t_queryString as $cle => $coupleNomValeur)
				{
					if($cle > 0)
					{
						$urlFinal .= "&amp;";
					}
					$t_coupleNomValeur = explode("=",$coupleNomValeur);
					if($t_coupleNomValeur[0]==$paramNom)
					{
						$urlFinal .= $paramNom."=".$paramValeur;
					}
					else
					{
						$urlFinal .= $t_coupleNomValeur[0]."=".$t_coupleNomValeur[1];
					}
				}
			}
		}
	}
	return $urlFinal;
}

function intro_texte($texte, $long) 
//***************************** description *****************************************************************//
 // cette fonction permet d'extraire les $long premiers caractres d'un texte sans couper au milieu d'un mot
 //***************************** Fin description ***********************************************************//
{
  if (strlen($texte)<$long+26)
    return $texte;
  // On prend les $long + 1 premiers caractres du texte
  $extrait = substr($texte,0,$long);
  
  // Problme : il se peut que l'on coupe au milieu d'un mot
  while (preg_match("#[!-~]#",substr($extrait,-1,1))) // si le dernier caractre de l'extrait n'est pas transparent
  {
    // alors, on recule pour examiner le caractre prcdent
    $extrait = substr($extrait,0,strlen($extrait)-1);
  }
  // si on arrive l, c'est qu'un caractre transparent a t trouv
  // on continue de reculer en cherchant le premier caractre non transparent (c'est l qu'il faudra arrter l'introduction)
  while (preg_match("#[^!-~]#",substr($extrait,-1,1))) // tant que Le caractre est transparent
  {
    // on recule
    $extrait = substr($extrait,0,strlen($extrait)-1);  
  }
  // ouf, c'est fini
  $intro = $extrait."...";
  return $intro;
}

function noaccent($texte)
{
  $acc='';  
  $noacc='AAAAAAaaaaaaOOOOOOooooooEEEEeeeeCcIIIIiiiiUUUUuuuuyNn';  
  $texte = strtr($texte,$acc,$noacc); 
  return $texte;
}

function nospace($texte)
{
  $space=" ";
  $nospace="_";
  $texte = strtr($texte,$space,$nospace);
  return $texte;
}

function noplus($texte)
{
	/*
	 * Utilis dans le traitement du nom d'un fichier lorsque celui-ci ne doit pas contenir de symbole "+"
	 * => Exemple, download_file.php avec un paramtre GET file comme CT_ineq+angles.pdf
	 * => $_GET['file'] contient alors "CT_ineq angles.pdf" au lieu de "CT_ineq+angles.pdf"
	 * => Le symbole "+" n'est donc pas pris en compte, le fichier n'est donc pas reconnu
	 * 
	 * Cette foncion avant enregistrement du nom de fichier (document joint  un cahier de textes)
	 */
	$plus = "+";
	$noplus = "-";
	$texte = strtr($texte,$plus,$noplus); 
  	return $texte;
}

function respace($texte)
{
  // c'est le contraire de nospace() => Remet les espaces  la place des tirets-bas
  $space=" ";
  $nospace="_";
  $texte = strtr($texte,$nospace,$space);
  return $texte;
}

function download_file($path_file,$fichier)
{
  /****************** ATTENTION ****************************/
  // du fait des intructions header, aucune sortie HTML ne doit
  // avoir t faite dans le script d'appel avant l'xcution de la fonction
  // on teste si le fichier est sur le serveur, si c'est le cas, on envoie le tlchargement
  
  if( headers_sent() )
    die('Des enttes HTTP ont dj t envoys. Le tlchargement ne peut avoir lieu.');

  // Required for some browsers
  if(ini_get('zlib.output_compression'))
    ini_set('zlib.output_compression', 'Off');

  // File Exists?
  if( file_exists($path_file.$fichier) )
  {
   
    // Parse Info / Get Extension
    $fsize = filesize($path_file.$fichier);
    $path_parts = pathinfo($path_file.$fichier);
    $ext = strtolower($path_parts["extension"]);
    
    // Determine Content Type
    switch ($ext)
    {
      case "pdf": $ctype="application/pdf"; break;
      case "exe": $ctype="application/octet-stream"; break;
      case "zip": $ctype="application/zip"; break;
      case "doc": $ctype="application/msword"; break;
      case "xls": $ctype="application/vnd.ms-excel"; break;
      case "ppt": $ctype="application/vnd.ms-powerpoint"; break;
      case "gif": $ctype="image/gif"; break;
      case "png": $ctype="image/png"; break;
      case "jpeg":
      case "jpg": $ctype="image/jpg"; break;
      case "gz": $ctype="application/x-gzip"; break;
      default: $ctype="application/force-download";
    }

    header("Pragma: public"); // required
    header("Expires: 0");
    header("Cache-Control: must-revalidate, post-check=0, pre-check=0");
    header("Cache-Control: private",false); // required for certain browsers
    header("Content-Type: $ctype");
    header("Content-Disposition: attachment; filename=\"".basename($path_file.$fichier)."\";" );
    header("Content-Transfer-Encoding: binary");
    header("Content-Length: ".$fsize);
    ob_clean();
    flush();
    readfile( $path_file.$fichier );
  }
  else
  {
  	debut_code_html();
    $error_message = array("
    Le fichier ".$path_file.$fichier." que vous souhaitez tlcharger n'existe pas sur le serveur","");
    affiche_erreurs($error_message);
    fin_code_html();
  }
}

function session_trouve_matieres_classe()
{
  // cette fonction cherche pour une classe donne (en variable de session), la liste des matires et sous-matires
  // qui y sont enseignes
  // le rsultat sera stock dans deux variables de session $_SESSION['liste_matieres'] et $_SESSION['liste_sous_matieres']
  // Cette fonction est utilise par les scripts relatifs aux cahiers de textes
  if (isset($_SESSION['classe_en_cours']) && $_SESSION['classe_en_cours']!="")
  {
    // on rcupre d'abord la liste des matires
    // si c'est une classe (pas un groupe! Dans le cas d'un groupe, il n'y a pas vraiment de matire, puisque la nature du groupe constitue en lui-mme une 'matire')
    if ($_SESSION['type_structure_en_cours'] == "D")
    {
      $sql = "SELECT matieres_sconet.libelle_edition, matieres_sconet.code_matiere FROM matieres_sconet,services WHERE matieres_sconet.code_matiere=services.code_matiere AND (code_structure='".quote_smart($_SESSION['classe_en_cours'])."' OR code_structure IN (SELECT code_structure FROM structures WHERE divisions_appartenance like '%".quote_smart($_SESSION['classe_en_cours'])."%')) ORDER BY libelle_edition";
      // DEBUGG echo $sql."<br />";
      $resultat = mysql_query($sql);
      if ($resultat)
      {
        if (mysql_num_rows($resultat)>0)
        {
          while ($ligne = mysql_fetch_array($resultat))
          {
            $i = $ligne['code_matiere']; // l'id_matiere correspondra  la cl dans le tableau $liste_matieres
            $_SESSION['liste_matieres'][$i] = $ligne['libelle_edition'];
          }
          // DEBUGG var_dump($_SESSION['liste_matieres']);
		  // Voil pour les matires en classe entire
		  // Mais on n'a peut-tre pas rcupr certaines matires : les langues vivantes (si les lves sont en groupes dans ces matires)
		  // le latin, l'accompagnement au travail, les idd....
		  /* En effet certains services correspondant  des matires ne sont pas associs directement  la classe mais peut-tre  un groupe constitu d'lves de la classe */
		  $liste_groupes_de_cette_classe = cherche_classe_dans_groupes($_SESSION['classe_en_cours']);
		  // On cherche les services correspondants
		  $where = "matieres_sconet.code_matiere=services.code_matiere AND code_structure IN(";
		  foreach ($liste_groupes_de_cette_classe as $value)
		  {
		  	$where .= "'$value',";
		  }
		  // si aucun groupe ne correspond  cette classe, alors il n'y a pas de recherche  faire
		  if (count($liste_groupes_de_cette_classe) != 0)
		  {
		  	// ici, il y a au moins un groupe qui concerne la classe
		  	$where = substr($where,0,strlen($where)-1).")"; // on retire la virgule terminale et on ferme la ()
		  	$sql = "SELECT DISTINCT matieres_sconet.libelle_edition, matieres_sconet.code_matiere FROM matieres_sconet,services WHERE $where ORDER BY libelle_edition";
		  	// DEBUGG print $sql."<br />"; 
		  	$resultat1 = mysql_query($sql);
          	if (mysql_num_rows($resultat1)>0)
          	{
          		while ($ligne = mysql_fetch_array($resultat1))
          		{
            		// Si c'est un lve (ou un de ses parents) qui est connect, alors on n'affichera pas les matires ou les groupes dans lesquels il n'est pas
          			if ($_SESSION['valid_group'] != "2" && $_SESSION['valid_group'] != "4") // Ce n'est ni un lve, ni un parent d'lve
          			{
          				// alors l'utilisateur verra toutes les matires concernant la classe
	          			// DEBUGG echo "<br />On va incorporer la matire ".$ligne['libelle_edition']."<br />";
    	      			$i = $ligne['code_matiere']; // le code matiere correspondra  la cl dans le tableau $liste_matieres
        	    		$_SESSION['liste_matieres'][$i] = $ligne['libelle_edition'];
            			// DEBUGG var_dump($_SESSION['liste_matieres']);
	          		}
          			else // c'est un lve (ou un de ses parents) qui est connect
          			{          			
          				// Alors on vrifie que la matire en cours lui est bien enseigne en groupe
          				foreach($liste_groupes_de_cette_classe as $value)
          				{
	          				if ($_SESSION['valid_group'] == "2") // c'est l'lve lui-mme
    	      				{
        	  					$sql = "SELECT t2.eleve_id, code_matiere FROM groupes as t1, groupes_eleves as t2, services as t3 WHERE t1.nom='$value' AND t1.id_groupe=t2.id_groupe AND t2.eleve_id='".quote_smart($_SESSION['identifiant_individu'])."' AND t3.code_structure='$value' AND t3.code_matiere='".$ligne['code_matiere']."'";
          					}
          					else // c'est l'un de ses parents
          					{
	          					$sql = "SELECT t2.eleve_id, code_matiere FROM groupes as t1, groupes_eleves as t2, services as t3 WHERE t1.nom='$value' AND t1.id_groupe=t2.id_groupe AND t2.eleve_id='".quote_smart($_SESSION['ctextes_enfant_id'])."' AND t3.code_structure='$value' AND t3.code_matiere='".$ligne['code_matiere']."'";
    	      				}
        	  				// DEBUGG echo $sql."<br />";
          					$resultat2 = mysql_query($sql);
          					if (mysql_num_rows($resultat2)>0) // L'lve fait partie du groupe
          					{
          						// Alors il faut rcuprer la matire pour ne pas l'afficher
	          					// DEBUGG echo "<br />On va incorporer la matire ".$ligne['libelle_edition']."<br />";
    	      					$i = $ligne['code_matiere']; // le code matiere correspondra  la cl dans le tableau $liste_matieres
        	    				$_SESSION['liste_matieres'][$i] = $ligne['libelle_edition'];          						
          					}      
          				}          			          			
          			}
          		}
          	}
		  }
          asort($_SESSION['liste_matieres']);
          // DEBUGG echo "resultat : "; var_dump($_SESSION['liste_matieres']);
        }
      }
      else
      {
        $error_message = array("Le serveur de base de donnes est indisponible. Veuillez ressayer ultrieurement.","");
        affiche_erreurs($error_message);
        return;
      }
    }
    elseif ($_SESSION['type_structure_en_cours'] == "G") // Cas d'un groupe sconet (peut concerner plusieurs matires)
    {
      
      // Par exemple un groupe d'lves bi-langues 5BIL = 5me Bilangue => Anglais LV1 et Allemand LV2
      $sql = "SELECT libelle_edition,t1.code_matiere FROM services as t1, matieres_sconet as t2 WHERE t1.code_structure='".$_SESSION['classe_en_cours']."' AND t1.code_matiere=t2.code_matiere ORDER BY libelle_edition";
      $resultat = mysql_query($sql);
      if (mysql_num_rows($resultat)>0)
      {
      	while ($ligne = mysql_fetch_array($resultat))
        {
        	$i = $ligne['code_matiere']; // le code matiere correspondra  la cl dans le tableau $liste_matieres
        	$_SESSION['liste_matieres'][$i] = $ligne['libelle_edition'];	
        }
      }
      $_SESSION['liste_sous_matieres'] = array(); // juste un tableau vide (vite un warning par la suite)
    }
   
    // on rcupre ensuite la liste des sous-matires connues de IEW (table sous_matieres)
    $sql ="SELECT * FROM sous_matieres ORDER BY sous_matiere";
    $resultat = mysql_query($sql);
    if ($resultat)
    {
      if (mysql_num_rows($resultat)>0)
      {
        while ($ligne = mysql_fetch_array($resultat))
        {
          $i = $ligne['code_matiere']; // le code_matiere parent correspondra  la cl dans le tableau $liste_sous_matieres
          $j = $ligne['id_sous_matiere'];
          $_SESSION['liste_sous_matieres'][$i][$j] = $ligne['sous_matiere'];         
        }
       // DEBUGG echo "Liste des sous-matires trouves : "; var_dump($_SESSION['liste_sous_matieres']); echo "<br />";
      }
    }
  }
  else
  {
    $_SESSION['liste_matieres'] = array();
    $_SESSION['liste_sous_matieres'] = array();
  }
}

function recup_choix_classe_ctextes()
{
  // Cette fonction a pour but de rcuprer la classe choisie dans le formulaire d'entre dans le cahier de texte
  // En effet, si l'utilisateur est un IPR, alors la variable $_POST['classe'] contient un format 'classe (civilit prenom nom du prof inspect), matiere du prof', il faut donc rcuprer la classe
  if ($_SESSION['valid_group'] == "11")
  {
    if (isset($_POST['classe']))
    {
  		$fragments = explode("(",$_POST['classe']);
    	$suite = explode(")",$_POST['classe']);
    	$libelle_matiere = trim($suite[1]); // La matire  consulter, il faut retrouver le code associ
    	foreach ($_SESSION['ipr_liste_matieres'] as $value)
    	{
    		$new_fragments = explode(',',$value);
    		if ($new_fragments[2] == $libelle_matiere)
    			$_SESSION['ipr_choix_matiere'] = $new_fragments[0]; // La matire  consulter (code_matiere)	
    	}
    	return trim($fragments[0]); // La classe seule est renvoye
    }
    elseif(isset($_GET['set_classe']) && isset($_GET['matiere'])) // Accs au ctextes par 1 IPR  partir de l'EDT d'un prof ou d'une classe
    {
    	// il faut vrifier que la classe est autorise et que la matire aussi
    	if (in_array($_GET['matiere'],$_SESSION['ipr_liste_codes_matieres']))
    		$_SESSION['ipr_choix_matiere'] = $_GET['matiere']; // sinon la variable de session garde la dernire valeur affecte (accs au chaier de textes de la matire) ou rien si non initialise (Dans ce cas message : vous n'avez pas accs aux autres disciplines que celle que vous inspectez)
    	if (in_array($_GET['set_classe'],$_SESSION['ipr_liste_codes_structures']))
    		return $_GET['set_classe'];
    }
  }
  elseif(isset($_GET['set_classe']))
    return $_GET['set_classe'];
  else
  {
  	if ($_SESSION['valid_group'] == "4") // cas d'un parent : $_POST['classe'] est alors au format classe%eleve_id
  	{
  		// On rcupre la classe
  		if (strstr($_POST['classe'],"%"))
  		{
  			$fragment = explode("%",$_POST['classe']);
  			$_SESSION['choix_classe_enfant'] = $_POST['classe']; // On rcupre le couple classe%eleve_id ncessaire pour raffichage de la valeur choisie pour le formulaire de synthse
  			$_POST['classe'] = $fragment[0]; // voil la classe seule
  			$_SESSION['ctextes_enfant_id'] = $fragment[1]; // Voil l'identifiant de l'lve dont le parent veut voir le cahier de texte
	  		// cet identifiant sera utilis notamment dans la fonction session_trouve_matieres_classe() pour rcuprer la liste des matires
  			// rellement enseignes  cet lve (latin par exemple s'il fait partie d'un tel groupe
  		}
  	}
  }
    return $_POST['classe']; // Comme ce n'est pas un IPR, on peut prendre directement la valeur renvoye dans le POST
}

function cherche_type_structure($classe)
{
	/* Renvoie le type de structure de l'argument $classe
	 * => D, si c'est une division
	 * => G, si c'est un groupe sconet
	 * => GM, si c'est un groupe cr manuellement
	 * */
	$sql = "SELECT type_structure FROM structures WHERE code_structure='".quote_smart($classe)."'";
  	$resultat=mysql_query($sql);
  	if (mysql_num_rows($resultat)>0)
  	{
  		$record = mysql_fetch_array($resultat);
  		$type_structure = $record['type_structure']; // Vaut D (division) si c'est une classe et G si c'est un groupe sconet
  	}
  	else // La structure n'est pas identifie en tant que structure sconet (groupe cr manuellement dans IEW par ex)
  	{
  		$type_structure = "GM"; // Alors c'est forcment un groupe manuel
  	}
  	return $type_structure;
}

function copyr($source, $dest)
{
    
    /**
 * Copy a file, or recursively copy a folder and its contents
 *
 * @author      Aidan Lister <aidan@php.net>
 * @version     1.0.1
 * @param       string   $source    Source path
 * @param       string   $dest      Destination path
 * @return      bool     Returns TRUE on success, FALSE on failure
 */
    // Simple copy for a file
    if (is_file($source)) {
        return copy($source, $dest);
    }
 
    // Make destination directory
    if (!is_dir($dest)) {
        mkdir($dest);
    }
 
    // Loop through the folder
    $dir = dir($source);
    while (false !== $entry = $dir->read()) {
        // Skip pointers
        if ($entry == '.' || $entry == '..') {
            continue;
        }
 
        // Deep copy directories
        if ($dest !== "$source/$entry") {
            copyr("$source/$entry", "$dest/$entry");
        }
    }
 
    // Clean up
    $dir->close();
    return true;
}

function chmod_R($path, $filemode)
{
   //$filemode = octdec($filemode); // transformation en octal
   // permet de changer les permissions sur un rperoire de faons rcursive
   if (!is_dir($path))
       return chmod($path, $filemode);

   $dh = opendir($path);
   while ($file = readdir($dh)) {
       if($file != '.' && $file != '..') {
           $fullpath = $path.'/'.$file;
           if(!is_dir($fullpath)) {
             if (!chmod($fullpath, $filemode))
                 return FALSE;
           } else {
             if (!chmod_R($fullpath, $filemode))
                 return FALSE;
           }
       }
   }
 
   closedir($dh);
  
   if(chmod($path, $filemode))
     return TRUE;
   else
     return FALSE;
}

// fonction utilise pour mesurer le temps d'excution d'un script et viter un timeout
function microtime_float() {
	list($usec, $sec) = explode(" ", microtime());
	return ((float)$usec + (float)$sec);
}

function get_navigator()  // Rcupre le nom du navigateur du client
{
  require_once(IEW_DIR.'browscap/Browser.php');
  $browser = new Browser;
  $infos_navigateur = $browser->detect();
  $navigateur = $infos_navigateur['name'] . " " . $infos_navigateur['version'];
  // Les lignes suivantes sont commentes en attendant de trouver la solution de l'anomalie #131
  /*require_once(IEW_DIR.'browscap/Browscap.php');
  $browscap = new Browscap("browscap/cache");
  $navigateur = $browscap->getBrowser();
  return $navigateur->Browser." ".$navigateur->Version;*/
  return rtrim($navigateur," "); // Dans le cas de Chrome, la version n'est pas identifie : on retire l'espace terminal
}

// Vrification du Navigateur Mozilla ou Firefox prconis
function verif_navigateur($navigateur)
{
  if ($navigateur != "Mozilla" && $navigateur != "Firefox")
  {
    $error_message = array("<div align='justify'>Votre Navigateur (<font color='black'><strong>".$navigateur."</strong></font>) n'est pas celui qui est recommand pour utiliser le Portail intranet de l'tablissement.<br />Ce Portail est conu pour s'afficher correctement avec le navigateur libre <u>Mozilla Firefox</u>, un navigateur performant, trs rapide, et  qui protge des virus, logiciels espions et publicits.<br />
    Vous pouvez garder votre navigateur actuel, mais le rendu graphique risque de ne pas tre idal, certains lments ne s'affichant pas correctement dans la page. Si vous n'avez pas le navigateur recommand, vous devrez le tlcharger  cette adresse :  <a href='http://www.mozilla-europe.org/fr/products/firefox/ ' target='_blank'>http://www.mozilla-europe.org/fr/products/firefox/</a> . Choisissez la version correspondante  votre systme d'exploitation (Windows, Linux, Mac OS X...), installez-le, et utilisez-le pour accder  notre portail.</div>","");
    affiche_erreurs($error_message);
  }
  else
    return;
}

function je_suis_la()
{
  // Objectif : dterminer de faon la + fiable possible si un utilisateur est actuellement connect
  /*
  En effet, un utilisateur est considr comme connect s'il est authentifi ET s'il effectue des requtes
  vers le serveur. S'il est facile de se rendre compte de la connexion d'un utilisateur, il n'en est pas de mme
  de la dconnexion : celle-ci peut se faire de manire propre (lien "se dconnecter") auquel cas nous sommes
  immdiatement au courant de la dconnexion, mais aussi de manire "sale" par la fermeture brutale du navigateur.
  Cette possibilit, compte tenu de la nature du protocole HTTP, n'est pas dtectable : la session est simplement
  dtruite, mais rien ne permet de communiquer via PHP la dconnexion et d'inscrire celle-ci dans le journal de
  connexion.
  L'astuce ici est de faire excuter (sur le client) par toute page charge dans le navigateur,  intervalles
  rguliers (ici une  minute), un code Javascript qui effectue une requte vers le serveur, qui appelle un script
  (je_suis_la.php) charg de mettre  jour un timestamp indiquant la date/heure de la dernire requte : ainsi,
  l'utilisateur est considr comme connect (la page est ouverte), mme si celui-ci est inactif. Lorsqu'il ferme
  la page (ou le navigateur), la requte "je_suis_la" n'est plus effectue, donc nous savons que l'utilisateur est
  dconnect.
  */

  if (isset($_SESSION['valid_login'])) // tout ceci seulement si l'utilisateur est authentifi !
  {
    /* la section suivante pouvait poser problme par exemple sur scribe : 
     * l'URL pour accder  IEW depuis Envole commence par https (URL renseigne avec la cration de l'item de bureau ou onglet correspondant)
     * mais la variable $_SERVER['HTTPS'] n'est pas fournie par le serveur apache de scribe 
     * De plus je n'avais pas russi  forcer l'accs SSL pour IEW
     * => il y avait un message d'alerte javascript lorsque le protocole dans le $path_url tait diffrent de celui de la page (bug #14)
     * 
     * => C'est rsolu depuis que apache-iew.conf contient les directives assurant le forage https et que les urls ne sont plus dtermines  partir de $_SERVER['DOCUMENT_ROOT']
     * => Mais derrire un AMON, cela ne fonctionne pas ainsi : il faut activer le reverse-proxy en redirigeant vers https toutes les requtes vers le dossier iew
     * */
  	$protocole = get_protocol_http($_SERVER['SCRIPT_URI']);
     
    // On a besoin de l'url complte du script PHP qui sera appel pour fournir les donnes XML ncessaire  l'AJAX
    $path_url = $protocole.$_SERVER['HTTP_HOST'].$GLOBALS['racine'];

   // Un peu d'AJAX nous vitera de recharger la page ou d'ouvrir une pop-up
   // tout en excutant une requte HTTP
   echo "<script type='text/javascript'>

   // global request and XML document objects
   var request;

   function FlagJeSuisLa() 
   {
     var url = \"$path_url"."je_suis_la.php\";
     // branch for native XMLHttpRequest object
     if (window.XMLHttpRequest) // pour mozilla ou firefox
     {
       // On cre un nouvel objet XMLHttpRequest pour la future requte vers le serveur
       request = new XMLHttpRequest();
       // on surveille la rponse du serveur :  chaque tat, elle sera analyse par la fonction processReqChange()
       request.onreadystatechange = processReqChange;
       // On lance la requte vers le serveur en mode asynchrone
       request.open(\"GET\", url, true);
       request.send(null); 
     } 
     else if (window.ActiveXObject) // // branch for IE/Windows ActiveX version : pour IE
     {
       request = new ActiveXObject(\"Microsoft.XMLHTTP\");
       // on surveille la rponse du serveur :  chaque tat, elle sera analyse par la fonction processReqChange()
       request.onreadystatechange = processReqChange;
       // On lance la requte vers le serveur en mode asynchrone
       request.open(\"GET\", url, true);
       request.send(null);
     }

     return false;
   }

   // handle onreadystatechange event of request object
   function processReqChange()
   {
     // Si la requte est termine (le serveur a rpondu)
     if (request.readyState == 4)
     {
       // et si la rponse est OK
       if (request.status == 200)
       {
         //normal, rien  faire...
       }
       else
       {
         alert(\"Il y a eu un problme pour rcuprer les donnes XML : \" + request.statusText);
       }
     }
   }
  
   // La fonction sera excute toutes les 3 minutes, tant que le navigateur est ouvert sur une page contenant ce code JS
   var timer=setInterval(\"FlagJeSuisLa()\", 3000*60); 

   </script>";
  }
}

function get_protocol_http($uri)
{
	/**
	 * Cette fonction renvoie le protocole HTTP pu HTTPS utilis
	 * lors de l'appel d'une page
	 */
	$fragments = explode("://",$uri); 
	if ($fragments[0] == "http" || $fragments[0] == "https")
    {
      $protocole = $fragments[0]."://";
    }
    else
   {
      $protocole = "http://";
    }
    // Si un reverse proxy force la redirection http vers https au niveau d'AMON par exemple, la fonction get_protocol_http verra uniquement les communications interne
    // (voir le memo_dev pour davantage d'explications) ; IL FAUT DANS CE CAS DECOMMENTER LA LIGNE SUIVANTE :
    //$protocole = "https://";
    return $protocole;
}

function end_with_string($string,$needle)
{
	/*
	 * Vrifie si $needle termine la chane $string
	 */
	$len_string = strlen($string);
	$len_needle = strlen($needle);
	$end_string = substr ($string, $len_string - $len_needle);
	if ($end_string == $needle)
	 return true;
	else
	 return false;
}

function cherche_classe_dans_groupes($classe)
{
	/**
	 * cherche la liste des groupes qui prennent leur lves dans la classe 
	 * n'est peut-tre pas utilise actuellement mais est fonctionnelle (tests concluants)
	 */
	
	$groupes = array();
	
	/* D'abord les groupes de SCONET */
	$sql = "SELECT code_structure FROM structures WHERE divisions_appartenance like '%$classe%'";
	// DEBUGG echo $sql."<br />";
	$resultat=mysql_query($sql);
	if (mysql_num_rows($resultat)>0)
	{
		while ($ligne=mysql_fetch_array($resultat))
		{
			// Il faut retenir uniquement les groupes qui ont des lves affects dedans
			$sql2 = "SELECT * FROM groupes_eleves WHERE code_structure='".$ligne['code_structure']."'";
			$resultat2 = mysql_query($sql2);
			if ($resultat2 && mysql_num_rows($resultat2) > 0)
				$groupes[] = $ligne['code_structure'];
		}
	}
	/* Puis les groupes crs manuellement */
	// D'abord ceux qui contiennent le nom de la classe de faon explicite
	$sql = "SELECT nom FROM groupes WHERE nom like '%$classe%' AND id_responsable<>0";
	// DEBUGG echo $sql."<br />";
	$resultat=mysql_query($sql);
	if (mysql_num_rows($resultat)>0)
	{
		while ($ligne=mysql_fetch_array($resultat))
		{
			// Il faut retenir uniquement les groupes qui ont des lves affects dedans
			$sql2 = "SELECT * FROM groupes_eleves WHERE code_structure='".$ligne['nom']."'";
			$resultat2 = mysql_query($sql2);
			if ($resultat2 && mysql_num_rows($resultat2) > 0)
				$groupes[] = $ligne['nom'];
		}
	}
	// Puis ceux qui contiennent le nom du niveau de formation (mef) concernant la classe
	$sql = "SELECT code_mef FROM structures WHERE code_structure='$classe'";
	// DEBUGG echo $sql."<br />";
	$resultat=mysql_query($sql);
	if (mysql_num_rows($resultat)>0)
	{
		while ($ligne=mysql_fetch_array($resultat)) // normalement un seul rsultat
		{
			$liste_code_mefs=explode(",",$ligne['code_mef']); // On rcupre le ou les codes mef
			foreach ($liste_code_mefs as $value)
			{
				$sql1 = "SELECT formation FROM mefs WHERE code_mef='$value'"; // et on s'en sert pour retrouver le libelle du mef correspondant
				// DEBUGG echo $sql1."<br />";
				$result_sql1 = mysql_query($sql1);
				$enregistrement1 = mysql_fetch_array($result_sql1);
				$formation = $enregistrement1['formation'];
				$nom_recherche = "Toutes les classes de $formation"; // on va rechercher les groupes comportant le mef dans son intitul
				$sql2 = "SELECT eleve_id,nom FROM groupes, groupes_eleves WHERE nom like '%$nom_recherche%' AND groupes_eleves.id_groupe= groupes.id_groupe AND code_structure='$classe'";
				// DEBUGG echo $sql2."<br />";
				$result_sql2 = mysql_query($sql2);
				if (mysql_num_rows($result_sql2)>0) // Le groupe trouv contient au moins un lve de la classe
				{
					while ($enregistrement2 = mysql_fetch_array($result_sql2))
					{
						$groupes[] = $enregistrement2['nom'];
					}
					// DEBUGG var_dump($groupes);
				}
			}
		}
	}
	$groupes = array_unique($groupes); // Elimination des doublons ventuels
	return $groupes;
}

function liste_classes_dans_groupe($nom_groupe)
{
  // Rcuprer la liste des classes concernes par un groupe
  
	/* Cas d'un groupe SCONET */
	$sql = "SELECT type_structure,divisions_appartenance FROM structures WHERE code_structure='$nom_groupe'";
	$result_gpe_sconet = mysql_query($sql);
	if (mysql_num_rows($result_gpe_sconet)>0)
	{
		$enregistrement = mysql_fetch_array($result_gpe_sconet); // Un enregistrement unique en principe
		if($enregistrement['type_structure'] == "G") // uniquement si c'est effectivement un groupe
		{
			$liste_classes = explode(",",$enregistrement['divisions_appartenance']);
		}
		else // dans ce cas, c'est une classe
		{
			$liste_classes[] = $nom_groupe;
		}
		$_SESSION['liste_classes'] = $liste_classes; // on le stocke aussi dans une variable de session qui sera utilise  la fin du script (cette variable de session doit tre efface avant la prochaine transaction d'absences)
		return $liste_classes;
	}
	
	/* Cas d'un mef SCONET  => Le nom du groupe contient alors  la chane "Toutes les classes de" */
	if (stristr($nom_groupe, "Toutes les classes de "))
	{
		// Il faut alors isoler le nom du groupe SCONET contenu dans $nom_groupe au format 'type_groupe - Toutes les classes de nom du groupe - nom du responsable'
		$fragment = explode("-",$nom_groupe);
		// DEBUGG var_dump($fragment);
		$nom_mef_sconet = str_replace("Toutes les classes de ","",$fragment[1]);
		// DEBUGG var_dump($nom_mef_sconet);
		$sql = "SELECT code_mef FROM mefs WHERE formation='$nom_mef_sconet'";
		$result_mef = mysql_query($sql);
		$enregistrement = mysql_fetch_array($result_mef);
		$code_mef = $enregistrement['code_mef'];
		$sql = "SELECT code_structure FROM structures WHERE type_structure='D' AND code_mef like '%$code_mef%'";
		// DEBUGG echo $sql."<br />";
		$result_sql_classes = mysql_query($sql);
		if (mysql_num_rows($result_sql_classes)>0)
		{
			while($enregistrement = mysql_fetch_array($result_sql_classes))
			{
				$liste_classes[] = $enregistrement['code_structure'];
			}
		}
		else
		{
			$error_message = array("Il n'y a pas de classe associe  ce niveau de formation <b>($nom_mef_sconet)</b> dans l'tablissement. Veuillez <a href=\"gesgroupes.php?choix=supprimer&amp;nom_groupe=$nom_groupe&amp;action=oui\" onClick=\"return(window.confirm('Voulez-vous vraiment supprimer le groupe \'$nom_groupe\' de la base de donnes ?'));\">supprimer</a> le groupe <b>$nom_groupe</b> et en crer un autre avec un niveau de formation diffrent de $nom_mef_sconet.","");
			affiche_erreurs($error_message);
			return $liste_classes;
		}
	}
	/* Cas d'un groupe cr manuellement */
	else
	{
		  $fragment=explode("-",$nom_groupe);
          $liste_classes=explode(",",$fragment[1]);
	}
          
    // DEBUGG echo "Venant de la fonction de recherche des classes : ",var_dump($liste_classes); echo "<br />";
    $_SESSION['liste_classes'] = $liste_classes; // on le stocke aussi dans une variable de session qui sera utilise  la fin du script (cette variable de session doit tre efface avant la prochaine transaction d'absences)
    // DEBUGG var_dump($liste_classes);
    return $liste_classes;
}

function traite_longueur_titre_ctextes($portion_titre)
{
	/*
	 * Dans les formules de cahiers de textes, le titre est Cahier de texte de la classe de '***' ou du groupe '***'
	 * Si '***' (correspond  l'arguement $portion_titre) est long, l'affichage peut tre disgracieux, dans ce cas il vaut mieux scinder le titre en 2 lignes
	 */
	if (strlen($portion_titre)>8) // 8 est la limite du champ code_structure de la table structure (donnes en provenance de sconet  la base)
		return "<br />$portion_titre";
	else
		return " $portion_titre";
}

function traite_titraille($chaine,$op)
{
	/* 
	 * Permet de rorgniser les niveaux hirarchiques des titres en fonction du paramtre $op
	 * $op = +1 => Les niveaux de titres sont incrments jusqu'au niveau 6 
	 * $op = -1 => Les niveaux de titres sont incrments jusqu'au niveau 1
	 * */
	switch($op)
	{
		case "+1":
			$search_opened  = array("#".htmlspecialchars('<h5>')."#", "#".htmlspecialchars('<h4>')."#","#".htmlspecialchars('<h3>')."#", "#".htmlspecialchars('<h2>')."#", "#".htmlspecialchars('<h1>')."#");
			$replace_opened  = array(htmlspecialchars('<h6>'), htmlspecialchars('<h5>'),htmlspecialchars('<h4>'), htmlspecialchars('<h3>'), htmlspecialchars('<h2>'));
			$search_closed  = array("#".htmlspecialchars('</h5>')."#", "#".htmlspecialchars('</h4>')."#","#".htmlspecialchars('</h3>')."#", "#".htmlspecialchars('</h2>')."#", "#".htmlspecialchars('</h1>')."#");
			$replace_closed  = array(htmlspecialchars('</h6>'), htmlspecialchars('</h5>'),htmlspecialchars('</h4>'), htmlspecialchars('</h3>'), htmlspecialchars('</h2>'));
			// DEBUGG echo "Chane NON traite (titraille) : $chaine<br />";
			$chaine = preg_replace($search_opened,$replace_opened,$chaine);
			$chaine = preg_replace($search_closed,$replace_closed,$chaine);
			// On laisse h6 (en principe, on ne descend pas plus bas....
			// DEBUGG echo "Chane traite (titraille) : $chaine<br />";
			break;
		case "-1":
			break;
		default:
	}
	return $chaine;
}

function realip() {
   //recupere l adresse ip de l ordi de l utilisateur
   if (isSet($_SERVER)) {
    if (isSet($_SERVER["HTTP_X_FORWARDED_FOR"])) {
     $realip = $_SERVER["HTTP_X_FORWARDED_FOR"];
    } elseif (isSet($_SERVER["HTTP_CLIENT_IP"])) {
     $realip = $_SERVER["HTTP_CLIENT_IP"];
    } else {
     $realip = $_SERVER["REMOTE_ADDR"];
    }

   } else {
    if ( getenv( 'HTTP_X_FORWARDED_FOR' ) ) {
     $realip = getenv( 'HTTP_X_FORWARDED_FOR' );
    } elseif ( getenv( 'HTTP_CLIENT_IP' ) ) {
     $realip = getenv( 'HTTP_CLIENT_IP' );
    } else {
     $realip = getenv( 'REMOTE_ADDR' );
    }
   }
   // Si l'utilisateur est derrire un proxy alors +sieurs ip renvoyes spares par des virgules
   // On suppose que l'ip relle est la premire (cas d'un serveur SCRIBE en DMZ derrire AMON)
   if (strpos($realip,",") !== false) 
   {
    $new_realip = explode(",",$realip);
    $realip = $new_realip[0]; // on prend la 1re ip
   }
   return $realip;
}

function cherche_classe_eleve()
{
  // Si la classe de l'lve n'est pas connue (aprs un unset $_SESSION['classe_en_cours'])
  if (!isset($_SESSION['classe_en_cours']) || $_SESSION['classe_en_cours']=="")
  {
    // Alors on doit recuprer sa valeur
      $sql = "SELECT t1.classe FROM eleves as t1, login as t2 WHERE t1.id_eleve=t2.id_pers AND t2.id_pers='".quote_smart($_SESSION['valid_id_user'])."'";
      // DEBUGG print $sql."<br />";
      $resultat = mysql_query($sql);
      if ($resultat)
      {
        if (mysql_num_rows($resultat)>0)
       {
         $ligne = mysql_fetch_array($resultat);
         $_SESSION['classe_en_cours'] = $ligne['classe'];
       }
       else
       {
        $error_message = array("<div align='justify'>Votre classe est introuvable. Veuillez contacter <a href='mailto:".email_encode($GLOBALS['admin_email'])."'>l'administrateur IntraEduWeb</a>.</div>","");
        affiche_erreurs($error_message);
        return;
       }
      }
      else
      {
        $error_message = array("Le serveur de base de donnes est indisponible. Veuillez ressayer ultrieurement.","");
        affiche_erreurs($error_message);
        return;
      }
  }
}

function cherche_infos_ipr()
{
	/**
	 * Rcupre les donnes utiles pour la session d'un IPR :
	 * 1) date de la visite
	 * 2) Dure de validit du compte
	 * 3) Liste des id_individus des profs inspects
	 * 4) Liste des codes matires des disciplines enseignes par les profs inspects
	 * 5) Liste des matires (libelle_edition) correspondantes
	 * 6) Liste des classes ou groupes en responsabilit pour les profs inspects
	 * 7) Email de l'IPR
	 * 
	 * Ces donnes sont toutes inscrites dans des variables de session afin d'tre disponibles pour tous les scripts
	 * utiliss lors d'une session IPR
	 */
	// 1er temps : toutes donnes excepts la liste de classes ou groupes en responsabilit pour les profs inspects
	$sql0 = "SELECT t1.code_discipline,libelle_edition,date_visite,email,liste_profs,date_validite  FROM ipr as t1,login as t2, disciplines_bcn as t3 WHERE t2.id_pers='".$_SESSION['valid_id_user']."' AND t1.id_pers=t2.id_pers AND t1.code_discipline=t3.code_discipline ORDER BY libelle_edition";
    $resultat0 = mysql_query($sql0);
    $ligne0 = mysql_fetch_array($resultat0);
    $_SESSION['ipr_discipline'] = $ligne0['code_discipline']."%".$ligne0['libelle_edition'];
	$_SESSION['ipr_date_visite'] = $ligne0['date_visite'];
	$_SESSION['ipr_datelimite_validite'] = $ligne0['date_validite'];
	$_SESSION['ipr_email'] = $ligne0['email'];
	$fragments = explode(",",$ligne0['liste_profs']);
	foreach ($fragments as $value)
	{
		$_SESSION['ipr_liste_id_individus_inspectes'][] = $value;
	}
	// 2me temps : Liste des classes ou groupes en responsabilit pour les profs inspects
	$sql = "SELECT id_pers,id_individu,civilite,nom,prenom FROM personnel WHERE id_individu IN (".$ligne0['liste_profs'].") ORDER BY nom,prenom";
    $resultat = mysql_query($sql);
    while ($enregistrement = mysql_fetch_array($resultat)) // et leurs classes
    {
      $sql1 = "SELECT DISTINCT code_structure,t1.code_matiere,libelle_edition FROM services as t1, enseignants_services as t2, matieres_sconet as t3  WHERE id_individu='".$enregistrement['id_individu']."' AND t1.id_service=t2.id_service AND t1.code_matiere=t3.code_matiere";
      $resultat1 = mysql_query($sql1);
      if ($resultat1)
      {
        if (mysql_num_rows($resultat1)>0)
        {  
          while ($ligne = mysql_fetch_array($resultat1))
          {
            // la classe doit tre lie au prof inspect (sera affich dans les formulaires de choix de classe), de mme en cas de co-enseignement
            $liste_classes[] = $ligne['code_structure']."%(".$enregistrement['civilite']." ".$enregistrement['prenom']." ".$enregistrement['nom'].") ".$ligne['libelle_edition'];
            $liste_codes_structures[] = $ligne['code_structure'];
            $_SESSION['ipr_liste_matieres'][]= $ligne['code_matiere'].",0,".$ligne['libelle_edition']; // Utilise pour la synthse matire
          }
        }
      }
      // et leurs groupes (ventuellement)
      $sql4 = "SELECT nom from groupes WHERE id_responsable='".$enregistrement['id_pers']."' ORDER BY nom";
      $resultat4 = mysql_query($sql4);
      if ($resultat4)
        if (mysql_num_rows($resultat4)>0)
        {
          while($ligne4 = mysql_fetch_array($resultat4))
          {
            // option qui sera affiche dans le choix de la classe
            $liste_classes[] = $ligne4['nom']."%(".$enregistrement['civilite']." ".$enregistrement['prenom']." ".$enregistrement['nom'].")";
            $liste_codes_structures[] = $ligne4['nom'];
          } 
        }  
    }
    $_SESSION['ipr_liste_matieres'] = array_values(array_unique($_SESSION['ipr_liste_matieres'])); // Elimination des doublons et rorganisation des cls
    foreach ($_SESSION['ipr_liste_matieres'] as $value)
    {
    	$fragments = explode(",",$value);
    	$_SESSION['ipr_liste_codes_matieres'][] = $fragments[0]; // sera utilis notamment pour grer l'affichage ou non des liens dans les plannings EDT
    }
    $liste_classes = array_values(array_unique($liste_classes)); // Elimination des doublons et rorganisation des cls
    $_SESSION['ipr_liste_classes_groupes'] = $liste_classes;
    $liste_codes_structures = array_values(array_unique($liste_codes_structures));
    $_SESSION['ipr_liste_codes_structures'] = $liste_codes_structures;
}

function truncate($chaine, $debut, $max)
{
     if (strlen($chaine) >= $max)
     {
     	$chaine = substr($chaine, $debut, $max);
        $espace = strrpos($chaine, " ");
      	$chaine = substr($chaine, $debut, $espace).'...';
      	return $chaine;
     }
     else { return $chaine; }
}

function verif_autorisation_publication_foto($cat_user,$id)
{
	/**
	 * @param $cat_user : vaut "eleve" si l'on souhaite voir la photo d'un eleve, vaut "prof" sinon
	 * @param $id : identification de la personne (=id_pers si prof, =id_eleve sinon)
	 * @return $fichier : le nom du fichier  renvoyer (la photo si autorisation, sinon une photo par dfaut) 
	 */
	
	if ($cat_user == "eleve")
	{
		// On vrifie s'il y a autorisation parentale
    	$autorisation = "";
    	$sql = "SELECT pub_intranet FROM autorisations_1 as t1, eleves as t2 WHERE t1.eleve_id=t2.eleve_id AND id_eleve='".quote_smart($id)."'";
    	$resultat = mysql_query($sql);
    	if ($resultat && mysql_num_rows($resultat)>0)
    	{  
      		$ligne = mysql_fetch_array($resultat);
      		$autorisation = $ligne['pub_intranet'];
    	}
    	else  // Pas d'autorisation/refus explicite => considr comme un refus
    	{
    		$fichier = "opposition_parentale.jpg";
    		return $fichier;
    	}
    	if ($autorisation != "1") // autorisation refuse
    	{
    		$fichier = "opposition_parentale.jpg";
    		return $fichier;
    	}
    	else // autorisation accorde
    	{
    		$fichier = $id.".jpg";
    		return $fichier;	
    	} 
	}
	else // la photo concerne un adulte (prof)
	{
		// Il faut vrifier les autorisations de publication
	    // On rcupre d'abord le nom du groupe auquel appartient l'utilisateur connect
    	$sql = "SELECT nom from groupes_utilisateurs WHERE id_groupe='".quote_smart($_SESSION['valid_group'])."'";
    	$resultat = mysql_query($sql);
    	$ligne = mysql_fetch_array($resultat);
	    // les groupes diffrents de parents, lves, ipr sont des 'collegues'
	    if ($ligne['nom']!="parents" && $ligne['nom']!="eleves" && $ligne['nom']!="ipr")
    	  	$nom_groupe = "collegues";
    	else
      		$nom_groupe = $ligne['nom'];
	    // On cherche les autorisations de publication de la photo demand par rapport au groupe de l'utilisateur connect
    	$sql = "SELECT auth_$nom_groupe FROM auth_foto WHERE id_pers='".quote_smart($id)."'";
    	$resultat = mysql_query($sql);
    	if ($resultat && mysql_num_rows($resultat) >0) // Il y a des donnes enregistres dans la base concernant cette personne et les autorisations de publication de sa photo d'identit pour ce groupe d'utilisateur
    	{
      		$ligne = mysql_fetch_array($resultat);
	        // on examine la valeur du champ correspondant (0 = refus, 1= autorisation)
		    if ($ligne[0] == 0)
      		{
        		$fichier = "opposition_perso.jpg";
    			return $fichier;
      		}
      		else // il y a autorisation ($ligne[0] == 1)
      		{
		        $fichier = $id.".jpg";
    			return $fichier;
      		}
    	}
    	elseif ($resultat && mysql_num_rows($resultat) == 0) // rien dans la base de donnes concernant cette personne => autorisation de publication par dfaut
    	{
	        $fichier = $id.".jpg";
    		return $fichier;
    	}
    	else // Le serveur Mysql n'a pas rpondu (pb technique ?)
    	{
	    	// Par prcaution, comme les autorisations n'ont pas pu tre consultes, on interdit l'affichage de la photo
	    	// qui est remplace par une photo particulire "opposition personnelle"
      		$fichier = "opposition_perso.jpg";
    		return $fichier;
    	}
	}
}

function quelle_date_ctexte($id_ctexte)
{
	/**
	 * Renvoie la date d'une entre de cahier de textes soit pour un contenu de sance, soit pour avoir la date  laquelle un TAF a t donne (pour une excution  une autre date)
	 * 
	 * @param id_ctexte : identifiant numrique de l'entre de cahier de texte concerne
	 * @param $ligne['date'] : date demande, rsultat de la requte SQL
	 */
	
	$sql = "SELECT date FROM cahiers_textes WHERE id_ctexte='$id_ctexte'";
	$resultat = mysql_query($sql);
	$ligne = mysql_fetch_array($resultat);
	return $ligne['date'];
}

function ct_cherche_docs_associes($with,$id,$code_structure,$libelle_edition_matiere)
{
	/**
	 * Trouve les documents joints publis associs  un contenu de sance ou  un travail  faire
	 * 
	 * @param $with : suivant valeur indique qu'on cherche une association soit avec un contenu de sance ($with = id_ctexte) ou avec un travail  faire ($with = id_afaire)
	 * @param $id : identifiant du contenu de sance ou du travail  faire
	 * @param $code_structure : dnomination de la classe ou du groupe
	 * @param $code_matiere : code de la matire concerne
	 * @return $code_html : variable renvoye contenant le code d'affichage des documents joints associs
	 */
	
	$code_html = "";
	if ($with == "id_afaire")
    {
    	$id_ctexte = 0;
    	$id_afaire = $id;
    }
    elseif ($with == "id_ctexte")
    {
    	$id_afaire = 0;
    	$id_ctexte = $id;
    }
    $sql = "SELECT id_doc,filename,commentaire FROM docs_joints_ctextes WHERE $with='".quote_smart($id)."' AND publication='1'";
    $resultat = mysql_query($sql);
    $k = 1; // initialisation au cas o la requte prcdente serait infructueuse
    	
    if ($resultat)
    {
    	$nb_docs = mysql_num_rows($resultat);
    		
    	if ($nb_docs>0) // il y a des documents dans la base de donnes
      	{
        	$code_html = "<hr /><img src='../images/trombone.png' alt='' /> Documents associs :<br />";
      		if ($nb_docs > 1)
        	{
        		$code_html .= "<ul>";
      			for ($k=1;$k<$nb_docs+1;$k++)
        		{
          			$ligne = mysql_fetch_array($resultat);
          			$id_doc = $ligne['id_doc'];
          			$filename = $ligne['filename'];
          			$commentaire = $ligne['commentaire'];
          			$code_html .= "<li><a href='./download_doc.php?file=$filename&amp;matiere=".nospace(noaccent($libelle_edition_matiere))."&amp;classe=".nospace($code_structure)."'><img src='../images/box_download.png' alt='[Tlcharger]' title='Tlcharger ce document' /></a><i>$filename</i><br />($commentaire)</li>";
        		}
        		$code_html .= "</ul>";
        	}
        	else
        	{
        		$ligne = mysql_fetch_array($resultat);
          		$id_doc = $ligne['id_doc'];
          		$filename = $ligne['filename'];
          		$commentaire = $ligne['commentaire'];
          		$code_html .= "<a href='./download_doc.php?file=$filename&amp;matiere=".nospace(noaccent($libelle_edition_matiere))."&amp;classe=".nospace($code_structure)."'><img src='../images/box_download.png' alt='[Tlcharger]' title='Tlcharger ce document' /></a><i>$filename</i><br />($commentaire)";
        	}
        		
      	}
	}
	return $code_html;    
}
?>