<?php
/**
 * fonctions_formulaires.php
 *
 * regroupe les fonctions de traitement de formulaire 
 * 
 * Ce fichier fait partie du projet IntraEduWeb (IEW)
 * 
 * @package		IEW
 * @author			Sylvain GODM <sylvain.godme@gmail.com>
 * @version		$LastChangedRevision$, $LastChangedDate$
 * @copyright		2004-2012 Sylvain GODM
 * @link			http://iew.free.fr
 * @license		GPL License version 3 (http://www.gnu.org/licenses/gpl.html)
 * @filesource
 * 
 */

// On cherche le rpertoire d'installation IEW
if(!defined('IEW_DIR')) define('IEW_DIR',realpath(dirname(__FILE__)."/../").'/');

////////////////// Fonctions utilises dans les formulaires ////////////////////////

function liste_options_form($etat_connexion,$champ,$table,$where)
{
 //***************************** description ********************************//
 // cette fonction s utilise dans un champ de formulaire "Liste d options" entre les
 // balises <select> et </select> dans le cas o les donnes de la liste d options doivent tre
 // lues dans une base de donnes mysql
 //
 // paramtre entr ($etat_connexion) : indique si une connexion avec mysql est dj engage
 // dans le script d appel, ce qu vite si c est le cas de crer une nouvelle connexion, consommatrice de res sources systme
 //
 // paramtre entr ($champ) : la requte prcisant le champ de la table mysql contenant la liste d options  afficher, ce champ peut-tre multiple, chaque partie est spare des suivantes par le caractre ","
 // IMPORTANT : s' assurer que le champ en question ne contient pas de doublons
 //
 // paramtre entr ($where) : filtre de requte
 // sortie : la fonction renvoi un tableau $option contenant les diffrents choix d options
 //          ce tableau a une porte globale pour tre rutilis au sein du script d appel
 // auteur : S.GODM (sylvain.godme@gmail.com)
 // Date de dernire mise  jour : 29/04/2006
 //***************************** Fin description *****************************//

 global $option;
 global $mysql_database;
 $option = array();
 $champ = trim($champ); // supprime les espaces ventuels
 include(CONF_DIR."inc_connect.php");
 include(CONF_DIR."k.php");
 global $admin_email;
 $user = mcrypt_decrypt($algo, $crypt_key, base64_decode($mysql_admin), $mode, $iv);
 $passwd = mcrypt_decrypt($algo, $crypt_key, base64_decode($mysql_admin_passwd), $mode, $iv);
if (!$etat_connexion) // si pas encore de connexion tablie avec le serveur mysql
{ 
  $connexion = @mysql_connect($mysql_server,$user,$passwd);
  if (!$connexion)
  {
    $error_message = array("Connexion au serveur de base de donnes <b>\"$mysql_server\"</b> impossible. Ressayez ultrieurement ou prvenez <a href='mailto:".email_encode($admin_email)."'>l'administrateur du site</a>.","");
    affiche_erreurs($error_message);
    exit;
  }
  mysql_select_db($mysql_database, $connexion);
}

 if ($where): // si un filtre de requte est pass en paramtre
  $sql = "SELECT DISTINCT $champ FROM $table WHERE $where ORDER BY $champ";
 else: // si pas de filtre
  $sql = "SELECT DISTINCT $champ FROM $table ORDER BY $champ";
 endif;
 // DEBUGG var_dump($sql);
 $resultat = mysql_query($sql);
 $nbligne = mysql_num_rows($resultat);
 for ($i=0;$i<=$nbligne-1;$i++){
  $variable = mysql_fetch_array($resultat);
  $fragment = explode(",",$champ); // examine si le contenu de $champ est multiple
  foreach($fragment as $value){
     $morceaux = preg_split("#\.#",$value); // Si le champ de la requte est du type 'nom_de_table.nom_du_champ' il nous faut extraire le nom du champ
     if (count($morceaux) >=2) // Si au moins deux morceaux (ne principe pas plus que deux)
     {
       $value = $morceaux[1];  // On a maintenant le nom du champ seul (2me morceau)
     }
     if (!isset($option[$i])): // si la variable n est pas encore dfinie, vite d crire un espace devant
     $option[$i] = stripslashes($variable["$value"]);
	 else:
      $option[$i] = $option[$i]." ".stripslashes($variable["$value"]); // dans ce cas, l option  afficher est constitue
      // par la concatnation des champs multiple spars par un espace.
    endif;
  }
 }
// mysql_close($connexion);
 return $option;
}

function new_liste_options_form($id,$champ,$table,$where,$option_vide)
{
 //***************************** description ********************************//
 // cette fonction s utilise dans un champ de formulaire "Liste d options" entre les
 // balises <select> et </select> dans le cas o les donnes de la liste d options doivent tre
 // lues dans une base de donnes mysql
 //
 // paramtre entr ($id) : si dfini, indique le champ qui sera utilis comme identifiant unique de l'enregistrement
 // (cl primaire) et sera la valeur qui sera renvoye par le formulaire aprs soumission (et pas la valeur affiche)
 //
 // paramtre entr ($champ) : la requte prcisant le champ de la table mysql contenant la liste d options  afficher, ce champ peut-tre multiple, chaque partie est spare des suivantes par le caractre ","
 // IMPORTANT : s' assurer que le champ en question ne contient pas de doublons
 //
 // paramtre entr ($where) : filtre de requte
 //
 // paramtre entr ($option_vide) : si ce paramtre contient une valeur, la premire option sera vide
 // c'est utile quand un champ <select> de formulaire a un attribut size = 1 (pour viter de prselectionner -ou de donner cette impression- une valeur). Si le size est plus grand que 1, c'est inutile !
 //
 // sortie : la fonction renvoie une chane $chaine_options contenant le code HTML  afficher entre les balises
 // <select> et </select> d'un formulaire
 //         
 // auteur : S.GODM (sylvain.godme@gmail.com)
 // Date de dernire mise  jour : 06/03/2005
 //***************************** Fin description *****************************//

 $champ = trim($champ); // supprime les espaces ventuels
 
if ($id == "") // la cl primaire n'est pas ncessaire
{
  // donc les champ options afficheront la valeur qui sera transmise par le POST du formulaire
  if ($where) // si un filtre de requte est pass en paramtre
  {
    $sql = "SELECT DISTINCT $champ FROM $table WHERE $where ORDER BY $champ";
  }
  else // si pas de filtre
  {
    $sql = "SELECT DISTINCT $champ FROM $table ORDER BY $champ";
  }
}
else
{
  // les champs options afficheront une valeur qui ne sera pas celle transmise par le POST du formulaire, mais la valeur de la cl primaire (car elle sera utilise pour lier les donnes de deux ou plusieurs tables par la suite)
  if ($where) // si un filtre de requte est pass en paramtre
  {
    $sql = "SELECT DISTINCT $id,$champ FROM $table WHERE $where ORDER BY $champ";
  }
  else // si pas de filtre
  {
    $sql = "SELECT DISTINCT $id,$champ FROM $table ORDER BY $champ";
  }
}
//echo "<br />$sql<br />";
$resultat = mysql_query($sql);
$nbligne = mysql_num_rows($resultat);
for ($i=0;$i<=$nbligne-1;$i++)
{
  $variable = mysql_fetch_array($resultat);
  $fragment = explode(",",$champ); // examine si le contenu de $champ est multiple
  foreach($fragment as $value)
  {
     $morceaux = preg_split("#\.#",$value); // Si le champ de la requte est du type 'nom_de_table.nom_du_champ' il nous faut extraire le nom du champ
     if (count($morceaux) >=2) // Si au moins deux morceaux (ne principe pas plus que deux)
     {
       $value = $morceaux[1];  // On a maintenant le nom du champ seul (2me morceau)
     }
     if (!isset($option[$i])) // si la variable n est pas encore dfinie, vite d crire un espace devant
     {
       $option[$i] = $variable["$value"];
     }
     else
     {
       $option[$i] = $option[$i]." ".$variable["$value"]; // dans ce cas, l option  afficher est constitue
       // par la concatnation des champs multiple spars par un espace.
     }
  }
  // On empile l'identifiant unique de l'enregistrement dans le tableau $id_tab s'il est ncessaire
  if ($id != "")
  {
    $id_tab[$i] = $variable[0]; // dans ce cas l'id est le premier champ renvoy par la requte
  }
}
$chaine_options = "";
// Voici le code html contenant les options qui vont s'insrer entre les balises <select> et </select>
// la premire option contient "" une chane vide si le paramtre $option_vide contient une valeur
if ($option_vide != "")
{
  $chaine_options = "<option>".""."</option>";
}
// puis vient le reste des choix possibles
for ($i=0;$i<=count($option)-1;$i++)
{
  if (isset($id_tab[$i]))
  {
    $chaine_options.= "<option value='".$id_tab[$i]."'>".$option[$i]."</option>";
  }
  else
  {
    $chaine_options.= "<option>".$option[$i]."</option>";
  }
}
// mysql_close($connexion);
 return $chaine_options;
}

function affiche_liste_options_form($option)
{
//***************************** description ********************************//
 // cette fonction a t crite dans le but de seconder la fonction liste_options_form
 // et est utile notamment dans le cas d un formulaire comportant plusieurs champs identiques
 // avec les mmes options. Dans un tel formulaire, l'appel  liste_otions_form n'a lieu qu'une
 // seule fois, le resultat est stock dans un tableau qui est utilis ensuite par cette fonction.
 // Ceci permet d viter d interroger plusieurs fois pour les mmes rponses le serveur mysql.
 //
 // paramtre entr ($option) : tableau retourn par la fonction liste_options_form contenant la 
 // liste des options  afficher.
 // sortie : code html des diverses balises <option>
 // auteur : S.GODM (sylvain.godme@gmail.com)
 // Date de dernire mise  jour : 28/03/02
 //***************************** Fin description *****************************//

 // la premire option contient "" une chane vide
 echo "<option>".""."</option>";
 
// puis vient le reste des choix possibles
 for ($i=0;$i<=count($option)-1;$i++)
 {
   echo "<option>".$option[$i]."</option>";
 }
}

function affiche_liste_options_formulaire($option)
{
//***************************** description ********************************//
 // mme fonction que affiche_liste_options_form(), mais utilise au sein des scripts
 // dans la variable $code_formulaire (qui contient le code html qui sera affich ultrieurement :
 // donc pas de commande echo contrairement  affiche_liste_options_form())
 // paramtre entr ($option) : tableau retourn par la fonction liste_options_form contenant la 
 // liste des options  afficher.
 //************ ce code ressemble  celui de affiche_liste_options_form(), mais ne comporte pas de
 // commande echo pour permettre l'intgration dans la variable $code_formulaire utilise par la fonction squelette_formulaire_standard() ********************************************************
 // sortie : chane contenant le code html des diverses balises <option>
 // auteur : S.GODM (sylvain.godme@gmail.com)
 // Date de dernire mise  jour : 22/01/2005
 //***************************** Fin description *****************************//

 // la premire option contient "" une chane vide
 $chaine_options = "<option>".""."</option>";
 
// puis vient le reste des choix possibles
 for ($i=0;$i<=count($option);$i++)
 {
   if ($option[$i] != "") // Permet d'liminer les valeurs vides
   	$chaine_options.= "<option>".$option[$i]."</option>";
 }
 return $chaine_options;
}


function filled_out($form_vars)
{
//***************************** description ********************************//
// cette fonction est tire du livre PHP & Mysql de Luke Welling & Laura Thomson
// chez campuspress chapitre 24 page 571. Elle permet de s'assurer du remplissage intgral
// du formulaire avant de le traiter
//***************************** Fin description *****************************//

// Teste si chaque variable du formulaire contient une valeur

reset($form_vars);
while (list ($key, $val) = each ($form_vars))
{
 if (!isset($key) || ($val == ""))
  return false;
}
 return true;
}


function squelette_formulaire_standard($width,$method,$action_script,$titre_form,$code_formulaire,$value_submit,$submit_name, $value_reset,$reset_name,$value_button,$button_name,$onclick,$formatage="",$param_id_name_enctype="")
{
  /*  Construit l'habillage externe d'un formulaire ou d'une bote d'informations
   * 
   *  $formatage est un paramtre optionnel servant  dterminer quel style  donner (centrer ou justifi) au contenu du div class='corps_formulaire'
   *  $param_id_name_enctype = est un paramtre optionnel servant  donner une valeur  l'attribut id et/ou name et/ou enctype
   * 
   * */
	echo "
    <div class='centrage' style='width: $width; margin: auto;'>
    ";
    if ($method!="")
    {
      if ($param_id_name_enctype!="")
      {
      	echo "<form method='".$method."' $param_id_name_enctype action='".$action_script."'>
      	";
      }
      else
      {
      	echo "<form method='".$method."' action='".$action_script."'>
      	";
      }
    }
   else
    echo "<form action='".$action_script."'>
    ";
    echo "<div class='entete_form'>
    ";
    echo $titre_form;
    echo "
    </div>
    ";
  if ($formatage == "")
    echo "<div class='corps_form'>
  ";
  elseif($formatage == "centrer_contenu")
    echo "<div class='corps_form_centrer'>
  ";
    echo $code_formulaire;
    echo "</div>
    ";
    echo "<div class='pp_form'>
    ";
  if ($value_submit)
  {
    echo "<input type='submit' value='$value_submit' id='$submit_name' name='$submit_name' />
    ";
  }
  if ($value_reset)
  {
    echo "<input type='reset' value='$value_reset' id='$reset_name' name='$reset_name' />
    ";
  }
  if ($onclick)
  {
    echo "<input type='button' value='$value_button' id='$button_name' name='$button_name' onclick=$onclick />
    ";
  }
  else
    echo "&nbsp;"; // Assure l'affichage du div de pied de formulaire mme si ne contient rien
  echo "</div>
  </form>
  </div>
  ";
}

function squelette_formulaire_upload($width,$enctype,$method,$action_script,$titre_form,$code_formulaire,$value_submit,$submit_name, $value_reset,$reset_name,$value_button,$button_name,$onclick,$formatage="",$param_id_name="")
{
  /*  Construit l'habillage externe d'un formulaire d'upload de fichiers
   * 
   *  $formatage est un paramtre optionnel servant  dterminer quel style  donner (centrer ou justifi) au contenu du div class='corps_formulaire'
   *  $param_id_name = est un paramtre optionnel servant  donner une valeur  l'attribut id et/ou name
   *  
   * */
  echo "
  <div class='centrage'>
    <div class='centrage' style='width: $width; margin: auto;'>
    ";
    if ($method!="")
    {
		if ($param_id_name!="")
      {
      	echo "<form enctype='".$enctype."' method='".$method."' $param_id_name action='".$action_script."'>
      ";
      }
      else
      {
      	echo "<form enctype='".$enctype."' method='".$method."' action='".$action_script."'>
      ";
      }
    }
    else
    {
    	echo "<form action='".$action_script."'>
    	";
    }
    echo "<div class='entete_form'>
    ";
    echo $titre_form;
    echo "
    </div>
    ";
 if ($formatage == "")
    echo "<div class='corps_form'>
  ";
  elseif($formatage == "centrer_contenu")
    echo "<div class='corps_form_centrer'>
  ";
    echo $code_formulaire;
    echo "</div>
    ";
    echo "<div class='pp_form'>
    ";
  if ($value_submit)
  {
    echo "<input type='submit' value='$value_submit' id='$submit_name' name='$submit_name' />
    ";
  }
  elseif ($value_reset)
  {
    echo "<input type='reset' value='$value_reset' id='$reset_name' name='$reset_name' />
    ";
  }
  elseif ($onclick)
  {
    echo "<input type='button' value='$value_button' id='$button_name' name='$button_name' onclick=$onclick />
    ";
  }
  else
    echo "&nbsp;"; // Assure l'affichage du div de pied de formulaire mme si ne contient rien
  echo "</div>
  </form>
  </div>
  </div>";
}

function form_fieldset_config_ldap()
{
	/**
	 * Contient les champs de formulaire  remplir pour la config d'accs  l'annuaire LDAP
	 */
	$corps_formulaire = "
	<fieldset id='config_ldap' class='form_config'>
			<legend>&nbsp;Configuration d'accs  l'annuaire LDAP&nbsp;</legend>
			<p class='info_importante'>Si votre serveur LDAP est un serveur SCRIBE (projet eole), laissez les valeurs par dfaut&nbsp;!</p>
			<p class='p_long_fieldset'>
				<label for='Form_Req_Ldap_Server_Name' accesskey='O'>Nom (FQDN) du serveur LDAP (ou adresse IP)</label>
				<input type='text' id='Form_Req_Ldap_Server_Name' name='ldap_server_name' size='30' tabindex='3' value=\"".stripslashes($_SESSION['liste_variables']['ldap_server_name'])."\" />
	  			<br />
				<label for='Form_Req_Ldap_Server_Port' accesskey='R'>Port</label>
	  			<input type='text' id='Form_Req_Ldap_Server_Port' name='ldap_server_port' tabindex='4' value='".$_SESSION['liste_variables']['ldap_server_port']."' />
	  		</p>
	  		<p class='p_long_fieldset'>
	  			La Base DN est le point d'entre dans l'arborescence de l'annuaire LDAP. Vous devez renseigner correctement ce champ ! (Valeur par dfaut : celle de l'annuaire scribe du projet eole)<br/>
	  			<label for='Form_Req_Ldap_Base_Dn' accesskey='B'>Base DN</label>
	  			<input type='text' id='Form_Req_Ldap_Base_Dn' name='ldap_base_dn' tabindex='5' value='".$_SESSION['liste_variables']['ldap_base_dn']."' />
	  		</p>
	  		<p class='p_long_fieldset'>
	  			Afin d'assurer la correspondance entre les entres (personnes et structures) du SI du MENESR et celles stockes dans les annuaires ENT ou LDAP, il est ncessaire de disposer d'un identifiant commun qui joue le rle ce cl de jointure.
	  			(Valeur par dfaut : celle de l'annuaire scribe du projet eole : intid)<br />
	  			<label for='Form_Req_Ldap_Attribut_Jointure' accesskey='D'>Nom de l'attribut contenant la cl de jointure</label>
	  			<input type='text' name='ldap_cle_jointure' id='Form_Req_Ldap_Attribut_Jointure' tabindex='6' value='".$_SESSION['liste_variables']['ldap_cle_jointure']."' />
	  		</p>
	  		<p class='p_long_fieldset'>
	  		Indiquez dans le champ suivant le nom de l'attribut LDAP correspondant  l'identifiant d'un utilisateur (Valeur par dfaut : celle de l'annuaire scribe du projet eole)<br />
	  		<label for='Form_Req_Ldap_Attribut_Login' accesskey='L'>Attribut Login</label>
	  		<input type='text' id='Form_Req_Ldap_Attribut_Login' name='ldap_user_login_attribute' tabindex='7' value='".$_SESSION['liste_variables']['ldap_user_login_attribute']."' />
	  		</p>
	  		<p class='p_long_fieldset'>
	  		Indiquez dans le champ suivant le nom de l'attribut LDAP (puis sa valeur) permettant d'identifier un utilisateur comme Professeur (Valeur par dfaut : celle de l'annuaire scribe du projet eole)<br />
	  		<label for='Form_Req_Ldap_Attribut_Id_Prof' accesskey='A'>Nom de l'attribut identifiant un professeur</label>
	  		<input type='text' id='Form_Req_Ldap_Attribut_Id_Prof' name='ldap_user_prof_attribute' tabindex='8' value='".$_SESSION['liste_variables']['ldap_user_prof_attribute']."' /><br />
	  		<label for='Form_Req_Ldap_Attribut_Id_Prof_Value' accesskey='V'>Valeur</label>
	  		<input type='text' id='Form_Req_Ldap_Attribut_Id_Prof_Value' name='ldap_user_prof_attribute_value' tabindex='9' value='".$_SESSION['liste_variables']['ldap_user_prof_attribute_value']."' />
	  		</p>
	  		<p class='p_long_fieldset'>
	  		Indiquez dans le champ suivant le nom de l'attribut LDAP (puis sa valeur) permettant d'identifier un utilisateur comme Elve (Valeur par dfaut : celle de l'annuaire scribe du projet eole)<br />
	  		<label for='Form_Req_Ldap_Attribut_Id_Eleve' accesskey='E'>Nom de l'attribut identifiant un lve</label>
	  		<input type='text' id='Form_Req_Ldap_Attribut_Id_Eleve' name='ldap_user_eleve_attribute' value='".$_SESSION['liste_variables']['ldap_user_eleve_attribute']."' /><br />
	  		<label for='Form_Req_Ldap_Attribut_Id_Eleve_Value' accesskey='U'>Valeur</label>
	  		<input type='text' id='Form_Req_Ldap_Attribut_Id_Eleve_Value' name='ldap_user_eleve_attribute_value' value='".$_SESSION['liste_variables']['ldap_user_eleve_attribute_value']."' />
	  		</p>
	  </fieldset>
	  ";
	return $corps_formulaire;
}

function form_fieldset_config_ldap_default_values()
{
	/**
	 * Dfinit les valeurs par dfaut des champs de formulaire pour la configuration d'accs  l'annuaire LDAP
	 */
	
	// les noms d'attributs LDAP DOIVENT tre en minuscule sinon la rcupration des valeurs des ces attributs
	// lorsqu'on contacte le serveur LDAP ne fonctionne pas (en tout cas avec un LDAP scribe...)
	
	$_SESSION['liste_variables']['ldap_server_name'] = "";
	$_SESSION['liste_variables']['ldap_server_port'] = "389";
	$_SESSION['liste_variables']['ldap_base_dn'] = "o=gouv,c=fr"; // Valeur par dfaut : le base DN de l'annuaire LDAP de Scribe (eole)
	$_SESSION['liste_variables']['ldap_user_login_attribute'] = "uid"; // Valeur par dfaut : nom de l'attribut contenant l'identifiant de connexion  l'annuaire LDAP de Scribe (eole)
	$_SESSION['liste_variables']['ldap_user_prof_attribute'] = "gidnumber"; // Valeur par dfaut : nom de l'attribut contenant l'identification d'un utilisateur en tant que prof  l'annuaire LDAP de Scribe (eole)
	$_SESSION['liste_variables']['ldap_user_prof_attribute_value'] = "10001"; // Valeur par dfaut : valeur de l'attribut contenant l'identification d'un utilisateur en tant que prof  l'annuaire LDAP de Scribe (eole)
	$_SESSION['liste_variables']['ldap_user_eleve_attribute'] = "gidnumber"; // Valeur par dfaut : nom de l'attribut contenant l'identification d'un utilisateur en tant qu'lve  l'annuaire LDAP de Scribe (eole)
	$_SESSION['liste_variables']['ldap_user_eleve_attribute_value'] = "10002"; // Valeur par dfaut : valeur de l'attribut contenant l'identification d'un utilisateur en tant que prof  l'annuaire LDAP de Scribe (eole)
	$_SESSION['liste_variables']['ldap_cle_jointure'] = "intid"; // Valeur par dfaut : nom de l'attribut contenant la valeur ELENOET pour un lve et ID_INDIVIDU pour les profs dans l'annuaire LDAP de Scribe (eole)
}

function form_fieldset_config_cas()
{
	/**
	 * Contient les champs de formulaire  remplir pour la config d'accs au serveur CAS (SSO)
	 */
	$corps_formulaire = "
	<fieldset id='config_cas' class='form_config'>
    	<legend>&nbsp;Configuration de l'accs au serveur CAS (SSO)&nbsp;</legend>
    	<p>
			<label for='Form_Req_Cas_Server_Name' accesskey='N'>Nom (FQDN) du serveur CAS (ou adresse IP)</label>
    		<input type='text' id='Form_Req_Cas_Server_Name' name='cas_server_name' size='30' tabindex='1' value=\"".stripslashes($_SESSION['liste_variables']['cas_server_name'])."\" />
	  	</p>
	  	<p>
	  		<label for='Form_Req_Cas_Server_Port' accesskey='P'>Port</label>
	  		<input type='text' id='Form_Req_Cas_Server_Port' name='cas_server_port' tabindex='2' value='".$_SESSION['liste_variables']['cas_server_port']."' />
		</p>
	</fieldset>
	";
	return $corps_formulaire;
}

function info_champs_obligatoires()
{
	/**
	 * Affiche des infos relatives aux champs de formulaire marqus d'un astrisque
	 */
	$info = "<p class='info_importante'>Les champs marqus d'un astrisque (*) doivent tre imprativement remplis.<br />VERIFIEZ BIEN VOS ENTREES DANS LES CHAMPS DU FORMULAIRE AVANT DE L'ENVOYER !</p>";
	return $info;
}
?>