<?php 
/**
 * visas_globaux.php
 *
 * Vue pour la page de gestion des Visas de cahiers de textes (Vue globale = tous les professeurs)
 * 
 * Ce fichier fait partie du projet IntraEduWeb (IEW)
 * 
 * @package	IEW
 * @author	Sylvain GODM <sylvain.godme@gmail.com>
 * @version	$LastChangedRevision$, $LastChangedDate$
 * @copyright	2004-2014 Sylvain GODM
 * @link	http://iew.free.fr
 * @license	GPL License version 3 (http://www.gnu.org/licenses/gpl.html)
 * @filesource
 * 
 */

// Le script en cours doit tre le script d'appel prvu
if (end_with_string($_SERVER['PHP_SELF'],"modules/cdt/controleurs/visas_ct.php"))
{
	global $liste_structures,$last_visas,$last_id_seances,$liste_services,$nb_jours_cours_deroules,$nb_total_jours_cours,$nb_seances_completees,$nb_total_seances_completees,$taux_partiel,$taux_global;
	?>
	<h1>Gestion globale des visas de cahiers de textes<br />des structures</h1>
	<center>
		<a href="../controleurs/visas_ct.php"><img src="<?php echo $GLOBALS['chemin_relatif']."images/prof.png"?>" alt="[Voir les visas des professeurs]" title="Voir l'ensemble des professeurs"/></a>
	</center>
	<table class="ctextes edt">
  	<tr>
    	<th class="fond_sommaire topleft">Classe / Groupe</th>
    	<th class="fond_sommaire">Dernire publication</th>
    	<th class="fond_sommaire">Dernier Visa</th>
    	<th class="fond_sommaire topright">Taux de remplissage global</th>
  	</tr>
  	<?php
  	$i = 0;
  	$nb_lignes = count($liste_structures);
  	foreach ($liste_structures as $structure) {
  		$percent = $taux_global[$structure['code_structure']];
  		$i++;
  		if($i%2) {
            $classe = "ligne_paire";
        }
        else {
            $classe = "ligne_impaire";
        }
        // En dernire ligne il faut arrondir les coins
        if ($i == $nb_lignes)
        {
        	$last_left = " bottomleft";
        	$last_right = " bottomright";	
        }
  		?>
  		<tr>
    		<td class="<?php echo $classe . $last_left; ?>" style="text-align:left;"><a href="../controleurs/visas_ct.php?vue=structure&code_structure=<?php echo $structure['code_structure'];?>" title="Afficher le dtail des services"><b><?php echo $structure['code_structure']; ?></b></a></td>
    		<td class="<?php echo $classe; ?>">
    		<?php 
    		$derniere_seance = $last_id_seances[$structure['code_structure']][0];
    		echo infos_last_seance($derniere_seance);
    		?>
    		</td>
    		<td class="<?php echo $classe; ?>">
    		<?php 
    		$dernier_visa = $last_visas[$structure['code_structure']][0];
    		echo infos_visa($dernier_visa,$derniere_seance,null,$structure['code_structure']);
			?>
			</td>
    		<td class="<?php echo $classe . $last_right; ?>"><?php echo progression_bar($percent); ?></td>
  		</tr>
  		<?php 
  	}
  	?>
	</table>
	<?php 
	echo affiche_legende();	
}
else // L'utilisateur essaie d'invoquer ce script directement dans l'URL (interdit)
{
  $error_message = array("Vous tentez d'accder  un script qui n'est pas accessible directement  partir de l'URL... Utilisez les liens de navigation !","");
  affiche_erreurs($error_message);
}
?>