<?php 
/**
 * visas_prof.php
 *
 * Vue pour la page de gestion des Visas de cahiers de textes d'un professeur en particulier
 * 
 * Ce fichier fait partie du projet IntraEduWeb (IEW)
 * 
 * @package	IEW
 * @author	Sylvain GODM <sylvain.godme@gmail.com>
 * @version	$LastChangedRevision$, $LastChangedDate$
 * @copyright	2004-2014 Sylvain GODM
 * @link	http://iew.free.fr
 * @license	GPL License version 3 (http://www.gnu.org/licenses/gpl.html)
 * @filesource
 * 
 */

// Le script en cours doit tre le script d'appel prvu
if (end_with_string($_SERVER['PHP_SELF'],"modules/cdt/controleurs/visas_ct.php"))
{
	global $db,$id_prof,$infos_perso,$last_visas,$last_id_seances,$liste_services,$nb_jours_cours_deroules,$nb_total_jours_cours,$nb_seances_completees,$nb_total_seances_completees,$taux_partiel,$taux_global;
	
	$civilite = $infos_perso[0]['civilite'];
	$nom = $infos_perso[0]['nom'];
	$prenom = $infos_perso[0]['prenom'];
	$percent_global = $taux_global[$id_prof];
	?>
	<h1>Visas des cahiers de textes de <?php echo $civilite . " " . $nom . " " . $prenom;?></h1>
	<center>
		<a href="../controleurs/visas_ct.php"><img src="<?php echo $GLOBALS['chemin_relatif']."images/prof.png"?>" alt="[Choisir un autre professeur]" title="Choisir un autre professeur / Voir l'ensemble des professeurs"/></a>
	</center>
	<table class="ctextes edt">
  	<tr>
    	<th class="fond_sommaire topleft">Service</th>
    	<th class="fond_sommaire">Dernire publication</th>
    	<th class="fond_sommaire">Dernier Visa de Service</th>
    	<th class="fond_sommaire topright">Taux de remplissage</th>
  	</tr>
  	<?php 
  	$i = 0;
  	foreach ($liste_services[$id_prof] as $service) {
  		$percent = $taux_partiel[$id_prof][$service['id_enseignant_service']];
  		$i++;
  		if($i%2) {
            $classe = "ligne_paire";
        }
        else {
            $classe = "ligne_impaire";
        }
        $lien_ct = $GLOBALS['chemin_relatif'] . "prive/synthese_ctextes.php?action=synthmat&amp;structure=" . $service['code_structure'] . "&amp;matiere=" . $service['code_matiere'];
  		?>
  		<tr>
    	<td class="<?php echo $classe; ?>"><a href="<?php echo $lien_ct; ?>" title="Afficher le cahier de texte complet en <?php echo $service['libelle_court'];?> pour la structure <?php echo $service['code_structure']; ?>"><b><?php echo $service['code_structure'] . "<br/>" . $service['libelle_court']; ?></b></a></td>
    	<td class="<?php echo $classe; ?>">
    	<?php
    	$derniere_seance = $last_id_seances[$id_prof][$service['id_enseignant_service']][0];
    	echo infos_last_seance($derniere_seance);
    	?>
    	</td>
    	<td class="<?php echo $classe; ?>">
    	<?php
    	$dernier_visa = $last_visas[$id_prof][$service['id_enseignant_service']][0];
    	echo infos_visa($dernier_visa,$derniere_seance,$id_prof,null,$service['id_enseignant_service']);
    	?>
		</td>
    	<td class="<?php echo $classe; ?>"><?php echo progression_bar($percent); ?></td>
  	</tr>
  	<?php
	}
	?>
	<tr>
		<td class="corps_formulaire" colspan="2"><b>Taux de remplissage Global</b></td>
		<td class="corps_formulaire" colspan="2"><?php echo progression_bar($percent_global); ?>
	</td>
	</tr>
	<tr>
		<td class="corps_formulaire bottomleft" colspan="2"><b>Dernier Visa Global</b></td>
		<td class="corps_formulaire bottomright" colspan="2">
		<?php
		// On recherche s'il y a un visa global pour ce professeur
		$CdtVisamanager = new CdtVisaManager($db);
		$CdtVisa = $CdtVisamanager->getLastVisaGlobal($id_prof);
		echo infos_visa($CdtVisa[0],$derniere_seance,$id_prof,null);
		?>
		</td>
	</tr>
	</table>
	<?php 
	echo affiche_legende();	
}
else // L'utilisateur essaie d'invoquer ce script directement dans l'URL (interdit)
{
  $error_message = array("Vous tentez d'accder  un script qui n'est pas accessible directement  partir de l'URL... Utilisez les liens de navigation !","");
  affiche_erreurs($error_message);
}
?>