<?php 
/**
 * visas_structure.php
 *
 * Vue pour la page de gestion des Visas de cahiers de textes d'une structure en particulier
 * 
 * Ce fichier fait partie du projet IntraEduWeb (IEW)
 * 
 * @package	IEW
 * @author	Sylvain GODM <sylvain.godme@gmail.com>
 * @version	$LastChangedRevision$, $LastChangedDate$
 * @copyright	2004-2014 Sylvain GODM
 * @link	http://iew.free.fr
 * @license	GPL License version 3 (http://www.gnu.org/licenses/gpl.html)
 * @filesource
 * 
 */

// Le script en cours doit tre le script d'appel prvu
if (end_with_string($_SERVER['PHP_SELF'],"modules/cdt/controleurs/visas_ct.php"))
{
	global $db,$code_structure,$infos_structure,$last_visas,$last_id_seances,$liste_services,$nb_jours_cours_deroules,$nb_total_jours_cours,$nb_seances_completees,$nb_total_seances_completees,$taux_partiel,$taux_global;
	
	$percent_global = $taux_global[$code_structure];
	if ($infos_structure['type_structure'] == "D")
		$titre = " de la classe ";
	else 
		$titre = " du groupe ";
	?>
	<h1>Visas des cahiers de textes <?php echo $titre . $code_structure; ?></h1>
	<center>
		<a href="../controleurs/visas_ct.php?vue=global_struct"><img src="<?php echo $GLOBALS['chemin_relatif']."images/group.png"?>" alt="[Choisir une autre classe ou un autre groupe]" title="Choisir une autre classe ou un autre groupe / Voir l'ensemble des classes et des groupes"/></a>
	</center>
	<table class="ctextes edt">
  	<tr>
    	<th class="fond_sommaire topleft">Service</th>
    	<th class="fond_sommaire">Dernire publication</th>
    	<th class="fond_sommaire">Dernier Visa de Service</th>
    	<th class="fond_sommaire topright">Taux de remplissage</th>
  	</tr>
  	<?php 
  	$i = 0;
  	foreach ($liste_services[$code_structure] as $service) {
  		$percent = $taux_partiel[$code_structure][$service['id_service']];
  		$i++;
  		if($i%2) {
            $classe = "ligne_paire";
        }
        else {
            $classe = "ligne_impaire";
        }
        $lien_ct = $GLOBALS['chemin_relatif'] . "prive/synthese_ctextes.php?action=synthmat&amp;structure=" . $service['code_structure'] . "&amp;matiere=" . $service['code_matiere'];
  		// il faudra afficher le nom du (ou des) prof(s) qui assure(nt) le service
  		$ServiceEnseignementManager = new ServiceEnseignementManager($db);
  		$liste_profs_service = $ServiceEnseignementManager->getListProfService($service['id_service']);
  		foreach ($liste_profs_service as $prof) {
  			$affiche_liste_prof .= "<a href='../controleurs/visas_ct.php?vue=prof&amp;id_prof=" . $prof['id_individu'] . "' title=\"Afficher le contrle des Visas des cahiers de textes de " . $prof['civilite'] . " " . $prof['prenom'] . " " . $prof['nom'] . "\">" . $prof['civilite'] . " " . $prof['prenom'] . " " . $prof['nom'] . "</a><br />";
  		}
        ?>
  		<tr>
    	<td class="<?php echo $classe; ?>"><a href="<?php echo $lien_ct; ?>" title="Afficher le cahier de texte complet en <?php echo $service['libelle_court'];?> pour la structure <?php echo $service['code_structure']; ?>"><b><?php echo $service['libelle_court']; ?></b></a>
    	<br /><i><?php echo $affiche_liste_prof; $affiche_liste_prof = ""; // remis  vide sinon la liste s'allonge d'une ligne  l'autre ?></i></td>
    	<td class="<?php echo $classe; ?>">
    	<?php
    	$derniere_seance = $last_id_seances[$code_structure][$service['id_service']][0];
    	echo infos_last_seance($derniere_seance);
    	?>
    	</td>
    	<td class="<?php echo $classe; ?>">
    	<?php
    	$dernier_visa = $last_visas[$code_structure][$service['id_service']][0];
    	echo infos_visa($dernier_visa,$derniere_seance,null,$code_structure,$service['id_service']);
    	?>
		</td>
    	<td class="<?php echo $classe; ?>"><?php echo progression_bar($percent); ?></td>
  	</tr>
  	<?php
	}
	?>
	<tr>
		<td class="corps_formulaire" colspan="2"><b>Taux de remplissage Global</b></td>
		<td class="corps_formulaire" colspan="2"><?php echo progression_bar($percent_global); ?>
	</td>
	</tr>
	<tr>
		<td class="corps_formulaire bottomleft" colspan="2"><b>Dernier Visa Global</b></td>
		<td class="corps_formulaire bottomright" colspan="2">
		<?php
		// On recherche s'il y a un visa global pour ce professeur
		$CdtVisamanager = new CdtVisaManager($db);
		$CdtVisa = $CdtVisamanager->getLastVisaGlobalStructure($code_structure);
		echo infos_visa($CdtVisa[0],$derniere_seance,null,$code_structure);
		?>
		</td>
	</tr>
	</table>
	<?php 
	echo affiche_legende();	
}
else // L'utilisateur essaie d'invoquer ce script directement dans l'URL (interdit)
{
  $error_message = array("Vous tentez d'accder  un script qui n'est pas accessible directement  partir de l'URL... Utilisez les liens de navigation !","");
  affiche_erreurs($error_message);
}
?>