<?php 
/**
 * Hydrator.php
 *
 * Dfinition de la super classe (abstraite) Hydrator regroupant les mthodes communes  la plupart des classes
 * 
 * Ce fichier fait partie du projet IntraEduWeb (IEW)
 * 
 * @package	IEW
 * @author	Sylvain GODM <sylvain.godme@gmail.com>
 * @version	$LastChangedRevision$, $LastChangedDate$
 * @copyright	2004-2014 Sylvain GODM
 * @link	http://iew.free.fr
 * @license	GPL License version 3 (http://www.gnu.org/licenses/gpl.html)
 * @filesource
 * 
 */

abstract class Hydrator
{
	// Comme son nom l'indique, ici sont indiques les mthodes permettant d'hydrater les objets des classes drives
	// Cela vite de recopier le code dans chaque classe drive
	
	// hydratation  partir d'un tableau de donnes pour le moment,  partir d'un objet : ce sera ventuellement  dvelopper ici
	public function __construct($donnees = array()) // le tableau en argument est optionnel
	{
		if (!is_null($donnees)) {
			$this->hydrate($donnees);
		}
	}
	
	public function hydrate(array $donnees)
	{
  		foreach ($donnees as $key => $value){
		    // On rcupre le nom du setter correspondant  l'attribut.
    		$method = 'set'.ucfirst($key);
        
		    // Si le setter correspondant existe.
    		if (method_exists($this, $method)){
		    	// On appelle le setter.
      			$this->$method($value);
    		}
  		}
	}
}
?>