<?php 
/**
 * ServiceEnseignementManager.php
 *
 * Gestion des objets de la classe ServiceEnseignement (CRUD et autres fonctionnalits)
 * 
 * Ce fichier fait partie du projet IntraEduWeb (IEW)
 * 
 * @package	IEW
 * @author	Sylvain GODM <sylvain.godme@gmail.com>
 * @version	$LastChangedRevision$, $LastChangedDate$
 * @copyright	2004-2014 Sylvain GODM
 * @link	http://iew.free.fr
 * @license	GPL License version 3 (http://www.gnu.org/licenses/gpl.html)
 * @filesource
 * 
 */

require_once(IEW_DIR."modules/commun/modeles/classes/Crud.php");

class ServiceEnseignementManager extends Crud
{
	// paramtres ncessaires pour le CRUD
	protected $table = 'services';
	protected $pk = 'id_service'; // cl primaire
	
	// Mthodes en relation avec le CRUD

	// Autres Mthodes
	
	public function getListServicesStructure($code_structure)
	{
		/**
		 * Renvoie la liste des services d'enseignement relis  une structure
		 */
		
		$liste_services = $this->db->query("SELECT id_service,code_structure,t1.code_matiere,libelle_court FROM services as t1, matieres_sconet as t2 WHERE code_structure='$code_structure' AND t1.code_matiere=t2.code_matiere");
		return $liste_services;
	}
	
	public function getListProfService($id_service)
	{
		/**
		 * Retourne la liste des professeurs assurant un service pour une structure
		 * 
		 * @param $id_service : identifiant numrique du service correspondant  une matire enseigne pour la structure
		 * @return $liste_profs :tableau contenant la liste des professeurs assurant le service
		 */
		$liste_profs = $this->db->query("SELECT civilite,nom,prenom,t1.id_individu FROM personnel as t1, services as t2, enseignants_services as t3 WHERE categorie='7' AND t1.id_individu=t3.id_individu AND t2.id_service=t3.id_service AND t2.id_service='$id_service' ORDER BY nom,prenom");
		return $liste_profs;
	}
}
?>