<?php 
/**
 * ServiceProfesseurManager.php
 *
 * Gestion des objets de la classe ServiceProfesseurManager (CRUD et autres fonctionnalits)
 * 
 * Ce fichier fait partie du projet IntraEduWeb (IEW)
 * 
 * @package	IEW
 * @author	Sylvain GODM <sylvain.godme@gmail.com>
 * @version	$LastChangedRevision$, $LastChangedDate$
 * @copyright	2004-2014 Sylvain GODM
 * @link	http://iew.free.fr
 * @license	GPL License version 3 (http://www.gnu.org/licenses/gpl.html)
 * @filesource
 * 
 */

require_once(IEW_DIR."modules/commun/modeles/classes/Crud.php");

class ServiceProfesseurManager extends Crud
{
	// paramtres ncessaires pour le CRUD
	protected $table = 'enseignants_services';
	protected $pk = 'id_enseignant_service'; // cl primaire

	public function getList($id_prof) // Renvoie la liste des services d'enseignement d'un prof
	{
		$liste_services = $this->db->query("SELECT id_enseignant_service,code_structure,libelle_court,t2.code_matiere,heures_agent FROM enseignants_services as t1, services as t2, matieres_sconet as t3 where id_individu='$id_prof' AND t1.id_service=t2.id_service AND t2.code_matiere=t3.code_matiere");
		return $liste_services;
	} 
	
	public function getListServicesEnseignants($id_service)
	{
		/**
		 * Renvoie la liste des services enseignants correspondant  un service matire pour une structure
		 * 
		 * @param $id_service : identifiant numrique du service matire pour la structure
		 */
		
		$liste_enseignants_services = $this->db->query("SELECT * FROM enseignants_services WHERE id_service='$id_service'");
		return $liste_enseignants_services;
	}
}
?>