<?php 
/**
 * Structure.php
 *
 * Dfinition de la classe Structure pour reprsenter les structures (divisions et groupes)
 * 
 * Ce fichier fait partie du projet IntraEduWeb (IEW)
 * 
 * @package	IEW
 * @author	Sylvain GODM <sylvain.godme@gmail.com>
 * @version	$LastChangedRevision$, $LastChangedDate$
 * @copyright	2004-2014 Sylvain GODM
 * @link	http://iew.free.fr
 * @license	GPL License version 3 (http://www.gnu.org/licenses/gpl.html)
 * @filesource
 * 
 */

class Structure extends Hydrator
{
	private  	$code_structure,
				$type_structure,
				$libelle_long,
				$code_mef,
				$divisions_appartenance;
	
	// getters
	
	public function code_structure()
	{
		return $this->code_structure;
	}

	public function type_structure()
	{
		return $this->type_structure;
	}

	public function libelle_long()
	{
		return $this->libelle_long;
	}

	public function code_mef()
	{
		return $this->code_mef;
	}
	
	public function divisions_appartenance()
	{
		return $this->divisions_appartenance;
	}
				
	// setters
	
	public function setCode_structure($code_structure)
	{
		if (!is_string($code_structure) || strlen($code_structure) > 8) {
    		trigger_error("Un code_structure doit tre une chane n'excdant pas 8 caractres !", E_USER_WARNING);
    		return;
    	}
		$this->code_structure = $code_structure;
	}
	
	public function setType_structure($type_structure)
	{
		$type_values = array("D","G");
  		if (!in_array($type_structure,$type_values)) {
  			trigger_error("L'attribut 'type_structure' d'une structure doit tre 'D' (division) ou 'G' (Groupe) !", E_USER_WARNING);
    		return;
  		}
		$this->type_structure = $type_structure;
	}
	
	public function setLibelle_long($libelle_long)
	{
		if (!is_string($libelle_long) || strlen($libelle_long) > 20) {
    		trigger_error("Un libelle_long de structure doit tre une chane n'excdant pas 20 caractres !", E_USER_WARNING);
    		return;
    	}
		$this->libelle_long = $libelle_long;
	}
	
	public function setCode_mef($code_mef)
	{
		if (!is_string($code_mef) || strlen($code_mef) > 60) {
    		trigger_error("Un code_mef de structure doit tre une chane n'excdant pas 60 caractres !", E_USER_WARNING);
    		return;
    	}
		$this->code_mef = $code_mef;
	}
	
	public function setDivisions_appartenance($divisions_appartenance)
	{
		if (!is_string($divisions_appartenance) || strlen($divisions_appartenance) > 255) {
    		trigger_error("Une liste de division_appartenance d'une structure doit tre une chane n'excdant pas 255 caractres !", E_USER_WARNING);
    		return;
    	}
		$this->divisions_appartenance = $divisions_appartenance;
	}
		
	// Autres mthodes
}
?>