<?php 
/**
 * StructureManager.php
 *
 * Gestion des objets de la classe Structure (CRUD et autres fonctionnalits)
 * 
 * Ce fichier fait partie du projet IntraEduWeb (IEW)
 * 
 * @package	IEW
 * @author	Sylvain GODM <sylvain.godme@gmail.com>
 * @version	$LastChangedRevision$, $LastChangedDate$
 * @copyright	2004-2014 Sylvain GODM
 * @link	http://iew.free.fr
 * @license	GPL License version 3 (http://www.gnu.org/licenses/gpl.html)
 * @filesource
 * 
 */
 
require_once(IEW_DIR."modules/commun/modeles/classes/Crud.php");

class StructureManager extends Crud
{
	// paramtres ncessaires pour le CRUD
	
	protected $table = 'structures';
	protected $pk = 'code_structure'; // cl primaire
	
	// Mthodes en relation avec le CRUD

	// Autres Mthodes
	
	public function getListStructures()
	{
		/**
		 *  Renvoie la liste des structures de l'tablissement (division = classes et groupes)
		 *  Ce sont les structures existant dans SIECLE : cela ne comprend pas les groupes crs manuellement dans IEW
		 */ 
		
		$liste_structures = $this->db->query("SELECT code_structure,type_structure,libelle_long FROM structures ORDER BY type_structure,code_structure");
		return $liste_structures;
	}
	
	public function  getListEquipePedag($code_structure)
	{
		/**
		 * Renvoie la liste des professeurs enseignant dans la structure
		 */
		
		$liste_profs = $this->db->query("SELECT id_individu, civilite, nom, prenom, libelle_edition as matiere
  		FROM personnel AS t1, enseignants_services AS t3, services AS t4, matieres_sconet AS t5
  		WHERE t4.code_structure='$code_structure'
  		AND t1.id_individu = t3.id_individu
  		AND t4.id_service = t3.id_service
  		AND t5.code_matiere = t4.code_matiere
  		ORDER BY matiere, nom, prenom");
		return $liste_profs;
	}
}
?>