/******************************************************************************************************
// Copyright 2004-2012 Sylvain GODME (sylvain.godme@gmail.com)
// All Rights Reserved.                            
// This file is part of IntraEduWeb.
    IntraEduWeb is free software you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation either version 2 of the License, or
    any later version.
    IntraEduWeb is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
    You should have received a copy of the GNU General Public License
    along with IntraEduWeb if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
    
// Nom du script : intraeduweb.sql
// Fonction : installation des tables MySQL utilises par l application

// ATTENTION : LES COMMENTAIRES ICI NE DOIVENT PAS COMPRENDRE D APOSTROPHES, DE GUILLEMETS
// OU DE POINTS VIRGULES ! (sinon la requte effectue  partir de ce fichier de commandes n aboutira pas)
// et DE PLUS CE FICHIER DOIT SE TERMINER PAR UN POINT VIRGULE !

// Les commentaires explicatifs se trouvent dans le fichier intraeduweb_comment.sql

// Date de cration : 
// Date de dernire modification : 
******************************************************************************************************/

create table jours(
 code_jour tinyint primary key,
 jour varchar(8) not null
 );

insert into jours values("1","Lundi");
insert into jours values("2","Mardi");
insert into jours values("3","Mercredi");
insert into jours values("4","Jeudi");
insert into jours values("5","Vendredi");
insert into jours values("6","Samedi");
insert into jours values("7","Dimanche");

create table horodatages_imports_base(
 date_import_base date,
 communs char(19),
 nomenclature char(19),
 structures char(19)
 );

create table horodatages_imports_eleves(
 date_import_eleves date,
 eleves char(19),
 responsables char(19)
 );
 
create table disciplines_bcn(
 code_discipline char(5) primary key,
 libelle_court varchar(10),
 libelle_long varchar(40),
 libelle_edition varchar(120)
 );

create table uaj(
 etab_uaj_id int(11) primary key,
 code_rne varchar(8) not null,
 num_siren varchar(9),
 denom_princ varchar(30),
 denom_compl varchar(30),
 nom_resp varchar(25),
 qual_resp varchar(15),
 ligne1_adresse varchar(32),
 ligne2_adresse varchar(32),
 ligne3_adresse varchar(32),
 ligne4_adresse varchar(32),
 telephone varchar(15),
 telecopie varchar(15),
 mel_1 varchar(60),
 mel_2 varchar(60),
 code_type_etab varchar(4), 
 code_postal varchar(5),
 libelle_postal varchar(32)
 );
 
create table mefs(
 code_mef char(11) primary key,
 formation varchar(6) not null,
 libelle_long varchar(40),
 libelle_edition varchar(60)
 );

create table matieres_sconet(
 code_matiere char(6),
 code_gestion varchar(5),
 libelle_court varchar(20),
 libelle_long varchar(40) primary key,
 libelle_edition varchar(60),
 matiere_etp smallint not null
 );

create table programmes(
 code_mef char(11) not null,
 code_matiere char(6),
 code_modalite_elect char(1) not null,
 horaire float,
 unique(code_mef,code_matiere,code_modalite_elect)
 );
 
create table options_obligatoires(
 code_mef char(11) not null,
 code_matiere char(6) not null,
 rang_option smallint not null,
 unique(code_mef,code_matiere)
 ); 

create table modalites_election(
 code_modalite_election char(1) primary key,
 libelle_court varchar(10),
 libelle_long varchar(40) not null
 );

create table regimes(
 code_regime char(2) primary key,
 libelle_court char(10) not null,
 libelle_long char(40) not null
 );

create table liens_parente(
 code_parente char(1) primary key,
 libelle_court varchar(10),
 libelle_long varchar(40) not null
 );

create table statuts_eleve(
 code_statut char(2) primary key,
 libelle_court varchar(10),
 libelle_long varchar(40)
 );

create table type_etablissement(
 code_type_etab char(4) primary key,
 libelle_court varchar(10),
 libelle_long varchar(40)
 );

create table structures(
 code_structure varchar(8) primary key,
 type_structure char(1) not null,
 libelle_long varchar(20),
 code_mef varchar(60) not null,
 divisions_appartenance varchar(255)
 );
 
create table eleves(
 id_eleve int(11) primary key,
 eleve_id int(11) not null unique,
 elenoet int(11),
 id_national varchar(11),
 nom varchar(25) not null,
 prenom char(25) not null,
 prenom2 char(25),
 prenom3 char(25),
 date_naiss date not null,
 code_sexe char(1),
 doublement tinyint not null,
 code_regime varchar(2) not null,
 date_entree date,
 date_modification date,
 adresse_id int(11),
 tel_professionnel tinyblob,
 tel_personnel tinyblob,
 tel_mobile tinyblob,
 accepte_sms tinyint,
 code_mef char(11),
 classe varchar(8)
 );

create table eleves_maj(
 id_eleve int(11) primary key auto_increment,
 eleve_id int(11) not null unique,
 elenoet int(11),
 id_national varchar(11),
 nom varchar(25) not null,
 prenom char(25) not null,
 prenom2 char(25),
 prenom3 char(25),
 date_naiss date not null,
 code_sexe char(1),
 doublement tinyint not null,
 code_regime varchar(2) not null,
 date_entree date,
 date_modification date,
 adresse_id int(11),
 tel_professionnel tinyblob,
 tel_personnel tinyblob,
 tel_mobile tinyblob,
 accepte_sms tinyint,
 code_mef char(11),
 classe varchar(8)
 );

create table options(
 eleve_id int(11) not null,
 elenoet int(11),
 num_option tinyint not null,
 code_modalite_elect char(1) not null,
 code_matiere varchar(6) not null,
 primary key(eleve_id,num_option)
 );

create table options_maj(
 eleve_id int(11) not null,
 elenoet int(11),
 num_option tinyint not null,
 code_modalite_elect char(1) not null,
 code_matiere varchar(6) not null,
 primary key(eleve_id,num_option)
 );

create table structures_eleves(
 eleve_id int(11) not null,
 elenoet int(11),
 code_structure varchar(8) not null,
 type_structure char(1) not null,
 primary key(eleve_id,code_structure)
 );

create table structures_eleves_maj(
 eleve_id int(11) not null,
 elenoet int(11),
 code_structure varchar(8) not null,
 type_structure char(1) not null,
 primary key(eleve_id,code_structure)
 );
 
create table adresses_eleves(
 adresse_id int(11) primary key,
 ligne1_adresse tinyblob,
 ligne2_adresse tinyblob,
 ligne3_adresse tinyblob,
 ligne4_adresse tinyblob,
 code_postal tinyblob,
 libelle_postal tinyblob
 );

create table adresses_eleves_maj(
 adresse_id int(11) primary key,
 ligne1_adresse tinyblob,
 ligne2_adresse tinyblob,
 ligne3_adresse tinyblob,
 ligne4_adresse tinyblob,
 code_postal tinyblob,
 libelle_postal tinyblob
 );

create table responsables(
 personne_id int(11) primary key,
 id_pers int(11) not null,
 lc_civilite varchar(5),
 nom varchar(25) not null,
 prenom varchar(25) not null,
 tel_personnel tinyblob,
 tel_mobile tinyblob,
 accepte_sms tinyint,
 tel_professionnel tinyblob,
 mel varchar(60),
 communication_adresse tinyint,
 adresse_id int(11),
 unique(id_pers)
 );

create table responsables_maj(
 personne_id int(11) not null,
 id_pers int(11) primary key auto_increment,
 lc_civilite varchar(5),
 nom varchar(25) not null,
 prenom varchar(25) not null,
 tel_personnel tinyblob,
 tel_mobile tinyblob,
 accepte_sms tinyint,
 tel_professionnel tinyblob,
 mel varchar(60),
 communication_adresse tinyint,
 adresse_id int(11),
 unique(personne_id)
 );

create table responsables_eleves(
 eleve_id int(11) not null,
 personne_id int(11) not null,
 resp_legal tinyint,
 code_parente char(1) not null,
 pers_contact tinyint,
 unique(eleve_id,personne_id)
 );

create table responsables_eleves_maj(
 eleve_id int(11) not null,
 personne_id int(11) not null,
 resp_legal tinyint,
 code_parente char(1) not null,
 pers_contact tinyint,
 unique(eleve_id,personne_id)
 );
 
create table adresses_responsables(
 adresse_id int(11) primary key,
 ligne1_adresse tinyblob,
 ligne2_adresse tinyblob,
 ligne3_adresse tinyblob,
 ligne4_adresse tinyblob,
 code_postal tinyblob,
 libelle_postal tinyblob
 );

create table adresses_responsables_maj(
 adresse_id int(11) primary key,
 ligne1_adresse tinyblob,
 ligne2_adresse tinyblob,
 ligne3_adresse tinyblob,
 ligne4_adresse tinyblob,
 code_postal tinyblob,
 libelle_postal tinyblob
 );

create table civilites(
 code_civilite char(1) primary key,
 libelle_court varchar(10) not null,
 libelle_long varchar(40) not null
 );

create table personnel(
 id_pers int(11) primary key,
 id_individu int(11) not null unique,
 type varchar(5) not null,
 nom char(20) not null,
 prenom char(15) not null,
 datenaiss date,
 activite char(35),
 categorie int(11),
 sous_categorie varchar(10),
 civilite char(5),
 code_discipline char(5) not null
 );

create table personnel_maj(
 id_pers int(11) primary key auto_increment,
 id_individu int(11) not null unique,
 type varchar(5) not null,
 nom char(20) not null,
 prenom char(15) not null,
 datenaiss date,
 activite char(35),
 categorie int(11),
 sous_categorie varchar(10),
 civilite char(5),
 code_discipline char(5) not null
 );

create table taux_ponderations(
 taux_pond float primary key,
 cpge_bts varchar(4)
 );

create table horaires_edt(
 code_jour tinyint primary key,
 debut_cours char(4) not null,
 fin_cours char(4) not null
 );
 
create table horaires_pauses(
 debut_recree_matin char(4),
 debut_pause_dej char(4),
 debut_recree_aprem char(4)
 );
 
insert into horaires_pauses values(NULL,"1200",NULL);

create table alternances(
 code_alternance varchar(3) primary key,
 libelle_court varchar(10) not null,
 libelle_long varchar(40) not null
 );

create table semaines_alternances(
 code_alternance varchar(3) not null,
 date_debut_semaine date not null
 );

create table profs_principaux(
  id_prof int(11) not null,
  code_structure char(8) not null unique,
  primary key(id_prof,code_structure)
 );

create table matieres_etablissement(
 code_matiere_etab varchar(5) primary key,
 code_matiere char(6) not null,
 libelle_court varchar(20) not null,
 libelle_long varchar(40) not null
 );
 
create table salles_cours(
 code_salle varchar(5) primary key,
 groupe_salle varchar(5) not null,
 localisation varchar(2) not null
 );

create table services(
 id_service int(11) primary key auto_increment,
 code_structure varchar(8) not null,
 code_matiere char(6) not null,
 code_mod_cours char(2) not null,
 heure float UNSIGNED not null,
 co_ens boolean,
 unique(code_structure,code_matiere,code_mod_cours,heure)
 );

create table enseignants_services(
 id_enseignant_service int(11) primary key auto_increment,
 id_service int(11) not null,
 type varchar(5) not null,
 id_individu int(11) not null,
 heures_agent float UNSIGNED not null,
 taux_ponderation float,
 unique(id_service,id_individu)
 );
 
create table cours(
 id_cours int(11) primary key auto_increment,
 id_enseignant_service int(11) not null,
 code_alternance varchar(3) not null,
 code_jour tinyint not null,
 heure_debut char(4) not null,
 duree char(4) not null,
 code_matiere char(6) not null,
 code_matiere_etab varchar(5),
 code_salle varchar(5),
 unique(id_enseignant_service,code_alternance,code_jour,heure_debut,duree,code_matiere)
 );
 
create table liste_absents_transactions(
 id_transaction int(11) primary key auto_increment,
 date date not null,
 id_pers int(11) not null,
 debut char(5) not null,
 classe varchar(255) not null,
 unique(date,debut,classe)
 );

create table liste_absents_provisoires(
 id_pers int(11) not null,
 debut char(5) not null,
 classe varchar(255) not null,
 eleve_id int(11) not null,
 date date not null,
 primary key(id_pers,debut,classe,eleve_id,date)
 );

create table liste_absents(
 id_transaction int(11) not null,
 eleve_id int(11) not null,
 primary key(id_transaction,eleve_id)
 );

create table majbddelev(
 maj timestamp
 );

create table notes(
date timestamp,
auteur char(45),
objet char(80),
destinataire char(20),
note text,
id_note int(11) primary key auto_increment,
unique (auteur,destinataire,objet)
);

create table categories_pers(
 id_cat int(11) primary key auto_increment,
 id_groupe int(11),
 categorie char(30));

insert into categories_pers values("1","7","Administratif");
insert into categories_pers values("2","7","Chef de travaux");
insert into categories_pers values("4","9","COP");
insert into categories_pers values("5","6","Direction");
insert into categories_pers values("6","7","Gestionnaire");
insert into categories_pers values("7","3","Enseignant");
insert into categories_pers values("8","8","Vie scolaire");
insert into categories_pers values("9","10","Mdico-Social");
insert into categories_pers values("10","7","Agent");
insert into categories_pers values("12","7","Contrat Aid");

create table sous_categories_pers(
  id_sous_cat int(11) primary key auto_increment,
  sous_categorie char(30) not null,
  id_cat int(11) not null,
  unique(id_cat,sous_categorie)
);

insert into sous_categories_pers values(NULL,"Secrtariat","1");
insert into sous_categories_pers values(NULL,"Secrtariat Intendance","1");
insert into sous_categories_pers values(NULL,"Principal","5");
insert into sous_categories_pers values(NULL,"Principal Adjoint","5");
insert into sous_categories_pers values(NULL,"Proviseur","5");
insert into sous_categories_pers values(NULL,"Proviseur Adjoint","5");
insert into sous_categories_pers values(NULL,"Directeur","5");
insert into sous_categories_pers values(NULL,"Adjoint d'Enseignement","7");
insert into sous_categories_pers values(NULL,"Agrg","7");
insert into sous_categories_pers values(NULL,"Assistant Etranger","7");
insert into sous_categories_pers values(NULL,"Certifi","7");
insert into sous_categories_pers values(NULL,"PEGC","7");
insert into sous_categories_pers values(NULL,"Intervenant Second Degr","7");
insert into sous_categories_pers values(NULL,"Matre auxilliaire","7");
insert into sous_categories_pers values(NULL,"PLP1","7");
insert into sous_categories_pers values(NULL,"PLP2","7");
insert into sous_categories_pers values(NULL,"Professeur Contractuel","7");
insert into sous_categories_pers values(NULL,"Professeur des Ecoles","7");
insert into sous_categories_pers values(NULL,"Vacataire","7");
insert into sous_categories_pers values(NULL,"Assistant(e) pdagogique","8");
insert into sous_categories_pers values(NULL,"Assistant(e) d'ducation","8");
insert into sous_categories_pers values(NULL,"Auxilliaire de Vie Scolaire","8");
insert into sous_categories_pers values(NULL,"CPE","8");
insert into sous_categories_pers values(NULL,"Surveillant","8");
insert into sous_categories_pers values(NULL,"Assistant(e) social(e)","9");
insert into sous_categories_pers values(NULL,"Infirmire","9");
insert into sous_categories_pers values(NULL,"Mdecin","9");
insert into sous_categories_pers values(NULL,"Technicien","10");
insert into sous_categories_pers values(NULL,"Ouvrier","10");
insert into sous_categories_pers values(NULL,"Service","10");

create table sous_matieres(
 id_sous_matiere int(11) primary key auto_increment,
 code_matiere char(6),
 sous_matiere varchar(20) not null,
 unique (sous_matiere)
 );

create table semab(
 date_rentree date,
 dbt_toussaint date,
 fin_toussaint date,
 dbt_noel date,
 fin_noel date,
 dbt_fev date,
 fin_fev date,
 dbt_paq date,
 fin_paq date,
 dbt_1t date,
 fin_1t date,
 p_1t date,
 dbt_2t date,
 fin_2t date,
 p_2t date,
 dbt_3t date,
 fin_3t date,
 p_3t date,
 dbt_ete date
 );
 
create table categories_groupes(
 id_cat_grp int(11) primary key auto_increment,
 nom char(45) not null,
 description char(60) not null,
 unique(nom)
 );

insert into categories_groupes values(NULL,"soutien","Soutien");
insert into categories_groupes values(NULL,"atp","Aide au Travail Personnel");
insert into categories_groupes values(NULL,"idd1","Itinraire De Dcouverte : Nature et corps humain");
insert into categories_groupes values(NULL,"idd2","Itinraire De Dcouverte : Langues et civilisations");
insert into categories_groupes values(NULL,"idd3","Itinraire De Dcouverte : Crations et techniques");
insert into categories_groupes values(NULL,"idd4","Itinraire De Dcouverte : Arts et humanits");
insert into categories_groupes values(NULL,"tpe","Travaux Personnels Encadrs");
insert into categories_groupes values(NULL,"tc","Travaux Croiss");


create table groupes(
 id_groupe int(11) primary key auto_increment,
 nom varchar(255) not null,
 id_responsable int(11) not null,
 unique(nom)
 );

create table groupes_eleves(
 id_groupe int(11) not null,
 eleve_id int(11) not null,
 code_structure varchar(8) not null,
 primary key(id_groupe,eleve_id)
 );

create table login(
 id_pers int(11) primary key auto_increment,
 id_individu int(11),
 eleve_id int(11),
 id_personne int(11),
 nomlogin char(20),
 auth_source varchar(8) not null,
 id_gpe_utilisateurs int(11) not null,
 mot_pass tinytext,
 nom char(25) not null,
 prenom char(20) not null,
 date_validite date,
 etat int(1) not null,
 limit_date_passwd date
 );

insert into login values(NULL,NULL,NULL,NULL,"admin-iew","native","1",PASSWORD("admin"),"","",NULL,"1",NULL);

create table groupes_utilisateurs(
  id_groupe int(11) primary key auto_increment,
  nom char(20) not null,
  unique(nom)
);

insert into groupes_utilisateurs values("1","admin"); 
insert into groupes_utilisateurs values("2","eleves");
insert into groupes_utilisateurs values("3","profs");
insert into groupes_utilisateurs values("4","parents");
insert into groupes_utilisateurs values("5","gestadmin"); 
insert into groupes_utilisateurs values("6","direction");
insert into groupes_utilisateurs values("7","autres_pers");
insert into groupes_utilisateurs values("8","Vie_scolaire");
insert into groupes_utilisateurs values("9","orientation");
insert into groupes_utilisateurs values("10","sante_social");
insert into groupes_utilisateurs values("11","ipr");
insert into groupes_utilisateurs values("12","exterieurs");

create table installation(
  date_install date
  );

create table accept_charte(
  id_pers int(11) not null primary key
  );

insert into accept_charte values("1");

create table cahiers_textes(
 id_ctexte int(11) not null primary key auto_increment,
 date date not null,
 code_structure varchar(255) not null default "0",
 id_groupe int( 11 ) NOT NULL DEFAULT  "0",
 id_individu int(11) not null,
 code_matiere char(6) not null,
 id_sous_matiere int(11) not null,
 activite text not null,
 publication bool not null default "1",
 unique (date,code_structure,code_matiere,id_sous_matiere)
 );

create table a_faire(
 id_afaire int(11) not null primary key auto_increment,
 id_ctexte int(11) not null,
 afaire text not null,
 pourle date not null,
 publication bool not null default "1",
 unique(id_ctexte,afaire(100),pourle)
 );

create table docs_joints_ctextes(
 id_doc int(11) not null primary key auto_increment,
 filename varchar(60) not null,
 commentaire tinytext,
 id_ctexte int(11) not null,
 id_afaire int(11) not null,
 publication bool not null default "1",
 md5 char(32) not null,
 unique(filename,id_ctexte,id_afaire)
 );

create table telechargement (
 id int(11) not null primary key auto_increment,
 nom char(40) not null,
 chemin varchar(255),
 description text
 );

insert into telechargement values(NULL,"new_comptes_eleves.txt","","Fichier contenant les identifiants et mots de passe des comptes IntraEduweb des Elves arrivs en cours d'anne. Le mot de passe est chiffr.<br />Ce fichier peut tre utilis pour connatre les nouveaux lves auxquels vous devrez communiquer leurs identifiants et mots de passe en cours d'anne. Voir la documentation de l'administrateur IEW.");
insert into telechargement values(NULL,"new_comptes_personnel.txt","","Fichier contenant les identifiants et mots de passe des comptes IntraEduweb du personnel de l'tablissement arriv en cours d'anne. Le mot de passe est chiffr.<br />Ce fichier peut tre utilis pour connatre les nouveaux membres du personnel auxquels vous devrez communiquer leurs identifiants et mots de passe en cours d'anne. Voir la documentation de l'administrateur IEW.");
insert into telechargement values(NULL,"suppr_comptes_eleves.txt","","Fichier contenant les identifiants des comptes IntraEduweb Elves sortis de l'tablissement en cours d'anne scolaire<br />Ce fichier peut tre utilis pour la suppression des comptes des lves concerns sur le rseau pdagogique ds leur dpart de l'tablissement, pour le cas o vous auriez les mmes comptes sur IEW et votre rseau pdagogique.");
insert into telechargement values(NULL,"suppr_comptes_personnel.txt","","Fichier contenant les identifiants des comptes IntraEduweb des membres du personnel sortis de l'tablissement en cours d'anne scolaire<br />Ce fichier peut tre utilis pour la suppression des comptes des membres du personnel concerns sur le rseau pdagogique ds leur dpart de l'tablissement, pour le cas o vous auriez les mmes comptes sur IEW et votre rseau pdagogique.");

create table coordonnateurs (
 id_coordonnateur int(11) not null primary key auto_increment,
 id_individu int(11) not null,
 code_matiere char(6) not null,
 unique(id_individu,code_matiere)
 );

create table version (
  version varchar(30)
 );

create table ipr (
 id_pers int(11) not null primary key,
 nom char(25) not null,
 prenom char(20) not null,
 code_discipline char(5) not null,
 date_visite date not null,
 email char(60),
 liste_profs text,
 unique(nom,prenom)
 );

create table autorisations_1 (
 eleve_id int(11) not null primary key,
 pub_intranet ENUM("0","1"),
 bal_externe ENUM("0","1"),
 pub_travaux_siteweb ENUM("0","1"),
 pub_fotoweb ENUM("0","1"),
 foto_video_pedago ENUM("0","1"),
 foto_cie_indiv ENUM("0","1"),
 foto_cie_classe ENUM("0","1")
);

create table domaines_autorisations (
 id_domaine int(11) not null primary key auto_increment,
 titre text not null
);

insert into domaines_autorisations values(NULL,"TICE-Donnes Personnelles");

create table autorisations_etab (
 id_autorisation int(11) not null primary key auto_increment,
 nom_champ char(25) not null,
 libelle tinytext not null,
 detail text not null,
 id_domaine int(11) not null,
 ordre tinyint(1),
 unique(nom_champ)
);

insert into autorisations_etab values(NULL,"pub_intranet","Publication de donnes personnelles dans IEW","<u>si l'application IEW est accessible depuis l'extrieur</u>, la publication de sa photographie d'identit et de certaines donnes pdagogiques ou administratives* qui le concernent, sur les pages de cette application, <strong>ces informations n'tant accessibles que par des personnes dment autorises</strong> (administration, vie scolaire, enseignants, assistante sociale, conseiller d'orientation, mdecin ou infirmire scolaire, parents concerns) <strong>et identifies par un mot de passe</strong>. Ces informations <strong>circulent sous forme crypte</strong> (comme lors de transactions bancaires sur le web).<br />La nature des informations publies est prcise dans la <a href='../../charte_droits.html'>Charte de l'utilisateur IntraEduWeb</a><br />*<i> l'exception du nom, prnom, date de naissance, sexe, status de redoublant ventuel, le rgime de sortie, les langues et options suivies qui sont des informations indispensables au fonctionnement de l'application IEW et qui  ce titre sont toujours publies (mais accessibles uniquement par les personnes dment autorises comme prcis plus haut)</i>","1","1");
insert into autorisations_etab values(NULL,"bal_externe","Cration d'une adresse email externe","La cration d'une bote aux lettres lectronique personnelle <u>externe</u> (le cas chant), <u>dans le cadre d'un projet pdagogique</u>, sur le site de La Poste qui a sign dans ce sens un accord avec le ministre de l'Education Nationale et qui prvoit notamment le respect de la neutralit commerciale de notre service public, ainsi que la conservation exclusive des informations  caractre personnel fournies lors de l'inscription de manire  se prmunir contre la diffusion de donnes  caractre publicitaire. L'utilisation de cette bote aux lettres ne se limite pas au seul cadre de l'tablissement, et l'lve pourra l'utiliser tout au long de sa vie mme lorsqu'il aura quitt le systme ducatif: c'est une des raisons pour lesquelles ce service gratuit est rendu par un organisme extrieur  l'Education Nationale. Cette bote aux lettres est accessible depuis l'internet.","1","2");
insert into autorisations_etab values(NULL,"pub_travaux_siteweb","Publication de travaux sur le site internet de l'tablissement","La publication <u>sur le site internet de l'tablissement</u> <strong>(accs tout public)</strong>, ventuellement, des travaux qu'il aura ralis dans le cadre de son travail scolaire. Seuls son prnom et la premire lettre de son nom apparatront sur le site. Les photos ventuelles le reprsentant sont soumises  mon autorisation pralable avant la publication sur ce site et dans le respect des dispositions lgales en vigueur.","1","3");
insert into autorisations_etab values(NULL,"pub_fotoweb","Publication de photo sur le site internet de l'tablissement","la publication ventuelle, sur le site internet de l'tablissement <strong>(accs tout public)</strong>, de photographies le reprsentant pour illustrer la publication d'articles pdagogiques ou d'albums photos faisant suite  des sorties pdagogiques,  des manifestations diverses de la vie de l'tablissement (march de Nol, comptitions sportives, reprsentations thtrales, chorale, etc...), ou issues d'activits faites en classe. Cette publication sera faite dans le respect de la <a href='http://www.educnet.education.fr/legamedia/fiches/droit-image.htm'>lgislation sur le droit d'image</a>","1","4");
insert into autorisations_etab values(NULL,"foto_video_pedago","Utilisation de l'image par un professeur dans un projet pdagogique (hors site web)","Qu'un professeur utilise l'image filme ou photographie de mon enfant <u>dans le cadre strictement limit d'une ralisation pdagogique au sein de l'tablissement scolaire, non commerciale</u>. Le choix de ce support pour les activits pgadogiques est prvu dans les programmes de certaines disciplines publis dans les bulletins officiels de l'Education Nationale. Dans le cas d'un refus du reprsentant lgal, l'lve sera amen  produire un autre travail.","1","5");
insert into autorisations_etab values(NULL,"foto_cie_indiv","Prise de photo individuelle par une socit spcialise","La prise de <u>photos individuelles</u> par un photographe spcialis, qui vient tous les ans dans notre tablissement (la date sera communique aux familles ultrieurement) pour photographier les lves et les personnels.","1","6");
insert into autorisations_etab values(NULL,"foto_cie_classe","Prise de photo de groupe par une socit spcialise","La prise de <u>photos avec sa classe</u> par le mme photographe","1","7");

create table auth_foto (
 id_pers int(11) not null,
 auth_eleves ENUM("0","1"),
 auth_parents ENUM("0","1"),
 auth_ipr ENUM("0","1"),
 auth_collegues ENUM("0","1"),
 unique(id_pers)
);

create table demande_mdp (
 id_pers int(11) not null,
 date date not null,
 usercat int(11) not null,
 nom varchar(25) not null,
 prenom varchar(25),
 date_satisfaction date,
 unique(id_pers,date)
);

create table echec_acces (
 id int(11) not null primary key auto_increment,
 nomlogin char(20) not null unique,
 connect_failed_nb tinyint(1),
 heure int(11) not null
);

create table journal_connexions (
 id_connexion int(11) not null primary key auto_increment,
 id_pers int(11) not null,
 debut int(10) unsigned NOT NULL default "0",
 fin int(10) unsigned NOT NULL default "0",
 last_request int(10) unsigned NOT NULL default "0",
 ip varchar(39) not null,
 navigateur varchar(20) not null
);

create table horaires(
  debut_matin char(5) not null,
  nb_matin tinyint(1)  not null,
  debut_aprem char(5) not null,
  nb_aprem char(5) not null,
  duree_cours tinyint(1) not null
  );

insert into horaires values("08h00","4","12h30","4","1");

create table matieres(
 id_matiere int(11) primary key auto_increment,
 matiere varchar(60),
 id_discipline varchar(20) not null,
 unique(matiere)
 );

create table disciplines(
 id_discipline int(11) primary key auto_increment,
 discipline varchar(60),
 unique(discipline)
 );

create table divisions(
 id_div int(11) primary key auto_increment,
 division varchar(20) not null,
 unique(division)
 );
 
create table corps_personnel(
 id_corps char(3) primary key,
 libelle_court varchar(10),
 libelle_long varchar(40),
 libelle_edition varchar(160)
 );
 
create table grades_personnel(
 id_grade char(4) primary key,
 libelle_court varchar(10),
 libelle_long varchar(40),
 libelle_edition varchar(160),
 id_corps char(3)
 );
 
create table couleurs_edt_matieres(
 matiere varchar(20) primary key,
 avt_plan varchar(6),
 arr_plan varchar(6)
 );
  
create table remplacants(
 id_remplacant int(11) not null unique,
 id_titulaire int(11) not null unique
 );
 
create table cours_diff(
 id_cours_diff int(11) primary key auto_increment,
 type_diff char(3) not null,
 id_cours int(11) not null,
 id_individu int(11) not null,
 code_structure varchar(8) not null,
 structure_complete BOOL NOT NULL DEFAULT '1',
 code_alternance varchar(3),
 date date,
 code_jour tinyint not null,
 heure_debut char(4) not null,
 duree char(4) not null,
 code_matiere char(6) not null,
 code_matiere_etab varchar(5),
 code_salle varchar(5),
 unique(type_diff,id_cours,id_individu,code_alternance,code_jour,heure_debut,duree,code_matiere)
 )
 AUTO_INCREMENT = 10000;
 
create table visas_ct(
 id_visa int(11) primary key auto_increment,
 type char(3) not null,
 id_pers int(11) not null,
 date datetime not null,
 id_prof int(11) not null,
 code_structure varchar(8) not null default "0",
 id_enseignant_service int(11) not null default "0",
 id_groupe int(11) not null,
 last_id_ctexte int(11) not null,
 activation bool not null,
 unique(type,id_prof,code_structure,id_enseignant_service,id_groupe,last_id_ctexte)
);