/**
 * intraeduweb_comment.sql
 *
 * Ce fichier contient la mme chose que intraeduweb.sql, mais en plus il y a des commentaires explicatifs
 * sur les tables et leurs relations
 *
 * installation des tables MySQL utilises par l application
 * ATTENTION : LES COMMENTAIRES ICI NE DOIVENT PAS COMPRENDRE D APOSTROPHES, DE GUILLEMETS
 * OU DE POINTS VIRGULES ! (sinon la requte effectue  partir de ce fichier de commandes n aboutira pas)
 * et DE PLUS CE FICHIER DOIT SE TERMINER PAR UN POINT VIRGULE !
 * 
 * Ce fichier fait partie du projet IntraEduWeb (IEW)
 * 
 * @package		IEW
 * @author			Sylvain GODM <sylvain.godme@gmail.com>
 * @version		$LastChangedRevision$, $LastChangedDate$
 * @copyright		2004-2012 Sylvain GODM
 * @link			http://iew.free.fr
 * @license		GPL License version 3 (http://www.gnu.org/licenses/gpl.html)
 * @filesource
 * 
 */

/*** Dans sa premire partie, ce fichier est construit  partir de la description des exports standards
XML de SCONET et STSWEB. Les tables qui suivent tiennent compte de ces spcifications.
Du fait que certaines balises XML n ont pas de caractre obligatoire (Repres par un N dans le document Exports standards
XML  destination des Editeurs Version 1,7-a ou ultrieure), il se peut que celles-ci soient
absentes du fichier d import. En consquence, la structure de chaque table est ainsi faite que si la balise est absente
du fichier d import, alors la valeur du champ correspondant dans la table sera mis  NULL.
Ceci implique qu aucune balise facultative ne peut tre la cl primaire d une table (seules les balises obligatoires
repres par un O dans le document Exports standards XML  destination des Editeurs Version 1,7-a ou ultrieure peuvent l tre)
d une part et, d autre part il faut que les scripts d insertion ou de mise  jour des donnes testent l existence
de ces balises dans les fichers d import pour adapter la valeur NULL ou valeur vide (ou non vide) selon le cas.

Rappel, ne confondons pas la valeur NULL et la valeur vide : par exemple pour un champ numro de tlphone,
Une valeur NULL signifie : numro de tlphone est inconnu
Une valeur Vide signifie : numro de tlphone ne contient rien

Par consquent une colonne not null ou primary key correspond  une balise XML Obligatoire (mais qui peut comporter des valeurs vides dans le cas not null)
une colonne sans la prcision not null correspond donc  une balise XML facultative.

Dans sa 2me partie, ce fichier contient la structure des tables propres  IEW, qui ne dpendent pas des applications
administratives de gestion comme SCONET ou STSWEB ou bien des tables qui en dpendent (car elles sont alimentes par
les exports xml correspondants), mais qui sont conserves pour permettre le fonctionnement des scripts antrieurs
 l utilisation des exports xml des applications de gestion

Dans la 3me partie, on trouvera les tables additionnelles ajoutes au fur et  mesure du dveloppement de l application,
notamment celles ncessaires  l implmentation de nouvelles fonctionnalits.

***/



/***************************** PREMIERE PARTIE ******************************/

/* Table donnant les codes des jours de la semaine selon les applications administratives de gestion (STSWEB)

Elle est renseigne une fois pour toutes  l installation IEW et ne subit ensuite plus aucune modification

Liaison avec les tables :
- horaires
- cours

  */

create table jours(
 code_jour tinyint primary key,
 jour varchar(8) not null
 );

insert into jours values("1","Lundi");
insert into jours values("2","Mardi");
insert into jours values("3","Mercredi");
insert into jours values("4","Jeudi");
insert into jours values("5","Vendredi");
insert into jours values("6","Samedi");
insert into jours values("7","Dimanche");

/*** Les tables suivantes donnent une indication sur les dates des imports effectus  partir des fichiers XML des applications administratives de gestion
Elles ne contiennent qu un seul enregistrement
Les char(19) sont au format jj/mm/aaaa hh:mm:ss

MAJ => c_imports.php

 ***/

create table horodatages_imports_base(
 date_import_base date,
 communs char(19),
 nomenclature char(19),
 structures char(19)
 );

create table horodatages_imports_eleves(
 date_import_eleves date,
 eleves char(19),
 responsables char(19)
 );
 
/*** DONNEES A IMPORTER A PARTIR DE LA BCN table N_DISCIPLINE_POSTE 
MAJ => c_imports.php ***/

/* Table contenant les disciplines des postes d enseignants

Ces informations ne peuvent pas toutes tre rcupres par les exports XML des application de gestion
En particulier, seul le code et le libelle_court sont prsents dans sts_emp_rne_annee.xml
Nous avons besoin en particulier du libell long, c est pourquoi on travaille  partir
DE LA BCN table N_DISCIPLINE_POSTE disponible sur le site http://www.infocentre.education.fr/bcn/accueil.php
Il faut rechercher la table N_DISCIPLINE_POSTE et raliser un export csv dans le fichier
n_discipline_poste.csv

Ces informations ne sont utiles que pour la publication de la liste du personnel enseignant (par discipline poste)
et pour le champ discipline de la table personnel pour les enseignants

Liaison avec les tables :
- personnel

*/

create table disciplines_bcn(
 code_discipline char(5) primary key,
 libelle_court varchar(10),
 libelle_long varchar(40),
 libelle_edition varchar(120)
 );

/*** Tables pour les exports Communs.xml (SCONET) 
MAJ => c_imports.php ***/

/* Bloc UAJ */

/* Table contenant des informations sur l tablissement : Unit Administratives et Juridique

uaj.code_type_etab = type_etablissement.code_type_etab (lien externe)

*/

create table uaj(
 etab_uaj_id int(11) primary key,
 code_rne varchar(8) not null,
 num_siren varchar(9),
 denom_princ varchar(30),
 denom_compl varchar(30),
 nom_resp varchar(25),
 qual_resp varchar(15),
 ligne1_adresse varchar(32),
 ligne2_adresse varchar(32),
 ligne3_adresse varchar(32),
 ligne4_adresse varchar(32),
 telephone varchar(15),
 telecopie varchar(15),
 mel_1 varchar(60),
 mel_2 varchar(60),
 code_type_etab varchar(4), 
 code_postal varchar(5),
 libelle_postal varchar(32)
 );
 
/* les autres Blocs de  l export ne sont pas utiliss par IEW */


/*** Tables pour les exports Nomenclature.xml (SCONET) 
MAJ => c_imports.php ***/

/* Bloc MEF */

/* Table contenant les Modules Elmentaires de Formation 

La colonne formation est un code administratif de type libell court

Liaison avec les tables :
- programmes
- options_obligatoires
- structures
- eleves

*/

create table mefs(
 code_mef char(11) primary key,
 formation varchar(6) not null,
 libelle_long varchar(40),
 libelle_edition varchar(60)
 );

/* Bloc matires */

/* Table contenant les matires nationales

Code_matiere peut tre NULL, les balises obligatoires dans le fichier XML d import sont :
- libelle_long
- matiere_etp
Le reste peut potentiellement tre NULL

La colonne code_gestion : je ne sais pas encore  quoi a sert...
La colonne matiere_etp : je ne sais pas encore  quoi a sert...

Liaison avec les tables :
- programmes
- options_obligatoires
- options
- matieres_etablissement
- services

libelle_edition.matieres_sconet=matiere.matieres

*/

create table matieres_sconet(
 code_matiere char(6),
 code_gestion varchar(5),
 libelle_court varchar(20),
 libelle_long varchar(40) primary key,
 libelle_edition varchar(60),
 matiere_etp smallint not null
 );

/* Bloc programmes */

/* Table contenant les horaires prvus par les programmes dans une matire et une formation donne 

programmes.code_mef = mefs.code_mef (lien externe)
programmes.code_matiere = matieres.code_matiere (lien externe)
programmes.code_modalite_election = modalites_election.code_modalite_election (lien externe)

*/

create table programmes(
 code_mef char(11) not null,
 code_matiere char(6),
 code_modalite_elect char(1) not null,
 horaire float,
 unique(code_mef,code_matiere,code_modalite_elect)
 );
 
/* Bloc options obligatoires */

/* Table contenant les options obligatoires comme les langues vivantes par exemple 

options_obligatoires.code_mef = mefs.code_mef (lien externe)
options_obligatoires.code_matiere = matieres.code_matiere (lien externe)

*/

create table options_obligatoires(
 code_mef char(11) not null,
 code_matiere char(6) not null,
 rang_option smallint not null,
 unique(code_mef,code_matiere)
 ); 

/* Bloc modalits d lection */

/* Table contenant les diffrentes modalits d lection des matires enseignes
Par exemple Matire enseigne en tronc commun ou matire enseigne option facultative

Liaison avec les tables :
- services

*/

create table modalites_election(
 code_modalite_election char(1) primary key,
 libelle_court varchar(10),
 libelle_long varchar(40) not null
 );

/* Bloc rgimes */

/* Table rgime contenant les libell des rgimes des lves de l tablissement (externe, interne...) 

Liaison avec les tables :
- eleves

*/

create table regimes(
 code_regime char(2) primary key,
 libelle_court char(10) not null,
 libelle_long char(40) not null
 );

/* Bloc liens de parents */

/* Table contenant les libells des liens de parent avec les responsables des lves 

Liaison avec les tables :
- responsables_eleves

*/

create table liens_parente(
 code_parente char(1) primary key,
 libelle_court varchar(10),
 libelle_long varchar(40) not null
 );

/* Bloc statuts lve */

/* Table contenant les statuts des lves (Scolaire, Apprenti,...) 

Sera remplie par l import XML, mais n est pas utilis par IEW

*/

create table statuts_eleve(
 code_statut char(2) primary key,
 libelle_court varchar(10),
 libelle_long varchar(40)
 );

/* Bloc type tablissement */

/* Table dont les colonnes sont assez explicites 

Liaison avec les tables :
- uaj

*/

create table type_etablissement(
 code_type_etab char(4) primary key,
 libelle_court varchar(10),
 libelle_long varchar(40)
 );


/*** Tables pour les exports Structures.xml (SCONET) 
MAJ => c_imports.php ***/

/* Bloc lments de structure */

/* 
La table suivante contient ausi bien les divisions que les groupes.
- structures.type_structure = D pour une division, G pour un groupe
- Il peut potentiellement exister plusieurs MEFs (code MEF = 11 caractres) pour une division, donc le champ code_mef a une longueur de 60
 on peut y mettre j usqu  5 codes mefs spars par 4 virgules
- structures.divisions_appartenance peut tre NULL (Si la structure est une division), ou contenir la liste des divisions
auquelles un groupe prend des lves (on peut y mettre j usqu   27 codes division (code_structure  8 caractres : soit
27*8 = 216) mefs spars par 26 virgules (216+26=242 < 255 = OK)

structures.code_mef = mefs.code_mef (lien externe)

Liaison avec les tables :
- structures_eleves
- profs_principaux
- services

*/
 

create table structures(
 code_structure varchar(8) primary key,
 type_structure char(1) not null,
 libelle_long varchar(20),
 code_mef varchar(60) not null,
 divisions_appartenance varchar(255)
 );
 

/*** Tables pour les exports ElevesAvecAdresses.xml ou ElevesSansAdresses.xml  (SCONET) 
MAJ => maj_bddelev_sconet.php ***/


/* Bloc Elves */

/* Table contenant les informations sur les lves
Il n y a pas de colonne date_sortie car on ne prend que les lves actuellement dans l etablissement

eleves.id_eleve = login.id_pers (lien externe)
eleves.eleve_id : identifiant SCONET de l lve
eleves.elenoet : identifiant de l lve dans l tablissement
eleves.id_national : identifiant national de l lve
eleves.adresse_id = adresses_eleves.adresse_id (lien externe)

Les colonnes tel_professionnel, tel_personnel et tel_mobile sont de type tinyblob car seront cryptes par AES_ENCRYPT (binaire)

Liaison avec les tables :
- autorisations_1
- options
- structures_eleves
- responsables_eleves

 */

create table eleves(
 id_eleve int(11) primary key,
 eleve_id int(11) not null unique,
 elenoet int(11),
 id_national varchar(11),
 nom varchar(25) not null,
 prenom char(25) not null,
 prenom2 char(25),
 prenom3 char(25),
 date_naiss date not null,
 code_sexe char(1),
 doublement tinyint not null,
 code_regime varchar(2) not null,
 date_entree date,
 date_modification date,
 adresse_id int(11),
 tel_professionnel tinyblob,
 tel_personnel tinyblob,
 tel_mobile tinyblob,
 accepte_sms tinyint,
 code_mef char(11),
 classe varchar(8)
 );

/* Table pour la mise  jour */

create table eleves_maj(
 id_eleve int(11) primary key auto_increment,
 eleve_id int(11) not null unique,
 elenoet int(11),
 id_national varchar(11),
 nom varchar(25) not null,
 prenom char(25) not null,
 prenom2 char(25),
 prenom3 char(25),
 date_naiss date not null,
 code_sexe char(1),
 doublement tinyint not null,
 code_regime varchar(2) not null,
 date_entree date,
 date_modification date,
 adresse_id int(11),
 tel_professionnel tinyblob,
 tel_personnel tinyblob,
 tel_mobile tinyblob,
 accepte_sms tinyint,
 code_mef char(11),
 classe varchar(8)
 );

/* Bloc Options de l lve */

/* Table contenant les options suivies par les lves

options.eleve_id = eleves.eleve_id (lien externe)
options.elenoet = eleves.elenoet (lien externe)
options.num_option : numro de l option pour l lve
options.code_modalite_elect = modalites_elections.code_modalite_elect (lien externe)
options.code_matiere = matieres.code_matiere (lien externe)

*/

create table options(
 eleve_id int(11) not null,
 elenoet int(11),
 num_option tinyint not null,
 code_modalite_elect char(1) not null,
 code_matiere varchar(6) not null,
 primary key(eleve_id,num_option)
 );

/* Table pour la mise  jour */

create table options_maj(
 eleve_id int(11) not null,
 elenoet int(11),
 num_option tinyint not null,
 code_modalite_elect char(1) not null,
 code_matiere varchar(6) not null,
 primary key(eleve_id,num_option)
 );

/* Bloc Elve inscrit dans une structure */

/* Table contenant les identifiants des lves inscrits dans des divisions ou des groupes

structures_eleves.eleve_id = eleves.eleve_id (lien externe)
structures_eleves.elenoet = eleves.elenoet (lien externe)
structures_eleves.code_structure = structures.code_structure (lien externe)

*/

create table structures_eleves(
 eleve_id int(11) not null,
 elenoet int(11),
 code_structure varchar(8) not null,
 type_structure char(1) not null,
 primary key(eleve_id,code_structure)
 );

/* Table pour la mise  jour */

create table structures_eleves_maj(
 eleve_id int(11) not null,
 elenoet int(11),
 code_structure varchar(8) not null,
 type_structure char(1) not null,
 primary key(eleve_id,code_structure)
 );
 
/* Bloc Adresse */

/* Table contenant les adresses des lves (si fournies dans l import, ce qui ne doit tre souvent le cas)

Les colonnes ligne1_adresse  ligne4_adresse, code_postal et libelle_postal sont de type tinyblob car seront cryptes par AES_ENCRYPT (binaire)

Liaison avec les tables :
- eleves

*/

create table adresses_eleves(
 adresse_id int(11) primary key,
 ligne1_adresse tinyblob,
 ligne2_adresse tinyblob,
 ligne3_adresse tinyblob,
 ligne4_adresse tinyblob,
 code_postal tinyblob,
 libelle_postal tinyblob
 );

/* Table pour la mise  jour */

create table adresses_eleves_maj(
 adresse_id int(11) primary key,
 ligne1_adresse tinyblob,
 ligne2_adresse tinyblob,
 ligne3_adresse tinyblob,
 ligne4_adresse tinyblob,
 code_postal tinyblob,
 libelle_postal tinyblob
 );

/*** Tables pour les exports ResponsablesAvecAdresses.xml ou ResponsablesSansAdresses.xml  (SCONET) 
MAJ => maj_bddelev_sconet.php ***/

/* Bloc Personne */

/* Table contenant les informations sur les responsables

responsables.personne_id : identifiant du responsable dans l tablissement
responsables.id_pers = login.id_pers (lien externe)
responsables.adresse_id = adresses_responsables.adresse_id (lien externe)

Les colonnes tel_professionnel, tel_personnel et tel_mobile sont de type tinyblob car seront cryptes par AES_ENCRYPT (binaire)

Liaison avec les tables :
- responsables_eleves

*/

create table responsables(
 personne_id int(11) primary key,
 id_pers int(11) not null,
 lc_civilite varchar(5),
 nom varchar(25) not null,
 prenom varchar(25) not null,
 tel_personnel tinyblob,
 tel_mobile tinyblob,
 accepte_sms tinyint,
 tel_professionnel tinyblob,
 mel varchar(60),
 communication_adresse tinyint,
 adresse_id int(11),
 unique(id_pers)
 );

/* Table pour la mise  jour */

create table responsables_maj(
 personne_id int(11) not null,
 id_pers int(11) primary key auto_increment,
 lc_civilite varchar(5),
 nom varchar(25) not null,
 prenom varchar(25) not null,
 tel_personnel tinyblob,
 tel_mobile tinyblob,
 accepte_sms tinyint,
 tel_professionnel tinyblob,
 mel varchar(60),
 communication_adresse tinyint,
 adresse_id int(11),
 unique(personne_id)
 );

/* Bloc Responsable (est rattach  l lve) */

/* Table liant les responsables aux lves

responsables_eleves.eleve_id = eleves.eleve_id (lien externe)
responsables_eleves.personne_id = responsables.personne_id (lien externe)
responsables_eleves.resp_legal : 
	valeurs possibles :
	- 0 (pas de responsabilit lgale, simple personne contact)
	- 1 premier responsable lgal
	- 2 deuxime responsable lgal
responsables_eleves.code_parente = liens_parente.code_parente (lien externe)
responsables_eleves.pers_contact : si valeur 1, c est une personne  contacter si c est 0 non.

*/

create table responsables_eleves(
 eleve_id int(11) not null,
 personne_id int(11) not null,
 resp_legal tinyint,
 code_parente char(1) not null,
 pers_contact tinyint,
 unique(eleve_id,personne_id)
 );

/* Table pour la mise  jour */

create table responsables_eleves_maj(
 eleve_id int(11) not null,
 personne_id int(11) not null,
 resp_legal tinyint,
 code_parente char(1) not null,
 pers_contact tinyint,
 unique(eleve_id,personne_id)
 );
 
/* Bloc Adresse */ 

/* Table contenant les adresses des responsables

Les colonnes ligne1_adresse  ligne4_adresse, code_postal et libelle_postal sont de type tinyblob car seront cryptes par AES_ENCRYPT (binaire)

Liaison avec les tables :
- responsables

*/

create table adresses_responsables(
 adresse_id int(11) primary key,
 ligne1_adresse tinyblob,
 ligne2_adresse tinyblob,
 ligne3_adresse tinyblob,
 ligne4_adresse tinyblob,
 code_postal tinyblob,
 libelle_postal tinyblob
 );

/* Table pour la mise  jour */

create table adresses_responsables_maj(
 adresse_id int(11) primary key,
 ligne1_adresse tinyblob,
 ligne2_adresse tinyblob,
 ligne3_adresse tinyblob,
 ligne4_adresse tinyblob,
 code_postal tinyblob,
 libelle_postal tinyblob
 );

/*** Tables utilise pour l import automatique des enseignants (sts_emp_rne_annee.xml dans c_imports.php) 
MAJ => c_imports.php ***/

/* Table contenant les libells des civilits

Liason avec les tables :
- personnel
- responsables

*/

create table civilites(
 code_civilite char(1) primary key,
 libelle_court varchar(10) not null,
 libelle_long varchar(40) not null
 );


/* Table contenant les membres du personnel de l tablissement

Les types d individus peuvent tre epp ou local
EPP : Emplois Postes Personnes (Ressources gres par une application acadmique), personnel enseignant du 2d degr,
 inspection,direction,ducation,orientation,surveillance.
local : ressources locales.
Les  EPP sont ADA=READAPTATION AED=ASSISTANT EDUCATION ALB=LABORATOIRE ASE=ASSISTANT ETRANGER
CTR=CHEF DE TRAVAUX DIR=DIRECTION DOC=DOCUMENTATION EDU=EDUCATION EEI=EDUCATEUR EN INTERNAT ENS=ENSEIGNEMENT
FIJ=FORMATION INSERTION JEUNES DEVANT ELEVES SUR=SURVEILLANCE

personnel.id_individu = numro d identification propre  STSWEB (pour les enseignants), null pour les autres membres du personnel
personnel.ip_pers = login.id_pers (lien externe)
personnel.activite = titre pour le personnel de direction, grade pour les enseignants, emploi ou activit pour les autres catgories de personnel 
personnel.categorie = categories_pers.id_cat (lien externe)
personnel.sous_categorie = si valeur numrique : sous_categories_pers.id_sous_cat (lien externe) si valeur alphanumrique : GRADE 
personnel.code_discipline = disciplines.code_discipline (lien externe)

*/

create table personnel(
 id_pers int(11) primary key,
 id_individu int(11) not null unique,
 type varchar(5) not null,
 nom char(20) not null,
 prenom char(15) not null,
 datenaiss date,
 activite char(35),
 categorie int(11),
 sous_categorie varchar(10),
 civilite char(5),
 code_discipline char(5) not null
 );

/* Table propre  IEW pour la mise  jour de la base du personnel 

Diffre de la table personnel par la colonne id_pers qui est primary key auto_increment

*/

create table personnel_maj(
 id_pers int(11) primary key auto_increment,
 id_individu int(11) not null unique,
 type varchar(5) not null,
 nom char(20) not null,
 prenom char(15) not null,
 datenaiss date,
 activite char(35),
 categorie int(11),
 sous_categorie varchar(10),
 civilite char(5),
 code_discipline char(5) not null
 );


/* La table suivante doit tre utile pour des calculs sur les emplois du temps, je la mets ici et elle sera renseigne
par l import mais IEW ne l utilise pas actuellement 

Liaison avec les tables :
- enseignants_services par la colonne taux_pond

*/

create table taux_ponderations(
 taux_pond float primary key,
 cpge_bts varchar(4)
 );

/*** Tables utilise pour l import automatique d autres information en provenance des logiciels d emploi du temps
 (logiciel du ministre ou logicile priv) (ex : EDT_vers_STS_rne_annee.xml dans c_imports.php) 
 MAJ => c_imports.php ***/

/* Bloc horaires */

/* Table contenant les horaires de l tablissement selon les jours de la semaine

Liaison avec les tables :
- cours

*/

create table horaires_edt(
 code_jour tinyint primary key,
 debut_cours char(4) not null,
 fin_cours char(4) not null
 );
 
/* Table contenant les horaires des pauses (rcrations, pause djeuner)

Ces donnes sont utilises lors de l affichage des EDT

*/

create table horaires_pauses(
 debut_recree_matin char(4),
 debut_pause_dej char(4),
 debut_recree_aprem char(4)
 );
 
insert into horaires_pauses values(NULL,"1200",NULL);

/* Bloc alternances */

/* Table contenant les alternances : les semaines, les trimestres => On en dduira les priodes de vacances

Liaison avec les tables :
- cours
- semaines_alternances

*/

create table alternances(
 code_alternance varchar(3) primary key,
 libelle_court varchar(10) not null,
 libelle_long varchar(40) not null
 );

/* Table contenant les dates de dbut des semaines selon les alternances

semaines_alternances.code_alternance = alternances.alternances (lien externe)

*/

create table semaines_alternances(
 code_alternance varchar(3) not null,
 date_debut_semaine date not null
 );

/* Bloc Individus */

/* Table contenant les professeurs principaux
Dans les tablissements en zone sensible, un prof peut tre prof principal de 2 divisions

profs_principaux.id_prof = personnel.personne_id (lien externe)
profs_principaux.code_structure = structures.code_structure (lien externe)

*/

create table profs_principaux(
  id_prof int(11) not null,
  code_structure char(8) not null unique,
  primary key(id_prof,code_structure)
 );

/*  Table contenant les matires tablissement : il peut n y avoir aucune donne selon les tablissements

Le concept de matires tablissement correspond au dcoupage d une matire nationale en sous-matires ou au
renommage d une matire avec un libell plus parlant pou l tablissement 
- Il peut n y avoir aucune matire tablissement
- Renommage d une matire : code_matiere_etab = code_matiere 
- Dcomposition d une matire en sous-matires : code_matiere_etab != code_matiere 

matieres_etablissement.code_matiere = matieres.code_matiere (lien externe)

Liaison avec les tables :
- cours

*/

create table matieres_etablissement(
 code_matiere_etab varchar(5) primary key,
 code_matiere char(6) not null,
 libelle_court varchar(20) not null,
 libelle_long varchar(40) not null
 );
 
/* Table contenant les salles de cours pour les emplois du temps notamment

Liaision avec les tables :
- cours

*/

create table salles_cours(
 code_salle varchar(5) primary key,
 groupe_salle varchar(5) not null,
 localisation varchar(2) not null
 );

/* Tables contenant les services d enseignement par structure et par matire

services.code_division = structures.code_structure (lien externe)
services.code_matiere = matieres.code_matiere (lien externe)
services.code_mod_cours = modalites_election.code_modalite_election (lien externe)
services.heure : horaire de la matire
services.co_ens : vaut true ou false (le plus souvent false). Si vaut true c est qu un deuxime (ou +) enseignant
assure ce service pour la mme structure, la mme matire, le mme horaire,

Liaison avec les tables :
- enseignants_services

*/

create table services(
 id_service int(11) primary key auto_increment,
 code_structure varchar(8) not null,
 code_matiere char(6) not null,
 code_mod_cours char(2) not null,
 heure float UNSIGNED not null,
 co_ens boolean,
 unique(code_structure,code_matiere,code_mod_cours,heure)
 );

/* Table contenant l association entre les services et les enseignants

enseignants_services.id_service = services.id_service (lien externe)
enseignants_services.type : epp ou local
enseignants_services.id_individu = personnel.id_individu
enseignants_services.heures_agent : nb d heures assure par l enseignant pour ce service
enseignants_services.taux_ponderation =  taux_ponderations.taux_pond (lien externe)

Liaison avec les tables :
- cours

*/
 
create table enseignants_services(
 id_enseignant_service int(11) primary key auto_increment,
 id_service int(11) not null,
 type varchar(5) not null,
 id_individu int(11) not null,
 heures_agent float UNSIGNED not null,
 taux_ponderation float,
 unique(id_service,id_individu)
 );
 
/* Table des cours

cours.id_enseignant_service = enseignants_services.id_enseignant_service (lien externe)
cours.code_alternance = alternances.code_alternance (lien externe)
cours.code_jour = jours.code_jour (lien externe)
cours.code_matiere = matieres.code_matiere_etab (lien externe)
cours.code_matiere_etab = matieres_etablissement.code_matiere_etab (lien externe)
cours.code_salle = salles_cours.code_salle (lien externe)

*/

create table cours(
 id_cours int(11) primary key auto_increment,
 id_enseignant_service int(11) not null,
 code_alternance varchar(3) not null,
 code_jour tinyint not null,
 heure_debut char(4) not null,
 duree char(4) not null,
 code_matiere char(6) not null,
 code_matiere_etab varchar(5),
 code_salle varchar(5),
 unique(id_enseignant_service,code_alternance,code_jour,heure_debut,duree,code_matiere)
 );
 
/***************************** DEUXIEME PARTIE  : Tables propres  IEW ******************************/

/* Table contenant les transactions d absences

liste_absents_transactions.id_pers = login.id_pers (lien externe)
En effet, les absences peuvent tre signales par des personnes qui ne sont pas intgres  la table du personnel comme admin par exemple

Liaison avec les tables :
- liste_absents

*/

create table liste_absents_transactions(
 id_transaction int(11) primary key auto_increment,
 date date not null,
 id_pers int(11) not null,
 debut char(5) not null,
 classe varchar(255) not null,
 unique(date,debut,classe)
 );

create table liste_absents_provisoires(
 id_pers int(11) not null,
 debut char(5) not null,
 classe varchar(255) not null,
 eleve_id int(11) not null,
 date date not null,
 primary key(id_pers,debut,classe,eleve_id,date)
 );

/* Table contenant la liste des absents par transaction 

liste_absents.id_transaction = liste_absents_transactions.id_transaction (lien externe)

*/

create table liste_absents(
 id_transaction int(11) not null,
 eleve_id int(11) not null,
 primary key(id_transaction,eleve_id)
 );


/* La table suivantes donne une indication sur la date d import des lves effectus  partir d un flux XML
en provenance de SCONET
Elle ne contient qu un seul enregistrement de donnes au format AAAAMMJJHHmmss
*/

create table majbddelev(
 maj timestamp
 );

/* Table contenant les notes de service */

create table notes(
date timestamp,
auteur char(45),
objet char(80),
destinataire char(20),
note text,
id_note int(11) primary key auto_increment,
unique (auteur,destinataire,objet)
);

/* Table contenant la liste des catgories de personnel 

Ces catgories ne correspondent pas  la nomenclature officielle du ministre
Il faudra peut-tre revenir sur ces donnes et leur structures si on peut avoir un document XML dcrivant
les catgories de personnel d un tablissement scolaire

IMPORTANT : NE PAS MODIFIER l id_cat DES ENREGISTREMENTS EXISTANTS CAR CES VALEURS FIXES SONT UTILISEES DANS CERTAINS SCRIPTS
MEME SI CERTAINS id_cat NE SE SUIVENT PAS (Certaines catgories ont t supprimes dans cette version car obsoltes 
mais les autres doivent conserver leur id_cat)

COP : Conseiller d Orientation Psychologue

categories_pers.id_groupe = groupes_utilisateurs.id_groupe (lien externe)

Liaision avec les tables :
- sous_categories_pers
- personnel

*/

create table categories_pers(
 id_cat int(11) primary key auto_increment,
 id_groupe int(11),
 categorie char(30));

insert into categories_pers values("1","7","Administratif");
insert into categories_pers values("2","7","Chef de travaux");
insert into categories_pers values("4","9","COP");
insert into categories_pers values("5","6","Direction");
insert into categories_pers values("6","7","Gestionnaire");
insert into categories_pers values("7","3","Enseignant");
insert into categories_pers values("8","8","Vie scolaire");
insert into categories_pers values("9","10","Mdico-Social");
insert into categories_pers values("10","7","Agent");
insert into categories_pers values("12","7","Contrat Aid");

/* Table contenant les sous_catgories de personnel 

Ces sous-catgories ne correspondent pas  la nomenclature officielle du ministre
Il faudra peut-tre revenir sur ces donnes et leur structures si on peut avoir un document XML dcrivant
les catgories de personnel d un tablissement scolaire

sous_categories_pers.id_cat = categories_pers.id_cat

Liaison avec les tables :
- personnel 

*/

create table sous_categories_pers(
  id_sous_cat int(11) primary key auto_increment,
  sous_categorie char(30) not null,
  id_cat int(11) not null,
  unique(id_cat,sous_categorie)
);

insert into sous_categories_pers values(NULL,"Secrtariat","1");
insert into sous_categories_pers values(NULL,"Secrtariat Intendance","1");
insert into sous_categories_pers values(NULL,"Principal","5");
insert into sous_categories_pers values(NULL,"Principal Adjoint","5");
insert into sous_categories_pers values(NULL,"Proviseur","5");
insert into sous_categories_pers values(NULL,"Proviseur Adjoint","5");
insert into sous_categories_pers values(NULL,"Directeur","5");
insert into sous_categories_pers values(NULL,"Adjoint d'Enseignement","7");
insert into sous_categories_pers values(NULL,"Agrg","7");
insert into sous_categories_pers values(NULL,"Assistant Etranger","7");
insert into sous_categories_pers values(NULL,"Certifi","7");
insert into sous_categories_pers values(NULL,"PEGC","7");
insert into sous_categories_pers values(NULL,"Intervenant Second Degr","7");
insert into sous_categories_pers values(NULL,"Matre auxilliaire","7");
insert into sous_categories_pers values(NULL,"PLP1","7");
insert into sous_categories_pers values(NULL,"PLP2","7");
insert into sous_categories_pers values(NULL,"Professeur Contractuel","7");
insert into sous_categories_pers values(NULL,"Professeur des Ecoles","7");
insert into sous_categories_pers values(NULL,"Vacataire","7");
insert into sous_categories_pers values(NULL,"Assistant(e) pdagogique","8");
insert into sous_categories_pers values(NULL,"Assistant(e) d'ducation","8");
insert into sous_categories_pers values(NULL,"Auxilliaire de Vie Scolaire","8");
insert into sous_categories_pers values(NULL,"CPE","8");
insert into sous_categories_pers values(NULL,"Surveillant","8");
insert into sous_categories_pers values(NULL,"Assistant(e) social(e)","9");
insert into sous_categories_pers values(NULL,"Infirmire","9");
insert into sous_categories_pers values(NULL,"Mdecin","9");
insert into sous_categories_pers values(NULL,"Technicien","10");
insert into sous_categories_pers values(NULL,"Ouvrier","10");
insert into sous_categories_pers values(NULL,"Service","10");


/* PROBLEME POUR LA TABLE SUIVANTE, FAUT-IL LA GARDER (id_matiere  modifier en char(4) lien avec table matiere) */

/* Table contenant des sous-matires UNIQUEMENT pour les cahiers de textes

Par exemple, une matire telle que Histoire-gographie peut sur un cahier de texte papier
prendre 3 onglets : histoire, gographie, Education civique

IEW permet ceci avec les donnes qui suivent

sous_matieres.code_matiere = matieres.code_matiere (lien externe)

Liaison avec les tables :
- cahiers_textes

*/

create table sous_matieres(
 id_sous_matiere int(11) primary key auto_increment,
 code_matiere char(6),
 sous_matiere varchar(20) not null,
 unique (sous_matiere)
 );

/* Le code 040600 est le code_matiere pour l histoire-gographie dans Nomenclature.xml (SCONET)
// Il est possible d ajouter des sous-matires pour d autres matires en ajoutant des lignes insert into
Les lignes d insertions suivantes sont mises en commentaires car en pratique, mes collgues d hist-geo
prfraient ne pas utiliser les sous-matires, mais la fonctionnalit est l pour peu qu on veuille activer les sous-matires,
il suffit juste de remplir la table 
*/

/* insert into sous_matieres values(NULL,"040600","Histoire")
insert into sous_matieres values(NULL,"040600","Gographie")
insert into sous_matieres values(NULL,"040600","Education civique")
*/

/* Table utilise pour dterminer le calendrier des semaines et les dates de vacances scolaires

Cette table peut-tre remplie par le script saisie_semab.php (saisie manuelle par formulaire)
ou par import du fichier xml d emploi du temps (voir plus haut)

 */

create table semab(
 date_rentree date,
 dbt_toussaint date,
 fin_toussaint date,
 dbt_noel date,
 fin_noel date,
 dbt_fev date,
 fin_fev date,
 dbt_paq date,
 fin_paq date,
 dbt_1t date,
 fin_1t date,
 p_1t date,
 dbt_2t date,
 fin_2t date,
 p_2t date,
 dbt_3t date,
 fin_3t date,
 p_3t date,
 dbt_ete date
 );
 
/* Table contenant les catgories de groupes */

create table categories_groupes(
 id_cat_grp int(11) primary key auto_increment,
 nom char(45) not null,
 description char(60) not null,
 unique(nom)
 );

/* Sont inscrit les catgories des groupes qu il faut crer manuellement
// car non disponibles dans structures.xml (ou dont les lves doivent tre choisis et changent en cours d anne) */

insert into categories_groupes values(NULL,"soutien","Soutien");
insert into categories_groupes values(NULL,"atp","Aide au Travail Personnel");
insert into categories_groupes values(NULL,"idd1","Itinraire De Dcouverte : Nature et corps humain");
insert into categories_groupes values(NULL,"idd2","Itinraire De Dcouverte : Langues et civilisations");
insert into categories_groupes values(NULL,"idd3","Itinraire De Dcouverte : Crations et techniques");
insert into categories_groupes values(NULL,"idd4","Itinraire De Dcouverte : Arts et humanits");
insert into categories_groupes values(NULL,"tpe","Travaux Personnels Encadrs");
insert into categories_groupes values(NULL,"tc","Travaux Croiss");


/* Table contenant le nom des groupes crs automatiquement (issus de structures.xml de STSWEB) et manuellement 

groupes.id_groupe : identifiant du groupe cr manuellement
groupes.nom : le nom du groupe de la forme nom_categorie_groupe-nom_responsable-liste des divisions
groupes.id_responsable = personnel.id_individu (lien externe)

Liaison avec les tables
- groupes_eleves

*/

create table groupes(
 id_groupe int(11) primary key auto_increment,
 nom varchar(255) not null,
 id_responsable int(11) not null,
 unique(nom)
 );

/* Table contenant la liste des lves inscrits dans les groupes crs manuellement

groupes_eleves.id_groupe = groupes.id_groupe (lien externe)
groupes_eleves.eleve_id = eleves.eleve_id (lien externe)
groupes_eleves.code_structure = structures.code_structure (lien externe)

Liaison avec les tables
- groupes

*/

create table groupes_eleves(
 id_groupe int(11) not null,
 eleve_id int(11) not null,
 code_structure varchar(8) not null,
 primary key(id_groupe,eleve_id)
 );

/* Table contenant les donnes d identification des utilisateurs (en authentification native) 

login.id_pers : identifiant propre  IEW (unique)
login.id_individu : identifiant numrique d un prof (vient de STS WEB), NULL si c est pas un prof
login.eleve_id : identifiant numrique d un lve (vient de SCONET), NULL si c est pas un lve
login.id_personne : identifiant numrique d un parent (vient de SCONET), NULL s c est pas un parent
login.auth_source : Contient la source d authentification de l utilisateur (CAS,LDAP,NATIVE)
login.id_gpe_utilisateurs = groupes_utilisateurs.id_groupe (lien externe)
login.mot_pass peut tre NULL (pour les utilisateurs authentifis par CAS, LDAP)
login.date_validite : Date de fin de validit du compte
login.etat : tat du compte, activ ou dsactiv
login.limit_date_passwd : Date limite d utilisation du mot de passe actuel peut tre NULL (cf mot_pass)

Le couple nomlogin, auth_source doit tre unique => Il peut donc y avoir des nomlogins identiques pourvu
que les auth_sources correspondants soient diffrents : ceci permet de mettre  jour les donnes
de la bonne personne lorsqu il y a eu une modification de donnes dans la base des utilisateurs LDAP ou NATIVE

Liaison avec les tables :
- eleves
- personnel
- responsables
- accept_charte
- ipr
- auth_foto
- demande_mdp
- journal_connexions

*/

create table login(
 id_pers int(11) primary key auto_increment,
 id_individu int(11),
 eleve_id int(11),
 id_personne int(11),
 nomlogin char(20),
 auth_source varchar(8) not null,
 id_gpe_utilisateurs int(11) not null,
 mot_pass tinytext,
 nom char(25) not null,
 prenom char(20) not null,
 date_validite date,
 etat int(1) not null,
 limit_date_passwd date
 );

insert into login values(NULL,NULL,NULL,NULL,"admin-iew","native","1",PASSWORD("admin"),"","",NULL,"1",NULL);

/* Table contenant la liste des groupes d utilisateurs IEW */

IMPORTANT : NE PAS MODIFIER l id_groupe DES ENREGISTREMENTS EXISTANTS CAR CES VALEURS FIXES SONT UTILISEES DANS CERTAINS SCRIPTS

/* groupes_utilisateurs.id_groupe : trs utilis pour la gestion des accs aux ressources */

create table groupes_utilisateurs(
  id_groupe int(11) primary key auto_increment,
  nom char(20) not null,
  unique(nom)
);

insert into groupes_utilisateurs values("1","admin"); 
insert into groupes_utilisateurs values("2","eleves");
insert into groupes_utilisateurs values("3","profs");
insert into groupes_utilisateurs values("4","parents");
insert into groupes_utilisateurs values("5","gestadmin"); 
insert into groupes_utilisateurs values("6","direction");
insert into groupes_utilisateurs values("7","autres_pers");
insert into groupes_utilisateurs values("8","Vie_scolaire");
insert into groupes_utilisateurs values("9","orientation");
insert into groupes_utilisateurs values("10","sante_social");
insert into groupes_utilisateurs values("11","ipr");
insert into groupes_utilisateurs values("12","exterieurs");

/* Table contenant la date d installation IEW */

create table installation(
  date_install date
  );

/* Table contenant la liste des utilisateur ayant accept la charte IEW 

accept_charte.id_pers = login.id_pers (lien externe)

*/

create table accept_charte(
  id_pers int(11) not null primary key
  );

/* admin a accept la charte d office : */

insert into accept_charte values("1");

/* Table contenant les entres de cahiers de textes 

cahiers_textes.code_structure = structures.code_structure (lien externe)
cahiers_textes.id_groupe = groupes.id_groupe (lien externe)
cahiers_textes.id_individu = personnel.id_pers (lien externe : ce n est pas personnel.id_individu)
cahiers_textes.code_matiere = matieres.code_matiere (lien externe)
cahiers_textes.id_sous_matiere = sous_matieres.id_sous_matiere (lien externe)

Liaison avec les tables :
- a_faire
- docs_joints_ctextes

*/

create table cahiers_textes(
 id_ctexte int(11) not null primary key auto_increment,
 date date not null,
 code_structure varchar(255) not null default "0",
 id_groupe int( 11 ) NOT NULL DEFAULT  "0",
 id_individu int(11) not null,
 code_matiere char(6) not null,
 id_sous_matiere int(11) not null,
 activite text not null,
 publication bool not null default "1",
 unique (date,code_structure,code_matiere,id_sous_matiere)
 );

/* Table contenant les travaux  faire pour le cours suivant

a_faire.id_ctexte = cahiers_textes.id_ctexte (lien externe)
a_faire.id_ctexte = docs_joints_ctextes.id_afaire (lien externe)

*/

create table a_faire(
 id_afaire int(11) not null primary key auto_increment,
 id_ctexte int(11) not null,
 afaire text not null,
 pourle date not null,
 publication bool not null default "1",
 unique(id_ctexte,afaire(100),pourle)
 );

/* Table contenant les noms de fichiers joints aux cahiers de textes

Ces fichiers sont tlchargeables

docs_joints_ctextes.id_ctexte = cahiers_textes.id_ctexte (lien externe)
docs_joints_ctextes.id_afaire = a_faire.id_afaire (lien externe)

*/

create table docs_joints_ctextes(
 id_doc int(11) not null primary key auto_increment,
 filename varchar(60) not null,
 commentaire tinytext,
 id_ctexte int(11) not null,
 id_afaire int(11) not null,
 publication bool not null default "1",
 md5 char(32) not null,
 unique(filename,id_ctexte,id_afaire)
 );

/* Table utilise pour les tlchargement des fichiers spciaux (comptes utilisateurs) */

create table telechargement (
 id int(11) not null primary key auto_increment,
 nom char(40) not null,
 chemin varchar(255),
 description text
 );

insert into telechargement values(NULL,"new_comptes_eleves.txt","","Fichier contenant les identifiants et mots de passe des comptes IntraEduweb des Elves arrivs en cours d'anne. Le mot de passe est chiffr.<br />Ce fichier peut tre utilis pour connatre les nouveaux lves auxquels vous devrez communiquer leurs identifiants et mots de passe en cours d'anne. Voir la documentation de l'administrateur IEW.");
insert into telechargement values(NULL,"new_comptes_personnel.txt","","Fichier contenant les identifiants et mots de passe des comptes IntraEduweb du personnel de l'tablissement arriv en cours d'anne. Le mot de passe est chiffr.<br />Ce fichier peut tre utilis pour connatre les nouveaux membres du personnel auxquels vous devrez communiquer leurs identifiants et mots de passe en cours d'anne. Voir la documentation de l'administrateur IEW.");
insert into telechargement values(NULL,"suppr_comptes_eleves.txt","","Fichier contenant les identifiants des comptes IntraEduweb Elves sortis de l'tablissement en cours d'anne scolaire<br />Ce fichier peut tre utilis pour la suppression des comptes des lves concerns sur le rseau pdagogique ds leur dpart de l'tablissement, pour le cas o vous auriez les mmes comptes sur IEW et votre rseau pdagogique.");
insert into telechargement values(NULL,"suppr_comptes_personnel.txt","","Fichier contenant les identifiants des comptes IntraEduweb des membres du personnel sortis de l'tablissement en cours d'anne scolaire<br />Ce fichier peut tre utilis pour la suppression des comptes des membres du personnel concerns sur le rseau pdagogique ds leur dpart de l'tablissement, pour le cas o vous auriez les mmes comptes sur IEW et votre rseau pdagogique.");

/* Table des coordonnateurs matires 

coordonnateurs.id_individu = personnel.id_individu (lien externe)
coordonnateurs.code_matiere = matieres.code_matiere

*/

create table coordonnateurs (
 id_coordonnateur int(11) not null primary key auto_increment,
 id_individu int(11) not null,
 code_matiere char(6) not null,
 unique(id_individu,code_matiere)
 );

/* Table contenant le numro de version IEW installe (dans la base de donne) */

create table version (
  version varchar(30)
 );

/* Table contenant les noms des IPR ayant un compte d accs temporaire 

ipr.id_pers = login.id_pers (lien externe)
ipr.code_discipline = disciplines.code_discipline (lien externe)

*/

create table ipr (
 id_pers int(11) not null primary key,
 nom char(25) not null,
 prenom char(20) not null,
 code_discipline char(5) not null,
 date_visite date not null,
 email char(60),
 liste_profs text,
 unique(nom,prenom)
 );

/* Table contenant les autorisations du responsable lgal concernant le droit d image, de cration d adresse email,
la publication de travaux sur le site web de l tablissement, les donnes personnelles dans IEW,
 la prise de photos d identit ou du groupe classe par une socit spcialise

Le chiffre  la fin du nom de la table correspond  l id du domaine d autorisation (table domaines_autorisations)
ici le 1 correspond  l id_domaine 1 soit TICE-Donnes Personnelles

autorisations_1.eleve_id = eleves.eleve_id (lien externe)

*/

create table autorisations_1 (
 eleve_id int(11) not null primary key,
 pub_intranet ENUM("0","1"),
 bal_externe ENUM("0","1"),
 pub_travaux_siteweb ENUM("0","1"),
 pub_fotoweb ENUM("0","1"),
 foto_video_pedago ENUM("0","1"),
 foto_cie_indiv ENUM("0","1"),
 foto_cie_classe ENUM("0","1")
);

/* Table contenant les domaines d autorisations du Reprsentant lgal demandes par l tablissement
Ces domaines sont personnalisables

Liaison avec les tables :
- autorisations_etab

*/

create table domaines_autorisations (
 id_domaine int(11) not null primary key auto_increment,
 titre text not null
);

insert into domaines_autorisations values(NULL,"TICE-Donnes Personnelles");

/* Table contenant la nature des autorisations du Reprsentant lgal demandes par l tablissement
Les donnes sont personnalisables dans IEW 

autorisations_etab.id_domaine = domaines_autorisations.id_domaine (lien externe)

*/

create table autorisations_etab (
 id_autorisation int(11) not null primary key auto_increment,
 nom_champ char(25) not null,
 libelle tinytext not null,
 detail text not null,
 id_domaine int(11) not null,
 ordre tinyint(1),
 unique(nom_champ)
);

/* le champ ordre permet de dterminer l ordre d affichage dans une page, et est modifiable par admin */

insert into autorisations_etab values(NULL,"pub_intranet","Publication de donnes personnelles dans IEW","<u>si l'application IEW est accessible depuis l'extrieur</u>, la publication de sa photographie d'identit et de certaines donnes pdagogiques ou administratives* qui le concernent, sur les pages de cette application, <strong>ces informations n'tant accessibles que par des personnes dment autorises</strong> (administration, vie scolaire, enseignants, assistante sociale, conseiller d'orientation, mdecin ou infirmire scolaire, parents concerns) <strong>et identifies par un mot de passe</strong>. Ces informations <strong>circulent sous forme crypte</strong> (comme lors de transactions bancaires sur le web).<br />La nature des informations publies est prcise dans la <a href='../../charte_droits.html'>Charte de l'utilisateur IntraEduWeb</a><br />*<i> l'exception du nom, prnom, date de naissance, sexe, status de redoublant ventuel, le rgime de sortie, les langues et options suivies qui sont des informations indispensables au fonctionnement de l'application IEW et qui  ce titre sont toujours publies (mais accessibles uniquement par les personnes dment autorises comme prcis plus haut)</i>","1","1");
insert into autorisations_etab values(NULL,"bal_externe","Cration d'une adresse email externe","La cration d'une bote aux lettres lectronique personnelle <u>externe</u> (le cas chant), <u>dans le cadre d'un projet pdagogique</u>, sur le site de La Poste qui a sign dans ce sens un accord avec le ministre de l'Education Nationale et qui prvoit notamment le respect de la neutralit commerciale de notre service public, ainsi que la conservation exclusive des informations  caractre personnel fournies lors de l'inscription de manire  se prmunir contre la diffusion de donnes  caractre publicitaire. L'utilisation de cette bote aux lettres ne se limite pas au seul cadre de l'tablissement, et l'lve pourra l'utiliser tout au long de sa vie mme lorsqu'il aura quitt le systme ducatif: c'est une des raisons pour lesquelles ce service gratuit est rendu par un organisme extrieur  l'Education Nationale. Cette bote aux lettres est accessible depuis l'internet.","1","2");
insert into autorisations_etab values(NULL,"pub_travaux_siteweb","Publication de travaux sur le site internet de l'tablissement","La publication <u>sur le site internet de l'tablissement</u> <strong>(accs tout public)</strong>, ventuellement, des travaux qu'il aura ralis dans le cadre de son travail scolaire. Seuls son prnom et la premire lettre de son nom apparatront sur le site. Les photos ventuelles le reprsentant sont soumises  mon autorisation pralable avant la publication sur ce site et dans le respect des dispositions lgales en vigueur.","1","3");
insert into autorisations_etab values(NULL,"pub_fotoweb","Publication de photo sur le site internet de l'tablissement","la publication ventuelle, sur le site internet de l'tablissement <strong>(accs tout public)</strong>, de photographies le reprsentant pour illustrer la publication d'articles pdagogiques ou d'albums photos faisant suite  des sorties pdagogiques,  des manifestations diverses de la vie de l'tablissement (march de Nol, comptitions sportives, reprsentations thtrales, chorale, etc...), ou issues d'activits faites en classe. Cette publication sera faite dans le respect de la <a href='http://www.educnet.education.fr/legamedia/fiches/droit-image.htm'>lgislation sur le droit d'image</a>","1","4");
insert into autorisations_etab values(NULL,"foto_video_pedago","Utilisation de l'image par un professeur dans un projet pdagogique (hors site web)","Qu'un professeur utilise l'image filme ou photographie de mon enfant <u>dans le cadre strictement limit d'une ralisation pdagogique au sein de l'tablissement scolaire, non commerciale</u>. Le choix de ce support pour les activits pgadogiques est prvu dans les programmes de certaines disciplines publis dans les bulletins officiels de l'Education Nationale. Dans le cas d'un refus du reprsentant lgal, l'lve sera amen  produire un autre travail.","1","5");
insert into autorisations_etab values(NULL,"foto_cie_indiv","Prise de photo individuelle par une socit spcialise","La prise de <u>photos individuelles</u> par un photographe spcialis, qui vient tous les ans dans notre tablissement (la date sera communique aux familles ultrieurement) pour photographier les lves et les personnels.","1","6");
insert into autorisations_etab values(NULL,"foto_cie_classe","Prise de photo de groupe par une socit spcialise","La prise de <u>photos avec sa classe</u> par le mme photographe","1","7");

/* Table regroupant les autorisations personnelles concernant la publication de photos d identit 

auth_foto.id_pers = personnel.id_pers (lien externe)

*/

create table auth_foto (
 id_pers int(11) not null,
 auth_eleves ENUM("0","1"),
 auth_parents ENUM("0","1"),
 auth_ipr ENUM("0","1"),
 auth_collegues ENUM("0","1"),
 unique(id_pers)
);

/* Table regroupant les demandes de mots de passe suite  la perte ou l oubli de l un d eux 

demande_mdp.id_pers = login.id_pers (lien externe)
demande_mdp.usercat = id_groupe.groupes_utilisateurs (lien externe)

*/

create table demande_mdp (
 id_pers int(11) not null,
 date date not null,
 usercat int(11) not null,
 nom varchar(25) not null,
 prenom varchar(25),
 date_satisfaction date,
 unique(id_pers,date)
);

/* Table permettant l enregistrement des tentatives de connexion choues avec un nom d utilisateur valide
Ceci permet, aprs traitement, de limiter  5, le nombre de tentatives de connexion par un utilisateur

echec_acces.nomlogin = login.nomlogin (lien externe)

*/

create table echec_acces (
 id int(11) not null primary key auto_increment,
 nomlogin char(20) not null unique,
 connect_failed_nb tinyint(1),
 heure int(11) not null
);

/* Table assurant l enregistrement du journal de connexion
Ceci permet de savoir le nombre d utilisateurs en ligne et de garder une trace des connexions

journal_connexions.id_pers = login.id_pers (lien externe)

*/

create table journal_connexions (
 id_connexion int(11) not null primary key auto_increment,
 id_pers int(11) not null,
 debut int(10) unsigned NOT NULL default "0",
 fin int(10) unsigned NOT NULL default "0",
 last_request int(10) unsigned NOT NULL default "0",
 ip varchar(39) not null,
 navigateur varchar(20) not null
);

/* Table assurant contenant les horaires
C est une table originelle : elle est conserve pour maintenir la compatibilit avec les anciens scripts
notamment pour le formulaire de saisie des absences (entres autres).
Cette table est alimente par le script 

*/

create table horaires(
  debut_matin char(5) not null,
  nb_matin tinyint(1)  not null,
  debut_aprem char(5) not null,
  nb_aprem char(5) not null,
  duree_cours tinyint(1) not null
  );

insert into horaires values("08h00","4","12h30","4","1");

/* Table contenant les matieres
C est une table originelle : elle est conserve pour maintenir la compatibilit avec les anciens scripts

Cette table est alimente par la table matieres_sconet et disciplines_bcn
*/

create table matieres(
 id_matiere int(11) primary key auto_increment,
 matiere varchar(60),
 id_discipline varchar(20) not null,
 unique(matiere)
 );

/* Table contenant les disciplines des postes enseignants
C est une table originelle : elle est conserve pour maintenir la compatibilit avec les anciens scripts

Cette table est alimente par la table disciplines_bcn

*/

create table disciplines(
 id_discipline int(11) primary key auto_increment,
 discipline varchar(60),
 unique(discipline)
 );

/* Table contenant les disciplines des postes enseignants
C est une table originelle : elle est conserve pour maintenir la compatibilit avec les anciens scripts

Cette table est alimente par la table structures

*/

create table divisions(
 id_div int(11) primary key auto_increment,
 division varchar(20) not null,
 unique(division)
 );
 
 /***************************** TROISIEME PARTIE ******************************/
 
 /* Table contenant les corps du personnel enseignant
C est une table ajoute afin de permettre de faire la liaison entre le grade de l enseignant et son corps d appartenance

Cette table est alimente  l installation par les donnes du fichier n_corps_profs_.csv obtenu
sur le site de la BCN (Base Centrale des Nomenclature du Ministre de l Education Nationale) par la mthode
dcrite dans le document IEW_todo.odt

Liaison avec les tables :
- grades_personnel

*/

create table corps_personnel(
 id_corps char(3) primary key,
 libelle_court varchar(10),
 libelle_long varchar(40),
 libelle_edition varchar(160)
 );
 
 /* Table contenant les grades du personnel
C est une table ajoute afin de permettre la slection du grade dans le formulaire
d ajout manuelle d un membre du personnel non import des logiciels de gestion comme
par exemple les professeurs doucmentalistes ou les professeurs remplaants

Cette table est alimente  l installation par les donnes du fichier n_grade_.csv obtenu
sur le site de la BCN (Base Centrale des Nomenclature du Ministre de l Education Nationale) par la mthode
dcrite dans le document IEW_todo.odt

Liaison avec les tables :
- corps_personnel

grades_personnel.id_corps = corps_personnel.id_corps (lien externe)

*/

create table grades_personnel(
 id_grade char(4) primary key,
 libelle_court varchar(10),
 libelle_long varchar(40),
 libelle_edition varchar(160),
 id_corps char(3)
 );
 
 /* Table contenant les associations entre des couples de couleurs avant-plan/arrire-plan et les matires
 utilise pour afficher les emplois du temps
 Elle est alimente lors du 1er appel  la consultation d un edt, par un choix alatoire de couleur parmi des
 couples compatibles avec les niveaux AA et AAA de contraste de luminosit prconiss par les WCAG 2.0 
 */
 
create table couleurs_edt_matieres(
 matiere varchar(20) primary key,
 avt_plan varchar(6),
 arr_plan varchar(6)
 );
 
 /* Table contenant la correspondance entre les identifiants individus des professeurs remplaants et des
 titulaires qu'ils remplacent. Les id_remplacant ou id_titulaire correspondent  l id_individu dans la table personnel
 */
 
create table remplacants(
 id_remplacant int(11) not null unique,
 id_titulaire int(11) not null unique
 );

 /* Table contenant les cours ajouts, supprims ou modifis par rapport  la table cours (obtenue par importation des donnes de EDT_vers_STS_RNE_annee.xml)
 Cette table est alimente manuellement par formulaire. Elle est utile pour pouvoir effectuer des corrections d'EDT lorsqu'il n'est pas possible
 de modifier EDT_vers_STS_RNE_annee.xml ou bien lorsqu'il s'agit de modifier un EDT de faon trs ponctuelle (dplacement d'un cours, remplacement d'un cours
 par un autre en cas d'absence d'un professeur,...)
 
 L'AUTO_INCREMENT (id_cours_diff) de cette table commence  10000 pour permettre la distinction avec les id_cours de la table cours (qui seront dans
 tous les cas infrieurs  10000)
 
 */
 
create table cours_diff(
 id_cours_diff int(11) primary key auto_increment,
 type_diff char(3) not null,
 id_cours int(11) not null,
 id_individu int(11) not null,
 code_structure varchar(8) not null,
 structure_complete BOOL NOT NULL DEFAULT '1',
 code_alternance varchar(3),
 date date,
 code_jour tinyint not null,
 heure_debut char(4) not null,
 duree char(4) not null,
 code_matiere char(6) not null,
 code_matiere_etab varchar(5),
 code_salle varchar(5),
 unique(type_diff,id_cours,id_individu,code_alternance,code_jour,heure_debut,duree,code_matiere)
 )
 AUTO_INCREMENT = 10000;
 
 /* Table contenant les visas de cahiers de textes apposs par la direction ou les IPR
 
 */
 
create table visas_ct(
 id_visa int(11) primary key auto_increment,
 type char(3) not null,
 id_pers int(11) not null,
 date datetime not null,
 id_prof int(11) not null,
 code_structure varchar(8) not null default "0",
 id_enseignant_service int(11) not null default "0",
 id_groupe int(11) not null,
 last_id_ctexte int(11) not null,
 activation bool not null,
 unique(type,id_prof,code_structure,id_enseignant_service,id_groupe,last_id_ctexte)
);