<?php
/**
 * somgestadmin.php
 *
 * contient le libell des rubriques, sous-rubriques (avec leur liens)
 * du sommaire spcifique aux utilisateurs chargs de la gestion administrative
 * du contenu de l'intraeduweb (souvent le secrtariat)
 * 
 * Ce fichier fait partie du projet IntraEduWeb (IEW)
 * 
 * @package		IEW
 * @author			Sylvain GODM <sylvain.godme@gmail.com>
 * @version		$LastChangedRevision$, $LastChangedDate$
 * @copyright		2004-2012 Sylvain GODM
 * @link			http://iew.free.fr
 * @license		GPL License version 3 (http://www.gnu.org/licenses/gpl.html)
 * @filesource
 * 
 */

// Dans le tableau suivant, pour chaque rubrique, on associe les sous-rubriques et leurs liens
// Si le lien doit ouvrir un pop-up ou un nouvel onglet, sa structure doit tre la suivante :
// $lien = "javascript://chemin_vers_la_cible_du_lien\" title=\"titre_du_lien (nouvelle fentre ou nouvel onglet)\"// onclick='code_du_onclick'" (attribut title obligatoire)
// Ceci permet de passer la validation XHTML (car target='_blank' pas valide)

// Le sommaire dpend si l'anne scolaire est celle en cours ou dans les archives
if (isset($_SESSION['anscol']) && isset($_SESSION['anscol']) !="") // Si on est dans les archives
  $rubriques_somgestadmin = array(
  "Archives" => array("Sortir des archives" => "prive/admin/prive/exit_archives.php\" title=\"Sortir de l'archive de cette anne scolaire et revenir  l'anne scolaire en cours\"","Choisir une autre anne" => "prive/admin/prive/exit_archives.php?autre_archive=y\" title='Consulter les archives des autres annes scolaires'"),
  "Calendrier" => array("Semaines" => "semab.php\" title=\"Voir le calendrier d'alternance des semaines\"","Priodes" => "pernot.php\" title='Voir les dates de dbut/fin de trimestre'"),
  "Emplois du temps" => array("Classes" => "prive/edt.php?categorie=classes\" title='Voir les emplois du temps des classes'","Salles" => "prive/edt.php?categorie=salles\" title='Voir les emplois du temps des salles'","Professeurs" => "prive/edt.php?categorie=professeurs\" title='Voir les emplois du temps des Professeurs'"),
  "notes d'information" => array("Consultation" => "consult_not.php?critere=lves\" title=\"Consulter les notes d'information\""),
  "Le Personnel" => array("Gestion gnrale" => "prive/admin/prive/bdd_pers.php\" title=\"Consulter/Modifier/Ajouter une fiche administrative d'un membre du Personnel\"","Administratif" => "admin/pers_admin.php\" title='Voir le trombinoscope du personnel administratif'","Vie scolaire" => "admin/pers_viscol.php\" title='Voir le trombinoscope du personnel de Vie scolaire'","Enseignant" => "admin/pers_prof.php\" title='Voir le trombinoscope du personnel enseignant'","Equipes pdagogiques" => "prive/eqpedag.php\" title='Voir la liste ou le trombinoscope des quipes pdagogiques'","Profs principaux" => "admin/pp.php\" title='Voir la liste des Professeurs Principaux'","Coordonnateurs" => "prive/coordonnateurs.php\" title='Voir la liste des Professeurs Coordonnateurs Matires'","Autres personnels" => "admin/pers_autre.php\" title='Voir le trombinoscope des autres personnels'"),
  "Elves" => array("Consulter la base" => "prive/bddelev.php\" title=\"Rechercher un lve ou une liste d'lves\"","Trombinoscope" => "prive/admin/trombinelev.php\" title='Voir le trombinoscope des lves'",
  "Autorisations"=>"prive/admin/autorisations.php\" title='Voir les autorisations parentales'"),
  "Conseils d'administration" => array("Composition" => "\" title=\"Voir la composition du Conseil d'Administration\"","Comptes-rendus" => "\" title=\"Consulter les comptes-rendus du Conseil d'administration\"")
  );
else // Cas ordinaire de l'anne scolaire en cours
  $rubriques_somgestadmin = array(
  "Calendrier" => array("Semaines" => "semab.php\" title=\"Voir le calendrier d'alternance des semaines\"","Priodes" => "pernot.php\" title='Voir les dates de dbut/fin de trimestre'"),
  "Emplois du temps" => array("Classes" => "prive/edt.php?categorie=classes\" title='Voir les emplois du temps des classes'","Salles" => "prive/edt.php?categorie=salles\" title='Voir les emplois du temps des salles'","Professeurs" => "prive/edt.php?categorie=professeurs\" title='Voir les emplois du temps des Professeurs'","Rservations" => "javascript://".$GLOBALS['url_grr']."\" title='Voir les Rservations de salles ou de matriel (nouvelle fentre ou nouvel onglet)'// onclick='window.open(this.href); return false;'","horaires des pauses" => "prive/admin/prive/get_time_pauses_edt.php\" title='Grer les horaires de pause pour les emplois du temps'"),
  "notes d'information" => array("Consultation" => "consult_not.php?critere=lves\" title=\"Consulter les notes d'information\"","Saisie" => "prive/saisie_notes.php\" title=\"Sasisir une note d'information\""),
  "Le Personnel" => array("Gestion gnrale" => "prive/admin/prive/bdd_pers.php\" title=\"Consulter/Modifier/Ajouter une fiche administrative d'un membre du Personnel\"","Administratif" => "admin/pers_admin.php\" title='Voir le trombinoscope du personnel administratif'","Vie scolaire" => "admin/pers_viscol.php\" title='Voir le trombinoscope du personnel de Vie scolaire'","Enseignant" => "admin/pers_prof.php\" title='Voir le trombinoscope du personnel enseignant'","Remplaants" => "prive/admin/prive/remplacants.php\" title='Grer les remplacements de professeurs'","Equipes pdagogiques" => "prive/eqpedag.php\" title='Voir la liste ou le trombinoscope des quipes pdagogiques'","Profs principaux" => "admin/pp.php\" title='Voir la liste des Professeurs Principaux'","Coordonnateurs" => "prive/coordonnateurs.php\" title='Voir la liste des Professeurs Coordonnateurs Matires'","Autres personnels" => "admin/pers_autre.php\" title='Voir le trombinoscope des autres personnels'"),
  "Elves" => array("Mise  jour de la base" => "prive/admin/prive/imports.php?type=elev\" title=\"Mettre  jour les donnes lves et responsables  partir de SCONET (nouvelle fentre ou nouvel onglet)\"","Consulter la base" => "prive/bddelev.php\" title=\"Rechercher un lve ou une liste d'lves\"","Trombinoscope" => "prive/admin/trombinelev.php\" title='Voir le trombinoscope des lves'",
  "Autorisations"=>"prive/admin/autorisations.php\" title='Voir les autorisations parentales'","Notation" => "javascript://".$GLOBALS['url_notation']."\" title='Consulter/Modifier les notes des lves  (nouvelle fentre ou nouvel onglet)'// onclick='window.open(this.href); return false;'"),
  "Accs temporaires" => array("IPR" => "prive/admin/prive/compte_ipr.php\" title=\"Crer un compte temporaire pour un IPR en visite dans l'tablissement\""),
  "Conseils d'administration" => array("Composition" => "\" title=\"Voir la composition du Conseil d'Administration\"","Comptes-rendus" => "\" title=\"Consulter les comptes-rendus du Conseil d'administration\""),
  "Archives" => array("Clture anne scolaire" => "prive/admin/prive/cloture_anscol.php\" title=\"Procder  la clture de l'anne scolaire en cours\"","Annes antrieures" => "prive/admin/prive/archives.php\" title='Consulter les archives des annes scolaires prcdentes'")
  );
?>