<?php
/**
 * sommaire.php
 *
 * contient le libell des rubriques, sous-rubriques (avec leur liens) du sommaire par dfaut
 * 
 * Ce fichier fait partie du projet IntraEduWeb (IEW)
 * 
 * @package		IEW
 * @author			Sylvain GODM <sylvain.godme@gmail.com>
 * @version		$LastChangedRevision$, $LastChangedDate$
 * @copyright		2004-2012 Sylvain GODM
 * @link			http://iew.free.fr
 * @license		GPL License version 3 (http://www.gnu.org/licenses/gpl.html)
 * @filesource
 * 
 */

// Dans le tableau suivant, pour chaque rubrique, on associe les sous-rubriques et leurs liens
// Si le lien doit ouvrir un pop-up ou un nouvel onglet, sa structure doit tre la suivante :
// $lien = "javascript://chemin_vers_la_cible_du_lien\" title=\"titre_du_lien (nouvelle fentre ou nouvel onglet)\"// onclick='code_du_onclick'" (attribut title obligatoire)
// Ceci permet de passer la validation XHTML (car target='_blank' pas valide)

if (isset($_SESSION['valid_group']) && $_SESSION['valid_group'] != '2' && $_SESSION['valid_group'] != '4')
{
  // Rubriques pour tout membre de l'etablissement (sens large) sauf lves et parents
  // + rubrique coordonnateurs 
  $rubriques_sommaire = array(
  "Calendrier" => array("Semaines" => "semab.php\" title=\"Voir le calendrier d'alternance des semaines\"","Priodes" => "pernot.php\" title='Voir les dates de dbut/fin de trimestre'"),
  "Emplois du temps" => array("Classes" => "prive/edt.php?categorie=classes\" title='Voir les emplois du temps des classes'","Salles" => "prive/edt.php?categorie=salles\" title='Voir les emplois du temps des salles'","Professeurs" => "prive/edt.php?categorie=professeurs\" title='Voir les emplois du temps des Professeurs'","Rservations" => "javascript://".$GLOBALS['url_grr']."\" title='Voir les Rservations de salles ou de matriel (nouvelle fentre ou nouvel onglet)'// onclick='window.open(this.href); return false;'"),
  "notes d'information" => array("Consultation" => "consult_not.php?critere=lves\" title=\"Consulter les notes d'information\"","Saisie" => "prive/saisie_notes.php\" title=\"Saisir une note d'information\""),
  "Le Personnel" => array("Liste complte" => "admin/liste_pers.php\" title='Voir la liste complte du personnel'", "Administratif" => "admin/pers_admin.php\" title='Voir le trombinoscope du personnel administratif'","Vie scolaire" => "admin/pers_viscol.php\" title='Voir le trombinoscope du personnel de Vie scolaire'","Enseignant" => "admin/pers_prof.php\" title='Voir le trombinoscope du personnel enseignant'","Equipes pdagogiques" => "prive/eqpedag.php\" title='Voir la liste ou le trombinoscope des quipes pdagogiques'","Profs principaux" => "admin/pp.php\" title='Voir la liste des Professeurs Principaux'","Coordonnateurs" => "prive/coordonnateurs.php\" title='Voir la liste des Professeurs Coordonnateurs Matires'","Autres personnels" => "admin/pers_autre.php\" title='Voir le trombinoscope des autres personnels'")
  );
}
elseif (isset($_SESSION['valid_group'])) // cas des parents et des lves
  $rubriques_sommaire = array(
  "Calendrier" => array("Semaines" => "semab.php\" title=\"Voir le calendrier d'alternance des semaines\"","Priodes" => "pernot.php\" title='Voir les dates de dbut/fin de trimestre'"),
  "Emplois du temps" => array("Classes" => "prive/edt.php?categorie=classes\" title='Voir les emplois du temps des classes'"),
  "notes d'information" => array("Consultation" => "consult_not.php\" title=\"Consulter les notes d'information\""),
  "Le Personnel" => array("Liste complte" => "admin/liste_pers.php\" title='Voir la liste complte du personnel'", "Administratif" => "admin/pers_admin.php\" title='Voir le trombinoscope du personnel administratif'","Vie scolaire" => "admin/pers_viscol.php\" title='Voir le trombinoscope du personnel de Vie scolaire'","Enseignant" => "admin/pers_prof.php\" title='Voir le trombinoscope du personnel enseignant'","Equipes pdagogiques" => "prive/eqpedag.php\" title='Voir la liste ou le trombinoscope des quipes pdagogiques'","Profs principaux" => "admin/pp.php\" title='Voir la liste des Professeurs Principaux'","Autres personnels" => "admin/pers_autre.php\" title='Voir le trombinoscope des autres personnels'")
  );
else // sommaire pour utilisateur non identifi
  $rubriques_sommaire = array(
  "Calendrier" => array("Semaines" => "semab.php\" title=\"Voir le calendrier d'alternance des semaines\"","Priodes" => "pernot.php\" title='Voir les dates de dbut/fin de trimestre'"),
  "Le Personnel" => array("Liste complte" => "admin/liste_pers.php\" title='Voir la liste complte du personnel'")
  );
if (isset($_SESSION['valid_group']) && ($_SESSION['valid_group'] == '3' || $_SESSION['valid_group'] == '6' || $_SESSION['valid_group'] == '8' || $_SESSION['valid_group'] == '9' || $_SESSION['valid_group'] == '10'))
{
  // Le sommaire gnral se complte avec un accs  la consultation de la base lves pour les groupes profs, direction, surveillance, orientation et sante_social
  $sommaire_complementaire = array(
  "Elves" => array("Consulter la base" => "prive/bddelev.php\" title=\"Rechercher un lve ou une liste d'lves\"","Trombinoscope"=> "prive/admin/trombinelev.php\" title='Voir le trombinoscope des lves'",
  "Autorisations"=>"prive/admin/autorisations.php\" title='Voir les autorisations parentales'","Notation" => "javascript://".$GLOBALS['url_notation']."\" title='Consulter/Modifier les notes des lves (nouvelle fentre ou nouvel onglet)'// onclick='window.open(this.href); return false;'")
  );
  // on chaine avec le sommaire gnral :
  $rubriques_sommaire = array_merge($rubriques_sommaire,$sommaire_complementaire);
  // On donne accs aux archives aux profs
  if (isset($_SESSION['valid_group']) && ($_SESSION['valid_group'] == '3'))
  {
  	$sommaire_complementaire_suppl = array(
  	"Archives" => array("Consulter les archives" => "prive/admin/prive/archives.php\" title='Consulter les archives des annes scolaires prcdentes'")
  	);
  	// S'ils sont dj dans les archives, on leur donne la possibilit d'en sortir
  	if (isset($_SESSION['anscol']) && isset($_SESSION['anscol']) !="") // Si on est dans les archives
  	{	
  		$sommaire_complementaire_suppl = array(
  		"Archives" => array("Consulter les archives" => "prive/admin/prive/archives.php\" title='Consulter les archives des annes scolaires prcdentes'", "Sortir des archives" => "prive/admin/prive/exit_archives.php\" title=\"Sortir de l'archive de cette anne scolaire et revenir  l'anne scolaire en cours\"")
  		);
  	}
  	$rubriques_sommaire = array_merge($rubriques_sommaire,$sommaire_complementaire_suppl);
  }
}
?>