<?php
/**
 * c_abs_affichage.php
 *
 * Ce script permet de diversifier l'affichage des absences, en incluant le rsultat d une
 * recherche des absences concernant un lve, l'affichage des absences du jour par tranche
 * horaire, et les absences du jour concernant les demi-pensionnaires. L'appel de ce script
 * est fait avec passage d un paramtre 'critere' dont la valeur dtermine l'action du script
 * 
 * Ce fichier fait partie du projet IntraEduWeb (IEW)
 * 
 * @package		IEW
 * @author			Sylvain GODM <sylvain.godme@gmail.com>
 * @version		$LastChangedRevision$, $LastChangedDate$
 * @copyright		2004-2012 Sylvain GODM
 * @link			http://iew.free.fr
 * @license		GPL License version 3 (http://www.gnu.org/licenses/gpl.html)
 * @filesource
 * 
 */

/* Dclaration des fonctions */

function choix_affichage($critere){

//***************************** description ********************************//
 // Cette fonction affiche les liens de bas de page en fonction du choix du
 // type d affichage demand par l utilisateur
 // paramtres entrs	$critere	:	contient le choix actuel d affichage
 // sortie : affichage HTML des liens adquats
 // auteur : S.GODM (sylvain.godme@gmail.com)
 // Date de cration : ?
 // Date de dernire mise  jour : 
 //***************************** Fin description *****************************//

?><br />
<table width="100%">
<tr>
<td width="50%" align="center"><font color="red"><u><b>Absences du jour</b></u></font></td>
<td width="50%" align="center"><font color="red"><u><b>Recherche</b></u></font></td>
</tr>
<tr>
<td width="50%">
  <?php
  switch ($critere){
   case 'th':
    echo "<a href=\"bddabsences.php\">Affichage par classe (normal)</a><br />
    <a href=\"abs_affichage.php?critere=dp\">Absences des demi-pensionnaires</a>";
    break;
   case 'dp':
    echo "<a href=\"abs_affichage.php?critere=th\">Affichage par tranche horaire</a><br />
    <a href=\"bddabsences.php\">Affichage par classe (normal)</a>";
    break;
   default:
    echo "<a href=\"abs_affichage.php?critere=th\">Affichage par tranche horaire</a><br />
    <a href=\"abs_affichage.php?critere=dp\">Demi-pensionnaires</a>";
  }
  ?>
  </td>
<td width="50%" align="right"><label for="Form_Eleve_Nom">Entrer le nom d'un lve :</label>
  <form method="post" action="recherche_absent.php">
    <p><input id="Form_Eleve_Nom" type="text" name="eleve" size="15" /><input type="submit" value="Rechercher" name="soumettre" /></p>
  </form>
</td>
</tr>
</table>
<?php
}

/* Dbut du programme principal */

// Le script en cours doit tre le script d'appel prvu
if (end_with_string($_SERVER['PHP_SELF'],"prive/abs_affichage.php"))
{
   
  // on tablit une fois pour toutes la connexion avec la base de donne
  connexion_mysql();
  select_database();
  
  $test_date_ouvrable = date("Y-m-d"); // c'est la date du jour (au format MySQL) qui est teste
  // test si la date est un jour ouvrable de l'tablissement ou non
  if (!test_jour_ouvrable(date_mysql_to_jjmmaaaa($test_date_ouvrable)) || !test_jour_dans_periode_scolaire($test_date_ouvrable))
      {
        $error_message = array("Le ".format_date_long($GLOBALS['default_language'],date_mysql_to_jjmmaaaa($test_date_ouvrable))." n'est pas un jour ouvrable dans l'tablissement ou tombe pendant les vacances scolaires !","");
        affiche_erreurs($error_message);
        return; // le script est alors interrompu
      }
      
  switch ($_GET['critere'])
  { // suivant la valeur du paramtre pass au script

    case 'th': // cas de l affichage par tranche horaire des absences du jour
      echo "<br /><h1>Absences du jour par tranche horaire</h1>";
      echo "Voici, en temps rel, la liste des absents du jour <b><u>par tranche horaire</u></b> transmises par les professeurs ou surveillants. Si vous restez sur cette page un certain temps il est conseill de cliquer sur le bouton <b>Actualiser</b> du navigateur pour rafrachir les informations de temps en temps.<br />Pour un autre type d'affichage,<a href='#baspage'> voir en bas de cette page</a>.<br /><br />";

      if (is_edt_import())
  	  {
  	  	$debut_plage_horaire = array();
  		$plage_horaire_provisoire = horaires_print(recup_horaires_debut_cours()); // Ce tableau commence  l'indice 1
	  	// Mais pour la suite (bon fonctionnement de l'affichage du cahier d'appel), on a besoin qu'il commence  l'indice 0
  		foreach ($plage_horaire_provisoire as $value)
  		{
  			$debut_plage_horaire[] = $value;
  		}
	  	// On a donc maintenant un tableau $debut_plage_horaire dont l'indice de dpart est bien 0
  	 }
  	 else
	 	$debut_plage_horaire = horaires();
	 	
      foreach ($debut_plage_horaire as $value)
      {
	      echo "<table width=\"100%\"><tr><th bgcolor=\"#FFCC99\" align=\"center\"><h2 class='hidden'>".$value."</h2><font color=\"brown\">".$value."</font></th></tr></table>";
	      $sql = "SELECT DISTINCT t3.nom,t3.prenom,t3.classe FROM liste_absents as t1,liste_absents_transactions as t2, eleves as t3 WHERE t2.date=CURRENT_DATE() AND t2.debut='".quote_smart($value)."' AND t1.id_transaction=t2.id_transaction AND t3.eleve_id=t1.eleve_id ORDER BY t3.nom,t3.prenom";
 	      // DEBUGG echo $sql."<br />";
	      $resultat = mysql_query($sql);
        if (mysql_num_rows($resultat)) // s il y a des absents
        {
          echo "<table class='ctextes edt' width='100%'>";
          echo "<tr bgcolor=\"#FFFF00\"><th align=\"center\">Noms des lves</th><th align=\"center\">Classe</th></tr>";
          while ($ligne = mysql_fetch_array($resultat))
          {
            $eleve = $ligne['nom']. " ". $ligne['prenom'];
            echo "<tr><td>".$eleve."</td><td align=\"center\">".$ligne['classe']."</td></tr>";
          }
          echo "</table>";
          echo "<table width=\"100%\"><tr><td width=\"50%\"><a href=\"#bas\"> Bas de la page</a></td><td width=\"50%\" align=\"right\"><a href=\"#haut\"> Haut de la page</a></td></tr></table><br />";
        }
        else // s il n ya pas d absents
        {
          echo "
          <table width=\"100%\"><tr><td align=\"center\"><b><font color=\"red\">PAS D'ABSENT</font></b></td></tr></table>";
        }
      }  // foreach
      echo "<a name='baspage'></a>";
      choix_affichage("th");
	break;

    case 'dp': // cas de l affichage des absences du jour concernant les demi-pensionnaires
      echo "<br /><h1>Absences des demi-pensionnaires et des internes</h1>";
      echo "Voici, en temps rel, la liste des <b><u>demi-pensionnaires</u></b> absents du jour transmises par les professeurs ou surveillants. Si vous restez sur cette page un certain temps il est conseill de cliquer sur le bouton <b>Actualiser</b> du navigateur pour rafrachir les informations de temps en temps.<br />Pour un autre type d'affichage,<a href='#baspage'> voir en bas de cette page</a>.<br /><br />";
      
      if (is_edt_import())
  	  {
  	  	$debut_plage_horaire = array();
  		$plage_horaire_provisoire = horaires_print(recup_horaires_debut_cours()); // Ce tableau commence  l'indice 1
	  	// Mais pour la suite (bon fonctionnement de l'affichage du cahier d'appel), on a besoin qu'il commence  l'indice 0
  		foreach ($plage_horaire_provisoire as $value)
  		{
  			$debut_plage_horaire[] = $value;
  		}
	  	// On a donc maintenant un tableau $debut_plage_horaire dont l'indice de dpart est bien 0
  	 }
  	 else
	 	$debut_plage_horaire = horaires();
	 	
      foreach ($debut_plage_horaire as $value)
      {
	      echo "<table width=\"100%\"><tr><th bgcolor=\"#FFCC99\" align=\"center\"><h2 class='hidden'>".$value."</h2><font color=\"brown\">".$value."</font></th></tr></table>";
	      $sql = "SELECT DISTINCT t3.nom,t3.prenom,t3.classe,t3.eleve_id FROM liste_absents as t1,liste_absents_transactions as t2, eleves as t3 WHERE t2.date=CURRENT_DATE() AND t2.debut='".quote_smart($value)."' AND t1.id_transaction=t2.id_transaction AND t3.eleve_id=t1.eleve_id ORDER BY t3.nom,t3.prenom";
 	      $resultat = mysql_query($sql);
 	      if (mysql_num_rows($resultat)) // s il y a des absents
        {
          echo "<table class='ctextes edt' width='100%'>";
          echo "<tr bgcolor=\"#FFFF00\"><th align=\"center\">Noms des lves</th><th align=\"center\">Classe</th></tr>";
          // rechercher si ce sont des DP
          while ($ligne = mysql_fetch_array($resultat))
          {
            $eleve_id = $ligne['eleve_id']; 
            $sql = "SELECT regimes.libelle_court FROM eleves, regimes WHERE eleve_id='$eleve_id' AND eleves.code_regime=regimes.code_regime";
            // DEBUGG echo $sql."<br />";
            $result = mysql_query($sql);
            $row = mysql_fetch_array($result); // une seule ligne est trouve
            if (substr($row['libelle_court'],0,2)=="DP" || substr($row['libelle_court'],0,2)=="IN"): // si l lve est DP ou interne
              echo "<tr><td>".$ligne['nom']." ".$ligne['prenom']."</td><td align=\"center\">".$ligne['classe']."</td></tr>";
            endif;
          }
          echo "</table>";
          echo "<table width=\"100%\"><tr><td width=\"50%\"><a href=\"#bas\"> Bas de la page</a></td><td width=\"50%\" align=\"right\"><a href=\"#haut\"> Haut de la page</a></td></tr></table><br />";
        }
        else // s il n ya pas d absents
        {
          echo "
          <table width=\"100%\"><tr><td align=\"center\"><b><font color=\"red\">PAS D'ABSENT</font></b></td></tr></table>";
        }
      }  // foreach
      echo "<a name='baspage'></a>";
      choix_affichage("dp");
	break;
  }
  // on affiche le formulaire de gestion administrative de ces pages
  echo "<br /><br /><br /><center>";
  $code_formulaire = "<br />Cet accs est strictement rserv aux personnes charges de la gestion des absences.<br /><br /><a href='".$GLOBALS['chemin_relatif']."/prive/admin/prive/cahier_appel.php'>Consultation du cahier d'appel pour d'autres dates</a><br /><br />";
  squelette_formulaire_standard("75%","","","Rserv  la Vie Scolaire",$code_formulaire,"","","","","","","");
  echo "</center>";
}
else // L'utilisateur essaie d'invoquer ce script directement dans l'URL (interdit)
{
  $error_message = array("Vous tentez d'accder  un script qui n'est pas accessible directement  partir de l'URL... Utilisez les liens de navigation !","");
  affiche_erreurs($error_message);
}
?>