<?php
/**
 * c_absences.php
 *
 * affichage des formulaires de saisie des absences et traitement du formulaire
 * La liste des absents s crit au fur et  mesure dans une table mysql (liste_absents_provisoires).
 * Aprs validation par le bouton <Envoyer>, la transaction effectue par le prof
 * s'incrit dans la table liste_absents_transactions et les absents dans la table liste_absents
 * (ces deux tables sont jointes par le champ id_transaction)
 * 
 * Ce fichier fait partie du projet IntraEduWeb (IEW)
 * 
 * @package		IEW
 * @author			Sylvain GODM <sylvain.godme@gmail.com>
 * @version		$LastChangedRevision$, $LastChangedDate$
 * @copyright		2004-2012 Sylvain GODM
 * @link			http://iew.free.fr
 * @license		GPL License version 3 (http://www.gnu.org/licenses/gpl.html)
 * @filesource
 * 
 */

if(!defined('IEW_DIR')) define('IEW_DIR',realpath(dirname(__FILE__)."/../../").'/');
// Inclusions
require_once(IEW_DIR."librairie_fonctions.php");

/* Dclaration des fonctions */

function affiche_form_infos_plage_horaire($prof,$debut,$classe,$date)
{
	//***************************** description ********************************//
	// cette fonction assure l affichage du formulaire de saisie des absences lorsque l utilisateur
	// invoque le script
	// paramtres entrs $prof:nom du prof ou identifiant
	// $debut: dbut de la plage horaire (les plages sont de dure une heure)
	// $classe: contient le nom de la classe slectionne dans le formulaire
	// sortie : les mmes paramtres sont ressortis avec en plus $ok qui est une variable dfinie si
	// l' utilisateur a cliqu sur le bouton <Afficher la liste des lves de la classe>
	// auteur : S.GODM (sylvain.godme@gmail.com)
	// Date de cration : ?
	// Date de dernire mise  jour : 20/08/2005
	//***************************** Fin description *****************************//
	
    $valid_group = $_SESSION['valid_group'];
    $valid_nom = $_SESSION['valid_nom'];
    $valid_prenom = $_SESSION['valid_prenom'];
	$flag = false;
	if ($date == "") // Si la date est vide, le script considrera par dfaut que c'est la date du jour
  { // la valeur "CURRENT_DATE()" sera associe aux requtes SQL
    $flag = true; // un flag est positionn pour indiquer qu'un changement (provisoire) de lavariable $date a eu lieu
    $date = date("Y-m-d"); // pour les tests suivants, les fonctions doivent tre appels avec une date non-vide
    /* et le fait de fixer la variable date indique au script (ici  tort) qu'il ne s'agit pas de la date du jour
    et cela fait basculer les affichages en mode archives (car la date est fixe)
    Il faudra donc, aprs excution de ces tests, rtablir la valeur vide originelle de faon  ce que
    script considre bien qu'il s'agit de la date du jour et pas d'une date archive */
  }
  if (!test_jour_dans_periode_scolaire($date) || !test_jour_ouvrable(date_mysql_to_jjmmaaaa($date)))
  {
    $error_message = array("La date du jour ou la date choisie (".format_date_long($GLOBALS['default_language'],date_mysql_to_jjmmaaaa($date)).") tombe pendant les vacances scolaires ou n'est pas un jour ouvrable pour l'tablissement! Il n'est donc pas possible de saisir les absences pour ce jour...","");
    affiche_erreurs($error_message);
    return;
  }
  if ($flag == true) // Si la date tait vide et a t renseigne (pour des raisons d'appel de fonctions de tests, voir plus haut) 
    $date = ""; // alors on rtablit la valeur d'origine pour que le script travaille en mode normal et pas en mode archive
  global $chemin_relatif;
	if ($_SESSION['valid_prenom']!="")
    {
       $nom_prof = $valid_nom." ".$valid_prenom;
    }
    else // cas d'admin par exemple
    {
      $nom_prof = $_SESSION['valid_login'];
    }
    $id_pers=$_SESSION['valid_id_user'];
    $code_formulaire = "<p>Remplissez le formulaire suivant, puis cliquer sur le bouton <i>Affichage de la liste des lves de la classe</i></p>";
        $code_formulaire .= "
        <table width='100%' border='0'>
          <tr>
            <td colspan='2'>
              <img src='".$chemin_relatif."images/pixel.gif' width='2' height='10' alt='' />
            </td>
          </tr>
          <tr>
            <td align='center'>
              <label for='Form_Req_Nomprof'>Prof/surveillant :</label>
		<select id='Form_Req_Nomprof' size='1' name='prof'>";
        
			if ($date) // si la date est dfinie (ajout ou modification des absences a posteriori de la date du jour par un utilisateur autoris)
			{
				if ($_SESSION['valid_group']=="3") // si l'utilisateur est un enseignant
                {
                	$code_formulaire.="<option selected='selected' value='".$id_pers."'>".$nom_prof."</option>";
                }
				else
                {
                	$tableau_options=new_liste_options_form("id_pers","nom,prenom","personnel","categorie='7' OR categorie='8'",$option_vide);
					$code_formulaire.=affiche_liste_options_formulaire($tableau_options);
                }
			}
			else
			{
				$code_formulaire.="<option selected='selected' value='".$id_pers."'>".$nom_prof."</option>";
			}
		$code_formulaire.="
		</select>
            </td>
            <td align='center'>
               <label for='Form_Req_Debut_Heure'>Dbut du cours  :</label>&nbsp;
		<select id='Form_Req_Debut_Heure' size='1' name='debut'>";
                  if (is_edt_import())
                  	$tableau_options = horaires_print(recup_horaires_debut_cours());
                  else
				  	$tableau_options=horaires();
                  $code_formulaire.="<option selected='selected'>".horaire_plus_proche($tableau_options)."</option>";
                  $code_formulaire.=affiche_liste_options_formulaire($tableau_options);
                  $code_formulaire.="
                  </select>
            </td>
          </tr>
          <tr>
            <td>
              <img src='".$chemin_relatif."images/pixel.gif' width='2' height='5' alt='' />
            </td>
          </tr>
          <tr>
            <td align='center'>
               <label for='Form_Req_Classe'>Classe ou groupe :</label> 
		<select id='Form_Req_Classe' size='1' name='classe'>";
			
			if (($date && $valid_group!="3") || $valid_group == "8" || $valid_group == "1" || $valid_group == "6") // Si la date est autre que celle du jour ou si l'utilisateur est un surveillant (ou un admin intraeduweb) ou encore un membre de la direction, il pourra voir toutes les classes (et tous les groupes) (utile en cas de prof absent, si sa classe ou son groupe vient en permanence, le surveillant pourra traiter les absences
			{
				$tableau_options1=liste_options_form("connect","division","divisions","");
				$tableau_options2=liste_options_form("connect","nom","groupes","");
				$tableau_options3=array_merge($tableau_options1,$tableau_options2);
				$code_formulaire.=affiche_liste_options_formulaire($tableau_options3);
			}
			else // c'est un prof, il ne verra que ses classes ou groupes
			{
				// Sauf pour le documentaliste qui verra tout
				$sql5 = "SELECT libelle_long FROM disciplines_bcn,personnel WHERE id_pers='".quote_smart($_SESSION['valid_id_user'])."' AND personnel.code_discipline=disciplines_bcn.code_discipline";
			    // DEBUGG print $sql5."<br />"; 
    			$resultat5 = mysql_query($sql5);
    			$ligne5 = mysql_fetch_array($resultat5);
    			if (stristr($ligne5['libelle_long'],"Documentation"))
    			{
      				$tableau_options1=liste_options_form("connect","division","divisions","");
	  				$tableau_options2=liste_options_form("connect","nom","groupes","");
	  				$tableau_options3=array_merge($tableau_options1,$tableau_options2);
    			}
    			else
    			{
					$tableau_options1=liste_options_form("connect","services.code_structure","services,enseignants_services","services.id_service = enseignants_services.id_service AND id_individu='".$_SESSION['identifiant_individu']."'");
					$tableau_options2=liste_options_form("connect","nom","groupes","id_responsable='".$_SESSION['valid_id_user']."'");
					$tableau_options3=array_merge($tableau_options1,$tableau_options2);
    			}
				$code_formulaire.=affiche_liste_options_formulaire($tableau_options3);
			}
		$code_formulaire.="
		</select>
            </td>
            <td align='center'>
               
            </td>
          </tr>
          <tr>
            <td colspan='2'>
              <img src='".$chemin_relatif."images/pixel.gif' width='2' height='10' alt='' />
            </td>
          </tr>
        </table>"; 
        squelette_formulaire_standard("100%","post","absences.php?date=".$date,"Saisie des Absences",$code_formulaire,"Afficher la liste des lves de la classe ou du groupe","ok","Effacer","","","","");   
}

function affiche_form_liste_absents($prof,$debut,$classe,$ajouter,$eleve,$list_absents,$enlever,$absents,
$id_transaction,$bloc2h,$date,$sql_date,$sql_insert_date)
{

 //***************************** description ********************************//
 // cette fonction assure l affichage de la liste des lves de la classe slectionne et le choix
 // des absents fait par le professeur
 // paramtres entrs ($prof,$debut,$classe) : voir fonction affiche_form_infos_plage_horaire()
 //	$ajouter: variable cre si l utilisateur a cliqu sur le bouton <Ajouter>
 //	$eleve	: lve choisi dans la  liste des lves de la classe pour figurer sur la liste des absents
 //	$enlever: variable cre si l utilisateur a cliqu sur le bouton <Enlever>
 //	$absents: contient le nom de l lve SELECTIONNE depuis la liste des absents
 //	$GLOBALS['id_transaction'] : contient l identification d une transaction ancienne si le prof est en train de la modifier
 //			 (ajout ou suppression d absents)
 // sortie : bouton <Envoyer> du formulaire avec toutes les variables prcites transmises
 // auteur : S.GODM (sylvain.godme@gmail.com)
 // Date de cration : ,
 // Date de dernire mise  jour : 
 //***************************** Fin description *****************************//

 global $chemin_relatif;
 $nbligne_absents = 0;
 $code_formulaire = "
 <br />
 <table>
 	<tr>
 		<td>
 			<img src='$chemin_relatif"."images/puce.png' border='0' alt='' />
 			 Si vous n'avez pas d'absent, il vous suffit d'envoyer ce formulaire sans le remplir (la liste des absents reste vide)
 		</td>
 	</tr>
 	<tr>
 		<td>
 			<img src='$chemin_relatif"."images/puce.png' border='0' alt='' /> <label for='Form_Bloc2h'>Si vous avez cours avec la classe deux heures conscutives, vous pouvez cocher la case suivante :</label><br />
 ";
 if ($bloc2h=="2h") // Si la variable est dfinie  2h (case dj coche prcdemment)
 {
 	$code_formulaire .= "<input id='Form_Bloc2h' type=\"checkbox\" value=\"2h\" name=\"bloc2h\" checked=\"checked\" /> Bloc de 2 heures</td></tr></table>";
 }
 else
 {
 	$code_formulaire .= "<input id='Form_Bloc2h' type=\"checkbox\" value=\"2h\" name=\"bloc2h\" /> Bloc de 2 heures</td></tr></table>";
 }
 $code_formulaire .= "
 <table border='0' width='100%'>
    <tr>
      <td width='45%' align='center'>
        <b><u><label for='Form_Liste_Classe'>Liste des lves 
 ";
  if (strlen($classe)!=3)
  {
    $code_formulaire .= "du <a href='?change_class=oui' title='Changer de groupe'>groupe<br /><font color='red'>$classe</font></a></label></u>";
  }
  else
  {
    $code_formulaire .= "de la <a href='?change_class=oui' title='Changer de classe'>classe de<br /><font color='red'>$classe</font></a></label></u>";
  }
	$code_formulaire .= "
        :</b>
      </td>
      <td width='15%'>&nbsp;</td>
      <td width='40%' align='center'>
        <u><b><label for='Form_Liste_Absents'>Absents :</label></b></u>
      </td>
    </tr>
    <tr>
      <td width='40%' align='center'>
        <p align='center'><select id='Form_Liste_Classe' size='10' multiple='multiple' name='eleve[]'>
        ";
     // On liste les lves de la classe ou du groupe
     $sql="SELECT eleves.eleve_id,nom,prenom FROM structures_eleves,eleves WHERE code_structure='".quote_smart($classe)."' AND structures_eleves.eleve_id=eleves.eleve_id ORDER BY nom,prenom";
     // DEBUGG echo "$sql<br />";
     $resultat = mysql_query($sql);
     $nbligne = mysql_num_rows($resultat);
     if ($nbligne>0) // S'il y des rsultats dans les structures importes de Sconet
     {
     	for ($i=1;$i<=$nbligne;$i++)
     	{
      		$variable = mysql_fetch_array($resultat);
      		$option = $variable["nom"]." ".$variable["prenom"];
      		$code_formulaire .= "<option value='".$variable['eleve_id']."'>".$option."</option>";
      		
     	}
     }
     else // si pas de rsultat dans les structures importes de Sconet, on cherche dans la table groupes_eleves (groupes crs manuellement)
     {
     	$sql = "SELECT eleves.eleve_id,eleves.nom,prenom FROM groupes,groupes_eleves,eleves WHERE groupes.nom='".quote_smart($classe)."' AND groupes.id_groupe=groupes_eleves.id_groupe AND groupes_eleves.eleve_id=eleves.eleve_id ORDER BY nom,prenom";
		// DEBUGG echo "$sql<br />";
     	$resultat=mysql_query($sql);
		$nbligne=mysql_num_rows($resultat);
		for ($i=1;$i<=$nbligne;$i++)
     	{
      		$variable = mysql_fetch_array($resultat);
      		$option = $variable["nom"]." ".$variable["prenom"];
      		$code_formulaire .= "<option value='".$variable['eleve_id']."'>".$option."</option>";
     	}
     }
  $code_formulaire .= "
  </select></p>
      Total : <font color='red'>$nbligne</font> lve(s)
  ";
      // Il faut rinitialiser la variable car elle va tre utilise maintenant pour dnombrer les lves de la liste des absents : dans le cas contraire, elle contient la valeur prcdente (nombre d'lves dans la classe ou la groupe), et ce mme si la liste des absents est vide -au premier chargement du formulaire-)
      $nbligne = 0;
      
      $code_formulaire .= "
      </td>
      <td width='20%'>
        <p align='center'>
        <!-- les champs cachs suivants sont ncessaire pour retransmettre les valeurs des variables -->
        <input type='hidden' name='classe' value=\"$classe\" />
        <input type='hidden' name='prof' value=\"$prof\" />
        <input type='hidden' name='debut' value=\"$debut\" />
        <input type='submit' value='Ajouter &gt;&gt;' name='ajouter' /></p>
        <p align='center'><input type='submit' value=' Enlever &lt;&lt;' name='enlever' />&nbsp;</p>
      </td>
      <td width='40%'>
        <p align='center'><select id='Form_Liste_Absents' size='10' multiple='multiple' name='absents[]'>     
      ";
        
         if (!$ajouter && !$enlever)
         { // on vient juste de cliquer sur le bouton Afficher la liste de classe
            // y-a-t-il dj des absences dclares pour cette transaction ?
           if (verif_transaction($prof,"CURRENT_DATE()",$debut,$classe,$sql_date,$sql_insert_date))
           { // Si oui, afficher la liste des absents dj dclars
             $sql = "SELECT eleves.eleve_id,nom,prenom FROM liste_absents_provisoires,eleves WHERE id_pers='".quote_smart($prof)."' AND debut='".quote_smart($debut)."' AND liste_absents_provisoires.classe='".quote_smart($classe)."' AND ".$sql_date." AND eleves.eleve_id=liste_absents_provisoires.eleve_id ORDER BY nom,prenom";
             // DEBUGG echo "$sql<br />";
             $resultat = mysql_query($sql);
             $nbligne_absents = mysql_num_rows($resultat);
             for ($i=1;$i<=$nbligne_absents;$i++)
             {
              $variable = mysql_fetch_array($resultat);
              $option = $variable["nom"]." ".$variable["prenom"];
      		  $code_formulaire .= "<option value='".$variable['eleve_id']."'>".$option."</option>";
             }
             $code_formulaire .="
             </select>
             ";
             // Si la transaction concerne un groupe, on rcupre la liste des classes de ce groupe
             $liste_classes = liste_classes_dans_groupe($classe); // Si ce n'est pas un groupe, ce tableau ne contiendra qu'un seul lment (la classe elle-mme)
             // DEBUGG var_dump($_SESSION['liste_classes']);
           }
           else
           { // Si c'est la premire fois qu'on affiche ce formulaire
		
	   		 // on cherche l'heure prcdente
	   		 if (is_edt_import())
             	$tableau = horaires_print(recup_horaires_debut_cours());
             else
			 	$tableau = horaires();
			 	
			 $option = array(); // va contenir la liste des absents dclars pour la classe ou le groupe les heures prcdentes ( afficher dans lechamp select du formulaire)
                
				/*********************/
                // on cherche d'abord si la transaction d'absence en cours se fait sur un groupe, ou une classe entire
                $sql = "SELECT * FROM divisions WHERE division='".quote_smart($classe)."'";
               // DEBUGG echo $sql."<br />";
                mysql_query($sql);
                if (mysql_affected_rows()==0) // cela signifie que c'est un groupe
                {
                  // DEBUGG echo "C'est un groupe !<br />";
                  // Il faut rcuprer le nom des classes figurant dans ce groupe
                  $liste_classes = liste_classes_dans_groupe($classe);
                  // DEBUGG var_dump($_SESSION['liste_classes']);
                  // et l'identifiant du groupe
                  $sql = "SELECT id_groupe FROM groupes WHERE nom='".quote_smart($classe)."'";
                 // DEBUGG echo $sql."<br />";
                  $resultat = mysql_query($sql);
                  $ligne4 = mysql_fetch_array($resultat);
                  $id_groupe = $ligne4['id_groupe'];
                  // pour chaque classe, on va rechercher les absents dj dclars dans la journe
                  foreach($liste_classes as $value)
                  {
                    // DEBUGG echo "<u>Classe : $value</u><br />";
                    $indice=array_search($debut,$tableau); // on cherche l'indice du tableau correspondant  l'heure de dbut de cours
		    		$indice--; // on dcrmente l'indice pour accder  l'horaire prcdent
                    if ($indice<0)
                      $debut_avant = false;
                    else
                      $debut_avant=$tableau[$indice]; // on rcupre l'horaire prcdent
                    while ($debut_avant) // tant qu'on ne rencontrera pas de break, on boucle sur les heures prcdentes
                    {
                      	// Les absents dj dclars pour cette classe peuvent avoir t dclars soit en classe entire, soit en groupe. Donc on recherche les enregistrements de transactions d'absences correspondant  la classe en cours ou bien  un groupe contenant le nom de cette classe
                      	$sql = "SELECT t3.eleve_id,nom,prenom FROM liste_absents as t1,liste_absents_transactions as t2,eleves as t3 WHERE t2.debut='$debut_avant' AND t2.date = ".quote_smart($sql_insert_date)." AND t1.id_transaction=t2.id_transaction AND t1.eleve_id=t3.eleve_id AND (t2.classe='$classe' OR t2.classe='$value') AND t3.classe='$value' ORDER BY nom,prenom";
	                    // DEBUGG echo "Horaire de recherche : $debut_avant<br>";
	                    // DEBUGG echo "SQL recherche : $sql<br>";
                      
    	                // On rcupre ainsi aussi bien les absents dclars classe entire qu'en groupe
   	              		$resultat = mysql_query($sql);
	    	            if (mysql_num_rows($resultat)>0)
	    	  		    {
	    					$nbligne = mysql_num_rows($resultat);
            				for ($i=1;$i<=$nbligne;$i++)
	    					{
                          		$variable = mysql_fetch_array($resultat);
		                        // DEBUGG echo "Sera affich : ".$variable['nom']." ".$variable['prenom']."<br />";
            					$option[] = $variable["eleve_id"]."%".$variable['nom']." ".$variable['prenom']; // on prend le nom de l'lve tel quel         
		                        // on enregistre cet absent dj dclar l'heure prcdente dans la table liste_absent_provisoires
								// DEBUGG echo "OPTION : ".current($option)."<br />";
                		        $sql = "INSERT INTO liste_absents_provisoires VALUES('".quote_smart($prof)."','".quote_smart($debut)."','".quote_smart($classe)."','".quote_smart($variable["eleve_id"])."',".$sql_insert_date.")";
           						// DEBUGG echo "$sql<br />";
                        		mysql_query($sql);
                        		next($option);
                        		// DEBUGG echo "SQL_INSERT : $sql<br />";	
		                        $nbligne_absents++;
	    					}
		 					// DEBUGG echo "Absents trouvs !<br />";
                            break; // on sort de la boucle while (sinon s'excute indfiniment) 
                            // en effet, on a trouv des absents, donc inutile de chercher l'heure prcdente, on passe donc  la classe suivante (boucle foreach)
	    	      		}	
	    	      		else // s'il n'y a pas d'absents dj dclars l'heure prcdente pour cette classe
	    	      		{
							// On commence alors par vrifier si un prof a fait une dclaration "pas d'absents")
							$sql ="SELECT id_transaction FROM liste_absents_transactions WHERE ".$sql_date." AND debut='".quote_smart($debut_avant)."' AND (classe='".quote_smart($value)."' OR classe like '%".quote_smart($value)."%')";
    						// DEBUGG echo "$sql<br />";
							$resultat = mysql_query($sql);
							if (mysql_num_rows($resultat)>0)
	    					{
			  					// DEBUGG echo "Il n'y a pas d'absent en $value  $debut_avant<br />";
                          		break; // on sort de la boucle while (sinon s'excute indfiniment) 
                          		// en effet, on a trouv une transaction faite par un prof ou il ne dclare aucun absent pour cette classe, donc inutile de chercher l'heure prcdente, on arrte pour cette classe et on passe  la suivante
	    					}
                        	// Si on arrive ici, c'est que la transaction n'existe pas (la classe n'a pas eu cours ou le prof
							// a oubli de dclarer les absences
							// on va donc chercher recursivement les heures prcdentes si des transactions ont t faites pour cette classe
							// par d'autres profs et afficher la liste des absents prcdemment dclars
							//  si on ne trouve pas d'absents, alors la liste sera vide
				
    						// Dtermination de l'heure prcdente
							$indice=array_search($debut_avant,$tableau); // on cherche l'indice du tableau correspondant  l'heure de dbut de cours
							$indice--; // on dcrmente l'indice pour accder  l'horaire prcdent
							if ($indice<0)
                          		$debut_avant = false;
                        	else
                          		$debut_avant=$tableau[$indice]; // on rcupre l'horaire prcdent
                        	// DEBUGG echo "On passe  l'heure prcdente !$debut_avant<br />";
                     	 }
                    } // while ($debut_avant) 
                  } // fin de boucle classe pour le groupe en cours foreach($liste_classes as $value)
                } //if (mysql_affected_rows()==0) // cela signifie que c'est un groupe
                else // la transaction en cours se fait sur une classe entire
                {
                  // DEBUGG echo "C'est une classe entire !<br />";
                  $indice=array_search($debut,$tableau); // on cherche l'indice du tableau correspondant  l'heure de dbut de cours
		  		  $indice--; // on dcrmente l'indice pour accder  l'horaire prcdent
                  if ($indice<0)
                    $debut_avant = false;
                  else
                    $debut_avant=$tableau[$indice]; // on rcupre l'horaire prcdent
                  $tableau_groupes=cherche_classe_dans_groupes($classe); // On recherche les groupes dont la classe fait partie
                  // DEBUGG echo "Groupes dont la classe fait partie : ";var_dump($tableau_groupes);
                  $or = "";
                  foreach ($tableau_groupes as $value)
                  {
                  	$or .= " OR t2.classe='".quote_smart($value)."'";
                  }
                  while ($debut_avant)
                  {
                    // Les absents dj dclars pour cette classe peuvent avoir t dclars soit en classe entire, soit en groupe. Donc on recherche les enregistrements de transactions d'absences correspondant  la classe en cours ou bien  un groupe contenant le nom de cette classe
                    $sql = "SELECT t3.eleve_id,nom,prenom FROM liste_absents as t1,liste_absents_transactions as t2,eleves as t3 WHERE t2.debut='$debut_avant' AND t2.date = ".quote_smart($sql_insert_date)." AND t1.id_transaction=t2.id_transaction AND t1.eleve_id=t3.eleve_id AND (t2.classe='$classe'".$or.") AND t3.classe='$classe' ORDER BY nom,prenom";
                    // DEBUGG echo "Horaire de recherche : $debut_avant<br />";
                    // DEBUGG echo "SQL recherche : $sql<br />";
                    // On rcupre ainsi aussi bien les absents dclars classe entire qu'en groupe
   		    		$resultat = mysql_query($sql);
		    		if (mysql_num_rows($resultat)>0)
	    	    	{
	    	      		$nbligne = mysql_num_rows($resultat);
            	      	for ($i=1;$i<=$nbligne;$i++)
	    	      		{
            				$variable = mysql_fetch_array($resultat);
                        	// DEBUGG echo "Sera affich : ".$variable['nom']." ".$variable['prenom']."<br />";
            				$option[] = $variable["eleve_id"]."%".$variable['nom']." ".$variable['prenom']; // on prend le nom de l'lve tel quel         
                        	// on enregistre cet absent dj dclar l'heure prcdente dans la table liste_absent_provisoires
							// DEBUGG echo "OPTION : ".current($option)."<br />";
                        	$sql = "INSERT INTO liste_absents_provisoires VALUES('".quote_smart($prof)."','".quote_smart($debut)."','".quote_smart($classe)."','".quote_smart($variable["eleve_id"])."',".$sql_insert_date.")";
           					// DEBUGG echo "$sql<br />";
                        	mysql_query($sql);
                        	next($option);
                        	// DEBUGG echo "SQL_INSERT : $sql<br />";
                        	$nbligne_absents++;
	    	      		}
						// DEBUGG echo "Absents trouvs !<br />";
                        break; // on sort de la boucle while (sinon s'excute indfiniment)
	    	    	}
	    	    	else // s'il n'y a pas d'absents dj dclars l'heure prcdente pour cette classe
	    	    	{
			
						// On commence alors par vrifier si un prof a fait une dclaration "pas d'absents")
						$sql ="SELECT id_transaction FROM liste_absents_transactions WHERE ".$sql_date." AND debut='".quote_smart($debut_avant)."' AND classe='".quote_smart($classe)."'";
    					// DEBUGG echo "$sql<br />";
						$resultat = mysql_query($sql);
						if (mysql_num_rows($resultat)>0)
	    				{
			  				// DEBUGG echo "Il n'y a pas d'absent en $value  $debut_avant<br />";
                          	break; // on sort de la boucle while (le prof prcdent a fait une dcalrarion "pas d'absents")
	    				}
						// Si on arrive ici, c'est que la transaction n'existe pas (la classe n'a pas eu cours ou le prof
						// a oubli de dclarer les absences
						// on va donc chercher recursivement les heures prcdentes si des transactions ont t faites
						// par d'autres profs et afficher la liste des absents prcdemment dclars (si pas on a dclar
						// pas d'absents, alors la liste sera vide
				
    					// Dtermination de l'heure prcdente

						$indice=array_search($debut_avant,$tableau); // on cherche l'indice du tableau correspondant  l'heure de dbut de cours
						$indice--; // on dcrmente l'indice pour accder  l'horaire prcdent
						if ($indice<0)
                          $debut_avant = false;
                        else
                          $debut_avant=$tableau[$indice]; // on rcupre l'horaire prcdent
                        // DEBUGG echo "On passe  l'heure prcdente !$debut_avant<br />";
                    }
                  } // while ($debut_avant)
                } 
	    		// On va afficher les options trouves dans la liste des absents dj dclars
            	//on enlve d'abord les doublons ventuels
            	$option = array_unique($option);
            	$option = enlever_valeurs_vides($option);
            	if (count($option)>0)
            	{
            		foreach ($option as $value)
            		{
              			$fragment = explode("%",$value); // On spare l'eleve_id de son nom+prnom
              			$value_eleve_id = $fragment[0]; // le nom+prenom sont dans $fragment[1]
            			$code_formulaire .= "<option value='".$value_eleve_id."'>".$fragment[1]."</option>";
            		}
            	}
            	else // Si il n'y a rein, on met quand mme au moins une balise <option> (vide) dans le <select> pour la validit du code XHTML
            	{
            		$code_formulaire .= "<option></option>";
            	}
          	} // $id_transaction
        } // !$ajouter && !$enlever
        if ($ajouter || $enlever)
        { // si on vient de cliquer sur l un des boutons Ajouter ou Enlever
          // Si la transaction concerne un groupe, on rcupre la liste des classes de ce groupe
          /* En effet, si l'appel vient du lien [Ajouter] depuis le cahier d'appel, la variable $_SESSION['liste_classe'] contient un lment vide (je ne sais pas pourquoi) : alors on rcupre la liste perdue */
          $liste_classes = liste_classes_dans_groupe($classe); // Si ce n'est pas un groupe, ce tableau ne contiendra qu'un seul lment (la classe elle-mme)
          if ($enlever)
          { // si on a cliqu sur enlever
	   		$absents = $_POST['absents']; // on rcupre le tableau contenant la liste des absents  enlever
	   		if ($bloc2h=="2h") // C'est un bloc de deux heures qui a t coch
	   		{
				if ($id_transaction) // Si la transaction est dj faite
				{
					// On cherche la dernire heure de la matine et de l'aprs-midi (ce sont celles qui ne peuvent pas se trouver au dbut d'un bloc de deux heures
                	$sql3 = "SELECT * from horaires";
                    // DEBUGG echo "$sql3<br />";
                    $resultat3 = mysql_query($sql3);
                    $ligne3 = mysql_fetch_array($resultat3);
                    $h_fin_matin = substr($ligne3['debut_matin'],0,2)+$ligne3['nb_matin']-1;
                    $m_fin_matin = substr($ligne3['debut_matin'],-2,2);
                    $h_fin_aprem = substr($ligne3['debut_aprem'],0,2)+$ligne3['nb_aprem']-1;
                    $m_fin_aprem = substr($ligne3['debut_aprem'],-2,2);
                    $fin_matin = $h_fin_matin."h".$m_fin_matin;
                    $fin_aprem = $h_fin_aprem."h".$m_fin_aprem;
       
                    if ($debut!=$fin_matin && $debut!=$fin_aprem) 
					{
						// On cherche l'heure suivante
						if (is_edt_import())
             				$tableau = horaires_print(recup_horaires_debut_cours());
             			else
			 				$tableau = horaires();
			 			$indice=array_search($debut,$tableau); // on cherche l'indice du tableau correspondant  l'heure de dbut de cours
						$indice++; // on incrmente l'indice pour accder  l'horaire suivant
						$debut_2h=$tableau[$indice]; // on rcupre l'horaire suivant
						$sql = "SELECT id_transaction FROM liste_absents_transactions WHERE ".$sql_date." AND id_pers='".quote_smart($prof)."'
 						AND (debut='".quote_smart($debut)."' OR debut='".quote_smart($debut_2h)."') AND classe='".quote_smart($classe)."'";
						// DEBUGG echo "$sql<br />";
						$selection=mysql_query($sql);
						while ($ligne=mysql_fetch_array($selection))  // En principe deux rponse pour un bloc 2h valide
						{						// on supprime les lves slectionns dans les deux transactions
							$transaction=$ligne['id_transaction'];
							if (count($absents)!=0)
                    		{
                    			foreach ($absents as $value)
	  				  			{
									$sql = "DELETE FROM liste_absents_provisoires WHERE id_pers='".quote_smart($prof)."' AND debut='".quote_smart($debut)."' AND classe='".quote_smart($classe)."' AND eleve_id='".quote_smart($value)."' AND ".$sql_date;
									// DEBUGG echo "$sql<br />";
									mysql_query($sql);
									$sql = "DELETE FROM liste_absents WHERE id_transaction='".quote_smart($transaction)."' AND eleve_id='".quote_smart($value)."'";
									// DEBUGG echo "$sql<br />";
									mysql_query($sql);
		  			  			}
                    		}
						}
					}
					else // Si la case bloc de 2h a t coche, mais par erreur (11h00 ou 15h30),la suppression concerne une transaction unique
					{
						if (count($absents)!=0)
                        {
                        	foreach ($absents as $value)
	  			  			{
								$sql = "DELETE FROM liste_absents_provisoires WHERE id_pers='".quote_smart($prof)."' AND debut='".quote_smart($debut)."' AND classe='".quote_smart($classe)."' AND eleve_id='".quote_smart($value)."' AND ".$sql_date;
								// DEBUGG echo "$sql<br />";
								mysql_query($sql);
	  							$sql = "DELETE FROM liste_absents WHERE id_transaction='".quote_smart($id_transaction)."' AND eleve_id='".quote_smart($value)."'";
								// DEBUGG echo "$sql<br />";
	  							mysql_query($sql);
          			  		}
                        }
					}
				}
				else // Si la transaction n'est pas encore faite, on ne supprime que dans la table provisoire
				{	
					if (count($absents)!=0)
                    {
                    	foreach ($absents as $value)
	  		  			{
							$sql = "DELETE FROM liste_absents_provisoires WHERE id_pers='".quote_smart($prof)."' AND debut='".quote_smart($debut)."' AND classe='".quote_smart($classe)."' AND eleve_id='".quote_smart($value)."' AND ".$sql_date;
							// DEBUGG echo "$sql<br />";
							mysql_query($sql);
		  	  			}
                    }
				}
	  		}
	  		else // pas de bloc de deux heures : la suppression concerne une transaction unique
	  		{
				if (count($absents)!=0)
                {
                	foreach ($absents as $value)
	  	  			{
						$sql = "DELETE FROM liste_absents_provisoires WHERE id_pers='".quote_smart($prof)."' AND debut='".quote_smart($debut)."' AND classe='".quote_smart($classe)."' AND eleve_id='".quote_smart($value)."' AND ".$sql_date;
						// DEBUGG echo "$sql<br />";
						mysql_query($sql);
	  					if ($id_transaction) // Si la transaction a dj t faite, il faut enlever ces lves de la table liste_absents
						{
							$sql = "DELETE FROM liste_absents WHERE id_transaction='".quote_smart($id_transaction)."' AND eleve_id='".quote_smart($value)."'";
							// DEBUGG echo "$sql<br />";
							mysql_query($sql);
          				}
	  	  			}
                }
	  		}   
         } // si on a cliqu sur enlever
         else 
         { // si on a cliqu sur ajouter
         	$liste_eleves = $_POST['eleve']; // on rcupre le tableau contenant la liste des absents  ajouter
           	// DEBUGG var_dump($_POST['eleve']);
	   		if (count($liste_eleves)!=0) // si pas de slection, le clic sur ajouter n'a pas d'effet
           	{
            	foreach($liste_eleves as $value)
	     		{
               		if ($value!="")
               		{
		  				$sql = "INSERT INTO liste_absents_provisoires VALUES('".quote_smart($prof)."','".quote_smart($debut)."','".quote_smart($classe)."','".quote_smart($value)."',".$sql_insert_date.")";
		  				// DEBUGG echo $sql."<br />";
		  				mysql_query($sql);
               		}
               		else
               		{
               		} // si le nom d lve est vide, pas de requte
	   			}
           }
         }
        
         // on affiche la liste des absents actuelle (liste provisoire)
         $sql = "SELECT eleves.eleve_id,nom,prenom FROM liste_absents_provisoires,eleves WHERE id_pers='".quote_smart($prof)."' AND debut='".quote_smart($debut)."' AND liste_absents_provisoires.classe='".quote_smart($classe)."' AND ".$sql_date." AND eleves.eleve_id=liste_absents_provisoires.eleve_id
         ORDER BY nom,prenom";
         // DEBUGG echo $sql."<br />";
         $resultat = mysql_query($sql);
         $nbligne_absents = mysql_num_rows($resultat);
         for ($i=1;$i<=$nbligne_absents;$i++)
         {
           $variable = mysql_fetch_array($resultat);
           $option = $variable["nom"]." ".$variable["prenom"];
      	   $code_formulaire .= "<option value='".$variable['eleve_id']."'>".$option."</option>";
         }
        } //if ($ajouter || $enlever)        
        $code_formulaire .= "
        </select>
        <br />Total : <font color='red'>$nbligne_absents</font> lve(s)
        </p>
        </td>
        </tr>
        </table>
        <p><i><font color='red' size='2'>Pour une slection multiple, maintenez la touche CTRL enfonce et cliquez sur les lves absents.</font></i></p>
        <input type='hidden' name='id_transaction' value='$id_transaction' />
        ";
        // Il faut rcuprer le nom et le prnom du prof ( dfaut le login) pour l'afficher dans l'en-tte de formulaire
        // car $prof contient l'id_pers = identifiant numrique dans la table login
        $sql = "SELECT nomlogin,nom,prenom FROM login WHERE id_pers='".quote_smart($prof)."'";
        $result_sql = mysql_query($sql);
        $record = mysql_fetch_array($result_sql);
        if ($record['nom']=="")
        	$nom_prof = $record['nomlogin'];
        else
        	$nom_prof = $record['nom']." ".$record['prenom'];
        squelette_formulaire_standard("100%","post","absences.php?date=".$date,"Prof/surveillant : <font class='entete_form_special1'>$nom_prof</font><img src='".$chemin_relatif."images/pixel.gif' width='10' alt='' /> -                         <img src='".$chemin_relatif."images/pixel.gif' width='10' alt='' />Dbut du cours  : <font class='entete_form_special2'>$debut</font>",$code_formulaire,"Envoyer  la Vie scolaire","soumettre","Annuler","annuler","","","");
}

function verif_transaction($prof,$date,$debut,$classe,$sql_date,$sql_insert_date)
{

  //***************************** description ********************************//
  // cette fonction vrifie si une transaction faite par un professeur pour une classe donne,
  //  une date donne et  une heure donne a dj t effectue dans la table mysql liste_
  // absents_transactions. Si c est la cas, elle copie les lves dj nots absents dans la table
  // liste_absents_provisoires destine  afficher la liste des absents avant l envoi des infor-
  // -mations  la vie scolaire
  // paramtres entrs ($prof,$date,$debut,$classe) : permet identification de la transaction
  // dans le script d appel
  // sortie : la fonction renvoie une variable id_transaction si la transaction tait dj existante
  // et rien dans le cas contraire
  // auteur : S.GODM (sylvain.godme@gmail.com)
  // Date de cration : 15/05/02
  // Date de dernire mise  jour : 
  //***************************** Fin description *****************************//

  $sql = "SELECT id_transaction FROM liste_absents_transactions WHERE id_pers='".quote_smart($prof)."' AND debut='".quote_smart($debut)."' AND ".$sql_date." AND classe='".quote_smart($classe)."'";
  // DEBUGG echo $sql."<br />";
  // remarque : dans $sql, il ne faut pas de guillemets pour $date car son contenu est une fonction mysql
  // ici le plus souvent CURRENT_DATE(), dans le cas contraire, la requte n aboutit pas

  $resultat = mysql_query($sql);
  if (mysql_num_rows($resultat)) // Si la transaction existe
  {
    $variable = mysql_fetch_array($resultat); // alors elle est unique
    $id_transaction = $variable['id_transaction'];
    $sql = "SELECT eleve_id FROM liste_absents WHERE id_transaction='".quote_smart($id_transaction)."'";
   // DEBUGG echo $sql."<br />";
    $resultat = mysql_query($sql);
    while ($variable = mysql_fetch_array($resultat)) // on peuple la table liste_absents_provisoires avec les absents dj connus pour cette transaction
    {
      $eleve = $variable['eleve_id'];
      $sql = "INSERT INTO liste_absents_provisoires values('".quote_smart($prof)."','".quote_smart($debut)."','".quote_smart($classe)."','".quote_smart($eleve)."',".$sql_insert_date.")";
     // DEBUGG echo $sql."<br />";
      mysql_query($sql);
    }
    return $id_transaction;
  } // si elle n existe pas, ne rien faire
  return false;
}


function horaire_plus_proche($horaires)
{
   //***************************** description ********************************//
  // cette fonction dtermine l'horaire de dbut de cours le plus proche de l'heure actuelle
  // Ceci sert  pr-remplir le premier formulaire de saisie des absences (champ 'Dbut de cours')
  // et permet de limiter un peu plus les erreurs lis  une mauvaise slection de l'horaire
  // le paramre $horaires est le tableau renvoy par la fonction horaires() et contient les horaires
  // des cours de la journe
  // auteur : S.GODM (sylvain.godme@gmail.com)
  // Date de cration : 08/03/2005
  // Date de dernire mise  jour : 29/04/2014
  //***************************** Fin description *****************************//
  
  $ecarts = array();
  
  /*
   * Test
   * Remplacer + bas date("H") par $dateH et date("i") par $datei
   * et dcommenter les 2 lignes qui suivent : 
   * */
   //$dateH = "12"; // les heures doivent tre indiqus sur 2 chiffres (ex : 12h13)
   //$datei = "13";
  /* 
   * A la fin du test, remplacer $dateH par date("H") et $dateI par date("I")
   * et recommenter les 2 lignes qui prcdent 
   * */
  
  foreach($horaires as $cle => $value)
  {
  	$ecarts[$cle] = ecart_minutes_2_horaires(date("H")."h".date("i"),$value); // l'utilisation de $cle permet d'assurer que les tableaux $horaires et $ecarts auront les mmes index sans dcalage
  }

  // on rcupre la cl de l'cart le + faible
  $cle = array_search(min($ecarts),$ecarts);
  
  return $horaires[$cle];
}

/* Dbut du programme principal */


// Le script en cours doit tre le script d'appel prvu
if (end_with_string($_SERVER['PHP_SELF'],"prive/absences.php") || end_with_string($_SERVER['PHP_SELF'],"prive/admin/prive/cahier_appel.php"))
{
    // et on ne doit pas tre dans les archives (saisie des absences inaccessible dans ce cas)
	if (isset($_SESSION['anscol']) && isset($_SESSION['anscol']) !="")
	{
		  $error_message = array("Vous ne pouvez pas accder au formulaire de saisie car vous tes dans les archives. <a href='./admin/prive/exit_archives.php'>Sortez du mode archives</a> ou bien <a href='./admin/prive/cahier_appel.php'>consultez le cahier d'appel des archives</a>","");
		  affiche_erreurs($error_message);
		  return;
	}
	
	/* initialisations */
    
  // s'il s'agit de modifier une dclaration d'absences pour une autre date telle que celle du jour
  // (appel  partir du script c_cahier_appel.php)
  if (isset($_GET['date']) && $_GET['date']!="CURRENT_DATE()")
  {
    $date = $_GET['date'];
    
  }
  else
    $date = "";
    
  // on intercepte le changement de classe demand  partir du formulaire de saisie de la liste des absents
  // Cette demande peut survenir si un prof s'aperoit qu'il s'est tromp de clase dans le premier formulaire
  // dans ce cas, s'il essaie de revenir au formulaire initial pour changer de classe par les liens de navigation, il n'y parviendra pas,  cause de la rgnration systmatique du POST
  // le code suivant permet de rsoudre le problme
  if (isset($_GET['change_class']) && $_GET['change_class']=="oui")
  {
    unset($_POST);
    unset($_SESSION['post_imprimable']);
  }
  // DEBUGG var_dump($_POST); var_dump($date);
  if (isset($_POST['ajouter']))
    $ajouter = $_POST['ajouter'];
  else $ajouter = "";
  if (isset($_POST['enlever']))
    $enlever = $_POST['enlever'];
  else $enlever = "";
  if (isset($_POST['ok']))
    $ok = $_POST['ok'];
  elseif (isset($_GET['ok']))
    $ok = $_GET['ok'];
  if (isset($_POST['annuler']))
    $annuler = $_POST['annuler'];
    
  $prof = $_SESSION['valid_id_user'];
  
  if (isset($_POST['debut']))
    $debut = $_POST['debut'];
  else $debut = "";
  if (isset($_POST['classe']))
    $classe = $_POST['classe'];
  elseif (isset($_GET['classe']))
    $classe = $_GET['classe'];
  else
    $classe = "";
  if (isset($_POST['id_transaction']))
    $id_transaction = $_POST['id_transaction'];
  elseif (isset($_GET['id_transaction']))
    $id_transaction = $_GET['id_transaction'];
  else
    $id_transaction = "";
  if (isset($_POST['bloc2h']))
    $bloc2h = $_POST['bloc2h'];
  else
    $bloc2h = "";
  if (isset($_POST['eleve']))
    $eleve = $_POST['eleve'];
  else
    $eleve = "";
  if (isset($_POST['list_absent']))
    $list_absents = $_POST['eleve'];
  else
    $list_absents = "";
  if (isset($_POST['absents']))
    $absents = $_POST['absents'];
  else
    $absents = "";
  
  // DEBUGG echo "SESSION['liste_classe'] : ";var_dump($_SESSION['liste_classes']);
      
  global $admin_email;

  if ($date)
  {
	// On vrifie que l'utilisateur dispose des droits requis pour Modifier les Absences d'un jour autre que la date du jour (seuls la direction et les surveillants, les profs et admin sont habilits  faire des modification ou suppression pour une date autre que celle du jour -archives-)
    if ($_SESSION['valid_group'] =="6" || $_SESSION['valid_group'] =="8" || $_SESSION['valid_group'] =="1" || $_SESSION['valid_group'] == "3")
    {
      echo "<!-- Affichage du titre de la page -->";
	    echo "<br /><h1>Ajout/modification des absences d'lves<br /><font color='red'><i>(ARCHIVES : ".MySQLDateToExplicitDate($date, $WeekDayOn=1, $YearOn=1).")</i></font></h1><br />";
    }
    else
    {
      $error_message = array("Vous n'tes pas autoris(e)  faire des ajouts ou des modifications dans la base de donnes des absences pour une autre date que celle du jour.","update_denied"); // On empchera l'affichage de la page
    }        
  $test_date_ouvrable = $date;
  }
  else
  {
	  echo "<!-- Affichage du titre de la page -->";
	  echo "<br /><h1>Saisie des absences d'lves<br/>du ".format_date_long($GLOBALS['default_language'],"")."</h1><br />";
    $test_date_ouvrable = date("Y-m-d"); // date du jour au format MySQL
  }
  
  // test si la date est un jour ouvrable de l'tablissement ou non
   if (!test_jour_dans_periode_scolaire($test_date_ouvrable) || !test_jour_ouvrable(date_mysql_to_jjmmaaaa($test_date_ouvrable)))
   {
     $error_message = array("Le ".format_date_long($GLOBALS['default_language'],date_mysql_to_jjmmaaaa($test_date_ouvrable))." tombe pendant les vacances scolaires ou n'est pas un jour ouvrable pour l'tablissement!","");
     affiche_erreurs($error_message);
     return; // le script est alors interrompu
   }
  
  
  if (connexion_mysql() && select_database())
  {

  if (!isset($error_message) || (isset($error_message) && $error_message[1] != "update_denied")) // Si pas d'empchement d'affichage de la page
  {
    if ($date) // si la date est dfinie, il s'agit d'un ajout ou d'une modification a posteriori de la date du jour
    {
	    // Alors la gestion sql de la date est ajuste
	    $sql_date="date='$date'";
	    $sql_insert_date="'$date'";
    }
  else // pour la date du jour (fonctionnement par dfaut du script)
  {
	$sql_date="date=CURRENT_DATE()";
	$sql_insert_date="CURRENT_DATE()";
	// DEBUGG var_dump($sql_date);
  }
  // on commence par effacer le contenu de la table liste_absents_provisoires si
  // elle contient des enregistrements ne correspondant pas  la date du jour
  // ceci permet, dans le cas o un utilisateur aurait quitt son navigateur sans envoyer les donnes
  // sur les absences, de ne pas encombrer inutilement la table en question

  $sql = "DELETE FROM liste_absents_provisoires WHERE date<".quote_smart($sql_insert_date);
  //DEBUGG echo htmlspecialchars($sql)."<br />";
  mysql_query($sql);
  if (isset($_POST['soumettre'])) // si le bouton Envoyer a t enfonc
  {  
     /* code correspondant  la transmission des informations  la vie scolaire */
     /* slectionne les enregistrements  envoyer (ceux qui correspondent  l utilisateur courant du script,
     dans la mesure o plusieurs accs simultans peuvent avoir lieu sur la table liste_absents_provisoires,
     il faut identifier la provenance des donnes.) */

     $sql = "SELECT * FROM liste_absents_provisoires WHERE id_pers='".quote_smart($prof)."' AND debut='".quote_smart($debut)."' AND classe='".quote_smart($classe)."' AND ".$sql_date;
    // DEBUGG echo $sql."<br />";
     $resultat = mysql_query($sql);

     // garde une trace de la transaction, identification par autoincrmentation

     if (!$id_transaction) // Si la transaction n' existe pas dans la table liste_absents_transactions
     {
       if (isset($prof)&&isset($debut)&&isset($classe))
       {
         if ($bloc2h=="2h") // Si c'est un bloc de deux heures
         {
           // On cherche la dernire heure de la matine et de l'aprs-midi (ce sont celles qui ne peuvent pas se trouver au dbut d'un bloc de deux heures
           $sql3 = "SELECT * from horaires";
           // DEBUGG echo "$sql3<br />";
           $resultat3 = mysql_query($sql3);
           $ligne3 = mysql_fetch_array($resultat3);
           $h_fin_matin = substr($ligne3['debut_matin'],0,2)+$ligne3['nb_matin']-1;
           $m_fin_matin = substr($ligne3['debut_matin'],-2,2);
           $h_fin_aprem = substr($ligne3['debut_aprem'],0,2)+$ligne3['nb_aprem']-1;
           $m_fin_aprem = substr($ligne3['debut_aprem'],-2,2);
           $fin_matin = $h_fin_matin."h".$m_fin_matin;
           $fin_aprem = $h_fin_aprem."h".$m_fin_aprem;
           
           if ($debut!=$fin_matin && $debut!=$fin_aprem)  // Si bloc de deux heures possibles pour ces horaires
           {
             // On cherche l'heure suivante
             if (is_edt_import())
             	$tableau = horaires_print(recup_horaires_debut_cours());
             else
			 	$tableau = horaires();
           	 $indice=array_search($debut,$tableau); // on cherche l'indice du tableau correspondant  l'heure de dbut de cours
             $indice++; // on incrmente l'indice pour accder  l'horaire suivant
             $debut_2h=$tableau[$indice]; // on rcupre l'horaire suivant
             $sql1 = "INSERT INTO liste_absents_transactions VALUES(NULL,".$sql_insert_date.",'".quote_smart($prof)."','".quote_smart($debut)."','".quote_smart($classe)."')";
             $sql2="INSERT INTO liste_absents_transactions VALUES(NULL,".$sql_insert_date.",'".quote_smart($prof)."','".quote_smart($debut_2h)."','".quote_smart($classe)."')";
           }
           else
           {
             $sql1 = "INSERT INTO liste_absents_transactions VALUES(NULL,".$sql_insert_date.",'".quote_smart($prof)."','".quote_smart($debut)."','".quote_smart($classe)."')";
             $sql2="";
           }
         }
         else
         {
           $sql1 = "INSERT INTO liste_absents_transactions VALUES(NULL,".$sql_insert_date.",'".quote_smart($prof)."','".quote_smart($debut)."','".quote_smart($classe)."')";
           $sql2="";
         }
       }
       else
       {
         $sql1="";
         $sql2="";
       }
      // DEBUGG echo "$sql1<br />$sql2<br />";
      mysql_query($sql1);
      mysql_query($sql2);
     }
  
      // rcupre identification unique qui vient d tre cre

     if ($bloc2h=="2h") // Si c'est un bloc deux heures, on rcupre les deux transactions
     {
       // On cherche la dernire heure de la matine et de l'aprs-midi (ce sont celles qui ne peuvent pas se trouver au dbut d'un bloc de deux heures
       $sql3 = "SELECT * from horaires";
       $resultat3 = mysql_query($sql3);
       $ligne3 = mysql_fetch_array($resultat3);
       $h_fin_matin = substr($ligne3['debut_matin'],0,2)+$ligne3['nb_matin']-1;
       $m_fin_matin = substr($ligne3['debut_matin'],-2,2);
       $h_fin_aprem = substr($ligne3['debut_aprem'],0,2)+$ligne3['nb_aprem']-1;
       $m_fin_aprem = substr($ligne3['debut_aprem'],-2,2);
       $fin_matin = $h_fin_matin."h".$m_fin_matin;
       $fin_aprem = $h_fin_aprem."h".$m_fin_aprem;
       
       if ($debut!=$fin_matin && $debut!=$fin_aprem)  // Pas de bloc de deux heures valides pour ces horaires
       {
         // On cherche l'heure suivante
         if (is_edt_import())
             	$tableau = horaires_print(recup_horaires_debut_cours());
             else
			 	$tableau = horaires();
       	 $indice=array_search($debut,$tableau); // on cherche l'indice du tableau correspondant  l'heure de dbut de cours
         $indice++; // on incrmente l'indice pour accder  l'horaire suivant
         $debut_2h=$tableau[$indice]; // on rcupre l'horaire suivant
         $sql = "SELECT id_transaction FROM liste_absents_transactions WHERE ".$sql_date." AND id_pers='".quote_smart($prof)."' AND (debut='".quote_smart($debut)."' OR debut='".quote_smart($debut_2h)."') AND classe='".quote_smart($classe)."'";
       }
       else
       {
         $sql = "SELECT id_transaction FROM liste_absents_transactions WHERE ".$sql_date." AND id_pers='".quote_smart($prof)."' AND debut='".quote_smart($debut)."' AND classe='".quote_smart($classe)."'";
       }
     }
     else
     {
       $sql = "SELECT id_transaction FROM liste_absents_transactions WHERE ".$sql_date." AND id_pers='".quote_smart($prof)."' AND debut='".quote_smart($debut)."' AND classe='".quote_smart($classe)."'";
     }
 	// DEBUGG echo $sql."<br />";

     $result = mysql_query($sql);
     while($row = mysql_fetch_array($result))  // il n y a qu une ligne ou 2 lignes (si bloc deux heures)  rcuprer
     {
       $id = $row['id_transaction']; // contient le n d identification de la transaction
       $sql = "SELECT eleve_id FROM liste_absents_provisoires WHERE id_pers='".quote_smart($prof)."' AND debut='".quote_smart($debut)."' AND classe='".quote_smart($classe)."' AND ".$sql_date;
       // DEBUGG echo $sql."<br />";
       $resultat = mysql_query($sql);
       while ($ligne = mysql_fetch_array($resultat))
       { // pour chaque enregistrement  envoyer
         // cet enregistrement est crit dans la table dfinitive contenant la liste des absents
         $eleve = $ligne['eleve_id'];
         $sql = "INSERT INTO liste_absents VALUES($id,'".quote_smart($eleve)."')";
        // DEBUGG echo $sql."<br />";
         mysql_query($sql);
       }
     }

     /*
     Suppression des donnes envoyes de la table liste_absents_provisoires
     */

     $sql = "DELETE FROM liste_absents_provisoires WHERE id_pers='".quote_smart($prof)."' AND debut='".quote_smart($debut)."' AND classe='".quote_smart($classe)."' AND ".$sql_date;
    // DEBUGG echo $sql."<br />";
     mysql_query($sql);

     // affiche de nouveau le formulaire de dpart
 
     if (isset($id))
     {
       if (is_array($_SESSION['liste_classes']) && $_SESSION['liste_classes'][0] !="") // Si la saisie concernait un groupe cr manuellement
       {
          $classe = $_SESSION['liste_classes'][0]; // on pointe alors sur la premire classe du groupe dans le cahier d'appel
          unset($_SESSION['liste_classes']);
       }
       $ancre_classe = str_replace(" ","",$classe); // permettra de rediriger l'affichage du cahier d'apppel directement au niveau de la classe qui vient d'tre dfinie
  
      if ($date) // si la date est dfinie, alors c'est que les absences venant d'tre saisies ne sont pas du jour
       // mais  partir d'une modification par l'administration ou la vie scolaire sur une date donne
      {
        // DEBUGG var_dump($classe);
      	// on change de page et on va vers le cahier d'appel
        echo "<script type='text/javascript'>
        <!--
          window.location.href=\"".$GLOBALS['racine']."prive/admin/prive/cahier_appel.php?date=$date&imprimer=non#$ancre_classe\";
        //-->
        </script>";
      }
      else // point normal de passage lorsque la saisie concerne la date du jour, on affiche alors le cahier d'appel
      {
        // DEBUGG var_dump($classe);
        // on change de page et on va vers le cahier d'appel
        echo "<script type='text/javascript'>
        <!--
          window.location.href=\"bddabsences.php#$ancre_classe\";
        //-->
        </script>";
      }
      affiche_form_infos_plage_horaire("","","",""); // affichage du formulaire de collecte d infos sur plage horaire
     }
     else
     {
      $error_message = array("<div align='justify'>La notification d'absence pour cette classe et cet horaire a dj t effectue par un autre professeur (ou bien par vous mme mais pour une autre classe). Il s'agit probablement d'une erreur de saisie. Cliquer <a href=\"absences.php\">ici</a> pour renouveller l'opration. Si l'erreur persiste, contacter l'<a href=\"mailto:".email_encode($admin_email)."\">administrateur du site</a></div>","");
      affiche_erreurs($error_message);
      // On efface les donnes du POST
      unset($_POST);
      unset($_SESSION['post_imprimable']);
     }
   }
   else // si le bouton Envoyer n a pas t enfonc
   {
     if ((isset($ajouter) && $ajouter!="") || (isset($enlever) && $enlever!="")) // si le bouton /Ajouter/ a t enfonc
     {
      // il faut ajouter ou enlever l lve slectionn dans la liste provisoire des absents
       affiche_form_liste_absents($prof,$debut,$classe,$ajouter,$eleve,$list_absents,$enlever,$absents,$id_transaction,$bloc2h,$date,$sql_date,$sql_insert_date);
     }
     else
     {
       if (!isset($ok) || isset($annuler))
       { // si le bouton /Afficher la liste de la classe/ n a pas t enfonc ou si le bouton Annuler a t enfonc
         if (isset($annuler))
         {
           $sql = "DELETE FROM liste_absents_provisoires WHERE id_pers='".quote_smart($prof)."' AND debut='".quote_smart($debut)."' AND classe='".quote_smart($classe)."' AND ".$sql_date;
          // DEBUGG echo $sql."<br />";
           mysql_query($sql);
         }
         affiche_form_infos_plage_horaire("","","",$date); // affichage du formulaire de collecte d infos sur plage horaire
       } 
       else // si le bouton Afficher la liste de la classe ou le bouton Annuler a t enfonc
       {
         if ($ok && isset($_GET['modif_liste'])) // Si l'appel vient du lien [Ajouter] depuis le cahier d'appel
         {
            // alors l'id_transaction est fourni pour rcuprer les infos concernant le prof(le surveillant), l'heure et la classe concerne par la modification  faire
           $sql = "SELECT id_pers,debut,classe FROM liste_absents_transactions where id_transaction='".quote_smart($id_transaction)."'";
          // DEBUGG echo $sql."<br />";
           $resultat = mysql_query($sql);
           $ligne = mysql_fetch_array($resultat);
           $prof = $ligne['id_pers'];
           $debut = $ligne['debut'];
           $classe = $ligne['classe'];
           affiche_form_liste_absents($prof,$debut,$classe,$ajouter,$eleve,$list_absents,$enlever,$absents,$id_transaction,$bloc2h,$date,$sql_date,$sql_insert_date);
        }
        else 
        {
          // on vrifie que le champ prof,debut,classe ont t entrs pour viter une transaction vide
          if (!$prof || !$classe || !$debut)
          {
            $error_message = array("Certains champs obligatoires n'ont pas t renseigns.Cliquer <a href=\"absences.php\">ici</a> pour renouveller l'opration.","");
            affiche_erreurs($error_message);
            // comme il n'y a que le champ classe qui n'est pas pr-rempli, on peut supprimer le $_POST
            unset($_POST);
            unset($_SESSION['post_imprimable']);
          }
          else // c'est bon
          {
            // DEBUGG var_dump($sql_date);
          	affiche_form_liste_absents($prof,$debut,$classe,$ajouter,$eleve,$list_absents,$enlever,$absents,$id_transaction,$bloc2h,$date,$sql_date,$sql_insert_date);
          } // if !$prof ...
        }
       } // if (!ok....)
      } // if ($ajouter)
     } // if ($soumettre)
    } // if ($error_message[1] != "update_denied")
    else
    {
      affiche_erreurs($error_message);
    }
  } //if (connexion_mysql() && select_database())
}
else // L'utilisateur essaie d'invoquer ce script directement dans l'URL (interdit)
{
  $error_message = array("Vous tentez d'accder  un script qui n'est pas accessible directement  partir de l'URL... Utilisez les liens de navigation !","");
  affiche_erreurs($error_message);
}
?>