<?php
/**
 * c_bddabsences.php
 *
 * Ce script a t crit  l usage (non exclusif) des surveillants pour leur permettre
 * de recueillir les signalements des absences d lves pour le jour en cours. Il s'agit
 * du traditionnel cahier d'appel. Le script de saisie des absences est c_absences.php

 * 
 * Ce fichier fait partie du projet IntraEduWeb (IEW)
 * 
 * @package		IEW
 * @author			Sylvain GODM <sylvain.godme@gmail.com>
 * @version		$LastChangedRevision$, $LastChangedDate$
 * @copyright		2004-2012 Sylvain GODM
 * @link			http://iew.free.fr
 * @license		GPL License version 3 (http://www.gnu.org/licenses/gpl.html)
 * @filesource
 * 
 */
 
/* Dclaration des fonctions */

function affiche_cahier_d_appel($classe,$debut_plage_horaire,$error_message){
 
 //***************************** description ********************************//
 // Cette fonction affiche pour une classe donne ($classe) le cahier d appel
 // paramtres entrs:	$classe: 	contient le nom de la classe 
 // sortie : affichage HTML d un tableau type cahier d appel
 // auteur : S.GODM (sylvain.godme@gmail.com)
 // Date de cration : ?
 // Date de dernire mise  jour : 
 //***************************** Fin description *****************************//
 
 global $class_add_last, $date_jour;
	
 // DEBUGG var_dump($error_message,$debut_plage_horaire);
 echo "<table class='header_cahier_appel'><tr>";
 $ancre_classe = str_replace(" ","",$classe);
 echo "<td class='gauche'><a name=\"$ancre_classe\"></a>
 <h2 class='titre_classe'>Classe de $classe</h2>
 </td>";
 echo "<td class='droite'>
 <a href='edt.php?categorie=classes&amp;edt=$classe'><img src='".$GLOBALS['chemin_relatif']."images/edt.png' alt='[Emploi du temps]' title=\"Voir l'emploi du temps de la classe de ".$classe."\" /></a><img src='".$GLOBALS['chemin_relatif']."images/pixel.gif' width='20' alt='' /><a href='cahiers_textes.php?imprimable=oui&amp;date=".date_mysql_to_jjmmaaaa_tiret($date_jour)."&amp;set_classe=$classe'><img src='".$GLOBALS['chemin_relatif']."images/ctexte.png' alt='[Cahier de Textes]' title='Voir le Cahier de Textes de la classe de $classe' /></a>
 <a href=\"absences.php\"><img src='".$GLOBALS['chemin_relatif']."images/redo.png' alt='[Retour  la saisie des Absences]' title='Retour  la saisie des Absences' /></a></td>"; // titre du tableau
 echo "</tr></table>";
 // S'il y a un message d'erreur suite  une tentative pour retirer ou annuler des absences alors qu'on a pas les droits ncessaires
 // On l'affiche maintenant
 // Ce message d'erreur contient la classe (ou le groupe) sur laquelle cette tentative a t faite, si la classe en cours n'est pas concerne
 // On n'affichera pas de message
 // Il faut galement savoir
 $liste_classes = liste_classes_dans_groupe($error_message[1]); // au cas o le message contient le nom d'un groupe
 // DEBUGG var_dump($liste_classes);
 if (in_array($classe,$liste_classes) || stristr($error_message[1],$classe))
 // Au cas o un utilisateur aurait tent une suppression dans la table des absences sans avoir le droit de le faire, un message d'erreur est gnr, mais ne s'affiche que si la classe actuellement concerne est celle affiche
 {
   affiche_erreurs($error_message);
 }
 echo "<table class='ctextes' width='100%'>";
 $nbligne = round(count($debut_plage_horaire)/2); // Le nombre de lignes
 for ($i=0;$i<=($nbligne-1);$i++) 
 {
  if ($i == 0) // gestion des bordures arrondies
  {
  	$class_add_first = " topleft";
    $class_add_last = " topright";
  }
  elseif ($i == ($nbligne-1))
  {
  	$class_add_first = " bottomleft";
    $class_add_last = " bottomright";
  }
  else 
  {
  	$class_add_first = "";
    $class_add_last = "";
  }
  echo "<tr>";
  if (isset($debut_plage_horaire[$i])) // 1re colonne de plage horaire
  {
    echo "<th class='fond_sommaire".$class_add_first."'>$debut_plage_horaire[$i]</th>"; // debut plage horaire
    $class_add_last = ""; // Comme c la 1re colonne de plage horaire, le coin topright de la prochaine cellule ne doit pas $etre arrondie
    affiche_absents($classe,"CURRENT_DATE()",$debut_plage_horaire[$i]); // affiche la liste des absents de la plage horaire
  }
  else
  {
    echo "<th class='fond_sommaire".$class_add_first."'>&nbsp;</th>"; // debut plage horaire
  }
  $k = $i+$nbligne;
  if ($k == $nbligne)
  {
  	$class_add_first = " topleft";
    $class_add_last = " topright";
  }
  elseif ($k == (2*$nbligne-1))
  {
  	$class_add_first = " bottomleft";
    $class_add_last = " bottomright";
  }
  else 
  {
  	$class_add_first = "";
    $class_add_last = "";
  }
  if (isset($debut_plage_horaire[$k])) // 2me colonne de plage horaire
  {
    echo "<th class='fond_sommaire'>$debut_plage_horaire[$k]</th>";
    affiche_absents($classe,"CURRENT_DATE()",$debut_plage_horaire[$k]);
  }
  else
  {
    echo "<th class='fond_sommaire'>&nbsp;</th>";
    echo "<td class='affiche_absents".$class_add_last."'>&nbsp;</td>";
  }
  echo "</tr>";
 }
 echo "</table>";
 echo "<table class='footer_cahier_appel'><tr><td class='gauche'><a href=\"#bas\"> Bas de la page</a></td>
 <td class='droite'><a href=\"#haut\"> Haut de la page</a></td></tr></table>";
}


function affiche_absents($classe,$date,$debut)
{

//***************************** description *******************************//
 // Cette fonction affiche pour une classe donne ($classe) et dans la plage horaire
 // donne ($debut)la liste des absents  la date donne ($date : en principe le
 // jour en cours, CURRENT_DATE() il ne faut pas de guillemets sur $date dans $sql car CURRENT_DATE()
 // est une fonction mysql)
 // paramtres entrs	$date	:
 //			$debut	:	dbut de la plage horaire
 //			$classe: 	contient le nom de la classe
 // sortie : affichage HTML de la liste des absents
 // auteur : S.GODM (sylvain.godme@gmail.com)
 // Date de cration : ?
 // Date de dernire mise  jour : 
 //***************************** Fin description *****************************//

 global $champ, $class_add_last;
 // c'est exprs s'il n'y a pas de '' autour de $date dans la requte suivante car $date contient CURRENT_DATE()
 // et la requte ne fonctionne pas si l'on a 'CURRENT_DATE()'
 
 /* On recherche d'abord les absents dclars en classe entire : dans ce cas, prioritaire, les absences ventuelles signals pour un groupe pednant la mme heure
  * (ce qui ne devrait pas se produire) ne seront pas affiches, ce qui n'est pas un problme */
 
 $sql = "SELECT t3.eleve_id,nom,prenom,t1.id_transaction FROM liste_absents as t1,liste_absents_transactions as t2,eleves as t3 WHERE
 t2.date=".quote_smart($date)." AND t2.debut='".quote_smart($debut)."' AND t2.classe='".quote_smart($classe)."' AND
 t1.id_transaction=t2.id_transaction AND t3.eleve_id=t1.eleve_id";
 // DEBUGG echo $sql."<br />";
 $resultat = mysql_query($sql);
 if (mysql_num_rows($resultat)>0) // s il y a des absents dclars en classe entire
 {
  	echo "<td class='affiche_absents".$class_add_last."'>";
  	affiche_nom_prof($classe,$date,$debut);
  	echo "<table>";
  	while ($ligne = mysql_fetch_array($resultat))
	{
   		echo "<tr>";
		$eleve = $ligne['nom']." ".$ligne['prenom'];
   		$id_transaction = $ligne['id_transaction'];
   		$eleve_id = $ligne['eleve_id'];
   		affiche_eleve_absent($eleve,$eleve_id,$_SESSION['script'],$id_transaction,$champ,$classe);
   		echo "</tr>";
  	}
  	echo "</table><br />";
        affiche_lien_annuler_la_notification($_SESSION['script'],$id_transaction,$champ,$classe,$date);
        echo "</td>";
 }
 else // s il n' y a pas d'absents dclars en classe entire
 {
 	// Soit une transaction a t faite et pas d'absents, soit pas de transactions, soit transaction faite dans un groupe
	// qui concerne peut-tre la classe (avec ou sans absents dclars)
	echo "<td class='affiche_absents".$class_add_last."'>";
	////////
	//echo "Pas d'absent en classe entire<br />";
	////////
	/* peut-tre y a t-il des absents dclars dans un groupe-classe 
	Il faut donc chercher toutes les transactions d'absences faites  cette date et  cet horaire sur des groupes-classes
	puis regarder si la classe en cours est concerne par cette transaction */
	// c'est exprs s'il n'y a pas de '' autour de $date dans la requte suivante car $date contient CURRENT_DATE()
    // et la requte ne fonctionne pas si l'on a 'CURRENT_DATE()'
	$sql ="SELECT * FROM liste_absents_transactions,groupes WHERE date=".quote_smart($date)." AND debut='".quote_smart($debut)."' AND classe=nom";
    // DEBUGG echo $sql."<br />";
	$resultat1=mysql_query($sql);
	if (mysql_num_rows($resultat1)>0) // Il y a un ou plusieurs groupes-classes pour lesquels une transaction
					   // a t faite pour ce jour et pour cette plage horaire. On va chercher si la classe
					   // est concerne par ces dclarations d'absences
	{
		////////
		// DEBUGG echo mysql_num_rows($resultat1)." transaction(s) de groupe sur cette heure<br />";
		////////
		// la variable suivante sera ventuellement utilise pour dterminer si un sparateur <hr /> doit tre inclus aprs l'affichage de la notification d'absence pour ce groupe (dans le cas ou plusieurs notifications d'absences sont effectus aux mmes heures pour la mme classe, mais les lves tant dans des groupes diffrents)
        $numero_groupe=0;
		while ($ligne=mysql_fetch_array($resultat1)) // on examine chacun des groupes
		{
			$numero_groupe++;
			// DEBUGG echo $numero_groupe."me transaction de groupe<br />";
            $id_transaction=$ligne['id_transaction'];
			////////
			//echo $id_transaction."<br />";
			////////
			$nom_groupe=$ligne['nom'];
			$nom_prof=$ligne['prof'];
			$id_groupe=$ligne['id_groupe'];
			$id_responsable=$ligne['id_responsable']; 
			// On examine le groupe pour savoir s'il concerne la classe
			if ($id_responsable == 0) // Si c'est un groupe sconet, on cherche les divisions concernes par sa composition
			{
				$sql = "SELECT divisions_appartenance FROM structures, groupes WHERE code_structure=nom AND nom='".quote_smart($nom_groupe)."'";
				// DEBUGG echo $sql."<br />";
				$result_gpe_sconet=mysql_query($sql);
				$record = mysql_fetch_array($result_gpe_sconet);
				$divisions_appartenance = $record['divisions_appartenance'];
				$liste_divisions_appartenance = explode(",",$divisions_appartenance);
				if (in_array($classe,$liste_divisions_appartenance)) // le groupe concerne la classe
					$flag_classe = true; // on positionne le flag pour l'indiquer
				else
					$flag_classe = false;
			}
			else // C'est un groupe cr manuellement, mais on recherche galement si la classe en cours est concerne par la composition du groupe
			{
				$liste_classes = liste_classes_dans_groupe($nom_groupe);
				if (in_array($classe,$liste_classes))
					$flag_classe = true; // on positionne le flag pour l'indiquer
				else
					$flag_classe = false;
			}
	
			
			if ($flag_classe)
			{
    				////////
				// DEBUGG echo "le groupe $nom_groupe contient la classe de $classe<br />";
				////////
				// La classe en cours a-t-elle des lves inscrits dans ce groupe ?
				$sql = "SELECT nom,prenom,eleves.eleve_id,classe FROM groupes_eleves,eleves WHERE id_groupe='".quote_smart($id_groupe)."' AND eleves.eleve_id=groupes_eleves.eleve_id ORDER BY nom,prenom";
				// DEBUGG echo $sql."<br />";
				$new_result=mysql_query($sql);
				if (mysql_num_rows($new_result)>0) // oui, il y en a
				{
					if (mysql_num_rows($resultat1)>1 && $numero_groupe>1) // on spare les notifications par des profs diffrents par un <hr /> (sauf pour le dernier groupe, puisqu'il n'y a rien  afficher aprs)
                    	echo "<hr />";
					affiche_nom_prof($nom_groupe,$date,$debut);
					echo "<font color=\"green\"> (Groupe ".strtok($nom_groupe,"-").")</font>";
					// On cherche si des absents ont t indiqus pour ce groupe et faisant partie de la classe en cours
					$id_transaction=$ligne['id_transaction'];
					$nom_groupe=$ligne['classe'];
					$sql = "SELECT DISTINCT eleves.eleve_id,eleves.nom,prenom,liste_absents.id_transaction FROM liste_absents,eleves, groupes, groupes_eleves, liste_absents_transactions WHERE liste_absents.id_transaction='".quote_smart($id_transaction)."' AND liste_absents.eleve_id=eleves.eleve_id AND eleves.classe='".quote_smart($classe)."' AND groupes_eleves.id_groupe=groupes.id_groupe AND liste_absents_transactions.classe='$nom_groupe'";
					// DEBUGG echo $sql."<br />";
					$new_result1=mysql_query($sql);
					if ($new_result1 && (mysql_num_rows($new_result1)>0)) // Des absents ont t indiqus
					{
     					echo "<table>";
						while ($ligne = mysql_fetch_array($new_result1)) // pour chaque absent indiqu
						{
							echo "<tr>";
   							$eleve = $ligne['nom']." ".$ligne['prenom'];
   							$eleve_id = $ligne['eleve_id'];
   							$id_transaction = $ligne['id_transaction'];
							affiche_eleve_absent($eleve,$eleve_id,$_SESSION['script'],$id_transaction,$champ,$classe);
							echo "</tr>";
						}
						echo "</table><br />";
                        affiche_lien_annuler_la_notification($_SESSION['script'],$id_transaction,$champ,$classe,$date);
					}
					else
					{
						echo "<br />pas d'absent<br />";
                        affiche_lien_annuler_la_notification($_SESSION['script'],$id_transaction,$champ,$classe,$date);
					}
				}
				else // La classe en cours n'a pas d'inscrit dans le groupe => laisser la cellule vide
  				{
					////////
					// DEBUGG echo "Cette classe n'a pas d'inscrit dans le groupe<br />";
					////////
					echo "&nbsp;";
					break; // il faut sortir de la boucle while
				}
			}
			else // Le groupe en cours ne concerne pas la classe en cours, on vrifie si une transaction a tout de
			    // mme t faite pour la classe entire
  			{
				// c'est exprs s'il n'y a pas de '' autour de $date dans la requte suivante car $date contient CURRENT_DATE()
                // et la requte ne fonctionne pas si l'on a 'CURRENT_DATE()'
                $sql="SELECT * from liste_absents_transactions WHERE date=".quote_smart($date)." AND debut='".quote_smart($debut)."' AND classe='".quote_smart($classe)."'";
				$resultat2=mysql_query($sql);
				if (mysql_num_rows($resultat2)>0) // Une transaction a t faite pour la classe, mais pas d'absent dclar
				{
					$ligne=mysql_fetch_array($resultat2);
					$id_transaction=$ligne['id_transaction'];
					affiche_nom_prof($classe,$date,$debut);
					echo "<br />pas d'absent<br />";
                    affiche_lien_annuler_la_notification($_SESSION['script'],$id_transaction,$champ,$classe,$date);
					break; // il faut sortir de la boucle while
				}
				else // pas de transaction faite, laisser la cellule vide
				{
					echo "&nbsp;";
				}
			}
		}
	}
	else // Soit Il n'y a vraiment pas d'absent dclar, mme dans un groupe-classe, soit pas de transaction faite
  	{
		// c'est exprs s'il n'y a pas de '' autour de $date dans la requte suivante car $date contient 
                // et la requte ne fonctionne pas si l'on a ''
                $sql="SELECT * from liste_absents_transactions WHERE date=".quote_smart($date)." AND debut='".quote_smart($debut)."' AND classe='".quote_smart($classe)."'";
		$resultat3=mysql_query($sql);
		if (mysql_num_rows($resultat3)>0) // Une transaction a t faite pour la classe, mais pas d'absent dclar
		{
			$ligne=mysql_fetch_array($resultat3);
			$id_transaction=$ligne['id_transaction'];
			affiche_nom_prof($classe,$date,$debut);
			echo "<br />pas d'absent<br />";
                        affiche_lien_annuler_la_notification($_SESSION['script'],$id_transaction,$champ,$classe,$date);
		}
		else // pas de transaction faite, laisser la cellule vide
		{
			echo "&nbsp;";
		}
	}
	echo "</td>";
 }

}

function affiche_nom_prof($classe,$date,$debut){

//***************************** description ********************************//
 // cette fonction affiche le nom du professeur qui a rempli le cahier d 'appel
 // Si aucun nom ne correspond, rien ne s'affichera et cela signifiera que le prof
 // n'a pas encore envoy la liste des absents ou a oubli de le faire
 // paramtres entrs	$date	:	
 //			$debut	:	dbut de la plage horaire 
 //			$classe: 	contient le nom de la classe
 // sortie : affichage HTML nom du professeur, et retour du numro de transaction (si le prof a rempli le cahier d'appel). Cette valeur 
 // est ensuite teste dans le script d'appel, et si elle n'est pas retourne, rien 
 // n'est affich dans le cahier d'appel. Dans le cas contraire, la liste des 
 // absents est alors affiche ou bien la notification <pas d'absent> le cas chant.
 // auteur : S.GODM (sylvain.godme@gmail.com)
 // Date de cration : 19/05/02
 // Date de dernire mise  jour : 
 //***************************** Fin description *****************************//

// c'est exprs s'il n'y a pas de '' autour de $date dans la requte suivante car $date contient 
// et la requte ne fonctionne pas si l'on a ''
$sql = "SELECT liste_absents_transactions.id_pers,nom,prenom,id_transaction,nomlogin FROM liste_absents_transactions,login WHERE classe='".quote_smart($classe)."' AND debut='".quote_smart($debut)."' AND date=".quote_smart($date)." AND liste_absents_transactions.id_pers=login.id_pers";
// DEBUGG echo $sql."<br />";
$resultat = mysql_query($sql);
if (mysql_num_rows($resultat)):
$ligne = mysql_fetch_row($resultat);
if ($ligne[1]=="") // Si pas de nom dfini dans la table login (ex : admin) => on affichera le nom de login
	$prof = $ligne[4];
else
	$prof = $ligne[1]." ".substr($ligne[2],0,1).strtolower(substr($ligne[2],1,strlen($ligne[2])-1));
$id_transaction = $ligne[3];
echo "Professeur ou Surveillant(e) :  <br /><span class='nom_prof_cahier_appel'>$prof</span>";
endif;
return $id_transaction;
}

function affiche_form_gestion()
{
  //***************************** description ********************************//
 // cette fonction affiche le formulaire de gestion des dates de consultation
 // du cachier d'appel
 // Date de cration : 03/03/2005
 // Date de dernire mise  jour : 
 //***************************** Fin description *****************************//
 echo "<a name='bas'></a><br /><br /><br /><center>";
  $code_formulaire = "<br />Cet accs est strictement rserv aux personnes charges de la gestion des absences.<br /><br /><a href='".$GLOBALS['racine']."./prive/admin/prive/cahier_appel.php?autre_date=oui'>Consultation du cahier d'appel pour d'autres dates</a><br /><br />";
  squelette_formulaire_standard("75%","","","Rserv  la Vie Scolaire",$code_formulaire,"","","","","","","");
  echo "</center>";
}

/* Dbut du programme principal */

// Le script en cours doit tre le script d'appel prvu
if (end_with_string($_SERVER['PHP_SELF'],"prive/bddabsences.php"))
{
  if (isset($_GET['id_transaction']))
    $id_transaction = $_GET['id_transaction'];
  if (isset($_GET['eleve_id']))
    $eleve_id = $_GET['eleve_id'];
  
  // Les variables suivantes ne servent pas dans ce script, mais font partie des paramtres de fonctions externes
  // donc il faut les fournir alors on les initialise  vide
  $_SESSION['script'] = "";
  global $champ, $date_jour;
  $champ = "";
    
  ?>
  <!-- Affichage du titre de la page -->
  <br />
  <h1>Cahier d'appel des classes<br />du <?php echo affiche_date(""); ?></h1>
  <?php
  $date_jour = date("Y-m-d"); // date du jour au format mysql
  // test si la date est un jour ouvrable de l'tablissement ou non
   if (!test_jour_ouvrable(date_mysql_to_jjmmaaaa($date_jour)) || !test_jour_dans_periode_scolaire($date_jour))
   {
     $error_message = array("Le ".format_date_long($GLOBALS['default_language'],date_mysql_to_jjmmaaaa($date_jour))." n'est pas un jour ouvrable dans l'tablissement ou tombe pendant les vacances scolaires !","");
     affiche_erreurs($error_message);
     // on affiche le formulaire de gestion administrative de ces pages
     affiche_form_gestion();
     return; // le script est alors interrompu
   }
  ?>
  <br />
  Voici, en temps rel, la liste des absents <b><u>du jour</u></b> transmises par les professeurs ou surveillants. Si vous restez sur cette page un certain temps il est conseill de cliquer sur le bouton <b>Actualiser</b> du navigateur pour rafrachir les informations de temps en temps.<br />Pour un autre type d'affichage,<a href='#bas'> voir en bas de cette page</a>.<br /><br />
  <?php
  
  // On rcupre les horaires de dbut de cours de l'tablissement
  if (is_edt_import())
  {
  	$debut_plage_horaire = array();
  	$plage_horaire_provisoire = horaires_print(recup_horaires_debut_cours()); // Ce tableau commence  l'indice 1
  	// Mais pour la suite (bon fonctionnement de l'affichage du cahier d'appel), on a besoin qu'il commence  l'indice 0
  	foreach ($plage_horaire_provisoire as $value)
  	{
  		$debut_plage_horaire[] = $value;
  	}
  	// On a donc maintenant un tableau $debut_plage_horaire dont l'indice de dpart est bien 0
  }
  else
	$debut_plage_horaire = horaires();
  
  global $classe_del;
  if (isset($_GET['retirer']) && $_GET['retirer']=="ok") // L appel du script a t fait en cliquant sur le lien RETIRER  ct du nom
  { // d un lve absent, il faut donc effectuer le traitement correspondant avant d afficher la liste
    // des absents
    if (check_del_access_absences($id_transaction)) // On vrifie si l'utilisateur a le droit de retirer l'lve de la liste des absents enregistrs dans le cahier d'appel
    {
      $sql = "DELETE FROM liste_absents WHERE id_transaction='".quote_smart($id_transaction)."' AND eleve_id='".quote_smart($eleve_id)."'";
      // DEBUGG echo $sql."<br />";
      mysql_query($sql);
    }
    else // s'il n'a pas le droit, on affiche un message d'erreurs
    {
      $error_message = array("Vous n'avez pas les droits vous permettant de raliser cette opration.","$classe_del");
    }
  }

  if (isset($_GET['effacer']) && $_GET['effacer']=="ok") // L appel du script a t fait en cliquant sur le lien ANNULER LA NOTIFICATION  ct du nom
  {
    if (check_del_access_absences($id_transaction)) // On vrifie si l'utilisateur a le droit de retirer l'lve de la liste des absents enregistrs dans le cahier d'appel
    {
      // on efface les absents dj dclars
      $sql = "DELETE FROM liste_absents WHERE id_transaction='".quote_smart($id_transaction)."'";
      // DEBUGG echo $sql."<br />";
      mysql_query($sql);
      // on efface la trace de la transaction
      $sql = "DELETE FROM liste_absents_transactions WHERE id_transaction='".quote_smart($id_transaction)."'";
      // DEBUGG echo $sql."<br />";
      mysql_query($sql);
    }
    else // s'il n'a pas le droit, on affiche un message d'erreurs
    {
      $error_message = array("Vous n'avez pas les droits vous permettant de raliser cette opration.","$classe_del");
    }
  }
  
  $sql = "SELECT division FROM divisions";
  $resultat = mysql_query($sql);
  while ($ligne = mysql_fetch_array($resultat)){
  affiche_cahier_d_appel($ligne["division"],$debut_plage_horaire,$error_message);
  echo "<br />";
  }
  ?><br />
  <table width="100%">
  <tr>
  <td width="50%" align="center"><font color="red"><u><b>Absences du jour</b></u></font></td>
  <td width="50%" align="center"><font color="red"><u><b>Recherche</b></u></font></td>
  </tr>
  <tr>
  <td width="50%">
    <a href="abs_affichage.php?critere=th">Affichage par tranche horaire</a><br />
    <a href="abs_affichage.php?critere=dp">Absences des demi-pensionnaires</a></td>
  <td width="50%" align="right"><label for="Form_Eleve_Nom">Entrer le nom d'un lve :</label>
    <form method="post" action="recherche_absent.php">
      <p><input id="Form_Eleve_Nom" type="text" name="eleve" size="15" /><input type="submit" value="Rechercher" name="soumettre" /></p>
    </form>
  </td>
  </tr>
  </table>
  <?php
  // on affiche le formulaire de gestion administrative de ces pages
  affiche_form_gestion();
}
else // L'utilisateur essaie d'invoquer ce script directement dans l'URL (interdit)
{
  $error_message = array("Vous tentez d'accder  un script qui n'est pas accessible directement  partir de l'URL... Utilisez les liens de navigation !","");
  affiche_erreurs($error_message);
}
?>