<?php
/**
 * c_consult_bddelev.php
 *
 * Page de rsultat de recherche sur la base lves
 * 
 * Ce fichier fait partie du projet IntraEduWeb (IEW)
 * 
 * @package		IEW
 * @author			Sylvain GODM <sylvain.godme@gmail.com>
 * @version		$LastChangedRevision$, $LastChangedDate$
 * @copyright		2004-2012 Sylvain GODM
 * @link			http://iew.free.fr
 * @license		GPL License version 3 (http://www.gnu.org/licenses/gpl.html)
 * @filesource
 * 
 */

// Le script en cours doit tre le script d'appel prvu
if (end_with_string($_SERVER['PHP_SELF'],"prive/admin/consult_bddelev.php"))
{
  /* Initialisations */
  if (isset($_POST['nom']))
    $nom = $_POST['nom'];
  else
    $nom = "";
  if (isset($_POST['prenom']))
    $prenom = $_POST['prenom'];
  else
    $prenom = "";
  if (isset($_POST['classe']))
    $classe = $_POST['classe'];
  else
    $classe = "";
  if (isset($_POST['doublement']))
    $doublement = $_POST['doublement'];
  else
    $doublement = "";
  if (isset($_POST['option_langue']))
  {
  	$fragment = explode ("%",$_POST['option_langue']); // $_POST['option_langue'] est au format libelle_option%code_matiere
  	$libelle_option_langue = $fragment[0]; // on rcupre le libelle de l'option langue
  	$option_langue = $fragment[1]; // on rcupre le code matire
  }
  else
    $option_langue = "";
  if (isset($_POST['regime']))
    $regime = $_POST['regime'];
  else
    $regime = "";
  $and="";
    
  // On vrifie d'abord les entres de formulaire
  if (isset($_POST) && count($_POST)!=0)
  {
    $champs_obligatoires = array($_POST['nom'],$_POST['prenom'],$_POST['classe']);
    if (!filled_out($champs_obligatoires))
    {
      $error_message = array("Certains champs obligatoires ne sont pas remplis ! Veuillez <a href='../bddelev.php'>recommencer</a>.","");
      affiche_erreurs($error_message);
      return;
    }
  
    echo "<h1>Rsultat de la recherche</h1>";
    // DEBUGG var_dump($_POST);
    connexion_mysql();
    select_database();
    //$sql="SELECT DISTINCT nom,prenom,id_eleve,eleves.eleve_id,date_naiss,code_sexe,doublement,code_matiere,options.num_option,regimes.libelle_court,classe FROM eleves,options,regimes WHERE ";
    $sql = "SELECT id_eleve,eleve_id,nom,prenom,date_naiss,code_sexe,doublement,code_regime,classe FROM eleves WHERE ";
    // DEBUGG print $sql."<br />";
    $long_init_sql=strlen($sql);  // la chane $sql va s agrandir, on mmorise sa longueur initiale
    $tableau = array('nom' => $nom, 'prenom' => $prenom, 'classe' => $classe, 'doublement' => $doublement,'option_langue' => $option_langue, 'regime' => $regime);  // tableau de correspondance entre les noms des champs du formulaire
    // de recherche et les noms des champs de la table mysql interroge
    $champ_mysql=array_keys($tableau); // contient la liste des champs mysql
    // On va complter la requte avec les critres de recherche sur certains champs
    foreach ($champ_mysql as $value) 
    {
      // On prpare les donnes postes
      $tableau[$value] = trim(htmlspecialchars(quote_smart($tableau[$value])));
      // Si le critre de recherche pour ce champ n'est pas renseign
      if ($tableau[$value]=="" || $tableau[$value]=="tous" || $tableau[$value]=="toutes")
      {
        $and=""; // variable servant  lier plusieurs conditions where dans la requte mysql
      }
      else // si le champ de formulaire n'est pas vide et ne contient pas tous ou toutes
      {
        if (($value=="classe") && substr($tableau[$value],0,1) == "%") // si le champ est le champ classe et qu'on a slectionn un niveau
        {
        	// il faut rcuprer le mef depuis le format %code_mef%libelle_long
        	$fragment = explode("%",$_POST['classe']); // c'est fragment[2] qui contient le libelle du niveau
        	$where[$$value]= "classe IN(SELECT code_structure FROM structures WHERE type_structure='D' AND code_mef LIKE '%".$fragment[1]."%' )";
        }
        else // il s'agit d'un autre champ que le champ classe (le chr(39) correspond au guillemet simple)
        { 
          if (strstr($tableau[$value],"*")) // S'il y a un joker dans le champ de saisie
          {
            $morceaux = explode("*",$tableau[$value]);
            $where[$$value]=$value." LIKE ".chr(39).$morceaux[0]."%".$morceaux[1].chr(39);
          }
          else // pas de joker
          {
            // Si c'est une langue qui est recherche
            if ($value=='option_langue')
            {
              $where[$$value]="eleve_id IN(SELECT eleve_id FROM options WHERE code_matiere='".quote_smart($tableau[$value])."')";
            }
            elseif ($value == 'regime') // ici rgime ne concerne que les demi-pensionnaires...
            	$where[$$value]="code_regime IN (2,6,21,22,23,24,25,26,29)"; // ce sont les codes rgimes pour tous les types de demi-pensionnaires (voir table regimes)  
            elseif ($value == 'doublement')
            	$where[$$value]="doublement='1'";
            else // cas normal (autre chose que la langue et que le regime et le doublement)
              $where[$$value]=$value." = ".chr(39).$tableau[$value].chr(39);  // condition where correspondant au champ mysql avec la valeur du champ de formulaire
          }  
        }
      }
      if (isset($where[$$value]) && $where[$$value]!="")
      {
        $sql=$sql.$and.$where[$$value]; // la requte s'allonge
        unset($where[$$value]); // vite la rptition dans le prochain tour de boucle
      }
      if (strlen($sql)!=$long_init_sql) // si la chane $sql a dj grandit par rapport  la valeur initialise plus haut
      {
        $and=" AND "; // alors il faut un oprateur logique pour lier les conditions where successives
      }
    }
    $tri = " ORDER BY classe,nom,prenom";
    $sql = $sql.$tri; // fin de la descrition de la requte : classement
    $ctrl = explode("WHERE ",$sql); // qu y a t-il aprs WHERE ?
    if ($ctrl[1]==$tri): // s il n y a rien entre WHERE et ORDER, retirer WHERE, on fait une recherche sur tous les lves de l'tablissement
    	$sql = $ctrl[0].$tri;
    endif;
    // DEBUGG print $sql."<br />";
  
    // Prsentation du rsultat
    echo "<u>La recherche porte sur :</u><b> ";
    if ($_POST['nom']=="tous" && $_POST['prenom']=="tous")
    {
      $recherche_nom = "Tous les lves";
    }
    elseif ($_POST['nom']!="tous" && $_POST['prenom']!="tous")
    {
      $recherche_nom = "Nom : ".stripslashes($_POST['nom'])." "."Prnom : ".stripslashes($_POST['prenom']);
    }
    elseif ($_POST['nom']!="tous")
    {
      $recherche_nom = "Nom : ".stripslashes($_POST['nom']);
    }
    elseif ($_POST['prenom']!="tous")
    {
      $recherche_nom = "Prnom : ".stripslashes($_POST['prenom']);
    }
    if ($_POST['classe']=='toutes')
    {
      $recherche_classe = "Dans toutes les classes";
    }
    elseif (substr($_POST['classe'],0,1) == "%") // Si un niveau est slectionn $_POST['classe'] est alors au format %code_mef%libelle_long
    {
      	$fragment = explode("%",$_POST['classe']);
    	$recherche_classe = "Dans le niveau : ".$fragment[2];
    }
    else
    {
      $recherche_classe = "Dans la classe de : ".$_POST['classe'];
    }
    echo $recherche_nom.", ".$recherche_classe;
    // autres champs
    $autres_champs = array("option_langue","doublement","regime");
    foreach ($autres_champs as $value)
    {
      if (isset($_POST[$value]) && $_POST[$value]!="")
      {
        if ($value=="option_langue")
          echo ", Option : ".$libelle_option_langue;
        elseif ($value=="regime")
          echo ", Demi-pensionnaires";
        elseif ($value=="doublement")
          echo ", Redoublant";
        else
          echo ", ".$_POST[$value];
      }
    }
    echo "</b><br /><br />";
  }
  elseif (isset($_GET['classe']))
  {
    $classe = $_GET['classe'];
    $sql = "SELECT id_eleve,eleve_id,nom,prenom,date_naiss,code_sexe,doublement,classe FROM eleves WHERE classe='$classe' ORDER BY nom,prenom";
  }
  // DEBUGG print $sql."<br />";
  $resultat = mysql_query($sql);
  $i=0;
  $nbligne = mysql_num_rows($resultat);
  ?>
  <table border="0" cellpadding="3" width="100%">
  <?php
  echo "<tr>
  <td><i>Il y a <b><font color=\"red\">$nbligne</font></b> fiche(s) lve(s) trouve(s).</i></td>
  <td><a href='../bddelev.php'>[Effectuer une autre Recherche]</a></td>
  <td align='right'>";
  if ($nbligne>=10)
  	echo "<a href='#bas'>Bas de la page</a>";
  echo "</td>
  </tr>";  
  ?>
  </table>
  <table class="ctextes edt">
   <tr>
    <td bgcolor="#FFCC99" align="center" class="topleft"><font color="brown"><b>Nom</b></font></td>
    <td bgcolor="#FFCC99" align="center"><font color="brown"><b>Prnom</b></font></td>
    <td bgcolor="#FFCC99" align="center"><font color="brown"><b>Date de naissance</b></font></td>
    <td bgcolor="#FFCC99" align="center"><font color="brown"><b>Sexe</b></font></td>
    <td bgcolor="#FFCC99" align="center"><font color="brown"><b>Red</b></font></td>
    <td bgcolor="#FFCC99" align="center"><font color="brown"><b>Opt1</b></font></td>
    <td bgcolor="#FFCC99" align="center"><font color="brown"><b>Opt2</b></font></td>
    <td bgcolor="#FFCC99" align="center"><font color="brown"><b>Opt3</b></font></td>
    <td bgcolor="#FFCC99" align="center"><font color="brown"><b>Rg</b></font></td>
    <td bgcolor="#FFCC99" align="center" class="topright"><font color="brown"><b>Classe</b></font></td>
   </tr>
   <?php
  while($ligne = mysql_fetch_array($resultat))
  {
    $i++;
    // si $i est pair, on colore lgrement le fond de la cellule, sinon on laisse en blanc
    if (is_int($i/2))
    {
      $class = "corps_formulaire";
    }
    else
    {
      $class = "";
    }
  	if ($i == $nbligne)
    {
    	$class_add_first = " bottomleft";
      	$class_add_last = " bottomright";
    }
    list($annee,$mois,$jour)=explode("-",$ligne["date_naiss"]);
    $date_naissance = $jour."/".$mois."/".$annee;
    echo "<tr>
    <td class='".$class.$class_add_first."' align='left'><a href='fichelev.php?id_eleve=".$ligne['id_eleve']."&amp;imprimable=oui' title='Consulter la fiche de cet(te) lve'>".$ligne["nom"]."</a></td>
    <td class='".$class."' align='left'>".$ligne["prenom"]."</td>
    <td class='".$class."' align='center'>".$date_naissance."</td>";
    if($ligne['code_sexe'] == 1)
    	$sexe = "M";
    elseif($ligne['code_sexe'] == 2)
    	$sexe = "F";
    else
    	$sexe = "NC"; // Non connu
    echo "
    <td class='".$class."' align='center'>".$sexe."</td>";
    if($ligne['doublement'] == 0)
    	$doublement = "Non";
    elseif($ligne['doublement'] == 1)
    	$doublement = "Oui";
    else
    	$doublement = "NC"; // Non connu
    echo "
    <td class='".$class."' align='center'>".$doublement."</td>";
    // Options LV1, LV2 + 3me option
    $sql1 = "SELECT code_gestion FROM matieres_sconet as t1,options as t2 WHERE t2.eleve_id='".$ligne['eleve_id']."' AND t1.code_matiere=t2.code_matiere ORDER BY num_option";
    // DEBUGG print $sql1."<br />";
    $resultat1 = mysql_query($sql1);
    for ($j=1;$j<=3;$j++) // Si on veut + de 3 options (lyce, faudra retoucher le code)
    {
    	$ligne1 = mysql_fetch_array($resultat1);
    	echo "
    	<td class='".$class."'>".$ligne1['code_gestion']."</td>";	
    }
    if (!isset($ligne['libelle_court'])) // si le rgime n'est pas encore connu
    {
    	$sql2 = "SELECT libelle_court FROM regimes as t1, eleves as t2 WHERE t1.code_regime=t2.code_regime AND eleve_id='".$ligne['eleve_id']."'";
    	$resultat2 = mysql_query($sql2);
    	$ligne2 = mysql_fetch_array($resultat2);
    	$ligne['libelle_court'] = $ligne2['libelle_court'];
    }
    echo "<td class='".$class."' align='center'>".$ligne['libelle_court']."</td>";
    echo "<td class='".$class.$class_add_last."' align='center'>".$ligne["classe"]."</td>
  </tr>";
  }

  ?>
  </table>
  <table border="0" width="100%">
    <tr>
      <td width="50%"></td>
      <?php
      if ($nbligne>=10):
       ?>
       <td width="50%" align="right" valign="top">&nbsp;<a href="#haut">Haut de la page</a></td>
       <?php
      endif;
      ?>
    </tr>
  </table>
  <?php
}
else // L'utilisateur essaie d'invoquer ce script directement dans l'URL (interdit)
{
  $error_message = array("Vous tentez d'accder  un script qui n'est pas accessible directement  partir de l'URL... Utilisez les liens de navigation !","");
  affiche_erreurs($error_message);
}
?>