<?php
/**
 * c_fichelev.php
 *
 * Permet la consultation d'une fiche lve
 * 
 * Ce fichier fait partie du projet IntraEduWeb (IEW)
 * 
 * @package		IEW
 * @author			Sylvain GODM <sylvain.godme@gmail.com>
 * @version		$LastChangedRevision$, $LastChangedDate$
 * @copyright		2004-2012 Sylvain GODM
 * @link			http://iew.free.fr
 * @license		GPL License version 3 (http://www.gnu.org/licenses/gpl.html)
 * @filesource
 * 
 */

function barre_navigation($pointeur)
{
  // Cette fonction affiche les contrles graphiques d'avance/retour et avance rapide/retour rapide
  // lors de la consultation des fiches individuelles lves d'une classe
  // la valeur $pointeur indique la cl menant  l'identifiant lve courant dans le tableau $liste_eleves_classe
  // qui contient les identifiants de tous les lves de la classe
  
  // Mais ne fonctionne pas pour les parents qui n'ont pas le droit de voir d'autres fiches que celles de leurs enfant
  if ($_SESSION['valid_group']=='4')
    return;

  global $liste_eleves_classe;
  echo
    "<table class='nav_fast_fichelev' width='100%'> 
      <tr>
        <td align='left' width='50%'>";
        if ($pointeur!=0) // Si c'est le premier lve de la classe, il ne faut pas afficher les les contrles graphiques de retour/retour rapide
          echo "<a href='".$_SERVER['PHP_SELF']."?id_eleve=".$liste_eleves_classe[0]."'><img src='".$GLOBALS['chemin_relatif']."images/previous.png' alt='Premier lve de cette classe' title='Premier lve de cette classe' /></a>
          <a href='".$_SERVER['PHP_SELF']."?id_eleve=".$liste_eleves_classe[$pointeur-1]."'><img src='".$GLOBALS['chemin_relatif']."images/little_previous.png' alt='Elve prcdent dans la classe' title='Elve prcdent dans la classe' /></a>";
        echo "</td>
        <td align='right' width='50%'>";
        if ($pointeur!=count($liste_eleves_classe)-1) // Si c'est le dernier lve de la classe, il ne faut pas afficher les contrles graphiques d'avance/avance rapide
          echo "<a href='".$_SERVER['PHP_SELF']."?id_eleve=".$liste_eleves_classe[$pointeur+1]."'><img src='".$GLOBALS['chemin_relatif']."images/little_next.png' alt='Elve suivant dans la classe' title='Elve suivant dans la classe' /></a>
          <a href='".$_SERVER['PHP_SELF']."?id_eleve=".$liste_eleves_classe[count($liste_eleves_classe)-1]."'><img src='".$GLOBALS['chemin_relatif']."images/next.png' alt='Dernier lve de cette classe' title='Dernier lve de cette classe' /></a>";
        echo "</td>
      </tr>
    </table>";
}

function affiche_donnees_parents()
{
  global $ligne_parents,$code_formulaire;
  $tab = $ligne_parents; // initialisation d'un tableau, qui contient les donnes personnelles du parents telles qu'elles ont t rcupres dans la base
  if ($tab['resp_legal'] != 0)
  {
  	$qualite = "Responsable Lgal n".$tab['resp_legal'];
  }
  else
  {
  	$qualite = "Autre personne";
  }
  $code_formulaire .="
  <div class='titre_cadre_formulaire' align='left'><b>Contacts famille =&gt; ".$qualite."</b></div>
  <div class='cadre_formulaire_gris' align='center'>
  <p>
  <label for='Form_Nom".$tab['resp_legal']."'>Nom&nbsp;:</label> <input type='text' name='nom' id='Form_Nom".$tab['resp_legal']."' size='25' value=\"".stripslashes($tab['nom'])."\" readonly='readonly' />
  <label for='Form_Prenom".$tab['resp_legal']."'>Prnom&nbsp;:</label> <input type='text' name='prenom' id='Form_Prenom".$tab['resp_legal']."' size='25' value=\"".stripslashes($tab['prenom'])."\" readonly='readonly' />
  </p><br />
  <p>
  <label for='Form_Adresse".$tab['resp_legal']."'>Adresse&nbsp;:</label> <input type='text' name='ligne1_adresse' id='Form_Adresse".$tab['resp_legal']."' size='30' value=\"".stripslashes($tab['ligne1_adresse'])."\" readonly='readonly' />
  </p><br />
  <p>
  <label for='Form_CP".$tab['resp_legal']."'>Code postal&nbsp;:</label> <input type='text' name='code_postal' id='Form_CP".$tab['resp_legal']."' size='5' value='".$tab['code_postal']."' readonly='readonly' /> 
  <label for='Form_Commune".$tab['resp_legal']."'>Commune&nbsp;:</label> <input type='text' name='commune' id='Form_Commune".$tab['resp_legal']."' size='30' value=\"".stripslashes($tab['libelle_postal'])."\" readonly='readonly' />
  </p><br />
  <p>
  <label for='Form_Telperso".$tab['resp_legal']."'>Tl (fixe)&nbsp;:</label> <input type='text' name='tel_fixe' id='Form_Telperso".$tab['resp_legal']."' size='13' value='".numtel($tab['tel_personnel'])."' readonly='readonly' /> 
  <label for='Form_Telmobile".$tab['resp_legal']."'>Tl (mobile)&nbsp;:</label> <input type='text' name='tel_mobile' id='Form_Telmobile".$tab['resp_legal']."' size='13' value='".numtel($tab['tel_mobile'])."' readonly='readonly' />
  </p><br />
  <p>
  <label for='Form_Mail".$tab['resp_legal']."'>Email&nbsp;:</label> <input type='text' name='email' id='Form_Mail".$tab['resp_legal']."' size='60' value='".$tab['mel']."' readonly='readonly' />
  </p>
  </div>
  <br />";
}

function affiche_autorisations_responsable_legal()
{
  global $record,$code_formulaire;
  if (isset($_POST) && count($_POST)!=0) // Le formulaire a dj t post, mais un champ manque ou contient une valeur invalide => il faut rafficher le formulaire avec les valeurs transmises
    $tab = $_POST; // voil les valeurs transmises
  else
    $tab = $record;
  // Seuls gestadmin, la direction, la vie scolaire et admin on le droit de modifier les autorisations de publications dans IEW
  /* Les parents avaient t initalement prvus pour tre autoriss  faire des modifications, mais aprs discussion avec la direction du collge Lonard de Vinci, il nous est apparu "risqu" de permettre des changements  tout moment : en effet si la photo d'un lve est dj publie (avec autorisation parentale) et qu'un parent sans crier gare modifie en refusant ce qu'il avait prcdemment accept, la responsabilit de l'tablissement pourrait tre engage. Nous avons prfr maintenir des autorisations figes pour une anne scolaire ( partir du document papier rempli par les parents en dbut d'anne scolaire) et traiter les demandes de modification au cas par cas, celles-ci tant ralises non pas par les parents eux-mmes, mais par la vie soclaire, qui devra alors au pralable vrifier qu'aucune publication existante n'est en contradiction avec les autorisations nouvellement modifies, et dans le cas contriare, il faudra procder  la suppresion de la publication qui ne serait plus en concordance avec les nouvelles autorisations parentales.
  Si toutefois, on veut permettre aux parents de modifier les autorisations  tout moment (et sans en avertir explicitement la vie scolaire), il suffirait d'ajouter,  la condition if suivante "$_SESSION['valid_group']=="5" */
  if ($_SESSION['valid_group']=="5" || $_SESSION['valid_group']=="6" || $_SESSION['valid_group']=="8" || $_SESSION['valid_group']=="1")
    $disabled = "";
  else
    $disabled = "disabled='disabled'";
  $code_formulaire .="
  <br /><a name='legal'></a>
  <div class='titre_cadre_formulaire' align='left'><h2 class='hidden'>Autorisations du Reprsentant Lgal dans le domaine TICE</h2><b>Autorisations du Reprsentant Lgal (Domaine TICE-Donnes Personnelles)</b></div>
  <div class='cadre_formulaire_gris' align='center'>
    <table class='auth_parentales'>
    <tr>
      <th class='fond_sommaire topleft'>Autorise</th>
      <th class='fond_sommaire'>Refuse</th>
      <th class='fond_sommaire topright'>Pour mon enfant :</th>
    </tr>";
  // On cherche dans la base de donnes la liste des autorisations du reprsentant lgal demandes par l'tablissement
  $sql = "SELECT * FROM autorisations_etab ORDER BY ordre";
  $liste_autorisations_etab = mysql_query($sql);
  if ($liste_autorisations_etab && mysql_num_rows($liste_autorisations_etab)>0)
  {
    $nb_autorisations = mysql_num_rows($liste_autorisations_etab);
    $i=1;
    while ($demande_autorisation = mysql_fetch_array($liste_autorisations_etab))
    {
      $background_ok = "";
      $background_no = "";
      $checked_ok = "";
      $checked_no = "";
      if ($i == $nb_lignes)
      {
    	$class_add_first = " bottomleft";
      	$class_add_last = " bottomright";
      }
      if (isset($record[$demande_autorisation["nom_champ"]]) && $record[$demande_autorisation["nom_champ"]]==1) // Si pour ce champ, il y a autorisation
      {  
        $background_ok = "style='background-color: #46eb4e;'";
        $background_no = "";
        $checked_ok = "checked='checked'"; // On coche le bouton radio correspondant
        $checked_no = ""; // On dcoche l'autre
      }
      elseif (isset($record[$demande_autorisation["nom_champ"]]) && $record[$demande_autorisation["nom_champ"]]==0) // Si pour ce champ, il y a refus
      {
        $background_no = "style='background-color: red;'";
        $background_ok = "";
        $checked_ok = ""; // On dcoche l'autorisation
        $checked_no = "checked='checked'"; // On coche le refus
      }
      else // Enfin si le champ n'et pas renseign
      {
        $checked_ok = ""; // On dcoche l'autorisation
        $checked_no = ""; // On dcoche le refus
      }
      $code_formulaire .="
      <tr>
        <td id='autorisation$i' class='$class_add_first' align='center' $background_ok><label class='hidden' for='".$demande_autorisation["nom_champ"]."btn_yes'>".$demande_autorisation["nom_champ"]."</label><input type='radio' name='".$demande_autorisation["nom_champ"]."' id='".$demande_autorisation["nom_champ"]."btn_yes' value='1' $checked_ok $disabled onclick=\"changeCouleur(document.getElementById('autorisation$i'),'#46eb4e',document.getElementById('refus$i'),'#e6e7e6')\" /></td>
        <td id='refus$i' align='center' $background_no><label class='hidden' for='".$demande_autorisation["nom_champ"]."btn_no'>".$demande_autorisation["nom_champ"]."</label><input type='radio' name='".$demande_autorisation["nom_champ"]."' id='".$demande_autorisation["nom_champ"]."btn_no' value='0' $checked_no $disabled onclick=\"changeCouleur(document.getElementById('refus$i'),'red',document.getElementById('autorisation$i'),'#e6e7e6')\" /></td>
        <td align='justify' class='$class_add_last'>".$demande_autorisation["detail"]."</td>
      </tr>
      ";
      $i++;
    }
  }
  $code_formulaire .="
    </table>
  </div><br />";
  // Seuls gestadmin, la direction, la vie scolaire et admin on le droit de modifier les autorisations de publications dans IEW
  /* Les parents avaient t initalement prvus pour tre autoriss  faire des modifications, mais aprs discussion avec la direction du collge Lonard de Vinci, il nous est apparu "risqu" de permettre des changements  tout moment : en effet si la photo d'un lve est dj publie (avec autorisation parentale) et qu'un parent sans crier gare modifie en refusant ce qu'il avait prcdemment accept, la responsabilit de l'tablissement pourrait tre engage. Nous avons prfr maintenir des autorisations figes pour une anne scolaire ( partir du document papier rempli par les parents en dbut d'anne scolaire) et traiter les demandes de modification au cas par cas, celles-ci tant ralises non pas par les parents eux-mmes, mais par la vie soclaire, qui devra alors au pralable vrifier qu'aucune publication existante n'est en contradiction avec les autorisations nouvellement modifies, et dans le cas contriare, il faudra procder  la suppresion de la publication qui ne serait plus en concordance avec les nouvelles autorisations parentales.
  Si toutefois, on veut permettre aux parents de modifier les autorisations  tout moment (et sans en avertir explicitement la vie scolaire), il suffirait d'ajouter,  la condition if suivante "$_SESSION['valid_group']=="5" */
  if ($_SESSION['valid_group']=="5" || $_SESSION['valid_group']=="6" || $_SESSION['valid_group']=="8" || $_SESSION['valid_group']=="1")
    $code_formulaire .="
    <input type='hidden' name='id_eleve' id='id_eleve' value='".$_GET["id_eleve"]."' />  
    <input type='submit' id='soumettre_autorisations' name='soumettre_autorisations' value='Enregistrer les nouvelles autorisations' />
    <br />";

  // Un peu de javascript pour changer dynamiquement la couleur du fond des cellules autorisation-refus en fonction du choix dans le formulaire
  echo "
  <script type='text/javascript'>
    function changeCouleur(cellule_ok,couleurFond_ok,cellule_no,couleurFond_no)
    {
      // Cette fonction modifie la couleur de fond
      cellule_ok.style.backgroundColor = couleurFond_ok;
      cellule_no.style.backgroundColor = couleurFond_no;
    }
  </script>";
}

/* Dbut du programme principal */

// Le script en cours doit tre le script d'appel prvu
if (end_with_string($_SERVER['PHP_SELF'],"prive/admin/fichelev.php"))
{
  global $code_formulaire,$ligne_parents,$record,$liste_eleves_classe;
	// Le clic droit est interdit sur la page
  protection_image();

  connexion_mysql();
  select_database();
  if (isset($_POST["soumettre_autorisations"])) // Les autorisations du reprsentant lgale viennent d'tre changes
  {
    $_GET['id_eleve'] = $_POST['id_eleve']; // Ceci permettra de rafficher la fiche lve
    $sql = "SELECT eleve_id FROM eleves WHERE id_eleve='".quote_smart($_GET['id_eleve'])."'";
    $result = mysql_query($sql);
    $ligne = mysql_fetch_array($result);
    // On ne sait pas encore si c'est une mise  jour ou une nouvelle insertion : on se prpare aux deux cas de figure
    $sql1 = "update autorisations_1 SET "; // dbut de la requte de mise  jour
    $sql3 = "INSERT INTO autorisations_1 VALUES('".$ligne['eleve_id']."',"; // dbut de la requte d'insertion
    $sql2 = "SELECT nom_champ from autorisations_etab ORDER BY id_autorisation"; // on rcupre le nom des champs
    $result2 = mysql_query($sql2);
    While ($ligne2 = mysql_fetch_array($result2))
    {
      $sql1 .= $ligne2['nom_champ']."='".quote_smart($_POST[$ligne2['nom_champ']])."',"; // on complte la requte de mise  jour
      $sql3 .= "'".quote_smart($_POST[$ligne2['nom_champ']])."',"; // on complte la requte d'insertion
    }
    $sql1 = preg_replace('#.$#', "", $sql1); // On retire le dernier cc (la virgule)
    $sql3 = preg_replace('#.$#', "", $sql3).")"; // On retire le dernier cc (la virgule) et on ferme la parenthse
    $sql1 .= " WHERE eleve_id='".$ligne['eleve_id']."'";
    // DEBUGG print $sql1."<br/>";
    $result1 = mysql_query($sql1); // On tente une mise  jour
    if ($result1 && mysql_affected_rows()==0) // la requte de mise  jour n'aboutit pas car l'enregistrement n'existe pas => il faut faire une requte INSERT ou alors il n'y a aucun changement par rapport  la base de donnes
    {
      $result3 = mysql_query($sql3); // On tente une insertion
      if ($result3 && mysql_affected_rows()>0) // et a marche
      {
        $ok_message = "Les <a href='#legal'>autorisations du reprsentant lgal</a> concernant cet lve ont t mises  jour.";
        affiche_ok($ok_message);
        unset($_POST);
        unset($_SESSION['post_imprimable']);
      }
      else // l'insertion ne marche pas non plus, donc il n'y a pas eu de changement
      {
        $error_message = array("Vous n'avez effectu aucun changement dans <a href='#legal'>les autorisations du reprsentant lgal</a> !","");
        affiche_erreurs($error_message);
        unset($_POST);
        unset($_SESSION['post_imprimable']);
      }
    }
    elseif ($result1 && mysql_affected_rows()>0) // la requte de mise  jour a abouti
    {
      $ok_message = "Les <a href='#legal'>autorisations du reprsentant lgal</a> concernant cet lve ont t mises  jour.";
      affiche_ok($ok_message);
      unset($_POST);
      unset($_SESSION['post_imprimable']);
    }
    else // autre cas
    {
      $error_message = array("Les <a href='#legal'>autorisations du reprsentant lgal</a> concernant cet lve n'ont pas pu tre mises  jour. Veuillez ressayer ultrieurement.","");
      affiche_erreurs($error_message); 
    }
  }
  if (isset($_GET['id_eleve']) && $_GET['id_eleve']!="")
  {
    // On recherche les infos concernant l'lve dans la base de donnes
    // Mais les parents connects n'ont le droit de voir que leurs enfants !!
    if ($_SESSION['valid_group']=="4")
      $sql = "SELECT t1.*, t3.libelle_long as regime FROM eleves as t1, responsables_eleves as t2,regimes as t3 WHERE t1.eleve_id=t2.eleve_id AND t2.personne_id='".quote_smart($_SESSION['identifiant_individu'])."' AND t1.id_eleve='".quote_smart($_GET['id_eleve'])."' AND t1.code_regime=t3.code_regime";
    else
      $sql = "SELECT t1.*, t3.libelle_long as regime FROM eleves as t1, regimes as t3 WHERE id_eleve='".quote_smart($_GET['id_eleve'])."'";
    // DEBUGG print $sql."<br />";
    $resultat = mysql_query($sql);
    if ($resultat)
    {
       if (mysql_num_rows($resultat)>0)
       {
         $ligne = mysql_fetch_array($resultat);
         $nom = $ligne['nom'];
         $prenom = $ligne['prenom'];
         $eleve_id = $ligne['eleve_id']; // lien numrique avec la table parents
         $info_legale = "";
         // Recherche des autorisations/refus du reprsentant lgal
         $sql = "SELECT * FROM autorisations_1 WHERE eleve_id='$eleve_id'";
         $result = mysql_query($sql);
         if ($result && mysql_num_rows($result)==1)
         {
           $record = mysql_fetch_array($result);
         }
         // DEBUGG var_dump($record);
         $date_naiss = date_mysql_to_jjmmaaaa($ligne['date_naiss']);
         if ($ligne['code_sexe'] == 1)
         	$sexe = "Masculin";
         elseif ($ligne['code_sexe'] == 2)
         	$sexe = "Fminin";
         else
         	$sexe = "?";
         $classe = $ligne['classe'];
         if ($ligne['doublement'] == 1)
         	$doublement = "Oui";
         else
         	$doublement = "Non";
         $regime = $ligne['regime'];
         $id_national = $ligne['id_national'];
         if (isset($record["pub_intranet"]) && $record["pub_intranet"]==1)
         {
           // rien  faire ?
         }
         else
         {
           $info_legale = "<font color='red'><strong><i>Conformment  l'article 34 de la loi &quot;Informatique et Liberts&quot; du 6 janvier 1978, Le responsable lgal de cet lve a refus (ou n'a pas encore explicitement accept) la publication des donnes personnelles de son enfant sur l'intranet d'tablissement</i></strong><br />La fiche lve ci-dessous n'est donc pas complte (il manque la photographie d'identit et les coordonnes parentales). Seul le responsable lgal peut rautoriser la publication de ces donnes dans l'application IEW (en prvenant l'administration de l'tablissement)</font>";
         }
         // Recherche des options suivies par l'lve
         $sql = "SELECT num_option, libelle_court FROM options as t1, matieres_sconet as t2 WHERE t1.eleve_id='$eleve_id' AND t1.code_matiere=t2.code_matiere";
         // DEBUGG print $sql."<br />";
         $result_options = mysql_query($sql);
         while ($ligne_options = mysql_fetch_array($result_options))
         {
         	$opt[$ligne_options['num_option']] = $ligne_options['libelle_court'];
         }
         // DEBUGG var_dump($opt);
       }
       else
       {
         if ($_SESSION['valid_group']=="4") // parent connect
          $error_message = array("Vous ne pouvez consulter que les fiches concernant votre(vos) enfant(s) !","");
         else
          $error_message = array("Aucune fiche ne correspond  cet lve dans la base de donnes. La fiche doit avoir t efface !","");
         affiche_erreurs($error_message);
         return;
       }
       // On en profite pour rechercher les identifiants de autres lves de la classe si ce n'est dj fait
       $liste_eleves_classe = array();
       $new_sql = "SELECT id_eleve FROM eleves WHERE classe='".quote_smart($classe)."' ORDER BY nom,prenom";
       $new_resultat = mysql_query($new_sql);
       if ($new_resultat)
       {
         if (mysql_num_rows($new_resultat)>0)
         {
          while ($ligne=mysql_fetch_array($new_resultat))
          {
            array_push($liste_eleves_classe,$ligne['id_eleve']);
          }
         }
       }
       // On recherche les informations concernant les parents
       $new_sql = "SELECT id_lp,libelle FROM lien_parente"; // Codes et libells de responsabilit lgale gnrales
       $new_resultat = mysql_query($new_sql);
       $valeurs_resp_legale = array();
       if ($new_resultat)
       {
         if (mysql_num_rows($new_resultat)>0)
         {
          while ($ligne=mysql_fetch_array($new_resultat))
          {
            $valeurs_resp_legale[$ligne['id_lp']]=$ligne['libelle']; // on stocke les codes et les libell dans un tableau
          }
         }
       }
       // Le code de responsabilit lgale concernant l'lve en cours est stock dans $eleli

       // DEBUGG echo "<br />";print_r($liste_eleves_classe); echo"<br />";
       // On rcupre le pointeur du tableau des identifiants lve correspondant  l'lve en cours (dont la fiche est affiche  l'cran)
       // Ce pointeur sera utilis plus loin pour tre incrment ou dcrment suivant le choix du visiteur pour voir la fiche de l'lve suivant ou prcdent 
      $pointeur = array_search($_GET['id_eleve'],$liste_eleves_classe);
    }
    else
    {
      $error_message = array("Le serveur de base de donnes est indisponible. Veuillez ressayer ultrieurement.","");
      affiche_erreurs($error_message);
       return;
    }
    
    if ($info_legale !="")
    {
      $error_message = array("<div align='justify'>$info_legale</div>","");
      affiche_erreurs($error_message);
    }
    // Barre de navigation graphique pour passer d'une fiche  l'autre dans une mme classe
    barre_navigation($pointeur);

    // Affichage de la fiche lve
    $code_formulaire = "
    <div class='titre_cadre_formulaire' align='left'><h2 class='hidden'>Donnes nominatives</h2><b>Donnes nominatives</b></div>
    <div class='cadre_formulaire_gris' align='center'>
    <table width='100%' border='0' bgcolor='#e6e7e6'>
     <tr valign='top'>
      <td>
       <p><label for='Form_Nom'>Nom&nbsp;:</label></p>
      </td>
      <td>
       <p><input type='text' size='25' name='nom' id='Form_Nom' value=\"$nom\" readonly='readonly' /></p>
      </td>
      <td rowspan='4' width='33%' align='center' valign='middle'>";
      $code_formulaire .= affiche_fotoelev($_GET['id_eleve'],"150","180");
      $code_formulaire .="
      </td>
     </tr>
     <tr valign='top'>
      <td>
       <p><label for='Form_Prenom'>Prnom&nbsp;:</label></p>
      </td>
      <td>
       <p><input type='text' size='25' name='prenom' id='Form_Prenom' value=\"$prenom\" readonly='readonly' /></p>
      </td>
     </tr>
     <tr valign='top'>
      <td>
       <p><label for='Form_DateNaiss'>Date de naissance&nbsp;:</label></p>
      </td>
      <td>
       <p><input type='text' size='10' name='date_naiss' id='Form_DateNaiss' value='$date_naiss' readonly='readonly' /></p>
      </td>
     </tr>
     <tr valign='top'>
      <td>
       <p><label for='Form_Sex'>Sexe&nbsp;:</label></p>
      </td>
      <td>
       <p><input type='text' size='10' name='sexe' id='Form_Sex' value='$sexe' readonly='readonly' /></p>
      </td>
     </tr>
     <tr valign='top'>
      <td>
       <p><label for='Form_IdNational'>Identifiant national&nbsp;:</label></p>
      </td>
      <td>
       <p><input type='text' size='11' name='id_national' id='Form_IdNational' value='$id_national' readonly='readonly' /></p>
      </td>
     </tr>
    </table>
    </div>
    <br />
    <div class='titre_cadre_formulaire' align='left'><h2 class='hidden'>Donnes pdagogiques</h2><b>Donnes pdagogiques</b></div>
    <div class='cadre_formulaire_gris' align='center'>
    <table width='100%' border='0'>
     <tr valign='middle'>
      <td>
       <p><label for='Form_Redoublant'>Redoublant&nbsp;:</label></p>
      </td>
      <td>
       <p><input type='text' size='3' name='doublement' id='Form_Redoublant' value=\"$doublement\" readonly='readonly' /></p>
      </td>
      <td>
       <p><label for='Form_Regime'>R&eacute;gime&nbsp;:</label></p>
      </td>
      <td colspan='3'>
       <p><input type='text' size='40' name='regime' id='Form_Regime' value=\"$regime\" readonly='readonly' /></p>
      </td>
     </tr>
     <tr valign='middle'>
      <td>
       <p><label for='Form_LV1'>LV1&nbsp;:</label></p>
      </td>
      <td>
        <p><input type='text' size='20' name='opt1' id='Form_LV1' value=\"$opt[1]\" readonly='readonly' /></p>
      </td>
      <td>
       <p><label for='Form_LV2'>LV2&nbsp;:</label></p>
      </td>
      <td colspan='3'>
       <p><input type='text' size='20' name='opt2' id='Form_LV2' value=\"$opt[2]\" readonly='readonly' /></p>
      </td>
     </tr>
     <tr valign='middle'>
      <td>
       <p><label for='Form_Option1'>Option 1&nbsp;:</label></p>
      </td>
      <td>
        <p><input type='text' size='20' name='opt3' id='Form_Option1' value=\"$opt[3]\" readonly='readonly' /></p>
      </td>
      <td>
       <p><label for='Form_Option2'>Option 2&nbsp;:</label></p>
      </td>
      <td>
       <p><input type='text' size='20' name='opt4' id='Form_Option2' value=\"$opt[4]\" readonly='readonly' /></p>
      </td>
      </tr>
      <tr valign='middle'>
      <td>
       <p><label for='Form_Option3'>Option 3&nbsp;:</label></p>
      </td>
      <td>
        <p><input type='text' size='20' name='opt5' id='Form_Option3' value=\"$opt[5]\" readonly='readonly' /></p>
      </td>
     </tr>
   </table>
   </div>
   <br />      
   ";
   if (isset($record["pub_intranet"]) && $record["pub_intranet"]==1) // Si autorisation parentale de publication
   {
    // On recherche qui est responsable lgal
    $sql = "SELECT t2.resp_legal,t3.libelle_court, t1.nom, t1.prenom FROM responsables as t1, responsables_eleves as t2, liens_parente as t3 WHERE t2.eleve_id='$eleve_id' AND t2.code_parente=t3.code_parente AND t1.personne_id=t2.personne_id";
    // DEBUGG print $sql."<br />";
    $result4 = mysql_query($sql);
    $nb_lignes = mysql_num_rows($result4);
    $code_formulaire .="
    <div class='titre_cadre_formulaire' align='left'><h2 class='hidden'>Responsable lgal</h2><b>Responsable lgal</b></div>
    <div class='cadre_formulaire_gris' align='center'>
        <table class='ctextes' width='100%'>
        	<tr>
        		<th class='fond_sommaire topleft'>Qualit</th>
        		<th class='fond_sommaire'>Nom - Prnom</th>
        		<th class='fond_sommaire topright'>Lien de parent</th>
        	</tr>";
    $i = 1;
    while ($ligne4 = mysql_fetch_array($result4))
    {
    	if ($i == $nb_lignes)
    	{
    		$class_add_first = " bottomleft";
      		$class_add_last = " bottomright";
    	}
    	$code_formulaire .= "
    	<tr>
    		<td class='$class_add_first' align='center'>
    			Responsable lgal n".$ligne4['resp_legal']."
    		</td>	
    		<td align='center'>
    			".$ligne4['nom']." ".$ligne4['prenom']."
    		</td>
    		<td class='$class_add_last' align='center'>
    			".$ligne4['libelle_court']."
    		</td>
    	</tr>";
    	$i++;
    }   
          $code_formulaire .="
    </table>
    </div><br />";
   }
    // Voil les donnes parentales :
        if (isset($record["pub_intranet"]) && $record["pub_intranet"]==1) // Si autorisation parentale de publication
        {
          $sql = "SELECT lc_civilite,nom,prenom, t1.adresse_id, t3.resp_legal, AES_DECRYPT(ligne1_adresse,'".$GLOBALS['crypt_key']."') as ligne1_adresse,
   			AES_DECRYPT(ligne2_adresse,'".$GLOBALS['crypt_key']."') as ligne2_adresse,
   			AES_DECRYPT(ligne3_adresse,'".$GLOBALS['crypt_key']."') as ligne3_adresse,
   			AES_DECRYPT(ligne4_adresse,'".$GLOBALS['crypt_key']."') as ligne4_adresse,
   			AES_DECRYPT(code_postal,'".$GLOBALS['crypt_key']."') as code_postal,
   			AES_DECRYPT(libelle_postal,'".$GLOBALS['crypt_key']."') as libelle_postal,
   			mel, 
   			AES_DECRYPT(tel_personnel,'".$GLOBALS['crypt_key']."') as tel_personnel, 
   			AES_DECRYPT(tel_mobile,'".$GLOBALS['crypt_key']."') as tel_mobile, 
   			AES_DECRYPT(tel_professionnel,'".$GLOBALS['crypt_key']."') as tel_professionnel 
   			FROM responsables as t1, adresses_responsables as t2, responsables_eleves as t3 WHERE t1.personne_id=t3.personne_id AND t3.eleve_id='$eleve_id' AND t1.adresse_id=t2.adresse_id";
		  // DEBUGG print $sql."<br />";
          $new_resultat = mysql_query($sql);
          if ($new_resultat)
          {
            if (mysql_num_rows($new_resultat)>0)
            {
              while ($ligne_parents=mysql_fetch_array($new_resultat))
              {
                affiche_donnees_parents();
              }
            }
            else
            {
              $code_formulaire .= "<div class='encadrer' align='justify'>Aucune information concernant <b>les parents</b> de cet lve n'est disponible. Il est probable que les donnes parentales n'ont pas t importes.</div>";
            }
          }
        }
        // Voil les autorisations du reprsentant lgal
        affiche_autorisations_responsable_legal();
        $code_formulaire .= "
        <div align='justify'><font color='red'>TOUTE ERREUR REPEREE (ou toute modification  apporter) DANS LES INFORMATIONS prsentes sur cette fiche EST A SIGNALER DANS LES PLUS BREFS DELAIS AU SECRETARIAT DE L'ETABLISSEMENT.</font></div>
        <br />";
    echo "<center>";
    squelette_formulaire_standard("100%","post",$_SERVER['PHP_SELF']."?id_eleve=".$_GET['id_eleve'],"<h1 class='hidden'>Consulter une fiche Elve</h1>Consulter une fiche Elve (Classe : <a href='../eqpedag.php?classe=$classe' title=\"Voir l'quipe pdagogique de la classe\">$classe</a>)",$code_formulaire,"","","","","","","");
    echo "</center>";
    // Barre de navigation graphique pour passer d'une fiche  l'autre dans une mme classe
    barre_navigation($pointeur);
  }
  else
  {
    $error_message = array("Aucun identifiant Elve dfini  l'appel de cette page !","");
    affiche_erreurs($error_message);
  }
}
else // L'utilisateur essaie d'invoquer ce script directement dans l'URL (interdit)
{
  $error_message = array("Vous tentez d'accder  un script qui n'est pas accessible directement  partir de l'URL... Utilisez les liens de navigation !","");
  affiche_erreurs($error_message);
}
?>