<?php
/**
 * c_cahier_appel.php
 *
 * Ce script a t crit  l'usage (non exclusif) des surveillants pour leur permettre
 * de recueillir les signalements des absences d lves pour la date de leur choix. Il s'agit
 * du traditionnel cahier d'appel.
 * 
 * Ce fichier fait partie du projet IntraEduWeb (IEW)
 * 
 * @package		IEW
 * @author			Sylvain GODM <sylvain.godme@gmail.com>
 * @version		$LastChangedRevision$, $LastChangedDate$
 * @copyright		2004-2012 Sylvain GODM
 * @link			http://iew.free.fr
 * @license		GPL License version 3 (http://www.gnu.org/licenses/gpl.html)
 * @filesource
 * 
 */

function affiche_form()
{
//***************************** description *****************************************************************//
 // cette fonction permet d'afficher le formulaire de saisie de la date ou de la priode pour laquelle on souhaite
 // afficher le cahier d'appel
 // paramtres entrs : $date qui peut-tre une date isole ou un tableau contenant une liste de dates conscutives
 // auteur : S.GODM (sylvain.godme@gmail.com)
 // Date de cration :	04/08/2003
 // Date de dernire mise  jour : 
 //***************************** Fin description ***********************************************************//

if (isset($_POST['date_isolee']))
  $date_isolee = $_POST['date_isolee'];
else
  $date_isolee = "";
if (isset($_POST['date_debut']))
  $date_debut = $_POST['date_debut'];
else
  $date_debut = "";
if (isset($_POST['date_fin']))
  $date_fin = $_POST['date_fin'];
else
  $date_fin = "";
 
echo "<br /><h1>Affichage du cahier d'appel<br />pour une date ou une priode donne</h1><br />";
$code_formulaire = "
<p><b><u><label for='Form_Req_Date_Isolee'>Date isole :</label></u></b>
 prcisez le jour (format jj-mm-aaaa)  <input id='Form_Req_Date_Isolee' type='text' size='10' name='date_isolee' value='$date_isolee' /></p>
 <p> <b><u>Priode :</u></b> (Ne pas remplir cette section si le champ Date isole ci-dessus a t renseign)</p>
 <p><label for='Form_Req_Date_Periode_Du'>du :</label> prcisez le jour (format jj-mm-aaaa)  <input id='Form_Req_Date_Periode_Du' type='text' size='10' name='date_debut' value='$date_debut' /></p>
 <p><label for='Form_Req_Date_Periode_Au'>au :</label> prcisez le jour (format jj-mm-aaaa)  <input id='Form_Req_Date_Periode_Au' type='text' size='10' name='date_fin' value='$date_fin' /></p>";
echo "<center>";
squelette_formulaire_standard("75%","post","cahier_appel.php","Choisissez une date ou une priode",$code_formulaire,"Valider","soumettre","Annuler","annuler","","","");
echo "</center>";
}

function verif_format_saisie($date)
{
//***************************** description *****************************************************************//
 // cette fonction permet de vrifier le format (jj-mm-aaaa) des dates saisies dans le formulaire
 // paramtres entrs : $date qui peut-tre une date isole ou un tableau contenant une liste de dates conscutives
 // auteur : S.GODM (sylvain.godme@gmail.com)
 // Date de cration :	04/08/2003
 // Date de dernire mise  jour : 
 //***************************** Fin description ***********************************************************//
 

	if (!preg_match ("#([0-9]{2})-([0-9]{2})-([0-9]{4})#", $date))
	{
		$error_message = array("<b><i>Au moins une date saisie n'est pas au format jj-mm-aaaa spcifi. Recommencez la saisie :</i></b>","");
		affiche_erreurs($error_message);
		affiche_form();
		return false;
	}
        else
        {
          $fragment = explode("-",$date);
          if (!checkdate($fragment[1],$fragment[0],$fragment[2]))
          {
            $error_message = array("<b><i>Au moins une date saisie n'est pas une date valide ! Recommencez la saisie :</i></b>","");
	    affiche_erreurs($error_message);
	    affiche_form();
	    return false;
          }
          else
          {
            return true;
          }
        }
}


function form_to_db($date)
{ // cette fonction permet de convertir une date saisie dans un formulaire (au format jj-mm-aaaa) dans le format mysql
  if (preg_match("#([0-9]{1,2})-([0-9]{1,2})-([0-9]{2,4})#",
      $date, $regs))
  {
    if(strlen($regs[1]) <2) $regs[1] = "0$regs[1]";
    if(strlen($regs[2]) <2) $regs[2] = "0$regs[2]";
    if(strlen($regs[3]) <4) $regs[3] = "20$regs[3]";

    return "$regs[3]-$regs[2]-$regs[1]";
  }
  else
  {
    return false;
  }
}

function nextDay($date)
{ // cette fonction permet de trouver le jour suivant d'une date donne au format mysql
 //YYYY-MM-DD
  list($year, $month, $day) = explode("-", $date);
  // check if newyear
  if($month==12 AND $day==31) {
  $year++;
  return $year."-01-01";
  // check if feb and if
  } elseif($month=="02" AND $day=="28") {
  if($year %4 == 0) {
  $day++;
  if (intval($day)<=9)
  {
	$day="0".$day;
  }
  return $year."-".$month."-".$day;
  } else {
  $month++;
  if (intval($month)<=9)
  {
	$month="0".$month;
  }
  return $year."-".$month."-01";
  }
  } elseif($month=="02" AND $day==29) {
  $month++;
  if (intval($month)<=9)
  {
	$month="0".$month;
  }
  return $year."-".$month."-01";
  // check if 31 day or 30
  } else {
  if($month<8) { $flag=0; }
  if($month>8) { $flag=1; }
  if(($month % 2) == $flag) {
  if($day == "30") {
  $month++;
  if (intval($month)<=9)
  {
	$month="0".$month;
  }
  return ($year."-".$month."-01");
  } else {
  $day++;
  if (intval($day)<=9)
  {
	$day="0".$day;
  }
  return ($year."-".$month."-".$day);
  }
  } else {
  if($day == "31") {
  $month++;
  if (intval($month)<=9)
  {
	$month="0".$month;
  }
  return ($year."-".$month."-01");
 
  } else {
  $day++;
  if (intval($day)<=9)
  {
	$day="0".$day;
  }
  return ($year."-".$month."-".$day);
  }
  }
  }
}

function elim_separateur($chaine,$separateur)
{
//***************************** description *****************************************************************//
 // cette fonction permet d'liminer un sparateur dans une chaine
 // paramtres entrs :	$chaine (la chaine  traiter)
 //			$separateur (le sparateur  supprimer de la chaine)
 // auteur : S.GODM (sylvain.godme@gmail.com)
 // Date de cration :	04/08/2003
 // Date de dernire mise  jour : 
 //***************************** Fin description ***********************************************************//
 
        $new_chaine = "";
	$fragment=explode($separateur,$chaine);
	for ($i=0;$i<=count($fragment)-1;$i++)
	{
		$new_chaine.=$fragment[$i];
	}
	return $new_chaine;
}

function affiche_navigation_cahier_appel($date,$indice)
{
	//***************************** description *****************************************************************//
 	// cette fonction permet d'afficher page par page le cahier d'appel (consultation d'archives)
 	// paramtres entrs : $date qui peut-tre une date isole ou un tableau contenant une liste de dates conscutives
 	//			$indice contient l'indice courant du tableau de date entr
	// auteur : S.GODM (sylvain.godme@gmail.com)
 	// Date de cration :	04/08/2003
 	// Date de dernire mise  jour : 16/02/2005
 	//***************************** Fin description ***********************************************************//
        
        global $racine;
        global $repertoire_theme;
        global $jeu_couleurs;
        global $chemin_relatif;
	if (count($date)!=1) // si la date n'est pas unique, on affiche des flches de navigation
	{
		echo "<br /><h1>Affichage du cahier d'appel pour la priode<br />du ".MySQLDateToExplicitDate($date[0], "", $YearOn=1)." au ".MySQLDateToExplicitDate($date[count($date)-1], "", $YearOn=1)."</h1><br />";
		$_SESSION['script']="cahier_appel.php"; // alors on affiche la page complte (en-tte et sommaire)
		?><br />
		Voici la liste des absents dclars le <b><u><?php echo "<font color='red'>".MySQLDateToExplicitDate($date[$indice], $WeekDayOn=1, $YearOn=1)
		."</font>" ?></u></b> transmises par les
		professeurs ou surveillants.<br /><br />
		<?php
                // On n'affichera le cahier d'appel que pour les dates comprises pendant les priodes scolaires (hors vacances)
                if (test_jour_dans_periode_scolaire($date[$indice]))
                {
                  // test si la date est un jour ouvrable de l'tablissement ou non
                  if (!test_jour_ouvrable(date_mysql_to_jjmmaaaa($date[$indice])))
                  {
                    // On affiche des liens vers le jour ouvrable prcdent et/ou le jour ouvrable prcdent dans la priode de dates demandes
                    $next_indice = $indice+1;
                    $prev_indice = $indice-1;
                    if ($prev_indice>=0 && $next_indice<count($date))
                      $supplement_message = "Passez au <a href='".$_SESSION['script']."?affichage=ok&amp;indice=".$prev_indice."&amp;chemin_relatif=$chemin_relatif#$classe'>jour prcdent</a> ou au <a href='".$_SESSION['script']."?affichage=ok&amp;indice=".$next_indice."&amp;chemin_relatif=$chemin_relatif#$classe'>jour suivant</a>.";
                    elseif ($prev_indice<0)
                      $supplement_message = "Passez au <a href='".$_SESSION['script']."?affichage=ok&amp;indice=".$next_indice."&amp;chemin_relatif=$chemin_relatif#$classe'>jour suivant</a>.";
                    elseif ($next_indice>=count($date))
                      $supplement_message = "Passez au <a href='".$_SESSION['script']."?affichage=ok&amp;indice=".$prev_indice."&amp;chemin_relatif=$chemin_relatif#$classe'>jour prcdent</a>";  
                    $error_message = array("Le ".format_date_long($GLOBALS['default_language'],date_mysql_to_jjmmaaaa($date[$indice]), $WeekDayOn=1, $YearOn=1)." n'est pas un jour ouvrable dans l'tablissement.<br />
                    $supplement_message","");
                    affiche_erreurs($error_message);
                    affiche_form_gestion($date[$indice]);
                    return; // on n'ira pas plus loin : pas d'affichage de la page correspondante du cahier d'appel
                  }
                  affiche_page($date[$indice],$indice); // On affiche le cahier d'appel pour la date spcifie
                }
                else // C'est pendant les vacances !
                {
                  // Il faut trouver le prochain jour ouvrable, et le prcdent
                  $newdate_ouvrable = ""; // initialisation d'une variable qui contiendra la prochaine date ouvrable fournie par la fonction mysql_jour_suiv_prec_ouvrable()
                  //echo "DATE_INDICE : ".$date[$indice]."<br />";
                  mysql_jour_suiv_prec_ouvrable($date[$indice],"1"); // Permet d'assigner la valeur  $newdate_ouvrable
                  $next_openday = $GLOBALS['newdate_ouvrable']; // On sauvegarde car va tre encore modifie
                  //echo "NEXT_OPENDAY : ".$next_openday."<br />";
                  mysql_jour_suiv_prec_ouvrable($date[$indice],"-1"); // $newdate_ouvrable va tre modifie
                  $prev_openday = $GLOBALS['newdate_ouvrable'];
                  //echo "PREV_OPENDAY : ".$prev_openday."<br />";
                  
                  // Maintenant, trouver  quels indices du tableau $_SESSION['liste_dates'] (contenu dans $date) ces jours correspondent
                  $next_indice = array_search($next_openday,$date);
                  $prev_indice = array_search($prev_openday,$date);
                  $error_message = array("Le ".format_date_long($GLOBALS['default_language'],date_mysql_to_jjmmaaaa($date[$indice]), $WeekDayOn=1, $YearOn=1)." tombe pendant les vacances scolaires.<br />
                    Passez au <a href='".$_SESSION['script']."?affichage=ok&amp;indice=".$prev_indice."&amp;chemin_relatif=$chemin_relatif#$classe'>jour ouvrable prcdent</a> ou au <a href='".$_SESSION['script']."?affichage=ok&amp;indice=".$next_indice."&amp;chemin_relatif=$chemin_relatif#$classe'>jour ouvrable suivant</a>.","");
                    affiche_erreurs($error_message);
                    affiche_form_gestion($date[$indice]);
                    return; // on n'ira pas plus loin : pas d'affichage de la page correspondante du cahier d'appel
                }
	}
	else // pour une date isole
	{
		$_SESSION['script']="cahier_appel.php";
		echo "<br /><h1>Affichage du cahier d'appel<br />du ".MySQLDateToExplicitDate($date, "", $YearOn=1)."</h1><br />";
		echo "Voici la liste des absents dclars le <b><u><font color='red'>".MySQLDateToExplicitDate($date, $WeekDayOn=1, $YearOn=1)."</font></u></b> transmises par les professeurs ou surveillants.<br /><br />";
		// test si la date est un jour ouvrable de l'tablissement ou non
    if (!test_jour_ouvrable(date_mysql_to_jjmmaaaa($date)) || !test_jour_dans_periode_scolaire($date))
    {
      $error_message = array("Le ".format_date_long($GLOBALS['default_language'],date_mysql_to_jjmmaaaa($date))." n'est pas un jour ouvrable dans l'tablissement ou tombe pendant les vacances scolaires!","");
      affiche_erreurs($error_message);
      affiche_form_gestion($date);
      return; // on n'ira pas plus loin : pas d'affichage de la page correspondante du cahier d'appel
    }
    affiche_page($date,0);
	}
}

function affiche_page($date,$indice)
{
	//***************************** description *****************************************************************//
	// cette fonction permet d'afficher une page du cahier d'appel (consultation d'archives)
	// elle fait appel aux fonctions importes du script c_bddabsences et modifies (cf dclaration des fonctions)
	// paramtres entrs : $date qui est une date isole qui correspond  la date consulte
	//			$indice (si dfini : cl courante du tableau $liste_dates contenant les diffrentes dates
	//				conscutives d'une priode)
	// auteur : S.GODM (sylvain.godme@gmail.com)
	// Date de cration :	04/08/2003
	// Date de dernire mise  jour : 03/03/2005
	//***************************** Fin description ***********************************************************//
	$sql = "SELECT division FROM divisions";
	$resultat = mysql_query($sql);
	while ($ligne = mysql_fetch_array($resultat))
	{
		affiche_cahier_d_appel($ligne["division"],$date,$indice);
		echo "<br />";
	}
	 affiche_form_gestion($date);
}

//********* Fonctions importes du script c_bddabsences et adaptes 
// -remplacement de CURRENT_DATE() par '$date' dans les requtes des fonctions importes
// fonction affiche_cahier_d_appel : ajout de l'argument $date, remplacement de CURRENT_DATE() par '$date' dans l'appel de affiche_absents()
//******************//

function affiche_cahier_d_appel($classe,$date,$indice){

 //***************************** description ********************************//
 // Cette fonction affiche pour une classe donne ($classe) le cahier d appel
 // paramtres entrs:	$classe: 	contient le nom de la classe
 //			$date (date du jour consult)
 //			$indice (si dfini : cl courante du tableau $liste_dates contenant les diffrentes dates
 //				conscutives d'une priode)
 // sortie : affichage HTML d un tableau type cahier d appel
 // auteur : S.GODM (sylvain.godme@gmail.com)
 // Date de cration : ?
 // Date de dernire mise  jour : 
 //***************************** Fin description *****************************//

 global $debut_plage_horaire;
 global $error_message;
 global $class_add_last;
 
 $ancre_classe = str_replace(" ","",$classe);
 echo "<a name='$ancre_classe'></a>";
 echo "<table class='header_cahier_appel'><tr>";
 // titre du tableau
 echo "<td class='gauche'><a name=\"$ancre_classe\"></a>
 <h2 class='titre_classe'>Classe de $classe</h2>
 </td>";
 if (isset($_SESSION['liste_dates']))
 {
   echo "<td class='droite'><a href='../../edt.php?categorie=classes&amp;edt=$classe' title=\"Voir l'emploi du temps de la classe de ".$classe."\"><img src='".$GLOBALS['chemin_relatif']."images/edt.png' alt='[Emploi du temps]' title='Emploi du temps' /></a><img src='".$GLOBALS['chemin_relatif']."images/pixel.gif' width='20' alt='' /><a href='../../cahiers_textes.php?set_classe=$classe&amp;date=".date_mysql_to_jjmmaaaa_tiret($date)."'><img src='".$GLOBALS['chemin_relatif']."images/ctexte.png' alt='[Cahier de Textes]' title='Cahier de Textes' /></a>&nbsp;&nbsp;&nbsp;<b>Archives : </b><font color='green'>Du ".date_mysql_to_jjmmaaaa($_SESSION['liste_dates'][0])." au ".date_mysql_to_jjmmaaaa($_SESSION['liste_dates'][count($_SESSION['liste_dates'])-1])."</font></td>";
 }
 else
 {
   echo "<td class='droite'><b>Archives : </b><font color='green'>Le ".date_mysql_to_jjmmaaaa($date)."</font></td>";
 }
 echo "</tr></table><br />";
// S'il y a un message d'erreur suite  une tentative pour retirer ou annuler des absences alors qu'on a pas les droits ncessaires
 // On l'affiche maintenant
 // Ce message d'erreur contient la classe (ou le groupe) sur laquelle cette tentative a t faite, si la classe en cours n'est pas concerne
 // On n'affichera pas de message
 // Il faut galement savoir
 $liste_classes = liste_classes_dans_groupe($error_message[1]); // au cas o le message contient le nom d'un groupe
 // DEBUGG var_dump($liste_classes);
 if (in_array($classe,$liste_classes) || stristr($error_message[1],$classe))
 // Au cas o un utilisateur aurait tent une suppression dans la table des absences sans avoir le droit de le faire, un message d'erreur est gnr, mais ne s'affiche que si la classe actuellement concerne est celle affiche
 {
   affiche_erreurs($error_message);
 }
 affiche_liens_navigation_dates($date,$indice,$classe);
 echo "<table class='ctextes' width='100%'>";
 $nbligne = round(count($debut_plage_horaire)/2); // Le nombre de lignes
 for ($i=0;$i<=($nbligne-1);$i++) 
 {
  if ($i == 0) // gestion des bordures arrondies
  {
  	$class_add_first = " topleft";
    $class_add_last = " topright";
  }
  elseif ($i == ($nbligne-1))
  {
  	$class_add_first = " bottomleft";
    $class_add_last = " bottomright";
  }
  else 
  {
  	$class_add_first = "";
    $class_add_last = "";
  }
  echo "<tr>";
  if (isset($debut_plage_horaire[$i]))
  {
    echo "<th class='fond_sommaire".$class_add_first."'>$debut_plage_horaire[$i]</th>"; // debut plage horaire
    $class_add_last = ""; // Comme c la 1re colonne de plage horaire, le coin topright de la prochaine cellule ne doit pas $etre arrondie
    affiche_absents($classe,$date,$debut_plage_horaire[$i],$indice); // affiche la liste des absents de la plage horaire
  }
  else
  {
    echo "<th class='fond_sommaire".$class_add_first."'>&nbsp;</th>"; // debut plage horaire
  }
  $k = $i+$nbligne;
  if ($k == $nbligne)
  {
  	$class_add_first = " topleft";
    $class_add_last = " topright";
  }
  elseif ($k == (2*$nbligne-1))
  {
  	$class_add_first = " bottomleft";
    $class_add_last = " bottomright";
  }
  else 
  {
  	$class_add_first = "";
    $class_add_last = "";
  }
  if (isset($debut_plage_horaire[$k]))
  {
    echo "<th class='fond_sommaire'>$debut_plage_horaire[$k]</th>";
    affiche_absents($classe,$date,$debut_plage_horaire[$k],$indice);
  }
  else
  {
    echo "<th class='fond_sommaire'>&nbsp;</th>";
    echo "<td class='affiche_absents".$class_add_last."'>&nbsp;</td>";
  }
  echo "</tr>";
 }
 
 echo "</table>";
 echo "<table class='footer_cahier_appel'><tr><td class='gauche'><a href=\"#bas\"> Bas de la page</a></td>
 <td class='droite'><a href=\"#haut\"> Haut de la page</a></td></tr></table>";
}


function affiche_absents($classe,$date,$debut,$indice)
{

//***************************** description ********************************//
 // C'est la mme fonction que dans c_bddabsences.php (exactement mme code) sauf qu'un paramtre
 // supplmentaire ($indice) doit tre spcifi (trait en dbut de code) et la variable $script
 // est remplace par $_SESSION['script']
 // De plus, la valeur du champ date des requtes SQL est dlimite par des '', ce qui n'est pas le cas
 // dans c_bddabsences.php, car la date est ici au fromat MySQL aaaa-mm-jj (alors que c'est CURRENT_DATE
 // dans c_bddabsences.php (et dans ce cas-l, il ne faut pas de '')
 // Cette fonction affiche pour une classe donne ($classe) et dans la plage horaire
 // donne ($debut)la liste des absents  la date donne $date
 // paramtres entrs	$date	:
 //			$debut	:	dbut de la plage horaire
 //			$classe: 	contient le nom de la classe
 //			$indice (si dfini : cl courante du tableau $liste_dates contenant les diffrentes dates
 //				conscutives d'une priode)
 // sortie : affichage HTML de la liste des absents
 // auteur : S.GODM (sylvain.godme@gmail.com)
 // Date de cration : ?
 // Date de dernire mise  jour : 06/03/2005
 //***************************** Fin description *****************************//

 global $liste_dates, $class_add_last; // pour accder au tableau des dates d'une priode
 if ($liste_dates) // si le tableau des dates d'une priode existe
 {
	$champ="affichage=ok&amp;indice=".$indice; // sera utilis plus loin dans les liens
 }
 else // alors on a affaire  une date isole
 {
	$champ="affichage=ok&amp;date=".$date;
 }
 $sql = "SELECT t3.eleve_id,nom,prenom,t1.id_transaction FROM liste_absents as t1,liste_absents_transactions as t2,eleves as t3 WHERE
 t2.date='".quote_smart($date)."' AND t2.debut='".quote_smart($debut)." 'AND t2.classe='".quote_smart($classe)."' AND
 t1.id_transaction=t2.id_transaction AND t3.eleve_id=t1.eleve_id";
 // DEBUGG echo $sql."<br />";
 $resultat = mysql_query($sql);
 if (mysql_num_rows($resultat)) // s il y a des absents dclars en classe entire
 {
  	echo "<td class='affiche_absents".$class_add_last."'>";
  	affiche_nom_prof($classe,$date,$debut);
  	echo "<table>";
  	while ($ligne = mysql_fetch_array($resultat))
	{
   		echo "<tr>";
		$eleve = $ligne['nom']." ".$ligne['prenom'];
   		$id_transaction = $ligne['id_transaction'];
   		$eleve_id = $ligne['eleve_id'];
		affiche_eleve_absent($eleve,$eleve_id,$_SESSION['script'],$id_transaction,$champ,$classe);
		echo "</tr>";
  	}
  	echo "</table><br />";
    affiche_lien_annuler_la_notification($_SESSION['script'],$id_transaction,$champ,$classe,$date);
    echo "</td>";
 }
 else // s il n' y a pas d'absents dclars en classe entire
 {
 	// Soit une transaction a t faite et pas d'absents, soit pas de transactions, soit transaction faite dans un groupe
	// qui concerne peut-tre la classe (avec ou sans absents dclars)
	echo "<td class='affiche_absents".$class_add_last."'>";
        ////////
	//echo "Pas d'absent en classe entire<br />";
	////////
	// peut-tre y a t-il des absents dclars dans un groupe-classe (le champ classe de la requte suivante contient alors le caractre "." compris dans le nom du groupe)
	$sql ="SELECT * FROM liste_absents_transactions,groupes WHERE date='".quote_smart($date)."' AND debut='".quote_smart($debut)."' AND classe=nom";
    // DEBUGG echo $sql."<br />";
	$resultat1=mysql_query($sql);
	if (mysql_num_rows($resultat1)>0) // Il y a un ou plusieurs groupes-classes pour lesquels une transaction
					   // a t faite pour ce jour et pour cette plage horaire. On va chercher si la classe
					   // est concerne par ces dclarations d'absences
	{
		////////
		// DEBUGG echo mysql_num_rows($resultat1)." transaction(s) de groupe sur cette heure<br />";
		////////
		// la variable suivante sera ventuellement utilise pour dterminer si un sparateur <hr /> doit tre inclus aprs l'affichage de la notification d'absence pour ce groupe (dans le cas ou plusieurs notifications d'absences sont effectus aux mmes heures pour la mme classe, mais les lves tant dans des groupes diffrents)
        $numero_groupe=0;
		while ($ligne=mysql_fetch_array($resultat1)) // on examine chacun des groupes
		{
			$numero_groupe++;
			// DEBUGG echo $numero_groupe."me transaction de groupe<br />";
            $id_transaction=$ligne['id_transaction'];
			////////
			//echo $id_transaction."<br />";
			////////
			$nom_groupe=$ligne['nom'];
			$nom_prof=$ligne['prof'];
			$id_groupe=$ligne['id_groupe'];
			$id_responsable=$ligne['id_responsable']; 
			// On examine le groupe pour savoir s'il concerne la classe
			if ($id_responsable == 0) // Si c'est un groupe sconet, on cherche les divisions concernes par sa composition
			{
				$sql = "SELECT divisions_appartenance FROM structures, groupes WHERE code_structure=nom AND nom='".quote_smart($nom_groupe)."'";
				// DEBUGG echo $sql."<br />";
				$result_gpe_sconet=mysql_query($sql);
				$record = mysql_fetch_array($result_gpe_sconet);
				$divisions_appartenance = $record['divisions_appartenance'];
				$liste_divisions_appartenance = explode(",",$divisions_appartenance);
				if (in_array($classe,$liste_divisions_appartenance)) // le groupe concerne la classe
					$flag_classe = true; // on positionne le flag pour l'indiquer
				else
					$flag_classe = false;
			}
			else // C'est un groupe cr manuellement, mais on recherche galement si la classe en cours est concerne par la composition du groupe
			{
				$liste_classes = liste_classes_dans_groupe($nom_groupe);
				if (in_array($classe,$liste_classes))
					$flag_classe = true; // on positionne le flag pour l'indiquer
				else
					$flag_classe = false;
			}
	
			
			if ($flag_classe)
			{
    				////////
				// DEBUGG echo "le groupe $nom_groupe contient la classe de $classe<br />";
				////////
				// La classe en cours a-t-elle des lves inscrits dans ce groupe ?
				$sql = "SELECT nom,prenom,eleves.eleve_id,classe FROM groupes_eleves,eleves WHERE id_groupe='".quote_smart($id_groupe)."' AND eleves.eleve_id=groupes_eleves.eleve_id ORDER BY nom,prenom";
				// DEBUGG echo $sql."<br />";
				$new_result=mysql_query($sql);
				if (mysql_num_rows($new_result)>0) // oui, il y en a
				{
					if (mysql_num_rows($resultat1)>1 && $numero_groupe>1) // on spare les notifications par des profs diffrents par un <hr /> (sauf pour le dernier groupe, puisqu'il n'y a rien  afficher aprs)
                    	echo "<hr />";
					affiche_nom_prof($nom_groupe,$date,$debut);
					echo "<font color=\"green\"> (Groupe ".strtok($nom_groupe,"-").")</font>";
					// On cherche si des absents ont t indiqus pour ce groupe et faisant partie de la classe en cours
					$id_transaction=$ligne['id_transaction'];
					$nom_groupe=$ligne['classe'];
					$sql = "SELECT DISTINCT eleves.eleve_id,eleves.nom,prenom,liste_absents.id_transaction FROM liste_absents,eleves, groupes, groupes_eleves, liste_absents_transactions WHERE liste_absents.id_transaction='".quote_smart($id_transaction)."' AND liste_absents.eleve_id=eleves.eleve_id AND eleves.classe='".quote_smart($classe)."' AND groupes_eleves.id_groupe=groupes.id_groupe AND liste_absents_transactions.classe='$nom_groupe'";
					// DEBUGG echo $sql."<br />";
					$new_result1=mysql_query($sql);
					if ($new_result1 && (mysql_num_rows($new_result1)>0)) // Des absents ont t indiqus
					{
     					echo "<table>";
						while ($ligne = mysql_fetch_array($new_result1)) // pour chaque absent indiqu
						{
							echo "<tr>";
   							$eleve = $ligne['nom']." ".$ligne['prenom'];
   							$eleve_id = $ligne['eleve_id'];
   							$id_transaction = $ligne['id_transaction'];
							affiche_eleve_absent($eleve,$eleve_id,$_SESSION['script'],$id_transaction,$champ,$classe);
							echo "</tr>";
						}
						echo "</table><br />";
                        affiche_lien_annuler_la_notification($_SESSION['script'],$id_transaction,$champ,$classe,$date);
					}
					else
					{
						echo "<br />pas d'absent<br />";
                        affiche_lien_annuler_la_notification($_SESSION['script'],$id_transaction,$champ,$classe,$date);
					}
				}
				else // La classe en cours n'a pas d'inscrit dans le groupe => laisser la cellule vide
  				{
					////////
					// DEBUGG echo "Cette classe n'a pas d'inscrit dans le groupe<br />";
					////////
					echo "&nbsp;";
					break; // il faut sortir de la boucle while
				}
			}
			else // Le groupe en cours ne concerne pas la classe en cours, on vrifie si une transaction a tout de
			    // mme t faite pour la classe entire
  			{
				$sql="SELECT * from liste_absents_transactions WHERE date='".quote_smart($date)."' AND debut='".quote_smart($debut)."' AND classe='".quote_smart($classe)."'";
				$resultat2=mysql_query($sql);
				if (mysql_num_rows($resultat2)>0) // Une transaction a t faite pour la classe, mais pas d'absent dclar
				{
					$ligne=mysql_fetch_array($resultat2);
					$id_transaction=$ligne['id_transaction'];
					affiche_nom_prof($classe,$date,$debut);
					echo "<br />pas d'absent<br />";
                    affiche_lien_annuler_la_notification($_SESSION['script'],$id_transaction,$champ,$classe,$date);
					break; // il faut sortir de la boucle while
				}
				else // pas de transaction faite, laisser la cellule vide
				{
					echo "&nbsp;";
				}
			}
		}
	}
	else // Soit Il n'y a vraiment pas d'absent dclar, mme dans un groupe-classe, soit pas de transaction faite
  	{
		$sql="SELECT * from liste_absents_transactions WHERE date='".quote_smart($date)."' AND debut='".quote_smart($debut)."' AND classe='".quote_smart($classe)."'";
		$resultat3=mysql_query($sql);
		if (mysql_num_rows($resultat3)>0) // Une transaction a t faite pour la classe, mais pas d'absent dclar
		{
			$ligne=mysql_fetch_array($resultat3);
			$id_transaction=$ligne['id_transaction'];
			affiche_nom_prof($classe,$date,$debut);
			echo "<br />pas d'absent<br />";
            affiche_lien_annuler_la_notification($_SESSION['script'],$id_transaction,$champ,$classe,$date);
		}
		else // pas de transaction faite, laisser la cellule vide
		{
			echo "&nbsp;";
		}
	}
	echo "</td>";
 }

}

function affiche_nom_prof($classe,$date,$debut){

//***************************** description ********************************//
// C'est la mme fonction que dans c_bddabsences.php (exactement mme code) 
 // De plus, la valeur du champ date des requtes SQL est dlimite par des '', ce qui n'est pas le cas
 // dans c_bddabsences.php, car la date est ici au fromat MySQL aaaa-mm-jj (alors que c'est CURRENT_DATE
 // dans c_bddabsences.php (et dans ce cas-l, il ne faut pas de '') 
// cette fonction affiche le nom du professeur qui a rempli le cahier d 'appel
 // Si aucun nom ne correspond, rien ne s'affichera et cela signifiera que le prof
 // n'a pas encore envoy la liste des absents ou a oubli de le faire
 // paramtres entrs	$date	:	
 //			$debut	:	dbut de la plage horaire 
 //			$classe: 	contient le nom de la classe
 // sortie : affichage HTML nom du professeur, et retour du numro de transaction (si le prof a rempli le cahier d'appel). Cette valeur 
 // est ensuite teste dans le script d'appel, et si elle n'est pas retourne, rien 
 // n'est affich dans le cahier d'appel. Dans le cas contraire, la liste des 
 // absents est alors affiche ou bien la notification <pas d'absent> le cas chant.
 // auteur : S.GODM (sylvain.godme@gmail.com)
 // Date de cration : 19/05/02
 // Date de dernire mise  jour : 
 //***************************** Fin description *****************************//


$sql = "SELECT liste_absents_transactions.id_pers,nom,prenom,id_transaction,nomlogin FROM liste_absents_transactions,login WHERE classe='".quote_smart($classe)."' AND debut='".quote_smart($debut)."' AND date='".quote_smart($date)."' AND liste_absents_transactions.id_pers=login.id_pers";
// DEBUGG echo $sql."<br />";
$resultat = mysql_query($sql);
if (mysql_num_rows($resultat)):
$ligne = mysql_fetch_row($resultat);
if ($ligne[1]=="") // Si pas de nom dfini dans la table login (ex : admin) => on affichera le nom de login
	$prof = $ligne[4];
else
	$prof = $ligne[1]." ".substr($ligne[2],0,1).strtolower(substr($ligne[2],1,strlen($ligne[2])-1));
$id_transaction = $ligne[3];
echo "Professeur ou Surveillant(e) :  <br /><span class='nom_prof_cahier_appel'>$prof</span>";
endif;
return $id_transaction;
}

function affiche_form_gestion($date)
{
  //***************************** description ********************************//
 // cette fonction affiche le formulaire de gestion des dates de consultation
 // du cachier d'appel
 // Date de cration : 03/03/2005
 // Date de dernire mise  jour : 03/03/2005
 //***************************** Fin description *****************************//
 echo "<a name='bas'></a><center>";
 $code_formulaire = "<br />Cet accs est strictement rserv aux personnes charges de la gestion Vie scolaire.<br /><br /><a href='../../absences.php?date=".$date."'>Ajouter/Modifier une notification d'absence en date du :<br /> ".MySQLDateToExplicitDate($date, "1", "1")."</a><br /><br />";
 $code_formulaire .= "<a href='./cahier_appel.php?autre_date=oui'>Consultation du cahier d'appel pour d'autres dates</a><br /><br />";
 squelette_formulaire_standard("75%","","","Contrle du cahier d'appel",$code_formulaire,"","","","","","","");
 echo "</center>";
}

function affiche_liens_navigation_dates($date,$indice,$classe)
{
  //***************************** description ********************************//
 // cette fonction affiche les liens de navigation d'une date  l'autre 
 // pour une consultation du cachier d'appel sur une priode (pas une date isole)
 // Date de cration : 09/03/2005
 // Date de dernire mise  jour : 09/03/2005
 //***************************** Fin description *****************************//
  
 global $chemin_relatif;
 
  echo "<table border='0' width='100%'>";
  echo "<tr><td align='left'>";
  // pas d'affichage du lien de navigation si c'est la date de debut de priode
  if ($indice!=0)
  {
    echo "<a href='".$_SESSION['script']."?affichage=ok&amp;indice=0&amp;chemin_relatif=$chemin_relatif#$classe'><img src='$chemin_relatif"."images/debut.png' alt='' align='middle' /> Premier jour</a> | ";
    echo "<a href='".$_SESSION['script']."?affichage=ok&amp;indice=".($indice-1)."&amp;chemin_relatif=$chemin_relatif#$classe'><img src='$chemin_relatif"."images/puce_gauche.png' alt='' /> <img src='$chemin_relatif"."images/puce_gauche.png' alt='' /> Jour prcdent</a>";
  }
  echo "</td>
  <td align='center'><font color='red'><i>(".MySQLDateToExplicitDate($date, "1","").")</i></font></td>
  <td align='right'>";
  // pas d'affichage du lien de navigation si c'est la date de fin de priode
  if (isset($_SESSION['liste_dates']) && $indice!=count($_SESSION['liste_dates'])-1)
  {
    echo "<a href='".$_SESSION['script']."?affichage=ok&amp;indice=".($indice+1)."&amp;chemin_relatif=$chemin_relatif#$classe'>Jour suivant <img src='$chemin_relatif"."images/puce.png' alt='' /> <img src='$chemin_relatif"."images/puce.png'  alt='' /></a> | ";
    echo " <a href='".$_SESSION['script']."?affichage=ok&amp;indice=".(count($_SESSION['liste_dates'])-1)."&amp;chemin_relatif=$chemin_relatif#$classe'>Dernier jour <img src='$chemin_relatif"."images/fin.png'  alt='' /></a>";
  }
  echo "</td></tr>";
  echo "</table>";
}


//*********************** Fin des fonctions importes de c_bddabsences (et modifies) **************************//

/* Dbut du programme principal */

// Le script en cours doit tre le script d'appel prvu
if (end_with_string($_SERVER['PHP_SELF'],"prive/admin/prive/cahier_appel.php"))
{
  if (isset($_GET['autre_date']) && $_GET['autre_date']=="oui") // assure un retour au formulaire de dpart
  {
    unset($_POST);
    unset($_SESSION['affichage_consultation_engage']);
    unset($_SESSION['indice_date_consultation_cahier_appel']);
    unset($_SESSION['liste_dates']);
    unset($_SESSION['date_isolee']);  
  }

  // DEBUGG echo "POST : ";print_r($_POST); echo "<br /><br /> GET : "; print_r($_GET); echo "<br /><br /> SESSION :"; print_r($_SESSION);

  /* initialisations */
  // Dfinition de porte globale pour les variables qui suivent (ce qui les rend disponibles dans les fonctions qui les utilisent)
    global $error_message, $debut_plage_horaire,$liste_dates,$valid_categories;
    global $classe_del;
  if (isset($_GET['affichage']))
  {  
    $affichage = $_GET['affichage'];
    $_SESSION['affichage_consultation_engage'] = $affichage; // On l'enregistre dans une variable de session
    // car si on clique sur un lien [Ajouter] pour modifier une notification d'absences, on sera redirig vers un autres script (c_absences.php) et aprs y avoir complt le formulaire, on sera  nouveau sur le cahier d'appel (mais le flag 'affichage' qui prcise que la consultation des dates est engage n'est plus fourni : il faut alors le rcuprer  partir de la variable de session)
  }
  elseif (isset($_SESSION['affichage_consultation_engage'])) // voil la rcupration cite ci-dessus
  { 
    $affichage = $_SESSION['affichage_consultation_engage'];
    // mais il faut aussitt supprimer la variable de session car ne sert plus (sera rinitalise si le script est appel avec un paramtre 'affichage' dans l'url)
    //unset($_SESSION['affichage_consultation_engage']);
  }
  if (isset($_GET['retirer']))
    $retirer = $_GET['retirer'];
  if (isset($_GET['effacer']))
    $effacer = $_GET['effacer'];
  if (isset($_GET['id_transaction']))
    $id_transaction = $_GET['id_transaction'];
  if (isset($_GET['date']))
    $date = $_GET['date'];
  if (isset($_POST['soumettre']))
    $soumettre = $_POST['soumettre'];
  if (isset($_POST['date_isolee']))
    $date_isolee = $_POST['date_isolee'];
  if (isset($_POST['date_debut']))
    $date_debut = $_POST['date_debut'];
  if (isset($_POST['date_fin']))
    $date_fin = $_POST['date_fin'];
  if (isset($_SESSION['liste_dates']))
    $liste_dates = $_SESSION['liste_dates'];
  if (isset($_GET['indice'])) // pour une consultation d'une plage de date (indice transmis par url)
  {  
    $indice = $_GET['indice'];
    $_SESSION['indice_date_consultation_cahier_appel'] = $indice; // On l'enregistre dans une variable de session
    // car si on clique sur un lien [Ajouter] pour modifier une notification d'absences, on sera redirig vers un autres script (c_absences.php) et aprs y avoir complt le formulaire, on sera  nouveau sur le cahier d'appel (mais l'indice courant n'est pas fourni : il faut alors le rcuprer  partir de la variable de session)
  }
  elseif (isset($_SESSION['indice_date_consultation_cahier_appel'])) // voil la rcupration cite ci-dessus
  {
    $indice = $_SESSION['indice_date_consultation_cahier_appel'];
    //echo "INDICE :",$indice."<br />";
    //unset($_SESSION['indice_date_consultation_cahier_appel']); // On n'en a plus besoin pour l'instant (sera rinitialis si on change d'indice dans l'url de la page, donc de date de consultation)
  }
  if (isset($_GET['eleve_id']))
    $eleve_id = $_GET['eleve_id'];
    

  // DEBUGG echo "<br /><br />POST : ";print_r($_POST);echo "<br /><br />","GET : ";print_r($_GET);echo "<br /><br />","SESSION : ";print_r($_SESSION);echo "<br /><br />";

  // On rcupre les horaires de dbut de cours de l'tablissement
   if (is_edt_import())
  {
  	$debut_plage_horaire = array();
  	$plage_horaire_provisoire = horaires_print(recup_horaires_debut_cours()); // Ce tableau commence  l'indice 1
  	// Mais pour la suite (bon fonctionnement de l'affichage du cahier d'appel), on a besoin qu'il commence  l'indice 0
  	foreach ($plage_horaire_provisoire as $value)
  	{
  		$debut_plage_horaire[] = $value;
  	}
  	// On a donc maintenant un tableau $debut_plage_horaire dont l'indice de dpart est bien 0
  }
  else
	$debut_plage_horaire = horaires();
  
  if (isset($affichage) && $affichage!="") // Si le script est appel avec comme argument la variable 'affichage'
		  // c'est que le formulaire est dja soumis et la consultation de l'affichage
		  // des absences est dj engag
  {
  	if (isset($retirer) && $retirer=="ok") // L appel du script a t fait en cliquant sur le lien RETIRER  ct du nom
	 // d un lve absent, il faut donc effectuer le traitement correspondant avant d afficher la liste
	 // des absents
	 {
  		if (check_del_access_absences($id_transaction)) // On vrifie si l'utilisateur a le droit de retirer l'lve de la liste des absents enregistrs dans le cahier d'appel
      {
        $sql = "DELETE FROM liste_absents WHERE id_transaction='".quote_smart($id_transaction)."' AND eleve_id='".quote_smart($eleve_id)."'";
        // DEBUGG echo $sql."<br />";
        mysql_query($sql);
      }
      else // s'il n'a pas le droit, on affiche un message d'erreur
      {
        $error_message = array("Vous n'avez pas les droits vous permettant de raliser cette opration.","$classe_del");
      }
	 }
	 if (isset($effacer) && $effacer=="ok") // L appel du script a t fait en cliquant sur le lien ANNULER LA NOTIFICATION  ct du nom
	 {
    	if (check_del_access_absences($id_transaction)) // On vrifie si l'utilisateur a le droit de retirer l'lve de la liste des absents enregistrs dans le cahier d'appel
      {
         // on efface les absents dj dclars
      	$sql = "DELETE FROM liste_absents WHERE id_transaction='".quote_smart($id_transaction)."'";
	    // DEBUGG echo $sql."<br />";
    	mysql_query($sql);
      	// on efface la trace de la transaction
      	$sql = "DELETE FROM liste_absents_transactions WHERE id_transaction='".quote_smart($id_transaction)."'";
      	// DEBUGG echo $sql."<br />";
      	mysql_query($sql);
      }
      else // s'il n'a pas le droit, on affiche un message d'erreurs
      {
        $error_message = array("Vous n'avez pas les droits vous permettant de raliser cette opration.","$classe_del");
      }
	 }
	 if (isset($liste_dates)) // Si la consultation porte sur plusieurs dates ($_SESSION['liste_dates'] dfini)
     affiche_navigation_cahier_appel($liste_dates,$indice);
   elseif (isset($date)) // sinon c'est que l'on consulte une date isole (fournie dans l'url par GET)
     affiche_navigation_cahier_appel($date,"");
   elseif (isset($date_isolee)) // date isole aussi mais par rechargement d'une page rsultat dj affiche
     affiche_navigation_cahier_appel(form_to_db($date_isolee),"");
   else // si on arrive l, c'est qu'il y avait une consultation sur plusieurs dates, mais la session a expir (donc $liste_dates n'est pas dfini, pas plus que $date), il faut donc viter des problmes d'affichage par la suite en forant le rechargement de la page vers le formulaire de saisie des dates de consultation
   { // s'il y a des variables de session dj enregistres, on les efface
	   unset($_SESSION['script']); 	// variable $_SESSION['script'] contenant le nom du script appel dans les liens
	   // cette variable sera dfinie dans la fonction affiche_navigation_cahier_appel()
	   affiche_form();
   }
  }
  else // Si la variable 'affichage' n'est pas dfinie
  {
	 if (isset($soumettre))
	 {
		  if (isset($date_isolee) && $date_isolee!="") // si le champ date_isolee est renseign
		  {
			 // on commence par vrifier la validit du format de saisie
			 if (verif_format_saisie($date_isolee))
       {
			   if ((isset($date_debut) && $date_debut!="") || (isset($date_fin) && $date_fin!=""))
			   {
			     $error_message = array("Attention  ne pas remplir la section &laquo;priode&raquo; si le champ date isole a t renseign !
			     Renouvellez votre tentative :","");
           affiche_erreurs($error_message);
			     affiche_form();
			   }
			   else // tout va bien, on va traiter une date isole
			   {
			     $date_mysql=form_to_db($date_isolee); // on convertit d'abord la date au format mysql
			     $_SESSION['affichage_consultation_engage'] = "ok";
           $_SESSION['indice_date_consultation_cahier_appel'] = 0;
           affiche_navigation_cahier_appel($date_mysql,0);
			   }
       }
		  }
		  else // Pas de date isole saisie, on vrifie si les champ date_debut et date_fin sont bien renseigns
		  {
			  if (isset($date_debut) && isset($date_fin))
			  {
				  if (verif_format_saisie($date_debut) &&	verif_format_saisie($date_fin))
          {
            // on vrifie l'ordre des dates
            list($day,$month,$annee)=explode("-",$date_debut);
            $timestamp_debut=mktime(0,0,0,$month,$day,$annee);
            list($day,$month,$annee)=explode("-",$date_fin);
            $timestamp_fin=mktime(0,0,0,$month,$day,$annee);
            if ($timestamp_debut>$timestamp_fin)
            {
              $error_message = array("La date de dbut de priode est postrieure  la date de fin de priode !<br /> Veuillez corriger SVP.","");
              affiche_erreurs($error_message);
              affiche_form();
              return;
            }
            // Si on arrive ici, tout va bien, on va traiter une priode
				    $date_en_cours=form_to_db($date_debut); // on initialise au format mysql
				    $liste_dates=array();
				    while (elim_separateur($date_en_cours,"-")<=elim_separateur(form_to_db($date_fin),"-"))
				    {
				      array_push($liste_dates,$date_en_cours);
				      $date_en_cours=nextDay($date_en_cours); // on incrmente la date
				    }
				    $_SESSION['liste_dates'] = $liste_dates;
            $_SESSION['affichage_consultation_engage'] = "ok";
            $_SESSION['indice_date_consultation_cahier_appel'] = 0;
				    affiche_navigation_cahier_appel($liste_dates,0);
          }
			  }
			  else
			  {
				  $error_message = array("Il manque au moins une date de dbut ou de fin de &laquo;priode&raquo;. Renouvellez votre tentative :","");
          affiche_erreurs($error_message);
				  affiche_form();
			  }
		  }
	 }
	 else // Si c'est la premire fois que la page est affiche ou si le bouton Annuler du formulaire a t enfonc
		// ou encore si le script est recharg sans que les variables $affichage et $soumettre ne soient dfinies
		// (par exemple lors d'une consultation de date isole, si on clique sur le lien 'format imprimable')
	 {
		 if (isset($date))
		 {
			 if (isset($retirer) && $retirer=="ok") // L appel du script a t fait en cliquant sur le lien RETIRER  ct du nom
			 // d un lve absent, il faut donc effectuer le traitement correspondant avant d afficher la liste
			 // des absents
			 {
				 if (check_del_access_absences($id_transaction)) // On vrifie si l'utilisateur a le droit de retirer l'lve de la liste des absents enregistrs dans le cahier d'appel
         {
           $sql = "DELETE FROM liste_absents WHERE id_transaction='".quote_smart($id_transaction)."' AND eleve='".quote_smart($eleve)."'";
				   mysql_query($sql);
         }
         else // s'il n'a pas le droit, on affiche un message d'erreurs
         {
           $error_message = array("Vous n'avez pas les droits vous permettant de raliser cette opration.","$classe_del");
         }
			 }
			 if (isset($effacer) && $effacer=="ok") // L appel du script a t fait en cliquant sur le lien ANNULER LA NOTIFICATION  ct du nom
			 {
				 if (check_del_access_absences($id_transaction)) // On vrifie si l'utilisateur a le droit de retirer l'lve de la liste des absents enregistrs dans le cahier d'appel
         {
           // on efface les absents dj dclars
				   $sql = "DELETE FROM liste_absents WHERE id_transaction='".quote_smart($id_transaction)."'";
				   mysql_query($sql);
				   // on efface la trace de la transaction
				   $sql = "DELETE FROM liste_absents_transactions WHERE id_transaction='".quote_smart($id_transaction)."'";
				   mysql_query($sql);
         }
         else // s'il n'a pas le droit, on affiche un message d'erreurs
         {
           $error_message = array("Vous n'avez pas les droits vous permettant de raliser cette opration.","$classe_del");
         }
			 }
			 affiche_navigation_cahier_appel($date,0);
		 }
		 else // ce script est appel sans paramtres (cas d'un chargement initial)
		 {
			 // s'il y a des variables de session dj enregistres, on les efface
			 unset($_SESSION['script']); 	// variable $_SESSION['script'] contenant le nom du script appel dans les liens
			 // cette variable sera dfinie dans la fonction affiche_navigation_cahier_appel()
			 affiche_form();
		 } 
	 }
 }
}
else // L'utilisateur essaie d'invoquer ce script directement dans l'URL (interdit)
{
  $error_message = array("Vous tentez d'accder  un script qui n'est pas accessible directement  partir de l'URL... Utilisez les liens de navigation !","");
  affiche_erreurs($error_message);
}
?>