<?php
/**
 * c_cloture_anscol.php
 *
 * Page de clture de l'anne scolaire, effacement des donnes devenues inutiles avant les
 * importations pour la prochaine anne scolaire
 * 
 * Ce fichier fait partie du projet IntraEduWeb (IEW)
 * 
 * @package		IEW
 * @author			Sylvain GODM <sylvain.godme@gmail.com>
 * @version		$LastChangedRevision$, $LastChangedDate$
 * @copyright		2004-2012 Sylvain GODM
 * @link			http://iew.free.fr
 * @license		GPL License version 3 (http://www.gnu.org/licenses/gpl.html)
 * @filesource
 * 
 */

function recursive_deldir($path)
{
    // Permet la suppression complte d'un rpertoire non vide

    // $path est le chemin relatif au fichier php
	
    // on vrifie d'abord que le nom du repertoire contient "/"  la fin,
    // sinon on le lui rajoute
    if ($path[strlen($path)-1] != "/")
        $path .= "/";

    if (is_dir($path))
    {
        $d = opendir($path);

        while ($f = readdir($d))
        {
            if ($f != "." && $f != "..")
            {
                $rf = $path . $f; // chemin relatif au fichier php
                if (is_dir($rf))
                    rdel($rf);
                else
                    unlink($rf);
            }
        }
        
        closedir($d);

        if (!rmdir($path))
          return false;
        else
          return true;
    }
    return true;
}

// Le script en cours doit tre le script d'appel prvu
if (end_with_string($_SERVER['PHP_SELF'],"prive/admin/prive/cloture_anscol.php"))
{
  /* Vrification initiale : la clture de l'anne scolaire ne peut se faire qu'aprs le dernier jour
  de classe */
  connexion_mysql();
  select_database();
  // initialisation
  $annee_scolaire = str_replace(" ","",annee_scolaire_en_cours());
  $rapport = "";
  $erreur = "";

  $sql="SELECT dbt_ete FROM semab";
  $resultat=mysql_query($sql);
  if ($resultat && mysql_num_rows($resultat)>0)
  {
    $row=mysql_fetch_row($resultat);
    $date_du_jour=strtotime(date("Y-m-d"));
    if ($date_du_jour<=strtotime($row[0])) // la date du jour est antrieure  la date des grandes vacances
    {
      // on ne peut excuter le script 
      $error_message = array("Vous ne pouvez effectuer de clture de l'anne scolaire en cours qu'aprs la date de fin des cours (soit aprs le ".format_date_long($GLOBALS['default_language'],date_mysql_to_jjmmaa($row[0]))."&nbsp;!)","");
      affiche_erreurs($error_message);
      return;
    }
    // Si on arrive ici le script peut se poursuivre
  }
  else
  {
    $error_message = array("<div align='justify'>Le calendrier de l'anne scolaire ne contient aucune donne ou bien le serveur MySQL est indisponible. Veuillez ressayer ultrieurement. Si le problme persiste, prvenez votre <a href='mailto:".email_encode($GLOBALS['admin_email'])."'>administrateur IntraEduWeb</a></div>","");
    affiche_erreurs($error_message);
    return;
  }
  
  $erreur = "";
  $erreur1 = "";
  $erreur2 = "";
  $erreur3 = "";
  $erreur4 = "";
  $erreur5 = "";
  
  if (!isset($_POST['soumettre'])) // On affiche un formulaire  valider pour continuer
  {
    if (isset($_POST['finalisation'])) // Si la procdure de clture est dj ralise
    {
        
        // c'est la fin de la procdure de clture : il s'agit de supprimer le dossier de sauvegarde
        // contenant (entre autres) le fichier SQL cr lors du mysqldump de la base de donnes
        $rapport .= "<br /><br /><font color='black'><strong>===== Opration 5 : finalisation de la clture =====</strong></font>
        <br /><font color='black'>- Effacement des donnes-fichiers sensibles devenues inutiles.....</font>";
        if (!recursive_deldir($GLOBALS['stock_baselev']."backup/")) // dans le dossier data
          $erreur .= "Le dossier <strong>".$GLOBALS['stock_baselev']."backup/"."</strong> n'a pas pu tre supprim : il est IMPERATIF de le faire manuellement, pour des raisons de scurit.<br />";
        if (!recursive_deldir($_POST['data_anscol']."backup/")) // dans le dossier data de la sauvegarde qui vient d'tre faite
          $erreur .= "Le dossier <strong>".$_POST['data_anscol']."backup/"."</strong> n'a pas pu tre supprim : il est IMPERATIF de le faire manuellement, pour des raisons de scurit.<br />";
        // on supprime aussi les fichiers contenant les mots de passe pour la diffusion aux utilisateurs (s'ils existent)
        $liste_fichiers_a_supprimer = array(
        "comptes_","new_comptes_","suppr_comptes_","diffusion_");
        $error_supprflag = 0;
        foreach($liste_fichiers_a_supprimer as $value)
        {
          foreach (glob($_POST['data_anscol'].$value."*") as $filename)  // On supprime tous les fichiers commenant par $value
          {
            if (file_exists($filename) && !@unlink($filename))
            {
              $error_supprflag = 1;
              $erreur .= "<br />Le fichier <font color='black'><strong>$value</strong></font> n'a pas pu tre supprim&nbsp;(sur un serveur windows, veuillez le faire manuellement)!<br />";
            }
          }
        }
        if ($erreur != "")
        {
          $rapport .= "<strong>Il y eu un problme</strong><br />";
          $error_message = array("$rapport.$erreur","");
          affiche_erreurs($error_message);
          return;
        }
        else // tout c'est bien droul jusque l
        {
          $rapport .= "<font color='green'><strong>OK</strong></font><br />";
          /* Effacement des donnes (MySQL) de l'anne en cours */
          // Opration 5 : Effacement des donnes de l'anne en cours
          // A faire en dernier car la table semab est efface et ne contiendra plus la date de la fin de l'anne scolaire
          // Ce script ne pourra alors plus s'excuter (ce qui est logique si tout c'est correctement droul)
          // avant la fin de la prochaine anne scolaire
          $rapport .= "<font color='black'>- Effacement des donnes devenues inutiles de la base MySQL.....</font>";
          $erreur5 = "";
          // On n'efface pas les tables 'personnel', 'eleve', 'responsables', 'responsables_eleves', 'login', de faon  ce que ces personnes conservent leur compte IEW et leur id-pers
          $liste_tables_a_effacer = array(
          "a_faire",
          "accept_charte",
          "adresses_eleves",
          "adresses_eleves_maj",
          "adresses_responsables",
          "adresses_responsables_maj",
          "alternances",
          "autorisations_1",
          "cahiers_textes",
          "civilites",
          "coordonnateurs",
          "cours",
          "cours_diff",
          "demande_mdp",
          "divisions",
          "docs_joints_ctextes",
          "echec_acces",
          "eleves_maj",
          "enseignants_services",
          "groupes",
          "groupes_eleves",
          "horaires_edt",
          "horodatages_imports_base",
          "horodatages_imports_eleves",
          "journal_connexions",
          "liens_parente",
          "liste_absents",
          "liste_absents_provisoires",
          "liste_absents_transactions",
          "majbddelev",
          "matieres",
          "matieres_etablissement",
          "matieres_sconet",
          "mefs",
          "modalites_election",
          "notes",
          "options",
          "options_maj",
          "options_obligatoires",
          "personnel_maj",
          "profs_principaux",
          "programmes",
          "regimes",
          "remplacants",
          "responsables_eleves_maj",
          "responsables_maj",
          "salles_cours",
          "semab",
          "semaines_alternances",
          "services",
          "statuts_eleve",
          "structures",
          "structures_eleves",
          "structures_eleves_maj",
          "taux_ponderations",
          "type_etablissement",
          "uaj",
          "visas_ct");
          $error_deleteflag = 0;
          foreach($liste_tables_a_effacer as $value)
          {
            $sql = "TRUNCATE TABLE $value";
            //echo $sql."<br />";
            if (!mysql_query($sql) || mysql_affected_rows()==-1)
            {
              $error_deleteflag = 1;
              $erreur5 .= "<br />Les donnes de la table <font color='black'><strong>$value</strong></font> n'ont pas pu tre effaces !<br />";
            }
            /* Cas particulier de la table cours_diff : comme l'AUTO_INCREMENT est dfini  10000 comme valeur de base dans intraeduweb.sql 
             * le truncate va remettre cet auto_increment  zro, il faut ensuite rtablir la valeUr 10000 */
            if ($value == cours_diff)
            {
            	$sql = "ALTER TABLE $value AUTO_INCREMENT = 10000";
            	if (!mysql_query($sql))
            	{
              		$error_deleteflag = 1;
              		$erreur5 .= "<br />La valeur de l'AUTO_INCREMENT de la table <font color='black'><strong>$value</strong></font> n'ont pas pu tre remis  10000. Vous devez le faire manuellement ($sql) !<br />";
            	}
            }
          }
          if ($error_deleteflag == 0)
            $rapport .= "<font color='green'><strong>OK</strong></font><br />";
          if ($erreur5 != "")
          {
            $rapport .= "<strong>Il y a eu un problme</strong><br />";
            $error_message = array("$rapport.$erreur5","");
            affiche_erreurs($error_message);
            return;
          }
          else
          {
            $ok_message = "<div align='justify'>$rapport<br />La clture de l'anne scolaire <font color='black'><strong>$annee_scolaire</strong></font> s'est <u>finalise</u> avec succs !<br />
            Suivez la documentation du gestionnaire de contenu (gestadmin) pour prparer IEW pour la prochaine rentre.<br />
            Vous pouvez depuis IEW accder aux <a href='archives.php'>archives de annes scolaires prcdentes</a> qui restent disponibles dans l'application.<br /></div>";
            affiche_ok($ok_message);
            unset($_POST);
            unset($_SESSION['post_imprimable']);
            return;
          }
        }
    }
    /* Dernire vrification avant le lancement de la procdure */
    $code_formulaire = "<br /><div align='justify'>La clture de l'anne scolaire en cours consiste  effacer les donnes devenues inutiles (aprs les avoir archives) pour prparer la prochaine rentre scolaire.<br />Le dossier d'archivage qui va tre cr portera le nom <strong>'data_$annee_scolaire'</strong>. Il est recommand de le rapatrier localement par FTP ou une autre mthode, et de le graver sur cdrom !<br />Ainsi, il sera possible en cas de problme de restaurer les donnes archives.<br />Laissez tout de mme ce dossier sur votre site pour accder depuis IEW aux <a href='archives.php'>archives des annes antrieures</a><br /><br />Attention ! Si vous cliquez sur le bouton ci-dessous, vous lancerez la procdure de clture, et certaines donnes de l'anne scolaire en cours ne seront plus disponibles qu'en mode <a href='archives.php'>consultation d'archives</a><br /><br />
    La procdure peut durer plusieurs dizaines de secondes, veuillez patienter pour le rechargement de la page SVP</div><br />";
    echo "<br /><center>";
    squelette_formulaire_standard("100%","post",$_SERVER['PHP_SELF'],"Procdure de clture de l'anne $annee_scolaire",$code_formulaire,"Lancer la procdure de clture","soumettre", "","","","","");
    echo "</center>";
  }
  else // La procdure de clture a t lance (validation du bouton 'Lancer la procdure de clture')
  {
    
    //echo "OK, Procdure en cours ....";
    /*************************** Archivage de donnes ************************************/
    /* Plusieurs oprations sont  faire dans cette partie :
    1) Sauvegarde immdiate de la base de donne => cloture_iew_[Anne scolaire].tar.gz
    2) Archivage de la base de donnes actuelle (copie dans une autre base pour un accs aux archives)
    3) Copie du rpertoire data dans un rpertoire data_[Anne scolaire]  l'intrieur du rpertoire data (pour un accs aux archives)
    4) Suppression des fichiers devenus inutiles dans le rpertoire data 
    5) Effacement des donnes de l'anne en cours */
    /**************************************************************************************/
  	
  	// Opration 1 : Sauvegarde immdiate de la base de donne => cloture_iew_[Anne scolaire].tar.gz
    $rapport .= "<br /><font color='black'><strong>===== Opration 1 =====</strong></font>";
    $erreur1 = "";
    // on rcupre les infos de connexion au serveur MySQL pour l'anne scolaire en cours
    include(CONF_DIR."inc_connect.php");
    include(CONF_DIR."k.php");
    $user = mcrypt_decrypt($algo, $crypt_key, base64_decode($mysql_admin), $mode, $iv);
    $passwd = mcrypt_decrypt($algo, $crypt_key, base64_decode($mysql_admin_passwd), $mode, $iv);

    // on cre le dossier de sauvegarde (data/backup) si celui-ci n'existe pas
    $dossier_sauvegarde = $GLOBALS['stock_baselev']."backup/";
    if (!is_dir($dossier_sauvegarde))
    {
      mkdir($dossier_sauvegarde,0755);
      $rapport .= "<br /><font color='black'><i>Le dossier $dossier_sauvegarde vient d'tre cr.</i></font>";
    }
    $rapport .= "<br /><font color='black'>- Sauvegarde de l'tat actuel de la base de donnes (export SQL).....</font>";
    
    
    $exec_dir = "";
    $fichier_cloture = "cloture_iew_$annee_scolaire.sql.gz";
    
    // Si le fichier de sauvegarde existe dj (clture prcdente avorte), inutile de le recrer
    if (file_exists($dossier_sauvegarde.$fichier_cloture))
    {
      if (filesize($dossier_sauvegarde.$fichier_cloture) != 0)
        $rapport .= "<font color='green'>Le fichier <i>$fichier_cloture</i> <strong>existe dj.</strong></font>";
    }
    else // pas de fichier de sauvegarde de clture de l'anne
    {
      $redirection = " | gzip > ".$dossier_sauvegarde.$fichier_cloture;
      
      /* La fonction exec() sur une commande comprenant des arguments, pipes et redirection
engendre un problme d'xcution si la safe_mode est activ (dans ce cas les caractres | et > sont chapps
et par exemple la commande myqldump -uuser -ppassword --opt iew_database | gzip /repertoire_de_stockage_iew/backup/iew_database.sql.gz ne peut s'excuter correctement (PHP applique obligatoirement la fonction escapeshellcmd() ce qui chappe les caractres cits plus haut), alors que cette mme commande s'excute parfaitement lorsque le safe_mode est off. Je solutionne donc le problme en crant un script shell qui sera excut par la fonction exec()*/
      $safe_mode = (bool) ini_get('safe_mode');
      if ($safe_mode) // doit tre on pour des raisons de scurit
      {
        $cmd = "bkup-iew.sh ".rtrim($user)." ".rtrim($passwd)." ".$mysql_database." ".$dossier_sauvegarde.$fichier_cloture;
      }
      else // le safe_mode n'est pas activ (serveur de test par exemple) // il faut utiliser rtrim pour supprimer les caractres spciaux en fin de chane
        $cmd = $exec_dir."mysqldump --default-character-set=latin1 -u".rtrim($user)." -p".rtrim($passwd)." --opt ".$mysql_database.$redirection;
      // on xcute la commande
      // suivant le rsultat, on affiche un message
      exec($cmd,$output,$retval);
      if (isset($retval) && $retval == 0) // commande bien xcute (sur un serveur LINUX)
      {
        $rapport .= "<font color='green'><strong>OK</strong></font>";
      }
      else
      { 
        $erreur1 .= "<br />La sauvegarde a chou. Si votre serveur est un serveur linux, veuillez ressayer ultrieurement. Si cela ne marche toujours pas, vrifiez la directive safe_mode_exec_dir du fichier php.ini en effectuant <a href='security_check.php'>un test de scurit</a>. Si le safe_mode est activ, vrifiez que le script <i><strong>bkup-iew.sh</strong></i> existe bien (en droits 750) dans le rpertoire spcifi par la directive safe_mode_exec_dir. 
        Si votre serveur est sous windows, utilisez <strong>PhpMyAdmin</strong> pour sauvegarder votre base de donnes (sous le nom <i>cloture_iew_$annee_scolaire.sql.gz</i> et copiez-le dans le rpertoire <strong>$dossier_sauvegarde</strong>) puis recommencez la procdure de clture de l'anne scolaire.";
        $rapport .= $erreur1; // pour que l'erreur soit signale au bon endroit dans le rapport
        // si la taille du fichier cloture_iew_[Anne scolaire].tar.gz est nulle, (cas qui peut se produire en cas d'chec de mysqldump) on efface le fichier
        $fichier_sql = $dossier_sauvegarde.$fichier_cloture;
        if (file_exists($fichier_sql) && filesize($fichier_sql) == 0)
          unlink($dossier_sauvegarde.$fichier_cloture); // on efface le fichier qui ne contient rien
        // Comme la sauvegarde a chou, il ne faut pas continuer (sinon les tables seront effaces sans possibilit de rcupration d'une sauvegarde)
        $error_message = array("$rapport.$erreur1","");
        affiche_erreurs($error_message);
        return;
      }
    }
    //echo "fin opration 1<br />$rapport.$erreur1<br />";
    // Opration 2 : Archivage de la base de donnes actuelle (copie dans une autre base pour un accs aux archives)
    $rapport .= "<br /><br /><font color='black'><strong>===== Opration 2 =====</strong></font>";
    $rapport .= "<br /><font color='black'>- Archivage de la base de donnes actuelle (copie dans une autre base).....</font>";
    $erreur2 = "";
    // On s'assure d'abord que le fichier cloture_iew_[Anne scolaire].tar.gz existe bien
    if (!file_exists($dossier_sauvegarde.$fichier_cloture))
    {
      $erreur2 .= "<br /><br />Le fichier $fichier_cloture n'existe pas sur le serveur. Abandon de la clture.<br />";
      $error_message = array("$rapport.$erreur2","");
      affiche_erreurs($error_message);
      return;
    }
    else // il existe
    {
      if (filesize($dossier_sauvegarde.$fichier_cloture) == 0)
      {
        $erreur2 .= "<br /><br />Le fichier $fichier_cloture a une taille nulle. Abandon de la clture.<br />";
        $error_message = array("$rapport.$erreur2","");
        affiche_erreurs($error_message);
        return;
      }
      // On vrifie aussi si le fichier est rcent (il devrait dater d'aujourd'hui, toute la procdure de clture doit se faire le mme jour
      if (strtotime(date ("Y-m-d", filemtime($dossier_sauvegarde.$fichier_cloture))) != strtotime(date("Y-m-d")))
      {
        $erreur2 .= "<br /><br />Le fichier $fichier_cloture ne date pas d'aujourd'hui&nbsp;! Abandon de la clture. Supprimez le fichier $dossier_sauvegarde.$fichier_cloture et rechargez cette page.<br />";
        $error_message = array("$rapport.$erreur2","");
        affiche_erreurs($error_message);
        return;
      }
    }
    // Si on arrive ici c'est que toutes les conditions de sauvegarde sont runies
    
    // Il vaut mieux demander  l'utilisateur de crer une autre base pour la sauvegarde (on ne va pas le faire de faon automatique pour des raisons de scurit, c'est donc au root de MySQL de le faire)
    
    $bd =@mysql_connect($mysql_server,$user,$passwd);
    if (!$bd)
    {
      $erreur2 .= "<br /><br />Connexion au serveur de base de donnes <strong>\"$mysql_server\"</strong> impossible. Ressayez ultrieurement ou prvenez <a href='mailto:".email_encode($admin_email)."'>l'administrateur du site</a>. Abandon de la clture.<br />";
      $error_message = array("$rapport.$erreur2","");
      affiche_erreurs($error_message);
      return;
    }
    $new_anscol = str_replace("-","_",$annee_scolaire); // MySQL n'accepte pas les tirets dans le nom des bases
    $seldb=@mysql_select_db($mysql_database."_$new_anscol");
    if (!$seldb)
    {
      $erreur2 .= "<br /><br />La base de donnes d'archive IntraEduWeb pour l'anne scolaire coule n'existe pas. Prvenez <a href='mailto:".email_encode($admin_email)."'>l'administrateur du site</a>, qui doit la crer :
      <br /><br /><p><b>Si IEW est hberge sur un serveur scribe, en console sous root, il faut taper :</b></p><br />
      <p><code>root@scribe:~# /usr/share/eole/mysql_add.py</code></p>
      <p><code>Nom de la base de donnes  crer : <font color='black'>".$mysql_database."_$new_anscol"."</font></code></p>
      <p><code>Nom de l'utilisateur Mysql administrant la base : <font color='black'>le nom de l'utilisateur MySQL autoris  accder  la base de donnes IEW (dfini  l'installation de IEW)</font></code></p>
	  <p><code>Mot de passe de l'utilisateur Mysql administrant la base : <font color='black'>le mot de passe de l'utilisateur MySQL autoris  accder  la base de donnes IEW (dfini  l'installation de IEW)</font></code></p>
      <br /><br /><p><b>Si vous n'tes pas sur scribe, en mode console mysql (connect avec le root MySQL) il faut taper : </b></p><br />
      <p><code>mysql&gt; CREATE database <font color='black'>".$mysql_database."_$new_anscol"."</font></code></p>
      <p><code>mysql&gt; GRANT all privileges on <font color='black'>".$mysql_database."_$new_anscol"."</font>.* to <font color='black'>votre_nom_d_utilisateur MySQL@localhost</font> identified by <font color='black'>'votre_mot_de_passe'</font></code></p>
      <br /><br /><p><b>Vous pouvez aussi raliser cette opration avec phpMyAdmin si vous l'avez install. Lorsque c'est fait, rechargez cette page.</b></p>";
      $error_message = array("$rapport.$erreur2","");
      affiche_erreurs($error_message);
      return;
    }
    // La base de donnes qui va accueillir l'archive est prte, on y copie les donnes  archiver
    $safe_mode = (bool) ini_get('safe_mode');
    if ($safe_mode)
      $cmd = "restore-iew.sh ".$dossier_sauvegarde.$fichier_cloture." ".rtrim($user)." ".rtrim($passwd)." -D".$mysql_database."_$new_anscol";
    else
      $cmd = $exec_dir."gunzip <  ".$dossier_sauvegarde.$fichier_cloture." | mysql -u".rtrim($user)." -p".rtrim($passwd)." -D".$mysql_database."_$new_anscol";
    //echo "<br />$cmd<br />";
    // on excute la commande
    // suivant le rsultat, on affiche un message
    exec($cmd,$output,$retval);
    if (isset($retval) && $retval == 0) // commande bien xcute (sur un serveur LINUX)
    {
      $rapport .= "<font color='green'><strong>OK</strong></font>";
    }
    else
    { 
      $erreur2 .= "<br />Les donnes n'ont pas pu tre copies dans la base de donnes d'archivage. Si votre serveur est un serveur linux, veuillez ressayer ultrieurement.<br />
      Si votre serveur est sous windows, utilisez <strong>PhpMyAdmin</strong> pour importer dans votre base de donnes <strong>".$mysql_database."_".$new_anscol."</strong> le fichier de commandes SQL <i>cloture_iew_$annee_scolaire.sql(.gz)</i> qui se trouve dans le rpertoire <strong>$dossier_sauvegarde</strong>) puis rechargez cette page.<br />";
      $error_message = array("$rapport.$erreur2","");
      affiche_erreurs($error_message);
      return;
    }
    // On continue
    //echo "fin opration 2<br />$rapport.$erreur2<br/>";
    // Opration 3 : Copie du rpertoire data dans un rpertoire data_[Anne scolaire]  l'intrieur du rpertoire data
    $rapport .= "<br /><br /><font color='black'><strong>===== Opration 3 =====</strong></font>
    <br /><font color='black'>- Cration du dossier d'archivage.....</font>";
    $erreur3 = "";
    // on cre le dossier de sauvegarde (data_[Anne scolaire]) si celui-ci n'existe pas (dans 'data')
    $dossier_cloture = $GLOBALS['stock_baselev']."data_$annee_scolaire/";
    if (!is_dir($dossier_cloture))
    {
      mkdir($dossier_cloture,0755);
      $rapport .= "<font color='green'><strong>OK</strong></font><br />";
    }
    else
      $rapport .= "<font color='green'><strong>Existe dj</strong></font><br />";
    
    // On rezippe le fichier SQL provenant du dump de sauvegarde de la base de donnes (pour rduire la taille du fichier
    $cmd = "gzip ".$dossier_sauvegarde."cloture_iew_$annee_scolaire.sql"." ".$dossier_sauvegarde."cloture_iew_$annee_scolaire.sql.gz";
    exec($cmd,$output,$retval); // mme si ce n'est pas fait, ce n'est pas dramatique, car il sera supprim lors de la finalisation de la clture
   
    // On copie le dossier 'data' en cours dans le dossier de sauvegarde cr prcdemment (except data_[Anne scolaire] qui vient d'tre cr)
    // pour viter le ct rcursif
    $rapport .= "<font color='black'>- Copie des donnes.....</font>";
    $dir2copy = $GLOBALS['stock_baselev'];
    $dir_paste = $dossier_cloture;
    $except = "data_"; // Les dossiers d'archives ne sont pas inclus dans la copie
    $error_copyflag =  copy_dir ($dir2copy,$dir_paste,$except); // fonction de fichier (fonctions_fichiers.php)
    if ($error_copyflag == "") 
      $rapport .= "<font color='green'><strong>OK</strong></font>";
    else
    {
      $rapport .= "<strong>Il y a eu un problme !</strong><br />";
      $erreur3 .= "<br />Les fichiers suivants n'ont pas pu tre copis dans le dossier d'archivage :<br />
      $error_copyflag
      <br />Abandon de la clture.<br />
      <br />";
      $error_message = array("$rapport.$erreur3</div>","");
      affiche_erreurs($error_message);
      return;
    }
    
    //echo "fin opration 3<br />$rapport.$erreur3<br/>";
    // Opration 4 : Suppression des fichiers devenus inutiles dans le rpertoire data
    $rapport .= "<br /><br /><font color='black'><strong>===== Opration 4 =====</strong></font>
    <br /><font color='black'>- Suppression des fichiers devenus inutiles.....</font>";
    $erreur4 = "";
    $liste_fichiers_a_supprimer = array(
    "comptes_","new_comptes_","suppr_comptes_","diffusion_");
    $error_supprflag = 0;
    foreach($liste_fichiers_a_supprimer as $value)
    {
      foreach (glob($GLOBALS['stock_baselev'].$value."*.bak*") as $filename)  // On supprime tous les fichiers commenant par $value et se terminant par .bak+numro
      {
        if (file_exists($filename) && !@unlink($filename))
        {
          $error_supprflag = 1;
          $erreur4 .= "<br />Le fichier <font color='black'><strong>$value</strong></font> n'a pas pu tre supprim&nbsp;(sur un serveur windows, veuillez le faire manuellement)!</font><br />";
        }
      }
    }
    // En ce qui concerne les photos d'identit, la suppression des photos devenus inutiles se fera lors de la mise  jour de la base du personnel (pour le personnel) et de celle de la base lves (pour les lves)
    // On supprime le rpertoire cahiers_textes
    $liste_dossiers_a_supprimer = array("cahiers_textes");
    foreach($liste_dossiers_a_supprimer as $value)
    {
    	if (!recursive_deldir($GLOBALS['stock_baselev'].$value))
        {
          $error_supprflag = 1;
          $erreur4 .= "<br />Le dossier <font color='black'><strong>".$GLOBALS['stock_baselev'].$value."</strong></font> n'a pas pu tre supprim&nbsp;(sur un serveur windows, veuillez le faire manuellement)!<br />";
        }
    }

    if ($error_supprflag == 0)
      $rapport .= "<font color='green'><strong>OK</strong></font>";
    //echo "fin opration 4<br />$rapport.$erreur4<br/>";return;
    $rapport .= $erreur4; // pour que l'erreur soit signale au bon endroit dans le rapport
    
    // Depuis l'opration 2, On est connect  la base sauvegarde (anne antrieure) : On dsactive les comptes qui n'ont pas besoin d'accder  l'archive de l'anne antrieure
    $rapport .="<br /><font color='black'>- Dsactivation des comptes des utilisateurs non autoriss  accder  la base archive.....</font>";
    $sql = "UPDATE login set etat='0' WHERE id_gpe_utilisateurs NOT IN (1,3,5,6)"; // seuls les administrateurs, les profs, les gestadmin et la direction pourront accder  l'archive de l'anne antrieure
  	$resultat = mysql_query($sql);
    if ($resultat)
    {
    	$rapport .= "<font color='green'><strong>OK</strong></font>";
    }
    select_database(); // On est maintenant connect  la base actuelle (pour la nouvelle anne scolaire)
    // Dans cette base, On dsactive les comptes autres que les administrateurs pour empcher leur connexion avant les importations de donnes pour la nouvelle anne scolaire
    $rapport .="<br /><font color='black'>- Dsactivation des comptes autres que les administrateurs sur la nouvelle base.....</font>";
    $sql = "UPDATE login SET etat='0' WHERE id_gpe_utilisateurs<>'1'";
    $resultat = mysql_query($sql);
    if ($resultat)
    {
    	$rapport .= "<font color='green'><strong>OK</strong></font>";
    }
    
    /* Information de gestadmin */
    if ($erreur1 != "" || $erreur2 != "" || $erreur3 != "" || $erreur4 != "" || $erreur5 != "")
    {
      $error_message = array("*** Des erreurs se sont produites ***<br />$rapport<br />","");
      affiche_erreurs($error_message);
    }
    else // aucune erreur signale
    {
      $ok_message = $rapport."<br /><br />La premire phase de la clture de l'anne scolaire <font color='black'><strong>$annee_scolaire</strong></font> s'est droule avec succs !<br /><br />
      <strong>SAUVEGARDEZ</strong> le dossier <strong>$dossier_cloture</strong> sur cd-rom aprs l'avoir rapatri par FTP (ou une autre mthode), mais laissez-le sur votre site pour permettre l'accs aux archives depuis l'application.<br /><br />
      Une dernire chose est  faire : il faut nettoyer la place en supprimant le dossier de sauvegarde contenant le fichier SQL cr lors de la sauvegarde de la base de donnes. Ce fichier ne doit pas rester sur le serveur pour des raisons de scurit et de confidentialit de certaines donnes.<br /><br />Cliquez sur le bouton suivant (APRES VOUS ETRE ASSURE DU GRAVAGE SUR CD-ROM du dossier <strong>$dossier_cloture</strong> comme indiqu plus haut) :<br /><br />
      <form action='' method='post'>
      <center><input type='submit' name='finalisation' id='finalisation' value='Suppression des fichiers exposs...' /></center>
        <input type='hidden' name='data_anscol' id='data_anscol' value='$dossier_cloture' />
      </form>
      <br/>";
      affiche_ok($ok_message);
    }
  }
}
else // L'utilisateur essaie d'invoquer ce script directement dans l'URL (interdit)
{
  $error_message = array("Vous tentez d'accder  un script qui n'est pas accessible directement  partir de l'URL... Utilisez les liens de navigation !","");
  affiche_erreurs($error_message);
}
?>