<?php
/**
 * c_compte_ipr.php
 *
 * Page de gestion des comptes temporaires pour l'accs des IPR au site IEW
 * 
 * Ce fichier fait partie du projet IntraEduWeb (IEW)
 * 
 * @package		IEW
 * @author			Sylvain GODM <sylvain.godme@gmail.com>
 * @version		$LastChangedRevision$, $LastChangedDate$
 * @copyright		2004-2012 Sylvain GODM
 * @link			http://iew.free.fr
 * @license		GPL License version 3 (http://www.gnu.org/licenses/gpl.html)
 * @filesource
 * 
 */

function affiche_form($id_pers)
{
  $valeur_bouton_validation = "Crer le compte"; // C'est la valeur par dfaut (change en cas de maj)
  $valeur_bouton_onclick = "";
  $url_bouton_onclick = "";
  $tab = array(); // initialisation d'un tableau, qui sera vide ou bien qui contiendra le contenu des champs aprs validation
  if (isset($_POST) && count($_POST)!=0) // Le formulaire a dj t post, mais un champ manque ou contient une valeur invalide => il faut rafficher le formulaire avec les valeurs transmises
  {
    $tab = $_POST; // voil les valeurs transmises
    //print_r($_POST);
    if ($id_pers != "") // Si c'est une modification de fiche (l'id_pers est non vide), alors il faut ajuster la valeur du bouton de validation
    {
      $valeur_bouton_validation = "Modifier la fiche";
      $valeur_bouton_onclick = "Abandonner";
      $url_bouton_onclick = "\"location.href='".$_SERVER['PHP_SELF']."';\"";
    }
  }
  elseif($id_pers != "") // c'est une dition de fiche pour modification
  {
    // On rcupre les donnes dans la base
    $sql = "SELECT * FROM ipr WHERE id_pers='".quote_smart($id_pers)."'";
    //echo $sql;
    $resultat = mysql_query($sql);
    if ($resultat)
    {  
      if (mysql_num_rows($resultat)>0)
      {
        $ligne = mysql_fetch_array($resultat);
        $tab = $ligne;
        // Un coup de stripslashes sur le nom et le prnom (qui peuvent contenir des apostrophes chappes !!)
        $tab['nom'] = stripslashes($tab['nom']);
        $tab['prenom'] = stripslashes($tab['prenom']);
        // On reformate la date de MySQL en jj-mm-aaaa
        $date_visite = $tab['date_visite']; // on sauvegarde d'abord la valeur au format MySQL (utilise plus loin)
        $tab['date_visite'] = date_mysql_to_jjmmaaaa_tiret($tab['date_visite']);
        // On rcupre la date de validit du compte
        $sql1 = "SELECT date_validite FROM login WHERE id_pers='".quote_smart($id_pers)."'";
        $resultat1 = mysql_query($sql1);
        $ligne1 = mysql_fetch_array($resultat1);
        $date_validite = $ligne1['date_validite'];
        if ($date_validite !="")  // On calcule le nombre de jours de validit ( compter de la date de visite)
          $nb_jours_validite = round((strtotime($date_validite) - strtotime($date_visite))/(60*60*24)+1);
        else
          $nb_jours_validite = -1; // pas de limite de validit
        $tab['duree_validite'] = $nb_jours_validite;
        // On rcupre les identifiants des profs inspects
        $tab['profs'] = explode(",",$ligne['liste_profs']);
      }
      else
      {
        $error_message = array("Les donnes existantes n'ont pas pu tre rcupres dans la base. Veuillez ressayer ultrieurement.","");
        affiche_erreurs($error_message);
        return;
      }
    }
    $valeur_bouton_validation = "Modifier la fiche";
    $valeur_bouton_onclick = "Abandonner";
    $url_bouton_onclick = "\"location.href='".$_SERVER['PHP_SELF']."';\"";
  }
  echo "<a name='form' id='form'></a>";
  $titre = "Cration et activation d'un compte d'accs local";
  $code_formulaire = "
  <br />
  <div align='justify'>\n
  <p>Les Inspecteurs Pdagogiques Rgionaux, lors de leurs inspections ont besoin d'accder aux cahiers de textes des classes visites. Pour que les cahiers de textes en ligne leur soient accessibles, vous pouvez crer des comptes temporaires. Remplissez soigneusement ce formulaire (aprs validation, le compte est cr, et les codes d'accs gnrs sont automatiquement transmis par mail  l'IPR concern)</p>\n
  <br />
  <p><b><u>IMPORTANT :</u> Vous devez informer les enseignants inspects, que l'IPR aura un accs temporaire (en consultation) aux cahiers de textes de TOUTES les classes ou groupes dont ils ont la charge, et pas seulement celui de la classe qu'ils auront en charge au moment de l'inspection.</b></p>\n
  <br />
  <p><u>ATTENTION :</u> Le compte qui va tre cr par la validation de ce formulaire sera immdiatement actif. La dure de validit du compte va de&nbsp;: aujourd'hui &nbsp;: date d'inspection + le nombre de jours indiqu dans ce formulaire.</p>\n<br />
  </div>
  <label id='L_DateVisite' for='Form_Req_DateVisite'>Date de la visite</label>
  <input type='text' aria-labelledby='L_DateVisite' id='Form_Req_DateVisite' name='date_visite' class='datepicker' size='12' readonly='readonly' ";
  if (isset($tab['date_visite']))
  	$code_formulaire .= "value='".$tab['date_visite']."'";
  $code_formulaire .= " /><br />
  <label id='L_NomIpr' for='Form_Req_NomIpr'>Nom</label>  
  <input type='text' aria-labelledby='L_NomIpr' size='20' id='Form_Req_NomIpr' name='nom' ";
  if (isset($tab['nom']))
    $code_formulaire .= "value=\"".stripslashes($tab['nom'])."\"";
  $code_formulaire .= " /><br />
  <label id='L_PrenomIpr' for='Form_Req_PrenomIpr'>Prnom</label>  
  <input type='text'  aria-labelledby='L_PrenomIpr' size='20' id='Form_Req_PrenomIpr' name='prenom' ";
  if (isset($tab['prenom']))
    $code_formulaire .= "value=\"".stripslashes($tab['prenom'])."\"";
  $code_formulaire .= " /><br />
  <label id='L_DisciplineIpr' for='Form_Req_DisciplineIpr'>Discipline</label>
  <select size='1'  aria-labelledby='L_DisciplineIpr' id='Form_Req_DisciplineIpr' name='discipline'>";
  if (isset($tab['code_discipline']))
  {
  	$sql = "SELECT t1.code_discipline,libelle_long FROM disciplines_bcn as t1, personnel as t2 WHERE t1.code_discipline=t2.code_discipline AND t1.code_discipline='".quote_smart($tab['code_discipline'])."'";
    $result = mysql_query($sql);
    if (mysql_num_rows($result) >0)
    {
    	$enregistrement = mysql_fetch_array($result);
        $code_formulaire .= "<option selected='selected' value='".$enregistrement['code_discipline']."'>".$enregistrement['libelle_long']."</option>
            <option></option>";
    }
  }
  else
    $code_formulaire .= "<option></option>";
  $sql = "SELECT DISTINCT t1.code_discipline,libelle_long FROM disciplines_bcn as t1, personnel as t2 WHERE t1.code_discipline=t2.code_discipline ORDER BY libelle_long";
  $result = mysql_query($sql);
  if (mysql_num_rows($result) >0)
  {
     while ($enregistrement = mysql_fetch_array($result)) // on les affiche
     {
       $code_formulaire .= "<option value='".$enregistrement['code_discipline']."'>".$enregistrement['libelle_long']."</option>";
     }
  }
  $code_formulaire .= "</select><br />
  <label id='L_EmailIpr' for='Form_Req_EmailIpr'>Email</label>
  <input type='text' aria-labelledby='L_EmailIpr' size='30' id='Form_Req_EmailIpr' name='email' ";
  if (isset($tab['email']))
    $code_formulaire .= "value=\"".stripslashes($tab['email'])."\"";
  $code_formulaire .= " /><br />
  <label id='L_DureeCompteIpr' for='Form_Req_DureeCompteIpr'>Dure de validit du compte (en jours)</label>
  <input type='text' aria-labelledby='L_DureeCompteIpr' size='2' id='Form_Req_DureeCompteIpr' name='duree_validite' ";
  if (isset($tab['duree_validite']))
     $code_formulaire .= "value='".$tab['duree_validite'];
  else
    $code_formulaire .= "value='7";
  $code_formulaire .= "' />";
  if (isset($tab['duree_validite']) && $tab['duree_validite']==-1)
    $code_formulaire .= "<br />-1 indique une validite permanente";
  if (!isset($tab['duree_validite']))
    $code_formulaire .= "<br />( partir de la date de visite)";
  $code_formulaire .= "<br /><br />
  <label id='L_EnsInspect' for='Form_Req_EnsInspect'>Enseignants inspects</label><br />Pour une slection multiple, maintenez la touche CTRL enfonce et cliquez sur les enseignants concerns.<br />
  <select multiple='multiple' size='10' aria-labelledby='L_EnsInspect' id='Form_Req_EnsInspect' name='profs[]'>";
  $sql = "SELECT id_individu,nom,prenom FROM personnel WHERE categorie='7' ORDER BY nom,prenom";
  $result = mysql_query($sql);
  if (mysql_num_rows($result) >0)
  {
    while ($enregistrement = mysql_fetch_array($result)) // on les affiche
    {
      $affiche = $enregistrement['nom']." ".$enregistrement['prenom'];
      $code_formulaire .= "<option value='".$enregistrement['id_individu']."'";
      if (isset($tab['profs']))
        if (in_array($enregistrement['id_individu'],$tab['profs']))
          $code_formulaire .= " selected";
      $code_formulaire .= ">$affiche</option>";
    }
  }
  $code_formulaire .="
  </select><br /><br />".info_champs_obligatoires()."<br />";
  if ($id_pers !="") // on en a besoin pour la mise  jour de la fiche
  { 
    $code_formulaire .= "<input type='hidden' name='id_pers' id='id_pers' value='$id_pers' />";
  }
  else
    $param_url = "";
  squelette_formulaire_standard("100%","post","compte_ipr.php",$titre,$code_formulaire,$valeur_bouton_validation,"soumettre","","","","","");
}

// Le script en cours doit tre le script d'appel prvu
if (end_with_string($_SERVER['PHP_SELF'],"prive/admin/prive/compte_ipr.php"))
{
  echo "<h1>Gestion des comptes locaux des <abbr title='Inspecteur Pdagogique Rgional'>IPR</abbr></h1>";
  if (isset($_GET['id_pers']) && $_GET['id_pers'] !="")
    $id_pers = $_GET['id_pers'];
  elseif (isset($_POST['id_pers']) && $_POST['id_pers'] !="")
    $id_pers = $_POST['id_pers'];
  else
    $id_pers = "";
  if (isset($_GET['action']))
    switch ($_GET['action'])
    {
      case 'modifier': // Il s'agit de la modification des donnes sur l'IPR
        affiche_form($id_pers);
        return;
        break;
      case 'supprimer': // On supprime purement et simplement le compte IPR
        // On rcupre d'abord le nom et le prnom
        $sql0 = "SELECT nom,prenom FROM login WHERE id_pers='".quote_smart($_GET['id_pers'])."'";
        $resultat0 = mysql_query($sql0);
        if ($resultat0 && mysql_num_rows($resultat0)>0)
        {
          $ligne0 = mysql_fetch_array($resultat0);
          $prenom0 = $ligne0['prenom'];
          $nom0 = $ligne0['nom'];
          // On tente la suppression du compte ipr
          $sql1 = "DELETE FROM ipr WHERE id_pers='".quote_smart($_GET['id_pers'])."'";
          $sql2 = "DELETE FROM login WHERE id_pers='".quote_smart($_GET['id_pers'])."'";
          if (mysql_query($sql1) && mysql_query($sql2)) // OK, a a fonctionn
          {
            // Il faut aussi supprimer les codes d'accs dans comptes_ipr.txt
            modif_fichier_texte_codes_acces($GLOBALS['stock_baselev']."comptes_ipr.txt","ok",$id_pers,"","",$prenom0,$nom0,"");
            // on supprime les donnees obsoletes sans lien avec le compte supprim
          	suppr_compte_tables_nettoyage($id_pers);
            $ok_message = "Le compte vient d'tre supprim de la base de donnes.<br />
            <a href='".$_SERVER['PHP_SELF']."'>[Retour et Vrification]</a>";
            affiche_ok($ok_message);
            return;
          }
          else
          {
            $error_message = array("Le compte n'a pas pu tre supprim. Veuillez recommencer ultrieurement.<br />
            <a href='".$_SERVER['PHP_SELF']."'>[Retour]</a>","");
            affiche_erreurs($error_message);
            return;
          }
        }
        else // Si on n'a pas pau rcuprer le nom et le prnom de l'ipr, la suppression ne peut se faire dans comptes_ipr.txt, donc on ne supprime pas le compte dans les tables MySQL
        {
            $error_message = array("Le compte n'a pas pu tre supprim. Veuillez recommencer ultrieurement.<br />
            <a href='".$_SERVER['PHP_SELF']."'>[Retour]</a>","");
            affiche_erreurs($error_message);
            return;
        }
        break;
      case 'activ': // On active ou on dsactive le compte (suivant la valeur du paramtre code dans l'URL)
        /* L'activation d'un compte est li  deux champs de la table login :
        - date_validite : indique la date d'expiration du compte 
        - etat : indique l'tat d'activation du compte 
        Pour que le compte soit actif, il faut que la date du jour soit antrieure ou gale  la date de validit ET que l'etat soit positionn sur 1 (activ) 
        
        Ici, le code suivant se borne  modifier le champ etat vers 0 (inactif) ou 1 (actif), mais dans ce dernier cas, ceci sera inoprant si la date du jour est postrieure  la date de validit => il faut donc informer l'utilisateur si ce cas de figure se produit */
        if (isset($_GET['date_validite']) && strtotime(convert_date_to_mysql(date("d/m/Y"))) > strtotime($_GET['date_validite']))
        { 
          $error_message = array("Ce compte ne peut pas tre activ puisque la date d'expiration est dpasse. Il faut Editer/Modifier la fiche correspondante et modifier la date de visite et/ou la dure de validit (en jours).","");
          affiche_erreurs($error_message);
          break; // on sort du switch pour que l'instruction sql qui suit ne puisse pas s'excuter
        }
        $sql = "UPDATE login SET etat='".quote_smart($_GET['code'])."' WHERE id_pers='".quote_smart($_GET['id_pers'])."'";
        if (mysql_query($sql))
        {
          $ok_message = "Le compte a t ";
          if ($_GET['code'] == 1)
            $ok_message .= "activ.";
          else
            $ok_message .= "dsactiv.";
          $ok_message .= "<br /><a href='".$_SERVER['PHP_SELF']."'>[Retour et Vrification de l'tat du compte]</a>";
          affiche_ok($ok_message);
          return;
        }
        else
        {
          $error_message = array("L'tat d'activation du compte n'a pas pu tre modifi. Veuillez ressayer ultrieurement.<br /><a href='".$_SERVER['PHP_SELF']."'>[Retour]</a>","");
          affiche_erreurs($error_message);
          return;
        }
        break;
      case 'creer': // Il s'agit de crer un nouveau compte IPR
        affiche_form($id_pers);
        return;
        break;
      case 'mail': // L'envoi d'un mail automatique (suite  la cration d'un compte IPR) a t confirm
        $message = $_SESSION['message_ipr'];
        $email = $_SESSION['email_ipr'];
        $nom = $_SESSION['nom_ipr'];
        $prenom = $_SESSION['prenom_ipr'];
        // Ce message doit tre morcel en lignes de 70 cc max pour la fonction mail()
        $message = wordwrap($message, 70);
        $entetes_additionnels = "From: ".$GLOBALS['nom_etablissement']."<".$GLOBALS['email_etablissement'].">\n";
        // Si chec du mail automatique, lui communiquer autrement (mail manuel, ou de vive voix...)
        if (!@mail($email,"Codes d'accs temporaire  l'application IEW du ".$GLOBALS['nom_etablissement'],$message,$entetes_additionnels))
        {
          $error_message = array("<div align='justify'>L'identifiant et le code d'accs  IEW n'ont pas pu tre transmis de faon automatique  ".strtoupper(substr(stripslashes($prenom),0,1)).substr(stripslashes($prenom),1,strlen(stripslashes($prenom))-1)." ".strtoupper(stripslashes($nom))."<br />Voici le message  lui communiquer par un autre moyen (Vous pouvez copiez/coller ou imprimer ce message pour l'envoyer manuellement  son destinataire) :<br /><br />
          ".str_replace("\n","<br />",$message)."
          </div>","");
          affiche_erreurs($error_message);
          return;
        }
        else // Le mail a SEMBLE-T-IL t transmis, mais ...est-il arriv ??
        {
          // La fonction mail a t excute avec succs, mais cela signifie simplement que le MTA local a pris le message en charge. Nous n'avons pas d'information sur la configuration du MTA local ni sur le devenir du message, il faut donc avertir l'utilisateur d'une possibilit de non transmission de l'information (indpendante d'IEW)
          $ok_message = "<div align='justify'>Le message a t correctement pris en charge par le service de courrier. Cependant, ce service tant indpendant de l'application IEW, il ne peut tre garanti que le message soit effectivement reu par le destinataire (le service de messagerie est peut-tre mal configur, ou la connexion internet inactive au moment de l'envoi)<br /><br />En consquence, il est recommand de contrler la bonne rception de ce message en vrifiant si l'tablissement a reu (sur <font color='blue'>".$GLOBALS['email_etablissement']."</font>) un accus de rception de la part du destinataire. Si tel n'tait pas le cas dans un dlai de 48 heures, il est conseill d'envoyer manuellement ce mail au destinataire, par le moyen de votre choix.<br /><br />A cet effet, copiez le corps du message et le coller dans votre client de messagerie habituel, dans un nouveau message que vous enregistrerez en tant que brouillon (au cas o)<br /><br />************ Dbut du Corps du message  copier ***********<br /><br />".str_replace("\n","<br />",$message)."<br/><br />************ Fin du Corps du message  copier ***********<br/><br />
          </div>
          <div align='right'>
          <a href='".$_SERVER['PHP_SELF']."'>[Retour  la liste des IPR]</a></div>";
          affiche_ok($ok_message);
          return;
        }
        break;
      case 'nomail': // Refus d'envoi de mail automatique (suite  la cration d'un compte IPR)
        $message = $_SESSION['message_ipr'];
        $email = $_SESSION['email_ipr'];
        $nom = $_SESSION['nom_ipr'];
        $prenom = $_SESSION['prenom_ipr'];
        $error_message = array("<div align='justify'>Vous avez choisi de ne pas transmettre de faon automatique  <font color='blue'>".strtoupper(substr(stripslashes($prenom),0,1)).substr(stripslashes($prenom),1,strlen(stripslashes($prenom))-1)." ".strtoupper(stripslashes($nom))."</font> ses codes d'accs  IEW.<br />Il faudra nanmoins pour lui permettre d'accder  l'application, lui communiquer ses codes par un autre moyen (Vous pouvez copiez/coller ou imprimer le message qui suit pour l'envoyer manuellement  son destinataire) :<br /><br />
        ".str_replace("\n","<br />",$message)."<br /><br /></div>
        <div align='right'>
        <a href='".$_SERVER['PHP_SELF']."'>[Retour  la liste des IPR]</a></div>","");
        affiche_erreurs($error_message);
        return;
        break;
      default: // En cas de paramtre action non prvu dans l'URL, on abandonne le script
        return;
    }

  // Traitement du formulaire pour la cration d'un compte ipr
  
  if (isset($_POST['soumettre'])) // si le formulaire de cration de compte vient d'tre envoy
  {
    if (!filled_out($_POST) || count($_POST['profs']) == 0)
    {
      //var_dump($_POST);
      $error_message = array("Certains champs ne sont pas remplis !","");
      affiche_erreurs($error_message);
      affiche_form($id_pers);
      return;
    }
    else 
   {
  	  $mel = trim(htmlspecialchars($_POST['email']));
      if (!email_check($mel, $error_message))
      {
        // la fonction renvoie un message d'erreur sous la form d'une chane
        $error_message = array("$error_message",""); // on la transforme en tableau pour permettre l'affichage par le systme d'affichage des messages d'erreurs (qui s'attend  avoir un tableau  traiter)
        affiche_erreurs($error_message);
        affiche_form($id_pers);
        return;
      }
    }
    $date_visite = convert_date_to_mysql($_POST['date_visite'],'-');
    // On vrifie si la date de visite est un jour ouvrable (au cas o)
    if (!test_jour_dans_periode_scolaire($date_visite) || !test_jour_ouvrable(date_mysql_to_jjmmaaaa($date_visite))) // Si c'est dans une priode de travail
    {
      $error_message = array("<div align='justify'>La date choisie (".format_date_long($GLOBALS['default_language'],date_mysql_to_jjmmaaaa($date_visite)).") n'est pas un jour ouvrable de la semaine dans l'tablissement ou bien tombe pendant les vacances scolaires !");
      affiche_erreurs($error_message);
      affiche_form($id_pers);
      return; 
    }
    settype($_POST['duree_validite'],"integer"); // On convertit la dure de validit du compte du format chane en format numrique entier
    if ($_POST['duree_validite']<=0 && $_POST['duree_validite'] != -1)
    {
      $error_message = array("La dure de validit du compte doit tre un nombre entier suprieur  zro !","");
      affiche_erreurs($error_message);
      //echo $_POST['duree_validite'];
      affiche_form($id_pers);
      return;
    }
    elseif($_POST['duree_validite'] == -1) // pas de limite de dure
    {
      $date_validite = "";
    }
    else
    {
      $duree_validite = intval($_POST['duree_validite'])-1;
      $date_validite = date("Y-m-d",strtotime("$date_visite+$duree_validite days")); // Dtermination de la date d'inactivation de l'accs
      //echo $date_validite; return;
    }
    
    $email = trim(htmlspecialchars($_POST['email']));
    if (!email_check($email, $error_message))
    {
      // la fonction renvoie un message d'erreur sous la form d'une chane
      $error_message = array("$error_message",""); // on la transforme en tableau pour permettre l'affichage par le systme d'affichage des messages d'erreurs (qui s'attend  avoir un tableau  traiter)
      affiche_erreurs($error_message);
      affiche_form($id_pers);
      return;
    }
    $liste_prof = $_POST['profs'];
    // DEBUGG print "Liste des identifiants profs inspects : ";print_r($liste_prof);
    $id_groupe_utilisateur = "11"; // c'est le groupe ipr
    $nom = stripslashes($_POST['nom']); // au cas o le php.ini active les magic_quotes
    $prenom = stripslashes($_POST['prenom']);
    
    if ($_POST['soumettre'] == "Crer le compte")
    {     
      // La date de visite doit aussi tre postrieure (ou gale)  la date en cours
      if (strtotime($date_visite) < strtotime(convert_date_to_mysql(date("d/m/Y"))))
      {
        $error_message = array("La date de visite doit tre postrieure (ou gale)  la date d'aujourd'hui !","");
        affiche_erreurs($error_message);
        affiche_form($id_pers);
        return; 
      }
      // On cre le compte d'accs IEW
      $nom = trim(htmlspecialchars($nom)); // // On vrifie les entres de formulaire (on retire les caractres spciaux posant des problmes de scurit)*/
      $prenom = trim(htmlspecialchars($prenom));
      $nom = strtoupper($nom); // et on met en majuscules
      $prenom = strtoupper(substr($prenom,0,1)).strtolower(substr($prenom,1,strlen($prenom)-1)); // La 1re lettre en majuscule
      
      // On ouvre le fichier texte qui va contenir les codes d'accs
      $fichier = fopen($GLOBALS['stock_baselev']."comptes_ipr.txt","a");
       $GLOBALS['flag_no_user_ldap_import'] = true; // Le $flag_no_user_ldap_import sert  indiquer que la cration du compte IEW doit avoir lieu
	   // avec cration d'un mot de passe (et inscription dans un fichier de diffusion),
       // mme si la mthode d'authentification par dfaut n'est pas native
      if ($id=cree_compte_iew("","","",$nom,$prenom,$id_groupe_utilisateur,$fichier,""))
      {
        // On insre les donnes du formulaire dans la base de donnes
        // Il faut prparer le formatage du tableau $liste_prof contenant les personnes inspectes en une variable contenant des valeurs spares par des virgules
        $liste = "";
        foreach($liste_prof as $value)
        { 
          $liste .= $value.",";
        }
        $liste = substr($liste,0,strlen($liste)-1); // on retire la virgule  la fin
        $discipline = $_POST['discipline'];
        $sql = "INSERT INTO ipr VALUES('".quote_smart($id)."','".quote_smart($nom)."','".quote_smart($prenom)."','".quote_smart($discipline)."','".quote_smart($date_visite)."','".quote_smart($email)."','".quote_smart($liste)."')";
        $flag=mysql_query($sql);
        if ($flag) // Si la requte a abouti
        {
          $ok_message = "<div align='justify'>Un nouvel IPR <font color='blue'>(".stripslashes($nom)." ".stripslashes($prenom).")</font> a t ajout dans la base de donnes.<br />Le mail qui suit peut lui tre envoy automatiquement ( l'adresse <font color='blue'>$email</font>) pour lui transmettre ses codes d'accs et quelques indications sommaires pour se connecter. Veuillez contrler ce mail avant de dcider de l'envoyer : <br />";
          
          // On met  jour la date de validit du compte IPR, cela n'a pas pu tre fait lors de la cration du compte IPR (car la fonction cree_compte_iew ne le permet pas)
          $sql4 = "UPDATE login set date_validite='$date_validite' WHERE id_pers='$id'";
          mysql_query($sql4);
          
          // il faut lui envoyer un mail avec ses codes d'accs, quelques indications et le rappel des enseignants inspects
        
          // Rcuprons les codes d'accs
          $fichier = fopen($GLOBALS['stock_baselev']."comptes_ipr.txt","r");
          include(CONF_DIR."k.php");
          while (!feof($fichier)) // on commence la recherche jusqu' la fin du fichier
          {
            $champs=fgetcsv($fichier,100,","); // Lit une ligne et envoie dans un tableau les champs spars par ","
            if ($champs[0]==$id) // L'utilisateur est trouv
            {
              $login = $champs[1];
              // Le mot de passe dans le fichier lu est crypt, il faut le dcrypter pour le fichier de diffusion
              $password = mcrypt_decrypt($algo, $crypt_key, base64_decode($champs[4]), $mode, $iv);
              $password = rtrim($password, "\0"); // Supprime les caractres null en fin de chane ventuellement ajouts par la fonction mcrypt_decrypt() 
            }
          }

          // On recherche les enseignants inspects
          $sql = "SELECT id_pers,id_individu,civilite,nom,prenom FROM personnel WHERE id_individu IN (".quote_smart($liste).") ORDER BY nom,prenom";
          $resultat = mysql_query($sql);

          // Voici le dbut du mail
          $message = "Bonjour,\n\nCeci est un message automatique envoy  ".stripslashes($nom)." ".stripslashes($prenom)." par l'application IEW du ".$GLOBALS['nom_etablissement']." :\n\nVous allez venir dans notre tablissement le ".format_date_long($GLOBALS['default_language'],date_mysql_to_jjmmaaaa($date_visite))." pour une mission d'inspection.\nNous utilisons des cahiers de textes lectroniques que vous pourrez consulter en vous connectant  notre application IEW (";
          // https obligatoire (en esprant que l'admin iew ait fait ce qu'il fallait...)
          $protocole = "https";
          if ($date_validite !="")
            $message .= "$protocole://".$_SERVER['HTTP_HOST'].$GLOBALS['racine']."?log=locale) avec l'identifiant '$login' et le mot de passe '$password'\nL'accs  ces ressources est limit dans le temps : votre compte est activ depuis aujourd'hui (".format_date_long($GLOBALS['default_language'],date_mysql_to_jjmmaaaa(date("Y-m-d"))).") jusqu'au ".format_date_long($GLOBALS['default_language'],date_mysql_to_jjmmaaaa($date_validite))." inclus.";
          else
            $message .= "$protocole://".$_SERVER['HTTP_HOST'].$GLOBALS['racine'].") avec l'identifiant '$login' et le mot de passe '$password'\nL'accs  ces ressources est illimit dans le temps : votre compte est activ depuis aujourd'hui (".format_date_long($GLOBALS['default_language'],date_mysql_to_jjmmaaaa(date("Y-m-d"))).").";
          $message .= "\n\nPour consulter un cahier de texte (une fois connect et aprs avoir accept la charte de l'application), cliquez sur le bouton 'Cahier de textes' dans la barre de navigation horizontale suprieure, puis choisissez la classe souhaite; enfin, dans le sommaire de gauche (section synthse), cliquez sur le lien 'Synthse matire' : vous avez alors accs au cahier de textes de la classe depuis le dbut de l'anne scolaire.
          \n\nLa documentation Professeur de notre application pourra vous clairer : http://iew.free.fr/IMG/pdf/guide_prof_iew.pdf (pour vous, pages 7, 21 et 22 notamment).
          \n\nVoici un rappel des enseignants que vous allez inspecter, ainsi que la liste de leurs classes :\n";
          // On y insre le rappel des enseignants inspects (et de leurs classes)
          while ($enregistrement = mysql_fetch_array($resultat))
          {
            $sql1 = "SELECT DISTINCT code_structure FROM services as t1, enseignants_services as t2 WHERE id_individu='".$enregistrement['id_individu']."' AND t1.id_service=t2.id_service";
          	$resultat1 = mysql_query($sql1);
            if ($resultat1)
            {
              if (mysql_num_rows($resultat1)>0)
              {  
                $message .= "- ".$enregistrement['civilite']." ".$enregistrement['nom']." ".$enregistrement['prenom']." : ";
                while ($ligne = mysql_fetch_array($resultat1))
                {
                  $message .= $ligne['code_structure'].", ";
                }
                $message = substr($message,0,strlen($message)-2); // on retire la virgule et l'espace  la fin
                $message .= "\n";
              }
              else // Dans le cas de l'enseignant documentaliste par exemple, il n'y a pas de classe
              {
                $message .= "- ".$enregistrement['civilite']." ".$enregistrement['nom']." ".$enregistrement['prenom']."\n";
              }
            }  
          }
          $message .= "\nN'hsitez pas  nous demander conseil en cas de problme.
          \n\nIMPORTANT : Merci de confirmer par retour de courrier la prise de connaissance de vos codes d'accs ds rception de ce message.
          \n\nA bientt.\n".$GLOBALS['admin_name'].", Administrateur de l'application IEW (".$GLOBALS['admin_email'].")\n".$GLOBALS['nom_etablissement']."\n".$GLOBALS['adresse_etablissement']."\n".$GLOBALS['cp_etablissement']." ".$GLOBALS['ville_etablissement']."\nTl : ".$GLOBALS['tel_etablissement']."\nFax : ".$GLOBALS['fax_etablissement']."\nCourriel : ".$GLOBALS['email_etablissement'];
          
          // On formate le message pour l'afficher  l'cran pour l'information de l'utilisateur sur le contenu du mail automatique qui va tre envoy :
          $ctrl_message = str_replace("\n","<br />",$message);
          $ok_message .= "<br />***************** Dbut du Message ****************<br /><br />".$ctrl_message."<br /><br />***************** Fin du Message ****************<br /><br /></div>
          <a href='".$_SERVER['PHP_SELF']."?action=mail'>[Lancer l'envoi automatique du message]</a>&nbsp;&nbsp;&nbsp;<a href='".$_SERVER['PHP_SELF']."?action=nomail'>[Ne pas envoyer]</a>";
          affiche_ok($ok_message);
          $_SESSION['message_ipr'] = $message;
          $_SESSION['email_ipr'] = $email;
          $_SESSION['nom_ipr'] = $nom;
          $_SESSION['prenom_ipr'] = $prenom;
          unset($_POST);
          unset($_SESSION['post_imprimable']);
          return;
        }
        else // La requte n'a pas abouti (membre dj existant, serveur MySQL indisponible)
        {
          $error_message = array("Le nouvel IPR n'a pu tre ajout dans la base de donnes ou existe dja.","");
          affiche_erreurs($error_message);
          unset($_POST);
          unset($_SESSION['post_imprimable']);
        }
      }
      else 
      {
        // Erreur MySQL
        $error_message = array("<div align='justify'>La table contenant le compte utilisateur (identifant + mot de passe) n'a pas pu tre mise  jour parce que l'utilisateur existe dj ou parce qu'il y a un problme avec le serveur MySQL! Veuillez ressayer ultrieurement. Cet utilisateur n'a pas t ajout  la base de donnes.<br />
        Erreur MySQL n".mysql_errno()." : ".mysql_error()."</div>","");
        affiche_erreurs($error_message);
        unset($_POST);
        unset($_SESSION['post_imprimable']);
      }
    }
    elseif($_POST['soumettre'] == "Modifier la fiche")
    {
        // On vrifie les entres de formulaire (on retire les caractres spciaux posant des problmes de scurit)
        $nom = strtoupper(trim(htmlspecialchars(quote_smart($nom)))); // et on met en majuscules
        $prenom = trim(htmlspecialchars(quote_smart($prenom)));
        $prenom = strtoupper(substr($prenom,0,1)).strtolower(substr($prenom,1,strlen($prenom)-1)); // La 1re lettre en majuscule
        $discipline = $_POST['discipline'];
        
        // Il faut prparer le formatage du tableau $liste_prof contenant les personnes inspectes en une variable contenant des valeurs spares par des virgules
        $liste = "";
        foreach($liste_prof as $value)
        { 
          $liste .= $value.",";
        }
        $liste = substr($liste,0,strlen($liste)-1); // on retire la virgule  la fin
        
        // On rcupre le nom et le prnom de l'ipr avant la modification (on en a besoin pour mettre  jour comptes_ipr.txt)
        $sql3 = "SELECT nom,prenom FROM login WHERE id_pers='".quote_smart($_POST['id_pers'])."'";
        $resultat3 = mysql_query($sql3);
        $ligne3 = mysql_fetch_array($resultat3);
        $ancien_nom = $ligne3['nom'];
        $ancien_prenom = $ligne3['prenom'];

        // On insre les nouvelles donnes du formulaire dans la base de donnes
        $sql1 = "UPDATE ipr SET nom='$nom',prenom='$prenom',code_discipline='".quote_smart($discipline)."',date_visite='".quote_smart($date_visite)."',email='".quote_smart($email)."',liste_profs='".quote_smart($liste)."' WHERE id_pers='".quote_smart($_POST['id_pers'])."'";
        $sql2 = "UPDATE login SET nom='$nom',prenom='$prenom',date_validite='".quote_smart($date_validite)."' WHERE id_pers='".quote_smart($_POST['id_pers'])."'";
        //echo $sql1."<br />".$sql2;
        if (mysql_query($sql1) && mysql_query($sql2)) // Si la requte a abouti
        {
          // Il faut mettre  jour le fichier comptes_ipr.txt
          modif_fichier_texte_codes_acces($GLOBALS['stock_baselev']."comptes_ipr.txt","",$id_pers,$ancien_prenom,$ancien_nom,$prenom,$nom,"");
          $ok_message = "<div align='justify'>La fiche de <font color='blue'>".stripslashes($nom)." ".stripslashes($prenom)."</font> a t mise  jour.<br /></div>";
          affiche_ok($ok_message);
          unset($_POST);
          unset($_SESSION['post_imprimable']);
        }
        else // La requte n'a pas abouti (membre dj existant, serveur MySQL indisponible)
        {
          $error_message = array("La fiche de <font color='blue'>".stripslashes($nom)." ".stripslashes($prenom)."</font> n'a pas pu tre mise  jour.
          <br />Erreur MySQL n".mysql_errno()." : ".mysql_error()."<br />Veuillez ressayer ultrieurement.<br />","");
          affiche_erreurs($error_message);
          unset($_POST);
          unset($_SESSION['post_imprimable']);
        }
    }
  }
  
  
  // On commence par vrifier s'il y a dj des comptes ipr
  $sql = "SELECT * FROM ipr ORDER BY nom,prenom";
  $resultat = mysql_query($sql);
  if ($resultat && mysql_num_rows($resultat))
  {
    echo "
    <table width='100%'>
      <tr>
        <td>
          Il y a <b><font color=\"red\">".mysql_num_rows($resultat)."</font></b> fiche(s) dans la base de donnes.
        </td>
        <td align='right'>
          <a href='".$_SERVER['PHP_SELF']."?action=creer'>[Crer un nouveau compte IPR]</a>
        </td>
      </tr>
    </table>
    ";
    $code_formulaire = "<br />
    <table class='ctextes'>
      <tr>
        <th>Nom</th>
        <th>
          Prnom
        </th>
        <th>
          Action
        </th>
        <th>
          Compte activ
        </th>
        <th>
          Expiration du compte
        </th>
      </tr>";
    while ($ligne = mysql_fetch_array($resultat))
    {
      $code_formulaire .= "
      <tr>
        <td>
          ".stripslashes($ligne["nom"])."
        </td>
        <td>
          ".stripslashes($ligne["prenom"])."
        </td>";
      $code_formulaire .= "
        <td align='center'>
          <a href=\"?action=modifier&amp;id_pers=".$ligne['id_pers']."\">Editer/Modifier</a>";
          $code_formulaire .= "&nbsp;&nbsp;&nbsp;<a href=\"?action=supprimer&amp;id_pers=".$ligne['id_pers'];
          $code_formulaire .= "\" onClick=\"return(window.confirm('Voulez-vous vraiment supprimer compltement le compte de ".addslashes($ligne['prenom'])." "  .addslashes($ligne['nom'])." dans la base de donnes ?'));\">Supprimer</a>
        </td>
        <td align='center'>";
        $sql = "SELECT date_validite,etat FROM login as t1, ipr as t2 WHERE t1.id_pers=t2.id_pers AND t1.id_pers='".quote_smart($ligne['id_pers'])."'";
        //echo $sql."<br />";
        $result = mysql_query($sql);
        if ($result)
          if (mysql_num_rows($result))
          {
            $enregistrement = mysql_fetch_array($result);
            $etat = $enregistrement['etat'];
            $date_validite = $enregistrement['date_validite'];
            if ($date_validite != "")
            {
              if ($etat == 1 && strtotime(convert_date_to_mysql(date("d/m/Y")))<=strtotime($date_validite))
                $code_formulaire .= "Oui <a href='?action=activ&amp;code=0&amp;id_pers=".$ligne['id_pers']."&amp;date_validite=$date_validite'>[Dsactiver]</a>";
              else
                $code_formulaire .= "Non <a href='?action=activ&amp;code=1&amp;id_pers=".$ligne['id_pers']."&amp;date_validite=$date_validite'>[Activer]</a>";
            }
            else // pas de date limite
            {
              if ($etat == 1)
                $code_formulaire .= "Oui <a href='?action=activ&amp;code=0&amp;id_pers=".$ligne['id_pers']."'>[Dsactiver]</a>";
              else
                $code_formulaire .= "Non <a href='?action=activ&amp;code=1&amp;id_pers=".$ligne['id_pers']."'>[Activer]</a>";
            }
          }
          else
         {
            $code_formulaire .="Pas de compte !";
          }
        $code_formulaire .= "
        </td>
        <td align='center'>"; 
          if ($date_validite !="")
          $code_formulaire .=
          MySQLDateToExplicitDate($date_validite,0,1);
          else
            $code_formulaire .="Jamais";
          $code_formulaire .=
          "
        </td>
      </tr>";
    }
    $code_formulaire .= "
    </table><br />";
    echo "<center>";
    squelette_formulaire_standard("100%","","","Liste alphabtique des IPR ayant un compte IEW",$code_formulaire,"","","","","","",""); 
    echo "</center>";
  }
  else
  // Affichage du formulaire de cration du 1er compte IPR
    affiche_form($id_pers);
}
else // L'utilisateur essaie d'invoquer ce script directement dans l'URL (interdit)
{
  $error_message = array("Vous tentez d'accder  un script qui n'est pas accessible directement  partir de l'URL... Utilisez les liens de navigation !","");
  affiche_erreurs($error_message);
}
?>