<?php
/**
 * c_do_imports_adm.php
 *
 * Ralise l'import des donnes administratives XML dans la base de donnes
 * Affiche un rapport rsum de l'opration et enregistre un rapport dtaill
 * consultable en ligne par un lien affich dans le rapport rsum
 * 
 * Ce fichier fait partie du projet IntraEduWeb (IEW)
 * 
 * @package		IEW
 * @author			Sylvain GODM <sylvain.godme@gmail.com>
 * @version		$LastChangedRevision$, $LastChangedDate$
 * @copyright		2004-2012 Sylvain GODM
 * @link			http://iew.free.fr
 * @license		GPL License version 3 (http://www.gnu.org/licenses/gpl.html)
 * @filesource
 * 
 */

if (!defined('IEW_DIR')) {
 	/**
 	 * Constante contenant le chemin complet du rpertoire d'installation IEW
 	 */	
	define('IEW_DIR',realpath(dirname(__FILE__).'/../../../').'/');
}

/**
 * On inclut la librairie complte des fonctions et les fichiers de config, et on dmarre la session PHP
 */
require_once(IEW_DIR."librairie_fonctions.php"); 

function efface_post()
{
	/**
	 *  On efface les donnes du post et de $_SESSION['post_imprimable'] pour empcher en cas de rechargement de page une nouvelle excution 
	 */
 	unset($_POST['soumettre']);
 	unset($_SESSION['post_imprimable']['soumettre']);
}

function insert_maj_services($value,$service,$type_structure)
{
	/* Permet d'insrer un nouveau service ou de mettre  jour un service existant
	 * dans la table "services"
	 * 
	 * @param $value : contient l'arborescence xml d'une structure (division, groupe) dans sts_emp_RNE_annee.xml
	 * @param $service : contient l'arborescence xml d'un service rattach  une structure (division, groupe) dans sts_emp_RNE_annee.xml
	 * @param $type_structure : valeur "la division" pour une division, "le groupe" pour un groupe (utilis dans le rapport d'importation)
	 * 
	 * @return $id_service : identifiant de service dans la table "services"
	 * */
	
	global $rapport;
	
	// on rcupre le libell de la matire pour le rapport
	$libelle_matiere = ""; // Rinitialis  chaque boucle foreach
	$sql = "SELECT libelle_long FROM matieres_sconet WHERE code_matiere='".$service->tagAttrs['code_matiere']."'";
	$resultat = mysql_query($sql);
	$ligne = mysql_fetch_array($resultat);
	$libelle_matiere = $ligne['libelle_long'];
	
	$sql = "INSERT INTO services VALUES(NULL,'".quote_smart($value->tagAttrs['code'])."','".quote_smart($service->tagAttrs['code_matiere'])."','".quote_smart($service->tagAttrs['code_mod_cours'])."','".quote_smart($service->heures_structure[0]->tagData)."','".quote_smart($service->co_ens[0]->tagData)."')";
	mysql_query($sql); // On tente l'insertion dans la table services
	
	if (mysql_affected_rows() == 1)
	{
		$rapport .= "Pour $type_structure ".$value->tagAttrs['code'].", et la matire <strong><i>".$libelle_matiere."</i></strong> (code_matiere=".$service->tagAttrs['code_matiere'].") (modalit=".$service->tagAttrs['code_mod_cours']."), l'horaire <strong>".$service->heures_structure[0]->tagData."</strong> a t <u>ajout</u> dans la base de donnes.<br />";
		$id_service = mysql_insert_id();
	}
	else // l'insertion ne marche pas => On tente une MAJ
	{
		$sql = "UPDATE services set heure='".quote_smart($service->heures_structure[0]->tagData)."', co_ens='".quote_smart($service->co_ens[0]->tagData)."' WHERE code_structure='".quote_smart($value->tagAttrs['code'])."' AND code_matiere='".quote_smart($service->tagAttrs['code_matiere'])."' AND code_mod_cours='".quote_smart($service->tagAttrs['code_mod_cours'])."'";
		mysql_query($sql);
		if (mysql_affected_rows() == 1) // Mise  jour faite : des champs ont chang
		{
			$rapport .= "Pour $type_structure ".$value->tagAttrs['code'].", et la matire <strong><i>".$libelle_matiere."</i></strong> (code_matiere=".$service->tagAttrs['code_matiere'].") (modalit=".$service->tagAttrs['code_mod_cours']."), l'horaire <strong>".$service->heures_structure[0]->tagData."</strong> <u>existe dj</u> dans la base de donnes MAIS a t mis  jour.<br />";
		}
		else // Les donnes sont identiques  celles de la base
		{
			$rapport .= "Pour $type_structure ".$value->tagAttrs['code'].", et la matire <strong><i>".$libelle_matiere."</i></strong> (code_matiere=".$service->tagAttrs['code_matiere'].") (modalit=".$service->tagAttrs['code_mod_cours']."), l'horaire <strong>".$service->heures_structure[0]->tagData."</strong> <u>existe dj</u> dans la base de donnes et il n'y a pas de modification.<br />";
		}
		// Il faut rcuprer un id_service
		$sql = "SELECT id_service FROM services WHERE code_structure='".quote_smart($value->tagAttrs['code'])."' AND code_matiere='".quote_smart($service->tagAttrs['code_matiere'])."' AND code_mod_cours='".quote_smart($service->tagAttrs['code_mod_cours'])."'";
		$resultat = mysql_query($sql);
		if ($resultat && mysql_num_rows($resultat)>0)
		{
			$ligne = mysql_fetch_array($resultat);
			$id_service = $ligne['id_service'];
		}
	}
	return $id_service;
}

function insert_maj_enseignants_services($id_service,$enseignant)
{
	/* Permet de rattacher un nouveau service  un enseignant ou de mettre  jour un service enseignant
	 * dans la table "enseignants_services"
	 * 
	 * @param $id_service : identifiant de service dans la table "services" servant de cl de jointure avec la table "enseignants_services"
	 * @param $enseignant : contient l'arborescence xml d'un enseignant rattach  un service lui-mme rattach  une structure (division, groupe) dans sts_emp_RNE_annee.xml 
	 * 
	 * @return $id_enseignant_service : identifiant du service de l'enseignant dans la table "enseignants_services"
	 * */
	
	global $rapport;
	
	// On rcupre le nom et le prnom de l'enseignant pour le rapport
	$nom=""; // s'assure d'effacer la vleur prcdente
	$prenom="";
	$sql = "SELECT nom,prenom FROM personnel WHERE categorie='7' AND id_individu='".$enseignant->tagAttrs['id']."'";
	$resultat = mysql_query($sql);
	$ligne = mysql_fetch_array($resultat);
	$nom = $ligne['nom'];
	$prenom = $ligne['prenom'];
	
	// La balise XML TAUX_PONDERATION n'est pas forcment prsente
	if (!isset($enseignant->taux_ponderation[0]))
		$taux_ponderation = "NULL";
	else
		$taux_ponderation = "'".quote_smart($enseignant->taux_ponderation[0]->tagData)."'";
	$sql = "INSERT INTO enseignants_services VALUES(NULL,'".quote_smart($id_service)."','".quote_smart($enseignant->tagAttrs['type'])."','".quote_smart($enseignant->tagAttrs['id'])."','".quote_smart($enseignant->heures_agent[0]->tagData)."',$taux_ponderation)";
	// DEBUGG echo $sql."<br />";
	mysql_query($sql); // On tente l'insertion dans la table enseignants_services
	if (mysql_affected_rows() == 1)
	{
		$rapport .= "Le Service n ".$id_service.", est assur par l'enseignant <strong><i>$nom ".ucfirst(strtolower($prenom))."</i></strong> (ID=".$enseignant->tagAttrs['id']."), ceci a t <u>ajout</u> dans la base de donnes.<br />";
		$id_enseignant_service = mysql_insert_id();
	}
	else // l'insertion ne marche pas => On tente une MAJ
	{
		$sql = "UPDATE enseignants_services set type='".quote_smart($enseignant->tagAttrs['type'])."', heures_agent='".quote_smart($enseignant->heures_agent[0]->tagData)."', taux_ponderation=$taux_ponderation WHERE id_service='".quote_smart($id_service)."' AND id_individu='".quote_smart($enseignant->tagAttrs['id'])."'";
		mysql_query($sql);
		if (mysql_affected_rows() == 1) // Mise  jour faite : des champs ont chang
		{
			$rapport .= "Le Service n ".$id_service.", est assur par l'enseignant <strong><i>$nom ".ucfirst(strtolower($prenom))."</i></strong> (ID=".$enseignant->tagAttrs['id']."), <u>ceci existe dj</u> dans la base de donnes MAIS a t mis  jour.<br />";
		}
		else // Les donnes sont identiques  celles de la base
		{
			$rapport .= "Le Service n ".$id_service.", est assur par l'enseignant <strong><i>$nom ".ucfirst(strtolower($prenom))."</i></strong> (ID=".$enseignant->tagAttrs['id']."), <u>existe dj</u> dans la base de donnes et il n'y a pas de modification.<br />";
		}
		// Il faut rcuprer un id_enseignant_service
		$sql = "SELECT id_enseignant_service FROM enseignants_services WHERE id_service='".quote_smart($id_service)."' AND id_individu='".quote_smart($enseignant->tagAttrs['id'])."'";
		$resultat = mysql_query($sql);
		if ($resultat && mysql_num_rows($resultat)>0)
		{
			$ligne = mysql_fetch_array($resultat);
			$id_enseignant_service = $ligne['id_enseignant_service'];
		}
	}
	return $id_enseignant_service;
}

function insert_maj_cours($id_enseignant_service,$cours,$service,$type_structure,$code_structure)
{
	/* Permet d'insrer un nouveau cours ou de mettre  jour un cours existant
	 * dans la table "cours"
	 * 
	 * @param $id_enseignant_service : identifiant du service de l'enseignant dans la table "enseignants_services"
	 * @param $cours : contient l'arborescence xml d'un cours rattach  un enseignant lui-mme rattach  un service lui-mme rattach  un structure (division ou groupe) dans EDT_vers_STS_RNE_annee.xml
	 * @param $service : contient l'arborescence xml d'un service au sein de la division ou du groupe dans EDT_vers_STS_RNE_annee.xml
	 * @param $type_structure : valeur "la division" pour une division, "le groupe" pour un groupe (utilis dans le rapport d'importation
	 * 
	 * */
	
	global $rapport,$nom,$prenom,$libelle_matiere,$balises_cours,$duree_cours,$id_individu;
	// on rcupre le nom du jour de ce cours pour le rapport
	$jour = "";
	$sql = "SELECT jour FROM jours WHERE code_jour='".$cours->jour[0]->tagData."'";
	$resultat = mysql_query($sql);
	$ligne = mysql_fetch_array($resultat);
	$jour = $ligne['jour'];
										
	// La balise XML CODE_MATIERE_ETABLISSEMENT n'est pas forcment prsente
	if (!isset($cours->code_matiere_etablissement[0]))
		$code_matiere_etablissement = "NULL";
	else
	$code_matiere_etablissement = "'".quote_smart($cours->code_matiere_etablissement[0]->tagData)."'";
	// La balise XML CODE_SALLE n'est pas forcment prsente
	if (!isset($cours->code_salle[0]))
		$code_salle = "NULL";
	else
		$code_salle = "'".quote_smart($cours->code_salle[0]->tagData)."'";
	$sql = "INSERT INTO cours values(NULL,'".quote_smart($id_enseignant_service)."','".quote_smart($cours->code_alternance[0]->tagData)."','".quote_smart($cours->jour[0]->tagData)."','".quote_smart($cours->heure_debut[0]->tagData)."','".quote_smart($cours->duree[0]->tagData)."','".quote_smart($service->tagAttrs['code_matiere'])."',$code_matiere_etablissement,$code_salle)";
	mysql_query($sql); // On tente l'insertion dans la table cours
	if (mysql_affected_rows() == 1)
	{
		$rapport .= "Pour $type_structure ".$code_structure.", et la matire <strong><i>$libelle_matiere</i></strong> (code_matiere=".$service->tagAttrs['code_matiere'].") (modalit=".$service->tagAttrs['code_mod_cours']."), le cours est assur par l'enseignant <strong><i>$nom ".ucfirst(strtolower($prenom))."</i></strong> (ID=".$id_individu.") le $jour (heure_debut : ".formate_horaire($cours->heure_debut[0]->tagData)." en semaine <strong>".$cours->code_alternance[0]->tagData."</strong> dure : ".formate_horaire($cours->duree[0]->tagData)."), ceci a t <u>ajout</u> dans la base de donnes.<br />";
		$balises_cours++;
		if ($cours->code_alternance[0]->tagData == "H")
			$duree_cours += $cours->duree[0]->tagData;
		else 
			$duree_cours += ($cours->duree[0]->tagData)/2;
	}
	else // l'insertion ne marche pas => On tente une MAJ
	{
		$sql = "UPDATE cours set code_alternance='".quote_smart($cours->code_alternance[0]->tagData)."', code_jour='".quote_smart($cours->jour[0]->tagData)."', heure_debut='".quote_smart($cours->heure_debut[0]->tagData)."', duree='".quote_smart($cours->duree[0]->tagData)."', code_matiere_etab=$code_matiere_etablissement, code_salle=$code_salle  WHERE id_enseignant_service='".quote_smart($id_enseignant_service)."' AND code_matiere='".quote_smart($service->tagAttrs['code_matiere'])."'";
		mysql_query($sql);
		if (mysql_affected_rows() == 1) // Mise  jour faite : des champs ont chang
		{
			$rapport .= "Pour $type_structure ".$code_structure.", et la matire <strong><i>$libelle_matiere</i></strong> (code_matiere=".$service->tagAttrs['code_matiere'].") (modalit=".$service->tagAttrs['code_mod_cours']."), le cours est assur par l'enseignant <strong><i>$nom ".ucfirst(strtolower($prenom))."</i></strong> (ID=".$id_individu.") le $jour (heure_debut : ".formate_horaire($cours->heure_debut[0]->tagData)." en semaine <strong>".$cours->code_alternance[0]->tagData."</strong> dure : ".formate_horaire($cours->duree[0]->tagData)."), <u>ceci existe dj</u> dans la base de donnes MAIS a t mis  jour.<br />";
		}
		else // Les donnes sont identiques  celles de la base
		{	
			$rapport .= "Pour $type_structure ".$code_structure.", et la matire <strong><i>$libelle_matiere</i></strong> (code_matiere=".$service->tagAttrs['code_matiere'].") (modalit=".$service->tagAttrs['code_mod_cours']."), le cours est assur par l'enseignant <strong><i>$nom ".ucfirst(strtolower($prenom))."</i></strong> (ID=".$id_individu.") le $jour (heure_debut : ".formate_horaire($cours->heure_debut[0]->tagData)." en semaine <strong>".$cours->code_alternance[0]->tagData."</strong> dure : ".formate_horaire($cours->duree[0]->tagData)."), <u>existe dj</u> dans la base de donnes et il n'y a pas de modification.<br />";
		}
	}
}

function formate_horaire($horaire)
{
	/*
	 * @param $horaire : horaire au format numrique hhmm
	 * @return $horaire_chaine : horaire format en chane "hh"."h"."mm"
	 *  */
	$horaire_chaine = substr($horaire,0,2)."h".substr($horaire,-2);
	return $horaire_chaine;
}

// Au cas o, Finalisation de l'import (suppression des comptes prof ou administratifs non retrouvs)
if (isset($_GET['action']) && $_GET['action'] == "delprof")
{
	// on vient de poster les personnes  supprimer de la liste du personnel
	if (isset($_POST['soumettre']))
	{
		$ok_message = stripslashes($_POST['ok_message']);
		$link_rapport = stripslashes($_POST['link_rapport']);
		$name_file_report = $_POST['name_file_report'];
		$compteur_suppr = 0;
		foreach ($_POST as $key => $value)
		{
			if (substr($key,0,10) == "suppr_prof") // Ce champ indique un prof  supprimer
			{
				if ($GLOBALS['auth_method'] == "native") // compatibilit anciennes versions
    			{
 					$fichier_suppr = @fopen($GLOBALS['stock_baselev']."suppr_comptes_personnel.txt","w"); // on ouvre en criture un fichier qui recevra les comptes profs  supprimer
    			}
				if (!isset($rapport))
					$rapport = "<h2>Professeurs et autres membres du personnel supprims (aprs confirmation)</h2>";
				// on rcupre les id : la variable $value est au format id_pers#id_individu
				$id_suppr = explode("#",$value);
				$id_pers = $id_suppr[0];
				$id_individu = $id_suppr[1];
				$civilite = $id_suppr[2];
				$nom = $id_suppr[3];
				$prenom = $id_suppr[4];
				$sql = "DELETE FROM personnel WHERE id_individu='".quote_smart($id_individu)."'";
      			if (mysql_query($sql) && mysql_affected_rows() > 0)
      			{
                	$rapport .= "<strong>$civilite $nom $prenom</strong> (ID_INDIVIDU = $id_individu) est <u>effac(e)</u> de la table du personnel<br />";
               		$compteur_suppr++; // on incrmente le compteur de suppression
    	  
       	          	// On supprime alors la photo d'identit si elle existe
           	      	$fichier_photo = $GLOBALS['stock_baselev']."fotoprof/".$id_pers.".jpg";
               	  	if (file_exists($fichier_photo))
               		{
                   		if(!@unlink($fichier_photo))
                   		{
                      		$err_mess = "La photo d'identit <strong>$id_pers.jpg</strong> ($civilite $nom $prenom) n'a pas pu tre supprime. Vrifiez que les droits sur les fichiers sont corrects<br />
                   			ou supprimez manuellement le fichier $id_pers.jpg dans le rpertoire ".$GLOBALS['stock_baselev']."fotoprof. Pour ce faire, <a href='mailto:".email_encode($GLOBALS['admin_email'])."'>prvenez votre administrateur IntraEduWeb</a> qui se chargera de la suppression.";
                   			$error_message = array("<div align='justify'>$err_mess</div>","");
                   			$rapport .= $err_mess."<br />";
                   			affiche_erreurs($error_message);
                   		}
                	}           
   				}
                // on recherche les informations sur son compte utilisateur : l'identifiant (nomlogin)
   	            $sql = "SELECT nomlogin FROM login WHERE id_pers='".quote_smart($id_pers)."'";
   				$resultat = mysql_query($sql);
   				if ($resultat && mysql_num_rows($resultat)!=0) // s'il existe
     			{
   					// on supprime le prof de la table login il n'a plus de compte IntraEduWeb
    				$sql = "DELETE FROM login WHERE id_pers='".quote_smart($id_pers)."'";
    	  			if (mysql_query($sql) && mysql_affected_rows() > 0)
      				{
        				$rapport .= "<strong>$civilite $nom $prenom</strong> (ID_INDIVIDU = $id_individu) est <u>effac(e)</u> de la table login<br /><br />";
      					// on supprime les donnees obsoletes : nettoyage des table accept_charte, auth_foto, demande_mdp
          	  			suppr_compte_tables_nettoyage($id_pers);
        				if ($GLOBALS['auth_method'] == "native") // compatibilit anciennes versions
   						{
    						$row = mysql_fetch_row($resultat);
   							$login = $row[0];
   							$enregistrement = $id_pers.",".$login.",".$prenom.",".$nom."\n";
   							fwrite($fichier_suppr,$enregistrement); // on enregistre son nom dans un fichier listant les comptes profs  supprimer
   						}
      				}
				}
    		}
		}
		if ($fichier_suppr)
			fclose($fichier_suppr);
		// On ajoute ces diffrentes suppression au rapport complet de l'importation
		$affichage_horodatage_jour = format_date_long("fr",date("j/m/Y"));
		$affichage_horodatage_heure = "  ".date("H")." heures ".date("i")." minutes ".date("s")." secondes";
		$rapport .= "<br /><p>Rapport finalis le ".$affichage_horodatage_jour.$affichage_horodatage_heure."</p>";
		$fichier_rapport = fopen($GLOBALS['stock_baselev']."importation/".$name_file_report,"a");
		fwrite($fichier_rapport, $rapport);
		fclose($fichier_rapport);
		// On raffiche le rsum de l'importation, avec le lien vers le rapport complet
		affiche_ok($ok_message.$link_rapport."<br />Il y a $compteur_suppr membre(s) du personnel non retrouv(s) dont la suppression a t confirme.<br />");
		return; // Permet de ne pas excuter la suite, puisqu'on est en phase finale
	}
	else // on ne devrait pas tre l...
	{
		$error_message = array("Vous tentez d'accder  un script qui n'est pas accessible directement  partir de l'URL...","");
  		affiche_erreurs($error_message);
  		return;
	}	
}

// Excution initiale
/** 
 * Rcupration des donnes de session utiles */
$tab_delfile = $_SESSION['tab_delfile'];
	
	global $rapport,$nom,$prenom,$libelle_matiere,$balises_cours,$duree_cours,$id_individu;
	setlocale (LC_CTYPE, 'fr_FR'); // pour que la fonction fgetcsv n'ait pas de problme avec les accents franais si le fichier lu est cod en ISO-8859-1
	
	// on tablit une fois pour toutes la connexion avec la base de donnes
	connexion_mysql();
	select_database();
	
	// On inclut le code du parser XML (XMLParser) : http://www.criticaldevelopment.net/xml/doc.php
	// Ceci fonctionne aussi bien en php4 qu'en php5 (simule les fonctions SimpleXML de php5 => Parsing d'un document XML vers un objet php)
	// Suivant la version de php, le code  inclure n'est pas le mme
	if (version_compare(phpversion(), "5.0.0", ">="))
    {
      // La version php installe est une version 5
      include(IEW_DIR."/lib/parser_php5.php");
    }
    else // La version PHP est une version 4
    {
      include(IEW_DIR."/lib/parser_php4.php");
    } 

	$sql = "SELECT * FROM horodatages_imports_base"; // lit la date de dernire mise  jour
  	$resultat = mysql_query($sql);
  	$datmaj = mysql_fetch_array($resultat);
  	if (!$datmaj["date_import_base"])
  	{
    	$datmaj = "Aucune mise  jour n'a encore t faite, la base est vide (normal  l'installation <abbr title='IntraEduWeb'>IEW</abbr>).";
  	}
  	else
  	{
    	$datmaj = $datmaj["date_import_base"];  // la date mysql aaaa-mm-jj est formate en jj-mm-aaaa
    	list($annee,$mois,$jour)=explode("-",$datmaj);
    	$datmaj=date("d/m/Y", mktime(0,0,0,$mois,$jour,$annee));
  	}
    
  		echo "<br />";

		// Si on arrive ici, c'est que tout s'est bien pass, on ouvre les fichiers d'imports
		$rapport = "<h1>Rapport d'importation des donnes administratives de rentre</h1>"; // Contiendra le rapport de l'import
		
		/**************** Traitement du fichier Communs.xml => Import des donnes de l'uaj **********/
		
		$rapport .= "<h2>Traitement du fichier Communs.xml</h2>";
		$rapport .= "<h3>Unit Administrative et Juridique (UAJ)</h3>
		<p>";
		// Rinitalisation du parser
		$fichier = $GLOBALS['stock_baselev']."importation/Communs.xml";
		//Get the XML document loaded into a variable
		$xml = file_get_contents($fichier);
		//Set up the parser object
		$parser = new XMLParser($xml);
		//Work the magic...
		$parser->Parse();
		
  		// On peut maintenant accder aux donnes proprement dites : il faut mettre  jour la table uaj, des donnes ont peut-tre chang
		// On prpare les donnes  crire
		// Certaines balises XML ne sont pas obligatoires => Remplies par une valeur NULL dans la table uaj
		$etab_uaj_id = "'".quote_smart($parser->document->donnees[0]->uaj[0]->etab_uaj_id[0]->tagData)."'"; // Obligatoire (Export "Commun", Bloc UAJ)
		$code_rne = "'".quote_smart($parser->document->parametres[0]->uaj[0]->tagData)."'"; // Obligatoire (Fait partie des PARAMETRES de tout export XML  partir de SCONET
		if (!isset($parser->document->donnees[0]->uaj[0]->num_siren[0])) // Facultative  (Export "Commun", Bloc UAJ)
			$num_siren = "NULL";
		else
			$num_siren = "'".quote_smart($parser->document->donnees[0]->uaj[0]->num_siren[0]->tagData)."'";
		if (!isset($parser->document->donnees[0]->uaj[0]->denom_princ[0])) // Facultative  (Export "Commun", Bloc UAJ)
			$denom_princ = "NULL";
		else
			$denom_princ = "'".quote_smart($parser->document->donnees[0]->uaj[0]->denom_princ[0]->tagData)."'";
		if (!isset($parser->document->donnees[0]->uaj[0]->denom_compl[0])) // Facultative  (Export "Commun", Bloc UAJ)
			$denom_compl = "NULL";
		else
			$denom_compl = "'".quote_smart($parser->document->donnees[0]->uaj[0]->denom_compl[0]->tagData)."'";
		if (!isset($parser->document->donnees[0]->uaj[0]->nom_resp[0])) // Facultative  (Export "Commun", Bloc UAJ)
			$nom_resp = "NULL";
		else
			$nom_resp = "'".quote_smart($parser->document->donnees[0]->uaj[0]->nom_resp[0]->tagData)."'";
		if (!isset($parser->document->donnees[0]->uaj[0]->qual_resp[0])) // Facultative  (Export "Commun", Bloc UAJ)
			$qual_resp = "NULL";
		else
			$qual_resp = "'".quote_smart($parser->document->donnees[0]->uaj[0]->qual_resp[0]->tagData)."'";
		if (!isset($parser->document->donnees[0]->uaj[0]->ligne1_adresse[0])) // Facultative  (Export "Commun", Bloc UAJ)
			$ligne1_adresse = "NULL";
		else
			$ligne1_adresse = "'".quote_smart($parser->document->donnees[0]->uaj[0]->ligne1_adresse[0]->tagData)."'";
		if (!isset($parser->document->donnees[0]->uaj[0]->ligne2_adresse[0])) // Facultative  (Export "Commun", Bloc UAJ)
			$ligne2_adresse = "NULL";
		else
			$ligne2_adresse = "'".quote_smart($parser->document->donnees[0]->uaj[0]->ligne2_adresse[0]->tagData)."'";
		if (!isset($parser->document->donnees[0]->uaj[0]->ligne3_adresse[0])) // Facultative  (Export "Commun", Bloc UAJ)
			$ligne3_adresse = "NULL";
		else
			$ligne3_adresse = "'".quote_smart($parser->document->donnees[0]->uaj[0]->ligne3_adresse[0]->tagData)."'";
		if (!isset($parser->document->donnees[0]->uaj[0]->ligne4_adresse[0])) // Facultative  (Export "Commun", Bloc UAJ)
			$ligne4_adresse = "NULL";
		else
			$ligne4_adresse = "'".quote_smart($parser->document->donnees[0]->uaj[0]->ligne4_adresse[0]->tagData)."'";
		if (!isset($parser->document->donnees[0]->uaj[0]->telephone[0])) // Facultative  (Export "Commun", Bloc UAJ)
			$telephone = "NULL";
		else
			$telephone = "'".quote_smart($parser->document->donnees[0]->uaj[0]->telephone[0]->tagData)."'";
		if (!isset($parser->document->donnees[0]->uaj[0]->telecopie[0])) // Facultative  (Export "Commun", Bloc UAJ)
			$telecopie = "NULL";
		else
			$telecopie = "'".quote_smart($parser->document->donnees[0]->uaj[0]->telecopie[0]->tagData)."'";
		if (!isset($parser->document->donnees[0]->uaj[0]->mel_1[0])) // Facultative  (Export "Commun", Bloc UAJ)
			$mel_1 = "NULL";
		else
			$mel_1 = "'".quote_smart($parser->document->donnees[0]->uaj[0]->mel_1[0]->tagData)."'";
		if (!isset($parser->document->donnees[0]->uaj[0]->mel_2[0])) // Facultative  (Export "Commun", Bloc UAJ)
			$mel_2 = "NULL";
		else
			$mel_2 = "'".quote_smart($parser->document->donnees[0]->uaj[0]->mel_2[0]->tagData)."'";
		if (!isset($parser->document->donnees[0]->uaj[0]->code_type_etab[0])) // Facultative  (Export "Commun", Bloc UAJ)
			$code_type_etab = "NULL";
		else
			$code_type_etab = "'".quote_smart($parser->document->donnees[0]->uaj[0]->code_type_etab[0]->tagData)."'";
		if (!isset($parser->document->donnees[0]->uaj[0]->code_postal[0])) // Facultative  (Export "Commun", Bloc UAJ)
			$code_postal = "NULL";
		else
			$code_postal = "'".quote_smart($parser->document->donnees[0]->uaj[0]->code_postal[0]->tagData)."'";
			
		$sql = "UPDATE uaj set etab_uaj_id=$etab_uaj_id,
		code_rne=$code_rne, num_siren=$num_siren, denom_princ=$denom_princ, denom_compl=$denom_compl, nom_resp=$nom_resp, qual_resp=$qual_resp, ligne1_adresse=$ligne1_adresse, ligne2_adresse=$ligne2_adresse, ligne3_adresse=$ligne3_adresse, ligne4_adresse=$ligne4_adresse, telephone=$telephone, telecopie=$telecopie, mel_1=$mel_1, mel_2= $mel_2, code_type_etab=$code_type_etab, code_postal=$code_postal";
		// DEBUGG print $sql."<br />";
		mysql_query($sql);
		if (mysql_affected_rows() == 1) // Mise  jour faite : des champs ont chang
		{
			$rapport .= "L'UAJ <strong><i>".$code_rne."</i></strong> <u>existe dj</u> dans la base de donnes MAIS <i></i> a t mise  jour.<br />";
		}
		else // Les donnes sont identiques  celles de la base
		{
			$rapport .= "L'UAJ <strong><i>".$code_rne."</i></strong> <u>existe dj</u> dans la base de donnes et il n'y a pas de modification.<br />";
		}		
     	$rapport .= "</p>";
	$date_maj_communs = $parser->document->parametres[0]->horodatage[0]->tagData;
	
     	/**************** Traitement du fichier Nomenclature.xml => Import des MEFs, matires et options, les rgimes **********/
		
     	// On peut maintenant accder aux donnes proprement dites (on rcupre seulement ce qui est utile pour IEW : les MEF, les matires, les rgimes et les liens de parent
		$rapport .= "<h2>Traitement du fichier Nomenclature.xml</h2>";
		$rapport .= "<h3><abbr title='Modules lmentaires de formation'>MEFs</abbr></h3>
		<p>";
		
		// Rinitalisation du parser
		$fichier = $GLOBALS['stock_baselev']."importation/Nomenclature.xml";
		//Get the XML document loaded into a variable
		$xml = file_get_contents($fichier);
		//Set up the parser object
		$parser = new XMLParser($xml);
		//Work the magic...
		$parser->Parse();
		
    	if (is_array($parser->document->donnees[0]->mefs[0]->mef)) // vite un Warning: Invalid argument supplied for foreach() si la balise n'existe pas dans le fichier xml 
    	{
			foreach($parser->document->donnees[0]->mefs[0]->mef as $value) // Voil les MEF (formations)
			{
				// Certaines balises XML ne sont pas obligatoires => Remplies par une valeur NULL dans la table mefs
				if (!isset($value->libelle_long[0]))
				{
					$libelle_long = "NULL";
				}
				else
				{
					$libelle_long = "'".quote_smart($value->libelle_long[0]->tagData)."'";
				}
				if (!isset($value->libelle_edition[0])) // 
				{
					$libelle_edition = "NULL";
				}
				else
				{
					$libelle_edition = "'".quote_smart($value->libelle_edition[0]->tagData)."'";
				}
				$sql = "INSERT INTO mefs VALUES('".quote_smart($value->tagAttrs['code_mef'])."','".quote_smart($value->formation[0]->tagData)."',$libelle_long,$libelle_edition)";			
				mysql_query($sql); // On tente l'insertion dans la table mefs
				if (mysql_affected_rows() == 1)
				{
					$rapport .= "Le MEF <strong><i>".$value->formation[0]->tagData."</i></strong> (".$value->tagAttrs['code_mef'].") a t <u>ajout</u> dans la base de donnes.<br />";
				}
				else // l'insertion ne marche pas (MEF dj existant) => On tente une MAJ
				{
					$sql = "UPDATE mefs set formation='".quote_smart($value->formation[0]->tagData)."', libelle_long=$libelle_long, libelle_edition=$libelle_edition WHERE code_mef='".quote_smart($value->tagAttrs['code_mef'])."'";
					mysql_query($sql);
					if (mysql_affected_rows() == 1) // Mise  jour faite : des champs ont chang
					{
						$rapport .= "Le MEF <strong><i>".$value->formation[0]->tagData."</i></strong> (".$value->tagAttrs['code_mef'].") <u>existe dj</u> dans la base de donnes MAIS <i></i> a t mis  jour.<br />";
					}
					else // Les donnes sont identiques  celles de la base
					{
						$rapport .= "Le MEF <strong><i>".$value->formation[0]->tagData."</i></strong> (".$value->tagAttrs['code_mef'].") <u>existe dj</u> dans la base de donnes et il n'y a pas de modification.<br />";
					}				
				}
			}
  		}
  		
		$rapport .= "</p>
		<h3>Matires</h3>
		<p>";
    	
		if (is_array($parser->document->donnees[0]->matieres[0]->matiere)) // vite un Warning: Invalid argument supplied for foreach() si la balise n'existe pas dans le fichier xml 
    	{
			foreach($parser->document->donnees[0]->matieres[0]->matiere as $value) // Les matires
			{
				
				// On prpare les donnes  crire
				// Certaines balises XML ne sont pas obligatoires => Remplies par une valeur NULL dans la table matieres
				if (!isset($value->tagAttrs['code_matiere'])) 
					$code_matiere = "NULL";
				else
					$code_matiere = "'".quote_smart($value->tagAttrs['code_matiere'])."'";
				if (!isset($value->code_gestion[0])) 
					$code_gestion = "NULL";
				else
					$code_gestion = "'".quote_smart($value->code_gestion[0]->tagData)."'";
				if (!isset($value->libelle_court[0])) 
					$libelle_court = "NULL";
				else
					$libelle_court = "'".quote_smart($value->libelle_court[0]->tagData)."'";
				if (!isset($value->libelle_edition[0])) 
					$libelle_edition = "NULL";
				else
					$libelle_edition = "'".quote_smart($value->libelle_edition[0]->tagData)."'";
				$sql = "INSERT INTO matieres_sconet VALUES($code_matiere, $code_gestion, $libelle_court,'".quote_smart($value->libelle_long[0]->tagData)."',$libelle_edition,'".quote_smart($value->matiere_etp[0]->tagData)."')";
				mysql_query($sql); // On tente l'insertion dans la table matieres
				if (mysql_affected_rows() == 1)
				{
					$rapport .= "La matire <strong><i>".$value->libelle_long[0]->tagData."</i></strong> (".$value->tagAttrs['code_matiere'].") a t <u>ajoute</u> dans la base de donnes.<br />";
					$sql = "INSERT INTO matieres VALUES(NULL,$libelle_edition,'UNDEFINED')";
					// DEBUGG print $sql;"<br />";
					mysql_query($sql);
				}
				else // l'insertion ne marche pas (matire dj existante) => On tente une MAJ
				{
					if ($code_matiere != "NULL")
						$sql = "UPDATE matieres_sconet set libelle_court='".quote_smart($value->libelle_court[0]->tagData)."', libelle_long='".quote_smart($value->libelle_long[0]->tagData)."', libelle_edition='".quote_smart($value->libelle_edition[0]->tagData)."' WHERE code_matiere=$code_matiere";
					else
						$sql = "UPDATE matieres_sconet set code_matiere=$code_matiere, code_gestion=$code_gestion, libelle_court=$libelle_court, libelle_edition=$libelle_edition WHERE libelle_long='".quote_smart($value->libelle_long[0]->tagData)."'";
					mysql_query($sql);
					if (mysql_affected_rows() == 1) // Mise  jour faite : des champs ont chang
					{
						$rapport .= "La matire <strong><i>".$value->libelle_long[0]->tagData."</i></strong> (".$value->tagAttrs['code_matiere'].") <u>existe dj</u> dans la base de donnes MAIS <i></i> a t mise  jour.<br />";
					}
					else // Les donnes sont identiques  celles de la base
					{
						$rapport .= "La matire <strong><i>".$value->libelle_long[0]->tagData."</i></strong> (".$value->tagAttrs['code_matiere'].") <u>existe dj</u> dans la base de donnes et il n'y a pas de modification.<br />";
					}				
				}	
			
			}
    	}
    	
		$rapport .= "</p>
		<h3>Programmes</h3>
		<p>";
		
		if (is_array($parser->document->donnees[0]->programmes[0]->programme)) // vite un Warning: Invalid argument supplied for foreach() si la balise n'existe pas dans le fichier xml 
    	{
			foreach($parser->document->donnees[0]->programmes[0]->programme as $value) // Les programmes
			{
				// On prpare les donnes  crire
				// Certaines balises XML ne sont pas obligatoires => Remplies par une valeur NULL dans la table programmes
				if (!isset($value->code_matiere[0])) 
					$code_matiere = "NULL";
				else
					$code_matiere = "'".quote_smart($value->code_matiere[0]->tagData)."'";
				if (!isset($value->horaire[0])) 
					$horaire = "NULL";
				else
					$horaire = "'".quote_smart($value->horaire[0]->tagData)."'";
				$sql = "INSERT INTO programmes values('".quote_smart($value->code_mef[0]->tagData)."',$code_matiere,'".quote_smart($value->code_modalite_elect[0]->tagData)."',$horaire)";
				mysql_query($sql); // On tente l'insertion dans la table programmes
				if (mysql_affected_rows() == 1)
				{
					$rapport .= "Pour le code_mef <strong><i>".$value->code_mef[0]->tagData."</i></strong> et la matire <strong><i>".$value->code_matiere[0]->tagData."</i></strong> (modalit d'lection <strong><i>".$value->code_modalite_elect[0]->tagData."</i></strong>), l'horaire <strong><i>".$value->horaire[0]->tagData."</i></strong> a t <u>ajoute</u> dans la table des programmes.<br />";
				}
				else // l'insertion ne marche pas (matire dj existante) => On tente une MAJ
				{
					$sql = "UPDATE programmes set horaire=$horaire WHERE code_mef='".quote_smart($value->code_mef[0]->tagData)."' AND code_matiere=$code_matiere AND code_modalite_elect='".quote_smart($value->code_modalite_elect[0]->tagData)."'";
					mysql_query($sql);
					if (mysql_affected_rows() == 1) // Mise  jour faite : des champs ont chang
					{
						$rapport .= "Pour le code_mef <strong><i>".$value->code_mef[0]->tagData."</i></strong> et la matire <strong><i>".$value->code_matiere[0]->tagData."</i></strong> (modalit d'lection <strong><i>".$value->code_modalite_elect[0]->tagData."</i></strong>), l'horaire <strong><i>".$value->horaire[0]->tagData."</i></strong> a t <u>MODIFIE</u> dans la table des programmes.<br />";
					}
					else // Les donnes sont identiques  celles de la base
					{
						$rapport .= "Pour le code_mef <strong><i>".$value->code_mef[0]->tagData."</i></strong> et la matire <strong><i>".$value->code_matiere[0]->tagData."</i></strong> (modalit d'lection <strong><i>".$value->code_modalite_elect[0]->tagData."</i></strong>), l'horaire <strong><i>".$value->horaire[0]->tagData."</i></strong> <u>existe dj</u> dans la base de donnes et il n'y a pas de modification.<br />";
					}		
				}
			}
    	}
    	
		$rapport .= "</p>
		<h3>Options obligatoires</h3>
		<p>";
		
		if (is_array($parser->document->donnees[0]->options_obligatoires[0]->option_obligatoire)) // vite un Warning: Invalid argument supplied for foreach() si la balise n'existe pas dans le fichier xml 
    	{
			foreach($parser->document->donnees[0]->options_obligatoires[0]->option_obligatoire as $value) // Les options obligatoires
			{
				$sql = "INSERT INTO options_obligatoires values('".quote_smart($value->code_mef[0]->tagData)."','".quote_smart($value->code_matiere[0]->tagData)."','".quote_smart($value->rang_option[0]->tagData)."')";
				mysql_query($sql); // On tente l'insertion dans la table options_obligatoires
				if (mysql_affected_rows() == 1)
				{
					$rapport .= "Pour le code_mef <strong><i>".$value->code_mef[0]->tagData."</i></strong> et la matire <strong><i>".$value->code_matiere[0]->tagData."</i></strong>, le rang option <strong><i>".$value->rang_option[0]->tagData."</i></strong> a t <u>ajout</u> dans la table des options obligatoires.<br />";
				}
				else // l'insertion ne marche pas => On tente une MAJ
				{
					$sql = "UPDATE options_obligatoires set code_mef='".quote_smart($value->code_mef[0]->tagData)."', code_matiere='".quote_smart($value->code_matiere[0]->tagData)."', rang_option='".quote_smart($value->rang_option[0]->tagData)."'  WHERE code_mef='".quote_smart($value->code_mef[0]->tagData)."' AND code_matiere='".quote_smart($value->code_matiere[0]->tagData)."'";
					mysql_query($sql);
					if (mysql_affected_rows() == 1) // Mise  jour faite : des champs ont chang
					{
						$rapport .= "Pour le code_mef <strong><i>".$value->code_mef[0]->tagData."</i></strong> et la matire <strong><i>".$value->code_matiere[0]->tagData."</i></strong>, le rang option <strong><i>".$value->rang_option[0]->tagData."</i></strong> a t <u>MODIFIE</u> dans la table des options obligatoires.<br />";
					}
					else // Les donnes sont identiques  celles de la base
					{
						$rapport .= "Pour le code_mef <strong><i>".$value->code_mef[0]->tagData."</i></strong> et la matire <strong><i>".$value->code_matiere[0]->tagData."</i></strong>, le rang option <strong><i>".$value->rang_option[0]->tagData."</i></strong> <u>existe dj</u> dans la base de donnes et il n'y a pas de modification.<br />";
					}	
				}
			}
    	}
    	
		$rapport .= "</p>
		<h3>Modalits d'lection</h3>
		<p>";
		
		if (is_array($parser->document->donnees[0]->modalites_election[0]->modalite_election)) // vite un Warning: Invalid argument supplied for foreach() si la balise n'existe pas dans le fichier xml 
    	{
			foreach($parser->document->donnees[0]->modalites_election[0]->modalite_election as $value) // Les modalits d'lection
			{
				// On prpare les donnes  crire
				// Certaines balises XML ne sont pas obligatoires => Remplies par une valeur NULL dans la table modalites_election
				if (!isset($value->libelle_court[0])) 
					$libelle_court = "NULL";
				else
					$libelle_court = "'".quote_smart($value->libelle_court[0]->tagData)."'";
				$sql = "INSERT INTO modalites_election values('".quote_smart($value->tagAttrs['code_modalite_elect'])."',$libelle_court,'".quote_smart($value->libelle_long[0]->tagData)."')";
				mysql_query($sql); // On tente l'insertion dans la table modalites_election
				if (mysql_affected_rows() == 1)
				{
					$rapport .= "Le code modalit d'lection <strong><i>".$value->tagAttrs['code_modalite_elect']."</i></strong> (<strong><i>".$value->libelle_long[0]->tagData."</i></strong>) a t <u>ajout</u> dans la table modalites_election.<br />";
				}
				else // l'insertion ne marche pas (matire dj existante) => On tente une MAJ
				{
					$sql = "UPDATE modalites_election set libelle_court=$libelle_court, libelle_long='".quote_smart($value->libelle_long[0]->tagData)."' WHERE code_modalite_election='".quote_smart($value->tagAttrs['code_modalite_elect'])."'";
					mysql_query($sql);
					if (mysql_affected_rows() == 1) // Mise  jour faite : des champs ont chang
					{
						$rapport .= "Le code modalit d'lection <strong><i>".$value->tagAttrs['code_modalite_elect']."</i></strong> (<strong><i>".$value->libelle_long[0]->tagData."</i></strong>) a t <u>MODIFIE</u> dans la table des modalites_election.<br />";
					}
					else // Les donnes sont identiques  celles de la base
					{
						$rapport .= "Le code modalit d'lection <strong><i>".$value->tagAttrs['code_modalite_elect']."</i></strong> (<strong><i>".$value->libelle_long[0]->tagData."</i></strong>) <u>existe dj</u> dans la base de donnes et il n'y a pas de modification.<br />";
					}	
				}
			}
    	}
    	
		$rapport .= "</p>
		<h3>Rgimes</h3>
		<p>";
		
		if (is_array($parser->document->donnees[0]->regimes[0]->regime)) // vite un Warning: Invalid argument supplied for foreach() si la balise n'existe pas dans le fichier xml 
    	{
    		foreach($parser->document->donnees[0]->regimes[0]->regime as $value) // Les rgimes
			{
				$sql = "INSERT INTO regimes VALUES('".quote_smart($value->tagAttrs['code_regime'])."','".quote_smart($value->libelle_court[0]->tagData)."','".quote_smart($value->libelle_long[0]->tagData)."')";
				mysql_query($sql); // On tente l'insertion dans la table regimes
				if (mysql_affected_rows() == 1)
				{
					$rapport .= "Le rgime <strong><i>".$value->libelle_long[0]->tagData."</i></strong> (".$value->tagAttrs['code_regime'].") a t <u>ajout</u> dans la base de donnes.<br />";
				}
				else // l'insertion ne marche pas (rgime dj existant) => On tente une MAJ
				{
					$sql = "UPDATE regimes set libelle_court='".quote_smart($value->libelle_court[0]->tagData)."', libelle_long='".quote_smart($value->libelle_long[0]->tagData)."' WHERE code_regime='".quote_smart($value->tagAttrs['code_regime'])."'";
					mysql_query($sql);
					if (mysql_affected_rows() == 1) // Mise  jour faite : des champs ont chang
					{
						$rapport .= "Le rgime <strong><i>".$value->libelle_long[0]->tagData."</i></strong> (".$value->tagAttrs['code_regime'].") <u>existe dj</u> dans la base de donnes MAIS <i></i> a t mis  jour.<br />";
					}
					else // Les donnes sont identiques  celles de la base
					{
						$rapport .= "Le rgime <strong><i>".$value->libelle_long[0]->tagData."</i></strong> (".$value->tagAttrs['code_regime'].") <u>existe dj</u> dans la base de donnes et il n'y a pas de modification.<br />";
					}				
				}	
			}
    	}
    	
		$rapport .= "</p>
		<h3>Liens de parent</h3><p>";
    	
		if (is_array($parser->document->donnees[0]->liens_parente[0]->lien_parente)) // vite un Warning: Invalid argument supplied for foreach() si la balise n'existe pas dans le fichier xml 
    	{
			foreach($parser->document->donnees[0]->liens_parente[0]->lien_parente as $value) // les liens de parent
			{
				// On prpare les donnes  crire
				// Certaines balises XML ne sont pas obligatoires => Remplies par une valeur NULL dans la table modalites_election
				if (!isset($value->libelle_court[0])) 
					$libelle_court = "NULL";
				else
					$libelle_court = "'".quote_smart($value->libelle_court[0]->tagData)."'";
				$sql = "INSERT INTO liens_parente VALUES('".quote_smart($value->tagAttrs['code_parente'])."',$libelle_court,'".quote_smart($value->libelle_long[0]->tagData)."')";
				mysql_query($sql); // On tente l'insertion dans la table regimes
				if (mysql_affected_rows() == 1)
				{
					$rapport .= "Le lien de parent <strong><i>".$value->libelle_long[0]->tagData."</i></strong> (".$value->tagAttrs['code_parente'].") a t <u>ajout</u> dans la base de donnes.<br />";
				}
				else // l'insertion ne marche pas (lien de parent dj existant) => On tente une MAJ
				{
					$sql = "UPDATE liens_parente set libelle_court='".quote_smart($value->libelle_court[0]->tagData)."', libelle_long='".quote_smart($value->libelle_long[0]->tagData)."' WHERE code_parente='".quote_smart($value->tagAttrs['code_parente'])."'";
					mysql_query($sql);
					if (mysql_affected_rows() == 1) // Mise  jour faite : des champs ont chang
					{
						$rapport .= "Le lien de parent <strong><i>".$value->libelle_long[0]->tagData."</i></strong> (".$value->tagAttrs['code_parente'].") <u>existe dj</u> dans la base de donnes MAIS <i></i> a t mis  jour.<br />";
					}
					else // Les donnes sont identiques  celles de la base
					{
						$rapport .= "Le lien de parent <strong><i>".$value->libelle_long[0]->tagData."</i></strong> (".$value->tagAttrs['code_parente'].") <u>existe dj</u> dans la base de donnes et il n'y a pas de modification.<br />";
					}				
				}	
			}
    	}
		
		$rapport .= "</p>
		<h3>Statuts lve</h3>
		<p>";
		
		if (is_array($parser->document->donnees[0]->statuts_eleve[0]->statut_eleve)) // vite un Warning: Invalid argument supplied for foreach() si la balise n'existe pas dans le fichier xml 
    	{
			foreach($parser->document->donnees[0]->statuts_eleve[0]->statut_eleve as $value) // Les statuts des lves
			{
				// On prpare les donnes  crire
				// Certaines balises XML ne sont pas obligatoires => Remplies par une valeur NULL dans la table statuts_eleve
				if (!isset($value->libelle_court[0])) 
					$libelle_court = "NULL";
				else
					$libelle_court = "'".quote_smart($value->libelle_court[0]->tagData)."'";
				if (!isset($value->libelle_long[0])) 
					$libelle_long = "NULL";
				else
					$libelle_long = "'".quote_smart($value->libelle_long[0]->tagData)."'";
				$sql = "INSERT INTO statuts_eleve values('".quote_smart($value->tagAttrs['code_statut'])."',$libelle_court,$libelle_long)";
				mysql_query($sql); // On tente l'insertion dans la table statuts_eleve
				if (mysql_affected_rows() == 1)
				{
					$rapport .= "le code statut <strong><i>".$value->tagAttrs['code_statut']."</i></strong>, (<strong><i>".$value->libelle_long[0]->tagData."</i></strong>) a t <u>ajout</u> dans la table des statuts_eleve.<br />";
				}
				else // l'insertion ne marche pas (matire dj existante) => On tente une MAJ
				{
					$sql = "UPDATE statuts_eleve set libelle_court=$libelle_court, libelle_long=$libelle_long WHERE code_statut='".quote_smart($value->tagAttrs['code_statut'])."'";
					mysql_query($sql);
					if (mysql_affected_rows() == 1) // Mise  jour faite : des champs ont chang
					{
						$rapport .= "le code statut <strong><i>".$value->tagAttrs['code_statut']."</i></strong>, (<strong><i>".$value->libelle_long[0]->tagData."</i></strong>) a t <u>MODIFIE</u> dans la table des statuts_eleve.<br />";
					}
					else // Les donnes sont identiques  celles de la base
					{
						$rapport .= "le code statut <strong><i>".$value->tagAttrs['code_statut']."</i></strong>, (<strong><i>".$value->libelle_long[0]->tagData."</i></strong>) <u>existe dj</u> dans la base de donnes et il n'y a pas de modification.<br />";
					}	
				}
			}
    	}
    	
		$rapport .= "</p>
		<h3>Types d'tablissement</h3>
		<p>";
		
		if (is_array($parser->document->donnees[0]->types_etablissement[0]->type_etablissement)) // vite un Warning: Invalid argument supplied for foreach() si la balise n'existe pas dans le fichier xml 
    	{
			foreach($parser->document->donnees[0]->types_etablissement[0]->type_etablissement as $value) // Les Types d'tablissement
			{
				// On prpare les donnes  crire
				// Certaines balises XML ne sont pas obligatoires => Remplies par une valeur NULL dans la table type_etablissement
				if (!isset($value->libelle_court[0])) 
					$libelle_court = "NULL";
				else
					$libelle_court = "'".quote_smart($value->libelle_court[0]->tagData)."'";
				if (!isset($value->libelle_long[0])) 
					$libelle_long = "NULL";
				else
					$libelle_long = "'".quote_smart($value->libelle_long[0]->tagData)."'";
				$sql = "INSERT INTO type_etablissement values('".quote_smart($value->tagAttrs['code_type_etab'])."',$libelle_court,$libelle_long)";
				mysql_query($sql); // On tente l'insertion dans la table type_etablissement
				if (mysql_affected_rows() == 1)
				{
					$rapport .= "le code type tablissement <strong><i>".$value->tagAttrs['code_type_etab']."</i></strong>, (<strong><i>".$value->libelle_long[0]->tagData."</i></strong>) a t <u>ajout</u> dans la table des type_etablissement.<br />";
				}
				else // l'insertion ne marche pas (matire dj existante) => On tente une MAJ
				{
					$sql = "UPDATE type_etablissement set libelle_court=$libelle_court, libelle_long=$libelle_long WHERE code_type_etab='".quote_smart($value->tagAttrs['code_type_etab'])."'";
					mysql_query($sql);
					if (mysql_affected_rows() == 1) // Mise  jour faite : des champs ont chang
					{
						$rapport .= "le code type tablissement <strong><i>".$value->tagAttrs['code_type_etab']."</i></strong>, (<strong><i>".$value->libelle_long[0]->tagData."</i></strong>) a t <u>MODIFIE</u> dans la table des type_etablissement.<br />";
					}
					else // Les donnes sont identiques  celles de la base
					{
						$rapport .= "le code type tablissement <strong><i>".$value->tagAttrs['code_type_etab']."</i></strong>, (<strong><i>".$value->libelle_long[0]->tagData."</i></strong>) <u>existe dj</u> dans la base de donnes et il n'y a pas de modification.<br />";
					}	
				}
			}
    	}

		$rapport .= "</p>";
		
		$date_maj_nomenclature = $parser->document->parametres[0]->horodatage[0]->tagData;


		/**************** Traitement du fichier Structures.xml => Import des divisions et des groupes ***********/
		
		// On peut maintenant accder aux donnes proprement dites (on rcupre seulement ce qui est utile pour IEW : les divisions, les groupes, les lves inscrits dans les groupes
		$rapport .= "<h2>Traitement du fichier Structures.xml</h2>";
		$rapport .= "<h3>Divisions</h3>
		<p>";
		
		$compteur_insert_divisions = 0;
		// Rinitalisation du parser
		$fichier = $GLOBALS['stock_baselev']."importation/Structures.xml";
		//Get the XML document loaded into a variable
		$xml = file_get_contents($fichier);
		//Set up the parser object
		$parser = new XMLParser($xml);
		//Work the magic...
		$parser->Parse();
		
		if (is_array($parser->document->donnees[0]->divisions[0]->division)) // vite un Warning: Invalid argument supplied for foreach() si la balise n'existe pas dans le fichier xml 
    	{
			foreach($parser->document->donnees[0]->divisions[0]->division as $value) // les divisions
			{
				$mefs = "";
				//echo "<pre>";print_r($value); echo "</pre><br /><br/>";
				// Il peut y avoir plusieurs MEF d'appartenance pour une division
				if (is_array($value->mefs_appartenance[0]->mef_appartenance)) // vite un Warning: Invalid argument supplied for foreach() si la balise n'existe pas dans le fichier xml 
    			{
					foreach($value->mefs_appartenance[0]->mef_appartenance as $mef)
					{ 
						$mefs .= $mef->code_mef[0]->tagData.","; // on les mets dans une chane o les valeurs sont spares par une virgule
					}
    			}
				$mefs = rtrim($mefs,","); // On enlve la virgule terminale
				$rapport .= "codes MEF d'appartenance pour la division&nbsp;: ".$mefs."<br />";
				// On prpare les donnes  crire
				// Certaines balises XML ne sont pas obligatoires => Remplies par une valeur NULL dans la table type_etablissement
				if (!isset($value->libelle_long[0])) 
					$libelle_long = "NULL";
				else
					$libelle_long = "'".quote_smart($value->libelle_long[0]->tagData)."'";
				$sql = "INSERT INTO structures VALUES('".quote_smart(trim($value->tagAttrs['code_structure']))."','D',$libelle_long,'".quote_smart($mefs)."',NULL)";
				mysql_query($sql); // On tente l'insertion dans la table divisions
				if (mysql_affected_rows() == 1)
				{
					$rapport .= "La division <strong><i>".$value->tagAttrs['code_structure']."</i></strong> (".$value->libelle_long[0]->tagData.") a t <u>ajoute</u> dans la base de donnes.<br />";
					$sql = "INSERT INTO divisions VALUES(NULL,'".quote_smart(trim($value->tagAttrs['code_structure']))."')";
					mysql_query($sql);
					$compteur_insert_divisions++;
				}
				else // l'insertion ne marche pas (division dj existante) => On tente une MAJ
				{
					$sql = "UPDATE structures set libelle_long=$libelle_long, code_mef='".quote_smart($mefs)."' WHERE code_structure='".quote_smart(trim($value->tagAttrs['code_structure']))."'";
					//$rapport .="$sql<br />";
					mysql_query($sql);
					if (mysql_affected_rows() == 1) // Mise  jour faite : des champs ont chang
					{
						$rapport .= "La division <strong><i>".$value->tagAttrs['code_structure']."</i></strong> (".$value->libelle_long[0]->tagData.") <u>existe dj</u> dans la base de donnes MAIS <i></i> a t mise  jour.<br />";
					}
					else // Les donnes sont identiques  celles de la base
					{
						$rapport .= "La division <strong><i>".$value->tagAttrs['code_structure']."</i></strong> (".$value->libelle_long[0]->tagData.") <u>existe dj</u> dans la base de donnes et il n'y a pas de modification.<br />";
					}				
				}		
			}
    	}
    	
		$rapport .= "</p>";
		
		$rapport .= "<h3>Groupes</h3>
		<p>";
		
		$compteur_insert_groupes = 0;
		if (is_array($parser->document->donnees[0]->groupes[0]->groupe)) // vite un Warning: Invalid argument supplied for foreach() si la balise n'existe pas dans le fichier xml 
    	{
			foreach($parser->document->donnees[0]->groupes[0]->groupe as $value) // les groupes
			{
				$mefs = "";
				$divs = ""; // contiendra la liste des divisions d'appartenance
				// Il peut y avoir plusieurs MEF d'appartenance pour un groupe
				if (is_array($value->mefs_appartenance[0]->mef_appartenance))
				{
					foreach($value->mefs_appartenance[0]->mef_appartenance as $mef)
					{ 
						$mefs .= $mef->code_mef[0]->tagData.","; // on les mets dans une chane o les valeurs sont spares par une virgule
					}
				}
				$mefs = rtrim($mefs,","); // On enlve la virgule terminale
				// Il y a souvent pluisuers divisions d'appartenance pour un groupe
				if (is_array($value->divisions_appartenance[0]->division_appartenance))
				{
					foreach($value->divisions_appartenance[0]->division_appartenance as $div)
					{ 
						$divs .= $div->code_structure[0]->tagData.","; // on les mets dans une chane o les valeurs sont spares par une virgule
				}
				}
				$divs = rtrim($divs,","); // On enlve la virgule terminale
				// On prpare les donnes  crire
				// Certaines balises XML ne sont pas obligatoires => Remplies par une valeur NULL dans la table type_etablissement
				if (!isset($value->libelle_long[0])) 
					$libelle_long = "NULL";
				else
					$libelle_long = "'".quote_smart($value->libelle_long[0]->tagData)."'";
				$sql = "INSERT INTO structures VALUES('".quote_smart(trim($value->tagAttrs['code_structure']))."','G',$libelle_long,'".quote_smart($mefs)."','".quote_smart($divs)."')";
				mysql_query($sql); // On tente l'insertion dans la table groupes
				if (mysql_affected_rows() == 1)
				{
					$rapport .= "Le groupe <strong><i>".$value->tagAttrs['code_structure']."</i></strong> (".$value->libelle_long[0]->tagData.") a t <u>ajout</u> dans la base de donnes.<br />";
					$sql = "INSERT INTO groupes VALUES('NULL','".quote_smart(trim($value->tagAttrs['code_structure']))."','0')"; // La dernire valeur (id_responsable) du groupe n'est pas connue
					mysql_query($sql);
					$compteur_insert_groupes++;
				}
				else // l'insertion ne marche pas (groupe dj existant) => On tente une MAJ
				{
					$sql = "UPDATE structures set libelle_long=$libelle_long, code_mef='".quote_smart($mefs)."', divisions_appartenance='".quote_smart($divs)."' WHERE code_structure='".quote_smart($value->tagAttrs['code_structure'])."'";
					mysql_query($sql);
					if (mysql_affected_rows() == 1) // Mise  jour faite : des champs ont chang
					{
						$rapport .= "Le groupe <strong><i>".$value->tagAttrs['code_structure']."</i></strong> (".$value->libelle_long[0]->tagData.") <u>existe dj</u> dans la base de donnes MAIS <i></i> a t mis  jour.<br />";
					}
					else // Les donnes sont identiques  celles de la base
					{
						$rapport .= "Le groupe <strong><i>".$value->tagAttrs['code_structure']."</i></strong> (".$value->libelle_long[0]->tagData.") <u>existe dj</u> dans la base de donnes et il n'y a pas de modification.<br />";
					}				
				}	
			}
    	}
	    	
		$rapport .= "</p>";

		$date_maj_structures = $parser->document->parametres[0]->horodatage[0]->tagData;


		/**************** Traitement du fichier sts_emp_RNE_annee.xml => Import des enseignants, des quipes pdagogiques, des EDT  **********/
		
		// On rcupre le nom du fichier
		foreach ($tab_delfile as $value)
		{
			if (substr($value,0,7) == "sts_emp")
           	{
           		$filename = $value; // On a le nom complet sts_emp_RNE_annee.xml
           		break;
           	} 
		}
		       	
		// On peut maintenant accder aux donnes proprement dites (on rcupre seulement ce qui est utile pour IEW : les professeurs, les quipes pdagogiques
		$rapport .= "<h2>Traitement du fichier $filename</h2>";
		$rapport .= "<h3>Civilits</h3>
		<p>";
		
		// Rinitalisation du parser
		$fichier = $GLOBALS['stock_baselev']."importation/".$filename;
		//Get the XML document loaded into a variable
		$xml = file_get_contents($fichier);
		//Set up the parser object
		$parser = new XMLParser($xml);
		//Work the magic...
		$parser->Parse();
		
		if (is_array($parser->document->nomenclatures[0]->civilites[0]->civilite)) // vite un Warning: Invalid argument supplied for foreach() si la balise n'existe pas dans le fichier xml 
    	{
			foreach($parser->document->nomenclatures[0]->civilites[0]->civilite as $value) // les civilits
			{
				$sql = "INSERT INTO civilites VALUES('".quote_smart($value->tagAttrs['code'])."','".quote_smart($value->libelle_court[0]->tagData)."','".quote_smart($value->libelle_long[0]->tagData)."')";
				mysql_query($sql); // On tente l'insertion dans la table regimes
				if (mysql_affected_rows() == 1)
				{
					$rapport .= "La civilit <strong><i>".$value->libelle_long[0]->tagData."</i></strong> (Code ".$value->tagAttrs['code'].") a t <u>ajoute</u> dans la base de donnes.<br />";
				}
				else // l'insertion ne marche pas (lien de parent dj existant) => On tente une MAJ
				{
					$sql = "UPDATE civilites set libelle_court='".quote_smart($value->libelle_court[0]->tagData)."', libelle_long='".quote_smart($value->libelle_long[0]->tagData)."' WHERE code_civilite='".quote_smart($value->tagAttrs['code'])."'";
					mysql_query($sql);
					if (mysql_affected_rows() == 1) // Mise  jour faite : des champs ont chang
					{
						$rapport .= "La civilit <strong><i>".$value->libelle_long[0]->tagData."</i></strong> (Code ".$value->tagAttrs['code'].") <u>existe dj</u> dans la base de donnes MAIS <i></i> a t mise  jour.<br />";
					}
					else // Les donnes sont identiques  celles de la base
					{
						$rapport .= "La civilit <strong><i>".$value->libelle_long[0]->tagData."</i></strong> (Code ".$value->tagAttrs['code'].") <u>existe dj</u> dans la base de donnes et il n'y a pas de modification.<br />";
					}				
				}	
			}
    	}
    	
		$rapport .= "</p>";
		
		$rapport .= "<h3>Taux de pondration</h3>
		<p>";
		
		if (is_array($parser->document->nomenclatures[0]->taux_ponds[0]->taux_pond)) // vite un Warning: Invalid argument supplied for foreach() si la balise n'existe pas dans le fichier xml 
    	{
			foreach($parser->document->nomenclatures[0]->taux_ponds[0]->taux_pond as $value) // les taux de pondration
			{
				// On prpare les donnes  crire
				// Certaines balises XML ne sont pas obligatoires => Remplies par une valeur NULL dans la table type_etablissement
				if (!isset($value->cpge_bts[0])) 
					$cpge_bts = "NULL";
				else
					$cpge_bts = "'".quote_smart($value->cpge_bts[0]->tagData)."'";
				$sql = "INSERT INTO taux_ponderations VALUES('".quote_smart($value->tagAttrs['taux'])."',$cpge_bts)";
				mysql_query($sql); // On tente l'insertion dans la table taux_ponderations
				if (mysql_affected_rows() == 1)
				{
					$rapport .= "Le taux de pondration <strong><i>".$value->tagAttrs['taux']."</i></strong> (CPGE_BTS = ".$value->cpge_bts[0]->tagData.") a t <u>ajout</u> dans la base de donnes.<br />";
				}
				else // l'insertion ne marche pas (lien de parent dj existant) => On tente une MAJ
				{
					$sql = "UPDATE taux_ponderations set cpge_bts=$cpge_bts WHERE taux_pond='".quote_smart($value->tagAttrs['taux'])."'";
					mysql_query($sql);
					if (mysql_affected_rows() == 1) // Mise  jour faite : des champs ont chang
					{
						$rapport .= "Le taux de pondration <strong><i>".$value->tagAttrs['taux']."</i></strong> (CPGE_BTS = ".$value->cpge_bts[0]->tagData.") <u>existe dj</u> dans la base de donnes MAIS <i></i> a t mis  jour.<br />";
					}
					else // Les donnes sont identiques  celles de la base
					{
						$rapport .= "Le taux de pondration <strong><i>".$value->tagAttrs['taux']."</i></strong> (CPGE_BTS = ".$value->cpge_bts[0]->tagData.") <u>existe dj</u> dans la base de donnes et il n'y a pas de modification.<br />";
					}				
				}	
			}
    	}
    	
		$rapport .= "</p>";
		
		$rapport .= "<h3>Nouveaux Professeurs, membres de la direction, CPE et chefs de travaux</h3>
		<p>";
		
		// Il faut  la fois intgrer les nouveaux profs, mais aussi supprimer ceux qui ne sont plus dans l'tablissement
		// Pour ce faire, on utilise la table personnel_maj que l'on remplit avec les donnes du fichiers xml en cours
		// Cette table sera parcourue ensuite pour crer des nouveaux comptes profs (si celui-ci n'existe pas),
		// ou pour mettre  jour des donnes sur les profs
		// Enfin, la table du personnel enseignant sera parcourue  son tour et compare  la table personnel_maj
		// Toute personne prsente dans la table personnel mais pas dans personnel_maj sera supprime de la base (ainsi que son compte iew)
		// sauf pour les enseignants documentalistes car ils ne sont jamais dans le fichier xml d'import

		// On ouvre les fichiers destins  recevoir les codes d'accs des membres du personnel
		if ($GLOBALS['auth_method'] == "native")
		{
			$fichier=fopen($GLOBALS['stock_baselev']."comptes_personnel.txt","a");
      		$fichier_suivant=fopen($GLOBALS['stock_baselev']."new_comptes_personnel.txt","a");
  		}
  		else
  		{
  			$fichier = "";
  			$fichier_suivant="";
  		}
      	
      	// Lecture du fichier xml et intgration des profs dans la table personnel_maj
		$sql= "TRUNCATE TABLE personnel_maj";  // efface tous les enregistrements de la table provisoire cre lors de la dernire mise  jour
    	mysql_query($sql); // contrairement  DELETE, l'auto_increment est remis  zro  	
		
    	// On met les civilits dans un tableau pour un accs + rapide que l'accs MySQL
		$tab_civilites = array();
		$sql = "SELECT code_civilite,libelle_long FROM civilites";
		$resultat = mysql_query($sql);
		while ($ligne=mysql_fetch_array($resultat))
		{
			$cle = $ligne['code_civilite'];
			$valeur = $ligne['libelle_long'];
			$tab_civilites[$cle] = $valeur;
		}
		
		if (is_array($parser->document->donnees[0]->individus[0]->individu)) // vite un Warning: Invalid argument supplied for foreach() si la balise n'existe pas dans le fichier xml 
    	{
    		foreach($parser->document->donnees[0]->individus[0]->individu as $value) // les personnes  mettre dans la table de maj
			{
				if (isset($value->fonction[0])) // la fonction n'est pas une balise obligatoire
				{
					// Les individus sans fonction ne sont donc pas pris en compte dans l'import !

					$id_individu = $value->tagAttrs['id'];
					$type = $value->tagAttrs['type'];
					$nom = $value->nom_usage[0]->tagData; // nom (en majuscules)
					$prenom = $value->prenom[0]->tagData;
					// le prnom est en majuscule, on le formate de faon  mettre la 1re lettre en Majuscule, le reste en minuscule
					$prenom = ucfirst(strtolower($prenom));
					// Les trois balises XML suivantes ne sont pas obligatoires : si absentes => valeur NULL
					if (!isset($value->date_naissance[0]->tagData))
						$datenaiss = "NULL";
					else
						$datenaiss = 	"'".quote_smart($value->date_naissance[0]->tagData)."'";
					if (!isset($value->grade[0]->tagData))
						$sous_categorie = "NULL";
					else
						$sous_categorie = "'".quote_smart($value->grade[0]->tagData)."'";
					if (!isset($value->civilite[0]->tagData))
						$code_civilite = "NULL";
					else
						$code_civilite = $value->civilite[0]->tagData;
					// Voil le libell de la civilit
					if ($code_civilite != "NULL")		
						$civilite = "'".quote_smart($tab_civilites[$code_civilite])."'";
					else
						$civilite = "NULL";
				
					if ($value->fonction[0]->tagData == "ENS" || $value->fonction[0]->tagData == "FIJ" || $value->fonction[0]->tagData == "DOC") // seulement les profs 
					{	
						$categorie = "7"; // c'est un prof ou un documentalitste, valeur correspond  categories_pers.id_cat (Table MySQL)
				
						// On rcupre la discipline_poste
						$code_discipline = $value->disciplines[0]->discipline[0]->tagAttrs['code'];
					}
					elseif ($value->fonction[0]->tagData == "DIR")
					{
						$categorie = "5"; // C'est un membre du personnel de direction, valeur correspond  categories_pers.id_cat (Table MySQL)
						$code_discipline = "";						
					}
					elseif ($value->fonction[0]->tagData == "AED" || $value->fonction[0]->tagData == "SUR" || $value->fonction[0]->tagData == "EDU")
					{
						$categorie = "8"; // C'est un Assistant d'ducation ou un surveillant ou un CPE, valeur correspond  categories_pers.id_cat (Table MySQL)
						$code_discipline = "";						
					}
					elseif ($value->fonction[0]->tagData == "CTR")
					{
						$categorie = "2"; // C'est un Chef de travaux, valeur correspond  categories_pers.id_cat (Table MySQL)
						$code_discipline = "";						
					}
					// On insre dans la table de maj
					$sql = "INSERT INTO personnel_maj VALUES(NULL,'".quote_smart($id_individu)."','".quote_smart($type)."','".quote_smart($nom)."','".quote_smart($prenom)."',$datenaiss,NULL,'".quote_smart($categorie)."',$sous_categorie,$civilite,'".quote_smart($code_discipline)."')";
					if (!mysql_query($sql))
            		{
	              		// DEBUGG echo "La Commande SQL suivante a chou :<br />$sql<br />".mysql_errno(). ": " . mysql_error(). "<br />";
    	        	}
        	    	else
	            	{
        	      		// DEBUGG echo "Le membre du personnel $nom $prenom a t <font color='green'><strong>Intgr</strong></font> dans la table de mise  jour.<br />";
	            	}				
				}
			}
    	}
		
		///////// comparaison de la nouvelle base personnel_maj et de la base active personnel //////////

    	// 1) Recherche des nouveaux profs ou des mises  jour  faire pour les profs existants

    	$erreur = ""; // contiendra ventuellement la chane concatne des erreurs rencontres
    	$compteur_insert = 0; // contiendra le nombre d'enregistrements ajouts  la table personnel (nouveaux profs)
    	$compteur_non_retrouves = 0; // contiendra le nombre de profs non retrouvs candidats potentiels  la suppression
    	$compteur_suppr = 0; // contiendra le nombre d'enregistrements supprims  la table personnel (profs sortants)
    	$compteur_maj = 0; // contiendra le nombre d'enregistrement mis  jour si une modification de l'un quelconque des champs  t faite
    	$compteur_new_comptes = 0; // contiendra le nombre de nouveau comptes intraeduweb qui sont cr par la mise  jour de la base du personnel enseignant
    	$personnels_maj = array(); // contiendra la liste (nom+prenom) des membres du personnel dont les donnes ont t mises  jour (requte UPDATE sur la table personnel)
    	$personnels_nouveaux = array(); // Contiendra la liste (nom+prenom) des nouveaux membres du personnel
    	
		// On part des enregistrements de la nouvelle table personnel_maj pour chercher une correspondance avec la table personnel active
    
    	$sql = "SELECT t1.*,t3.id_groupe FROM personnel_maj as t1, categories_pers as t2, groupes_utilisateurs as t3 WHERE t1.categorie=t2.id_cat AND t2.id_groupe=t3.id_groupe";
    	$resultat = mysql_query($sql);
    
    	$rapport .= "Nb enregistrements dans la table de mise  jour (contient tous les membres du personnel ducatif de l'tablissement prsents dans le fichier d'import : ".mysql_num_rows($resultat).")<br />";
    	
    	$k =1; // pour un debug
  	
    	while($enregistrement = mysql_fetch_array($resultat))
    	{
    		// chaque enregistrement de la base de mise  jour est trait
	      	// voici les champs  mettre  jour en cas de correspondance trouve
	        // ceci pour tenir compte de modifications ventuelles depuis la dernire mise  jour (ces champs sont aussi utiliss
	  	    // en cas d'ajout d'un prof dans la base active
			$id_individu = quote_smart($enregistrement['id_individu']);
      		$type = quote_smart($enregistrement['type']);
			$nom = quote_smart($enregistrement['nom']); 
      		$prenom = quote_smart($enregistrement['prenom']);
			// la date de naissance peut tre NULL
			if (is_null($enregistrement['datenaiss']))
				$datenaiss = "NULL";
			else
				$datenaiss = "'".quote_smart($enregistrement['datenaiss'])."'";
			// l'activit aussi (grade) peut tre NULL
			if (is_null($enregistrement['activite']))
				$activite = "NULL";
			else
				$activite = "'".quote_smart($enregistrement['activite'])."'";
			// la civilit peut tre NULL
			if (is_null($enregistrement['civilite']))
				$civilite = "NULL";
			else
				$civilite = "'".quote_smart($enregistrement['civilite'])."'";
			$categorie = quote_smart($enregistrement['categorie']);
			$sous_categorie = quote_smart($enregistrement['sous_categorie']);
			$code_discipline = quote_smart($enregistrement['code_discipline']);
			$id_gpe_utilisateurs = quote_smart($enregistrement['id_groupe']); // C'est le groupe de droits pour IEW, utile pour l'insertion dans la table login
      
      		$rapport .= "<br />Cas $k : <strong>$nom $prenom</strong> (ID = $id_individu)<br />";
      		$k++;
      
      		$sql = "SELECT * FROM personnel WHERE id_individu='".quote_smart($id_individu)."'"; // recherche sur base active
      		$resultat_bis = mysql_query($sql);
      		if (mysql_num_rows($resultat_bis)>0)
      		{ // Il y a un enregistrement correspondant dans la base active
        
		        $rapport .= "Cette personne a t <strong>trouve dans la base !</strong><br />";
        
        		$id_pers = mysql_result($resultat_bis, 0, "id_pers"); // l'identifiant IntraEduweb est stock
        		$rapport .= "id_pers = $id_pers (dans la table 'personnel')<br />";
        		// de mme que les anciens nom et prnom (ils peuvent tre mis  jour)
        		$ancien_nom = mysql_result($resultat_bis, 0, "nom");
        		$ancien_prenom = mysql_result($resultat_bis, 0, "prenom");
        		// On met  jour par prcaution les champs (sauf id_pers et id_individu, on est sr qu'ils ne changent pas) au cas o ils auraient chang
        		$sql = "UPDATE personnel SET type='$type', nom='$nom', prenom='$prenom', datenaiss=$datenaiss, activite=$activite, categorie='$categorie',sous_categorie='$sous_categorie', civilite=$civilite, code_discipline='$code_discipline' WHERE id_individu='".quote_smart($id_individu)."'";
        		if (mysql_query($sql))
        		{
          			if (mysql_affected_rows()>0)  
          			{  
            			$rapport .= "La mise  jour (au cas o un changement serait fait) s'est acheve avec <font color='blue'>succs !</font><br />";
            			$rapport .= $sql."<br />"."<u>Nombre de lignes affectes :</u> ".mysql_affected_rows()."<br />";
          			}
        		}
        		else
        		{  
	          		$rapport .= "La mise  jour (au cas o un changement serait fait) a <font color='red'>chou !</font><br />";
    	    	}
	        	if (mysql_affected_rows()>0)
	        	{
	          		$compteur_maj += mysql_affected_rows(); // si l'enregistrement a t effectivement mis  jour (si une ou plusieurs nouvelles valeurs des champs diffrent des anciennes, on incrmente le compteur de mise  jour)
	        		$personnels_maj[] = $nom." ".$prenom; // On l'ajoute  la liste du personnel existant dont les donnes ont t mises  jour
	        	}
	          	$rapport .= "Nb total de fiches du personnel mises  jour : $compteur_maj<br />";
		    
    			// On s'assure que le prof trouv a un compte pour se connecter  IntraEduWeb
    			   	$sql="SELECT nom,prenom FROM login WHERE id_pers='".quote_smart($id_pers)."'";
        			$resultat_tris=mysql_query($sql);
        			if ($resultat_tris && mysql_num_rows($resultat_tris)==0) // s'il existe pas de compte pour ce prof, on en cre un
        			{
          				$rapport .= "Cette personne <strong>n'a pas de compte</strong> IntraEduWeb, on tente de lui en crer un ! (la requte $sql n'a pas donn de rsultat)<br />";
          				$identifiant = ""; // pas encore connu
        				$nom_cle_jointure = "id_individu"; // Nom du champ de la table login jouant le rle de cl de jointure avec les exports XML des applications de gestion
        				$valeur_cle_jointure = $id_individu;
        				if ($id=cree_compte_iew($nom_cle_jointure,$valeur_cle_jointure,$identifiant,$nom,$prenom,$id_gpe_utilisateurs,$fichier,$fichier_suivant)) // Si la cration du compte a russi
          				{
            				$rapport .= "<strong>Cration</strong> du compte IntraEduWeb <strong>russie</strong> !<br />";
            				$compteur_new_comptes++; // on incrmente le compteur de nouveau comptes intraeduweb
	            			$rapport .= "Nb total de nouveaux comptes utilisateurs IEW : $compteur_new_comptes<br />";
	    	        		// Un identifiant utilisateur unique vient d'tre cr, on le rcupre
    	    	    		// On le met comme identifiant de la personne dans la base du personnel
        	    			$sql2 = "UPDATE personnel SET id_pers='".quote_smart($id)."' WHERE  id_individu='".quote_smart($id_individu)."'";
            				mysql_query($sql2);
            				if (mysql_affected_rows()==-1) // Si l'criture n'a pas russi
            				{
		              			$rapport .= "L'identifiant numrique de <strong>".stripslashes($prenom)." ".stripslashes( $nom)."</strong> n'a pas pu tre mis  jour dans la base de donnes. La correspondance entre les donnes du compte utilisateur et la table personnel risque de ne plus tre correcte.<br />";
	        		      		$erreur .= "L'identifiant numrique de <strong>".stripslashes($prenom)." ".stripslashes( $nom)."</strong> n'a pas pu tre mis  jour dans la base de donnes. La correspondance entre les donnes du compte utilisateur et la table personnel risque de ne plus tre correcte.<br />";
    	        			}
        	  			}
          				else // l'criture dans la table login n'a pas eu lieu
          				{
		            		$rapport .= "Le <u>login</u> et le <u>mot de passe</u> de <strong>".stripslashes($prenom)." ".stripslashes( $nom)."</strong> n'ont pas pu tre inscrits dans la base de donnes.<br />";
	        		    	$erreur .= "Le <u>login</u> et le <u>mot de passe</u> de <strong>".stripslashes($prenom)." ".stripslashes( $nom)."</strong> n'ont pas pu tre inscrits dans la base de donnes (ils existent peut-tre dj).<br />";
    	      			}
        			}
        			else // il existe un compte pour ce prof, mais si le nom et/ou le prnom a chang, il faut mettre  jour l'enregistrement du compte (mais le login ne change pas -ni le mot de passe- et restera unique)
        			{
          				$rapport .= "cette personne a <strong>dj un compte IntraEduWeb</strong> : ses identifiant et mot de passe restent inchangs. la Requte $sql a bien donn un rsultat.<br />";
          				if ($ancien_nom!=stripslashes($nom) || $ancien_prenom!=stripslashes($prenom)) // stripslashes car $nom et $prenom sont quote_smartes
          				{
	            			$nom_table_login = $nom; // dj squote_smart
            				$prenom_table_login = $prenom;
            				$sql = "UPDATE login SET nom='$nom_table_login', prenom='$prenom_table_login' WHERE id_pers='".quote_smart($id_pers)."'";
            				if (mysql_query($sql))
            				{
              					$rapport .= "Son nom et/ou son prnom a <strong>chang</strong> (mise  jour russie de la table login)<br />";
            				}
		            		// On met  jour les fichiers textes contenant les comptes du personnel
		            		// Mais il faut rcuprer le login existant avant
    		        		$ligne_tris = mysql_fetch_array($resultat_tris);
        		    		$login = $ligne_tris['nomlogin'];
            				$rapport .= "mise  jour des fichiers textes contenant les comptes du personnel<br />";
            				modif_fichier_texte_codes_acces($GLOBALS['stock_baselev']."comptes_personnel.txt","",$id_pers,$ancien_prenom,$ancien_nom,$prenom,$nom,$login);
            				// et dans le fichiers de mots de passe new_comptes_eleves.txt (si ncessaire)
            				modif_fichier_texte_codes_acces($GLOBALS['stock_baselev']."new_comptes_personnel.txt","",$id_pers,$ancien_prenom,$ancien_nom,$prenom,$nom,$login); 
	          			}
    	    		}

      		}
      		else  // Si aucune correspondance n'existe, c'est que le prof est nouveau : il faut l'ajouter  la base
      		{
        
        		$rapport .= "C'est un <strong><font color='red'>Nouveau membre</font> du personnel ducatif !</strong><br />";
        

				// on lui cree un compte IEW
        			$identifiant = ""; // pas encore connu
        			$nom_cle_jointure = "id_individu"; // Nom du champ de la table login jouant le rle de cl de jointure avec les exports XML des applications de gestion
        			$valeur_cle_jointure = $id_individu;
        			if ($id=cree_compte_iew($nom_cle_jointure,$valeur_cle_jointure,$identifiant,$nom,$prenom,$id_gpe_utilisateurs,$fichier,$fichier_suivant)) // Si la cration du compte a russi
        			{
          				$rapport .= "Son compte IntraEduWeb est <font color='red'>cr !</font><br />";
          				$compteur_new_comptes++; // on incrmente le compteur de nouveau comptes intraeduweb
          				$rapport .= "Nb de nouveau comptes utilisateurs IntraEduWeb : $compteur_new_comptes<br />";
	          			// suite  des problmes d'apostrophes dans les noms
    	      			$nom_table_personnel = $nom; // dj squote_smart
        	  			$prenom_table_personnel = $prenom;
          				$sql2 = "INSERT INTO personnel VALUES('$id','$id_individu','$type','$nom_table_personnel','$prenom_table_personnel',$datenaiss, $activite,'$categorie','$sous_categorie
          				',$civilite,'$code_discipline')";
          				mysql_query($sql2);
          				if (mysql_affected_rows()==-1) // Si l'criture n'a pas russi
          				{
             
			            	$rapport .= "<strong><font color=orange>Echec d'criture</font></strong> dans la table personnel !<br />$sql2<br /><br />Erreur MySQL : ".mysql_errno()."<br />"; 
             
             				$erreur .= "<strong>".stripslashes($prenom)." ".stripslashes($nom)."</strong> n'a pas t enregistr dans la base de donnes.<br />";
          				}
          				else // Si l'criture dans la table personnel a russi, on incrmente un compteur
          				{
          
            				$rapport .= "Ecriture <font color=blue><strong>russie</strong></font> dans la table personnel !<br />";
          
			            	$compteur_insert++;
            				$rapport .= "Nb de membres du personnel ducatif insrs dans la base : $compteur_insert<br />";
							$personnels_nouveaux[] = "$nom $prenom"; // On met  jour la liste des nouveaux membres du personnel
          				}
        			}
        			else // l'criture dans la table login n'a pas eu lieu
        			{
          
		          		$rapport .= "<strong><font color=orange>Echec d'criture</font></strong> dans la table login!<br />";
          
        		  		$erreur .= "Le <u>login</u> et le <u>mot de passe</u> de <strong>".stripslashes($prenom)." ".stripslashes($nom)."</strong> n'ont pas pu tre inscrits dans la base de donnes (ils existent peut-tre dj).<br />";
        			}

      		} // professeur nouveau

    	} // while
    	
    	$rapport .= "<br />Il y a <strong>$compteur_insert</strong> Nouveaux membres du personnel enseignant ou administratif : <br />";
    	
    	foreach ($personnels_nouveaux as $value) // on donne la liste des nouveaux personnels
    	{
    		$rapport .= $value."<br />";
    	}
    	$rapport .= "<br />";
    	
    	// on ferme les fichiers ouverts
    	if ($GLOBALS['auth_method'] == "native")
    	{
 			fclose($fichier);
 			fclose($fichier_suivant);
    	}
 		
 		$rapport .= "</p>
 		<h3>Professeurs et autres membres du personnel supprims</h3>
		<p>";
 		
 		// 2) Recherche des profs sortants
	    // Cette fois-ci on part de la table active personnel et on cherche une correspondance avec la base de mise  jour
 		// Il faut galement mettre  jour la table login et le fichier comptes_personnel.txt;

 		if ($GLOBALS['auth_method'] == "native")
    	{
 			$fichier_lu=@fopen($GLOBALS['stock_baselev']."comptes_personnel.txt","r"); // ouverture en lecture seule
 			if ($fichier_lu)
 			{
  				$compteur=0;
  				while (!feof($fichier_lu)) // on commence la lecture jusqu' la fin du fichier
  				{
    				$compteur++; // contient le nombre de lignes du fichier lu
    				$champs_lus[$compteur]=fgetcsv($fichier_lu,100,","); // Lit une ligne et envoie dans un tableau les champs spars par des virgules
  				}
 			}
 			fclose($fichier_lu);
    	}


 		$comptes_personnel=array(); // Tableau destin  recevoir les comptes du personnel  recopier dans comptes_personnel.txt
 		// Traitement du fichier contenant les comptes  supprimer (pour les profs sortants)
   
 	    // Ce fichier ne sera pas forcment utilis : historiquement, il sert  l'admin rseau pour connatre les comptes  supprimer sur le rseau pdagogique, si les comptes IEW ont servi  la cration des comptes de ce rseau
 		if ($GLOBALS['auth_method'] == "native")
    	{
 			$fichier_suppr=@fopen($GLOBALS['stock_baselev']."suppr_comptes_personnel.txt","w"); // on ouvre en criture un fichier qui recevra les comptes profs  supprimer
    	}
 		 // C'est parti pour rechercher les profs sortants (on ne cherche que les profs et le personnel de direction)
 		 // Les autres membres du personnel ne sont pas grs dans STS_WEB (on fait du natif IEW pour ceux-l)
 		
    	$rapport .= "<b>Examen de la liste du personnel dans la base IEW</b><br />"; 
 		$sql = "SELECT * FROM personnel WHERE categorie='7' OR sous_categorie LIKE 'CPE%' OR categorie='5' OR categorie='2'"; // Voir table categories_pers
 		$resultat = mysql_query($sql);
 		$liste_profs_non_retrouves = array();
 		while($enregistrement = mysql_fetch_array($resultat))
 		{
			$id_individu = $enregistrement['id_individu']; // l'identifiant unique du prof
			$type = $enregistrement['type'];
			$civilite = $enregistrement['civilite'];
    		$nom = $enregistrement['nom']; 
    		$prenom = $enregistrement['prenom'];
    		$id_pers = $enregistrement['id_pers']; // on stocke l'id_pers en cours
    		$code_discipline = $enregistrement['code_discipline']; // on en aura besoin + loin pour savoir si c'est un prof documentaliste
    		$rapport .= "<br />$nom $prenom (id_pers=$id_pers)..........";
    		$sql = "SELECT * FROM personnel_maj WHERE id_individu='".quote_smart($id_individu)."'"; // recherche sur base de maj
    		$resultat_bis = mysql_query($sql);
    		if (mysql_num_rows($resultat_bis)>0)
    		{ // Il y a un enregistrement correspondant dans la base de maj
		      // la correspondance existe, le prof doit tre conserv : on ne fait rien sur les tables
		      // mais on recopie le compte
      			$rapport .= "est encore dans le fichier d'import (compte conserv)<br />";
    			$sql="SELECT nomlogin,nom,prenom FROM login WHERE id_pers='".quote_smart($id_pers)."'"; // on rcupre son nom de login
      			$resultat_tris=mysql_query($sql);
      			if ($resultat_tris && mysql_num_rows($resultat_tris)!=0) // s'il existe, alors il a un compte dans comptes_personnel.txt
      			{
        			if ($GLOBALS['auth_method'] == "native")
        			{
      					$row=mysql_fetch_row($resultat_tris);
        				$login=$row[0];
        				$prenom=$row[1];
        				$nom=$row[2];
        				foreach ($champs_lus as $value) // on recherche les infos du compte prof
        				{
          					if ($value[0]==$login) // Si correspondance trouve, on empile pour recopier
          					{
            					$enregistrement=$value[0].",".$prenom.",".$nom.",".$value[3];
            					array_push($comptes_personnel,$enregistrement);
            					break; // on sort de foreach
          					}
        				}
        			}
      			}
    		}
    		else // Si la correspondance n'existe pas, c'est que le prof est sorti de l'tablissement : il faut le supprimer de la base (SAUF Si c'est un documentaliste ou un professeur remplaant, car les documentalistes et les professeurs remplaants ne sont pas dans STS : il est donc normal qu'ils ne soient pas dans la table de maj)
    		{
      			$rapport .= "<b>n'est pas dans le fichier d'import</b>.....";
    			// on cherche  savoir si c'est un documentaliste
      			$libelle_long_discipline = "";
    			$sql = "SELECT libelle_long FROM disciplines_bcn WHERE code_discipline='$code_discipline'";
      			$resultat_bis = mysql_query($sql);
      			if (mysql_num_rows($resultat_bis)>0)
      			{
      				$ligne = mysql_fetch_array($resultat_bis);
      				$libelle_long_discipline = $ligne['libelle_long'];
      			}
      			// ou bien un professeur remplaant
      			$is_remplacant = false;
      			$sql = "SELECT * FROM remplacants WHERE id_remplacant='$id_individu'";
    			$resultat_tris = mysql_query($sql);
      			if (mysql_num_rows($resultat_tris)>0)
      				$is_remplacant = true; // oui c'en est un !
      			if (!stristr($libelle_long_discipline,"documentation") && !$is_remplacant) // si ce n'est pas un documentaliste, ni un professeur remplaant : on supprime le prof
      			{
    				/*
    				 * Oui, mais non ce n'est pas aussi simple (anomalie #99) :
    				 * Les professeurs crs manuellement dans l'EAD de scribe, puis s'tant connects au moins une fois dans IEW sont supprims 
    				 * lors d'un import administratif par xml STS, car ils ne sont pas dans le xml d'importation.
    				 * Il faut donc viter cela : pour l'instant, on va simplement mettre les professeurs non retrouvs dans une liste
    				 * Il sera demand  la fin de l'import quels professeurs non retrouvs on souhaite effectivement supprimer. */
      				$liste_profs_non_retrouves[] = "$id_pers".",".$id_individu.",".$civilite.",".$nom.",".$prenom.",".$libelle_long_discipline;
      				$rapport .= "<br/><strong>$civilite $nom $prenom</strong> (ID_INDIVIDU = $id_individu) n'a pas t retrouv(e) dans le fichier d'import. Il(elle) est ajout(e)  la <a href='#noretrieves'>liste des membres du personnel non retrouvs</a><br />";
      				$compteur_non_retrouves++;
      			}
      			// Autres cas : remplaant ou documentaliste. Dans ces cas, il n'y a aucune suppression dans la base de donnes, on communique seulement dans le rapport d'importation que le cas a t correctement examin
      			elseif ($is_remplacant)
      				$rapport .= "<br />Cette personne est un professeur remplaant, elle ne sera pas supprime de la base de donnes<br />";
      			else 
      				$rapport .= "<br />Cette personne est un documentaliste, elle ne sera pas supprime de la base de donnes<br />";
    		}
  		} // while => tous les profs ont t traits

  		if ($GLOBALS['auth_method'] == "native")
      	{
      		fclose($fichier_suppr);
      	}
 		
  		// On recopie dans le fichier comptes_personnel.txt les comptes profs  jour
 		// Bien que le fichier soit ouvert en mode ajout de donnes plus haut, ceci ne permet pas de supprimer les profs sortants
 		// il faut donc passer par l'tape suivante pour mettre  jour le fichier des comptes personnel

      	if ($GLOBALS['auth_method'] == "native")
      	{
      		if (count($comptes_personnel)!=0)
 			{
  				$fichier=fopen($GLOBALS['stock_baselev']."comptes_personnel.txt","w"); // on crase le contenu existant
  				for ($i=0;$i<=(count($comptes_personnel)-1);$i++)
  				{
    				$enregistrement=$comptes_personnel[$i]."\n";
    				fwrite($fichier,$enregistrement);
  				}
  				fclose($fichier);
 			}
      	}
 		
 		// Pour les personnels non retrouvs, on inscrit dans le rapport, mais on traitera la suppression effective + tard
      	if ($compteur_non_retrouves !=0)
      	{
      		$rapport .= "<a id='noretrieves'><br /><b>Liste des membres du personnel (enseignant ou administratif) non retrouvs</b><br /><br />
      		Il y a <strong>$compteur_non_retrouves</strong> personnes non retrouves dans le fichier d'import :<br />";
 			foreach ($liste_profs_non_retrouves as $value) // on donne la liste des nouveaux personnels
    		{
    			$frags = explode(",",$value); // $value est au formet id_pers,id_individu,civilite,nom,prenom,libelle_long_discipline
    			// On affiche les civilite,nom,prenom,libelle_long_discipline
    			$rapport .= "<b>".$frags[2]." ".$frags[3]." ".$frags[4]."</b> (".$frags[5].")"."<br />";
    		}
    		$rapport .= "<br />Il faudra <b>confirmer ou non leur suppression</b>  la fin de la procdure d'importation !<br />";
      	}
      	
		if ($compteur_maj !=0)
		{
			$rapport .= "</p>
			<h3>Professeurs Mis  jour</h3>
		<p>";
			
			$rapport .= "Il y a <strong>$compteur_maj</strong> membres du personnel (enseignant ou administratif) dont les donnes ont t mises  jour.</p>";
			foreach ($personnels_maj as $value)
			{
				$rapport .= "$value<br />"; // On affiche le nom+prenom de chaque personne dont les donnes ont t maj
			}
		}
		
		/*
		 * On rcupre ici les professeurs principaux
		 * */
  		$rapport .= "</p>
  		<h3>Professeurs principaux</h3>
		<p>";

  		$compteur_insert_pp = 0;
		if (is_array($parser->document->donnees[0]->individus[0]->individu))
		{
			foreach($parser->document->donnees[0]->individus[0]->individu as $value) 
			{
				if (is_array($value->profs_princ[0]->prof_princ))
				{
					foreach($value->profs_princ[0]->prof_princ as $prof_princ) // On peut tre PP de 2 divisions en zone sensible
					{
						$sql = "INSERT INTO profs_principaux VALUES('".quote_smart($value->tagAttrs['id'])."','".quote_smart($prof_princ->code_structure[0]->tagData)."')";
						mysql_query($sql); // On tente l'insertion dans la table profs_principaux
						if (mysql_affected_rows() == 1)
						{
							$rapport .= "Le professeur principal <strong>".ucfirst(strtolower($value->tagAttrs['prenom']))." ".$value->tagAttrs['nom_usage']."</strong> de la classe <strong><i>".$prof_princ->code_structure[0]->tagData."</i></strong> a t <u>ajout</u> dans la base de donnes.<br />";
							$compteur_insert_pp++;
						}
						else // l'insertion ne marche pas (rgime dj existant) => On tente une MAJ
						{	
							$sql = "UPDATE profs_principaux set code_structure='".quote_smart($prof_princ->code_structure[0]->tagData)."' WHERE id_prof='".quote_smart($value->tagAttrs['id'])."'";
							mysql_query($sql);
							if (mysql_affected_rows() == 1) // Mise  jour faite : des champs ont chang
							{
								$rapport .= "Le professeur principal <strong>".ucfirst(strtolower($value->tagAttrs['prenom']))." ".$value->tagAttrs['nom_usage']."</strong> de la classe <strong><i>".$prof_princ->code_structure[0]->tagData."</i></strong> <u>existe dj</u> dans la base de donnes MAIS <i></i> a t mis  jour.<br />";
							}
							else // Les donnes sont identiques  celles de la base
							{
								$rapport .= "Le professeur principal <strong>".ucfirst(strtolower($value->tagAttrs['prenom']))." ".$value->tagAttrs['nom_usage']."</strong> de la classe <strong><i>".$prof_princ->code_structure[0]->tagData."</i></strong> <u>existe dj</u> dans la base de donnes et il n'y a pas de modification.<br />";
							}				
						}	
					}
				}
			}
		}
		else
		{
			$rapport .= "<font color='red'><b>Il n'y a pas de professeurs principaux dans le fichier d'import !</b></font><br />";
		}
		
		/*
		 * On rcupre ici les services d'enseignement par division et par groupe
		 * */
		
		$balises_cours = 0; // initialisation d'un compteur de cours
		
		$rapport .= "</p>
		<h3>Services d'enseignement par division</h3>";
		
		$rapport .= "Les tables services et enseignants_services sont effaces, puis repeuples avec les donnes du fichier d'import. Ainsi, il est certain de ne pas avoir conservation d'anciens services.<br />";

		// On efface les tables suivantes pour permettre des changements dans les quipes pdagogiques et les services au dbut de l'anne scolaire
		// Par exemple, un prof d'anglais A a les 5me 3, le prof d'anglais B a les 5me 4
		// L'administration veut inverser les classes aprs import dans IEW : la modif est d'abord faite dans STS, mais si on importe sans effacer au pralable les donnes
		// on aura les 2 profs dans les 2 classes car je n'ai pas trouv de moyen simple de rechercher et de supprimer le prof en trop dans la classe
		// en effaant ces tables,o n aura toujours des services en correspondance avec les nouvelles donnes de STS (et pas un mix avec les donnes d'un import prcdent...)
		$sql = "TRUNCATE TABLE services";
		mysql_query($sql);
		$sql = "TRUNCATE TABLE enseignants_services";
		mysql_query($sql);
		// Attention cependant  l'effet de bord : les services d'un professeur remplaant ainsi supprims ne seront pas recrs automatiquement avec les donnes de STS puisqu'un professeur remplaant ne figure pas dans STS
		// il s'agit du bug n67, il suffit  la fin de l'import, et  partir de la table 'remplacants', de recrr les donnes supprimes de la table 'enseignants_services' et 'cours'
		// Ceci est implment plus bas dans le code 
		
		
		if (is_array($parser->document->donnees[0]->structure[0]->divisions[0]->division))
		{
			// La balise XML DIVISIONS peut ne pas exister ! 
			foreach($parser->document->donnees[0]->structure[0]->divisions[0]->division as $value) 
			{
				$rapport .= "<h4>Division ".$value->tagAttrs['code']."</h4>
				<p>";
				if (is_array($value->services[0]->service))
				{
					// La balise SERVICES peut ne pas exister ! 
					foreach($value->services[0]->service as $service)
					{
						$id_service = insert_maj_services($value,$service,"la division");
						// Il faut maintenant rattacher un ou plusieurs enseignant  ce service
						if (isset($id_service) && $id_service != "")
						{
							if (is_array($service->enseignants[0]->enseignant))
							{
								foreach($service->enseignants[0]->enseignant as $enseignant)
								{
									$id_enseignant_service = insert_maj_enseignants_services($id_service,$enseignant);
									// Les cours correspondants aux services seront rcuprs dans EDT_vers_STS_RNE_annee.xml
								}
							}
							else
							{
								$rapport .= "<font color='red'>Il n'y a pas d'enseignant indiqu pour le service sur la division ".$value->tagAttrs['code'].", matire ".$service->tagAttrs['code_matiere'].", modalit ".$service->tagAttrs['code_mod_cours']." dans le fichier d'import !</font><br />";
							}
						}
					}
				}
				else
				{
					$rapport .= "<font color='red'>Il n'y a pas de Service indiqu pour la division <strong>".$value->tagAttrs['code']."</strong> dans le fichier d'import !</font><br />";
				}
				$rapport .="</p>";
			}
		}
		else
		{
			$rapport .= "<font color='red'><b>Il n'y a pas de Service indiqu pour les divisions dans le fichier d'import !</b></font><br />";
		}
			
		$rapport .= "<h3>Services d'enseignement par groupe</h3>";

		if (is_array($parser->document->donnees[0]->structure[0]->groupes[0]->groupe))
		{
			// La balise XML GROUPES peut ne pas exister ! 
			foreach($parser->document->donnees[0]->structure[0]->groupes[0]->groupe as $value)
			{
				$rapport .= "<h4>Groupe ".$value->tagAttrs['code']."</h4>
				<p>";
				if (is_array($value->services[0]->service))
				{
					// La balise SERVICES peut ne pas exister ! 
					foreach($value->services[0]->service as $service)
					{
						$id_service = insert_maj_services($value,$service,"le groupe");
						// Il faut maintenant rattacher un ou plusieurs enseignant  ce service
						if (isset($id_service) && $id_service != "")
						{
							if (is_array($service->enseignants[0]->enseignant))
							{
								foreach($service->enseignants[0]->enseignant as $enseignant)
								{
									$id_enseignant_service = insert_maj_enseignants_services($id_service,$enseignant);
									// Les cours correspondants aux services seront rcuprs dans EDT_vers_STS_RNE_annee.xml
								}
							}
							else
							{
								$rapport .= "<font color='red'>Il n'y a pas d'enseignant indiqu pour le service sur le groupe ".$value->tagAttrs['code'].", matire ".$service->tagAttrs['code_matiere'].", modalit ".$service->tagAttrs['code_mod_cours']." dans le fichier d'import !</font><br />";
							}
						}
					}
				}
				else
				{
					$rapport .= "<font color='red'>Il n'y a pas de Service indiqu pour le groupe <strong>".$value->tagAttrs['code']."</strong> dans le fichier d'import !</font><br />";
				}
				$rapport .="</p>";
			}
		}
		else
		{
			$rapport .= "<font color='red'><b>Il n'y a pas de Service indiqu pour les groupes dans le fichier d'import !</b></font><br />";
		}	
		
		/**
		 * Recopie des services des professeurs remplaants  partir de ceux des titulaires
		 * Du fait du truncate ralis plus haut sur la table 'enseignants_services' (truncate ralis  chaque import)
		 * les services des professeurs remplaants sont supprims avec le truncate, mais vu que les professeurs remplaants ne sont pas dans STS, ces services ne sont donc pas recrs
		 * On peut cependant automatiser cette re-cration  partir de la table 'remplacants' (qui n'est pas efface  l'import)
		 */
		
		$rapport .= "<h3>Traitement des professeurs remplaants</h3>
		<p>";
		
		$sql = "SELECT * FROM remplacants";
		$resultat = mysql_query($sql);
		if ($resultat && mysql_num_rows($resultat) > 0)
		{
			while ($ligne = mysql_fetch_array($resultat))
			{
				$sql1 = "SELECT nom, prenom FROM personnel WHERE id_individu='".$ligne['id_remplacant']."'";
				$resultat1 = mysql_query($sql1);
				$ligne1 = mysql_fetch_array($resultat1);
				$rapport .= $ligne1['prenom']." ".$ligne1['nom']." remplace ";
				$sql2 = "SELECT nom, prenom FROM personnel WHERE id_individu='".$ligne['id_titulaire']."'";
				$resultat2 = mysql_query($sql2);
				$ligne2 = mysql_fetch_array($resultat2);
				$rapport .= $ligne2['prenom']." ".$ligne2['nom']."<br />Recopie des services du titulaire...";
				// on va recopier le service du titulaire dans le service du remplaant
				$sql3 = "SELECT * FROM enseignants_services WHERE id_individu='".$ligne['id_titulaire']."'";
				$resultat3 = mysql_query($sql3);
				while ($ligne3 = mysql_fetch_array($resultat3)) // pour chaque service du titulaire
				{
					// recopie du service du titulaire vers un nouveau service du remplaant
					$sql4 = "INSERT INTO enseignants_services VALUES(NULL,'".$ligne3['id_service']."','".$ligne3['type']."','".$ligne['id_remplacant']."','".$ligne3['heures_agent']."','".$ligne3['taux_ponderation']."')";
					if (!mysql_query($sql4))
					{
						$rapport .= "ERREUR :<br />$sql4<br />".mysql_errno()." : ".mysql_error()."<br />";
						$err_cp_serv = true;
					}
				}
				if (!$err_cp_serv)
					$rapport .= "OK<br />";
			}
		}
		else
		{
			$rapport .= "<font color='blue'>Il n'y a pas de professeur remplac dans l'tablissement.</font>";	
		}
		$rapport .="</p>";	
		
		/*
		 * On rcupre ici les matires propres  l'tablissement
		 * */
		
		$rapport .= "<h3>Matires tablissement</h3>
		<p>";

		if (is_array($parser->document->donnees[0]->matieres_etablissement[0]->matiere_etablissement))
		{
			// La balise XML MATIERE_ETABLISSEMENT peut ne pas exister ! 
			foreach($parser->document->donnees[0]->matieres_etablissement[0]->matiere_etablissement as $value) // Les Matires tablissement
			{
				$sql = "INSERT INTO matieres_etablissement VALUES('".quote_smart($value->tagAttrs['matiere_etablissement.code'])."','".quote_smart($value->code_matiere[0]->tagData)."','".quote_smart($value->libelle_court[0]->tagData)."','".quote_smart($value->libelle_long[0]->tagData)."')";
				mysql_query($sql); // On tente l'insertion dans la table matieres_etablissement
				if (mysql_affected_rows() == 1)
				{
					$rapport .= "La matire-tablissement <strong><i>".$value->libelle_long[0]->tagData."</i></strong> (".$value->tagAttrs['matiere_etablissement'].") a t <u>ajoute</u> dans la base de donnes.<br />";
				}
				else // l'insertion ne marche pas (rgime dj existant) => On tente une MAJ
				{
					$sql = "UPDATE matieres_etablissement set code_matiere='".quote_smart($value->code_matiere[0]->tagData)."', libelle_court='".quote_smart($value->libelle_court[0]->tagData)."', libelle_long='".quote_smart($value->libelle_long[0]->tagData)."' WHERE code_matiere_etab='".quote_smart($value->tagAttrs['matiere_etablissement'])."'";
					mysql_query($sql);
					if (mysql_affected_rows() == 1) // Mise  jour faite : des champs ont chang
					{
						$rapport .= "La matire-tablissement <strong><i>".$value->libelle_long[0]->tagData."</i></strong> (".$value->tagAttrs['matiere_etablissement'].") <u>existe dj</u> dans la base de donnes MAIS <i></i> a t mise  jour.<br />";
					}
					else // Les donnes sont identiques  celles de la base
					{
						$rapport .= "La matire-tablissement <strong><i>".$value->libelle_long[0]->tagData."</i></strong> (".$value->tagAttrs['matiere_etablissement'].") <u>existe dj</u> dans la base de donnes et il n'y a pas de modification.<br />";
					}				
				}	
			}
		}
		else
		{
			$rapport .= "<font color='blue'>Il n'y a pas de matire-tablissement dans le fichier d'import.</font><br />";
		}
		$rapport .="</p>";
				
 		
		/**************** Traitement du fichier EDT_vers_STS_RNE_annee.xml **************/

		$filename = ""; // rinitialisation pour le test plus bas
		// On rcupre le nom du fichier 
		foreach ($tab_delfile as $value)
		{
			if (substr($value,0,12) == "EDT_vers_STS")
           	{
           		$filename = $value; // On a le nom complet EDT_vers_STS_RNE_annee.xml
           		break;
           	}
		}
		
		// Pas la peine de traiter ces lignes de code si le fichier n'est pas fourni (facultatif)
		if ($filename != "") // l le fichier est fourni
		{
			$rapport .= "<h2>Traitement du fichier EDT_vers_STS_RNE_annee.xml</h2>";
		
			$rapport .= "<h3>Horaires de l'tablissement</h3>
			<p>";
		
			// Rinitalisation du parser
			$fichier = $GLOBALS['stock_baselev']."importation/".$filename;
			//Get the XML document loaded into a variable
			$xml = file_get_contents($fichier);
			//Set up the parser object
			$parser = new XMLParser($xml);
			//Work the magic...
			$parser->Parse();
		
			if (is_array($parser->document->donnees[0]->horaires[0]->horaire))
			{
				foreach($parser->document->donnees[0]->horaires[0]->horaire as $value) // Les horaires des jours
				{
					$sql = "INSERT INTO horaires_edt VALUES('".quote_smart($value->tagAttrs['jour'])."','".quote_smart($value->debut_cours[0]->tagData)."','".quote_smart($value->fin_cours[0]->tagData)."')";
					mysql_query($sql); // On tente l'insertion dans la table horaires_edt
					if (mysql_affected_rows() == 1)
					{
						$rapport .= "Les horaires du jour <strong><i>".$value->tagAttrs['jour']."</i></strong> (debut = ".formate_horaire($value->debut_cours[0]->tagData).", fin = ".formate_horaire($value->fin_cours[0]->tagData).") ont t <u>ajouts</u> dans la base de donnes.<br />";
					}
					else // l'insertion ne marche pas (horaires du jour dj existant) => On tente une MAJ
					{
						$sql = "UPDATE horaires_edt SET debut_cours='".quote_smart($value->debut_cours[0]->tagData)."', fin_cours='".quote_smart($value->fin_cours[0]->tagData)."' WHERE code_jour='".quote_smart($value->tagAttrs['jour'])."'";
						mysql_query($sql);
						if (mysql_affected_rows() == 1) // Mise  jour faite : des champs ont chang
						{
							$rapport .= "Les horaires du jour <strong><i>".$value->tagAttrs['jour']."</i></strong> (debut = ".formate_horaire($value->debut_cours[0]->tagData).", fin = ".formate_horaire($value->fin_cours[0]->tagData).") <u>existent dj</u> dans la base de donnes MAIS <i></i> ont t mis  jour.<br />";
						}
						else // Les donnes sont identiques  celles de la base
						{
							$rapport .= "Les horaires du jour <strong><i>".$value->tagAttrs['jour']."</i></strong> (debut = ".formate_horaire($value->debut_cours[0]->tagData).", fin = ".formate_horaire($value->fin_cours[0]->tagData).") <u>existent dj</u> dans la base de donnes et il n'y a pas de modification.<br />";
						}				
					}	
				}
			}
			
			$rapport .= "</p>
			<h3>Alternances (semaines, trimestres, priodes)</h3>";
			
			// Il faut effacer les donns de la table semaines_alternances, car sinon les donnes du fichier XML s'ajoutent aux donnes dans la base (pas de cl primaire)
			$sql = "TRUNCATE table semaines_alternances";
			mysql_query($sql);
			
			if (is_array($parser->document->donnees[0]->alternances[0]->alternance))
			{
				foreach($parser->document->donnees[0]->alternances[0]->alternance as $value) 
				{
					$rapport .= "<h4>Alternance ".$value->tagAttrs['code']."</h4>
					<p>";
					$sql = "INSERT INTO alternances VALUES('".quote_smart($value->tagAttrs['code'])."','".quote_smart($value->libelle_court[0]->tagData)."','".quote_smart($value->libelle_long[0]->tagData)."')";
					mysql_query($sql); // On tente l'insertion dans la table alternances
					if (mysql_affected_rows() == 1)
					{
						$rapport .= "L'alternance <strong><i>".$value->tagAttrs['code']."</i></strong> (".$value->libelle_long[0]->tagData.") a t <u>ajoute</u> dans la base de donnes.<br />";
					}
					else // l'insertion ne marche pas (rgime dj existant) => On tente une MAJ
					{
						$sql = "UPDATE alternances set libelle_court='".quote_smart($value->libelle_court[0]->tagData)."', libelle_long='".quote_smart($value->libelle_long[0]->tagData)."' WHERE code_alternance='".quote_smart($value->tagAttrs['code'])."'";
						mysql_query($sql);
						if (mysql_affected_rows() == 1) // Mise  jour faite : des champs ont chang
						{
							$rapport .= "L'alternance <strong><i>".$value->tagAttrs['code']."</i></strong> (".$value->libelle_long[0]->tagData.") <u>existe dj</u> dans la base de donnes MAIS <i></i> a t mise  jour.<br />";
						}
						else // Les donnes sont identiques  celles de la base
						{
							$rapport .= "L'alternance <strong><i>".$value->tagAttrs['code']."</i></strong> (".$value->libelle_long[0]->tagData.") <u>existe dj</u> dans la base de donnes et il n'y a pas de modification.<br />";
						}				
					}
					if (is_array($value->semaines[0]->date_debut_semaine))
					{
						foreach($value->semaines[0]->date_debut_semaine as $date_debut_semaine) // Les semaines
						{
							$sql = "INSERT INTO semaines_alternances VALUES('".quote_smart($value->tagAttrs['code'])."','".quote_smart($date_debut_semaine->tagData)."')";
							mysql_query($sql); // On tente l'insertion dans la table semaines_alternances
							if (mysql_affected_rows() == 1)
							{
								$rapport .= "Le debut de semaine  <strong><i>".$date_debut_semaine->tagData."</i></strong> ( pour l'alternance ".$value->tagAttrs['code'].") a t <u>ajout ou mis  jour</u> dans la base de donnes.<br />";
							}
							else // l'insertion ne marche pas (rgime dj existant) => On tente une MAJ
							{
								// Rien car pas de mise  jour possible	vu qu'il n' y a pas de cl primaire
								// La donne est inchange
								$rapport .= "Le debut de semaine  <strong><i>".$date_debut_semaine->tagData."</i></strong> ( pour l'alternance ".$value->tagAttrs['code'].") existe <u>dj</u> dans la base de donnes.<br />";
							}	
						}
					}
					$rapport .="</p>";	
				}
			}
			
			// Remplissage de la table semab pour le calendrier des semaines (permet le remplissage de cette table sans devoir ncessairement utiliser le formulaire de saisie des dates du calendrier scolaire : tche n141)
			// uniquement si la table semab ne contient pas dj des donnes			
			$sql = "SELECT * FROM semab";
			$resultat = mysql_query($sql);
			if ($resultat && mysql_num_rows($resultat) == 0)
			{
				$prefix_nom_variables_trim = array("dbt_1t","fin_1t","p_1t","dbt_2t","fin_2t","p_2t","dbt_3t","fin_3t","p_3t","dbt_ete");
				// Les dates rcupres sont toujours les dates de dbut de semaine o a lieu l'vvenement (rentre scolaire, dbuts et fin des diffrents trimestres,...)
				
				/** date de rentre, date de dbut du 1er trimestre, date des vacances d't */
				
				$sql = "SELECT date_debut_semaine FROM semaines_alternances WHERE code_alternance='H' ORDER BY date_debut_semaine";
				// Il faut rcuprer seulement le 1er et le dernier rsultat de cette requte : avec MIN(date_debut_semaine) et MAX(date_debut_semaine), on ne rcupre pas ce que je veux (car il y a d'autres codes d'alternance que H)
				// il aurait fallu une requte recherchant la valeur MIN et MAX de la colonne date_debut_semaine UNIQUEMENT pour le code_alternance 'H'
				// Le problme est contourn par l'utilisation de mysql_data_seek(), voir + bas...
				$resultat = mysql_query($sql);
				if ($resultat)
				{
					$nblignes = mysql_num_rows($resultat);
					if ($nblignes >=1)
					{
						$ligne = mysql_fetch_array($resultat); // Le 1er rsultat donne la date de rentre
						$date_rentree = $ligne['date_debut_semaine'];
						$dbt_1t = $date_rentree; // la date de dbut du 1er trimestre = date de rentre
						mysql_data_seek($resultat,$nblignes - 1); // On dplace le pointeur de rsultat sur le dernier rsultat (pour avoir la fin du 3me trimestre)
						$ligne = mysql_fetch_array($resultat);
						$dbt_ete = $ligne['date_debut_semaine'];
					}
				}
				
				/** date de fin du 1er trimestre */
				
				$sql = "SELECT date_debut_semaine FROM semaines_alternances WHERE code_alternance='T1' ORDER BY date_debut_semaine DESC"; // on trie par ordre inverse car on ne va rcuprer que la dernire date
				$resultat = mysql_query($sql);
				if ($resultat)
				{
					$nblignes = mysql_num_rows($resultat);
					if ($nblignes >=1)
					{
						$ligne = mysql_fetch_array($resultat); // Le 1er rsultat donne la date de rentre
						$fin_1t = $ligne['date_debut_semaine'];
					}
				}
				
				/** date de dbut et date de fin du 2me trimestre */
				
				$sql = "SELECT date_debut_semaine FROM semaines_alternances WHERE code_alternance='T2' ORDER BY date_debut_semaine";
				$resultat = mysql_query($sql);
				if ($resultat)
				{
					$nblignes = mysql_num_rows($resultat);
					if ($nblignes >=1)
					{
						$ligne = mysql_fetch_array($resultat); // Le 1er rsultat donne la date de rentre
						$dbt_2t = $ligne['date_debut_semaine'];
						mysql_data_seek($resultat,$nblignes - 1); // On dplace le pointeur de rsultat sur le dernier rsultat (pour avoir la fin du 3me trimestre)
						$ligne = mysql_fetch_array($resultat);
						$fin_2t = $ligne['date_debut_semaine'];
					}
				}
				
				/** date de dbut et fin du 3me trimestre */
				
				$sql = "SELECT date_debut_semaine FROM semaines_alternances WHERE code_alternance='T3' ORDER BY date_debut_semaine";
				$resultat = mysql_query($sql);
				if ($resultat)
				{
					$nblignes = mysql_num_rows($resultat);
					if ($nblignes >=1)
					{
						$ligne = mysql_fetch_array($resultat); // Le 1er rsultat donne la date de rentre
						$dbt_3t = $ligne['date_debut_semaine'];
						mysql_data_seek($resultat,$nblignes - 1); // On dplace le pointeur de rsultat sur le dernier rsultat (pour avoir la fin du 3me trimestre)
						$ligne = mysql_fetch_array($resultat);
						$fin_3t = $ligne['date_debut_semaine'];
					}
				}
				
				/** Maintenant on va calculer les dates des vacances scolaires */
				
				$noms_variables_dates_vacances = array("","dbt_toussaint","fin_toussaint","dbt_noel","fin_noel","dbt_fev","fin_fev","dbt_paq","fin_paq");
				$sql = "SELECT date_debut_semaine FROM semaines_alternances WHERE code_alternance='H' ORDER BY date_debut_semaine";
				$resultat = mysql_query($sql);
				if ($resultat)
				{
					$nblignes = mysql_num_rows($resultat);
					if ($nblignes >=1)
					{
						while ($ligne = mysql_fetch_array($resultat))
						{
							$semaines_alternances_H[] = $ligne['date_debut_semaine']; 
						}
						$pointeur = 0; // initialisation d'un pointeur pour le tableau $noms_variables_dates_vacances
						for ($i=0;$i<=count($semaines_alternances_H)-1;$i++)
						{
							$diff_tab = date_difference($semaines_alternances_H[$i], $semaines_alternances_H[$i+1]);
							$nbjours = $diff_tab['d'];
							if ($nbjours>7)
							{
								$pointeur++; // pointeur dans un tableau contenant les noms de variable, dbt_toussaint, fin_toussaint etc...
								// on affecte  la variable le dernier jour de la semaine de $semaines_alternances_H[$i]
								$nom_var = $noms_variables_dates_vacances[$pointeur];
								$nbjoursplus = count($GLOBALS['jours_ouvrables'])-1;
								$format = "+".$nbjoursplus." day";
								// Voil la date de dbut des vacances (dernier jour de classe)
								$$nom_var = date("Y-m-d", strtotime($format,strtotime($semaines_alternances_H[$i])));
								// Voil la date de fin des vacances (date de reprise des cours
								$pointeur++;
								$nom_var = $noms_variables_dates_vacances[$pointeur];
								$$nom_var = $semaines_alternances_H[$i+1];
							}
						}
					}
				}	
				
				/** Il faut maintenant calculer les date de demi-priodes (demi-trimestre) */
				
				for ($i=1;$i<=3;$i++)
				{
					$date1 = "dbt_".$i."t";
					$date2 = "fin_".$i."t";
					$diff_tab = date_difference($$date1, $$date2);
					$nbjours1 = $diff_tab['d'];
					// Il faut retirer les vacances entre les 2 dates s'il y en a, avant de calculer la demi-priode
					switch ($i)
					{
						case 1:
							// Il n'y a que les vacances de toussaint
							$diff_tab = date_difference($dbt_toussaint, $fin_toussaint);
							$nbjours2 = $diff_tab['d'];
							$nbjours = $nbjours1 - $nbjours2; // Nombre de jours (hors vacances) au 1er trimestre
							break;
						case 2:
							// Il n'y a que les vacances de Nol
							$diff_tab = date_difference($dbt_noel, $fin_noel);
							$nbjours2 = $diff_tab['d'];
							$nbjours = $nbjours1 - $nbjours2; // Nombre de jours (hors vacances) au 2me trimestre
							break;
						case 3;
							// Vacances de fvrier + Pques
							$diff_tab = date_difference($dbt_fev, $fin_fev);
							$nbjours2 = $diff_tab['d'];
							$diff_tab = date_difference($dbt_paq, $fin_paq);
							$nbjours3 = $diff_tab['d'];
							$nbjours = $nbjours1 - $nbjours2 - $nbjours3; // Nombre de jours (hors vacances) au 3me trimestre
							break;	
					}
					$nbsemaines = round($nbjours/7)+1; 
					if ($nbsemaines%2 != 0) // si le nombre de semaine n'est pas pair, on l'incrmente
					{
						$nbsemaines++;
						$flag_pair = false;
					}
					else
						$flag_pair = true;
					$date3 = "p_".$i."t";
					$nbsemplus = round($nbsemaines / 2);
					if (!$flag_pair)
						$nbsemplus = $nbsemplus - 1;
					if ($i == 2)
						$nbsemplus = $nbsemplus + 2; // On tient compte des vacances
					elseif ($i == 3)
						$nbsemplus = $nbsemplus + 4; // On tient compte des vacances
					$format = "+".$nbsemplus." week";
					$$date3 = date("Y-m-d", strtotime($format,strtotime($$date1))); // Voil la date du dbut de la semaine de demi-priode, mais il nous faut la fin de cette semaine
					$nbjoursplus = count($GLOBALS['jours_ouvrables'])-1;
					$format = "+".$nbjoursplus." day";
					$$date3 = date("Y-m-d", strtotime($format,strtotime($$date3))); // Voil la date de fin de demi-priode
				}
				
				// 	les dates de fin de priode doivent correspondre au dernier jour ouvr de la semaine dans l'tablissement (sauf cas particulier des vacances d't qui peuvent tomber en milieu de semaine ?)
				for ($i=1;$i<=3;$i++)
				{
					$date_fin_trim = "fin_".$i."t";
					$nbjoursplus = count($GLOBALS['jours_ouvrables'])-1;
					$format = "+".$nbjoursplus." day";
					$$date_fin_trim = date("Y-m-d", strtotime($format,strtotime($$date_fin_trim))); // Voil la date de fin de semaine de la dernire semaine du trimestre	
				}
				
				$dbt_ete = $fin_3t; // Afin que la date des grandes vacances corresponde  la fin du 3me trimestre
				
				/** Ecriture des donnes dans la table semab */
				
				$sql = "INSERT INTO semab VALUES('".$date_rentree."','".$dbt_toussaint."','".$fin_toussaint."','".$dbt_noel."','".$fin_noel."','".$dbt_fev."','".$fin_fev."','".$dbt_paq."','".$fin_paq."','".$dbt_1t."','".$fin_1t."','".$p_1t."','".$dbt_2t."','".$fin_2t."','".$p_2t."','".$dbt_3t."','".$fin_3t."','".$p_3t."','".$dbt_ete."')";
				mysql_query($sql);
				if (mysql_affected_rows() == 1)
				{
					$rapport .= "Les dates de vacances scolaires ont t rcupres, <strong><i>le calendrier scolaire avec l'alternances de semaines est prt</i></strong>:<br />";
					foreach ($prefix_nom_variables_trim as $value)
					{
						$rapport .= "$value : ".$$value."<br />";
					}
					foreach ($noms_variables_dates_vacances as $value)
					{
						if ($value !== "") // On n'affiche pas le 1er elt du tableau qui est vide
							$rapport .= "$value : ".$$value."<br />";
					}
				}
				else
				{
					$rapport .= "Les dates de vacances scolaires <strong><i>n'ont pas pu tre inscrites dans la table semab</i></strong>, vous devriez peut-tre utiliser le <a href='saisie_semab.php'>formulaire de saisie des dates de calendrier</a> pour que le calendrier scolaire avec l'alternances de semaines est prt.<br />";
				}
			}
			
			$rapport .= "<h3>Salles de cours</h3>
			<p>";
			
			if (is_array($parser->document->donnees[0]->salles_cours[0]->salle_cours))
			{
				// 	La balise XML SALLES_COURS peut ne pas exister ! 
				foreach($parser->document->donnees[0]->salles_cours[0]->salle_cours as $value) // Les Matires tablissement
				{
					$sql = "INSERT INTO salles_cours VALUES('".quote_smart($value->tagAttrs['code'])."','".quote_smart($value->groupe_salle[0]->tagData)."','".quote_smart($value->localisation[0]->tagData)."')";
					mysql_query($sql); // On tente l'insertion dans la table matieres_etablissement
					if (mysql_affected_rows() == 1)
					{
						$rapport .= "La salle de cours <strong><i>".$value->tagAttrs['code']."</i></strong> a t <u>ajoute</u> dans la base de donnes.<br />";
					}
					else // l'insertion ne marche pas (rgime dj existant) => On tente une MAJ
					{
						$sql = "UPDATE salles_cours set groupe_salle='".quote_smart($value->groupe_salle[0]->tagData)."', localisation='".quote_smart($value->localisation[0]->tagData)."',WHERE code_salle='".quote_smart($value->tagAttrs['code'])."'";
						mysql_query($sql);
						if (mysql_affected_rows() == 1) // Mise  jour faite : des champs ont chang
						{
							$rapport .= "La salle de cours <strong><i>".$value->tagAttrs['code']."</i></strong> <u>existe dj</u> dans la base de donnes MAIS <i></i> a t mise  jour.<br />";
						}
						else // Les donnes sont identiques  celles de la base
						{
							$rapport .= "La salle de cours <strong><i>".$value->tagAttrs['code']."</i></strong> <u>existe dj</u> dans la base de donnes et il n'y a pas de modification.<br />";
						}				
					}	
				}
			}
			else
			{
				$rapport .= "<font color='blue'>Il n'y a pas de salles de cours dans le fichier d'import.</font><br />";
			}
			
			$rapport .= "</p>
			<h3>Cours : emplois du temps</h3>";
		
			// On efface la table suivante pour permettre des changements sans ajout aux donnes existantes
			$sql = "TRUNCATE TABLE cours";
			mysql_query($sql);
			// Attention cependant  l'effet de bord : les cours d'un professeur remplaant ainsi supprims ne seront pas recrs automatiquement avec les donnes de EDT puisqu'un professeur remplaant ne figure pas dans EDT
			// il s'agit du bug n67, il suffit  la fin de l'import, et  partir de la table 'remplacants', de recrr les donnes supprimes de la table 'enseignants_services' et 'cours'
			// Ceci est implment plus bas dans le code 
			
		
			/*
		 	* On rcupre ici les cours rattachs aux services d'enseignement par division et par groupe
		 	* Les services d'enseignement existent dj dans sts et ont t import.
		 	* Il faut reparcourir le mme type d'arborescence xml pour rattacher les cours aux bons services
		 	* */
			
			$balises_cours = 0; // initialisation d'un compteur de cours
			$duree_cours = 0; // initialisation d'un compteur d'heures de cours
			
			$rapport .= "<h4>Emplois du temps par division</h4>";
	
			if (is_array($parser->document->donnees[0]->structure[0]->divisions[0]->division))
			{
				// La balise XML DIVISIONS peut ne pas exister ! 
				foreach($parser->document->donnees[0]->structure[0]->divisions[0]->division as $value) 
				{
					$rapport .= "<h5>Division ".$value->tagAttrs['code']."</h5>";
					if (is_array($value->services[0]->service))
					{
						$rapport .="<p>";
						// La balise SERVICES peut ne pas exister ! 
						foreach($value->services[0]->service as $service)
						{
							// on rcupre le libell de la matire pour le rapport
							$libelle_matiere = ""; // Rinitialis  chaque boucle foreach
							$sql = "SELECT libelle_long FROM matieres_sconet WHERE code_matiere='".$service->tagAttrs['code_matiere']."'";
							$resultat = mysql_query($sql);
							$ligne = mysql_fetch_array($resultat);
							$libelle_matiere = $ligne['libelle_long'];
							
							// Il faut rcuprer l'id_service du service
							$id_service = ""; // rinitalisation indispensable sinon le test isset($id_service) && $id_service != "" + bas est fauss car $id_service contient alors la valeur dtermine dans la boucle prcdente
							$sql = "SELECT id_service FROM services WHERE code_structure='".quote_smart($value->tagAttrs['code'])."' AND code_matiere='".quote_smart($service->tagAttrs['code_matiere'])."' AND code_mod_cours='".quote_smart($service->tagAttrs['code_mod_cours'])."'";
							$resultat = mysql_query($sql);
							if ($resultat && mysql_num_rows($resultat)>0)
							{
								$ligne = mysql_fetch_array($resultat);
								$id_service = $ligne['id_service'];
							}
							// Il faut maintenant rattacher un ou plusieurs enseignant  ce service
							if (isset($id_service) && $id_service != "")
							{
								if (is_array($service->enseignants[0]->enseignant))
								{
									foreach($service->enseignants[0]->enseignant as $enseignant)
									{
										// On rcupre le nom et le prnom de l'enseignant pour le rapport
										$nom=""; // s'assure d'effacer la vleur prcdente
										$prenom="";
										$sql = "SELECT nom,prenom FROM personnel WHERE categorie='7' AND id_individu='".$enseignant->tagAttrs['id']."'";
										$resultat = mysql_query($sql);
										$ligne = mysql_fetch_array($resultat);
										$nom = $ligne['nom'];
										$prenom = $ligne['prenom'];
										$id_individu = $enseignant->tagAttrs['id']; // sera mis en global dans insert_maj_cours() pour tre inscrit dans le rapport 
										
										// Il faut rcuprer l'id_enseignant_service de l'enseignant
										$id_enseignant_service = ""; // rinitalisation indispensable
										$sql = "SELECT id_enseignant_service FROM enseignants_services WHERE id_service='".quote_smart($id_service)."' AND id_individu='".quote_smart($enseignant->tagAttrs['id'])."'";
										$resultat = mysql_query($sql);
										if ($resultat && mysql_num_rows($resultat)>0)
										{
											$ligne = mysql_fetch_array($resultat);
											$id_enseignant_service = $ligne['id_enseignant_service'];
										}
	
										// Il faut rattacher maintenant 1 ou plusieurs cours pour cet enseignant  propos du service en cours
										if (isset($id_enseignant_service) && $id_enseignant_service != "")
										{
											if (is_array($enseignant->cours_rattaches[0]->cours))
											{
												foreach($enseignant->cours_rattaches[0]->cours as $cours)
												{
													insert_maj_cours($id_enseignant_service,$cours,$service,"la division",$value->tagAttrs['code']);
												}
											}
											else
											{
												$rapport .= "<font color='red'>Il n'y a pas de cours rattach  l'enseignant <strong><i>$nom ".ucfirst(strtolower($prenom))."</i></strong> indiqu pour le service n ".$id_service." sur la structure ".$value->tagAttrs['code'].", matire ".$libelle_matiere.", modalit ".$service->tagAttrs['code_mod_cours']." dans le fichier d'import !</font><br />";	
											}
										}
	
									}
								}
								else
								{
									$rapport .= "<font color='red'>Il n'y a pas d'enseignant indiqu pour le service sur la division ".$value->tagAttrs['code'].", matire ".$libelle_matiere.", modalit ".$service->tagAttrs['code_mod_cours']." dans le fichier d'import !</font><br />";
								}
							}
							else // le service n'existe pas dans STS, mais seulement dans l'EDT, il faut alors crer le service et le cours correspondant
							{
								/* C'est le cas par exemple de l'heure de vie de classe qui apparat dans les EDT des profs principaux, mais pas dans les services
								 * imports par sts_emp_RNE_annee.xml : si on ne cre pas le service avec ses cours rattachs ce service n'apparatra pas dans l'EDT
								 * En effet, c'est une heure rserve dans l'EDT, mais qui n'est pas obligatoire, c'est pourquoi elle n'est pas dans STS
								 * */
								
								// cration du service
								$id_service = insert_maj_services($value,$service,"la division");
								
								// Il faut maintenant rattacher un ou plusieurs enseignant  ce service
								if (isset($id_service) && $id_service != "")
								{
									if (is_array($service->enseignants[0]->enseignant))
									{
										foreach($service->enseignants[0]->enseignant as $enseignant)
										{
											$id_individu = $enseignant->tagAttrs['id']; // sera mis en global dans insert_maj_cours() pour tre inscrit dans le rapport 
											$id_enseignant_service = insert_maj_enseignants_services($id_service,$enseignant);
											
											// Il faut rattacher maintenant 1 ou plusieurs cours pour cet enseignant  propos du service en cours
											if (isset($id_enseignant_service) && $id_enseignant_service != "")
											{
												if (is_array($enseignant->cours_rattaches[0]->cours))
												{
													foreach($enseignant->cours_rattaches[0]->cours as $cours)
													{
														insert_maj_cours($id_enseignant_service,$cours,$service,"la division",$value->tagAttrs['code']);
													}
												}
												else
												{
													$rapport .= "<font color='red'>Il n'y a pas de cours rattach  l'enseignant <strong><i>$nom ".ucfirst(strtolower($prenom))."</i></strong> indiqu pour le service n ".$id_service." sur la structure ".$value->tagAttrs['code'].", matire ".$libelle_matiere.", modalit ".$service->tagAttrs['code_mod_cours']." dans le fichier d'import !</font><br />";	
												}
											}
										}
									}
									else
									{
										$rapport .= "<font color='red'>Il n'y a pas d'enseignant indiqu pour le service sur la division ".$value->tagAttrs['code'].", matire ".$service->tagAttrs['code_matiere'].", modalit ".$service->tagAttrs['code_mod_cours']." dans le fichier d'import !</font><br />";
									}
								}								
							}
						}
						$rapport .="</p>";
					}
					else
					{
						$rapport .= "<font color='red'>Il n'y a pas de Service indiqu pour la division <strong>".$value->tagAttrs['code']."</strong> dans le fichier d'import !</font><br />";
					}	
				}
			}
			else
			{
				$rapport .= "<font color='red'><b>Il n'y a pas de Service indiqu pour les divisions dans le fichier d'import !</b></font><br />";
			}
			
			$rapport .= "<h4>Emplois du temps par groupe</h4>";
	
			if (is_array($parser->document->donnees[0]->structure[0]->groupes[0]->groupe))
			{
				// 	La balise XML GROUPES peut ne pas exister ! 
				foreach($parser->document->donnees[0]->structure[0]->groupes[0]->groupe as $value)
				{
					$rapport .= "<h5>Groupe ".$value->tagAttrs['code']."</h5>";
					if (is_array($value->services[0]->service))
					{
						$rapport .="<p>";
						// La balise SERVICES peut ne pas exister ! 
						foreach($value->services[0]->service as $service)
						{
							// on rcupre le libell de la matire pour le rapport
							$libelle_matiere = ""; // Rinitialis  chaque boucle foreach
							$sql = "SELECT libelle_long FROM matieres_sconet WHERE code_matiere='".$service->tagAttrs['code_matiere']."'";
							$resultat = mysql_query($sql);
							$ligne = mysql_fetch_array($resultat);
							$libelle_matiere = $ligne['libelle_long'];
							
							// 	Il faut rcuprer l'id_service du service
							$id_service = ""; // rinitalisation indispensable sinon le test isset($id_service) && $id_service != "" + bas est fauss car $id_service contient alors la valeur dtermine dans la boucle prcdente
							$sql = "SELECT id_service FROM services WHERE code_structure='".quote_smart($value->tagAttrs['code'])."' AND code_matiere='".quote_smart($service->tagAttrs['code_matiere'])."' AND code_mod_cours='".quote_smart($service->tagAttrs['code_mod_cours'])."'";
							$resultat = mysql_query($sql);
							if ($resultat && mysql_num_rows($resultat)>0)
							{
								$ligne = mysql_fetch_array($resultat);
								$id_service = $ligne['id_service'];
							}		
							// 	Il faut maintenant rattacher un ou plusieurs enseignant  ce service
							if (isset($id_service) && $id_service != "")
							{
								if (is_array($service->enseignants[0]->enseignant))
								{
									foreach($service->enseignants[0]->enseignant as $enseignant)
									{
										// On rcupre le nom et le prnom de l'enseignant pour le rapport
										$nom=""; // s'assure d'effacer la vleur prcdente
										$prenom="";
										$sql = "SELECT nom,prenom FROM personnel WHERE categorie='7' AND id_individu='".$enseignant->tagAttrs['id']."'";
										$resultat = mysql_query($sql);
										$ligne = mysql_fetch_array($resultat);
										$nom = $ligne['nom'];
										$prenom = $ligne['prenom'];
										$id_individu = $enseignant->tagAttrs['id']; // sera mis en global dans insert_maj_cours() pour tre inscrit dans le rapport 
										
										// Il faut rcuprer l'id_enseignant_service de l'enseignant
										$id_enseignant_service = ""; // rinitalisation indispensable
										$sql = "SELECT id_enseignant_service FROM enseignants_services WHERE id_service='".quote_smart($id_service)."' AND id_individu='".quote_smart($enseignant->tagAttrs['id'])."'";
										$resultat = mysql_query($sql);
										if ($resultat && mysql_num_rows($resultat)>0)
										{
											$ligne = mysql_fetch_array($resultat);
											$id_enseignant_service = $ligne['id_enseignant_service'];
										}
	
										// Il faut rattacher maintenant 1 ou plusieurs cours pour cet enseignant  propos du service en cours
										if (isset($id_enseignant_service) && $id_enseignant_service != "")
										{
											if (is_array($enseignant->cours_rattaches[0]->cours))
											{
												foreach($enseignant->cours_rattaches[0]->cours as $cours)
												{
													insert_maj_cours($id_enseignant_service,$cours,$service,"le groupe",$value->tagAttrs['code']);	
												}
											}
											else
											{
												$rapport .= "<font color='red'>Il n'y a pas de cours rattach  l'enseignant <strong><i>$nom ".ucfirst(strtolower($prenom))."</i></strong> indiqu pour le service n ".$id_service." sur la structure ".$value->tagAttrs['code'].", matire ".$service->tagAttrs['code_matiere'].", modalit ".$service->tagAttrs['code_mod_cours']." dans le fichier d'import !</font><br />";	
											}
										}
	
									}
								}
								else
								{
									$rapport .= "<font color='red'>Il n'y a pas d'enseignant indiqu pour le service sur le groupe ".$value->tagAttrs['code'].", matire ".$libelle_matiere.", modalit ".$service->tagAttrs['code_mod_cours']." dans le fichier d'import !</font><br />";
								}
							}
							else 
							{
								$rapport .= "<font color='red'>Aucun service dans la base IEW ne correspond au service pour la matiere <b>$libelle_matiere</b> concernant le groupe <b>".$value->tagAttrs['code']."</b>&nbsp;: il est fort probable que ce groupe n'a pas de correspondance dans STS<br />
								Vrifiez que les noms de TOUS les groupes dans votre logiciel d'EDT correspondent bien aux noms de ces groupes <b><u>dans STS et dans SIECLE</u></b>&nbsp;!<br />
								Les cours de ce groupe ne peuvent pas tre intgrs dans la base de donnes (ils ne seront donc pas visibles dans les emplois du temps dans IEW)</font><br />";
							}
						}
						$rapport .="</p>";
					}
					else
					{
						$rapport .= "<font color='red'>Il n'y a pas de Service indiqu pour le groupe <strong>".$value->tagAttrs['code']."</strong> dans le fichier d'import !</font><br />";
					}	
				}
			}
			else
			{
				$rapport .= "<font color='red'>Il n'y a pas de Service indiqu pour les groupes dans le fichier d'import !</font><br />";
			}

			$rapport .= "<h3>Traitement des emplois du temps des professeurs remplaants</h3>
			<p>";
		
			$sql = "SELECT * FROM remplacants";
			$resultat = mysql_query($sql);
			if ($resultat && mysql_num_rows($resultat) > 0)
			{
				$err_cp_serv = false;
				$err_cp_cours = false;
				while ($ligne = mysql_fetch_array($resultat))
				{
					$sql1 = "SELECT nom, prenom FROM personnel WHERE id_individu='".$ligne['id_remplacant']."'";
					$resultat1 = mysql_query($sql1);
					$ligne1 = mysql_fetch_array($resultat1);
					$rapport .= $ligne1['prenom']." ".$ligne1['nom']." remplace ";
					$sql2 = "SELECT nom, prenom FROM personnel WHERE id_individu='".$ligne['id_titulaire']."'";
					$resultat2 = mysql_query($sql2);
					$ligne2 = mysql_fetch_array($resultat2);
					$rapport .= $ligne2['prenom']." ".$ligne2['nom']."<br />Recopie des services et de l'emploi du temps du titulaire...";
					// Cela a dj t fait + haut lors de l'import de STS (car l'import de EDT n'est pas obligatoire, donc il ne fallait pas attendre d'tre ici pour copier les services)
					// Mais il faut recommencer car on a besoin de l'id_enseignant_service pour la recopie de l'edt
					// donc on efface d'abord les services du remplaants
					$sql_del = "DELETE FROM enseignants_services WHERE id_individu='".$ligne['id_remplacant']."'";
					mysql_query($sql_del);
					// on va recopier le service du titulaire dans le service du remplaant = re-cration des services du remplaant
					$sql3 = "SELECT * FROM enseignants_services WHERE id_individu='".$ligne['id_titulaire']."'";
					$resultat3 = mysql_query($sql3);
					while ($ligne3 = mysql_fetch_array($resultat3)) // pour chaque service du titulaire
					{
						$id_enseignant_service_titulaire = $ligne3['id_enseignant_service']; // on va s'en servir pour identifier le service  recopier dans l'EDT
						// recopie du service du titulaire vers un nouveau service du remplaant
						$sql4 = "INSERT INTO enseignants_services VALUES(NULL,'".$ligne3['id_service']."','".$ligne3['type']."','".$ligne['id_remplacant']."','".$ligne3['heures_agent']."','".$ligne3['taux_ponderation']."')";
						if (!mysql_query($sql4))
						{
							$rapport .= "ERREUR :<br />$sql4<br />".mysql_errno()." : ".mysql_error()."<br />";
							$err_cp_serv = true;
						}
						$id_enseignant_service_remplacant = mysql_insert_id(); // on va s'en servir pour lier avec la table "cours" qui contiendra l'EDT du remplaant
						// On recherche les cours de l'EDT correspondant au service du titulaire en cours dans la boucle while
						$sql5 = "SELECT code_alternance,code_jour,heure_debut,duree,code_matiere,code_matiere_etab,code_salle FROM cours WHERE id_enseignant_service='".$id_enseignant_service_titulaire."'";
						$resultat5 = mysql_query($sql5);
						if ($resultat5 && mysql_num_rows($resultat5) > O)
						{
							while ($ligne5 = mysql_fetch_array($resultat5)) // Pour chaque cours trouv
							{
								// recopie du cours du titulaire vers un nouveau cours du remplaant (la seule valeur qui diffre entre les cours du titulaire et du remplaant est la colonne id_enseignant_service)
								$sql6 = "INSERT INTO cours VALUES(NULL,'$id_enseignant_service_remplacant','".$ligne5['code_alternance']."','".$ligne5['code_jour']."','".$ligne5['heure_debut']."','".$ligne5['duree']."','".$ligne5['code_matiere']."','".$ligne5['code_matiere_etab']."','".$ligne5['code_salle']."')";
								if (!mysql_query($sql6))
								{
									$rapport .= "ERREUR :<br />$sql6<br />".mysql_errno()." : ".mysql_error()."<br />";
									$err_cp_cours = true;
								}
							}
						}
						else 
						{
							$rapport .= "ERREUR :<br />$sql5<br />Pas de cours trouvs !<br />";
							$err_cp_cours = true;
						}
					}
					if (!$err_cp_serv && !$err_cp_cours)
						$rapport .= "OK<br />";
				}
				
			}
			else
			{
				$rapport .= "<font color='blue'>Il n'y a pas de professeur remplac dans l'tablissement.</font>";	
			}
			$rapport .="</p>";	
			
		}
		
		 		// Indicateur de la date de dernire mise  jour

 		$sql = "DELETE fROM horodatages_imports_base"; // efface l'enregistrement prcdent
 		mysql_query($sql);
 		$sql = "INSERT INTO horodatages_imports_base VALUES(CURRENT_DATE,'$date_maj_communs','$date_maj_nomenclature','$date_maj_structures')"; // crit la date de mise  jour
 		mysql_query($sql);
  		
 		// Voici un rapport rsum des oprations
 		$duree_cours = $duree_cours/100; // car les heures de cours ajoutes sont au format hhmm
 		/* Il faudra revoir le calcul de la dure totale des cours en tenant compte des cours de quinzaine 
 		 * puis rajouter dans le rapport la ligne suivante :
 		 * - <strong>$duree_cours</strong> heures de cours (dont des heures de quinzaine)<br />
 		 * */
 		
		$ok_message = "Mise  jour de la base termine avec succs !<br />
		<table border='0'>
			<tr>
				<td align='left'>
					<font color='black'>
					<ul>
					<li><strong>$compteur_insert</strong> nouveau(x) membre(s) du personnel (enseignant ou administratif)</li>
					<li><strong>$compteur_new_comptes</strong> nouveau(x) compte(s) IntraEduWeb</li>
					<li><strong>$compteur_maj</strong> fiche(s) de membre du personnel (enseignant ou administratif) mise(s)  jour</li>
					<li><strong>$compteur_suppr</strong> membres du personnel (enseignant ou administratif) supprim(s)</li>
					<li><strong>$compteur_non_retrouves</strong> membres du personnel (enseignant ou administratif) non retrouvs</li>
					<li><strong>$compteur_insert_divisions</strong> nouvelle(s) division(s)</li>
					<li><strong>$compteur_insert_groupes</strong> nouveau(x) groupe(s)</li>
					<li><strong>$compteur_insert_pp</strong> nouveaux professeurs principaux</li>
					<li><strong>$balises_cours</strong> nouveaux cours</li>
					</ul>
					</font>";
		$ok_message .= "</td></tr></table><br />";
  
		// On affiche si besoin un rapport d'erreur
 		if ($erreur!="")
  			$ok_message .= "<br />***** Les erreurs suivantes ont t dtectes *****<br /><br />$erreur";
		
		// Le rapport complet de l'opration est inscrit dans un fichier qui pourra servir au dboguage
		// mais on va supprimer les rapports les + anciens (on va conserver les 2 derniers + le rapport en cours)
		$dh = opendir($GLOBALS['stock_baselev']."importation/");
  		$rapports_importation = array(); // va contenir la liste des couples nom_du_rapport/date de modif
   		while ($file = readdir($dh))
   		{
   			if($file != '.' && $file != '..' && substr($file,0,12) == "importation_")
       		{
           		$rapports_importation[] = $file; // le nom de fichier est stock
       		}
   		}
 		closedir($dh);
 		sort($rapports_importation); // tri selon la date de cration (contenue dans le nom de fichier) : les plus anciens seront en premier
 		$nb_rapports = count($rapports_importation);
 		$nb_delete = 0;
 		$rapport_purge = "";
 		if ($nb_rapports>=3)
 		{
 			$nb_delete = $nb_rapports - 2; // nombre de rapports  supprimer
 		}
 		$rapport_purge .= "<p>Il y a $nb_delete rapport(s)  supprimer (on conserve seulement les 3 derniers rapports).</p>";
 		if ($nb_delete !=0)
 		{
 			for ($i=0;$i<$nb_delete;$i++)
 			{
 				if (unlink($GLOBALS['stock_baselev']."importation/".$rapports_importation[$i]))
 					$rapport_purge .= "<p>Effacement du rapport : ".$GLOBALS['stock_baselev']."importation/".$rapports_importation[$i]."</p>";
 				else 
 					$rapport_purge .= "<p>Le rapport ".$GLOBALS['stock_baselev']."importation/".$rapports_importation[$i]." n'a pas pu tre supprim. Vous devriez excuter cette suppression manuellement.</p>";
	 		}	
 		}
 		
		// On prpare le nouveau rapport
 		$affichage_horodatage_jour = format_date_long("fr",date("j/m/Y"));
		$affichage_horodatage_heure = "  ".date("H")." heures ".date("i")." minutes ".date("s")." secondes";
  		$horodatage_fichier=date("_Ymd_His");
		$name_file_report = "importation".$horodatage_fichier.".html";
  		$fichier_rapport=fopen($GLOBALS['stock_baselev']."importation/".$name_file_report,"w");
		$code_a_ecrire = "<?xml version='1.0' encoding='iso-8859-1'?>
		<!DOCTYPE html PUBLIC '-//W3C//DTD XHTML 1.0 Transitional//EN' 'http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd'>
		<html xmlns='http://www.w3.org/1999/xhtml' lang='fr-FR' xml:lang='fr-FR'>
  		<head>
    	<title>IntraEduWeb, Espace Numrique de Travail du ".$GLOBALS['nom_etablissement'].", $titre_page</title>
    	<meta http-equiv='Content-Type' content='text/html; charset=iso-8859-1' />
    	<meta name='author'    content='Sylvain GODM' />
    	<meta name='copyright' content='2004-".date("Y").", Sylvain GODM. All Rights Reserved.' />
    	<link rel='stylesheet' type='text/css' href='".$GLOBALS['racine'].$GLOBALS['repertoire_theme'].$GLOBALS['jeu_couleurs']['stylesheet']."' />
    	</head>
    	<body><p>".$affichage_horodatage_jour.$affichage_horodatage_heure."</p>".$rapport."
    	<h2>Rsum (pour l'importation des professeurs)</h2>".$ok_message."
    	<h2>Purge des rapports prcdents</h2>".$rapport_purge."
    	</body>
		</html>";
		fwrite($fichier_rapport, $code_a_ecrire);
		fclose($fichier_rapport);
		
		// lien vers le rapport complet dans le rapport rsum
		$link_rapport = "<br /><p><a href='".$GLOBALS['racine']."prive/download_doc.php?file=".$name_file_report."&amp;import=yes'>Tlcharger le rapport dtaill de l'importation</a></p>";
		 		
		affiche_ok($ok_message.$link_rapport);
  	
  		efface_post(); // si on recharge la page vite un repost
  		
  		// On efface du serveur les fichiers d'import qui ont t tlchargs
  		foreach($tab_delfile as $value)
  		{
  			if (file_exists($GLOBALS['stock_baselev']."importation/".$value))
			{
				unlink($GLOBALS['stock_baselev']."importation/".$value);
			}
  		}
  		
  		// On propose de supprimer les membres du personnel (enseignant et administratifs) non retrouvs
  		if (count($liste_profs_non_retrouves) > 0)
  		{
  			$code_formulaire = "
			<div style='text-align: justify;'>
			<p>Il y a <b>".count($liste_profs_non_retrouves)."</b> personnes non retrouves dans le fichier d'import.</p>
			<p>Il peut s'agir de <abbr title='Titulaires sur zone de remplacement'>TZR</abbr> dont les comptes IEW ont t crs, mais qui ne sont pas dans le fichier en provenance de l'application <abbr title='Structures et Services'>STS</abbr>.
			<br />Ces personnes sont susceptibles d'effectuer des remplacements effectifs en cours d'anne. Si c'est le cas, il ne faut pas les supprimer.</p>
			<p>Dans la liste ci-dessous, cochez la (ou les) personne(s)  supprimer de la liste du personnel (le compte IEW correspondant sera supprim)&nbsp;:</p>";
			
  			if (count($liste_profs_non_retrouves) > 1)
  				$code_formulaire .= "<ul>";
  			$i = 0;
  			foreach ($liste_profs_non_retrouves as $value) // on donne la liste des nouveaux personnels
    		{
    			$i++;
    			$frags = explode(",",$value); // $value est au format id_pers,id_individu,civilite,nom,prenom,libelle_long_discipline
	    		// On affiche les civilite,nom,prenom,libelle_long_discipline
    			$personne = "<b>".$frags[2]." ".$frags[3]." ".$frags[4]."</b> (".$frags[5].")";
    			if (count($liste_profs_non_retrouves) > 1)
    				$code_formulaire .= "<li>";
    			$code_formulaire .= "<input id='SupprProf$i' aria-labelledby='L_SupprProf$i' type='checkbox' name='suppr_prof$i' value='".$frags[0]."#".$frags[1]."#".$frags[2]."#".$frags[3]."#".$frags[4]."' title=\"Cochez la case pour supprimer la personne de la liste du personnel\" />
				<label id='L_SupprProf$i' for='SupprProf$i'>$personne</label>";
    			if (count($liste_profs_non_retrouves) > 1)
    				$code_formulaire .= "</li>";
    		}
  			if (count($liste_profs_non_retrouves) > 1)
  				$code_formulaire .= "</ul>";
    		$code_formulaire .= "
    		<input type='hidden' name='name_file_report' value=\"$name_file_report\" />
    		<input type='hidden' name='ok_message' value=\"$ok_message\" />
    		<input type='hidden' name='link_rapport' value=\"$link_rapport\" />
    		</div>";
    		echo "<center>";
    		squelette_formulaire_standard("90%","post","do_imports_adm.php?action=delprof","<h2 class='hidden'>Supprimer les personnes non retrouves ?</h2>Supprimer les personnes non retrouves ?",$code_formulaire,"Supprimer la slection","soumettre","Annuler","AnnulerForm","","","","","id='SupprProfNonRetrouvForm'");
    		echo "</center>";
  		}
?>