<?php
/**
 * c_do_imports_elev.php
 *
 * Ralise l'import des donnes lves et responsables dans la base de donnes
 *  partir de fichiers XML : ElevesAvecAdresses.xml et ResponsablesAvecAdresses.xml
 * Ces fichiers XML sont uplods par un autre script (upload_imports.php)
 * 
 * Affiche un rapport rsum de l'opration et enregistre un rapport dtaill
 * consultable en ligne par un lien affich dans le rapport rsum
 * 
 * Tables mysql mises  jour : 
 * - adresses_eleves
 * - adresses_eleves_maj
 * - adresses_responsables
 * - adresses_responsables_maj
 * - eleves
 * - eleves_maj
 * - horodatages_imports_eleves
 * - login
 * - majbddelev  (garde la date de la dernire mise  jour de la base active)
 * - options
 * - options_maj
 * - responsables
 * - responsables_eleves
 * - responsables_eleves_maj
 * - responsables_maj
 * - structures_eleves
 * - structures_eleves_maj
 * 
 * Pour tester plusieurs fois ce script en revenant  l'import initial,
 * on peut vider toutes les tables prcdentes
 * A L'EXECPTION DE LA TABLE LOGIN dans laquelle on ne doit effacer que les comptes lves ou parents !!
 * 
 * A noter de nombreuses tables existent en 2 exemplaires (ex : options et options_maj) car cela permet par comparaison croise
 * de connatre les donnes  insrer dans la base de donnes et celles  supprimer, les donnes du fichier d'import faisant foi
 * 
 * Les tables en version _maj contiennent les donnes du fichier d'import XML pars, donc les donnes  jour
 * 
 * Les variables sont quote_smartes quand leur contenu provient d'une source non sre (fichier tlcharg ou donne saisie)
 * si elles sont utilises dans des requtes MySQL. Mme si la source est sre (provenant de la bdd), les donnes textuelles
 * sont systmatiquement quote_smartes pour viter les problmes d'apostrophes
 * 
 * POUR FAIRE DU DEBOGAGE, en cas de problme, avec les fonctions de recherche/remplacement d'un diteur
 * de script, on peut remplacer la chane '//DEBUGG echo' par la chane 'echo', ce qui donnera un maximum
 * d'information sur l'xcution pas  pas de ce script complexe. 
 * Il faudra faire l'inverse (MAIS PAS DANS CET ENTETE DE FICHIER !)ensuite pour
 * supprimer les sorties cran devenues inutile  la fin du dbogage.
 * 
 * Ce fichier fait partie du projet IntraEduWeb (IEW)
 * 
 * @package		IEW
 * @author			Sylvain GODM <sylvain.godme@gmail.com>
 * @version		$LastChangedRevision$, $LastChangedDate$
 * @copyright		2004-2012 Sylvain GODM
 * @link			http://iew.free.fr
 * @license		GPL License version 3 (http://www.gnu.org/licenses/gpl.html)
 * @filesource
 * 
 */
 
if (!defined('IEW_DIR')) {
 	/**
 	 * Constante contenant le chemin complet du rpertoire d'installation IEW
 	 */	
	define('IEW_DIR',realpath(dirname(__FILE__).'/../../../').'/');
}

/**
 * On inclut la librairie complte des fonctions et les fichiers de config, et on dmarre la session PHP
 */
require_once(IEW_DIR."librairie_fonctions.php"); 

// On va avoir besoin de la cl de cryptage pour certaines infos comme les adresses et le n de tl
// qui ne seront pas stocks en clair
// il faut un include car le require, require_once ou include_once ne fonctionnent pas
// car il s'agit de mettre  disposition quelques variables initialises dans ce script
include(CONF_DIR."k.php");


function efface_post()
{
	/**
	 *  On efface les donnes du post et de $_SESSION['post_imprimable'] pour empcher en cas de rechargement de page une nouvelle excution 
	 */
 	unset($_POST['soumettre']);
 	unset($_SESSION['post_imprimable']['soumettre']);
}

function supprime_donnees_eleve($id_eleve,$eleve_id, $nom,$prenom,$adresse_id,$eleve_sans_classe = false)
{
	global $compteur_suppr,$rapport;
	$sql = "DELETE FROM eleves WHERE id_eleve='$id_eleve'";
    if (mysql_query($sql))
    {
    	if ($eleve_sans_classe) // cas d'un lve prsent dans le fichier xml mais non intgr dans une classe : on le supprime
    	{
    		// ne sera pas comptabilis par le compteur de suppression
    		$rapport .= "L'lve <strong>$nom $prenom</strong> (eleve_id : $eleve_id) est <u>effac</u> de la base <b>car il n'est dans aucune classe</b> (il doit tre sorti de l'talbissement, mais pour une raison inconnu il se trouve dans le fichier XML import, sans qu'une date de sortie ne soit renseigne<br />
    		Il a t intgr  la table eleves et la table login dans un premier temps, mais est maintenant supprim.<br/>";
        	$rapport .= "Nb total d'lves supprims de la table eleves : $compteur_suppr (inchang)<br />";    
    	}
    	else // l'lve tait dans une classe
    	{
			$rapport .= "L'lve <strong>$nom $prenom</strong> (eleve_id : $eleve_id) est <u>effac</u> de la base<br />";
    		$compteur_suppr++; // on incrmente le compteur de suppression
        	$rapport .= "Nb total d'lves supprims de la table eleves : $compteur_suppr<br />";    		
    	}
		// On supprime alors la photo d'identit si elle existe
        $fichier_photo = $GLOBALS['stock_baselev']."fotoelev/".$id_eleve.".jpg";
        if (file_exists($fichier_photo))
        {
          	if(!@unlink($fichier_photo))
            {
              	$error_message = array("
               	<div align='justify'>
               	La photo d'identit <strong>$id_eleve.jpg</strong> n'a pas pu tre supprime. Vrifiez que les droits sur les fichiers sont corrects<br />
               	ou supprimez manuellement le fichier $id_eleve.jpg dans le rpertoire ".$GLOBALS['stock_baselev']."fotoelev. Pour ce faire, prvenez votre <a href='mailto:".email_encode($GLOBALS['admin_email'])."'>administrateur IntraEduWeb</a> qui se chargera de la suppression.
               	</div>
               	","");
               	affiche_erreurs($error_message);
            }
        }
        // On supprime les entres correspondantes dans certaines tables o cet lve est rfrenc
        // sauf celles o il faut en garder la trace, comme les absences par exemple
        $tables_concernees_par_suppr = array(
        "options",
        "structures_eleves",
        "responsables_eleves",
        "groupes_eleves",
        "autorisations_1");
        foreach($tables_concernees_par_suppr as $table)
        {
        	$sql = "DELETE FROM $table WHERE eleve_id='$eleve_id'";
        	mysql_query($sql);
        	if (mysql_affected_rows() >0)
    		{
    			$rapport .= "<b>".mysql_affected_rows()."</b> entres ont t supprimes pour cet lve dans la table <b>$table</b><br />";	
    		}		
        }
        if (!is_null($adresse_id))
        {
        	$sql = "DELETE FROM adresses_eleves WHERE adresse_id='$adresse_id'";
        	mysql_query($sql);
        	if (mysql_affected_rows()>0)
          	{
        		$rapport .= "L'adresse de l'lve dans la table <b>adresses_eleves</b> a t supprime.<br />";	
            }
        }          
     }
     // on recherche les informations sur son compte utilisateur
     $sql="SELECT nomlogin FROM login WHERE id_pers='$id_eleve'";
     $resultat_tris=mysql_query($sql);
     if ($resultat_tris && mysql_num_rows($resultat_tris)!=0) // s'il existe
     {
     	$row=mysql_fetch_row($resultat_tris);
     	$login=$row[0];
     	if ($GLOBALS['auth_method'] == 'native') // on enregistre son nom dans un fichier listant les comptes lves  supprimer
     	{
     		$enregistrement=$id_eleve.",".$login.",".$prenom.",".$nom."\n";
     		fwrite($fichier_suppr,$enregistrement); 
     	}
        // on supprime l'lve de la table login il n'a plus de compte IntraEduWeb
     	$sql = "DELETE FROM login WHERE nomlogin='$login' AND id_pers='$id_eleve'";
        mysql_query($sql);
        // on supprime les donnees obsoletes sans lien avec le compte supprim
        suppr_compte_tables_nettoyage($id_pers);
        if (mysql_affected_rows() >0)
    	{
    		$rapport .= "Le compte de cet lve a t supprim dans la table login.<br />";	
    	}	
     }
}

global $rapport;

/** 
 * Rcupration des donnes de session utiles */
$tab_delfile = $_SESSION['tab_delfile'];

// on tablit une fois pour toutes la connexion avec la base de donnes
	connexion_mysql();
	select_database();
	
	// On inclut le code du parser XML (XMLParser) : http://www.criticaldevelopment.net/xml/doc.php
	// Ceci fonctionne aussi bien en php4 qu'en php5 (simule les fonctions SimpleXML de php5 => Parsing d'un document XML vers un objet php)
	// Suivant la version de php, le code  inclure n'est pas le mme
	if (version_compare(phpversion(), "5.0.0", ">="))
    {
      // La version php installe est une version 5
      include(IEW_DIR."/lib/parser_php5.php");
    }
    else // La version PHP est une version 4
    {
      include(IEW_DIR."/lib/parser_php4.php");
    } 

    // Le temps d'excution peut tre long en raison du volume de donnes  traiter
    // on va donc augmenter le temps dfini par dfaut  30 secondes dans le php.ini
    ini_set ("max_execution_time","120"); // ne marche pas si le safe-mode est activ !!
    
   	$rapport .= "<h1>Rapport d'excution de la mise  jour de la base lves/responsables</h1>";
    $rapport .= "
    <p>Ce rapport permet suivre pas  pas l'excution de la mise  jour pour reprer des erreurs ventuelles.</p>
    <p><a href='#bas'>Voir au bas de la page pour un accs direct au rsum du rapport...</a></p>";

    // Lecture du fichier ElevesAvecAdresses.xml, extraction et formatage des donnes utiles vers la table eleves_maj
    $rapport_resume = "";
    $erreur = "";
    $rapport_resume .= "<h2>****** Traitement du fichier ElevesAvecAdresses.xml ******</h2>";
    
    // Rinitalisation du parser
	$fichier = $GLOBALS['stock_baselev']."importation/ElevesAvecAdresses.xml";
	//Get the XML document loaded into a variable
	$xml = file_get_contents($fichier);
	//Set up the parser object
	$parser = new XMLParser($xml);
	//Work the magic...
	$parser->Parse();
	
	$date_maj_eleves = $parser->document->parametres[0]->horodatage[0]->tagData;
	
	$erreur = ""; // contiendra ventuellement la chane concatne des erreurs rencontres
    $compteur_insert = 0; // contiendra le nombre d'enregistrements ajouts  la table lves (nouveaux lves)
    $compteur_suppr = 0; // contiendra le nombre d'enregistrements supprims  la table lves (lves sortant en cours d'anne scolaire)
    global $compteur_suppr; // utilis galement dans une fonction locale (donc mot cl global ncessaire)
    $compteur_maj = 0; // contiendra le nombre d'enregistrement mis  jour si une modification de l'un quelconque des champs  t faite dans SCONET
    $compteur_new_comptes = 0; // contiendra le nombre de nouveau comptes intraeduweb qui sont cr par la mise  jour de la base lves
	
	// Initialisation des fichiers contenant les comptes lves (uniquement utilis en authentification native)
	
	// On effectue une copie de sauvegarde pour les comptes lves (ce fichier est toujours cras lors d'une mise  jour)
    @copy($GLOBALS['stock_baselev']."comptes_eleves.txt",$GLOBALS['stock_baselev']."comptes_eleves.bak");
    
    // On ouvre les fichiers ncessaires aux mises  jour
    $fichier=fopen($GLOBALS['stock_baselev']."comptes_eleves.txt","a"); // pour l'instant, on ajoute les nouveaux
    
    // On effectue ventuellement un backup d'une mise  jour prcdente
    if (file_exists($GLOBALS['stock_baselev']."new_comptes_eleves.txt"))
    {
    	@copy($GLOBALS['stock_baselev']."new_comptes_eleves.txt",$GLOBALS['stock_baselev']."new_comptes_eleves.bak");
    }
    
    // Il peut maintenant tre cras
    $fichier_suivant=fopen($GLOBALS['stock_baselev']."new_comptes_eleves.txt","w"); // on crase ce fichier (il ne contiendra que les nouveaux comptes de la dernire mise  jour) 
    
	
	/// Traitement des donnes du bloc ELEVES ///
	
    $rapport .= "<br /><h2><u>*** Lecture des donnes du bloc ELEVES : intgration dans la table de MAJ ***</u></h2><br />";
    
    $compteur_eleves_importes = 0; // Compteur du nombre d'lves  importer
    
    $sql = "TRUNCATE TABLE eleves_maj";
    mysql_query($sql);
	
	foreach($parser->document->donnees[0]->eleves[0]->eleve as $value) // les lves  mettre dans la table
	{
		// Certaines balises XML ne sont pas obligatoires, elles peuvent donc donner lieu  des valeurs NULL dans la base de donnes
		// Elles subissent donc un traitement particulier pour un enregistrement correct dans la bdd
		
		$eleve_id = $value->tagAttrs['eleve_id'];
		
		if (!isset($value->tagAttrs['elenoet']))
			$elenoet = "NULL";
		else
			$elenoet = "'".quote_smart($value->tagAttrs['elenoet'])."'";
		
		if (!isset($value->date_sortie[0]->tagData)) // On ne traite que les lves non sortis de l'tablissement
		{
			/* Le problme est qu'il existe des cas o la date de sortie n'est pas renseigne (pas mis  jour automatiquement par les 
			 * applications de gestion) alors que l'lve n'est plus dans l'tablissement, DONC il faudra traiter un peu plus loin
			 * (voir la fin de la section /// Traitement des donnes du bloc STRUCTURES_ELEVES ///) la table eleves_maj pour retirer
			 *  les lves qui ne sont affects dans aucune division : c'est ainsi que l'on peut reprer ces cas */
			
			// Rcupration des donnes du fichier xml
			
			if (!isset($value->id_national[0]->tagData))
				$id_national = "NULL";
			else
		  		$id_national = "'".quote_smart($value->id_national[0]->tagData)."'";
		  		
			$nom = $value->nom[0]->tagData;
			$prenom = $value->prenom[0]->tagData;
			
			if (!isset($value->prenom2[0]->tagData))
				$prenom2 = "NULL";
			else
		  		$prenom2 = "'".quote_smart($value->prenom2[0]->tagData)."'";
			
			if (!isset($value->prenom3[0]->tagData))
				$prenom3 = "NULL";
			else
		  		$prenom3 = "'".quote_smart($value->prenom3[0]->tagData)."'";
			
			$date_naiss = $value->date_naiss[0]->tagData;
			
			if (!strstr($date_naiss,"-")) // Si pas dj au format MySQL
			{
				$date_naiss = convert_date_to_mysql($date_naiss); // convertie au format MySQL
			}
			
			if (!isset($value->code_sexe[0]->tagData))
				$code_sexe = "NULL";
			else
		  		$code_sexe = "'".quote_smart($value->code_sexe[0]->tagData)."'";
			
			$doublement = $value->doublement[0]->tagData;
			$code_regime = $value->code_regime[0]->tagData;
			
			if (!isset($value->date_entree[0]->tagData))
				$date_entree = "NULL";
			else
		  		$date_entree = "'".quote_smart($value->date_entree[0]->tagData)."'";

			if ($date_entree != "NULL" && !strstr($date_entree,"-")) // Si pas dj au format MySQL
			{
				$date_entree = "'".quote_smart(convert_date_to_mysql($date_entree))."'"; // convertie au format MySQL
			}

			if (!isset($value->date_modification[0]->tagData))
				$date_modification = "NULL";
			else
		  		$date_modification = "'".quote_smart($value->date_modification[0]->tagData)."'";
						
			if ($date_modification != "NULL" && !strstr($date_modification,"-")) // Si pas dj au format MySQL
			{
				$date_modification = "'".quote_smart(convert_date_to_mysql($date_modification))."'"; // convertie au format MySQL
			}
			
			// Les champs suivants sont vides pour des lves mineurs
			if (!isset($value->adresse_id[0]->tagData))
				$adresse_id = "NULL";
			else
		  		$adresse_id = "'".quote_smart($value->adresse_id[0]->tagData)."'";
			
			if (!isset($value->tel_professionnel[0]->tagData))
		  		$tel_professionnel = "NULL";
			else
			{
		  		$tel_professionnel = $value->tel_professionnel[0]->tagData;
				$tel_professionnel = "AES_ENCRYPT('$tel_professionnel','$crypt_key')";
			}
			
			if (!isset($value->tel_personnel[0]->tagData))
		  		$tel_personnel = "NULL";
			else
			{
		  		$tel_personnel = $value->tel_personnel[0]->tagData;
				$tel_personnel = "AES_ENCRYPT('$tel_personnel','$crypt_key')";
			}
			  
			if (!isset($value->tel_mobile[0]->tagData))
		  		$tel_mobile = "NULL";
			else
			{
		  		$tel_mobile = $value->tel_mobile[0]->tagData;
				$tel_mobile = "AES_ENCRYPT('$tel_mobile','$crypt_key')";
			}
			  
			if (!isset($value->accepte_sms[0]->tagData))
		  		$accepte_sms = "NULL";
			else
		  		$accepte_sms = "'".quote_smart($value->accepte_sms[0]->tagData)."'";
		  	
		  	if (!isset($value->code_mef[0]->tagData))
		  		$code_mef = "NULL";
			else
		  		$code_mef = "'".quote_smart($value->code_mef[0]->tagData)."'";
			
			// On insre l'lve dans la table de mise  jour, les coordonnes tlphoniques sont cryptes
			// Le dernier champ (classe) est mis  NULL temporairement car non connu  ce stade
			$sql = "INSERT INTO eleves_maj VALUES(NULL,'".quote_smart($eleve_id)."',$elenoet,$id_national,'".quote_smart($nom)."','".quote_smart($prenom)."',$prenom2,$prenom3,'".quote_smart($date_naiss)."',$code_sexe,'".quote_smart($doublement)."','".quote_smart($code_regime)."',$date_entree,$date_modification,$adresse_id,$tel_professionnel,$tel_personnel,$tel_mobile,$accepte_sms,$code_mef,NULL)";
			$rapport .= "$sql<br />";
			if (!mysql_query($sql))
			{
				$rapport .= "La Commande SQL suivante a chou :<br />$sql<br />".mysql_errno(). ": " . mysql_error(). "<br />";
			}
			else
			{	
	    		$rapport .= "L'lve $nom $prenom a t <font color='green'><strong>Intgr</strong></font> dans la table eleves_maj.<hr />";
	    		$compteur_eleves_importes++;
	    	}
		}
	}

	$rapport .= "<hr /><b>$compteur_eleves_importes</b> lves ont t imports vers la table de mise  jour.<hr />";
	
	$rapport .= "<br /><h2/><u>*** Mise  jour des fiches lves existantes et Recherche des nouveaux lves ***</u></h2><br />";

  	// Parcours des donnes de l'import : on cherche les donnes nouvelles
  	// Il faut d'abord dcrypter les donnes cryptes (c'est du binaire) sinon cela pose des problmes
	$sql = "SELECT * FROM eleves_maj";
    $resultat = mysql_query($sql);
    $k=0;
    while($enregistrement = mysql_fetch_array($resultat))
    { 
    	$k++;
    	// Les valeurs NULL posent des problmes pour les insert ou update alors il faut bidouiller...
    	$colonnes_null_possibles = array(
    	"elenoet",
    	"id_national",
    	"prenom2",
    	"prenom3",
    	"code_sexe",
    	"date_entree",
    	"date_modification",
    	"adresse_id",
    	"tel_professionnel",
    	"tel_personnel",
    	"tel_mobile",
    	"accepte_sms",
    	"code_mef");
    	foreach($colonnes_null_possibles as $colonne)
    	{
    		$$colonne = $enregistrement[$colonne];
    		if (is_null($$colonne))
			{	
				$$colonne = "NULL";
			}
			else
			{
				$$colonne = "'".quote_smart($enregistrement[$colonne])."'";
			}
    	}
    	$eleve_id = $enregistrement['eleve_id'];
    	$nom = $enregistrement['nom'];
		$prenom = $enregistrement['prenom'];
		$date_naiss = $enregistrement['date_naiss'];
		$doublement = $enregistrement['doublement'];
		$code_regime = $enregistrement['code_regime'];
		
		$rapport .= "<hr />Cas de l'lve n$k: <strong>$nom $prenom</strong> (eleve_id : $eleve_id, n nat: $id_national)<br />";$k++;
		
    	$sql = "SELECT * from eleves WHERE eleve_id='$eleve_id'"; // variable non quote_smartes car viennent de la bdd
      	$resultat_bis = mysql_query($sql);
      	if (mysql_num_rows($resultat_bis)>0) // Oui cet lve est dj dans la base
      	{
      		$rapport .= "Cet lve a t <strong>trouv dans la base !</strong><br />";
      		$id_eleve = mysql_result($resultat_bis, 0, "id_eleve"); // l'identifiant IntraEduweb est stock (permet la correspondance avec la table login (id_pers) 
        	// de mme que les anciens nom et prnom (ils peuvent tre mis  jour)
        	$ancien_nom = mysql_result($resultat_bis, 0, "nom");
        	$ancien_prenom = mysql_result($resultat_bis, 0, "prenom");
      		// On met  jour ventuellement les tables eleves et login
      		$sql = "UPDATE eleves set id_national=$id_national, nom='".quote_smart($nom)."', prenom='".quote_smart($prenom)."', prenom2=$prenom2, prenom3=$prenom3, date_naiss='$date_naiss', code_sexe=$code_sexe, doublement='$doublement', code_regime='$code_regime', date_entree=$date_entree, date_modification=$date_modification, adresse_id=$adresse_id, tel_professionnel=$tel_professionnel, tel_personnel=$tel_personnel, tel_mobile=$tel_mobile, accepte_sms=$accepte_sms, code_mef=$code_mef WHERE id_eleve=$id_eleve";
      		if (mysql_query($sql))
        	{
          		if (mysql_affected_rows()>0)  
          		{  
		            $rapport .= "La mise  jour (au cas o un changement serait fait) s'est acheve avec <font color='blue'>succs !</font><br />";
        		    $rapport .= $sql."<br />"."<u>Nombre de lignes affectes :</u> ".mysql_affected_rows()."<br />";
          		}
        	}
        	else
        	{  
		        $rapport .= "La mise  jour (au cas o un changement serait fait) a <font color='red'>chou !</font><br />".mysql_errno(). ": " .mysql_error()."<br />";
        	}
        	if (mysql_affected_rows()>0)
        	{
          		$compteur_maj += mysql_affected_rows(); // si l'enregistrement a t effectivement mis  jour (si une ou plusieurs nouvelles valeurs des champs diffrent des anciennes, on incrmente le compteur de mise  jour)
        	}
	        
        	$rapport .= "Nb total de fiches lves mises  jour : $compteur_maj<br />";
	        
        	// On s'assure que l'lve a un compte pour se connecter  IntraEduWeb
        	
        	$sql="SELECT nomlogin FROM login WHERE id_pers='$id_eleve'";
        	$rapport .= $sql."<br />";
        	$resultat_tris=mysql_query($sql);
        	if ($resultat_tris && mysql_num_rows($resultat_tris)==0) // s'il existe pas de compte pour cet lve, on en cre un
        	{
			   	$rapport .= "Cet lve <strong>n'a pas de compte</strong> IntraEduWeb, on tente de lui en crer un !<br />";
			   	$nom_cle_jointure = "eleve_id"; // Nom du champ de la table login jouant le rle de cl de jointure avec les exports XML des applications de gestion
        		$valeur_cle_jointure = $eleve_id;
        		$identifiant = ""; // pas encore connu
    	    	if ($id=cree_compte_iew($nom_cle_jointure,$valeur_cle_jointure,$identifiant,$nom,$prenom,"2",$fichier,$fichier_suivant)) // Si la cration du compte a russi
        	  	{
		    	   	$rapport .= "<strong>Cration</strong> du compte IntraEduWeb <strong>russie</strong> !<br />";
        		   	$compteur_new_comptes++; // on incrmente le compteur de nouveau comptes intraeduweb
				    $rapport .= "Nb total de nouveaux comptes lves IEW : $compteur_new_comptes<br />";
				    // Un identifiant utilisateur unique vient d'tre cr, on le rcupre
        		    // On le met comme identifiant de l'lve dans la base lve
            		$sql2 = "UPDATE eleves SET id_eleve='$id' WHERE  eleve_id='$eleve_id'";
            		mysql_query($sql2);
            		if (mysql_affected_rows()==-1) // Si l'criture n'a pas russi
            		{
				        $rapport .= "L'identifiant numrique de l'lve <strong>".stripslashes($prenom)." ".stripslashes( $nom)."</strong> de <strong>$classe</strong> n'a pas pu tre mis  jour dans la base de donnes. La correspondance entre les donnes du compte utilisateur et la table lves risque de ne plus tre correcte.<br />";
    		    		$erreur .= "L'identifiant numrique de l'lve <strong>".stripslashes($prenom)." ".stripslashes( $nom)."</strong> de <strong>".stripslashes($classe)."</strong> n'a pas pu tre mis  jour dans la base de donnes. La correspondance entre les donnes du compte utilisateur et la table lves risque de ne plus tre correcte.<br />";
        		    }
          		}
          		else // l'criture dans la table login n'a pas eu lieu
          		{
		        	$rapport .= "$sql<br />";
          			$rapport .= "Le <u>login</u> et le <u>mot de passe</u> de l'lve <strong>".stripslashes($prenom)." ".stripslashes( $nom)."</strong> n'ont pas pu tre inscrits dans la base de donnes.<br />";
            		$erreur .= "Le <u>login</u> et le <u>mot de passe</u> de l'lve <strong>".stripslashes($prenom)." ".stripslashes( $nom)."</strong> n'ont pas pu tre inscrits dans la base de donnes (ils existent peut-tre dj).<br />";
          		}
			}
        	else // il existe un compte pour cet lve, mais si le nom et/ou le prnom a chang, il faut mettre  jour l'enregistrement du compte (mais le login ne change pas -ni le mot de passe- et restera unique)
        	{
		    	$rapport .= "cet lve a <strong>dj un compte IntraEduWeb</strong> : ses identifiant et mot de passe restent inchangs.<br />";
    			if ($ancien_nom!=stripslashes($nom) || $ancien_prenom!=stripslashes($prenom)) // stripslashes car $nom et $prenom sont quote_smartes
        		{
            		$nom_table_login = $nom; 
            		$prenom_table_login = $prenom;
            		$sql = "UPDATE login SET nom='".quote_smart($nom_table_login)."', prenom='".quote_smart($prenom_table_login)."' WHERE id_pers='$id_eleve'";
	        		if (mysql_query($sql))
    	    		{
			            $rapport .= "Son nom et/ou son prnom a <strong>chang</strong> (mise  jour russie de la table login)<br />";
    		        }
	    	   	    // On met  jour les fichiers textes contenant les comptes lves
    	        	// Mais il faut rcuprer le login existant avant
	            	$ligne_tris = mysql_fetch_array($resultat_tris);
		       		$login = $ligne_tris['nomlogin'];
	    	       	$rapport .= "mise  jour des fichiers textes contenant les comptes lves<br />";
	            	modif_fichier_texte_codes_acces($GLOBALS['stock_baselev']."comptes_eleves.txt","",$id_eleve,$ancien_prenom,$ancien_nom,$prenom,$nom,$login);
	    	   		// et dans le fichiers de mots de passe new_comptes_eleves.txt (si ncessaire)
		           	modif_fichier_texte_codes_acces($GLOBALS['stock_baselev']."new_comptes_eleves.txt","",$id_eleve,$ancien_prenom,$ancien_nom,$prenom,$nom,$login); 
    			}
        	}
        	 
      	}
    	else // L'lve est nouveau
		{
			$rapport .= "C'est un <strong>Nouvel lve !</strong><br />";
			// On lui cr un compte IEW
			$nom_cle_jointure = "eleve_id"; // Nom du champ de la table login jouant le rle de cl de jointure avec les exports XML des applications de gestion
        	$valeur_cle_jointure = $eleve_id;
        	$identifiant = ""; // pas encore connu
    	   	if ($id=cree_compte_iew($nom_cle_jointure,$valeur_cle_jointure,$identifiant,$nom,$prenom,"2",$fichier,$fichier_suivant)) // Si la cration du compte a russi
          	{
		   		$rapport .= "<strong>Cration</strong> du compte IntraEduWeb <strong>russie</strong> !<br />";
        		$compteur_new_comptes++; // on incrmente le compteur de nouveau comptes intraeduweb
			    $rapport .= "Nb total de nouveaux comptes lves IEW : $compteur_new_comptes<br />";
          		// 	On insre dans la table eleves
				$sql = "INSERT INTO eleves VALUES('$id','$eleve_id',$elenoet,$id_national,'".quote_smart($nom)."','".quote_smart($prenom)."',$prenom2,$prenom3,'$date_naiss',$code_sexe,'$doublement','$code_regime',$date_entree,$date_modification,$adresse_id,$tel_professionnel,$tel_personnel,$tel_mobile,$accepte_sms,$code_mef,NULL)";
				$rapport .= "$sql<br />";
				mysql_query($sql);
          		if (mysql_affected_rows()>0) // Si l'criture dans la table lve a russi, on incrmente un compteur
          		{
		            $rapport .= "Ecriture <font color=blue><strong>russie</strong></font> dans la table eleves!<br />";
                    $compteur_insert++;
          			$rapport .= "Nb d'lves insrs dans la base : $compteur_insert<br />";
          		}
          		else // Si l'criture n'a pas russi
          		{
                	$rapport .= "<strong><font color=orange>Echec d'criture</font></strong> dans la table eleves !<br />$sql<br /><br />Erreur MySQL : ".mysql_errno(). ": " .mysql_error()."<br />";
             		$erreur .= "L'lve <strong>".stripslashes($prenom)." ".stripslashes($nom)."</strong> n'a pas t enregistr dans la base de donnes.<br />";
          		}
          	}
        	else // l'criture dans la table login n'a pas eu lieu
        	{
		      	$rapport .= "<strong><font color=orange>Echec d'criture</font></strong> dans la table login!<br />".mysql_errno(). ": " .mysql_error()."<br />";
        		$rapport .= "Le <u>login</u> et le <u>mot de passe</u> de l'lve <strong>".stripslashes($prenom)." ".stripslashes( $nom)."</strong> n'ont pas pu tre inscrits dans la base de donnes.<br />";
           		$erreur .= "Le <u>login</u> et le <u>mot de passe</u> de l'lve <strong>".stripslashes($prenom)." ".stripslashes( $nom)."</strong> n'ont pas pu tre inscrits dans la base de donnes (ils existent peut-tre dj).<br />";
        	}
		}
    }
    
    // Recherche des lments  supprimer (lves qu'on ne retrouve pas dans l'import, c'est--dire dans la table eleves_maj)
    // Cette fois-ci on part de la table active eleves et on cherche une correspondance avec la table de mise  jour 
	
    $rapport .= "<br /><h2/><u>*** Recherche des lves  supprimer (lves non retrouvs dans l'import) ***</u></h2><br />";
    
    // Tout d'abord, si la mthode d'authentification est native, il faut grer les fichiers contenant les comptes lves 
	if ($GLOBALS['auth_method'] == 'native')
	{
    	$fichier_lu=@fopen($GLOBALS['stock_baselev']."comptes_eleves.txt","r"); // ouverture en lecture seule
 		if ($fichier_lu)
 		{
  			$compteur=0;
  			while (!feof($fichier_lu)) // on commence la lecture jusqu' la fin du fichier
  			{
    			$compteur++; // contient le nombre de lignes du fichier lu
    			$champs_lus[$compteur]=fgetcsv($fichier_lu,100,","); // Lit une ligne et envoie dans un tableau les champs spars par des virgules
  			}
 		}
 		fclose($fichier_lu);
 		$comptes_eleves=array(); // Tableau destin  recevoir les comptes lves  recopier dans comptes_eleves.txt
		// Traitement du fichier contenant les comptes  supprimer (pour les lves sortants (au cours de l'anne scolaire))
		// On effectue ventuellement un backup d'une mise  jour prcdente pour les lves
    	if (file_exists($GLOBALS['stock_baselev']."suppr_comptes_eleves.txt"))
    	{
	    	// On cherche dans le dossier le dernier backup
    		$liste_fichiers_backup = array();
      		if ($handle = opendir($GLOBALS['stock_baselev'])) 
      		{
        		while (false !== ($file = readdir($handle)))
        		{
          			if ($file != "." && $file != ".." && strstr($file,"suppr_comptes_eleves.bak"))
          			{
            			$liste_fichiers_backup[] = $file; // On ajoute au tableau
          			}
        		}
        		closedir($handle);
      		}
		    // on incrmente le numro de mise  jour
			$num_maj = count($liste_fichiers_backup)+1;
	    	// On fait un backup du ficher nouveau comptes existant
    		@copy($GLOBALS['stock_baselev']."suppr_comptes_eleves.txt",$GLOBALS['stock_baselev']."suppr_comptes_eleves.bak".$num_maj);
    	}  
	    // Il peut maintenant tre cras
    	$fichier_suppr=@fopen($GLOBALS['stock_baselev']."suppr_comptes_eleves.txt","w"); // on ouvre en criture un fichier qui recevra les comptes lves  supprimer
	}

	// C'est parti pour rechercher les lves sortants (au cours de l'anne scolaire)
 	$sql = "SELECT * FROM eleves";
 	$resultat = mysql_query($sql);
 	while($enregistrement = mysql_fetch_array($resultat))
 	{
    	$nom = $enregistrement['nom']; // les critres de recherche...(nom+prenom)
    	$prenom = $enregistrement['prenom'];
    	$id_eleve = $enregistrement['id_eleve']; // on stocke l'id_eleve en cours
    	$eleve_id = $enregistrement['eleve_id']; // et celui-l (On en a besoin pour supprimer si ncessaire l'entre dans la table responsables_eleves entre autres...)
    	$adresse_id = $enregistrement['adresse_id']; // pour supprimer si ncessaire l'entre dans la table adresses_eleves
    	$sql = "SELECT * FROM eleves_maj WHERE eleve_id='$eleve_id'"; 
    	$resultat_bis = mysql_query($sql);
    	if (mysql_num_rows($resultat_bis)>0)
    	{ 
    		// Il y a un enregistrement correspondant dans les donnes de mise  jour
		    // la correspondance existe, l'lve doit tre conserv : on ne fait rien sur les tables
		    if ($GLOBALS['auth_method'] == 'native')
		    {
	    		// mais on recopie le compte (si la mthode d'authentification est native
    	  		$sql="SELECT nomlogin,nom,prenom FROM login WHERE id_pers='$id_eleve'"; // on rcupre son nom de login
      			$resultat_tris=mysql_query($sql);
      			if ($resultat_tris && mysql_num_rows($resultat_tris)!=0) // s'il existe, alors il a un compte dans comptes_eleves.txt
      			{
        			$row=mysql_fetch_row($resultat_tris);
        			$login=$row[0];
        			$prenom=$row[1];
        			$nom=$row[2];
        			foreach ($champs_lus as $value) // on recherche les infos du compte lves
        			{
        				if ($value[1]==$login) // Si correspondance trouve, on empile pour recopier
          				{
            				$enregistrement=$value[0].",".$login.",".$prenom.",".$nom.",".$value[4].",".$value[5];
            				array_push($comptes_eleves,$enregistrement);
            				break; // on sort de foreach
          				}
        			}
      			}
    		}
    	}
    	else // Si la correspondance n'existe pas, c'est que l'lve est sorti de l'tablissement : il faut le supprimer de la base
    	{
      		supprime_donnees_eleve($id_eleve,$eleve_id, $nom,$prenom,$adresse_id);
    	}
	} // while => tous les lves ont t traits

	if ($GLOBALS['auth_method'] == 'native')
    {
    	// On recopie dans le fichier comptes_eleves.txt les comptes lves  jour
 		// Bien que le fichier soit ouvert en mode ajout de donnes plus haut, ceci ne permet pas de supprimer les lves sortants (au cours de l'anne scolaire)
		// il faut donc passer par l'tape suivante pour mettre  jour le fichier des comptes lves

 		if (count($comptes_eleves)!=0)
 		{
  			$fichier=fopen($GLOBALS['stock_baselev']."comptes_eleves.txt","w"); // on crase le contenu existant
  			for ($i=0;$i<=(count($comptes_eleves)-1);$i++)
  			{
    			$enregistrement=$comptes_eleves[$i]."\n";
    			fwrite($fichier,$enregistrement);
  			}
  			fclose($fichier);
 		}
    	fclose($fichier_suppr);
    }
    
    fclose($fichier);
 	fclose($fichier_suivant);

	/// Traitement des donnes du bloc OPTIONS ///
	
    $rapport .= "<br /><h2/><u>*** Lecture des donnes du bloc OPTIONS : Intgration dans la table de MAJ ***</u></h2><br />";
    
    $compteur_options = 0;
    $compteur_options_suppr = 0;
    $compteur_insert_options = 0;
    
    $sql = "TRUNCATE TABLE options_maj";
    mysql_query($sql);
    
    foreach($parser->document->donnees[0]->options[0]->option as $value) 
	{
		// Certaines balises XML ou attributs ne sont pas obligatoires, elles peuvent donc donner lieu  des valeurs NULL dans la base de donnes
		// Elles subissent donc un traitement particulier pour un enregistrement correct dans la bdd
		
		$eleve_id = $value->tagAttrs['eleve_id'];
		
		if (!isset($value->tagAttrs['elenoet']))
			$elenoet = "NULL";
		else
			$elenoet = "'".quote_smart($value->tagAttrs['elenoet'])."'";
		
		foreach($value->options_eleve as $option)
		{
			$num_option = $option->num_option[0]->tagData;
			$code_modalite_elect = $option->code_modalite_elect[0]->tagData;
			$code_matiere = $option->code_matiere[0]->tagData;
			// On remplit la table de maj
			$sql = "INSERT INTO options_maj VALUES('".quote_smart($eleve_id)."',$elenoet,'".quote_smart($num_option)."','".quote_smart($code_modalite_elect)."','".quote_smart($code_matiere)."')";
			mysql_query($sql);
			if (mysql_affected_rows() >0)
    		{
    			$compteur_options++;	
    		}			
		}
	}
	
	$rapport .= "Il y a <strong>$compteur_options</strong> enregistrements imports dans la table options_maj.<br />";
	
	$rapport .= "<br /><h2/><u>*** Insertion, mise  jour ou suppression des options des lves ***</u></h2><br />";
	
	// Parcours des donnes de l'import : on cherche les donnes nouvelles
	$sql = "SELECT * FROM options_maj";
    $resultat = mysql_query($sql);
    while($enregistrement = mysql_fetch_array($resultat))
    { 
    	// Les valeurs NULL posent des problmes pour les insert ou update alors il faut bidouiller...
    	if (is_null($enregistrement['elenoet']))
    		$elenoet = "NULL";
    	else
    		$elenoet = "'".$enregistrement['elenoet']."'";
    	$eleve_id = $enregistrement['eleve_id'];
    	$num_option = $enregistrement['num_option'];
    	$code_modalite_elect = $enregistrement['code_modalite_elect'];
    	$code_matiere = $enregistrement['code_matiere'];
    	$sql = "SELECT * from options WHERE eleve_id='$eleve_id' AND num_option='$num_option'";
      	$resultat_bis = mysql_query($sql);
      	if (mysql_num_rows($resultat_bis)>0) // Oui cet lve est dj inscrit pour cette option
      	{
      		 // On le laisse...
      	}
      	else // non cet lve n'est pas dans cet option => On l'inscrit
      	{
      		$sql = "INSERT INTO options VALUES('$eleve_id',$elenoet,'$num_option','$code_modalite_elect','$code_matiere')";
			mysql_query($sql);
			$compteur_insert_options++;
			if (mysql_affected_rows() >0)
    		{
    			$compteur_insert_options++;	
    		}		
      	}
    }
  	
    // Recherche des lments  supprimer (lves ayant des options sur la base de donne qu'on ne retrouve pas dans l'import, c'est--dire dans la table options_maj)
    // Cette fois-ci on part de la table active options et on cherche une correspondance avec la table de mise  jour 
     
 	$sql = "SELECT eleve_id,num_option FROM options";
 	$resultat = mysql_query($sql);
 	while($enregistrement = mysql_fetch_array($resultat))
 	{
		$eleve_id = $enregistrement['eleve_id'];
    	$num_option = $enregistrement['num_option'];
    	$sql = "SELECT * from options WHERE eleve_id='$eleve_id' AND num_option='$num_option'";
    	$resultat_bis = mysql_query($sql);
    	if (mysql_num_rows($resultat_bis)>0)
    	{ 
    		// Il y a un enregistrement correspondant dans la base de maj
    		// On fait rien (rien  supprimer)
    	}
    	else
    	{
    		// L'enregistrement prsent dans la base active n'est plus dans le fichier d'import
    		// On le supprime de la base active
    		$sql = "DELETE FROM options WHERE eleve_id='$eleve_id' AND num_option='$num_option'";
    		mysql_query($sql);
    		if (mysql_affected_rows() >0)
    		{
    			$compteur_options_suppr++;	
    		}
    	}
 	}
  	
 	$rapport .= "Il y a <strong>$compteur_options_suppr</strong> suppressions d'options et <strong>$compteur_insert_options</strong> nouvelles insertions dans la table options.<br />";
		
	
	/// Traitement des donnes du bloc STRUCTURES_ELEVES ///
	
    $rapport .= "<br /><h2><u>*** Lecture des donnes du bloc STRUCTURES_ELEVES : Intgration dans la table de MAJ ***</u></h2><br />";
    
    $compteur_structures = 0;
    $compteur_structures_suppr = 0;
    $compteur_insert_structures = 0;
    $sql = "TRUNCATE TABLE structures_eleves_maj";
    mysql_query($sql);
    
    foreach($parser->document->donnees[0]->structures[0]->structures_eleve as $value) 
	{
		// Certaines balises XML ou attributs ne sont pas obligatoires, elles peuvent donc donner lieu  des valeurs NULL dans la base de donnes
		// Elles subissent donc un traitement particulier pour un enregistrement correct dans la bdd
		
		$eleve_id = $value->tagAttrs['eleve_id'];
		if (!isset($value->tagAttrs['elenoet']))
			$elenoet = "NULL";
		else
			$elenoet = "'".quote_smart($value->tagAttrs['elenoet'])."'";
		foreach($value->structure as $structure)
		{
			$code_structure = $structure->code_structure[0]->tagData;
			$type_structure = $structure->type_structure[0]->tagData;
			// On remplit la table de maj
			$sql = "INSERT INTO structures_eleves_maj VALUES('".quote_smart($eleve_id)."',$elenoet,'".quote_smart($code_structure)."','".quote_smart($type_structure)."')";
			mysql_query($sql);
			if (mysql_affected_rows() >0)
    		{
    			$compteur_structures++;	
    		}
		}			
	}
	
	$rapport .= "Il y a <strong>$compteur_structures</strong> enregistrements imports dans la table structures_eleves_maj.<br />";
	
	$rapport .= "<br /><h2><u>*** Insertion, mise  jour ou suppression des lves dans les structures (divisions, groupes) ***</u></h2><br />";
	
	// Parcours des donnes de l'import : on cherche les donnes nouvelles
	$sql = "SELECT * FROM structures_eleves_maj";
    $resultat = mysql_query($sql);
    while($enregistrement = mysql_fetch_array($resultat))
    { 
    	// Les valeurs NULL posent des problmes pour les insert ou update alors il faut bidouiller...
    	if (is_null($enregistrement['elenoet']))
    		$elenoet = "NULL";
    	else
    		$elenoet = "'".$enregistrement['elenoet']."'";
    	$eleve_id = $enregistrement['eleve_id'];
    	$code_structure = $enregistrement['code_structure'];
    	$type_structure = $enregistrement['type_structure'];
    	$sql = "SELECT * FROM structures_eleves WHERE eleve_id='$eleve_id' AND code_structure='$code_structure'"; // recherche sur base active
      	$resultat_bis = mysql_query($sql);
      	if (mysql_num_rows($resultat_bis)>0) // Oui cet lve est dj inscrit dans la structure
      	{
      		 // On le laisse...
      	}
      	else // non cet lve n'est pas dans la structure => On l'inscrit
      	{
      		$sql = "INSERT INTO structures_eleves VALUES('$eleve_id',$elenoet,'$code_structure','$type_structure')";
			mysql_query($sql);
      		if (mysql_affected_rows() >0)
    		{
    			$compteur_insert_structures++;	
    		}
    		// Si la structure est un groupe, il faut galement enregistrer l'lve dans la table groupes
    		if ($type_structure == "G")
    		{
    			$sql = "SELECT id_groupe FROM groupes WHERE nom='$code_structure'";
    			$result_gp = mysql_query($sql);
    			$record = mysql_fetch_array($result_gp);
    			if (mysql_num_rows($result_gp)>0) 
      			{
      		 		$id_groupe = $record['id_groupe'];
      				$sql = "INSERT INTO groupes_eleves VALUES('$id_groupe','$eleve_id','$code_structure')";
      				$rapport .= $sql."<br />";
    				mysql_query($sql);
      			}
    			
    		}
      	}
    }
    
    // Recherche des lments  supprimer (lves dans une structure sur la base de donne qu'on ne retrouve pas dans l'import, c'est--dire dans la table structures_eleves_maj)
    // Cette fois-ci on part de la table active structures_eleves et on cherche une correspondance avec la table de mise  jour 
    
 	$sql = "SELECT * FROM structures_eleves";
 	$resultat = mysql_query($sql);
 	while($enregistrement = mysql_fetch_array($resultat))
 	{
		$eleve_id = $enregistrement['eleve_id'];
    	$code_structure = $enregistrement['code_structure'];
    	$type_structure = $enregistrement['type_structure'];
    		
    	$sql = "SELECT * FROM structures_eleves_maj WHERE eleve_id='$eleve_id' AND code_structure='$code_structure'"; // recherche sur base de maj
    	$resultat_bis = mysql_query($sql);
    	if (mysql_num_rows($resultat_bis)>0)
    	{ 
    		// Il y a un enregistrement correspondant dans la base de maj
    		// On fait rien (rien  supprimer)
    	}
    	else
    	{
    		// L'enregistrement prsent dans la base active n'est plus dans le fichier d'import
    		// On le supprime de la base active
    		$sql = "DELETE FROM structures_eleves WHERE eleve_id='$eleve_id' AND code_structure='$code_structure'";
    		mysql_query($sql);
    		if (mysql_affected_rows() >0)
    		{
    			$compteur_structures_suppr++;	
    		}
    		// et ventuellement des groupes dont il faisait partie
    		$sql = "DELETE FROM groupes_eleves WHERE eleve_id='$eleve_id'";
    		mysql_query($sql);
    	}
 	}
	
	$rapport .= "Il y a <strong>$compteur_structures_suppr</strong> suppression d'lves dans des structures et <strong>$compteur_insert_structures</strong> nouvelles insertions dans la table structures_eleves.<br /><br />";
	
	/*
	 *  Il faut maintenant parcourir la table structures_eleves 
	et recopier la classe de chaque lve dans le champ classe de la table lve mis  NULL plus haut*/
	
	/* On va galement rechercher les lves sans classe :
	 * Les lves concerns n'ont pas de date de sortie renseigne dans le fichier xml sont dans un premier temps intgrs  la
	 * table lves (et aussi la table login) lors de la partie du script /// Traitement des donnes du bloc ELEVES /// (voir + haut)
	 * mais en fait ces lves ne sont plus dans l'tablissement car ne sont pas intgrs dnas les divisions
	 * et a le script n'en a connaissance que dans la partie /// Traitement des donnes du bloc STRUCTURES_ELEVES ///
	 * C'est pourquoi ensuite ces lves sont identifis puis supprims.
	 * Il faut donc tenir compte de tout ceci dans la gestion des compteurs dans le script pour que les valeurs affiches  la fin
	 * soient fiables : c'est pour cela que l'appel  la fonction supprime_donnees_eleve() est fait avec un dernier paramtre=true
	 * de faon  ce que le compte de suppression ne soit pas modifi.
	 * */
	
	$compteur_suppr_eleves_sans_classe = 0;
	
	$sql = "SELECT * FROM eleves";
	$result = mysql_query($sql);
	while ($ligne = mysql_fetch_array($result)) // Pour chaque lve
	{
		$eleve_id = $ligne['eleve_id'];
		// On cherche sa classe
		$sql = "SELECT code_structure FROM structures_eleves WHERE eleve_id='$eleve_id' AND type_structure='D'";
		$rapport .= "*********************************<br />";
		$rapport .= $sql."<br /><br />";
		$result2 = mysql_query($sql);
		$ligne2 = mysql_fetch_array($result2);
		$classe = $ligne2['code_structure'];
		// Si la classe est vide, c'est que l'lve n'est plus dans l'tablissement (et sa date de sortie n'est pas renseigne dans le xml d'import - pas normal, mais a arrive -)
		if ($classe == "")
		{
			// Dans ce cas il faut supprimer toutes les donnes concernant l'lve
			$rapport .= "---***--- CAS d'lve sans Classe ( supprimer ) : ---***---<br/>";
			supprime_donnees_eleve($ligne['id_eleve'],$eleve_id, $ligne['nom'],$ligne['prenom'],$ligne['adresse_id'],true);
			$compteur_suppr_eleves_sans_classe++; // Pour tenir compte de ces lves particuliers dans la fiabilit des compteurs affichs  la fin
		}
		// et on la recopie dans le champ classe de la table lve
		$sql = "UPDATE eleves set classe='$classe' WHERE eleve_id='$eleve_id'";
		$rapport .= $sql."<br /><br />";
		$rapport .= "*********************************<br />";
		mysql_query($sql);
	}
	
	/// Traitement des donnes du bloc ADRESSES ///
	
	$rapport .= "<br /><h2><u>*** Lecture des donnes du bloc ADRESSES : Intgration dans la table de MAJ ***</u></h2>";
	
	$compteur_adresses_eleves = 0;
	$compteur_maj_adresses_eleves = 0;
	$compteur_suppr_adresses_eleves = 0;
    $compteur_insert_adresses_eleves = 0;
    $sql = "TRUNCATE TABLE adresses_eleves_maj";
    mysql_query($sql);
	
	if (isset($parser->document->donnees[0]->adresses[0]->adresse)) // Si les adresses sont fournies
	{
		foreach($parser->document->donnees[0]->adresses[0]->adresse as $value) // les adresses des lves  mettre dans la table adresses_eleves
		{
			// Certaines balises XML ou attributs ne sont pas obligatoires, elles peuvent donc donner lieu  des valeurs NULL dans la base de donnes
			// Elles subissent donc un traitement particulier pour un enregistrement correct dans la bdd
			
			$adresse_id = $value->tagAttrs['adresse_id'];
		
			if (!isset($value->ligne1_adresse[0]->tagData))
		  		$ligne1_adresse = "NULL";
			else
			{
		  		$ligne1_adresse = $value->ligne1_adresse[0]->tagData;
				$ligne1_adresse = "AES_ENCRYPT('$ligne1_adresse','$crypt_key')";
			}			  
			if (!isset($value->ligne2_adresse[0]->tagData))
		  		$ligne2_adresse = "NULL";
			else
			{
		  		$ligne2_adresse = $value->ligne2_adresse[0]->tagData;
				$ligne2_adresse = "AES_ENCRYPT('$ligne2_adresse','$crypt_key')";
			}
			if (!isset($value->ligne3_adresse[0]->tagData))
		  		$ligne3_adresse = "NULL";
			else
			{
		  		$ligne3_adresse = $value->ligne3_adresse[0]->tagData;
				$ligne3_adresse = "AES_ENCRYPT('$ligne3_adresse','$crypt_key')";
			}		  
			if (!isset($value->ligne4_adresse[0]->tagData))
		  		$ligne4_adresse = "NULL";
			else
			{
		  		$ligne4_adresse = $value->ligne4_adresse[0]->tagData;
				$ligne4_adresse = "AES_ENCRYPT('$ligne4_adresse','$crypt_key')";
			}		  	
		  	if (!isset($value->code_postal[0]->tagData))
		  		$code_postal = "NULL";
			else
			{
		  		$code_postal = $value->code_postal[0]->tagData;
				$code_postal = "AES_ENCRYPT('$code_postal','$crypt_key')";
			}	
		  	if (!isset($value->libelle_postal[0]->tagData))
		  		$libelle_postal = "NULL";
			else
			{
		  		$libelle_postal = $value->libelle_postal[0]->tagData;
				$libelle_postal = "AES_ENCRYPT('$libelle_postal','$crypt_key')";
			}	
		  	// On remplit la table de maj
			$sql = "INSERT INTO adresses_eleves_maj VALUES('".quote_smart($adresse_id)."',$ligne1_adresse,$ligne2_adresse,$ligne3_adresse,$ligne4_adresse,$code_postal,$libelle_postal)";
			mysql_query($sql);
			$rapport .= "<br />".$sql."<br /><br />";
			if (mysql_affected_rows() >0)
			{
				$compteur_adresses_eleves++;			  	
			}
		}
		$rapport .= "Il y a <strong>$compteur_adresses_eleves</strong> adresses d'lves importes dans la table adresses_eleves_maj.<br />";
	}
	
	$rapport .= "<br /><h2><u>*** Insertion, mise  jour ou suppression des adresses d'lves ***</u></h2>";
	
	// Parcours des donnes de l'import : on cherche les donnes nouvelles
	$sql = "SELECT * FROM adresses_eleves_maj";
    $resultat = mysql_query($sql);
    while($enregistrement = mysql_fetch_array($resultat))
    { 
    	// Les valeurs NULL posent des problmes pour les insert ou update alors il faut bidouiller...
    	$colonnes_null_possibles = array(
    	"ligne1_adresse",
    	"ligne2_adresse",
    	"ligne3_adresse",
    	"ligne4_adresse",
    	"code_postal",
    	"libelle_postal");
    	foreach($colonnes_null_possibles as $colonne)
    	{
    		$$colonne = $enregistrement[$colonne];
    		if (is_null($$colonne))
			{	
				$$colonne = "NULL";
			}
			else
			{
				$$colonne = "'".quote_smart($enregistrement[$colonne])."'";
			}
    	}
    	
    	$adresse_id = $enregistrement['adresse_id'];
    	
    	$sql = "SELECT * FROM adresses_eleves WHERE adresse_id='$adresse_id'";
      	$resultat_bis = mysql_query($sql);
      	if (mysql_num_rows($resultat_bis)>0) // Oui cette adresse est dj inscrite
      	{
      		 // On la met  jour le cas chant
      		 $sql = "UPDATE adresses_eleves set ligne1_adresse=$ligne1_adresse, ligne2_adresse=$ligne2_adresse, ligne3_adresse=$ligne3_adresse, ligne4_adresse=$ligne4_adresse, code_postal=$code_postal, libelle_postal=$libelle_postal WHERE adresse_id='$adresse_id'";
      		mysql_query($sql);
			if (mysql_affected_rows() >0)
			{
				$compteur_maj_adresses_eleves++;			  	
			}
      	}
      	else // non cette lve n'est pas dans la base => On l'inscrit
      	{
      		$sql = "INSERT INTO adresses_eleves VALUES('$adresse_id',$ligne1_adresse,$ligne2_adresse,$ligne3_adresse,$ligne4_adresse,$code_postal,$libelle_postal)";
			mysql_query($sql);
      		if (mysql_affected_rows() >0)
    		{
    			$compteur_insert_adresses_eleves++;	
    		}	
      	}
    }
    
    // Recherche des lments  supprimer (adresses dans la base de donne qu'on ne retrouve pas dans l'import, c'est--dire dans la table adresses_eleves_maj)
    // Cette fois-ci on part de la table active adresses_eleves et on cherche une correspondance avec la table de mise  jour 
    
 	$sql = "SELECT adresse_id FROM adresses_eleves";
 	$resultat = mysql_query($sql);
 	while($enregistrement = mysql_fetch_array($resultat))
 	{
		$adresse_id = $enregistrement['adresse_id'];
    	    		
    	$sql = "SELECT * FROM adresses_eleves_maj WHERE adresse_id='$adresse_id'"; // recherche sur base de maj
    	$resultat_bis = mysql_query($sql);
    	if (mysql_num_rows($resultat_bis)>0)
    	{ 
    		// Il y a un enregistrement correspondant dans la base de maj
    		// On fait rien (rien  supprimer)
    	}
    	else
    	{
    		// L'enregistrement prsent dans la base active n'est plus dans le fichier d'import
    		// On le supprime de la base active
    		$sql = "DELETE FROM adresses_eleves WHERE adresse_id='$adresse_id'";
    		mysql_query($sql);
    		if (mysql_affected_rows() >0)
    		{
    			$compteur_suppr_adresses_eleves++;	
    		}
    	}
 	}
	
	$rapport .= "Il y a <strong>$compteur_suppr_adresses_eleves</strong> suppression d'adresses lves et <strong>$compteur_insert_adresses_eleves</strong> nouvelles insertions dans la table adresses_eleves.<br /><br />";
	
	$compteur_new_eleves_reel = $compteur_insert-($compteur_suppr+$compteur_suppr_eleves_sans_classe); // Pour avoir le nombre rel d'lves ajouts  la table lves
	$compteur_new_comptes_reel = $compteur_new_comptes-($compteur_suppr+$compteur_suppr_eleves_sans_classe); // Pour avoir le nombre rel de comptes de connexion  IEW (table login) crs
		
	$rapport_resume .= "<br />
    - <strong>$compteur_new_eleves_reel</strong> nouveaux lves imports dans la base de donnes<br />
    - <strong>$compteur_suppr</strong> supprims de la base de donnes<br />
    - <strong>$compteur_new_comptes_reel</strong> nouveaux comptes lves<br />
    - <strong>$compteur_maj</strong> fiches lves mises  jour<br />
    <br />Horodatage du fichier trait : $date_maj_eleves
    <br/>";
	
    ////////// l'importation des donnes du fichier ElevesAvecAdresses.xml (pour les lves) est termine  ////////////////
	/*********************************************************************************************************************
	**********************************************************************************************************************
	**********************************************************************************************************************
	**********************************************************************************************************************
	********/
   	$rapport_resume .= "<br /><h2>****** Traitement du fichier ResponsablesAvecAdresses.xml ******</h2>";
   
	// Rinitalisation du parser
	$fichier = $GLOBALS['stock_baselev']."importation/ResponsablesAvecAdresses.xml";
	//Get the XML document loaded into a variable
	$xml = file_get_contents($fichier);
	//Set up the parser object
	$parser = new XMLParser($xml);
	//Work the magic...
	$parser->Parse();
     
	$date_maj_responsables = $parser->document->parametres[0]->horodatage[0]->tagData;
	
	// On effectue une copie de sauvegarde pour les comptes parents (ce fichier est toujours cras lors d'une mise  jour)
    @copy($GLOBALS['stock_baselev']."comptes_parents.txt",$GLOBALS['stock_baselev']."comptes_parents.bak");
	// On ouvre les fichiers ncessaires aux mises  jour
    $fichier_parents=fopen($GLOBALS['stock_baselev']."comptes_parents.txt","a"); // on va ajouter les nouveaux comptes
	// On effectue ventuellement un backup d'une mise  jour prcdente
    if (file_exists($GLOBALS['stock_baselev']."new_comptes_parents.txt"))
    {
        @copy($GLOBALS['stock_baselev']."new_comptes_parents.txt",$GLOBALS['stock_baselev']."new_comptes_parents.bak");
    }
	// Il peut maintenant tre cras
    $fichier_suivant_parents=fopen($GLOBALS['stock_baselev']."new_comptes_parents.txt","w"); // on crase ce fichier (il ne contiendra que les nouveaux comptes de la dernire mise  jour) 
	
    /// Traitement des donnes du bloc PERSONNES ///
    
    $rapport .= "<h2><u>*** Lecture des Donnes du bloc PERSONNES : Intgration des responsables dans la table de MAJ correspondante ***</u></h2><br />";
    
    $compteur_responsables_import = 0; // initialisation du compteur de personnes prsentes dans le fichier d'import
	    
    $sql = "TRUNCATE TABLE responsables_maj";
    mysql_query($sql);
    
    foreach($parser->document->donnees[0]->personnes[0]->personne as $value) // les responsables  mettre dans la table responsables
	{  
    	
		// Certaines balises XML ou attributs ne sont pas obligatoires, elles peuvent donc donner lieu  des valeurs NULL dans la base de donnes
		// Elles subissent donc un traitement particulier pour un enregistrement correct dans la bdd
			
    	if (!isset($value->lc_civilite[0]->tagData))
		  	$lc_civilite = "NULL";
		else
			$lc_civilite = "'".quote_smart($value->lc_civilite[0]->tagData)."'";
			
		if (!isset($value->tel_personnel[0]->tagData))
		  	$tel_personnel = "NULL";
		else
		{
			$tel_personnel = $value->tel_personnel[0]->tagData;
			$tel_personnel = "AES_ENCRYPT('$tel_personnel','$crypt_key')";
		}
		
		if (!isset($value->accepte_sms[0]->tagData))
		  	$accepte_sms = "NULL";
		else
			$accepte_sms = "'".quote_smart($value->accepte_sms[0]->tagData)."'";
			
		if (!isset($value->tel_professionnel[0]->tagData))
		  	$tel_professionnel = "NULL";
		else
		{
			$tel_professionnel = $value->tel_professionnel[0]->tagData;
			$tel_professionnel = "AES_ENCRYPT('$tel_professionnel','$crypt_key')";
		}
			
		if (!isset($value->mel[0]->tagData))
		  	$mel = "NULL";
		else
			$mel = "'".quote_smart($value->mel[0]->tagData)."'";
			
		if (!isset($value->communication_adresse[0]->tagData))
		  	$communication_adresse = "NULL";
		else
			$communication_adresse = "'".quote_smart($value->communication_adresse[0]->tagData)."'";
			
		if (!isset($value->adresse_id[0]->tagData))
		  	$adresse_id = "NULL";
		else
			$adresse_id = "'".quote_smart($value->adresse_id[0]->tagData)."'";
    	
		if (!isset($value->tel_portable[0]->tagData))
		  	$tel_mobile = "NULL";
		else
		{
			$tel_mobile = $value->tel_portable[0]->tagData;
			$tel_mobile = "AES_ENCRYPT('$tel_mobile','$crypt_key')";
		}
		    	
    	// Les valeurs qui ne peuvent pas tre NULL
		$personne_id = $value->tagAttrs['personne_id'];
    	$nom = $value->nom[0]->tagData;
      	$prenom = $value->prenom[0]->tagData;
      	      	
		// On remplit la table de maj
		$sql = "INSERT INTO responsables_maj VALUES('".quote_smart($personne_id)."',NULL,$lc_civilite,'".quote_smart($nom)."','".quote_smart($prenom)."',$tel_personnel,$tel_mobile,$accepte_sms,$tel_professionnel,$mel,$communication_adresse,$adresse_id)";
		mysql_query($sql);
		if (mysql_affected_rows()==-1)
		{
			$rapport .= "La Commande SQL suivante a chou :<br />$sql<br />".mysql_errno(). ": " . mysql_error(). "<br />";
		}
		else
		{	
	    	$rapport .= "Le responsable $nom $prenom a t <font color='green'><strong>Intgr</strong></font> dans la table responsables_maj.<br />";
	    	$compteur_responsables_import++;
	    } 	
	}		 	
	
	$rapport .= "<br />Il y a <strong>$compteur_responsables_import</strong> responsables prsents dans le fichier d'import et imports dans la table responsables_maj.<br /><br />";
	
	/* On ne va garder que les responsables ayant la responsabilit lgale effective
	 * et les personnes ayant le code_parente = MERE ou PERE, mme si n'ont pas de responsabilit lgale effective
	 * Ceci afin de permettre l'accs  IEW aux parents naturels par dfaut et pallier une ventuelle erreur de saisie des responsabilit
	 * dans SCONET qui ferait que ces parents ne pourraient se connecter dans IEW */
	
	/// Traitement des donnes du bloc RESPONSABLES ///
    
    $rapport .= "<br /><h2><u>*** Lecture des donnes du bloc RESPONSABLES : Intgration des responsabilits d'lves dans la table de MAJ correspondante ***</u></h2><br />";
    
	$compteur_responsabilites_eleves = 0;
   	
	$sql = "TRUNCATE TABLE responsables_eleves_maj";
    mysql_query($sql);
	    
  	foreach($parser->document->donnees[0]->responsables[0]->responsable_eleve as $value) // les responsables  mettre dans la table responsables
	{  
    	$eleve_id = $value->eleve_id[0]->tagData;
		$personne_id = $value->personne_id[0]->tagData;
    	
		// Certaines balises XML ou attributs ne sont pas obligatoires, elles peuvent donc donner lieu  des valeurs NULL dans la base de donnes
		// Elles subissent donc un traitement particulier pour un enregistrement correct dans la bdd
			
    	if (!isset($value->resp_legal[0]->tagData))
		  	$resp_legal = "NULL";
		else
			$resp_legal = "'".quote_smart($value->resp_legal[0]->tagData)."'";

		$code_parente = $value->code_parente[0]->tagData;
	      	
 		if (!isset($value->pers_contact[0]->tagData))
		  	$pers_contact= "NULL";
		else
		 	$pers_contact = "'".quote_smart($value->pers_contact[0]->tagData)."'";
			
		// On remplit la table de maj uniquement avec les personnes ayant une responsabilit lgal non null et diffrente de zro
		// mais aussi avec des personnes n'ayant pas de responsabilit lgale mais tant tout de mme le pre ou la mre
		if (($resp_legal != "NULL" && $resp_legal != 0) || $code_parente == 1 || $code_parente == 2)
		{
			$sql = "INSERT INTO responsables_eleves_maj VALUES('".quote_smart($eleve_id)."','".quote_smart($personne_id)."',$resp_legal,'".quote_smart($code_parente)."',$pers_contact)";
			mysql_query($sql);
			if (mysql_affected_rows() >0)
			{
				$compteur_responsabilites_eleves++;			  	
			}
		} 			 
    }    
    $rapport .= "Il y a <strong>$compteur_responsabilites_eleves</strong> enregistrements imports dans la table responsables_eleves_maj.<br />";
	
    $rapport .= "<br /><h2><u>*** Elimination des responsables sans responsabilit effective dans la table de MAJ correspondante ***</u></h2><br />";
    // Elimination des responsables sans responsabilit effective dans la table responsables_maj
    // et des responsabilits en rapport avec des lves qui ne sont plus dans l'tablissement
    // Parcours des donnes de l'import : on cherche les donnes  liminer
	$compteur_suppr_responsables_eleves = 0; // initialisation d'un compteur de suppression de responsables sans responsabilit
    $sql = "SELECT * FROM responsables_maj";
    $resultat = mysql_query($sql);
    while($enregistrement = mysql_fetch_array($resultat))
    { 
    	$personne_id = $enregistrement['personne_id'];
    	$sql = "SELECT * from responsables_eleves_maj WHERE personne_id='$personne_id'"; // On cherche s'il y a une responsabilit associe  ce responsable
    	$resultat2 = mysql_query($sql);
    	if (mysql_num_rows($resultat2) == 0) // Pas de responsabilit
    	{
    		$sql = "DELETE FROM responsables_maj WHERE personne_id='$personne_id'"; // On supprime le responsable
    		mysql_query($sql);
    		if (mysql_affected_rows() >0)
			{
				$compteur_suppr_responsables_eleves++;			  	
			}
    	}
    	else // Il y a au moins une responsabilit sur un lve
    	{
    		// Il faut s'assurer que l'lve est encore dans l'tablissement
    		while($enregistrement2 = mysql_fetch_array($resultat2))
    		{
    			$eleve_id = $enregistrement2['eleve_id'];
    			$sql = "SELECT * from eleves WHERE eleve_id='$eleve_id'";
    			$resultat3 = mysql_query($sql);
    			if (mysql_num_rows($resultat3) == 0) // Pas d'lve correspondant : l'lve n'est + dans l'tablissement
    			{
    				// On efface la responsabilit correspondante
    				$sql = "DELETE from responsables_eleves_maj WHERE personne_id='$personne_id' AND eleve_id='$eleve_id'";
    				mysql_query($sql);
    			}
    		}
    		// On recherche  nouveau si le responsable a encore des responsabilits effectives (sur des lves encore dans l'tablissement)
    		$sql = "SELECT * from responsables_eleves_maj WHERE personne_id='$personne_id'"; // On cherche s'il y a une responsabilit associe  ce responsable
    		$resultat4 = mysql_query($sql);
    		if (mysql_num_rows($resultat4) == 0) // Pas de responsabilit
    		{
    			$sql = "DELETE FROM responsables_maj WHERE personne_id='$personne_id'"; // On supprime le responsable
    			mysql_query($sql);
    			if (mysql_affected_rows() >0)
				{
					$compteur_suppr_responsables_eleves++;			  	
				}
    		}
    	}
    }
    $rapport .= "Il y a <strong>$compteur_suppr_responsables_eleves</strong> responsables (sans responsabilits) supprims dans la table responsables_maj.<br />";

    $rapport .= "<br /><h2><u>*** MAJ des enregistrements existants ou ajout de nouveaux responsables ***</u></h2><br />";
    
    $compteur_insert_responsables = 0;
	$compteur_maj_responsables = 0;
	$compteur_new_comptes_responsables = 0;
	
	// Parcours des donnes de l'import : on cherche les donnes nouvelles
	$sql = "SELECT * FROM responsables_maj";
    $resultat = mysql_query($sql);
    while($enregistrement = mysql_fetch_array($resultat))
    { 
    	// Les valeurs NULL posent des problmes pour les insert ou update alors il faut bidouiller...
    	$colonnes_null_possibles = array(
    	"lc_civilite",
    	"tel_personnel",
    	"tel_mobile",
    	"accepte_sms",
    	"tel_professionnel",
    	"mel",
    	"communication_adresse",
    	"adresse_id");
    	foreach($colonnes_null_possibles as $colonne)
    	{
    		$$colonne = $enregistrement[$colonne];
    		if (is_null($$colonne))
			{	
				$$colonne = "NULL";
			}
			else
			{
				$$colonne = "'".quote_smart($enregistrement[$colonne])."'";
			}
    	}
    	// Voici les colonnes qui ne peuvent tre NULL
    	$personne_id = $enregistrement['personne_id'];
    	$nom = $enregistrement['nom'];
    	$prenom = $enregistrement['prenom'];

    	$rapport .= "<u>Cas du Responsable <strong>$nom $prenom</strong> (personne_id = $personne_id) :</u><br />";
    	
    	$sql = "SELECT * FROM responsables WHERE personne_id='$personne_id'";
      	$resultat_bis = mysql_query($sql);
      	if (mysql_num_rows($resultat_bis)>0) // Oui ce responsable est dj dans la base
      	{
      		$rapport .= "Ce responsable a t <strong>trouv dans la base !</strong><br />";
		    
      		$id_pers = mysql_result($resultat_bis, 0, "id_pers"); // l'identifiant IntraEduweb est stock
      		$ancien_nom = mysql_result($resultat_bis, 0, "nom");
        	$ancien_prenom = mysql_result($resultat_bis, 0, "prenom");
			// On met  jour par prcaution les champs (sauf personne_id et id_pers on est sr qu'ils ne changent pas) au cas o ils auraient chang
        	$sql = "UPDATE responsables SET lc_civilite=$lc_civilite, nom='".quote_smart($nom)."', prenom='".quote_smart($prenom)."', tel_personnel=$tel_personnel, tel_mobile=$tel_mobile, accepte_sms=$accepte_sms, tel_professionnel=$tel_professionnel, mel=$mel, communication_adresse=$communication_adresse, adresse_id=$adresse_id  WHERE personne_id='$personne_id'";
        	if (mysql_query($sql))
        	{
	        	if (mysql_affected_rows()>0)  
        		{  
			       	$rapport .= "La mise  jour (au cas o un changement serait fait) s'est acheve avec <font color='blue'>succs !</font><br />";
           			$rapport .= $sql."<br />"."<u>Nombre de lignes affectes :</u> ".mysql_affected_rows()."<br />";
            		$compteur_maj_responsables += mysql_affected_rows(); // si l'enregistrement a t effectivement mis  jour (si une ou plusieurs nouvelles valeurs des champs diffrent des anciennes, on incrmente le compteur de mise  jour)
            		$rapport .= "Nb total de fiches responsables mises  jour : $compteur_maj_responsables<br />";
          		}
        	}
        	else
        	{  
			    $rapport .= "La mise  jour (au cas o un changement serait fait) a <font color='red'>chou !</font><br />".mysql_errno(). ": " .mysql_error()."<br />";
		    }
			// On s'assure que le responsable a un compte pour se connecter  IntraEduWeb
        			
        	$sql="SELECT nomlogin FROM login WHERE id_pers='$id_pers'";
        	$resultat_tris=mysql_query($sql);
        	if ($resultat_tris && mysql_num_rows($resultat_tris)==0) // s'il existe pas de compte pour ce responsable, on en cre un
        	{
				$rapport .= "Ce responsable <strong>n'a pas de compte</strong> IntraEduWeb, on tente de lui en crer un !<br />";
			   	$nom_cle_jointure = "id_personne"; // Nom du champ de la table login jouant le rle de cl de jointure avec les exports XML des applications de gestion
        		$valeur_cle_jointure = $personne_id;
        		$identifiant = ""; // pas encore connu
    	    	if ($id=cree_compte_iew($nom_cle_jointure,$valeur_cle_jointure,$identifiant,$nom,$prenom,"4",$fichier_parents,$fichier_suivant_parents)) // Si la cration du compte a russi
        		{
			  	   	$rapport .= "<strong>Cration</strong> du compte IntraEduWeb <strong>russie</strong> !<br />";
        	   		$compteur_new_comptes_responsables++; // on incrmente le compteur de nouveau comptes intraeduweb
			    	$rapport .= "Nb total de nouveaux comptes responsables IEW : $compteur_new_comptes_responsables<br />";
				    // Un identifiant utilisateur unique vient d'tre cr, on le rcupre
	        	    // On le met comme identifiant du responsable dans la base IEW
            		$sql2 = "UPDATE responsables SET id_pers='$id' WHERE  personne_id='$personne_id'";
            		mysql_query($sql2);
            		if (mysql_affected_rows()==-1) // Si l'criture n'a pas russi
            		{
			        	$rapport .= "L'identifiant numrique du responsable <strong>".stripslashes($prenom)." ".stripslashes( $nom)."</strong>  n'a pas pu tre mis  jour dans la base de donnes. La correspondance entre les donnes du compte utilisateur et la table responsables risque de ne plus tre correcte.<br />";
    		       		$erreur .= "L'identifiant numrique du responsable <strong>".stripslashes($prenom)." ".stripslashes( $nom)."</strong> n'a pas pu tre mis  jour dans la base de donnes. La correspondance entre les donnes du compte utilisateur et la table responsables risque de ne plus tre correcte.<br />";
        	    	}
          		}
          		else // l'criture dans la table login n'a pas eu lieu
          		{
		       		$rapport .= "Le <u>login</u> et le <u>mot de passe</u> du responsable <strong>".stripslashes($prenom)." ".stripslashes( $nom)."</strong> n'ont pas pu tre inscrits dans la base de donnes.<br />";
            		$erreur .= "Le <u>login</u> et le <u>mot de passe</u> du responsable <strong>".stripslashes($prenom)." ".stripslashes( $nom)."</strong> n'ont pas pu tre inscrits dans la base de donnes (ils existent peut-tre dj).<br />";
          		}
          	}
        	else // il existe un compte pour ce responsable, mais si le nom et/ou le prnom a chang, il faut mettre  jour l'enregistrement du compte (mais le login ne change pas -ni le mot de passe- et restera unique)
        	{
			   	$rapport .= "ce responsable a <strong>dj un compte IntraEduWeb</strong> : ses identifiant et mot de passe restent inchangs.<br />";
    			if ($ancien_nom!=stripslashes($nom) || $ancien_prenom!=stripslashes($prenom)) // stripslashes car $nom et $prenom sont quote_smartes
        		{
	           		$nom_table_login = $nom; 
            		$prenom_table_login = $prenom;
            		$sql = "UPDATE login SET nom='".quote_smart($nom_table_login)."', prenom='".quote_smart($prenom_table_login)."' WHERE id_pers='$id_pers'";
            		if (mysql_query($sql))
    	       		{
				       	$rapport .= "Son nom et/ou son prnom a <strong>chang</strong> (mise  jour russie de la table login)<br />";
    			   	}
		    	    // On met  jour les fichiers textes contenant les comptes lves
	    	      	// Mais il faut rcuprer le login existant avant
	        		$ligne_tris = mysql_fetch_array($resultat_tris);
		        	$login = $ligne_tris['nomlogin'];
	    			$rapport .= "mise  jour des fichiers textes contenant les comptes lves<br />";
	        		modif_fichier_texte_codes_acces($GLOBALS['stock_baselev']."comptes_parents.txt","",$id_eleve,$ancien_prenom,$ancien_nom,$prenom,$nom,$login);
		    	   	// et dans le fichiers de mots de passe new_comptes_eleves.txt (si ncessaire)
		    		modif_fichier_texte_codes_acces($GLOBALS['stock_baselev']."new_comptes_parents.txt","",$id_eleve,$ancien_prenom,$ancien_nom,$prenom,$nom,$login); 
    			}
    			$rapport .= "<hr />";
        	}	                    
      	}
      	else // non ce responsable est nouveau => On l'inscrit
      	{
      		$rapport .= "C'est un <strong>Nouveau responsable !</strong><br />";
			// On lui cr un compte IEW
			$nom_cle_jointure = "id_personne"; // Nom du champ de la table login jouant le rle de cl de jointure avec les exports XML des applications de gestion
        	$valeur_cle_jointure = $personne_id;
        	$identifiant = ""; // pas encore connu
        	// Ligne suivante  dcommenter si les parents ne sont pas identifiables par LDAP
        	//$GLOBALS['flag_no_user_ldap_import'] = true; // Le $flag_no_user_ldap_import sert  indiquer que la cration du compte IEW doit avoir lieu
			// avec cration d'un mot de passe (et inscription dans un fichier de diffusion),
			// mme si la mthode d'authentification par dfaut n'est pas native
    	    if ($id=cree_compte_iew($nom_cle_jointure,$valeur_cle_jointure,$identifiant,$nom,$prenom,"4",$fichier_parents,$fichier_suivant_parents)) // Si la cration du compte a russi
        	{
		    	$rapport .= "<strong>Cration</strong> du compte IntraEduWeb <strong>russie</strong> !<br />";
        		$compteur_new_comptes_responsables++; // on incrmente le compteur de nouveau comptes intraeduweb
				$rapport .= "Nb total de nouveaux comptes responsables IEW : $compteur_new_comptes_responsables<br />";
	          	// 	On insre dans la table eleves
				$sql = "INSERT INTO responsables VALUES('$personne_id','$id',$lc_civilite,'".quote_smart($nom)."','".quote_smart($prenom)."',$tel_personnel,$tel_mobile,$accepte_sms, $tel_professionnel,$mel,$communication_adresse,$adresse_id)";
				if (!mysql_query($sql))
				{
					$erreur .= "La Commande SQL suivante a chou :<br />$sql<br />".mysql_errno(). ": " . mysql_error(). "<br />";
				}
				else	
				{	
	    			$rapport .= "Le responsable $nom $prenom a t <font color='green'><strong>Intgr</strong></font> dans la table responsables.<hr />";
	    			$compteur_insert_responsables++;
	    		}
          	}
          	else // l'criture dans la table login n'a pas eu lieu
          	{
		    	$rapport .= "Le <u>login</u> et le <u>mot de passe</u> du responsable <strong>".stripslashes($prenom)." ".stripslashes( $nom)."</strong> n'ont pas pu tre inscrits dans la base de donnes.<br />";
            	$erreur .= "Le <u>login</u> et le <u>mot de passe</u> du responsable <strong>".stripslashes($prenom)." ".stripslashes( $nom)."</strong> n'ont pas pu tre inscrits dans la base de donnes (ils existent peut-tre dj).<br />";
          	}
      	}
    }
    
    $rapport .= "<br /><h2><u>*** Recherche des responsables  supprimer ***</u></h2><br />";
    // Recherche des lments  supprimer (responsables qu'on ne retrouve pas dans l'import, c'est--dire dans la table responsables_maj)
    // Cette fois-ci on part de la table active responsables et on cherche une correspondance avec la table de mise  jour 
    
    $fichier_lu=@fopen($GLOBALS['stock_baselev']."comptes_parents.txt","r"); // ouverture en lecture seule
 	if ($fichier_lu)
 	{
  		$compteur=0;
  		while (!feof($fichier_lu)) // on commence la lecture jusqu' la fin du fichier
  		{
    		$compteur++; // contient le nombre de lignes du fichier lu
    		$champs_lus[$compteur]=fgetcsv($fichier_lu,100,","); // Lit une ligne et envoie dans un tableau les champs spars par des virgules
  		}
 	}
 	fclose($fichier_lu);
 	$comptes_parents=array(); // Tableau destin  recevoir les comptes responsables  recopier dans comptes_parents.txt
	// Traitement du fichier contenant les comptes  supprimer (pour les lves sortants (au cours de l'anne scolaire))
	// On effectue ventuellement un backup d'une mise  jour prcdente pour les lves
    if (file_exists($GLOBALS['stock_baselev']."suppr_comptes_parents.txt"))
    {
	   	@copy($GLOBALS['stock_baselev']."suppr_comptes_parents.txt",$GLOBALS['stock_baselev']."suppr_comptes_parents.bak");
    }  
	// Il peut maintenant tre cras
    $fichier_suppr=@fopen($GLOBALS['stock_baselev']."suppr_comptes_parents.txt","w"); // on ouvre en criture un fichier qui recevra les comptes lves  supprimer
    
    $compteur_suppr_responsables = 0;
    
    // C'est parti pour rechercher les responsables sortants (au cours de l'anne scolaire)
 	$sql = "SELECT * FROM responsables";
 	$resultat = mysql_query($sql);
 	while($enregistrement = mysql_fetch_array($resultat))
 	{
    	$personne_id = $enregistrement['personne_id']; 
    	$id_pers = $enregistrement['id_pers']; // utile pour la table login
    	$nom = $enregistrement['nom']; // les critres de recherche...(nom+prenom)
    	$prenom = $enregistrement['prenom'];
    	$adresse_id = $enregistrement['adresse_id']; // pour supprimer si ncessaire l'entre dans la table adresses_responsables
    	$sql = "SELECT * FROM responsables_maj WHERE personne_id='$personne_id'"; 
    	$resultat_bis = mysql_query($sql);
    	if (mysql_num_rows($resultat_bis)>0)
    	{ 
    		// Il y a un enregistrement correspondant dans les donnes de mise  jour
		    // la correspondance existe, le responsable doit tre conserv : on ne fait rien sur les tables
		    // mais on recopie le compte
    	  	$sql="SELECT nomlogin,nom,prenom FROM login WHERE id_pers='$id_pers'"; // on rcupre son nom de login
      		$resultat_tris=mysql_query($sql);
      		if ($resultat_tris && mysql_num_rows($resultat_tris)!=0) // s'il existe, alors il a un compte dans comptes_parents.txt
      		{
        		$row=mysql_fetch_row($resultat_tris);
        		$login=$row[0];
        		$prenom=$row[1];
        		$nom=$row[2];
        		foreach ($champs_lus as $value) // on recherche les infos du compte responsable
        		{
          			if ($value[1]==$login) // Si correspondance trouve, on empile pour recopier
          			{
            			$enregistrement=$value[0].",".$login.",".$prenom.",".$nom.",".$value[4].",".$value[5];
            			array_push($comptes_parents,$enregistrement);
            			break; // on sort de foreach
          			}
        		}
      		}    		
    	}
    	else // Si la correspondance n'existe pas, c'est que le responsable est sorti de l'tablissement : il faut le supprimer de la base
    	{
      		$sql = "DELETE FROM responsables WHERE personne_id='$personne_id'";
      		if (mysql_query($sql))
      		{
            	$rapport .= "Le responsable <strong>$nom $prenom</strong> (personne_id : $personne_id , id_pers : $id_pers) est <u>effac</u> de la base<br />";
                $compteur_suppr_responsables++; // on incrmente le compteur de suppression
                $rapport .= "Nb total de responsables supprims : $compteur_suppr_responsables<br />";

                // On supprime alors la photo d'identit si elle existe
                $fichier_photo = $GLOBALS['stock_baselev']."fotoparents/".$id_pers.".jpg";
                if (file_exists($fichier_photo))
                {
                	if(!@unlink($fichier_photo))
                    {
                    	$error_message = array("
                      	<div align='justify'>
                      	La photo d'identit <strong>$id_pers.jpg</strong> n'a pas pu tre supprime. Vrifiez que les droits sur les fichiers sont corrects<br />
                      	ou supprimez manuellement le fichier $id_pers.jpg dans le rpertoire ".$GLOBALS['stock_baselev']."fotoparents. Pour ce faire, prvenez votre <a href='mailto:".email_encode($GLOBALS['admin_email'])."'>administrateur IntraEduWeb</a> qui se chargera de la suppression.
                      	</div>
                      	","");
                      	affiche_erreurs($error_message);
                    }
                }
                // On supprime les entres correspondantes dans certaines tables o ce responsable est rfrenc
                
                $sql = "DELETE FROM responsables_eleves WHERE personne_id='$personne_id'";
                mysql_query($sql);
                if (mysql_affected_rows() >0)
    			{
    				$rapport .= "<b>".mysql_affected_rows()."</b> entres ont t supprimes pour ce responsable dans la table <b>responsables_eleves</b><br />";	
    			}		
                if (!is_null($adresse_id))
                {
                	$sql = "DELETE FROM adresses_responsables WHERE adresse_id='$adresse_id'";
                	mysql_query($sql);
                	if (mysql_affected_rows()>0)
                	{
                		$rapport .= "L'adresse du responsable dans la table <b>adresses_responsables</b> a t supprime.<br />";	
                	}  
                }        
      		}
            // on recherche les informations sur son compte utilisateur
            $sql="SELECT nomlogin FROM login WHERE id_pers='$id_pers'";
      		$resultat_tris=mysql_query($sql);
      		if ($resultat_tris && mysql_num_rows($resultat_tris)!=0) // s'il existe
      		{
      			// On l'enregistre dans la liste des comptes supprims
      			$row=mysql_fetch_row($resultat_tris);
      			$login=$row[0];
      			$enregistrement=$id_pers.",".$login.",".$prenom.",".$nom."\n";
      			fwrite($fichier_suppr,$enregistrement); 
                // on supprime le responsable de la table login il n'a plus de compte IntraEduWeb
      			$sql = "DELETE FROM login WHERE id_pers='$id_pers'";
      			if (mysql_query($sql) && mysql_affected_rows() > 0)
      			{
        			// on supprime les donnees obsoletes sans lien avec le compte supprim
          	    	suppr_compte_tables_nettoyage($id_pers);
        			$rapport .= "Le compte de ce responsable a t supprim dans la table login.<br />";		
      			}
      		}
    	}
	} // while => tous les responsables ont t traits

	// On recopie dans le fichier comptes_parents.txt les comptes parents  jour
 	// Bien que le fichier soit ouvert en mode ajout de donnes plus haut, ceci ne permet pas de supprimer les responsables sortants (au cours de l'anne scolaire)
	// il faut donc passer par l'tape suivante pour mettre  jour le fichier des comptes responsables

 	if (count($comptes_parents)!=0)
 	{
  		$fichier=fopen($GLOBALS['stock_baselev']."comptes_parents.txt","w"); // on crase le contenu existant
  		for ($i=0;$i<=(count($comptes_parents)-1);$i++)
  		{
    		$enregistrement=$comptes_parents[$i]."\n";
    		fwrite($fichier,$enregistrement);
  		}
  		fclose($fichier);
 	}
    fclose($fichier_suppr);
    
    // On ferme les fichiers ouverts
 	fclose($fichier_parents); 
 	fclose($fichier_suivant_parents);
        
	$compteur_maj_responsabilites_eleves = 0;
	
    $compteur_insert_responsabilites_eleves = 0;
    
 	$rapport .= "<br /><h2><u>*** MAJ des responsabilits (table responsables_eleves) ***</u></h2><br />"; 	
 	// Parcours des donnes de l'import : on cherche les donnes nouvelles
	$sql = "SELECT * FROM responsables_eleves_maj";
    $resultat = mysql_query($sql);
    while($enregistrement = mysql_fetch_array($resultat))
    { 
    	// Les valeurs NULL posent des problmes pour les insert ou update alors il faut bidouiller...
    	if (is_null($enregistrement['resp_legal']))
    		$resp_legal = "NULL";
    	else
    		$resp_legal = "'".$enregistrement['resp_legal']."'";
    	if (is_null($enregistrement['pers_contact']))
    		$pers_contact = "NULL";
    	else
    		$pers_contact = "'".$enregistrement['pers_contact']."'";
    	
    	$eleve_id = $enregistrement['eleve_id'];
    	$personne_id = $enregistrement['personne_id'];
    	$code_parente = $enregistrement['code_parente'];
    	
    	$sql = "SELECT * FROM responsables_eleves WHERE eleve_id='$eleve_id' AND personne_id='$personne_id'";
      	$resultat_bis = mysql_query($sql);
      	if (mysql_num_rows($resultat_bis)>0) // Oui cette responsabilit est dj inscrite
      	{
      		 // On la met  jour le cas chant
      		 $sql = "UPDATE responsables_eleves set resp_legal=$resp_legal, code_parente='$code_parente', pers_contact=$pers_contact WHERE eleve_id='$eleve_id' AND personne_id='$personne_id'";
      		mysql_query($sql);
			if (mysql_affected_rows() >0)
			{
				$compteur_maj_responsabilites_eleves++;			  	
			}
      	}
      	else // non cette responsabilit n'est pas dans la base => On l'inscrit
      	{
      		$sql = "INSERT INTO responsables_eleves VALUES('$eleve_id','$personne_id',$resp_legal,'$code_parente',$pers_contact)";
			mysql_query($sql);
      		if (mysql_affected_rows() >0)
    		{
    			$compteur_insert_responsabilites_eleves++;	
    		}	
      	}
    }
    $rapport .= "Il y a <strong>$compteur_insert_responsabilites_eleves</strong> nouvelles insertions dans la table responsables_eleves.<br />";
    
    $rapport .= "<br /><h2><u>*** Suppression des responsabilits non retrouves (table responsables_eleves) ***</u></h2><br />"; 	
    
    $compteur_suppr_responsabilites_eleves = 0;
    
    // Recherche des lments  supprimer (responsabilits dans la base de donne qu'on ne retrouve pas dans l'import, c'est--dire dans la table responsables_eleves_maj)
    // Cette fois-ci on part de la table active responsables_eleves et on cherche une correspondance avec la table de mise  jour 
    
 	$sql = "SELECT * FROM responsables_eleves";
 	$resultat = mysql_query($sql);
 	while($enregistrement = mysql_fetch_array($resultat))
 	{
		$eleve_id = $enregistrement['eleve_id'];
    	$personne_id = $enregistrement['personne_id'];
    		
    	$sql = "SELECT * FROM responsables_eleves_maj WHERE eleve_id='$eleve_id' AND personne_id='$personne_id'"; // recherche sur base de maj
    	$resultat_bis = mysql_query($sql);
    	if (mysql_num_rows($resultat_bis)>0)
    	{ 
    		// Il y a un enregistrement correspondant dans la base de maj
    		// On fait rien (rien  supprimer)
    	}
    	else
    	{
    		// L'enregistrement prsent dans la base active n'est plus dans le fichier d'import
    		// On le supprime de la base active
    		$sql = "DELETE FROM responsables_eleves WHERE eleve_id='$eleve_id' AND personne_id='$personne_id'";
    		mysql_query($sql);
    		if (mysql_affected_rows() >0)
    		{
    			$compteur_suppr_responsabilites_eleves++;	
    		}
    	}
 	}
	
	$rapport .= "Il y a <strong>$compteur_suppr_responsabilites_eleves</strong> suppression de responsabilit d'lves<br />";
    
    /// Traitement des donnes du bloc ADRESSES (Responsables) ///
    
    $rapport .= "<br /><h2><u>*** Lecture des donnes du bloc ADRESSES : Intgration dans la table de MAJ ***</u></h2><br />";
    
    $compteur_adresses_responsables = 0;
	$compteur_maj_adresses_responsables = 0;
	$compteur_insert_adresses_responsables = 0;
	$compteur_suppr_adresses_responsables = 0;
    
    $sql = "TRUNCATE TABLE adresses_responsables_maj";
    mysql_query($sql);
        
    //apparemment les responsables non directs n'ont pas d'adresse_id dans l'import donc ces adresses ne seront pas prsentes dans la base
    // (on n'en a pas besoin)
    
  	foreach($parser->document->donnees[0]->adresses[0]->adresse as $value) // les responsables  mettre dans la table responsables
	{  
    	// Certaines balises XML ou attributs ne sont pas obligatoires, elles peuvent donc donner lieu  des valeurs NULL dans la base de donnes
		// Elles subissent donc un traitement particulier pour un enregistrement correct dans la bdd
			
		$adresse_id = $value->tagAttrs['adresse_id'];
		
	if (!isset($value->ligne1_adresse[0]->tagData))
		  		$ligne1_adresse = "NULL";
			else
			{
		  		$ligne1_adresse = $value->ligne1_adresse[0]->tagData;
				$ligne1_adresse = "AES_ENCRYPT('$ligne1_adresse','$crypt_key')";
			}			  
			if (!isset($value->ligne2_adresse[0]->tagData))
		  		$ligne2_adresse = "NULL";
			else
			{
		  		$ligne2_adresse = $value->ligne2_adresse[0]->tagData;
				$ligne2_adresse = "AES_ENCRYPT('$ligne2_adresse','$crypt_key')";
			}
			if (!isset($value->ligne3_adresse[0]->tagData))
		  		$ligne3_adresse = "NULL";
			else
			{
		  		$ligne3_adresse = $value->ligne3_adresse[0]->tagData;
				$ligne3_adresse = "AES_ENCRYPT('$ligne3_adresse','$crypt_key')";
			}		  
			if (!isset($value->ligne4_adresse[0]->tagData))
		  		$ligne4_adresse = "NULL";
			else
			{
		  		$ligne4_adresse = $value->ligne4_adresse[0]->tagData;
				$ligne4_adresse = "AES_ENCRYPT('$ligne4_adresse','$crypt_key')";
			}		  	
		  	if (!isset($value->code_postal[0]->tagData))
		  		$code_postal = "NULL";
			else
			{
		  		$code_postal = $value->code_postal[0]->tagData;
				$code_postal = "AES_ENCRYPT('$code_postal','$crypt_key')";
			}	
		  	if (!isset($value->libelle_postal[0]->tagData))
		  		$libelle_postal = "NULL";
			else
			{
		  		$libelle_postal = $value->libelle_postal[0]->tagData;
				$libelle_postal = "AES_ENCRYPT('$libelle_postal','$crypt_key')";
			}
			// On remplit la table de maj
			// uniquement insrer celles qui correspondent  des $adresses_id existants dans la table responsables_maj
			// c-a-d correspondant  des respondables ayant une responsabilit effective
			$sql = "SELECT * FROM responsables_maj WHERE adresse_id='$adresse_id'";
			$resultat = mysql_query($sql);
			if (mysql_num_rows($resultat) >0)
			{
				$sql = "INSERT INTO adresses_responsables_maj VALUES('".quote_smart($adresse_id)."',$ligne1_adresse,$ligne2_adresse,$ligne3_adresse,$ligne4_adresse,$code_postal,$libelle_postal)";
				mysql_query($sql);
				if (mysql_affected_rows() >0)
				{
					$compteur_adresses_responsables++;			  	
				}
			}
    }
    
    $rapport .= "Il y a <strong>$compteur_adresses_responsables</strong> adresses de responsables importes dans la table adresses_responsables_maj.<br />";
    
    $rapport .= "<br /><h2><u>*** Intgration, mise  jour ou suppression des adresses des responsables ***</u></h2><br />";
    
    // Parcours des donnes de l'import : on cherche les donnes nouvelles
	$sql = "SELECT * FROM adresses_responsables_maj";
    $resultat = mysql_query($sql);
    while($enregistrement = mysql_fetch_array($resultat))
    { 
	    // Les valeurs NULL posent des problmes pour les insert ou update alors il faut bidouiller...
    	$colonnes_null_possibles = array(
    	"ligne1_adresse",
    	"ligne2_adresse",
    	"ligne3_adresse",
    	"ligne4_adresse",
    	"code_postal",
    	"libelle_postal");
    	foreach($colonnes_null_possibles as $colonne)
    	{
    		$$colonne = $enregistrement[$colonne];
    		if (is_null($$colonne))
			{	
				$$colonne = "NULL";
			}
			else
			{
				$$colonne = "'".quote_smart($enregistrement[$colonne])."'";
			}
    	}
    	
    	$adresse_id = $enregistrement['adresse_id'];
    	
    	$sql = "SELECT * FROM adresses_responsables WHERE adresse_id='$adresse_id'";
      	$resultat_bis = mysql_query($sql);
      	if (mysql_num_rows($resultat_bis)>0) // Oui cette adresse est dj inscrite
      	{
      		 // On la met  jour le cas chant
      		 $sql = "UPDATE adresses_responsables set ligne1_adresse=$ligne1_adresse, ligne2_adresse=$ligne2_adresse, ligne3_adresse=$ligne3_adresse, ligne4_adresse=$ligne4_adresse, code_postal=$code_postal, libelle_postal=$libelle_postal WHERE adresse_id='$adresse_id'";
      		mysql_query($sql);
			if (mysql_affected_rows() >0)
			{
				$compteur_maj_adresses_responsables++;			  	
			}
      	}
      	else // non cette adresse de responsable n'est pas dans la base => On l'inscrit
      	{
      		$sql = "INSERT INTO adresses_responsables VALUES('$adresse_id',$ligne1_adresse,$ligne2_adresse,$ligne3_adresse,$ligne4_adresse,$code_postal,$libelle_postal)";
			mysql_query($sql);
      		if (mysql_affected_rows() >0)
    		{
    			$compteur_insert_adresses_responsables++;	
    		}	
      	}
    }
    
    // Recherche des lments  supprimer (adresses dans la base de donne qu'on ne retrouve pas dans l'import, c'est--dire dans la table adresses_responsables_maj)
    // Cette fois-ci on part de la table active adresses_responsables et on cherche une correspondance avec la table de mise  jour 
    
 	$sql = "SELECT adresse_id FROM adresses_responsables";
 	$resultat = mysql_query($sql);
 	while($enregistrement = mysql_fetch_array($resultat))
 	{
		$adresse_id = $enregistrement['adresse_id'];
    	    		
    	$sql = "SELECT * FROM adresses_responsables_maj WHERE adresse_id='$adresse_id'"; // recherche sur base de maj
    	$resultat_bis = mysql_query($sql);
    	if (mysql_num_rows($resultat_bis)>0)
    	{ 
    		// Il y a un enregistrement correspondant dans la base de maj
    		// On fait rien (rien  supprimer)
    	}
    	else
    	{
    		// L'enregistrement prsent dans la base active n'est plus dans le fichier d'import
    		// On le supprime de la base active
    		$sql = "DELETE FROM adresses_responsables WHERE adresse_id='$adresse_id'";
    		mysql_query($sql);
    		if (mysql_affected_rows() >0)
    		{
    			$compteur_suppr_adresses_responsables++;	
    		}
    	}
 	}
	
	$rapport .= "Il y a <strong>$compteur_suppr_adresses_responsables</strong> suppression d'adresses responsables et <strong>$compteur_insert_adresses_responsables</strong> nouvelles insertions dans la table adresses_responsables.<br /><br />";
	
  	/// Traitement spcifique : il faut liminer les responsables ayant une resp_legal gale  0 (ce sont les autres personnes  contacter qui ne sont pas responsables lgaux) ///
    // C'est une simple prcaution car en principe dj fait, mais on ne sait jamais....
    
	$rapport .= "<h2><u>*** Suppression rsiduelle de responsables ***</u></h2><br />
	Il faut liminer les responsables ayant une resp_legal gale  0 (ce sont les autres personnes  contacter qui ne sont pas responsables lgaux) qui auraient chapps  la suppression faite dj dans les tables de MAJ.<br /><br />";
	
	// Mais aussi les responsables des lves sortis de l'tablissement (hors structures), mais prsents dans le fichier d'import
	// Ils ont une balise DATE_SORTIE renseigne
	
	$personnes_suppr = 0;
	
	$sql = "SELECT DISTINCT t1.personne_id,id_pers,adresse_id,nom,prenom,resp_legal,code_parente FROM responsables as t1, responsables_eleves as t2 where (resp_legal=0 OR (t2.eleve_id not in (select eleve_id from eleves))) AND t1.personne_id=t2.personne_id";
	// La requte slectionne tous les responsables n'ayant pas de responsabilit lgale d'un lve ou bien celle d'un lve qui ne fait plus partie de l'tablissement
	// Dans ce dernier cas, il se peut qu'il soient responsbles de frres ou soeurs encore dans l'tablissement
	// Il faudra donc s'en assurer avant de les supprimer
	$rapport .= $sql."<br />";
	$result = mysql_query($sql);
	if (mysql_num_rows($result)>0) // Il y a des gens  liminer
	{
		$elim_personnes = array();
		// Il faudra les retirer du fichier comptes_parents.txt
		$fichier_lu=@fopen($GLOBALS['stock_baselev']."comptes_parents.txt","r"); // ouverture en lecture seule
 		if ($fichier_lu)
 		{
  			$compteur=0;
  			while (!feof($fichier_lu)) // on commence la lecture jusqu' la fin du fichier
  			{
    			$compteur++; // contient le nombre de lignes du fichier lu
    			$champs_lus[$compteur]=fgetcsv($fichier_lu,100,","); // Lit une ligne et envoie dans un tableau les champs spars par des virgules
  			}
 		}
 		fclose($fichier_lu);
		while ($ligne=mysql_fetch_array($result)) // Pour chaque personne  supprimer
		{
			$personne_id = $ligne['personne_id'];
			$id_pers = $ligne['id_pers'];
			$adresse_id = $ligne['adresse_id'];
			$nom = $ligne['nom'];
			$prenom = $ligne['prenom'];
			$resp_legal = $ligne['resp_legal'];
			$code_parente = $ligne['code_parente'];
			
			$sql = "SELECT * FROM responsables_eleves WHERE personne_id='$personne_id' AND (eleve_id IN (select eleve_id FROM eleves))";
			$rapport .= $sql."<br />";
			$resultat_a = mysql_query($sql);
			
			// Avant de supprimer, on s'assure que le responsable n'a aucune responsabilit lgale
			// ou a une responsabilit uniquement sur des lves sortis de l'tablissement
			// et qu'il n'a ni le statut de pre, ni le statut de mre
			
			if ((is_null($resp_legal) || $resp_legal == 0 || mysql_num_rows($resultat_a)==0) && $code_parente != 1 && $code_parente != 2) 
			{
				$sql = "DELETE FROM responsables_eleves WHERE personne_id='$personne_id'"; // de la table responsabilites_eleves
				mysql_query($sql);
				$rapport .= "<br />Les responsabilits de $nom $prenom ont t supprimes de la table responsabilites_eleves<br />";
				$sql = "DELETE FROM responsables WHERE personne_id='$personne_id'"; // de la table responsables
				mysql_query($sql);
				if (mysql_affected_rows()>0)
				{
					$rapport .= "<b>$nom $prenom</b> a t supprim de la table responsables<br />";
					$personnes_suppr++;
				}
				if (!is_null($adresse_id)) // l'adresse ventuelle est supprime de la table adresses_responsables_eleves
				{
					$sql = "DELETE FROM adresses_responsables WHERE adresse_id='$adresse_id'";
					mysql_query($sql);
				}
				// on recherche les informations sur son compte utilisateur afin de le supprimer
    	        $sql="SELECT nomlogin FROM login WHERE id_pers='$id_pers'";
      			$resultat_tris=mysql_query($sql);
	      		if ($resultat_tris && mysql_num_rows($resultat_tris)!=0) // s'il existe
      			{
	      			// On l'enregistre dans la liste des id_pers des comptes  supprimer dans comptes_parents.txt
    	  			array_push($elim_personnes,$id_pers);
        	        // on supprime le responsable de la table login il n'a plus de compte IntraEduWeb
      				$sql = "DELETE FROM login WHERE id_pers='$id_pers'";
        			mysql_query($sql);
        			if (mysql_affected_rows() >0)
    				{
	    				// on supprime les donnees obsoletes sans lien avec le compte supprim
          	  			suppr_compte_tables_nettoyage($id_pers);
    					$rapport .= "Le compte de ce responsable a t supprim dans la table login.<br />";	
    				}	
      			}
			}
		}
		// R-criture du fichier comptes_parents.txt en tenant compte des dernires suppressions
		$fichier=fopen($GLOBALS['stock_baselev']."comptes_parents.txt","w"); // on crase le contenu existant
		foreach ($champs_lus as $value) // on recherche les infos du compte responsable
        {
        	if (!in_array($value[0],$elim_personnes) && $value[0]!="") // Si pas de correspondance trouve, on empile pour recopier
        	{
        		$enregistrement=$value[0].",".$value[1].",".$value[2].",".$value[3].",".$value[4].",".$value[5]."\n";
    			fwrite($fichier,$enregistrement);
        	}
        }
        fclose($fichier);
	}
	
	$rapport .= "<br />Il y a eu au total <strong>$personnes_suppr</strong> responsables sans responsabilit lgale supprims.<br />";
    
	// On tient compte des dernires suppression pour connatre le nombre rel de nouveaux responsables imports
	$compteur_insert_responsables = $compteur_insert_responsables-$personnes_suppr;
	$compteur_new_comptes_responsables = $compteur_new_comptes_responsables-$personnes_suppr;
	
    $rapport_resume .= "<br />
    - <strong>$compteur_insert_responsables</strong> nouveaux responsables imports dans la base de donnes<br />
    - <strong>$compteur_suppr_responsables</strong> supprims de la base de donnes<br />
    - <strong>$compteur_new_comptes_responsables</strong> nouveaux comptes responsables<br />
    - <strong>$compteur_maj_responsables</strong> fiches responsables mises  jour<br />
    <br />Horodatage du fichier trait : $date_maj_responsables
    <br/>";
    
    ////////// l'importation des donnes du fichier ResponsablesAvecAdresses.xml (pour les parents) est termine  ////////////////

     // Indicateur de la date de dernire mise  jour

 	$sql = "DELETE FROM horodatages_imports_eleves"; // efface l'enregistrement prcdent
 	mysql_query($sql);
 	$sql = "INSERT INTO horodatages_imports_eleves VALUES(CURRENT_DATE,'$date_maj_eleves','$date_maj_responsables')"; // crit la date de mise  jour
 	mysql_query($sql);
  		
 
  // Indicateur de la date de dernire mise  jour de la base lves (d'origine IEW, ne contient pas d'horodatage)

 $sql = "DELETE FROM majbddelev"; // efface l'enregistrement prcdent
 mysql_query($sql);
 $sql = "INSERT INTO majbddelev VALUES(CONCAT(CURRENT_DATE(),' ',CURRENT_TIME()))"; // crit la date de mise  jour de la base lves
 mysql_query($sql);
 
 print "<a id='bas'></a>";
 
 // Rapport de mise  jour
  $ok_message = "Mise  jour de la base termine avec succs !<br /><table border='0'><tr><td align='left'><font color='black'>$rapport_resume</font>";
 $ok_message .= "</td></tr></table><br />";
  
 // On affiche si besoin un rapport d'erreur
 if ($erreur!="")
  $ok_message .= "<br />***** Les erreurs suivantes ont t dtectes *****<br /><br />$erreur";
 
  // Le rapport complet de l'opration est inscrit dans un fichier qui pourra servir au dboguage
  // mais on va supprimer les rapports les + anciens (on va conserver les 2 derniers + le rapport en cours)
  $dh = opendir($GLOBALS['stock_baselev']."importation/");
  $rapports_importation = array(); // va contenir la liste des couples nom_du_rapport/date de modif
  while ($file = readdir($dh))
  {
  	if($file != '.' && $file != '..' && substr($file,0,24) == "MajBaselevesResponsables")
  	{
  		$rapports_importation[] = $file; // le nom de fichier est stock
    }
  }
  closedir($dh);
  sort($rapports_importation); // tri selon la date de cration (contenue dans le nom de fichier) : les plus anciens seront en premier
  $nb_rapports = count($rapports_importation);
  $nb_delete = 0;
  $rapport_purge = "";
  if ($nb_rapports>=3)
  {
  	$nb_delete = $nb_rapports - 2; // nombre de rapports  supprimer
  }
  $rapport_purge .= "<p>Il y a $nb_delete rapport(s)  supprimer (on conserve seulement les 3 derniers rapports).</p>";
  if ($nb_delete !=0)
  {
  	for ($i=0;$i<$nb_delete;$i++)
 	{
 		if (unlink($GLOBALS['stock_baselev']."importation/".$rapports_importation[$i]))
 			$rapport_purge .= "<p>Effacement du rapport : ".$GLOBALS['stock_baselev']."importation/".$rapports_importation[$i]."</p>";
 		else 
 			$rapport_purge .= "<p>Le rapport ".$GLOBALS['stock_baselev']."importation/".$rapports_importation[$i]." n'a pas pu tre supprim. Vous devriez excuter cette suppression manuellement.</p>";
	}	
  }
  
 // Le rapport complet de l'opration est inscrit dans un fichier qui pourra servir au dboguage
 $affichage_horodatage_jour = format_date_long("fr",date("j/m/Y"));
 $affichage_horodatage_heure = "  ".date("H")." heures ".date("i")." minutes ".date("s")." secondes";
 $horodatage_fichier=date("_Ymd_His");
 $name_file_report = "MajBaselevesResponsables".$horodatage_fichier.".html";
 $fichier_rapport=fopen($GLOBALS['stock_baselev']."importation/".$name_file_report,"w");
 $code_a_ecrire = "<?xml version='1.0' encoding='iso-8859-1'?>
		<!DOCTYPE html PUBLIC '-//W3C//DTD XHTML 1.0 Transitional//EN' 'http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd'>
		<html xmlns='http://www.w3.org/1999/xhtml' lang='fr-FR' xml:lang='fr-FR'>
  		<head>
    	<title>IntraEduWeb, Espace Numrique de Travail du ".$GLOBALS['nom_etablissement'].", $titre_page</title>
    	<meta http-equiv='Content-Type' content='text/html; charset=iso-8859-1' />
    	<meta name='author'    content='Sylvain GODM' />
    	<meta name='copyright' content='2004-".date("Y").", Sylvain GODM. All Rights Reserved.' />
    	<link rel='stylesheet' type='text/css' href='".$GLOBALS['racine'].$GLOBALS['repertoire_theme'].$GLOBALS['jeu_couleurs']['stylesheet']."' />
    	</head>
    	<body><p>".$affichage_horodatage_jour.$affichage_horodatage_heure."</p>".$rapport."<hr />
    	<a id='bas'></a><h2>Rsum</h2>".$ok_message."
    	</body>
		</html>";
 fwrite($fichier_rapport, $code_a_ecrire);
 fclose($fichier_rapport);

 // On met un lien vers le rapport complet dans le rapport rsum
 $ok_message .= "<br /><p><a href='".$GLOBALS['racine']."prive/download_doc.php?file=".$name_file_report."&amp;import=yes'>Tlcharger le rapport dtaill de l'importation</a></p>";

 affiche_ok($ok_message);
 efface_post();
 
 // on envoie un email  admin pour qu'il puisse configurer les nouveaux comptes lves et supprimer les comptes prims (pour le cas o les comptes IEW servent  crer ceux du rseau pdagogique (mode d'authentification "native")
 if ($GLOBALS['mail_server']!="")
 {
   $message = "Bonjour,\n\nCeci est un mail automatique provenant du serveur IEW du ".$GLOBALS['nom_etablissement']."\n\nLa base de donnes lves vient d'tre mise  jour.\nIl y a $compteur_insert nouveaux lves, $compteur_suppr lves supprims.\n";
   if((isset($compteur_insert_responsables) && $compteur_insert_responsables!=0) || (isset($compteur_suppr_responsables) && $compteur_suppr_responsables!=0))
     $message .= "Il y a $compteur_insert_responsables nouveaux parents, $compteur_suppr_responsables parents supprims.\n";
   $entetes_additionnels = "From: ".$GLOBALS['nom_etablissement']."<".$GLOBALS['email_etablissement'].">\n";
   $testmail=mail($GLOBALS['admin_email'],"Mise  jour de la base lves", $message,$entetes_additionnels);
   if ($testmail)
   {
     $ok_message = "Un mail vient d'tre envoy avec succs  l'administrateur IntraEduWeb pour le prvenir de la mise  jour de la base lves.<br />Celui-ci mettra  jour les comptes utilisateurs pour le rseau informatique.";
     affiche_ok($ok_message);
   }
   else
   {
     $error_message = array("L'administrateur IntraEduWeb n'a pu tre prvenu par mail de la mise  jour de la base lve. Veuillez le contacter par un autre moyen.","");
     affiche_erreurs($error_message);
   }
 }
 
 // Par scurit, on supprime les fichiers ayant servi  l'import des donnes. Ces dernires sont trop facilement accessibles  travers ces fichiers
 // C'est important notamment pour les donnes perso comme les adresses ou les n de tl
 // On efface les fichiers ElevesAvecAdresses.xml et ResponsablesAdresses.xml qui ont t uploads
 foreach($tab_delfile as $value)
 {
 	if (file_exists($GLOBALS['stock_baselev']."importation/".$value))
	{
		unlink($GLOBALS['stock_baselev']."importation/".$value);
	}
 }

?>