<?php
/**
 * c_form_imports.php
 *
 * formulaire de tlchargement des fichiers XML de gestion administrative (SIECLE, sts)
 * Utilise Javascript pour viter le rechargement de la page  la soumission du formulaire
 * seul les blocs dont le contenu change sont mis  jour
 * 
 * Comme c'est un formulaire d'upload, l'encodage multipart/form-data n'est pas gr par XMLHttpRequest
 * on a donc recours  de "l'iframe loading" : il faut envoyer le formulaire dans une iframe, 
 * le traitement du formulaire se fait alors via PHP (voir upload_imports.php) et le rsultat de l'upload
 * est renvoy par le biais de l'iframe, avec un systme de callback
 * 
 * Ce fichier fait partie du projet IntraEduWeb (IEW)
 * 
 * @package		IEW
 * @author			Sylvain GODM <sylvain.godme@gmail.com>
 * @version		$LastChangedRevision$, $LastChangedDate$
 * @copyright		2004-2012 Sylvain GODM
 * @link			http://iew.free.fr
 * @license		GPL License version 3 (http://www.gnu.org/licenses/gpl.html)
 * @filesource
 * 
 */

if (!defined('IEW_DIR')) {
 	/**
 	 * Constante contenant le chemin complet du rpertoire d'installation IEW
 	 */	
	define('IEW_DIR',realpath(dirname(__FILE__).'/../../../').'/');
}

/**
 * On inclut la librairie complte des fonctions et les fichiers de config, et on dmarre la session PHP
 */
require_once(IEW_DIR."librairie_fonctions.php");

function get_date_last_update($type)
{
	/**
	 * Renvoie la date de la dernire importation
	 * @param $type = adm (imports administratifs au dbut de l'anne scolaire) ou elev (importation des lves et des responsables)
	 * @return $datemaj : date de la dernire importation
	 */
	switch ($type)
	{
		case "adm":
			$sql = "SELECT * FROM horodatages_imports_base";
			break;
		case "elev":
			$sql = "SELECT * FROM horodatages_imports_eleves";
			break;
	}
	$resultat = mysql_query($sql);
	$datmaj = mysql_fetch_row($resultat);
	if (!$datmaj[0])
	{
  		$datmaj = "Aucune mise  jour n'a encore t faite, la base est vide (normal  l'installation <abbr title='IntraEduWeb'>IEW</abbr>).";
	}
	else
	{
 		$datmaj = $datmaj[0];  // la date mysql aaaa-mm-jj est formate en jj-mm-aaaa
 		list($annee,$mois,$jour)=explode("-",$datmaj);
 		$datmaj=date("d/m/Y", mktime(0,0,0,$mois,$jour,$annee));
	}
	return $datmaj;
}

connexion_mysql();
select_database();

switch ($_GET['type'])
{
	case "adm":
		echo "<h1>Importer les donnes administratives de rentre</h1>";
		$datmaj = get_date_last_update("adm");
		$code_formulaire = "
		<div style='text-align: justify;'>
		<p>La dernire mise  jour date du : <strong>$datmaj</strong></p>
		<p>Cet import est  effectuer aprs la clture de l'anne scolaire et avant la mise  jour de la base de donnes du Personnel de l'tablissement. Il consiste  rcuprer ou mettre  jour les nomenclatures utilises, les <abbr title='Modules lmentaires de formation'>MEFs</abbr>, les matires, les divisions, les groupes, les enseignants, les emplois du temps.</p>
		<p>Il s'agit de l'import des donnes en provenance de SIECLE (pour les <abbr title='Modules lmentaires de formation'>MEFs</abbr>, matires et options, les rgimes, les divisions et les groupes), et STS WEB (pour les enseignants, les quipes pdagogiques)</p>
		<p>Assurez-vous d'avoir sous la main les fichiers suivants (la casse doit tre respecte)&nbsp;:</p>
    	
    	<ul>
		<li><strong>Communs.xml/zip</strong> (export standard de SIECLE)</li>
		<li><strong>Nomenclature.xml/zip</strong> (export standard de SIECLE)</li>
		<li><strong>Structures.xml/zip</strong> (export standard de SIECLE)</li> 
		<li><strong>sts_emp_RNE_annee.xml</strong> (export standard de STS WEB)</li>
		<li><strong>Facultatif : EDT_vers_STS_RNE_annee.xml</strong> (export XML de votre application d'emplois du temps vers STS WEB : Si votre fichier n'a pas le nom indiqu, renommez-le correctement en respectant la casse)
		<br/><span class='rouge'>ATTENTION : si ce fichier est fourni, il est IMPRATIF que les noms des groupes soient IDENTIQUES avec ceux prsents dans le fichier sts_emp_RNE_annee.xml !</span>
		<br />Si ce fichier n'est pas fourni, les emplois du temps ne seront pas disponibles dans <abbr title='IntraEduWeb'>IEW</abbr>
		<br />Voir la documentation Administrateur pour davantage de dtails.
		</li>
		</ul>
    	<p>Cliquez sur le bouton parcourir et slectionnez les fichiers&nbsp;:</p><br />
    	<input type='hidden' name='MAX_FILE_SIZE' value='1000000' />
    	<label id='L_Form_Req_Communs_Filename' for='Form_Req_Communs_Filename'>Communs.xml/ExportXML_Communs.zip</label>
    	<input id='Form_Req_Communs_Filename' name='Communs' type='file' aria-labelledby='L_Form_Req_Communs_Filename' /><br/><br />
    	<input type='hidden' name='MAX_FILE_SIZE' value='1000000' />
    	<label id='L_Form_Req_Nomenclature_Filename' for='Form_Req_Nomenclature_Filename'>Nomenclature.xml/ExportXML_Nomenclature.zip</label>
    	<input id='Form_Req_Nomenclature_Filename' name='Nomenclature' type='file' aria-labelledby='L_Form_Req_Nomenclature_Filename' /><br /><br />
    	<input type='hidden' name='MAX_FILE_SIZE' value='1000000' />
    	<label id='L_Form_Req_Structures_Filename' for='Form_Req_Structures_Filename'>Structures.xml/ExportXML_Structures.zip</label>
    	<input id='Form_Req_Structures_Filename' name='Structures' type='file' aria-labelledby='L_Form_Req_Structures_Filename' /><br /><br />
    	<input type='hidden' name='MAX_FILE_SIZE' value='1000000' />
    	<label id='L_Form_Req_sts_emp_Filename' for='Form_Req_sts_emp_Filename'>sts_emp_RNE_annee.xml</label>
    	<input id='Form_Req_sts_emp_Filename' name='sts_emp_RNE_annee' type='file' aria-labelledby='L_Form_Req_sts_emp_Filename' /><br /><br />
    	<input type='hidden' name='MAX_FILE_SIZE' value='1000000' />
    	<label id='L_Form_EDT_vers_STS_Filename' for='Form_EDT_vers_STS_Filename'>EDT_vers_STS_RNE_annee.xml</label>
    	<input id='Form_EDT_vers_STS_Filename' name='EDT_vers_STS_RNE_annee' type='file' aria-labelledby='L_Form_EDT_vers_STS_Filename' /><br /><br />".info_champs_obligatoires()."
    	<br /><p>Cliquez enfin sur le bouton &quot;Importer&quot;</p>
    	</div>";
    	
		break;
	case "elev":
		echo "<h1>Importer les lves et les responsables</h1>";
		$datmaj = get_date_last_update("elev");
		// MAX_FILE_SIZE est positionn en consquence car les fichiers sont volumineux (1  2 Mo)
    	// Si l'upload ne fonctionnepas malgr des fichiers corrects, alors il faut augmenter la valeur MAX_FILE_SIZE
  		$code_formulaire = "
  		<div style='text-align: justify;'>
    	<p>La dernire mise  jour date du : <strong>$datmaj</strong></p>
    	<p>Cette mise  jour est  effectuer  chaque mise  jour de la base lve SIECLE.</p>
    	<p>Assurez-vous d'avoir sous la main les fichiers suivants&nbsp;:</p><br/>
    	<ul>
    	<li><strong>ElevesAvecAdresses.xml<br />(ou ExportXML_ElevesAvecAdresses.zip)</strong></li>
    	<li><strong>ResponsablesAvecAdresses.xml<br />(ou ExportXML_ResponsablesAvecAdresses.zip)</strong></li>
    	</ul>
    	<p>provenant d'une extraction standard de SIECLE (indications donnes dans la documentation du gestionnaire de contenu IEW).</p><br />
    	<p>Cliquez le bouton parcourir et slectionnez&nbsp;:</p><br />
    	<input type='hidden' name='MAX_FILE_SIZE' value='2000000' />
    	<label id='L_Form_Req_Eleves_Filename' for='Form_Req_Eleves_Filename'>le fichier ElevesAvecAdresses.xml<br />(ExportXML_ElevesAvecAdresses.zip)</label>
    	<input id='Form_Req_Eleves_Filename' name='ElevesAvecAdresses' type='file' aria-labelledby='L_Form_Req_Communs_Filename' />
    	<br /><br /><p>Cliquez le bouton parcourir et slectionnez&nbsp;:</p><br />
    	<label id='L_Form_Req_Parents_Filename' for='Form_Req_Parents_Filename'>le fichier ResponsablesAvecAdresses.xml<br />(ExportXML_ResponsablesAvecAdresses.zip)</label><br />
    	<input type='hidden' name='MAX_FILE_SIZE' value='2000000' />
    	<input id='Form_Req_Parents_Filename' name='ResponsablesAvecAdresses' type='file' aria-labelledby='L_Form_Req_Parents_Filename' />
    	<br /><br />Cliquez enfin sur le bouton &quot;Mettre  jour&quot; et patientez; le traitement peut durer jusqu' 2 minutes.
    	</div><br />";
		break;
	default:
		$error_message = array("Les paramtres dans l'url ont t modifis et ne sont pas ceux attendus !","");
		affiche_erreurs($error_message);
		return;
}

// Bloc pour l'affichage du loader (sans contenu au dpart)
echo "<div id='wait_message'></div>";

// Bloc pour l'affichage du message de succs de l'opration (non affich au dpart CSS display : none;)
// contient un bloc id='uploadStatus_ok' contenant le message  afficher (sans contenu au dpart)
echo "
	<center>
	<div id='upload_ok_msg' class='encadrer ok_message'>
	<center>
	<table width='50%'>
	<tr>
	<td align='center'><img src='".$GLOBALS['racine']."images/trophees001.gif' alt='' /></td>
	<td align='center'><div class='texterror-warning'>Opration Russie !</div></td>
	<td align='center'><img src='".$GLOBALS['racine']."images/trophees001.gif' alt='' /></td>
	</tr>
	</table>
	</center>
	<div id='uploadStatus_ok'></div>
	</div></center>";

// Bloc pour l'affichage d'un message d'erreur ventuel (non affich au dpart CSS display : none;)
// contient un bloc id='uploadStatus_error' contenant le message  afficher (sans contenu au dpart)
	echo "
   	<center>
   	<div id='upload_error_msg' class='texterror'>
   	<center>
   	<table width='50%'>
   	<tr>
   	<td align='center'>
   	<img src='".$GLOBALS['racine']."images/warning.gif' alt='' />
   	</td>
   	<td align='center'>
   	<div class='texterror-warning'>ATTENTION</div>
   	</td>
   	<td align='center'>
   	<img src='".$GLOBALS['racine']."images/warning_right.gif' alt='' />
   	</td>
   	</tr>
   	</table>
   	</center>
	<div id='uploadStatus_error'></div>
	</div></center>
   			";
// Bloc contenant le rsum du rapport d'importation
	echo "<div id='resume_rapport'></div>";
	
// Bloc contenant le formulaire d'upload des fichiers
	echo "<div id='form_container'>";

echo "<center>";
squelette_formulaire_upload("90%","multipart/form-data","post","upload_imports.php?validation=php&amp;type=".$_GET['type'],"<h2>Tlchargement des fichiers ncessaires</h2>",$code_formulaire,"Importer","uploadSubmit","Annuler","annuler","","","","","id='uploadForm'");
echo "</center>";
echo "</div>";


// voil l'iframe utilise par le script upload_imports.php (attribut action du formulaire)
// pour faire de l'iframe loading
echo "<iframe id='uploadFrame' name='uploadFrame' src='#'></iframe>";
?>