<?php
/**
 * c_saisie_semab.php
 *
 * Ce script permet d'afficher le formulaire de saisie des priodes de vacances scolaires,
 * des dates de dbut et de fin de trimestre
 * Utilisation : Une SEULE fois par an avant la rentre scolaire
 * 
 *  priori, la procdure ne peut pas tre automatise par des imports XML, car la table semaines_alternances
 * remplie par le script c_imports.php, ne contient aucune rfrence aux dates des vacances, ni au dcoupage
 * en trimestre et demi-priodes pour la notation (qui se fait  l'initiative de l'tablissement)
 * 
 * Ce fichier fait partie du projet IntraEduWeb (IEW)
 * 
 * @package		IEW
 * @author			Sylvain GODM <sylvain.godme@gmail.com>
 * @version		$LastChangedRevision$, $LastChangedDate$
 * @copyright		2004-2012 Sylvain GODM
 * @link			http://iew.free.fr
 * @license		GPL License version 3 (http://www.gnu.org/licenses/gpl.html)
 * @filesource
 * 
 */

/* Dclaration de fonctions */
function imprimer_form($date_rentree, $dbt_toussaint, $fin_toussaint, $dbt_noel, $fin_noel, 
 $dbt_fev, $fin_fev, $dbt_paq, $fin_paq, $dbt_1t, $fin_1t, $p_1t, $dbt_2t, $fin_2t, $p_2t, 
 $dbt_3t, $fin_3t, $p_3t, $dbt_ete) 
{
	$code_formulaire = "<br />
 <div align='justify'>
 	Rentrez les dates au format <font color='red'><b>jj-mm-aaaa</b></font>. Cliquer sur le datepicker (petit calendrier) dans chaque champ de saisie pour vous faciliter la saisie de la date.
 	<br />
 	<i>Pour les vacances, les dates de <u>dbut</u> doivent correspondre au <u>dernier jour de classe</u> et les dates de <u>fin</u> au <u>premier jour de la reprise des cours</u>.</i>
 </div>
 <br /><br />
 	<label for='Form_Req_Date_rentree'>Date de la rentre des lves</label> : 
 	<input type='text' id='Form_Req_Date_rentree' name='date_rentree' class='datepicker' size='10' value='$date_rentree' /><br />
   	<br />
 	<strong>Vacances de toussaint</strong> 
 		<label for='Form_Req_dbt_toussaint'>du</label> : 
 		<input type='text' id='Form_Req_dbt_toussaint' name='dbt_toussaint' class='datepicker' size='10' value='$dbt_toussaint' />
   		<label for='Form_Req_fin_toussaint'>au</label> : 
   		<input type='text' id='Form_Req_fin_toussaint' name='fin_toussaint' class='datepicker' size='10' value='$fin_toussaint' /><br /><br />
 	<strong>Vacances de Nol</strong> 
 		<label for='Form_Req_dbt_noel'>du</label> : 
 		<input type='text' id='Form_Req_dbt_noel' name='dbt_noel' class='datepicker' size='10' value='$dbt_noel' />
   		<label for='Form_Req_fin_noel'>au</label> : 
   		<input type='text' id='Form_Req_fin_noel' name='fin_noel' class='datepicker' size='10' value='$fin_noel' /><br /><br />
 	<strong>Vacances de Fvrier</strong> 
 		<label for='Form_Req_dbt_fev'>du</label> : 
 		<input type='text' id='Form_Req_dbt_fev' name='dbt_fev' class='datepicker' size='10' value='$dbt_fev' />
   		<label for='Form_Req_fin_fev'>au</label> : 
   		<input type='text' id='Form_Req_fin_fev' name='fin_fev' class='datepicker' size='10' value='$fin_fev' /><br /><br />
 	<strong>Vacances de Pques</strong> 
 		<label for='Form_Req_dbt_paq'>du</label> : 
 		<input type='text' id='Form_Req_dbt_paq' name='dbt_paq' class='datepicker' size='10' value='$dbt_paq' />
   		<label for='Form_Req_fin_paq'>au</label> : 
   		<input type='text' id='Form_Req_fin_paq' name='fin_paq' class='datepicker' size='10' value='$fin_paq' /><br /><br /><hr />
 	<strong>1er Trimestre</strong> 
 		<label for='Form_Req_dbt_1t'>du</label> : 
 		<input type='text' id='Form_Req_dbt_1t' name='dbt_1t' class='datepicker' size='10' value='$dbt_1t' /> 
 		<label for='Form_Req_fin_1t'>au</label> : 
 		<input type='text' id='Form_Req_fin_1t' name='fin_1t' class='datepicker' size='10' value='$fin_1t' /><br /><br />
 	<strong>Fin de la premire priode</strong> 
 		<label for='Form_Req_p_1t'>le</label> : 
 		<input type='text' id='Form_Req_p_1t' name='p_1t' class='datepicker' size='10' value='$p_1t' /><br /><br /><hr />
 	<strong>2me Trimestre</strong> 
 		<label for='Form_Req_dbt_2t'>du</label> : 
 		<input type='text' id='Form_Req_dbt_2t' name='dbt_2t' class='datepicker' size='10' value='$dbt_2t' /> 
 		<label for='Form_Req_fin_2t'>au</label> : 
 		<input type='text' id='Form_Req_fin_2t' name='fin_2t' class='datepicker' size='10' value='$fin_2t' /><br /><br />
 	<strong>Fin de la premire priode</strong> 
 		<label for='Form_Req_p_2t'>le</label> : 
 		<input type='text' id='Form_Req_p_2t' name='p_2t' class='datepicker' size='10' value='$p_2t' /><br /><br /><hr />  
 	<strong>3me Trimestre</strong> 
 		<label for='Form_Req_dbt_3t'>du</label> : 
 		<input type='text' id='Form_Req_dbt_3t' name='dbt_3t' class='datepicker' size='10' value='$dbt_3t' /> 
 		<label for='Form_Req_fin_3t'>au</label> : 
 		<input type='text' id='Form_Req_fin_3t' name='fin_3t' class='datepicker' size='10' value='$fin_3t' /><br /><br />
    <strong>Fin de la premire priode</strong> 
 		<label for='Form_Req_p_3t'>le</label> : 
 		<input type='text' id='Form_Req_p_3t' name='p_3t' class='datepicker' size='10' value='$p_3t' /><br /><br /><hr /> 
    <strong>Vacances d't</strong> 
   		<label for='Form_Req_dbt_ete'>le</label> : 
 		<input type='text' id='Form_Req_dbt_ete' name='dbt_ete' class='datepicker' size='10' value='$dbt_ete' /><br />
   <br />".info_champs_obligatoires()."<br />";
   echo "<br />";
   squelette_formulaire_standard("100%","post",$_SERVER['PHP_SELF'],"Saisie de dates de calendrier",$code_formulaire,"Envoyer","soumettre","Annuler","annuler","","","");
}

function verif_form($date_rentree, $dbt_toussaint, $fin_toussaint, $dbt_noel, $fin_noel, 
 $dbt_fev, $fin_fev, $dbt_paq, $fin_paq, $dbt_1t, $fin_1t, $p_1t, $dbt_2t, $fin_2t, $p_2t, 
 $dbt_3t, $fin_3t, $p_3t, $dbt_ete) 
{
 if (!$date_rentree || !$dbt_toussaint || !$fin_toussaint || !$dbt_noel || !$fin_noel || !$dbt_fev
  || !$fin_fev || !$dbt_paq || !$fin_paq || !$dbt_1t || !$fin_1t || !$p_1t || !$dbt_2t || !$fin_2t 
  || !$p_2t || !$dbt_3t || !$fin_3t || !$p_3t || !$dbt_ete) // si un au moins de ces champs de formulaire sont vides
 { 
  $error_message = array("Il y a des champs de formulaire vides ! Remplissez correctement le formulaire.","");
  affiche_erreurs($error_message);
  imprimer_form($date_rentree, $dbt_toussaint, $fin_toussaint, $dbt_noel, $fin_noel,
  $dbt_fev, $fin_fev, $dbt_paq, $fin_paq, $dbt_1t, $fin_1t, $p_1t, $dbt_2t, $fin_2t, $p_2t, 
  $dbt_3t, $fin_3t, $p_3t, $dbt_ete);
 }
 else
 {
  /* vrification du format des dates entres et leur validit */
  $tableau = array($date_rentree, $dbt_toussaint, $fin_toussaint, $dbt_noel, $fin_noel, $dbt_fev, $fin_fev, $dbt_paq, $fin_paq, $dbt_1t, $p_1t, $fin_1t, $dbt_2t, $p_2t, $fin_2t, $dbt_3t, $p_3t, $fin_3t, $dbt_ete);
  if (verif_format_date_jjmmaa($tableau)) // si bon format
  {
    $err = 0;
    // On va vrifier la cohrence des dates :
    $tableau_coherence = array_chunk($tableau,9); // On spare le tableau $tableau en tableaux de 9 lments
    // 1. les dates de rentre, de vacances doivent tre dans l'ordre croissant
    if (!verif_dates_croissantes($tableau_coherence[0]))
    {
      $err = 1;
    }
    // 2. la date de dbut du 1er trimestre doit tre gal  la date de rentre
    elseif ($tableau_coherence[0][0] != $tableau_coherence[1][0])
    {
      $err = 2;
    }
    // 3. Les dates de dbut, de mi-priode et de fin de trimestre doivent tre croissantes du 1er au 3me trimestre
    elseif (!verif_dates_croissantes($tableau_coherence[1]))
    {
      $err = 3;
    }
    // 4. La date de fin du 3me trimestre doit tre gale  la date des grandes vacances
    elseif ($tableau_coherence[1][8] != $tableau_coherence[2][0])
    {
      $err = 4;
    }
    
    // On traite les erreurs ventuelles
    switch ($err)
    {
      case 1:
        $error_message = array("Les dates de rentre, de vacances ne sont pas dans l'ordre croissant ! Veuillez corriger cette incohrence.","");
        affiche_erreurs($error_message);
        imprimer_form($date_rentree, $dbt_toussaint, $fin_toussaint, $dbt_noel, $fin_noel, $dbt_fev, $fin_fev, $dbt_paq, $fin_paq, $dbt_1t, $fin_1t, $p_1t, $dbt_2t, $fin_2t, $p_2t, $dbt_3t, $fin_3t, $p_3t, $dbt_ete);
        break;
      case 2:
        $error_message = array("La date de dbut du 1er trimestre doit tre gal  la date de rentre ! Veuillez corriger cette incohrence.","");
        affiche_erreurs($error_message);
        imprimer_form($date_rentree, $dbt_toussaint, $fin_toussaint, $dbt_noel, $fin_noel, $dbt_fev, $fin_fev, $dbt_paq, $fin_paq, $dbt_1t, $fin_1t, $p_1t, $dbt_2t, $fin_2t, $p_2t, $dbt_3t, $fin_3t, $p_3t, $dbt_ete);
        break;
      case 3:
        $error_message = array("Les dates de dbut, de mi-priode et de fin de trimestre ne sont pas dans l'ordre croissant ! Veuillez corriger cette incohrence et vrifier pour chaque trimestre.","");
        affiche_erreurs($error_message);
        imprimer_form($date_rentree, $dbt_toussaint, $fin_toussaint, $dbt_noel, $fin_noel, $dbt_fev, $fin_fev, $dbt_paq, $fin_paq, $dbt_1t, $fin_1t, $p_1t, $dbt_2t, $fin_2t, $p_2t, $dbt_3t, $fin_3t, $p_3t, $dbt_ete);
        break;
      case 4:
        $error_message = array("La date de fin du 3me trimestre doit tre gale  la date des grandes vacances ! Veuillez corriger cette incohrence.","");
        affiche_erreurs($error_message);
        imprimer_form($date_rentree, $dbt_toussaint, $fin_toussaint, $dbt_noel, $fin_noel, $dbt_fev, $fin_fev, $dbt_paq, $fin_paq, $dbt_1t, $fin_1t, $p_1t, $dbt_2t, $fin_2t, $p_2t, $dbt_3t, $fin_3t, $p_3t, $dbt_ete);
        break;
      default: // Pas d'erreur
        confirm_form($date_rentree, $dbt_toussaint, $fin_toussaint, $dbt_noel, $fin_noel, $dbt_fev, $fin_fev, $dbt_paq, $fin_paq, $dbt_1t, $fin_1t, $p_1t, $dbt_2t, $fin_2t, $p_2t, $dbt_3t, $fin_3t, $p_3t, $dbt_ete);
    }
  }
  else
  {
    //////////////////////// certaines donnes saisies ne sont pas au format spcifi donc recommencer !
   if (isset($_SESSION['message_erreur_precision']))
   {
     $error_message = array($_SESSION['message_erreur_precision'],"");
     unset($_SESSION['message_erreur_precision']);
   }
   else
   {
     $error_message = array("Il y a des dates mal formates ! Remplissez correctement les champs en respectant le format jj-mm-aaaa.","");
   }
   affiche_erreurs($error_message);
   imprimer_form($date_rentree, $dbt_toussaint, $fin_toussaint, $dbt_noel, $fin_noel, 
   $dbt_fev, $fin_fev, $dbt_paq, $fin_paq, $dbt_1t, $fin_1t, $p_1t, $dbt_2t, $fin_2t, $p_2t, 
   $dbt_3t, $fin_3t, $p_3t, $dbt_ete);
  }
 }
} // fin de fonction verif_form


function confirm_form($date_rentree, $dbt_toussaint, $fin_toussaint, $dbt_noel, $fin_noel, 
  $dbt_fev, $fin_fev, $dbt_paq, $fin_paq, $dbt_1t, $fin_1t, $p_1t, $dbt_2t, $fin_2t, $p_2t, 
  $dbt_3t, $fin_3t, $p_3t, $dbt_ete)
{
  $_SESSION['dates_semab'] = $_POST; // On rcupre le POST Prcdent dans une variable de session
  $code_formulaire = "<br /><b>Veuiller vrifier les informations que vous avez saisies SVP :</b><br />
  <br />
  <table border='0' width='100%'>
   <tr>
    <td>Date de la rentre des lves :</td>
    <td>".format_date_long($GLOBALS['default_language'],preg_replace("#-#","/",$date_rentree))."</td>
   </tr>
   <tr>
    <td><img src='".$GLOBALS['chemin_relatif']."/images/pixel.gif' height='10' alt='' /></td>
    <td></td>
   </tr>
   <tr>
    <td>Dbut des vacances de toussaint :</td>
    <td>".format_date_long($GLOBALS['default_language'],preg_replace("#-#","/",$dbt_toussaint))."</td>
   </tr>
   <tr>
    <td>Fin des vacances de toussaint :</td> 
    <td>".format_date_long($GLOBALS['default_language'],preg_replace("#-#","/",$fin_toussaint))."</td>
   </tr>
   <tr>
    <td>Dbut des vacances de nol :</td> 
    <td>".format_date_long($GLOBALS['default_language'],preg_replace("#-#","/",$dbt_noel))."</td>
   </tr>
   <tr>
    <td>Fin des vacances de nol :</td>
    <td>".format_date_long($GLOBALS['default_language'],preg_replace("#-#","/",$fin_noel))."</td>
   </tr>
   <tr>
    <td>Dbut des vacances de fvrier :</td>
    <td>".format_date_long($GLOBALS['default_language'],preg_replace("#-#","/",$dbt_fev))."</td>
   </tr>
   <tr>
    <td>Fin des vacances de fvrier :</td>
    <td>".format_date_long($GLOBALS['default_language'],preg_replace("#-#","/",$fin_fev))."</td>
   </tr>
   <tr>
    <td>Dbut des vacances de pques :</td>    
    <td>".format_date_long($GLOBALS['default_language'],preg_replace("#-#","/",$dbt_paq))."</td>
   </tr>
   <tr>
    <td>Fin des vacances de pques :</td>
    <td>".format_date_long($GLOBALS['default_language'],preg_replace("#-#","/",$fin_paq))."</td>
   </tr>
   <tr>
    <td><img src='".$GLOBALS['chemin_relatif']."/images/pixel.gif' height='10' alt='' /></td>
    <td></td>
   </tr>
   <tr>
    <td>Dbut du 1er trimestre :</td>
    <td>".format_date_long($GLOBALS['default_language'],preg_replace("#-#","/",$dbt_1t))."</td>
   </tr>
   <tr>
    <td>Fin de la 1re priode (1er trimestre) :</td>
    <td>".format_date_long($GLOBALS['default_language'],preg_replace("#-#","/",$p_1t))."</td>
   </tr>
   <tr>
    <td>Fin du 1er trimestre :</td>
    <td>".format_date_long($GLOBALS['default_language'],preg_replace("#-#","/",$fin_1t))."</td>
   </tr>
   <tr>
    <td>Dbut du 2me trimestre :</td>
    <td>".format_date_long($GLOBALS['default_language'],preg_replace("#-#","/",$dbt_2t))."</td>
   </tr>
   <tr>
    <td>Fin du 2me trimestre :</td>
    <td>".format_date_long($GLOBALS['default_language'],preg_replace("#-#","/",$fin_2t))."</td>
   </tr>
   <tr>
    <td>Fin de la 1re priode (2me trimestre) :</td>
    <td>".format_date_long($GLOBALS['default_language'],preg_replace("#-#","/",$p_2t))."</td>
   </tr>
   <tr>
    <td>Dbut du 3me trimestre :</td>
    <td>".format_date_long($GLOBALS['default_language'],preg_replace("#-#","/",$dbt_3t))."</td>
   </tr>
   <tr>
    <td>Fin de la 1re priode (3me trimestre) :</td>
    <td>".format_date_long($GLOBALS['default_language'],preg_replace("#-#","/",$p_3t))."</td>
   </tr>
   <tr>
    <td>Fin du 3me trimestre :</td>
    <td>".format_date_long($GLOBALS['default_language'],preg_replace("#-#","/",$fin_3t))."</td>
   </tr>
   <tr>
    <td><img src='".$GLOBALS['chemin_relatif']."/images/pixel.gif' height='10' alt='' /></td>
    <td></td>
   </tr>
   <tr>
    <td>Dbut des vacances d't :</td>
    <td>".format_date_long($GLOBALS['default_language'],preg_replace("#-#","/",$dbt_ete))."</td>
   </tr>
  </table>
  <br />En cas de problme, vous pouvez <a href='".$_SERVER['PHP_SELF']."?annuler=oui' title='recommencer ou modifier la saisie des dates du calendrier scolaire'>recommencer ou faire une modification</a>.<br />
  <!-- les champs de formulaire suivants sont cachs  l'utilisateur et reprennent les valeurs dj
   entres dans le formulaire prcdent. Ceci permet la transmission des variables au script dfini
   par l'attribut action du formulaire -->
   <input type='hidden' name='date_rentree' size='10' value='$date_rentree' />
   <input type='hidden' name='dbt_toussaint' size='10' value='$dbt_toussaint' />
   <input type='hidden' name='fin_toussaint' size='10' value='$fin_toussaint' />
   <input type='hidden' name='dbt_noel' size='10' value='$dbt_noel' />
   <input type='hidden' name='fin_noel' size='10' value='$fin_noel' />
   <input type='hidden' name='dbt_fev' size='10' value='$dbt_fev' />
   <input type='hidden' name='fin_fev' size='10' value='$fin_fev' />
   <input type='hidden' name='dbt_paq' size='10' value='$dbt_paq' />
   <input type='hidden' name='fin_paq' size='10' value='$fin_paq' />
   <input type='hidden' name='dbt_1t' size='10' value='$dbt_1t' />
   <input type='hidden' name='fin_1t' size='10' value='$fin_1t' />
   <input type='hidden' name='p_1t' size='10' value='$p_1t' />
   <input type='hidden' name='dbt_2t' size='10' value='$dbt_2t' /> 
   <input type='hidden' name='fin_2t' size='10' value='$fin_2t' />
   <input type='hidden' name='p_2t' size='10' value='$p_2t' /><br />
   <input type='hidden' name='dbt_3t' size='10' value='$dbt_3t' />
   <input type='hidden' name='fin_3t' size='10' value='$fin_3t' />
   <input type='hidden' name='p_3t' size='10' value='$p_3t' />
   <input type='hidden' name='dbt_ete' size='10' value='$dbt_ete' />
    <!-- fin des champs cachs -->   
  ";
  echo "<br /><center>";
  squelette_formulaire_standard("100%","post",$_SERVER['PHP_SELF'],"Vrification de la saisie",$code_formulaire,"Confirmer la saisie","confirmer","","","","","");
  echo "</center>";
}

function verif_format_date_jjmmaa($tableau)
{
   // DEBUGG var_dump($tableau);  
   foreach($tableau as $value)
   { // la vrification porte sur chaque variable
   		// DEBUGG print "<br/>$value : ";
   		if (preg_match("#^[0-9]{1,2}-[0-9]{1,2}-([0-9]{4})$#", $value)) // format jj-mm-aaaa ?
    	{ 
      		// DEBUGG print "Format OK";
      		$element=preg_split("#-#", $value);
      		// DEBUGG print " $element[0]";
      		if (($element[0]>=0)&&($element[0]<=31)):
      		else :
       			// DEBUGG print " PB ";
      			return false;
      		endif;
      		// DEBUGG print " $element[1]";
      		if (($element[1]>=0)&&($element[1]<=12)):
      		else :
      			// DEBUGG print " PB ";
       			return false;
      		endif;
      		// DEBUGG print " $element[2]";
      		if (($element[2]>=0)&&($element[2]<=9999)):
      		else :
      			// DEBUGG print " PB ";
       			return false;
      		endif;
   		}
   		else
   		{
   			// DEBUGG print " Mauvais Format ";
    		return false;
   		}
	  	// Pendant qu'on y est, on vrifie si la date correspond bien  un jour ouvrable de la semaine dans l'tablissement
   		$jour = preg_split("# #", format_date_long($GLOBALS['default_language'],preg_replace("#-#","/",$value)));
   		// DEBUGG var_dump($jour);
   		if (!in_array($jour[0],$GLOBALS['jours_ouvrables']))
   		{
     		$_SESSION['message_erreur_precision'] = "Le ".format_date_long($GLOBALS['default_language'],preg_replace("#-#","/",$value))." n'est pas un jour ouvrable dans l'tablissement";
     		return false;
   		}
  } // fin de boucle foreach
  return true;
}

function verif_dates_croissantes($tableau)
{
  $timestamp_array = array();
  foreach($tableau as $value)
  { 
    $element=preg_split("#-#", $value); // On spare jj, mm et aaaa
    // On gnre un timestamp de chaque date pour vrifier si elles sont bien en ordre croissant
    $timestamp = mktime(0,0,0,$element[1],$element[0],$element[2]);
    $timestamp_array[] = $timestamp; // On ajoute la valeur au tableau
  } // fin de boucle foreach
  foreach ($timestamp_array as $value) // On va vrifier si les dates sont bien en ordre croissant
  {
    $cle = key($timestamp_array)-1; // On rcupre la cl de l'lment courant
    $cle_precedente = $cle-1; // on pointe sur l'lment prcdent
    if ($cle_precedente>-1) // Le premier lment ne sera pas compar avec le prcdent puisqu'il n'existe pas !
    {
      if ($value <= $timestamp_array["$cle_precedente"])
      {
       	return false;
      }
    }
    next($timestamp_array);
  }
  return true;
}

/* Dbut du progamme principal */
// Le script en cours doit tre le script d'appel prvu
if (end_with_string($_SERVER['PHP_SELF'],"prive/admin/prive/saisie_semab.php"))
{
  echo "<h1>Saisie des dates des priodes de cours et de vacances</h1>";
  if (!isset($_POST['confirmer'])) // Pas encore de confirmation des dates
  {
    if (!isset($_POST['soumettre'])) // formulaire pas encore soumis, on affiche un formulaire vierge
    {
        connexion_mysql();
        select_database();
        $sql = "select * from semab";
        $resultat = @mysql_query($sql);
        if (!$resultat || mysql_num_rows($resultat)==0) // si rien dans la bdd, on affiche un formulaire vierge
        {
          imprimer_form("", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "");
        }
        else // s'il y a quelque chose dj, on affiche les valeurs actuelles
        {
          $ligne = mysql_fetch_array($resultat);
          // mais il faut reformater les dates mysql en jj-mm-aa
          $date_rentree = date_mysql_to_jjmmaaaa_tiret($ligne['date_rentree']);
          $dbt_toussaint = date_mysql_to_jjmmaaaa_tiret($ligne['dbt_toussaint']);
          $fin_toussaint = date_mysql_to_jjmmaaaa_tiret($ligne['fin_toussaint']);
          $dbt_noel = date_mysql_to_jjmmaaaa_tiret($ligne['dbt_noel']);
          $fin_noel = date_mysql_to_jjmmaaaa_tiret($ligne['fin_noel']);
          $dbt_fev = date_mysql_to_jjmmaaaa_tiret($ligne['dbt_fev']);
          $fin_fev = date_mysql_to_jjmmaaaa_tiret($ligne['fin_fev']);
          $dbt_paq = date_mysql_to_jjmmaaaa_tiret($ligne['dbt_paq']);
          $fin_paq = date_mysql_to_jjmmaaaa_tiret($ligne['fin_paq']);
          $dbt_1t = date_mysql_to_jjmmaaaa_tiret($ligne['dbt_1t']);
          $fin_1t = date_mysql_to_jjmmaaaa_tiret($ligne['fin_1t']);
          $p_1t = date_mysql_to_jjmmaaaa_tiret($ligne['p_1t']);
          $dbt_2t = date_mysql_to_jjmmaaaa_tiret($ligne['dbt_2t']);
          $fin_2t =date_mysql_to_jjmmaaaa_tiret($ligne['fin_2t']);
          $p_2t = date_mysql_to_jjmmaaaa_tiret($ligne['p_2t']);
          $dbt_3t = date_mysql_to_jjmmaaaa_tiret($ligne['dbt_3t']);
          $fin_3t = date_mysql_to_jjmmaaaa_tiret($ligne['fin_3t']);
          $p_3t = date_mysql_to_jjmmaaaa_tiret($ligne['p_3t']);
          $dbt_ete = date_mysql_to_jjmmaaaa_tiret($ligne['dbt_ete']);
          imprimer_form($date_rentree, $dbt_toussaint, $fin_toussaint, $dbt_noel, $fin_noel, $dbt_fev, $fin_fev, $dbt_paq, $fin_paq, $dbt_1t, $fin_1t, $p_1t, $dbt_2t, $fin_2t, $p_2t, $dbt_3t, $fin_3t, $p_3t, $dbt_ete);
        }
    }
    else // Le formulaire est soumis, on va vrifier les donnes
    {
      if (isset($_GET['annuler']) && $_GET['annuler']=="oui") // On vient d'annuler la confirmation des entres de formulaire (donc les champ hidden ne sont pas transmis car le POST par le bouton Confirmer n'a pas eu lieu)
      {  
        // On rcupre les donnes postes avant la demande de confirmation par la variable de session utilise pour ce stockage
        if (isset($_SESSION['dates_semab']))
        {  
          // DEBUGG var_dump($_SESSION['dates_semab']);
          reset($_SESSION['dates_semab']);
		  while (list($cle, $value) = each($_SESSION['dates_semab']))
		  {
    	  	$$cle = stripslashes($value); // Forme une variable ayant pour nom la cl courante et lui donne la valeur de l'lment courant
		  }
        } // on reprend le forumlaire avec les valeurs antrieures  la demande d'annulation
        imprimer_form($date_rentree, $dbt_toussaint, $fin_toussaint, $dbt_noel, $fin_noel, $dbt_fev, $fin_fev, $dbt_paq, $fin_paq, $dbt_1t, $fin_1t, $p_1t, $dbt_2t, $fin_2t, $p_2t, $dbt_3t, $fin_3t, $p_3t, $dbt_ete);
        // on rinitialise les variables ayant conduit ici
        unset($_GET['annuler']);
      }
      else // formulaire soumis mais pas d'annulation demande dans l'url (cas normal  la soumission du formulaire des dates
      {
        verif_form($_POST['date_rentree'], $_POST['dbt_toussaint'], $_POST['fin_toussaint'], $_POST['dbt_noel'], $_POST['fin_noel'], $_POST['dbt_fev'], $_POST['fin_fev'], $_POST['dbt_paq'], $_POST['fin_paq'], $_POST['dbt_1t'], $_POST['fin_1t'], $_POST['p_1t'], $_POST['dbt_2t'], $_POST['fin_2t'], $_POST['p_2t'], $_POST['dbt_3t'], $_POST['fin_3t'], $_POST['p_3t'], $_POST['dbt_ete']);
      }
    }
    
  }
  else // On vient de confirmer les entres de formulaire, on va stocker dans la base de donnes
  {
    
  	// DEBUGG print "Variables de session : "; var_dump($_SESSION['dates_semab']); print "<br />";
    $tableau = array($_POST['date_rentree'], $_POST['dbt_toussaint'], $_POST['fin_toussaint'], $_POST['dbt_noel'], $_POST['fin_noel'], $_POST['dbt_fev'], $_POST['fin_fev'], $_POST['dbt_paq'], $_POST['fin_paq'], $_POST['dbt_1t'], $_POST['fin_1t'], $_POST['p_1t'], $_POST['dbt_2t'], $_POST['fin_2t'], $_POST['p_2t'], $_POST['dbt_3t'], $_POST['fin_3t'], $_POST['p_3t'], $_POST['dbt_ete']);
    // DEBUGG print "Variables du POST : "; var_dump($tableau); print "<br />";
    $i=1;
    unset($_SESSION['dates_semab']);
    foreach($tableau as $value)
    { 
      // formate les dates pour mysql en aaaa-mm-jj
      list($jour,$mois,$annee)=explode("-",$value);
      $value_a_ecrire[$i]=quote_smart("$annee-$mois-$jour");
      // DEBUGG print "Valeur  crire : $value_a_ecrire[$i]<br />";
      $i++;
    }
    connexion_mysql();
    select_database();
    $sql = "DELETE FROM semab";
    mysql_query($sql);
    $sql = "INSERT INTO semab VALUES('$value_a_ecrire[1]','$value_a_ecrire[2]','$value_a_ecrire[3]','$value_a_ecrire[4]','$value_a_ecrire[5]','$value_a_ecrire[6]','$value_a_ecrire[7]','$value_a_ecrire[8]','$value_a_ecrire[9]','$value_a_ecrire[10]','$value_a_ecrire[11]','$value_a_ecrire[12]','$value_a_ecrire[13]','$value_a_ecrire[14]','$value_a_ecrire[15]','$value_a_ecrire[16]','$value_a_ecrire[17]','$value_a_ecrire[18]','$value_a_ecrire[19]')";
    if (mysql_query($sql))
    {
      $ok_message = "La Base de donnes vient d'tre mise  jour. Vos dates ont t prises en compte ...<br />Vous pouvez <a href='imprim_semab.php' target='_blank'> imprimer le calendrier des semaines</a> pour la reprographie ou <a href='../../../semab.php'>voir le calendrier des semaines</a> tel qu'il sera affich sur le site.";
      echo "<br />";
      affiche_ok($ok_message);
      // On met aussi  jour la date limite des mots de passe des utilisateurs locaux  la date de la fin des cours de l'anne scolaire
      $sql2 = "UPDATE login SET limit_date_passwd='$value_a_ecrire[19]' WHERE limit_date_passwd IS NOT NULL"; // les utilisateurs locaux sont reconnaissables car leur limit_date_passwd n'est pas NULL contrairement  ceux qui sont identifis non nativement
      mysql_query($sql2);
      // On efface les variables utilises jusque l
      unset($_SESSION['post_imprimable']);
      unset($_POST);
    }
    else
    {
      $error_message = array("La base de donnes n'a pas pu tre mises  jour. Veuillez <a href=''>recommencer</a>.<br />Si le problme persiste, prvenez votre <a href='mailto:".email_encode($GLOBALS['admin_email'])."'>Administrateur IntaEduWeb</a>","");
      affiche_erreurs($error_message);
    }
  }
}
else // L'utilisateur essaie d'invoquer ce script directement dans l'URL (interdit)
{
  $error_message = array("Vous tentez d'accder  un script qui n'est pas accessible directement  partir de l'URL... Utilisez les liens de navigation !","");
  affiche_erreurs($error_message);
}
?>