<?php
/**
 * imprim_semab.php
 *
 * Ce script permet d'imprimer le calendrier ds semaines A et B en dbut d'anne scolaire
 * Utilisation : Une SEULE fois par an avant la rentre scolaire
 * 
 * Ce fichier fait partie du projet IntraEduWeb (IEW)
 * 
 * @package		IEW
 * @author			Sylvain GODM <sylvain.godme@gmail.com>
 * @version		$LastChangedRevision$, $LastChangedDate$
 * @copyright		2004-2012 Sylvain GODM
 * @link			http://iew.free.fr
 * @license		GPL License version 3 (http://www.gnu.org/licenses/gpl.html)
 * @filesource
 * 
 */

/* Ce script est  lancer une fois par an aprs la rentre scolaire et avoir utilis le script saisie_
semab.php. Il faudrait trouver le moyen de produire une fois pour toutes une page html qui donnera le calendrier
de  l anne scolaire, il est inutile de devoir recalculer la mme chose  chaque demande de cette page */

if(!defined('IEW_DIR')) define('IEW_DIR',realpath(dirname(__FILE__)."/../../../").'/');
// Inclusions
require_once(IEW_DIR."librairie_fonctions.php");

debut_code_html("popup");

$chemin_relatif = "../../../"; // indique comment retrouver le rpertoire racine (pour le dossier 'images' par exemple)
$array_valid_user=array("1","5"); // les groupes admin et gestadmin ont seuls une autorisation d'accs (c'est le groupe charg de la gestion administrative du contenu de l'intranet)
$error_message = check_valid_user($array_valid_user);
if (isset($error_message))
{
  affiche_erreurs($error_message);
  exit;
}

/* Dclaration des fonctions */

function colorsemab($bgcolor,$date,$p_1t,$p_2t,$p_3t,$fin_1t,$fin_2t,$fin_3t) {		// dtermine la couleur du fond de la cellule en fonction de la semaine A ou B
 if ($bgcolor=="#FFCCFF"):
  $affichage = "A";
 else:
  $affichage = "B";
 endif;
 ?>
 <td width="105" align="center"><?php echo $affichage ?></td>
 <?php
}

/* Dbut du programme principal */

$langue="fr";
if($langue!="fr")
{
    include("../../../date_".$langue.".php");
}
else
{
    include("../../../date_fr.php");
}

// initialisations
$semaine_depart = "A"; // La 1re semaine de cours est une semaine A, pour changer, il suffit de modifier cette valeur
$semab = array(); // Tableau qui contiendra en cl les numros de semaine de l'anne travailles (1  52) et en valeur A ou B
$num_sem_trav = array(); // Tableau contenant les numros de semaines travailles
$i = 0;
// On regarde si le samedi est ouvrable ou non
$dernier_jour = array_pop($GLOBALS['jours_ouvrables']);
if ($dernier_jour == "Samedi")
  $weekend = array("D");
else
  $weekend = array("S","D");


/* Acquisition des variables dates de la table semab utilises pour dterminer le calendrier */
 connexion_mysql();
 select_database();
 $sql = "select * from semab";
 $resultat = mysql_query($sql);
 $nbligne = mysql_num_rows($resultat);
 for ($i=1;$i<=$nbligne;$i++){
  $variable = mysql_fetch_array($resultat); 
 }
 $date_rentree = $variable["date_rentree"];
 $dbt_toussaint = $variable["dbt_toussaint"];
 $fin_toussaint = $variable["fin_toussaint"];
 $dbt_noel = $variable["dbt_noel"];
 $fin_noel = $variable["fin_noel"];
 $dbt_fev = $variable["dbt_fev"];
 $fin_fev = $variable["fin_fev"];
 $dbt_paq = $variable["dbt_paq"];
 $fin_paq = $variable["fin_paq"];
 $dbt_1t = $variable["dbt_1t"];
 $fin_1t = $variable["fin_1t"];
 $p_1t = $variable["p_1t"];
 $dbt_2t = $variable["dbt_2t"];
 $fin_2t = $variable["fin_2t"];
 $p_2t = $variable["p_2t"];
 $dbt_3t = $variable["dbt_3t"];
 $fin_3t = $variable["fin_3t"];
 $p_3t = $variable["p_3t"];
 $dbt_ete = $variable["dbt_ete"];

 $annee = substr($date_rentree,0,4); // dtermine anne de rfrence  la date de rentre
 $fin_annee = $annee + 1;
 // le script est alors excutable  n importe quel moment de l anne scolaire
 
 
/*********************************** Dtermination des semaines A et B *****************************/

// cherche les numros de semaines de chaque date de vacances acquise plus haut

$tableau = array("date_rentree", "dbt_toussaint", "fin_toussaint", "dbt_noel", "fin_noel", 
  "dbt_fev", "fin_fev", "dbt_paq", "fin_paq", "dbt_ete");
$i=1;
foreach($tableau as $value) { // la vrification porte sur chaque variable
 $mois_tab=substr($$value,5,2);
 $jour_tab=substr($$value,8,2);
 $annee_tab=substr($$value,0,4); 
 $sem_trav[$i]=strftime("%W", mktime(0,0,0,$mois_tab,$jour_tab,$annee_tab));
$i++;
} 

$tableau=""; // rinitialisation du tableau car utilis plus loin
// Remplit le tableau $num_sem_trav contenant seulement les numros de semaines travailles
// si elles ne font pas partie des semaines da vacances

$k=1;
 for ($j=$sem_trav[1];$j<=52;$j++) { // de la semaine de rentree  fin dcembre
  if ((($j>$sem_trav[2]) && ($j<$sem_trav[3])) || ($j>$sem_trav[4])
   || ($j<$sem_trav[5])
   || (($j>$sem_trav[6]) && ($j<$sem_trav[7])) || (($j>$sem_trav[8]) && ($j<$sem_trav[9]))
   || (($j>$sem_trav[10]) && ($j<$sem_trav[1]))):
  else:
   $num_sem_trav[$k]=$j;
   $k++;
  endif;
 }

 for ($j=0;$j<=$sem_trav[10];$j++) {
 // la semaine zro existe si pas de lundi entre le 1 et 6 janv
 // de cette semaine de rentre nouvelle anne civile  la fin juin
  if ((($j>$sem_trav[2]) && ($j<$sem_trav[3])) || ($j>$sem_trav[4])
   || ($j<$sem_trav[5])
   || (($j>$sem_trav[6]) && ($j<$sem_trav[7])) || (($j>$sem_trav[8]) && ($j<$sem_trav[9]))
   || (($j>$sem_trav[10]) && ($j<$sem_trav[1]))):
  else:
   $num_sem_trav[$k]=$j;
   $k++;
  endif;
 }

/* rempli un tableau destin  recevoir pour chaque semaine travaille son type A ou B */

for ($i=1;$i<=count($num_sem_trav);$i++) {
 if(isset($num_sem_trav[$i-1])) // On commencera  1, pas  0
 {
   if (!isset($semab{$num_sem_trav[$i-1]})) // se produit pour la 1re semaine
     $semab{$num_sem_trav[$i-1]} = $semaine_depart;
   switch ($semab{$num_sem_trav[$i-1]})
   {
    case 'A':
     $semab{$num_sem_trav[$i]}="B";
     break;
    case 'B':
     $semab{$num_sem_trav[$i]}="A";
     break;
    default:
     $semab{$num_sem_trav[$i]}="A";
   }
 }
}



/**************************** Fin de dtermination des semaines A et B ******************************/

?>

<center>
<table border="0">
<tr><td align="center">
<h1>Calendrier des semaines &nbsp;&nbsp;(anne scolaire <?php echo $annee." - ".$fin_annee ?>)</h1>
</td>
</tr>
</table>
</center>

<center>
<table border="0" width="799">
  <tr>
    <td width="362">
    
    
    
    <!-- ************************** premier tableau (mois de septembre  janvier) ******************** -->
<table border="1" width="362">
  <tr>  <!-- voici la ligne entte contenant les mois de septembre a janvier -->
    <td width="145" bgcolor="#FFFF00" colspan="3" align="center"><b><?php echo $mois[8] ?></b></td>
    <td width="125" bgcolor="#FFFF00" colspan="2" align="center"><b><?php echo $mois[9] ?></b></td>
    <td width="125" bgcolor="#FFFF00" colspan="2" align="center"><b><?php echo $mois[10] ?></b></td>
    <td width="125" bgcolor="#FFFF00" colspan="2" align="center"><b><?php echo $mois[11] ?></b></td>
    <td width="125" bgcolor="#FFFF00" colspan="2" align="center"><b><?php echo $mois[0] ?></b></td>
  </tr>
  <?php
  $ligne=1;   // initialisation  la premire ligne du tableau
  $col_mois=9;  // initialisation de la premire colonne au mois de septembre
  while ($ligne<=30){ 
   ?>
   <tr>
    <td width="20" bgcolor="#FFFF00" align="center"><b><?php echo $ligne ?></b></td>  <!-- affiche le numro du jour du mois -->
     <?php
     while ($col_mois<=12) {  // boucle jusqu au mois de dcembre
      $j=$jour[date("w", mktime(0,0,0,$col_mois,$ligne,$annee))]; //dtermine le jour de la semaine
      ?>
      <td width="20" bgcolor="#FFCC99" align="center"><b><?php echo $j{0}  /* affiche la premire lettre du jour de la semaine */?></b></td>
      <?php
      if (in_array($j{0},$weekend)): // les cellules week end sont grises
       ?>
       <td width="105" align="center" bgcolor="#C0C0C0">&nbsp;</td>
       <?php
      else:  // si pas week end
      
       /* teste si c est un jour de vacances alors griser la cellule
       sinon si c est un jour de fin de priode insrer comme contenu /FIN 1er PERIODE/ et dans le
       cas contraire, ne rien afficher et dtermine si la semaine est A (fond rose) ou B (fond bleu)
       */
       $date=date("Y-m-d", mktime(0,0,0,$col_mois,$ligne,$annee)); // date du jour au format aaaa-mm-jj
       /* si la date du jour $ligne, $col_mois est un jour de vacances */
       if (($date<$date_rentree) || (($date>$dbt_toussaint) && ($date<$fin_toussaint)) 
        || (($date>$dbt_noel) && ($date<$fin_noel)) || (($date>$dbt_fev) && ($date<$fin_fev))
        || (($date>$dbt_paq) && ($date<$fin_paq)) || ($date>$dbt_ete)):
        ?>
        <td width="105" align="center" bgcolor="#C0C0C0">&nbsp;</td>
        <?php
       else :		// sinon fond normal
        /* reste  insrer la vrification des semaines A (fond rose) et B (fond bleu)*/
        $sem_actuelle=strftime("%W", mktime(0,0,0,$col_mois,$ligne,$annee));
        foreach($num_sem_trav as $value) {
         if ($sem_actuelle==$value):
          switch ($semab{$value}){
           case 'B':
            $bgcolor="#33CCFF";
            break;
           case 'A':
            $bgcolor="#FFCCFF";
            break;
          } 
         endif;
        }
        colorsemab($bgcolor,$date,$p_1t,$p_2t,$p_3t,$fin_1t,$fin_2t,$fin_3t);
       endif;
      endif;
      $col_mois++;
     } // on passe  la colonne suivante
     $col_mois=9; // valeur initialise  chaque ligne
     ?>
     <!--  **** cas particulier de la colonne du mois de janvier (numro thorique 13!)**** -->
     <td width="20" align="center" bgcolor="#FFCC99"><b><?php echo $jour[date("w", mktime(0,0,0,1,$ligne,$annee+ 1))]{0} ?></b></td>
     <?php
     if (in_array($jour[date("w", mktime(0,0,0,1,$ligne,$annee+ 1))]{0},$weekend)): // les cellules week end sont grises
       ?>
       <td width="105" align="center" bgcolor="#C0C0C0">&nbsp;</td>
       <?php
      else:  // si pas week end
      
       /* teste si c est un jour de vacances alors griser la cellule
       sinon si c est un jour de fin de priode insrer comme contenu /FIN 1er PERIODE/ et dans le
       cas contraire, ne rien afficher et dtermine si la semaine est A (fond rose) ou B (fond bleu)
       */
       $date=date("Y-m-d", mktime(0,0,0,1,$ligne,$annee+ 1)); // date du jour au format aaaa-mm-jj
       /* si la date du jour $ligne, $col_mois est un jour de vacances */
       if (($date<$date_rentree) || (($date>$dbt_toussaint) && ($date<$fin_toussaint)) 
        || (($date>$dbt_noel) && ($date<$fin_noel)) || (($date>$dbt_fev) && ($date<$fin_fev))
        || (($date>$dbt_paq) && ($date<$fin_paq)) || ($date>$dbt_ete)):
        ?>
        <td width="105" align="center" bgcolor="#C0C0C0">&nbsp;</td>
        <?php
       else :		// sinon fond normal
        /* reste  insrer la vrification des semaines A (fond rose) et B (fond bleu)*/
        $sem_actuelle=strftime("%W", mktime(0,0,0,1,$ligne,$annee+ 1));
        foreach($num_sem_trav as $value) {
         if ($sem_actuelle==$value):
          switch ($semab{$value}){
           case 'B':
            $bgcolor="#33CCFF";
            break;
           case 'A':
            $bgcolor="#FFCCFF";
            break;
          } 
         endif;
        }
        colorsemab($bgcolor,$date,$p_1t,$p_2t,$p_3t,$fin_1t,$fin_2t,$fin_3t);

        
       endif;
      endif;
      ?>
   </tr>
     <?php
     $ligne++;
   } // on passe  la ligne suivante
   
   // ***** Affichage du 31 ime jour le cas chant dans une 31 ime ligne *****
   ?>
   <tr>
   <td width="20" bgcolor="#FFFF00" align="center"><b>31</b></td>
   <?php
   while ($col_mois<=12){
     if (date("t", mktime(0,0,0,$col_mois,1,$annee))=="31"): // si le mois comporte 31 jours
     ?>
     <td width="20" align="center" bgcolor="#FFCC99"><b><?php echo $jour[date("w", mktime(0,0,0,$col_mois,31,$annee))]{0} ?></b></td>
     <?php
     //
     if (in_array($jour[date("w", mktime(0,0,0,$col_mois,$ligne,$annee+ 1))]{0},$weekend)): // les cellules week end sont grises
       ?>
       <td width="105" align="center" bgcolor="#C0C0C0">&nbsp;</td>
       <?php
      else:  // si pas week end
      
       /* teste si c est un jour de vacances alors griser la cellule
       sinon si c est un jour de fin de priode insrer comme contenu /FIN 1er PERIODE/ et dans le
       cas contraire, ne rien afficher et dtermine si la semaine est A (fond rose) ou B (fond bleu)
       */
       $date=date("Y-m-d", mktime(0,0,0,$col_mois,$ligne,$annee+ 1)); // date du jour au format aaaa-mm-jj
       /* si la date du jour $ligne, $col_mois est un jour de vacances */
       if (($date<$date_rentree) || (($date>$dbt_toussaint) && ($date<$fin_toussaint)) 
        || (($date>$dbt_noel) && ($date<$fin_noel)) || (($date>$dbt_fev) && ($date<$fin_fev))
        || (($date>$dbt_paq) && ($date<$fin_paq)) || ($date>$dbt_ete)):
        ?>
        <td width="105" align="center" bgcolor="#C0C0C0">&nbsp;</td>
        <?php
       else :		// sinon fond normal
        /* reste  insrer la vrification des semaines A (fond rose) et B (fond bleu)*/
        $sem_actuelle=strftime("%W", mktime(0,0,0,$col_mois,$ligne,$annee+ 1));
        foreach($num_sem_trav as $value) {
         if ($sem_actuelle==$value):
          switch ($semab{$value}){
           case 'B':
            $bgcolor="#33CCFF";
            break;
           case 'A':
            $bgcolor="#FFCCFF";
            break;
          } 
         endif;
        }
        colorsemab($bgcolor,$date,$p_1t,$p_2t,$p_3t,$fin_1t,$fin_2t,$fin_3t);

        
       endif;
      endif;
     //
     
    else: // si le mois ne comporte pas 31 jours, ne rien afficher dans les cellules
     ?> 
     <td width="20" align="center">&nbsp;</td>
     <td width="105" align="center">&nbsp;</td>
     <?php
    endif;
    $col_mois++;
   } // on passe  la colonne du mois suivant
    $col_mois=9; // valeur initialise  chaque ligne
     ?>
     <td width="20" align="center" bgcolor="#FFCC99"><b><?php echo $jour[date("w", mktime(0,0,0,1,31,$annee+ 1))]{0} ?></b></td>
     <?php
     //
if (in_array($jour[date("w", mktime(0,0,0,1,31,$annee+ 1))]{0},$weekend)): // les cellules week end sont grises
       ?>
       <td width="105" align="center" bgcolor="#C0C0C0">&nbsp;</td>
       <?php
      else:  // si pas week end
      
       /* teste si c est un jour de vacances alors griser la cellule
       sinon si c est un jour de fin de priode insrer comme contenu /FIN 1er PERIODE/ et dans le
       cas contraire, ne rien afficher et dtermine si la semaine est A (fond rose) ou B (fond bleu)
       */
       $date=date("Y-m-d", mktime(0,0,0,1,31,$annee+ 1)); // date du jour au format aaaa-mm-jj
       /* si la date du jour $ligne, $col_mois est un jour de vacances */
       if (($date<$date_rentree) || (($date>$dbt_toussaint) && ($date<$fin_toussaint)) 
        || (($date>$dbt_noel) && ($date<$fin_noel)) || (($date>$dbt_fev) && ($date<$fin_fev))
        || (($date>$dbt_paq) && ($date<$fin_paq)) || ($date>$dbt_ete)):
        ?>
        <td width="105" align="center" bgcolor="#C0C0C0">&nbsp;</td>
        <?php
       else :		// sinon fond normal
        /* reste  insrer la vrification des semaines A (fond rose) et B (fond bleu)*/
        $sem_actuelle=strftime("%W", mktime(0,0,0,1,31,$annee+ 1));
        foreach($num_sem_trav as $value) {
         if ($sem_actuelle==$value):
          switch ($semab{$value}){
           case 'B':
            $bgcolor="#33CCFF";
            break;
           case 'A':
            $bgcolor="#FFCCFF";
            break;
          } 
         endif;
        }
        colorsemab($bgcolor,$date,$p_1t,$p_2t,$p_3t,$fin_1t,$fin_2t,$fin_3t);

        
       endif;
      endif;
     //
     ?>
   </tr>
   <!-- **** fin d affichage de la 31 ime ligne **** -->

<!-- ************************* deuxime tableau (mois de fvrier  juin) ************************ -->
</table>


    
    
    
    
    
    </td>
    <td width="10"></td>
    <td width="362">
    
    
    
    <table border="1" width="362">
  <tr>
    <td width="145" bgcolor="#FFFF00" colspan="3" align="center"><b><?php echo $mois[1] ?></b></td>
    <td width="125" bgcolor="#FFFF00" colspan="2" align="center"><b><?php echo $mois[2] ?></b></td>
    <td width="125" bgcolor="#FFFF00" colspan="2" align="center"><b><?php echo $mois[3] ?></b></td>
    <td width="125" bgcolor="#FFFF00" colspan="2" align="center"><b><?php echo $mois[4] ?></b></td>
    <td width="125" bgcolor="#FFFF00" colspan="2" align="center"><b><?php echo $mois[5] ?></b></td>
  </tr>
  <?php
  $ligne=1;
  $col_mois=2; // initialisation du deuxime tableau au mois de fvrier
  while ($ligne<=30){
   ?>
   <tr>
    <td width="20" bgcolor="#FFFF00" align="center"><b><?php echo $ligne ?></b></td>
     <?php
     while ($col_mois<=6) {   // jusqu au mois de juin
      
      
      if ($col_mois==2):    // dtermination du nombre de jours du mois de fvrier
       $noexist_case="off"; // cette variable peut changer ci-dessous si le jour n existe pas
       if ($ligne<29):    
        $j=$jour[date("w", mktime(0,0,0,$col_mois,$ligne,$annee+1))]; //dtermine le jour de la semaine
       else:     // si la ligne est gale ou suprieure  29
        if ($ligne==29):
         if (date("L", mktime(0,0,0,$col_mois,$ligne,$annee+1))): // si anne bissextile		
          $j=$jour[date("w", mktime(0,0,0,$col_mois,$ligne,$annee+1))]; //dtermine le jour de la semaine
         else: // si anne pas bissextile
          $j=""; // ce jour n existe pas (le 29 fvrier n existe pas car l anne n est pas bissextile)
          $noexist_case="on";  // la cellule correspondante sera grise
         endif;
        else :  // si la ligne est suprieure  29
         $j=""; // ce jour n existe pas (le mois de fvrier ne comporte pas plus de 29 jours)
         $noexist_case="on";  // la cellule correspondante sera grise
     
        endif;
       endif;
      else:  // si ce n est pas le mois de fvrier
       $j=$jour[date("w", mktime(0,0,0,$col_mois,$ligne,$annee+1))]; //dtermine le jour de la semaine
       $noexist_case="off";
      endif;
      
      
      if ($j==""): // pour les jours de fvrier qui n existent pas
       ?>
       <td width="20" align="center">&nbsp;</td>
       <?php
      else: // pour tous les autres jours
       ?>
       <td width="20" align="center" bgcolor="#FFCC99"><b><?php echo $j{0}  /* affiche la premire lettre du jour de la semaine */?></b></td>
       <?php
      endif; 
      if (!isset($j{0}))
       $j{0} = "";
 if (in_array($j{0},$weekend)): // les cellules week end sont grises
//
       switch ($noexist_case){  // cas du mois de fvrier, si le jour n existe pas, laisser la cellule vide
        case 'off': // ce jour existe
       ?>
       <td width="105" align="center" bgcolor="#C0C0C0">&nbsp;</td>
       <?php
        break;
        case 'on': // ce jour n existe pas
        ?>
       <td width="105" align="center">&nbsp;</td>
       <?php
       }
//
      else: // si pas week end
// 
     switch ($noexist_case){  // cas du mois de fvrier, si le jour n existe pas, laisser la cellule vide
       
       case 'off': // le jour existe

       /* teste si c est un jour de vacances alors griser la cellule
       sinon si c est un jour de fin de priode insrer comme contenu /FIN 1er PERIODE/ et dans le
       cas contraire, ne rien afficher et dtermine si la semaine est A (fond rose) ou B (fond bleu)
       */
       $date=date("Y-m-d", mktime(0,0,0,$col_mois,$ligne,$annee+ 1)); // date du jour au format aaaa-mm-jj
       /* si la date du jour $ligne, $col_mois est un jour de vacances */
       if (($date<$date_rentree) || (($date>$dbt_toussaint) && ($date<$fin_toussaint)) 
        || (($date>$dbt_noel) && ($date<$fin_noel)) || (($date>$dbt_fev) && ($date<$fin_fev))
        || (($date>$dbt_paq) && ($date<$fin_paq)) || ($date>$dbt_ete)):
        ?>
        <td width="105" align="center" bgcolor="#C0C0C0">&nbsp;</td>
        <?php
       else :		// sinon fond normal
        /* reste  insrer la vrification des semaines A (fond rose) et B (fond bleu)*/
        $sem_actuelle=strftime("%W", mktime(0,0,0,$col_mois,$ligne,$annee+ 1));
        foreach($num_sem_trav as $value) {
         if ($sem_actuelle==$value):
          switch ($semab{$value}){
           case 'B':
            $bgcolor="#33CCFF";
            break;
           case 'A':
            $bgcolor="#FFCCFF";
            break;
          } 
         endif;
        }
        colorsemab($bgcolor,$date,$p_1t,$p_2t,$p_3t,$fin_1t,$fin_2t,$fin_3t);
      endif;
      break;
      case 'on': // le jour n existe pas
       ?>
        <td width="105" align="center">&nbsp;</td>
        <?php
       break;
     } // fin du switch sur $noexist_case

      endif;
      $col_mois++;
     }
     $col_mois=2; // valeur initialise  chaque ligne
     ?>
   </tr>
     <?php
     $ligne++;
   }
   // Affichage du 31 ime jour le cas chant
   ?>
   <tr>
   <td width="20" bgcolor="#FFFF00" align="center"><b>31</b></td>
   <?php
   while ($col_mois<=6){
     if (date("t", mktime(0,0,0,$col_mois,1,$annee+1))=="31"): // si ce mois comporte 31 jours
     ?>
     <td width="20" align="center" bgcolor="#FFCC99"><b><?php echo $jour[date("w", mktime(0,0,0,$col_mois,31,$annee+1))]{0} ?></b></td>
      <?php
       if (in_array($jour[date("w", mktime(0,0,0,$col_mois,31,$annee+1))]{0},$weekend)): // les cellules week end sont grises
       ?>
       <td width="105" align="center" bgcolor="#C0C0C0">&nbsp;</td>
       <?php
      else: // si ce n est pas un weekend
      /* teste si c est un jour de vacances alors griser la cellule
       sinon si c est un jour de fin de priode insrer comme contenu /FIN 1er PERIODE/ et dans le
       cas contraire, ne rien afficher et dtermine si la semaine est A (fond rose) ou B (fond bleu)
       */
       $date=date("Y-m-d", mktime(0,0,0,$col_mois,31,$annee+ 1)); // date du jour au format aaaa-mm-jj
       /* si la date du jour $ligne, $col_mois est un jour de vacances */
       if (($date<$date_rentree) || (($date>$dbt_toussaint) && ($date<$fin_toussaint)) 
        || (($date>$dbt_noel) && ($date<$fin_noel)) || (($date>$dbt_fev) && ($date<$fin_fev))
        || (($date>$dbt_paq) && ($date<$fin_paq)) || ($date>$dbt_ete)):
        ?>
        <td width="105" align="center" bgcolor="#C0C0C0">&nbsp;</td>
        <?php
       else :		// sinon fond normal
        /* reste  insrer la vrification des semaines A (fond rose) et B (fond bleu)*/
        $sem_actuelle=strftime("%W", mktime(0,0,0,$col_mois,31,$annee+ 1));
        foreach($num_sem_trav as $value) {
         if ($sem_actuelle==$value):
          switch ($semab{$value}){
           case 'B':
            $bgcolor="#33CCFF";
            break;
           case 'A':
            $bgcolor="#FFCCFF";
            break;
          } 
         endif;
        }
        colorsemab($bgcolor,$date,$p_1t,$p_2t,$p_3t,$fin_1t,$fin_2t,$fin_3t);

        
       endif;
      endif;
     
     else: // si ce mois comporte seulement 30 jours
      ?> 
      <td width="20" align="center">&nbsp;</td>
      <td width="105" align="center">&nbsp;</td>
      <?php
     endif;
    $col_mois++;
   } 
    $col_mois=2; // valeur initialise  chaque ligne
     ?>
     
   </tr>

</table>


    
    
    
    
    
    </td>
    
    <td width="10"></td>
    
    <td width="65">
    <!-- ************************** 3me tableau (mois de juillet) ******************** -->
<table border="1" width="90">
  <tr>  <!-- voici la ligne entte contenant les mois -->
    <td width="145" bgcolor="#FFFF00" colspan="3" align="center"><b><?php echo $mois[6] ?></b></td>
  </tr>
  <?php
  $ligne=1;   // initialisation  la premire ligne du tableau
  $col_mois=7;  // initialisation de la premire colonne au mois de juillet
  while ($ligne<=31){
   ?>
   <tr>
    <td width="20" bgcolor="#FFFF00" align="center"><b><?php echo $ligne ?></b></td>  <!-- affiche le numro du jour du mois -->
     <?php
     // while ($col_mois<=) {  // boucle jusqu au mois que l'on souhaite
      $j=$jour[date("w", mktime(0,0,0,$col_mois,$ligne,$annee+1))]; //dtermine le jour de la semaine
      ?>
      <td width="20" bgcolor="#FFCC99" align="center"><b><?php echo $j{0}  /* affiche la premire lettre du jour de la semaine */?></b></td>
      <?php
      if (in_array($j{0},$weekend)): // les cellules week end sont grises
       ?>
       <td width="105" align="center" bgcolor="#C0C0C0">&nbsp;</td>
       <?php
      else:  // si pas week end
      
       /* teste si c est un jour de vacances alors griser la cellule
       sinon si c est un jour de fin de priode insrer comme contenu /FIN 1er PERIODE/ et dans le
       cas contraire, ne rien afficher et dtermine si la semaine est A (fond rose) ou B (fond bleu)
       */
       $date=date("Y-m-d", mktime(0,0,0,$col_mois,$ligne,$annee+1)); // date du jour au format aaaa-mm-jj
       /* si la date du jour $ligne, $col_mois est un jour de vacances */
       if (($date<$date_rentree) || (($date>$dbt_toussaint) && ($date<$fin_toussaint)) 
        || (($date>$dbt_noel) && ($date<$fin_noel)) || (($date>$dbt_fev) && ($date<$fin_fev))
        || (($date>$dbt_paq) && ($date<$fin_paq)) || ($date>$dbt_ete)):
        ?>
        <td width="105" align="center" bgcolor="#C0C0C0">&nbsp;</td>
        <?php
       else :		// sinon fond normal
        /* reste  insrer la vrification des semaines A (fond rose) et B (fond bleu)*/
        $sem_actuelle=strftime("%W", mktime(0,0,0,$col_mois,$ligne,$annee+1));
        foreach($num_sem_trav as $value) {
         if ($sem_actuelle==$value):
          switch ($semab{$value}){
           case 'B':
            $bgcolor="#33CCFF";
            break;
           case 'A':
            $bgcolor="#FFCCFF";
            break;
          } 
         endif;
        }
        colorsemab($bgcolor,$date,$p_1t,$p_2t,$p_3t,$fin_1t,$fin_2t,$fin_3t);
       endif;
      endif;
     // $col_mois++;
     //} // on passe  la colonne suivante
     ?>
   </tr>
     <?php
     $ligne++;
   } // on passe  la ligne suivante
?>
</table>

    </td>
  </tr>
</table>
</center>
<a name='bas'></a><br /><br />
<div align="center">
  <i><?php echo "<font color='red'><b>".strtoupper($GLOBALS['nom_etablissement']).", ".$GLOBALS['adresse_etablissement']." ".$GLOBALS['cp_etablissement']." ".$GLOBALS['ville_etablissement']." - Tl: ".$GLOBALS['tel_etablissement']."</b></font><br /><br />".$GLOBALS['copyright'] ?></i>
</div>
<?php
fin_code_html();
?>