<?php
/**
 * c_maj_logos_sign.php
 *
 * Permet la mise  jour du logo de l'tablissement et des signatures sur les documents
 * officiels (notamment pour les documents PDF crs  la vole)
 * 
 * Ce fichier fait partie du projet IntraEduWeb (IEW)
 * 
 * @package		IEW
 * @author			Sylvain GODM <sylvain.godme@gmail.com>
 * @version		$LastChangedRevision$, $LastChangedDate$
 * @copyright		2004-2012 Sylvain GODM
 * @link			http://iew.free.fr
 * @license		GPL License version 3 (http://www.gnu.org/licenses/gpl.html)
 * @filesource
 * 
 */

// la page est protge, elle utilise les sessions et le systme d'authentification diffrencie
// le tableau $array_valid_user contient les identifiants des catgories d'utilisateurs autoriss  accder  cette page (voir la table groupes_utilisateurs)

if(!defined('IEW_DIR')) define('IEW_DIR',realpath(dirname(__FILE__)."/../../").'/');
// Inclusions
require_once(IEW_DIR."librairie_fonctions.php");

// Cette fonction apparait dans +sieurs scripts : il faudra  terme la mettre dans un lieu unique (fonctions_diverses.php ?)
function efface_post()
{
	/**
	 *  On efface les donnes du post et de $_SESSION['post_imprimable'] pour empcher en cas de rechargement de page une nouvelle excution 
	 */
 	unset($_POST['soumettre']);
 	unset($_SESSION['post_imprimable']['soumettre']);
}

function affiche_formulaire_upload($missing_files)
{
  $code_formulaire = "<br />";
  $libelles = array("logo_en_etab.jpg"=>"Logo de l'tablissement (en-tte de courrier)","sign_admin.jpg" => "Signature de l'administrateur IEW","sign_boss.jpg" => "Signature (avec cachet) du Chef d'tablissement");
  $i = 1;
  foreach($missing_files as $value)
  {
    $code_formulaire .= "
    <div class='titre_cadre_formulaire' align='center'><b>".$libelles[$value]."</b></div>
    <div class='cadre_formulaire_gris' align='center'>";
    if (file_exists($GLOBALS['stock_baselev'].$value))
    {
      $image = $GLOBALS['stock_baselev'].$value;
      $code_formulaire .= "<img src='".$GLOBALS['chemin_relatif']."resize_image.php?image=$image&amp;max_width=300&amp;max_height=110' alt='Vue miniature du fichier $value' /><br />";
    }
    $code_formulaire .="
    <div align='justify'><p>Cliquez le bouton parcourir et slectionnez le fichier image souhait (ATTENTION : le poids autoris est de 60 ko maximum).</p></div>
    <p><input type='hidden' name='MAX_FILE_SIZE' value='61440' />
    <input name='fichier$i' type='file' /></p>
    </div>
    <br />";
    $i++;
  }
  $i--;
  // On transmet en champ cach le nom des fichiers manquants
  $liste_fichiers = "";
  foreach($missing_files as $value)
  {
    $liste_fichiers .= $value.",";
  }
  $liste_fichiers = substr($liste_fichiers,0,strlen($liste_fichiers)-1); // on retire la virgule terminale
  $code_formulaire .= "<input type='hidden' name='liste_fichiers' value='$liste_fichiers' />";
  echo "<br /><center>";
  squelette_formulaire_upload("95%","multipart/form-data","post",$_SERVER['PHP_SELF'],"<h2 class='hidden'>Formulaire de tlchargement</h2>Formulaire de tlchargement",$code_formulaire,"Mettre  jour","soumettre","","","","","");
  echo "</center>";
}

// Accs autoris : on poursuit le traitement; d'abord on rcupre les infos sur l'lve dans la base de donnes
connexion_mysql();
select_database();

echo "<h1>Mettre  jour les logos<br/>et les signatures des documents officiels</h1>";

// Si l'appel est conscutif au POST du formulaire d'upload
if (isset($_POST['soumettre']))
{
  $i = 1;
  $count_vide = 0;
  $libelles = array("logo_en_etab.jpg"=>"Logo de l'tablissement (en-tte de courrier)","sign_admin.jpg" => "Signature de l'administrateur IEW","sign_boss.jpg" => "Signature (avec cachet) du Chef d'tablissement");
  $error_message = "";
  $ok_message = "";
  $liste_fichiers = explode(",",$_POST['liste_fichiers']); // On rcupre la liste des fichiers transmis
  $renew_missing_files = str_replace(",","+",$_POST['liste_fichiers']); // On reconstruit la liste pour ventuellement la renvoyer en paramtre GET, si on doit renouveller l'affichage du formulaire
  //print_r($_FILES);
  foreach($liste_fichiers as $value)
  {
    if ($_FILES["fichier$i"]['name'] != "") // seulement si le champ du formulaire a t rempli
    {
      // on traite le formulaire d'upload envoy
      if (!isset($_FILES["fichier$i"]['tmp_name']))
      {
        $error_message .= "Le tlchargement du <font color='black'><strong>".$libelles[$value]."</strong></font> n'a pas pu s'effectuer. Vrifiez vos entres de formulaire puis <b>renouvellez l'opration</b>.<br />";
      }
      if ($_FILES["fichier$i"]['size']==0)
      {
        $error_message .= "Le fichier <font color='black'><strong>".$libelles[$value]."</strong></font> tlcharg ne contient aucune donne ou bien la taille excde le maximum des 60 ko autoriss. Vrifiez le nom du fichier et son contenu, puis <b>renouvellez l'opration</b>.<br />";
      }
      if (!is_uploaded_file($_FILES["fichier$i"]['tmp_name']) && $_FILES["fichier$i"]['size'] !=0) // pour la scurit
      {
        $error_message .= "Attention, le fichier <font color='black'><strong>".$libelles[$value]."</strong></font>  traiter est un fichier local du serveur est n'a pas t tlcharg  partir du client. Le script est interrompu pour des raisons de scurit.<br />";
      }
      // on vrifie maintenant l'extension
      $type_file = $_FILES["fichier$i"]['type'];
      if(!strstr($type_file, 'image/jpeg')) // Ce doit tre un fichier jpeg !
      { 
        $error_message .= "Attention, le fichier  <font color='black'><strong>".$libelles[$value]."</strong></font>  traiter n'est pas au format jpeg ! Vrifiez le nom du fichier et son contenu, puis <b>renouvellez l'opration</b>.<br />";
      }
      else // c'est bien du jpeg, on continue
      {
        // on sauvegarde le fichier prcdent s'il existe
        if (file_exists($GLOBALS['stock_baselev'].$value))
          if (!@copy($GLOBALS['stock_baselev'].$value,$GLOBALS['stock_baselev'].$value.".bak"))
          {
            $error_message .= "Le fichier <font color='black'><strong>".$libelles[$value]."</strong></font> existant n'a pas pu tre sauvegard. Il est remplac par le nouveau qui vient d'tre tlcharg.<br />";
          }
        if( !move_uploaded_file($_FILES["fichier$i"]['tmp_name'], $GLOBALS['stock_baselev'].$value) )
        {
          $error_message .= "Le fichier <font color='black'><strong>".$libelles[$value]."</strong></font> tlcharg n'a pas pu tre copi dans le dossier cible sur le serveur<br />";
        }
        else
        {
          // Si on arrive l c'est que tout va bien, mais le fichier est en droit 600; donc si on veut faire une sauvegarde du rpertoire 'data' par exemple par FTP, comme seul le propritaire du fichier (apache) y a accs, on ne pourra pas lire ce fichier et donc la sauvegarde sera incomplte
          // On va donc mettre les droits 644 (pas de droit d'excution pour les autres, on ne sait jamais)
          chmod($GLOBALS['stock_baselev'].$value, 0644);
          $ok_message .= "Le nouveau fichier <font color='black'><strong>".$libelles[$value]."</strong></font> a bien t enregistr !<br /><br />";
        }
      }
    }
    else // le champ de formulaire est vide (ce qui peut se produire, mais il ne faut pas qu'ils soients tous vide)
    {
      $count_vide++;
    }
  $i++;
  }
  if ($count_vide == 3)
  {
  	$error_message .= "<div align='justify'>Vous venez d'envoyer un formulaire compltement vide ! Il faut fournir au moins un fichier sur les trois demands !<br />Veuillez <b>renouveller l'opration</b> :</div>";
  }    
  if ($error_message != "")
  {
    $error_message = array("<p><font color='black'><strong><u>*** Rapport d'erreur ***</u></strong></font></p><br />$error_message","");
    affiche_erreurs($error_message);
  	// Quel est le type de mise  jour souhaite ?
  	if (isset($_GET['missing'])) // Cela dpend des fichiers manquants
  	{
    	$missing_files = explode(" ",$_GET['missing']);
    	affiche_formulaire_upload($missing_files);
  	}
  	else // par dfaut, tous les fichiers prvus par ce script sont supposs manquants ou  remplacer
  	{
    	$missing_files = array("logo_en_etab.jpg","sign_admin.jpg","sign_boss.jpg");
    	affiche_formulaire_upload($missing_files);
  	}
    return;
  }
  else
  {
    echo "<br />";
    affiche_ok($ok_message);
    efface_post();
    return;
  }
}
else // formulaire pas encore soumis : il faut afficher le formulaire d'upload
{
  // Quel est le type de mise  jour souhaite ?
  if (isset($_GET['missing'])) // Cela dpend des fichiers manquants
  {
    $missing_files = explode(" ",$_GET['missing']);
    affiche_formulaire_upload($missing_files);
  }
  else // par dfaut, tous les fichiers prvus par ce script sont supposs manquants ou  remplacer
  {
    $missing_files = array("logo_en_etab.jpg","sign_admin.jpg","sign_boss.jpg");
    affiche_formulaire_upload($missing_files);
  }
}
?>