<?php
/**
 * c_maj_version.php
 *
 * Assure la mise  jour de la structure des tables MySQL d'une version IEW existante
 * vers une nouvelle version
 * 
 * Ce script doit tre test avant chaque publication de version, mme si cette nouvelle version n'apporte pas de
 * modifs dans la structure des tables de la base de donnes. Pour cela, rechercher les occurences "// DEBUGG print"
 * et les remplacer par "print" le temps du test en dveloppement (et "// DEBUGG var_dump" par "var_dump"). Revenir  l'tat initial
 * avant publication de la nouvelle version
 * 
 * Ce fichier fait partie du projet IntraEduWeb (IEW)
 * 
 * @package		IEW
 * @author			Sylvain GODM <sylvain.godme@gmail.com>
 * @version		$LastChangedRevision$, $LastChangedDate$
 * @copyright		2004-2014 Sylvain GODM
 * @link			http://iew.free.fr
 * @license		GPL License version 3 (http://www.gnu.org/licenses/gpl.html)
 * @filesource
 * 
 */

if(!defined('IEW_DIR')) define('IEW_DIR',realpath(dirname(__FILE__)."/../../").'/');

function ecrire_rapport($rapport,$resume)
{
	/**
	 * Consigne dans un fichier au format HTML, le rapport de mise  jour
	 * 
	 * @param $rapport = contenu du rapport  crire
	 * @param $resume = message d'erreur ou de succs de l'opration
	 * 
	 * @return $name_file_report = nom du fichier de rapport
	 */
	
	$affichage_horodatage_jour = format_date_long("fr",date("j/m/Y"));
	$affichage_horodatage_heure = "  ".date("H")." heures ".date("i")." minutes ".date("s")." secondes";
  	$horodatage_fichier=date("_Ymd_His");
	$name_file_report = "iew-update".$horodatage_fichier.".html";
	$titre_page = "Mise  jour de l'application";
    // on vrifie que le dossier "updates" existe, sinon on le cre
  	if (!file_exists($GLOBALS['stock_baselev']."updates"))
  	{
  		mkdir($GLOBALS['stock_baselev']."updates",0755);
  	}
  	$fichier_rapport=fopen($GLOBALS['stock_baselev']."updates/".$name_file_report,"w");
	$code_a_ecrire = "<?xml version='1.0' encoding='iso-8859-1'?>
	<!DOCTYPE html PUBLIC '-//W3C//DTD XHTML 1.0 Transitional//EN' 'http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd'>
	<html xmlns='http://www.w3.org/1999/xhtml' lang='fr-FR' xml:lang='fr-FR'>
  	<head>
    <title>IntraEduWeb, Espace Numrique de Travail du ".$GLOBALS['nom_etablissement'].", $titre_page</title>
    <meta http-equiv='Content-Type' content='text/html; charset=iso-8859-1' />
    <meta name='author'    content='Sylvain GODM' />
    <meta name='copyright' content='2004-".date("Y").", Sylvain GODM. All Rights Reserved.' />
    <link rel='stylesheet' type='text/css' href='".$GLOBALS['racine'].$GLOBALS['repertoire_theme'].$GLOBALS['jeu_couleurs']['stylesheet']."' />
    </head>
    <body><p>".$affichage_horodatage_jour.$affichage_horodatage_heure."</p>".$rapport."<hr />
    <h2>Rsum de la mise  jour</h2>".$resume."<hr />
    </body>
	</html>";
	fwrite($fichier_rapport, $code_a_ecrire);
	fclose($fichier_rapport);
	return $name_file_report;
}

// Le script en cours doit tre le script d'appel prvu
if (end_with_string($_SERVER['PHP_SELF'],"prive/admintraeduweb/maj_version.php"))
{
  // Liste des versions depuis la mise  disposition en GPL de la version 1.3.0-beta (version en cours  la rentre 2011 au collge Lonard de Vinci)
  // Il s'agit d'un tableau contenant le numro de la version et la liste correspondante des mises  jour  faire
  // dans la structure de la base de donnes par rapport  la version prcdente
  // La plupart des maj se font automatiquement, mais certaines requirent pour tre compltes, une intervention manuelle => des instructions sont alors donnes dans ce cas,  la fin de la procdure automatique. Ces intructions se trouvent entre les caractres *** et *** (formatage obligatoire)
  /* Par exemple : "1.2.0-beta-2006-09-01" => "***ATTENTION : vous devez MAINTENANT faire une mise  jour de la base lve pour terminer correctement la mise  jour de l'application IEW***;
    create table version (version varchar(30));
    insert into version values('1.2.0-beta-2006-09-01'); + d'autres instructions SQL ventuellement */
  // Dans le tableau qui suit, la cl est le numro de version (!! A RECOPIER IMPERATIVEMENT DANS LE FICHIER VERSION, SANS OUBLIER LE CHANGELOG !!)
  
  /* La version initiale est en premire position, pas de maj  faire pour cette version
   * $liste_versions = array(
  "1.2.0-beta-2007-03-03"=> "",
  "1.2.0-beta-aaaa-mm-jj"=> "
	create table majsconet_nomenclature(
 	maj date
 	);
	create table uaj(
 	uaj char(8)
 	);
	drop table
	"
  );*/
  
  // On considre que la mise s'effectue  partir d'une version 1.3.0-beta minimum
  /* Ce qui signifie que les versions ultrieures successives doivent cumuler les maj :
   * Par exemple, la version installe est 1.3.0-beta et la mise  jour est en version 2.4.0. Il faut donc faire toutes les maj de la base de donnes cumules
   * entre les 2 versions*/
  $liste_versions = array(
  "1.3.0-beta" => "",
  "2.0.0-beta" => "
  	create table corps_personnel(
  	id_corps char(3) primary key,
  	libelle_court varchar(10),
	libelle_long varchar(40),
  	libelle_edition varchar(160)
  	);
  	create table grades_personnel(
  	id_grade char(4) primary key,
  	libelle_court varchar(10),
  	libelle_long varchar(40),
  	libelle_edition varchar(160),
  	id_corps char(3)
  	);
 	create table couleurs_edt_matieres(
  	matiere varchar(20) primary key,
  	avt_plan varchar(6),
  	arr_plan varchar(6)
  	);
  	DELETE FROM telechargement WHERE telechargement.id > 4;
  	ALTER TABLE profs_principaux DROP mefstat4;",
  "2.0.1-beta" => "
    create table remplacants(
  	id_remplacant int(11) not null unique,
  	id_titulaire int(11) not null unique
  	);
  	ALTER TABLE cahiers_textes ADD publication BOOL NOT NULL DEFAULT '1';
  	ALTER TABLE a_faire ADD publication BOOL NOT NULL DEFAULT '1';
  	ALTER TABLE docs_joints_ctextes ADD publication BOOL NOT NULL DEFAULT '1';
  	ALTER TABLE docs_joints_ctextes ADD id_afaire INT(11) NOT NULL DEFAULT '0' AFTER id_ctexte;
  	ALTER TABLE docs_joints_ctextes CHANGE id_ctexte id_ctexte INT(11) NOT NULL DEFAULT '0';
  	ALTER TABLE docs_joints_ctextes DROP INDEX filename, ADD UNIQUE filename (filename,id_ctexte,id_afaire);
  	ALTER TABLE docs_joints_ctextes ADD md5 CHAR(32) NOT NULL;
  	DROP TABLE remarques;
  	DROP TABLE flag_maj_parents;",
  "2.0.2-beta" => "",
  "2.0.3-beta" => "",
  "2.1.0-beta" => "
  	create table cours_diff(
 id_cours_diff int(11) primary key auto_increment,
 type_diff char(3) not null,
 id_cours int(11) not null,
 id_individu int(11) not null,
 code_structure varchar(8) not null,
 structure_complete BOOL NOT NULL DEFAULT '1',
 code_alternance varchar(3),
 date date,
 code_jour tinyint not null,
 heure_debut char(4) not null,
 duree char(4) not null,
 code_matiere char(6) not null,
 code_matiere_etab varchar(5),
 code_salle varchar(5),
 unique(type_diff,id_cours,id_individu,code_alternance,code_jour,heure_debut,duree,code_matiere)
 )
 AUTO_INCREMENT = 10000;
 UPDATE cahiers_textes as t1,personnel as t2 SET t1.id_individu=t2.id_individu WHERE t1.id_individu=t2.id_pers;
 create table horaires_pauses(
 debut_recree_matin char(4),
 debut_pause_dej char(4),
 debut_recree_aprem char(4)
 ); 
 INSERT INTO horaires_pauses values(NULL,'1200',NULL);
 create table visas_ct(
 id_visa int(11) primary key auto_increment,
 type char(3) not null,
 id_pers int(11) not null,
 date datetime not null,
 id_prof int(11) not null,
 code_structure varchar(8) not null default '0',
 id_enseignant_service int(11) not null default '0',
 id_groupe int(11) not null,
 last_id_ctexte int(11) not null,
 activation bool not null,
 unique(type,id_prof,code_structure,id_enseignant_service,id_groupe,last_id_ctexte)
 );"
 );

  $position_version_installee = "";
  
  echo "<h1>Mise  jour de l'application IEW</h1>";
  $rapport = "<h1>Mise  jour de l'application IEW</h1>";

// Il faut dterminer la version dans la base MySQL
  connexion_mysql();
  select_database();
  $sql = "SELECT * FROM version";
  $resultat = mysql_query($sql);
  if ($resultat && mysql_num_rows($resultat)>0)
  {
    $ligne = mysql_fetch_array($resultat);
    $version_installee = $ligne['version'];
  }
  else
  {
    $error_message = array("<div align='justify'>Impossible de dterminer la version IEW installe. La structure de la base de donnes ne sera pas modifie. Abandon du processus.</div>","");
    affiche_erreurs($error_message);
    return;
  }
  
  $rapport .= "<h2>Numros de versions</h2>";
  $rapport .= "<p>La version IEW actuellement installe (ct base MySQL) est : $version_installee</p>";
  $intro_message = "La version IEW anciennement installe (ct base MySQL) est : $version_installee<br />";
  // et la version des scripts IEW
  $version_scripts = trim(file_get_contents(IEW_DIR."VERSION"));
  $rapport .= "<p>La version IEW de mise  jour est (ct arborescence web) : $version_scripts</p>";
  $intro_message .= "La version IEW de mise  jour est (ct arborescence web) : $version_scripts<br /><br />";
  if (!array_key_exists($version_scripts,$liste_versions))
  {
    // Le fichier VERSION n'est pas un fichier officiel, il a t modifi par quelqu'un !
    $error_message = array("Le fichier VERSION ne contient pas une version valide ! Le script de mise  jour est interrompu.","");
    $rapport .= "<p>Le fichier VERSION ne contient pas une version valide ! La version indique n'est pas rfrence dans le script de mise  jour. La mise  jour va tre abandonne.</p>";
    affiche_erreurs($error_message);
    return;
  }

  // On dfinit alors la liste des modifications  faire
  if ($version_installee == $version_scripts)
  {
    $error_message = array("$intro_message La version IEW courante <strong>($version_installee)</strong> dans la base de donnes est la mme que celle des scripts installs sur le serveur web : aucune mise  jour n'est  faire !","");
    $rapport .= "<p>La version IEW courante <strong>($version_installee)</strong> dans la base de donnes est la mme que celle des scripts installs sur le serveur web : aucune mise  jour n'est  faire !</p>";
    affiche_erreurs($error_message);
    return;
  }
  else
  {
    // On dtermine la position de $version_script et de $version_installee dans le tableau $liste_versions
    $cles_liste_versions = array_keys($liste_versions);
    // DEBUGG print "<h2>Test avant publication de nouvelle version</h2>";print "<u>Tableau liste des versions :</u><br />";print_r($cles_liste_versions); echo "<br />";
    $cle_version_script = array_keys($cles_liste_versions,$version_scripts);
    // DEBUGG print "<u>Numro de la cl pour la version des scripts :</u><br />";print_r($cle_version_script);echo "<br />";
    if (count($cle_version_script) != 0)
      $position_version_script = $cle_version_script[0]; // Voil la position cherche
    $cle_version_installee = array_keys($cles_liste_versions,$version_installee);
    // DEBUGG print "<u>Numro de la cl pour la version installe :</u><br />";print_r($cle_version_installee);echo "<br />";
    if (count($cle_version_installee) != 0)
      $position_version_installee = $cle_version_installee[0]; // Voil la position cherche

    // On cherche les modifs  faire
    if ($position_version_script < $position_version_installee)
    {
      $error_message = array("$intro_message<div align='justify'>La version IEW courante <strong>($version_installee)</strong> dans la base de donnes est plus rcente que celle des scripts installs sur le serveur web : aucune mise  jour n'est  faire ! Il semble que vous ayez tent une mise  jour vers une version antrieure. Si vous laissez les choses en l'tat, le comportement de l'application sera anormal <br />=> Remettez les scripts par FTP  partir de la version $version_installee ou ultrieure, et rechargez cette page !</div>","");
      $rapport .= "<p>La version IEW courante <strong>($version_installee)</strong> dans la base de donnes est plus rcente que celle des scripts installs sur le serveur web : aucune mise  jour n'est  faire ! Il semble que vous ayez tent une mise  jour vers une version antrieure. Si vous laissez les choses en l'tat, le comportement de l'application sera anormal <br />=> Remettez les scripts par FTP  partir de la version $version_installee ou ultrieure, et rechargez cette page !</p>";
      affiche_erreurs($error_message);
      return;
    }
    else // il y a des choses  faire
    {
      // mais quoi ?
      $nb_lots_actions = $position_version_script - $position_version_installee;
      // DEBUGG print "Nb de lots d'action  mener: ".$nb_lots_actions."<br />"; // il y a autant de lots d'action que de versions d'cart entre la version installe et la version des scripts
      $cmd = "";
      for ($i=$position_version_installee+1;$i<=($position_version_installee+$nb_lots_actions);$i++) 
      {
        $cmd .= $liste_versions[$cles_liste_versions[$i]];
      }
      // la liste des commandes  excuter est complte
      $liste_commandes_sql = enlever_valeurs_vides(explode(";",$cmd));
      // DEBUGG print "<h3>COMMANDES  excuter (de la version $version_installee vers la version $version_scripts)&nbsp;:</h3>";
      foreach ($liste_commandes_sql as $value)
      {
      	// DEBUGG print "<hr>$value</hr>";
      }
    }
  }
  
  // DEBUGG print "<br /><b>Fin de la liste des commandes (vrification du script de maj)</b>"; print $rapport;return // arrt du script (test)

  // On applique les modifications
  $liste_commandes_sql = enlever_valeurs_vides(explode(";",$cmd));
  
  $rapport .= "<h2>Traitement des commandes MySQL  excuter</h2>";
  if (count($liste_commandes_sql)>0) // il y a des commandes MySQL  excuter pour mettre  jour la structure de la base de donnes
  {
    // Il faut les excuter pour les bases de donnes archives
    $annees_archives = trouve_annees_archives(); // on cherche les annes des bases archives (tableau)
    $databases_annees_scol = array(); // On va construire un tableau dont les valeurs seront les noms des difrentes bases de donnes (anne actuelle + annes archives)
    // on rcupre les infos de connexion au serveur MySQL
    include(CONF_DIR."inc_connect.php"); // cela donne accs  la variable $mysql_database
    $databases_annees_scol[0] = "$mysql_database"; // nom de la base de l'anne en cours
    if (count($annees_archives) != 0) // Il y a des archives, on rcupre le nom des bases
    {
    	foreach ($annees_archives as $annee_scol)
    	{
    		$databases_annees_scol[] = "$mysql_database_" . str_replace("-","_",$annee_scol);
    	}
    }
    $flag_err = false; // a priori il n'y aura pas d'erreur ;-)
    foreach ($databases_annees_scol as $database_annee) // Les commandes SQL sont  excuter sur chaque base
  	{
  		$selectdb = mysql_select_db($database_annee);
  		if ($selectdb) // La base a pu tre ouverte
  		{
  			$rapport .= "<h3>Base de donnes '$database_annee'</h3>";
  			foreach ($liste_commandes_sql as $value)
    		{
	    		// On doit tre sr qu'il s'agit d'une commande et pas d'un message de consigne accompagnant la maj
    			if (!strstr($value,"***")) // ce n'est pas un message mais une commande SQL
      			{
        			$rapport .= "<p>$value&nbsp;: ";
      				if (!mysql_query($value)) // on tente d'excuter chaque commande : s'il y a erreur
        			{
          				$rapport .= "Cette commande n'a pas pu tre excute <b>(".mysql_errno().": ".mysql_error().")</b></p>";
          				$flag_err = true;
        			}
        			else // pas d'erreur
        				$rapport .= "Cette commande a t excute <b>avec succs !</b></p>";
      			}
      			else // c'est un message de consigne
      			{
      				$message_maj = substr($value,3,strlen($value)-3); // On rcupre le message de consigne accompagnant la maj
      				$rapport .= "<p><b>Intervention manuelle requise :</b> $message_maj</p>";
      			}
    		}
    	}
  		else // La base n'a pas pu tre ouverte
  		{
  			$err = "La connexion  la base de donnes $database_annee est impossible !";
  			$rapport .= "<h3>Base de donnes '$database_annee'</h3>$err";
  			$flag_err = true;
  		}
  	}
  	$selectdb = mysql_select_db($mysql_database); // On reslectionne la base actuelle
  	if ($flag_err)
  	{
  		$err = "Certaines instructions de mise  jour de la base de donnes MySQL n'ont pas t excutes !";
      	$name_file_report = ecrire_rapport($rapport,$err);
      	$error_message = array($intro_message.$err."<br /><p><a href='".$GLOBALS['racine']."prive/download_doc.php?file=".$name_file_report."&amp;maj=yes'>Tlcharger le rapport dtaill de la mise  jour</a></p>","");
      	affiche_erreurs($error_message);
      	return; // sortie du script, la version en sera pas  jour dans la base de donnes
  	}
  }
  else // il n'y avait pas de commande MySQL  excuter
  {
    $rapport .= "Il n'y a aucune commande MySQL  excuter. Cette Mise  jour de l'application ne ncessite pas de modification dans la base de donnes.";
  	$intro_message .= "Pour ce transfert de version, aucune mise  jour de la base de donne n'est  faire.<br /><br />";
  }
  // Si on arrive l, c'est que les commandes SQL ont t correctement excutes ou bien qu'il n'y en avait pas    
  // On enregistre la nouvelle version dans la base MySQL
  $sql = "UPDATE version set version='".quote_smart($version_scripts)."'";
  if (mysql_query($sql))
  {
    // Mise  jour termine
    if (isset($message_maj) && $message_maj!="")
      $ok_message = "$intro_message La mise  jour a t ralise avec succs !<br />Mais vous devez tenir compte des consignes suivantes pour que la mise  jour soit complte et que le systme reste fonctionnel :<br /><br />$message_maj";
    else
   {
      $ok_message = "$intro_message La mise  jour a t ralise avec succs !<br />La base MySQL est en maintenant en version $version_scripts";
    }
    
	// On prpare le rapport de MAJ
    $resume = $ok_message;
	$name_file_report = ecrire_rapport($rapport,$resume);
    // On met un lien vers le rapport complet dans le rapport rsum
	$ok_message .= "<br /><p><a href='".$GLOBALS['racine']."prive/download_doc.php?file=".$name_file_report."&amp;maj=yes'>Tlcharger le rapport dtaill de la mise  jour</a></p>";
    affiche_ok($ok_message);
  }
  else
  {
    $error_message = array("$intro_message<div align='justify'>L'inscription de la nouvelle version dans la base de donnes a chou. Ne refaites pas de mise  jour avant d'avoir modifi manuellement la version dans la base de donnes. La valeur dans la table Version doit tre la mme que celle du fichier VERSION  la racine IEW.</div>","");
    affiche_erreurs($error_message);
    return;
  }
}
else // L'utilisateur essaie d'invoquer ce script directement dans l'URL (interdit)
{
  $error_message = array("Vous tentez d'accder  un script qui n'est pas accessible directement  partir de l'URL... Utilisez les liens de navigation !","");
  affiche_erreurs($error_message);
}
?>