<?php
/**
 * c_restauration.php
 *
 * Excute une restauration  partir d'une sauvegarde
 * 
 * Ce fichier fait partie du projet IntraEduWeb (IEW)
 * 
 * @package		IEW
 * @author			Sylvain GODM <sylvain.godme@gmail.com>
 * @version		$LastChangedRevision$, $LastChangedDate$
 * @copyright		2004-2012 Sylvain GODM
 * @link			http://iew.free.fr
 * @license		GPL License version 3 (http://www.gnu.org/licenses/gpl.html)
 * @filesource
 * 
 */

//tri du tableau sur les dates
function cmp($a,$b) 
{
  // Cette fonction est utilise pour trier un tableau contenant les fichiers de sauvegarde selon leur date de modification (le plus rcent en premier)
    if ($a[1] == $b[1])
        return 0;
    return ($a[1] > $b[1]) ? -1 : 1;
}

// Le script en cours doit tre le script d'appel prvu
if (end_with_string($_SERVER['PHP_SELF'],"prive/admintraeduweb/restauration.php"))
{
  // on rcupre les infos de connexion au serveur MySQL
  include(CONF_DIR."inc_connect.php");
  include(CONF_DIR."k.php");
  
  if (!isset($_POST['submit_form']))
  {
    $code_formulaire = "
    <br />
    <div align='justify'>
    <p>
    Cette page vous permet de faire une <b><u>restauration</u></b> des donnes de votre site IntraEduWeb  partir d'une sauvegarde. Il y a deux types de restaurations  effectuer :<br />
    - une restauration de la base de donnes MySQL<br />
    - une restauration des fichiers de donnes (rpertoire <b>".CONF_DIR."</b>)<br /><br />
    Il est vivement recommand d'effectuer une <b><u>sauvegarde immdiate</u></b> (au cas o la restauration effacerait des donnes importantes) et de stocker cette sauvegarde en lieu sr.<br />
    Ceci vous permettra, en cas de problme de revenir  l'tat antrieur.<br /><br />
    </p>
    <p>Suivez DANS l'ORDRE ces tapes :</p><br/>
    A. <b><u>Si vous souhaitez restaurer vos donnes sur le serveur IntraEduWeb d'origine :</u></b><br /><br />
    1. Faites une <a href='sauvegarde.php'>sauvegarde immdiate</a> de vos donnes (IMPORTANT! Au cas o la restauration se passerait mal) et mettez le dossier rapatri par FTP (<b>".CONF_DIR."</b>) en lieu sr.<br /><br />
    2. Supprimez votre rpertoire de donnes actuel (<b>".CONF_DIR."</b>)<br /><br />
    3. Restaurer manuellement votre dossier <b>".CONF_DIR."</b> par FTP (ou une autre mthode) <u> partir de la sauvegarde que vous souhaitez restaurer</u> <strong>-pas celle faite  l'tape 1 !-</strong>, c'est--dire, si vous utilisez les sauvegardes automatiques par cron,  partir du fichier <strong>datadir_".$mysql_database."<font color='red'>-*</font>-tar.gz</strong>, o <strong><font color='red'>-*</font></strong> est gal  <strong><font color='red'>-day</font></strong>, <strong><font color='red'>-week</font></strong> ou <strong><font color='red'>-month</font></strong> (choisissez celui que vous voulez sachant que <strong><font color='red'>-day</font></strong> est le plus rcent) ou, si vous faites seulement des sauvegardes manuelles ponctuelles,  partir du dossier <b>".CONF_DIR."</b> que vous avez copi ou rapatri au moment o vous aviez fait votre sauvegarde.<br /><br />
    Le dossier restaur contient vos fichiers de donnes, dont les fichiers servant  la restauration de la base MySQL&nbsp;:<br/>
    - <strong>".$mysql_database."<font color='red'>-month</font>-backup.sql.gz</strong>  ou <strong>".$mysql_database."<font color='red'>-month</font>-backup.sql</strong> (dernire sauvegarde mensuelle par cron)<br />
    - <strong>".$mysql_database."<font color='red'>-week</font>-backup.sql.gz</strong>  ou <strong>".$mysql_database."<font color='red'>-week</font>-backup.sql</strong> (dernire sauvegarde hebdomadaire par cron)<br />
    - <strong>".$mysql_database."<font color='red'>-day</font>-backup.sql.gz</strong>  ou <strong>".$mysql_database."<font color='red'>-day</font>-backup.sql</strong> (dernire sauvegarde quotidienne par cron)<br />
     - <strong>".$mysql_database."-backup.sql.gz</strong>  ou <strong>".$mysql_database."-backup.sql</strong> (dernire sauvegarde manuelle)<br />
    Les 3 premiers fichiers sont prsents seulement si vous utilisiez les sauvegardes automatiques par cron, et le 4me seulement si vous aviez effectu une sauvegarde manuelle.<br />
    N'OUBLIEZ PAS DE VERIFIER QUE LE DOSSIER <b>".CONF_DIR."</b> SOIT ACCESSIBLE EN LECTURE/ECRITURE POUR L'UTILISATEUR APACHE ! (Ajustez les droits si ncessaire)
    <br /><br />
    4. Par dfaut, c'est la sauvegarde <u>la plus rcente</u> qui sera restaure : examinez les dates de modification des fichiers prcdents,et <u>si le plus rcent vous convient</u>, <strong>passez  l'tape 5</strong>.
    <div class='encadrer' align='justify'><strong><u>ATTENTION :</u></strong> Il est important pour garder une cohrence de toutes les donnes (notamment pour les cahiers de textes) que vous restauriez la sauvegarde la plus rcente !<br />Vous pouvez, rcuprer des donnes plus anciennes, mais dans ce cas, les cahiers de textes, les absences ne seront pas  jour.</div><br />
    - Si vous voulez restaurer la dernire sauvegarde <u>quotidienne</u>, il vous faut copier le fichier <strong>".$mysql_database."<font color='red'>-day</font>-backup.sql.gz</strong>  ou <strong>".$mysql_database."<font color='red'>-day</font>-backup.sql</strong> (dernire sauvegarde quotidienne) sous le nom <strong>".$mysql_database."-backup.sql.gz</strong>  ou <strong>".$mysql_database."-backup.sql</strong> (crasez ventuellement le fichier existant), vous pourrez <u>ensuite</u> passer  l'tape suivante.<br />
    - Si vous voulez restaurer la dernire sauvegarde <u>hebdomadaire</u>, il vous faut copier le fichier <strong>".$mysql_database."<font color='red'>-week</font>-backup.sql.gz</strong>  ou <strong>".$mysql_database."<font color='red'>-week</font>-backup.sql</strong> (dernire sauvegarde hebdomadaire) sous le nom <strong>".$mysql_database."-backup.sql.gz</strong>  ou <strong>".$mysql_database."-backup.sql</strong> (crasez ventuellement le fichier existant), vous pourrez <u>ensuite</u> passer  l'tape suivante.<br />
    - Si vous voulez restaurer la dernire sauvegarde <u>mensuelle</u>, il vous faut copier le fichier <strong>".$mysql_database."<font color='red'>-month</font>-backup.sql.gz</strong>  ou <strong>".$mysql_database."<font color='red'>-month</font>-backup.sql</strong> (dernire sauvegarde mensuelle) sous le nom <strong>".$mysql_database."-backup.sql.gz</strong>  ou <strong>".$mysql_database."-backup.sql</strong> (crasez ventuellement le fichier existant), vous pourrez <u>ensuite</u> passer  l'tape suivante.<br /><br />
    5. Cliquez <u>maintenant</u> sur le bouton <b>Restaurer la base de donnes</b> situ au bas de ce formulaire.
    <br /><br /><br />
    B. <b><u>Si vous souhaitez restaurer vos donnes sur un autre serveur IntraEduWeb :</u></b><br /><br />
    1. Installez IEW sur le serveur DESTINATION (voir documentation administrateur)<br />Votre base de donnes MySQL <u>doit porter le mme nom</u> que sur le serveur IEW d'origine !<br /><br />
    2. Restaurez votre sauvegarde par FTP (ou une autre mthode) sur le serveur DESTINATION (le rpertoire data de la sauvegarde devrait tre restaur au mme emplacement que sur le serveur d'origine : <b>".CONF_DIR."</b>) et ajustez les droits si ncessaire : il faut que ce rpertoire et ses sous-rpertoires appartiennent  l'utilisateur apache de votre nouveau serveur<br /><br />
    3. Copiez le fichier <strong>conf_dir.php</strong> de votre sauvegarde  la racine de votre installation IEW.<br /><br />
    4. Toujours sur le serveur DESTINATION, <u>suivez l'tape 4 de la section A prcdente</u> puis, <u>en supposant que vous tes connect  l'application IntraEduWeb en admin sur le serveur DESTINATION</u>, cliquez sur le bouton <b>Restaurer la base de donnes</b> situ au bas de ce formulaire.
    <br /><br />
    5. <b>IMPORTANT !</b> Les adresses et n de tlphone dans la base de donnes sont cryptes avec un algorithme de cryptage choisi de faon alatoire lors de l'installation IEW. Ces informations seront donc illisibles sur le nouveau serveur. Pour les rendre accessibles, il faut alors faire une mise  jour de la base lves, juste aprs avoir fait la restauration (de prfrence avec les derniers fichiers XML en date les plus rcents <u>parmi ceux qui prcdent</u> la sauvegarde qui vient d'tre restaure)<br /><br />
    </div>
    ";
    squelette_formulaire_standard("100%","post",$_SERVER['PHP_SELF'],"AVERTISSEMENT : Suivez bien les intructions !",$code_formulaire,"Restaurer la base de donnes","submit_form","","","","","");
  }
  else
  {
    // on fait la restauration
    $dossier_sauvegarde = $GLOBALS['stock_baselev']."backup/";
    // il faut utiliser rtrim pour supprimer les caractres spciaux en fin de chane
    $user = rtrim(mcrypt_decrypt($algo, $crypt_key, base64_decode($mysql_admin), $mode, $iv));
    $passwd = rtrim(mcrypt_decrypt($algo, $crypt_key, base64_decode($mysql_admin_passwd), $mode, $iv));

    /* La fonction exec() sur une commande comprenant des arguments, pipes et redirection
engendre un problme d'xcution si la safe_mode est activ (dans ce cas les caractres | et > sont chapps
et par exemple la commande myqldump -uuser -ppassword --opt iew_database | gzip /repertoire_de_stockage_iew/backup/iew_database.sql.gz ne peut s'excuter correctement (PHP applique obligatoirement la fonction escapeshellcmd() ce qui chappe les caractres cits plus haut), alors que cette mme commande s'excute parfaitement lorsque le safe_mode est off. Je solutionne donc le problme en crant un script shell qui sera excut par la fonction exec()*/
    $safe_mode = (bool) ini_get('safe_mode');
    
    // On va restaurer la sauvegarde la plus rcente que l'on trouve dans le rpertoire backup
    $type = array("","-day","-week","-month"); // parmi les types possibles
    // rien => dernire Sauvegarde manuelle
    // -day => dernire Sauvegarde automatique par cron quotidienne
    // -week => dernire Sauvegarde automatique par cron hebdomadaire
    // -month => dernire Sauvegarde automatique par cron mensuelle
    $file_bkup = array();
    foreach ($type as $value)
    {
      
      if (file_exists($dossier_sauvegarde.$mysql_database."$value-backup.sql.gz"))
      {
        $file = $dossier_sauvegarde.$mysql_database."$value-backup.sql.gz";
        $file_bkup[] = array($file, filemtime($file)); 
      }
      elseif(file_exists($dossier_sauvegarde.$mysql_database."$value-backup.sql"))
      {
        $file = $dossier_sauvegarde.$mysql_database."$value-backup.sql";
        $file_bkup[] = array($file, filemtime($file)); 
      }
    }
    usort($file_bkup, "cmp"); // On trie le tableau sur les dates
    //print_r($file_bkup);
    // On prend le + rcent
    $recent_file = $file_bkup[0];
    //echo "<br/>".$recent_file[0];
    // On le copie sous le nom $mysql_database."-backup.sql.gz"
    if (substr($recent_file[0],-2,2) == "gz")
      copy($recent_file[0],$dossier_sauvegarde.$mysql_database."-backup.sql.gz");
    else
      copy($recent_file[0],$dossier_sauvegarde.$mysql_database."-backup.sql");
    
    // On est donc sr de travailler sur  partir du fichier le plus rcent
    if (file_exists($dossier_sauvegarde.$mysql_database."-backup.sql.gz"))
    {
      if ($safe_mode) // doit tre on pour des raisons de scurit
      {
        $cmd = "restore-iew.sh ".$dossier_sauvegarde.$mysql_database."-backup.sql.gz". " $user $passwd ".$mysql_database;
      }
      else // le safe_mode n'est pas activ (serveur de test par exemple)
        $cmd = "gunzip < ".$dossier_sauvegarde.$mysql_database."-backup.sql.gz | mysql -u$user -p$passwd ".$mysql_database;
      // si a marche correctement, suite des instructions
      /* notamment : vous venez de restaurer une sauvegarde datant du  heures
      Vous pouvez aussi restaurer les dernires mises  jour ...*/
      // suivant le rsultat, on affiche un message
      exec($cmd,$output,$retval);
      if (isset($retval) && $retval == 0) // commande bien xcute (sur un serveur LINUX)
      {
        $ok_message = "<div align='justify'>La base de donnes a bien t restaure !<br />
        Retournez sur la page d'accueil de votre site IntraEduWeb et vrifiez que vous retrouvez bien vos donnes en vous connectant en <b>admin</b>
        (par exemple, en consultant les absences ou les cahiers de textes)</div>";
        affiche_ok($ok_message);
        unset($_POST);
        unset($_SESSION['post_imprimable']);
      }
      else
      {
        $error_message = array("<div align='justify'>
        La restauration a chou. Si votre serveur est un serveur linux, veuillez ressayer ultrieurement.<br />
        Si cela ne marche toujours pas, vrifiez la directive safe_mode_exec_dir du fichier php.ini en effectuant <a href='security_check.php'>un test de scurit</a><br />Si le safe_mode est activ, vrifiez que les scripts <i><strong>bkup-iew.sh</strong></i> et <i><strong>restore-iew.sh</strong></i> existent bien (en droits 750) dans le rpertoire spcifi par la directive safe_mode_exec_dir<br />Si votre serveur est sous windows, utilisez <b>PhpMyAdmin</b> pour restaurer votre base de donnes  partir du fichier <b>".$mysql_database."-backup.sql.gz</b>.</div>","");
        affiche_erreurs($error_message);
        unset($_POST);
        unset($_SESSION['post_imprimable']);

      }
    }
    else
    {
      $error_message = array("Le fichier <b>".$mysql_database."-backup.sql.gz</b> ou <b>".$mysql_database."-backup.sql</b> ncessaire pour la restauration de la base de donnes n'a pas t trouv !<br />
      La restauration est abandonne.","");
      affiche_erreurs($error_message);
    }
  }
}
else // L'utilisateur essaie d'invoquer ce script directement dans l'URL (interdit)
{
  $error_message = array("Vous tentez d'accder  un script qui n'est pas accessible directement  partir de l'URL... Utilisez les liens de navigation !","");
  affiche_erreurs($error_message);
}
?>