<?php
/**
 * c_sauvegarde.php
 *
 * Excute une sauvegarde sous forme de fichiers (un fichier pour la base de donnes)
 * et un fichier pour le rpertoire data
 * 
 * Ce fichier fait partie du projet IntraEduWeb (IEW)
 * 
 * @package		IEW
 * @author			Sylvain GODM <sylvain.godme@gmail.com>
 * @version		$LastChangedRevision$, $LastChangedDate$
 * @copyright		2004-2012 Sylvain GODM
 * @link			http://iew.free.fr
 * @license		GPL License version 3 (http://www.gnu.org/licenses/gpl.html)
 * @filesource
 * 
 */

function sauvegarder()
{
    include(CONF_DIR."inc_connect.php");
    include(CONF_DIR."k.php");
    // on cre le dossier de sauvegarde (data/backup) si celui-ci n'existe pas
    $dossier_sauvegarde = $GLOBALS['stock_baselev']."backup/";
    if (!is_dir($dossier_sauvegarde))
    {
      mkdir($dossier_sauvegarde,0755);
    }
        
    // On copie le conf_dir.php qui donne le chemin d'accs au rpertoire de donnes
    copy(IEW_DIR."conf_dir.php",$GLOBALS['stock_baselev']."backup/conf_dir.php");

    // On rcupre les infos du compte MySQL
    $user = mcrypt_decrypt($algo, $crypt_key, base64_decode($mysql_admin), $mode, $iv);
    $passwd = mcrypt_decrypt($algo, $crypt_key, base64_decode($mysql_admin_passwd), $mode, $iv);
    // il faudra utiliser rtrim pour supprimer les caractres spciaux en fin de chane
    
    /* La fonction exec() sur une commande comprenant des arguments, pipes et redirection
engendre un problme d'xcution si la safe_mode est activ (dans ce cas les caractres | et > sont chapps
et par exemple la commande myqldump -uuser -ppassword --opt iew_database | gzip /repertoire_de_stockage_iew/backup/iew_database.sql.gz ne peut s'excuter correctement (PHP applique obligatoirement la fonction escapeshellcmd() ce qui chappe les caractres cits plus haut), alors que cette mme commande s'excute parfaitement lorsque le safe_mode est off. Je solutionne donc le problme en crant un script shell qui sera excut par la fonction exec()*/
    $safe_mode = (bool) ini_get('safe_mode');
    if ($safe_mode) // doit tre on pour des raisons de scurit
    {
      $cmd = "bkup-iew.sh ".rtrim($user)." ".rtrim($passwd)." ".$mysql_database." ".$GLOBALS['stock_baselev']."backup/".$mysql_database."-backup.sql.gz";
    }
    else // le safe_mode n'est pas activ (serveur de test par exemple)
    {
      $exec_dir = "";
      $redirection = "";
      
      // Si sauvegarde au format XML
      //$redirection = " | gzip > ".$dossier_sauvegarde.$mysql_database."-backup.xml.gz";
      // Si sauvegarde au format SQL
      $redirection = " | gzip > ".$dossier_sauvegarde.$mysql_database."-backup.sql.gz";
          
      // au format xml
      //$cmd = $exec_dir."mysqldump --default-character-set=latin1 -u".rtrim($user)." -p".rtrim($passwd)." --opt ".$mysql_database." --xml ".$redirection;
    
      // au format SQL
      $cmd = $exec_dir."mysqldump --default-character-set=latin1 -u".rtrim($user)." -p".rtrim($passwd)." --opt ".$mysql_database.$redirection;
    }
    
    // on xcute la commande
    // suivant le rsultat, on affiche un message
    exec($cmd,$output,$retval);
    /*echo $cmd."<br />";
    echo $retval."<br />";print_r($output);*/
    
    if (isset($retval) && $retval == 0) // commande bien xcute (sur un serveur LINUX)
    {
      $ok_message = "La sauvegarde de la base de donnes a bien russi !<br /> Il vous reste maintenant  sauvegarder vos fichiers de donnes :<br/> Utilisez votre logiciel FTP (si votre dossier de stockage des donnes est dans votre arborescence web) ou un autre moyen (si votre dossier de stockage des donnes est hors arborescence web) pour rcuprer le dossier <b>".$GLOBALS['stock_baselev']."</b> qui contient tous vos fichiers de donnes (dont le fichier <b>".$mysql_database."-backup.sql.gz</b>, situ dans le rpertoire data/backup qui servira  restaurer les donnes MySQL) , et pour stocker ces sauvegardes hors-site.";
      affiche_ok($ok_message);
      unset($_POST);
      unset($_SESSION['post_imprimable']);
    }
    else
    {
      $error_message = array("<div align='justify'>
      La sauvegarde a chou. Si votre serveur est un serveur linux, veuillez ressayer ultrieurement. Si cela ne marche toujours pas, vrifiez la directive safe_mode_exec_dir du fichier php.ini en effectuant <a href='security_check.php'>un test de scurit</a><br />Si le safe_mode est activ, vrifiez que les scripts <i><strong>bkup-iew.sh</strong></i> et <i><strong>restore-iew.sh</strong></i> existent bien (en droits 750) dans le rpertoire spcifi par la directive safe_mode_exec_dir<br />
      Si votre serveur est sous windows, utilisez un logiciel <b>FTP</b> ou une autre mthode pour sauvegarder le rpertoire <i>".$GLOBALS['stock_baselev']."</i> et <b>PhpMyAdmin</b> pour sauvegarder votre base de donnes.</div>","");
      affiche_erreurs($error_message);
      // si la taille du fichier intraeduweb-backup.sql.gz est nulle, (cas qui peut se produire en cas d'chec de mysqldump) on efface le fichier
      $fichier_sql = $dossier_sauvegarde.$mysql_database."-backup.sql.gz";
      if (file_exists($fichier_sql) && filesize($fichier_sql) == 0)
        unlink($dossier_sauvegarde.$mysql_database."-backup.sql.gz"); // on efface le fichier qui ne contient rien
    }
}

/* Script principal*/ 

// Le script en cours doit tre le script d'appel prvu
if (end_with_string($_SERVER['PHP_SELF'],"prive/admintraeduweb/sauvegarde.php"))
{
  
  // on rcupre les infos de connexion au serveur MySQL
    include(CONF_DIR."inc_connect.php");
    
  // Si l'appel du script est fait avec un paramtre erase dans l'url
  // c'est qu'une sauvegarde prcdente va tre crase sur demande de l'administrateur intraeduweb
  if (isset($_GET['erase']) && $_GET['erase']=="ok")
  {
    sauvegarder(); // on peut craser la sauvegarde prcdente
    return; // fin du script
  }
  if (!isset($_POST['submit_form']))
  {
  $code_formulaire = "
  <br />
  <div align='justify'>
  <p>
  Cette page vous permet de faire une <b><u>sauvegarde ponctuelle</u></b> des donnes de votre site IntraEduWeb. Il y a deux types de sauvegardes  effectuer :<br />
  - une sauvegarde de la base de donnes MySQL (fichier SQL compress)<br />
  - une sauvegarde des fichiers de donnes (rpertoire ".$GLOBALS['stock_baselev'].")<br /><br />
  Il est vivement recommand d'effectuer des <b><u>sauvegardes quotidiennes</u></b> :</p>
  <p>
  - Si vous avez un accs <b><i>root</i></b>, utilisez <b><u>cron</u></b> pour faire une sauvegarde horaire de la base de donnes. Je vous renvoie  l'abondante documentation sur crontab disponible sur internet.</p>
  </div>
  <div class='encadrer' align='justify'><strong><i><u>ATTENTION :</u> Les procdures dcrites ci-aprs ne remplacent pas une sauvegarde rgulire plus globale du serveur sur une machine dporte ! Notamment en ce qui concerne les sauvegardes incrmentales... Vous aurez quelques prcisions dans la documentation Administrateur IEW.</i></strong></div><br />
  <div class='titre_cadre_formulaire' align='center'><b>Voici un exemple de crontab que vous devez adapter  votre systme :</b></div>
  <div class='cadre_formulaire'>
    <div align='justify'>
   (les caractres <font color='red'>[]</font> reprsentent un espace<br />
   le chemin &lt;chemin_complet_vers_le_dossier_de_sauvegarde&gt; correspond  <font color='red'>".$GLOBALS['stock_baselev']."</font>backup, la partie rouge correspond  votre dossier de stockage des donnes)<br /><br />
    - Pour une sauvegarde <strong>mensuelle</strong> (le premier jour du mois  3h00) de la totalit de la <strong>base de donnes</strong><br />
    <code>";    
      $code = "00 3 1 * * mysqldump --default-character-set=latin1 -u&lt;nom_utilisateur_mysql&gt;<br/> -p&lt;mot_de_passe&gt; --opt ".$mysql_database." | gzip &gt; <br/>&lt;votre_chemin_complet_vers_le_dossier_de_sauvegarde&gt;". $mysql_database."-month-backup.sql.gz";
      $code = str_replace(" ","<font color='red'>[]</font>",$code);
      $code_formulaire .= $code;
      $code_formulaire .="<br /><br />
    </code> 
    - Pour une sauvegarde <strong>mensuelle</strong> (le premier jour du mois  3h40) de la totalit des <strong>fichiers de donnes</strong> (rpertoire data : pensez  rcuprez alors l'archive par FTP)<br />
    <code>";
      $code = "40 3 1 * * tar -czf &lt;chemin_complet_vers_le_dossier_de_sauvegarde&gt;<br/>datadir_".$mysql_database."-month.tar.gz <br/>&lt;chemin_complet_d'accs_au_rpertoire_data&gt;";
      $code = str_replace(" ","<font color='red'>[]</font>",$code);
      $code_formulaire .= $code;
      $code_formulaire .="<br /><br />
    </code>
    - Pour une sauvegarde <strong>hebdomadaire</strong> (le dimanche  3h00) de la totalit de la <strong>base de donnes</strong><br />
    <code>"; 
      $code = "00 3 * * 0 mysqldump --default-character-set=latin1 -u&lt;nom_utilisateur_mysql&gt;<br/> -p&lt;mot_de_passe&gt; --opt ".$mysql_database." | gzip &gt; <br/>&lt;votre_chemin_complet_vers_le_dossier_de_sauvegarde&gt;". $mysql_database."-week-backup.sql.gz";
      $code = str_replace(" ","<font color='red'>[]</font>",$code);
      $code_formulaire .= $code;
      $code_formulaire .="<br /><br />
    </code> 
    - Pour une sauvegarde <strong>hebdomadaire</strong> (le dimanche  3h40) de la totalit des <strong>fichiers de donnes</strong> (rpertoire data : pensez  rcuprez alors l'archive par FTP)<br />
    <code>";
      $code = "40 3 * * 0 tar -czf &lt;chemin_complet_vers_le_dossier_de_sauvegarde&gt;<br/>datadir_".$mysql_database."-week.tar.gz <br/>&lt;chemin_complet_d'accs_au_rpertoire_data&gt;";
      $code = str_replace(" ","<font color='red'>[]</font>",$code);
      $code_formulaire .= $code;
      $code_formulaire .="<br /><br />
    </code>
    - Pour une sauvegarde <strong>quotidienne</strong> ( 2h35) de la totalit de la <strong>base de donnes</strong><br />
    <code>";    
      $code = "35 2 * * * mysqldump --default-character-set=latin1 -u&lt;nom_utilisateur_mysql&gt;<br/> -p&lt;mot_de_passe&gt; --opt ".$mysql_database." | gzip &gt; <br/>&lt;votre_chemin_complet_vers_le_dossier_de_sauvegarde&gt;". $mysql_database."-day-backup.sql.gz";
      $code = str_replace(" ","<font color='red'>[]</font>",$code);
      $code_formulaire .= $code;
      $code_formulaire .="<br /><br />
    </code>
    - Pour une sauvegarde <strong>quotidienne</strong> ( 2h40) de la totalit des <strong>fichiers de donnes</strong> (rpertoire data : pensez  rcuprez alors l'archive par FTP)<br />
    <code>";
      $code = "40 2 * * * tar -czf &lt;chemin_complet_vers_le_dossier_de_sauvegarde&gt;<br/>datadir_".$mysql_database."-day.tar.gz <br/>&lt;chemin_complet_d'accs_au_rpertoire_data&gt;";
      $code = str_replace(" ","<font color='red'>[]</font>",$code);
      $code_formulaire .= $code;
      $code_formulaire .="<br /><br />
    </code>
    - Pour une sauvegarde <strong>horaire</strong> (de 8h35  19h35) des donnes frquemment mises  jour <strong>(absences et entres de cahiers de textes)</strong> <br /> 
    <code>";
      $code = "35 8-19 * * * mysqldump --default-character-set=latin1 -u&lt;nom_utilisateur_mysql&gt;<br/> -p&lt;mot_de_passe&gt; --opt ".$mysql_database."<br/> liste_absents liste_absents_transactions a_faire cahiers_textes<br/> docs_joints_ctextes | gzip &gt; <br/>&lt;chemin_complet_vers_le_dossier_de_sauvegarde&gt;". $mysql_database."-hour-backup.sql.gz";
      $code = str_replace(" ","<font color='red'>[]</font>",$code);
      $code_formulaire .= $code;
      $code_formulaire .="<br /><br />
    </code>
    - Pour une sauvegarde <strong>horaire</strong> (de 8h40  19h40) des <strong>documents joints</strong> dans les cahiers de textes) <br /> 
    <code>";
      $code = "40 8-19 * * * tar -czf &lt;chemin_complet_vers_le_dossier_de_sauvegarde&gt;<br/>cahiers_textes_dir_".$mysql_database."-hour.tar.gz &lt;<br/>chemin_complet_d'accs_au_rpertoire_data&gt;/cahiers_textes";
      $code = str_replace(" ","<font color='red'>[]</font>",$code);
      $code_formulaire .= $code;
      $code_formulaire .="<br /><br />  
    </code>
    <br />
    <font color='red'>
    <u><b>ATTENTION :</b></u> La sauvegarde automatique <u>quotidienne</u> crasera la sauvegarde manuelle ponctuelle que vous ferez en cliquant sur le bouton <b>Sauvegarder les donnes</b> au bas de cette page; c'est pourquoi vous devrez bien suivre les intructions qui vous seront donnes concernant le rapatriement par FTP  (ou par une autre mthode) du rpertoire <b>".$GLOBALS['stock_baselev']."</b> sur une machine distante.
    </font>
    <br />
    </div>
  </div>
  <br />
  <div align='justify'>
  <p>
  - Si <u>vous n'avez pas</u> d'accs <b><i>root</i></b>, utilisez si vous le pouvez <b><u>PhpMyAdmin</u></b> pour effectuer une sauvegarde <u>quotidienne</u> de la base de donnes et rapatriez aussi par FTP (ou une autre mthode) le contenu du rpertoire ".$GLOBALS['stock_baselev'].". Je vous renvoie  l'abondante documentation sur PhpMyAdmin disponible sur internet.
  </p>
  <p>
  - Si vous avez des ides pour automatiser le processus (et sauvegarder sur une serveur ou une station distante), <a href='mailto:".email_encode($GLOBALS['email_developpeur_iew'])."'>crivez-moi</a>, je suis preneur !
  </p>
  </div>
  <br />
  ";
  squelette_formulaire_standard("100%","post",$_SERVER['PHP_SELF'],"AVERTISSEMENT",$code_formulaire,"","","","","","","");
  echo "<br /><br />";
  $code_formulaire = "
  <br />
  <div align='justify'>
  Cliquez sur le bouton ci-dessous pour faire une sauvegarde immdiate de la base de donnes.
  </div>
  <br /><br />";
  squelette_formulaire_standard("100%","post",$_SERVER['PHP_SELF'],"Sauvegarde ponctuelle",$code_formulaire,"Sauvegarder les donnes","submit_form","","","","","");
  }
  else // le formulaire lanant la sauvegarde immdiate a t valid
  {
    $fichier_sql = $GLOBALS['stock_baselev']."backup/".$mysql_database."-backup.sql.gz";
    if (file_exists($fichier_sql))
    {
      $error_message = array("<div align='justify'>Une sauvegarde prcdente de la base de donnes a t dtecte :<br />
      Fichier <b>".$mysql_database."-backup.sql.gz</b> (en date du ".date ("d/m/Y  H:i:s.", filemtime($fichier_sql)).")<br />
      MD5 : ".md5($fichier_sql)."<br />taille : ".filesize($fichier_sql)." octets<br /><br />
      Si vous poursuivez, ce fichier sera cras ! Assurez-vous d'avoir transfr tout le dossier <b>".$GLOBALS['stock_baselev']."</b> par FTP (ou une autre mthode) sur une machine hors site avant de <a href='".$_SERVER['PHP_SELF']."?erase=ok'>poursuivre</a> !</div>","") ;
      affiche_erreurs($error_message);
      return;
      // on demande ensuite  l'utilisateur s'il est sr de vouloir craser la sauvegarde existante
    }
    // Si on arrive l c'est qu'il n'y a pas de fichier provenant d'une sauvegarde prcdente
    sauvegarder();
  }
}
else // L'utilisateur essaie d'invoquer ce script directement dans l'URL (interdit)
{
  $error_message = array("Vous tentez d'accder  un script qui n'est pas accessible directement  partir de l'URL... Utilisez les liens de navigation !","");
  affiche_erreurs($error_message);
}
?>