<?php
/**
 * c_security_check.php
 *
 * vrification de la scurit PHP
 * 
 * Ce fichier fait partie du projet IntraEduWeb (IEW)
 * 
 * @package		IEW
 * @author			Sylvain GODM <sylvain.godme@gmail.com>
 * @version		$LastChangedRevision$, $LastChangedDate$
 * @copyright		2004-2012 Sylvain GODM
 * @link			http://iew.free.fr
 * @license		GPL License version 3 (http://www.gnu.org/licenses/gpl.html)
 * @filesource
 * 
 */

// Le script en cours doit tre le script d'appel prvu
if (end_with_string($_SERVER['PHP_SELF'],"prive/admintraeduweb/security_check.php"))
{
  echo "<h1>Test de scurit du serveur</h1>
  <center>
  <div class='encadrer' style='text-align: justify;'>
    Voici un <strong>test de scurit</strong> qui permet de savoir si certains lments de scurit sont correctement positionns. Les rsultats de ce test, mme positifs, ne pourront garantir une scurit de 100% car c'est <strong>impossible</strong>.<br />Les vulnrabilits (potentielles) se situent aux niveaux suivants :<br />
    - <i><u>Application IEW</u></i> : c'est le problme du dveloppeur (mais aucune garantie ne peut tre fournie). De votre ct, assurez-vous de faire des mises  jour rgulires du produit ds qu'une nouvelle version est disponible.<br />
    - <i><u>Environnement logiciel</u></i> : Les versions des serveurs web, mysql et de PHP doivent tre le plus  jour possible (des failles de scurit sont rgulirement dcouvertes, puis corriges) et correctement configurs.<br />
    - <i><u>Environnement rseau</u></i> : Si IEW est accessible depuis l'extrieur de l'tablissement, il faut le mettre imprativement derrire un pare-feu, dans une DMZ. Son accessibilit doit tre uniquement possible en mode scuris par SSL (Protocole https).<br />
    Les tests qui suivent ne portent que sur certains lments dcrits ci-dessus; il est de <strong>votre responsabilit</strong> de vous assurer que le maximum de prcautions soit pris  tous les niveaux pr-cits.
  </div>
  </center>";
  $security_warning = false; // a priori tout est secure
  $message_bad_safe_mode_exec_dir = "<i>Modifiez la directive safe_mode_exec_dir pour pointer vers un rpertoire o vous placerez les commandes systmes qu'il faut autoriser pour un fonctionnement complet de IEW,  savoir : <strong>gzip</strong>, <strong>gunzip</strong>, <strong>mysql</strong>, <strong>mysqldump</strong> ( l'exclusion de toute autre commande). Ce rpertoire doit tre lisible par l'utilisateur apache et les commandes qui y sont places doivent tre excutables par cet utilisateur</i>";
  // La configuration PHP pour la scurit
    $code_formulaire = "<h3>Analyse de la Configuration PHP pour la scurit (php.ini)</h3>
    <div align='justify'>";
    $code_formulaire .= "register_globals : ";
    $register_globals = (bool) ini_get('register_globals');
    if (!$register_globals) // doit tre Off
      $code_formulaire .= "<font color='green'><strong>OK</strong></font><br />";
    else
    {
      $code_formulaire .= "<font color='red'><strong>Alerte de scurit</strong> (devrait tre  Off)</font><br />";
      $security_warning = true; // option de scurit (si IEW est accessible depuis l'extrieur)
    }
    $code_formulaire .= "safe_mode : ";
    $safe_mode = (bool) ini_get('safe_mode');
    if ($safe_mode) // doit tre on
      $code_formulaire .= "<font color='green'><strong>OK</strong></font><br />";
    else
    {
      $code_formulaire .= "<font color='red'><strong>Alerte de scurit</strong> (devrait tre  On)</font><br />";
      $security_warning = true; // option de scurit (si IEW est accessible depuis l'extrieur)
    }
    $code_formulaire .= "safe_mode_gid : ";
    $safe_mode_gid = (bool) ini_get('safe_mode_gid');
    if (!$safe_mode_gid) // doit tre off
      $code_formulaire .= "<font color='green'><strong>OK</strong></font><br />";
    else
    {
      $code_formulaire .= "<font color='red'><strong>Alerte de scurit</strong> (devrait tre  Off)</font><br />";
      $security_warning = true; // option de scurit (si IEW est accessible depuis l'extrieur)
    }
    if ($safe_mode) // si mode activ, on vrifie que safe_mode_exec_dir contient les commandes systmes ncessaires au bon fonctionnement de IEW
    {
      $code_formulaire .= "safe_mode_exec_dir : ";
      if (ini_get("safe_mode_exec_dir") == "") // doit contenir les commandes systmes dont IEW a besoin
      {
        $code_formulaire .= "<font color='red'><strong>Non dfini !</strong></font><br />$message_bad_safe_mode_exec_dir.<br />";
        $security_warning = true; // option de scurit (si IEW est accessible depuis l'extrieur)
      }
      else // la directive safe_mode_exec_dir contient quelque chose
      {
        $code_formulaire .= "<font color='green'><strong>OK</strong> (dfini  ".ini_get("safe_mode_exec_dir")." qui doit contenir les excutables requis par le service IEW -voir ci-dessous-)</font><br />";
        // On vrifie si les excutables sont disponibles
        // CODE COPIE A PARTIR DU SCRIPT install.php
        $code_formulaire .= "<br />
        <u><strong><font color='blue'>Vrification des excutables ncessaires</font></strong></u><br />";
        $code_formulaire .= "
        <strong><i>gzip</i></strong> : ";
        $cmd = "gzip --version >/dev/null";
        // on xcute la commande
        // suivant le rsultat, on affiche un message
        exec($cmd,$output,$retval);
        if (isset($retval) && $retval == 0) // commande bien xcute (sur un serveur LINUX)
        {
          $code_formulaire .= "<font color='green'><strong>OK</strong></font><br />";
        }
        else // Le serveur est peut-tre Windows, ou la commande n'est pas disponible
        {
          $code_formulaire .= "<font color='red'>La commande <strong>gzip</strong> ne peut pas te excute sur ce serveur&nbsp;!</font><br />";
          $erreur_install = 1; // option indispensable
        }
        $code_formulaire .= "
        <strong><i>gunzip</i></strong> : ";
        $cmd = "gunzip --version >/dev/null";
        // on xcute la commande
        // suivant le rsultat, on affiche un message
        exec($cmd,$output,$retval);
        if (isset($retval) && $retval == 0) // commande bien xcute (sur un serveur LINUX)
        {
          $code_formulaire .= "<font color='green'><strong>OK</strong></font><br />";
        }
        else // Le serveur est peut-tre Windows, ou la commande n'est pas disponible
        {
          $code_formulaire .= "<font color='red'>La commande <strong>gunzip</strong> ne peut pas te excute sur ce serveur&nbsp;!</font><br />";
          $erreur_install = 1; // option indispensable
        }
        $code_formulaire .= "
        <strong><i>tar</i></strong> : ";
        $cmd = "tar --version >/dev/null";
        // on xcute la commande
        // suivant le rsultat, on affiche un message
        exec($cmd,$output,$retval);
        if (isset($retval) && $retval == 0) // commande bien xcute (sur un serveur LINUX)
        {
          $code_formulaire .= "<font color='green'><strong>OK</strong></font><br />";
        }
        else // Le serveur est peut-tre Windows, ou la commande n'est pas disponible
        {
          $code_formulaire .= "<font color='red'>La commande <strong>tar</strong> ne peut pas te excute sur ce serveur&nbsp;!</font><br />";
          $erreur_install = 1; // option indispensable
        }
        $code_formulaire .= "
        <strong><i>mysql</i></strong> : ";
        $cmd = "mysql --version >/dev/null";
        // on xcute la commande
        // suivant le rsultat, on affiche un message
        exec($cmd,$output,$retval);
        if (isset($retval) && $retval == 0) // commande bien xcute (sur un serveur LINUX)
        {
          $code_formulaire .= "<font color='green'><strong>OK</strong></font><br />";
        }
        else // Le serveur est peut-tre Windows, ou la commande n'est pas disponible
        {
          $code_formulaire .= "<font color='red'>La commande <strong>mysql</strong> ne peut pas te excute sur ce serveur&nbsp;!</font><br />";
          $erreur_install = 1; // option indispensable
        }
        $code_formulaire .= "
        <strong><i>mysqldump</i></strong> : ";
        $cmd = "mysqldump --version >/dev/null";
        // on xcute la commande
        // suivant le rsultat, on affiche un message
        exec($cmd,$output,$retval);
        if (isset($retval) && $retval == 0) // commande bien xcute (sur un serveur LINUX)
        {
          $code_formulaire .= "<font color='green'><strong>OK</strong></font><br />";
        }
        else // Le serveur est peut-tre Windows, ou la commande n'est pas disponible
        {
          $code_formulaire .= "<font color='red'>La commande <strong>mysqldump</strong> ne peut pas te excute sur ce serveur&nbsp;!</font><br />";
          $erreur_install = 1; // option indispensable
        }
        $code_formulaire .= "<br />";
        // FIN DE CODE COPIE A PARTIR DE install.php (denire ligne modifie)
      }
    }
    $code_formulaire .= "safe_mode_include_dir : ";
    if (ini_get("safe_mode_include_dir") == "") // doit tre vide
      $code_formulaire .= "<font color='green'><strong>OK</strong></font><br />";
    else
    {
      $code_formulaire .= "<font color='red'><strong>Alerte de scurit : non vide !</strong> (devrait tre vide)</font><br />";
      $security_warning = true; // option de scurit (si IEW est accessible depuis l'extrieur)
    }
    $code_formulaire .= "safe_mode_allowed_env_vars : ";
    if (ini_get("safe_mode_allowed_env_vars") == "PHP_") // doit contenir "PHP_"
      $code_formulaire .= "<font color='green'><strong>OK</strong></font><br />";
    else
    {
      $code_formulaire .= "<font color='red'><strong>Alerte de scurit</strong> (devrait tre PHP_)</font><br />";
      $security_warning = true; // option de scurit (si IEW est accessible depuis l'extrieur)
    }
    $code_formulaire .= "safe_mode_protected_env_vars : ";
    if (ini_get("safe_mode_protected_env_vars") == "LD_LIBRARY_PATH") // doit contenir "LD_LIBRARY_PATH"
      $code_formulaire .= "<font color='green'><strong>OK</strong></font><br />";
    else
    {
      $code_formulaire .= "<font color='red'><strong>Alerte de scurit</strong> (devrait tre LD_LIBRARY_PATH)</font><br />";
      $security_warning = true; // option de scurit (si IEW est accessible depuis l'extrieur)
    }
    $code_formulaire .= "open_basedir : ";
    // le open_basedir doit comprendre la racine web ET le dossier de stockage data (en principe en dehors de l'arborescence web si les consignes de scurit sont respectes)
    if (ini_get("open_basedir") == "") // Open_basedir vide signifie accs  toute l'arborescence => NON SECURE !
    {
      $code_formulaire .= "<font color='red'><strong>Alerte de scurit</strong> (Le paramtre est vide, donc par dfaut toute l'arborescence de fichiers de votre serveur est accessible potentiellement  partir d'un script PHP)</font><br />";
      $security_warning = true; // option de scurit (si IEW est accessible depuis l'extrieur)
    }
    else // open_basedir n'est pas vide, il faut vrifier qu'il contient la racine web
    {
      $fragment_open_base_dir = explode(":",ini_get("open_basedir"));
      // CONF_DIR contient le chemin d'accs complet au rpertoire de stockage contenant les fichiers spciaux
      if (substr(CONF_DIR,-1,1) == "/") // en principe, ce chemin se termine par un slash
        $conf_dir = substr(CONF_DIR,0,strlen(CONF_DIR)-1); // on retire ce slash
      else
        $conf_dir = CONF_DIR;
      if (in_array($_SERVER['DOCUMENT_ROOT'],$fragment_open_base_dir)) // Ok pour la racine web
      {
        if (!strstr($conf_dir,$_SERVER['DOCUMENT_ROOT'])) // le dossier de stockage est un dossier en dehors de l'arborescence web (conseill)
        {
          // Alors il faut qu'il soit dans l'open_basedir
          if (in_array($conf_dir,$fragment_open_base_dir)) // Ok pour ce dossier
            $code_formulaire .= "<font color='green'><strong>OK</strong></font><br />";
          else
            $code_formulaire .= "<font color='red'>Le dossier <strong>".$conf_dir."</strong> n'est pas prsent dans la directive open_basedir !</font><br />";
        }
        else // Si le dossier de stockage est un sous-dossier de la racine web, pas besoin de le spcifier dans open_basedir (mais c'est dconseill pour des raisons de scurit)
        {  
          $code_formulaire .= "<font color='red'><strong>Alerte de scurit</strong> (Votre dossier de stockage <strong><i>data</i></strong> devrait se trouver en dehors de l'arborescence web au lieu de <strong>".$conf_dir."</strong> !)</font><br />";
          $security_warning = true; // option de scurit (si IEW est accessible depuis l'extrieur)
        }
      }
      else // la racine web n'est pas dans le open_basedir !!
      {
        $code_formulaire .= "<font color='red'><strong>Alerte de scurit</strong> (devrait tre ".$_SERVER['DOCUMENT_ROOT'];
        if (!strstr($conf_dir,$_SERVER['DOCUMENT_ROOT'])) // le dossier de stockage est un dossier en dehors de l'arborescence web (conseill)
          $code_formulaire .= ":".$conf_dir."/"; // On rajoute le slash terminal car sinon c'est un prfixe pour open_basedir (tous les dossiers commenant par $conf_dir seraient accessibles, donc il faut restreindre l'accs uniquement au rperoire $conf_dir et  ses sous-rpertoires)
        $code_formulaire .= ")</font><br />";
        $security_warning = true; // option de scurit (si IEW est accessible depuis l'extrieur)
      }
    }
    $code_formulaire .= "display_errors : ";
    $display_errors = (bool) ini_get('display_errors');
    if (!$display_errors) // doit tre Off en production
    {
      $code_formulaire .= "<font color='green'><strong>OK</strong></font><br />";
      // on vrifie alors que les messages d'erreur sont logus
      $code_formulaire .= "log_errors : ";
      $log_errors = (bool) ini_get('log_errors');
      if ($log_errors) // doit tre On en production
      {
        $code_formulaire .= "<font color='green'><strong>OK</strong></font><br />";
        $code_formulaire .= "error_log : ";
        // on vrifie alors qu'un fichier de log est spcifi
        if (ini_get("error_log") != "") // doit contenir le nom du fichier de log
         $code_formulaire .= "<font color='green'><strong>OK</strong></font><br />";
        else
         $code_formulaire .= "<font color='red'><strong>Le fichier de logs pour enregistrer les erreurs PHP n'est pas spcifi !</strong> Ceci n'est pas un trou de scurit, mais vous ne pourrez pas consulter les erreurs qui peuvent se produire.</font><br />";
      }
      else
        $code_formulaire .= "<font color='red'><strong>Les erreurs PHP ne sont pas enregistres dans des logs !</strong> Ceci n'est pas un trou de scurit, mais vous aurez des difficults  identifier la nature des erreurs qui peuvent se produire.</font><br />";
    }
    else
    {
      $code_formulaire .= "<font color='red'><strong>Alerte de scurit</strong> (devrait tre Off)</font><br />";
      $security_warning = true; // option de scurit (si IEW est accessible depuis l'extrieur)
    }
    $code_formulaire .= "allow_url_fopen : ";
    $allow_url_fopen = (bool) ini_get('allow_url_fopen');
    if (!$allow_url_fopen) // doit tre Off en production
      $code_formulaire .= "<font color='green'><strong>OK</strong></font><br />";
    else
    {
      $code_formulaire .= "<font color='red'><strong>Alerte de scurit</strong> (devrait etre Off)</font><br />";
      $security_warning = true; // option de scurit (si IEW est accessible depuis l'extrieur)
    }
    $code_formulaire .= "short_open_tag : ";
    $short_open_tag = (bool) ini_get('short_open_tag');
    if (!$short_open_tag) // doit tre Off en production
      $code_formulaire .= "<font color='green'><strong>OK</strong></font><br />";
    else
      $code_formulaire .= "<font color='red'><strong>Non compatible avec la norme XML</strong></font><br />";
    $code_formulaire .= "magic_quotes_gpc : ";
    $magic_quotes_gpc = (bool) ini_get('magic_quotes_gpc');
    if ($magic_quotes_gpc) // doit tre On en production
      $code_formulaire .= "<font color='green'><strong>OK</strong> (valeur  On, prfrable au cas o votre serveur hberge des applications PHP mal programmes -ce n'est pas le cas de IEW !-)</font><br />";
    else
    {
      $code_formulaire .= "<font color='red'><strong>Alerte de scurit non bloquante</strong> (devrait etre On, mais IEW peut fonctionner de manire scurise, mme si c'est  Off : sur On c'est une simple prcaution, surtout si sur votre serveur sont installes d'autres applications PHP qui ne sont pas forcment toutes bien scures)</font><br />";
    }
    $code_formulaire .= "magic_quotes_runtime : ";
    $magic_quotes_runtime = (bool) ini_get('magic_quotes_runtime');
    if (!$magic_quotes_runtime) // doit tre Off en production
      $code_formulaire .= "<font color='green'><strong>OK</strong> (valeur  Off)</font><br />";
    else
    {
      $code_formulaire .= "<font color='red'><strong>Alerte non bloquante :</strong> (devrait tre Off, dans le cas contraire, certaines informations rcupres de la base de donnes peuvent comporter le caractre anti-slash, disgracieux  l'affichage des pages)</font><br />";
    }
    $code_formulaire .= "session.save_path : ";
    // le open_basedir doit comprendre la racine web ET le dossier de stockage data (en principe en dehors de l'arborescence web si les consignes de scurit sont respectes)
    $session_save_path = ini_get("session.save_path");
    if ($session_save_path == "/tmp")
    {
      $code_formulaire .= "<font color='red'><strong>Alerte de scurit</strong> (Le rpertoire <strong>/tmp</strong> est accessible en lecture/criture pour tout le monde. Il faut modifier le rpertoire de stockage des sessions commme indiqu dans la documentation de l'administrateur IEW -voir annexe de scurit-)</font><br />";
      $security_warning = true; // option de scurit (si IEW est accessible depuis l'extrieur)
    }
    else // c'est OK
    {
      $code_formulaire .= "<font color='orange'><strong>Alerte de scurit potentielle</strong> (Vrifiez que le rpertoire <i><strong>$session_save_path</strong></i> appartient bien  l'utilisateur apache et a des droits 700 (rwx------) ! Si c'est bien le cas, ne tenez pas compte de cet avertissement)</font><br />";
    }
    $code_formulaire .= affiche_version_environnement();
    // Fin de toutes les vrifications
    $code_formulaire .= "
    </div><br /><br />";
    echo "<br /><center>";
    squelette_formulaire_standard("90%","post",$_SERVER['PHP_SELF'],"<h2>Vrifications de scurit sur la configuration PHP</h2>",$code_formulaire,"","","","","","","");
    echo "</center>";
    
    if ($security_warning)
    {
      $error_message = array("<div align='justify'>Il est FORTEMENT conseill de modifier votre configuration PHP (ventuellement apache) pour que la scurit soit suffisante. C'est INDISPENSABLE si IEW doit tre accessible depuis l'extrieur de l'tablissement et si vous voulez assurer une scurit maximale.<br />Cependant, sachez qu'en modifiant la configuration php, il est possible que d'autres applications web installes sur votre serveur ne fonctionnent plus correctement : il est conseill de d'abord faire une sauvegarde de la configuration php avant toute modification afin de pouvoir revenir  l'tat antrieur en cas de problme avec d'autres applications.<br />Faites les modifications ncessaires dans le fichier php.ini (ventuellement le fichier de configuration apache), redmarrez apache et refaites ce test de scurit jusqu' ce que tous les voyants soient au vert.</div>","");
      affiche_erreurs($error_message);
    }
    else
    {
      $ok_message = "<div align='justify'>Votre configuration PHP offre une scurit suffisante pour utiliser IEW depuis l'extrieur de l'tablissement.
      <br />
      Toutefois, il vous est rappel que la scurit de votre application IEW ne dpend pas que du php.ini, mais de l'environnemment complet. Il faut donc s'assurer de disposer de mises  jour de scurit rcentes et rgulires concernant le serveur web, le serveur MySQL et la version de PHP installe, sans oublier l'application IEW elle-mme qui doit tre mise  jour chaque fois qu'une nouvelle version est disponible.</div>";
      affiche_ok($ok_message);
    }
}
else // L'utilisateur essaie d'invoquer ce script directement dans l'URL (interdit)
{
  $error_message = array("Vous tentez d'accder  un script qui n'est pas accessible directement  partir de l'URL... Utilisez les liens de navigation !","");
  affiche_erreurs($error_message);
}
?>