<?php
/**
 * c_userless.php
 *
 * Recense les lves et les responsables qui peuvent se connecter  IEW, mais qui ne l'ont pas encore fait
 * et vrifie si chaque lve de la table "lves" a un enregistrement correspondant dans la table "login"
 * qui lui permet de se connecter  IEW (pareil pour les responsables)
 * Ce script est notamment utilis lors de la mise au point de la version 1.3.0 pour corriger les bugs
 * lis  la "disparition" (ou la non-cration) d'un compte lve ou responsable dans la table login.
 * 
 * On vrifie galement l'existence de doublons sur les identifiants (ce qui est possible, car l'authentification
 * peut tre locale et sur un serveur SSO, LDAP distant)
 * 
 * Ce fichier fait partie du projet IntraEduWeb (IEW)
 * 
 * @package		IEW
 * @author			Sylvain GODM <sylvain.godme@gmail.com>
 * @version		$LastChangedRevision$, $LastChangedDate$
 * @copyright		2004-2012 Sylvain GODM
 * @link			http://iew.free.fr
 * @license		GPL License version 3 (http://www.gnu.org/licenses/gpl.html)
 * @filesource
 * 
 */

// Le script en cours doit tre le script d'appel prvu
if (end_with_string($_SERVER['PHP_SELF'],"prive/admintraeduweb/userless.php"))
{
	$missing_counter = 0; // compteur d'enregistrements manquants pour les lves dans la table login
	$UserLess = array(); // Contiendra les lves qui ne se sont pas encore connects alors qu'ils le peuvent
	$UserLoginLess = array(); // Contiendra les lves qui ne se sont pas encore connects car ils n'avaient pas d'enregistrement dans la table login
	
	echo "<h1>Script correctif pour les lves ou responsables qui ne pourraient pas se connecter  IEW</h1>";
	
	// Parcours de la table "lves"
	$rapport = "<h2>Analyse des lves dans la base de donnes</h2>";
	$sql = "SELECT * FROM eleves ORDER BY classe,nom,prenom";
 	$resultat = mysql_query($sql);
 	$nb_eleves_base_iew = mysql_num_rows($resultat);
 	$rapport .= "<p>Il y a <b>$nb_eleves_base_iew</b> lves dans la base de donnes <a href='#rapport_eleves'>[Aller directement au rapport]</a></p>";
 	$rapport .= "<br /><h3>Dtail du traitement lve par lve</h3><br />";
 	
 	while($enregistrement = mysql_fetch_array($resultat))
 	{
    	$nom = $enregistrement['nom']; // les critres de recherche...(nom+prenom)
    	$prenom = $enregistrement['prenom'];
    	$id_eleve = $enregistrement['id_eleve']; // correspond  l'id_pers dans la table "login"
    	$eleve_id = $enregistrement['eleve_id'];
    	$classe = $enregistrement['classe'];
    	
    	$rapport .= "<p><u>Cas de l'lve <b>$nom $prenom</b> (classe : <b>$classe</b>)</u></p>";
    	
    	// L'lve a-t-il un enregistrement dans la table login ?
    	$sql2="SELECT nomlogin,auth_source FROM login WHERE id_pers='$id_eleve'";
    	$resultat2 = mysql_query($sql2);
 		if ($resultat2 && mysql_num_rows($resultat2)==0) // s'il existe pas de compte pour cet lve, on en cre un
        {
		   	$rapport .= "<p>$sql2</p>";
        	$rapport .= "<p>Cet lve <strong>n'a pas de compte</strong> IntraEduWeb, on tente de lui en crer un !</p>";
		   	// Attention, traitement spcial au cas ou nom et/ou prnom contient une simple quote (sinon la requte d'insertion chouera)
         	$nom = quote_smart($nom);
		   	$prenom = quote_smart($prenom);
         	$sql = "INSERT INTO login VALUES('$id_eleve',NULL,'$eleve_id',NULL,'','cas','2',NULL,'$nom','$prenom',NULL,'1',NULL)";
		   	mysql_query($sql);
		   	$rapport .= "<p>$sql</p>";
        	if (mysql_affected_rows()>0) // Si l'criture dans la table login a russi, on incrmente un compteur
          	{
		    	$missing_counter++;
          		$rapport .=	"<p>Elve intgr dans la table login.</p>";
          		$UserLoginLess[$classe][] = "$nom $prenom id_pers=$id_eleve";
          	}
          	else // Si l'criture n'a pas russi
          	{
	       		$rapport .= "<p>L'lve <b>".stripslashes($prenom)." ".stripslashes($nom)."</b> n'a pas pu tre enregistr dans la table login.
          		<br />Erreur MySQL : ".mysql_errno(). ": " .mysql_error()."</p>";
       		}
        }
        else  // il existe un enregistrement de la table login pour cet lve 
        {
        	// on rcupre le nom de login
        	$enregistrement2 = mysql_fetch_array($resultat2);
        	$nomlogin = $enregistrement2['nomlogin'];
        	if ($nomlogin == "") // l'lve ne s'est pas encore connect
        	{
        		$UserLess[$classe][] = "$nom $prenom";
        		$rapport .= "<p>Cet lve ne s'est encore jamais connect  IEW !</p>";
        	}
        	else // L'lve s'est dj connect, on recherche le nombre de connexions
        	{
        		$sql3 = "SELECT count(*) as nb FROM journal_connexions WHERE id_pers='$id_eleve'";
        		$resultat3 = mysql_query($sql3);
        		$enregistrement3 = mysql_fetch_array($resultat3);
        		$nb_connexions = $enregistrement3['nb'];
        		$rapport .= "<p>Cet lve s'est dj connect <b>$nb_connexions</b> fois cette anne.</p>";
        	}
        }
        $rapport .= "<hr />";
 	}
 	
 	// Affichage du rapport d'analyse pour les lves
 	$rapport .= "<a name='rapport_eleves'>
 	<br/><h2>Rapport d'analyse pour les lves</h2><br />";
 	$pourcentage = round(($missing_counter/$nb_eleves_base_iew)*100,2);
 	$rapport .= "<p>Sur <b>$nb_eleves_base_iew</b> lves dans la base de donnes IEW, <b>$missing_counter</b> n'avaient pas d'enregistrement dans la table login (soit <b>$pourcentage %</b>).</p>";
 	if ($pourcentage != 0)
 	{
 		$rapport .= "<p>Ceci a t corrig et ces utilisateurs peuvent maintenant se connecter.</p>";
 	}
 	// Affichage des listes
 	$rapport .= "<br /><hr /><h3>Liste des lves qui ne pouvaient pas se connecter, regroups par classe</h3>";
 	$sql4 = "SELECT division FROM divisions ORDER BY division";
 	$resultat4 = mysql_query($sql4);
 	while ($ligne = mysql_fetch_array($resultat4))
 	{
 		$rapport .= "<br /><h4><u>Classe de ".$ligne['division']."</u></h4><br />";
 		$nb = count($UserLoginLess{$ligne['division']});
 		if ($nb > 0)
 		{
 			foreach ($UserLoginLess{$ligne['division']} as $value)
 			{
 				$rapport .= "<b>$value</b><br />";
 			}
 		}
 		else
 		{
 			$rapport .= "Pas d'lve concern dans cette classe.<br />";
 		}
 	}
 	$rapport .= "<br /><hr /><h3>Liste des lves qui pouvaient se connecter, mais qui ne l'ont pas encore fait, regroups par classe</h3>";
	$sql4 = "SELECT division FROM divisions ORDER BY division";
 	$resultat4 = mysql_query($sql4);
 	while ($ligne = mysql_fetch_array($resultat4))
 	{
 		$rapport .= "<br /><h4><u>Classe de ".$ligne['division']."</u> : ";
 		$nb = count($UserLess{$ligne['division']});
 		$rapport .= "$nb lves</h4><br />";
 		if ($nb > 0)
 		{
 			foreach ($UserLess{$ligne['division']} as $value)
 			{
 				$rapport .= "<b>$value</b><br />";
 			}
 		}
 		else
 		{
 			$rapport .= "Pas d'lve concern dans cette classe.<br />";
 		}
 	} 
 	echo $rapport;	// Fin du traitement pour les lves
 	
 	// maintenant les responsables
 	$rapport = "<h2>Analyse des responsables dans la base de donnes</h2>";
 	$missing_counter = 0; // compteur d'enregistrements manquants pour les responsables dans la table login
	$UserLess = array(); // Contiendra les responsables qui ne se sont pas encore connects alors qu'ils le peuvent
	$UserLoginLess = array(); // Contiendra les responsables qui ne se sont pas encore connects car ils n'avaient pas d'enregistrement dans la table login
	// Parcours de la table "responsables"
	$rapport = "<h2>Analyse des responsables dans la base de donnes</h2>";
	$sql = "SELECT t1.nom as nom_responsable,t1.prenom as prenom_responsable,t1.id_pers,libelle_court as lien_parente, classe, t3.nom, t3.prenom FROM responsables as t1, responsables_eleves as t2, eleves as t3, liens_parente as t4 WHERE t1.personne_id=t2.personne_id AND t2.eleve_id=t3.eleve_id AND t4.code_parente=t2.code_parente ORDER BY classe,t3.nom,t3.prenom";
 	$resultat = mysql_query($sql);
 	$nb_enregistrements_responsabilites = mysql_num_rows($resultat);
 	$rapport .= "<p>Il y a <b>$nb_enregistrements_responsabilites</b> responsables dans la base de donnes <a href='#rapport_responsables'>[Aller directement au rapport]</a></p>";
 	$rapport .= "<br /><h3>Dtail du traitement responsables</h3><br />";
 	$rapport .= "<table border='1'>
    	<tr>
    		<th>Classe</th>
    		<th>Nom lve</th>
    		<th>Prnom lve</th>
    		<th>Nom responsable</th>
    		<th>Prnom responsable</th>
    		<th>Lien de parent</th>
    		<th>Compte IEW existant</th>
    		<th>Cration du compte</th>
    		<th>Nb de connexions de l'anne</th>
    	</tr>";
	while($enregistrement = mysql_fetch_array($resultat))
 	{
    	$nom = $enregistrement['nom']; // Nom de l'lve
    	$prenom = $enregistrement['prenom']; // son prnom
    	$nom_responsable = $enregistrement['nom_responsable'];
    	$prenom_responsable = $enregistrement['prenom_responsable'];
    	$id_pers = $enregistrement['id_pers']; // correspond  l'id_pers du responsable dans la table "login"
    	$lien_parente = $enregistrement['lien_parente']; // lien de parent du responsable avec l'lve
    	$classe = $enregistrement['classe'];
    	
    	$rapport .= "
    	<tr>
    		<td>$classe</td>
    		<td>$nom</td>
    		<td>$prenom</td>
    		<td>$nom_responsable</td>
    		<td>$prenom_responsable</td>
    		<td>$lien_parente</td>";
    	
    	// Le responsable a-t-il un enregistrement dans la table login ?
    	$sql2="SELECT nomlogin,auth_source FROM login WHERE id_pers='$id_pers'";
    	$resultat2 = mysql_query($sql2);
 		if ($resultat2 && mysql_num_rows($resultat2)==0) // s'il existe pas de compte pour ce responsable, on en cre un
        {
		   	$rapport .= "<td>NON</td>";
		   	$sql = "INSERT INTO login VALUES('$id_pers',NULL,NULL,'personne_id','','cas','4',NULL,'$nom_responsable','$prenom_responsable',NULL,'1',NULL)";
		   	mysql_query($sql);
        	if (mysql_affected_rows()>0) // Si l'criture dans la table login a russi, on incrmente un compteur
          	{
		    	$missing_counter++;
          		$rapport .=	"<td>OK</td>";
          		$UserLoginLess[$classe][] = "$nom_responsable $prenom_responsable id_pers=$id_pers";
          	}
          	else // Si l'criture n'a pas russi
          	{
	       		$rapport .= "<td>Erreur MySQL : ".mysql_errno(). ": " .mysql_error()."</td>";
       		}
        }
        else  // il existe un enregistrement de la table login pour ce responsable
        {
        	$rapport .= "<td>OUI</td><td>-</td>";
        	// Le responsable s'est-il dj connect ?
        	$enregistrement2 = mysql_fetch_array($resultat2);
        	$nomlogin = $enregistrement2['nomlogin'];
        	if ($nomlogin == "") // Le responsable ne s'est pas encore connect
        	{
        		$UserLess[$classe][] = "$nom $prenom";
        		$rapport .= "<td>ne s'est jamais connect</td>";
        	}
        	else // Le responsable s'est dj connect, on recherche le nombre de connexions
        	{
        		$sql3 = "SELECT count(*) as nb FROM journal_connexions WHERE id_pers='$id_pers'";
        		$resultat3 = mysql_query($sql3);
        		$enregistrement3 = mysql_fetch_array($resultat3);
        		$nb_connexions = $enregistrement3['nb'];
        		$rapport .= "<td>$nb_connexions</td>";
        	}
        }
        $rapport .= "</tr>";
 	}
 	$rapport .= "</table>";
	// Affichage du rapport d'analyse des responsables
 	$rapport .= "<a name='rapport_responsables'>
 	<br/><h2>Rapport d'analyse des Responsables</h2><br />";
 	$sql = "SELECT count(*) as nb_responsables FROM responsables";
 	$resultat = mysql_query($sql);
 	$ligne = mysql_fetch_array($resultat);
 	$nb_responsables = $ligne['nb_responsables'];
 	$pourcentage = round(($missing_counter/$nb_responsables)*100,2);
 	$rapport .= "<p>Sur <b>$nb_enregistrements_responsabilites</b> enregistrements de responsabilit (lve/parent) dans la base de donnes IEW (<b>$nb_responsables</b> responsables), <b>$missing_counter</b> n'avaient pas d'enregistrement dans la table login (soit <b>$pourcentage %</b>).</p>";
 	if ($pourcentage != 0)
 	{
 		$rapport .= "<p>Ceci a t corrig et ces utilisateurs peuvent maintenant se connecter.</p>";
 	}
 	echo $rapport;	// Fin du traitement pour les responsables
 	
 	// On identifie les doublons sur les nomlogin dans la table "login"
 	/* des doublons sont possibles sur ce champ de par la structure de la table et du fait que certains d'entre eux sont crs localement
 	 * et ne proviennent pas d'un serveur SSO */
 	$rapport = "<h2>Analyse des doublons sur les identifiants dans la table <b>login</b></h2>";
	$sql = "SELECT t1.nom, t1.prenom, t1.nomlogin, t1.id_pers, t1.id_individu, t1.eleve_id, t1.id_personne, t1.auth_source, t1.etat, t2.nom as nom_groupe FROM login as t1, groupes_utilisateurs as t2 WHERE EXISTS (SELECT * FROM login as t2 WHERE t1.id_pers<>t2.id_pers AND t1.nomlogin=t2.nomlogin AND nomlogin<>'') AND t1.id_gpe_utilisateurs=t2.id_groupe ORDER BY nomlogin";
 	$resultat = mysql_query($sql);
 	$rapport .= "<br /><table border='1'>
    	<tr>
    		<th>Nom</th>
    		<th>Prnom</th>
    		<th>Identifiant</th>
    		<th>id_pers</th>
    		<th>id_individu</th>
    		<th>eleve_id</th>
    		<th>id_personne</th>
    		<th>auth_source</th>
    		<th>Groupe utilisateur IEW</th>
    		<th>Droit de connexion</th>
    	</tr>";
 	while($enregistrement = mysql_fetch_array($resultat))
 	{
    	$nom = $enregistrement['nom']; 
    	$prenom = $enregistrement['prenom'];
    	$nomlogin = $enregistrement['nomlogin'];
    	$id_pers = $enregistrement['id_pers'];
    	$id_individu = $enregistrement['id_individu']; 
    	$eleve_id = $enregistrement['eleve_id']; 
    	$id_personne = $enregistrement['id_personne'];
    	$auth_source = $enregistrement['auth_source'];
    	$nom_groupe = $enregistrement['nom_groupe'];
    	$etat = $enregistrement['etat'];
    	
    	$rapport .= "
    	<tr>
    		<td>$nom</td>
    		<td>$prenom</td>
    		<td>$nomlogin</td>
    		<td>$id_pers</td>
    		<td>$id_individu</td>
    		<td>$eleve_id</td>
    		<td>$id_personne</td>
    		<td>$auth_source</td>
    		<td>$nom_groupe</td>
    		<td>$etat</td>
    	</tr>";
 	}
 	$rapport .= "</table>";
 	echo "<br /><br />".$rapport;	// Fin du traitement pour les doublons sur les identifiants
}
else // L'utilisateur essaie d'invoquer ce script directement dans l'URL (interdit)
{
  $error_message = array("Vous tentez d'accder  un script qui n'est pas accessible directement  partir de l'URL... Utilisez les liens de navigation !","");
  affiche_erreurs($error_message);
}
?>