<?php
/**
 * c_users_inline.php
 *
 * Affiche les utilisateurs actuellement connects ( trois minutes prs) en les classant par catgorie
 * 
 * Ce fichier fait partie du projet IntraEduWeb (IEW)
 * 
 * @package		IEW
 * @author			Sylvain GODM <sylvain.godme@gmail.com>
 * @version		$LastChangedRevision$, $LastChangedDate$
 * @copyright		2004-2012 Sylvain GODM
 * @link			http://iew.free.fr
 * @license		GPL License version 3 (http://www.gnu.org/licenses/gpl.html)
 * @filesource
 * 
 */

if(!defined('IEW_DIR')) define('IEW_DIR',realpath(dirname(__FILE__)."/../../").'/');
// Inclusions
require_once(IEW_DIR."librairie_fonctions.php");

// Le script en cours doit tre le script d'appel prvu
if (isset($_SESSION['valid_group']) && $_SESSION['valid_group'] == 1)
{
  echo "
  <div id='contenu'>
  <h1>Etat actuel des connexions</h1>";
  // Tableau indiquant les critres de tri possibles
  $tri = array("nom_prenom" => "t2.nom,t2.prenom", "id" => "nomlogin", "cat" => "nom_groupe", "debut" => "debut");
  if (isset($_GET['tri']) && $_GET['tri'] != "") // le critre de tri est dans l'url
  {
    $cle = $_GET['tri'];
  }
  else
    $cle = "nom_prenom"; // Si pas de critre de tri dans l'url => tri par dfaut sur le nom + prnom
  // Extraction des donnes
  $sql = "SELECT t1.*, t2.nomlogin,t2.prenom,t2.nom,t3.nom as nom_groupe FROM journal_connexions as t1, login as t2, groupes_utilisateurs as t3 WHERE t1.fin=0 AND t1.id_pers=t2.id_pers AND t2.id_gpe_utilisateurs=t3.id_groupe ORDER BY ".$tri[$cle];
  $resultat = mysql_query($sql);
  $nb_users_connected = mysql_num_rows($resultat);
  if ($resultat && $nb_users_connected>0)
  {
    echo "<table border='0' width='100%'><tr><td>Il y a actuellement <strong><font color='red'> ".$nb_users_connected."</font></strong> utilisateur(s) connect(s)</td><td><a href='' title='Rechercher un utilisateur'><img src='../../images/loupe.png' alt='[Rechercher]' /></a></td><td><a href='users_stats.php' title='Afficher les statistiques de connexion'><img src='../../images/stats.png' alt='[Statistiques]' /></a></td></tr></table>";
    echo "<h2>Nombre d'utilisateurs connects par Catgorie</h2>";
    // On recherche le nombre de connects par catgorie
    $sql5 = "SELECT nom from groupes_utilisateurs";
    $result5 = mysql_query($sql5);
    $nb_groupes = mysql_num_rows($result5);
    echo "<table class='ctextes'>
    <tr>"; // ligne d'en-tte = nom des catgories
      $i=0;
      $effectif = array();
      while ($ligne5=mysql_fetch_array($result5))
      {
        $i++;
        if ($i == 1)
        	$class_add = " topleft";
        elseif ($i == $nb_groupes)
        	$class_add = " topright";
        else 
        	$class_add = "";
        echo "<th class='fond_sommaire$class_add' align='center'>".$ligne5['nom']."</th>";
        $sql4 = "SELECT count(*) FROM journal_connexions as t1, login as t2, groupes_utilisateurs as t3 WHERE t1.fin=0 AND t1.id_pers=t2.id_pers AND t2.id_gpe_utilisateurs=t3.id_groupe AND t3.nom='".$ligne5['nom']."'";
        $result4 = mysql_query($sql4);
        $ligne4=mysql_fetch_array($result4);
        $effectif[$i]=$ligne4['count(*)'];
      }
      echo "
    </tr>
    <tr>";
    $i = 0;
    foreach ($effectif as $value)
    {
      $i++;
      if ($i == 1)
      	$class_add = " bottomleft";
      elseif ($i == $nb_groupes)
      	$class_add = " bottomright";
      else 
       	$class_add = "";
      echo "
      <td class='corps_formulaire$class_add' align='center'>$value</td>";
    }
    echo "</tr>";
    echo "</table>";
    echo "<br /><h2>Liste des utilisateurs actuellement connects</h2>";
    echo "
    <table class='ctextes' width='100%'>
      <tr>
        <th class='fond_sommaire topleft' align='center'><a href='users_inline.php?tri=id' title=\"Trier selon l'identifiant\">Identifiant</a></th>
        <th class='fond_sommaire' align='center'><a href='users_inline.php?tri=nom_prenom' title='Trier selon le nom'>Nom Prnom</a></th>
        <th class='fond_sommaire' align='center'><a href='users_inline.php?tri=cat' title='Trier selon la catgorie'>Catgorie</a></th>
        <th class='fond_sommaire' align='center'><a href='users_inline.php?tri=debut' title=\"Trier selon l'heure de dbut de la connexion actuelle\">Dbut de la connexion en cours</a></th>
        <th class='fond_sommaire' align='center'>Dure</th>
        <th class='fond_sommaire topright' align='center'>N de la connexion</th>
      </tr>";
    $k = 0;
    while ($ligne=mysql_fetch_array($resultat))
    {
      $k++;
      // si $k est pair, on colore lgrement le fond de la cellule, sinon on laisse en blanc
      if (is_int($k/2))
      {
        $class = "corps_formulaire";
      }
      else
      {
        $class = "";
      }
      // On dtermine la dure de la connexion actuelle en h, min et s
      $duree_timestamp = time()-$ligne['debut'];
      $heures = date("H",$duree_timestamp)-1; // car un bug met toujours une heure de plus (je ne sais pas pourquoi)
      $minutes_secondes = date("i:s",$duree_timestamp);
      $duree = $heures.":".$minutes_secondes;
      // On dtermine le script d'accs aux donnes personnelles de l'utilisateur
      if ($ligne['nom_groupe'] == "parents") // pour un parent
        $script_donnees_perso = "donnees_parent.php?id_pers=".$ligne['id_pers'];
      elseif ($ligne['nom_groupe'] == "eleves") // pour un lve
        $script_donnees_perso = "admin/fichelev.php?id_eleve=".$ligne['id_pers'];
      elseif ($ligne['nom_groupe'] == "ipr")
        $script_donnees_perso = "admin/prive/compte_ipr.php?action=modifier&amp;id_pers=".$ligne['id_pers'];
      elseif ($ligne['nom_groupe'] == "exterieurs") // pour un membre de la communaut ducative extrieur au personnel, aux lves, aux parents, aux ipr
        $script_donnees_perso = ""; // A DETERMINER !!
      else // pour un membre du personnel
      {
        // On rcupre certaines infos manquantes dans la table 'personnel'
        $sql3 = "SELECT * from personnel WHERE id_pers='".quote_smart($ligne['id_pers'])."'";
        $result3 = mysql_query($sql3);
        if ($result3 && mysql_num_rows($result3)) // si utilisateur = admin => pas de rsultat (donc pas de lien vers la fiche perso)
        {
          $ligne3 = mysql_fetch_array($result3);
          $script_donnees_perso = "donnees_perso.php?id_pers=".$ligne['id_pers']."&amp;gpe=personnel";
        }
      }
      if ($k == $nb_users_connected)
      {
      	$class_add_first = " bottomleft";
      	$class_add_last = " bottomright";
      }
      echo "
      <tr>
        <td class='".$class.$class_add_first."'>";
          // Pour admin, pas de lien ver la fiche perso
          if ($ligne['id_pers'] == "1")
            echo $ligne['nomlogin'];
          else
            echo "
            <a href='".$GLOBALS['chemin_relatif']."../".$script_donnees_perso."'>".$ligne['nomlogin']."</a>";
          echo "
        </td>
        <td  class='$class' align='center'>
          ".$ligne['nom']." ".$ligne['prenom']."
        </td>
        <td class='$class' align='center'>".$ligne['nom_groupe']."</td>
        <td class='$class' align='center'>".date("H:i:s",$ligne['debut'])."</td>
        <td class='$class' align='center'>$duree</td>";
        // On dtermine le numro actuel de la connexion (nb total de connexion pour cet utilisateur)
        $sql = "SELECT count(*) FROM journal_connexions WHERE id_pers='".$ligne['id_pers']."'";
        $result2 = mysql_query($sql);
        $nb_connexions = 0;
        if ($result2 && mysql_num_rows($result2))
        {
          $ligne2 = mysql_fetch_array($result2);
          $nb_connexions = $ligne2['count(*)']; // Nombre total de connexions
        }
        echo "
        <td class='".$class.$class_add_last."' align='center'>$nb_connexions</td>
      </tr>";
    }
    echo "
    </table>
    <br/>";
  }
  else
  {
    $error_message = array("Actuellement, personne n'est connect ! Votre session a certainement expir. Rechargez la page pour vous reconnecter.","");
    affiche_erreurs($error_message);
  }
  echo "</div>";
}
else // L'utilisateur essaie d'invoquer ce script directement dans l'URL (interdit)
{
  $error_message = array("Vos droits ne vous autorisent pas  accder  cette page !","");
  affiche_erreurs($error_message);
}
?>