<?php
/**
 * c_users_stats.php
 *
 * Affiche les statistiques des connexions utilisateurs
 * 
 * Ce fichier fait partie du projet IntraEduWeb (IEW)
 * 
 * @package		IEW
 * @author			Sylvain GODM <sylvain.godme@gmail.com>
 * @version		$LastChangedRevision$, $LastChangedDate$
 * @copyright		2004-2012 Sylvain GODM
 * @link			http://iew.free.fr
 * @license		GPL License version 3 (http://www.gnu.org/licenses/gpl.html)
 * @filesource
 * 
 */

connexion_mysql();
select_database();

// Le script en cours doit tre le script d'appel prvu
if (end_with_string($_SERVER['PHP_SELF'],"prive/admintraeduweb/users_stats.php"))
{
  // Choix du type de rsultats prsent : Top Catgorie (dfaut) ou Top Utilisateurs
  if (isset($_GET['top']) && $_GET['top'] != "" && ($_SESSION['valid_group'] == "1" || $_GET['id_pers'] == $_SESSION['valid_id_user']))
    $top = $_GET['top'];
  else
    $top = "cat"; // par dfaut
  if (isset($_GET['tri']) && $_GET['tri'] != "")
    $tri = $_GET['tri'];
  else
    $tri = "";
  echo "<h1>Statistiques des connexions</h1>";
  // Nombre total de connexions (pour calculs de %)
  // On ne se contente pas de "SELECT count(*) FROM journal_connexions" car ce total l prendrait en compte la totalit
  // des connexions (y compris celles des personnes qui ont t supprimes de la base de donnes, dont l'identifiant numrique ne peut
  // pas tre associe  un nom et  une catgorie d'utilisateurs => Il nous faut ignorer ces lignes) et le nombre total de connexions
  // calcules dans le formulaire ne correspondrait pas  la valeur renvoye par "SELECT count(*) FROM journal_connexions"
  // D'o un % total qui ne serait pas de 100% dans la dernire colonne
  $sql = "SELECT count(*) FROM journal_connexions as t1, login as t2, groupes_utilisateurs as t3 WHERE t1.id_pers=t2.id_pers AND t2.id_gpe_utilisateurs=t3.id_groupe";
  $result = mysql_query($sql);
  $ligne=mysql_fetch_array($result);
  $nb_total_connexions = $ligne['count(*)'];

  switch ($top)
  {
    case "cat":
      // Recherche des donnes pour un classement "Top catgories" en nombre de connexions
      $sql = "SELECT nom from groupes_utilisateurs"; // On rcupre les catgories d'utilisateurs
      $result = mysql_query($sql);
      $nb_connexions = array();
      $i=0;
      while ($ligne=mysql_fetch_array($result))
      {
        $i++;
        $sql1 = "SELECT count(*) FROM journal_connexions as t1, login as t2, groupes_utilisateurs as t3 WHERE t1.id_pers=t2.id_pers AND t2.id_gpe_utilisateurs=t3.id_groupe AND t3.nom='".$ligne['nom']."'";
        $result1 = mysql_query($sql1);
        $ligne1=mysql_fetch_array($result1);
        $nb_connexions[$ligne['nom']]=$ligne1['count(*)'];
      }
      // Le tableau $nb_connexions contient en cls les catgories et en valeurs les nombres de connexions correspondantes
      // Il faut trier ce tableau suivant les valeurs dcroissantes
      //print_r($nb_connexions); echo "<br /><br />";
      arsort($nb_connexions);
      //print_r($nb_connexions);
      $code_formulaire = "<br />
      <table class='ctextes' width='100%'>
        <tr>
          <th class='fond_sommaire topleft' align='center'>Rang</th>
          <th class='fond_sommaire' align='center'>Catgorie</th>
          <th class='fond_sommaire' align='center'>Nb Ut.</th>
          <th class='fond_sommaire' align='center'>Nb Ut. connec.</th>
          <th class='fond_sommaire' align='center'>Taux de connexions cat.</th>
          <th class='fond_sommaire' align='center'>Nb connexions</th>
          <th class='fond_sommaire topright' align='center'>% du total</th>
        </tr>";
      reset($nb_connexions);
      $i=0;
      $total_nb_users_cat = array();
      $total_nb_users_cat_connected = array();
      $total_connexions = array();
      $total_pourcentage = array();
      while (list($key, $value) = each($nb_connexions))
      {
        $i++;
        // si $i est pair, on colore lgrement le fond de la cellule, sinon on laisse en blanc
        if (is_int($i/2))
        {
          $class = "style='background-color: #ffffff;'";
        }
        else
        {
          $class = "style='background-color: #cecfce;'";
        }
        $code_formulaire .="
        <tr>
          <td align='center' $class>$i</td>
          <td $class>$key</td>"; 
          // Il faut rcuprer le nombre d'utilisateurs potentiels dans cette catgorie
          $sql = "SELECT count(*) FROM login as t1, groupes_utilisateurs as t2 WHERE t1.id_gpe_utilisateurs=t2.id_groupe AND t2.nom='".quote_smart($key)."'";
          $result = mysql_query($sql);
          $ligne=mysql_fetch_array($result);
          $nb_users_cat=$ligne['count(*)'];
          $total_nb_users_cat[]=$nb_users_cat; // On empile la valeur dans un tableau pour pouvoir calculer des totaux ultrieurement
          // Puis le nombre d'utilisateurs de la catgorie s'tant dj connect au moins une fois
          $sql = "SELECT count(DISTINCTROW t1.id_pers) as nb FROM journal_connexions as t1, login as t2, groupes_utilisateurs as t3 WHERE t1.id_pers=t2.id_pers AND t2.id_gpe_utilisateurs=t3.id_groupe AND t3.nom='".quote_smart($key)."'";
          $result = mysql_query($sql);
          $ligne=mysql_fetch_array($result);
          $nb_users_cat_connected=$ligne['nb'];
          $total_nb_users_cat_connected[]=$nb_users_cat_connected;
          $code_formulaire .="
          <td align='center' $class>$nb_users_cat</td>
          <td align='center' $class>$nb_users_cat_connected</td>
          <td align='center' $class>";
          if ($nb_users_cat !=0)
            $code_formulaire .=round($nb_users_cat_connected/$nb_users_cat*100,1)." %</td>";
          else
            $code_formulaire .="-</td>";
          $code_formulaire .="<td align='center' $class>$value</td>";
          $total_connexions[]=$value;
          $code_formulaire .="<td align='center' $class>";
          if ($nb_total_connexions !=0)
            $code_formulaire .=round($value/$nb_total_connexions*100,1)."</td>";
          else
            $code_formulaire .="-</td>";
          $total_pourcentage[]=round($value/$nb_total_connexions*100,1);
          $code_formulaire .="
        </tr>
        ";
      }
      $code_formulaire.="
      <tr>
          <td class='fond_sommaire bottomleft' align='center' style='background-color: #FC9;'></td>
          <td class='fond_sommaire' align='center' style='font-weight: bold;background-color: #FC9;'>TOTAUX :</td>
          <td class='fond_sommaire' align='center' style='font-weight: bold;background-color: #FC9;'>".array_sum($total_nb_users_cat)."</td>
          <td class='fond_sommaire' align='center' style='font-weight: bold;background-color: #FC9;'>".array_sum($total_nb_users_cat_connected)."</td>
          <td class='fond_sommaire' align='center' style='font-weight: bold;background-color: #FC9;'>".round(array_sum($total_nb_users_cat_connected)/array_sum($total_nb_users_cat)*100,1)." %</td>
          <td class='fond_sommaire' align='center' style='font-weight: bold;background-color: #FC9;'>".array_sum($total_connexions)."</td>
          <td class='fond_sommaire bottomright' align='center' style='font-weight: bold;background-color: #FC9;'>".round(array_sum($total_pourcentage))." %</td>
        </tr>
      </table>
      <div align='left'>
        <ul class='rec_cnil' style='margin-top:1.5em;'>
          <li><strong>Nb Ut. </strong>: Nombre d'utilisateurs dans la catgorie total)<br /></li>
          <li><strong>Nb Ut. connec. </strong>: Nombre d'utilisateurs de la catgorie s'tant dj connects au portail IEW<br /></li>
          <li><strong>Taux de connexions cat. </strong>: % d'utilisateurs de la catgorie s'tant dj connects au portail IEW<br /></li>
          <li><strong>Nb connexions </strong>: Nombre total de connexions (toutes catgories confondues)<br /></li>
          <li><strong>% du total </strong>: Part de connexions de la catgorie dans le total des connexions</li>
          <li><strong><font color='red'>".round(array_sum($total_nb_users_cat_connected)/array_sum($total_nb_users_cat)*100,1)." %</font> </strong>: % des membres de la communaut ducative utilisant les services IEW</li>
        </ul>
      </div>
      ";
      break;
    
    case "user":
      // On rcupre la liste des utilisateurs s'tant connect au moins une fois, en triant suivant le nombre total de connexions en ordre dcroissant
      if ($tri == "") // Cas par dfaut => Tri suivant le nombre de connexions (dcroissant)
        $sql = "SELECT t1.id_pers,t2.nomlogin,t2.nom,t2.prenom,t3.nom as nom_groupe,count(*) as nb FROM journal_connexions as t1, login as t2, groupes_utilisateurs as t3 WHERE t1.id_pers=t2.id_pers AND t2.id_gpe_utilisateurs=t3.id_groupe GROUP BY t1.id_pers ORDER BY nb DESC";
      else // Tri par Dure totale de connexion (dcroissant)
        $sql = "SELECT t1.id_pers,t2.nomlogin,t2.nom,t2.prenom,t3.nom as nom_groupe,count(*) as nb, sum(last_request-debut) as duree FROM journal_connexions as t1, login as t2, groupes_utilisateurs as t3 WHERE t1.id_pers=t2.id_pers AND t2.id_gpe_utilisateurs=t3.id_groupe GROUP BY t1.id_pers ORDER BY duree DESC";
      $result = mysql_query($sql);
      $nb_users = mysql_num_rows($result);
      $code_formulaire = "<br />
      <table class='ctextes'>
        <tr>
          <th class='fond_sommaire topleft' align='center'>Rang</th>
          <th class='fond_sommaire' align='center'>Identifiant</th>
          <th class='fond_sommaire' align='center'>Nom</th>
          <th class='fond_sommaire' align='center'>Prnom</th>
          <th class='fond_sommaire' align='center'>Catgorie</th>
          <th class='fond_sommaire' align='center'><a href='".$_SERVER['PHP_SELF']."?top=user' title='Trier suivant le nombre total de connexions'>Nb connexions</a></th>
          <th class='fond_sommaire' align='center'><a href='".$_SERVER['PHP_SELF']."?top=user&amp;tri=duree' title='Trier suivant la dure totale de connexion'>Dure Totale</a></th>
          <th class='fond_sommaire topright' align='center'>Dure moyenne d'une connexion</th>
        </tr>";
      $i=0;
      for ($k=1;$k<=$nb_users;$k++)
      {
        $script_donnees_perso = ""; // initialisation
        $ligne=mysql_fetch_array($result); // on rcupre un enregistrement
        $i++;
        // si $i est pair, on colore lgrement le fond de la cellule, sinon on laisse en blanc
        if (is_int($i/2))
        {
          $class = "ligne_paire";
        }
        else
        {
          $class = "ligne_impaire";
        }
        // On dtermine le script d'accs aux donnes personnelles de l'utilisateur
        if ($ligne['nom_groupe'] == "parents") // pour un parent
          $script_donnees_perso = "donnees_parent.php?id_pers=".$ligne['id_pers'];
        elseif ($ligne['nom_groupe'] == "eleves") // pour un lve
          $script_donnees_perso = "admin/fichelev.php?id_eleve=".$ligne['id_pers'];
        elseif ($ligne['nom_groupe'] == "ipr")
          $script_donnees_perso = "admin/prive/compte_ipr.php?action=modifier&amp;id_pers=".$ligne['id_pers'];
        elseif ($ligne['nom_groupe'] == "exterieurs") // pour un membre de la communaut ducative extrieur au personnel, aux lves, aux parents, aux ipr
          $script_donnees_perso = "donnees_perso.php?id_pers=".$ligne['id_pers']."&amp;gpe=personnel"; // A REDETERMINER !!
        else // pour un membre du personnel
        { 
          // On rcupre certaines infos manquantes dans la table 'personnel'
          $sql3 = "SELECT * from personnel WHERE id_pers='".quote_smart($ligne['id_pers'])."'";
          $result3 = mysql_query($sql3);
          if ($result3 && mysql_num_rows($result3)) // si utilisateur = admin => pas de rsultat (donc pas de lien vers la fiche perso)
          {
            $ligne3 = mysql_fetch_array($result3);
            $script_donnees_perso = "donnees_perso.php?id_pers=".$ligne['id_pers']."&amp;gpe=personnel";
          }
        }
      	if ($k == $nb_users)
      	{
      		$class_add_first = " bottomleft";
      		$class_add_last = " bottomright";
      	}
        $code_formulaire .="
        <tr>
          <td align='center' class='".$class.$class_add_first."'>$i</td>
          <td class='$class'>";
          if ($ligne['id_pers']=="1")
            $code_formulaire .= $ligne['nomlogin'];
          else
            $code_formulaire .= "<a href='".$GLOBALS['chemin_relatif']."prive/".$script_donnees_perso."'>".$ligne['nomlogin']."</a>";
          $code_formulaire .= "</td>
          <td class='$class'>".$ligne['nom']."</td>
          <td class='$class'>".$ligne['prenom']."</td>
          <td class='$class'>".$ligne['nom_groupe'];
          // La colonne suivante est une colonne de tri possible (si le tri se fait suivant cette colonne, on la met en vidence)
          if ($ligne['nb'] == "0") // Si le nombre de connexions n'est pas nul on met un lien vers l'historique des connexions de cet utilisateur
            $contenu = $ligne['nb'];
          else
            $contenu ="<a href='".$_SERVER['PHP_SELF']."?top=log&amp;id_pers=".$ligne['id_pers']."'>".$ligne['nb']."</a>";
          $code_formulaire .= "</td>";
          if ($tri == "")
          {
            $code_formulaire .="
          <td align='center' class='entete_page'>".$contenu."</td>";
          }
          else
          {
            $code_formulaire .="
            <td align='center' class='$class'>".$contenu."</td>";
          }
        // On dtermine la dure totale des connexionx de l'utilisateur (y compris si connexion actuellement en cours)
        // On ne prend pas le champ 'fin' car celui-ci ne correspond pas  la fin relle de la connexion (la dernire requte
        // seule est prise en compte, mme si elle se fait par un heartbeat 'je_suis_la()' )
        $sql1 = "select sum(last_request-debut) as duree from journal_connexions WHERE id_pers='".$ligne['id_pers']."'";
        $result1 = mysql_query($sql1);
        $ligne1 = mysql_fetch_array($result1);
        $duree = $ligne1['duree']; // dure totale en secondes
        $heures = floor($duree/3600);
        if ($heures < 10)
          $heures = "0".$heures;
        $reste_secondes = ($duree%3600);
        $minutes = floor($reste_secondes/60);
        if ($minutes < 10)
          $minutes = "0".$minutes;
        $reste_secondes = ($reste_secondes%60);
        if ($reste_secondes < 10)
          $reste_secondes = "0".$reste_secondes;
        $duree_totale = $heures.":".$minutes.":".$reste_secondes; // dure totale au format 00:00:00
        // La colonne suivante est une colonne de tri possible (si le tri se fait suivant cette colonne, on la met en vidence)
        if ($tri == "duree")
        {
          $code_formulaire .="
          <td align='center' class='entete_page'>$duree_totale</td>";
        }
        else
        {
        $code_formulaire .="
          <td align='center' class='$class'>$duree_totale</td>"; 
        }
        // On dtermine la dure moyenne d'une connexion pour cet utilisateur
        $duree_moyenne = round($duree/$ligne['nb']); // dure moyenne en secondes
        $heures = floor($duree_moyenne/3600);
        if ($heures < 10)
          $heures = "0".$heures;
        $reste_secondes = ($duree_moyenne%3600);
        $minutes = floor($reste_secondes/60);
        if ($minutes < 10)
          $minutes = "0".$minutes;
        $reste_secondes = ($reste_secondes%60);
        if ($reste_secondes < 10)
          $reste_secondes = "0".$reste_secondes;
        $duree_moyenne = $heures.":".$minutes.":".$reste_secondes; // dure totale au format 00:00:00
        $code_formulaire .= "
          <td align='center' class='".$class.$class_add_last."'>$duree_moyenne</td>
        </tr>
        ";
      }
      $code_formulaire .="
      </table>";
      break;
      
      case "log":
      // Ici il s'agit de mettre un historique des connexions pour un utilisateur donn
      $sql = "SELECT * FROM journal_connexions WHERE id_pers=".quote_smart($_GET['id_pers'])." ORDER BY id_connexion DESC";
      $result = mysql_query($sql);
      $code_formulaire = "<br />
      <table class='ctextes'>
        <tr>
          <th class='fond_sommaire topleft' align='center'>Connexion n</th>
          <th class='fond_sommaire' align='center'>Date/heure dbut</th>
          <th class='fond_sommaire' align='center'>Date/heure fin</th>
          <th class='fond_sommaire' align='center'>Dure</th>
          <th class='fond_sommaire' align='center'>Navigateur</th>
          <th class='fond_sommaire topright' align='center'>Adresse IP</th>
        </tr>
        ";
      $i=0;
      $k=0;
      $nb_connexions = mysql_num_rows($result);
      while ($ligne=mysql_fetch_array($result))
      {
        $i++;
        // si $i est pair, on colore lgrement le fond de la cellule, sinon on laisse en blanc
      if (is_int($i/2))
      {
        $class = "ligne_paire";
      }
      else
     {
        $class = "ligne_impaire";
      }
      	if ($i == $nb_connexions)
      	{
      		$class_add_first = " bottomleft";
      		$class_add_last = " bottomright";
      	}
        $num_connexion = $nb_connexions - $k;
        $code_formulaire .="
        <tr>
          <td align='center' class='".$class.$class_add_first."'>".$num_connexion."</td>
          <td align='center' class='$class'>".date("d/m/Y",$ligne['debut'])."<br /><i>".date("H:i:s",$ligne['debut'])."</i></td>
          <td align='center' class='$class'>".date("d/m/Y",$ligne['last_request'])."<br /><i>".date("H:i:s",$ligne['last_request'])."</i></td>";
        // Calcul de la dure de la connexion
        $duree = $ligne['last_request']-$ligne['debut']; // dure en secondes
        $heures = floor($duree/3600);
        if ($heures < 10)
          $heures = "0".$heures;
        $reste_secondes = ($duree%3600);
        $minutes = floor($reste_secondes/60);
        if ($minutes < 10)
          $minutes = "0".$minutes;
        $reste_secondes = ($reste_secondes%60);
        if ($reste_secondes < 10)
          $reste_secondes = "0".$reste_secondes;
        $duree = $heures.":".$minutes.":".$reste_secondes; // dure au format 00:00:00
        $code_formulaire .= "
          <td align='center' class='$class'>$duree</td>
          <td align='center' class='$class'>".$ligne['navigateur']."</td>
          <td align='center' class='".$class.$class_add_last."'>".$ligne['ip']."</td>
        </tr>
        ";
        $k++;
      }
      $code_formulaire .="
      </table><br />";
      break;
  }
  echo "<br /><center>";
  $critere = ""; // Contiendra le critre du classement
  if ($tri == "duree")
    $critere = "(selon la dure totale de connexion)";
  else
    $critere = "(selon le nombre de connexions)";
  if ($top=="cat")
  {
    $titre_form_head = "Classement TOP Catgories";
  	$titre_form = "Classement TOP Catgories <img src='".$GLOBALS['chemin_relatif']."images/pixel.gif' width='20' alt='' /><a href='".$_SERVER['PHP_SELF']."?top=user'><img src='".$GLOBALS['chemin_relatif']."images/little_next.png' align='middle' alt='[Classement Top Utilisateurs]' title='Vers le Classement Top Utilisateurs (accs pour les administrateurs uniquement)' /></a>";
  }
  elseif ($top == "user")
  {
    $titre_form_head = "Classement Top Utilisateurs";
  	$titre_form = "<a href='".$_SERVER['PHP_SELF']."?top=cat'><img src='".$GLOBALS['chemin_relatif']."images/little_previous.png' align='middle' alt='[Classement Top Catgories]' title='Vers le Classement Top Catgories' /></a><img src='".$GLOBALS['chemin_relatif']."images/pixel.gif' width='20' alt='' /> Classement TOP Utilisateurs $critere";
  }
  elseif ($top == "log")
  {
    $sql = "SELECT t1.nom,t1.prenom, t2.nom as nom_groupe FROM login as t1, groupes_utilisateurs as t2 WHERE t1.id_pers='".quote_smart($_GET['id_pers'])."' AND t1.id_gpe_utilisateurs=t2.id_groupe";
    $resultat = mysql_query($sql);
    if (mysql_num_rows($resultat) >0)
    {
      $ligne = mysql_fetch_array($resultat);
      if ($_GET['id_pers'] == "1")
        $titre_form = "Historique des connexions de l'administrateur IEW<br/>(admin-iew)";
      else
        $titre_form = "Historique des connexions de ".$ligne['prenom']." ".$ligne['nom']."<br/>(Groupe ".$ligne['nom_groupe'].")";
      $titre_form_head = $titre_form;
    }
    else
    {
      $error_message = array("Il n'y a pas d'utilisateur correspondant  l'identifiant spcifi dans la base de donnes !","");
      affiche_erreurs($error_message);
      return;
    }
  }
  squelette_formulaire_standard("100%","","","<h2 class='hidden'>$titre_form_head</h2>$titre_form",$code_formulaire,"","","","","","","");
  echo "</center>";

}
else // L'utilisateur essaie d'invoquer ce script directement dans l'URL (interdit)
{
  $error_message = array("Vous tentez d'accder  un script qui n'est pas accessible directement  partir de l'URL... Utilisez les liens de navigation !","");
  affiche_erreurs($error_message);
}
?>