<?php
/**
 * prepare_diffusion_new_comptes.php
 *
 * Ce script permet la gnration de trois fichiers textes formats contenant les donnes 
 * des login et mots de passe des utilisateurs (uniquement ceux identifis localement dans la base IEW) servant de sources de donnes pour la fusion
 * avec les documents principaux Code_acces_*.odt
 * 
 * Les fichiers gnrs dans le rpertoire de stockage des fichiers spciaux sont :
 * - diffusion_comptes_eleves.txt
 * - diffusion_comptes_profs.txt
 * - diffusion_comptes_autres_pers.txt
 * 
 * Les fichiers lus au dpart sont comptes_eleves.txt et comptes_personnel.txt
 * Les fichiers diffusion_* sont des fichiers crs temporairement (car ils contiennent les mots de passe en clair des utilisateurs)
 * et replacs ensuite dans une archive tar.gz que l'on tlcharge, et qui est supprime du serveur pour des raisons de scurit
 * De plus, il ne contiennent que les mots de passe  diffuser au dbut de l'anne scolaire, et pas ceux qui
 * sont ventuellement modifis par la suite par leur propritaire !
 * 
 * Ce fichier fait partie du projet IntraEduWeb (IEW)
 * 
 * @package		IEW
 * @author			Sylvain GODM <sylvain.godme@gmail.com>
 * @version		$LastChangedRevision$, $LastChangedDate$
 * @copyright		2004-2012 Sylvain GODM
 * @link			http://iew.free.fr
 * @license		GPL License version 3 (http://www.gnu.org/licenses/gpl.html)
 * @filesource
 * 
 */

// la page est protge, elle utilise les sessions et le systme d'authentification diffrencie
// le tableau $array_valid_user contient les identifiants des catgories d'utilisateurs autoriss  accder  cette page (voir la table groupes_utilisateurs)

if(!defined('IEW_DIR')) define('IEW_DIR',realpath(dirname(__FILE__)."/../../").'/');
// Inclusions
require_once(IEW_DIR."librairie_fonctions.php");
if ($_SESSION['valid_group'] == "1")
{
  include(CONF_DIR."k.php");
  // On va parcourir la base de donnes
  connexion_mysql();
  select_database();
  $erreur = "";

  if ($GLOBALS['auth_method'] == "native")
  {
  	// On traite d'abord les utilisateurs lves
  	if (file_exists($GLOBALS['stock_baselev']."comptes_eleves.txt")) // ce fichier est ncessaire pour que le script s'excute correctement
  	{
    	// On commence par ouvrir le fichier utilis
    	$fichier_lu=@fopen($GLOBALS['stock_baselev']."comptes_eleves.txt","r");
    	if ($fichier_lu)
    	{
      	$fichier = fopen($GLOBALS['stock_baselev']."diffusion_comptes_eleves.txt","w"); // ouverture en criture en crasant le contenu existant
	      // on ecrit la ligne d'en-tte contenant les champs de donnes
    	  $enregistrement="id_pers,login,prenom,nom,mdp,limit_date_mdp,classe,ninterne_sconet,identifiant_national\n";
      	fwrite($fichier,$enregistrement);
      	while (!feof($fichier_lu)) // on commence la lecture jusqu' la fin du fichier
      	{
        	$champs_lus=fgetcsv($fichier_lu,100,","); // Lit une ligne et envoie dans un tableau les champs spars par des tabulations
        	if (count($champs_lus)!=0) // si la ligne n'est pas vide
        	{
          		$nomlogin=$champs_lus[1];
          		$mot_passe=$champs_lus[4];
          		$limit_date_passwd=$champs_lus[5];
	        	// Le mot de passe dans le fichier lu est crypt, il faut le dcrypter pour le fichier de diffusion
    		    $mot_passe = mcrypt_decrypt($algo, $crypt_key, base64_decode($mot_passe), $mode, $iv);
          		$mot_passe = rtrim($mot_passe, "\0"); // Supprime les caractres null en fin de chane ventuellement ajouts par la fonction mcrypt_decrypt()
          		$sql="SELECT t1.nom,t1.prenom,t1.classe,t1.elenoet,t1.id_national,t2.id_pers FROM eleves as t1,login as t2 WHERE t2.nomlogin='".quote_smart($nomlogin)."' AND
          		t1.id_eleve=t2.id_pers";
          		$resultat=mysql_query($sql);
          		if ($resultat && mysql_num_rows($resultat)==1)
          		{
            		$ligne=mysql_fetch_array($resultat);
            		$enregistrement=$ligne['id_pers'].",".$nomlogin.",".$ligne['prenom'].",".$ligne['nom'].",".$mot_passe.",".$limit_date_passwd.",".$ligne['classe'].",".$ligne['elenoet'].",".$ligne['id_national']."\n";
            		fwrite($fichier,$enregistrement);
          		}
          		else
          		{
            		if ($champs_lus[1]) // si le champ contient une donne
            		{
              			$erreur .= "Problme : l'lve ".$champs_lus[2]." ".$champs_lus[3]." n'a pas t trouv dans la base de donne  ou n'est pas unique. Il ne sera donc pas dans le fichier de sortie. Veuillez vrifier directement dans la base de donnes...<br />";
            		}
          		}
        	}
      	}
      	fclose($fichier);
      	fclose ($fichier_lu);
    
	    /*// Dernire manip
     	// Cette manip est dsactive car elle empche le tlchargment des fichiers spciaux par l'admin
	      // puisqu'elle les supprime. Si on dcommentait toutes ces lignes,l'admin ne serait pas en mesure de connatre les nouveaux comptes (pour le rseau pdagogique), ni les comptes  supprimer (pour le rseau pdagogique)
    	  // Le mme pb se pose pour les membres du personnel, mais pas pour les parents, vu qu'ils n'ont pas de compte sur le rseau pdagogique
	      // On efface le fichier new_comptes_eleves contenant les nouveaux comptes lves rentrs en cours d'anne
	      // Chaque lve inscrit aprs la diffusion des comptes utilisateurs, va se trouver ajout dans ce fichier (sera utile  l'administrateur rseau pour crer les comptes utilisateurs correspondants)
    	  if (file_exists($GLOBALS['stock_baselev']."new_comptes_eleves.txt"))
      	  {
        	copy($GLOBALS['stock_baselev']."new_comptes_eleves.txt",$GLOBALS['stock_baselev']."new_comptes_eleves.bak");
        	unlink($GLOBALS['stock_baselev']."new_comptes_eleves.txt");
      	  }
	      // On efface le fichier suppr_comptes_eleves contenant les comptes lves  supprimer en cours d'anne scolaire
    	  // Chaque lve qui quitte l'tablissement en cours d'anne est inscrit dans ce fichier (sera utile  l'administrateur rseau pour supprimer les comptes utilisateurs correspondants)
      	  if (file_exists($GLOBALS['stock_baselev']."suppr_comptes_eleves.txt"))
	      {
        	copy($GLOBALS['stock_baselev']."suppr_comptes_eleves.txt",$GLOBALS['stock_baselev']."suppr_comptes_eleves.bak");
        	unlink($GLOBALS['stock_baselev']."suppr_comptes_eleves.txt");
      	  }*/
	  }
      else
      {
        $erreur .= "Le fichier de compte lves existe sur le serveur, mais ne peut tre lu ! Il est impossible de gnrer le fichier de diffusion des comptes lves.<br />";
      }
    }
    else // Le fichier indispensable n'est pas l
    {
      $fichier = fopen($GLOBALS['stock_baselev']."diffusion_comptes_eleves.txt","w"); 
      fclose($fichier);
      $erreur .= "Aucun fichier de compte lves n'existe sur le serveur ! Il est impossible de remplir le fichier de diffusion des comptes lves.<br />";
    }
    
	   // Et maintenant les parents
  	if (file_exists($GLOBALS['stock_baselev']."comptes_parents.txt")) // ce fichier est ncessaire pour que le script s'excute correctement
  	{
	    // On commence par ouvrir le fichier utilis
    	$fichier_lu=@fopen($GLOBALS['stock_baselev']."comptes_parents.txt","r");
    	if ($fichier_lu)
    	{
      		$fichier = fopen($GLOBALS['stock_baselev']."diffusion_comptes_parents.txt","w"); // ouverture en criture en crasant le contenu existant
		      // on ecrit la ligne d'en-tte contenant les champs de donnes
    		  // l, comme certains champs comportent des virgules (ex : adresse => n, rue XXXXX)
	    	  // Le sparateur de champs est le point-virgule
    	  	$enregistrement="id_pers;login;prenom;nom;mdp;limit_date_mdp;prenom_eleve;nom_eleve;classe_eleve;ligne1_adresse;ligne2_adresse;ligne3_adresse;ligne4_adresse;code_postal;commune\n";
      		fwrite($fichier,$enregistrement);
      		while (!feof($fichier_lu)) // on commence la lecture jusqu' la fin du fichier
      		{
	        	// Les champs lus eux sont spars par une virgule
        		$champs_lus=fgetcsv($fichier_lu,100,","); // Lit une ligne et envoie dans un tableau les champs spars par des tabulations
        		if (count($champs_lus)!=0) // si la ligne n'est pas vide
        		{
          			$nomlogin=$champs_lus[1];
          			$prenom_parent=$champs_lus[2];
          			$nom_parent=$champs_lus[3];
          			$mot_passe=$champs_lus[4];
          			$limit_date_passwd = $champs_lus[5];
			        // Le mot de passe dans le fichier lu est crypt, il faut le dcrypter pour le fichier de diffusion
    			    $mot_passe = mcrypt_decrypt($algo, $crypt_key, base64_decode($mot_passe), $mode, $iv);
        			$mot_passe = rtrim($mot_passe, "\0"); // Supprime les caractres null en fin de chane ventuellement ajouts par la fonction mcrypt_decrypt()
          			$id_pers=$champs_lus[0];
	  	            // Pour chaque parent du fichier de compte, on recherche quelques infos dans la bdd (nom et prenom de l'enfant scolaris dans l'tablissement, adresse du parent pour le mailing)
    	      
	        	    //$sql="SELECT AES_DECRYPT(adresse,'".$GLOBALS['crypt_key']."') as adresse,t1.code_postal,t1.commune,t2.nom,t2.prenom,t2.classe FROM parents as t1,eleves as t2 WHERE t1.ereno=t2.ereno AND t1.id_pers='".quote_smart($id_pers)."' ORDER BY t2.datnaiss,t2.nom,t2.prenom DESC";
          
    	      		$sql ="SELECT t1.nom,t1.prenom,t1.date_naiss,code_structure,
    	      		AES_DECRYPT(ligne1_adresse,'".$GLOBALS['crypt_key']."') as ligne1_adresse,
   					AES_DECRYPT(ligne2_adresse,'".$GLOBALS['crypt_key']."') as ligne2_adresse,
   					AES_DECRYPT(ligne3_adresse,'".$GLOBALS['crypt_key']."') as ligne3_adresse,
   					AES_DECRYPT(ligne4_adresse,'".$GLOBALS['crypt_key']."') as ligne4_adresse,
   					AES_DECRYPT(code_postal,'".$GLOBALS['crypt_key']."') as code_postal,
   					AES_DECRYPT(libelle_postal,'".$GLOBALS['crypt_key']."') as libelle_postal FROM eleves as t1, adresses_responsables as t2, responsables as t3, responsables_eleves as t4, structures_eleves as t5 WHERE t3.id_pers='$id_pers' AND t3.adresse_id=t2.adresse_id AND t4.personne_id=t3.personne_id AND t1.eleve_id=t4.eleve_id AND t5.eleve_id=t1.eleve_id AND type_structure='D' ORDER BY date_naiss DESC";
        	  		$resultat=mysql_query($sql);
          			if ($resultat && mysql_num_rows($resultat)>0)
          			{
			            // S'il y a plus d'un enregistrement trouv, c'est que le parent en question a plusieurs enfants solariss dans l'tablissement
			            // Dans ce cas, seul le plus ag est pris en compte. Le parent ne se retrouvera donc pas en double dans le fichier de sortie
    			        $ligne=mysql_fetch_array($resultat);
        			    // Nouvel enregistrement  crire dans le fichier de diffusion
            			$enregistrement=$id_pers.";".$nomlogin.";".$prenom_parent.";".$nom_parent.";".$mot_passe.";".$limit_date_passwd.";".$ligne['prenom'].";".$ligne['nom'].";".$ligne['code_structure'].";".$ligne['ligne1_adresse'].";".$ligne['ligne2_adresse'].";".$ligne['ligne3_adresse'].";".$ligne['ligne4_adresse'].";".$ligne['code_postal'].";".$ligne['libelle_postal']."\n";
            			fwrite($fichier,$enregistrement);
          			}
          			else
          			{
	            		if ($champs_lus[1]) // si le champ contient une donne
            			{
	              			$erreur .= "Problme : Le parent ".$champs_lus[2]." ".$champs_lus[3]." n'a pas t trouv dans la base de donne. Il ne sera donc pas dans le fichier de sortie. Veuillez vrifier directement dans la base de donnes...<br />";
    	        		}
        	  		}
        		}
      		}
      		fclose($fichier);
      		fclose ($fichier_lu);

		      // On efface le fichier new_comptes_parents contenant les nouveaux comptes rentrs en cours d'anne
    		  // Chaque parent inscrit aprs la diffusion des comptes utilisateurs, va se trouver ajout dans ce fichier (sera utile  l'administrateur rseau pour crer les comptes utilisateurs correspondants)
	      	if (file_exists($GLOBALS['stock_baselev']."new_comptes_parents.txt"))
      		{
	        	copy($GLOBALS['stock_baselev']."new_comptes_parents.txt",$GLOBALS['stock_baselev']."new_comptes_parents.bak");
    	    	unlink($GLOBALS['stock_baselev']."new_comptes_parents.txt");
      		}
		      // On efface le fichier suppr_comptes_parents contenant les comptes  supprimer en cours d'anne scolaire
    		  // Chaque parent qui "quitte" l'tablissement en cours d'anne est inscrit dans ce fichier (sera utile  l'administrateur rseau pour supprimer les comptes utilisateurs correspondants)
      		if (file_exists($GLOBALS['stock_baselev']."suppr_comptes_parents.txt"))
      		{
        		copy($GLOBALS['stock_baselev']."suppr_comptes_parents.txt",$GLOBALS['stock_baselev']."suppr_comptes_parents.bak");
        		unlink($GLOBALS['stock_baselev']."suppr_comptes_parents.txt");
      		}
    	}
    	else
    	{
      		$erreur .= "Le fichier de compte parents existe sur le serveur, mais ne peut tre lu ! Il est impossible de gnrer le fichier de diffusion des comptes parents.<br/>";
    	}
  	}
  	else // Le fichier indispensable n'est pas l
  	{
    	$fichier = fopen($GLOBALS['stock_baselev']."diffusion_comptes_parents.txt","w"); 
    	fclose($fichier);
    	$erreur .= "Aucun fichier de compte parents n'existe sur le serveur ! Il est impossible de remplir le fichier de diffusion des comptes parents.<br/>";
  	}
  }

  // Maintenant, on traite les membres du personnel (profs et autres) : certains d'entre eux peuvent tre crs localement mme en authentification SSO
  if (file_exists($GLOBALS['stock_baselev']."comptes_personnel.txt")) // ce fichier est ncessaire pour que le script s'excute correctement
  {
    // On commence par ouvrir le fichier utilis
    $fichier_lu=@fopen($GLOBALS['stock_baselev']."comptes_personnel.txt","r");
    if ($fichier_lu)
    {
      $fichier1 = fopen($GLOBALS['stock_baselev']."diffusion_comptes_profs.txt","w"); // ouverture en criture en crasant le contenu existant
      $fichier2 = fopen($GLOBALS['stock_baselev']."diffusion_comptes_autres_personnels.txt","w"); // ouverture en criture en crasant le contenu existant
      // on ecrit la ligne d'en-tte contenant les champs de donnes
      $enregistrement="id_pers,login,prenom,nom,mdp,limit_date_mdp\n";
      fwrite($fichier1,$enregistrement);
      fwrite($fichier2,$enregistrement);
      while (!feof($fichier_lu)) // on commence la lecture jusqu' la fin du fichier
      {
        $champs_lus=fgetcsv($fichier_lu,100,","); // Lit une ligne et envoie dans un tableau les champs spars par des tabulations
        if (count($champs_lus)!=0) // si la ligne n'est pas vide
        {
          $nomlogin=$champs_lus[1];
          $mot_passe=$champs_lus[4];
          $limit_date_passwd=$champs_lus[5];
          // Le mot de passe dans le fichier lu est crypt, il faut le dcrypter pour le fichier de diffusion
          $mot_passe = mcrypt_decrypt($algo, $crypt_key, base64_decode($mot_passe), $mode, $iv);
          $mot_passe = rtrim($mot_passe, "\0"); // Supprime les caractres null en fin de chane ventuellement ajouts par la fonction mcrypt_decrypt()
          $sql="SELECT t1.nom,t1.prenom,t1.categorie,t1.id_pers FROM personnel as t1,login as t2 WHERE t2.nomlogin='".quote_smart($nomlogin)."' AND
          t1.id_pers=t2.id_pers";
          $resultat=mysql_query($sql);
          if ($resultat && mysql_num_rows($resultat)==1)
          {
            $ligne=mysql_fetch_array($resultat);
            $enregistrement=$ligne['id_pers'].",".$nomlogin.",".$ligne['prenom'].",".$ligne['nom'].",".$mot_passe.",".$limit_date_passwd."\n";
            // si la personne est un enseignant, on crit les infos de comptes dans le fichier adquat
            if ($ligne['categorie'] == "7")
            {
              fwrite($fichier1,$enregistrement);
            }
            else
            {
              fwrite($fichier2,$enregistrement);
            }
          }
          else
          {
            if ($champs_lus[1]) // si le champ contient une donne
            {
              $erreur .= "Problme : Le membre du personnel ".$champs_lus[2]." ".$champs_lus[3]." n'a pas t trouv dans la base de donne ou n'est pas unique. Il ne sera donc pas dans le fichier de sortie. Veuillez vrifier directement dans la base de donnes...<br />";
            }
          }
        }
      }
      fclose($fichier1);
      fclose($fichier2);
      fclose ($fichier_lu);
      
      /*// On efface le fichier new_comptes_personnel contenant les nouveaux comptes rentrs en cours d'anne
      // Chaque membre du personnel inscrit aprs la diffusion des comptes utilisateurs, va se trouver ajout dans ce fichier (sera utile  l'administrateur rseau pour crer les comptes utilisateurs correspondants)
      if (file_exists($GLOBALS['stock_baselev']."new_comptes_personnel.txt"))
      {
        copy($GLOBALS['stock_baselev']."new_comptes_personnel.txt",$GLOBALS['stock_baselev']."new_comptes_personnel.bak");
        unlink($GLOBALS['stock_baselev']."new_comptes_personnel.txt");
      }
      // On efface le fichier suppr_comptes_personnel contenant les comptes  supprimer en cours d'anne scolaire
      // Chaque membre du personnel qui quitte l'tablissement en cours d'anne est inscrit dans ce fichier (sera utile  l'administrateur rseau pour supprimer les comptes utilisateurs correspondants)
      if (file_exists($GLOBALS['stock_baselev']."suppr_comptes_personnel.txt"))
      {
        copy($GLOBALS['stock_baselev']."suppr_comptes_personnel.txt",$GLOBALS['stock_baselev']."suppr_comptes_personnel.bak");
        unlink($GLOBALS['stock_baselev']."suppr_comptes_personnel.txt");
      }*/
    }
    else
    {
      $erreur .= "Le fichier de compte pour le personnel existe sur le serveur, mais ne peut tre lu ! Il est impossible de gnrer le fichier de diffusion des comptes du personnel de l'tablissement.<br/>";
    }
  }
  else // Le fichier indispensable n'est pas l
  {
    $erreur .= "Aucun fichier de compte pour le personnel n'existe sur le serveur ! Il est impossible de gnrer le fichier de diffusion des comptes du personnel de l'tablissement.<br/>";
  }

  // On cre maintenant l'archive tar contenant les diffrents fichiers de diffusion des comptes utilisateurs
  if (file_exists($GLOBALS['stock_baselev']."diffusion_comptes_profs.txt"))
  $file_profs = $GLOBALS['stock_baselev']."diffusion_comptes_profs.txt";
  else
  $file_profs = "";
  if (file_exists($GLOBALS['stock_baselev']."diffusion_comptes_autres_personnels.txt"))
  $file_autres_personnels  = $GLOBALS['stock_baselev']."diffusion_comptes_autres_personnels.txt";
  else
  $file_autres_personnels = "";
  if (file_exists($GLOBALS['stock_baselev']."diffusion_comptes_eleves.txt"))
  $file_eleves = $GLOBALS['stock_baselev']."diffusion_comptes_eleves.txt";
  else
  $file_eleves = "";
  if (file_exists($GLOBALS['stock_baselev']."diffusion_comptes_parents.txt"))
  $file_parents = $GLOBALS['stock_baselev']."diffusion_comptes_parents.txt";
  else
  $file_parents = "";
  $cmd = "tar cfz ".$GLOBALS['stock_baselev']."iew_comptes_diffusion.tar.gz $file_profs $file_autres_personnels $file_eleves $file_parents";
  exec($cmd,$output,$retval);
  if (isset($retval) && $retval == 0) // commande bien xcute (sur un serveur LINUX)
  {
    // On supprime les fichiers de diffusion individuels car ils contiennent les mots de passe en clair (ils ne doivent donc pas rester sur le serveur)
    $files_array = array("diffusion_comptes_profs.txt","diffusion_comptes_autres_personnels.txt","diffusion_comptes_eleves.txt","diffusion_comptes_parents.txt");
    $err = false;
    foreach($files_array as $file)
    {
      if (@file_exists($GLOBALS['stock_baselev'].$file))
        if (!@unlink($GLOBALS['stock_baselev'].$file))
          $err = true;
    }
    if ($err == true)
      $erreur .= "Attention un ou plusieurs fichiers <strong>diffusion_comptes_*.txt</strong> n'ont pas pu tre supprims automatiquement sur le serveur. Veuillez le faire manuellement pour des raisons de scurit car ces fichiers conitennent les mots de passe en clair de vos utilisateurs<br />";
    
    // On tlcharge l'archive contenant les fichiers de diffusion des comptes
    download_file($GLOBALS['stock_baselev'],"iew_comptes_diffusion.tar.gz");
    // Puis on l'efface pour des raisons de scurit
    unlink($GLOBALS['stock_baselev']."iew_comptes_diffusion.tar.gz");
    
    // On affiche les erreurs ventuelles qui se sont produites au cours de la cration de fichiers de diffusion
    // On ne pouvait pas le faire avant car la fonction download_file du fait des instructions header interdit toute sortie html pralable
    if ($erreur !="")
    {
      $error_message = array("<div align='justify'>$erreur</div>","");
      affiche_erreurs($error_message);
    }
  }
  else
  {
    $error_message = array("
    <div align='justify'>L'archive tar.gz contenant les fichiers de diffusion des comptes aux utilisateurs n'a pas pu tre cre.<br />Il faut rcuprer manuellement les trois fichiers de diffusion sur le serveur et les supprimer de l'arborescence pour des raisons de scurit (ils contiennent les mots de passe en clair des utilisateurs.</div>", "");
    affiche_erreurs($error_message);
  }
}
else
{
  $error_message = array("Vous n'avez paz les droits requis pour cette opration !","");
  affiche_erreurs($error_message);
}
?>