<?php
/**
 * c_cahiers_textes.php
 *
 * Page affichant le cahier de textes d'une classe ou d'un groupe
 * 
 * Ce fichier fait partie du projet IntraEduWeb (IEW)
 * 
 * @package		IEW
 * @author			Sylvain GODM <sylvain.godme@gmail.com>
 * @version		$LastChangedRevision$, $LastChangedDate$
 * @copyright		2004-2012 Sylvain GODM
 * @link			http://iew.free.fr
 * @license		GPL License version 3 (http://www.gnu.org/licenses/gpl.html)
 * @filesource
 * 
 */

function info_nav_ct()
{
	/**
	 * Affiche une indication pour inciter de passer par les liens EDT du sommaire
	 */
	
	// A condition que les EDT soient imports...
	$sql = "SELECT id_cours FROM cours";
	$resultat = mysql_query($sql);
	if (mysql_num_rows($resultat) > 0)
	{
		$tip_message = "Utilisez de prfrence les liens de la rubrique EDT dans le sommaire de gauche pour choisir le cahier de textes";
  		affiche_astuce($tip_message);
	}
}

function auth_choix_classe()
{
  //***************************** description **********************************************************//
  // cette fonction permet de recenser les classes pour lesquelles l'utilisateur est autoris  voir
  // le cahier de textes. Elle renvoie un tableau contenant les classes (ou groupes) correspondantes
  //***************************** Fin description ******************************************************//
  global $is_documentaliste;
  $is_documentaliste = false;
  $valid_group = $_SESSION['valid_group'];
  $valid_nom = $_SESSION['valid_nom'];
  $valid_prenom = $_SESSION['valid_prenom'];
  if ($valid_group == "1" || $valid_group == "5" || $valid_group == "6" || $valid_group == "8") // groupes autoriss  voir les cahiers de textes de toutes les classes
  {
    $tableau_options1=liste_options_form("connect","division","divisions","");
	$tableau_options2=liste_options_form("connect","nom","groupes","");
	$tableau_options3=array_merge($tableau_options1,$tableau_options2);
    return $tableau_options3;
  }
  elseif ($valid_group == "3") // Si c'est un prof, il ne pourra choisir que le cahier de texte de ses classes
  {
    // Sauf le documentaliste qui peut choisir tous les cahiers de textes
    $sql5 = "SELECT libelle_long FROM disciplines_bcn,personnel WHERE id_pers='".quote_smart($_SESSION['valid_id_user'])."' AND personnel.code_discipline=disciplines_bcn.code_discipline";
    // DEBUGG print $sql5."<br />"; 
    $resultat5 = mysql_query($sql5);
    $ligne5 = mysql_fetch_array($resultat5);
    if (stristr($ligne5['libelle_long'],"Documentation"))
    {
      $is_documentaliste = true;
      $tableau_options1=liste_options_form("connect","division","divisions","");
	  $tableau_options2=liste_options_form("connect","nom","groupes","");
	  $tableau_options3=array_merge($tableau_options1,$tableau_options2);
      return $tableau_options3;
    }
    else // c'est un prof normal : il ne pourra voir que le cahier de texte de ses classes
    {
      $tableau_options1=liste_options_form("connect","services.code_structure","services,enseignants_services","services.id_service = enseignants_services.id_service AND id_individu='".$_SESSION['identifiant_individu']."'");
	  $tableau_options2=liste_options_form("connect","nom","groupes","id_responsable='".$_SESSION['valid_id_user']."'");
   	  $tableau_options3=array_merge($tableau_options1,$tableau_options2);
      return $tableau_options3;
    }
  }
  elseif ($valid_group == "11") // Si c'est un IPR, il ne pourra voir que le cahier de texte des classes des enseignants inspects (mais toutes ses classes)
  {
    $liste_classes = array();
    foreach ($_SESSION['ipr_liste_classes_groupes'] as $value)
    {
    	$liste_classes[] = str_replace("%"," ",$value); // Pour affichage le % sparant le nom de la classe ou d'un groupe du prof inspect
    }
  	return $liste_classes;
  }
  elseif($valid_group == "2") // Cas d'un lve : on arrive ici que lorsque le paramtre $_GET['set_classe'] est initialis (il s'agira ultrieurement de s'assurer que le paramtre correspondant pointe bien sur la classe de l'lve)
  {
      $tableau_options = array();
      $sql = "SELECT t1.classe FROM eleves as t1, login as t2 WHERE t1.id_eleve=t2.id_pers AND t2.id_pers='".quote_smart($_SESSION['valid_id_user'])."'";
      $resultat = mysql_query($sql);
      if ($resultat)
      {
        if (mysql_num_rows($resultat)>0)
       {
         $ligne = mysql_fetch_array($resultat);
         $tableau_options[] = $ligne['classe'];
         return $tableau_options; // Sa classe est renvoye
       }
      }
      // S'il y a un problme, un tableau vide sera renvoy
      return $tableau_options;
  }
  elseif($valid_group == "4") // Cas d'un parent : on arrive ici que lorsque le paramtre $_GET['set_classe'] est initialis (il s'agira ultrieurement de s'assurer que le paramtre correspondant pointe bien sur les classes des enfants de ce parent)
  {
    $tableau_options = array();
    // On recherche les classes des enfants de ce parent
    $sql = "SELECT classe FROM eleves WHERE eleve_id=";
    for($i=0;$i<count($_SESSION['enfants_scol']);$i++)
    {
      $fragment=explode(",",$_SESSION['enfants_scol'][$i]);
      $tab_id[$i]=$fragment[0]; // identifiant lve
      $tab_nom[$i]=$fragment[1]; // nom lve
      $tab_prenom[$i]=$fragment[2]; // prnom lve
      if ($i==0) // Si 1er tour de boucle
        $sql .= "'".quote_smart($tab_id[$i])."' ";
      else //  partir de la 2me itration
        $sql .= "OR eleve_id='".quote_smart($tab_id[$i])."' ";
    }
    $sql .= "ORDER BY classe"; // fin de la requte
    // DEBUGG print $sql."<br />";
    $resultat = mysql_query($sql);
    while ($ligne=mysql_fetch_array($resultat))
    {
      $tableau_options[] = $ligne['classe'];
    }
    return $tableau_options;
  }
}

function affiche_formulaire_choix_classe()
{
 //***************************** description *****************************************************************//
 // cette fonction permet d'afficher le formulaire permetttant de choisir la classe ou le groupe dont on veut
 // voir le cahier de textes
 //***************************** Fin description ***********************************************************//
  info_nav_ct();
  global $is_documentaliste;
  $param_url = "";
  // Affichage d'un lien vers l'emploi du temps d'un prof si connect
  $code_formulaire = "<br /><label for='Form_Req_Classe'>Classe ou groupe&nbsp;:</label> 
  <select id='Form_Req_Classe' size='1' name='classe'>";
  $code_formulaire.=affiche_liste_options_formulaire(auth_choix_classe());
  $code_formulaire .= "</select><br /><br />";
  squelette_formulaire_standard("80%","post",$_SERVER['PHP_SELF'],"<h2 class='hidden'>Choisissez une classe ou un groupe</h2>Choisissez une classe ou un groupe",$code_formulaire,"Voir le Cahier de textes","submit_classe","","","","","","centrer_contenu");
}

function affiche_formulaire_choix_eleve()
{
 //***************************** description *****************************************************************//
 // cette fonction permet d'afficher le formulaire permettant  l'lve de choisir sa classe ou son groupe dont il veut
 // voir le cahier de textes
 //***************************** Fin description ***********************************************************//
  info_nav_ct();
  global $liste_groupes; // $liste_groupes a dj t initialise pour l'lve dans le script cahier_textes.php
  cherche_classe_eleve();
  $code_formulaire = "<br /><label for='Form_Req_Classe'>Classe ou groupe&nbsp;:</label> 
  <select id='Form_Req_Classe' size='1' name='classe'>
    <option>".$_SESSION['classe_en_cours']."</option>";
  foreach ($liste_groupes as $value)
  {
    $code_formulaire .= "<option>$value</option>";
  }
  unset($_SESSION['classe_en_cours']); // Cette valeur doit tre efface, elle sera raffecte un peu plus tard avec le nouveau choix qui sera fait dans ce formulaire
  unset($_SESSION['type_structure_en_cours']);
  unset($_SESSION['id_groupe_en_cours']);
  unset($_SESSION['liste_groupes']);
  $code_formulaire .= "</select><br /><br />";
  squelette_formulaire_standard("80%","post",$_SERVER['PHP_SELF'],"<h2 class='hidden'>Choisissez une classe ou un groupe</h2>Choisissez une classe ou un groupe",$code_formulaire,"Voir le Cahier de textes","submit_classe","","","","","","centrer_contenu");
}

function affiche_formulaire_choix_parent()
{
  // Si un parent connect a plusieurs enfants scolariss dans l'tablissement, on lui donne le choix de voir le cahier de textes de la classe correspondante
  // +sieurs enfants ---> $_SESSION['enfants_scol'] = "" (simple dfinition sans affectation de valeur)
  // S'il n'a qu'un enfant scolaris dans l'tablissement, cette fonction retourne la classe correspondante
  // un seul enfant --> $_SESSION['classe_en_cours'] = celle de l'enfant
  info_nav_ct();
  global $liste_groupes; 
  // On recherche les classes des enfants de ce parent
  $sql = "SELECT classe,eleve_id FROM eleves WHERE eleve_id=";
  for($i=0;$i<count($_SESSION['enfants_scol']);$i++)
  {
    $fragment=explode(",",$_SESSION['enfants_scol'][$i]);
    $tab_id[$i]=$fragment[0]; // identifiant lve
    $tab_nom[$i]=$fragment[1]; // nom lve
    $tab_prenom[$i]=$fragment[2]; // prnom lve
    if ($i==0) // Si 1er tour de boucle
      $sql .= "'".quote_smart($tab_id[$i])."' ";
    else //  partir de la 2me itration
      $sql .= "OR eleve_id='".quote_smart($tab_id[$i])."' ";
  }
  $sql .= "ORDER BY nom,prenom"; // fin de la requte
  // DEBUGG print $sql."<br />";
  $resultat = mysql_query($sql);
  $code_formulaire = "<br /><label for='Form_Req_Classe'>Classe ou groupe de votre enfant&nbsp;:</label> 
  <select id='Form_Req_Classe' size='1' name='classe'>
  <option></option>"; // 1re valeur vide
  $i=0;
  while ($ligne=mysql_fetch_array($resultat))
  {
    $code_formulaire .= "<option value=\"".$ligne['classe']."%".$ligne['eleve_id']."\">".$ligne['classe']." (".$tab_prenom[$i].")</option>";
    $i++;
  }
  // On recherche le nom des groupes auquel appartiennent les enfants
  $sql = "SELECT DISTINCT t1.nom, prenom,t3.eleve_id FROM groupes as t1, groupes_eleves as t2, eleves as t3 WHERE t1.id_groupe=t2.id_groupe AND (t2.eleve_id=";
  for($i=0;$i<count($tab_id);$i++)
  {
    if ($i==0) // Si 1er tour de boucle
      $sql .= "'".quote_smart($tab_id[$i])."' AND t2.eleve_id=t3.eleve_id ";
    else //  partir de la 2me itration
      $sql .= "OR t2.eleve_id='".quote_smart($tab_id[$i])."' AND t2.eleve_id=t3.eleve_id ";
  }
  $sql .= ") ORDER BY nom"; // fin de la requte
  // DEBUGG print $sql."<br />";
  $resultat = mysql_query($sql);
  if ($resultat)
  {
    if (mysql_num_rows($resultat)>0)
    {
      while ($ligne = mysql_fetch_array($resultat))
      {
        $code_formulaire.="<option value=\"".$ligne['nom']."%".$ligne['eleve_id']."\">".$ligne['nom']." (".$ligne['prenom'].")</option>";
      }     
    }
  }
  $code_formulaire .= "</select><br /><br />";
  squelette_formulaire_standard("80%","post",$_SERVER['PHP_SELF'],"<h2 class='hidden'>Choisissez une classe ou un groupe</h2>Choisissez une classe ou un groupe",$code_formulaire,"Voir le Cahier de textes","submit_classe","","","","","","centrer_contenu");
}

function cherche_mode($indice_matiere,$force_consultation)
{
  // Cette fonction permet de rechercher (pour un prof connect) si la matire  fournie en indice
  // est la matire qu'il enseigne dans la classe et pour laquelle il convient d'activer le mode
  // de saisie pour le cahier de textes sur cette matire
  // la fonction renvoie le mode (saisie ou consultation pour cette matire)
  
  // Si le paramtre $force_consultation vaut true (par exemple si la date n'est pas un jour ouvrable dans l'tablissement)
  // alors le mode saisie est impossible
  
  // Le mode est fix par dfaut en consultation
  $mode = "consultation";
  
  if ($force_consultation === true)
  {
  	return $mode; // mode saisie impossible, la valeur par dfaut est renvoye
  }
  
  // Mais a peut voluer : cela dpend de la requte suivante
  $sql = "SELECT t1.code_matiere FROM services as t1,enseignants_services as t2,matieres_sconet as t3  WHERE id_individu='".$_SESSION['identifiant_individu']."' AND code_structure='".quote_smart($_SESSION['classe_en_cours'])."' AND t1.id_service=t2.id_service AND t1.code_matiere=t3.code_matiere ORDER BY t3.libelle_edition";
  $resultat = mysql_query($sql);
  if (mysql_num_rows($resultat)>0)
  {
    while($ligne = mysql_fetch_array($resultat))
    {
      if ($ligne['code_matiere'] == $indice_matiere) // La personne connecte est un un enseignant et la discipline en cours est bien celle qu'il enseigne dans la classe 
      {  
        $mode = "saisie";
        break; // On sort de la boucle while si la matire en cours est trouve avant la fin
      }
    }
  }
  else 
  {
  	// la requte prcdente ne donne rien si le prof n'enseigne pas la matire en classe entire, il faut alors tenter une requte sur le groupe concern par cette matire
  	$sql = "SELECT t1.code_matiere,t3.code_structure FROM services as t1,enseignants_services as t2,structures as t3 WHERE t1.id_service=t2.id_service AND id_individu='".$_SESSION['identifiant_individu']."' AND t1.code_matiere='$indice_matiere' AND t1.code_structure=t3.code_structure AND divisions_appartenance LIKE '%".quote_smart($_SESSION['classe_en_cours'])."%'";
  	$resultat = mysql_query($sql);
  	if (mysql_num_rows($resultat)>0)
  	{
	  	while($ligne = mysql_fetch_array($resultat))
    	{
      		if ($ligne['code_matiere'] == $indice_matiere) // La personne connecte est un un enseignant et la discipline en cours est bien celle qu'il enseigne dans la classe 
      		{  
        		$mode = "saisie";
        		break; // On sort de la boucle while si la matire en cours est trouve avant la fin
     	 	}
    	}
  	}
  }
  // Si le prof est dans les archives, alors on force le mode consultation
  if (isset($_SESSION['anscol']) && isset($_SESSION['anscol']) !="")
  {
  	$mode = "consultation";
  }
  return $mode;
}

function trouve_date_cours($prevnext)
{
  // Cette fonction permet de retrouver la date de la prochaine entre (prcdente ou suivante)
  // dans le cahier de textes pour la discipline en cours
  // Elle entre en action lorsque l'utilisateur clique sur le lien cours prcdent ou cours suivant
  $newdate = $_GET['dateref']; // a priori la date  renvoyer est celle fournie dans l'url (date de la dernire entre dans le cahier de textes)
  if ($_SESSION['type_structure_en_cours'] == "D" || $_SESSION['type_structure_en_cours'] == "G") // c'est une classe ou un groupe sconet
  {
  	if(isset($_SESSION['id_groupe_en_cours']) && $_SESSION['id_groupe_en_cours'] != "")
    	$code_structure = $_SESSION['id_groupe_en_cours'];
    else
    	$code_structure = $_SESSION['classe_en_cours'];
  	$where_plus = "code_matiere='".quote_smart($_GET['matiere'])."' AND id_sous_matiere='".quote_smart($_GET['sous_matiere'])."' AND code_structure='$code_structure'";
  }
  elseif($_SESSION['type_structure_en_cours'] == "GM") // c'est un groupe cr manuellement
  {
    $where_plus = "id_groupe='".quote_smart($_SESSION['id_groupe_en_cours'])."'";
  }
  switch ($prevnext)
  {
    case 'prev':
      $sql = "SELECT date FROM cahiers_textes WHERE $where_plus AND date<'".quote_smart($_GET['dateref'])."' ORDER BY date DESC";
      break;
    case 'next':
      $sql = "SELECT date FROM cahiers_textes WHERE $where_plus AND date>'".quote_smart($_GET['dateref'])."' ORDER BY date";
      break;
  }
  // DEBUGG print $sql."<br />";
  $resultat = mysql_query($sql);
  if ($resultat && mysql_num_rows($resultat)>0)
  {
    $ligne = mysql_fetch_array($resultat); // on ne s'intresse qu'au premier enregistrement
    $newdate = $ligne['date'];
  }
  elseif($prevnext == "next") // si requte infructueuse sur le cours suivant
  {
   	$error_message=array("Il n'y a pas d'entre de cahier de textes correspondant au cours <u>qui suit</u> celui du ".MySQLDateToExplicitDate($newdate),"");
   	affiche_erreurs($error_message);
  }
  else // Requte infructueuse sur le cours prcdent
  {
  	$error_message=array("Il n'y a pas d'entre de cahier de textes correspondant au cours <u>qui prcde</u> celui du ".MySQLDateToExplicitDate($newdate),"");
    affiche_erreurs($error_message);
  }
  return $newdate;
}

function sous_form_afaire($mode,$pourle,$k,$id_ctexte,$id_afaire,$afaire,$publication)
{
  /******************** Affichage du sous-formulaire "Travail  faire......pour le :" ************/
  
  // ici on utilise une variable $code_formulaire_ajouter (ce qu'il faut ajouter  $code_formulaire)
  // Si on avait pris $code_formulaire, on se retrouverait avec beaucoup de duplication
  // car cette variable se concatnerait avec elle mme !
  
  /**
   * Affiche le sous-formulaire de saisie/consultation d'un travail  faire
   * 
   * @param string $mode : "saisie" ou "consultation"
   * @param date $pourle : date pour laquelle le travail doit tre fait
   * @param int $k : compteur de travaux  faire (indique le n du travail associ au contenu de sance)
   * @param int $id_ctexte : contient la cl primaire d'identification du contenu de sance (table 'cahier de textes') associ au travail  faire
   * @param int $id_afaire : vide ou contient la cl primaire d'identification du travail  faire dans la table 'a_faire'
   * @param string $afaire : Dtail du travail  faire
   * @param string $publication : "1" si publi, "0" sinon
   * */
  
  global $date,$nb_docs;
  
  if ($pourle != '')
  {
  	$mysldate_pourle = convert_date_to_mysql($pourle, $delimiter = '-'); // conversion au format MySQL (dans le bon sens)
  	$date_long = format_date_long($GLOBALS['default_language'],date_mysql_to_jjmmaaaa($mysldate_pourle)); // pour affichage
  	$debut_semaine = debut_semaine($mysldate_pourle);
  	$semaine = quelle_semaine_alternance($debut_semaine); // on rcupre le n de quinzaine
  }
  else 
  {
  	$date_long = "";
  	$semaine = "?";
  }
  
  $code_formulaire_ajouter = "
  <a id='ancre_afaire$id_afaire' name='afaire$id_afaire'></a>
  <br />     
  <div class='cadre_afaire_entete'>          
  	<table width='100%' border='0'>
    	<tr>
        	<td align='left'><b><label for='date_pourle$k'>Travail $k,  faire pour le :</label></b>
        	";
            	if ($mode == "saisie")
            	{
	              	// On affiche l'image du calendrier (lien permettant de choisir un jour donn dans une popup)
	    	        // Mais il faut s'assurer de rcuprer les paramtre url en cours
    	    	    $param_url = str_replace("&","&amp;",$_SERVER['QUERY_STRING']); // pour la validation HTML
    	    	    $code_formulaire_ajouter .= "
            	  		<input id='date_pourle$k' type='text' class='datepicker choix_date_afaire' name='pourle$k' value='$date_long' /> (semaine&nbsp;$semaine)";
    	    	    $code_formulaire_ajouter .= "</td>
            		<td align='left' valign='top'>
            		";
            		if (isset($id_ctexte) && $id_ctexte !="" && $id_afaire!="")
              		{
              			$code_formulaire_ajouter .= "
              	  		<div class='copy_paste_to_btn' style='margin-top:0.5em;'><a href='edt.php?categorie=professeurs&amp;edt=".$_SESSION['identifiant_individu']."&amp;typecopy=afaire&amp;id_afaire=$id_afaire&amp;pourle=$pourle&amp;debut_semaine=$date' title=\"Copier le travail  faire + ses documents joints et le coller dans le cahier de textes d'une autre classe\">Copier et coller vers...</a></div>";
              		}
              		$code_formulaire_ajouter .= "
            		</td>";
            	}
            	else
            	{
              		$code_formulaire_ajouter .="
              		<input type='text' id='date_pourle$k' name='pourle$k' value='$date_long' class='choix_date_afaire' readonly='readonly' /> (semaine $semaine)
              		</td>
              		<td>&nbsp;</td>";
            	}
            	$code_formulaire_ajouter .="
        </tr>
    </table>
  </div>
  <div class='cadre_formulaire_gris cadre_afaire_corps'>
  ";  
          
  $link_afaire = "";  
  if ($mode == "saisie")
  {
  	$link_afaire = $k; // sera transmis  la fonction sous_form_docs() afin de garder trace de l'association entre le nom du textearea du travail  faire et un document joint  ce travail         	
    $code_formulaire_ajouter .= "<label for='travail_afaire$k' class='hidden'>Nature du travail  effectuer :</label>
    <textarea id='travail_afaire$k' name='afaire$k' rows='' cols=''>".stripslashes($afaire)."</textarea>";
    if ($publication == "1")
    	$checked = "checked='checked'";
    else 
    	$checked = "";
    $code_formulaire_ajouter .="<input type='checkbox' id='chkPublish_afaire$k' name='publication_afaire$k' value='1' $checked title=\"".infobulle("publication","travail  faire")."\" />
    <label for='chkPublish_afaire$k'>Publi</label>";
    if (isset($id_ctexte) && $id_ctexte !="" && $id_afaire!="")
    { 
    	$code_formulaire_ajouter .= "
    	<a href='?suppr_afaire=$id_afaire' id='Lk_DelAfaire$k'><img src='../images/delete.png' alt='[Supprimer ce travail]' title='Supprimer ce travail' class='ctexte_ico' /></a>";
        if (isset($GLOBALS['nb_travaux']) && $k == $GLOBALS['nb_travaux']) // Si des travaux  faire existent dans la base de donnes et que le travail en cours est le dernier
        {
			// Affichage d'un lien [Ajouter autre date]
    		//$j = $k + 1; // numro du prochain sous-formulaire 'afaire' (dans lien ajouter autre date) qui servira d'ancre
        	$code_formulaire_ajouter .= "
            <a href='?ajout_afaire=true&amp;id_ctexte=$id_ctexte&amp;date=".date_mysql_to_jjmmaaaa_tiret($GLOBALS['date'])."#ancre_afaire' id='Lk_AddAfaire$k'><img src='../images/add.png' alt='[Ajouter un travail  faire pour une autre date]' title='Ajouter un travail  faire pour une autre date' class='ctexte_ico' /></a>";
        } 
    }       		
    $code_formulaire_ajouter .= "<input type='hidden' id='id_afaire$k' name='id_afaire$k' value='$id_afaire' />
    <div>";
    if ($afaire != "")
    {
    	if ($_GET['typecopy'] == "doc")
      			$texte_bouton = "Associer le document  copier  ce travail";
      	else 
      			$texte_bouton = "Modifier";
    }
    else
   {
    	if ($_GET['typecopy'] == "doc")
      		$texte_bouton = "Associer le document  copier  ce travail";
      	else 
      		$texte_bouton = "Valider";
    }
    $code_formulaire_ajouter .= "<input type='submit' id='soumettre_afaire$k' name='soumettre_afaire$k' value='$texte_bouton' class='btn_submit_afaire'/>
    </div>";
    if (isset($_GET['typecopy'])) // si on est en mode copie
    {
    	if ($_GET['typecopy'] == "doc") // copie d'un document
      	{
      		// On transmet un champ cach qui permettra lors de la soumission du formulaire d'effectuer la copie effective du document  faire en plus du contenu du travail  faire
      		$code_formulaire .= "<input type='hidden' id='HideCopyDoc' name='copy_doc' value='".$_SERVER['QUERY_STRING']."' />";
      	}
    }
  }
  else
  {
  	$code_formulaire_ajouter .= "<div class='frame_form2' align='left'>".htmlspecialchars_decode(stripslashes($afaire))."<br /></div>"; 
  }
  
  // Voici les documents joints associs au travail  faire
  $code_formulaire_ajouter .= cherche_docs_associes($mode,"id_afaire",$id_afaire,$link_afaire);
  
  $code_formulaire_ajouter .= "
  </div>
  <input type='hidden' name='date' value='$date' />";
  return $code_formulaire_ajouter;
}

function sous_form_docs($mode,$id_doc,$id_ctexte,$id_afaire,$k,$filename,$commentaire,$publication,$link_afaire)
{
  // ici on utilise une variable $code_formulaire_ajouter (ce qu'il faut ajouter  $code_formulaire)
  // Si on avait pris $code_formulaire, on se retrouverait avec beaucoup de duplication
  // car cette variable se concatnerait avec elle mme !
  
   /**
   * Affiche le sous-formulaire de saisie/consultation d'un document joint
   * 
   * @param string $mode : "saisie" ou "consultation"
   * @param int $id_doc : contient la cl primaire d'identification du document joint
   * @param int $k : compteur de document (indique le n du document associ au contenu de sance ou au travail  faire)
   * @param int $id_ctexte : contient la cl primaire d'identification du contenu de sance (table 'cahier de textes') associ au document (vaut 0 si le document est joint  un travail  faire et non  un contenu de sance)
   * @param int $id_afaire : contient la cl primaire d'identification du travail  faire dans la table 'a_faire' associ au document (vaut 0 si le document est joint  un contenu de sance et non  un travail  faire)
   * @param string $filename : nom du fichier (extension comprise)
   * @param string $commentaire : commentaire affich  ct du document (descriptif rapide)
   * @param string $publication : "1" si publi, "0" sinon
   * @param string $link_afaire : contient le n du champ textearea du travail  faire associ au document (ou vide si document associ  un contenu de sance)
   * */
	
  if ($mode == "consultation" && $id_doc == "") // vite d'afficher un sous-formulaire document joint vide  la consultation
  	return;
	
  // Chaque appel  cette fonction incrmente un compteur qui permet d'assigner des ID uniques aux diffrents lments relatifs aux documents joints sur la page
  global $num_id; // n'a pas t dfini au dpart (vaut implicitement 0 avant la 1re incrmentation)
  $num_id++;
  $code_formulaire_ajouter ="
        <br />
        <a id='doc$num_id' name='doc$num_id'></a>
        <div class='doc_ctxt' align='left'>
          <table width='100%' border='0'>
            <tr>
              <td align='left' valign='middle'>";
              if ($mode == "saisie")
              {
              	if ($id_doc == "") // le formulaire d'upload n'est affich que si le document n'existe pas encore
                {
                  $code_formulaire_ajouter .= "<b><label for='fichier$num_id'>Choisir un Document  joindre&nbsp;:</label></b>";
                  $code_formulaire_ajouter .="
                  <input type='hidden' name='MAX_FILE_SIZE' value='2097152' />                  
                  <input id='fichier$num_id' name='fichier$num_id' type='file' style='margin-top:-0.06em;'/>";
                  
                  // champ de type submit non utilis pour le moment (pas de nom de variable associ : on met donc la ligne en commentaire) qui devrait permettre dans le futur de chercher un document directement sur le serveur,  condition que soit gre une base de donnes recensant les documents dj joints par le professeur et d'en faire un tri.
                  //$code_formulaire_ajouter .="<input id='search_file$num_id' name='' type='submit' value='Rechercher dans la base IEW' />";
                }
                else // le document existe : on affiche le nom du fichier et un lien de tlchargement
                {
                	$code_formulaire_ajouter .="<img src='../images/trombone.png' alt='' /><b>Document $k&nbsp;:&nbsp;<font color='black'><i>".respace($filename)."</i></font></b>";
                	if ($filename != "")
             		{  
                		if ($_SESSION['type_structure_en_cours'] == "G" || $_SESSION['type_structure_en_cours'] == "GM" || (isset($_GET['id_gpe']) && $_GET['id_gpe'] != "")) // Groupe sconet ou manuel
                		{
             				if ($id_groupe = $_SESSION['id_groupe_en_cours']) // le groupe est connu dans une variable de session
                			{
    	              			$sql = "SELECT nom FROM groupes WHERE id_groupe='".quote_smart($id_groupe)."'";
        	          			$resultat = mysql_query($sql);
            	      			$ligne = mysql_fetch_array($resultat);
			            	    /*if (isset($_GET['id_gpe']) && $_GET['id_gpe'] != "")
            				      	$classgroup = nospace(noaccent($_GET['id_gpe']));
            	      			else*/
            	      				$classgroup = nospace(noaccent($ligne['nom']));
                	  			$code_formulaire_ajouter .="
                  	  			<a href='./download_doc.php?file=$filename&amp;classe=".$classgroup."'><img src='../images/box_download.png' alt='[Tlcharger]' title='Tlcharger ce document' /></a>";
                			}
                			else // le groupe est transmis via $_GET['id_gpe']
                			{
                  				$code_formulaire_ajouter .="
                  				<a href='./download_doc.php?file=$filename&amp;classe=".nospace($_SESSION['classe_en_cours'])."'><img src='../images/box_download.png' alt='[Tlcharger]' title='Tlcharger ce document' /></a>";
                			}
                		}
                		else // On a  faire  une division
                		{
             				if (isset($_GET['matiere']) && $_GET['matiere'] != "")
                  			{
                				$code_formulaire_ajouter .="
                  				<a href='./download_doc.php?file=$filename&amp;matiere=".nospace(noaccent($_SESSION['liste_matieres'][$_GET['matiere']]))."&amp;classe=".nospace($_SESSION['classe_en_cours'])."' id='Dl_Doc$num_id'><img src='../images/box_download.png' alt='[Tlcharger]' title='Tlcharger ce document' /></a>";
                  			}
                			else
                			{
                				$code_formulaire_ajouter .="
                  				<a href='./download_doc.php?file=$filename&amp;matiere=".nospace(noaccent($_SESSION['liste_matieres'][$GLOBALS['id_matiere']]))."&amp;classe=".nospace($_SESSION['classe_en_cours'])."' id='Dl_Doc$num_id'><img src='../images/box_download.png' alt='[Tlcharger]' title='Tlcharger ce document' /></a>";
                			}
                		}
             		}
                }
                $code_formulaire_ajouter .="</td>
                <td align='right' valign='middle'>";
                if (((isset($id_ctexte) && $id_ctexte !="") || (isset($id_afaire) && $id_afaire !="")) && $id_doc!="")
                {
                  $code_formulaire_ajouter .= "
                  <a href='?suppr_doc=$id_doc&amp;matiere=".$GLOBALS['id_matiere']."' id='Lk_DelDoc$num_id'><img src='../images/delete.png' alt='[Supprimer ce document]' title='Supprimer ce document' /></a>";
                  if (isset($GLOBALS['nb_docs']) && $k == $GLOBALS['nb_docs']) // si des documents existent dans la base de donne et que celui en cours est le dernier
                  {
                    // Affichage d'un lien [Ajouter un autre document]
                    $j = $k + 1; // numro du prochain sous-formulaire 'docs' (dans lien ajouter autre document) qui servira d'ancre
                    if ($link_afaire == "")
                    	$paramURL_doc_link = "id_ctexte=$id_ctexte";
                    else 
                    	$paramURL_doc_link = "id_afaire=$id_afaire";
                    $code_formulaire_ajouter .= "
                    <a href='?ajout_doc=true&amp;$paramURL_doc_link&amp;date=".date_mysql_to_jjmmaaaa_tiret($GLOBALS['date'])."#doc$j' id='Lk_AddDoc$num_id'><img src='../images/add.png' alt='[Ajouter un document]' title='Ajouter un document' /></a>";
                  }
                }
                $code_formulaire_ajouter .= "
                </td>
                ";
              }
              else // on est en mode consultation
              {
              	// Si on arrive ici c'est que le document existe ($id_doc != "")
                $code_formulaire_ajouter .="<b>Document $k&nbsp;:&nbsp;<font color='black'><i>".respace($filename)."</i></font></b>";
                if ($filename != "")
             	{  
                	if ($_SESSION['type_structure_en_cours'] == "G" || $_SESSION['type_structure_en_cours'] == "GM" || (isset($_GET['id_gpe']) && $_GET['id_gpe'] != "")) // Groupe sconet ou manuel
                	{
             			if ($id_groupe = $_SESSION['id_groupe_en_cours']) // le groupe est connu dans une varaible de session
                		{
    	           			$sql = "SELECT nom FROM groupes WHERE id_groupe='".quote_smart($id_groupe)."'";
        	       			$resultat = mysql_query($sql);
            	   			$ligne = mysql_fetch_array($resultat);
			         	    if (isset($_GET['id_gpe']) && $_GET['id_gpe'] != "")
            			      	$classgroup = nospace(noaccent($_GET['id_gpe']));
            	    		else
            	    			$classgroup = nospace(noaccent($ligne['nom']));
                			$code_formulaire_ajouter .= lien_telechargement_doc($filename,$classgroup,"");
            	    	}
                		else // le groupe est transmis via $_GET['id_gpe']
                		{
                  			$code_formulaire_ajouter .= lien_telechargement_doc($filename,nospace($_SESSION['classe_en_cours']),"");
                		}
                	}
                	else // On a  faire  une division
                	{
             			if (isset($_GET['matiere']) && $_GET['matiere'] != "") // la matire est founie dans l'url
                  		{
                			$code_formulaire_ajouter .= lien_telechargement_doc($filename,nospace($_SESSION['classe_en_cours']),nospace(noaccent($_SESSION['liste_matieres'][$_GET['matiere']])));
                  		}
                		else // matire fournie par variable globale
                		{
                			$code_formulaire_ajouter .= lien_telechargement_doc($filename,nospace($_SESSION['classe_en_cours']),nospace(noaccent($_SESSION['liste_matieres'][$GLOBALS['id_matiere']])));
                		}
                	}
             	}
                
              	$code_formulaire_ajouter .="</td>
                <td align='right'>
                  &nbsp;
                </td>";
              }
              $code_formulaire_ajouter .="
            </tr>
          </table>
        </div>
        <div class='cadre_doc_ctxt'>
          <div align='left'>";
            if ($mode == "saisie")
            {
            	if ($id_doc != "")
            		$code_formulaire_ajouter .="<div class='copy_paste_to_btn' style='margin-top:0.5em;'><a href='edt.php?categorie=professeurs&amp;edt=".$_SESSION['identifiant_individu']."&amp;typecopy=doc&amp;id_doc=$id_doc&amp;pourle=$pourle&amp;debut_semaine=$date' title=\"Copier le document et le coller dans le cahier de textes d'une autre classe\">Copier et coller vers...</a></div>";
            	
            	 if ($publication == "1")
        			$checked = "checked='checked'";
        	  	else 
        			$checked = "";
            	$code_formulaire_ajouter .="
            	<div class='visibility_doc'><input type='checkbox' id='chkPublish_doc$num_id' name='publication_doc$num_id' value='1' $checked title=\"".infobulle("publication","document")."\" />
        		<label for='chkPublish_doc$num_id'>Publi</label></div>
        		<i><label for='Req_commentaire$num_id'>Courte description&nbsp;:</label></i>";
            }
            else
            	$code_formulaire_ajouter .="<i>Courte description&nbsp;:</i>";
            $code_formulaire_ajouter .= "</div>";
          if ($mode == "saisie")
          {
            // Pour l'attribut value du prochain input, on encadre par des \" au lieu de ' car sinon les ' contenus dans les commentaires
            // ne vont pas s'afficher d'une part, et vont fermer la valeur de value si bien qu'on aura  l'affichage une chane tronque
          	$code_formulaire_ajouter .= "<input type='text' class='ctextes_docs' id='Req_commentaire$num_id' name='commentaire$num_id' style='margin-top: 0.3em;' value=\"".stripslashes($commentaire)."\" />";
            // le champ cach id_doc_link_with$num_id permet de faire le lien entre ce document et le textearea du travail  faire auquel il est associ (important pour l'enregistrement des donnes dans la base)
            $code_formulaire_ajouter .= "<div align='right'>
              <input type='hidden' id='id_doc$num_id' name='id_doc$num_id' value='$id_doc' />
              <input type='hidden' id='id_doc_link_with$num_id' name='id_doc_link_with$num_id' value='$link_afaire' />
              <input type='submit' id='soumettre_docjoint$num_id' name='soumettre_docjoint$num_id' value='Valider' />
            </div>";
          }
          else
          {
            $code_formulaire_ajouter .= "<div class='frame_form2' align='left'>".stripslashes($commentaire)."<br /></div>"; 
          }
          $code_formulaire_ajouter .= "
          </div>
          ";
    return $code_formulaire_ajouter;
}

function lien_telechargement_doc($filename,$classe,$matiere)
{
	/**
	 * Construit un lien de tlchargement vers un document joint
	 * 
	 * @param $filename : nom du fichier correspondant au document
	 * @param $classe : classe ou groupe (=sous-dossier du dossier de stockage du lien symbolique pointant vers le fichier niveau 1)
	 * @param $matiere : matiere concerne (=sous-dossier du dossier de stockage du lien symbolique pointant vers le fichier niveau 2, c'est ce niveau qui contient le lien symbolique
	 * @return $link : lien renvoy 
	 */
	
	$link = "<a href='./download_doc.php?file=$filename&amp;classe=$classe&amp;matiere=$matiere'><img src='../images/box_download.png' alt='[Tlcharger]' title='Tlcharger ce document' /></a>";
	return $link;
}

function cherche_docs_associes($mode,$with,$id,$link_afaire)
{
	/**
	 * Trouve les documents joints associs  un contenu de sance ou  un travail  faire
	 * 
	 * @param $mode : indique si on est en mode saisie ou consultation (l'affichage sera un peu diffrent)
	 * @param $with : suivant valeur indique qu'on cherche une association soit avec un contenu de sance ($with = id_ctexte) ou avec un travail  faire ($with = id_afaire)
	 * @param $id : identifiant du contenu de sance ou du travail  faire
	 * @param $link_afaire : identifiant numrique du champ textearea dans un sous-formulaire travail  faire qui associe ce champ au champ input correspondant du document (valeur vide si on cherche une association avec un contenu de sance) 
	 * @return $code_formulaire_ajouter : variable renvoye contenant le code d'affichage des sous-formulaires des documents joints associs
	 */
	
	if ($id !="")
	{
		global $nb_docs;
	
		if ($with == "id_afaire")
      	{
      		$id_ctexte = 0;
      		$id_afaire = $id;
      	}
      	elseif ($with == "id_ctexte")
      	{
      		$id_afaire = 0;
      		$id_ctexte = $id;
      	}
	
		if ($mode != "saisie") // si le mode est en consultation, on ne recherche que les entres publies
    		$where_add = "AND publication='1'";
    	else 
    		$where_add = "";
  		$sql = "SELECT id_doc,filename,commentaire,publication FROM docs_joints_ctextes WHERE $with='".quote_smart($id)."'".$where_add;
		// DEBUGG print $sql;
    	
  		$resultat = mysql_query($sql);
    	$k = 1; // initialisation au cas o la requte prcdente serait infructueuse
    	
    	if ($resultat)
    	{
      		$nb_docs = mysql_num_rows($resultat);
      		
      		if ($nb_docs>0) // il y a des documents dans la base de donnes
      		{
        		
      			for ($k=1;$k<$nb_docs+1;$k++)
        		{
          			$ligne = mysql_fetch_array($resultat);
          			$id_doc = $ligne['id_doc'];
          			$filename = $ligne['filename'];
          			$commentaire = $ligne['commentaire'];
          			$publication = $ligne['publication'];          
          			$code_formulaire_ajouter .= sous_form_docs($mode,$id_doc,$id_ctexte,$id_afaire,$k,$filename,$commentaire,$publication,$link_afaire); // $id_ctexte ou $id_afaire vaut 0 pour indiquer  la fonction sous_form_docs() si le document trouv est associ  un contenu de sance ou  un travail  faire
        		}
      		}
      		else // Il n'y a pas de documents dans la base de donnes, on va afficher un sous-formulaire vierge 
      		{
        		$id_doc = "";
        		$filename = "";
        		$commentaire = "";
        		$publication = "1";
        		$k = 1;
        		$code_formulaire_ajouter .= sous_form_docs($mode,$id_doc,$id_ctexte,$id_afaire,$k,$filename,$commentaire,$publication,$link_afaire);
      		}  
    	}
	    
    	// Eventuellement, on affiche un nouveau formulaire de saisie (si demande utilisateur)
    	
    	if (isset($_GET['ajout_doc']) && $_GET['ajout_doc'] && isset($_GET[$with]) && $_GET[$with] == $id) // si ajout_doc vaut true avec un id_afaire fourni => Le nouveau sous-formulaire de document joint est  afficher ici (seulement pour le id_afaire correspondant au $id_afaire (sinon il apparat dans chaque travail faire si plusieurs)         
      		$code_formulaire_ajouter .= sous_form_docs($mode,"",$id_ctexte,$id_afaire,$k,"","","1",$link_afaire);
	}
	
    return $code_formulaire_ajouter;     
}

function verif_nom_fichier($file_key)
{
	/** Pour les documents joints, cette fonction vrifie :
	* - que le nom du fichier upload n'exde pas 60 cc extension comprise
   	* - qu'il ne comporte ni accent ni espaces, ni guillemets, ni caractre "+" (voir fonction rename_file())
   	* 
    * le nom est ensuite sauvegard dans la variable globale $_FILES[$file_key]['name']
   	* pour une disponibilit hors de la fonction
   	* 
   	* @param $file_key : nom de la cl du tableau $_FILE concerne (correspond au document qui a t upload) = nom du champ de formulaire d'upload (il peut y en avoir plusieurs sur la page de saisie, voil pourquoi le nom du champ est variable)
   	**/
  	
	// On vrifie que le nom du fichier ne commence pas par un point (fichiers cachs linux)
	// Si c'est le cas, on supprime ce point initial
    if (substr($_FILES[$file_key]['name'],0,1) == ".")
       	$_FILES[$file_key]['name'] = substr($_FILES[$file_key]['name'],1,strlen($_FILES[$file_key]['name'])-1);
	
    $extension = strrchr($_FILES[$file_key]['name'],"."); // S'il y a 2 points ou + dans le nom, on rcupre seulement le dernier + ce qui suit
    if ($extension) // s'il a bien une extension dans le nom de fichier
    {
    	// nom fichier sans extension
		$nom_fichier = substr($_FILES[$file_key]['name'],0,strlen($_FILES[$file_key]['name'])-strlen($extension));
		// pas de point autoris dans le nom du fichier (seulement pour l'extension)
		$nom_fichier = str_replace(".","_",$nom_fichier);
    	// le nom du fichier stock dans la table docs_joints_ctextes a une longueur max de 60 cc
    	// et a pour format nom_fichier-xx.extension o -xx.exte reprsentant 8 cc sur les 60 max
	    // donc nom_fichier ne oit pas dpasser les 52 cc
      	if (strlen($nom_fichier)>52) // Si a dpasse
        	$nom_fichier = substr($nom_fichier,0,52); // on ne prend que les 52 premiers cc
      	$nom_fichier = $nom_fichier.$extension;
      	$nom_fichier = rename_file($nom_fichier);
    }
    else // pas de "." dans le nom du fichier upload
    {
    	$nom_fichier = $_FILES[$file_key]['name'];
      	if (strlen($nom_fichier)>56)
        	$nom_fichier = substr($nom_fichier,0,56);
        $nom_fichier = rename_file($nom_fichier);
    }
    
    $_FILES[$file_key]['name'] = $nom_fichier; // le nom de fichier est nettoy, et est disponible dans la variable globale $_FILE
}

function rename_file($nom_fichier)
{
	/**
	 * le fichier est ventuellement renomm de telle sorte qu'il ne comporte ni accent ni espaces, ni guillemets
	 * 
	 * @param $nom_fichier : le nom du fichier  renommer
	 * @return $nom_fichier : nouvelle valeur (fichier correctement renomm)
	 */
	 	
	$nom_fichier = str_replace("\'","_",$nom_fichier); // pas de \' dans le nom
	$nom_fichier = str_replace("'","_",$nom_fichier); // pas de ' dans le nom
    $nom_fichier = str_replace('"',"_",$nom_fichier); // pas de " dans le nom
    $nom_fichier = nospace(noaccent(noplus($nom_fichier))); // On renomme le fichier upload pour qu'il ne comporte ni espace ni accent, ni caractre "+"
    
    return $nom_fichier;
}

function traite_fichier($file_key)
{
  /** Le fichier upload (document joint) est trait ici
   * on commence par vrifier l'existence d'un rpertoire 'cahiers_textes' dans /data, on le cre s'il n'existe pas
   * 
   * on fait des vrifications sur le fichier upload (s'il a pu tre upload, si sa taille n'est pas nulle ou n'excde pas la taille max, si le nom de fichier n'existe pas dj, si un fichier de mme contenu (hash md5) n'existe pas dj)
   * On stocke le fichier dans le dossier /data/cahiers_textes/docs (stockage unique)
   * On cre un lien symbolique vers ce fichier dans /data/cahiers_textes/classe_groupe/matiere : ainsi on peut rfrencer le mme document pour des classes diffrentes (stockage d'un unique exemplaire du fichier)
   * 
   * @param $file_key : nom de la cl du tableau $_FILE concerne (correspond au document qui a t upload) = nom du champ de formulaire d'upload (il peut y en avoir plusieurs sur la page de saisie, voil pourquoi le nom du champ est variable)
   * @return false en cas d'erreur (avec un affichage du message d'erreur), $hash_md5 (hash MD5 du fichier) si tout est OK
   *  
   * */
	
  $dossier_ctextes = $GLOBALS['stock_baselev']."cahiers_textes/";
  if (!is_dir($dossier_ctextes))
  {
    mkdir($dossier_ctextes,0755);
  }
  // Mme chose pour le sous-dossier de stockage centralis des documents joints
  $dossier_ctextes_docs = $dossier_ctextes."docs/";
  if (!is_dir($dossier_ctextes_docs))
  {
    mkdir($dossier_ctextes_docs,0755);
  }
  // Mme chose pour le sous-dossier de la classe ou du groupe (contiendra les liens symboliques vers les documents joints dans le sous-dossier de stockage centralis
  $sous_dossier_ctextes_classe = $dossier_ctextes.nospace(noaccent($_SESSION['classe_en_cours']))."/";
  if (!is_dir($sous_dossier_ctextes_classe))
  {
    mkdir($sous_dossier_ctextes_classe,0755);
  }
  $chemin_symlink = $sous_dossier_ctextes_classe; // valeur par dfaut : utilis plus loin pour l'enregistrement du fichier
  
  // Partie excute seulement s'il s'agit d'une vraie classe (et pas d'un groupe)
  if ($_SESSION['type_structure_en_cours'] == "D")
  {
    // Mme chose pour le sous-dossier de la matire (les sous-matires cumulent leurs documents
    // dans le mme rpertoire que la discipline parent, pour des raisons de simplification,
    // on ne cre pas un sous-rpertoire par sous-matire)
    $sous_dossier_ctextes_classe_matiere = $sous_dossier_ctextes_classe.nospace(noaccent($_SESSION['liste_matieres'][$_POST['id_matiere']]))."/";
    // DEBUGG print "sous-dossier matire : $sous_dossier_ctextes_classe_matiere<br />";
    if (!is_dir($sous_dossier_ctextes_classe_matiere))
    {
      mkdir($sous_dossier_ctextes_classe_matiere,0755);
    }
    $chemin_symlink = $sous_dossier_ctextes_classe_matiere; // crase la valeur prcdente : utilis plus loin pour l'enregistrement du fichier
  }
  
  if (!isset($_FILES[$file_key]['tmp_name']))
    {
      $error_message = array("Le tlchargement n'a pas pu s'effectuer. Vrifiez vos entres de formulaire puis <a href='".$_SERVER['PHP_SELF']."'>renouveller</a> l'opration.","");
      affiche_erreurs($error_message);
      unset($_FILES);
      efface_post();
      return false;
    }
    if ($_FILES[$file_key]['size']==0)
    {
      $error_message = array("<div align='justify'>Le fichier tlcharg ne contient aucune donne ou bien la taille excde le maximum des 2Mo autoriss. Vrifiez le nom du fichier et son contenu, puis <a href='".$_SERVER['PHP_SELF']."'>renouveller</a> l'opration.</div>","");
      affiche_erreurs($error_message);
      unset($_FILES);
      efface_post();
      return false;
    }
    if (!is_uploaded_file($_FILES[$file_key]['tmp_name'])) // pour la scurit
    {
      $error_message = array("Attention, le fichier  traiter est un fichier local du serveur est n'a pas t tlcharg  partir du client. Le script est interrompu pour des raisons de scurit.","");
      affiche_erreurs($error_message);
      unset($_FILES);
      efface_post();
      return false;
    }
	// On va vrifier que le contenu du fichier n'est pas identique  un fichier existant (check MD5)
    $hash_md5 = md5_file($_FILES[$file_key]['tmp_name']); // calcul du hash sur le fichier stock temporairement par PHP
    if ($hash_md5) // le calcul a t possible
    {
    	// on continue la verif
    	$sql = "SELECT id_doc,filename,md5 FROM docs_joints_ctextes WHERE md5='$hash_md5'";
		$resultat = mysql_query($sql);
    	if ($resultat && mysql_num_rows($resultat) > 0) // il y a dj un fichier de mme contenu (mme hash)
    	{
    		$ligne = mysql_fetch_array($resultat);
	    	// On inscrit le lien symbolique vers le fichier
    		$target = $dossier_ctextes_docs.$ligne['filename'];
    		$link = $chemin_symlink.$ligne['filename'];
    		if (!file_exists($link))
    		symlink($target,$link);
      		return $ligne['filename']; // ici au lieu de retourner le hash MD5, on retourne le nom du fichier ayant le mme contenu, le lien symbolique ne sera donc pas cr  	 	
    	}
    } // si le calcul du hash n'est pas possible, pas de vrif
    $name_file = $_FILES[$file_key]['name']; // le nom de fichier a dj t nettoy (pas d'espace, pas d'accent etc...) par la fonction verif_nomfichier avant d'appeler traite_fichier()
    if (file_exists($dossier_ctextes_docs.$name_file))
    {
      $error_message = array("Un fichier portant le mme nom existe dj sur le serveur. Veuillez renommer le fichier d'origine (ou copiez-le sous un autre nom) et recommencez la procdure (bouton <i><b>parcourir</b></i> disponible en cliquant ventuellement sur un lien <b><i>[Ajouter un document]</i></b>)","");
      affiche_erreurs($error_message);
      unset($_FILES);
      efface_post();
      return false;
    }
    elseif( !move_uploaded_file($_FILES[$file_key]['tmp_name'], $dossier_ctextes_docs.$name_file) )
    {
      $error_message = array("Le fichier tlcharg n'a pas pu tre copi dans le dossier cible sur le serveur","");
      affiche_erreurs($error_message);
      unset($_FILES);
      efface_post();
      return false;
    }
    // Si on arrive l c'est que tout va bien, mais le fichier est en droit 600; donc si on veut faire une sauvegarde du rpertoire 'data' par exemple par FTP, comme seul le propritaire du fichier (apache) y a accs, on ne pourra pas lire ce fichier et donc la sauvegarde sera incomplte
    // On va donc mettre les droits 644 (pas de droit d'excution pour les autres, on ne sait jamais)
    chmod($dossier_ctextes_docs.$name_file, 0644);
    // On inscrit le lien symbolique vers le fichier
    $target = $dossier_ctextes_docs.$name_file;
    $link = $chemin_symlink.$name_file;
    symlink($target,$link);
    return $hash_md5;
}

function remove_doc($sql,$code_matiere)
{
	/**
	 * Cette fonction supprime un document joint associ  un contenu de sance ou  un travail  faire
	 * Cette suppression peut s'accompagner d'un effacement du fichier correspondant sur le serveur (si le document correspondant n'est plus li  aucun contenu de sance et aucun travail  faire)
	 * 
	 *  @param $sql : requte de recherche des documents  supprimer
	 *  @param $code_matiere : contient le code matire (code matire en provenance de la BCN, Base Centrale des Nomenclatures du Ministre), utile pour le chemin d'accs au lien symbolique qui pointe vers le fichier
	 *  @return $status_message : message de succs ou d'erreur renvoy
	 */
	
	$resultat = mysql_query($sql);
    $ok_suppr_doc = "";
    $err = "";
    
    	while ($ligne = mysql_fetch_array($resultat))
		{
      		$nom_fichier = $ligne['filename'];
      		$md5 = $ligne['md5'];
			// On supprime l'entre correspondante dans la base de donnes
		    if (isset($_GET['suppr_doc']) && $_GET['suppr_doc' ] != "") // l'id_doc est fournie dans l'url de la page
	    	{
	    		$sql = "DELETE FROM docs_joints_ctextes WHERE id_doc='".quote_smart($_GET['suppr_doc'])."'";
	    		$id_doc = $_GET['suppr_doc'];
	    	}
	    	else // l'id_doc est fourni dans le rsultat de la requte SQL
	    	{
	    		$sql = "DELETE FROM docs_joints_ctextes WHERE id_doc='".$ligne['id_doc']."'";
	    		$id_doc = $ligne['id_doc'];
	    	}
    		$result = mysql_query($sql);
      		if (!$result || mysql_affected_rows()==0) // info en cas d'erreur
      		{
       			$err .= "Le document ".$nom_fichier." n'a pas pu tre supprim.<br />";
	       		// DEBUGG $err .= " Sa rfrence existe encore dans la base de donnes &nbsp;: table docs_joints_ctextes (id_doc=$id_doc)<br />";
    	  	}
      		else 
      		{
      			$ok_suppr_doc .= "Le document ".$nom_fichier." a t supprim.<br />";
      		}
	      	// On recherche s'il n'existe plus aucune association avec le document pour d'autres sances ou travaux  faire pour la classe/groupe et la matire considre
			// Le lien symbolique vers le document ne sera supprim que s'il n'y a plus aucune association entre CE document et une sance ou un travail  faire
	    	// Pour identifier correctement le document on utilise nom de fichier + empreinte md5
	    	// La requte n'est pas la mme si c'est un groupe manuel (ou bien un groupe sconet ou une division)
    	  	if ($_SESSION['type_structure_en_cours'] == "D" || $_SESSION['type_structure_en_cours'] == "G")
        		$sql = "SELECT count(DISTINCT id_doc,filename,code_structure) as nb FROM docs_joints_ctextes as t1, cahiers_textes as t2, a_faire as t3 WHERE filename='$nom_fichier' AND md5='$md5' AND ((t1.id_ctexte=t2.id_ctexte AND code_structure='".$_SESSION['classe_en_cours']."' AND code_matiere='$code_matiere') OR (t1.id_afaire=t3.id_afaire AND t2.id_ctexte=t3.id_ctexte AND code_structure='".$_SESSION['classe_en_cours']."' AND code_matiere='$code_matiere'))"; 
      		elseif($_SESSION['type_structure_en_cours'] == "GM")
				$sql = "SELECT count(DISTINCT id_doc,filename,code_structure) as nb FROM docs_joints_ctextes as t1, cahiers_textes as t2, a_faire as t3 WHERE filename='$nom_fichier' AND md5='$md5' AND ((t1.id_ctexte=t2.id_ctexte AND id_groupe='".$_SESSION['id_groupe_en_cours']."') OR (t1.id_afaire=t3.id_afaire AND t2.id_ctexte=t3.id_ctexte id_groupe='".$_SESSION['id_groupe_en_cours']."'))";
      		$resultat = mysql_query($sql);
      		$ligne = mysql_fetch_array($resultat);
      		if ($ligne['nb'] == 0) // pas d'association, on va supprimer le lien symbolique vers le doc
      		{	
	      		// il faut le libelle_edition de la matire pour le chemin d'accs
    	  		$sql = "SELECT libelle_edition FROM matieres_sconet WHERE code_matiere='$code_matiere'";
      			$resultat = mysql_query($sql);
      			$ligne = mysql_fetch_array($resultat);
      			$nommatiere = $ligne['libelle_edition'];
      			$nomdivision = $_SESSION['classe_en_cours'];
      			$a_suppr = $GLOBALS['stock_baselev']."cahiers_textes/".nospace(noaccent($nomdivision))."/".nospace(noaccent($nommatiere))."/".$nom_fichier;
      			if (!@unlink($a_suppr)) // En cas d'erreur
      			{
        			// DEBUGG $error_message = array("Le lien symbolique <b>$a_suppr</b> n'a pas pu tre supprim ou a dj t supprim !","");
	        		// DEBUGG affiche_erreurs($error_message);
    	  		}
      			else // le lien symbolique a t supprim 
      			{
	      			// DEBUGG $ok_suppr_doc .= "Il n'y a plus de rfrence vers le document ".$nom_fichier." donc Le lien symbolique <b>$a_suppr</b> a t supprim.<br />";
    	  			// ATTENTION ! le unlink prcdent ne supprime que le lien symbolique qui lie le fichier avec la sance ou le travail  faire, mais pas le fichier physique qui reste sur le serveur
				    // 	C'est voulu car il ne faudrait pas supprimer physiquement un fichier reli avec la sance ou le travail  faire d'une autre classe (dont le lien symbolique resterait actif)
    	  	
					// Il faut vrifier si le document est li  d'autres cahiers de textes, si c'est oui, on ne supprime pas ce doc du sous-dossier "docs", sinon on le supprime
					// Cela permettrait d'viter l'encombrement de la zone de stockage avec des fichiers qui ne sont lis  aucune sance ou travail  faire
    				$sql = "SELECT filename FROM docs_joints_ctextes WHERE filename='$nom_fichier' AND md5='$md5'";
    				$result = mysql_query($sql);
      				if (mysql_num_rows($result) == 0) // => Il n'y a pas de document (dont le nom de fichier et le md5 sont ceux spcifis) associ  une sance ou  un travail  faire
      				{
		    			// On peut donc supprimer physiquement le fichier du serveur
        				if (!@unlink($GLOBALS['stock_baselev']."cahiers_textes/docs/".$nom_fichier)) // Le @ prvient l'affichage d'un chec de la suppression, utile en cas de mise  jour de l'application IEW en cours d'anne depuis une version antrieure  2.0.1 (avant le sous-dossier "docs" n'existe pas, d'o l'erreur potentielle, mais celle-ci ne serait qu'apparente, puisque le doc serait supprim physiquement avec le 1er unlink)
        				{	
        					// DEBUGG $err .= "Le fichier ".$GLOBALS['stock_baselev']."cahiers_textes/docs/".$nom_fichier." n'a pas pu tre supprim du serveur.";
        				}
        				else
        				{
	        				// DEBUGG $ok_suppr_doc .= "Il n'y a plus aucune rfrence vers le document ".$nom_fichier."; Le fichier ".$GLOBALS['stock_baselev']."cahiers_textes/docs/".$nom_fichier." a donc t supprim du serveur.<br />";
    	    			}	
      				} 
      			}
      		} // si une association existe encore, on ne supprime ni lien symbolique, ni fichier
		}
    if ($err != "") // il y a eu une erreur, on prcise laquelle
	{
		$status_message = "ERR:Les erreurs suivantes se sont produites : $err"; // elles ne seront pas toutes affiches sauf si on passe le script en mode debugg (en enlevant les commentaires //DEBUGG dans la fonction en cours)
	}
	else // pas d'erreur tout est normal
	{
	  	$status_message = $ok_suppr_doc;
	}      
	return $status_message;
}

function affiche_bandeau_matiere_en_cours($i)
{
  // Gre l'affichage de la matire dans le formulaire et, le cas chant des sous-matires

  global $code_sous_matiere,$id_sous_matiere,$date; // ces variables sont dfinies hors de la fonction
  // DEBUGG print "indice de la matire : $i<br />";
  if (isset($_SESSION['liste_sous_matieres'][$i]))
  {
    //$code_sous_matiere .= "<br />";
    $m = 0; //initialisation d'un compteur
    $code_sous_matiere .= "<div id='liste_sous_mat'>";
    reset($_SESSION['liste_sous_matieres'][$i]);
    while($value = current($_SESSION['liste_sous_matieres'][$i]))
    {
      if(!isset($_GET['sous_matiere']) && !isset($_POST['id_sous_matiere']))
        $m++; // on incrmente le compteur (seulement si la matire, sous-matires n'est pas fournie ni GET ni POST)
      $code_sous_matiere .= "<a href='?matiere=".$i."&amp;sous_matiere=".key($_SESSION['liste_sous_matieres'][$i])."'>";
      // le code suivant dpend de la mthode du chargement de la page (aprs un post, paramtre GET dans l'url, cas par dfaut)
      if(isset($_GET['sous_matiere']) && $_GET['sous_matiere']==key($_SESSION['liste_sous_matieres'][$i]))
      { // Si la matire et la sous-matire sont passes par l'url (GET)
        $code_sous_matiere .= "<span class='ctexte_sous_mat_active'>$value</span>";
        $id_sous_matiere = $_GET['sous_matiere']; // on en aura besoin comme champ cach de formulaire      
      }
      elseif(isset($_POST['id_sous_matiere']) && $_POST['id_sous_matiere']==key($_SESSION['liste_sous_matieres'][$i]))
      {
        $code_sous_matiere .= "<span class='ctexte_sous_mat_active'>$value</span>";
        $id_sous_matiere = $_POST['id_sous_matiere']; // on en aura besoin comme champ cach de formulaire
      }
      else // aucune info de matire et de sous-matire n'est passe => cas par dfaut (au premier chargement de la page)
      {
        // l, on se sert du compteur (incrment dans ce cas  chaque tour de boucle foreach)
        if ($m==1) // C'est la premire sous_matire qui sera choisie par dfaut comme active
        {
          $code_sous_matiere .= "<span class='ctexte_sous_mat_active'>$value</span>";
          $id_sous_matiere = key($_SESSION['liste_sous_matieres'][$i]); // on en aura besoin comme champ cach de formulaire
        }
        else
          $code_sous_matiere .= "$value";
      }
      $code_sous_matiere .= "</a> - ";
      next($_SESSION['liste_sous_matieres'][$i]);
    }
    $code_sous_matiere = preg_replace("# - $#","",$code_sous_matiere); //on elimine le dernier " - "
    $code_sous_matiere .= "</div>";
  }
  $code_formulaire_ajouter = "
  <div class='encadrer_en_tete'>
  <h3 class='titre_matiere_ct'>".$_SESSION['liste_matieres'][$i]."</h3>
            $code_sous_matiere";
    $code_formulaire_ajouter .= "</div>";
    return $code_formulaire_ajouter;
}

function efface_post()
{
  // pour que le script fonctionne correctement, il faut faire souvent des unset($_POST)
  // car je rappelle, compte-tenu de la gestion d'un format imprimable, le tableau $_POST
  // est sauvegard dans un tableau $_SESSION['post_imprimable']
  // et au rechargement du squelette de page, le $_POST est restaur, ce qui pose le problme
  // des post multiples (les variables $_POST gardent leur valeurs -car restaures- mme si on fait du GET,car le simple
  // chargement de la page, donc mme en GET, fait que $_POST est restaur  partir de $_SESSION['post_imprimable'])
  global $sauve_id_matiere,$sauve_id_sous_matiere;
  $sauve_id_matiere = $_POST['id_matiere'];
  $sauve_id_sous_matiere = $_POST['id_sous_matiere'];
  unset($_POST);
  unset($_SESSION['post_imprimable']);
  // DEBUGG print "la fonction efface_post() vient d'tre excute<br />";
}

function supprassoc_activite()
{
  // Cette fonction sert  supprimer les travaux  faire et les documents joints associs
  //  une entre de cahier de texte (travail fait en classe) qu'un utilisateur souhaite supprimer
  
  // Si c'est Ok, on supprime les travaux  faire associs
  if (isset($_SESSION['suppr_id_afaire']))
  {
    foreach($_SESSION['suppr_id_afaire'] as $value)
    {
      // Il y a peut-tre des documents joints lis au travail  faire
      $sql = "DELETE FROM a_faire WHERE id_afaire='".quote_smart($value)."'";
      // DEBUGG print $sql."<br />";
      if ($result = mysql_query($sql) && mysql_affected_rows()>0)
      {
      	// Il faut aussi supprimer les ventuels documents joints associs
    	// il nous faut le nom du fichier  supprimer
      	$sql = "SELECT filename,id_doc,md5 FROM docs_joints_ctextes as t1, cahiers_textes as t2 WHERE id_afaire='".quote_smart($value)."'";
      	$reponse = remove_doc($sql,$_GET['matiere']); // message de succs ou d'erreur
      	if (substr($reponse,0,4) == "ERR:") // il y a eu erreur
      	{
      		$reponse = preg_replace("#ERR:#","",$reponse);
      		$err.= $reponse;
      	}
      }
      else 
     {
    	$err.= "Le travail  faire (id_afaire=$value) n'a pas pu tre supprim !<br />";
      }
    }
    unset($_SESSION['suppr_id_afaire']);
  }
  // puis on supprime les docs joints associs
  if (isset($_SESSION['suppr_id_doc']))
  {
    foreach($_SESSION['suppr_id_doc'] as $value)
    {
    	$sql = "SELECT filename,id_doc,md5 FROM docs_joints_ctextes WHERE id_doc='".quote_smart($value)."'";
    	$reponse = remove_doc($sql,$_GET['matiere']); // message de succs ou d'erreur
      	if (substr($reponse,0,4) == "ERR:") // il y a eu erreur
      	{
      		$reponse = preg_replace("#ERR:#","",$reponse);
      		$err.= $reponse;
      	}
    }
    unset($_SESSION['suppr_id_doc']);
  }
  // Enfin on supprime Le contenu de sance
  $sql = "DELETE FROM cahiers_textes WHERE id_ctexte='".quote_smart($_SESSION['suppr_id_ctexte'])."'";
  // DEBUGG print $sql."<br />";
  mysql_query($sql);
  unset($_SESSION['suppr_id_ctexte']);
  if ($err != "")
  {
  	$error_message = array($err,"");
  	affiche_erreurs($error_message);
  }
  else 
  {
  	$ok_message = "<div align='justify'>Le contenu de sance de texte ainsi que ses travaux  faire et documents distribus associs ont t supprims.</div>";
  	affiche_ok($ok_message);
  }
}

function infobulle($element,$type)
{
	$title_attribute = "";
	switch ($element)
	{
		case 'publication':
			$title_attribute = "Si cette case est coche, le $type est visible en particulier pour les lves et les parents. Si elle n'est pas coche, le $type est visible uniquement par son auteur";
			break;
	}
	return $title_attribute;
}

function copy_activite($result)
{
	/**
	 * Copie une sance de cahier de textes d'une classe ou d'un groupe VERS une nouvelle sance de classe ou de groupe
	 * 
	 * @param $result : resource identifier en provenance d'une requte SQL (slection de la source  copier)
	 * 
	 * @return : $id_ctexte, l'identifiant de sance nouvellement cr
	 */
	
	global $date; 
	
	$ligne = mysql_fetch_array($result);
    $activite = htmlspecialchars($ligne['activite']); // comme c'est rcupr dans un textarea, il ne faut pas de balise html
    $publication = $ligne['publication']; // la future entre aura le mme statut de publication que la sance  copier
    // il faut maintenant crer la copie
    // mais il faut savoir d'abord si on copie VERS une classe ou un groupe
    $sql1 = "SELECT id_groupe FROM groupes WHERE nom='".quote_smart($_GET['set_classe'])."'";
    if ($result = mysql_query($sql1))
    {
    	if (mysql_affected_rows()>0) // La cible est un groupe
        {
        	$ligne1 = mysql_fetch_array($result);
          	$id_groupe = $ligne1['id_groupe']; // on rcupre son id
        }
        else // Ce n'est pas un groupe
        	$id_groupe = 0;
    }
    // !!! Attention, on copie aussi la matire et la sous-matire ventuellement, donc problme  prvoir si un prof copie le contenu d'un sance dans une autre matire que l'original : ceci est a priori trs peu probable cependant...
    $sql1 = "INSERT INTO cahiers_textes values(NULL,'".quote_smart($date)."','".quote_smart($_GET['set_classe'])."','$id_groupe','".$_SESSION['identifiant_individu']."','".quote_smart($_GET['matiere'])."','".$ligne['id_sous_matiere']."','".quote_smart($ligne['activite'])."','".$ligne['publication']."')";
    if ($result = mysql_query($sql1))
    {
    	if (mysql_affected_rows()>0)
        {
        	$id_ctexte = mysql_insert_id(); // on rcupre l'id de l'entre cahier de texte qui vient d'tre faite, s'il s'agit d'une nouvelle insertion
          	$info = "Le travail fait en classe a bien t <b>copi</b> dans le cahier de textes.<br />";
          	  				
          	// il faut galement retrouver s'il y a des documents joints  la sance et les recopier aussi...
          	// le nom de classe ou du groupe vient de l'url en mode copie de sance
          	$classe_gpe = str_replace("%20"," ",$_GET['set_classe']); // dans  l'url les espaces sont cods %20 : on rtablit l'espace au cas o....
          	if ($id_groupe == 0) // si la cible de copie est une classe, il faut recopier les docs dans le dossier matire de la classe
          	{
          		// l'id de la matire destination est dans le paramtre URL matiere, il faut rcuprer le libell dition
          		$sql2 = "SELECT libelle_edition FROM matieres_sconet WHERE code_matiere='".quote_smart($_GET['matiere'])."'";
          		$result2 = mysql_query($sql2);
          		$ligne2 = mysql_fetch_array($result2);
          		$info .= copy_docs("id_ctexte",$_GET['id_ctexte'],mysql_insert_id(),$classe_gpe,$ligne2['libelle_edition']);
          	}
          	else // C'est un groupe, on recopie  la racine du groupe
          		$info .= copy_docs("id_ctexte",$_GET['id_ctexte'],mysql_insert_id(),$classe_gpe,"");
          	$info .= "<br /><a href='edt.php?categorie=professeurs&amp;edt=".$_SESSION['identifiant_individu']."&amp;typecopy=activite&amp;id_ctexte=".$_GET['id_ctexte']."&amp;debut_semaine=".convert_date_to_mysql($_GET['date'], "-")."' title=\"Retour  mon emploi du temps pour coller la mme sance dans le cahier de textes d'une autre classe ou bien afficher un autre cahier de textes\">[Retour  mon emploi du temps]</a>"; // On affiche un lien de retour  l'emploi du temps, ventuellement pour un autre copie ou pour choisir un autre cahier de texte que celui en cours d'affichage
          	affiche_ok($info);
        }
    }
    else 
   {
		// quelle en est la raison ?
        // erreur 1062 ? (duplicate entry : on essaye d'crire la mme entre, et les cls ne le permettent pas pour viter les doublons)
        if (mysql_errno()!="1062" && mysql_errno()!="0") // si ce n'est pas l'erreur 1062, il faut avertir l'utilisateur
        {
        	$error_message = array("Le travail effectu en classe n'a pas pu tre enregistr dans le cahier de textes (Erreur MySQL n".mysql_errno().") Veuillez recommencer ultrieurement.","");
            affiche_erreurs($error_message);
            // mais le script continue...
        }
        $id_ctexte = 0; // vite le retour d'une valeur vide en cas de problme
   }
   return $id_ctexte;
}

function copy_docs($type_copy,$id_source,$id_dest,$classe_gpe,$matiere)
{
	/**
	 * Ralise la copie des documents joints associs au contenu de sance ou au travail  faire que l'on doit copier
	 * => Copie dans la table docs_joints_ctextes
	 * => Cration d'un lien symbolique pointant vers l'emplacement rel du fichier
	 * 
	 * @param $type_copy : vaut 'id_ctexte' si on veut copier les docs joints  un contenu de sance et 'id_afaire' si on veut copier les docs joints  un travail  faire
	 * @param $id_source : identifiant numrique du contenu de sance ou du travail  faire  copier (utilis pour rechercher les documents associs) = source
	 * @param $id_dest : identifiant numrique du contenu de sance ou du travail  associer avec les documents  copier
	 * @param $classe_gpe : code_structure pour une classe ou un groupe sconet ou nom du groupe pour un groupe manuel
	 * @param $matiere : sous dossier /classe ou groupe/matiere (du dossier /data/cahiers_textes) pour la destination du lien symbolique  crer
	 * 
	 * @return $info : renvoie un message de succs ou chec de la copie de chaque document (sera vide si pas de document  copier)
	 */
	
	$info = "";
	$sql = "SELECT * FROM docs_joints_ctextes WHERE $type_copy='$id_source'"; // $id_source est dj quote_smart avant l'appel
	$resultat = mysql_query($sql);
	if ($resultat && mysql_num_rows($resultat) > 0)
	{
		while ($ligne = mysql_fetch_array($resultat))
		{
			if ($type_copy == "id_ctexte")
			{
				$id_afaire = 0;
				$id_ctexte = $id_dest;	
			}
			elseif ($type_copy == "id_afaire")
			{
				$id_ctexte = 0;
				$id_afaire = $id_dest;	
			}
			elseif ($type_copy == "id_doc")
			{
				// Dans le cas de la copie directe d'un document le paramtre $id_dest contient le symbole =, 
				// alors l'association du document se fera en fonction de la chane se trouvant  gauche de ce symbole: 
				// id_ctexte indique qu'il faut associer le document avec une sance dont l'identifiant est fourni  droite du symbole gal,
				// id_afaire  indique qu'il faut associer le document avec un travail  faire dont l'identifiant est fourni  droite du symbole gal
				$fragment = explode("=",$id_dest);
				$cible_copie = $fragment[0];
				if ($cible_copie == "id_ctexte")
				{
					$id_afaire = 0;
					$id_ctexte = $fragment[1];	
				}
				elseif ($cible_copie == "id_afaire")
				{
					$id_ctexte = 0;
					$id_afaire = $fragment[1];	
				}
			}
			// Attention le commentaire peut contenir une apostrophe, il faut quotesmarter...
			$sql = "INSERT INTO docs_joints_ctextes VALUES(NULL,'".$ligne['filename']."','".quote_smart($ligne['commentaire'])."','$id_ctexte','$id_afaire','".$ligne['publication']."','".$ligne['md5']."')";
			$result = mysql_query($sql);
			if ($result && mysql_affected_rows()>0)
			{
				// Cration d'un lien symbolique vers le fichier
				$dossier_ctextes_docs = $GLOBALS['stock_baselev']."cahiers_textes/docs/";
				$chemin_classe = $GLOBALS['stock_baselev']."cahiers_textes/".nospace(noaccent($classe_gpe))."/";
				if (!is_dir($chemin_classe))
  				{
    				mkdir($chemin_classe,0755);
  				}
  				if ($matiere != "") // Si la matire est prsente on doit copier vers le sous-dossier matire correspondant d'une classe
					$chemin_symlink = $chemin_classe.nospace(noaccent($matiere))."/";
				else // matire non prsente : on doit copier vers le dossier d'un groupe
					$chemin_symlink = $chemin_classe; // Pas besoin du slash terminal (il y est dj)
    			$target = $dossier_ctextes_docs.$ligne['filename'];
    			$link = $chemin_symlink.$ligne['filename'];
    			// on vrifie que la cible du futur lien symbolique existe, sinon on en crera pas le lien
    			if (file_exists($target))
    			{
    				// le chemin $chemin_symlink n'existe peut-tre pas encore: si c'est le cas, il faut le crer sinon la cration du lien symbolique chouera
    				if (!is_dir($chemin_symlink))
  					{
    					mkdir($chemin_symlink,0755);
  					}
    				if (!file_exists($link)) // on vrifie aussi que le lien symbolique n'existe pas dj
	    			{
    					if (symlink($target,$link))
    						$info .= "- Le document <i>".$ligne['filename']."</i> a t copi avec succs.<br />";
    					else 
    						$info .= "<b>- ATTENTION : Le lien symbolique <i>($link)</i> vers le document <i>$target</i> n'a pas pu tre cr !</b><br />";
    				}
    				else // le lien existe dj, il faut juste indiquer que la copie s'est bien droule
    				{
    					$info .= "- Le document <i>".$ligne['filename']."</i> a t copi avec succs.<br />";
    					//$info .= "- Le document <i>".$ligne['filename']."</i> <b>existe dj</b>, le fichier n'a pas t recopi.<br />";	
    				}
    			}
    			else // la cible n'existe pas
    			{
    				$info .= "<b>- ATTENTION : Le lien symbolique <i>($link)</i> vers le document <i>".$ligne['filename']."</i> ne peut pas tre cr car la cible <i>$target</i> n'existe pas !</b><br />";
    			}
			}
			else // la requte d'insertion n'a pas pu aboutir
			{
				if (mysql_errno()=="1062") // parce que le document existe dj dans la table (duplicate entry)
					$info .= "- Le document <i>".$ligne['filename']."</i> existe dj, pas besoin de le recopier.<br />";
				else
					$info .= "<b>- ATTENTION : Le document <i>".$ligne['filename']."</i> n'a pas pu tre copi !</b><br />";
			}
		}
	}
	return $info;
}

function recup_libelle_matiere($classe_gpe,$id_ctexte)
{
	/**
	 * Permet de rcuprer le libell de la matire associe  une sance de cahier de texte
	 * utilise pour la copie, le stockage d'un document attach  une sance ou  un travail  faire
	 * 
	 * @param $classe_gpe : nom de la classe ou du groupe
	 * @param $id_ctexte : identifiant de la sance  laquelle sera attache le document (directement ou par attachement  un travail  faire associ  la sance)
	 * 
	 * @return $libelle_matiere : contient le libell Edition de la matire qui fournira le nom du sous-dossier de stockage du document
	 */
	 $sql4 = "SELECT id_groupe FROM groupes WHERE nom='".quote_smart($classe_gpe)."'";
     if ($result4 = mysql_query($sql4))
     {
     	if (mysql_affected_rows()>0) // La cible est un groupe
        {
        	$libelle_matiere = ""; // pas de matire
        }
        else // Ce n'est pas un groupe, la matire doit tre rcupre
        {
        	$sql_2bis = "SELECT libelle_edition,t1.code_matiere FROM cahiers_textes as t1, matieres_sconet as t2 WHERE id_ctexte='$id_ctexte' AND t1.code_matiere=t2.code_matiere";
        	$resultat2bis = mysql_query($sql_2bis);
        	if ($resultat2bis)
        	{
        		$ligne2bis = mysql_fetch_array($resultat2bis);
        		$libelle_matiere = $ligne2bis['libelle_edition'];
        	}
        }
    }
    return $libelle_matiere;          	
	
}

function complement_titre()
{
	/**
	 * Complte le titre du formulaire avec des informations additionnelles
	 * Pour les parents, cela permet d'indiquer entre parenthses le prnom de l'enfant
	 * 
	 * @return : $complement_titre = le prnom de l'enfant entre ()
	 */
	// Les donnes des enfants sont dans $_SESSION['enfants_scol'] au format eleve_id,nom,prenom,classe
	// la classe (ou le groupe) est dans $_SESSION['classe_en_cours']
	$complement_titre = "";
	if ($_SESSION['valid_group'] == '4')
	{
		foreach ($_SESSION['enfants_scol'] as $donnees_enfant)
		{
			$fragment = explode(',', $donnees_enfant);
			$classe = $fragment[3];
			if ($classe == $_SESSION['classe_en_cours']) // Attention au groupes !!!
			{
				$complement_titre = " (".$fragment[2].")"; // on met son prnom entre ()
			}
		}
	}
	else 
		$complement_titre = "";
	return $complement_titre;
}

/**************************************************************************************************************************************
 *  Dbut du script principal
 *************************************************************************************************************************************/

// Le script en cours doit tre le script d'appel prvu
if (end_with_string($_SERVER['PHP_SELF'],"prive/cahiers_textes.php"))
{
   connexion_mysql();
   select_database();
   
   global $liste_groupes,$nb_travaux,$nb_docs,$sauve_id_matiere,$id_matiere,$sauve_id_sous_matiere,$is_documentaliste,$date,$code_sous_matiere,$id_sous_matiere; // Pour rendre ces variables dispo pour les fonctions de ce script
   
  // Initialisation d'une variable (porte globale, mais aussi modifie par la fonction mysql_jour_suiv_prec_ouvrable()) pour la date
  $newdate_ouvrable = "";
  // autres initialisations (vite les messages NOTICE lors de l'utilisation du cahier de textes pour un groupe)
  $i = "";
  $id_matiere = "";
  
  /** Nettoyage des variables de session **/
  
  /* Contenu des variables de session 
   * - $_SESSION['classe_en_cours'] = la classe ou le groupe (sconet ou manuel) slectionn dans le formulaire de dpart
   * - $_SESSION['type_structure_en_cours'] = 3 valeurs possibles : (D=division,G=Groupe sconet,GM=groupe cr manuellement)
   * - $_SESSION['id_groupe_en_cours'] = identifiant du groupe dans la table groupes
   * - $_SESSION['liste_groupes'] =  pour une division, contient la liste des groupes sconet qui prennent des lves dans la division
   * - $_SESSION['liste_sous_matieres'] = liste des sous-matires associes  une matire (table sous_matieres)
   * - $_SESSION['date_en_cours_consultation'] = mmorise la date que l'on consulte */
  
  // Si l'appel du script est fait avec le paramtre unset_classe  oui, il faut effacer la variable $_SESSION['classe_en_cours']
  // pour permettre l'affichage du formulaire du choix de la nouvelle classe
  if (isset($_GET['unset_classe']) && $_GET['unset_classe'] == "oui")
  {
    unset($_SESSION['classe_en_cours']);
    unset($_SESSION['type_structure_en_cours']);
    unset($_SESSION['id_groupe_en_cours']);
    unset($_SESSION['liste_groupes']);
    unset($_SESSION['liste_matieres']);
    unset($_SESSION['liste_sous_matieres']);
    unset($_SESSION['date_en_cours_consultation']);
    // on efface aussi les variables du post qui sont sauvegardes par session et restaures au chargement du squelette de page
    unset($_POST);
    unset($_SESSION['post_imprimable']);
  }
  elseif ($_SESSION['classe_en_cours'] !="" && !isset($_SESSION['liste_groupes'])) // Au cas o l'on arrive ici par le format imprimable
  {
  	// comme la variable $_SESSION['liste_groupes'] est initialise dans fonctions_formatage_sommaire.php
  	// cette dernire n'est pas excute si on est en format imprimable (le sommaire du cahier de textes n'est pas affich)
  	// Ce n'est pas un problme si on passe d'abord par un format normal ($_SESSION['liste_groupes'] sera alors initialise)
  	// Mais les profs eux, vont passer directement par le format imprimable ds le choix de la classe dans le formulaire
  	// On fait donc en sorte, que dans tous les cas, $_SESSION['liste_groupes'] soit bien initialise
  	$_SESSION['liste_groupes'] = cherche_classe_dans_groupes($_SESSION['classe_en_cours']);
  }
  
  // DEBUGG var_dump($_POST);

  /** Traitement des paramtres dans l'URL **/
  
  // Si l'appel du script est fait avec un paramtre set_classe, il faut raffecter la variable $_SESSION['classe_en_cours'] avec le nom de la classe (ou du groupe) correspondant
  if (isset($_GET['set_classe']) && $_GET['set_classe'] != "")
  {
    // Ainsi on zappe le formulaire de choix de classe
    // Mais comme cela vient d'un paramtre GET, donc modifiable par l'utilisateur, il faut s'assurer que
    // celui-ci a bien le droit de voir le cahier de textes de la classe (ou du groupe) correspondant
    if ($_SESSION['valid_group'] == "11") // Cas d'un IPR
    {
    	$liste_affichable_classes_autorisees = auth_choix_classe(); // Le format est Nom_Classe (Civilit Nom Prenom du prof) Matire
    	// C'est ce qui sera utilis dans l'affichage + bas
    	// Mais pour vrifier si le paramtre URL set_classe
    	foreach ($liste_affichable_classes_autorisees as $value)
    	{
    		$fragments = explode("(",$value);
    		$liste_classes_autorisees[] = rtrim($fragments[0]); // voil la classe seule
    	}
    }
    else // pas un IPR
    	$liste_classes_autorisees = auth_choix_classe(); // Le format est Nom_Classe seul
   
    // Vrification si la classe voulue est autorise
    if (in_array($_GET['set_classe'],$liste_classes_autorisees) || $_SESSION['valid_group'] == "3") // Si autoris
    // les profs sont autoriss par ce moyen  voir tous les cahiers de textes (y compris de la classe qu'il n'ont pas) => Cas typique de l'accs par le cahier d'appel (lien -icne- cahier de texte)
    {
      $_SESSION['classe_en_cours'] = $_GET['set_classe'];
      if ($_SESSION['valid_group'] == "4")
      {
      	if (isset($_GET['choix_classe_enfant'])) // Cas d'un parent qui a choisi d'afficher le cahier de texte de l'un de ses enfants  partir du script c_fichindiv.php
      		$_SESSION['choix_classe_enfant'] = $_GET['choix_classe_enfant'];
      	else // ou par exemple  partir de l'edt de l'enfant
      		$_SESSION['choix_classe_enfant'] = $_SESSION['classe_en_cours']."%".$_GET['eleve_id'];
      }
      if (isset($_SESSION['id_groupe_en_cours']))
        unset($_SESSION['id_groupe_en_cours']);
      if (isset($_SESSION['liste_groupes']))
        unset($_SESSION['liste_groupes']);
      if (isset($_SESSION['liste_matieres']))
        unset($_SESSION['liste_matieres']);
      if (isset($_SESSION['liste_sous_matieres']))
        unset($_SESSION['liste_sous_matieres']);
      session_trouve_matieres_classe(); // il faut rcuprer les matires de la classe
    }
    else // L'utilisateur a essayer d'entrer un paramtre URL set_classe avec une classe non autorise
    {
      $error_message = array("Vous avez modifi un paramtre de l'URL de la page avec une valeur de classe pour laquelle vous n'tes pas autoris  voir le cahier de textes !","");
      affiche_erreurs($error_message);
      if (isset($_SESSION['classe_en_cours']))
      {
        unset($_SESSION['classe_en_cours']);
        unset($_SESSION['type_structure_en_cours']);
      }
      if (isset($_SESSION['id_groupe_en_cours']))
        unset($_SESSION['id_groupe_en_cours']);
         if (isset($_SESSION['liste_groupes']))
        unset($_SESSION['liste_groupes']);
      if (isset($_SESSION['liste_matieres']))
        unset($_SESSION['liste_matieres']);
      if (isset($_SESSION['liste_sous_matieres']))
        unset($_SESSION['liste_sous_matieres']);
      if (isset($_SESSION['date_en_cours_consultation']))
        unset($_SESSION['date_en_cours_consultation']);
      // on efface aussi les variables du post qui sont sauvegardes par session et restaures au chargement du squelette de page
      if (isset($_POST))
        unset($_POST);
      if (isset($_SESSION['post_imprimable']))
        unset($_SESSION['post_imprimable']);
      return;
    }
  }
  
  // assurer la suppression d'une variable de session qui a t initialise lors d'un prcdent chargement du script s'il s'agissait d'un groupe
  // et que maintenant c'est une division
  if (!isset($_GET['id_gpe']) && $_SESSION['type_structure_en_cours'] == "D" && isset($_SESSION['id_groupe_en_cours']))
  	unset($_SESSION['id_groupe_en_cours']);
  
  echo "<h1>Cahier de textes</h1>";
  
  /** Affichage du formulaire de choix de la classe/groupe **/
    
  // Cas initial (ou d'un changement de classe ou de groupe)
  // Il faut afficher le formulaire permettant de choisir la classe ou le groupe dont on veut voir le cahier de textes
  if ((!isset($_SESSION['classe_en_cours']) || $_SESSION['classe_en_cours']=="") && (!isset($_POST['submit_classe']) || $_POST['submit_classe'] == ""))
  {
    if ($_SESSION['valid_group'] == '4') // cas d'un parent connect
      affiche_formulaire_choix_parent();
    elseif ($_SESSION['valid_group'] == '2') // Si c'est un lve faisant partie au moins d'un groupe
    {
      if (count($liste_groupes)!=0)
      {
        affiche_formulaire_choix_eleve(); // alors on lui donne le choix du cahier de textes  afficher
        return;
      }
      else // il n'est inscrit dans aucun groupe, donc c'est sa classe qui est choisie par dfaut pour la consultation du cahier de textes
      {
        cherche_classe_eleve(); // la valeur de $_SESSION['classe_en_cours'] n'est plus vide et contient la classe de l'lve
        // Il faut recharger la page pour que la valeur de $_SESSION['classe_en_cours'] puisse tre prise en compte
        // et que la suite du script puisse s'excuter
        echo "
        <script type='text/javascript'>
          <!--
            location.reload();
          // -->
        </script>";
      }
    }
    else // pour les autres cas (autres que l'lve, parmi les groupes d'utilisateurs autoriss)
      affiche_formulaire_choix_classe();
    return; // script interrompu pour ne pas afficher la suite
  }
  elseif (isset($_POST['classe']) && $_POST['classe'] == "") // le formulaire a t transmis sans choisir la classe !
  {
    $error_message = array("Le champ classe ou groupe est vide ! <a href='".$_SERVER['PHP_SELF']."'>Recommencez.</a>","");
    affiche_erreurs($error_message);
    efface_post();
    return;
  }
  else // si la classe a dj t choisie dans le formulaire ou affecte d'office (cas d'un lve connect)
  {
    // Alors il nous faut stocker le choix dans une variable de session et rcuprer aussi d'autres infos dans la base de donnes (identifiants classe ou groupe)
    if (!isset($_SESSION['classe_en_cours']) || $_SESSION['classe_en_cours']=="") // la classe vient juste d'tre choisie dans le formulaire
      {
        $_SESSION['classe_en_cours'] = recup_choix_classe_ctextes();
      }
    
    // Si c'est un groupe manuel (hors sconet) il faut rcuprer son identifiant
    /* En effet les groupes manuels ne sont pas associs  des matires comme les groupes sconet :
     * Ces derniers, comme les divisions (classes) sont associs aux matires (code_matiere) dans la table 'services' 
     * Comme ce script recherche les matires associes  une classe ou  un groupe, il ne peut trouver ces infos que dans la table services 
     * et par consquent il n'existe aucun code_structure de la table 'structures' donc 'services' contenant le nom d'un groupe cr manuellement 
     * Il faut donc reprer ce groupe par son identifiant dans la table 'groupes' (l o la cration manuelle l'a inscrit)
     * Car c'est cet identifiant qui va faire la liaison avec le cahier de textes correspondant */
    if ($_SESSION['type_structure_en_cours'] == "GM") // C'est un groupe cr manuellement
    {
       	$sql = "SELECT id_groupe FROM groupes WHERE nom='".quote_smart($_SESSION['classe_en_cours'])."'";
      	$resultat = mysql_query($sql);
      	$ligne = mysql_fetch_array($resultat);
      	$_SESSION['id_groupe_en_cours'] = $ligne['id_groupe'];
    }
    
    if (!isset($_SESSION['liste_matieres']) && $_SESSION['type_structure_en_cours'] == "D") // si ce n'est pas un groupe (c'est donc une vraie classe) et si les matires qui y sont enseignes n'existent pas
    {
      $error_message = array("<div align='justify'>La table contenant les informations sur les matires ne contient pas de donnes concernant la classe de <font color=black><b>".$_SESSION['classe_en_cours']."</b></font>. En consquence, les matires enseignes dans cette classe sont introuvables. Veuillez contacter la personne charge de mettre  jour les quipes pdagogiques (gestadmin) ou <a href='".$_SERVER['PHP_SELF']."?unset_classe=oui'>changer votre choix pour la classe</a>.</div>","");
      affiche_erreurs($error_message);
      return;
    }
    
    /* Nouveaut 2010 :  ce stade on va rediriger les lves et le parents vers le travail  faire pour une date  choisir
     * donc on change de script, ce qui suit ne concerne donc que les autres utilisateurs, mme s'il reste du code + loin concernant
     * les lves ou les parents : on garde ce code au cas o l'on voudrait rtablir l'accs aux formulaires de saisie/consultation
     * comme pour les profs
     * La redirection n'est pas applique si l'appel est fait en cliquant sur un des liens correspondants aux matires dans le menu du cahier de textes
     * (dans ce cas le paramtre matire est fourni dans l'URL) */
    if (($_SESSION['valid_group'] == 2 || $_SESSION['valid_group'] == 4) && !isset($_GET['matiere']))
    {
    	// la redirection ne peut pas tre faite avec un header php car un affichage a dj eu lieu
    	$protocole = get_protocol_http($_SERVER['SCRIPT_URI']);
		$adresse_redirection = $protocole.$_SERVER['HTTP_HOST'].$GLOBALS['racine']."prive/synthese_ctextes.php?action=afaire&amp;imprimable=oui";
		echo "<script language=\"javascript\" type=\"text/javascript\">
		<!--
			window.location.replace(\"$adresse_redirection\");
		-->
		</script>";
    	exit;
    }
    
  }
  
  /******************* Traitement ventuel des suppression d'entres de cahier de textes ************/
  
  /*** Suppression d'un contenu de sance, associ au moins  un travail  faire et/ou  un/des dcoument(s) joint(s) ***/
  if (isset($_GET['reponse_supprassoc']) && $_GET['reponse_supprassoc']="oui")
    supprassoc_activite();
  
  /*** Suppression d'un travail  faire ***/
  if (isset($_GET['suppr_afaire']) && $_GET['suppr_afaire']!="") // il faut supprimer un travail  faire
  {
    $suppr_afaire = quote_smart($_GET['suppr_afaire']);
    // pour le chemin d'accs aux documents joints  supprimer, il nous faut retrouver la matiere (AVANT que le travail  faire ne soit supprim !)
    $sql = "SELECT code_matiere FROM cahiers_textes as t1,a_faire as t2 WHERE t1.id_ctexte=t2.id_ctexte AND t2.id_afaire='$suppr_afaire'";
    $resultat = mysql_query($sql);
    $ligne = mysql_fetch_array($resultat);
    $code_matiere = $ligne['code_matiere'];
    // on supprime le travail  faire	
  	$sql = "DELETE FROM a_faire WHERE id_afaire='$suppr_afaire'";
    if ($result = mysql_query($sql) && mysql_affected_rows()>0)
    {
      $ok_message = "Le travail  faire a bien t supprim.<br/>";
      // Il faut aussi supprimer les ventuels documents joints associs
      // Il faut d'abord supprimer le fichier sur le serveur
      //**************************************************
      // il nous faut le nom du fichier  supprimer
      $sql = "SELECT filename,id_doc,md5 FROM docs_joints_ctextes WHERE id_afaire='$suppr_afaire'";
      $reponse = remove_doc($sql,$code_matiere); // message de succs ou d'erreur
      if (substr($reponse,0,4) == "ERR:") // il y a eu erreur
      {
      	$reponse = preg_replace("#ERR:#","",$reponse);
      	$error_message = array($ok_message.$reponse,"");
      	affiche_erreurs($error_message);
      }
      else 
      {
      	affiche_ok($ok_message.$reponse);
      }
    }
    else 
   {
    	$error_message = array("Le travail  faire slectionn n'a pas pu tre supprim !","");
    	affiche_erreurs($error_message);
    }
    // Une fois le traitement effectu, il faut enlever le paramtre suppr_afaire de l'url pour viter  nouveau l'excution du code de suppression si on change la date de la sance dans le datepicker
    // en effet, un vnement onchange sur le datepicker recharge la page avec l'url en cours
    $_SERVER['QUERY_STRING'] = preg_replace("#suppr_afaire=".$_GET['suppr_afaire']."#","",$_SERVER['QUERY_STRING']);
  }
  
  /*** Suppression d'un document joint ****/
  if (isset($_GET['suppr_doc']) && $_GET['suppr_doc']!="") // il faut supprimer un document joint
  {
    // Il faut d'abord supprimer le fichier sur le serveur
    //**************************************************
    // il nous faut le nom du fichier  supprimer
    $sql = "SELECT filename,id_doc,md5 FROM docs_joints_ctextes WHERE id_doc='".quote_smart($_GET['suppr_doc'])."'";
  	$reponse = remove_doc($sql,$_GET['matiere']); // message de succs ou d'erreur
    if (substr($reponse,0,4) == "ERR:") // il y a eu erreur
    {
    	$reponse = preg_replace("#ERR:#","",$reponse);
      	$error_message = array($reponse,"");
      	affiche_erreurs($error_message);
    }
    else 
   {
    	affiche_ok($reponse);
    }
    // Une fois le traitement effectu, il faut enlever le paramtre suppr_doc de l'url pour viter  nouveau l'excution du code de suppression si on change la date de la sance dans le datepicker
    // en effet, un vnement onchange sur le datepicker recharge la page avec l'url en cours
    $_SERVER['QUERY_STRING'] = preg_replace("#suppr_doc=".$_GET['suppr_doc']."#","",$_SERVER['QUERY_STRING']);
  }
  
  // Quelle est la date ?
  if (isset($_GET['date']) && $_GET['date']!="") // Si elle est dans l'url choix de date par calendrier
  // alors elle est au format jj-jmm-aaaa, il faut la mettre au format MySQL
    $date =  convert_date_to_mysql($_GET['date'],'-');
  elseif (isset($_POST['date']) && $_POST['date']!="") // Elle peut-tre retransmise par le formulaire de saisie
    $date = $_POST['date'];
  elseif (isset($_GET['cours']) && $_GET['cours']!="") // Peut-tre l'URL contient-elle un appel  une date du cours prcdent (lien cours prcdent) ou du cours suivant (lien cours suivant)
    $date = trouve_date_cours($_GET['cours'],$_GET['id_gpe']);
  
  // la ligne suivante vite de prendre systmatiquement la date du jour :
  /*En effet, si la date du jour n'est pas un jour ouvrable ou tombe pendant les vacances scolaire
  un message invitera l'utilisateur  changer la date de consultation, la page sera  nouveau appele
  avec une autre date, mais ce paramtre date dans l'url ne sera pas disponible lors d'un nouvel appel
  de la page (notamment avec le lien du calendrier dans le champ ' faire pour le' Le rechargement
  automatique de la page au moment de l'ouverture du popup ne contient pas d'information sur la date car
  les liens revoys par cette popup ne contiennent pas d'information sur la date de consultation */
  elseif (isset($_SESSION['date_en_cours_consultation']) && $_SESSION['date_en_cours_consultation']!="") 
    $date = $_SESSION['date_en_cours_consultation'];
  else  // Si la date n'est pas dfinie par GET (URL) ou par POST (formulaire), on l'initialise  la valeur de la date du jour
    $date = date("Y-m-d"); // Date courante au format MySQL
  
  $force_consultation = false; // paramtre utilis par la fonction cherche_mode() : sera mis  true si la date n'est pas un jour ouvrable, vaut false par dfaut
    
  // On vrifie si la date est un jour ouvrable
  if (!test_jour_dans_periode_scolaire($date) || !test_jour_ouvrable(date_mysql_to_jjmmaaaa($date))) // Si c'est dans une priode de travail
  {
     $date_a_remplacer = date_mysql_to_jjmmaaaa_tiret($date);
     $param_url = str_replace("&","&amp;",$_SERVER['QUERY_STRING']);
     // DEBUGG var_dump($param_url);
     $url = $_SERVER['PHP_SELF']."?".preg_replace("#&amp;date=$date_a_remplacer#","",$param_url)."&amp;date=";
     // DEBUGG var_dump($url);
  	 $error_message = array("<div align='justify'>La date choisie ou la date par dfaut (".format_date_long($GLOBALS['default_language'],date_mysql_to_jjmmaaaa($date)).") n'est pas un jour ouvrable de la semaine dans l'tablissement ou bien tombe pendant les vacances scolaires !<br />
     <label for='Form_Req_Choix_Date'>Veuillez choisir la date d'un jour ouvr</label> <input id='Form_Req_Choix_Date' type='text' size='10' class='datepicker choix_date_afaire' name='date' onchange='window.location.replace(\"$url\"+this.value)' /> ou bien utilisez les liens du sommaire de la rubrique <b>Synthse</b> (pour une simple consultation des informations).</div>","");
     affiche_erreurs($error_message);
     $force_consultation = true; // on positonne un flag pour empcher la saisie d'une entre de cahier de texte si la date n'est pas un jour ouvrable de l'tablissement
  }
  
  // la date de consultation du cahier de textes tant fixe, on l'enregistre dans une variable de session
  // pour qu'elle soit disponible comme valeur par dfaut pour toute la dure de la session
  $_SESSION['date_en_cours_consultation'] = $date;
  
  // Y-a-t-il une valeur id_ctexte transmise dans l'url (cas d'ajout d'un travail  faire ou d'un document joint cf liens [Ajouter une autre date] et [Ajouter un document])  
  if (isset($_GET['id_ctexte']) && $_GET['id_ctexte']!="")
    $id_ctexte = $_GET['id_ctexte'];
  
  // Si le script est accd via un lien de copie (dans l'url typecopy=afaire)
  if (isset($_GET['typecopy']))
  {
  	if ($_GET['typecopy'] == "afaire")
  		$error_message = array("Le travail  faire pour le <strong>".format_date_long($GLOBALS['default_language'],date_mysql_to_jjmmaaaa(convert_date_to_mysql($_GET['pourle'],'-')))."</strong> que vous souhaitez copier doit tre associ  un contenu de sance. Pour raliser cette association, il vous faut choisir le contenu de sance.<p>- Vous pouvez choisir la sance affiche (en modifiant son contenu ventuellement) en cliquant sur le bouton &laquo;Associer le travail  copier  cette sance&raquo;</p><p>- ou bien crer un nouveau contenu de sance  la date de votre choix (pourvu qu'elle soit <strong><u>antrieure</u></strong> au <strong>".format_date_long($GLOBALS['default_language'],date_mysql_to_jjmmaaaa(convert_date_to_mysql($_GET['pourle'],'-')))."</strong>). Dans ce dernier cas, cliquez sur le petit calendrier dans la zone de saisie du contenu de sance pour choisir la date de cette sance. Une fois la date et le contenu de sance renseigns, cliquez sur le bouton sur le bouton &laquo;Associer le travail  copier  cette sance&raquo;</p><p>Ds que l'association sera ralise, le travail  faire apparatra dans le formulaire de saisie.</p>","");
  	elseif ($_GET['typecopy'] == "doc")
  		$error_message = array("Le document que vous souhaitez copier doit tre associ  un contenu de sance ou  un travail  faire. Pour raliser cette association, il vous faut choisir le contenu de sance ou le travail  faire&nbsp;:<p>- Vous pouvez choisir la sance affiche ou l'un des travaux  faire affichs (en modifiant son contenu ventuellement) en cliquant sur le bouton &laquo;Associer le document  copier ( cette sance/ ce travail)&raquo;</p><p>- ou bien crer un nouveau contenu de sance (ou un nouveau travail  faire)  la date de votre choix. Dans ce dernier cas, cliquez sur le petit calendrier dans la zone de saisie du contenu de sance ou du travail  faire pour choisir la date. Une fois la date et le contenu de sance ou le travail  faire renseigns, cliquez sur le bouton sur le bouton &laquo;Associer le document  copier  cette sance/ ce travail&raquo;</p><p>Ds que l'association sera ralise, le document apparatra dans le formulaire de saisie.</p>","");
    affiche_erreurs($error_message);
    // alors on simule un post comme pour une saisie normale	
  }
  
  // Si le script est accd via in lien cours suivant ou prcdent, le tableau $_POST de l'xcution prcdente du script est encore en mmoire
  // mais il ne faut pas en tenir compte et sauter directement  l'affichage du cahier de textes
  if (!isset($_GET['cours']))
  {  
  // Si une entre vient d'tre ajoute dans le cahier de textes, on l'enregistre dans la base
  $submit_case = ""; // initialisation d'une variable qui indiquera quel type de sous-formulaire a t soumis

  $post_array_keys = array_keys($_POST); // on rcupre les cls du post (le type de sous-formulaire y est indiqu)
  //On dtermine d'abord si un sous-formulaire a t soumis et on identifie lequel
  foreach ($post_array_keys as $value)
  {
    if (stristr($value,"soumettre")) // s'il y eu une soumission de sous-formulaire
    {
      $submit_name = $value; // on rcupre le nom du bouton submit (qui peut comporter des chiffres  la fin)
      // On isole les chiffres ventuels (dans $regs[0])
      preg_match("#[0-9]+$#",$value,$regs);
      $num = $regs[0]; // on rcupre le numro
      // On prend le nom du bouton submit sans le numro (pour avoir le type de sous-formulaire: activite,afaire,docjoint)
      preg_match("#^[a-z]+_[a-z]+#",$value,$regs);
      $submit_case = $regs[0]; // On a maintenant le type de sous-formulaire, on va pouvoir grer les diffrents cas
    }     
  }
  
  // DEBUGG print "Submit_case : $submit_case<br />";
  // DEBUGG var_dump($_POST);
  
  // $submit_case contient le type du sous-formulaire valid, ou est vide (si aucun sous-formulaire soumis)
  if ($submit_case!="") // il faut traiter les donnes provenant du sous-formulaire
  {
    // Dans tous les cas certaines infos doivent tre avant tout rcupres depuis la base de donnes
    // On rcupre l'id de la classe en cours    $id_division = $_SESSION['classe_en_cours'];
    // On rcupre l'id de la personne connecte (qui vient d'ajouter une entre de cahier de textes)
    $id_pers = $_SESSION['valid_id_user'];
    // Puis l'id de la matire concerne
    $id_matiere = $_POST['id_matiere']; // cl courante dans la liste des matires
    // et de la sous-matire, si elle existe (exemple histoire en histoire-go)
    if (isset($_SESSION['liste_sous_matieres'][$id_matiere]))
      $id_sous_matiere = $_SESSION['liste_sous_matieres'][$id_matiere];
    else
      $id_sous_matiere = "";
      
    // Maintenant on passe aux diffrents cas
    switch($submit_case) // 
    {
      // Le cas suivant correspond  une nouvelle entre concernant l'activit
      case 'soumettre_activite': // Le sous-formulaire 'activite' a t soumis, nouvelle entre, le mme code que pour le cas suivant sera excut
      // Le cas suivant correspond  une modification d'une entre existante concernant l'activit
      case 'soumettre_modifactivite': // Le sous-formulaire 'activite' a t soumis, modification d'une entre existante
      // Pour les deux cas, on xcutera le mme bloc de code (voil pourquoi les deux case 'soumettre_activite' et 'soumettre_modifactivite' sont l'un derrrire l'autre sans break entre les deux)
        if (trim($_POST['activite'])!="")
        {
          $activite = trim($_POST['activite']);
          // on rcupre l'id sous_matiere s'il y en a un
          if (isset($_POST['id_sous_matiere']))
            $id_sous_matiere = $_POST['id_sous_matiere'];
          else
            $id_sous_matiere = 0;
          $publication = $_POST['publication_activite'];
          // enregistrement des activits faites en classe
          if (isset($date))
          {
            if (isset($_POST['id_ctexte']) && $_POST['id_ctexte'] != "") // c'est une modification d'une entre existante dans le cahier de textes
              $sql1 = "UPDATE cahiers_textes SET activite='".quote_smart($activite)."', publication='".quote_smart($publication)."' WHERE id_ctexte='".quote_smart($_POST['id_ctexte'])."'";
            else // C'est une nouvelle entre dans le cahier de textes
            {
              /* il faut traiter $_SESSION['id_groupe_en_cours'] : en effet, cette variable contient soit une chane, soit une valeur numrique
               * C'est une chane lorsque c'est une division ou un groupe sconet (le nom de la division ou du groupe) et on s'en sert dans la fonction trouve_date_cours()
               * C'est une valeur numrique dans le cas d'un groupe cr manuellement
               * Or dans la structure de la table cahier_textes, le champ id_groupe est de type numrique
               * Ce qui signifie que une chane donnera la valeur 0 (ce qui ne permet pas de diffrencier une entre
               * pour une division et une entre pour un groupe sconet).
               * Pour permettre l'identification d'une entre de cahier de texte pour un groupe sconet en tant que groupe
               * il faut donc affecter la valeur de l'id_groupe correspondant dans la table groupe
              */
              if ($_SESSION['type_structure_en_cours'] == "G") // Cas d'un groupe sconet
              {
              	$sql_id_gpe = "SELECT id_groupe FROM groupes WHERE nom='".quote_smart($_SESSION['classe_en_cours'])."'";
              	$result_id_gpe = mysql_query($sql_id_gpe);
              	$ligne_id_gpe = mysql_fetch_array($result_id_gpe);
              	$val_insert_id_groupe = $ligne_id_gpe['id_groupe']; // On rcupre l'id_groupe pour l'insrer + loin dans la table cahier_textes
              }
              else
              {
              	$val_insert_id_groupe = $_SESSION['id_groupe_en_cours'];
              }
              $sql1 = "INSERT INTO cahiers_textes values(NULL,'".quote_smart($date)."','".quote_smart($_SESSION['classe_en_cours'])."','".quote_smart($val_insert_id_groupe)."','".$_SESSION['identifiant_individu']."','".quote_smart($id_matiere)."','".quote_smart($id_sous_matiere)."','".quote_smart($activite)."','".quote_smart($publication)."')";
            }
            // DEBUGG print $sql1."<br />";
          }    
          else // si la date n'est pas dfinie, on entre la date en cours
          {
            if (isset($_POST['id_ctexte']) && $_POST['id_ctexte'] != "") // c'est une modification d'une entre existante dans le cahier de textes
              $sql1 = "UPDATE cahiers_textes SET activite='".quote_smart($activite)."' WHERE id_ctexte='".quote_smart($_POST['id_ctexte'])."'";
            else // C'est une nouvelle entre dans le cahier de textes  
            {
            	if ($_SESSION['type_structure_en_cours'] == "G") // Cas d'un groupe sconet
              	{
              		$sql_id_gpe = "SELECT id_groupe FROM groupes WHERE nom='".quote_smart($_SESSION['classe_en_cours'])."'";
              		$result_id_gpe = mysql_query($sql_id_gpe);
              		$ligne_id_gpe = mysql_fetch_array($result_id_gpe);
              		$val_insert_id_groupe = $ligne_id_gpe['id_groupe']; // On rcupre l'id_groupe pour l'insrer + loin dans la table cahier_textes
              	}
              	else
              	{
              		$val_insert_id_groupe = $_SESSION['id_groupe_en_cours'];
              	}
              	$sql1 = "INSERT INTO cahiers_textes values(NULL,NOW(),'".quote_smart($_SESSION['classe_en_cours'])."','".quote_smart($_SESSION['id_groupe_en_cours'])."','".$_SESSION['identifiant_individu']."','".quote_smart($id_matiere)."','".quote_smart($id_sous_matiere)."','".quote_smart($activite)."','".quote_smart($publication)."')";
              	// DEBUGG print $sql1."<br />";
            }
          }
          // traitement de la requte
          if ($result = mysql_query($sql1))
          {
          	  if (mysql_affected_rows()>0)
          	  {
          	  	$id_ctexte = mysql_insert_id(); // on rcupre l'id de l'entre cahier de texte qui vient d'tre faite, s'il s'agit d'une nouvelle insertion
          	  	$ok_message = "Le travail fait en classe a bien t enregistr dans le cahier de textes.<br />";
          	  }
          	  
              if (isset($_POST['copy_afaire'])) // si Le contenu de sance nouvellement insr ou modifi est associ  une copie d'un travail  faire
              {
              	// il faut raliser la copie effective de ce travail
              	// on rcupre la QUERY_STRING transmise
              	$query_string = explode("&",$_POST['copy_afaire']);
              	$url_params = array();
              	foreach($query_string as $value)
              	{
              		$fragment = explode("=",$value);
              		$key = $fragment[0];
              		$key_value = $fragment[1];
              		$url_params[$key] = $key_value;
              	}
              	// C'est parti pour la copie : on rcupre d'abord les donnes
              	$sql = "SELECT afaire,publication FROM a_faire WHERE id_afaire='".quote_smart($url_params['id_afaire'])."'";
              	$resultat = mysql_query($sql);
              	$ligne = mysql_fetch_array($resultat);
              	if ($id_ctexte == 0 || !isset($id_ctexte)) // Cas o il ne s'agit pas d'une nouvelle insertion de contenu de sance (la requte INSERT INTO cahiers_textes n'a pas gnr d'autoincrment sur id_ctexte)
              		$id_ctexte = $_POST['id_ctexte']; // alors on reprend la valeur transmise par formulaire
              	$pourle = convert_date_to_mysql($url_params['pourle'],'-');
              	// requte de copie effective
              	$sql2 ="INSERT INTO a_faire values(NULL,'$id_ctexte','".quote_smart($ligne['afaire'])."','".quote_smart($pourle)."','".quote_smart($ligne['publication'])."')";
	            // DEBUGG print $sql2."<br />";
	            // avant de copier le travail  faire, on vrifie que la date de ce travail est postrieur  celui de la sance associe + jour ouvrable
              	if (strtotime($pourle) <= strtotime($date))
          		{
            		$error_message = array("La date choisie pour ce Travail  faire (".format_date_long($GLOBALS['default_language'],date_mysql_to_jjmmaaaa($pourle)).") pour le travail  faire doit tre postrieure  la date du jour (".format_date_long($GLOBALS['default_language'],date_mysql_to_jjmmaaaa($date)).")!
            		<br />Veuillez recommencer !","");
            		affiche_erreurs($error_message);
            		efface_post();
            		return;
          		}
	            // Ce doit tre aussi une date hors vacances scolaires
      		    if (!test_jour_dans_periode_scolaire($pourle))
          		{
            		$error_message = array("La date choisie pour ce Travail  faire (".format_date_long($GLOBALS['default_language'],date_mysql_to_jjmmaaaa($pourle)).") tombe pendant les vacances scolaires !
            		<br />Veuillez recommencer !","");
            		affiche_erreurs($error_message);
            		efface_post();
            		return;
          		}
		          // et dans les jours ouvrables de la semaine
          		if (!test_jour_ouvrable(date_mysql_to_jjmmaaaa($pourle)))
          		{
            		$error_message = array("Le jour choisi pour ce Travail  faire (".format_date_long($GLOBALS['default_language'],date_mysql_to_jjmmaaaa($pourle)).") n'est pas un jour ouvrable pour l'tablissement !
            		<br />Veuillez recommencer !","");
            		affiche_erreurs($error_message);
            		efface_post();
            		return;
          		}
          		// C'est bon, on excute la copie (requte d'insertion dans la table a_faire)
          		$result = mysql_query($sql2);
    	        if ($result && mysql_affected_rows()>0)
        	    {
            		// La copie dans la table a_faire est russie, il faut s'occuper des documents joints ventuels
            		// Il faut d'abord rcuprer le libell de la matire (la cration du lien symbolique vers le document se fera dans un sous-dossier matire)
            		$sql_2bis = "SELECT libelle_edition,t1.code_matiere FROM cahiers_textes as t1, matieres_sconet as t2 WHERE id_ctexte='$id_ctexte' AND t1.code_matiere=t2.code_matiere";
            		$resultat2bis = mysql_query($sql_2bis);
            		if ($resultat2bis)
            		{
            			$ligne2bis = mysql_fetch_array($resultat2bis);
            			$matiere = $ligne2bis['libelle_edition'];
            		}
            		else 
            			$matiere = ""; // vide dans le cas d'un groupe manuel
        	    	$last_id_afaire = mysql_insert_id(); // on rcupre d'abord l'id du travail  faire qui vient d'tre cr
        	    	// puis le nom de la classe ou du groupe cible pour la copie
        	    	$classe_gpe = str_replace("%20"," ",$url_params['set_classe']); // dans  l'url les espaces sont cods %20 (se retrouve dans la QUERY_STRING rcupre par POST) : on rtablit l'espace
        	    	// et les documents joints associs, que l'on copie galement            		
        	    	$info .= copy_docs("id_afaire",quote_smart($url_params['id_afaire']),$last_id_afaire,$classe_gpe,$matiere);
        	    	$info .= "<br /><a href='edt.php?categorie=professeurs&amp;edt=".$_SESSION['identifiant_individu']."&amp;typecopy=afaire&amp;id_afaire=".$url_params['id_afaire']."&amp;debut_semaine=$pourle' title=\"Retour  mon emploi du temps pour coller le mme travail  faire dans le cahier de textes d'une autre classe ou bien afficher un autre cahier de textes\">[Retour  mon emploi du temps]</a>"; // On affiche un lien de retour  l'emploi du temps, ventuellement pour un autre copie ou pour choisir un autre cahier de texte que celui en cours d'affichage
          			$ok_message .= "Le travail  faire pour le <b>".format_date_long($GLOBALS['default_language'],date_mysql_to_jjmmaaaa($pourle))."</b> a bien t copi dans le cahier de textes.<br />";
        	    	// L'enregistrement s'est correctement effectu : il faut viter les problmes de repost
      		        efface_post();
            	}
            	else // la requte n'a pas pu aboutir favorablement
            	{
	              // erreur 1062 ? (duplicate entry : on essaye d'crire la mme entre, et les cls ne le permettent paspour viter les doublons)
    	        	if (mysql_errno()=="1062") // si ce n'est pas l'erreur 1062, il faut avertir l'utilisateur
        	        	$precision = "<br />Il existe dj un travail pour cette date (<i><b>".format_date_long($GLOBALS['default_language'],date_mysql_to_jjmmaaaa($pourle))."</b></i>). 
            	    	Si vous souhaitez conserver cette date, ajouter votre nouveau travail au travail existant (recherchez dans cette page le champ <i><b>Travail  faire pour le: ".format_date_long($GLOBALS['default_language'],date_mysql_to_jjmmaaaa($pourle))."</b></i>).
                 		Dans le cas contraire, Il vous faut recommencer en cliquant sur un lien <i><b>[Ajouter autre date]</b></i>.<br />";
              		else
                		$precision = "Veuillez ressayer ultrieurement.";
              		$error_message = array("Le travail  faire n'a pu tre enregistr dans la base de donnes.<div align='justify'>$precision</div>","");
              		affiche_erreurs($error_message);
              		efface_post();
            	}
              	
              }
              elseif(isset($_POST['copy_doc'])) // si Le contenu de sance nouvellement insr ou modifi est associ  une copie d'un document joint
              {
              	// il faut raliser la copie effective de ce document
              	// on rcupre les paramtres de la QUERY_STRING transmise dans le champ cach "copy_doc"
              	$url_params = recup_url_param_from_query_string($_POST['copy_doc']);
              	// C'est parti pour la copie
              	$classe_gpe = str_replace("%20"," ",$url_params['set_classe']); // dans  l'url les espaces sont cods %20 (se retrouve dans la QUERY_STRING rcupre par POST) : on rtablit l'espace
              	// il faut indiquer que la copie du document doit tre associe  la nouvelle sance
              	if ($id_ctexte == 0 || !isset($id_ctexte)) // Cas o il ne s'agit pas d'une nouvelle insertion de contenu de sance (mais d'une tentative d'update)
              		$id_ctexte = $_POST['id_ctexte']; // alors on reprend la valeur transmise par formulaire
              	$destination = "id_ctexte=".$id_ctexte;
              	// Il nous faut la matire
              	$matiere = recup_libelle_matiere($classe_gpe,$id_ctexte); // sera vide si c'est un groupe
              	$info .= copy_docs("id_doc",quote_smart($url_params['id_doc']),$destination,$classe_gpe,$matiere);
        	    $info .= "<br /><a href='edt.php?categorie=professeurs&amp;edt=".$_SESSION['identifiant_individu']."&amp;typecopy=doc&amp;id_doc=".$url_params['id_doc']."&amp;debut_semaine=".convert_date_to_mysql($url_params['date'], "-")."' title=\"Retour  mon emploi du temps pour coller le mme travail  faire dans le cahier de textes d'une autre classe ou bien afficher un autre cahier de textes\">[Retour  mon emploi du temps]</a>"; // On affiche un lien de retour  l'emploi du temps, ventuellement pour un autre copie ou pour choisir un autre cahier de texte que celui en cours d'affichage
              }
              // On affiche maintenant le message d'opration russie
              affiche_ok($ok_message.$info);
              // L'enregistrement s'est correctement effectu : il faut viter les problmes de repost
      		  efface_post();
          }
          else // La requte $sql ne s'est pas droule correctement
          {
            // quelle en est la raison ?
            // erreur 1062 ? (duplicate entry : on essaye d'crire la mme entre, et les cls ne le permettent pas pour viter les doublons)
            if (mysql_errno()!="1062" && mysql_errno()!="0") // si ce n'est pas l'erreur 1062, il faut avertir l'utilisateur
            {
              $error_message = array("Le travail effectu en classe n'a pas pu tre enregistr dans le cahier de textes (Erreur MySQL n".mysql_errno().") Veuillez recommencer ultrieurement.","");
              affiche_erreurs($error_message);
              efface_post();
              return;
            }
            // Si c'est l'erreur 1062, inutile de prvenir l'utilisateur, on laisse courir
            // cela vite les problmes lis au rechargement de la page qui aboutirait au message d'erreur en permanence
          }
        }
        else
        {
          // en cas de nouvelle entre d'activit, celle-ci ne doit pas tre vide
    	  $error_message = array("Le champ <i><b>Travail effectu en classe</b></i> n'est pas rempli. Veuillez recommencer.","");
          affiche_erreurs($error_message);
          efface_post();
        }
        break;
  
      case 'soumettre_suppractivite': // l'utilisateur souhaite supprimer l'entre activit
        // On vrifie s'il y a un travail  faire ou des docs joints associs  cette entre de cahier de textes
  		$sql1 = "SELECT DISTINCT id_afaire FROM a_faire WHERE id_ctexte='".quote_smart($_POST['id_ctexte'])."'";
  		// DEBUGG print $sql1."<br />";
  		$sql2 = "SELECT DISTINCT id_doc FROM docs_joints_ctextes WHERE id_ctexte='".quote_smart($_POST['id_ctexte'])."'";
		  // DEBUGG print $sql2."<br />";
  		$resultat1 = mysql_query($sql1);
  		$resultat2 = mysql_query($sql2);
  		if (mysql_num_rows($resultat1)>0 || mysql_num_rows($resultat2)>0)
  		{
    		$_SESSION['suppr_id_ctexte'] = $_POST['id_ctexte']; // on sauvegarde le numro du contenu de sance  supprimer pour qu'il soit dispo pour plus tard
    		$_SESSION['suppr_id_afaire'] = array(); // contiendra les identifiants des "travaux  faire" associs qu'il faudra supprimer
    		$_SESSION['suppr_id_doc'] = array();  // contiendra les identifiants des documents joints associs au contenu de sance ou aux travaux  faire qui sont associs au contenu de sance (documents qu'il faudra supprimer)
    		if (mysql_num_rows($resultat1)>0) // il y a des travaux  faire associs
    		{
		      // On rcupre leur identifiant
     
      			while ($ligne1 = mysql_fetch_array($resultat1))
      			{
        			$_SESSION['suppr_id_afaire'][] = $ligne1['id_afaire'];
			        // Le travail  faire est peut-tre associ  un document joint
        			$sql3 = "SELECT DISTINCT id_doc FROM docs_joints_ctextes WHERE id_afaire='".$ligne1['id_afaire']."'";
        			$resultat3 = mysql_query($sql3);
        			if (mysql_num_rows($resultat3)>0)
        			{
        				while ($ligne3 = mysql_fetch_array($resultat3))
      					{
        					$_SESSION['suppr_id_doc'][] = $ligne3['id_doc'];
      					}
        			}
      			}
    		}
    		if (mysql_num_rows($resultat2)>0) // il y a des docs joints associs
    		{
		      // On rcupre leur identifiant
     
				while ($ligne2 = mysql_fetch_array($resultat2))
      			{
        			$_SESSION['suppr_id_doc'][] = $ligne2['id_doc'];
      			}
    		}
    
		    // DEBUGG var_dump($_SESSION);
    
		    // on informe l'utilisateur que la suppression de cette activit entrane la suppression des travaux  faire et des documents joints associs, et on lui demande une confirmation
		    // s'il confirme, la page est recharge et les donnes de session seront utilises lors de l'appel de la fonction supprassoc_activite()
    		$error_message = array("
    		<div align='justify'>
		    Vous tentez de supprimer une entre de cahier de textes qui contient des travaux  faire et/ou des documents attachs. Si vous continuez, ces lments associs au contenu de sance seront galement supprims (voir plus bas dans la page les lments concerns).<br />
    		</div>
    		<a href=\"".$_SERVER['PHP_SELF']."?matiere=".$_POST['id_matiere']."&amp;sous_matiere=".$_POST['id_sous_matiere']."&amp;reponse_supprassoc=oui\"
                     onclick=\"return(window.confirm('tes-vous sr de vouloir supprimer les travaux  faire ou les documents joints associs  cette entre de cahier de textes ?'));\">
                     [Continuer]
         	</a>
    		","");
    		affiche_erreurs($error_message);
    		efface_post();
  		}
  		else // pas de travaux  faire ou de docs joints associs
  		{
		    // On peut supprimer Le contenu de sance
    		$sql = "DELETE FROM cahiers_textes WHERE id_ctexte='".quote_smart($_POST['id_ctexte'])."'";
		    // DEBUGG print $sql."<br />";
    		mysql_query($sql);
    		$ok_message = "La suppression de l'entre de cahier de texte (champ <b><i>Contenu de la sance</i></b>) a russi.";
    		affiche_ok($ok_message);
  		}
  		efface_post();
  	break;

      case 'soumettre_afaire': // Le sous-formulaire 'afaire' a t soumis
    
        if ($_POST['afaire'.$num]!="" && $_POST['pourle'.$num]!="") // il faut que les champs ne soient pas vides
        { 
          $afaire = trim($_POST['afaire'.$num]);
          if (preg_match("#[a-z]#",$_POST['pourle'.$num]) == 0) // si la date fournie par le POST ne contient pas de lettre, alors le format est jj-mm-aaaa
          	$pourle = convert_date_to_mysql($_POST['pourle'.$num], $delimiter = '-'); // la date doit tre au format mysql
          else // sinon, c'est que la date est complte (ex Mercredi 20 juin 2012)
         	$pourle = date_long_fr_to_mysql($_POST['pourle'.$num]); // elle doit aussi tre au format MySQL
          // Le champ 'pourle' doit contenir une date >  la date du jour
          // DEBUGG print $pourle, $date;
          if (strtotime($pourle) <= strtotime($date))
          {
            $error_message = array("La date choisie pour ce Travail  faire (".format_date_long($GLOBALS['default_language'],date_mysql_to_jjmmaaaa($pourle)).") doit tre postrieure  la date du jour (".format_date_long($GLOBALS['default_language'],date_mysql_to_jjmmaaaa($date)).")!
            <br />Veuillez recommencer !","");
            affiche_erreurs($error_message);
            efface_post();
            break; // on sort du switch
          }
          // Ce doit tre aussi une date hors vacances scolaires
          if (!test_jour_dans_periode_scolaire($pourle))
          {
            $error_message = array("La date choisie pour ce Travail  faire (".format_date_long($GLOBALS['default_language'],date_mysql_to_jjmmaaaa($pourle)).") tombe pendant les vacances scolaires !
            <br />Veuillez recommencer !","");
            affiche_erreurs($error_message);
            efface_post();
            break; // on sort du switch
          }
          // et dans les joursouvrables de la semaine
          if (!test_jour_ouvrable(date_mysql_to_jjmmaaaa($pourle)))
          {
            $error_message = array("Le jour choisi pour ce Travail  faire (".format_date_long($GLOBALS['default_language'],date_mysql_to_jjmmaaaa($pourle)).") n'est pas un jour ouvrable pour l'tablissement !
            <br />Veuillez recommencer !","");
            affiche_erreurs($error_message);
            efface_post();
            break; // on sort du switch
          }
          // enregistrement du travail  faire
          if (isset($_POST['id_ctexte']) && $_POST['id_ctexte'] != "") // On vrifie qu'un id est transmis
          {  // s'agit-il d'une mise  jour du champ ?
            $publication = $_POST['publication_afaire'.$num];
          	if (isset($_POST['id_afaire'.$num]) && $_POST['id_afaire'.$num] != "")
              $sql2 = "UPDATE a_faire SET afaire='".quote_smart($afaire)."',pourle='".quote_smart($pourle)."', publication='".quote_smart($publication)."' WHERE id_afaire='".quote_smart($_POST['id_afaire'.$num])."'"; 
            else // Non c'est un ajout
              $sql2 ="INSERT INTO a_faire values(NULL,'".quote_smart($_POST['id_ctexte'])."','".quote_smart($afaire)."','".quote_smart($pourle)."','".quote_smart($publication)."')";
            // DEBUGG print $sql2."<br />";
            if ($result = mysql_query($sql2) && mysql_affected_rows()>=0) // affected_rows = 0 si on a fait un update qui n'a pas modifi le travail  faire (il faut quand mme excuter la suite s'il y a un document joint  copier)
            {
              $id_afaire = mysql_insert_id();
              if ($id_afaire == 0 || !isset($id_afaire)) // Cas o il ne s'agit pas d'une nouvelle insertion de contenu de sance (mais d'une tentative d'update)
              	$id_afaire = $_POST['id_afaire'.$num];
              $ok_message = "Le travail  faire pour le <b>".format_date_long($GLOBALS['default_language'],date_mysql_to_jjmmaaaa($pourle))."</b> a bien t enregistr dans le cahier de textes.";
              if(isset($_POST['copy_doc'])) // si Le travail  faire nouvellement insr ou modifi est associ  une copie d'un document joint
              {
              	$ok_message .= "<br />"; // retour  la ligne car il y aura d'autres choses  crire dans le message
              	// il faut raliser la copie effective de ce document
              	// on rcupre les paramtres de la QUERY_STRING transmise dans le champ cach "copy_doc"
              	$url_params = recup_url_param_from_query_string($_POST['copy_doc']);
              	// C'est parti pour la copie
              	$classe_gpe = str_replace("%20"," ",$url_params['set_classe']); // dans  l'url les espaces sont cods %20 (se retrouve dans la QUERY_STRING rcupre par POST) : on rtablit l'espace
              	// il faut indiquer que la copie du document doit tre associe  la nouvelle sance
              	$destination = "id_afaire=".$id_afaire;
              	// Il nous faut la matire
              	$matiere = recup_libelle_matiere($classe_gpe,$_POST['id_ctexte']); // sera vide si c'est un groupe
              	$info .= copy_docs("id_doc",quote_smart($url_params['id_doc']),$destination,$classe_gpe,$matiere);
        	    $info .= "<br /><a href='edt.php?categorie=professeurs&amp;edt=".$_SESSION['identifiant_individu']."&amp;typecopy=doc&amp;id_doc=".$url_params['id_doc']."&amp;debut_semaine=".convert_date_to_mysql($url_params['date'], "-")."' title=\"Retour  mon emploi du temps pour coller le mme travail  faire dans le cahier de textes d'une autre classe ou bien afficher un autre cahier de textes\">[Retour  mon emploi du temps]</a>"; // On affiche un lien de retour  l'emploi du temps, ventuellement pour un autre copie ou pour choisir un autre cahier de texte que celui en cours d'affichage
              }
              // On affiche maintenant le message d'opration russie
              affiche_ok($ok_message.$info);
              // L'enregistrement s'est correctement effectu : il faut viter les problmes de repost
      		  efface_post();
            }
            else // la requte n'a pas pu aboutir favorablement
            {
              // erreur 1062 ? (duplicate entry : on essaye d'crire la mme entre, et les cls ne le permettent pas pour viter les doublons)
              if (mysql_errno()=="1062") // si ce n'est pas l'erreur 1062, il faut avertir l'utilisateur
                $precision = "<br />Il existe dj un travail pour cette date (<i><b>".format_date_long($GLOBALS['default_language'],date_mysql_to_jjmmaaaa($pourle))."</b></i>). 
                Si vous souhaitez conserver cette date, ajouter votre nouveau travail au travail existant (recherchez dans cette page le champ <i><b>Travail  faire pour le: ".format_date_long($GLOBALS['default_language'],date_mysql_to_jjmmaaaa($pourle))."</b></i>).
                 Dans le cas contraire, Il vous faut recommencer en cliquant sur un lien <i><b>[Ajouter autre date]</b></i>.<br />";
              else
                $precision = "Veuillez ressayer ultrieurement.";
              $error_message = array("Le travail  faire n'a pu tre enregistr dans la base de donnes.<div align='justify'>$precision</div>","");
              affiche_erreurs($error_message);
              efface_post();
            }
          }
          else // pas d'id transmis 
          {
            $error_message = array("Vous n'avez pas encore complt le champ <b>Travail effectu en classe ! Veuillez complter ce champ avant de poursuivre.</b>","");
            affiche_erreurs($error_message);
            efface_post();
          }
        }
        else
        {
          $error_message = array("Il y a au moins un champ non complt dans la zone <i><b>Travail  faire pour le</b></i>.<br />Veuillez recommencer (en cliquant ventuellement sur un lien <i><b>[Ajouter autre date]</b></i> s'il est prsent dans le formulaire).","");
          affiche_erreurs($error_message);
          efface_post();
        }  
        break;

      case 'soumettre_docjoint': // Le sous-formulaire 'docjoint' a t soumis
      	// comme il peut y avoir plusieurs formulaire d'upload sur la page, il faut savoir lequel a t transmis fichier1, fichier2,...
  		$file_key = 'fichier'.$num;
  		if (isset($_FILES[$file_key]['name']) && $_FILES[$file_key]['name']!="") // il faut que les champs ne soient pas vides
        {  
          verif_nom_fichier($file_key); // on contrle le format du nom de fichier (60 cc max, sans espace ni accent)
          $fichier = $_FILES[$file_key]['name']; // nom de fichier au bon format
        }
        if ($_POST['commentaire'.$num]!="")
        {
          $commentaire = trim(htmlspecialchars($_POST['commentaire'.$num]));
          if (isset($_POST['id_ctexte']) && $_POST['id_ctexte'] != "") // On vrifie qu'un id est transmis
          {  
            $publication = $_POST['publication_doc'.$num]; // si la case "publi" n'est pas coche, $_POST['publication_doc'.$num] n'est pas dfini donc $publication est vide => Il faut la mettre  0
            if ($publication == "")
            	$publication = 0;
          	// s'agit-il d'une mise  jour du champ ?
            if (isset($_POST['id_doc'.$num]) && $_POST['id_doc'.$num] != "")
            {
              if (!isset($fichier)) // la mise  jour ne porte que sur le commentaire
                $sql3 = "UPDATE docs_joints_ctextes SET commentaire='".quote_smart($commentaire)."', publication='".quote_smart($publication)."' WHERE id_doc='".quote_smart($_POST['id_doc'.$num])."'"; 
            }
            else // Non c'est un ajout
            {
              // Le doc est li soit  un contenu de sance, soit  un travail  faire
              // Ce lien est transmis par POST  travers la variable id_doc_link_with$num : si celle-ci est vide, c'est que l'utilisateur a valid le formulaire de saisie depuis le sous-formulaire de saisie de contenu de sance
              // si non vide, contient la valeur afaireX o X reprsente le nom du textearea du travail  faire associ au document
              // Si un id_afaire est transmis par POST, c'est que l'utilisateur a valid depuis le sous-formulaire a_faire, dans ce cas, ne pas tenir compte de l'id_texte
              // Les champs de formulaire id_afaire peuvent tre plusieurs dans le sous-formulaire a_faire donc ils portent un n disctinctif X "id_afaireX"
              //
              $id_afaire_a_ecrire = 0; // a priori, on considre que le doc est attach  un contenu de sance
              if (isset($_POST['id_doc_link_with'.$num]) && $_POST['id_doc_link_with'.$num] != "") // ben non, il est attach  un travail  faire, on va faire le lien dans la table docs_joints_ctextes avec le travail  faire
              {
              	$num_link_afaire = $_POST['id_doc_link_with'.$num];
              	$id_afaire_a_ecrire = $_POST['id_afaire'.$num_link_afaire]; 
              }
              if ($id_afaire_a_ecrire == 0) // Si le doc est attach  un contenu de sance
              {
              	$id_ctexte_a_ecrire = $_POST['id_ctexte']; // fait le lien dans la table docs_joints_ctextes avec le contenu de sance
              }
              else // le doc est attach  un travail  faire
              {
              	$id_ctexte_a_ecrire = 0;
              }
              
              // il faut uploader le nouveau fichier
              $hash_md5 = traite_fichier($file_key); // la valeur renvoye est false en cas d'erreur, le nom du fichier sur le serveur ayant le mme contenu (hash md5) que le fichier upload, ou le hash md5 d'un nouveau document
              
              if ($hash_md5) // si pas false, contient soit le hash MD5 d'un nouveau fichier, soit le nom d'un fichier existant ayant le mme hash MD5 que le fichier upload
              {
              	if (file_exists($GLOBALS['stock_baselev']."cahiers_textes/docs/".$hash_md5)) // Ce test choue si un hash md5 est renvoy, sinon il s'agit d'un document existant physiquement sur le serveur qu'il faut joindre soit  un contenu de sance, soit  un travail  faire
              	{
              		$fichier = $hash_md5; // $hash_md5 contenait le nom du fichier existant
              		// on recalcule un vrai hash md5
              		$hash_md5 = md5_file($GLOBALS['stock_baselev']."cahiers_textes/docs/".$hash_md5);
              	}
              	else // sinon c'est le hash MD5 d'un nouveau fichier 
              	{
              		
              	}
              	// Dans tous les cas, on ajoute un enregistrement dans la table des documents joints
              	$sql3 ="INSERT INTO docs_joints_ctextes values(NULL,'".quote_smart($fichier)."','".quote_smart($commentaire)."','".quote_smart($id_ctexte_a_ecrire)."','".quote_smart($id_afaire_a_ecrire)."','".quote_smart($publication)."','$hash_md5')";
              }
              else 
              {
              	$error_message = array("Il y a eu un problme avec la hash md5 du fichier qui n'a pu tre calcul.","");
              	affiche_erreurs($error_message);
              }
            }
            // DEBUGG print $sql3;
            if ($result = mysql_query($sql3) && mysql_affected_rows()>0)
            {
              if (substr($sql3,0,6) == "INSERT")
              	$ok_message = "Le document <i><b>$fichier</i></b> a bien t enregistr dans le cahier de textes.";
              else
              	$ok_message = "Les informations associes au document <i><b>$fichier</i></b> ont bien t mis  jour.";
              affiche_ok($ok_message);
              // L'enregistrement s'est correctement effectu : il faut viter les problmes de repost
              efface_post();
            }
            else
            {
              // erreur 1062 ? (duplicate entry : on essaye d'crire la mme entre, et les cls ne le permettent paspour viter les doublons)
              if (mysql_errno()=="1062") // si ce n'est pas l'erreur 1062, il faut avertir l'utilisateur
                $precision = "<br />Il existe dj un document joint portant le mme nom. 
                 Il vous faut recommencer en cliquant sur un lien <i><b>[Ajouter un document]</b></i>.<br />";
              elseif(mysql_errno()=="0")
              	$precision = "<br />Le document existe dj dans la base de donnes et son commentaire associ n'a pas chang."; 
              else
                $precision = "<br />Erreur MySQL n".mysql_errno()."&nbsp;: ".mysql_error();
              if (substr($sql3,0,6) == "INSERT")
              	$intro = "Le document";
              else 
              	$intro = "Le commentaire ou le changement d'tat de publication";
              $error_message = array("<div align='justify'>$intro n'a pu tre enregistr dans la base de donnes.$precision</div>","");
              affiche_erreurs($error_message);
              efface_post();
            }
          }
          else // pas d'id transmis 
          {
            $error_message = array("Vous n'avez pas encore complt le champ <b>Travail effectu en classe</b> ! Veuillez complter ce champ avant de poursuivre.","");
            affiche_erreurs($error_message);
            unset($_POST);
            unset($_SESSION['post_imprimable']);
          }
        }
        else
        {
          $error_message = array("Il y a au moins un champ non complt dans la zone <i><b>Document joint</b></i>.<br />Veuillez recommencer (en cliquant ventuellement sur un lien <i><b>[Ajouter un document]</b></i> s'il est prsent dans le formulaire).","");
          affiche_erreurs($error_message);
          unset($_POST);
          unset($_SESSION['post_imprimable']);
        }  
        break;
    }
  }
  }
    
    /** Affichage du cahier de textes proprement dit (mode formulaire) **/
  
   // DEBUGG var_dump($_SESSION);
    if ($_SESSION['type_structure_en_cours'] == "D" && (!isset($_SESSION['liste_matieres']) || count($_SESSION['liste_matieres'])==0)) // si c'est une classe, pas un groupe, et que les matires sont introuvables, c'est que l'quipe pdagogique de la classe n'est pas encore renseigne
    {
      $error_message = array("<div align='justify'>L'quipe pdagogique de <b>".$_SESSION['classe_en_cours']."</b> n'a pas encore t renseigne. L'accs au cahier de texte de la classe n'est pas possible pour le moment.</div>","");
      affiche_erreurs($error_message);
      return;
    }
    $code_sous_matiere = ""; //initialisation d'une variable qui servira  indiquer la sous-matire en cours (si la matire en cours est une matire  sous-matires comme l'histoire-go par ex)
    $id_sous_matiere = 0; // on part  du principe que la matire n'a pas de sous_matire
    // on rcupre les valeurs sauvegardes au moment du unset($_POST)
    if (isset($sauve_id_matiere))
    {
      $_POST['id_matiere'] = $sauve_id_matiere;
      $_POST['id_sous_matiere'] = $sauve_id_sous_matiere;
    }
    /***********************************  DEBUT DE FORMULAIRE ***********************************/
    
    /* On s'occupera de l'en-tte du formulaire avec son titre + tard, pour le moment on prpare les donnes  afficher
     * pour le bandeau matire  => CHOIX DE LA MATIERE A AFFICHER et du mode saisie ou consultation */
    
    $code_formulaire = "";
    if ($_SESSION['type_structure_en_cours'] == "D") // Si c'est une vraie classe (division)
    {
      $code_formulaire .= "<div class='titre_cadre_formulaire' id='bandeau_nav_matiere_ctxt'>";
      // On affiche la matire en cours pour la classe
      if (isset($_GET['matiere']) && $_GET['matiere']!="") // Si la matire est passe dans l'url (clic sur un lien matire dans le sommaire)
      {
        if ($_SESSION['valid_group'] == "11" && ($_GET['matiere']!=$_SESSION['ipr_choix_matiere'])) // si c'est un IPR qui tente d'accder  une autre discipline que celle qu'il inspecte (par les liens du sommaire de gauche), c'est refus
        {
          // Cette section est  retirer si on souhaite donner accs aux IPR  l'ensemble des matires de la classe ce qui est le cas pour les chaiers de textes papier (mais je ne vois pas ce que cela apporte  l'ipr)
          $error_message = array("<div align='justify'>Vous n'avez pas accs aux autres disciplines que celles que vous inspectez. Si vous souhaitez changer de classe, cliquez sur l'icne <a href='".$_SERVER['PHP_SELF']."?unset_classe=oui&amp;imprimable=non'><img src='".$GLOBALS['chemin_relatif']."images/group.png' border='0' align='middle' title='Choisir une autre classe ou un autre groupe' alt='Autre classe' /></a></div>","");
          affiche_erreurs($error_message);
          return;
        }
        $i = $_GET['matiere']; // l'id_matiere est rcupr sous forme d'indice (pour le tableau $_SESSION['liste_matieres'])
        $mode = cherche_mode($i,$force_consultation); // va dterminer si on est en saisie ou en consultation
        $id_matiere = $i; // il est aussi rcupr pour tre retransmis par le formulaire de saisie
        $code_formulaire .= affiche_bandeau_matiere_en_cours($i);
        $_SESSION['code_matiere_en_cours'] = $i; // on mmorise pour les autres script (c_synthese_ctextes.php) la matire en cours de consultation
      }
      elseif (isset($_POST['id_matiere']) && $_POST['id_matiere']!="") // Si la matire est passe par champ hidden du formulaire de saisie
      {
        // Cette partie ne s'xcutait pas  cause des nombreux unset($_POST) que j'ai d mettre dans le code
        // mais grce  la fonction efface_post() on peut rcuprer qq valeurs sauvegardes
        $i = $_POST['id_matiere']; // l'id_matiere est rcupr sous forme d'indice (pour le tableau $_SESSION['liste_matieres'])
        $mode = cherche_mode($i,$force_consultation); // va dterminer si on est en saisie ou en consultation
        $id_matiere = $i; // il est aussi rcupr pour tre retransmis par le formulaire de saisie
       	$code_formulaire .= affiche_bandeau_matiere_en_cours($i);
       	$_SESSION['code_matiere_en_cours'] = $i; // on mmorise pour les autres script (c_synthese_ctextes.php) la matire en cours de consultation
      }
      else // sinon, il faut choisir par dfaut une matire
      {
        // Si c'est un prof, la (ou les) matire(s) qu'il enseigne dans la classe
        if ($_SESSION['valid_group']=='3')
        {
          // S'il enseigne plusieurs matires (ex : Aide au Travail Personnel, Mathmatiques...), on slectionnera par dfaut la matire
          // ayant l'horaire le plus lev
          $sql = "SELECT code_structure,code_matiere,SUM(heure) as total  FROM services as t1,enseignants_services as t2 WHERE id_individu='".$_SESSION['identifiant_individu']."'
          AND code_structure='".quote_smart($_SESSION['classe_en_cours'])."' AND t1.id_service=t2.id_service GROUP BY code_matiere ORDER BY total DESC";
          //$sql = "SELECT t1.code_matiere FROM services as t1,enseignants_services as t2,matieres_sconet as t3  WHERE id_individu='".$_SESSION['identifiant_individu']."' AND code_structure='".quote_smart($_SESSION['classe_en_cours'])."' AND t1.id_service=t2.id_service AND t1.code_matiere=t3.code_matiere ORDER BY t3.libelle_edition";
          // DEBUGG print $sql."<br />";
          $resultat = mysql_query($sql);
          $matieres_ens = array(); // initialisation d'un tableau qui contiendra les matires enseignes par le prof dans cette classe
          while ($ligne = mysql_fetch_array($resultat)) 
          { 
            $matieres_ens[] = $ligne['code_matiere'];
          }
          // DEBUGG print "Codes des Matires enseignes : "; var_dump($matieres_ens)."<br />";
          // c'est la premire matire (s'il y en a plusieurs) qui sera celle affiche par dfaut
          $i = $matieres_ens[0]; // on rcupre son identifiant (code_matiere)
          if ($i == "") // Si la matire enseigne par le prof est introuvable => On pointe par dfaut sur la premire. Par exemple, c'est le cas pour un enseignant documentaliste (le mode sera alors en consultation seule)
          {  
            reset($_SESSION['liste_matieres']);
            $i = key($_SESSION['liste_matieres']); 
          }
          else
         {
          	$_SESSION['code_matiere_principale_enseignee'] = $i; // Le code de la matire principale enseigne est enregistr (sera rutilis par exemple dans c_synthese_ctextes.php pour afficher la matire par dfaut dans le formulaire)
          	// DEBUGG print "code_matiere_principale_enseignee = ".$_SESSION['code_matiere_principale_enseignee']."<br />";
          }
          $mode = cherche_mode($i,$force_consultation); // Le cahier de textes sera affich en mode saisie pour cette discipline
        }
        elseif ($_SESSION['valid_group']=='11') // Si c'est un IPR, la matire qu'il inspecte dans la classe
        {
          $i = $_SESSION['ipr_choix_matiere']; // on rcupre son identifiant (code_matiere)  
          // et on la stocke dans une variable de session propre  l'IPR pour pouvoir contrler les changements de matire au sein du cahier de textes (qui ne sont pas autoriss pour les IPR)
          $_SESSION['ipr_choix_matiere'] = $i; 
        } 
        else // Si c'est un autre type d'utilisateur, la matire affiche par dfaut est la premire (ordre alphabtique) 
        {
          reset($_SESSION['liste_matieres']);
          $i = key($_SESSION['liste_matieres']);// l'id_matiere est rcupr sous forme d'indice (pour le tableau $_SESSION['liste_matieres'])          
        }
        // Le choix de la matire  afficher par dfaut est fait !
        $id_matiere = $i; // l'id matire est aussi rcupr pour tre retransmis par le formulaire de saisie
        $code_formulaire .= affiche_bandeau_matiere_en_cours($i);
        $_SESSION['code_matiere_en_cours'] = $i; // on mmorise pour les autres script (c_synthese_ctextes.php) la matire en cours de consultation
      }
      $code_formulaire .="</div>";
    } // fin d'affichage de la matire en cours (si c'est une vraie classe, pas un groupe)
    elseif ($_SESSION['type_structure_en_cours'] == "GM" || ($_SESSION['type_structure_en_cours'] == "D" && isset($_GET['id_gpe']) && $_GET['id_gpe'] != "")) // comme c'est un groupe (cr manuellement ici), pas de matires  chercher, mais seulement le mode saisie ou consultation
    {
      if ($_SESSION['valid_group'] == 3) // Cas d'un prof connect
      {
      	// Pour le savoir, il suffit de rechercher si la personne connecte est le responsable du groupe
      	$sql = "SELECT id_responsable FROM groupes WHERE nom='".$_SESSION['classe_en_cours']."'";
      	$resultat = mysql_query($sql);
      	$ligne = mysql_fetch_array($resultat);
      	if ($_SESSION['valid_id_user'] == $ligne['id_responsable'] && $force_consultation === false) // on cherche si la personne connecte est celle qui a cr le groupe
      		$mode = "saisie";
      	else
      		$mode = "consultation";
      
      }
      else // la personne connecte n'est pas un prof
      {
      	$mode = "consultation";
      }
    }
    elseif ($_SESSION['type_structure_en_cours'] == "G" || ($_SESSION['type_structure_en_cours'] == "D" && isset($_GET['id_gpe']) && $_GET['id_gpe'] != "")) // comme c'est un groupe sconet, il faut trouver la matire associe et le mode saisie ou consultation
    {
    	$code_formulaire .= "<div class='titre_cadre_formulaire' id='bandeau_nav_matiere_ctxt'>";
    	if (isset($_GET['matiere']) && $_GET['matiere']!="") // Si la matire est passe dans l'url (clic sur un lien matire dans le sommaire)
      	{
      		$i = $_GET['matiere']; // l'id_matiere est rcupr sous forme d'indice (pour le tableau $_SESSION['liste_matieres'])
        	$mode = cherche_mode($i,$force_consultation); // va dterminer si on est en saisie ou en consultation
        	$id_matiere = $i; // il est aussi rcupr pour tre retransmis par le formulaire de saisie
      	}
    	elseif ($_SESSION['valid_group'] == 3) // matire non passe dans l'URL (donc non connue) mais c'est un prof connect
      	{
	      	// Alors il faut juste savoir si le prof a un service qui concerne ce groupe, et pour quelle matire
	      	$sql = "SELECT t2.id_service, code_matiere FROM enseignants_services as t1, services as t2 WHERE id_individu='".$_SESSION['identifiant_individu']."' AND t1.id_service=t2.id_service AND code_structure='".$_SESSION['classe_en_cours']."'"; 
	      	$resultat = mysql_query($sql);
	      	if (mysql_num_rows($resultat) > 0)
	      	{
	      		$ligne = mysql_fetch_array($resultat);
	      		$i = $ligne['code_matiere'];
	      		$id_matiere = $i;
	      		if ($force_consultation === false)
	      			$mode = "saisie";
	      		else 
	      			$mode = "consultation";
	      	}
	      	else // le prof n'a pas ce groupe en classe : il n'a pas accs au cahier de texte
	      	{
	      		$error_message = array("Vous n'avez pas accs au cahier de texte du groupe ".$_SESSION['classe_en_cours']." !<br />Veuillez <a href='".$_SERVER['PHP_SELF']."?unset_classe=oui'>choisir une autre classe/un autre groupe</a>.","");
	      		affiche_erreurs($error_message);
	      		return;
	      	}
    	}
    	else // matire non passe dans l'URL (donc non connue) mais ce n'est pas un prof qui est connect
    	{
    		$mode = "consultation";
    		// On point sur la premire matire enseigne dans le groupe
    		reset($_SESSION['liste_matieres']);
          	$i = key($_SESSION['liste_matieres']);
          	// Le choix de la matire  afficher par dfaut est fait !
        	$id_matiere = $i; // l'id matire est aussi rcupr pour tre retransmis par le formulaire de saisie
    	}
    	$code_formulaire .= affiche_bandeau_matiere_en_cours($i);
    	$_SESSION['code_matiere_en_cours'] = $i; // on mmorise pour les autres script (c_synthese_ctextes.php) la matire en cours de consultation
    	
    	$code_formulaire .="</div><br />";
     
    }
    
    ////// ****** Interruption dans le contenu de corps_formulaire pour permettre la rcupration ventuelle de $id_gpe_lien_prev_next
    ///// dont on va avoir besoin pour les liens cours prcdent et cours suivant
    
    // ------------------- Le titre du formulaire  afficher ----------------------- 
    
    // Le titre du formulaire de cahier de textes est un tableau  trois colonnes dont le contenu dpend du mode saisie ou consultation
    // et du groupe de l'utilisateur connect
    $titre_formulaire = "
    <table width='100%'>
      <tr style='margin:0'>
        <td width='10%'>
    ";
    // solution de l'anomalie #90 : le mode saisie autoris sur une matire, l'est automatiquement sur tous les groupes concernant cette matire
    // ce qui donne accs en criture  tous les groupes de la mtire alors que le prof connect n'est responsable que d'un seul
    // il faut donc vrifier le mode en cas d'accs au cahier de texte d'un groupe
    if ($_GET['id_gpe'] != "")
    {
    	// On vrifie donc que le groupe en cours est bien un groupe en responsabilit du prof : on recherche les profs responsables du groupe en cours
    	$sql = "SELECT id_individu from enseignants_services as t1,services as t2 WHERE t2.code_structure='" . quote_smart($_GET['id_gpe']) . "' AND t1.id_service=t2.id_service";
    	// DEBUGG print $sql;
    	$resultat = mysql_query($sql);
    	if ($resultat && mysql_num_rows($resultat) >= 1)
    	{
    		while ($ligne = mysql_fetch_array($resultat))
    		{
    			$liste_responsables_groupe[] = $ligne['id_individu'];
    		}
    		if (in_array($_SESSION['identifiant_individu'],$liste_responsables_groupe)) // OK, le prof connect a le droit d'crire
    		{
    			$mode = "saisie";
    		}
    		else // le prof connect ne fait pas partie de la liste des profs ayant le groupe en responsabilit
    			$mode = "consultation";
    	}
    	else // Pas de rsultat : le mode repasse en consultation
    		$mode = "consultation";
    }
    if ($mode == "saisie")
    {
      $titre_formulaire .= "<img src='".$GLOBALS['chemin_relatif']."images/kwrite.png' align='middle' border='0' title='Vous tes en mode saisie' alt='Mode saisie' />";
    }
    else
    {
      $titre_formulaire .= "<img src='".$GLOBALS['chemin_relatif']."images/loupe.png' align='middle' border='0' title='Vous tes en mode consultation' alt='Mode consultation' />";
    }
    $titre_formulaire .= "
    </td>
    <td width='80%' align='center'>
    <h2 id='title_ctxt'>";
    // Si c'est un groupe
    if ($_SESSION['type_structure_en_cours'] == "G" || $_SESSION['type_structure_en_cours'] == "GM" )
    {
       $titre_formulaire .= "Groupe".traite_longueur_titre_ctextes($_SESSION['classe_en_cours']);
    }
    elseif (!isset($_GET['id_gpe'])) // si c'est une vraie classe et qu'aucun id_gpe ne figure dans l'url
    {
		// Mais si la matire  afficher n'est pas enseigne en classe entire (ex : groupe de langue)
		// alors il faudra afficher le cahier de textes du groupe (si unique) ou bien donner le choix du groupe (si plusieurs)
		
    	// Les groupes recherchs sont les groupes sconet pas les groupes manuels
    	
    	if ($_SESSION['valid_group'] == 2) // cas d'un lve connect
    		$sql="SELECT t2.code_structure FROM groupes as t1,structures as t2, services as t3, groupes_eleves as t4 WHERE t3.code_structure=t2.code_structure AND t1.nom=t2.code_structure AND t3.code_matiere='$id_matiere' AND id_responsable=0 AND t4.eleve_id='".$_SESSION['identifiant_individu']."' AND t4.id_groupe=t1.id_groupe";
    	elseif ($_SESSION['valid_group'] == 4) // cas d'un parent connect
    		$sql="SELECT t2.code_structure FROM groupes as t1,structures as t2, services as t3, groupes_eleves as t4 WHERE t3.code_structure=t2.code_structure AND t1.nom=t2.code_structure AND t3.code_matiere='$id_matiere' AND id_responsable=0 AND t4.eleve_id='".$_SESSION['ctextes_enfant_id']."' AND t4.id_groupe=t1.id_groupe";
    	else // Autre cas : on cherche la liste des groupes sconet o cette matire est enseigne (la classe en cours ne sera pas concerne pour chaque groupe)
			$sql = "SELECT t2.code_structure FROM services as t1,structures as t2 WHERE code_matiere='$id_matiere' AND t1.code_structure= t2.code_structure AND t2.type_structure='G'";
		// DEBUGG print $sql."<br />"; 
		$resultat = mysql_query($sql);
		if (mysql_num_rows($resultat) == 1) // il n'y a qu'un seul rsultat => pas de choix possible
		{
			unset($_SESSION['assoc_matiere_groupe']);
			$ligne = mysql_fetch_array($resultat);
			$titre_formulaire .= "Groupe".traite_longueur_titre_ctextes($ligne['code_structure']);
			$id_gpe_lien_prev_next = $ligne['code_structure']; // On rcupre l'identifiant du groupe pour l'insrer + tard dans les liens cours prcdent et cours suivant
			$_SESSION['assoc_matiere_groupe'][$id_matiere][] = $id_gpe_lien_prev_next; // on associe le code_matiere avec l'identifiant du groupe pour rcuprer ce dernier  partir du code_matiere snas devoir refaire la requte qui vient d'tre faite
			// on en aura besoin pour la fonction trouve_date_cours()
			$_SESSION['id_groupe_en_cours'] = $ligne['code_structure'];
		}
		elseif (mysql_num_rows($resultat) > 1) // Il y a plus d'un rsultat, on va donner le choix si cela concerne la classe en cours
		{
			$liste_groupes_a_choisir = array();
			unset($_SESSION['assoc_matiere_groupe']);
			while ($ligne=mysql_fetch_array($resultat))
			{
				// on vite le cas chant une erreur sur le test in_array qui suit
				if (!isset($_SESSION['liste_groupes']))
					$_SESSION['liste_groupes'] = cherche_classe_dans_groupes($_SESSION['classe_en_cours']);
				// Il faut ensuite retenir uniquement les groupes qui concernent la classe en cours
				if (in_array($ligne['code_structure'], $_SESSION['liste_groupes']))
				{
					$liste_groupes_a_choisir[] = $ligne['code_structure'];
					$id_gpe_lien_prev_next = $ligne['code_structure'];
					$_SESSION['assoc_matiere_groupe'][$id_matiere][] = $id_gpe_lien_prev_next; // retient l'association entre la matire et le ou les groupes correspondants
				}
			}
			if (isset($_SESSION['assoc_matiere_groupe'][$id_matiere]))
				$_SESSION['assoc_matiere_groupe'][$id_matiere] = array_unique($_SESSION['assoc_matiere_groupe'][$id_matiere]); // limination des doublons ventuels
			if (count($liste_groupes_a_choisir) == 1) // S'il n'y qu'un groupe
			{
				$titre_formulaire .= "Groupe".traite_longueur_titre_ctextes($liste_groupes_a_choisir[0]);
				$id_gpe_lien_prev_next = $liste_groupes_a_choisir[0];
				$_SESSION['id_groupe_en_cours'] = $liste_groupes_a_choisir[0];
			}
			elseif (count($liste_groupes_a_choisir) > 1) // plusieurs groupes : on donne le choix
			{
				if (isset($_GET['id_ctexte']) && $_GET['id_ctexte'] != "")
				{
					// Si l'id_ctexte est dfini dans l'url le groupe  afficher sera retrouv  partir de l'id_ctexte et on ne donne plus le choix
					// Ceci permet par exemple d'viter l'affichage du message de choix d'un groupe  partir de la consultation
					// d'une entre de cahier de texte correspondant  un groupe suite  la consultation via le script c_synthsese_ctextes.php (via le lien [Consulter])
					$sql_id_ctexte = "SELECT code_structure FROM cahiers_textes WHERE id_ctextes='".quote_smart($_GET['id_ctexte'])."'";
					$result_id_ctexte = mysql_query($sql_id_ctexte);
					$ligne_id_ctexte = mysql_fetch_array($result_id_ctexte);
					$titre_formulaire .= "Groupe".traite_longueur_titre_ctextes($ligne_id_ctexte['code_structure']);
					$id_gpe_lien_prev_next = $ligne_id_ctexte['code_structure'];
					$_SESSION['id_groupe_en_cours'] = $ligne_id_ctexte['code_structure'];
				}
				else
				{
					$listing_gpes = "";
					reset($liste_groupes_a_choisir);
      				while($value = current($liste_groupes_a_choisir))
      				{	
        				// Avant d'afficher les liens vers les choix possibles, on prcise le prof qui a le groupe en responsabilit
        				$sql2 = "SELECT civilite,nom,prenom from personnel as t1,services as t2,enseignants_services as t3 WHERE t2.code_structure='$value' AND t2.id_service=t3.id_service AND t3.id_individu=t1.id_individu";
        				// DEBUGG print $sql2 . "<br />";
        				$resultat2 = mysql_query($sql2);
        				$profs = array(); // la rinitialisation vite la concatnation  chauqe tour de boucle while
        				while ($ligne2 = mysql_fetch_array($resultat2)) // en cas de co-enseignement sur le groupe ?
        				{
      						if ($_SESSION['valid_group'] == 2 || $_SESSION['valid_group'] == 4) // cas d'un lve ou d'un parent connect
      							$profs[] = $ligne2['civilite'] . " " . $ligne2['nom']; 
      						else // autre cas
      							$profs[] = $ligne2['civilite'] . " " . $ligne2['prenom'] . " " . $ligne2['nom'];
        				}
        				$liste_profs = ""; // la rinitialisation vite la concatnation  chauqe tour de boucle while
        				$prof = "";
      					foreach ($profs as $prof)
        				{
        					$liste_profs .= $prof . ",";
        				}
        				$liste_profs = rtrim($liste_profs,","); // on retire la virgule terminale
      					$listing_gpes .= "- <a href='?".$_SERVER['QUERY_STRING']."&amp;id_gpe=".$_SESSION['assoc_matiere_groupe'][$id_matiere][key($liste_groupes_a_choisir)]."'>$value ($liste_profs)</a><br />";
        				next($liste_groupes_a_choisir);
      				}
					$error_message = array("<div align='justify'>La matire <strong><font color='black'>".$_SESSION['liste_matieres'][$i]."</font></strong> pour cette classe est rpartie en plusieurs groupes, cliquez sur le groupe pour lequel vous voulez consulter le cahier de texte :<br />$listing_gpes<br /></div>","");
      				affiche_erreurs($error_message);
      				return; // l'affichage du script s'arrte l...
				}
			}
			else // Les groupes trouvs ne concernent pas cette classe : la matire est donc enseigne en classe entire
			{
				$titre_formulaire .= "Classe de ".$_SESSION['classe_en_cours'];
			}
		}
		else // pas de rsultat, cette matire est enseigne en classe entire
		{
			$titre_formulaire .= "Classe de ".$_SESSION['classe_en_cours'];
		}
    }
    elseif (isset($_GET['id_gpe'])) // appel avec un id_gpe dans l'url
    {
    	if($_GET['id_gpe'] == "")
    		$titre_formulaire .= "Classe de ".$_SESSION['classe_en_cours'];
    	else
    		$titre_formulaire .= "Groupe".traite_longueur_titre_ctextes($_GET['id_gpe']);
    	$_SESSION['id_groupe_en_cours'] = $_GET['id_gpe'];
    	$id_gpe_lien_prev_next = $_GET['id_gpe'];   	
    }
    // On affiche la date de consultation/saisie au format long ( retransmettre par champ cach)
    $date_long = format_date_long($GLOBALS['default_language'],date_mysql_to_jjmmaaaa($date));
    $debut_semaine = debut_semaine($date);
    $semaine = quelle_semaine_alternance($debut_semaine); // on rcupre le n de quinzaine
    // On affiche un bouton de contrle permettant de changer la classe en cours pour les utilisateurs autoriss  visualiser plusieurs classes
    // Ce bouton de contrle fait obligatoirement repasser par le format non imprimable (variable imprimable=non dans l'url), car seul ce format (avec l'affichage du sommaire de cahier de textes, somcahiers_textes.php), permet de connatre les disciplines enseignes dans la classe et d'afficher correctement le cahier de textes de la classe choisie, avec le mode (saisie ou consultation) appropri
    $titre_formulaire .= complement_titre()."</h2>
    </td>
    <td width='10%' align='right'>
    ";
    if ($_SESSION['valid_group'] != '2') // c'est-dire parmi les utilisateurs autoriss  voir les cahiers de textes, mais pas les lves
      $titre_formulaire .= "<img src='".$GLOBALS['chemin_relatif']."images/pixel.gif' width='15' alt='' /><a href='".$_SERVER['PHP_SELF']."?unset_classe=oui&amp;imprimable=non'><img src='".$GLOBALS['chemin_relatif']."images/group.png' border='0' align='middle' title='Choisir une autre classe ou un autre groupe' alt='Autre classe' /></a>";
    elseif ($_SESSION['valid_group'] == '2' && count($liste_groupes)!=0) // Si l'utilisateur est un lve faisant partie au moins d'un groupe
      $titre_formulaire .= "<img src='".$GLOBALS['chemin_relatif']."images/pixel.gif' width='15' alt='' /><a href='".$_SERVER['PHP_SELF']."?unset_classe=oui&amp;imprimable=non'><img src='".$GLOBALS['chemin_relatif']."images/group.png' border='0' align='middle' title='Choisir une autre classe ou un autre groupe' alt='Autre classe' /></a>";  
    else
      $titre_formulaire .= "&nbsp;";
    $titre_formulaire .= "
    </td>
    </tr>
    </table>";
    
    // ---------------------- Fin du titre --------------------------
    
    /////****** Reprise du contenu de corps_formulaire : la variable $id_gpe_lien_prev_next est disponible pour les liens cours prcdent et cours suivant
    // Elle ne contient rien si la classe en cours est :
    // - une classe entire avec une matire en cours enseigne en classe entire
    // - un groupe cr manuellement
    // Elle contient l'identifiant du groupe  :
    // - si la classe en cours est une classe entire MAIS que la matire en cours est enseigne en groupe
    
    $code_formulaire .="
    <div class='titre_cadre_formulaire' align='left' id='bandeau_nav_datecours_ctx'>
      <table width='100%' border='0'>";
          // On affiche le champ de formulaire de changement de date
          $date_a_remplacer = date_mysql_to_jjmmaaaa_tiret($date);
          $param_url = str_replace("&","&amp;",$_SERVER['QUERY_STRING']);
          $url_sans_date = $_SERVER['PHP_SELF']."?".preg_replace("#&date=$date_a_remplacer#","",$param_url)."&amp;date=";
          $code_formulaire .= "
        <tr>
        	<td width='33%'>
        		<a href='?cours=prev&amp;id_gpe=$id_gpe_lien_prev_next&amp;dateref=$date&amp;matiere=$id_matiere&amp;sous_matiere=$id_sous_matiere'><img src='".$GLOBALS['chemin_relatif']."images/previous.png' alt='[Cours prcdent]' title='Cours prcdent' /></a>
        	</td>
        	<td width='33%' align='center'>
          		<label for='choix_date_seance' class='hidden'>Choisir une autre date&nbsp;:</label>
          		<input id='choix_date_seance' type='text' class='datepicker' name='date' title='Cliquez sur le calendrier pour changer la date' style='margin: 0;' onchange='window.location.replace(\"$url_sans_date\"+this.value)' value='$date_long' />
          		(semaine $semaine)
          	</td>
          	<td width='33%'>
          		<a href='?cours=next&amp;id_gpe=$id_gpe_lien_prev_next&amp;dateref=$date&amp;matiere=$id_matiere&amp;sous_matiere=$id_sous_matiere'><img src='".$GLOBALS['chemin_relatif']."images/next.png' alt='[Cours suivant]' title='Cours suivant' /></a>
          	</td>";
          $code_formulaire .= "
        </tr>
      </table>
    </div>";
          
      /************************** TRAVAUX EFFECTUES EN CLASSE  ET RAPPEL DES TRAVAUX DONNES POUR CE JOUR *****************************/
      
        if ($mode != "saisie") // si le mode est en consultation, on ne recherche que les entres publies
        	$where_add = "AND t1.publication='1'";
        else 
        	$where_add = "";
        // On rcupre les donnes de la base de donnes
        if ($_SESSION['type_structure_en_cours'] == "D" || $_SESSION['type_structure_en_cours'] == "G") // Si c'est une classe ou un groupe sconet
    	{
          	if(isset($_SESSION['id_groupe_en_cours']) && $_SESSION['id_groupe_en_cours'] != "")
          		$code_structure = $_SESSION['id_groupe_en_cours'];
          	else
          		$code_structure = $_SESSION['classe_en_cours'];
          	if (isset($_GET['id_gpe']) && $_GET['id_gpe'] != "" && $_GET['matiere'] == "")
          		$i = ""; // Dans ce cas puisque c'est un groupe manuel (les groupes sconet eux correspondent  une matire) demand dansl'URL,pas de matire
    		$sql = "SELECT id_ctexte,activite,publication FROM cahiers_textes as t1 WHERE date='".quote_smart($date)."' AND code_structure='$code_structure' AND code_matiere='".quote_smart($i)."' AND id_sous_matiere='".quote_smart($id_sous_matiere)."'".$where_add;
    		$sql2 = "SELECT afaire,t1.id_ctexte FROM a_faire as t1,cahiers_textes as t2 WHERE pourle='".quote_smart($date)."' AND t1.id_ctexte=t2.id_ctexte AND code_structure='$code_structure' AND code_matiere='".quote_smart($i)."' AND id_sous_matiere='".quote_smart($id_sous_matiere)."'".$where_add;
        	// DEBUGG print "<hr />Contenu de sance : ".$sql."<br />Travail  faire pour ce jour : $sql2<hr />";
    	}
        elseif (($_SESSION['type_structure_en_cours'] == "GM")) // Si c'est un groupe manuel
        {
          $sql = "SELECT id_ctexte,activite,publication FROM cahiers_textes as t1 WHERE date='".quote_smart($date)."' AND id_groupe='".quote_smart($_SESSION['id_groupe_en_cours'])."'".$where_add;
          $sql2 = "SELECT afaire,t1.id_ctexte FROM a_faire as t1,cahiers_textes as t2 WHERE pourle='".quote_smart($date)."' AND t1.id_ctexte=t2.id_ctexte AND id_groupe='".quote_smart($_SESSION['id_groupe_en_cours'])."'".$where_add;
        }
       // DEBUGG print "<hr />Contenu de sance : ".$sql."<br />Travail  faire pour ce jour : $sql2<hr />";
        $resultat=mysql_query($sql);
        if (mysql_num_rows($resultat)>0) // Si la requte abouti, c'est que le cahier de textes a dj t rempli
        {
          // Si le prof a voulu copier un contenu de sance dans une entre dj existante, on affiche un message d'avertissement (pas d'crasement automatique de l'entre existante)
          if (isset($_GET['typecopy']) && $_GET['typecopy'] == "activite")
          {
          	$error_message = array("Vous tentez de copier une sance sur une entre dj existante ! Si vous maintenez votre choix, il faut d'abord supprimer l'entre existante en cliquant sur le bouton <i>Supprimer</i> dans le contenu de sance <b>(Attention : les documents joints et les travaux lis  l'entre supprime -&nbsp;s'il y en a&nbsp;- seront galement effacs)</b>. Ensuite, il faudra recommencer la copie  partir de la sance d'origine.","");
          	affiche_erreurs($error_message);
          }
          // Alors on affiche les valeurs de la base de donnes
          $variable = mysql_fetch_array($resultat);
          $activite = htmlspecialchars($variable['activite']); // comme c'est rcupr dans un textarea, il ne faut pas de balise html
          // En vue de permettre une modif des donnes existantes, on a besoin de l'id
          // qu'on va transmettre avec le formulaire
          $id_ctexte = $variable['id_ctexte']; // le lien entre les 3 tables du cahier de textes
          $publication = $variable['publication'];
        }
        else // Le cahier de textes n'a pas d'entre correspondante  la date, la classe et la matire
        {
          // On peut entrer ici parce que l'on copie une sance, un travail  faire ou un document d'une autre classe
          if (isset($_GET['typecopy']))
          {
          	if ($_GET['typecopy'] == "activite") // c'est une copie de sance
          	{
          		// avec l'id_ctexte transmis dans l'URL, on va retrouver le contenu de la sance  copier (et le libell Edition de la matire)
          		$sql3 = "SELECT t1.*,t2.libelle_edition FROM cahiers_textes as t1,matieres_sconet as t2 WHERE id_ctexte='".quote_smart($_GET['id_ctexte'])."' AND t1.code_matiere=t2.code_matiere";
          		$result3 = mysql_query($sql3);
          		if (mysql_num_rows($result3)>0) // Il y aura des rsultats si c'est une copie de sance d'un cahier de textes d'une classe ou d'un groupe sconet
        		{
        			$id_ctexte = copy_activite($result3); // On rcupre l'id de la sance nouvellement cre pour rcuprer le contenu pour affichage
        			// On rcrit les requte SQL pour afficher le contenu de la sance
        			$sql = "SELECT id_ctexte,activite,publication FROM cahiers_textes as t1 WHERE id_ctexte='$id_ctexte' ".$where_add;
        			// et le travail  faire pour ce jour
    				$sql2 = "SELECT afaire,t1.id_ctexte FROM a_faire as t1,cahiers_textes as t2 WHERE pourle='".quote_smart($date)."' AND t1.id_ctexte=t2.id_ctexte AND code_structure='$code_structure' AND code_matiere='".quote_smart($i)."' AND id_sous_matiere='".quote_smart($id_sous_matiere)."'".$where_add;
        		}
        		else // C'est peut-tre un contenu de sance de groupe manuel (groupe cr manuellement : dans ce cas le code_matiere n'est pas renseign dans la table cahiers_textes), on recommence avec une requte approprie
        		{
        			$sql3 = "SELECT * FROM cahiers_textes WHERE id_ctexte='".quote_smart($_GET['id_ctexte'])."'";
          			$result3 = mysql_query($sql3);
          			if (mysql_num_rows($result3)>0)
          			{
          				$id_ctexte = copy_activite($result3);// On rcupre l'id de la sance nouvellement cre pour rcuprer le contenu pour affichage
          				// On rcrit les requte SQL pour afficher le contenu de la sance
        				$sql = "SELECT id_ctexte,activite,publication FROM cahiers_textes as t1 WHERE id_ctexte='$id_ctexte' ".$where_add;
        				// Puis le travail  faire pour ce jour
        				if ($_SESSION['id_groupe_en_cours'] && $_SESSION['id_groupe_en_cours'] != "")
    						$sql2 = "SELECT afaire,t1.id_ctexte FROM a_faire as t1,cahiers_textes as t2 WHERE pourle='".quote_smart($date)."' AND t1.id_ctexte=t2.id_ctexte AND id_groupe='".quote_smart($_SESSION['id_groupe_en_cours'])."'".$where_add;
    					else 
    						$sql2 = "SELECT afaire,t1.id_ctexte FROM a_faire as t1,cahiers_textes as t2 WHERE pourle='".quote_smart($date)."' AND t1.id_ctexte=t2.id_ctexte AND code_structure='$code_structure' AND code_matiere='".quote_smart($i)."' AND id_sous_matiere='".quote_smart($id_sous_matiere)."'".$where_add;
          			}
          			else 
          			{
        				$error_message = array("Le contenu de la sance  copier n'a pas pu tre rcupr ! Cependant vous pouvez insrer manuellement une nouvelle sance si vous le souhaitez...","");
        				affiche_erreurs($error_message);
        				$activite = "";
          			}
        		}
        		$resultat=mysql_query($sql); // on va tenter d'afficher le contenu de la nouvelle sance aprs copie
          		if (mysql_num_rows($resultat)>0) // Si la requte abouti, c'est que le cahier de textes a dj t rempli
        		{
		          	// Alors on affiche les valeurs de la base de donnes
          			$variable = mysql_fetch_array($resultat);
          			$activite = htmlspecialchars($variable['activite']); // comme c'est rcupr dans un textarea, il ne faut pas de balise html
			        // En vue de permettre une modif des donnes existantes, on a besoin de l'id
			        // qu'on va transmettre avec le formulaire
          			$id_ctexte = $variable['id_ctexte']; // le lien entre les 3 tables du cahier de textes
          			$publication = $variable['publication'];
        		}
        		else 
        		{
        			// Valeurs par dfaut pour une nouvelle entre
          			$activite = ""; 
         			$id_ctexte = "";
          			$publication = "1"; 
        		}
          	}
          	elseif($_GET['typecopy'] == "afaire" || $_GET['typecopy'] == "doc")
          	{
          		// si on est en mode copie du travail  faire ou d'un document (il faudra bien associer cette copie  une sance..., alors on en pr-remplit une avec un texte par dfaut que l'utilisateur va modifier)
          		// le formulaire de saisie de sance devra tre soumis pralablement  la copie
          		$activite = htmlspecialchars("&lt;Indiquez ici un contenu de sance et cliquer sur le bouton &laquo;Associer le travail  copier  cette sance&raquo; pour terminer la copie du travail  faire.&gt;");
          		// valeurs par dfaut
          		$id_ctexte = "";
          		$publication = "1";
          	}
          	else // ventuellement pour un autre cas de valeur de  $_GET['typecopy'] (non prvu  ce jour...il faudra peut-tre modifier en consquence)
          	{
          		// Valeurs par dfaut pour une nouvelle entre
          		$activite = ""; 
         		$id_ctexte = "";
          		$publication = "1"; 
          	}
          	         	
          }
          else // entre normale de saisie d'une nouvelle sance
          {
          	// Valeurs par dfaut pour une nouvelle entre
          	$activite = ""; 
         	$id_ctexte = "";
          	$publication = "1";
          } 
        }
        
        // Avant d'afficher le contenu de sance, on va rappeler le travail  faire pour ce jour
        $resultat2 = mysql_query($sql2);
        $nb_travaux = mysql_num_rows($resultat2);
        if ($nb_travaux > 0)
        {
        	$code_formulaire .= "<div class='frame_form2 rappel_travail_jour' align='left'>
        	<h4 style='margin-bottom:0.5em;border-bottom:1px solid;'>Rappel du travail donn pour ce jour</h4>";
        	while ($ligne = mysql_fetch_array($resultat2))
        	{
        		$code_formulaire .= stripslashes($ligne['afaire']);
        		// On cherche les documents joints attachs  chaque travail  faire
        		$sql = "SELECT * FROM docs_joints_ctextes WHERE ";
        	}
        	$code_formulaire .= "
        	</div>";
        }
        
        $code_formulaire .= "
        <div class='cadre_seance_ctx'>
        <div class='titre_cadre_formulaire_gris'><h4>Contenu de la sance</h4>";
        
        if ($mode == "saisie")
        {
        	if ($publication == "1")
        		$checked = "checked='checked'";
        	else 
        		$checked = "";
        	$code_formulaire .= "<div class='visibility_activite'><input type='checkbox' id='chkPublish_activite' name='publication_activite' value='1' $checked title=\"".infobulle("publication","contenu")."\" />
        	<label for='chkPublish_activite'>Publi</label></div>";
        }
        
        $code_formulaire .= "</div>";
        
        // Affichage du visa ventuel (DIR ou IPR : le plus rcent) : uniquement si la sance est dj renseigne
       	global $db;
      	$CdtVisaManager = new CdtVisaManager($db);
      	$code_affichage_visa = $CdtVisaManager->afficheTamponVisa($id_ctexte);
      	if ($code_affichage_visa != "") {
      		$code_formulaire .= "<div style='float:right;position:relative;'>$code_affichage_visa</div>";
      		$mode = "consultation"; // comme le visa est actif, il faut bloquer les modifications ou suppression de la sance, ainsi que l'ajout d'un doc joint et de TAF
      	}      	
        if ($mode == "saisie" && $activite !="") // En mode saisie, on affiche un bouton permettant la recopie de l'entre vers une autre classe
        {
        	$code_formulaire .= "<div class='copy_paste_to_btn'><a href='edt.php?categorie=professeurs&amp;edt=".$_SESSION['identifiant_individu']."&amp;typecopy=activite&amp;id_ctexte=$id_ctexte&amp;debut_semaine=$date' title=\"Copier le contenu de la sance + ses documents joints et le coller dans le cahier de textes d'une autre classe\">Copier et coller vers...</a></div>
        	<div class='v_spacer'>&nbsp;</div>";
        }
        else // il faut afficher ce div, sinon dcalage dans le bloc textarea qui sort de son conteneur
        {
        	$code_formulaire .= "<div class='v_spacer'>&nbsp;</div>";
        }
      
        if ($mode == "saisie")
        {
          $code_formulaire .= "<b><label for='activite' class='hidden'>Travail effectu en classe&nbsp;:</label></b>
          <textarea id='activite' name='activite' rows='' cols=''>".stripslashes($activite)."</textarea>";
    	  $code_formulaire .="
          <div align='right'>";
    	  if ($activite!="")
    	  {
      		if ($_GET['typecopy'] == "afaire")
      			$texte_bouton = "Associer le travail  copier  cette sance";
      		elseif ($_GET['typecopy'] == "doc")
      			$texte_bouton = "Associer le document  copier  cette sance";
      		else 
      			$texte_bouton = "Modifier";
    	  	$code_formulaire .="
              	<input type='submit' id='soumettre_modifactivite' name='soumettre_modifactivite' value='$texte_bouton' />
    		  	<input type='submit' id='soumettre_suppractivite' name='soumettre_suppractivite' value='Supprimer' />";
      		if (isset($_GET['typecopy'])) // si on est en mode copie
      		{
      			if ($_GET['typecopy'] == "afaire") // copie d'un travail  faire
      			{
      				// On transmet un champ cach qui permettra lors de la soumission du formulaire d'effectuer la copie effective du travail  faire en plus du contenu de sance
      				$code_formulaire .= "<input type='hidden' id='HideCopyAfaire' name='copy_afaire' value='".$_SERVER['QUERY_STRING']."' />";
      			}
      			elseif ($_GET['typecopy'] == "doc") // copie d'un document
      			{
      				// On transmet un champ cach qui permettra lors de la soumission du formulaire d'effectuer la copie effective du document en plus du contenu de sance
      				$code_formulaire .= "<input type='hidden' id='HideCopyDoc' name='copy_doc' value='".$_SERVER['QUERY_STRING']."' />";
      			}
      		}
    	  }
    	  else
    	  {
      		if ($_GET['typecopy'] == "afaire")
      			$texte_bouton = "Associer le travail  copier  cette sance";
      		elseif ($_GET['typecopy'] == "doc")
      			$texte_bouton = "Associer le document  copier  cette sance";
      		else 
      			$texte_bouton = "Valider";
    	  	$code_formulaire .="
              <input type='submit' id='soumettre_activite' name='soumettre_activite' value='$texte_bouton' />";
    	  }
    	  $code_formulaire .="
          	</div>";
        }
        else
        {  
          $code_formulaire .= "<div class='frame_form1' align='left'>".htmlspecialchars_decode(stripslashes($activite))."<br /></div>"; 
        }
        
        // Voici les documents joints associs  la sance
        $code_formulaire .= cherche_docs_associes($mode,"id_ctexte",$id_ctexte,"");
        
        $code_formulaire .= "
        </div>";
    	
    	 /************************** TRAVAUX A FAIRE *****************************/
        
        $code_formulaire .="
        <h4 class='hidden'>Travaux  faire</h4>";
      
      if ($mode != "saisie") // si le mode est en consultation, on ne recherche que les entres publies
      	$where_add = "AND publication='1'";
      else 
        $where_add = "";
      // On doit rcuprer les travaux  faire s'ils existent ou en crer
      $sql = "SELECT pourle,id_afaire,afaire,publication FROM a_faire WHERE id_ctexte='".quote_smart($id_ctexte)."'".$where_add." ORDER BY pourle";
      // DEBUGG print $sql."<br />";
      $resultat = mysql_query($sql);
      $k = 1; // initialisation au cas o la requte prcdente serait infructueuse
      if ($resultat)
      {
        $nb_travaux = mysql_num_rows($resultat);
        if ($nb_travaux>0) // il y a des travaux  faire dans la base de donnes
        {
          for ($k=1;$k<$nb_travaux+1;$k++)
          {
            $ligne = mysql_fetch_array($resultat);
            $id_afaire = $ligne['id_afaire'];
            $publication = $ligne['publication'];
            $afaire = trim(htmlspecialchars($ligne['afaire']));
            // pour viter un warning ventuel
            if ($ligne['pourle']!="0000-00-00" && $ligne['pourle']!="")
              $pourle = date_mysql_to_jjmmaaaa_tiret($ligne['pourle']);
            else
              $pourle = "";
            $code_formulaire .= sous_form_afaire($mode,$pourle,$k,$id_ctexte,$id_afaire,$afaire,$publication);
          }    
        }
        else // Il n'y a pas de travaux  faire dans la base de donnes, on va afficher un sous-formulaire vierge 
        {
          $id_afaire = "";
          $afaire = "";
          $pourle = "";
          $publication = "1";
          $k = 1;
          $code_formulaire .= sous_form_afaire($mode,$pourle,$k,$id_ctexte,$id_afaire,$afaire,$publication);
        }  
      }
      // si l'utilisateur vient de cliquer sur le lien [Ajouter une autre date], il faut afficher un sous-formulaire vierge 
      if (isset($_GET['ajout_afaire']) && $_GET['ajout_afaire']) // si ajout_afaire vaut true
        $code_formulaire .= sous_form_afaire($mode,"",$k,$id_ctexte,"","","1");
          
  
    /***************************** CHAMPS CACHES *********************************************/
    // Transmission des champs cachs : id_ctexte si non vide sert  indiquer qu'il s'agit d'un update des donnes
    
    $code_formulaire .= "
    <input type='hidden' id='id_matiere' name='id_matiere' value='$id_matiere' />
    <input type='hidden' id='id_sous_matiere' name='id_sous_matiere' value='$id_sous_matiere' />
    <input type='hidden' name='date' value='$date' />
    <input type='hidden' id='id_ctexte' name='id_ctexte' value='$id_ctexte' />";
    
    /***************************** Fin du formulaire ****************************/
    
    echo "<center>";
    
    /************** Affichage effectif du formulaire *************/
    
    if ($mode == "saisie")
    {
      squelette_formulaire_standard(
      "100%",
      "post",
      $_SERVER['PHP_SELF'],
      $titre_formulaire,
      $code_formulaire,
      "","","","","","","","","enctype='multipart/form-data' id='ctextform' name='ctextform'");
    }
    else
    {
      squelette_formulaire_standard(
      "100%",
      "",
      "",
      $titre_formulaire,
      $code_formulaire,"","","","","","","");
    }
    echo "</center>";
}
else // L'utilisateur essaie d'invoquer ce script directement dans l'URL (interdit)
{
  $error_message = array("Vous tentez d'accder  un script qui n'est pas accessible directement  partir de l'URL... Utilisez les liens de navigation !","");
  affiche_erreurs($error_message);
}
?>