<?php
/**
 * c_edt.php
 *
 * Page permettant la consultation des emplois du temps
 * 
 * Ce fichier fait partie du projet IntraEduWeb (IEW)
 * 
 * @package		IEW
 * @author			Sylvain GODM <sylvain.godme@gmail.com>
 * @version		$LastChangedRevision$, $LastChangedDate$
 * @copyright		2004-2012 Sylvain GODM
 * @link			http://iew.free.fr
 * @license		GPL License version 3 (http://www.gnu.org/licenses/gpl.html)
 * @filesource
 * 
 */

/* Dclaration de fonctions */ 

function trouve_hauteur_ligne($h1,$h2)
{
	/** fixe la hauteur en em des balises tr (lignes du planning) en fonction de la dure en minutes entre 2 lignes successives (temps en minutes sparant 2 horaires conscutifs)
	 * @param $h1, $h2 horaires  comparer au format hh."h".mm (tableau $horaires_print)
	 * @return $em : hauteur de ligne  0.1 em prs
	 */
	if ($h1 != "" && $h2 !="")
	{
		$diff_min = ecart_minutes_2_horaires($h1,$h2);
		$em = round(4 * $diff_min / 60,1); // la hauteur par dfaut fixe est de 4em pour 60 minutes
	}
	else	// un des 2 horaires  comparer est vide : par dfaut, on met la hauteur comme  60 minutes 
		$em = 4; 
	return $em;
}

function affiche_planning($planning)
{
	/** Affiche le planning fourni en paramtres sous forme de tableau
	 * 
	 * @param $planning tableau associatif  2 dimensions contenant pour chaque couple de cls (jour, heure de dbut de cours) le cours sous forme de chane au format "structure_complete#type_diff#id_cours#Code_matiere#matire<br />id_individu#nom_prof<br />salle%dure" (pour un planning de classe) et au format "structure_complete#type_diff#id_cours#Code_matiere#matire<br />nom_classe_ou_groupe<br />salle%dure" (pour un planning de Professeur)
	 * 
	 * pour chaque ligne de rsultat, traiter : 
	 * - les alternances
	 * - les heures de trous
	 * 
	 * Enfin,  l'affichage, il faut grer les liens vers l'entre de cahier de textes pour saisie/consultation par le prof
	 * Il faut trouver le nombre de structures diffrentes dans le service du prof et y affecter des couleurs diffrentes de fort contraste
	 * Pour le tableau, le nombre de colonnes est fixe : 6 (on ne bosse pas le dimanche)
	 * Le nombre de lignes est fonction de la table horaires_edt = (heure de fin de la plus grande journe - heure de dbut de la plus grande journe)/ dure par dfaut d'une heure de cours
	 * Mais si la diff n'est pas multiple de la dure par dfaut d'une heure de cours, a craint !!
	 * REVOIR LA TABLE HORAIRES ET LES SCRIPTS QUI L'UTILISENT !!
	 * l'heure de cours est positionne  1h00 par dfaut (que se passe-t-il si a change un jour ?)
	 */
	
	global $couleurs_matieres,$mode,$debut_semaine,$horaires_sql,$horaires_print;
	
	// DEBUGG var_dump($planning);
	// DEBUGG print "Cl du 1er lment du tableau planning :".key($planning[1])."<hr />";
	// DEBUGG print "Valeur du 1er lment du tableau planning :".current($planning[1])."<hr />";
	$jours = array("Lundi","Mardi","Mercredi","Jeudi","Vendredi","Samedi");
	$nblignes = count($horaires_sql);
	
	// On cherche les valeurs de colspan pour les cours en parallle pour connatre le nombre de cellules  fusionner dans une mme colonne
	// On recherche s'il y a des cours en parallle dans la journe et combien au maximum sont en parallle (2, 3 ??)  une mme plage horaire
	$nb_max_cours_paralleles = 0;
	$jour_colspan = array(); // contiendra les valeurs par dfaut de colspan pour chaque colonne du planning (= chaque jour)
	$d = 1; // jour 1 = lundi
	foreach($planning as $jour) // pour chaque jour
	{
		$colspan = ""; // pas de cours en parallle ce jour a priori
		$nb_max_cours_paralleles = 0;
		foreach($jour as $horaire_jour) // pour chaque horaire du jour
		{
			if (strpos($horaire_jour,"!%!") !== false) // si, il y a des cours en parallle  cet horaire
			{
				$tab_cours_paralleles = explode("!%!",$horaire_jour); // combien ?
				$nb_entree_cours_paralleles = count($tab_cours_paralleles);
				if ($nb_entree_cours_paralleles > $nb_max_cours_paralleles)
					$nb_max_cours_paralleles = $nb_entree_cours_paralleles;
			}		
		}
		// en fin de journe, le bilan :
		if ($nb_max_cours_paralleles > 0)
			$jour_colspan[$d] = $nb_max_cours_paralleles; // le colspan est fix par dfaut pour toutes les cellules de la colonne du jour
		else 
			$jour_colspan[$d] = 0;
		$d++; // on passe au jour suivant
	}
	
	// DEBUGG var_dump($jour_colspan);
	
	$nbcolonnes = 6; // 6 jours au max dans la semaine
	$pas_de_balise_td = array(); // contient des valeurs 1 ou vides selon la cl pour indiquer si une balise <td> doit tre affiche ou non (permet de faire des fusions de cellules)
	
	echo "<table id='planning_edt' class='ctextes edt'>";
	for ($i=0;$i<=$nblignes;$i++) // on boucle sur les lignes du tableau d'affichage
	{
		if ($i == 0)
			echo "<tr>";
		else
			echo "<tr style='height: ".trouve_hauteur_ligne($horaires_print[$i],$horaires_print[$i+1])."em;'>";
		for ($j=0;$j<=$nbcolonnes;$j++) // on boucle sur les colonnes
		{
			$class_jour_en_cours = ""; // a priori, ce n'est pas aujourd'hui
			$d = $j-1;
			if (date("Y-m-d") == strftime("%Y-%m-%d", strtotime("$debut_semaine +$d day")))
				$class_jour_en_cours = " jour_en_cours"; // c'est aujourd'hui : on le met en vidence  l'affichage (classe CSS supplmentaire)
			if ($i == 0) // C'est la 1re ligne = ligne d'en-tte
			{
				if ($j == 0) // 1re colonne = les horaires
				{
					echo "<th class='fond_sommaire topleft' style='height: 3em;'>";
					echo "Horaires";
				}
				else // Les autres colonnes : les jours de la semaine
				{
					if ($j == $nbcolonnes) // si dernire colonne de la 1re ligne
						$class_add_last = " topright";
					else 
						$class_add_last = "";
					if (isset($jour_colspan[$j]) && $jour_colspan[$j] != 0)
					{
						$colspan = " colspan='$jour_colspan[$j]'";
					}
					else
						$colspan = "";
					echo "<th$colspan class='fond_sommaire".$class_jour_en_cours.$class_add_last."' style='height: 3em;'>"; // si c le jour en cours, c mis en vidence par la classe CSS 'jours_en_cours'
					echo "<a href='ct_day.php?categorie=".$_GET['categorie']."&amp;edt=".$_GET['edt']."&amp;j=".strftime("%d-%m-%Y", strtotime("$debut_semaine +$d day"))."' title='Voir le cahier de texte de la journe du ".$jours[$j-1]." ".$date_jour = strftime("%d/%m/%Y", strtotime("$debut_semaine +$d day"))."'>".$jours[$j-1]." ".$date_jour = strftime("%d", strtotime("$debut_semaine +$d day"))."</a>";
				}
				echo "</th>";
			}
			else // Ce n'est pas la ligne d'en-tte => ligne de donnes
			{
				if ($j == 0) // 1re colonne = l'horaire
				{
					if ($i == $nblignes) // on est sur la dernire ligne
						$class_add_first = " bottomleft";
					echo "<th class='fond_sommaire".$class_add_first."' style='vertical-align:top;'>";
					echo $horaires_print[$i];
					echo "</th>";
				}
				else // les autres colonnes : les cours
				{
					$rowspan = "";
					$value = "";
					if ($i == $nblignes && $class_jour_en_cours != "") // Si c le dernier cours du jour en cours
						$class_jour_en_cours = "dernier_cours_jour_en_cours"; // on modifie la CSS pour la border-bottom-width
					// le planning correspondant  l'horaire actuel contient-il des cours en parallle ?
					if (strpos($planning[$j]{$horaires_sql[$i-1]},"!%!") !== false)
					{
						// On spare les cours parallles
						$frag_cours_paralleles = explode("!%!",$planning[$j]{$horaires_sql[$i-1]});
						$nb_cours_paralleles = count($frag_cours_paralleles);
						$r = 0;
						foreach($frag_cours_paralleles as $cours_parallele)
						{
							$r++;
							if ($r == 1)
								$rang_parallele = 1;
							elseif ($r == $nb_cours_paralleles)
								$rang_parallele = $nb_cours_paralleles;
							else 
								$rang_parallele = $r;
							affiche_cours($cours_parallele,$i,$j,$planning,$horaires_sql,$jour_colspan,false,$nb_cours_paralleles,$rang_parallele,$class_jour_en_cours);
						}
					}
					else 
					{
						affiche_cours($planning[$j]{$horaires_sql[$i-1]},$i,$j,$planning,$horaires_sql,$jour_colspan,true,0,"",$class_jour_en_cours);
					}
				}
			}
		}
		echo "</tr>";
	}
	echo "</table>";
	// DEBUGG print "<br /> Tableau pas de balise td :<pre>"; print_r($pas_de_balise_td); print "</pre><br />";
}

function affiche_cours($cours,$i,$j,$planning,$horaires_sql,$jour_colspan,$is_colspan,$nb_cours_paralleles,$rang_parallele,$class_jour_en_cours)
{
	/**
	 * Affiche le cours comme cellule du planning d'emploi du temps (balises td)
	 * 
	 * @param $cours : Cours au format "structure_complete#type_diff#id_cours#Code_matiere#matire<br />id_individu#nom_prof<br />salle%dure" (pour un planning de classe) et au format "structure_complete#type_diff#id_cours#Code_matiere#matire<br />nom_classe_ou_groupe<br />salle%dure" (pour un planning de Professeur)
	 * @param $i : n de la ligne en cours dans le planning affich (0 = ligne d'entte)
	 * @param $j : n de colonne en cours dans le planning affich (0 = colonne d'entte, 1 = lundi, 2 = mardi, etc.)
	 * @param $planning : tableau associatif 2 dimensions (jour, heure de dbut de cours) contenant en valeur les $cours
	 * @param $horaires_sql : tableau contenant suivant les n de ligne du planning les heures de dbut de cours au format chane hhmm (=seconde cl du tableau $planning)
	 * @param $jour_colspan : indique le nombre de colonnes  fusionner (fusion horizontale) en cas de cours en parallle
	 * @param $is_colspan : si false, indique que le cours est en parallle avec un autre  la mme heure
	 * @param $nb_cours_paralleles : indique le nombre de cours en parallle  cet horaire (=0 si un seul cours, 2 si 2 cours...)
	 * @param $rang_parallele : indique (si le cours est en parallle avec d'autres) le rang du cours parallle  cet horaire : 1, 2, 3, etc. 
	 * @param $class_jour_en_cours : vide si ce n'est pas un cours du jour en cours, sinon contient le nom de la classe CSS  appliquer pour mettre en vidence le cours comme tant un cours du jour en cours
	 * */
		
	global $couleurs_matieres,$pas_de_balise_td,$debut_semaine,$eleve_id,$horaires_recrees;
	
	$fragment = explode("%",$cours); // On spare le cours ($fragment[0]) de sa dure ($fragment[1])
	if (array_key_exists($horaires_sql[$i-1],$planning[$j])) // Si une donne existe pour cet horaire et pour ce jour
	{
		// dtermination du rowspan
		$heure_debut_cours = intval($horaires_sql[$i-1]);
		$duree_cours = intval($fragment[1]);
		$heure_fin_cours_th = $heure_debut_cours + $duree_cours; // horaire numrique thorique de fin de cours
		$nb_minutes = substr($heure_fin_cours_th,-2);
		$nb_heures = substr($heure_fin_cours_th,0,-2);
		if ($nb_minutes >= 60)
		{
			$nb_minutes = $nb_minutes - 60;
			if ($nb_minutes < 10)
				$nb_minutes = "0".$nb_minutes; // on force le nb de min sur 2 chiffres
			$nb_heures++;
			$heure_fin_cours_th = intval($nb_heures.$nb_minutes); // horaire sexagesimal de fin de cours
		}

		// correction sur l'horaire de fin de cours : on trouve l'horaire rel le + proche
		foreach ($horaires_sql as $value)
		{
			$diff_val = $heure_fin_cours_th - intval($value);
			$diff[$value] = abs($diff_val);
		}
		$min_diff_val = min($diff);
		$heure_fin_cours_redirect = intval(array_search($min_diff_val,$diff));
		
		// On traite les problmes de rcre qui peuvent perturber le rowspan : $heure_fin_cours_redirect va peut-tre tre redfini...
		if (isset($horaires_recrees))
		{
			foreach ($horaires_recrees as $value)
			{
				if ($heure_debut_cours < intval($value) && intval($value) < $heure_fin_cours_th) // le dbut de rcre a lieu pendant le cours
				{
					$fin_recree = intval($value) + 15; // Les rcres dans les EPLE durent 15 minutes en principe
					$nb_minutes = substr($fin_recree,-2);
					$nb_heures = substr($fin_recree,0,-2);
					if ($nb_minutes >= 60)
					{
						$nb_minutes = $nb_minutes - 60;
						if ($nb_minutes < 10)
							$nb_minutes = "0".$nb_minutes; // on force le nb de min sur 2 chiffres
						$nb_heures++;
						$fin_recree = intval($nb_heures.$nb_minutes); // horaire sexagesimal de fin de rcre
					}
					if ($fin_recree < $heure_fin_cours_th) // le cours se termine aprs la fin de la rcre
					{
						$diff[$fin_recree] = ""; // On va supprimer la valeur correspondant  l'horaire de fin de rcre
						$diff = enlever_valeurs_vides($diff); // fait !
						$min_diff_val = min($diff); // le nouveau minimum
						$heure_fin_cours_redirect = intval(array_search($min_diff_val,$diff)); // On rdfini la fin du cours
					}
					else // le cours se termine donc avant la fin de la rcre
						$heure_fin_cours_redirect = $value; // fin du cours = dbut de rcre
				}
			}
		}
		
		$heure_fin_cours = $heure_fin_cours_redirect;
		
		// combien y-a-t-il d'horaires diffrents >=  l'heure de dbut et <=  l'heure de fin ?
		$count_values = 0;
		foreach ($horaires_sql as $value)
		{
			if (intval($value) >= $heure_debut_cours && intval($value) < $heure_fin_cours)
			{
				$count_values++;
			}
		}
		$rowspan = " rowspan='$count_values'";
		if ($count_values >= 2) 
		{
			// Il faut ensuite faire en sorte que sur les ($rowspan-1) lignes suivantes, la balise <td></td> correspondant
			// au jour ne soit pas crite (sinon il y aura un dcalage vers la droite !!)				
			for ($k=1;$k<=$count_values-1;$k++)
			{
				$pas_de_balise_td[$i+$k][$j] = "1";
			}
		}
		else 
			$rowspan = "";
		
		if ($is_colspan) // il ne s'agit pas d'un cours en parallle ($is_colspan = true) => Il faut peut-tre fusionner horizontalement les cellules
		{
			if (isset($jour_colspan[$j]) && $jour_colspan[$j] != 0) // seulement si le jour contient des cours en parallle
				$colspan = " colspan='$jour_colspan[$j]'";
			else // le jour ne contient pas de cours en parallle
				$colspan = ""; // donc on ne fusionne pas horizontalement
		}
		else // il s'agit d'un cours en parallle, la cellule ne se fusionne pas avec celle d' ct (horizontalement)
			$colspan = "";
	}
	else // pas de donnes pour cet horaire : la cellule est vide mais doit peut-tre fusionner horizontalement avec celle de droite si le jour contient des cours en parallle 
	{
		if (isset($jour_colspan[$j]) && $jour_colspan[$j] != 0) // seulement si le jour contient des cours en parallle
			$colspan = " colspan='$jour_colspan[$j]'";
		else // le jour ne contient pas de cours en parallle
			$colspan = ""; // donc on ne fusionne pas horizontalement	
	}
	if (!isset($pas_de_balise_td[$i][$j])) // les $pas_de_balise_td[$i][$j] dfinis ( 1) ne seront pas affichs afin d'viter les dcalages lis aux fusions verticles et horizontales de cellules
	{
		// on rcupre le libell matire
		$libelles = explode("<br />",$fragment[0]);
		$recup_code_matiere = explode("#",$libelles[0]);
		$id_cours = $recup_code_matiere[2];
		$code_matiere = $recup_code_matiere[3];
		$libelle_matiere = str_replace("&","<br />&",$recup_code_matiere[4]); // la matire telle qu'elle sera affiche dans le planning, retour  la ligne si trop long pour viter le dbordement du tableau par rapprot  son conteneur
		$libelle_edition_matiere = $recup_code_matiere[5]; // la matire dans l'attrbut title des liens
		// on cherche les couleurs associes  la matire
		$split_couleurs = explode("%",$couleurs_matieres[$code_matiere]);
		$avt_plan = $split_couleurs[0];
		$arr_plan = $split_couleurs[1];
		if ($j == $nbcolonnes && $i == $nblignes) // on est sur la dernire ligne et la dernire colonne
			$class_add_last = " bottomright";
		else
			$class_add_last = "";
		if (!$is_colspan && $class_jour_en_cours != "") // si c un cours en parallle pour le jours en cours
		{
			// Alors il faut moduler les bordures selon que le cours est le premier, le dernier ou au milieu des cours parallles  afficher
			if ($rang_parallele == 1)
				$class_jour_en_cours = "first_parallele";
			elseif ($rang_parallele == $nb_cours_paralleles)
				$class_jour_en_cours = "last_parallele";
			else
				$class_jour_en_cours = "";
		}
		echo "<td$rowspan $colspan class='".$class_jour_en_cours.$class_add_last."' style='background-color: #$arr_plan;color: #$avt_plan'>"; // les cellules sont fusionnes si le cours existe et dure + d'une heure
		// il faut dterminer le jour pour l'entre dans le cahier de textes
		$plus = $j-1;
		$date_jour = strftime("%Y-%m-%d", strtotime("$debut_semaine +$plus day"));
		if (isset($libelles[1])) // contient la classe pour un EDT prof, le nom du prof pour un EDT classe...
		{
			$nom_prof = explode("#",$libelles[1]); // $nom_prof[0] = id_individu, $nom_prof[1] = NOM du prof pour un EDT classe ou NOM de la classe pour un EDT Prof
				
			if ($_GET['categorie'] == "professeurs") // Affichage de la matire, lien vers le cahier de textes correspondant + affichage de la classe, lien vers l'emploi du temps correspondant
			{
				$lien_ct = "<a href='cahiers_textes.php?date=".date_mysql_to_jjmmaaaa_tiret($date_jour)."&amp;set_classe=".$libelles[1]."&amp;matiere=$code_matiere' title='Accder au cahier de texte de ".$libelles[1]." (Matire : ".$libelle_edition_matiere.")' style='color:#$avt_plan'>".$libelle_matiere."</a>";
				echo "$lien_ct<br /><a href='./edt.php?categorie=classes&amp;edt=".$libelles[1]."' title=\"Voir l'emploi du temps de la classe de ".$libelles[1]."\" style='color:#$avt_plan'>".$libelles[1]."</a>";
				if (isset($_GET['mode']) && $_GET['mode'] == "ct") // En mode ct, Affiche au sein du planning EDT, les intros des TAF et des contenus de sance du cahier de textes
				{
					if ($_GET['edt'] == $_SESSION['identifiant_individu']) // si c'est un cours du prof qui consulte l'edt (ou si un admin consulte l'edt)
						affiche_ct($libelles[1],$libelle_edition_matiere,$date_jour,$i,$j,$nb_cours_paralleles,$rang_parallele,$nom_prof[0],true);	// On affiche les entres non publies
					// Dans tous les cas, on affiche les entres publies
					affiche_ct($libelles[1],$libelle_edition_matiere,$date_jour,$i,$j,$nb_cours_paralleles,$rang_parallele,$nom_prof[0],false);
				}
			}
			elseif ($_GET['categorie'] == "classes")
			{
				if ($_SESSION['valid_group'] == "4")
					echo "<a href='cahiers_textes.php?date=".date_mysql_to_jjmmaaaa_tiret($date_jour)."&amp;set_classe=".$_GET['edt']."&amp;matiere=$code_matiere&amp;eleve_id=$eleve_id' title='Accder au cahier de texte de ".$_GET['edt']." (Matire : ".$libelle_edition_matiere.")' style='color:#$avt_plan'>".$libelle_matiere."</a><br />";
				elseif ($_SESSION['valid_group'] == "11") // Les IPR ne peuvent voir les cahiers de textes d'une classe que dans la matire qu'ils inspectent
				{
					if (isset($_SESSION['ipr_liste_codes_matieres']) && in_array($code_matiere,$_SESSION['ipr_liste_codes_matieres']))
					{
						echo "<a href='cahiers_textes.php?date=".date_mysql_to_jjmmaaaa_tiret($date_jour)."&amp;set_classe=".$_GET['edt']."&amp;matiere=$code_matiere' title='Accder au cahier de texte de ".$_GET['edt']." (Matire : ".$libelle_edition_matiere.")' style='color:#$avt_plan'>".$libelle_matiere."</a><br />";
					}
					else 
						echo $libelle_matiere."<br />";
				}
				else 
					echo "<a href='cahiers_textes.php?date=".date_mysql_to_jjmmaaaa_tiret($date_jour)."&amp;set_classe=".$_GET['edt']."&amp;matiere=$code_matiere' title='Accder au cahier de texte de ".$_GET['edt']." (Matire : ".$libelle_edition_matiere.")' style='color:#$avt_plan'>".$libelle_matiere."</a><br />";
				if ($_SESSION['valid_group'] != "2" && $_SESSION['valid_group'] != "4") // les parents et les lves n'ont pas le lien vers les EDT des profs
				{
					if ($_SESSION['valid_group'] != "11") // A part les IPR, on a le lien vers les EDT de tous les profs
						echo "<a href='./edt.php?categorie=professeurs&amp;edt=".$nom_prof[0]."' title=\"Voir l'emploi du temps de (Monsieur ou Madame) ".$nom_prof[1]."\" style='color:#$avt_plan'>".$nom_prof[1]."</a>";
					elseif ($_SESSION['valid_group'] == "11" && in_array($nom_prof[0],$_SESSION['ipr_liste_id_individus_inspectes'])) // mais les IPR qui inspectent les profs ont le lien vers l'edt de ces derniers uniquement
						echo "<a href='./edt.php?categorie=professeurs&amp;edt=".$nom_prof[0]."' title=\"Voir l'emploi du temps de (Monsieur ou Madame) ".$nom_prof[1]."\" style='color:#$avt_plan'>".$nom_prof[1]."</a>";
					else 
						echo $nom_prof[1];	
				}
				else // Cas d'un parent ou d'un lve
					echo $nom_prof[1];
				echo "<br/>";
				if (isset($_GET['mode']) && $_GET['mode'] == "ct") // En mode ct, Affiche au sein du planning EDT, les intros des TAF et des contenus de sance du cahier de textes
				{
					affiche_ct($_GET['edt'],$libelle_edition_matiere,$date_jour,$i,$j,$nb_cours_paralleles,$rang_parallele,$nom_prof[0]);
				}
			}
					
			switch ($_GET['typecopy'])
			{
				case 'activite':
					echo "<a href='cahiers_textes.php?set_classe=".$libelles[1]."&amp;typecopy=".$_GET['typecopy']."&amp;id_ctexte=".$_GET['id_ctexte']."&amp;matiere=$code_matiere&amp;date=".date_mysql_to_jjmmaaaa_tiret($date_jour)."' title='Coller le contenu de la sance dans le cahier de textes de ".$libelles[1]."  la date du ".MySQLDateToExplicitDate($date_jour)."' style='color:#$avt_plan'><strong>[Coller]</strong></a>";
					break;
				case 'afaire':
					// Le lien doit renvoyer vers le formulaire de saisie d'une entre de c_textes car il faut associer le travail  faire  une sance (qui n'existe peut-tre pas encore...)
					echo "<a href='cahiers_textes.php?set_classe=".$libelles[1]."&amp;typecopy=".$_GET['typecopy']."&amp;id_afaire=".$_GET['id_afaire']."&amp;matiere=$code_matiere&amp;pourle=".date_mysql_to_jjmmaaaa_tiret($date_jour)."' title='Coller le travail  faire pour le  ".MySQLDateToExplicitDate($date_jour)." dans le cahier de textes de ".$libelles[1]."' style='color:#$avt_plan'><strong>[Coller]</strong></a>";
					break;
				case 'doc':
					// ici il y aura 2 collages possibles (dtermins dans c_cahiers_textes.php) : vers un contenu de sance ou bien vers un travail  faire
					echo "<a href='cahiers_textes.php?set_classe=".$libelles[1]."&amp;typecopy=".$_GET['typecopy']."&amp;id_doc=".$_GET['id_doc']."&amp;matiere=$code_matiere&amp;date=".date_mysql_to_jjmmaaaa_tiret($date_jour)."' title='Coller le document dans le cahier de textes de ".$libelles[1]." associ au contenu de sance  la date du ".MySQLDateToExplicitDate($date_jour)."' style='color:#$avt_plan'><strong>[Coller]</strong></a>";
					break;
			}
		}
		// On affiche ventuellement les contrles de modification d'un cours (pour les personnes autorises)
		if (isset($_GET['modif']) && $_GET['modif'] == true && auth_modif_edt())
			$add_style = "style='display: inline-table'";
		else 
			$add_style = "";
		// Selon le $add_style, on affiche ou pas les contrles (ceci peut tre galement modifi par javascript)
		if (!isset($libelles[1]))// Si pas de cours affich, on affiche un +
				echo "<a class='add_cours' $add_style href='edt.php?modif=true&amp;changeform=true&amp;type_diff=add&amp;categorie=".$_GET['categorie']."&amp;edt=".$_GET['edt']."&amp;j=$j&amp;i=$i&amp;debut_semaine=$debut_semaine'><img src='".$GLOBALS['chemin_relatif']."images/add.png' title='Ajouter un cours' alt='[Ajouter]' /></a>";
			else // Sinon on affiche une croix et un stylo
				echo "<a class='del_cours' $add_style href='edt.php?modif=true&amp;changeform=true&amp;type_diff=del&amp;cours=$id_cours&amp;categorie=".$_GET['categorie']."&amp;edt=".$_GET['edt']."&amp;j=$j&amp;i=$i&amp;debut_semaine=$debut_semaine'><img src='".$GLOBALS['chemin_relatif']."images/delete.png' title='Supprimer ce cours' alt='[Supprimer]' /></a><a class='del_cours' $add_style href='edt.php?modif=true&amp;changeform=true&amp;type_diff=mod&amp;cours=$id_cours&amp;categorie=".$_GET['categorie']."&amp;edt=".$_GET['edt']."&amp;j=$j&amp;i=$i&amp;debut_semaine=$debut_semaine'><img src='".$GLOBALS['chemin_relatif']."images/edt_write24x24.png' title='Modifier ce cours' alt='[Modifier]' /></a>";
		// et ventuellement un contrle permettant le rtablissement du cours d'origine s'il en existe un ou sinon rtablissement du crneau libre
		if ($recup_code_matiere[1] == "add" || $recup_code_matiere[1] == "mod" || $recup_code_matiere[1] == "del")
			echo "<a class='restore_cours' $add_style href='edt.php?modif=true&amp;changeform=true&amp;type_diff=restore&amp;cours=$id_cours&amp;categorie=".$_GET['categorie']."&amp;edt=".$_GET['edt']."&amp;j=$j&amp;i=$i&amp;debut_semaine=$debut_semaine'><img src='".$GLOBALS['chemin_relatif']."images/restore.png' title=\"Rtablir le cours d'origine\" alt='[Rtablir]' /></a>";
		echo "</td>";	
	}
}

function trouve_planning($table,$categorie,$dequi,$debut_semaine)
{
	/**
	 * Recherche l'emploi du temps demand
	 * 
	 * @param $table : Indique la table dans laquelle il faut chercher les donnes (soit la table "cours" pour les cours en provenance de EDT_vers_STS_RNE_Annee.xml, soit la table "cours_diff" pour les cours modifis manuellement)
	 * @param $categorie : Indique le type de planning demand : salle, classe, professeur
	 * @param $dequi : pour dfinir l'edt de quel professeur (id_individu), quelle classe (code_structure), quelle salle
	 * @param $debut_semaine : dfini la date du dbut de la semaine choisie
	 * 
	 * @return $planning tableau associatif  2 dimensions contenant pour chaque couple de cls (jour, heure de dbut de cours) le cours sous forme de chane au format "structure_complete#type_diff#id_cours#Code_matiere#matire#libelle_edition_matiere<br />id_individu#nom_prof<br />salle%dure" (pour un planning de classe) et au format "structure_complete#type_diff#id_cours#Code_matiere#matire#libelle_edition_matiere<br />nom_classe_ou_groupe<br />salle%dure" (pour un planning de Professeur)
	 * */
	
	$planning = array();
	global $planning_ct,$planning_ct_nopub,$planning;
	
	// On cherche si on est en semaine Q1 ou Q2
	$quinzaine = quelle_semaine_alternance($debut_semaine);
	for ($i=1;$i<=6;$i++) // pour chaque jour de la semaine
	{
 		$k = $i-1; // $k est l'incrment par rapport  la date $debut_semaine
		$date_jour = strftime("%Y-%m-%d", strtotime("$debut_semaine +$k day"));
		// DEBUGG print "Jour $i : $date_jour<br />";
		if (test_jour_dans_periode_scolaire($date_jour)) // 
		{
			if ($categorie == "classes")
			{
				// Requte cherchant l'edt d'une classe pour un jour donn (dans l'ordre chronologique)
				if ($table == "cours")
					$sql = "SELECT id_cours,code_jour,heure_debut,code_alternance,t4.code_matiere,code_gestion as matiere,libelle_edition,t5.id_individu,nom,duree,code_salle FROM enseignants_services as t1, services as t2, cours as t3, matieres_sconet as t4, personnel as t5 WHERE code_jour='$i' AND (code_structure='".quote_smart($dequi)."' OR code_structure IN (SELECT code_structure FROM structures WHERE divisions_appartenance like '%".quote_smart($dequi)."%')) AND t1.id_individu=t5.id_individu AND t1.id_service=t2.id_service AND t3.id_enseignant_service=t1.id_enseignant_service AND t2.code_matiere=t4.code_matiere AND t5.id_individu NOT IN (SELECT id_remplacant FROM remplacants) ORDER BY code_jour,heure_debut,libelle_edition";
				if ($table == "cours_diff")
					$sql = "SELECT id_cours_diff,type_diff,code_jour,heure_debut,code_alternance,date,structure_complete,t1.code_matiere,code_gestion as matiere,libelle_edition,t1.id_individu,nom,duree,code_salle FROM cours_diff as t1, matieres_sconet as t2, personnel as t3 WHERE code_jour='$i' AND (code_structure='".quote_smart($dequi)."' OR code_structure IN (SELECT code_structure FROM structures WHERE divisions_appartenance like '%".quote_smart($dequi)."%')) AND t1.id_individu=t3.id_individu AND t1.code_matiere=t2.code_matiere AND t3.id_individu NOT IN (SELECT id_remplacant FROM remplacants) ORDER BY code_jour,heure_debut,libelle_edition";						
			}
			elseif ($categorie == "professeurs")
			{
				// Requte cherchant l'edt d'un prof pour un jour donn (dans l'ordre chronologique)
				if ($table == "cours")
					$sql = "SELECT id_cours,heure_debut,code_alternance,code_structure,t4.code_matiere,libelle_court as matiere,libelle_edition,duree,code_salle FROM enseignants_services as t1, services as t2, cours as t3, matieres_sconet as t4 WHERE code_jour='$i' AND id_individu='".quote_smart($dequi)."' AND t1.id_service=t2.id_service AND t3.id_enseignant_service=t1.id_enseignant_service AND t2.code_matiere=t4.code_matiere ORDER BY heure_debut";
				if ($table == "cours_diff")
					$sql = "SELECT id_cours_diff,type_diff,heure_debut,code_alternance,date,code_structure,structure_complete,t1.code_matiere,libelle_court as matiere,libelle_edition,duree,code_salle FROM cours_diff as t1, matieres_sconet as t2 WHERE code_jour='$i' AND id_individu='".quote_smart($dequi)."' AND t1.code_matiere=t2.code_matiere ORDER BY heure_debut";							
			}
			// DEBUGG print $sql."<hr />";
			$resultat = mysql_query($sql);
			$nb_cours = mysql_num_rows($resultat);
			if ($nb_cours > 0) // au moins un cours dans cette journe
			{	
				// il peut y avoir 2 rcuprations de lignes sur la mme ressource MySQL, il faut donc grer le pointeur interne
				$pointeur_data_seek = 0; // initialisation du pointeur interne de rsultat MySQL (voir dtail dans Doc_dev_edt.odt)
				while ($ligne = mysql_fetch_array($resultat))
				{
					// type_diff et id_cours permettront d'identifier au final dans le planning si le cours vient de la table "cours" (donc de EDT_vers_STS_RNE_Annee.xml) ou de la table "cours_diff" (ajout, modifi, supprim manuellement)
					if ($table == "cours_diff")
					{
						$type_diff = $ligne['type_diff'];
						$id_cours = $ligne['id_cours_diff'];
						$date_cours = $ligne['date']; // n'est pas NULL si c un cours ponctuel
						$structure_complete = $ligne['structure_complete']; // si 0 (=false), le cours concerne seulement une partie de la classe; si 1 (=true) le cours concerne toute la classe
					}
					else
					{
						$type_diff = 0;
						$id_cours = $ligne['id_cours'];
						$structure_complete = 1; // dans la table cours, les cours concernent toujours une structure complte (classe ou groupe)
					}
					$heure_debut = $ligne['heure_debut'];
					$code_alternance = $ligne['code_alternance'];
					// $cours_avec permettra de renseigner avec qui se fait le cours : quelle prof pour un edt classe, quelle classe pour un edt prof
					if ($categorie == "classes")
					{
						$id_individu = $ligne['id_individu'];
						$nom = $ligne['nom'];
						$cours_avec = $id_individu."#".$nom;
						// on recherche s'il existe un cours en parallle  cet horaire
						$count_cours_paralleles = 0; // a priori non
						// On va  nouveau utiliser la ressource MySQL $resultat, donc modifier le pointeur interne
						mysql_data_seek($resultat,0); // avant le prochain appel  mysql_fetch_array($resultat), on remet le pointeur sur la premire ligne de la ressource
						while ($ligne_test_cours_parallele = mysql_fetch_array($resultat)) // on parcourt  nouveau le rsultat de la requte
						{
							if ($ligne_test_cours_parallele['heure_debut'] == $heure_debut)
								$count_cours_paralleles++;
						}
					}
					elseif ($categorie == "professeurs")
					{
						$id_individu = quote_smart($dequi);
						$cours_avec = $ligne['code_structure'];
					}
					$code_matiere = $ligne['code_matiere'];
					$matiere = $ligne['matiere']; // le libell de la matire est le code_gestion pour viter un affichage trop large du planning
					$libelle_edition_matiere = $ligne['libelle_edition']; // le libell long sera rcupr pour la valeur d'attribut title dans les liens
					$duree = $ligne['duree'];
					$code_salle = $ligne['code_salle'];
					// DEBUGG print "<br />".$heure_debut."***".$code_alternance."***".$code_structure."<br />";
					if ($code_alternance == "H" || $code_alternance == $quinzaine || $date_jour == $date_cours) // Si le cours est hebdomadaire ou si c'est un cours ajout ponctuellement, il est inscrit systmatiquement dans le planning
					{
						if (isset($planning[$i][$heure_debut]) && $planning[$i][$heure_debut] !="" && $categorie == "classes") // UNIQUEMENT pour un edt classe : gestion des cours en parallle (mme crneau horaire, mais matire diffrente : ex langues ANGLAIS pour les uns, ESPAGNOL pour les autres)
						{
							// on concatne avec le cours existant dj, le sparateur de cours parallles est "!%!" (sera trait dans la fonction affiche_cours())
							$planning[$i][$heure_debut] .= "!%!".$structure_complete."#".$type_diff."#".$id_cours."#".$code_matiere."#".$matiere."#".$libelle_edition_matiere."<br />".$cours_avec."<br />".$code_salle."%".$duree;
						}
						else 
						{
							$planning[$i][$heure_debut] = $structure_complete."#".$type_diff."#".$id_cours."#".$code_matiere."#".$matiere."#".$libelle_edition_matiere."<br />".$cours_avec."<br />".$code_salle."%".$duree;
						}
					}
					elseif (!isset($planning[$i][$heure_debut])) // si ce n'est pas la bonne semaine, on n'inscrit rien UNIQUEMENT si la plage horaire ne contient pas de valeur
					{
						/*
						 * En effet, si on ne met pas !isset($planning[$i][$heure_debut]) on se retrouve avec des cours de quinzaine non affichs
						 * lorsque 2 cours de quinzaines diffrentes occupent la mme case horaire
						 * */
						$planning[$i][$heure_debut] = "";	
					}
					// DEBUGG print "Entre dans le planning : ".$planning[$i][$heure_debut];
					if (isset($_GET['mode']) && $_GET['mode'] == "ct") // en mode ct, outre l'edt, le contenu du cahier de textes sera affich dans le planning
					{
						// on recherche donc pour chaque cours si le ct correspondant est publi
						// il nous faut la date (on l'a dj c'est $date_jour), le code_structure, le code_matiere (on l'a : $code_matiere)
						if ($categorie == "classes")
						{
							// Attention pour les groupes (notamment les langues), le ct ne sera pas affich si on ne peut pas dterminer le nom du groupe
							$sql2 = "SELECT code_structure FROM services WHERE code_matiere='$code_matiere' AND code_structure='".quote_smart($_GET['edt'])."'";
							$resultat2 = mysql_query($sql2);
							if (mysql_num_rows($resultat2) == 1) // la matire est enseigne en classe en entire, ce n''est pas un groupe
								$code_structure = quote_smart($dequi);
							else // la matire est enseigne en groupe
							{
								// il faut trouver le nom du groupe que l'enseignant qui assure ce cours a en responsabilit
								$sql3 = "SELECT t1.code_structure FROM services as t1,structures as t2, enseignants_services as t3 WHERE t1.code_structure=t2.code_structure AND divisions_appartenance like '%".quote_smart($_GET['edt'])."%' AND t1.code_matiere='$code_matiere' AND t3.id_service=t1.id_service AND t3.id_individu='$id_individu'";
								$resultat3 = mysql_query($sql3);
								$ligne3 = mysql_fetch_array($resultat3);
								$code_structure = $ligne3['code_structure'];
							}		
						}
						elseif ($categorie == "professeurs")
						{
							$code_structure = $cours_avec;						
						}
						// On ajoute au planning les entres de CT concernant le cours 
						add_planning_ct($i,$heure_debut,$date_jour,$code_structure,$code_matiere,$libelle_edition_matiere,$categorie,$count_cours_paralleles,$id_individu,$code_alternance,$quinzaine,$date_cours);
						if ($code_matiere == "040600" || $code_matiere == "041400") // code matire pour l'histoire-go ou l'ducation civique : il faudra peut-tre cumuler les entres de CT pour les 2 matires
						{
							// Cumul uniquement si c'est le mme prof
							// Est-ce le mme prof qui enseigne les 2 ?
							$sql4 = "SELECT DISTINCT id_individu FROM enseignants_services as t1,services as t2 WHERE t1.id_service=t2.id_service AND (t2.code_matiere='040600' OR t2.code_matiere='041400') AND code_structure='$code_structure'";
							// DEBUGG print $sql4."<br />";
							$resultat4 = mysql_query($sql4);
							if ($resultat4 && mysql_num_rows($resultat4) == 1) // C'est bien le mme prof qui enseigne HG + Education civique
							{
								if ($code_matiere == "040600") // Si l'HG est dans l'EDT
								{ 
									// les entres de CT concernant l'HG sont dl dans le planning_ct
									// on ajoute les entres de CT concernant l'ducation civique (si elles existent)
									if ($planning_ct[$i][$heure_debut] != "") // si vide, pas besoin de sparateur
										$planning_ct[$i][$heure_debut] .= "!HG%EC!"; // pour ajouter un sparateur entre HG et Education civique
									if ($planning_ct_nopub[$i][$heure_debut] != "")
										$planning_ct_nopub[$i][$heure_debut] .= "!HG%EC!";
									add_planning_ct($i,$heure_debut,$date_jour,$code_structure,"041400","Education civique",$categorie,$count_cours_paralleles,$id_individu,$code_alternance,$quinzaine,$date_cours);									
								}
							}
						}
					}
					$pointeur_data_seek++; // pointeur interne incrment
					if ($pointeur_data_seek < $nb_cours) // si c'est gal cela gnre une erreur
						mysql_data_seek($resultat,$pointeur_data_seek); // avant le prochain appel  mysql_fetch_array($resultat), on remet le pointeur correctement car il a peut-tre t modifi par un autre accs  la ressource MySQL
				}
			}
			else // pas de cours pour ce jour
			{
				$planning[$i] = array(); // tableau vide
			}
		}
		else // pas de cours car ce jour est un jour de vacances
		{
			$planning[$i] = array(); // tableau vide
		}	
	}
	// DEBUGG print "TABLE : $table";var_dump($planning);print "<hr/>";
	// DEBUGG print "Planning_ct : ";var_dump($planning_ct);
	// DEBUGG print "Planning_ct_nopub : ";var_dump($planning_ct_nopub);
	return $planning;
}

function add_planning_ct($i,$heure_debut,$date_jour,$code_structure,$code_matiere,$libelle_edition_matiere,$categorie,$count_cours_paralleles,$id_individu,$code_alternance,$quinzaine,$date_cours)
{
	/**
	 * Ajoute au planning de l'edt les entres de cahier de textes correspondantes
	 * 
	 * @param $i : n de jour dans la semaine, 1re cl du tableau $planning_ct
	 * @param $heure_debut : heure de debut du cours, 2me cl du tableau $planning_ct
	 * @param $date_jour : date du jour au format MySQL
	 * @param $code_structure : dnomination de la classe ou du groupe
	 * @param $code_matiere : code de la matire concerne
	 * @param $libelle_edition_matiere : libell de la matire concerne
	 * @param $categorie : type de planning EDT concern (classes, professeurs)
	 * @param $count_cours_paralleles : si 1, pas de cours en parallle, si > 1 => nombre de cours en parallle (ne sert que pour un edt classe)
	 * @param $id_individu : identifiant numrique du prof qui assure le cours
	 * @param $code_alternance : H si le cours est hebdomadaire, Q1 si en semaine 1, Q2 si en semaine 2
	 * @param $quinzaine : semaine en cours de consultation (Q1 ou Q2)
	 * @param $date_cours : contient la date d'un cours ponctuel (vide si le cours n'est pas ponctuel)
	 * 
	 */
	
	global $planning_ct, $planning_ct_nopub, $planning; // $planning_ct_nopub contiendra les entres non publies
	
	// L'ajout ne sera excut que si l'alternance du cours est hebdomadaire, le cours est ponctuel, ou si la quinzaine en cours est la bonne
	if ($code_alternance == "H" || $code_alternance == $quinzaine || $date_jour == $date_cours)
	{
		$date = $date_jour;
	
		// gestion des cours en parallle
		if ($categorie == "classes" && $count_cours_paralleles > 1 && $planning_ct[$i][$heure_debut] != "") // UNIQUEMENT pour un edt classe : gestion des cours en parallle (mme crneau horaire, mais matire diffrente : ex langues ANGLAIS pour les uns, ESPAGNOL pour les autres)
		{
			// on concatne avec le cours existant dj, le sparateur de cours parallles est "!%!" (sera trait dans la fonction affiche_ct())
			$planning_ct[$i][$heure_debut] .= "!%!";
		}
		else 
			$planning_ct[$i][$heure_debut] .= ""; // ncessaire car si $planning_ct[$i][$heure_debut] n'est pas encore dfini et si les requtes SQL suivantes ne donnent rien, aucune valeur ne sera dfinie pour $planning_ct[$i][$heure_debut], or si pas d'entre de cahiers de textes  afficher, il faut que la valeur soit vide
	
		// le TAF donn pour ce jour
		$sql1 = "SELECT id_afaire,afaire,t1.id_ctexte,t1.publication FROM a_faire as t1,cahiers_textes as t2 WHERE id_individu='$id_individu' AND pourle='$date' AND t1.id_ctexte=t2.id_ctexte AND code_structure='$code_structure' AND code_matiere='$code_matiere' AND id_sous_matiere='0' ORDER BY id_ctexte";
		$resultat1 = mysql_query($sql1);
		if (mysql_num_rows($resultat1) > 0)
		{
			if (mysql_num_rows($resultat1) > 1) // +sieurs TAF => sous forme de liste  puces
			{
				$k = 1;
				$taf_jour = "<ul>";
				$taf_jour_nopub = "<ul>";
				while ($ligne = mysql_fetch_array($resultat1))
				{
					// Quel jour a-t-on donn ce TAF ?
					$date_init_taf = date_mysql_to_jjmmaaaa_tiret(quelle_date_ctexte($ligne['id_ctexte']));
					
					// lien de modif dans lightbox pour le prof "propritaire"
					if($id_individu == $_SESSION['identifiant_individu'])
						$lien_modif_taf = "<a href='cahiers_textes.php?date=".$date_init_taf."&amp;set_classe=$code_structure&amp;matiere=$code_matiere#ancre_afaire".$ligne['id_afaire']."' title='Modifier/Supprimer ce travail'><img src='".$GLOBALS['chemin_relatif']."images/kwrite24x24.png' alt='[Modifier/Supprimer ce Travail]' /></a>";
					
					// Affichage du visa ventuel (DIR ou IPR : le plus rcent) : uniquement si la sance est dj renseigne
   	  				global $db;
      				$CdtVisaManager = new CdtVisaManager($db);
      				$code_affichage_visa = $CdtVisaManager->afficheTamponVisa($ligne['id_ctexte'],$icon_size = "medium");
      				if ($code_affichage_visa != "") { // il y a un visa  afficher
        				$lien_modif_taf = "<div style='float:right;position:relative;'>$code_affichage_visa</div>";	// le visa remplace l'icne de modification : le TAF ne peut pas tre modifi
        			}
      				if ($ligne['publication'] == "0" AND $id_individu == $_SESSION['identifiant_individu']) // les entres non publies sont inscrites dans le tableau $planning_ct_nopub uniquement pour le prof qui consulte l'edt (si les entres lui appartiennent)
					{
						$taf_jour_nopub .= "<li><div class='title_taf_lightbox'>Travail $k (donn le $date_init_taf)  $lien_modif_taf <span class='rouge'>non publi&nbsp;!</span></div>".secure_separators_ct($ligne['afaire'])."</li>";
						$taf_jour_nopub .= ct_cherche_docs_associes("id_afaire",$ligne['id_afaire'],$code_structure,$libelle_edition_matiere);
					}
					elseif ($ligne['publication'] == "1")
					{
						$taf_jour .= "<li><div class='title_taf_lightbox'>Travail $k (donn le $date_init_taf)  $lien_modif_taf</div>".secure_separators_ct($ligne['afaire'])."</li>";
						$taf_jour .= ct_cherche_docs_associes("id_afaire",$ligne['id_afaire'],$code_structure,$libelle_edition_matiere);
					}
					$k++;
				}
				$taf_jour .= "</ul>";
				$taf_jour_nopub .= "</ul>";
				if ($taf_jour_nopub != "<ul></ul>" AND $id_individu == $_SESSION['identifiant_individu']) // les entres non publies sont inscrites dans le tableau $planning_ct_nopub uniquement pour le prof qui consulte l'edt (si les entres lui appartiennent)
					$planning_ct_nopub[$i][$heure_debut] .= $id_individu."!###!".$taf_jour_nopub; // pour reprer le prof
				if ($taf_jour != "<ul></ul>") 
					$planning_ct[$i][$heure_debut] .= $id_individu."!###!".$taf_jour; // pour reprer le prof
				}
			else // un seul TAF
			{
				$ligne = mysql_fetch_array($resultat1);
				// Quel jour a-t-on donn ce TAF ?
				$date_init_taf = date_mysql_to_jjmmaaaa_tiret(quelle_date_ctexte($ligne['id_ctexte']));
				// lien de modif dans lightbox pour le prof "propritaire"
				if($id_individu == $_SESSION['identifiant_individu'])
					$lien_modif_taf = "<a href='cahiers_textes.php?date=".$date_init_taf."&amp;set_classe=$code_structure&amp;matiere=$code_matiere#ancre_afaire".$ligne['id_afaire']."' title='Modifier/Supprimer ce travail'><img src='".$GLOBALS['chemin_relatif']."images/kwrite24x24.png' alt='[Modifier/Supprimer ce Travail]' /></a>";
				
				// Affichage du visa ventuel (DIR ou IPR : le plus rcent) : uniquement si la sance est dj renseigne
   	  			global $db;
      			$CdtVisaManager = new CdtVisaManager($db);
      			$code_affichage_visa = $CdtVisaManager->afficheTamponVisa($ligne['id_ctexte'],$icon_size = "medium");
      			if ($code_affichage_visa != "") { // il y a un visa  afficher
        			$lien_modif_taf = "<div style='float:right;position:relative;'>$code_affichage_visa</div>";	// le visa remplace l'icne de modification : le TAF ne peut pas tre modifi
        		}
      			if ($ligne['publication'] == "0")
					$info_nopub = "<span class='rouge'>non publi&nbsp;!</span>";
				$taf_jour = "<div class='title_taf_lightbox'>(donn le $date_init_taf)  $lien_modif_taf $info_nopub</div>";
				if ($ligne['publication'] == "0" AND $id_individu == $_SESSION['identifiant_individu']) // les entres non publies sont inscrites dans le tableau $planning_ct_nopub uniquement pour le prof qui consulte l'edt (si les entres lui appartiennent)
					$planning_ct_nopub[$i][$heure_debut] .= $id_individu."!###!".$taf_jour.secure_separators_ct($ligne['afaire']).ct_cherche_docs_associes("id_afaire",$ligne['id_afaire'],$code_structure,$libelle_edition_matiere);
				elseif ($ligne['publication'] == "1")
					$planning_ct[$i][$heure_debut] .= $id_individu."!###!".$taf_jour.secure_separators_ct($ligne['afaire']).ct_cherche_docs_associes("id_afaire",$ligne['id_afaire'],$code_structure,$libelle_edition_matiere);
			}
			if ($planning_ct_nopub[$i][$heure_debut] != "" AND $id_individu == $_SESSION['identifiant_individu']) // les entres non publies sont inscrites dans le tableau $planning_ct_nopub uniquement pour le prof qui consulte l'edt (si les entres lui appartiennent)
				$planning_ct_nopub[$i][$heure_debut] .= ":%:"; // sparateur entre le TAF et le contenu
			if ($planning_ct[$i][$heure_debut] != "") 
				$planning_ct[$i][$heure_debut] .= ":%:"; // sparateur entre le TAF et le contenu
		}
		// Entre de cahier de texte du jour
		$sql2 = "SELECT id_ctexte,activite,publication FROM cahiers_textes as t1 WHERE id_individu='$id_individu' AND date='$date' AND code_structure='$code_structure' AND code_matiere='$code_matiere' AND id_sous_matiere='0'";
		$resultat2 = mysql_query($sql2);
		if (mysql_num_rows($resultat2) > 0)
		{
			$ligne = mysql_fetch_array($resultat2);
				
			// lien de modif ou Visa dans lightbox pour le prof "propritaire" (Si Visa, pas de lien de modif possible)
			if($id_individu == $_SESSION['identifiant_individu'])
			{
				$date_contenu = date_mysql_to_jjmmaaaa_tiret(quelle_date_ctexte($ligne['id_ctexte']));
				$lien_modif = "<a href='cahiers_textes.php?date=".$date_contenu."&amp;set_classe=$code_structure&amp;matiere=$code_matiere#bandeau_nav_datecours_ctx' title='Modifier/Supprimer ce contenu de sance'><img src='".$GLOBALS['chemin_relatif']."images/kwrite24x24.png' alt='[Modifier/Supprimer ce contenu de sance]' /></a>";
        	}
			else // Ce n'est pas le prof propritaire qui consulte le CT
				$lien_modif = "";
			
			// Affichage du visa ventuel (DIR ou IPR : le plus rcent) : uniquement si la sance est dj renseigne
   	  		global $db;
      		$CdtVisaManager = new CdtVisaManager($db);
      		$code_affichage_visa = $CdtVisaManager->afficheTamponVisa($ligne['id_ctexte']);
      		if ($code_affichage_visa != "") { // il y a un visa  afficher
        		$lien_modif = "<div style='float:right;position:relative;'>$code_affichage_visa</div>";	// le visa remplace l'icne de modification : l'entre de cahier de textes ne peut pas tre modifie
        	}
      		if (strpos($planning_ct[$i][$heure_debut],$id_individu."!###!") !== false) // l'identifiant individu est dj prsent (devant le TAF)
			{
				if ($ligne['publication'] == "0" AND $id_individu == $_SESSION['identifiant_individu']) // les entres non publies sont inscrites dans le tableau $planning_ct_nopub uniquement pour le prof qui consulte l'edt (si les entres lui appartiennent)
					$planning_ct_nopub[$i][$heure_debut] .= $lien_modif.secure_separators_ct($ligne['activite']).ct_cherche_docs_associes("id_ctexte",$ligne['id_ctexte'],$code_structure,$libelle_edition_matiere);
				else
					$planning_ct[$i][$heure_debut] .= $lien_modif.secure_separators_ct($ligne['activite']).ct_cherche_docs_associes("id_ctexte",$ligne['id_ctexte'],$code_structure,$libelle_edition_matiere);
			}
			else // si pas de TAF, il faut identifier l'auteur
			{
				if ($ligne['publication'] == "0" AND $id_individu == $_SESSION['identifiant_individu'])
					$planning_ct_nopub[$i][$heure_debut] .= $id_individu."!###!".$lien_modif.secure_separators_ct($ligne['activite']).ct_cherche_docs_associes("id_ctexte",$ligne['id_ctexte'],$code_structure,$libelle_edition_matiere);
				elseif ($ligne['publication'] == "1")
					$planning_ct[$i][$heure_debut] .= $id_individu."!###!".$lien_modif.secure_separators_ct($ligne['activite']).ct_cherche_docs_associes("id_ctexte",$ligne['id_ctexte'],$code_structure,$libelle_edition_matiere);
			}
		}
	}
}

function debut_semaine_navigation($debut_semaine, $increment)
{
	/* permet de fournir la date de dbut de semaine cible dans les liens de navigation semaine prcdente/suivante
	 * @param $debut_semaine : date du dbut de la semaine encours de consultation
	 * @param $increment : nombre de semaine d'cart par rapport  la semaine en cours (vaut soit -1 soit +1)
	 * 
	 * */
	$sql = "SELECT date_debut_semaine FROM semaines_alternances WHERE code_alternance='H'"; // on rcupre toutes les semaines
	// DEBUGG print $sql."<hr />";
	$resultat = mysql_query($sql);
	$liste_semaines = array();
	while ($ligne = mysql_fetch_array($resultat))
	{
		$liste_semaines[] = $ligne['date_debut_semaine'];
	}
	$offset = array_search($debut_semaine,$liste_semaines);
	if ($offset) // le debut de semaine est trouv
	{
		$new_offset = $offset + $increment;
	}
	else // Le dbut de semaine n'est pas trouv : on est pendant les vacances (il faut alors pointer selon l'incrment vers la semaine prcdent ou suivant les vacances)
	{
		foreach ($liste_semaines as $key => $value)
		{
			if ($value > $debut_semaine)
			{
				$offset_next = $key; // on a l'offset de la semaine (hors priode vacances) qui suit celle en cours de consultation
				break; // on sort de la boucle car la semaine en cours de consultation est mainteant encadre par la semaine prcdente ($offset_perv) et la semaine suivante ($offset_next)
			}
			else 
				$offset_prev = $key; // la dernire valeur de $offset_prev sera l'offset de la semaine (hors priode vacances) qui prcde celle en cours de consultation
		}
		if ($increment == 1)
			$new_offset = $offset_next;
		elseif ($increment == -1)
			$new_offset = $offset_prev;
		else // ne devrait pas se produire, mais dans ce cas un planning vide sera affich
			$new_offset = -1;
	}
	$new_debut_semaine = $liste_semaines[$new_offset];
	// DEBUGG var_dump($debut_semaine,$liste_semaines,$offset,$new_offset,$new_debut_semaine);
	return $new_debut_semaine;
}

function affiche_liens($categorie)
{
  
	/** 
	 * Affiche les liens vers les edt autoriss selon la catgorie (classes, professeurs, salles)
	 * 
	 *  @param $categorie */
	
  // A l'entre sur la page, en fonction du paramtre categorie prcis dans l'url, on affiche les liens vers les emplois du temps correspondant aux autorisations
  global $data_dir;

  switch ($categorie)
  {
    case 'classes': // emplois du temps des classes
      $code_formulaire = "<br />
      Voici la liste des classes dont vous pouvez consulter l'emploi du temps&nbsp;:<br /><br />
      <table border='0'>
      ";
      // la variable de session suivante contient la liste des classes autorises (initialise avant l'appel de cette fonction)
      if (isset($_SESSION['liste_classes_edt']) && is_array($_SESSION['liste_classes_edt']))
      {
        foreach($_SESSION['liste_classes_edt'] as $value)
        {
          // si l'utilisateur connect est un responsable, on affichera le prnom de l'enfant  ct de la classe
          if ($_SESSION['valid_group'] == "4")
          {
          	$precision = "";
          	foreach ($_SESSION['enfants_scol'] as $enfant)
          	{
          		$fragment = explode(",",$enfant);
          		if ($value == $fragment[3])
          			$precision = " ($fragment[2])";
          	}
          }
          // Si l'accs s'effectue depuis un lien du sommaire du cahier de textes
          if (isset($_GET['taf']) && isset($_GET['content']) && $_GET['taf'] == "true" && $_GET['content'] == "true")
          	$url_param_ct = "&amp;mode=ct&amp;taf=true&amp;content=true"; // Affichage des intros des TAF et des contenus de sance dans le planning EDT
          else 
          $url_param_ct = "";
          // et on affiche le lien correspondant
          $code_formulaire .= "
          <tr>
            <td>
              <a href='edt.php?categorie=".$categorie.$url_param_ct."&amp;edt=".$value."' title=\"Voir l'emploi du temps de la classe de ".$value."\">$value$precision</a>
            </td>
            <td width='20px'>
             &nbsp;
            </td>
            <td>
              <a href='eqpedag.php?classe=$value'>[Voir l'quipe pdagogique de $value]</a>
            </td>
          </tr>
          ";
        }
      }
      elseif (isset($_SESSION['liste_classes_edt'])) // une seule classe est autorise  la consultation
      {
      	// si l'utilisateur connect est un responsable, on affichera le prnom de l'enfant  ct de la classe
        if ($_SESSION['valid_group'] == "4")
        {
        	$precision = "";
        	foreach ($_SESSION['enfants_scol'] as $enfant)
          	{
          		$fragment = explode(",",$enfant);
          		if ($_SESSION['liste_classes_edt'] == $fragment[3])
          			$precision = " ($fragment[2])";
          	}
        }
      	$code_formulaire .= "
          <tr>
            <td>
              <a href='edt.php?categorie=".$categorie."&amp;edt=".$_SESSION['liste_classes_edt']."' title=\"Voir l'emploi du temps de la classe de ".$_SESSION['liste_classes_edt']."\">".$_SESSION['liste_classes_edt'].$precision."</a>
            </td>
            <td width='20px'>
             &nbsp;
            </td>
            <td>
              <a href='eqpedag.php?classe=".$_SESSION['liste_classes_edt']."'>[Voir l'quipe pdagogique de ".$_SESSION['liste_classes_edt']."]</a>
            </td>
          </tr>
          ";
       }
      $code_formulaire .= "
      </table>
      <br /><br />";
      break;
      
    case 'professeurs':
      // On cherche la liste des profs
      if ($_SESSION['valid_group'] == "11")
      {
      	// La personne connecte est un IPR, on cherche les profs inspects
      	$sql = "SELECT liste_profs FROM ipr WHERE id_pers='".$_SESSION['valid_id_user']."'";
      	$resultat = mysql_query($sql);
      	if (mysql_num_rows($resultat)>0)
      		$ligne = mysql_fetch_array($resultat);
      	$sql = "SELECT id_individu,prenom,nom,civilite FROM personnel where id_individu IN(".$ligne['liste_profs'].") ORDER BY nom,prenom";
      }	
      else
     	$sql = "SELECT id_individu,prenom,nom,civilite FROM personnel where categorie='7' ORDER BY nom,prenom";
      $resultat = mysql_query($sql);
      if ($resultat)
      {
        if (mysql_num_rows($resultat)>0)
        {
          $code_formulaire = "<br />
          Voici la liste des professeurs (classement alphabtique) dont vous pouvez consulter l'emploi du temps&nbsp;:<br /><br />
          <table border='0'>
          ";
          while ($ligne = mysql_fetch_array($resultat))
          {
            // Si l'accs s'effectue depuis un lien du sommaire du cahier de textes ou bien si c'est un ipr qui accde  l'edt d'un prof
          	if ((isset($_GET['taf']) && isset($_GET['content']) && $_GET['taf'] == "true" && $_GET['content'] == "true") || $_SESSION['valid_group'] == "11")
          		$url_param_ct = "&amp;mode=ct&amp;taf=true&amp;content=true"; // Affichage des intros des TAF et des contenus de sance dans le planning EDT
          	else 
          		$url_param_ct = "";
          	$code_formulaire .= "
            <tr>
              <td>
              <a href='".$_SERVER['PHP_SELF']."?categorie=professeurs".$url_param_ct."&amp;edt=".$ligne['id_individu']."' title=\"Consulter l'emploi du temps de ".ucfirst(strtolower($ligne['prenom']))." ".$ligne['nom']."\">".$ligne['nom']." ".ucfirst(strtolower($ligne['prenom']))."</a>
              </td>
            </tr>
            ";
          }
          $code_formulaire .= "
          </table>
          <br /><br />";
        }
        else
        {
          $error_message = array("La liste des professeurs est vide. Il est probable que le gestionnaire de contenu <b>gestadmin</b> n'a pas encore mis  jour la base du personnel.","");
          affiche_erreurs($error_message);
        }
      }
      else
      {
        $error_message = array("Le serveur de base de donne est indisponible pour le moment. La liste des professeurs est donc introuvable. Veuillez ressayer ultrieurement.","");
        affiche_erreurs($error_message);
      }
      break;
    
    case 'salles':
    	$error_message = array("Les emplois du temps des salles ne sont pas disponibles dans cette version <abbr title='IntraEduWeb'>IEW</abbr>.","");
        affiche_erreurs($error_message);
            break;
  }
  echo "<br /><center>";
  squelette_formulaire_standard("85%","","","<h2 class = 'hidden'>Liste des Emplois du temps consultables</h2>Liste des Emplois du temps consultables",$code_formulaire,"","","","","","","");
  echo "</center>";
}

function cherche_classe($critere)
{
  // on cherche ici la ou le classes dont on peut voir l'edt (la liste est stocke dans une variable de session)

  if (!isset($_SESSION['liste_classes_edt'])) // on ne cherche pas si la variable de session est dj dfinie
  {
    switch ($critere)
    {
      case 'parent':
        // Seules les classes des enfants scolariss dans l'tablissement seront accessibles
        $sql = "SELECT t1.classe,t1.prenom FROM eleves as t1, responsables_eleves as t2 WHERE t1.eleve_id=t2.eleve_id AND t2.personne_id='".$_SESSION['identifiant_individu']."' ORDER by t1.classe";
        $resultat = mysql_query($sql);
        if ($resultat)
        {
          if (mysql_num_rows($resultat)>0)
          {
            while($ligne = mysql_fetch_array($resultat))
            {
              $_SESSION['liste_classes_edt'][] = $ligne['classe'];
            }
          }
          else
          {
           $error_message = array("<div align='justify'>La(les) classe(s) de votre(vos) enfant(s) est(sont) introuvable(s). Veuillez contacter <a href='mailto:".email_encode($GLOBALS['admin_email'])."'>l'administrateur IntraEduWeb</a>.</div>","");
           affiche_erreurs($error_message);
           return;
          }
        }
        else
        {
          $error_message = array("Le serveur de base de donnes est indisponible. Veuillez ressayer ultrieurement.","");
          affiche_erreurs($error_message);
          return;
        }
        break;
      case 'eleve':
      // une seule classe sera autorise : la sienne !
        $sql = "SELECT t1.classe FROM eleves as t1, login as t2 WHERE t1.id_eleve=t2.id_pers AND t2.id_pers='".quote_smart($_SESSION['valid_id_user'])."'";
        $resultat = mysql_query($sql);
        if ($resultat)
        {
          if (mysql_num_rows($resultat)>0)
          {
            $ligne = mysql_fetch_array($resultat);
            $_SESSION['liste_classes_edt'] = $ligne['classe'];
          }
          else
          {
           $error_message = array("<div align='justify'>Votre classe est introuvable. Veuillez contacter <a href='mailto:".email_encode($GLOBALS['admin_email'])."'>l'administrateur IntraEduWeb</a>.</div>","");
           affiche_erreurs($error_message);
           return;
          }
        }
        else
        {
          $error_message = array("Le serveur de base de donnes est indisponible. Veuillez ressayer ultrieurement.","");
          affiche_erreurs($error_message);
          return;
        }
        break;
    
      case 'ipr':
      	// les classes autorises pour l'ipr sont dj dans une variable de session
      	$_SESSION['liste_classes_edt'] = $_SESSION['ipr_liste_codes_structures'];
      	break;
      
      case 'toutes':
        // Ce sera les cas pour tous les utilisateurs authentifis autres que les parents et les lves
        $sql = "SELECT division FROM divisions";
        $resultat = mysql_query($sql);
        if ($resultat)
        {
          if (mysql_num_rows($resultat)>0)
          {
            while ($ligne = mysql_fetch_array($resultat))
            {
              $_SESSION['liste_classes_edt'][] = $ligne['division']; // on remplit le tableau avec les classes trouves
            }
          }
          else
          { 
            $error_message = array("<div align='justify'>Les classes sont introuvables. Veuillez contacter <a href='mailto:".email_encode($GLOBALS['admin_email'])."'>votre administrateur IntraEduWeb</a>.</div>","");
            affiche_erreurs($error_message);
            return;
          }
        }
        else
        {
          $error_message = array("Le serveur de base de donnes est indisponible. Veuillez ressayer ultrieurement.","");
          affiche_erreurs($error_message);
          return;
        }
        break;
    }
  }
}

function affiche_edt($param)
{
	/**
	 * Contrle l'affichage des edt
	 * 
	 *  @param $param : contient le profil de l'utilisateur qui demande  voir l'EDT */
	
	global $debut_semaine,$fin_semaine,$eleve_id;
  
	// Si c'est un lve, on assigne le paramtre edt (mme s'il n'xiste pas dans l'url) avec sa classe
	if ($param == "eleve")
	{
		$_GET['edt'] = $_SESSION['liste_classes_edt'];
	}	
	
	// Modulation du titre selon le type d'accs 
	if ($_GET['mode'] == "ct") // mode cahier de textes
    	$titre = "Cahier de Textes";
    else 
    	$titre = "Emploi du temps"; // mode normal
    	
  // le paramtre $param permet de grer les droits d'accs aux edt des classes
  if (isset($_GET['edt']) && $_GET['edt']!="") // la variable edt dans l'url
  {
  	// et on affiche l'edt demand
    if ($param == "eleve")
	{
		if ($_GET['mode'] == "ct") // mode cahier de textes
    		$titre = "Cahier de Textes";
    	else 
    		$titre = "Emploi du temps"; // mode normal
		echo "<h1>Mon $titre (".$_SESSION['liste_classes_edt'].")</h1>";
		$critere_trouve_planning = "classes"; // un lve ne peut pas voir les edt des professeurs ou des salles
		$dequi = $_SESSION['liste_classes_edt']; // mais seulement sa classe
	}
	elseif ($param == "parent")
	{
		// On va afficher le prnom de l'enfant dans le titre de l'edt
		$prenom = "";
        foreach ($_SESSION['enfants_scol'] as $enfant) // si le responsable a +sieurs enfants, on cherche le prnom de celui qui correspond  la classe choisie
        {
        	$fragment = explode(",",$enfant);
        	if ($_GET['edt'] == $fragment[3])
        	{
        		$prenom = $fragment[2];
        		$eleve_id = $fragment[0]; // sera utile dans le paramtre URL correspondant das le lien vers le cahier de textes de la matire au sein du planing edt
        	}
        }
          
		echo "<h1>$titre de la classe de $prenom (".$_GET['edt'].")</h1>";
		$critere_trouve_planning = "classes"; // un responsable ne peut pas voir les edt des professeurs ou des salles, mais seulement les edt des classes de ses enfants
		$dequi = $_GET['edt']; // edt de qui ? => C'est la classe choisie ici
	}
	elseif ($param == "professeur")
	{
		$sql = "SELECT nom, prenom FROM personnel WHERE id_individu='".quote_smart($_GET['edt'])."'";
        $resultat = mysql_query($sql);
        $ligne = mysql_fetch_array($resultat);
        $nom_prof = ucfirst(strtolower($ligne['prenom']))." ".$ligne['nom']; // sera rutilis aussi dans le lien du contrle de modification de l'EDT plus loin
        echo "<h1>$titre de $nom_prof</h1>";
		$critere_trouve_planning = $_GET['categorie']; // un professeur peut demander  voir les edt des classes, de ses collgues, des salles
		$dequi = $_GET['edt']; // edt de qui ? => C'est le prof choisi ici
	}
	elseif ($param == "classe")
	{
		echo "<h1>$titre de ".$_GET['edt']."</h1>";
		$critere_trouve_planning = "classes";
		$dequi = $_GET['edt']; // edt de qui ? => C'est la classe choisie ici
	}
	elseif ($param == "salle")
	{
		echo "<h1>Emploi du temps de la salle ".$_GET['edt']."</h1>";
		$critere_trouve_planning = "salles";
		$dequi = $_GET['edt']; // edt de qui ? => C'est la salle choisie ici
	}
    
	// Zone de notification de rponse AJAX, non affich par dfaut, mais contiendra les messages AJAX ou le formulaire de saisie/modification (si JS activ)
	echo "<div id='add_msg'>";
	// ventuellement, code de traitement du formulaire de saisie/modification d'un cours (si soumis) pour intgrer la modif dans la base de donnes avant d'afficher l'EDT demand
	if (isset($_GET['SubmitChangeForm']) && $_GET['SubmitChangeForm'] == true && isset($_POST['id_cours']))
		include('do_change_edt.php');
	echo "</div>";
	
	// Aprs le titre, un div cach contenant un formulaire de saisie/modification d'un cours (mode JS dsactiv)
	if (isset($_GET['changeform']) && $_GET['changeform'] == true)
	{
		echo "<div id='ChangeCoursBlockForm'>";
		include('form_change_edt.php');
		echo "</div>";
	}
	
	echo "<div id='content-edt'>";
	
	// On met ici un champ datepicker pour choisir la semaine
    $intitule_semaine = "Semaine du ".MySQLDateToExplicitDate($debut_semaine)." au ".MySQLDateToExplicitDate($fin_semaine, $WeekDayOn=1, $YearOn=1)." (Quinzaine&nbsp;:&nbsp;".quelle_semaine_alternance($debut_semaine).")";
    $url = ajouterParametreGET($_SERVER['REQUEST_URI'], "debut_semaine", "");
    // la suite suppose que le paramtre URL 'debut_semaine' est LE DERNIER dans la query_string (sinon un changement dans le datepicker sera sans effet)
    echo "<center><input id='choix_date_semaine_edt' type='text' class='datepicker' name='date' title='Cliquez sur le calendrier pour changer la date' style='margin: 0;' onchange='window.location.replace(\"$url\"+this.value)' value='".$intitule_semaine."' /></center>";
	echo "<h2 align='center'></h2>";
    /* 
    * on va prparer les liens de navigation d'une semaine  l'autre
    * */
	// s'il y a dj un paramtre GET debut_semaine dans l'url on le met  jour
    // on rcupre d'abord les paramtres dans l'url
    $url_get_params = recup_get_url($_GET);
    if (substr(recup_get_url($_GET),0,5) == "&amp;")
    	$url_get_params = substr($url_get_params,5,strlen($url_get_params)-5); // on retire le &amp; en dbut de chane afin que la query_string soit valide
	//DEBUGG print "Paramtres URL au chargement de la page : ";var_dump($url_get_params);
    if (stristr($url_get_params,"debut_semaine=")) // debut_semaine fait partie des paramtres fournis
    {
	    // on va extraire les autres paramtres situs avant le paramtre debut_semaine (on suppose qu'il n'y a rien aprs)
    	$fragments = explode("&amp;debut_semaine=", $url_get_params);
		// Le 1er elt contient les paramtres avant le paramtre debut_semaine : $fragments[0]
    	$new_url_put_params = $fragments[0]."&amp;debut_semaine=";
    	// DEBUGG print "Paramtres  injecter dans l'url : ";var_dump($new_url_put_params);
    }
    else // debut_semaine ne fait pas partie des paramtres fournis
    {
    	$new_url_put_params = $url_get_params."&amp;debut_semaine=";
    }
	echo "<div class='nav_left'>
    <a href='?".$new_url_put_params.debut_semaine_navigation($debut_semaine, -1)."'><img id='WeekNavLeft' src='".$GLOBALS['chemin_relatif']."images/little_previous.png' alt='[Semaine prcdente]' title='Consulter le planning de la semaine prcdente' /></a>
    </div>
    <div class='nav_right'>
    <a href='?".$new_url_put_params.debut_semaine_navigation($debut_semaine, 1)."'><img id='WeekNavRight' src='".$GLOBALS['chemin_relatif']."images/little_next.png' alt='[Semaine suivante]' title='Consulter le planning de la semaine suivante' /></a>
    </div>";  
    $planning_cours = trouve_planning("cours",$critere_trouve_planning,$dequi,$debut_semaine); // Voil le planning de la semaine selon le fichier EDT_vers_STS_RNE_Annee.xml
    // DEBUGG print "Tableau de planning_cours : "; var_dump($planning_cours); print "<br />";
	// DEBUGG print "Nombres de valeurs : ";  var_dump(count(enlever_valeurs_vides($planning_cours))); print "<hr />";
    
    $planning_cours_diff = trouve_planning("cours_diff",$critere_trouve_planning,$dequi,$debut_semaine); // Voil le planning de la semaine modifi manuellement
    // DEBUGG print "Tableau de planning_cours_diff : "; var_dump($planning_cours_diff); print "<br />";
	// DEBUGG print "Nombres de valeurs : ";  var_dump(count(enlever_valeurs_vides($planning_cours_diff))); print "<hr />";
    $planning = fusion_plannings($planning_cours,$planning_cours_diff); // Le planning qui sera affich correspond  la fusion des 2 plannings prcdents
	// DEBUGG print "Tableau de planning final (aprs fusion) : "; var_dump($planning); print "<br />";
	// DEBUGG print "Nombres de valeurs : ";  var_dump(count(enlever_valeurs_vides($planning))); print "<hr />";
	
	// Pour le script ct_day.php (affichage du cahier de textes  la journe)
	$_SESSION['planning_edt'] = $planning;
	$_SESSION['planning_edt_infos'] = array("categorie" => $_GET['categorie'], "edt" => $_GET['edt'], "debut_semaine" => $_GET['debut_semaine']);
	
    if (count(enlever_valeurs_vides($planning)) == 0)
    {
    	if ($_GET['categorie'] == "classes")
    		$classe_ou_prof = "cette classe";
    	elseif ($_GET['categorie'] == "professeurs")
    		$classe_ou_prof = "ce professeur";
    	$error_message = array("Il n'y a pas de service d'enseignement rattach  $classe_ou_prof pour la priode demande. C'est pourquoi l'Emploi du temps est vide. Vrifiez si la priode choisie se situe bien en dehors des vacances scolaires.","");
    	echo "<br/>";
    	affiche_erreurs($error_message);
    }
     if ($param != "eleve") // seuls les lves n'ont pas le droit de voir d'autres classes que la leur (les responsables ne voient que les classes de leurs enfants)
     {
    	$icone = array("classes" => "group.png", "professeurs" => "prof.png", "salles" => "");
    	if ($_GET['mode'] == "ct" && ($_GET['categorie'] != "professeurs" || $_SESSION['valid_group'] == "1" || $_SESSION['valid_group'] == "6"))
    		$url_mode_ct_params = "mode=ct&amp;taf=true&amp;content=true&amp;";
    	else 
    		$url_mode_ct_params = "";
     	echo "<center><a id='choose_edt' href='".$_SERVER['PHP_SELF']."?".$url_mode_ct_params."categorie=".$_GET['categorie']."'><img id='icon_choose_edt' src='".$GLOBALS['chemin_relatif']."images/".$icone[$_GET['categorie']]."' alt='[Choisir un/une autre ".substr($_GET['categorie'],0,strlen($_GET['categorie'])-1)."]' title='Choisir un ou une autre ".substr($_GET['categorie'],0,strlen($_GET['categorie'])-1)."' /></a>";
     	// utilis (ventuellement) dans le prochain test :
     	if (isset($_GET['modif']) && $_GET['modif'] == true) // si on est dj en mode modif, on affiche icne et lien qui permettent d'en sortir
     	{
     		$uri_query = str_replace("&modif=true","",$_SERVER['REQUEST_URI']);
     		$uri_query = str_replace("&","&amp;",$_SERVER['REQUEST_URI']);// Attention au problme des ampersands pour la validation si on modifie la query string
     		$icon_modif = "noedt_write.png";
     		$title = "Sortir du mode Modification";
     		$alt = "[Sortir du mode Modification]";
     	}
     	else // On pourra affiche le lien et l'icne d'entre dans le mode modif
     	{
     		$uri_query = str_replace("&","&amp;",$_SERVER['REQUEST_URI'])."&amp;modif=true"; // Attention au problme des ampersands pour la validation si on modifie la query string
     		$icon_modif = "edt_write.png";
     		if ($_GET['categorie'] == "classes")
     			$title = "Modifier l'emploi de ".$_GET['edt'];
     		elseif ($_GET['categorie'] == "professeurs")
     			$title = "Modifier l'emploi du temps de ".addslashes($nom_prof);
     		$alt = "[Modifier l'emploi du temps]";
     	} 
     	// On affiche ventuellement un lien vers un formulaire de modification de l'EDT
     	if ($_GET['categorie'] == "professeurs" && auth_modif_edt()) // seules les personnes autorises ont le droit de modifier les EDT de tous les profs
     	{
     		echo "<a id='lien_modif_edt' href='$uri_query'><img id='icon_modif_edt' src='".$GLOBALS['chemin_relatif']."images/$icon_modif' title=\"$title\" alt=\"$alt\" /></a>";
     	}
     	elseif ($_GET['categorie'] == "classes" && auth_modif_edt()) // seuls les personnes autorises ont le droit de modifier les EDT de toutes les classes
     	{
			echo "<a id='lien_modif_edt' href='$uri_query'><img id='icon_modif_edt' src='".$GLOBALS['chemin_relatif']."images/$icon_modif' title=\"$title\" alt=\"$alt\" /></a>";
     	}
     	// et enfin les contrles d'affichage du cahier de textes dans le planning EDT
     	if ($_GET['mode'] == "ct")
     	{
     		affiche_controles_display_ct();
     	}
     	echo "</center>";
     }
     else // les lves seuls
    {
    	if ($_GET['mode'] == "ct")
     	{
     		echo "<center>";
     		affiche_controles_display_ct();
     		echo "</center>";
     	}	
     } 
    // echo "<br />"; // pour que les flches de navigation ne soient pas trop prs du planning (consultation lve)
    affiche_planning($planning);
    echo "</div>";
  }
  else // le paramtre edt n'est pas renseign dans l'url
  {
    echo "<h1>$titre</h1>"; // titre gnrique
  	// alors on n'a pas d'edt particulier  afficher : il faut alors afficher les liens de la catgorie pour que l'utilisateur fasse un choix
    if (isset($_GET['categorie']) && $_GET['categorie'] == "classes")
      cherche_classe($param); // on cherche toutes les classes autorises (dpend de la valeur de $param)
    affiche_liens($_GET['categorie']);
  }
}

function choix_couleur()
{
	/**
	 * Permet de faire un choix alatoire de couleur parmi un groupe de couleurs
	 * 
	 * Les couples de couleur avant-plan et arrire plan sont choisis de manire  satisfaire le ratio
	 * de luminosit permettant de satisfaire aux niveaux AA et/ou AAA des WCAG 2.0
	 * 
	 * @return $couleur (couleur choisie au format avant-plan%arrire-plan)*/

	global $arrieres_plans_choisis;
	
	$couleurs_foncees = array(
	"rouges" => array("7e1111","964401","b33544","a00819","9a4b54","83644a","b8530f","614572"),
	"verts" => array("477703","426141","0a6606","596f3a","068700","585f07","207c42","415c40"),
	"bleus" => array("0066cb","0303a9","1271ae","561dd7","603ba5","290f63","6f49c6","6f6889"));
	
	$couleurs_claires = array(
	"rouges" => array("ffd5d5","f6a6a6","fd7474","f9af46","f6c887","e8c07a","ffd4d4","ffa2d9"),
	"verts" => array("a4ffa2","75f872","39ff34","c8ff34","f8ff34","fbff8c","5ef88d","acfbc4"),
	"bleus" => array("acfafb","72ddde","1cf8fb","a4e1fd","66cdfd","9fc9fd","b0abfd","dfabfd"));
	
	// on choisi alatoirement une couleur fonce, une couleur claire
	$i = rand(0,9);
	if (fmod($i,2) == 0) // si $i est pair
	{
		$type_couleurs = "couleurs_foncees";
		$avt_plan = "fff";
	}
	else
	{
		$type_couleurs = "couleurs_claires";
		$avt_plan = "000";
	}
	// on choisi alatoirement un ton
	$j = rand(0,2); // car 3 ton possibles
	switch ($j)
	{
		case "0":
			$j = "rouges";
			break;
		case "1":
			$j = "verts";
			break;
		default:
			$j = "bleus";
	}
	// on choisi alatoirement une couleur dans le ton
	$k = rand(0,7); // car 8 couleurs possibles
	$arr_plan = array();
	$arr_plan = $$type_couleurs;
	
	// on regarde si la couleur d'arrire-plan n'a pas dj t choisie
	if (in_array($arr_plan[$j][$k], $arrieres_plans_choisis))
	{
		$couleur = choix_couleur(); // appel rcursif
	}
	else 
	{
		$couleur = $avt_plan."%".$arr_plan[$j][$k];	
		$arrieres_plans_choisis[] = $arr_plan[$j][$k];
	}
	return $couleur;
}

function assoc_matiere_couleurs()
{
	/** 
	 * Associe des couleurs d'arrite plan et d'avant plan par matire
	 * L'assiociation est ralise de faon alatoire  la premire excution du script
	 * 
	 * Elle est ensuite conserve dans une table afin de s'assurer d'avoir toujours les mmes associations
	 * Cette fonction n'est excute que si la table en question ne contient pas encore de donnes
	 *  
	 * @return $assoc_matieres_couleurs, tableau associatif dont les lments sont les couples de couleur d'avant plan et d'arrire plan
	 * et la cl est le libell court de la discipline 
	 * */
	
	$sql = "SELECT code_matiere FROM matieres_sconet ORDER BY libelle_court";
	$resultat = mysql_query($sql);
	if (mysql_num_rows($resultat)>0)
	{	
		$sql = "";
		while ($ligne = mysql_fetch_array($resultat))
		{
			$couple_couleurs = choix_couleur(); // choix alatoire d'un couple de couleurs avant-plan%arrire-plan
			$fragment = explode("%",$couple_couleurs);
			$avt_plan = $fragment[0];
			$arr_plan = $fragment[1];
			// on conserve les valeurs choisies dans la table couleurs_edt_matieres
			$sql = "INSERT INTO couleurs_edt_matieres VALUES('".$ligne['code_matiere']."','".$avt_plan."','".$arr_plan."')";
			mysql_query($sql);
		}
	}
}

function fusion_plannings($planning_cours,$planning_cours_diff)
{
	/**
	 * Ralise la fusion des donnes entre le planning issu de la table "cours" (provenance des donnes = import de EDt_vers_STS_RNE_Annee.xml)
	 * et le planning issu de la table "cours_diff" (provenances des donnes = saisie manuelle par formulaire)
	 */
	
	global $horaires_sql;
	// DEBUGG var_dump($horaires_sql);
	// Si l'un des 2 est vide, c vite fait ! On renvoie l'autre...
	if (empty($planning_cours_diff))
	{
		$planning = $planning_cours;
		return $planning;
	}
	if (empty($planning_cours))
	{
		$planning = $planning_cours_diff;
		return $planning;
	}
	// Si on est ici c qu'il faut fusionner
	// il faut boucler sur l'ensemble des jours et des horaires = $horaires_sql (car comme on a que les dbut de cours, avec les crneaux de 2 heures ou plus conscutives, on risque de ne pas prendre en compte certains cours de la talbe cours_diff)
	for ($i=1;$i<=6;$i++) // pour chaque jour de la semaine
	{
		if (!empty($planning_cours_diff[$i])) // l'autre tableau n'est pas vide sur ce jour, il faut fusionner les infos
		{
			foreach ($horaires_sql as $debut_cours)
 			{
 				if (array_key_exists($debut_cours,$planning_cours_diff[$i]))
 				{
 					$contenu_cours = $planning_cours_diff[$i][$debut_cours]; // chane concatne correspondant au(x) cour(s)  cet horaire (il peut y avoir des cours parallles)
 					if (!empty($contenu_cours))
					{
						// Voil la fusion  faire
						$frag_cours_paralleles = explode("!%!",$contenu_cours); // on spare les cours parallles
						foreach ($frag_cours_paralleles as $cours) // si pas de cours parallle, boucle excute une seule fois
						{
							$infos_cours = explode("#",$cours);
							$structure_complete = $infos_cours[0]; // 1 ou 0 selon que le cours concerne ou pas la structure complte (classe entire)
							$type_diff = $infos_cours[1]; // add, del ou mod
							if ($type_diff == "add" || $type_diff == "mod")
							{
								// Si le cours concerne une partie de la classe seulement et si l'edt est celui d'une classe
								if ($structure_complete == 0 && $_GET['categorie'] == "classes")
								{
									$planning_cours[$i][$debut_cours] .= "!%!".$cours; // le cours ajout remplace le crneau libre dans le planning
									if (substr($planning_cours[$i][$debut_cours],0,3) == "!%!") // on vite d'avoir une case blanche en cas de cours parallles, mais cela ne permet plus d'ajouter un nouveau cours en parallle (icne en forme de "+") depuis l'edt de la classe : il faut le faire  partir de l'edt d'un prof
										$planning_cours[$i][$debut_cours] = substr($planning_cours[$i][$debut_cours],3,strlen($planning_cours[$i][$debut_cours]));
								}
								else // classe entire
									$planning_cours[$i][$debut_cours] .= "!%!".$cours; // le cours ajout remplace le crneau libre dans le planning, le cours modifi remplace le cours d'origine
							}
							elseif ($type_diff == "del")
								$planning_cours[$i][$debut_cours] .= "!%!".$infos_cours[0]."#".$infos_cours[1]."#".$infos_cours[2]; // Le cours "d'origine" est "supprim", il n'y aura pas de contenu  afficher, masi seulement les infos ncessaires au rtablissement ventuel du cours d'origine
						}
					}
 				}
 				// On vrifie que la chane concatne correspondant au(x) cour(s)  cet horaire rsultat de la fusion ne commence, ni ne termine par "!%!", sinon il y aura des case blanches affiches dans le planning final
				if (substr($planning_cours[$i][$debut_cours],0,3) == "!%!")
				$planning_cours[$i][$debut_cours] = substr($planning_cours[$i][$debut_cours],3,strlen($planning_cours[$i][$debut_cours])-3); 			
			}
 		}
 		ksort($planning_cours[$i]); // tri suivant les horaires
	}
	$planning = $planning_cours;
	// DEBUGG print "PLANNING DE FUSION";var_dump($planning);print "<hr/>";
	return $planning; 
}

function affiche_ct($classe,$libelle_edition_matiere,$date_jour,$i,$j,$nb_cours_paralleles,$rang_parallele,$id_individu,$nopub=false)
{
	/**
	 * Affiche au sein du planning EDT, les intros des TAF et des contenus de sance du cahier de textes
	 * 
	 * @param $classe : classe concerne (sera dans le titre de la lightbox)
	 * @param $libelle_edition_matiere : le nom complet de la matire concerne
	 * @param $date : la date du jour au format MySQL
	 * @param $i : indice de l'horaire dans le planning
	 * @param $j : indice du jour dans le planning
	 * @param $nb_cours_paralleles : indique le nombre de cours en parallle  cet horaire (=0 si un seul cours, 2 si 2 cours...)
	 * @param $rang_parallele : indique (si le cours est en parallle avec d'autres) le rang du cours parallle  cet horaire : 1, 2, 3 etc.
	 * @param $id_individu : identifiant du prof, pour associer correctement l'intro avec le bon prof en cas de cours parallles
	 * @param $nopub (optionnel) : vaut true si on doit afficher les intros des entres de cahier de textes non publies, sinon vaut false  
	 * 
	 */
	
	global $planning_ct,$planning_ct_nopub,$horaires_sql; // $planning_ct contient les lments du cahier de textes heure par heure au format 
	// $horaire_sql contient les heures de dbut de cours, cls du tableau $planning_ct
	
	if ($nopub == true) // Affichage des entres non publies
		$planning_local = $planning_ct_nopub; // on travaille avec le tableau nopub
	else // Affichage des entres publies
		$planning_local = $planning_ct; // on travaille avec le tableau normal
	
	// selon les paramtres URL, on affiche ou on masque certains lments (TAF, contenu ou entres non publies)
	if ($_GET['taf'] == "true")
		$add_style_ctIntoDiv_Taf = "style='display: block'";
	else 
		$add_style_ctIntoDiv_Taf = "";
	if ($_GET['content'] == "true")
		$add_style_ctIntoDiv_Content = "style='display: block'";
	else 
		$add_style_ctIntoDiv_Content = "";
	if ($_GET['nopub'] == "true")
	{
		$add_style_ctIntoDiv_Tafnopub = "style='display: block'";
		$add_style_ctIntoDiv_Contentnopub = "style='display: block'";
	}
	else 
	{
		$add_style_ctIntoDiv_Tafnopub = "";
		$add_style_ctIntoDiv_Contentnopub = "";
	}
	
	if ($nb_cours_paralleles !=0) // il y a des cours parallles avec chacun des donnes de cahier de textes  afficher
	{
		// On spare les cours parallles
		if (strpos($planning_local[$j]{$horaires_sql[$i-1]},"!%!") !== false) // s'il au moins 2 profs ont publi dans le cahier de textes
		{
			$frag_cours_paralleles = explode("!%!",$planning_local[$j]{$horaires_sql[$i-1]});
			// Il faut dterminer quel fragment il faut afficher pour ne pas se tromper de cours
			$a_traiter = $frag_cours_paralleles[$rang_parallele-1];
		}
		else // il y a des cours parallles, mais un seul prof a renseign et publi le cahier de textes
			$a_traiter = $planning_local[$j]{$horaires_sql[$i-1]};
			
		// Est-ce le bon prof ?
		if ($a_traiter != "")
		{
			$frag_prof = explode("!###!",$a_traiter); // $frag_prof[0] contient l'id_individu et $frag_prof[1] contient la partie  afficher 
			if ($frag_prof[0] != $id_individu) // ce n'est pas le bon prof
				$a_traiter = ""; // on affiche rien
			else // c'est lui
				$a_traiter = $frag_prof[1]; // on affiche le contenu ou le taf
		}
	}
	else 
		$a_traiter = $planning_local[$j]{$horaires_sql[$i-1]};
		
	// La partie  traiter contient peut-tre des doubles entres (HG et ducation civique)
	$portions_HG = array();
	$portions_HG[0] = $a_traiter; // Ce tableau n'a qu'un seul lment pour l'instant (le contenu  traiter) : la boucle foreach plus ne sera excute qu'une seule fois)
	
	// Cas particulier de l'historie-go ( cause de l'ducation civique : voir task #167, anomalie #93, Doc_dev_edt.odt)
	if (strpos($a_traiter,"!HG%EC!") !== false)
	{
		$portions_HG = array(); // on rinitialise
		$portions_HG = explode("!HG%EC!",$a_traiter);
		$portions_HG = enlever_valeurs_vides($portions_HG);
	}
	
	$k = 0;
	foreach ($portions_HG as $a_traiter) // Boucle excute une seule fois s'il n'y a pas de double entre HG-ducation civique
	{
		$k++;
		// uniquement si la boucle est excute 2 fois (en cas de double-entre HG-ducation civique) : pour distinguer les encadrs Afaire et contenu de sance...
		if ($k == 2)
			$libelle_edition_matiere = "Education Civique"; // Apparatra dans le titre de la fentre lightbox
		// contenu du div  cacher (apparatra en lightbox au clic souris)
		$texte_brut = strip_tags($a_traiter);
		// le contenu du ct apparat avec ses balises html : pour afficher l'intro, il faut les supprimer (strip_tags), sinon  cause du truncate, il y a de dcalages de cellules car des balises ne sont pas fermes correctement
		if (strpos($texte_brut,":%:") !== false) // il y a du TAF (et ventuellement un contenu de sance)
		{
			$frags = explode(":%:",$texte_brut); // $frags[0]= le TAF pour le jour, $frags[1]=le contenu de sance, le reste=les TAF donn ce jour pour d'autres dates
			$frags_with_tags = explode(":%:",$a_traiter); // pour affichage avec lightview
		}
		else // Pas de TAF
		{
			$frags[0] = ""; // car pas de TAF
			$frags[1] = $texte_brut; // contenu de sance, format brut
			$frags_with_tags[1] = $a_traiter; // contenu de sance, format HTML pour affichage dans la LightBox
		}
		if (strlen($frags[0]) > 0) // il y a un TAF pour ce jour, on l'affiche
		{	
			// Mais il faut d'abord se dbarrasser de la squence "id_individu!###!" si prsente
			if (strpos($frags[0],"!###!") !== false)
			{
				$frag_prof = explode("!###!",$frags[0]); // $frag_prof[0] contient l'id_individu et $frag_prof[1] contient la partie  afficher
				$frags[0] = $frag_prof[1];
			}
			if (strpos($frags_with_tags[0],"!###!") !== false)
			{
				$frag_prof = explode("!###!",$frags_with_tags[0]); // $frag_prof[0] contient l'id_individu et $frag_prof[1] contient la partie  afficher
				$frags_with_tags[0] = $frag_prof[1];
			}
			// TAF complet avec tags HTML (sera utilis par l'effet lightbox dans trombi.js)
			if ($nopub)
			{
				$pubtype = "nopub";
				$add_style_ctIntoDiv_Taf = $add_style_ctIntoDiv_Tafnopub;
			}
			else 
				$pubtype = "";
			echo "<div id='ctIntoDiv$j-$i-$k-$rang_parallele-Taf$pubtype' style='display: none' title='$classe, $libelle_edition_matiere : Travail  faire pour le ".MySQLDateToExplicitDate($date_jour)."'>".$frags_with_tags[0]."</div>";
			// intro affiche dans le planning
			echo "<div class='tafEDT$pubtype' $add_style_ctIntoDiv_Taf><b><i>A faire pour ce jour&nbsp;:</i></b><br />".truncate($frags[0],0,100)."</div>";
		}
		if (strlen($frags[1]) > 0) // il y a un contenu de sance renseign, on l'affiche
		{
			// Mais il faut d'abord se dbarrasser de la squence "id_individu!###!" si prsente
			if (strpos($frags[1],"!###!") !== false)
			{
				$frag_prof = explode("!###!",$frags[1]); // $frag_prof[0] contient l'id_individu et $frag_prof[1] contient la partie  afficher
				$frags[1] = $frag_prof[1];
			}
			if (strpos($frags_with_tags[1],"!###!") !== false)
			{
				$frag_prof = explode("!###!",$frags_with_tags[1]); // $frag_prof[0] contient l'id_individu et $frag_prof[1] contient la partie  afficher
				$frags_with_tags[1] = $frag_prof[1];
			}
			// Pour les cours de quinzaine, il y a "!%!" en trop   la fin qui ne sert plus  rien
			if (substr($frags_with_tags[1],-3) == "!%!")
				$frags_with_tags[1] = substr($frags_with_tags[1],0,-3); // on l'enlve
			// Contenu de sance complet avec tags HTML (sera utilis par l'effet lightbox dans trombi.js)
			if ($nopub)
			{
				$pubtype = "nopub";
				$add_style_ctIntoDiv_Content = $add_style_ctIntoDiv_Contentnopub;
				$info_nopub = "<span class='rouge'>non publi&nbsp;!</span><br /><br />";
			}
			else 
				$pubtype = "";
			echo "<div id='ctIntoDiv$j-$i-$k-$rang_parallele-Seance$pubtype' style='display: none' title='$classe, $libelle_edition_matiere : Contenu de la sance du  ".MySQLDateToExplicitDate($date_jour)."'>".$info_nopub.$frags_with_tags[1]."</div>";
			// Seule l'intro du contenu de sance est affiche en mode ct
			echo "<div class='ctEDT$pubtype' $add_style_ctIntoDiv_Content><b><i>Contenu de sance&nbsp;:</i></b><br />".truncate($frags[1],0,100)."</div>";
		}
	}
}

function affiche_controles_display_ct()
{
	/**
	 * Affiche les punaises qui permettent d'afficher ou de masquer les introductions des TAF ou des contenus de sance du cahier de textes
	 */

	if ($_GET['taf'])
	{
    	$icone_aff_taf = "nopunaise1.png";
    	$add_title_alt = "title=\"Supprimer l'affichage des travaux  faire publis\" alt='Ne pas afficher les travaux  faire publis'";
	}
    else
    {
    	$icone_aff_taf = "punaise1.png";
    	$add_title_alt = "title=\"Cahier de Textes : Afficher les travaux  faire publis (intro)\" alt='Afficher les travaux  faire publis'";
    }
    echo "<img id='icon_aff_taf' src='".$GLOBALS['chemin_relatif']."images/$icone_aff_taf' $add_title_alt />";	
    if ($_GET['content'])
    {
    	$icone_aff_ct= "nopunaise2.png";
    	$add_title_alt = "title=\"Supprimer l'affichage des contenus de sances\" alt='Ne pas afficher les contenus de sance publis'";
    }
    else
    {
    	$icone_aff_ct = "punaise2.png";
    	$add_title_alt = "title=\"Cahier de Textes : Afficher les contenus de sances publis (intro)\" alt='Afficher les contenus de sances publis'";
    }
     echo "<img id='icon_aff_ct' src='".$GLOBALS['chemin_relatif']."images/$icone_aff_ct' $add_title_alt />";
    // la punaise contrlant l'affichage des contenus ou TAF non publis ne seront disponibles que pour les professeurs sur leur propre EDT
    if ($_GET['edt'] == $_SESSION['identifiant_individu'])
    {
    	if ($_GET['nopub'] == "true")
    	{
    			$icone_aff_nopub = "nopunaise3.png";
    			$add_style_legend = " style='display: inline-block'";
    			$add_title_alt = "title=\"Supprimer l'affichage des entres de cahiers de textes non publies\" alt='Ne pas afficher les entres de cahiers de textes non publies'";
    	}
    	else
    	{
    		$icone_aff_nopub = "punaise3.png";
    		$add_title_alt = "title=\"Cahier de Textes : Afficher les contenus de sance et les travaux  faire non publies (intro)\" alt='Afficher les entres de cahiers de textes non publies'";
    	}
    	echo "<img id='icon_aff_nopub' src='".$GLOBALS['chemin_relatif']."images/$icone_aff_nopub' $add_title_alt />";
    	echo "<span id='nopub_legend' class='legend'$add_style_legend>Non publi</span>";
    }	
    
}

function secure_separators_ct($chaine)
{
	/**
	 * Elimine les sparateurs !%!, !###! et :%: s'ils sont prsents dans la chane $chaine
	 * avant insertion dans $planning_ct
	 * 
	 * @param $chaine : contient le TAF ou le contenu de sance saisi par le prof
	 * @return : chane dbarrasse des sparateurs interdits
	 * 
	 * du fait de l'ajout des sparateurs !%!, !###! et :%: dans la chane stocke dans chaque lment du tableau $planning_ct,
	 * il faut s'assurer qu'aucun professeur ne saisisse ces sparateurs dans les entres du cahier de textes qu'il remplit.
	 * Cela pourrait fausser le bon dcoupage de la chane par la fonction affiche_ct() et donc le bon affichage des informations.
	 * 
	 */
	
	$mask = array("!%!","!###!",":%:","!HG%EC!"); // sparateurs interdits
	$chaine = str_replace($mask,"",$chaine); // limins !
	return $chaine;
}

function auth_modif_edt()
{
	/**
	 * Vrifie si la personne connecte a le droit de modifier l'edt affiche
	 */
	
	if ($_SESSION['valid_group'] == "1" || $_SESSION['valid_group'] == "6") // administrateurs et direction OK, pas les autres
		return true;
	else 
		return false;
}

/* Script principal */

// Le script en cours doit tre le script d'appel prvu
if (end_with_string($_SERVER['PHP_SELF'],"prive/edt.php"))
{
  	global $arrieres_plans_choisis, $couleurs_matieres,$debut_semaine,$fin_semaine,$mode,$pas_de_balise_td,$eleve_id,$horaires_sql,$horaires_recrees,$planning_ct,$planning_ct_nopub;
	$arrieres_plans_choisis = array();
	$couleurs_matieres = array();
	
	// Si les EDT n'ont pas t imports, pas la peine d'aller + loin (il y aura plein de warnings...)
	if (!is_edt_import())
		return; // fin du script
	
	recup_horaires_edt(); // Remplit le tableau $horaires_sql (utilis par plusieurs fonctions) + le tableau $horaires_print
	
	// on vrifie dj si des couleurs ont t affectes aux matires
	$sql = "SELECT * FROM couleurs_edt_matieres";
	$resultat = mysql_query($sql);
	if (mysql_num_rows($resultat) == 0) // ce n'est pas encore le cas
	{
		assoc_matiere_couleurs(); // on affecte les couleurs aux matires
	}
	else // les associations couleurs/matires ont dj t faites 
	{
		// On les rcupre de la base de donnes
		while ($ligne = mysql_fetch_array($resultat))
		{
			$couleurs_matieres[$ligne['matiere']] = $ligne['avt_plan']."%".$ligne['arr_plan'];
		}
	}
  
	// Titre de la page
	// Modulation du titre selon le type d'accs 
	if ($_GET['mode'] == "ct") // mode cahier de textes
    	$titre = "Cahier de Textes de";
    else 
    	$titre = "Emploi du temps de"; // mode normal
  
    // DEBUGG var_dump($_GET);
    
    // On cherche la semaine en cours
    if (isset($_GET['debut_semaine']) && $_GET['debut_semaine'] !="")
    {
    	// Dtection de format : normalement c'est du MySQL
    	// sauf si a vient du date picker (dans ce cas il faut convertir jj-mm-aaaa en aaaa-mm-jj
    	if (preg_match("#^[0-9]{4}-[0-9]{1,2}-([0-9]{1,2})$#", $_GET['debut_semaine'])) // format MySQL ?
    	{
    		// Pour grer les allers-retours edt-cahiers de textes, on utilise une variable de session pour la date (format MySQL)
    		$_SESSION['date_en_cours_consultation'] = $_GET['debut_semaine'];
    		$debut_semaine = debut_semaine($_GET['debut_semaine']);
    	}
    	else // format jj-mm-aaaa 
    	{
    		// Pour grer les allers-retours edt-cahiers de textes, on utilise une variable de session pour la date (format MySQL)
    		$_SESSION['date_en_cours_consultation'] = convert_date_to_mysql($_GET['debut_semaine'],"-"); // si a vient du datepicker, c'est le jour choisi, si a vient d'un lien de navigation semaine suivante ou prcdente, c'est le debut de semaine
    		$debut_semaine = debut_semaine(convert_date_to_mysql($_GET['debut_semaine'], "-")); // on trouve le dbut de semaine correspondant
    	}
    }
    elseif ($_SESSION['date_en_cours_consultation']) // la semaine de consultation n'est pas prcise dans l'url, il y a peut-tre une variable de session indiquant la date
    {
    	$debut_semaine = debut_semaine($_SESSION['date_en_cours_consultation']);
    }
    else // non pas de variable de session indiquant la date, on prend la date du jours en cours par dfaut 
    {
    	$_SESSION['date_en_cours_consultation'] = date("Y-m-d");
    	$debut_semaine = debut_semaine("");
    }
    // DEBUGG print "Dbut de semaine : "; var_dump($debut_semaine);
    
    
    // DEBUGG var_dump($GLOBALS['jours_ouvrables']);
    $nb_jours_ouvrables_semaine = count($GLOBALS['jours_ouvrables']);
    $jours_ajout = $nb_jours_ouvrables_semaine-1; // le nombre de jour  ajouter au jour de dbut de semaine pour obtenir la date de fin de semaine
    $fin_semaine = strftime("%Y-%m-%d", strtotime("$debut_semaine +$jours_ajout day"));
    // DEBUGG print "Fin de semaine : ";var_dump($fin_semaine);
    
    if (isset($_GET['mode'])) // utilis pour afficher des liens depuis le planning EDT vers le cahier de textes correspondant
    	$mode = $_GET['mode'];
    else 
    	$mode = "";
    
  // c'est ici qu'on va grer une partie des droits d'accs (en plus de ce qui est fait dans edt.php)
  if (isset($_GET['categorie']))
  {
    switch ($_GET['categorie'])
    {
      case 'classes':
        if ($_SESSION['valid_group'] == "4") // c'est un parent
        {
        	// On va contrler que l'URL ne contient que la classe de son enfant (en cas de modification manuelle de l'URL)
			if (isset( $_GET['edt']))
			{
        		$portion_url = $_GET['edt'];
				cherche_classe("parent");
				if (in_array($portion_url,$_SESSION['liste_classes_edt']))
        			affiche_edt("parent"); // on affiche l'edt de son enfant
        		else
        		{
        			$error_message = array("Vous avez seulement le droit de consulter l'emploi du temps de la classe de votre enfant ! <a href='".$_SERVER['PHP_SELF']."?categorie=classes'>[Retour aux emplois du temps autoriss]</a>","");
          			affiche_erreurs($error_message);
          			return;
        		}
        	}
        	else // il n'y a pas de paramtre edt dans l'url
        	{
        		affiche_edt("parent"); // on affiche l'edt de son enfant ou un choix  faire si plusieurs enfants
        	}
        }
        elseif ($_SESSION['valid_group'] == "2") // c'est un lve
        {
        	if (isset( $_GET['edt'])) // il y a un paramtre edt dans l'url
			{
          		$portion_url = $_GET['edt'];
				cherche_classe("eleve");
				if ($_SESSION['liste_classes_edt'] == $portion_url) // le paramtre edt de l'url correspond  la classe de l'lve
				{
					// on autorise l'affichage de l'edt
					affiche_edt("eleve");
				}
        		else // l'lve a modifi le param edt de l'url pour accder  l'edt d'une autre classe que la sienne
        		{
        			// on n'autorise pas un lve  voir un edt autre que celui de sa classe
        			$error_message = array("Vous avez seulement le droit de consulter l'emploi du temps de votre classe ! <a href='".$_SERVER['PHP_SELF']."?categorie=classes'>[Retour aux emplois du temps autoriss]</a>","");
          			affiche_erreurs($error_message);
          			return;
        		}
        	}
        	else // pas de paramtre edt ans l'url, on affiche l'edt de la classe de l'lve
        	{
          		cherche_classe("eleve");
          		affiche_edt("eleve");
        	}

        }
    	elseif ($_SESSION['valid_group'] == "11") // les IPR ont le droit de voir les edt de toutes les classes/groupes des profs qu'ils inspectent, mais pas les autres classes
        {
          if (isset($_GET['edt']) && $_GET['edt'] !="")
          {
          	if (in_array($_GET['edt'],$_SESSION['ipr_liste_codes_structures']))
          		affiche_edt("classe");
          	else 
          	{
          		$error_message = array("Vous n'avez pas accs aux autres classes que celles des enseignants que vous inspectez ! <a href='".$_SERVER['PHP_SELF']."?categorie=classes'><br />[Retour aux emplois du temps autoriss]</a>","");
          		affiche_erreurs($error_message);
          		return;
          	}
          }
          else 
         {
          	affiche_edt("ipr");
          }
        }
        elseif (isset($_SESSION['valid_group'])) // les autres utilisateurs authentifis ont le droit de voir les edt de toutes les classes
        {
          if (isset($_GET['edt']) && $_GET['edt'] !="" )
          {
          	affiche_edt("classe");
          }
          else 
         {
          	affiche_edt("toutes");
          }
        }
        break;
        
      case 'professeurs': // accs  tous pour les edt des profs sauf pour les lves et responsables
        if ($_SESSION['valid_group'] != "2" && $_SESSION['valid_group'] != "4") // les parents et les lves ne peuvent pas consulter les edt des profs
        {
          if (!isset($_GET['edt']) || $_GET['edt'] == "") // pas de professeur prcis sous forme d'id_individu dans l'url
          {
          	if ($_SESSION['valid_group'] == "11")
          	{
          		// On affiche la liste des profs inspects (lien vers leur edt)
    	      	echo "<h1>".$titre."s professeurs inspects</h1>";
        	  	affiche_liens("professeurs");
          	}
          	else
          	{
	          	// On affiche la liste de TOUS les profs (lien vers leur edt)
    	      	echo "<h1>".$titre."s professeurs</h1>";
        	  	affiche_liens("professeurs");
          	}
          }
          else // le prof est prcis, on recherche son edt et on l'affiche
          {
          	if ($_SESSION['valid_group'] == "11") // Si un IPR a chang manuellement le param URL 'edt', il faut vrifier si l'id_individu correspond  celui d'un prof inspect
          	{
          		if (in_array($_GET['edt'],$_SESSION['ipr_liste_id_individus_inspectes']))
          			affiche_edt("professeur");
          		else 
          		{
          			$error_message = array("Vous n'avez accs qu'aux emplois du temps des enseignants que vous inspectez ! <a href='".$_SERVER['PHP_SELF']."?categorie=professeurs'><br />[Retour aux emplois du temps autoriss]</a>","");
          			affiche_erreurs($error_message);
          			return;
          		}
          	}
          	else 
          		affiche_edt("professeur");
          }
        }
        else // cas des parents et des lves
        {
          $error_message = array("Vous n'avez pas les droits ncessaires pour consulter les emplois du temps des ".$_GET['categorie']." ! <a href='".$_SERVER['PHP_SELF']."?categorie=classes'>[Retour aux emplois du temps autoriss]</a>","");
          affiche_erreurs($error_message);
          return;
        }
        break;
      case 'salles':
        if ($_SESSION['valid_group'] != "2" && $_SESSION['valid_group'] != "4")
        {
          affiche_edt("salle"); // accs total  tous les edt des salles si on est un utilisateur authentifi autre qu'un lve ou un parent
        }
        else // cas des parents et des lves
        {
          $error_message = array("Vous n'avez pas les droits ncessaires pour consulter les emplois du temps des ".$_GET['categorie']." ! <a href='".$_SERVER['PHP_SELF']."?categorie=classes'>[Retour aux emplois du temps autoriss]</a>","");
          affiche_erreurs($error_message);
          return;
        }
        break;
      default:
      	$error_message = array("La catgorie demande n'existe pas ! <a href='".$_SERVER['PHP_SELF']."?categorie=classes'>[Retour aux emplois du temps autoriss]</a>","");
        affiche_erreurs($error_message);
        return;
    }  
  }
  else // si le script est appel sans aucun paramtre catgorie dans l'url, on interrompt le script
  {  
    $error_message = array("Veuillez SVP utiliser les liens de la section 'Emplois du temps' du menu, pour accder  cette page !","");
    affiche_erreurs($error_message);
    return; 
  }
}
else // L'utilisateur essaie d'invoquer ce script directement dans l'URL (interdit)
{
  $error_message = array("Vous tentez d'accder  un script qui n'est pas accessible directement  partir de l'URL... Utilisez les liens de navigation !","");
  affiche_erreurs($error_message);
}
?>