<?php
/**
 * c_eqpedag.php
 *
 * affiche les quipes pdagogiques des diffrentes classes avec le trombinoscope
 * 
 * Ce fichier fait partie du projet IntraEduWeb (IEW)
 * 
 * @package		IEW
 * @author			Sylvain GODM <sylvain.godme@gmail.com>
 * @version		$LastChangedRevision$, $LastChangedDate$
 * @copyright		2004-2012 Sylvain GODM
 * @link			http://iew.free.fr
 * @license		GPL License version 3 (http://www.gnu.org/licenses/gpl.html)
 * @filesource
 * 
 */

/* Dclaration de fonctions */

function liste_profs($classe)
{
  // Affichage la liste des professeurs de la classe slectionne

  // trouver d abord le prof principal (et sa matire principale - horaire d'enseignement le + lev - dans la classe) et le stocker dans la variable $pp
  $sql = "SELECT t1.id_pers, civilite, nom, prenom, libelle_edition as matiere
  FROM personnel AS t1, profs_principaux AS t2, enseignants_services AS t3, services AS t4, matieres_sconet AS t5
  WHERE t2.code_structure = '".quote_smart($classe)."'
  AND t2.id_prof = t1.id_individu
  AND t1.id_individu = t3.id_individu
  AND t4.id_service = t3.id_service
  AND t4.code_structure = '".quote_smart($classe)."'
  AND t5.code_matiere = t4.code_matiere
  ORDER BY heure DESC , nom, prenom";
  $resultat = mysql_query($sql);
  if ($ligne = @mysql_fetch_array($resultat)) // On ne prend que le premier rsultat pour avoir la matire principalement enseigne par ce prof dans la classe
  { // s il y a des rponses
    $pp = $ligne['nom']." "."(".$ligne['matiere'].")"; // contient le nom du prof principal et la matire principale
    // sa photo, on va l'afficher en rduction
    $image = $GLOBALS['stock_baselev']."fotoprof/".$ligne['id_pers'].".jpg";
    $defaut = $GLOBALS['stock_baselev']."fotoprof/defaut.jpg";
    if (file_exists($image))
    {
      // Mais elle n'est pas forcment affichable pour l'utilisateur en cours
      if ($_SESSION['valid_id_user'] != $ligne['id_pers']) // Si l'utilisateur en cours n'est pas la personne reprsente sur la photo
      {
        $image = $GLOBALS['stock_baselev']."fotoprof/".verif_autorisation_publication_foto("prof",$ligne['id_pers']);
      }
      $code_image = "<img id='".$ligne['id_pers']."' title='".$ligne['civilite']." $pp' class='trombi' align='middle' src='".$GLOBALS['chemin_relatif']."resize_image.php?image=$image&amp;max_width=50&amp;max_height=60' alt='photo du professeur principal' /><br />";
    }
    else
    {
      $code_image = "<img id='".$ligne['id_pers']."' title='".$ligne['civilite']." $pp' class='trombi' align='middle' src='".$GLOBALS['chemin_relatif']."resize_image.php?image=$defaut&amp;max_width=50&amp;max_height=60' alt='photo du professeur principal' /><br />";
    }
    $code_formulaire = "<center><span class='pp'>".$ligne['civilite']." ".$pp."&nbsp;&nbsp;&nbsp;$code_image</span></center>";
    
  }
  else
  {
    $error_message = array("Le professeur principal de la classe et/ou l'quipe pdagogique n'est pas encore dfini(e) pour la classe de <b>$classe</b>. Veuillez <a href='./admin/prive/imports.php?type=adm'>mettre  jour</a> cette information.","");
    affiche_erreurs($error_message);
    return;
  }
  $groupes_appartenance = cherche_classe_dans_groupes($classe); // On cherche les groupes qui prennent des lves dans la classe
  // On va construire une liste des groupes sous forme de n-uplet pour tre utilisable dans requte SQL avec clause WHERE code_structure IN (x1,x2,...)
  $where_sql_code_structure = "t4.code_structure IN ('".quote_smart($classe)."','";
  foreach ($groupes_appartenance as $value)
  {
  	$where_sql_code_structure .= $value."','";
  }
  $where_sql_code_structure = rtrim($where_sql_code_structure,"'"); // on enlve la simple quote terminale
  $where_sql_code_structure = rtrim($where_sql_code_structure,","); // et la virgule terminale
  $where_sql_code_structure .= ")";
  // trouver le reste de l quipe pdagogique
  $sql = "SELECT civilite, nom, prenom, libelle_edition as matiere
  FROM personnel AS t1, enseignants_services AS t3, services AS t4, matieres_sconet AS t5
  WHERE $where_sql_code_structure
  AND t1.id_individu = t3.id_individu
  AND t4.id_service = t3.id_service
  AND t5.code_matiere = t4.code_matiere
  ORDER BY matiere, nom, prenom";
  // DEBUGG print $sql."<br />";
  $resultat = mysql_query($sql);
  if (mysql_num_rows($resultat)>0)
  { // s il y a des rponses
    $code_formulaire .= "<table width=\"100%\"><tr><td width=\"50%\">
    <a href='edt.php?categorie=classes&amp;edt=$classe' title=\"Voir l'emploi du temps de la classe de $classe\">[Emploi du temps]</a>
    <a href='admin/trombinelev.php?classe=$classe' title='Voir le trombinoscope de la classe de $classe'>[Trombinoscope]</a>
    </td><td width=\"50%\" align=\"right\"><a href=\"#bas\">Bas de la page</a></td></tr></table>";
    $code_formulaire .= "<table class='eqpedag_main'><tr align=\"center\" bgcolor=\"#FFFF00\">
    <th class='topleft' width=\"30%\">Matire</th><th class='topright'>Professeur(s)</th></tr>";
    $i = 1;
    while ($ligne = mysql_fetch_array($resultat))
    {
      if (isset($matiere_test_multiple)) // Cette variable est positionne si la table eqpedag contient plusieurs champs matiere identique pour la classe considre (cela signifie que plus d'un prof enseignent cette matire dans la classe). Si la variable existe, il ne faut pas que la matire apparaisse sur plusieurs lignes, donc on passe  la ligne suivante du rsultat de la requte $sql jusqu' ce que la matire soit diffrente de celle en cours de traitement
      {
        do 
        {
          $ligne = mysql_fetch_array($resultat);
        }
        while ($ligne['matiere'] == $matiere_test_multiple); 
      }
      // On cherche combien de profs de cette matiere enseignant dans cette classe
      $sql = "SELECT civilite, nom, prenom, libelle_edition, id_pers
	  FROM personnel AS t1, enseignants_services AS t3, services AS t4, matieres_sconet AS t5
	  WHERE $where_sql_code_structure
	  AND t1.id_individu = t3.id_individu
	  AND t4.id_service = t3.id_service
	  AND t5.code_matiere = t4.code_matiere
	  AND libelle_edition = '".quote_smart($ligne['matiere'])."'
	  ORDER BY nom, prenom";
      $resultat2 = mysql_query($sql);
      if (mysql_num_rows($resultat2)>1) // Si plus d'un prof, on les regroupe sur une mme ligne du tableau
      {
        $code_formulaire .= "<tr><td align='center'><h2 class='titre_matiere_eqpedag'>".$ligne['matiere']."</h2></td><td align=\"center\">";
        $code_formulaire .= "<table class='eqpedag_sub'><tr>";
        while ($ligne2 = mysql_fetch_array($resultat2))
        {
          $code_formulaire .= "<td align=\"center\">";
          $code_formulaire .= affiche_fotoprof($ligne2['prenom'],$ligne2['nom'],$ligne2['id_pers']);
          if (isset($_SESSION['valid_group']) && $_SESSION['valid_group'] == "1" || $_SESSION['valid_group'] == "5" || $_SESSION['valid_group'] == "6")
          {
            $code_formulaire .= "<a href=\"../prive/donnees_perso.php?id_pers=".$ligne2['id_pers']."&amp;gpe=personnel\" title='Consulter/Mettre  jour la fiche de ce membre du personnel'><font size=\"2\">".$ligne2['civilite']."&nbsp;".$ligne2['nom']."<br />".ucfirst(strtolower($ligne2['prenom']))."</font></a></td>";
          }
          else
          {
            $code_formulaire .= "<font size=\"2\">".$ligne2['civilite']."&nbsp;".$ligne2['nom']."</font></td>";
          }
        }
        $code_formulaire .= "</tr></table></td></tr>";
        $matiere_test_multiple = $ligne['matiere']; // Comme il y a plus d'un prof enseignant cette discipline dans la classe, on positionne la variable $matiere_test_multiple
      }
      elseif (mysql_num_rows($resultat2)==1) // Si un seul prof (reste le cas o il n'y a pas de prof, on n'affiche rien)
      {
        $ligne2 = mysql_fetch_array($resultat2);
      	unset($matiere_test_multiple); // On efface au cas o la matiere prcdente l'aurait positionne pour que l'on ne traite pas la boucle do...while situe plus haut
        $code_formulaire .= "<tr><td align='center'><h2 class='titre_matiere_eqpedag'>".$ligne['matiere']."</h2></td><td align=\"center\">";
        $code_formulaire .= affiche_fotoprof($ligne2['prenom'],$ligne2['nom'],$ligne2['id_pers']);
        if (isset($_SESSION['valid_group']) && $_SESSION['valid_group'] == "1" || $_SESSION['valid_group'] == "5" || $_SESSION['valid_group'] == "6")
        {
          $code_formulaire .= "<a href=\"../prive/donnees_perso.php?id_pers=".$ligne2['id_pers']."&amp;gpe=personnel\" title='Consulter/Mettre  jour la fiche de ce membre du personnel'><font size=\"2\">".$ligne['civilite']."&nbsp;".$ligne['nom']."&nbsp;".ucfirst(strtolower($ligne['prenom']))."</font></a></td>";
        }
        else
        {
          $code_formulaire .= "<font size=\"2\">".$ligne['civilite']."&nbsp;".$ligne['nom']."</font></td>";
        }
        $code_formulaire .= "</tr>";
      }
      $i++;
    }
    $code_formulaire .= "</table>";
    $code_formulaire .= "<table width=\"100%\"><tr><td width=\"50%\"></td><td width=\"50%\" align=\"right\"><a href=\"#haut\">
    Haut de la page</a></td></tr></table><br />";
    echo "<center>";
    squelette_formulaire_standard("100%","","","<a href='".$GLOBALS['chemin_relatif']."admin/pp.php'>Professeur Principal de $classe</a>",$code_formulaire,"","","","","","","");
    echo "</center>";
  }
}

// on tablit une fois pour toutes la connexion avec la base de donnes

// Le script en cours doit tre le script d'appel prvu
if (end_with_string($_SERVER['PHP_SELF'],"prive/eqpedag.php"))
{
	// Le clic droit est interdit sur la page
  	protection_image();
	connexion_mysql();
	select_database();

	if ($_SESSION['valid_group']=='4') // Cas des parents connects
	{  
	  // On recherche les classes des enfants de ce parent
  		$sql = "SELECT classe as division, prenom FROM eleves WHERE eleve_id=";
  		for($i=0;$i<count($_SESSION['enfants_scol']);$i++)
  		{
    		$fragment=explode(",",$_SESSION['enfants_scol'][$i]);
    		$tab_id[$i]=$fragment[0]; // identifiant lve
    		$tab_nom[$i]=$fragment[1]; // nom lve
    		$tab_prenom[$i]=$fragment[2]; // prnom lve
    		if ($i==0) // Si 1er tour de boucle
      			$sql .= "'".quote_smart($tab_id[$i])."' ";
    		else //  partir de la 2me itration
      			$sql .= "OR eleve_id='".quote_smart($tab_id[$i])."' ";
  		}
  		$sql .= "ORDER BY classe"; // fin de la requte
	}
	elseif ($_SESSION['valid_group']=='2') // Cas des lves connects
	{
  		$sql = "SELECT t1.classe as division FROM eleves as t1, login as t2 WHERE t1.id_eleve=t2.id_pers AND t2.id_pers='".quote_smart($_SESSION['valid_id_user'])."'";
	}
	else // les autres utilisateurs authentifis dans IEW ont le droit de voir toutes les quipes pdagogiques
	{
  		$sql = "SELECT division from divisions order by division"; // on recherche la liste des classes
	}
	// DEBUGG print $sql."<br />";
	$resultat = mysql_query($sql);
	if (mysql_num_rows($resultat)) // s il y a des rponses
	{
  		$divisions_autorisees = array(); // contiendra la liste des divisions dont il est possible de voir l'quipe pdagogique
	  // On va afficher le tableau de liens permmettant de choisir la classe
  		$affichage_contenu_liens = "<center><table width=\"100%\">";
  		if (mysql_num_rows($resultat)<=10 && mysql_num_rows($resultat)>=1) // si au plus 10 classes
  		{
    		$affichage_contenu_liens .= "<tr>"; // alors il y aura une seule ligne
    		$largeur_colonne = floor(100/mysql_num_rows($resultat)); 
    		for ($i=1;$i<=mysql_num_rows($resultat);$i++)
    		{
      			$ligne = mysql_fetch_array($resultat);
      			if ($ligne['division'] != "")
      			{
        			$affichage_contenu_liens .= "<td width=\"$largeur_colonne\" align='center'><a href=\"eqpedag.php?classe=".$ligne['division']."\" title=\"Voir l'quipe pdagogique de ".$ligne['division']."\">[".$ligne['division']."]</a>";
        			if (isset($ligne['prenom'])) // Si c'est un parent connect, on affiche le prnom de l'lve sous la classe
        				$affichage_contenu_liens .= "<br />(Classe de ".$ligne['prenom'].")";
        			$affichage_contenu_liens .= "</td>";
        			$divisions_autorisees[]=$ligne['division'];
      			}
      			else
        			$affichage_contenu_liens .= "<td width=\"$largeur_colonne\" align='center'></td>";
    		}
    		$affichage_contenu_liens .= "</tr></table></center>";
  		}
  		elseif (mysql_num_rows($resultat)>10) // si + de 10 classes, crer une ligne supplmentaire dans le tableau
  		{
		    // si + de 10 classes, crer au moins une ligne supplmentaire dans le tableau
		    // Combien y aura-t-il de lignes ?
    		$quotient = mysql_num_rows($resultat)/10;
    		if (is_int($quotient))
      			$nb_ligne_tableau = $quotient;
    		else
      			$nb_ligne_tableau = intval($quotient)+1;
    		$largeur_colonne = floor(100/mysql_num_rows($resultat)); 
		    // Voici les lignes  afficher
    		for ($j=1;$j<=$nb_ligne_tableau;$j++)
    		{
      			$largeur_colonne = floor(100/mysql_num_rows($resultat)); 
			      // sur chaque ligne, 10 classes au max
      			$affichage_contenu_liens .= "<tr>";
      			for ($i=1;$i<=10;$i++)
      			{
        			$ligne = mysql_fetch_array($resultat);
        			if ($ligne['division'] != "")
        			{
          				$affichage_contenu_liens .= "<td width=\"$largeur_colonne\"><a href=\"eqpedag.php?classe=".$ligne['division']."\">[".$ligne['division']."]</a></td>";
          				$divisions_autorisees[]=$ligne['division'];
        			}
        			else
          				$affichage_contenu_liens .= "<td width=\"$largeur_colonne\"></td>";
      			}
      			$affichage_contenu_liens .= "</tr>";
    		}
    		$affichage_contenu_liens .= "</table></center>";
  		}
  		else
  		{
    		$affichage_contenu_liens .= "</table></center>";
  		}
	}
	else
	{
 		$error_message = array("La table contenant le nom des classes est inaccessible pour le moment ou est vide","");
 		affiche_erreurs($error_message);
 		return;
	}

	// DEBUGG print_r($divisions_autorisees); echo "<br />";

	// Affichage de la listes des professeurs de la classe

	if (isset($_GET['classe'])) // si la classe est dfinie
	{
		  // On s'assure que l'utilisateur connect a bien le droit de voir cette quipe pdagogique 
  		if (in_array($_GET['classe'],$divisions_autorisees))
  		{
    		echo "<h1>Equipe Pdagogique de ".$_GET['classe']."</h1>";
    		echo "<div class='encadrer'>Voici la liste des classes pour lesquelles vous tes autoriss  consulter l'quipe pdagogique&nbsp;:</div>";
			echo $affichage_contenu_liens;
  			liste_profs($_GET['classe']); // on affiche la liste des profs de la classe dfinie
  		}
  		else
  		{
    		echo "<h1>Equipe Pdagogique de ".$_GET['classe']."</h1>";
    		echo "<div class='encadrer'>Voici la liste des classes pour lesquelles vous tes autoriss  consulter l'quipe pdagogique&nbsp;:</div>";
			echo $affichage_contenu_liens;
  			$error_message = array("<div align='justify'>Vous n'avez pas les droits ncessaires pour voir l'quipe pdagogique de <strong>".$_GET['classe']."</strong>. Cliquez sur les liens ci-dessus pour accder aux quipes pdagogiques des classes autorises</div>","");
    		affiche_erreurs($error_message);
    		return;
  		}
	}
	else
	{
		echo "<h1>Equipes Pdagogiques</h1>";
		echo "<div class='encadrer'>Voici la liste des classes pour lesquelles vous tes autoriss  consulter l'quipe pdagogique&nbsp;:</div>";
		echo $affichage_contenu_liens;
	}
}
else // L'utilisateur essaie d'invoquer ce script directement dans l'URL (interdit)
{
  $error_message = array("Vous tentez d'accder  un script qui n'est pas accessible directement  partir de l'URL... Utilisez les liens de navigation !","");
  affiche_erreurs($error_message);
}
?>