<?php
/**
 * c_gesgroupes.php
 *
 * Permet d'afficher et de modifier ou de supprimer la liste des lves d'un groupe
 * (de langues, de soutien, ou autre : groupes sconet et groupes manuels)
 * 
 * Ce fichier fait partie du projet IntraEduWeb (IEW)
 * 
 * @package		IEW
 * @author			Sylvain GODM <sylvain.godme@gmail.com>
 * @version		$LastChangedRevision$, $LastChangedDate$
 * @copyright		2004-2012 Sylvain GODM
 * @link			http://iew.free.fr
 * @license		GPL License version 3 (http://www.gnu.org/licenses/gpl.html)
 * @filesource
 * 
 */
 
// Le script en cours doit tre le script d'appel prvu
if (end_with_string($_SERVER['PHP_SELF'],"prive/gesgroupes.php"))
{
	connexion_mysql();
	select_database();
	
	/* Initialisations */

	if (isset($_GET['choix'])) // si la variable est dfinie dans l'URL
	$choix = $_GET['choix'];
	elseif (isset($_POST['choix'])) // ou bien transmise par formulaire
	$choix = $_POST['choix'];
	else
	$choix = "";
	if (isset($_GET['nom_groupe']))
	$nom_groupe = $_GET['nom_groupe'];
	elseif (isset($_POST['nom_groupe']))
	$nom_groupe = $_POST['nom_groupe'];
	else
	$nom_groupe = "";
	if (isset($_SESSION['liste_classes']))
	$liste_classes = $_SESSION['liste_classes'];
	if (isset($_POST['classe']))
	$classe = $_POST['classe'];
	elseif (isset($_GET['classe']))
	$classe = $_GET['classe'];
	else
	$classe = "";
	if (isset($_POST['pointeur_classe']))
	$pointeur_classe = $_POST['pointeur_classe'];
	elseif (isset($_GET['pointeur_classe']))
	$pointeur_classe = $_GET['pointeur_classe'];
	else
	$pointeur_classe = 0;
	if (isset($_POST['id_group']))
	$id_groupe = $_POST['id_group'];
	elseif (isset($_GET['id_group']))
	$id_groupe = $_GET['id_group'];
	/* Fin des initialisations */

	 // DEBUGG var_dump($_POST);

	echo "<br /><h1>Gestion manuelle de groupes d'lves</h1><br />";

	switch ($choix)
	{
		case 'creer':	//*** Cration de groupe ***
			if (isset($_POST['soumettre_creer'])) // Si le bouton de soumission du formulaire a t enfonc
			{
				$flag_error = false;
				if ((!isset($_POST['type']) && !isset($_POST['new_type'])) || !isset($_POST['classe']) || $_POST['classe']=="")
				{
					$error_message = array("Le formulaire est incomplet, veuillez <a href=\"gesgroupes.php?choix=creer\">recommencer</a>","");
					affiche_erreurs($error_message);
					$flag_error = true;
					unset($_POST);
					unset($_GET);
    				unset($_SESSION['post_imprimable']);
				}
				elseif ($_POST['type']!="" && $_POST['new_type']!="") // Si ces 2 champs sont remplis
				{
					// C'est interdit, c'est soi l'un, soit l'autre
					$error_message = array("Les instructions donnes dans le formulaire n'ont pas bien t suivies (voir <b><u>Ou bien</u></b>), veuillez <a href=\"gesgroupes.php?choix=creer\">recommencer</a>","");
					affiche_erreurs($error_message);
					$flag_error = true;
					unset($_POST);
					unset($_GET);
    				unset($_SESSION['post_imprimable']);
					
				}
				if (!$flag_error) // Si le formulaire est complet
				{
					if (isset($_POST['type']) && $_POST['type']!="")
					$type = $_POST['type'];
					if (isset($_POST['new_type']) && $_POST['new_type']!="")
					$type = $_POST['new_type'];
					$liste_classes=$_POST['classe']; // on rcupre dans un tableau la liste des classes composant le groupe  crer
					$chaine_classes = "";
					$test_pointeur_classe=count($liste_classes)-1;
					for ($i=0;$i<count($liste_classes);$i++)
					{
						if ($i==$test_pointeur_classe)
						{
							$chaine_classes .=$liste_classes[$i]."-";
						}
						else
						{
							$chaine_classes .=$liste_classes[$i].",";
						}
					}
					if ($_SESSION['valid_prenom']!="")
					{
						$nom_groupe = $type."-".$chaine_classes.substr($_SESSION['valid_prenom'],0,1).".".$_SESSION['valid_nom'];
					}
					else
					{
						$nom_groupe = $type."-".$chaine_classes.$_SESSION['valid_login'];
					}
					// On vrifie que le nom du groupe n'existe pas encore (par exemple homonymie parfaite)
					// Ce qui poserait des problmes pour le cahier de textes (les documents joints risqueraient
					// d'tre enregistrs tous dans le mme dossier).
					$sql = "SELECT id_groupe FROM groupes WHERE nom='".quote_smart($nom_groupe)."'";
					$result = mysql_query($sql);
					if ($result && mysql_num_rows($result)>0) // Si le nom existe dj, on complte avec l'identifiant du prof
					$nom_groupe .= "-".$_SESSION['valid_id_user'];
					$sql = "INSERT INTO groupes VALUES('NULL','".quote_smart($nom_groupe)."','".quote_smart($_SESSION['valid_id_user'])."')";
					if (mysql_query($sql))
					{
						$ok_message = "Le groupe &laquo;<b>$nom_groupe</b>&raquo; a t cr. Il vous faut maintenant <a href=\"gesgroupes.php?choix=choisir_eleves&amp;nom_groupe=$nom_groupe\">choisir les lves devant faire partie de ce groupe</a>.<br />";
						affiche_ok($ok_message);
						// On efface les donnes du POST
						unset($_POST);
						unset($_SESSION['post_imprimable']);
					}
					else // Si le groupe ne peut tre cr dans la base de donnes
					{
						$error_message = array("Le groupe n'a pas pu tre crit dans la base de donnes.<a href=\"gesgroupes.php?choix=creer\"> Faites une nouvelle tentative</a> et en cas de nouvel chec, prvenez <a href='mailto:".email_encode($GLOBALS['admin_email'])."'>l'administrateur du site</a>.","");
						affiche_erreurs($error_message);
					}
				} // if !$flag_error
			} // if $soumettre_creer
			else // on affiche le formulaire de cration de groupe
			{
				if ($_SESSION['valid_prenom']!="") // Si l'utilisateur a un prenom (donc un nom)
				{
					$nom_prof = $_SESSION['valid_prenom']." ".$_SESSION['valid_nom'];
				}
				else // c'est le cas par exmple pour admin
				{
					$nom_prof = $_SESSION['valid_login'];
				}
				$code_formulaire = "<p><label for='Form_Responsable'>Responsable du groupe:</label>&nbsp; <input id='Form_Responsable' type='text' name='nom' size='40' value=\"$nom_prof\" /></p>
      Veuillez <b>cocher <u>l'un</u> des boutons radio</b> suivants :<br /><br />
      <table width='100%' border='1'>";
				// Le nombre de lignes du tableau dpendra du nombre de langues et du nombre de catgories de groupe autre que les groupes de langues
				// on rcupre donc d'abord le nombre de langues
				$langues = array();
				$sql = "SELECT matiere FROM matieres where matiere like '%LV%'";
				$resultat = mysql_query($sql);
				while ($ligne = mysql_fetch_array($resultat))
				{
					$fragment = explode(" ",$ligne['matiere']);
					if (!in_array($fragment[0],$langues))
					$langues[] = $fragment[0];
				}
				$nb_langues = count($langues);

				// On affiche d'abord les groupes de langues
				for ($i=1;$i<=$nb_langues;$i++)
				{
					$code_formulaire .= "<tr>";
					if ($i==1)
					{
						$code_formulaire .= "<th class='fond_sommaire' width='20%' rowspan='".$nb_langues."'>Groupe<br />de Langue&nbsp;:</th>";
					}
					// on cherche le nb LV
					$sql = "SELECT matiere FROM matieres where matiere like '".quote_smart($langues[$i-1])." LV%' ORDER BY matiere";
					$resultat = mysql_query($sql);
					switch (mysql_num_rows($resultat))
					{
						case '1':
							$ligne = mysql_fetch_array($resultat);
							$k = substr($ligne['matiere'],-1,1);
							$code_formulaire .= "<td><input id='Form_Lang_$i' type='radio' name='type' value='".$langues[$i-1]." (LV".$k.")' /><label for='Form_Lang_$i'>".$langues[$i-1]." (LV".$k.")</label></td>";
							$code_formulaire .= "<td>&nbsp;</td><td>&nbsp;</td>";
							break;
						case '2':
							$j=1;
							while ($ligne = mysql_fetch_array($resultat))
							{
								$k = substr($ligne['matiere'],-1,1);
								$code_formulaire .= "<td><input id='Form_Lang_$i-$j' type='radio' name='type' value='".$langues[$i-1]." (LV".$k.")' /><label for='Form_Lang_$i-$j'>".$langues[$i-1]." (LV".$k.")</label></td>";
								$k++;
								$j++;
							}
							$code_formulaire .= "<td>&nbsp;</td>";
							break;
						case '3':
							$j=1;
							while ($ligne = mysql_fetch_array($resultat))
							{
								$k = substr($ligne['matiere'],-1,1);
								$code_formulaire .= "<td><input id='Form_Lang_$i-$j' type='radio' name='type' value='".$langues[$i-1]." (LV".$k.")' /><label for='Form_Lang_$i-$j'>".$langues[$i-1]." (LV".$k.")</label></td>";
								$k++;
								$j++;
							}
							break;
					}
					$code_formulaire .="</tr>";
				}
				$code_formulaire .="</table><br /><table width='100%' border='1'>";
				// On affiche maintenant les autres groupes disponibles
				$sql = "SELECT * FROM categories_groupes where nom<>'lang'";
				$resultat = mysql_query($sql);
				$k = 1;
				while ($ligne = mysql_fetch_array($resultat))
				{
					$code_formulaire .= "<tr>";
					if ($k==1)
					{
						$code_formulaire .= "<th class='fond_sommaire' width='20%' rowspan='".mysql_num_rows($resultat)."'>Groupe<br/>prdfini&nbsp;:</th>";
					}
					$code_formulaire .= "<td colspan='3'><input id='Form_Type_$k' type='radio' name='type' value='".$ligne['nom']."' /><label for='Form_Type_$k'>".$ligne['description']."</label></td>";
					$code_formulaire .= "</tr>";
					$k++;
				}
				$code_formulaire .= "</table>";
				$code_formulaire .= "
      <br /><p><b><u>Ou bien</u> remplissez</b> le champ suivant&nbsp;:</p>
      <p>
      <label for='Form_New_Type_Group'>Dfinition d'un nouveau type de groupe&nbsp;:</label>
      <input id='Form_New_Type_Group' type='text' size='20' value='' name='new_type' />
      </p>
      <table width='70%' border='0'>
        <tr>
          <td valign='middle'><label for='Form_Choix_Classes'>Choisissez une ou plusieurs classe(s) concerne(s) par la composition du groupe&nbsp;:</label></td>  <td>
            <select id='Form_Choix_Classes' multiple='multiple' name='classe[]' size='5'>";
				$code_formulaire .= affiche_liste_options_formulaire(liste_options_form("connect","division","divisions",""));
				// On rcupre les niveaux
				$sql = "SELECT formation FROM mefs order by formation";
				$resultat = mysql_query($sql);
				$niveaux = array();
				while ($ligne = mysql_fetch_array($resultat))
				{
					$code_formulaire .= "<option>Toutes les classes de ".$ligne['formation']."</option>";
				}
				$code_formulaire .= "<option value='Toutes les classes'>Toutes les classes de l'tablissement</option>
            </select>
          </td>
        </tr>
      </table><br />
      <div align='justify'><i><font color='red'>Pour une slection multiple, maintenez la touche CTRL enfonce et cliquez sur les classes choisies</font></i></div><br />";
				squelette_formulaire_standard("100%","post","gesgroupes.php?choix=creer","Formulaire de cration de groupe d'lves",$code_formulaire,"Crer le groupe","soumettre_creer","Remettre le formulaire  zro","Annuler","","","");
			}
			break;
		case 'choisir_eleves': // Si le groupe vient d'tre cr, il faut y mettre des lves
			// On rcupre l'id_groupe si $id_groupe non dfini
			if (!isset($id_groupe) || $id_groupe=="")
			{
				$sql ="SELECT id_groupe,id_responsable FROM groupes WHERE nom='".quote_smart($nom_groupe)."'";
				 // DEBUGG echo $sql."<br />";
				$resultat=mysql_query($sql);
				$ligne=mysql_fetch_row($resultat);
				$id_groupe=$ligne[0];
				$id_responsable = $ligne[1];
			    if ($id_responsable == 0) // si l'id_responsable est  zro, c'est qu'il s'agit d'un groupe SCONET (pas cr manuellement)
				{
					// Ce groupe a t cr par le script c_imports.php, il n'est pas possible de choisir les lves de ce groupe
					$error_message = array("<div align='justify'>Le groupe <b>$nom_groupe</b> provient du fichier Structures.xml de SCONET. Il est impossible de choisir les lves de ce groupe. Si la <a href=\"gesgroupes.php?choix=consulter&amp;nom_groupe=$nom_groupe\">liste des lves</a> n'est pas correcte, demandez  votre admnistrateur d'importer les donnes depuis SCONET.</a>","");
					affiche_erreurs($error_message);
					echo "<a href=\"gesgroupes.php\">[Retour au menu de gestion des groupes]</a>";
					return;
				}
				// seuls le responsable du groupe et les membres du groupe admin de IEW ont le droit de modifier la composition ce groupe
				elseif ($id_responsable != $_SESSION['valid_id_user'] && $_SESSION['valid_group'] != "1")
				{
					$error_message = array("<div align='justify'>Vous n'tes ni Administrateur, ni le responsable du groupe <b>$nom_groupe</b>. Vous n'avez donc pas les droits ncessaires pour pouvoir modifier sa composition.</a>","");
					affiche_erreurs($error_message);
					echo "<a href=\"gesgroupes.php\">[Retour au menu de gestion des groupes]</a>";
					return;
				}				
			}
			if (!isset($_POST['soumettre']))
			{
				if (!isset($_POST['classe_suivante'])) // Si le bouton "Passer  la classe" suivante n'a pas encore t enfonc ou bien si la classe suivante est fournie par l'url d'appel
				{
					if ($classe=="" || is_array($classe)) // Si la classe n'est pas dfinie (1er appel du formulaire)
					{
						$liste_classes = liste_classes_dans_groupe($nom_groupe);
						// Afficher la liste des classes concernes
						for ($i=0;$i<count($liste_classes);$i++)
						{
							if ($i==0)
							{
								$affiche_liste_classes = "&nbsp;&nbsp;&nbsp;<a href=\"gesgroupes.php?choix=choisir_eleves&amp;pointeur_classe=$i&amp;nom_groupe=$nom_groupe&amp;classe=$liste_classes[$i]\">".str_replace(" ","&nbsp;",$liste_classes[$i])."</a>";
							}
							else
							{
								$affiche_liste_classes .= " - <a href=\"gesgroupes.php?choix=choisir_eleves&amp;pointeur_classe=$i&amp;nom_groupe=$nom_groupe&amp;classe=$liste_classes[$i]\">".str_replace(" ","&nbsp;",$liste_classes[$i])."</a>";
							}
						}
						// Considrer la 1re classe
						$pointeur_classe=0;
						$classe = $liste_classes[$pointeur_classe];
					} // if (!$classe)
					else // La classe est connue (2me appel et suivants du formulaire)
					{
						if (isset($_GET['classe']))
						{
							$classe = $_GET['classe'];
							$pointeur_classe = $_GET['pointeur_classe'];
							$_POST['pointeur_classe'] = $_GET['pointeur_classe'];
							$_POST['classe'] = $classe;
						}
						// Afficher la liste des classes concernes
						for ($i=0;$i<count($liste_classes);$i++)
						{
							if ($i==0)
							{
								$affiche_liste_classes = "&nbsp;&nbsp;&nbsp;<a href=\"gesgroupes.php?choix=choisir_eleves&amp;pointeur_classe=$i&amp;nom_groupe=$nom_groupe&amp;classe=$liste_classes[$i]\">".str_replace(" ","&nbsp;",$liste_classes[$i])."</a>";
							}
							else
							{
								$affiche_liste_classes .= " - <a href=\"gesgroupes.php?choix=choisir_eleves&amp;pointeur_classe=$i&amp;nom_groupe=$nom_groupe&amp;classe=$liste_classes[$i]\">".str_replace(" ","&nbsp;",$liste_classes[$i])."</a>";
							}
						}
					}
				} //if (!$classe_suivante)
				else // Si le bouton "Passer  la classe suivante" vient d'tre enfonc
				{
					if (isset($_GET['classe']))
					{
						$classe = $_GET['classe'];
						$pointeur_classe = $_GET['pointeur_classe'];
						$_POST['pointeur_classe'] = $_GET['pointeur_classe'];
						$_POST['classe'] = $classe;
					}
					else
					{
						$pointeur_classe++;
						$classe = $liste_classes[$pointeur_classe];
					}
					// Afficher la liste des classes concernes
					for ($i=0;$i<count($liste_classes);$i++)
					{
						if ($i==0)
						{
							$affiche_liste_classes = "&nbsp;&nbsp;&nbsp;<a href=\"gesgroupes.php?choix=choisir_eleves&amp;pointeur_classe=$i&amp;nom_groupe=$nom_groupe&amp;classe=$liste_classes[$i]\">".str_replace(" ","&nbsp;",$liste_classes[$i])."</a>";
						}
						else
						{
							$affiche_liste_classes .= " - <a href=\"gesgroupes.php?choix=choisir_eleves&amp;pointeur_classe=$i&amp;nom_groupe=$nom_groupe&amp;classe=$liste_classes[$i]\">".str_replace(" ","&nbsp;",$liste_classes[$i])."</a>";
						}
					}
					if (!$classe) // S'il n'y a plus de classe
					{
						$pointeur_classe--;
						$classe = $liste_classes[$pointeur_classe];
						$error_message = array("<div align='justify'>Toutes les classes concernes ont t traites. Si vous voulez modifier la liste, cliquez sur le lien correspondant  l'une des classes. Si la liste vous semble complte, cliquez sur le bouton 'Liste complte' dans le formulaire ci-dessous</div>","");
						affiche_erreurs($error_message);
					}
				}

				// On affiche le formulaire permettant de choisir les lves
				$code_formulaire = "<div align='justify'>
      <p>Choisissez dans la liste de gauche les lves de la classe affiche  inclure dans le groupe (Slection mulitple possible : maintenez la touche CTRL enfonce tout en cliquant sur les lves que vous souhaitez choisir) , puis cliquez sur le bouton <b><i>&lt;Passer  la classe suivante&gt;</i></b> et renouveller l'opration jusqu' ce que toutes les classes concernes aient t traites. Cliquez enfin sur le bouton <b><i>&lt;Liste complte&gt;</i></b> pour enregistrer dans la base de donnes la liste des lves du groupe.</p>";
				$code_formulaire .= "<p><u>Liste des classes concernes :</u>";
				$code_formulaire .= $affiche_liste_classes;
				$code_formulaire .= "</p></div><table border='0' width='100%'>
          <tr>
            <td width='45%'>
              <p align='center'><b><u><label for='Form_Liste_Classe'>Liste des lves de la classe de <font color='red'>$classe</font>&nbsp;:</label></u></b></p>
            </td>
            <td width='15%'>&nbsp;</td>
            <td width='40%'>
              <p align='center'><u><b><label for='Form_Liste_Actuelle_Groupe'>Liste des lves de ce groupe&nbsp;:</label></b></u></p>
            </td>
          </tr>
          <tr>
            <td width='40%' valign='top'>
              <p align='center'>
              <select id='Form_Liste_Classe' size='10' multiple='multiple' name='eleve[]'>";
				$sql = "SELECT nom,prenom,eleve_id FROM eleves where classe='".quote_smart($classe)."' ORDER BY nom,prenom";
				$resultat = mysql_query($sql);
				$nbligne = mysql_num_rows($resultat);
				for ($i=1;$i<=$nbligne;$i++)
				{
					$variable = mysql_fetch_array($resultat);
					$option = $variable["nom"]." ".$variable["prenom"];
					$code_formulaire .= "<option value='".$variable["eleve_id"]."'>$option</option>";
				}
				$code_formulaire .= "</select></p>
            </td>
            <td width='20%' align='center'>
              <!-- les champs cachs suivants sont ncessaire pour retransmettre les valeurs des variables -->
              <input type='hidden' name='choix' value='$choix' />
              <input type='hidden' name='pointeur_classe' value='$pointeur_classe' />
              <input type='hidden' name='nom_groupe' value='$nom_groupe' />
              <input type='hidden' name='id_groupe' value='$id_groupe' />
              <input type='hidden' name='classe' value='$classe' />
              <p><input type='submit' value='Ajouter &gt;&gt;' name='ajouter' /></p>
              <p><input type='submit' value=' Enlever &lt;&lt;' name='enlever' />&nbsp;</p>
            </td>
            <td align='center' width='40%'>
              <select id='Form_Liste_Actuelle_Groupe' size='10' multiple='multiple' name='liste[]'>";
				if (isset($_GET['modifier']) && $_GET['modifier']=="modifier") // Si on arrive sur ce formulaire pour modifier une liste existante
				{
					$sql = "SELECT nom,prenom,eleves.eleve_id,classe FROM groupes_eleves,eleves WHERE id_groupe='".quote_smart($id_groupe)."' AND eleves.eleve_id=groupes_eleves.eleve_id ORDER BY nom,prenom";
					 // DEBUGG echo $sql."<br/>";
					$resultat=mysql_query($sql);
					$nb_eleves_groupe=mysql_num_rows($resultat);
					if ($nb_eleves_groupe>0)
					{
						while ($ligne=mysql_fetch_array($resultat))
						{
							$code_formulaire .= "<option value='".$ligne[2]."'>$ligne[0] $ligne[1]"." "."($ligne[3])</option>";
						}
					}
				}
				else
				{
					if (isset($_POST['ajouter']) || isset($_POST['enlever'])) // si on vient de cliquer sur l un des boutons Ajouter ou Enlever
					{
						if (isset($_POST['enlever'])) // si on a cliqu sur enlever
						{
							$liste_groupe_a_enlever = $_POST['liste']; // on rcupre le tableau contenant la liste des lves  enlever
							foreach ($liste_groupe_a_enlever as $value)
							{
								if ($value!="")
								{
									$sql = "DELETE FROM groupes_eleves WHERE id_groupe='".quote_smart($id_groupe)."' AND eleve_id='".quote_smart($value)."'";
									 // DEBUGG echo $sql."<br />";
									mysql_query($sql);
								}
							}
							// On rcupre la  nouvelle liste
							$sql = "SELECT nom,prenom,eleves.eleve_id,classe FROM groupes_eleves,eleves WHERE id_groupe='".quote_smart($id_groupe)."' AND eleves.eleve_id=groupes_eleves.eleve_id ORDER BY nom,prenom";
							 // DEBUGG echo $sql."<br/>";
							$resultat=mysql_query($sql);
							$nb_eleves_groupe=mysql_num_rows($resultat);
							if ($nb_eleves_groupe>0)
							{
								while ($ligne=mysql_fetch_array($resultat))
								{
									$code_formulaire .= "<option value='".$ligne[2]."'>$ligne[0] $ligne[1]"." "."($ligne[3])</option>";
								}
							}
							else
							$code_formulaire .= "<option></option>";
						} //if ($enlever)
						else  // si on a cliqu sur ajouter
						{
							$liste_eleves_a_ajouter = $_POST['eleve']; // on rcupre le tableau contenant la liste des lves  ajouter
							foreach($liste_eleves_a_ajouter as $value)
							{
								if ($value!="")
								{
									$sql = "INSERT INTO groupes_eleves VALUES('".quote_smart($id_groupe)."','".quote_smart($value)."','".quote_smart($classe)."')"; // On ajoute l'lve  la liste du groupe
									mysql_query($sql);
								}
							}
							// On rcupre la  nouvelle liste
							$sql = "SELECT nom,prenom,eleves.eleve_id,classe FROM groupes_eleves,eleves WHERE id_groupe='".quote_smart($id_groupe)."' AND eleves.eleve_id=groupes_eleves.eleve_id ORDER BY nom,prenom";
							 // DEBUGG echo $sql."<br/>";
							$resultat=mysql_query($sql);
							$nb_eleves_groupe=mysql_num_rows($resultat);
							if ($nb_eleves_groupe>0)
							{
								while ($ligne=mysql_fetch_array($resultat))
								{
									$code_formulaire .= "<option value='".$ligne[2]."'>$ligne[0] $ligne[1]"." "."($ligne[3])</option>";
								}
							}
							else
							$code_formulaire .= "<option></option>";
						}
					} //if ($ajouter || $enlever)
					else  // On n'a ni cliqu sur le bouton Ajouter, ni sur Enlever, mais par exemple sur le bouton Passer  la classe suivante
					{
						// On rcupre la liste des lves du groupe
						$sql = "SELECT nom,prenom,eleves.eleve_id,classe FROM groupes_eleves,eleves WHERE id_groupe='".quote_smart($id_groupe)."' AND eleves.eleve_id=groupes_eleves.eleve_id ORDER BY nom,prenom";
						 // DEBUGG echo $sql."<br />";
						$resultat=mysql_query($sql);
						$nb_eleves_groupe=mysql_num_rows($resultat);
						if ($nb_eleves_groupe>0)
						{
							while ($ligne=mysql_fetch_array($resultat))
							{
								$code_formulaire .= "<option value='".$ligne[2]."'>$ligne[0] $ligne[1]"." "."($ligne[3])</option>";
							}
						}
						else
						$code_formulaire .= "<option></option>";
					}
				}
				$code_formulaire .= "</select>
                       <center><b>Effectif : <font color='red'>$nb_eleves_groupe</font> lve(s)</b></center>
              </td>
            </tr>
            <tr>
              <td align='center'><br /><input type='submit' value='Passer  la classe suivante' name='classe_suivante' /><br /><br /></td>
              <td align='center'></td>
              <td align='center'><br /><input type='submit' value='Liste complte' name='soumettre' /><br /><br /></td>
            </tr>
          </table>";
				squelette_formulaire_standard("100%","post","gesgroupes.php","Choisir les lves devant faire partie du groupe<br /><font color='red'>\"$nom_groupe\"</font>",$code_formulaire,"","","","","","","");
				 // DEBUGG var_dump($liste_classes[$pointeur_classe]);
				 // DEBUGG var_dump($_POST);
				 // DEBUGG var_dump($_GET);
			} //if (!$soumettre)
			else // Si le bouton Liste complte a t enfonc, on inscrit la liste des lves du groupe dans la base de donnes
			{
				$sql = "SELECT nom,prenom,eleves.eleve_id,classe FROM groupes_eleves,eleves WHERE id_groupe='".quote_smart($id_groupe)."' AND eleves.eleve_id=groupes_eleves.eleve_id ORDER BY nom,prenom";
				 // DEBUGG echo $sql."<br/>";
				$resultat=mysql_query($sql);
				$nbligne=mysql_num_rows($resultat);
				if ($nbligne>0)
				{
					echo "<br />Voici la <b>liste actuelle enregistre</b> des lves du groupe :<center><p><b>$nom_groupe</b> (<font color='red'>$nbligne</font> lves)</p></center>";
					echo "<center><table border='0'>";
					while ($ligne=mysql_fetch_array($resultat))
					{
						echo "<tr><td>$ligne[0] $ligne[1]"." (".$ligne[3].")</td></tr>";
					}
					echo "</table></center><p>";
					echo "<a href=\"gesgroupes.php?choix=choisir_eleves&amp;nom_groupe=$nom_groupe&amp;modifier=modifier\">[Modifier la composition de ce groupe]</a><br />";
					echo "<a href=\"gesgroupes.php?choix=supprimer&amp;nom_groupe=$nom_groupe&amp;action=oui\" onclick=\"return(window.confirm('Voulez-vous vraiment supprimer le groupe \'$nom_groupe\' de la base de donnes ?'));\">[Supprimer ce groupe]</a><br />";
					echo "<a href=\"gesgroupes.php\">[Retour au menu de gestion des groupes]</a>";
					// On efface les donnes du POST
					unset($_POST);
					unset($_SESSION['post_imprimable']);
				}
				else
				{
					$error_message = array("<div align='justify'>Vous avez tent de recharger cette page et la liste est dj enregistre, ou bien vous avez appuy sur le bouton &laquo;Liste complte&raquo; alors que la liste des lves tait vide, ou il y a eu un problme et la liste n'est pas enregistre. Cliquez sur le lien de <a href=\"gesgroupes.php\">Retour au menu de gestion des groupes</a> pour essayer de consulter la liste que vous tentiez de crer. En cas de problme, Contactez <a href='mailto:".email_encode($GLOBALS['admin_email'])."'>l'administrateur du site</a>.</div>","");
					affiche_erreurs($error_message);
					// On efface les donnes du POST
					unset($_POST);
					unset($_SESSION['post_imprimable']);
				}
			}
			break;
		case 'supprimer':	//*** Suppression de groupe ***
			if (isset($_GET['nom_groupe']) && $_GET['nom_groupe']!="") // Si l'appel est fait avec un nom de groupe
			{
				$nom_groupe = $_GET['nom_groupe'];
				if (isset($_GET['action']) && $_GET['action']=="oui") // Si action est dfinie (oui dans les paramtres d'appel)
				// alors la suppression est effective
				{
					// on rcupre l'id_groupe
					$sql ="SELECT id_groupe,id_responsable FROM groupes WHERE nom='".quote_smart($nom_groupe)."'";
					$resultat=mysql_query($sql);
					$ligne=mysql_fetch_row($resultat);
					$id_groupe=$ligne[0];
					$id_responsable = $ligne[1];
					// seuls le responsable du groupe et les membres du groupe admin de IEW ont le droit de supprimer ce groupe ( condition que ce ne soit pas un groupe SCONET)
					if ($id_responsable == $_SESSION['valid_id_user'] || ($_SESSION['valid_group'] == "1" && $id_responsable != 0))
					{
						// On efface la liste des lves de ce groupe
						$sql = "DELETE FROM groupes_eleves WHERE id_groupe='".quote_smart($id_groupe)."'";
						mysql_query($sql);
						// On efface le groupe
						$sql = "DELETE FROM groupes WHERE id_groupe='".quote_smart($id_groupe)."'";
						mysql_query($sql);
						$ok_message = "Le groupe <b>$nom_groupe</b> a t <u>supprim</u> de la base de donnes.";
						affiche_ok($ok_message);
					}
					elseif ($id_responsable == 0) // si l'id_responsable est  zro, c'est qu'il s'agit d'un groupe SCONET (pas cr manuellement)
					{
						// Ce groupe a t cr par le script c_imports.php, il n'est pas possible de le supprimer
						$error_message = array("<div align='justify'>Le groupe <b>$nom_groupe</b> provient du fichier Structures.xml de SCONET. Il est impossible de le supprimer.</a>","");
						affiche_erreurs($error_message);
					}
					else
					{
						$error_message = array("<div align='justify'>Vous n'tes ni Administrateur, ni le responsable du groupe <b>$nom_groupe</b>. Vous n'avez donc pas les droits ncessaires pour pouvoir le supprimer.</a>","");
						affiche_erreurs($error_message);
					}
					echo "<a href=\"gesgroupes.php\">[Retour au menu de gestion des groupes]</a>";
				}
				else
				{
					$sql = "SELECT nom,prenom,eleves.eleve_id,classe FROM groupes_eleves,eleves WHERE id_groupe='".quote_smart($id_groupe)."' AND eleves.eleve_id=groupes_eleves.eleve_id ORDER BY nom,prenom";
					$resultat=mysql_query($sql);
					$nbligne=mysql_num_rows($resultat);
					if ($nbligne>0)
					{
						echo "Voici la liste actuelle enregistre des lves du groupe :<br /><br /><center><b>$nom_groupe</b> : (<font color='red'>$nbligne</font> lves)</center><p>";
						echo "<center><table border='0'>";
						while ($ligne=mysql_fetch_array($resultat))
						{
							echo "<tr><td>$ligne[0] $ligne[1]"." (".$ligne[3].")</td></tr>";
						}
						echo "</table></center><p>";
						echo "<a href=\"gesgroupes.php?choix=supprimer&amp;nom_groupe=$nom_groupe&amp;action=oui\" onclick=\"return(window.confirm('Voulez-vous vraiment supprimer le groupe \'$nom_groupe\' de la base de donnes ?'));\">[Supprimer ce groupe]</a><br />";
					}
					else
					{
						$error_message = array("Il n'y a pas d'lve enregistr dans le groupe <b>$nom_groupe</b>. <a href=\"gesgroupes.php?choix=supprimer&amp;nom_groupe=$nom_groupe\">Supprimer quand mme le groupe</a> ?.<br />","");
						affiche_erreurs($error_message);
					}
					echo "<a href=\"gesgroupes.php\">[Retour au menu de gestion des groupes]</a>";
				}
			} //if ($nom_groupe)
			else
			{
				// On rcupre d'abord la liste des groupes dont l'utilisateur est responsable
				if ($_SESSION['valid_group']=="1") // seuls les admin peuvent supprimer tous les groupes
				{
					$sql="SELECT * FROM groupes ORDER BY nom";
				}
				else
				{
					$sql="SELECT * FROM groupes WHERE nom like '%".quote_smart($_SESSION['valid_nom'])."' ORDER BY nom";
				}
				$resultat=mysql_query($sql);
				if (mysql_num_rows($resultat)>0)
				{
					$code_formulaire = "<br /><center><table border='0'>";
					while ($ligne=mysql_fetch_array($resultat))
					{
						$nom_groupe=$ligne['nom'];
						$code_formulaire .= "<tr><td>$nom_groupe <a href=\"gesgroupes.php?choix=consulter&amp;nom_groupe=$nom_groupe\">[Consulter la liste]</a><a href=\"gesgroupes.php?choix=supprimer&amp;nom_groupe=$nom_groupe&amp;action=oui\" onclick=\"return(window.confirm('Voulez-vous vraiment supprimer le groupe \'$nom_groupe\' de la base de donnes ?'));\">[Supprimer ce groupe]</a></td></tr>";
					}
					$code_formulaire .= "</table></center><br />";
					echo "<center>";
					squelette_formulaire_standard("100%","","","Liste des groupes sous votre responsabilit",$code_formulaire,"","","","","","","");
					echo "</center>";
					echo "<a href=\"gesgroupes.php\">[Retour au menu de gestion des groupes]</a>";
				}
				else
				{
					$error_message = array("Vous n'avez pas de groupe en responsabilit dans la base de donnes","");
					affiche_erreurs($error_message);
					echo "<a href=\"gesgroupes.php\">[Retour au menu de gestion des groupes]</a>";
				}
			}
			break;
		case 'consulter':   //*** Consultation/modification de groupe ***
			if (isset($_GET['nom_groupe']) && $_GET['nom_groupe']!="") // Si l'appel est fait avec un nom de groupe
			{
				$nom_groupe = $_GET['nom_groupe'];
				$sql = "SELECT eleves.nom,prenom,eleves.eleve_id,classe FROM groupes_eleves,eleves,groupes WHERE groupes.id_groupe=groupes_eleves.id_groupe AND groupes.nom='".quote_smart($nom_groupe)."' AND eleves.eleve_id=groupes_eleves.eleve_id ORDER BY nom,prenom";
				 // DEBUGG echo $sql."<br/>";
				$resultat=mysql_query($sql);
				$nbligne=mysql_num_rows($resultat);
				if ($nbligne>0)
				{
					echo "Voici la liste actuelle enregistre des lves du groupe :<br /><br /><center><b>$nom_groupe</b> : (<font color='red'>$nbligne</font> lves)</center>";
					echo "<center><table border='0'>";
					while ($ligne=mysql_fetch_array($resultat))
					{
						echo "<tr><td>$ligne[0] $ligne[1]"." (".$ligne[3].")</td></tr>";
					}
					echo "</table></center>";
					echo "<a href=\"gesgroupes.php?choix=choisir_eleves&amp;nom_groupe=$nom_groupe&amp;modifier=modifier\">[Modifier la composition de ce groupe]<br /></a>";
					echo "<a href=\"gesgroupes.php?choix=supprimer&amp;nom_groupe=$nom_groupe&amp;action=oui\" onclick=\"return(window.confirm('Voulez-vous vraiment supprimer le groupe \'$nom_groupe\' de la base de donnes ?'));\">[Supprimer ce groupe]</a><br />";
				}
				else
				{
					$error_message = array("<div align='justify'>Il n'y a pas d'lve enregistr dans le groupe <b>$nom_groupe</b> ou bien vous n'avez pas termin le choix des lves pour ce groupe la fois prcdente. <a href=\"gesgroupes.php?choix=choisir_eleves&amp;nom_groupe=$nom_groupe\">Choisir les lves devant faire partie de ce groupe</a>.</div>","");
					affiche_erreurs($error_message);
					//echo "Il n'y a pas d'lve enregistr dans le groupe <b>$nom_groupe</b>. <a href=\"gesgroupes.php?choix=choisir_eleves&amp;nom_groupe=$nom_groupe\">choisir les lves devant faire partie de ce groupe</a>.<br />";
				}
				echo "<a href=\"gesgroupes.php\">[Retour au menu de gestion des groupes]</a>";
			} //if ($nom_groupe)
			else
			{
				// On rcupre d'abord la liste des groupes dont l'utilisateur est responsable
				if ($_SESSION['valid_group']=="1" || $_SESSION['valid_group']=="6") // les membres de la direction et admin peuvent consulter tous les groupes
				{
					$sql="SELECT * FROM groupes ORDER BY nom";
				}
				else
				{
					$sql="SELECT * FROM groupes WHERE nom like '%".quote_smart($_SESSION['valid_nom'])."' ORDER BY nom";
				}
				$resultat=mysql_query($sql);
				if (mysql_num_rows($resultat)>0)
				{
					$code_formulaire = "<br /><center><table border='0'>";
					while ($ligne=mysql_fetch_array($resultat))
					{
						$nom_groupe=$ligne['nom'];
						$code_formulaire .= "<tr><td>$nom_groupe <a href=\"gesgroupes.php?choix=consulter&amp;nom_groupe=$nom_groupe\">[Consulter la liste]</a><a href=\"gesgroupes.php?choix=choisir_eleves&amp;nom_groupe=$nom_groupe&amp;modifier=modifier\">[Modifier la liste]</a></td></tr>";
					}
					$code_formulaire .= "</table></center><br />";
					echo "<center>";
					squelette_formulaire_standard("100%","","","Liste des groupes sous votre responsabilit",$code_formulaire,"","","","","","","");
					echo "</center>";
				}
				else
				{
					$error_message = array("Vous n'avez pas de groupe en responsabilit dans la base de donnes","");
					affiche_erreurs($error_message);
					echo "<a href=\"gesgroupes.php\">[Retour au menu de gestion des groupes]</a>";
				}
			}
			break;
		default:
			//*** Affichage du menu principal ***
			$code_formulaire = "<table border='0'>
        <tr>
          <td width='100%' align='left'>
            <ol>
              <li><a href='gesgroupes.php?choix=creer'>Crer un nouveau groupe d'lves</a></li>
              <li><a href='gesgroupes.php?choix=supprimer'>Supprimer un groupe d'lves</a></li>
              <li><a href='gesgroupes.php?choix=consulter'>Consulter/modifier un groupe d'lves</a></li>
            </ol>
          </td>
        </tr>
      </table>";
			echo "<center>";
			squelette_formulaire_standard("75%","","","Choisissez une action",$code_formulaire,"","","","","","","");
			echo "</center>";
	} // switch ($choix)
}
else // L'utilisateur essaie d'invoquer ce script directement dans l'URL (interdit)
{
	$error_message = array("Vous tentez d'accder  un script qui n'est pas accessible directement  partir de l'URL... Utilisez les liens de navigation !","");
	affiche_erreurs($error_message);
}
?>