<?php
/**
 * c_saisie_notes.php
 *
 * Affiche un formulaire de saisie de note d'information pour les profs et/ou les lves
 * 
 * Ce fichier fait partie du projet IntraEduWeb (IEW)
 * 
 * @package		IEW
 * @author			Sylvain GODM <sylvain.godme@gmail.com>
 * @version		$LastChangedRevision$, $LastChangedDate$
 * @copyright		2004-2012 Sylvain GODM
 * @link			http://iew.free.fr
 * @license		GPL License version 3 (http://www.gnu.org/licenses/gpl.html)
 * @filesource
 * 
 */
 
/* Dclaration de fonctions */
function imprimer_form($auteur_note, $destinataire, $objet, $note, $id_note)
{
  if ($auteur_note == "")
    $auteur_note = $_SESSION['valid_prenom']." ".$_SESSION['valid_nom'];
  $code_formulaire = "
  <p>
  <label for='Form_Req_Auteur'>Auteur&nbsp;:</label> <input type='text' id='Form_Req_Auteur' name='auteur_note' size='20' value=\"$auteur_note\" />
  </p>
  <p>
  <label for='Form_Req_Destinataire'>Destinataire(s)&nbsp;:</label> <select size='1' id='Form_Req_Destinataire' name='destinataire'>
  ";
  if ($destinataire == "")
  {
     $code_formulaire .= "
     <option>profs</option>
     <option>lves</option>
     <option>lves et profs</option>
     <option>parents</option>
     <option>lves et parents</option>
     ";
  }
  else
  {
     $code_formulaire .= "
     <option selected>$destinataire</option>
     <option>profs</option>
     <option>lves</option>
     <option>lves et profs</option>
     <option>parents</option>
     <option>lves et parents</option>
     ";
  }
  $code_formulaire .= "</select></p><br />
  <p>
  <label for='Form_Req_Objet'>Objet&nbsp;:</label> <input type='text' id='Form_Req_Objet' name='objet' size='50' value=\"$objet\" />
  </p>
  <p>
  <label for='Form_Req_Note'>Note&nbsp;:</label><br />
  <textarea rows='7' name='note' id='Form_Req_Note' cols='65'>$note</textarea>
  </p>
  <input type='hidden' name='id_note' value='$id_note' />
  ".info_champs_obligatoires();
  echo "<br /><center>";
  echo "</center>";
  squelette_formulaire_standard("100%","post",$_SERVER['PHP_SELF'],"Saisie d'une note de service ou d'information",$code_formulaire,"Envoyer","soumettre","Annuler","annuler","","",""); 
  echo "<br /><a href='admin_notes.php'>[Ajout-modification-suppression d'une note d'information]</a>";
}
function verif_form($auteur_note, $destinataire, $objet, $note, $id_note) {
 if (!$auteur_note || !$objet || !$note): // si un au moins de ces champs de formulaire sont vides
  $error_message = array("Il y a des champs de formulaire vides ! Remplissez correctement le formulaire, et n'oubliez pas de vrifier le destinataire.","");
  affiche_erreurs($error_message);
  imprimer_form($auteur_note, $destinataire, $objet, $note, $id_note);
 else:
  // On prpare les donnes qui doivent tre insres dans la base de donnes
  $auteur_note = trim(htmlspecialchars($auteur_note));
  $objet = trim(htmlspecialchars($objet));
  $note = trim(($note)); // ici on peut laisser les balises HTML
  if ($id_note) // s'il s'agit d'une modification d'une note existante (le script ayant t appel avec le paramtre id_note)
  {
   $sql = "UPDATE notes set auteur='".quote_smart($auteur_note)."', objet='".quote_smart($objet)."', destinataire='".quote_smart($destinataire)."', note='".quote_smart($note)."' WHERE id_note='".quote_smart($id_note)."'";
  }
  else
  {
   $sql = "INSERT INTO notes VALUES(NOW(), '".quote_smart($auteur_note)."', '".quote_smart($objet)."', '".quote_smart($destinataire)."', '".quote_smart($note)."', NULL)";
  }
  if (mysql_query($sql) && mysql_affected_rows()!=0)
  {
    $ok_message = "Base de donnes mise  jour...<br />La nouvelle note de service est <a href='../consult_not.php?critere=$destinataire' title='Consulter la nouvelle note'>consultable</a> en ligne.<br />";
    affiche_ok($ok_message);
    unset($_POST);
    unset($_SESSION['post_imprimable']);
  }
  else
  {
    $error_message = array("<div align='justify'>La note n'a pas pu tre enrgegistre dans la base de donnes. C'est le cas notamment si vous venez de recharger la page ou bien si la note a le mme objet, le mme auteur et les mmes destinataires... <a href='../consult_not.php?critere=$destinataire'>Vrifiez</a> si la note est prise en compte ou bien <a href='".$_SERVER['PHP_SELF']."'>recommencez la saisie</a></div>","");
    affiche_erreurs($error_message);
    unset($_POST);
    unset($_SESSION['post_imprimable']);
    return;
  }

// en plus de l'criture de la note de service dans la base de donnes, cette note est envoye par e-mail  chaque prof
// si les destinataires de la note de service sont les profs

  if ($destinataire=="profs" || $destinataire=="lves et profs")
  {
  	if ($GLOBALS['sso'] == "eolesso") // On va communiquer avec le systme de messagerie de scribe (projet eole)
  	{
  		// faudra adapter le code lorsque les responsables auront une liste de diffusion
  		if ($destinataire=="profs")
  			$adresse = "professeurs@".$GLOBALS['domaine_mail']; // faudra renseigner $GLOBALS['domaine_mail'] dans config.php
  		if ($destinataire=="lves et profs")
  			$adresse = "eleves@".$GLOBALS['domaine_mail'];
  		
  		// Suite du code  faire + tard...
  		
  			
  			
  			
  			
  			
  			
  	}
  	else
  	{
   		$echec_contact = array(); // contiendra les nom et prnom des profs n'ayant pas pu tre contacts par mail interne
   		$sql = "SELECT t1.id_pers,t1.nom,t1.prenom,t2.nomlogin from personnel as t1,login as t2 WHERE t1.id_pers=t2.id_pers AND t1.categorie='7'";
   		$resultat = mysql_query($sql);
	   //echo stripslashes(strip_tags($note))."<br />";
   		while ($ligne=mysql_fetch_array($resultat))
   		{
    		$adresse = $ligne['nomlogin']."@".$GLOBALS['mail_server'];
    		$entetes_additionnels = "From: ".$GLOBALS['nom_etablissement']."<".$GLOBALS['email_etablissement'].">\n";
    		$testmail=mail($adresse,"Note de service de $auteur_note : $objet", "Une nouvelle note de service vient d'tre publie dans l'application IntraEduWeb du ".$GLOBALS['nom_etablissement']." :\n\n".stripslashes(strip_tags($note))."\n\n$auteur_note",$entetes_additionnels);
    		if (!$testmail)
    		{
     			$echec_contact[] = $ligne['prenom']." ".$ligne['nom']; // On ajoute le prof qui n'a pas pu tre contact dans le tableau
    		}
   		}
   		if (count($echec_contact)!=0)
   		{
     		if (count($echec_contact)==mysql_num_rows($resultat)) // tous les contacts ont chou
     		{
       			$error_message = array("La note de service n'a cependant pas pu tre transmise directement par mail aux destinataires ! Elle est toutefois consultable sur ce site, et apparatra aux utilisateurs concerns lors de leur prochaine connexion.<br />","");
       			affiche_erreurs($error_message);
     		}
     		else // seuls certaines personnes n'ont pas pu tre contactes
     		{
       			echo "<p>Il y a eu un problme lors de la transmission de votre message aux personnes suivantes :<br />";
       			foreach ($echec_contact as $value)
       			{
         			echo $value.", ";
       			}
       			echo "br>";
     		}
   		}
   		else
   		{
     		echo "<i>Les professeurs destinataires de la note ont galement t contacts directement par e-mail</i><br />";
   		}
  	}
  }

 imprimer_form("", "", "", "", "");
 endif;
 }

/* Dbut du progamme principal */

if (end_with_string($_SERVER['PHP_SELF'],"prive/saisie_notes.php"))
{
  connexion_mysql();
  select_database();
  if (!isset($_POST['soumettre']))
  {
    if (isset($_GET['id_note'])) // s'il s'agit d'une modification d'une note existante (le script ayant t appel avec le paramtre id_note)
    {
      echo "<h1>Note d'information</h1>";
      $sql = "SELECT * from notes WHERE id_note='".quote_smart($_GET['id_note'])."'";
      $resultat=mysql_query($sql);
      $ligne=mysql_fetch_array($resultat);
      imprimer_form($ligne['auteur'],$ligne['destinataire'],$ligne['objet'],$ligne['note'], $_GET['id_note']);
    }
    else
    {
      echo "<h1>Note d'information</h1>";
      imprimer_form("", "", "", "", "");
    }
  }
  else
  {
    verif_form($_POST['auteur_note'], $_POST['destinataire'], $_POST['objet'], $_POST['note'], $_POST['id_note']);
  }
}
else
{
  $error_message = array("Vous tentez d'accder  un script qui n'est pas accessible directement  partir de l'URL... Utilisez les liens de navigation !","");
  affiche_erreurs($error_message);
}
?>