<?php 
/**
 * do_change_edt.php
 *
 * code grant les ajouts, modifications ou suppressions de cours dans un edt
 * 
 * Ce fichier fait partie du projet IntraEduWeb (IEW)
 * 
 * @package	IEW
 * @author	Sylvain GODM <sylvain.godme@gmail.com>
 * @version	$LastChangedRevision$, $LastChangedDate$
 * @copyright	2004-2013 Sylvain GODM
 * @link	http://iew.free.fr
 * @license	GPL License version 3 (http://www.gnu.org/licenses/gpl.html)
 * @filesource
 * 
 */

function insert_cours_diff()
{
	/**
	 * Insre un enregistrement dans la table cours_diff contenant les cours ajouts, supprims ou modifis par rapport  la table cours
	 * (obtenue par importation des donnes de EDT_vers_STS_RNE_annee.xml, et qui contient donc l'emploi du temps "officiel")
	 * Cette table est alimente manuellement par formulaire. Elle est utile pour pouvoir effectuer des corrections d'EDT lorsqu'il n'est pas possible
	 * de modifier EDT_vers_STS_RNE_annee.xml ou bien lorsqu'il s'agit de modifier un EDT de faon trs ponctuelle
	 * (dplacement d'un cours, remplacement d'un cours par un autre en cas d'absence d'un professeur,...)
	 *  
	 */
	if ($_POST['type_diff'] == "add")
		$msg_diff = "ajout ";
	elseif ($_POST['type_diff'] == "del")
		$msg_diff = "supprim de";
	elseif ($_POST['type_diff'] == "mod")
		$msg_diff = "modifi dans";
	
	if (!isset($_POST['structure_complete']))
		$_POST['structure_complete'] = 1; // Valeur par dfaut si non envoye par formulaire (case "Concerne une partie seulement de la classe ou du groupe" non coche)
	if ($_POST['date'] == NULL)
		$sql = "INSERT INTO cours_diff VALUES(NULL,'".$_POST['type_diff']."','".$_POST['id_cours']."','".$_POST['id_individu']."','".$_POST['code_structure']."','".$_POST['structure_complete']."','".$_POST['code_alternance']."',NULL,'".$_POST['code_jour']."','".$_POST['heure_debut']."','".$_POST['duree']."','".$_POST['code_matiere']."','".$_POST['code_matiere_etab']."','".quote_smart($_POST['code_salle'])."')";
	else 
		$sql = "INSERT INTO cours_diff VALUES(NULL,'".$_POST['type_diff']."','".$_POST['id_cours']."','".$_POST['id_individu']."','".$_POST['code_structure']."','".$_POST['structure_complete']."',NULL,'".$_POST['date']."','".$_POST['code_jour']."','".$_POST['heure_debut']."','".$_POST['duree']."','".$_POST['code_matiere']."','".$_POST['code_matiere_etab']."','".quote_smart($_POST['code_salle'])."')";
	// le code_salle est quote smart car c la seule valeur saisie directement par l'utilisateur (pas secure)
	
	if (!mysql_query($sql) || mysql_affected_rows() != 1)
	{
		$precision = "<br />La Commande SQL suivante a chou :<br />$sql<br />".mysql_errno(). ": " . mysql_error(). "<br />";
		$error_message = array("Le cours n'a pas pu tre $msg_diff l'emploi du temps !$precision","");
		affiche_erreurs($error_message);	
	}
	else 
	{
		$ok_message = "Le cours a bien t $msg_diff l'emploi du temps !";
		affiche_ok($ok_message);
	}
}

function update_cours_diff()
{
	/**
	 * Met  jour (ou supprime) un enregistrement dj prsent dans la table cours_diff
	 * 
	 * Il s'agit donc d'une mise  jour d'un cours qui est dj modifi par rapport  la table cours 
	 * (obtenue par importation des donnes de EDT_vers_STS_RNE_annee.xml, et qui contient donc l'emploi du temps "officiel")
	 */
	if ($_POST['type_diff'] == "mod")
	{
		$msg_diff = "modifi dans";
		if (!isset($_POST['structure_complete']))
			$_POST['structure_complete'] = 1; // Valeur par dfaut si non envoye par formulaire (case "Concerne une partie seulement de la classe ou du groupe" non coche)
		if ($_POST['date'] == NULL)
			$sql = "UPDATE cours_diff SET id_individu='".$_POST['id_individu']."',code_structure='".$_POST['code_structure']."',structure_complete='".$_POST['structure_complete']."',code_alternance='".$_POST['code_alternance']."',date=NULL,code_jour='".$_POST['code_jour']."',heure_debut='".$_POST['heure_debut']."',duree='".$_POST['duree']."',code_matiere='".$_POST['code_matiere']."',code_matiere_etab='".$_POST['code_matiere_etab']."',code_salle='".$_POST['code_salle']."' WHERE id_cours_diff='".$_POST['id_cours']."'";
		else
			$sql = "UPDATE cours_diff SET id_individu='".$_POST['id_individu']."',code_structure='".$_POST['code_structure']."',structure_complete='".$_POST['structure_complete']."',code_alternance=NULL,date='".$_POST['date']."',code_jour='".$_POST['code_jour']."',heure_debut='".$_POST['heure_debut']."',duree='".$_POST['duree']."',code_matiere='".$_POST['code_matiere']."',code_matiere_etab='".$_POST['code_matiere_etab']."',code_salle='".$_POST['code_salle']."' WHERE id_cours_diff='".$_POST['id_cours']."'";
	}
	elseif ($_POST['type_diff'] == "del")
	{
		$msg_diff = "supprim de";
		$sql = "DELETE FROM cours_diff WHERE id_cours_diff='".$_POST['id_cours']."'"; // On rtablit le cours officiel d'origine
	}
	elseif ($_POST['type_diff'] == "restore")
	{
		$msg_diff = "rtabli dans";
		$sql = "DELETE FROM cours_diff WHERE id_cours_diff='".$_POST['id_cours']."'"; // On rtablit le cours officiel d'origine
	}
	if (!mysql_query($sql) || mysql_affected_rows() != 1)
	{
		$precision = "<br />La Commande SQL suivante a chou :<br />$sql";
		if (mysql_errno() != 0)
		{
			$precision .= "<br />".mysql_errno(). ": " . mysql_error();
		}
		$error_message = array("Le cours n'a pas pu tre $msg_diff l'emploi du temps !<br />$precision","");
		affiche_erreurs($error_message);	
	}
	else 
	{
		$ok_message = "Le cours a bien t $msg_diff l'emploi du temps !";
		affiche_ok($ok_message);
	}
}

/* Code principal */

// Si ce script est appel directement (JS activ) sans tre inclus, il faut mettre les fonctions  disposition
if(!defined('IEW_DIR')) define('IEW_DIR',realpath(dirname(__FILE__)."/../").'/');
// Inclusions
require_once(IEW_DIR."librairie_fonctions.php");

/* Rcupration des donnes du formulaire */
// On modifie certanies valeurs rcupres
if (isset($_POST['cours_ponctuel'])) // si c un cours ponctuel
{
	$_POST['code_alternance'] = NULL; // la date du cours sera prise en compte
	$_POST['date'] = ExplicitDateToMySQLDate($_POST['date']); // Elle est au format long, il faut la convertir en MySQL
}
else // l'alternance sera prise en compte
	$_POST['date'] = NULL;

// DEBUGG var_dump($_POST);return;

if ($_POST['type_diff'] == "restore") // on veut restaurer un cours d'origine
{
	$_POST['id_cours'] = $_POST['id_cours_url']; // l'id_cours post est celui du cours d'origine (son intrt est tait juste pour rcuprer les infos du cours d"origine afin de les afficher dans le formulaire, mais le vritable cours qu'il faut supprimer est celui de la table cours_diff
	update_cours_diff();
}
elseif ($_POST['id_cours'] >= 10000) // c une nouvelle modification d'un cours dj modifi par rapport  l'EDT "officiel" (provenant de l'import de EDT_vers_STS_RNE_Annee.xml)
	update_cours_diff();
else // c une modification d'un cours de l'EDT "officiel" (provenant de l'import de EDT_vers_STS_RNE_Annee.xml)
	insert_cours_diff();
?>