<?php
/**
 * download_doc.php
 *
 * tlchargement de documents joints aux cahiers de textes
 *  cause des intructions header contenus dans la fonction download_file(), la sortie html doit avoir lieu aprs les headers
 * 
 * Ce fichier fait partie du projet IntraEduWeb (IEW)
 * 
 * @package		IEW
 * @author			Sylvain GODM <sylvain.godme@gmail.com>
 * @version		$LastChangedRevision$, $LastChangedDate$
 * @copyright		2004-2012 Sylvain GODM
 * @link			http://iew.free.fr
 * @license		GPL License version 3 (http://www.gnu.org/licenses/gpl.html)
 * @filesource
 * 
 */

if(!defined('IEW_DIR')) define('IEW_DIR',realpath(dirname(__FILE__)."/../").'/');
// Inclusions
require_once(IEW_DIR."librairie_fonctions.php");

// Si le paramtre file est dfini dans l'URL, on peut envoyer le fichier choisi
if (isset($_GET['file']) && $_GET['file']!="")
{ 
  if (isset($_GET['import']) && $_GET['import']!="") // la variable import est initialise dans c_import.php
  {
  	$path_file = $GLOBALS['stock_baselev']."importation/"; // racine du dossier de stockage
  	$fichier = $_GET['file'];
  }
  elseif (isset($_GET['maj']) && $_GET['maj']!="")
  {
  	$path_file = $GLOBALS['stock_baselev']."updates/"; // racine du dossier de stockage
  	$fichier = $_GET['file'];
  }
  else // cas par dfaut : c'est un document joint  un cahier de textes
  {
  	$dossier_ctextes = $GLOBALS['stock_baselev']."cahiers_textes/";
  	if (isset($_GET['classe']) && $_GET['classe'] != "") // Si la classe est fournie dans l'URL (cas d'un lien dans une vue de synthse d'un cahier de texte)
  	{
  		// Dans ce cas, le chemin d'accs au document sera un lien symbolique
  		$sous_dossier_ctextes_classe = $dossier_ctextes.$_GET['classe']."/";
  		if (!isset($_GET['matiere']) || $_GET['matiere'] == "") // si c'est un groupe et pas une classe
    		$sous_dossier_ctextes_classe_matiere = $sous_dossier_ctextes_classe; // il n'y a pas de sous-dossier matire
  		else
    		$sous_dossier_ctextes_classe_matiere = $sous_dossier_ctextes_classe.$_GET['matiere']."/";
	    // Voil le chemin d'accs complet au fichier
  		$path_file = $sous_dossier_ctextes_classe_matiere;
  	}
  	else // la classe n'est pas fourni, seul le nom du document l'est (rappel : le stockage est unique pour limiter l'occupation disque)
  	{
  		// Dans ce cas le chemin d'accs au document est le sous-dossier docs
  		$path_file = $dossier_ctextes."docs/";
  	}
  	$fichier = $_GET['file'];
  }
  download_file($path_file,$fichier); // on le tlcharge
}
else
{
  debut_code_html();
  $error_message = array("
  Aucun paramtre file n'est fourni dans l'url. Le tlchargement ne peut avoir lieu.","");
  affiche_erreurs($error_message);
  fin_code_html();
}
?>