<?php 
/**
 * form_change_edt.php
 *
 * code affichant le formulaire de saisie pour l'ajout ou la modification d'un emploi du temps
 * est inclus dans c_edt.php
 * 
 * Ce fichier fait partie du projet IntraEduWeb (IEW)
 * 
 * @package	IEW
 * @author	Sylvain GODM <sylvain.godme@gmail.com>
 * @version	$LastChangedRevision$, $LastChangedDate$
 * @copyright	2004-2013 Sylvain GODM
 * @link	http://iew.free.fr
 * @license	GPL License version 3 (http://www.gnu.org/licenses/gpl.html)
 * @filesource
 * 
 */

// Si ce script est appel directement (JS activ) sans tre inclus, il faut mettre les fonctions  disposition
if(!defined('IEW_DIR')) define('IEW_DIR',realpath(dirname(__FILE__)."/../").'/');
// Inclusions
require_once(IEW_DIR."librairie_fonctions.php");
require_once(IEW_DIR."lib/fonctions_edt.php");

global $horaires_sql; // va tre initialise dans l'appel suivant
recup_horaires_edt(); // contient tous les horaires de dbut de cours possible (dtermins lors de l'import de EDT_vers_STS_RNE_AAAA.xml)

/* Une partie des donnes vient des paramtres URL : il faut les contrler */
if (isset($_GET['modif']) && $_GET['modif'] != true) // on a le droit qu' true
	$_GET['modif'] = true;
if (isset($_GET['changeform']) && $_GET['changeform'] != true) // on a le droit qu' true
	$_GET['changeform'] = true;
if (isset($_GET['type_diff']))
{
	if ($_GET['type_diff'] != "add" && $_GET['type_diff'] != "mod" && $_GET['type_diff'] != "del" && $_GET['type_diff'] != "restore") // il y a eu une modification manuelle (avec valeur non autorise) dans l'url de la page
	{
		$error_message = array("Un paramtre URL a t modifi de faon interdite, veuillez ne pas modifier les valeurs des paramtres URL, utilisez les liens de la page tels quels !","");
		affiche_erreurs($error_message);
		return;
	}
}
else // ce paramtre est indispensable ! 
{
	$error_message = array("Un paramtre URL indispensable n'est pas prsent. Veuillez ne pas modifier les valeurs des paramtres URL, utilisez les liens de la page tels quels !","");
	affiche_erreurs($error_message);
	return;
}
if (isset($_GET['cours']))
	$id_cours = intval($_GET['cours']); // vaut 0 si ce n'est pas un nombre
else // Le paramtre peut-tre absent (ex : ajout de cours)
	$id_cours = 0;
// On rcupre la liste des Alternances possibles (sera utilis galement plus loin)
$tableau_options1=liste_options_form("connect","code_alternance","alternances","");
if (isset($_GET['alternance']))
{
	if (in_array($_GET['alternance'],$tableau_options1)) // on a le droit qu'aux valeurs d'alternances de la table alternances
		$current_code_alternance_cours = $_GET['alternance'];
	// sinon sera dfinie + loin
} // Dfinition par dfaut sera traite + loin

if (isset($_GET['j'])) // on a le droit qu'aux valeurs entires de 1  6 (jours de la semaine)
{
	if ($_GET['j'] > 6 || $_GET['j'] == 0)
		$_GET['j'] = 1; // on pointe sur le lundi par dfaut
	// l on laisse passer le paramtre
}
else // Dfinition par dfaut obligatoire
	$_GET['j'] = 1; // on pointe sur le lundi par dfaut

if (isset($_GET['i'])) // On a le droit qu'aux entiers de 1 au nombre de valeurs dans le tableau $horaires_sql
{
	if (isset($horaires_sql))
	{
		if ($_GET['i'] > count($horaires_sql) || $_GET['i'] == 0)
			$_GET['i'] = 1;
		else // c bon 
			$current_heure_debut_cours = $horaires_sql[$_GET['i']-1];
	}
	else 
		$_GET['i'] = 1;
}
else // Dfinition par dfaut obligatoire
	$_GET['i'] = 1;

// Dfinition par dfaut obligatoire
$current_duree_cours = "0100"; // sera modifi ventuellement (en cas de modif d'un cours existant)

/* Fin de la vrification de paramtres URL */

// Si on doit restaurer un cours d'origine, il faut rcup son id d'origine (qui n'est pas dans l'url)
if ($id_cours !=0 && $_GET['type_diff'] == "restore")
{
	if ($id_cours >= 10000) // pour un restore c tjs le cas normalement
	{
		$sql = "SELECT id_cours FROM cours_diff WHERE id_cours_diff='".quote_smart($id_cours)."'";
		$resultat = mysql_query($sql);
		$ligne = mysql_fetch_array($resultat);
		$id_cours = $ligne['id_cours']; // voil le cours  restaurer : c celui-ci qui sera afficher dans le formulaire
	}
}
// Dtermination des valeurs  afficher en cas de modification d'un cours existant ou de rtablissement d'un cours d'origine
if ($id_cours !=0 && ($_GET['type_diff'] == "mod" || $_GET['type_diff'] == "del" || $_GET['type_diff'] == "restore"))
{
	// Grce  l'identifiant du cours, on peut retrouver les infos compltes de la base de donnes
	if ($id_cours < 10000)
		$sql = "SELECT t2.id_individu,nom,prenom,code_structure,code_alternance,code_jour,heure_debut,duree,t1.code_matiere,libelle_long,code_salle FROM cours as t1, enseignants_services as t2, services as t3, personnel as t4, matieres_sconet as t5 WHERE id_cours='$id_cours' AND t1.id_enseignant_service=t2.id_enseignant_service AND t2.id_service=t3.id_service AND t2.id_individu=t4.id_individu AND t5.code_matiere=t1.code_matiere";
	else
		$sql = "SELECT t1.*,nom,prenom FROM cours_diff as t1, personnel as t2 WHERE id_cours_diff='$id_cours' AND t1.id_individu=t2.id_individu";
	// DEBUGG echo $sql;
	$resultat = mysql_query($sql);
	if ($resultat && mysql_num_rows($resultat) > 0)
	{
		$ligne = mysql_fetch_array($resultat);
		if (isset($ligne['date']))
		{
			$current_date_cours = $ligne['date'];
			$current_checkstatus_cours_ponctuel = "checked='checked'"; // la case correspondante sera coche dans le formulaire
		}
		$current_id_prof_cours = $ligne['id_individu'];
		$current_nom_prof_cours = $ligne['nom']." ".$ligne['prenom'];
		$current_code_structure_cours = $ligne['code_structure'];
		$current_code_alternance_cours = $ligne['code_alternance'];
		$current_code_jour_cours = $ligne['code_jour'];
		$current_heure_debut_cours = $ligne['heure_debut'];
		$current_duree_cours = $ligne['duree'];
		$current_code_matiere_cours = $ligne['code_matiere'];
		// pour avoir le libelle_long, si c un cours de la table cours_diff (id_cours >= 10000), il faut le rechercher  partir du code matire
		if ($id_cours >= 10000)
		{
			if ($ligne['structure_complete'] == 0)
			{
				$current_checkstatus_cours_partie_classe = "checked='checked'"; // la case correspondante sera coche dans le formulaire
			}
			$sql2 = "SELECT libelle_long FROM matieres_sconet WHERE code_matiere='$current_code_matiere_cours'";
			$resultat2 = mysql_query($sql2);
			$ligne2 = mysql_fetch_array($resultat2);
			$current_libelle_matiere_cours = $ligne2['libelle_long'];
		}
		else 
			$current_libelle_matiere_cours = $ligne['libelle_long'];
		$current_code_salle_cours = $ligne['code_salle'];
	}	
}

// On va dterminer la date du cours  ajouter/modifier d'aprs les paramtres URL
if (isset($current_date_cours) && $current_date_cours != "") // la date du cours a t rcupre dans la base de donnes (cours ponctuel)
	$date_long = MySQLDateToExplicitDate($current_date_cours);
else // la date du cours n'a rien  voir avec ce qui est enregistr dans la base de donn, mais c'est en rapport avec le clic sur le contrle d'ajout/modification dans le planning EDT
{
	$jour = $_GET['j'] - 1; // au pire on a 0 (on pointe alors au debut de la semaine)
	$date_cours = date("Y-m-d", strtotime("+ $jour day",strtotime($_GET['debut_semaine'])));
	$date_long = MySQLDateToExplicitDate($date_cours);
}

/************************ Affichage du formulaire ****************************/

$contenu_formulaire = "<p><label id='L_DateCours' for='DateCours'>Date du cours : </label>
<input id='DateCours' aria-labelledby='L_DateCours' type='text' name='date' value='".$date_long."' /></p>

<p><input id='CoursPonctuel' aria-labelledby='L_CoursPonctuel' type='checkbox' name='cours_ponctuel' value='1' $current_checkstatus_cours_ponctuel title=\"Si la case est coche, la valeur du champ Alternance qui suit ne sera pas prise en compte\" />
<label id='L_CoursPonctuel' for='CoursPonctuel'>Cours ponctuel</label>";

if ($current_checkstatus_cours_ponctuel != "checked='checked'") // on n'afffichera le champ select pour l'alternance que si la case cours ponctuel n'est pas coche
{
	$contenu_formulaire .="<label id='L_AlternanceCours' for='AlternanceCours'>Alternance : </label>
	<select id='AlternanceCours' aria-labelledby='L_AlternanceCours' name='code_alternance'>";
	// voil qui sera + explicite (ici c'est en dur dans le code...)
	$tableau_options1_complement_libelle = array("H"=>"Cours hebdomadaire",
	"Q1" => "Cours de premire quinzaine",
	"Q2" => "Cours de deuxime quinzaine",
	"T1" => "Cours de premier trimestre",
	"T2" => "Cours de deuxime trimestre",
	"T3" => "Cours de troisime trimestre",
	"S1" => "Cours de premier semestre",
	"S2" => "Cours de deuxime semestre");
	// On affiche l'alternance du cours  ajouter/modifier en premire option par dfaut
	if (isset($current_code_alternance_cours) && $current_code_alternance_cours != "")
	{
		$tab_options[0] = "<option selected='selected' value='$current_code_alternance_cours'>".$current_code_alternance_cours." (".$tableau_options1_complement_libelle[$current_code_alternance_cours].")"."</option>";
	}
	else // alternance du cours pas connue => par dfaut H
	{
		$tab_options[0] = "<option selected='selected' value='H'>H (Cours hebdomadaire)</option>";
	}
	// On va crer un nouveau tableau qui contiendra toutes les options  afficher sous le format "Alternance (complment du libell)"
	foreach($tableau_options1 as $value)
	{
		// On cherche un libell + explicite  afficher
		if (strlen($value) > 2) // Cas des alternances T12, T13, T23 (je ne sais pas  quoi elles servent !)
		{
			continue; // Ne sera pas intgr dans les options du select au final
		}
		$tab_options[] = "<option value='$value'>".$value." (".$tableau_options1_complement_libelle[$value].")"."</option>";
	}
	// On n'utilise pas ensuite $contenu_formulaire .= affiche_liste_options_formulaire($new_tab); car la valeur  afficher () ne se trouve pas dans la table alternance
	foreach($tab_options as $value)
	{
		$contenu_formulaire .= $value."\n"; // "\n" pour un retour  la ligne  chaque option dans l'affichage du code source (c un test : c + clair mais cela ne vaut pas le coup de modifier tous les scripts pour obtenir la mme chose, trop de travial pour trop peu de bnfice)
	}
	$contenu_formulaire .= "</select></p>";
}

$contenu_formulaire .= "<p><label id='L_DebutCours' for='ReqDebutCours'>Dbute  : </label>
<select id='ReqDebutCours' aria-labelledby='L_DebutCours' name='heure_debut'>";

// On affiche l'heure de dbut du cours  ajouter/modifier en premire option par dfaut
if (isset($current_heure_debut_cours))
	$contenu_formulaire .= "<option value='$current_heure_debut_cours'>".substr($current_heure_debut_cours,0,2)." h ".substr($current_heure_debut_cours,-2,2)."</option>";
// Puis les tous les horaires possibles en options
foreach ($horaires_sql as $value)
{
	$contenu_formulaire .= "<option value='$value'>".substr($value,0,2)." h ".substr($value,-2,2)."</option>";
}
$contenu_formulaire .= "
</select>

<label id='L_DureeCours' for='ReqDureeCours'>Dure : </label>
<select id='ReqDureeCours' aria-labelledby='L_DureeCours' name='duree'>";
$contenu_formulaire .= "<option selected='selected' value='$current_duree_cours'>".substr($current_duree_cours,0,2)." h ".substr($current_duree_cours,-2,2)."</option>\n
<option>-----</option>";
$tab_durees = recup_durees_cours();
foreach ($tab_durees as $value)
{
	$contenu_formulaire .= "<option value='$value'>".substr($value,0,2)." h ".substr($value,-2,2)."</option>";
}
$contenu_formulaire .= "
</select>
</p>

<p><label id='L_MatiereCours' for='ReqMatiereCours'>Matire : </label>
<select id='ReqMatiereCours' aria-labelledby='L_MatiereCours' name='code_matiere'>";
if (isset($current_code_matiere_cours))
	$contenu_formulaire .= "<option selected='selected' value='$current_code_matiere_cours'>$current_libelle_matiere_cours</option><option>-----</option";
/* Si c'est un EDT de prof qui est modifi, il faut afficher la liste des matires qu'il enseigne (dans l'ordre alphabtique), suivie d'un espace + la liste de toutes les matires */
$sql = "SELECT DISTINCT t1.code_matiere,libelle_long FROM services as t1,enseignants_services as t2, matieres_sconet as t3 WHERE id_individu='".$_GET['edt']."' AND t1.id_service=t2.id_service AND  t1.code_matiere=t3.code_matiere ORDER BY libelle_long";
// Si c'est un EDT de classe qu'on modifie la requte prcdente en donnera aucun rsultat, pas grave
$resultat = mysql_query($sql);
if ($resultat && mysql_num_rows($resultat) > 0)
{
	while ($ligne = mysql_fetch_array($resultat))
	{
		$contenu_formulaire .= "<option value='".$ligne['code_matiere']."'>".$ligne['libelle_long']."</option>";
	}
	$contenu_formulaire .= "<option>-----</option>";
	$flag_edt_prof = true;
}
elseif (mysql_num_rows($resultat) == 0) // on a donc srement  faire  un EDT de classe
{
	$flag_edt_prof = false;
}
/* Si c'est un EDT de classe qui est modifi, il faut afficher la liste complte des matires (mme dans le cas d'un EDT prof d'ailleurs) */
$sql = "SELECT code_matiere,libelle_long FROM matieres_sconet ORDER BY libelle_long";
$resultat = mysql_query($sql);
if ($resultat && mysql_num_rows($resultat) > 0)
{
	while ($ligne = mysql_fetch_array($resultat))
	{
		$contenu_formulaire .= "<option value='".$ligne['code_matiere']."'>".$ligne['libelle_long']."</option>";
	}
}
$contenu_formulaire .= "
</select>
</p>";

if ($flag_edt_prof) // C'est un EDT prof que l'on modifie
{
	$contenu_formulaire .= "
	<p><label id='L_ClasseCours' for='ReqClasseCours'>Classe ou Groupe : </label>
	<select id='ReqClasseCours' aria-labelledby='L_ClasseCours' name='code_structure'>";
	if (isset($current_code_structure_cours))
		$contenu_formulaire .= "<option selected='selected'>$current_code_structure_cours</option><option>-----</option";
	/* Comme c'est un EDT de prof qui est modifi, il faut afficher la liste des classes et groupes qu'il a en responsabilit (groupes sconet et groupes manuels), suivis du reste des classes et des groupes (groupes sconet seulement) existants */
	$tableau_options1 = liste_options_form("connect","services.code_structure","services,enseignants_services","services.id_service = enseignants_services.id_service AND id_individu='".quote_smart($_GET['edt'])."'");
	$tableau_options2 = liste_options_form("connect","nom","groupes","id_responsable='".quote_smart($_GET['edt'])."'");
   	// Puis on va mettre toutes les classes et tous les groupes sconet
   	$tableau_options2[] = "-----"; // mais un espace avant cette liste gnrale
   	$tableau_options3 = liste_options_form("connect","code_structure","structures","");
	$tableau_options=array_merge($tableau_options1,$tableau_options2, $tableau_options3);
   	$contenu_formulaire.=str_replace("<option></option>","",affiche_liste_options_formulaire($tableau_options)); // On enlve le premier lment de la liste des options car c une option vide (or le code_structure ne doit pas tre vide)
	$contenu_formulaire .= "
	</select>";
	// Il faut aussi transmettre l'identifiant numrique du prof (en champ cach)
	$contenu_formulaire .= "<input id='hideIdIndividu' type='hidden' name='id_individu' value='".$_GET['edt']."' />";
	// et signaler qu'on modifie un EDT de professeur
	$contenu_formulaire .= "<input id='hideFlagEdtProf' type='hidden' name='flag_edt_prof' value='1' />";
}
else // C'est un EDT classe que l'on modifie
{
	$contenu_formulaire .= "
	<p><label id='L_ProfCours' for='ReqProfCours'>Professeur : </label>
	<select id='ReqProfCours' aria-labelledby='L_ProfCours' name='id_individu'>";
	/* il faut afficher la liste des professeurs */
	if (isset($current_id_prof_cours) && $current_id_prof_cours !="")
		$contenu_formulaire .= "<option selected='selected' value='$current_id_prof_cours'>$current_nom_prof_cours</option><option>-----</option>";
	$contenu_formulaire .= new_liste_options_form("id_individu","nom,prenom","personnel","categorie='7'","");
	$contenu_formulaire .= "
	</select>";
	// Il faut aussi transmettre la classe ou le groupe
	$contenu_formulaire .= "<input id='hideCodeStructure' type='hidden' name='code_structure' value='".$_GET['edt']."' />";
}
$contenu_formulaire .= "
<label id='L_SalleCours' for='SalleCours'>Salle : </label>
<input id='SalleCours' aria-labelledby='L_SalleCours' type='text' size='5' name='code_salle' value='$current_code_salle_cours' />
</p>
<p><input id='CoursPartieClasse' aria-labelledby='L_CoursPartieClasse' type='checkbox' name='structure_complete' value='0' $current_checkstatus_cours_partie_classe title=\" cocher uniquement si vous avez choisi une classe (et pas un groupe) dans le champ libell 'Classe ou Groupe' et si une autre partie de la classe est susceptible d'avoir un autre cours en parallle\" />
<label id='L_CoursPartieClasse' for='CoursPartieClasse'>Concerne une partie seulement de la classe</label>
</p>
";
/* champs cachs */
$contenu_formulaire .= "
<input id='hideTypeDiff' type='hidden' name='type_diff' value='".$_GET['type_diff']."' />
<input id='hideIdCours' type='hidden' name='id_cours' value='".$id_cours."' />
<input id='hideIdCoursUrl' type='hidden' name='id_cours_url' value='".intval($_GET['cours'])."' />
<input id='hideCodeJour' type='hidden' name='code_jour' value='".$_GET['j']."' />
";
echo "<center>";
if ($_GET['type_diff'] == "del")
{
	$submit_btn_value = "Supprimer ce cours";
	$title_form = "Supprimer un cours";
}
elseif ($_GET['type_diff'] == "restore")
{
	if ($id_cours == 0)
	{
		$submit_btn_value = "Librer ce crneau";
		$title_form = "Rtablir un crneau libre";
	}
	else 
	{
		$submit_btn_value = "Rtablir ce cours";
		$title_form = "Rtablir un cours";
	}
}
elseif ($_GET['type_diff'] == "mod")
{
	$submit_btn_value = "Enregistrer les modifications";
	$title_form = "Modifier";	
}
elseif ($_GET['type_diff'] == "add")
{
	$submit_btn_value = "Ajouter ce cours";
	$title_form = "Ajouter un cours";
}

// La cible du formulaire est le script d'appel (afin de pouvoir rafficher l'EDT), mais avec un paramtre URL qui permet de charger le code traitant les donnes du formulaire avant d'afficher l'EDT
// comme il faut recharger l'emploi du temps affich sous le formulaire, il faut remettre les paramtres URL modif=true, categorie, edt, debut_semaine
$query_string = "?modif=true&amp;categorie=".$_GET['categorie']."&amp;edt=".$_GET['edt']."&amp;debut_semaine=".$_GET['debut_semaine']."&amp;SubmitChangeForm=true";
squelette_formulaire_standard("70%","post","edt.php".$query_string,"<h2 class='hidden'>$title_form un cours</h2>$title_form",$contenu_formulaire,$submit_btn_value,"soumettre","Annuler","AnnulerForm","","","","","id='AddModifyCoursForm'");
echo "</center>";
?>