<?php 
/**
 * show_foto.php
 *
 * Descriptif de la page permettant l'accs direct aux fichiers images pour les trombinoscopes (utilisation avec Lightview)
 * 
 * Ce fichier fait partie du projet IntraEduWeb (IEW)
 * 
 * @package	IEW
 * @author	Sylvain GODM <sylvain.godme@gmail.com>
 * @version	$LastChangedRevision$, $LastChangedDate$
 * @copyright	2004-2013 Sylvain GODM
 * @link	http://iew.free.fr
 * @license	GPL License version 3 (http://www.gnu.org/licenses/gpl.html)
 * @filesource
 * 
 */

// la page est protge, elle utilise les sessions et le systme d'authentification diffrencie
// le tableau $array_valid_user contient les identifiants des catgories d'utilisateurs autoriss  accder  cette page (voir la table groupes_utilisateurs)


if(!defined('IEW_DIR')) define('IEW_DIR',realpath(dirname(__FILE__)."/../").'/');
// Inclusions
require_once(IEW_DIR."librairie_fonctions.php");

if (end_with_string($_SERVER['HTTP_REFERER'],"prive/admin/trombinelev.php"))
{
	$cat_user = "eleve"; // On veut afficher la photo d'un lve
}
else 
	$cat_user = "prof"; // On veut afficher la photo d'un prof

// Dans tous les cas, le fichier  transmettre a priori
if (isset($_GET['id']))
	$fichier = $_GET['id'].".jpg";
else 
	$fichier = "defaut.jpg";
	
if ($cat_user == "eleve")
{
	$path_file = $GLOBALS['stock_baselev']."fotoelev/";
}
else 
{
	$path_file = $GLOBALS['stock_baselev']."fotoprof/";
}

if (file_exists($path_file.$fichier)) // La photo est disponible (elle existe)
{    
	// On vrifie s'il y a autorisation d'affichage (si oui le nom du fichier photo est renvoy, sinon, c'est un fichier par dfaut indiquant l'opposition parentale ou personnelle)
    $fichier = verif_autorisation_publication_foto($cat_user,$_GET['id']);
    // Reste  vrifier les droits d'accs par scurit de l'utilisateur connect
    // cela permet d'viter un accs  la photo par une mthode directe avec l'URL /iew/prive/show_foto.php?id=44 par exemple sans tre connect  l'appli ou sans faire partie des groupes autoriss
    $flag_access = false; // a priori pas d'accs
    if ($cat_user == "eleve") // si on veut voir le trombinoscope des lves, va falloir montrer patte blanche...
    {
    	$array_valid_user=array("1","3","5","6","8","9","10"); // les groupes admin,profs,gestadmin,direction,surveillants, orientation, sant/social ont seuls une autorisation d'accs 
       	foreach ($array_valid_user as $value)
    	{
    		if ($_SESSION['valid_group'] == $value)
    			$flag_access = true;
    	}
    }
    else // accs aux autres trombinoscope : autoris pour toute personne authentifie
    {
    		if (isset($_SESSION['valid_group']))
    			$flag_access = true;
    }
    if ($flag_access) // si accs autoris, on envoie l'image
    {
    	header("Content-Type: image/jpeg");
		readfile($path_file.$fichier);
    }
}
else // Si la photo n'existe pas on met la photo par dfaut, pas de vrification d'autorisation  faire dans ce cas
{
	header("Content-Type: image/jpeg");
	readfile($path_file."defaut.jpg");
}

?>