<?php
/**
 * resize_image.php
 *
 * permet de redimmensionner une image (utilis pour l'affichage du trombinoscope du personnel ou des lves)
 * 
 * Ce fichier fait partie du projet IntraEduWeb (IEW)
 * 
 * @package		IEW
 * @author			Sylvain GODM <sylvain.godme@gmail.com>
 * @version		$LastChangedRevision$, $LastChangedDate$
 * @copyright		2004-2012 Sylvain GODM
 * @link			http://iew.free.fr
 * @license		GPL License version 3 (http://www.gnu.org/licenses/gpl.html)
 * @filesource
 * 
 */

if (!isset($_GET['max_width']))
{
  $max_width = 100;
}
else
{
  $max_width = $_GET['max_width'];
}
if (!isset($_GET['max_height']))
{
  $max_height = 120;
}
else
{
  $max_height = $_GET['max_height'];
}

$size = getimagesize($_GET['image']);
$width = $size[0];
$height = $size[1];

$x_ratio = $max_width / $width;
$y_ratio = $max_height / $height;

if ( ($width <= $max_width) && ($height <= $max_height) ) {
  $tn_width = $width;
  $tn_height = $height;
}
else if (($x_ratio * $height) < $max_height) {
  $tn_height = ceil($x_ratio * $height);
  $tn_width = $max_width;
}
else {
  $tn_width = ceil($y_ratio * $width);
  $tn_height = $max_height;
}

header("Content-type: image/jpeg");
$src = imagecreatefromjpeg($_GET['image']);
$dst = imagecreatetruecolor($tn_width,$tn_height);
imagecopyresized($dst, $src, 0, 0, 0, 0,
    $tn_width,$tn_height,$width,$height);

imagejpeg($dst, null, -1);
imagedestroy($src);
imagedestroy($dst);

?>