<?php
/**
 * squelette.php
 *
 * indique les squelettes utiliss par dfaut
 * 
 * Ce fichier fait partie du projet IntraEduWeb (IEW)
 * 
 * @package		IEW
 * @author			Sylvain GODM <sylvain.godme@gmail.com>
 * @version		$LastChangedRevision$, $LastChangedDate$
 * @copyright		2004-2012 Sylvain GODM
 * @link			http://iew.free.fr
 * @license		GPL License version 3 (http://www.gnu.org/licenses/gpl.html)
 * @filesource
 * 
 */
 
/* On gre le format d'affichage de la page (un squelette pour l'affichage normal et un squelette (imprimable.php) pour le format imprimable
Le choix du squelette utilis se fait en fonction d'une variable $_GET['imprimable'] qui, positionne  oui
provoque l'affichage de la page en mode imprimable et, positionne  non, l'affichage de la page en mode normal.
Mais ensuite, il faut tenir compte du fait que si sur l'une des pages on poste un formulaire ou on clique sur un lien qui ne renvoie pas la variable $_GET['imprimable'], pour savoir dans quel format afficher la page suivante, on a recours  la variable $_SESSION['imprimable'] qui est positionne sur oui ou non dans le code du squelette des pages
Cela dit, cette variable $_SESSION['imprimable'] ne doit pas tre prioritaire car alors le passage d'un format  l'autre (lors du clic sur un lien de format en haut de la page par transmission de la variable $_GET['imprimable']) serait inoprant.
D'o la structure suivante de la condition if :
On passe au format imprimable seulement si $_GET['imprimable'] est dfinie ET vaut 'oui' OU BIEN si $_SESSION['imprimable'] existe et vaut 'oui' ET que dans le mme temps $_GET['imprimable'] n'est pas dfinie OU ne vaut pas 'non'
*/  
if ((isset($_GET['imprimable']) && $_GET['imprimable'] == "oui") || (isset($_SESSION['imprimable']) && $_SESSION['imprimable'] == "oui" && (!isset($_GET['imprimable']) || $_GET['imprimable'] != "non")))
{
  include(IEW_DIR.$GLOBALS['repertoire_theme']."imprimable.php");
  // $_SESSION['imprimable'] sera positionne  'oui' dans ce squelette
}
else
{
  include(IEW_DIR.$GLOBALS['repertoire_theme'].$GLOBALS['squelette']);
  // $_SESSION['imprimable'] sera positionne  'non' dans ce squelette
}
?>