<?php
/**
 * suivi_connexion.php
 *
 * Met  jour les donnes de connexion (date/heure de la dernire requte de page)
 * et de l'historique de la navigation d'un utilisateur
 * Ce script est inclus dans chaque page o librairie_fonction est requise
 * 
 * Ce fichier fait partie du projet IntraEduWeb (IEW)
 * 
 * @package		IEW
 * @author			Sylvain GODM <sylvain.godme@gmail.com>
 * @version		$LastChangedRevision$, $LastChangedDate$
 * @copyright		2004-2012 Sylvain GODM
 * @link			http://iew.free.fr
 * @license		GPL License version 3 (http://www.gnu.org/licenses/gpl.html)
 * @filesource
 * 
 */

if(!defined('SESSION_NAME')) define('SESSION_NAME','IEW');
session_name(SESSION_NAME);
session_start(); // Pour accder aux donnes de session

// Existe-t-il une session authentifie ?
// si oui, on met  jour le journal des connexions  chaque chargement d'une page
if (isset($_SESSION['id_connexion']))
{
  // On ouvre une connexion  la bdd
  // Comme ce script a t cr aprs la plupart des pages et qu'il est inclus au dbut de chacune de celles-ci
  // Les connexions  la bdd ouvertes pourraient s'tablir en double ou triple
  // mais en pratique ce n'est pas le cas, car si un deuxime (ou plus) appel  mysql_connect() avec les
  // mmes arguments a lieu, la connexion dj tablie est utilise (pas de cration de nouvelle)
  // donc si dans le mme script on a plusieurs connexion_mysql(), ce n'est pas un soucis
  connexion_mysql();
  select_database();
  
  $last_request = time();
  // On met  jour la date du dernier accs  une page protge
  // le timestamp "last_request" est mis  jour avec l'heure actuelle
  // et le timestamp "fin" est laiss ou remis*  zro (=> utilisateur connect puisque vient de charger une page)
  // *il est remis  zro dans le cas ou l'utilisateur vient de se "rveiller" (il n'avait pas ferm son
  // navigateur, mais tait rest inactif + de 5 minutes - ce qui en principe ne doit pas se produire, car si
  // l'utilisateur est inactif sur une page, un timer envoie toutes les minutes une requte HTTP
  // vers le serveur => je_suis_la.php - , donc son timestamp "fin" peut tre diffrent de zro
  // (utilisateur considr comme dconnect, mais peut-tre simplement inactif)
  $sql = "UPDATE journal_connexions SET last_request='$last_request',fin='0' WHERE id_connexion='".$_SESSION['id_connexion']."'";
  mysql_query($sql);
  
  // Si un utilisateur n'a pas envoy d'information depuis plus de deux minutes
  // on le considre comme dconnect : en effet,  chaque page demande, on met  jour le timestamp
  // "last_request" dans la table journal_connexion
  // Mme si l'utilisateur est inactif sur une page, un timer envoie toutes les 3 minutes une requte HTTP
  // vers le serveur => je_suis_la.php
  // Si ce champ n'est pas mis  jour dans une priode de 5 minutes, c'est que l'utilisateur a ferm son navigateur
  // ou la connexion avec le serveur est coupe
  // On met donc fin aux connexions dont le timestamp "last_request" est vieux de plus de 5 minutes,
  // c'est--dire le timestamp "fin" ne vaut plus zro => utilisateur dconnect ou inactif
  $last_request_moins_cinq_minutes = $last_request - 300;
  $sql = "UPDATE journal_connexions SET fin='$last_request' WHERE fin='0' AND last_request<$last_request_moins_cinq_minutes"; // fin ='0' signifie connexion ouverte
  mysql_query($sql);
  // On met  jour le timestamp "last_request" dans la table journal_connexion aussi pour les utilisateurs
  // qui ont dpass le timeout de session
  $sql = "UPDATE journal_connexions SET fin='$last_request' WHERE fin='0' AND last_request-debut>".$GLOBALS['session_timeout'];
  mysql_query($sql);
  // On cherche le nombre d'utilisateurs actuellement connects
  // Enfin plutt ayant charg une page dans les 2 dernires minutes
  $sql = "SELECT id_connexion FROM journal_connexions WHERE fin='0' AND last_request>$last_request_moins_cinq_minutes";
  $resultat = mysql_query($sql);
  // On met  jour la variable de session correspondante
  if ($resultat)
    $_SESSION['nb_users'] = mysql_num_rows($resultat);
}
// sinon, on sort du script
?>