<?php 
/**
 * modif_xml_demo.php
 *
 * Parse certains fichiers xml d'imports et les modifie en xml de demo
 * les fichiers  concerns sont :
 * - sts_emp_RNE_annee.xml
 * - ElevesAvecAdresses.xml
 * - ResponsablesAvecAdresses.xml
 * 
 * IL FAUT QUE CES FICHIERS SOIENT DANS LE DOSSIER "tests"
 * AINSI QUE LES FICHIERS liste_noms.csv, prenom_filles.csv, prenoms_garcons.csv !
 * VOIR LE DOCUMENT "Doc_Dev_appli_DEMO.odt" pour savoir comment prparer ces fichier
 * avant l'utilisation du prsent script !!
 * 
 * Ce fichier fait partie du projet IntraEduWeb (IEW)
 * 
 * @package	IEW
 * @author	Sylvain GODM <sylvain.godme@gmail.com>
 * @version	$LastChangedRevision$, $LastChangedDate$
 * @copyright	2004-2012 Sylvain GODM
 * @link	http://iew.free.fr
 * @license	GPL License version 3 (http://www.gnu.org/licenses/gpl.html)
 * @filesource
 * 
 */

//Rcupration des noms de famille de dmo et des prnoms

$nom_famille = array();

// ATTENTION : il faut que le nombre de noms de famille soit suprieur au nombre total d'individu  anonymiser (tous fichiers confondus)

if (($handle = fopen("liste_noms.csv", "r")) !== FALSE) // Ce fichier ne contient qu'un champ par ligne
{
	while (($data = fgetcsv($handle, 1000, ",")) !== FALSE)
	{
		$nom_famille[] = $data[0]; // car le fichier ne contient qu'un champ par ligne
	}
}
fclose($handle);

$prenom_fille = array();

if (($handle = fopen("prenoms_filles.csv", "r")) !== FALSE) // Ce fichier ne contient qu'un champ par ligne
{
	while (($data = fgetcsv($handle, 1000, ",")) !== FALSE)
	{
		$prenom_fille[] = $data[0]; // car le fichier ne contient qu'un champ par ligne
	}
}
fclose($handle);

$prenom_garcon = array();

if (($handle = fopen("prenoms_garcons.csv", "r")) !== FALSE) // Ce fichier ne contient qu'un champ par ligne
{
	while (($data = fgetcsv($handle, 1000, ",")) !== FALSE)
	{
		$prenom_garcon[] = $data[0]; // car le fichier ne contient qu'un champ par ligne
	}
}
fclose($handle);

echo "<h1>Anonymisation des fichiers XML imports dans IEW</h1>";

echo "<h2>Liste des noms de famille  affecter</h2>";
var_dump($nom_famille);
echo "<h2>Liste des prnoms de fille  affecter</h2>";
var_dump($prenom_fille);
echo "<h2>Liste des prnoms de garon  affecter</h2>";
var_dump($prenom_garcon);

// ****************************** TRAITEMENT DE sts_emp_0512014M_2012.xml ******************************

$document = 'sts_emp_0512014M_2012.xml';

echo "<h2>$document</h2>";

copy($document, 'copie-'.$document);

$document_xml = new DomDocument;
$document_xml->load('copie-'.$document);
$elements = $document_xml->getElementsByTagName('INDIVIDU');
$i=0; // indice pour les noms de famille
$nblignes=0;

foreach($elements as $element)
{
	$i++;
	$nblignes++;
	if ($i > count($nom_famille)) // si l'indice est suprieur au nombre de noms de famille
		$i=0; // on repointe sur le 1er lment (dans ce cas, 2 personnes diffrentes peuvent avoir le mme nom de famille si nombre de noms de famille est infrieur au nombre total d'individu  anonymiser
	echo "<p>$nblignes) Nom d'origine : ";
	echo $element->getElementsByTagName('NOM_USAGE')->item(0)->nodeValue;
	echo ", Nouveau nom : $nom_famille[$i]</p>";
	$element->getElementsByTagName('NOM_USAGE')->item(0)->nodeValue = $nom_famille[$i];
	$element->getElementsByTagName('NOM_PATRONYMIQUE')->item(0)->nodeValue = $nom_famille[$i];
	echo "<p>Prnom d'origine : ";
	echo $element->getElementsByTagName('PRENOM')->item(0)->nodeValue;
	echo ", Nouveau prnom : ";
	if ($element->getElementsByTagName('SEXE')->item(0)->nodeValue == '1')
	{
		$element->getElementsByTagName('PRENOM')->item(0)->nodeValue = $prenom_garcon[$i];
		echo "$prenom_garcon[$i]</p>";
	}
	else
	{
		$element->getElementsByTagName('PRENOM')->item(0)->nodeValue = $prenom_fille[$i];
		echo "$prenom_fille[$i]</p>";
	}
}
$compteur = $i;
$document_xml->save('new_'.$document);

// ****************************** TRAITEMENT DE ElevesAvecAdresses.xml ******************************

$document = 'ElevesAvecAdresses.xml';

echo "<h2>$document</h2>";

copy($document, 'copie-'.$document);

$document_xml = new DomDocument;
$document_xml->load('copie-'.$document);
$elements = $document_xml->getElementsByTagName('ELEVE');
$i=$compteur++; // Car les noms de famille prcdents ont t utiliss pour modifier sts_emp.... (cela permet d'viter que ces noms soient rutiliss)
$k=0; // indice pour les prnoms 
$nblignes=0;

foreach($elements as $element)
{
	$i++;
	if ($i > count($nom_famille)) // si l'indice est suprieur au nombre de noms de famille
		$i=0; // on repointe sur le 1er lment (dans ce cas, 2 personnes diffrentes peuvent avoir le mme nom de famille si nombre de noms de famille est infrieur au nombre total d'individu  anonymiser
	$nblignes++;
	$k++;
	echo "<p>$nblignes) Nom d'origine : ";
	echo utf8_encode($element->getElementsByTagName('NOM')->item(0)->nodeValue);
	echo ", Nouveau nom : ".utf8_encode($nom_famille[$i])."</p>";
	$element->getElementsByTagName('NOM')->item(0)->nodeValue = utf8_encode($nom_famille[$i]);
	echo "<p>Prnom d'origine : "; // seul le 1er prnom a besoin d'tre chang (on laisse les autres : prnom 2 et 3)
	echo utf8_encode($element->getElementsByTagName('PRENOM')->item(0)->nodeValue);
	echo ", Nouveau prnom : ";
	if ($element->getElementsByTagName('CODE_SEXE')->item(0)->nodeValue == '1') // c'est un garon
	{
		if ($k > count($prenom_garcon)) // si l'indice est suprieur au nombre de prnoms
			$k=0; // on repointe sur le 1er lment (dans ce cas, le mme prnom peut tre affect  des personnes diffrentes : ce n'est pas gnant)
		$element->getElementsByTagName('PRENOM')->item(0)->nodeValue = utf8_encode($prenom_garcon[$k]);
		echo utf8_encode($prenom_garcon[$k])."</p>";
	}
	else
	{
		if ($k > count($prenom_fille)) // si l'indice est suprieurau nombre de prnoms
			$k=0; // on repointe sur le 1er lment (dans ce cas, le mme prnom peut tre affect  des personnes diffrentes : ce n'est pas gnant)
		$element->getElementsByTagName('PRENOM')->item(0)->nodeValue = utf8_encode($prenom_fille[$k]);
		echo utf8_encode($prenom_fille[$k])."</p>";
	}
	// autres changements  oprer
	$element->getElementsByTagName('ID_NATIONAL')->item(0)->nodeValue = "XXXXXXXXXXX";
	$element->getElementsByTagName('VILLE_NAISS')->item(0)->nodeValue = "";
	$element->getElementsByTagName('CODE_DEPARTEMENT_NAISS')->item(0)->nodeValue = "";
	$element->getElementsByTagName('CODE_COMMUNE_INSEE_NAISS')->item(0)->nodeValue = "";
	$element->getElementsByTagName('DENOM_COMPL')->item(0)->nodeValue = "DEMO IEW";
	$element->getElementsByTagName('CODE_RNE')->item(0)->nodeValue = "XXXXXXXX";
	$element->getElementsByTagName('LIGNE1_ADRESSE')->item(0)->nodeValue = utf8_encode("15 rue de la dmo");
	$element->getElementsByTagName('MEL')->item(0)->nodeValue = strtolower(substr($element->getElementsByTagName('PRENOM')->item(0)->nodeValue,0,1)).strtolower($element->getElementsByTagName('NOM')->item(0)->nodeValue)."@demo-iew.fr";
	$element->getElementsByTagName('TELEPHONE')->item(0)->nodeValue = "00 00 00 00 00";
	$element->getElementsByTagName('CODE_COMMUNE_INSEE')->item(0)->nodeValue = "";
	$element->getElementsByTagName('LL_COMMUNE_INSEE')->item(0)->nodeValue = "DEMOVILLE";
	$element->getElementsByTagName('CODE_DEPARTEMENT')->item(0)->nodeValue = "99";
	$element->getElementsByTagName('LIBELLE_POSTAL')->item(0)->nodeValue = "DEMOVILLE";
	$element->getElementsByTagName('CODE_POSTAL')->item(0)->nodeValue = "99000";
}
$compteur = $i;
$document_xml->save('new_'.$document);

// ****************************** TRAITEMENT DE ResponsablesAvecAdresses.xml ******************************

$document = 'ResponsablesAvecAdresses.xml';

echo "<h2>$document</h2>";

copy($document, 'copie-'.$document);

$document_xml = new DomDocument;
$document_xml->load('copie-'.$document);
$elements = $document_xml->getElementsByTagName('PERSONNE');
$i=$compteur++; // Car les noms de famille prcdents ont t utiliss pour modifier ElevesAvecAdresses.xml.... (cela permet d'viter que ces noms soient rutiliss)
// L'INCONVNIENT EST QU'IL Y A PEU DE CHANCE QU'UN RESPONSABLE AIT LE MME NOM QUE SON ENFANT...
$k=0; // indice pour les prnoms 
$nblignes=0;

foreach($elements as $element)
{
	$i++;
	if ($i > count($nom_famille)) // si l'indice est suprieur au nombre de noms de famille
		$i=0; // on repointe sur le 1er lment (dans ce cas, 2 personnes diffrentes peuvent avoir le mme nom de famille si nombre de noms de famille est infrieur au nombre total d'individu  anonymiser
	$nblignes++;
	$k++;
	echo "<p>$nblignes) Nom d'origine : ";
	echo utf8_encode($element->getElementsByTagName('NOM')->item(0)->nodeValue);
	echo ", Nouveau nom : ".utf8_encode($nom_famille[$i])."</p>";
	$element->getElementsByTagName('NOM')->item(0)->nodeValue = utf8_encode($nom_famille[$i]);
	echo "<p>Prnom d'origine : ";
	echo utf8_encode($element->getElementsByTagName('PRENOM')->item(0)->nodeValue);
	echo ", Nouveau prnom : ";
	if ($element->getElementsByTagName('LL_CIVILITE')->item(0)->nodeValue == 'MONSIEUR')
	{
		if ($k > count($prenom_garcon)) // si l'indice est suprieur au nombre de prnoms
			$k=0; // on repointe sur le 1er lment (dans ce cas, le mme prnom peut tre affect  des personnes diffrentes : ce n'est pas gnant)
		$element->getElementsByTagName('PRENOM')->item(0)->nodeValue = utf8_encode($prenom_garcon[$k]);
		echo utf8_encode($prenom_garcon[$k])."</p>";
	}
	else
	{
		if ($k > count($prenom_fille)) // si l'indice est suprieurau nombre de prnoms
			$k=0; // on repointe sur le 1er lment (dans ce cas, le mme prnom peut tre affect  des personnes diffrentes : ce n'est pas gnant)
		$element->getElementsByTagName('PRENOM')->item(0)->nodeValue = utf8_encode($prenom_fille[$k]);
		echo utf8_encode($prenom_fille[$k])."</p>";
	}
	// autres changements  oprer
	$element->getElementsByTagName('TEL_PERSONNEL')->item(0)->nodeValue = "00 00 00 00 00";
	$element->getElementsByTagName('TEL_PORTABLE')->item(0)->nodeValue = "06 00 00 00 00";
	$element->getElementsByTagName('TEL_PROFESSIONNEL')->item(0)->nodeValue = "00 00 00 00 00";
	$element->getElementsByTagName('MEL')->item(0)->nodeValue = strtolower(substr($element->getElementsByTagName('PRENOM')->item(0)->nodeValue,0,1)).strtolower($element->getElementsByTagName('NOM')->item(0)->nodeValue)."@demo-iew.fr";
}

// Les adresses ne sont pas situes dnas le bloc "PERSONNE"
$elements = $document_xml->getElementsByTagName('ADRESSE');
foreach($elements as $element)
{
	$element->getElementsByTagName('LIGNE1_ADRESSE')->item(0)->nodeValue = utf8_encode("15 rue de la dmo");
	$element->getElementsByTagName('CODE_COMMUNE_INSEE')->item(0)->nodeValue = "";
	$element->getElementsByTagName('LIBELLE_POSTAL')->item(0)->nodeValue = "DEMOVILLE";
	$element->getElementsByTagName('CODE_POSTAL')->item(0)->nodeValue = "99000";
	$element->getElementsByTagName('CODE_DEPARTEMENT')->item(0)->nodeValue = "099";
}

$document_xml->save('new_'.$document);
?>