<?php
/**
 * fonctions_formatage_sommaire.php
 *
 * C'est le squelette du sommaire associ au squelette de page
 * Remarque : bien que ce script contiennent des fonctions, il ne se trouve pas dans le rpertoire lib
 * mais dans le rpertoire themes/defaut car il est associ  un squelette de page
 * 
 * Ce fichier fait partie du projet IntraEduWeb (IEW)
 * 
 * @package		IEW
 * @author			Sylvain GODM <sylvain.godme@gmail.com>
 * @version		$LastChangedRevision$, $LastChangedDate$
 * @copyright		2004-2012 Sylvain GODM
 * @link			http://iew.free.fr
 * @license		GPL License version 3 (http://www.gnu.org/licenses/gpl.html)
 * @filesource
 * 
 */

global $chemin_relatif;

function affiche_sommaire($rubriques)
//***************************** description ********************************//
 // cette fonction formate l'affichage du sommaire dans la partie gauche de la page
 // Elle est associe au squelette de page
 //***************************** Fin description *****************************//
{
 global $chemin_relatif;
 foreach($rubriques as $tab_sous_rubriques)
 {
   $rubrique = key($rubriques); // Renvoie la cl courante
   echo "
    <!-- Rubrique -->
    <div class='sommaire_titre'>$rubrique</div>
    ";
   // DEBUGG var_dump($tab_sous_rubriques);
    echo "<ul>
    ";
    foreach($tab_sous_rubriques as $lien)
    {
      $sous_rubrique = key($tab_sous_rubriques); // Renvoie la cl courante
      $target="";
      // On traite un ventuel onclick (pour ouvrir une popup) :
      if (stristr($lien,"javascript://")) // Le code du onclick se trouve derrire
      {
        $fragment = explode("//",$lien);
        $lien = $fragment[1]; // On rcupre seulement le vrai lien (contenu entre les deux paires de //)
        $onclick = $fragment[2]; // Voil le onclick
      }
      // Si le lien comprend un target au debut
      elseif (substr($lien,0,8) == " target=" || $pos=strpos($lien," target=")) // si le lien comprend un target ou commence par un target sans lien
      {
        $target = strstr($lien," target="); // On rcupre le target
        $lien = substr($lien,0,$pos); // On dbarrasse le lien de ce target
        if (substr($lien,0,8) == " target=" || $lien == "") // au cas o le lien ne contient que target (donc pas vritablement de lien), on annule le target et le lien est mis sur la page 404
        {
          $target = "";
          $lien = "page-404.php";
        }
        elseif (stristr($lien,"http://") || stristr($lien,"https://")) //  si le lien est un lien absolu
        {
          $absolu = true;
        }
      }
      elseif ($lien == "") // un lien qui serait vide ds le dpart (donc sans target forcment) repointera vers la page 404
      {
        $lien = "page-404.php";
      }
      elseif (stristr($lien,"http://") || stristr($lien,"https://")) // le lien est un lien absolu
      {
        $absolu = true;
      }
      ?>
      <li>
        <?php
        echo "<a href=\"";
        if (isset($absolu)) // le lien est absolu
         echo $lien; // on ne met pas le chemin relatif jusqu' la racine IntraEduWeb
        else
         echo $chemin_relatif.$lien;
         if (isset($onclick)) // Si un onclick vers une popup est dfini, on le met dans le lien
        {
         echo $onclick.">";
        }
        else
         echo $target.">";
        echo $sous_rubrique; 
       ?></a>
      </li>
      <?php
      // Avant de boucler, on efface un target ou un onclick prcdent (sinon cela se rptera dans le menu)
      unset($target);
      unset($onclick);
      unset($absolu);
      next($tab_sous_rubriques); // pointe sur la cl suivante
    }
    ?>
    </ul>
    <?php
    next($rubriques); // pointe sur la cl suivante        
  }
  echo "<br />"; // saut de ligne avant sommaire suivant
}

function affiche_sommaire_cahiers_textes()
//***************************** description ********************************//
 // cette fonction formate l'affichage du sommaire d'un cahier de textes
 // Elle est associe au squelette de page
 //***************************** Fin description *****************************//
{
  global $chemin_relatif;
  // on rcupre la date en cours dans l'affichage du cahier de texte (soit en GLOBALS, en GET ou en POST)
  // car on en a besoin dans les liens du sommaire
  if (isset($GLOBALS['date']))
    $date = $GLOBALS['date'];
  elseif (isset($_GET['date']))
    $date = $_GET['date'];
  elseif (isset($_POST['date']))
    $date = $_POST['date'];
  elseif (isset($_GET['dateref']))
    $date = $_GET['dateref'];
  else
    $date = "";
  
  // DEBUGG echo "DATE : $date";
    // On teste si la date n'est pas au format jj-mm-aaaa => on la remet dans ce format
  if (!is_format_date_jjmmaaaa($date,"-") && $date != "")
  	$date = date_mysql_to_jjmmaaaa_tiret($date);
  
  echo "<div class='titre_menu_gauche'>Menu Cahier de Textes</div>";
  if (isset($_SESSION['classe_en_cours']))
  {	
  	echo "<center><b><a href='".$chemin_relatif."prive/cahiers_textes.php?unset_classe=oui' title=\"Voir le cahier de textes d'une autre classe\">[Changer la classe]</a></b></center>";
  }
  if ($_SESSION['valid_group'] == "1") // Menu Administrateur
  {
  	// D'abord accs aux archives
  	affiche_menu_archives();
  	affiche_menu_edt($date);
  	affiche_menu_visas();
  }
  if ($_SESSION['valid_group'] == "6") // Menu Direction
  {
  	// D'abord accs aux archives
  	affiche_menu_archives();
  	affiche_menu_edt($date);
  	affiche_menu_visas();
    echo "
    <!-- Rubrique -->
    <div class='sommaire_titre'><abbr title='Inspecteurs Pdagogiques Rgionaux'>IPR</abbr></div>
    ";
    echo "
    <ul>
    	<li>
      		<a href='' title=\"Autoriser l'accs temporaire aux cahiers de textes d'un professeur par un IPR\">Accs temporaire</a>
      	</li>
    </ul>";
  }
  if ($_SESSION['valid_group'] == "3") // Menu Prof
  {
  	// D'abord accs aux archives
  	affiche_menu_archives();
  	// Menu EDT
  	echo "
    <!-- Rubrique -->
    <div class='sommaire_titre'><abbr title='Emplois du temps'>EDT</abbr></div>
    ";
    echo "
    <ul>
    	<li>
      		<a href='edt.php?categorie=professeurs&amp;mode=ct&amp;nopub=true&amp;taf=true&amp;content=true&amp;edt=".$_SESSION['identifiant_individu']."&amp;debut_semaine=".$date."' title='Accder au cahier de textes par mon emploi du temps'>Mon emploi du temps</a>
      	</li>
      	<li>
      		<a href='edt.php?categorie=classes&amp;mode=ct&amp;taf=true&amp;content=true&amp;edt=".$_SESSION['classe_en_cours']."&amp;debut_semaine=".$date."' title=\"Accder au cahier de textes par l'Emploi du temps de ".$_SESSION['classe_en_cours']."\">Classe ou groupe</a>
      	</li>
    </ul>";
  }
  elseif ($_SESSION['valid_group'] == "2") // Menu EDT eleve
  {
  	echo "
    <!-- Rubrique -->
    <div class='sommaire_titre'><abbr title='Emplois du temps'>EDT</abbr></div>
    ";
    echo "
    <ul>
    	<li>
      		<a href='edt.php?categorie=classes&amp;mode=ct&amp;taf=true&amp;content=true&amp;edt=".$_SESSION['classe_eleve']."&amp;debut_semaine=".$date."'>Mon emploi du temps</a>
      	</li>
    </ul>";
  }
  elseif ($_SESSION['valid_group'] == "4") // Menu EDT responsable
  {
  	echo "
    <!-- Rubrique -->
    <div class='sommaire_titre'><abbr title='Emplois du temps'>EDT</abbr></div>
    ";
  	echo "<ul>";
  	// On recherche les classes des enfants de ce parent
  	$sql = "SELECT classe,eleve_id FROM eleves WHERE eleve_id=";
  	for($i=0;$i<count($_SESSION['enfants_scol']);$i++)
  	{
    	$fragment=explode(",",$_SESSION['enfants_scol'][$i]);
    	$tab_id[$i]=$fragment[0]; // identifiant lve
    	$tab_nom[$i]=$fragment[1]; // nom lve
    	$tab_prenom[$i]=$fragment[2]; // prnom lve
    	if ($i==0) // Si 1er tour de boucle
      		$sql .= "'".quote_smart($tab_id[$i])."' ";
    	else //  partir de la 2me itration
      	$sql .= "OR eleve_id='".quote_smart($tab_id[$i])."' ";
  	}
  	$sql .= "ORDER BY nom,prenom"; // fin de la requte
	$resultat = mysql_query($sql);
  	$i=0;
  	while ($ligne=mysql_fetch_array($resultat))
  	{
    	echo "<li>
      		<a href='edt.php?categorie=classes&amp;mode=ct&amp;taf=true&amp;content=true&amp;edt=".$ligne['classe']."&amp;debut_semaine=".$date."'>Emploi du temps de ".$tab_prenom[$i]."</a>
      	</li>";
    	$i++;
  	}
    echo "</ul>";
  }
  elseif ($_SESSION['valid_group'] == "11") // menu edt IPR
  {
  	echo "
    <!-- Rubrique -->
    <div class='sommaire_titre'><abbr title='Emplois du temps'>EDT</abbr></div>
    ";
    echo "
    <ul>
    	<li>
      		<a href='edt.php?categorie=professeurs&amp;mode=ct&amp;taf=true&amp;content=true&amp;edt=&amp;debut_semaine=".$date."' title=\"Accder au cahier de textes d'un professeur par  son Emploi du temps\">Professeur</a>
      	</li>
    </ul>";
    affiche_menu_visas();
  }
  echo "
    <!-- Rubrique -->
    <div class='sommaire_titre'>Synthse</div>
    ";
    echo "<ul>
    ";
    echo "<li>
      <a href='".$chemin_relatif."prive/synthese_ctextes.php?action=afaire' title=\"Voir le travail  faire pour une date donne\">A faire pour le</a>";
    echo "
    </li>
    ";
    echo "<li>
      <a href='".$chemin_relatif."prive/synthese_ctextes.php?action=faitle' title=\"Voir le travail fait en classe  une date donne\">Fait en classe le</a>";
    echo "
    </li>
    ";
    echo "<li>
      <a href='".$chemin_relatif."prive/synthese_ctextes.php?action=synthmat' title=\"Voir l'historique du cahier de textes d'une matire  choisir\">Synthse matire</a>";
    echo "
    </li>
    ";
    if ($_SESSION['valid_group'] == "3")
  	{
  		$m = ""; // contiendra le code matire
  		if (isset($_GET['matiere']) && $_GET['matiere'] != "")
  			$m = $_GET['matiere'];
  		elseif (isset($_SESSION['code_matiere_en_cours']) && isset($_SESSION['code_matiere_en_cours']) != "")
  			$m = $_SESSION['code_matiere_en_cours'];
  		echo "<li>
      	<a href='".$chemin_relatif."prive/synthese_ctextes.php?action=synthmat&amp;matiere=$m' title=\"Imprimer le cahier de texte de ".$_SESSION['classe_en_cours']." en ".$_SESSION['liste_matieres'][$m]."\">Imprimer</a>";
    	echo "
    	</li>
   	 	";
    	// On affiche le lien vers le carnet de bord uniquement si on est dj pass par la page des EDT (c'est ce qui permettra d'initialisation de $_SESSION['planning_edt'], indispensable pour afficher le carnet de bord, voir c_ct_day.php)
    	if (isset($_SESSION['planning_edt']))
    	{
    		echo "<li>
      		<a href='".$chemin_relatif."prive/ct_day.php?categorie=professeurs&amp;edt=".$_SESSION['identifiant_individu']."&amp;j=$date' title=\"Voir le carnet de bord du cahier de textes du jour\">Carnet de bord du jour</a>";
    		echo "
    		</li>
    		";
    	}
  	}
    echo "
    </ul>
    ";
    echo "<br />";
  	
  if (isset($_SESSION['valid_group']) && isset($_SESSION['classe_en_cours']) && count($_SESSION['liste_matieres'])>0) // vite un message d'erreur si la personne n'est pas connecte
  {
  	echo "<div class='sommaire_titre'>Matires en ".$_SESSION['classe_en_cours']."</div>
    <ul>
    ";
    if (isset($_SESSION['liste_matieres'])) // Evite un message d'erreur et un problme d'affichage si non dfini
  		reset($_SESSION['liste_matieres']);
  	while($matiere = current($_SESSION['liste_matieres']))
  	{
  		if ($date == "")
  			$date = date("d-m-Y"); // Si la date n'est pas dfinie, on met la date en cours
  		echo "<li>
      	<a href='".$chemin_relatif."prive/cahiers_textes.php?date=$date&amp;matiere=".key($_SESSION['liste_matieres'])."' title=\"Voir le cahier de texte pour la matire : $matiere\">$matiere</a>";
    	echo "
    	</li>
    	";
    	next($_SESSION['liste_matieres']);
  	}
  	echo "
  	</ul>
  	";
  }
  // On affiche les liens de synthse sur le cahier de textes
  if (isset($_SESSION['valid_group']) && isset($_SESSION['classe_en_cours'])) // vite un message d'erreur si la personne n'est pas connecte
  {
     // Puis on cherche la liste des groupes dont la classe peut faire partie
     if (!isset($_SESSION['liste_groupes'])) // si ce n'est pas dj fait
     {
  		$_SESSION['liste_groupes'] = cherche_classe_dans_groupes($_SESSION['classe_en_cours']);
  		// DEBUGG var_dump($_SESSION['liste_groupes']);
     }
  }
}

function affiche_menu_archives()
{
	/**
	 * Affiche les menus en mode archives
	 */
	echo "
    <!-- Rubrique -->
    <div class='sommaire_titre'>Archives</div>
    ";
    echo "<ul>";
    echo "
    	<li>
      		<a href='admin/prive/exit_archives.php?autre_archive=y' title='Consulter les archives des annes scolaires prcdentes'>Consulter les archives</a>
      	</li>";
    if (isset($_SESSION['anscol']) && isset($_SESSION['anscol']) !="") // Si on est dans les archives
    	echo "
    	<li>
      		<a href='admin/prive/exit_archives.php' title=\"Sortir de l'archive de cette anne scolaire et revenir  l'anne scolaire en cours\">Sortir des archives</a>
      	</li>";
    echo "</ul>";
}

function affiche_menu_edt($date)
{
	/**
	 * Affiche le menu EDT pour accder au cahier de textes d'une classe  travers le planning EDT
	 * uniquement pour le menu Administrateur et Direction
	 * 
	 * @param $date : date d'entre dans le planning EDT (format jj-mm-aaaa)
	 */
	echo "
    <!-- Rubrique -->
    <div class='sommaire_titre'><abbr title='Emplois du temps'>EDT</abbr></div>
    ";
    echo "
    <ul>
    	<li>
      		<a href='edt.php?categorie=classes&amp;mode=ct&amp;taf=true&amp;content=true&amp;edt=".$_SESSION['classe_en_cours']."&amp;debut_semaine=".$date."' title=\"Accder au cahier de textes par l'Emploi du temps de ".$_SESSION['classe_en_cours']."\">Classe ou groupe</a>
      	</li>
      	<li>
      		<a href='edt.php?categorie=professeurs&amp;mode=ct&amp;taf=true&amp;content=true&amp;edt=&amp;debut_semaine=".$date."' title=\"Accder au cahier de textes d'un professeur par  son Emploi du temps\">Professeur</a>
      	</li>
    </ul>";
}

function affiche_menu_visas()
{
	/**
	 * Affiche le menu Visas pour contrpoler les cahiers de textes d'un professeur
	 * uniquement pour les Administrateurs, la Direction, et les IPR
	 */
	echo "
    <!-- Rubrique -->
    <div class='sommaire_titre'>Visas</div>
    ";
	// Elments du menu Visas
	if ($_SESSION['valid_group'] == "1" || $_SESSION['valid_group'] == "6")
	{
		/*$li_def_visa = "<li>
      		<a href='' title=\"Tlcharger le visa graphique  utiliser pour viser les cahiers de textes\">Dfinir le visa</a>
      	</li>";*/
		$li_visa_classe = "<li>
      		<a href='' title=\"Viser ou consulter les visas du cahier de textes d'une classe ou d'un groupe\">Classe</a>
      	</li>";
	}
	$li_visa_prof = "<li>
      		<a href='../modules/cdt/controleurs/visas_ct.php' title=\"Viser ou consulter les visas des cahiers de textes d'un professeur\">Professeur</a>
      	</li>";
    echo "
    <ul>
    	$li_def_visa
    	$li_visa_prof
      	$li_visa_classe
    </ul>";
}
?>