<?php
/**
 * principal.php
 *
 * squelette principal des pages
 * 
 * Ce fichier fait partie du projet IntraEduWeb (IEW)
 * 
 * @package		IEW
 * @author			Sylvain GODM <sylvain.godme@gmail.com>
 * @version		$LastChangedRevision$, $LastChangedDate$
 * @copyright		2004-2012 Sylvain GODM
 * @link			http://iew.free.fr
 * @license		GPL License version 3 (http://www.gnu.org/licenses/gpl.html)
 * @filesource
 * 
 */
 
// inclusions : ici il y a besoin des fonctions d'affichage en plus des fonctions gnrales
if(!defined('IEW_DIR')) define('IEW_DIR',realpath(dirname(__FILE__)."/../../").'/');
// Inclusions
require_once(IEW_DIR."librairie_fonctions.php");
// Mais aussi du format de sommaire associ  ce squelette de page
require_once (IEW_DIR.$GLOBALS['repertoire_theme']."fonctions_formatage_sommaire.php");

debut_code_html();

// Ce squelette de page n'est pas en format imprimable
$_SESSION['imprimable'] = "non";

?>
  <div id="page">
	<!-- Affichage des liens d'vitement --><?php aff_menu_evitement(); ?>
	
	<!-- Affichage de l'entte de page avec le logo -->
    <div id="entete" role="banner">
      <?php echo "<a id='haut'></a>"; affiche_entete(); ?>
    </div>
 	<!-- Affichage de la barre de navigation horizontale suprieure -->
      <div id="nav_horiz_sup" role="navigation">
        <?php affiche_barre_navigation_horizontale_sup(); ?>
      </div>
 <!-- Affichage du menu dans la partie gauche --> 
    <div id="menu_gauche">
      <div id ="sommaire_gauche" class="sommaire" role="navigation">
        <?php affiche_menu_principal();?>
      </div>
      <br />
      <!-- Informations sur les responsables du site et l'tablissement + les logos des ressources libres utilises -->
        <?php 
        echo "<div class='centrage' role='complementary'>";
        affiche_responsables();
        affiche_logos_marge_gauche();
        echo "</div>";
        ?>
    </div>
    <!-- Affichage de la partie centrale de la page --> 
    <div id="contenu_central" role="main">
    	<?php affiche_contenu(); ?>
    	<!-- Affichage de la barre de navigation horizontale infrieure -->
      	<?php affiche_barre_navigation_horizontale_inf(); ?>
    </div>
    
    <!-- Affichage des informations complmentaires dans la partie droite --> 
    <div id="menu_droit" class="menu_droit" role="complementary">
      <?php 
      if ($_SESSION['valid_group'] == "1" && isset($_SESSION['nb_users']))
      {
      	echo "
      	<center>
      	<font face='verdana,arial,helvetica' size='1'><font color='red'><strong>".$_SESSION['nb_users']."</strong></font>
      	<font color='blue'>
      	<a href='".$GLOBALS['chemin_relatif']."prive/admintraeduweb/users_inline.php' title='Voir la liste des utilisateurs actuellement en ligne'>utilisateur(s) connect(s)</a>
      	</font>
      	</font>
      	</center>";
      }
      affiche_menu_droite(); ?>
    </div>
    <!-- Affichage du pied de page --> 
    <div id="pied_page" role="contentinfo">
      <a id='bas'></a>
      <?php aff_piedpage();?>
    </div>
  </div>
<?php
fin_code_html();
?>